﻿
//*****************************************************************************************************\\
// Copyright (©) Sergey Latchenko ( github.com/SunSerega | forum.mmcs.sfedu.ru/u/sun_serega )
// This code is distributed under the Unlicense
// For details see LICENSE file or this:
// https://github.com/SunSerega/POCGL/blob/master/LICENSE
//*****************************************************************************************************\\
// Copyright (©) Сергей Латченко ( github.com/SunSerega | forum.mmcs.sfedu.ru/u/sun_serega )
// Данный код распространяется с лицензией Unlicense
// Подробнее в файле LICENSE или тут:
// https://github.com/SunSerega/POCGL/blob/master/LICENSE
//*****************************************************************************************************\\

///
///Код переведён отсюда:
///   https://github.com/KhronosGroup/OpenGL-Registry/tree/master/xml
///
///Спецификации всех версий OpenGL:
///   https://www.khronos.org/registry/OpenGL/specs/gl/
///
///Если чего-либо не хватает, или найдена ошибка - писать сюда:
///   https://github.com/SunSerega/POCGL/issues
///
unit OpenGL;

interface

uses System;
uses System.Runtime.InteropServices;
uses System.Runtime.CompilerServices;

type
  
  {$region Записи-имена}
  
  //--------------------------------------------------
  //                  Basic type's
  //--------------------------------------------------
  
  gl_program = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_program read default(gl_program);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_program[{val}]';
  end;
  gl_program_pipeline = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_program_pipeline read default(gl_program_pipeline);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_program_pipeline[{val}]';
  end;
  gl_texture = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_texture read default(gl_texture);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_texture[{val}]';
  end;
  gl_buffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_buffer read default(gl_buffer);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_buffer[{val}]';
  end;
  gl_shader = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_shader read default(gl_shader);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_shader[{val}]';
  end;
  gl_query = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_query read default(gl_query);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_query[{val}]';
  end;
  gl_framebuffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_framebuffer read default(gl_framebuffer);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_framebuffer[{val}]';
  end;
  gl_renderbuffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_renderbuffer read default(gl_renderbuffer);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_renderbuffer[{val}]';
  end;
  gl_sampler = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_sampler read default(gl_sampler);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_sampler[{val}]';
  end;
  gl_transform_feedback = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_transform_feedback read default(gl_transform_feedback);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_transform_feedback[{val}]';
  end;
  gl_vertex_array = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_vertex_array read default(gl_vertex_array);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_vertex_array[{val}]';
  end;
  gl_sync = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: gl_sync read default(gl_sync);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'gl_sync[{val}]';
  end;
  gl_display_list = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_display_list read default(gl_display_list);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_display_list[{val}]';
  end;
  
  gl_handle_ARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_handle_ARB read default(gl_handle_ARB);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_handle_ARB[{val}]';
  end;
  
  // GL_NV_vdpau_interop
  gl_vdpau_surface_NV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: gl_vdpau_surface_NV read default(gl_vdpau_surface_NV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'gl_vdpau_surface_NV[{val}]';
  end;
  
  // GL_INTEL_performance_query
  gl_perf_query_id_INTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_perf_query_id_INTEL read default(gl_perf_query_id_INTEL);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_perf_query_id_INTEL[{val}]';
  end;
  gl_perf_query_handle_INTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: gl_perf_query_handle_INTEL read default(gl_perf_query_handle_INTEL);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'gl_perf_query_handle_INTEL[{val}]';
  end;
  
  //--------------------------------------------------
  //                        cl
  //--------------------------------------------------
  
  gl_cl_context = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: gl_cl_context read default(gl_cl_context);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'gl_cl_context[{val}]';
  end;
  gl_cl_event = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: gl_cl_event read default(gl_cl_event);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'gl_cl_event[{val}]';
  end;
  
  //--------------------------------------------------
  //                        wgl
  //--------------------------------------------------
  
  // gdi
  gdi_device_context = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: gdi_device_context read default(gdi_device_context);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'gdi_device_context[{val}]';
  end;
  gdi_h_enh_metafile = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: gdi_h_enh_metafile read default(gdi_h_enh_metafile);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'gdi_h_enh_metafile[{val}]';
  end;
  
  // core
  wgl_context = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_context read default(wgl_context);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_context[{val}]';
  end;
  
  // WGL_ARB_pbuffer
  wgl_pbuffer_ARB = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_pbuffer_ARB read default(wgl_pbuffer_ARB);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_pbuffer_ARB[{val}]';
  end;
  wgl_pbuffer_EXT = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_pbuffer_EXT read default(wgl_pbuffer_EXT);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_pbuffer_EXT[{val}]';
  end;
  
  // WGL_NV_gpu_affinity
  wgl_GPU_NV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_GPU_NV read default(wgl_GPU_NV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_GPU_NV[{val}]';
  end;
  
  // GL_NV_video_capture
  // WGL_NV_video_capture
  wgl_h_video_input_device_NV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_h_video_input_device_NV read default(wgl_h_video_input_device_NV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_h_video_input_device_NV[{val}]';
  end;
  
  // GL_NV_present_video
  // WGL_NV_present_video
  wgl_h_video_output_device_NV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_h_video_output_device_NV read default(wgl_h_video_output_device_NV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_h_video_output_device_NV[{val}]';
  end;
  
  // WGL_NV_video_output
  wgl_h_video_device_NV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: wgl_h_video_device_NV read default(wgl_h_video_device_NV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'wgl_h_video_device_NV[{val}]';
  end;
  
  //--------------------------------------------------
  //                        glx
  //--------------------------------------------------
  
  // x
  x_p_visual_info = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_p_visual_info read default(x_p_visual_info);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_p_visual_info[{val}]';
  end;
  x_p_display = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_p_display read default(x_p_display);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_p_display[{val}]';
  end;
  x_pixmap = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_pixmap read default(x_pixmap);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_pixmap[{val}]';
  end;
  x_font = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_font read default(x_font);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_font[{val}]';
  end;
  x_window = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_window read default(x_window);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_window[{val}]';
  end;
  x_dm_params = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_dm_params read default(x_dm_params);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_dm_params[{val}]';
  end;
  x_dm_buffer = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_dm_buffer read default(x_dm_buffer);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_dm_buffer[{val}]';
  end;
  x_colormap = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_colormap read default(x_colormap);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_colormap[{val}]';
  end;
  
  //TODO что это вообще за типы? я не могу найти ничего про них
  x_vl_server = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_vl_server read default(x_vl_server);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_vl_server[{val}]';
  end;
  x_vl_path = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_vl_path read default(x_vl_path);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_vl_path[{val}]';
  end;
  x_vl_node = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: x_vl_node read default(x_vl_node);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'x_vl_node[{val}]';
  end;
  
  // core
  glx_context = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_context read default(glx_context);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_context[{val}]';
  end;
  glx_context_id = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_context_id read default(glx_context_id);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_context_id[{val}]';
  end;
  glx_drawable = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_drawable read default(glx_drawable);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_drawable[{val}]';
  end;
  glx_pixmap = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_pixmap read default(glx_pixmap);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_pixmap[{val}]';
  end;
  glx_fb_config = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_fb_config read default(glx_fb_config);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_fb_config[{val}]';
  end;
  glx_window = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_window read default(glx_window);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_window[{val}]';
  end;
  glx_pbuffer = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_pbuffer read default(glx_pbuffer);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_pbuffer[{val}]';
  end;
  
  // GLX_NV_video_out
  glx_video_device_NV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: glx_video_device_NV read default(glx_video_device_NV);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
    public function ToString: string; override := $'glx_video_device_NV[{val}]';
  end;
  
  // GL_NV_video_capture
  // GLX_NV_video_capture
  glx_video_capture_device_NV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_video_capture_device_NV read default(glx_video_capture_device_NV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_video_capture_device_NV[{val}]';
  end;
  
  // GLX_SGIX_video_source
  glx_video_source_SGIX = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: glx_video_source_SGIX read default(glx_video_source_SGIX);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'glx_video_source_SGIX[{val}]';
  end;
  
  //--------------------------------------------------
  //                       egl
  //--------------------------------------------------
  
  // GL_OES_EGL_image
  egl_image_OES = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: egl_image_OES read default(egl_image_OES);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'egl_image_OES[{val}]';
  end;
  
  // GL_EXT_external_buffer
  egl_chient_buffer_EXT = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: egl_chient_buffer_EXT read default(egl_chient_buffer_EXT);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
    public function ToString: string; override := $'egl_chient_buffer_EXT[{val}]';
  end;
  
  {$endregion Записи-имена}
  
  {$region Перечисления}
  
  {$region Core}
  
  AccumOp = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ACCUM:  AccumOp read new AccumOp($0100);
    public static property LOAD:   AccumOp read new AccumOp($0101);
    public static property RETURN: AccumOp read new AccumOp($0102);
    public static property MULT:   AccumOp read new AccumOp($0103);
    public static property ADD:    AccumOp read new AccumOp($0104);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0100) then Result := 'ACCUM' else
      if self.val = UInt32($0101) then Result := 'LOAD' else
      if self.val = UInt32($0102) then Result := 'RETURN' else
      if self.val = UInt32($0103) then Result := 'MULT' else
      if self.val = UInt32($0104) then Result := 'ADD' else
        Result := $'AccumOp[{self.val}]';
    end;
    
  end;
  
  AlphaFunction = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NEVER:    AlphaFunction read new AlphaFunction($0200);
    public static property LESS:     AlphaFunction read new AlphaFunction($0201);
    public static property EQUAL:    AlphaFunction read new AlphaFunction($0202);
    public static property LEQUAL:   AlphaFunction read new AlphaFunction($0203);
    public static property GREATER:  AlphaFunction read new AlphaFunction($0204);
    public static property NOTEQUAL: AlphaFunction read new AlphaFunction($0205);
    public static property GEQUAL:   AlphaFunction read new AlphaFunction($0206);
    public static property ALWAYS:   AlphaFunction read new AlphaFunction($0207);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0200) then Result := 'NEVER' else
      if self.val = UInt32($0201) then Result := 'LESS' else
      if self.val = UInt32($0202) then Result := 'EQUAL' else
      if self.val = UInt32($0203) then Result := 'LEQUAL' else
      if self.val = UInt32($0204) then Result := 'GREATER' else
      if self.val = UInt32($0205) then Result := 'NOTEQUAL' else
      if self.val = UInt32($0206) then Result := 'GEQUAL' else
      if self.val = UInt32($0207) then Result := 'ALWAYS' else
        Result := $'AlphaFunction[{self.val}]';
    end;
    
  end;
  
  AtomicCounterBufferPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER:         AtomicCounterBufferPName read new AtomicCounterBufferPName($90ED);
    public static property ATOMIC_COUNTER_BUFFER_BINDING:                              AtomicCounterBufferPName read new AtomicCounterBufferPName($92C1);
    public static property ATOMIC_COUNTER_BUFFER_DATA_SIZE:                            AtomicCounterBufferPName read new AtomicCounterBufferPName($92C4);
    public static property ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS:               AtomicCounterBufferPName read new AtomicCounterBufferPName($92C5);
    public static property ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES:        AtomicCounterBufferPName read new AtomicCounterBufferPName($92C6);
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER:          AtomicCounterBufferPName read new AtomicCounterBufferPName($92C7);
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER:    AtomicCounterBufferPName read new AtomicCounterBufferPName($92C8);
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER: AtomicCounterBufferPName read new AtomicCounterBufferPName($92C9);
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER:        AtomicCounterBufferPName read new AtomicCounterBufferPName($92CA);
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER:        AtomicCounterBufferPName read new AtomicCounterBufferPName($92CB);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($90ED) then Result := 'ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER' else
      if self.val = UInt32($92C1) then Result := 'ATOMIC_COUNTER_BUFFER_BINDING' else
      if self.val = UInt32($92C4) then Result := 'ATOMIC_COUNTER_BUFFER_DATA_SIZE' else
      if self.val = UInt32($92C5) then Result := 'ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS' else
      if self.val = UInt32($92C6) then Result := 'ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES' else
      if self.val = UInt32($92C7) then Result := 'ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER' else
      if self.val = UInt32($92C8) then Result := 'ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER' else
      if self.val = UInt32($92C9) then Result := 'ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER' else
      if self.val = UInt32($92CA) then Result := 'ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER' else
      if self.val = UInt32($92CB) then Result := 'ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER' else
        Result := $'AtomicCounterBufferPName[{self.val}]';
    end;
    
  end;
  
  AttribMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CURRENT_BIT:          AttribMask read new AttribMask($0001);
    public static property POINT_BIT:            AttribMask read new AttribMask($0002);
    public static property LINE_BIT:             AttribMask read new AttribMask($0004);
    public static property POLYGON_BIT:          AttribMask read new AttribMask($0008);
    public static property POLYGON_STIPPLE_BIT:  AttribMask read new AttribMask($0010);
    public static property PIXEL_MODE_BIT:       AttribMask read new AttribMask($0020);
    public static property LIGHTING_BIT:         AttribMask read new AttribMask($0040);
    public static property FOG_BIT:              AttribMask read new AttribMask($0080);
    public static property DEPTH_BUFFER_BIT:     AttribMask read new AttribMask($0100);
    public static property ACCUM_BUFFER_BIT:     AttribMask read new AttribMask($0200);
    public static property STENCIL_BUFFER_BIT:   AttribMask read new AttribMask($0400);
    public static property VIEWPORT_BIT:         AttribMask read new AttribMask($0800);
    public static property TRANSFORM_BIT:        AttribMask read new AttribMask($1000);
    public static property ENABLE_BIT:           AttribMask read new AttribMask($2000);
    public static property COLOR_BUFFER_BIT:     AttribMask read new AttribMask($4000);
    public static property HINT_BIT:             AttribMask read new AttribMask($8000);
    public static property EVAL_BIT:             AttribMask read new AttribMask($10000);
    public static property LIST_BIT:             AttribMask read new AttribMask($20000);
    public static property TEXTURE_BIT:          AttribMask read new AttribMask($40000);
    public static property SCISSOR_BIT:          AttribMask read new AttribMask($80000);
    public static property MULTISAMPLE_BIT:      AttribMask read new AttribMask($20000000);
    public static property MULTISAMPLE_BIT_3DFX: AttribMask read new AttribMask($20000000);
    public static property MULTISAMPLE_BIT_ARB:  AttribMask read new AttribMask($20000000);
    public static property MULTISAMPLE_BIT_EXT:  AttribMask read new AttribMask($20000000);
    public static property ALL_ATTRIB_BITS:      AttribMask read new AttribMask($FFFFFFFF);
    
    public static function operator+(f1,f2: AttribMask) := new AttribMask(f1.val or f2.val);
    public static function operator or(f1,f2: AttribMask) := f1+f2;
    
    public property HAS_FLAG_CURRENT_BIT:          boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_POINT_BIT:            boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_LINE_BIT:             boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_POLYGON_BIT:          boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_POLYGON_STIPPLE_BIT:  boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_PIXEL_MODE_BIT:       boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_LIGHTING_BIT:         boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_FOG_BIT:              boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_DEPTH_BUFFER_BIT:     boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_ACCUM_BUFFER_BIT:     boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_STENCIL_BUFFER_BIT:   boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_VIEWPORT_BIT:         boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_TRANSFORM_BIT:        boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_ENABLE_BIT:           boolean read self.val and $2000 <> 0;
    public property HAS_FLAG_COLOR_BUFFER_BIT:     boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_HINT_BIT:             boolean read self.val and $8000 <> 0;
    public property HAS_FLAG_EVAL_BIT:             boolean read self.val and $10000 <> 0;
    public property HAS_FLAG_LIST_BIT:             boolean read self.val and $20000 <> 0;
    public property HAS_FLAG_TEXTURE_BIT:          boolean read self.val and $40000 <> 0;
    public property HAS_FLAG_SCISSOR_BIT:          boolean read self.val and $80000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT:      boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT_3DFX: boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT_ARB:  boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT_EXT:  boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_ALL_ATTRIB_BITS:      boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'CURRENT_BIT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'POINT_BIT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'LINE_BIT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'POLYGON_BIT+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'POLYGON_STIPPLE_BIT+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'PIXEL_MODE_BIT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'LIGHTING_BIT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'FOG_BIT+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'DEPTH_BUFFER_BIT+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'ACCUM_BUFFER_BIT+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'STENCIL_BUFFER_BIT+';
      if self.val and UInt32($0800) = UInt32($0800) then res += 'VIEWPORT_BIT+';
      if self.val and UInt32($1000) = UInt32($1000) then res += 'TRANSFORM_BIT+';
      if self.val and UInt32($2000) = UInt32($2000) then res += 'ENABLE_BIT+';
      if self.val and UInt32($4000) = UInt32($4000) then res += 'COLOR_BUFFER_BIT+';
      if self.val and UInt32($8000) = UInt32($8000) then res += 'HINT_BIT+';
      if self.val and UInt32($10000) = UInt32($10000) then res += 'EVAL_BIT+';
      if self.val and UInt32($20000) = UInt32($20000) then res += 'LIST_BIT+';
      if self.val and UInt32($40000) = UInt32($40000) then res += 'TEXTURE_BIT+';
      if self.val and UInt32($80000) = UInt32($80000) then res += 'SCISSOR_BIT+';
      if self.val and UInt32($20000000) = UInt32($20000000) then res += 'MULTISAMPLE_BIT+';
      if self.val and UInt32($20000000) = UInt32($20000000) then res += 'MULTISAMPLE_BIT_3DFX+';
      if self.val and UInt32($20000000) = UInt32($20000000) then res += 'MULTISAMPLE_BIT_ARB+';
      if self.val and UInt32($20000000) = UInt32($20000000) then res += 'MULTISAMPLE_BIT_EXT+';
      if self.val and UInt32($FFFFFFFF) = UInt32($FFFFFFFF) then res += 'ALL_ATTRIB_BITS+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'AttribMask[{self.val}]';
    end;
    
  end;
  
  AttributeType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property INT:                                       AttributeType read new AttributeType($1404);
    public static property UNSIGNED_INT:                              AttributeType read new AttributeType($1405);
    public static property FLOAT:                                     AttributeType read new AttributeType($1406);
    public static property DOUBLE:                                    AttributeType read new AttributeType($140A);
    public static property INT64_ARB:                                 AttributeType read new AttributeType($140E);
    public static property INT64_NV:                                  AttributeType read new AttributeType($140E);
    public static property UNSIGNED_INT64_ARB:                        AttributeType read new AttributeType($140F);
    public static property UNSIGNED_INT64_NV:                         AttributeType read new AttributeType($140F);
    public static property FLOAT_VEC2:                                AttributeType read new AttributeType($8B50);
    public static property FLOAT_VEC2_ARB:                            AttributeType read new AttributeType($8B50);
    public static property FLOAT_VEC3:                                AttributeType read new AttributeType($8B51);
    public static property FLOAT_VEC3_ARB:                            AttributeType read new AttributeType($8B51);
    public static property FLOAT_VEC4:                                AttributeType read new AttributeType($8B52);
    public static property FLOAT_VEC4_ARB:                            AttributeType read new AttributeType($8B52);
    public static property INT_VEC2:                                  AttributeType read new AttributeType($8B53);
    public static property INT_VEC2_ARB:                              AttributeType read new AttributeType($8B53);
    public static property INT_VEC3:                                  AttributeType read new AttributeType($8B54);
    public static property INT_VEC3_ARB:                              AttributeType read new AttributeType($8B54);
    public static property INT_VEC4:                                  AttributeType read new AttributeType($8B55);
    public static property INT_VEC4_ARB:                              AttributeType read new AttributeType($8B55);
    public static property BOOL:                                      AttributeType read new AttributeType($8B56);
    public static property BOOL_ARB:                                  AttributeType read new AttributeType($8B56);
    public static property BOOL_VEC2:                                 AttributeType read new AttributeType($8B57);
    public static property BOOL_VEC2_ARB:                             AttributeType read new AttributeType($8B57);
    public static property BOOL_VEC3:                                 AttributeType read new AttributeType($8B58);
    public static property BOOL_VEC3_ARB:                             AttributeType read new AttributeType($8B58);
    public static property BOOL_VEC4:                                 AttributeType read new AttributeType($8B59);
    public static property BOOL_VEC4_ARB:                             AttributeType read new AttributeType($8B59);
    public static property FLOAT_MAT2:                                AttributeType read new AttributeType($8B5A);
    public static property FLOAT_MAT2_ARB:                            AttributeType read new AttributeType($8B5A);
    public static property FLOAT_MAT3:                                AttributeType read new AttributeType($8B5B);
    public static property FLOAT_MAT3_ARB:                            AttributeType read new AttributeType($8B5B);
    public static property FLOAT_MAT4:                                AttributeType read new AttributeType($8B5C);
    public static property FLOAT_MAT4_ARB:                            AttributeType read new AttributeType($8B5C);
    public static property SAMPLER_1D:                                AttributeType read new AttributeType($8B5D);
    public static property SAMPLER_1D_ARB:                            AttributeType read new AttributeType($8B5D);
    public static property SAMPLER_2D:                                AttributeType read new AttributeType($8B5E);
    public static property SAMPLER_2D_ARB:                            AttributeType read new AttributeType($8B5E);
    public static property SAMPLER_3D:                                AttributeType read new AttributeType($8B5F);
    public static property SAMPLER_3D_ARB:                            AttributeType read new AttributeType($8B5F);
    public static property SAMPLER_3D_OES:                            AttributeType read new AttributeType($8B5F);
    public static property SAMPLER_CUBE:                              AttributeType read new AttributeType($8B60);
    public static property SAMPLER_CUBE_ARB:                          AttributeType read new AttributeType($8B60);
    public static property SAMPLER_1D_SHADOW:                         AttributeType read new AttributeType($8B61);
    public static property SAMPLER_1D_SHADOW_ARB:                     AttributeType read new AttributeType($8B61);
    public static property SAMPLER_2D_SHADOW:                         AttributeType read new AttributeType($8B62);
    public static property SAMPLER_2D_SHADOW_ARB:                     AttributeType read new AttributeType($8B62);
    public static property SAMPLER_2D_SHADOW_EXT:                     AttributeType read new AttributeType($8B62);
    public static property SAMPLER_2D_RECT:                           AttributeType read new AttributeType($8B63);
    public static property SAMPLER_2D_RECT_ARB:                       AttributeType read new AttributeType($8B63);
    public static property SAMPLER_2D_RECT_SHADOW:                    AttributeType read new AttributeType($8B64);
    public static property SAMPLER_2D_RECT_SHADOW_ARB:                AttributeType read new AttributeType($8B64);
    public static property FLOAT_MAT2x3:                              AttributeType read new AttributeType($8B65);
    public static property FLOAT_MAT2x3_NV:                           AttributeType read new AttributeType($8B65);
    public static property FLOAT_MAT2x4:                              AttributeType read new AttributeType($8B66);
    public static property FLOAT_MAT2x4_NV:                           AttributeType read new AttributeType($8B66);
    public static property FLOAT_MAT3x2:                              AttributeType read new AttributeType($8B67);
    public static property FLOAT_MAT3x2_NV:                           AttributeType read new AttributeType($8B67);
    public static property FLOAT_MAT3x4:                              AttributeType read new AttributeType($8B68);
    public static property FLOAT_MAT3x4_NV:                           AttributeType read new AttributeType($8B68);
    public static property FLOAT_MAT4x2:                              AttributeType read new AttributeType($8B69);
    public static property FLOAT_MAT4x2_NV:                           AttributeType read new AttributeType($8B69);
    public static property FLOAT_MAT4x3:                              AttributeType read new AttributeType($8B6A);
    public static property FLOAT_MAT4x3_NV:                           AttributeType read new AttributeType($8B6A);
    public static property SAMPLER_BUFFER:                            AttributeType read new AttributeType($8DC2);
    public static property SAMPLER_1D_ARRAY_SHADOW:                   AttributeType read new AttributeType($8DC3);
    public static property SAMPLER_2D_ARRAY_SHADOW:                   AttributeType read new AttributeType($8DC4);
    public static property SAMPLER_CUBE_SHADOW:                       AttributeType read new AttributeType($8DC5);
    public static property UNSIGNED_INT_VEC2:                         AttributeType read new AttributeType($8DC6);
    public static property UNSIGNED_INT_VEC3:                         AttributeType read new AttributeType($8DC7);
    public static property UNSIGNED_INT_VEC4:                         AttributeType read new AttributeType($8DC8);
    public static property INT_SAMPLER_1D:                            AttributeType read new AttributeType($8DC9);
    public static property INT_SAMPLER_2D:                            AttributeType read new AttributeType($8DCA);
    public static property INT_SAMPLER_3D:                            AttributeType read new AttributeType($8DCB);
    public static property INT_SAMPLER_CUBE:                          AttributeType read new AttributeType($8DCC);
    public static property INT_SAMPLER_2D_RECT:                       AttributeType read new AttributeType($8DCD);
    public static property INT_SAMPLER_1D_ARRAY:                      AttributeType read new AttributeType($8DCE);
    public static property INT_SAMPLER_2D_ARRAY:                      AttributeType read new AttributeType($8DCF);
    public static property INT_SAMPLER_BUFFER:                        AttributeType read new AttributeType($8DD0);
    public static property UNSIGNED_INT_SAMPLER_1D:                   AttributeType read new AttributeType($8DD1);
    public static property UNSIGNED_INT_SAMPLER_2D:                   AttributeType read new AttributeType($8DD2);
    public static property UNSIGNED_INT_SAMPLER_3D:                   AttributeType read new AttributeType($8DD3);
    public static property UNSIGNED_INT_SAMPLER_CUBE:                 AttributeType read new AttributeType($8DD4);
    public static property UNSIGNED_INT_SAMPLER_2D_RECT:              AttributeType read new AttributeType($8DD5);
    public static property UNSIGNED_INT_SAMPLER_1D_ARRAY:             AttributeType read new AttributeType($8DD6);
    public static property UNSIGNED_INT_SAMPLER_2D_ARRAY:             AttributeType read new AttributeType($8DD7);
    public static property UNSIGNED_INT_SAMPLER_BUFFER:               AttributeType read new AttributeType($8DD8);
    public static property DOUBLE_MAT2:                               AttributeType read new AttributeType($8F46);
    public static property DOUBLE_MAT3:                               AttributeType read new AttributeType($8F47);
    public static property DOUBLE_MAT4:                               AttributeType read new AttributeType($8F48);
    public static property DOUBLE_MAT2x3:                             AttributeType read new AttributeType($8F49);
    public static property DOUBLE_MAT2x4:                             AttributeType read new AttributeType($8F4A);
    public static property DOUBLE_MAT3x2:                             AttributeType read new AttributeType($8F4B);
    public static property DOUBLE_MAT3x4:                             AttributeType read new AttributeType($8F4C);
    public static property DOUBLE_MAT4x2:                             AttributeType read new AttributeType($8F4D);
    public static property DOUBLE_MAT4x3:                             AttributeType read new AttributeType($8F4E);
    public static property INT64_VEC2_ARB:                            AttributeType read new AttributeType($8FE9);
    public static property INT64_VEC3_ARB:                            AttributeType read new AttributeType($8FEA);
    public static property INT64_VEC4_ARB:                            AttributeType read new AttributeType($8FEB);
    public static property UNSIGNED_INT64_VEC2_ARB:                   AttributeType read new AttributeType($8FF5);
    public static property UNSIGNED_INT64_VEC3_ARB:                   AttributeType read new AttributeType($8FF6);
    public static property UNSIGNED_INT64_VEC4_ARB:                   AttributeType read new AttributeType($8FF7);
    public static property DOUBLE_VEC2:                               AttributeType read new AttributeType($8FFC);
    public static property DOUBLE_VEC3:                               AttributeType read new AttributeType($8FFD);
    public static property DOUBLE_VEC4:                               AttributeType read new AttributeType($8FFE);
    public static property SAMPLER_CUBE_MAP_ARRAY:                    AttributeType read new AttributeType($900C);
    public static property SAMPLER_CUBE_MAP_ARRAY_SHADOW:             AttributeType read new AttributeType($900D);
    public static property INT_SAMPLER_CUBE_MAP_ARRAY:                AttributeType read new AttributeType($900E);
    public static property UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY:       AttributeType read new AttributeType($900F);
    public static property IMAGE_1D:                                  AttributeType read new AttributeType($904C);
    public static property IMAGE_2D:                                  AttributeType read new AttributeType($904D);
    public static property IMAGE_3D:                                  AttributeType read new AttributeType($904E);
    public static property IMAGE_2D_RECT:                             AttributeType read new AttributeType($904F);
    public static property IMAGE_CUBE:                                AttributeType read new AttributeType($9050);
    public static property IMAGE_BUFFER:                              AttributeType read new AttributeType($9051);
    public static property IMAGE_1D_ARRAY:                            AttributeType read new AttributeType($9052);
    public static property IMAGE_2D_ARRAY:                            AttributeType read new AttributeType($9053);
    public static property IMAGE_CUBE_MAP_ARRAY:                      AttributeType read new AttributeType($9054);
    public static property IMAGE_2D_MULTISAMPLE:                      AttributeType read new AttributeType($9055);
    public static property IMAGE_2D_MULTISAMPLE_ARRAY:                AttributeType read new AttributeType($9056);
    public static property INT_IMAGE_1D:                              AttributeType read new AttributeType($9057);
    public static property INT_IMAGE_2D:                              AttributeType read new AttributeType($9058);
    public static property INT_IMAGE_3D:                              AttributeType read new AttributeType($9059);
    public static property INT_IMAGE_2D_RECT:                         AttributeType read new AttributeType($905A);
    public static property INT_IMAGE_CUBE:                            AttributeType read new AttributeType($905B);
    public static property INT_IMAGE_BUFFER:                          AttributeType read new AttributeType($905C);
    public static property INT_IMAGE_1D_ARRAY:                        AttributeType read new AttributeType($905D);
    public static property INT_IMAGE_2D_ARRAY:                        AttributeType read new AttributeType($905E);
    public static property INT_IMAGE_CUBE_MAP_ARRAY:                  AttributeType read new AttributeType($905F);
    public static property INT_IMAGE_2D_MULTISAMPLE:                  AttributeType read new AttributeType($9060);
    public static property INT_IMAGE_2D_MULTISAMPLE_ARRAY:            AttributeType read new AttributeType($9061);
    public static property UNSIGNED_INT_IMAGE_1D:                     AttributeType read new AttributeType($9062);
    public static property UNSIGNED_INT_IMAGE_2D:                     AttributeType read new AttributeType($9063);
    public static property UNSIGNED_INT_IMAGE_3D:                     AttributeType read new AttributeType($9064);
    public static property UNSIGNED_INT_IMAGE_2D_RECT:                AttributeType read new AttributeType($9065);
    public static property UNSIGNED_INT_IMAGE_CUBE:                   AttributeType read new AttributeType($9066);
    public static property UNSIGNED_INT_IMAGE_BUFFER:                 AttributeType read new AttributeType($9067);
    public static property UNSIGNED_INT_IMAGE_1D_ARRAY:               AttributeType read new AttributeType($9068);
    public static property UNSIGNED_INT_IMAGE_2D_ARRAY:               AttributeType read new AttributeType($9069);
    public static property UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY:         AttributeType read new AttributeType($906A);
    public static property UNSIGNED_INT_IMAGE_2D_MULTISAMPLE:         AttributeType read new AttributeType($906B);
    public static property UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY:   AttributeType read new AttributeType($906C);
    public static property SAMPLER_2D_MULTISAMPLE:                    AttributeType read new AttributeType($9108);
    public static property INT_SAMPLER_2D_MULTISAMPLE:                AttributeType read new AttributeType($9109);
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE:       AttributeType read new AttributeType($910A);
    public static property SAMPLER_2D_MULTISAMPLE_ARRAY:              AttributeType read new AttributeType($910B);
    public static property INT_SAMPLER_2D_MULTISAMPLE_ARRAY:          AttributeType read new AttributeType($910C);
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY: AttributeType read new AttributeType($910D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
      if self.val = UInt32($140E) then Result := 'INT64_ARB' else
      if self.val = UInt32($140E) then Result := 'INT64_NV' else
      if self.val = UInt32($140F) then Result := 'UNSIGNED_INT64_ARB' else
      if self.val = UInt32($140F) then Result := 'UNSIGNED_INT64_NV' else
      if self.val = UInt32($8B50) then Result := 'FLOAT_VEC2' else
      if self.val = UInt32($8B50) then Result := 'FLOAT_VEC2_ARB' else
      if self.val = UInt32($8B51) then Result := 'FLOAT_VEC3' else
      if self.val = UInt32($8B51) then Result := 'FLOAT_VEC3_ARB' else
      if self.val = UInt32($8B52) then Result := 'FLOAT_VEC4' else
      if self.val = UInt32($8B52) then Result := 'FLOAT_VEC4_ARB' else
      if self.val = UInt32($8B53) then Result := 'INT_VEC2' else
      if self.val = UInt32($8B53) then Result := 'INT_VEC2_ARB' else
      if self.val = UInt32($8B54) then Result := 'INT_VEC3' else
      if self.val = UInt32($8B54) then Result := 'INT_VEC3_ARB' else
      if self.val = UInt32($8B55) then Result := 'INT_VEC4' else
      if self.val = UInt32($8B55) then Result := 'INT_VEC4_ARB' else
      if self.val = UInt32($8B56) then Result := 'BOOL' else
      if self.val = UInt32($8B56) then Result := 'BOOL_ARB' else
      if self.val = UInt32($8B57) then Result := 'BOOL_VEC2' else
      if self.val = UInt32($8B57) then Result := 'BOOL_VEC2_ARB' else
      if self.val = UInt32($8B58) then Result := 'BOOL_VEC3' else
      if self.val = UInt32($8B58) then Result := 'BOOL_VEC3_ARB' else
      if self.val = UInt32($8B59) then Result := 'BOOL_VEC4' else
      if self.val = UInt32($8B59) then Result := 'BOOL_VEC4_ARB' else
      if self.val = UInt32($8B5A) then Result := 'FLOAT_MAT2' else
      if self.val = UInt32($8B5A) then Result := 'FLOAT_MAT2_ARB' else
      if self.val = UInt32($8B5B) then Result := 'FLOAT_MAT3' else
      if self.val = UInt32($8B5B) then Result := 'FLOAT_MAT3_ARB' else
      if self.val = UInt32($8B5C) then Result := 'FLOAT_MAT4' else
      if self.val = UInt32($8B5C) then Result := 'FLOAT_MAT4_ARB' else
      if self.val = UInt32($8B5D) then Result := 'SAMPLER_1D' else
      if self.val = UInt32($8B5D) then Result := 'SAMPLER_1D_ARB' else
      if self.val = UInt32($8B5E) then Result := 'SAMPLER_2D' else
      if self.val = UInt32($8B5E) then Result := 'SAMPLER_2D_ARB' else
      if self.val = UInt32($8B5F) then Result := 'SAMPLER_3D' else
      if self.val = UInt32($8B5F) then Result := 'SAMPLER_3D_ARB' else
      if self.val = UInt32($8B5F) then Result := 'SAMPLER_3D_OES' else
      if self.val = UInt32($8B60) then Result := 'SAMPLER_CUBE' else
      if self.val = UInt32($8B60) then Result := 'SAMPLER_CUBE_ARB' else
      if self.val = UInt32($8B61) then Result := 'SAMPLER_1D_SHADOW' else
      if self.val = UInt32($8B61) then Result := 'SAMPLER_1D_SHADOW_ARB' else
      if self.val = UInt32($8B62) then Result := 'SAMPLER_2D_SHADOW' else
      if self.val = UInt32($8B62) then Result := 'SAMPLER_2D_SHADOW_ARB' else
      if self.val = UInt32($8B62) then Result := 'SAMPLER_2D_SHADOW_EXT' else
      if self.val = UInt32($8B63) then Result := 'SAMPLER_2D_RECT' else
      if self.val = UInt32($8B63) then Result := 'SAMPLER_2D_RECT_ARB' else
      if self.val = UInt32($8B64) then Result := 'SAMPLER_2D_RECT_SHADOW' else
      if self.val = UInt32($8B64) then Result := 'SAMPLER_2D_RECT_SHADOW_ARB' else
      if self.val = UInt32($8B65) then Result := 'FLOAT_MAT2x3' else
      if self.val = UInt32($8B65) then Result := 'FLOAT_MAT2x3_NV' else
      if self.val = UInt32($8B66) then Result := 'FLOAT_MAT2x4' else
      if self.val = UInt32($8B66) then Result := 'FLOAT_MAT2x4_NV' else
      if self.val = UInt32($8B67) then Result := 'FLOAT_MAT3x2' else
      if self.val = UInt32($8B67) then Result := 'FLOAT_MAT3x2_NV' else
      if self.val = UInt32($8B68) then Result := 'FLOAT_MAT3x4' else
      if self.val = UInt32($8B68) then Result := 'FLOAT_MAT3x4_NV' else
      if self.val = UInt32($8B69) then Result := 'FLOAT_MAT4x2' else
      if self.val = UInt32($8B69) then Result := 'FLOAT_MAT4x2_NV' else
      if self.val = UInt32($8B6A) then Result := 'FLOAT_MAT4x3' else
      if self.val = UInt32($8B6A) then Result := 'FLOAT_MAT4x3_NV' else
      if self.val = UInt32($8DC2) then Result := 'SAMPLER_BUFFER' else
      if self.val = UInt32($8DC3) then Result := 'SAMPLER_1D_ARRAY_SHADOW' else
      if self.val = UInt32($8DC4) then Result := 'SAMPLER_2D_ARRAY_SHADOW' else
      if self.val = UInt32($8DC5) then Result := 'SAMPLER_CUBE_SHADOW' else
      if self.val = UInt32($8DC6) then Result := 'UNSIGNED_INT_VEC2' else
      if self.val = UInt32($8DC7) then Result := 'UNSIGNED_INT_VEC3' else
      if self.val = UInt32($8DC8) then Result := 'UNSIGNED_INT_VEC4' else
      if self.val = UInt32($8DC9) then Result := 'INT_SAMPLER_1D' else
      if self.val = UInt32($8DCA) then Result := 'INT_SAMPLER_2D' else
      if self.val = UInt32($8DCB) then Result := 'INT_SAMPLER_3D' else
      if self.val = UInt32($8DCC) then Result := 'INT_SAMPLER_CUBE' else
      if self.val = UInt32($8DCD) then Result := 'INT_SAMPLER_2D_RECT' else
      if self.val = UInt32($8DCE) then Result := 'INT_SAMPLER_1D_ARRAY' else
      if self.val = UInt32($8DCF) then Result := 'INT_SAMPLER_2D_ARRAY' else
      if self.val = UInt32($8DD0) then Result := 'INT_SAMPLER_BUFFER' else
      if self.val = UInt32($8DD1) then Result := 'UNSIGNED_INT_SAMPLER_1D' else
      if self.val = UInt32($8DD2) then Result := 'UNSIGNED_INT_SAMPLER_2D' else
      if self.val = UInt32($8DD3) then Result := 'UNSIGNED_INT_SAMPLER_3D' else
      if self.val = UInt32($8DD4) then Result := 'UNSIGNED_INT_SAMPLER_CUBE' else
      if self.val = UInt32($8DD5) then Result := 'UNSIGNED_INT_SAMPLER_2D_RECT' else
      if self.val = UInt32($8DD6) then Result := 'UNSIGNED_INT_SAMPLER_1D_ARRAY' else
      if self.val = UInt32($8DD7) then Result := 'UNSIGNED_INT_SAMPLER_2D_ARRAY' else
      if self.val = UInt32($8DD8) then Result := 'UNSIGNED_INT_SAMPLER_BUFFER' else
      if self.val = UInt32($8F46) then Result := 'DOUBLE_MAT2' else
      if self.val = UInt32($8F47) then Result := 'DOUBLE_MAT3' else
      if self.val = UInt32($8F48) then Result := 'DOUBLE_MAT4' else
      if self.val = UInt32($8F49) then Result := 'DOUBLE_MAT2x3' else
      if self.val = UInt32($8F4A) then Result := 'DOUBLE_MAT2x4' else
      if self.val = UInt32($8F4B) then Result := 'DOUBLE_MAT3x2' else
      if self.val = UInt32($8F4C) then Result := 'DOUBLE_MAT3x4' else
      if self.val = UInt32($8F4D) then Result := 'DOUBLE_MAT4x2' else
      if self.val = UInt32($8F4E) then Result := 'DOUBLE_MAT4x3' else
      if self.val = UInt32($8FE9) then Result := 'INT64_VEC2_ARB' else
      if self.val = UInt32($8FEA) then Result := 'INT64_VEC3_ARB' else
      if self.val = UInt32($8FEB) then Result := 'INT64_VEC4_ARB' else
      if self.val = UInt32($8FF5) then Result := 'UNSIGNED_INT64_VEC2_ARB' else
      if self.val = UInt32($8FF6) then Result := 'UNSIGNED_INT64_VEC3_ARB' else
      if self.val = UInt32($8FF7) then Result := 'UNSIGNED_INT64_VEC4_ARB' else
      if self.val = UInt32($8FFC) then Result := 'DOUBLE_VEC2' else
      if self.val = UInt32($8FFD) then Result := 'DOUBLE_VEC3' else
      if self.val = UInt32($8FFE) then Result := 'DOUBLE_VEC4' else
      if self.val = UInt32($900C) then Result := 'SAMPLER_CUBE_MAP_ARRAY' else
      if self.val = UInt32($900D) then Result := 'SAMPLER_CUBE_MAP_ARRAY_SHADOW' else
      if self.val = UInt32($900E) then Result := 'INT_SAMPLER_CUBE_MAP_ARRAY' else
      if self.val = UInt32($900F) then Result := 'UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY' else
      if self.val = UInt32($904C) then Result := 'IMAGE_1D' else
      if self.val = UInt32($904D) then Result := 'IMAGE_2D' else
      if self.val = UInt32($904E) then Result := 'IMAGE_3D' else
      if self.val = UInt32($904F) then Result := 'IMAGE_2D_RECT' else
      if self.val = UInt32($9050) then Result := 'IMAGE_CUBE' else
      if self.val = UInt32($9051) then Result := 'IMAGE_BUFFER' else
      if self.val = UInt32($9052) then Result := 'IMAGE_1D_ARRAY' else
      if self.val = UInt32($9053) then Result := 'IMAGE_2D_ARRAY' else
      if self.val = UInt32($9054) then Result := 'IMAGE_CUBE_MAP_ARRAY' else
      if self.val = UInt32($9055) then Result := 'IMAGE_2D_MULTISAMPLE' else
      if self.val = UInt32($9056) then Result := 'IMAGE_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($9057) then Result := 'INT_IMAGE_1D' else
      if self.val = UInt32($9058) then Result := 'INT_IMAGE_2D' else
      if self.val = UInt32($9059) then Result := 'INT_IMAGE_3D' else
      if self.val = UInt32($905A) then Result := 'INT_IMAGE_2D_RECT' else
      if self.val = UInt32($905B) then Result := 'INT_IMAGE_CUBE' else
      if self.val = UInt32($905C) then Result := 'INT_IMAGE_BUFFER' else
      if self.val = UInt32($905D) then Result := 'INT_IMAGE_1D_ARRAY' else
      if self.val = UInt32($905E) then Result := 'INT_IMAGE_2D_ARRAY' else
      if self.val = UInt32($905F) then Result := 'INT_IMAGE_CUBE_MAP_ARRAY' else
      if self.val = UInt32($9060) then Result := 'INT_IMAGE_2D_MULTISAMPLE' else
      if self.val = UInt32($9061) then Result := 'INT_IMAGE_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($9062) then Result := 'UNSIGNED_INT_IMAGE_1D' else
      if self.val = UInt32($9063) then Result := 'UNSIGNED_INT_IMAGE_2D' else
      if self.val = UInt32($9064) then Result := 'UNSIGNED_INT_IMAGE_3D' else
      if self.val = UInt32($9065) then Result := 'UNSIGNED_INT_IMAGE_2D_RECT' else
      if self.val = UInt32($9066) then Result := 'UNSIGNED_INT_IMAGE_CUBE' else
      if self.val = UInt32($9067) then Result := 'UNSIGNED_INT_IMAGE_BUFFER' else
      if self.val = UInt32($9068) then Result := 'UNSIGNED_INT_IMAGE_1D_ARRAY' else
      if self.val = UInt32($9069) then Result := 'UNSIGNED_INT_IMAGE_2D_ARRAY' else
      if self.val = UInt32($906A) then Result := 'UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY' else
      if self.val = UInt32($906B) then Result := 'UNSIGNED_INT_IMAGE_2D_MULTISAMPLE' else
      if self.val = UInt32($906C) then Result := 'UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($9108) then Result := 'SAMPLER_2D_MULTISAMPLE' else
      if self.val = UInt32($9109) then Result := 'INT_SAMPLER_2D_MULTISAMPLE' else
      if self.val = UInt32($910A) then Result := 'UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE' else
      if self.val = UInt32($910B) then Result := 'SAMPLER_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($910C) then Result := 'INT_SAMPLER_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($910D) then Result := 'UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY' else
        Result := $'AttributeType[{self.val}]';
    end;
    
  end;
  
  BindTransformFeedbackTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TRANSFORM_FEEDBACK: BindTransformFeedbackTarget read new BindTransformFeedbackTarget($8E22);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E22) then Result := 'TRANSFORM_FEEDBACK' else
        Result := $'BindTransformFeedbackTarget[{self.val}]';
    end;
    
  end;
  
  BlendingFactor = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ZERO:                     BlendingFactor read new BlendingFactor($0000);
    public static property ONE:                      BlendingFactor read new BlendingFactor($0001);
    public static property SRC_COLOR:                BlendingFactor read new BlendingFactor($0300);
    public static property ONE_MINUS_SRC_COLOR:      BlendingFactor read new BlendingFactor($0301);
    public static property SRC_ALPHA:                BlendingFactor read new BlendingFactor($0302);
    public static property ONE_MINUS_SRC_ALPHA:      BlendingFactor read new BlendingFactor($0303);
    public static property DST_ALPHA:                BlendingFactor read new BlendingFactor($0304);
    public static property ONE_MINUS_DST_ALPHA:      BlendingFactor read new BlendingFactor($0305);
    public static property DST_COLOR:                BlendingFactor read new BlendingFactor($0306);
    public static property ONE_MINUS_DST_COLOR:      BlendingFactor read new BlendingFactor($0307);
    public static property SRC_ALPHA_SATURATE:       BlendingFactor read new BlendingFactor($0308);
    public static property CONSTANT_COLOR:           BlendingFactor read new BlendingFactor($8001);
    public static property ONE_MINUS_CONSTANT_COLOR: BlendingFactor read new BlendingFactor($8002);
    public static property CONSTANT_ALPHA:           BlendingFactor read new BlendingFactor($8003);
    public static property ONE_MINUS_CONSTANT_ALPHA: BlendingFactor read new BlendingFactor($8004);
    public static property SRC1_ALPHA:               BlendingFactor read new BlendingFactor($8589);
    public static property SRC1_COLOR:               BlendingFactor read new BlendingFactor($88F9);
    public static property ONE_MINUS_SRC1_COLOR:     BlendingFactor read new BlendingFactor($88FA);
    public static property ONE_MINUS_SRC1_ALPHA:     BlendingFactor read new BlendingFactor($88FB);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'ZERO' else
      if self.val = UInt32($0001) then Result := 'ONE' else
      if self.val = UInt32($0300) then Result := 'SRC_COLOR' else
      if self.val = UInt32($0301) then Result := 'ONE_MINUS_SRC_COLOR' else
      if self.val = UInt32($0302) then Result := 'SRC_ALPHA' else
      if self.val = UInt32($0303) then Result := 'ONE_MINUS_SRC_ALPHA' else
      if self.val = UInt32($0304) then Result := 'DST_ALPHA' else
      if self.val = UInt32($0305) then Result := 'ONE_MINUS_DST_ALPHA' else
      if self.val = UInt32($0306) then Result := 'DST_COLOR' else
      if self.val = UInt32($0307) then Result := 'ONE_MINUS_DST_COLOR' else
      if self.val = UInt32($0308) then Result := 'SRC_ALPHA_SATURATE' else
      if self.val = UInt32($8001) then Result := 'CONSTANT_COLOR' else
      if self.val = UInt32($8002) then Result := 'ONE_MINUS_CONSTANT_COLOR' else
      if self.val = UInt32($8003) then Result := 'CONSTANT_ALPHA' else
      if self.val = UInt32($8004) then Result := 'ONE_MINUS_CONSTANT_ALPHA' else
      if self.val = UInt32($8589) then Result := 'SRC1_ALPHA' else
      if self.val = UInt32($88F9) then Result := 'SRC1_COLOR' else
      if self.val = UInt32($88FA) then Result := 'ONE_MINUS_SRC1_COLOR' else
      if self.val = UInt32($88FB) then Result := 'ONE_MINUS_SRC1_ALPHA' else
        Result := $'BlendingFactor[{self.val}]';
    end;
    
  end;
  
  BlitFramebufferFilter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NEAREST: BlitFramebufferFilter read new BlitFramebufferFilter($2600);
    public static property LINEAR:  BlitFramebufferFilter read new BlitFramebufferFilter($2601);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2600) then Result := 'NEAREST' else
      if self.val = UInt32($2601) then Result := 'LINEAR' else
        Result := $'BlitFramebufferFilter[{self.val}]';
    end;
    
  end;
  
  Bool = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FALSE: Bool read new Bool($0000);
    public static property TRUE:  Bool read new Bool($0001);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'FALSE' else
      if self.val = UInt32($0001) then Result := 'TRUE' else
        Result := $'Bool[{self.val}]';
    end;
    
    public static function operator implicit(b: Bool): boolean := b.val<>Bool.FALSE.val;
    public static function operator implicit(b: boolean): Bool := new Bool(UInt32(b));
    
    public static function operator not(b: Bool): Bool := b.val=Bool.FALSE.val ? Bool.TRUE : Bool.FALSE;
    
  end;
  
  Buffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COLOR:   Buffer read new Buffer($1800);
    public static property DEPTH:   Buffer read new Buffer($1801);
    public static property STENCIL: Buffer read new Buffer($1802);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1800) then Result := 'COLOR' else
      if self.val = UInt32($1801) then Result := 'DEPTH' else
      if self.val = UInt32($1802) then Result := 'STENCIL' else
        Result := $'Buffer[{self.val}]';
    end;
    
  end;
  
  BufferStorageMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MAP_READ_BIT:                  BufferStorageMask read new BufferStorageMask($0001);
    public static property MAP_READ_BIT_EXT:              BufferStorageMask read new BufferStorageMask($0001);
    public static property MAP_WRITE_BIT:                 BufferStorageMask read new BufferStorageMask($0002);
    public static property MAP_WRITE_BIT_EXT:             BufferStorageMask read new BufferStorageMask($0002);
    public static property MAP_PERSISTENT_BIT:            BufferStorageMask read new BufferStorageMask($0040);
    public static property MAP_PERSISTENT_BIT_EXT:        BufferStorageMask read new BufferStorageMask($0040);
    public static property MAP_COHERENT_BIT:              BufferStorageMask read new BufferStorageMask($0080);
    public static property MAP_COHERENT_BIT_EXT:          BufferStorageMask read new BufferStorageMask($0080);
    public static property DYNAMIC_STORAGE_BIT:           BufferStorageMask read new BufferStorageMask($0100);
    public static property DYNAMIC_STORAGE_BIT_EXT:       BufferStorageMask read new BufferStorageMask($0100);
    public static property CLIENT_STORAGE_BIT:            BufferStorageMask read new BufferStorageMask($0200);
    public static property CLIENT_STORAGE_BIT_EXT:        BufferStorageMask read new BufferStorageMask($0200);
    public static property SPARSE_STORAGE_BIT_ARB:        BufferStorageMask read new BufferStorageMask($0400);
    public static property LGPU_SEPARATE_STORAGE_BIT_NVX: BufferStorageMask read new BufferStorageMask($0800);
    public static property PER_GPU_STORAGE_BIT_NV:        BufferStorageMask read new BufferStorageMask($0800);
    public static property EXTERNAL_STORAGE_BIT_NVX:      BufferStorageMask read new BufferStorageMask($2000);
    
    public static function operator+(f1,f2: BufferStorageMask) := new BufferStorageMask(f1.val or f2.val);
    public static function operator or(f1,f2: BufferStorageMask) := f1+f2;
    
    public property HAS_FLAG_MAP_READ_BIT:                  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_READ_BIT_EXT:              boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT:                 boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT_EXT:             boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT:            boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT_EXT:        boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT:              boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT_EXT:          boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_DYNAMIC_STORAGE_BIT:           boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_DYNAMIC_STORAGE_BIT_EXT:       boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_CLIENT_STORAGE_BIT:            boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_CLIENT_STORAGE_BIT_EXT:        boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_SPARSE_STORAGE_BIT_ARB:        boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_LGPU_SEPARATE_STORAGE_BIT_NVX: boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_PER_GPU_STORAGE_BIT_NV:        boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_EXTERNAL_STORAGE_BIT_NVX:      boolean read self.val and $2000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'MAP_READ_BIT+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'MAP_READ_BIT_EXT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'MAP_WRITE_BIT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'MAP_WRITE_BIT_EXT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'MAP_PERSISTENT_BIT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'MAP_PERSISTENT_BIT_EXT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'MAP_COHERENT_BIT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'MAP_COHERENT_BIT_EXT+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'DYNAMIC_STORAGE_BIT+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'DYNAMIC_STORAGE_BIT_EXT+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'CLIENT_STORAGE_BIT+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'CLIENT_STORAGE_BIT_EXT+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'SPARSE_STORAGE_BIT_ARB+';
      if self.val and UInt32($0800) = UInt32($0800) then res += 'LGPU_SEPARATE_STORAGE_BIT_NVX+';
      if self.val and UInt32($0800) = UInt32($0800) then res += 'PER_GPU_STORAGE_BIT_NV+';
      if self.val and UInt32($2000) = UInt32($2000) then res += 'EXTERNAL_STORAGE_BIT_NVX+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'BufferStorageMask[{self.val}]';
    end;
    
  end;
  
  BufferStorageTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ARRAY_BUFFER:              BufferStorageTarget read new BufferStorageTarget($8892);
    public static property ELEMENT_ARRAY_BUFFER:      BufferStorageTarget read new BufferStorageTarget($8893);
    public static property PIXEL_PACK_BUFFER:         BufferStorageTarget read new BufferStorageTarget($88EB);
    public static property PIXEL_UNPACK_BUFFER:       BufferStorageTarget read new BufferStorageTarget($88EC);
    public static property UNIFORM_BUFFER:            BufferStorageTarget read new BufferStorageTarget($8A11);
    public static property TEXTURE_BUFFER:            BufferStorageTarget read new BufferStorageTarget($8C2A);
    public static property TRANSFORM_FEEDBACK_BUFFER: BufferStorageTarget read new BufferStorageTarget($8C8E);
    public static property COPY_READ_BUFFER:          BufferStorageTarget read new BufferStorageTarget($8F36);
    public static property COPY_WRITE_BUFFER:         BufferStorageTarget read new BufferStorageTarget($8F37);
    public static property DRAW_INDIRECT_BUFFER:      BufferStorageTarget read new BufferStorageTarget($8F3F);
    public static property SHADER_STORAGE_BUFFER:     BufferStorageTarget read new BufferStorageTarget($90D2);
    public static property DISPATCH_INDIRECT_BUFFER:  BufferStorageTarget read new BufferStorageTarget($90EE);
    public static property QUERY_BUFFER:              BufferStorageTarget read new BufferStorageTarget($9192);
    public static property ATOMIC_COUNTER_BUFFER:     BufferStorageTarget read new BufferStorageTarget($92C0);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8892) then Result := 'ARRAY_BUFFER' else
      if self.val = UInt32($8893) then Result := 'ELEMENT_ARRAY_BUFFER' else
      if self.val = UInt32($88EB) then Result := 'PIXEL_PACK_BUFFER' else
      if self.val = UInt32($88EC) then Result := 'PIXEL_UNPACK_BUFFER' else
      if self.val = UInt32($8A11) then Result := 'UNIFORM_BUFFER' else
      if self.val = UInt32($8C2A) then Result := 'TEXTURE_BUFFER' else
      if self.val = UInt32($8C8E) then Result := 'TRANSFORM_FEEDBACK_BUFFER' else
      if self.val = UInt32($8F36) then Result := 'COPY_READ_BUFFER' else
      if self.val = UInt32($8F37) then Result := 'COPY_WRITE_BUFFER' else
      if self.val = UInt32($8F3F) then Result := 'DRAW_INDIRECT_BUFFER' else
      if self.val = UInt32($90D2) then Result := 'SHADER_STORAGE_BUFFER' else
      if self.val = UInt32($90EE) then Result := 'DISPATCH_INDIRECT_BUFFER' else
      if self.val = UInt32($9192) then Result := 'QUERY_BUFFER' else
      if self.val = UInt32($92C0) then Result := 'ATOMIC_COUNTER_BUFFER' else
        Result := $'BufferStorageTarget[{self.val}]';
    end;
    
  end;
  
  BufferTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PARAMETER_BUFFER:          BufferTarget read new BufferTarget($80EE);
    public static property ARRAY_BUFFER:              BufferTarget read new BufferTarget($8892);
    public static property ELEMENT_ARRAY_BUFFER:      BufferTarget read new BufferTarget($8893);
    public static property PIXEL_PACK_BUFFER:         BufferTarget read new BufferTarget($88EB);
    public static property PIXEL_UNPACK_BUFFER:       BufferTarget read new BufferTarget($88EC);
    public static property UNIFORM_BUFFER:            BufferTarget read new BufferTarget($8A11);
    public static property TEXTURE_BUFFER:            BufferTarget read new BufferTarget($8C2A);
    public static property TRANSFORM_FEEDBACK_BUFFER: BufferTarget read new BufferTarget($8C8E);
    public static property COPY_READ_BUFFER:          BufferTarget read new BufferTarget($8F36);
    public static property COPY_WRITE_BUFFER:         BufferTarget read new BufferTarget($8F37);
    public static property DRAW_INDIRECT_BUFFER:      BufferTarget read new BufferTarget($8F3F);
    public static property SHADER_STORAGE_BUFFER:     BufferTarget read new BufferTarget($90D2);
    public static property DISPATCH_INDIRECT_BUFFER:  BufferTarget read new BufferTarget($90EE);
    public static property QUERY_BUFFER:              BufferTarget read new BufferTarget($9192);
    public static property ATOMIC_COUNTER_BUFFER:     BufferTarget read new BufferTarget($92C0);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80EE) then Result := 'PARAMETER_BUFFER' else
      if self.val = UInt32($8892) then Result := 'ARRAY_BUFFER' else
      if self.val = UInt32($8893) then Result := 'ELEMENT_ARRAY_BUFFER' else
      if self.val = UInt32($88EB) then Result := 'PIXEL_PACK_BUFFER' else
      if self.val = UInt32($88EC) then Result := 'PIXEL_UNPACK_BUFFER' else
      if self.val = UInt32($8A11) then Result := 'UNIFORM_BUFFER' else
      if self.val = UInt32($8C2A) then Result := 'TEXTURE_BUFFER' else
      if self.val = UInt32($8C8E) then Result := 'TRANSFORM_FEEDBACK_BUFFER' else
      if self.val = UInt32($8F36) then Result := 'COPY_READ_BUFFER' else
      if self.val = UInt32($8F37) then Result := 'COPY_WRITE_BUFFER' else
      if self.val = UInt32($8F3F) then Result := 'DRAW_INDIRECT_BUFFER' else
      if self.val = UInt32($90D2) then Result := 'SHADER_STORAGE_BUFFER' else
      if self.val = UInt32($90EE) then Result := 'DISPATCH_INDIRECT_BUFFER' else
      if self.val = UInt32($9192) then Result := 'QUERY_BUFFER' else
      if self.val = UInt32($92C0) then Result := 'ATOMIC_COUNTER_BUFFER' else
        Result := $'BufferTarget[{self.val}]';
    end;
    
  end;
  
  ClearBufferMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DEPTH_BUFFER_BIT:       ClearBufferMask read new ClearBufferMask($0100);
    public static property ACCUM_BUFFER_BIT:       ClearBufferMask read new ClearBufferMask($0200);
    public static property STENCIL_BUFFER_BIT:     ClearBufferMask read new ClearBufferMask($0400);
    public static property COLOR_BUFFER_BIT:       ClearBufferMask read new ClearBufferMask($4000);
    public static property COVERAGE_BUFFER_BIT_NV: ClearBufferMask read new ClearBufferMask($8000);
    
    public static function operator+(f1,f2: ClearBufferMask) := new ClearBufferMask(f1.val or f2.val);
    public static function operator or(f1,f2: ClearBufferMask) := f1+f2;
    
    public property HAS_FLAG_DEPTH_BUFFER_BIT:       boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_ACCUM_BUFFER_BIT:       boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_STENCIL_BUFFER_BIT:     boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_COLOR_BUFFER_BIT:       boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_COVERAGE_BUFFER_BIT_NV: boolean read self.val and $8000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0100) = UInt32($0100) then res += 'DEPTH_BUFFER_BIT+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'ACCUM_BUFFER_BIT+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'STENCIL_BUFFER_BIT+';
      if self.val and UInt32($4000) = UInt32($4000) then res += 'COLOR_BUFFER_BIT+';
      if self.val and UInt32($8000) = UInt32($8000) then res += 'COVERAGE_BUFFER_BIT_NV+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'ClearBufferMask[{self.val}]';
    end;
    
  end;
  
  ClientAttribMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CLIENT_PIXEL_STORE_BIT:  ClientAttribMask read new ClientAttribMask($0001);
    public static property CLIENT_VERTEX_ARRAY_BIT: ClientAttribMask read new ClientAttribMask($0002);
    public static property CLIENT_ALL_ATTRIB_BITS:  ClientAttribMask read new ClientAttribMask($FFFFFFFF);
    
    public static function operator+(f1,f2: ClientAttribMask) := new ClientAttribMask(f1.val or f2.val);
    public static function operator or(f1,f2: ClientAttribMask) := f1+f2;
    
    public property HAS_FLAG_CLIENT_PIXEL_STORE_BIT:  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_CLIENT_VERTEX_ARRAY_BIT: boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_CLIENT_ALL_ATTRIB_BITS:  boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'CLIENT_PIXEL_STORE_BIT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'CLIENT_VERTEX_ARRAY_BIT+';
      if self.val and UInt32($FFFFFFFF) = UInt32($FFFFFFFF) then res += 'CLIENT_ALL_ATTRIB_BITS+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'ClientAttribMask[{self.val}]';
    end;
    
  end;
  
  ClipControlDepth = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NEGATIVE_ONE_TO_ONE: ClipControlDepth read new ClipControlDepth($935E);
    public static property ZERO_TO_ONE:         ClipControlDepth read new ClipControlDepth($935F);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($935E) then Result := 'NEGATIVE_ONE_TO_ONE' else
      if self.val = UInt32($935F) then Result := 'ZERO_TO_ONE' else
        Result := $'ClipControlDepth[{self.val}]';
    end;
    
  end;
  
  ClipControlOrigin = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LOWER_LEFT: ClipControlOrigin read new ClipControlOrigin($8CA1);
    public static property UPPER_LEFT: ClipControlOrigin read new ClipControlOrigin($8CA2);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8CA1) then Result := 'LOWER_LEFT' else
      if self.val = UInt32($8CA2) then Result := 'UPPER_LEFT' else
        Result := $'ClipControlOrigin[{self.val}]';
    end;
    
  end;
  
  ClipPlaneName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CLIP_DISTANCE0: ClipPlaneName read new ClipPlaneName($3000);
    public static property CLIP_PLANE0:    ClipPlaneName read new ClipPlaneName($3000);
    public static property CLIP_DISTANCE1: ClipPlaneName read new ClipPlaneName($3001);
    public static property CLIP_PLANE1:    ClipPlaneName read new ClipPlaneName($3001);
    public static property CLIP_DISTANCE2: ClipPlaneName read new ClipPlaneName($3002);
    public static property CLIP_PLANE2:    ClipPlaneName read new ClipPlaneName($3002);
    public static property CLIP_DISTANCE3: ClipPlaneName read new ClipPlaneName($3003);
    public static property CLIP_PLANE3:    ClipPlaneName read new ClipPlaneName($3003);
    public static property CLIP_DISTANCE4: ClipPlaneName read new ClipPlaneName($3004);
    public static property CLIP_PLANE4:    ClipPlaneName read new ClipPlaneName($3004);
    public static property CLIP_DISTANCE5: ClipPlaneName read new ClipPlaneName($3005);
    public static property CLIP_PLANE5:    ClipPlaneName read new ClipPlaneName($3005);
    public static property CLIP_DISTANCE6: ClipPlaneName read new ClipPlaneName($3006);
    public static property CLIP_DISTANCE7: ClipPlaneName read new ClipPlaneName($3007);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($3000) then Result := 'CLIP_DISTANCE0' else
      if self.val = UInt32($3000) then Result := 'CLIP_PLANE0' else
      if self.val = UInt32($3001) then Result := 'CLIP_DISTANCE1' else
      if self.val = UInt32($3001) then Result := 'CLIP_PLANE1' else
      if self.val = UInt32($3002) then Result := 'CLIP_DISTANCE2' else
      if self.val = UInt32($3002) then Result := 'CLIP_PLANE2' else
      if self.val = UInt32($3003) then Result := 'CLIP_DISTANCE3' else
      if self.val = UInt32($3003) then Result := 'CLIP_PLANE3' else
      if self.val = UInt32($3004) then Result := 'CLIP_DISTANCE4' else
      if self.val = UInt32($3004) then Result := 'CLIP_PLANE4' else
      if self.val = UInt32($3005) then Result := 'CLIP_DISTANCE5' else
      if self.val = UInt32($3005) then Result := 'CLIP_PLANE5' else
      if self.val = UInt32($3006) then Result := 'CLIP_DISTANCE6' else
      if self.val = UInt32($3007) then Result := 'CLIP_DISTANCE7' else
        Result := $'ClipPlaneName[{self.val}]';
    end;
    
  end;
  
  ColorBuffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:               ColorBuffer read new ColorBuffer($0000);
    public static property FRONT_LEFT:         ColorBuffer read new ColorBuffer($0400);
    public static property FRONT_RIGHT:        ColorBuffer read new ColorBuffer($0401);
    public static property BACK_LEFT:          ColorBuffer read new ColorBuffer($0402);
    public static property BACK_RIGHT:         ColorBuffer read new ColorBuffer($0403);
    public static property FRONT:              ColorBuffer read new ColorBuffer($0404);
    public static property BACK:               ColorBuffer read new ColorBuffer($0405);
    public static property LEFT:               ColorBuffer read new ColorBuffer($0406);
    public static property RIGHT:              ColorBuffer read new ColorBuffer($0407);
    public static property FRONT_AND_BACK:     ColorBuffer read new ColorBuffer($0408);
    public static property COLOR_ATTACHMENT0:  ColorBuffer read new ColorBuffer($8CE0);
    public static property COLOR_ATTACHMENT1:  ColorBuffer read new ColorBuffer($8CE1);
    public static property COLOR_ATTACHMENT2:  ColorBuffer read new ColorBuffer($8CE2);
    public static property COLOR_ATTACHMENT3:  ColorBuffer read new ColorBuffer($8CE3);
    public static property COLOR_ATTACHMENT4:  ColorBuffer read new ColorBuffer($8CE4);
    public static property COLOR_ATTACHMENT5:  ColorBuffer read new ColorBuffer($8CE5);
    public static property COLOR_ATTACHMENT6:  ColorBuffer read new ColorBuffer($8CE6);
    public static property COLOR_ATTACHMENT7:  ColorBuffer read new ColorBuffer($8CE7);
    public static property COLOR_ATTACHMENT8:  ColorBuffer read new ColorBuffer($8CE8);
    public static property COLOR_ATTACHMENT9:  ColorBuffer read new ColorBuffer($8CE9);
    public static property COLOR_ATTACHMENT10: ColorBuffer read new ColorBuffer($8CEA);
    public static property COLOR_ATTACHMENT11: ColorBuffer read new ColorBuffer($8CEB);
    public static property COLOR_ATTACHMENT12: ColorBuffer read new ColorBuffer($8CEC);
    public static property COLOR_ATTACHMENT13: ColorBuffer read new ColorBuffer($8CED);
    public static property COLOR_ATTACHMENT14: ColorBuffer read new ColorBuffer($8CEE);
    public static property COLOR_ATTACHMENT15: ColorBuffer read new ColorBuffer($8CEF);
    public static property COLOR_ATTACHMENT16: ColorBuffer read new ColorBuffer($8CF0);
    public static property COLOR_ATTACHMENT17: ColorBuffer read new ColorBuffer($8CF1);
    public static property COLOR_ATTACHMENT18: ColorBuffer read new ColorBuffer($8CF2);
    public static property COLOR_ATTACHMENT19: ColorBuffer read new ColorBuffer($8CF3);
    public static property COLOR_ATTACHMENT20: ColorBuffer read new ColorBuffer($8CF4);
    public static property COLOR_ATTACHMENT21: ColorBuffer read new ColorBuffer($8CF5);
    public static property COLOR_ATTACHMENT22: ColorBuffer read new ColorBuffer($8CF6);
    public static property COLOR_ATTACHMENT23: ColorBuffer read new ColorBuffer($8CF7);
    public static property COLOR_ATTACHMENT24: ColorBuffer read new ColorBuffer($8CF8);
    public static property COLOR_ATTACHMENT25: ColorBuffer read new ColorBuffer($8CF9);
    public static property COLOR_ATTACHMENT26: ColorBuffer read new ColorBuffer($8CFA);
    public static property COLOR_ATTACHMENT27: ColorBuffer read new ColorBuffer($8CFB);
    public static property COLOR_ATTACHMENT28: ColorBuffer read new ColorBuffer($8CFC);
    public static property COLOR_ATTACHMENT29: ColorBuffer read new ColorBuffer($8CFD);
    public static property COLOR_ATTACHMENT30: ColorBuffer read new ColorBuffer($8CFE);
    public static property COLOR_ATTACHMENT31: ColorBuffer read new ColorBuffer($8CFF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($0400) then Result := 'FRONT_LEFT' else
      if self.val = UInt32($0401) then Result := 'FRONT_RIGHT' else
      if self.val = UInt32($0402) then Result := 'BACK_LEFT' else
      if self.val = UInt32($0403) then Result := 'BACK_RIGHT' else
      if self.val = UInt32($0404) then Result := 'FRONT' else
      if self.val = UInt32($0405) then Result := 'BACK' else
      if self.val = UInt32($0406) then Result := 'LEFT' else
      if self.val = UInt32($0407) then Result := 'RIGHT' else
      if self.val = UInt32($0408) then Result := 'FRONT_AND_BACK' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15' else
      if self.val = UInt32($8CF0) then Result := 'COLOR_ATTACHMENT16' else
      if self.val = UInt32($8CF1) then Result := 'COLOR_ATTACHMENT17' else
      if self.val = UInt32($8CF2) then Result := 'COLOR_ATTACHMENT18' else
      if self.val = UInt32($8CF3) then Result := 'COLOR_ATTACHMENT19' else
      if self.val = UInt32($8CF4) then Result := 'COLOR_ATTACHMENT20' else
      if self.val = UInt32($8CF5) then Result := 'COLOR_ATTACHMENT21' else
      if self.val = UInt32($8CF6) then Result := 'COLOR_ATTACHMENT22' else
      if self.val = UInt32($8CF7) then Result := 'COLOR_ATTACHMENT23' else
      if self.val = UInt32($8CF8) then Result := 'COLOR_ATTACHMENT24' else
      if self.val = UInt32($8CF9) then Result := 'COLOR_ATTACHMENT25' else
      if self.val = UInt32($8CFA) then Result := 'COLOR_ATTACHMENT26' else
      if self.val = UInt32($8CFB) then Result := 'COLOR_ATTACHMENT27' else
      if self.val = UInt32($8CFC) then Result := 'COLOR_ATTACHMENT28' else
      if self.val = UInt32($8CFD) then Result := 'COLOR_ATTACHMENT29' else
      if self.val = UInt32($8CFE) then Result := 'COLOR_ATTACHMENT30' else
      if self.val = UInt32($8CFF) then Result := 'COLOR_ATTACHMENT31' else
        Result := $'ColorBuffer[{self.val}]';
    end;
    
  end;
  
  ColorMaterialParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property AMBIENT:             ColorMaterialParameter read new ColorMaterialParameter($1200);
    public static property DIFFUSE:             ColorMaterialParameter read new ColorMaterialParameter($1201);
    public static property SPECULAR:            ColorMaterialParameter read new ColorMaterialParameter($1202);
    public static property EMISSION:            ColorMaterialParameter read new ColorMaterialParameter($1600);
    public static property AMBIENT_AND_DIFFUSE: ColorMaterialParameter read new ColorMaterialParameter($1602);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1200) then Result := 'AMBIENT' else
      if self.val = UInt32($1201) then Result := 'DIFFUSE' else
      if self.val = UInt32($1202) then Result := 'SPECULAR' else
      if self.val = UInt32($1600) then Result := 'EMISSION' else
      if self.val = UInt32($1602) then Result := 'AMBIENT_AND_DIFFUSE' else
        Result := $'ColorMaterialParameter[{self.val}]';
    end;
    
  end;
  
  ColorPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:           ColorPointerType read new ColorPointerType($1400);
    public static property UNSIGNED_BYTE:  ColorPointerType read new ColorPointerType($1401);
    public static property UNSIGNED_SHORT: ColorPointerType read new ColorPointerType($1403);
    public static property UNSIGNED_INT:   ColorPointerType read new ColorPointerType($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'ColorPointerType[{self.val}]';
    end;
    
  end;
  
  ColorTableTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COLOR_TABLE:                         ColorTableTarget read new ColorTableTarget($80D0);
    public static property POST_CONVOLUTION_COLOR_TABLE:        ColorTableTarget read new ColorTableTarget($80D1);
    public static property POST_COLOR_MATRIX_COLOR_TABLE:       ColorTableTarget read new ColorTableTarget($80D2);
    public static property PROXY_COLOR_TABLE:                   ColorTableTarget read new ColorTableTarget($80D3);
    public static property PROXY_POST_CONVOLUTION_COLOR_TABLE:  ColorTableTarget read new ColorTableTarget($80D4);
    public static property PROXY_POST_COLOR_MATRIX_COLOR_TABLE: ColorTableTarget read new ColorTableTarget($80D5);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80D0) then Result := 'COLOR_TABLE' else
      if self.val = UInt32($80D1) then Result := 'POST_CONVOLUTION_COLOR_TABLE' else
      if self.val = UInt32($80D2) then Result := 'POST_COLOR_MATRIX_COLOR_TABLE' else
      if self.val = UInt32($80D3) then Result := 'PROXY_COLOR_TABLE' else
      if self.val = UInt32($80D4) then Result := 'PROXY_POST_CONVOLUTION_COLOR_TABLE' else
      if self.val = UInt32($80D5) then Result := 'PROXY_POST_COLOR_MATRIX_COLOR_TABLE' else
        Result := $'ColorTableTarget[{self.val}]';
    end;
    
  end;
  
  ConditionalRenderMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property QUERY_WAIT:                       ConditionalRenderMode read new ConditionalRenderMode($8E13);
    public static property QUERY_NO_WAIT:                    ConditionalRenderMode read new ConditionalRenderMode($8E14);
    public static property QUERY_BY_REGION_WAIT:             ConditionalRenderMode read new ConditionalRenderMode($8E15);
    public static property QUERY_BY_REGION_NO_WAIT:          ConditionalRenderMode read new ConditionalRenderMode($8E16);
    public static property QUERY_WAIT_INVERTED:              ConditionalRenderMode read new ConditionalRenderMode($8E17);
    public static property QUERY_NO_WAIT_INVERTED:           ConditionalRenderMode read new ConditionalRenderMode($8E18);
    public static property QUERY_BY_REGION_WAIT_INVERTED:    ConditionalRenderMode read new ConditionalRenderMode($8E19);
    public static property QUERY_BY_REGION_NO_WAIT_INVERTED: ConditionalRenderMode read new ConditionalRenderMode($8E1A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E13) then Result := 'QUERY_WAIT' else
      if self.val = UInt32($8E14) then Result := 'QUERY_NO_WAIT' else
      if self.val = UInt32($8E15) then Result := 'QUERY_BY_REGION_WAIT' else
      if self.val = UInt32($8E16) then Result := 'QUERY_BY_REGION_NO_WAIT' else
      if self.val = UInt32($8E17) then Result := 'QUERY_WAIT_INVERTED' else
      if self.val = UInt32($8E18) then Result := 'QUERY_NO_WAIT_INVERTED' else
      if self.val = UInt32($8E19) then Result := 'QUERY_BY_REGION_WAIT_INVERTED' else
      if self.val = UInt32($8E1A) then Result := 'QUERY_BY_REGION_NO_WAIT_INVERTED' else
        Result := $'ConditionalRenderMode[{self.val}]';
    end;
    
  end;
  
  ConvolutionTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CONVOLUTION_1D: ConvolutionTarget read new ConvolutionTarget($8010);
    public static property CONVOLUTION_2D: ConvolutionTarget read new ConvolutionTarget($8011);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8010) then Result := 'CONVOLUTION_1D' else
      if self.val = UInt32($8011) then Result := 'CONVOLUTION_2D' else
        Result := $'ConvolutionTarget[{self.val}]';
    end;
    
  end;
  
  CopyBufferSubDataTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ARRAY_BUFFER:              CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8892);
    public static property ELEMENT_ARRAY_BUFFER:      CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8893);
    public static property PIXEL_PACK_BUFFER:         CopyBufferSubDataTarget read new CopyBufferSubDataTarget($88EB);
    public static property PIXEL_UNPACK_BUFFER:       CopyBufferSubDataTarget read new CopyBufferSubDataTarget($88EC);
    public static property UNIFORM_BUFFER:            CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8A11);
    public static property TEXTURE_BUFFER:            CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8C2A);
    public static property TRANSFORM_FEEDBACK_BUFFER: CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8C8E);
    public static property COPY_READ_BUFFER:          CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8F36);
    public static property COPY_WRITE_BUFFER:         CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8F37);
    public static property DRAW_INDIRECT_BUFFER:      CopyBufferSubDataTarget read new CopyBufferSubDataTarget($8F3F);
    public static property SHADER_STORAGE_BUFFER:     CopyBufferSubDataTarget read new CopyBufferSubDataTarget($90D2);
    public static property DISPATCH_INDIRECT_BUFFER:  CopyBufferSubDataTarget read new CopyBufferSubDataTarget($90EE);
    public static property QUERY_BUFFER:              CopyBufferSubDataTarget read new CopyBufferSubDataTarget($9192);
    public static property ATOMIC_COUNTER_BUFFER:     CopyBufferSubDataTarget read new CopyBufferSubDataTarget($92C0);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8892) then Result := 'ARRAY_BUFFER' else
      if self.val = UInt32($8893) then Result := 'ELEMENT_ARRAY_BUFFER' else
      if self.val = UInt32($88EB) then Result := 'PIXEL_PACK_BUFFER' else
      if self.val = UInt32($88EC) then Result := 'PIXEL_UNPACK_BUFFER' else
      if self.val = UInt32($8A11) then Result := 'UNIFORM_BUFFER' else
      if self.val = UInt32($8C2A) then Result := 'TEXTURE_BUFFER' else
      if self.val = UInt32($8C8E) then Result := 'TRANSFORM_FEEDBACK_BUFFER' else
      if self.val = UInt32($8F36) then Result := 'COPY_READ_BUFFER' else
      if self.val = UInt32($8F37) then Result := 'COPY_WRITE_BUFFER' else
      if self.val = UInt32($8F3F) then Result := 'DRAW_INDIRECT_BUFFER' else
      if self.val = UInt32($90D2) then Result := 'SHADER_STORAGE_BUFFER' else
      if self.val = UInt32($90EE) then Result := 'DISPATCH_INDIRECT_BUFFER' else
      if self.val = UInt32($9192) then Result := 'QUERY_BUFFER' else
      if self.val = UInt32($92C0) then Result := 'ATOMIC_COUNTER_BUFFER' else
        Result := $'CopyBufferSubDataTarget[{self.val}]';
    end;
    
  end;
  
  CopyImageSubDataTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_1D:                   CopyImageSubDataTarget read new CopyImageSubDataTarget($0DE0);
    public static property TEXTURE_2D:                   CopyImageSubDataTarget read new CopyImageSubDataTarget($0DE1);
    public static property TEXTURE_3D:                   CopyImageSubDataTarget read new CopyImageSubDataTarget($806F);
    public static property TEXTURE_RECTANGLE:            CopyImageSubDataTarget read new CopyImageSubDataTarget($84F5);
    public static property TEXTURE_CUBE_MAP:             CopyImageSubDataTarget read new CopyImageSubDataTarget($8513);
    public static property TEXTURE_1D_ARRAY:             CopyImageSubDataTarget read new CopyImageSubDataTarget($8C18);
    public static property TEXTURE_2D_ARRAY:             CopyImageSubDataTarget read new CopyImageSubDataTarget($8C1A);
    public static property RENDERBUFFER:                 CopyImageSubDataTarget read new CopyImageSubDataTarget($8D41);
    public static property TEXTURE_CUBE_MAP_ARRAY:       CopyImageSubDataTarget read new CopyImageSubDataTarget($9009);
    public static property TEXTURE_2D_MULTISAMPLE:       CopyImageSubDataTarget read new CopyImageSubDataTarget($9100);
    public static property TEXTURE_2D_MULTISAMPLE_ARRAY: CopyImageSubDataTarget read new CopyImageSubDataTarget($9102);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0DE0) then Result := 'TEXTURE_1D' else
      if self.val = UInt32($0DE1) then Result := 'TEXTURE_2D' else
      if self.val = UInt32($806F) then Result := 'TEXTURE_3D' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP' else
      if self.val = UInt32($8C18) then Result := 'TEXTURE_1D_ARRAY' else
      if self.val = UInt32($8C1A) then Result := 'TEXTURE_2D_ARRAY' else
      if self.val = UInt32($8D41) then Result := 'RENDERBUFFER' else
      if self.val = UInt32($9009) then Result := 'TEXTURE_CUBE_MAP_ARRAY' else
      if self.val = UInt32($9100) then Result := 'TEXTURE_2D_MULTISAMPLE' else
      if self.val = UInt32($9102) then Result := 'TEXTURE_2D_MULTISAMPLE_ARRAY' else
        Result := $'CopyImageSubDataTarget[{self.val}]';
    end;
    
  end;
  
  CullFaceMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRONT:          CullFaceMode read new CullFaceMode($0404);
    public static property BACK:           CullFaceMode read new CullFaceMode($0405);
    public static property FRONT_AND_BACK: CullFaceMode read new CullFaceMode($0408);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0404) then Result := 'FRONT' else
      if self.val = UInt32($0405) then Result := 'BACK' else
      if self.val = UInt32($0408) then Result := 'FRONT_AND_BACK' else
        Result := $'CullFaceMode[{self.val}]';
    end;
    
  end;
  
  DebugSeverity = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DONT_CARE:                   DebugSeverity read new DebugSeverity($1100);
    public static property DEBUG_SEVERITY_NOTIFICATION: DebugSeverity read new DebugSeverity($826B);
    public static property DEBUG_SEVERITY_HIGH:         DebugSeverity read new DebugSeverity($9146);
    public static property DEBUG_SEVERITY_MEDIUM:       DebugSeverity read new DebugSeverity($9147);
    public static property DEBUG_SEVERITY_LOW:          DebugSeverity read new DebugSeverity($9148);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1100) then Result := 'DONT_CARE' else
      if self.val = UInt32($826B) then Result := 'DEBUG_SEVERITY_NOTIFICATION' else
      if self.val = UInt32($9146) then Result := 'DEBUG_SEVERITY_HIGH' else
      if self.val = UInt32($9147) then Result := 'DEBUG_SEVERITY_MEDIUM' else
      if self.val = UInt32($9148) then Result := 'DEBUG_SEVERITY_LOW' else
        Result := $'DebugSeverity[{self.val}]';
    end;
    
  end;
  
  DebugSource = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DONT_CARE:                    DebugSource read new DebugSource($1100);
    public static property DEBUG_SOURCE_API:             DebugSource read new DebugSource($8246);
    public static property DEBUG_SOURCE_WINDOW_SYSTEM:   DebugSource read new DebugSource($8247);
    public static property DEBUG_SOURCE_SHADER_COMPILER: DebugSource read new DebugSource($8248);
    public static property DEBUG_SOURCE_THIRD_PARTY:     DebugSource read new DebugSource($8249);
    public static property DEBUG_SOURCE_APPLICATION:     DebugSource read new DebugSource($824A);
    public static property DEBUG_SOURCE_OTHER:           DebugSource read new DebugSource($824B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1100) then Result := 'DONT_CARE' else
      if self.val = UInt32($8246) then Result := 'DEBUG_SOURCE_API' else
      if self.val = UInt32($8247) then Result := 'DEBUG_SOURCE_WINDOW_SYSTEM' else
      if self.val = UInt32($8248) then Result := 'DEBUG_SOURCE_SHADER_COMPILER' else
      if self.val = UInt32($8249) then Result := 'DEBUG_SOURCE_THIRD_PARTY' else
      if self.val = UInt32($824A) then Result := 'DEBUG_SOURCE_APPLICATION' else
      if self.val = UInt32($824B) then Result := 'DEBUG_SOURCE_OTHER' else
        Result := $'DebugSource[{self.val}]';
    end;
    
  end;
  
  DebugType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DONT_CARE:                      DebugType read new DebugType($1100);
    public static property DEBUG_TYPE_ERROR:               DebugType read new DebugType($824C);
    public static property DEBUG_TYPE_DEPRECATED_BEHAVIOR: DebugType read new DebugType($824D);
    public static property DEBUG_TYPE_UNDEFINED_BEHAVIOR:  DebugType read new DebugType($824E);
    public static property DEBUG_TYPE_PORTABILITY:         DebugType read new DebugType($824F);
    public static property DEBUG_TYPE_PERFORMANCE:         DebugType read new DebugType($8250);
    public static property DEBUG_TYPE_OTHER:               DebugType read new DebugType($8251);
    public static property DEBUG_TYPE_MARKER:              DebugType read new DebugType($8268);
    public static property DEBUG_TYPE_PUSH_GROUP:          DebugType read new DebugType($8269);
    public static property DEBUG_TYPE_POP_GROUP:           DebugType read new DebugType($826A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1100) then Result := 'DONT_CARE' else
      if self.val = UInt32($824C) then Result := 'DEBUG_TYPE_ERROR' else
      if self.val = UInt32($824D) then Result := 'DEBUG_TYPE_DEPRECATED_BEHAVIOR' else
      if self.val = UInt32($824E) then Result := 'DEBUG_TYPE_UNDEFINED_BEHAVIOR' else
      if self.val = UInt32($824F) then Result := 'DEBUG_TYPE_PORTABILITY' else
      if self.val = UInt32($8250) then Result := 'DEBUG_TYPE_PERFORMANCE' else
      if self.val = UInt32($8251) then Result := 'DEBUG_TYPE_OTHER' else
      if self.val = UInt32($8268) then Result := 'DEBUG_TYPE_MARKER' else
      if self.val = UInt32($8269) then Result := 'DEBUG_TYPE_PUSH_GROUP' else
      if self.val = UInt32($826A) then Result := 'DEBUG_TYPE_POP_GROUP' else
        Result := $'DebugType[{self.val}]';
    end;
    
  end;
  
  DepthFunction = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NEVER:    DepthFunction read new DepthFunction($0200);
    public static property LESS:     DepthFunction read new DepthFunction($0201);
    public static property EQUAL:    DepthFunction read new DepthFunction($0202);
    public static property LEQUAL:   DepthFunction read new DepthFunction($0203);
    public static property GREATER:  DepthFunction read new DepthFunction($0204);
    public static property NOTEQUAL: DepthFunction read new DepthFunction($0205);
    public static property GEQUAL:   DepthFunction read new DepthFunction($0206);
    public static property ALWAYS:   DepthFunction read new DepthFunction($0207);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0200) then Result := 'NEVER' else
      if self.val = UInt32($0201) then Result := 'LESS' else
      if self.val = UInt32($0202) then Result := 'EQUAL' else
      if self.val = UInt32($0203) then Result := 'LEQUAL' else
      if self.val = UInt32($0204) then Result := 'GREATER' else
      if self.val = UInt32($0205) then Result := 'NOTEQUAL' else
      if self.val = UInt32($0206) then Result := 'GEQUAL' else
      if self.val = UInt32($0207) then Result := 'ALWAYS' else
        Result := $'DepthFunction[{self.val}]';
    end;
    
  end;
  
  DrawBufferMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:               DrawBufferMode read new DrawBufferMode($0000);
    public static property NONE_OES:           DrawBufferMode read new DrawBufferMode($0000);
    public static property FRONT_LEFT:         DrawBufferMode read new DrawBufferMode($0400);
    public static property FRONT_RIGHT:        DrawBufferMode read new DrawBufferMode($0401);
    public static property BACK_LEFT:          DrawBufferMode read new DrawBufferMode($0402);
    public static property BACK_RIGHT:         DrawBufferMode read new DrawBufferMode($0403);
    public static property FRONT:              DrawBufferMode read new DrawBufferMode($0404);
    public static property BACK:               DrawBufferMode read new DrawBufferMode($0405);
    public static property LEFT:               DrawBufferMode read new DrawBufferMode($0406);
    public static property RIGHT:              DrawBufferMode read new DrawBufferMode($0407);
    public static property FRONT_AND_BACK:     DrawBufferMode read new DrawBufferMode($0408);
    public static property AUX0:               DrawBufferMode read new DrawBufferMode($0409);
    public static property AUX1:               DrawBufferMode read new DrawBufferMode($040A);
    public static property AUX2:               DrawBufferMode read new DrawBufferMode($040B);
    public static property AUX3:               DrawBufferMode read new DrawBufferMode($040C);
    public static property COLOR_ATTACHMENT0:  DrawBufferMode read new DrawBufferMode($8CE0);
    public static property COLOR_ATTACHMENT1:  DrawBufferMode read new DrawBufferMode($8CE1);
    public static property COLOR_ATTACHMENT2:  DrawBufferMode read new DrawBufferMode($8CE2);
    public static property COLOR_ATTACHMENT3:  DrawBufferMode read new DrawBufferMode($8CE3);
    public static property COLOR_ATTACHMENT4:  DrawBufferMode read new DrawBufferMode($8CE4);
    public static property COLOR_ATTACHMENT5:  DrawBufferMode read new DrawBufferMode($8CE5);
    public static property COLOR_ATTACHMENT6:  DrawBufferMode read new DrawBufferMode($8CE6);
    public static property COLOR_ATTACHMENT7:  DrawBufferMode read new DrawBufferMode($8CE7);
    public static property COLOR_ATTACHMENT8:  DrawBufferMode read new DrawBufferMode($8CE8);
    public static property COLOR_ATTACHMENT9:  DrawBufferMode read new DrawBufferMode($8CE9);
    public static property COLOR_ATTACHMENT10: DrawBufferMode read new DrawBufferMode($8CEA);
    public static property COLOR_ATTACHMENT11: DrawBufferMode read new DrawBufferMode($8CEB);
    public static property COLOR_ATTACHMENT12: DrawBufferMode read new DrawBufferMode($8CEC);
    public static property COLOR_ATTACHMENT13: DrawBufferMode read new DrawBufferMode($8CED);
    public static property COLOR_ATTACHMENT14: DrawBufferMode read new DrawBufferMode($8CEE);
    public static property COLOR_ATTACHMENT15: DrawBufferMode read new DrawBufferMode($8CEF);
    public static property COLOR_ATTACHMENT16: DrawBufferMode read new DrawBufferMode($8CF0);
    public static property COLOR_ATTACHMENT17: DrawBufferMode read new DrawBufferMode($8CF1);
    public static property COLOR_ATTACHMENT18: DrawBufferMode read new DrawBufferMode($8CF2);
    public static property COLOR_ATTACHMENT19: DrawBufferMode read new DrawBufferMode($8CF3);
    public static property COLOR_ATTACHMENT20: DrawBufferMode read new DrawBufferMode($8CF4);
    public static property COLOR_ATTACHMENT21: DrawBufferMode read new DrawBufferMode($8CF5);
    public static property COLOR_ATTACHMENT22: DrawBufferMode read new DrawBufferMode($8CF6);
    public static property COLOR_ATTACHMENT23: DrawBufferMode read new DrawBufferMode($8CF7);
    public static property COLOR_ATTACHMENT24: DrawBufferMode read new DrawBufferMode($8CF8);
    public static property COLOR_ATTACHMENT25: DrawBufferMode read new DrawBufferMode($8CF9);
    public static property COLOR_ATTACHMENT26: DrawBufferMode read new DrawBufferMode($8CFA);
    public static property COLOR_ATTACHMENT27: DrawBufferMode read new DrawBufferMode($8CFB);
    public static property COLOR_ATTACHMENT28: DrawBufferMode read new DrawBufferMode($8CFC);
    public static property COLOR_ATTACHMENT29: DrawBufferMode read new DrawBufferMode($8CFD);
    public static property COLOR_ATTACHMENT30: DrawBufferMode read new DrawBufferMode($8CFE);
    public static property COLOR_ATTACHMENT31: DrawBufferMode read new DrawBufferMode($8CFF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($0000) then Result := 'NONE_OES' else
      if self.val = UInt32($0400) then Result := 'FRONT_LEFT' else
      if self.val = UInt32($0401) then Result := 'FRONT_RIGHT' else
      if self.val = UInt32($0402) then Result := 'BACK_LEFT' else
      if self.val = UInt32($0403) then Result := 'BACK_RIGHT' else
      if self.val = UInt32($0404) then Result := 'FRONT' else
      if self.val = UInt32($0405) then Result := 'BACK' else
      if self.val = UInt32($0406) then Result := 'LEFT' else
      if self.val = UInt32($0407) then Result := 'RIGHT' else
      if self.val = UInt32($0408) then Result := 'FRONT_AND_BACK' else
      if self.val = UInt32($0409) then Result := 'AUX0' else
      if self.val = UInt32($040A) then Result := 'AUX1' else
      if self.val = UInt32($040B) then Result := 'AUX2' else
      if self.val = UInt32($040C) then Result := 'AUX3' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15' else
      if self.val = UInt32($8CF0) then Result := 'COLOR_ATTACHMENT16' else
      if self.val = UInt32($8CF1) then Result := 'COLOR_ATTACHMENT17' else
      if self.val = UInt32($8CF2) then Result := 'COLOR_ATTACHMENT18' else
      if self.val = UInt32($8CF3) then Result := 'COLOR_ATTACHMENT19' else
      if self.val = UInt32($8CF4) then Result := 'COLOR_ATTACHMENT20' else
      if self.val = UInt32($8CF5) then Result := 'COLOR_ATTACHMENT21' else
      if self.val = UInt32($8CF6) then Result := 'COLOR_ATTACHMENT22' else
      if self.val = UInt32($8CF7) then Result := 'COLOR_ATTACHMENT23' else
      if self.val = UInt32($8CF8) then Result := 'COLOR_ATTACHMENT24' else
      if self.val = UInt32($8CF9) then Result := 'COLOR_ATTACHMENT25' else
      if self.val = UInt32($8CFA) then Result := 'COLOR_ATTACHMENT26' else
      if self.val = UInt32($8CFB) then Result := 'COLOR_ATTACHMENT27' else
      if self.val = UInt32($8CFC) then Result := 'COLOR_ATTACHMENT28' else
      if self.val = UInt32($8CFD) then Result := 'COLOR_ATTACHMENT29' else
      if self.val = UInt32($8CFE) then Result := 'COLOR_ATTACHMENT30' else
      if self.val = UInt32($8CFF) then Result := 'COLOR_ATTACHMENT31' else
        Result := $'DrawBufferMode[{self.val}]';
    end;
    
  end;
  
  DrawElementsType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_BYTE:  DrawElementsType read new DrawElementsType($1401);
    public static property UNSIGNED_SHORT: DrawElementsType read new DrawElementsType($1403);
    public static property UNSIGNED_INT:   DrawElementsType read new DrawElementsType($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'DrawElementsType[{self.val}]';
    end;
    
  end;
  
  EnableCap = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POINT_SMOOTH:                            EnableCap read new EnableCap($0B10);
    public static property LINE_SMOOTH:                             EnableCap read new EnableCap($0B20);
    public static property LINE_STIPPLE:                            EnableCap read new EnableCap($0B24);
    public static property POLYGON_SMOOTH:                          EnableCap read new EnableCap($0B41);
    public static property POLYGON_STIPPLE:                         EnableCap read new EnableCap($0B42);
    public static property CULL_FACE:                               EnableCap read new EnableCap($0B44);
    public static property LIGHTING:                                EnableCap read new EnableCap($0B50);
    public static property COLOR_MATERIAL:                          EnableCap read new EnableCap($0B57);
    public static property FOG:                                     EnableCap read new EnableCap($0B60);
    public static property DEPTH_TEST:                              EnableCap read new EnableCap($0B71);
    public static property STENCIL_TEST:                            EnableCap read new EnableCap($0B90);
    public static property NORMALIZE:                               EnableCap read new EnableCap($0BA1);
    public static property ALPHA_TEST:                              EnableCap read new EnableCap($0BC0);
    public static property DITHER:                                  EnableCap read new EnableCap($0BD0);
    public static property BLEND:                                   EnableCap read new EnableCap($0BE2);
    public static property INDEX_LOGIC_OP:                          EnableCap read new EnableCap($0BF1);
    public static property COLOR_LOGIC_OP:                          EnableCap read new EnableCap($0BF2);
    public static property SCISSOR_TEST:                            EnableCap read new EnableCap($0C11);
    public static property TEXTURE_GEN_S:                           EnableCap read new EnableCap($0C60);
    public static property TEXTURE_GEN_T:                           EnableCap read new EnableCap($0C61);
    public static property TEXTURE_GEN_R:                           EnableCap read new EnableCap($0C62);
    public static property TEXTURE_GEN_Q:                           EnableCap read new EnableCap($0C63);
    public static property AUTO_NORMAL:                             EnableCap read new EnableCap($0D80);
    public static property MAP1_COLOR_4:                            EnableCap read new EnableCap($0D90);
    public static property MAP1_INDEX:                              EnableCap read new EnableCap($0D91);
    public static property MAP1_NORMAL:                             EnableCap read new EnableCap($0D92);
    public static property MAP1_TEXTURE_COORD_1:                    EnableCap read new EnableCap($0D93);
    public static property MAP1_TEXTURE_COORD_2:                    EnableCap read new EnableCap($0D94);
    public static property MAP1_TEXTURE_COORD_3:                    EnableCap read new EnableCap($0D95);
    public static property MAP1_TEXTURE_COORD_4:                    EnableCap read new EnableCap($0D96);
    public static property MAP1_VERTEX_3:                           EnableCap read new EnableCap($0D97);
    public static property MAP1_VERTEX_4:                           EnableCap read new EnableCap($0D98);
    public static property MAP2_COLOR_4:                            EnableCap read new EnableCap($0DB0);
    public static property MAP2_INDEX:                              EnableCap read new EnableCap($0DB1);
    public static property MAP2_NORMAL:                             EnableCap read new EnableCap($0DB2);
    public static property MAP2_TEXTURE_COORD_1:                    EnableCap read new EnableCap($0DB3);
    public static property MAP2_TEXTURE_COORD_2:                    EnableCap read new EnableCap($0DB4);
    public static property MAP2_TEXTURE_COORD_3:                    EnableCap read new EnableCap($0DB5);
    public static property MAP2_TEXTURE_COORD_4:                    EnableCap read new EnableCap($0DB6);
    public static property MAP2_VERTEX_3:                           EnableCap read new EnableCap($0DB7);
    public static property MAP2_VERTEX_4:                           EnableCap read new EnableCap($0DB8);
    public static property TEXTURE_1D:                              EnableCap read new EnableCap($0DE0);
    public static property TEXTURE_2D:                              EnableCap read new EnableCap($0DE1);
    public static property POLYGON_OFFSET_POINT:                    EnableCap read new EnableCap($2A01);
    public static property POLYGON_OFFSET_LINE:                     EnableCap read new EnableCap($2A02);
    public static property CLIP_DISTANCE0:                          EnableCap read new EnableCap($3000);
    public static property CLIP_PLANE0:                             EnableCap read new EnableCap($3000);
    public static property CLIP_DISTANCE1:                          EnableCap read new EnableCap($3001);
    public static property CLIP_PLANE1:                             EnableCap read new EnableCap($3001);
    public static property CLIP_DISTANCE2:                          EnableCap read new EnableCap($3002);
    public static property CLIP_PLANE2:                             EnableCap read new EnableCap($3002);
    public static property CLIP_DISTANCE3:                          EnableCap read new EnableCap($3003);
    public static property CLIP_PLANE3:                             EnableCap read new EnableCap($3003);
    public static property CLIP_DISTANCE4:                          EnableCap read new EnableCap($3004);
    public static property CLIP_PLANE4:                             EnableCap read new EnableCap($3004);
    public static property CLIP_DISTANCE5:                          EnableCap read new EnableCap($3005);
    public static property CLIP_PLANE5:                             EnableCap read new EnableCap($3005);
    public static property CLIP_DISTANCE6:                          EnableCap read new EnableCap($3006);
    public static property CLIP_DISTANCE7:                          EnableCap read new EnableCap($3007);
    public static property LIGHT0:                                  EnableCap read new EnableCap($4000);
    public static property LIGHT1:                                  EnableCap read new EnableCap($4001);
    public static property LIGHT2:                                  EnableCap read new EnableCap($4002);
    public static property LIGHT3:                                  EnableCap read new EnableCap($4003);
    public static property LIGHT4:                                  EnableCap read new EnableCap($4004);
    public static property LIGHT5:                                  EnableCap read new EnableCap($4005);
    public static property LIGHT6:                                  EnableCap read new EnableCap($4006);
    public static property LIGHT7:                                  EnableCap read new EnableCap($4007);
    public static property CONVOLUTION_1D_EXT:                      EnableCap read new EnableCap($8010);
    public static property CONVOLUTION_2D_EXT:                      EnableCap read new EnableCap($8011);
    public static property SEPARABLE_2D_EXT:                        EnableCap read new EnableCap($8012);
    public static property HISTOGRAM_EXT:                           EnableCap read new EnableCap($8024);
    public static property MINMAX_EXT:                              EnableCap read new EnableCap($802E);
    public static property POLYGON_OFFSET_FILL:                     EnableCap read new EnableCap($8037);
    public static property RESCALE_NORMAL_EXT:                      EnableCap read new EnableCap($803A);
    public static property TEXTURE_3D_EXT:                          EnableCap read new EnableCap($806F);
    public static property VERTEX_ARRAY:                            EnableCap read new EnableCap($8074);
    public static property NORMAL_ARRAY:                            EnableCap read new EnableCap($8075);
    public static property COLOR_ARRAY:                             EnableCap read new EnableCap($8076);
    public static property INDEX_ARRAY:                             EnableCap read new EnableCap($8077);
    public static property TEXTURE_COORD_ARRAY:                     EnableCap read new EnableCap($8078);
    public static property EDGE_FLAG_ARRAY:                         EnableCap read new EnableCap($8079);
    public static property INTERLACE_SGIX:                          EnableCap read new EnableCap($8094);
    public static property MULTISAMPLE:                             EnableCap read new EnableCap($809D);
    public static property MULTISAMPLE_SGIS:                        EnableCap read new EnableCap($809D);
    public static property SAMPLE_ALPHA_TO_COVERAGE:                EnableCap read new EnableCap($809E);
    public static property SAMPLE_ALPHA_TO_MASK_SGIS:               EnableCap read new EnableCap($809E);
    public static property SAMPLE_ALPHA_TO_ONE:                     EnableCap read new EnableCap($809F);
    public static property SAMPLE_ALPHA_TO_ONE_SGIS:                EnableCap read new EnableCap($809F);
    public static property SAMPLE_COVERAGE:                         EnableCap read new EnableCap($80A0);
    public static property SAMPLE_MASK_SGIS:                        EnableCap read new EnableCap($80A0);
    public static property TEXTURE_COLOR_TABLE_SGI:                 EnableCap read new EnableCap($80BC);
    public static property COLOR_TABLE:                             EnableCap read new EnableCap($80D0);
    public static property COLOR_TABLE_SGI:                         EnableCap read new EnableCap($80D0);
    public static property POST_CONVOLUTION_COLOR_TABLE:            EnableCap read new EnableCap($80D1);
    public static property POST_CONVOLUTION_COLOR_TABLE_SGI:        EnableCap read new EnableCap($80D1);
    public static property POST_COLOR_MATRIX_COLOR_TABLE:           EnableCap read new EnableCap($80D2);
    public static property POST_COLOR_MATRIX_COLOR_TABLE_SGI:       EnableCap read new EnableCap($80D2);
    public static property TEXTURE_4D_SGIS:                         EnableCap read new EnableCap($8134);
    public static property PIXEL_TEX_GEN_SGIX:                      EnableCap read new EnableCap($8139);
    public static property SPRITE_SGIX:                             EnableCap read new EnableCap($8148);
    public static property REFERENCE_PLANE_SGIX:                    EnableCap read new EnableCap($817D);
    public static property IR_INSTRUMENT1_SGIX:                     EnableCap read new EnableCap($817F);
    public static property CALLIGRAPHIC_FRAGMENT_SGIX:              EnableCap read new EnableCap($8183);
    public static property FRAMEZOOM_SGIX:                          EnableCap read new EnableCap($818B);
    public static property FOG_OFFSET_SGIX:                         EnableCap read new EnableCap($8198);
    public static property SHARED_TEXTURE_PALETTE_EXT:              EnableCap read new EnableCap($81FB);
    public static property DEBUG_OUTPUT_SYNCHRONOUS:                EnableCap read new EnableCap($8242);
    public static property ASYNC_HISTOGRAM_SGIX:                    EnableCap read new EnableCap($832C);
    public static property PIXEL_TEXTURE_SGIS:                      EnableCap read new EnableCap($8353);
    public static property ASYNC_TEX_IMAGE_SGIX:                    EnableCap read new EnableCap($835C);
    public static property ASYNC_DRAW_PIXELS_SGIX:                  EnableCap read new EnableCap($835D);
    public static property ASYNC_READ_PIXELS_SGIX:                  EnableCap read new EnableCap($835E);
    public static property FRAGMENT_LIGHTING_SGIX:                  EnableCap read new EnableCap($8400);
    public static property FRAGMENT_COLOR_MATERIAL_SGIX:            EnableCap read new EnableCap($8401);
    public static property FRAGMENT_LIGHT0_SGIX:                    EnableCap read new EnableCap($840C);
    public static property FRAGMENT_LIGHT1_SGIX:                    EnableCap read new EnableCap($840D);
    public static property FRAGMENT_LIGHT2_SGIX:                    EnableCap read new EnableCap($840E);
    public static property FRAGMENT_LIGHT3_SGIX:                    EnableCap read new EnableCap($840F);
    public static property FRAGMENT_LIGHT4_SGIX:                    EnableCap read new EnableCap($8410);
    public static property FRAGMENT_LIGHT5_SGIX:                    EnableCap read new EnableCap($8411);
    public static property FRAGMENT_LIGHT6_SGIX:                    EnableCap read new EnableCap($8412);
    public static property FRAGMENT_LIGHT7_SGIX:                    EnableCap read new EnableCap($8413);
    public static property TEXTURE_RECTANGLE:                       EnableCap read new EnableCap($84F5);
    public static property TEXTURE_RECTANGLE_ARB:                   EnableCap read new EnableCap($84F5);
    public static property TEXTURE_RECTANGLE_NV:                    EnableCap read new EnableCap($84F5);
    public static property TEXTURE_CUBE_MAP:                        EnableCap read new EnableCap($8513);
    public static property TEXTURE_CUBE_MAP_ARB:                    EnableCap read new EnableCap($8513);
    public static property TEXTURE_CUBE_MAP_EXT:                    EnableCap read new EnableCap($8513);
    public static property TEXTURE_CUBE_MAP_OES:                    EnableCap read new EnableCap($8513);
    public static property PROGRAM_POINT_SIZE:                      EnableCap read new EnableCap($8642);
    public static property DEPTH_CLAMP:                             EnableCap read new EnableCap($864F);
    public static property TEXTURE_CUBE_MAP_SEAMLESS:               EnableCap read new EnableCap($884F);
    public static property SAMPLE_SHADING:                          EnableCap read new EnableCap($8C36);
    public static property RASTERIZER_DISCARD:                      EnableCap read new EnableCap($8C89);
    public static property PRIMITIVE_RESTART_FIXED_INDEX:           EnableCap read new EnableCap($8D69);
    public static property FRAMEBUFFER_SRGB:                        EnableCap read new EnableCap($8DB9);
    public static property SAMPLE_MASK:                             EnableCap read new EnableCap($8E51);
    public static property FETCH_PER_SAMPLE_ARM:                    EnableCap read new EnableCap($8F65);
    public static property PRIMITIVE_RESTART:                       EnableCap read new EnableCap($8F9D);
    public static property DEBUG_OUTPUT:                            EnableCap read new EnableCap($92E0);
    public static property SHADING_RATE_IMAGE_PER_PRIMITIVE_NV:     EnableCap read new EnableCap($95B1);
    public static property SHADING_RATE_PRESERVE_ASPECT_RATIO_QCOM: EnableCap read new EnableCap($96A5);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0B10) then Result := 'POINT_SMOOTH' else
      if self.val = UInt32($0B20) then Result := 'LINE_SMOOTH' else
      if self.val = UInt32($0B24) then Result := 'LINE_STIPPLE' else
      if self.val = UInt32($0B41) then Result := 'POLYGON_SMOOTH' else
      if self.val = UInt32($0B42) then Result := 'POLYGON_STIPPLE' else
      if self.val = UInt32($0B44) then Result := 'CULL_FACE' else
      if self.val = UInt32($0B50) then Result := 'LIGHTING' else
      if self.val = UInt32($0B57) then Result := 'COLOR_MATERIAL' else
      if self.val = UInt32($0B60) then Result := 'FOG' else
      if self.val = UInt32($0B71) then Result := 'DEPTH_TEST' else
      if self.val = UInt32($0B90) then Result := 'STENCIL_TEST' else
      if self.val = UInt32($0BA1) then Result := 'NORMALIZE' else
      if self.val = UInt32($0BC0) then Result := 'ALPHA_TEST' else
      if self.val = UInt32($0BD0) then Result := 'DITHER' else
      if self.val = UInt32($0BE2) then Result := 'BLEND' else
      if self.val = UInt32($0BF1) then Result := 'INDEX_LOGIC_OP' else
      if self.val = UInt32($0BF2) then Result := 'COLOR_LOGIC_OP' else
      if self.val = UInt32($0C11) then Result := 'SCISSOR_TEST' else
      if self.val = UInt32($0C60) then Result := 'TEXTURE_GEN_S' else
      if self.val = UInt32($0C61) then Result := 'TEXTURE_GEN_T' else
      if self.val = UInt32($0C62) then Result := 'TEXTURE_GEN_R' else
      if self.val = UInt32($0C63) then Result := 'TEXTURE_GEN_Q' else
      if self.val = UInt32($0D80) then Result := 'AUTO_NORMAL' else
      if self.val = UInt32($0D90) then Result := 'MAP1_COLOR_4' else
      if self.val = UInt32($0D91) then Result := 'MAP1_INDEX' else
      if self.val = UInt32($0D92) then Result := 'MAP1_NORMAL' else
      if self.val = UInt32($0D93) then Result := 'MAP1_TEXTURE_COORD_1' else
      if self.val = UInt32($0D94) then Result := 'MAP1_TEXTURE_COORD_2' else
      if self.val = UInt32($0D95) then Result := 'MAP1_TEXTURE_COORD_3' else
      if self.val = UInt32($0D96) then Result := 'MAP1_TEXTURE_COORD_4' else
      if self.val = UInt32($0D97) then Result := 'MAP1_VERTEX_3' else
      if self.val = UInt32($0D98) then Result := 'MAP1_VERTEX_4' else
      if self.val = UInt32($0DB0) then Result := 'MAP2_COLOR_4' else
      if self.val = UInt32($0DB1) then Result := 'MAP2_INDEX' else
      if self.val = UInt32($0DB2) then Result := 'MAP2_NORMAL' else
      if self.val = UInt32($0DB3) then Result := 'MAP2_TEXTURE_COORD_1' else
      if self.val = UInt32($0DB4) then Result := 'MAP2_TEXTURE_COORD_2' else
      if self.val = UInt32($0DB5) then Result := 'MAP2_TEXTURE_COORD_3' else
      if self.val = UInt32($0DB6) then Result := 'MAP2_TEXTURE_COORD_4' else
      if self.val = UInt32($0DB7) then Result := 'MAP2_VERTEX_3' else
      if self.val = UInt32($0DB8) then Result := 'MAP2_VERTEX_4' else
      if self.val = UInt32($0DE0) then Result := 'TEXTURE_1D' else
      if self.val = UInt32($0DE1) then Result := 'TEXTURE_2D' else
      if self.val = UInt32($2A01) then Result := 'POLYGON_OFFSET_POINT' else
      if self.val = UInt32($2A02) then Result := 'POLYGON_OFFSET_LINE' else
      if self.val = UInt32($3000) then Result := 'CLIP_DISTANCE0' else
      if self.val = UInt32($3000) then Result := 'CLIP_PLANE0' else
      if self.val = UInt32($3001) then Result := 'CLIP_DISTANCE1' else
      if self.val = UInt32($3001) then Result := 'CLIP_PLANE1' else
      if self.val = UInt32($3002) then Result := 'CLIP_DISTANCE2' else
      if self.val = UInt32($3002) then Result := 'CLIP_PLANE2' else
      if self.val = UInt32($3003) then Result := 'CLIP_DISTANCE3' else
      if self.val = UInt32($3003) then Result := 'CLIP_PLANE3' else
      if self.val = UInt32($3004) then Result := 'CLIP_DISTANCE4' else
      if self.val = UInt32($3004) then Result := 'CLIP_PLANE4' else
      if self.val = UInt32($3005) then Result := 'CLIP_DISTANCE5' else
      if self.val = UInt32($3005) then Result := 'CLIP_PLANE5' else
      if self.val = UInt32($3006) then Result := 'CLIP_DISTANCE6' else
      if self.val = UInt32($3007) then Result := 'CLIP_DISTANCE7' else
      if self.val = UInt32($4000) then Result := 'LIGHT0' else
      if self.val = UInt32($4001) then Result := 'LIGHT1' else
      if self.val = UInt32($4002) then Result := 'LIGHT2' else
      if self.val = UInt32($4003) then Result := 'LIGHT3' else
      if self.val = UInt32($4004) then Result := 'LIGHT4' else
      if self.val = UInt32($4005) then Result := 'LIGHT5' else
      if self.val = UInt32($4006) then Result := 'LIGHT6' else
      if self.val = UInt32($4007) then Result := 'LIGHT7' else
      if self.val = UInt32($8010) then Result := 'CONVOLUTION_1D_EXT' else
      if self.val = UInt32($8011) then Result := 'CONVOLUTION_2D_EXT' else
      if self.val = UInt32($8012) then Result := 'SEPARABLE_2D_EXT' else
      if self.val = UInt32($8024) then Result := 'HISTOGRAM_EXT' else
      if self.val = UInt32($802E) then Result := 'MINMAX_EXT' else
      if self.val = UInt32($8037) then Result := 'POLYGON_OFFSET_FILL' else
      if self.val = UInt32($803A) then Result := 'RESCALE_NORMAL_EXT' else
      if self.val = UInt32($806F) then Result := 'TEXTURE_3D_EXT' else
      if self.val = UInt32($8074) then Result := 'VERTEX_ARRAY' else
      if self.val = UInt32($8075) then Result := 'NORMAL_ARRAY' else
      if self.val = UInt32($8076) then Result := 'COLOR_ARRAY' else
      if self.val = UInt32($8077) then Result := 'INDEX_ARRAY' else
      if self.val = UInt32($8078) then Result := 'TEXTURE_COORD_ARRAY' else
      if self.val = UInt32($8079) then Result := 'EDGE_FLAG_ARRAY' else
      if self.val = UInt32($8094) then Result := 'INTERLACE_SGIX' else
      if self.val = UInt32($809D) then Result := 'MULTISAMPLE' else
      if self.val = UInt32($809D) then Result := 'MULTISAMPLE_SGIS' else
      if self.val = UInt32($809E) then Result := 'SAMPLE_ALPHA_TO_COVERAGE' else
      if self.val = UInt32($809E) then Result := 'SAMPLE_ALPHA_TO_MASK_SGIS' else
      if self.val = UInt32($809F) then Result := 'SAMPLE_ALPHA_TO_ONE' else
      if self.val = UInt32($809F) then Result := 'SAMPLE_ALPHA_TO_ONE_SGIS' else
      if self.val = UInt32($80A0) then Result := 'SAMPLE_COVERAGE' else
      if self.val = UInt32($80A0) then Result := 'SAMPLE_MASK_SGIS' else
      if self.val = UInt32($80BC) then Result := 'TEXTURE_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D0) then Result := 'COLOR_TABLE' else
      if self.val = UInt32($80D0) then Result := 'COLOR_TABLE_SGI' else
      if self.val = UInt32($80D1) then Result := 'POST_CONVOLUTION_COLOR_TABLE' else
      if self.val = UInt32($80D1) then Result := 'POST_CONVOLUTION_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D2) then Result := 'POST_COLOR_MATRIX_COLOR_TABLE' else
      if self.val = UInt32($80D2) then Result := 'POST_COLOR_MATRIX_COLOR_TABLE_SGI' else
      if self.val = UInt32($8134) then Result := 'TEXTURE_4D_SGIS' else
      if self.val = UInt32($8139) then Result := 'PIXEL_TEX_GEN_SGIX' else
      if self.val = UInt32($8148) then Result := 'SPRITE_SGIX' else
      if self.val = UInt32($817D) then Result := 'REFERENCE_PLANE_SGIX' else
      if self.val = UInt32($817F) then Result := 'IR_INSTRUMENT1_SGIX' else
      if self.val = UInt32($8183) then Result := 'CALLIGRAPHIC_FRAGMENT_SGIX' else
      if self.val = UInt32($818B) then Result := 'FRAMEZOOM_SGIX' else
      if self.val = UInt32($8198) then Result := 'FOG_OFFSET_SGIX' else
      if self.val = UInt32($81FB) then Result := 'SHARED_TEXTURE_PALETTE_EXT' else
      if self.val = UInt32($8242) then Result := 'DEBUG_OUTPUT_SYNCHRONOUS' else
      if self.val = UInt32($832C) then Result := 'ASYNC_HISTOGRAM_SGIX' else
      if self.val = UInt32($8353) then Result := 'PIXEL_TEXTURE_SGIS' else
      if self.val = UInt32($835C) then Result := 'ASYNC_TEX_IMAGE_SGIX' else
      if self.val = UInt32($835D) then Result := 'ASYNC_DRAW_PIXELS_SGIX' else
      if self.val = UInt32($835E) then Result := 'ASYNC_READ_PIXELS_SGIX' else
      if self.val = UInt32($8400) then Result := 'FRAGMENT_LIGHTING_SGIX' else
      if self.val = UInt32($8401) then Result := 'FRAGMENT_COLOR_MATERIAL_SGIX' else
      if self.val = UInt32($840C) then Result := 'FRAGMENT_LIGHT0_SGIX' else
      if self.val = UInt32($840D) then Result := 'FRAGMENT_LIGHT1_SGIX' else
      if self.val = UInt32($840E) then Result := 'FRAGMENT_LIGHT2_SGIX' else
      if self.val = UInt32($840F) then Result := 'FRAGMENT_LIGHT3_SGIX' else
      if self.val = UInt32($8410) then Result := 'FRAGMENT_LIGHT4_SGIX' else
      if self.val = UInt32($8411) then Result := 'FRAGMENT_LIGHT5_SGIX' else
      if self.val = UInt32($8412) then Result := 'FRAGMENT_LIGHT6_SGIX' else
      if self.val = UInt32($8413) then Result := 'FRAGMENT_LIGHT7_SGIX' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE_ARB' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE_NV' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP_ARB' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP_EXT' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP_OES' else
      if self.val = UInt32($8642) then Result := 'PROGRAM_POINT_SIZE' else
      if self.val = UInt32($864F) then Result := 'DEPTH_CLAMP' else
      if self.val = UInt32($884F) then Result := 'TEXTURE_CUBE_MAP_SEAMLESS' else
      if self.val = UInt32($8C36) then Result := 'SAMPLE_SHADING' else
      if self.val = UInt32($8C89) then Result := 'RASTERIZER_DISCARD' else
      if self.val = UInt32($8D69) then Result := 'PRIMITIVE_RESTART_FIXED_INDEX' else
      if self.val = UInt32($8DB9) then Result := 'FRAMEBUFFER_SRGB' else
      if self.val = UInt32($8E51) then Result := 'SAMPLE_MASK' else
      if self.val = UInt32($8F65) then Result := 'FETCH_PER_SAMPLE_ARM' else
      if self.val = UInt32($8F9D) then Result := 'PRIMITIVE_RESTART' else
      if self.val = UInt32($92E0) then Result := 'DEBUG_OUTPUT' else
      if self.val = UInt32($95B1) then Result := 'SHADING_RATE_IMAGE_PER_PRIMITIVE_NV' else
      if self.val = UInt32($96A5) then Result := 'SHADING_RATE_PRESERVE_ASPECT_RATIO_QCOM' else
        Result := $'EnableCap[{self.val}]';
    end;
    
  end;
  
  ErrorCode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NO_ERROR:                          ErrorCode read new ErrorCode($0000);
    public static property INVALID_ENUM:                      ErrorCode read new ErrorCode($0500);
    public static property INVALID_VALUE:                     ErrorCode read new ErrorCode($0501);
    public static property INVALID_OPERATION:                 ErrorCode read new ErrorCode($0502);
    public static property STACK_OVERFLOW:                    ErrorCode read new ErrorCode($0503);
    public static property STACK_UNDERFLOW:                   ErrorCode read new ErrorCode($0504);
    public static property OUT_OF_MEMORY:                     ErrorCode read new ErrorCode($0505);
    public static property INVALID_FRAMEBUFFER_OPERATION:     ErrorCode read new ErrorCode($0506);
    public static property INVALID_FRAMEBUFFER_OPERATION_EXT: ErrorCode read new ErrorCode($0506);
    public static property INVALID_FRAMEBUFFER_OPERATION_OES: ErrorCode read new ErrorCode($0506);
    public static property TABLE_TOO_LARGE:                   ErrorCode read new ErrorCode($8031);
    public static property TABLE_TOO_LARGE_EXT:               ErrorCode read new ErrorCode($8031);
    public static property TEXTURE_TOO_LARGE_EXT:             ErrorCode read new ErrorCode($8065);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NO_ERROR' else
      if self.val = UInt32($0500) then Result := 'INVALID_ENUM' else
      if self.val = UInt32($0501) then Result := 'INVALID_VALUE' else
      if self.val = UInt32($0502) then Result := 'INVALID_OPERATION' else
      if self.val = UInt32($0503) then Result := 'STACK_OVERFLOW' else
      if self.val = UInt32($0504) then Result := 'STACK_UNDERFLOW' else
      if self.val = UInt32($0505) then Result := 'OUT_OF_MEMORY' else
      if self.val = UInt32($0506) then Result := 'INVALID_FRAMEBUFFER_OPERATION' else
      if self.val = UInt32($0506) then Result := 'INVALID_FRAMEBUFFER_OPERATION_EXT' else
      if self.val = UInt32($0506) then Result := 'INVALID_FRAMEBUFFER_OPERATION_OES' else
      if self.val = UInt32($8031) then Result := 'TABLE_TOO_LARGE' else
      if self.val = UInt32($8031) then Result := 'TABLE_TOO_LARGE_EXT' else
      if self.val = UInt32($8065) then Result := 'TEXTURE_TOO_LARGE_EXT' else
        Result := $'ErrorCode[{self.val}]';
    end;
    
  end;
  
  ExternalHandleType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property HANDLE_TYPE_OPAQUE_FD_EXT:        ExternalHandleType read new ExternalHandleType($9586);
    public static property HANDLE_TYPE_OPAQUE_WIN32_EXT:     ExternalHandleType read new ExternalHandleType($9587);
    public static property HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT: ExternalHandleType read new ExternalHandleType($9588);
    public static property HANDLE_TYPE_D3D12_TILEPOOL_EXT:   ExternalHandleType read new ExternalHandleType($9589);
    public static property HANDLE_TYPE_D3D12_RESOURCE_EXT:   ExternalHandleType read new ExternalHandleType($958A);
    public static property HANDLE_TYPE_D3D11_IMAGE_EXT:      ExternalHandleType read new ExternalHandleType($958B);
    public static property HANDLE_TYPE_D3D11_IMAGE_KMT_EXT:  ExternalHandleType read new ExternalHandleType($958C);
    public static property HANDLE_TYPE_D3D12_FENCE_EXT:      ExternalHandleType read new ExternalHandleType($9594);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9586) then Result := 'HANDLE_TYPE_OPAQUE_FD_EXT' else
      if self.val = UInt32($9587) then Result := 'HANDLE_TYPE_OPAQUE_WIN32_EXT' else
      if self.val = UInt32($9588) then Result := 'HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT' else
      if self.val = UInt32($9589) then Result := 'HANDLE_TYPE_D3D12_TILEPOOL_EXT' else
      if self.val = UInt32($958A) then Result := 'HANDLE_TYPE_D3D12_RESOURCE_EXT' else
      if self.val = UInt32($958B) then Result := 'HANDLE_TYPE_D3D11_IMAGE_EXT' else
      if self.val = UInt32($958C) then Result := 'HANDLE_TYPE_D3D11_IMAGE_KMT_EXT' else
      if self.val = UInt32($9594) then Result := 'HANDLE_TYPE_D3D12_FENCE_EXT' else
        Result := $'ExternalHandleType[{self.val}]';
    end;
    
  end;
  
  FeedbackType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property GL_2D:               FeedbackType read new FeedbackType($0600);
    public static property GL_3D:               FeedbackType read new FeedbackType($0601);
    public static property GL_3D_COLOR:         FeedbackType read new FeedbackType($0602);
    public static property GL_3D_COLOR_TEXTURE: FeedbackType read new FeedbackType($0603);
    public static property GL_4D_COLOR_TEXTURE: FeedbackType read new FeedbackType($0604);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0600) then Result := 'GL_2D' else
      if self.val = UInt32($0601) then Result := 'GL_3D' else
      if self.val = UInt32($0602) then Result := 'GL_3D_COLOR' else
      if self.val = UInt32($0603) then Result := 'GL_3D_COLOR_TEXTURE' else
      if self.val = UInt32($0604) then Result := 'GL_4D_COLOR_TEXTURE' else
        Result := $'FeedbackType[{self.val}]';
    end;
    
  end;
  
  FogCoordinatePointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FLOAT:  FogCoordinatePointerType read new FogCoordinatePointerType($1406);
    public static property DOUBLE: FogCoordinatePointerType read new FogCoordinatePointerType($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'FogCoordinatePointerType[{self.val}]';
    end;
    
  end;
  
  FogParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FOG_INDEX:             FogParameter read new FogParameter($0B61);
    public static property FOG_DENSITY:           FogParameter read new FogParameter($0B62);
    public static property FOG_START:             FogParameter read new FogParameter($0B63);
    public static property FOG_END:               FogParameter read new FogParameter($0B64);
    public static property FOG_MODE:              FogParameter read new FogParameter($0B65);
    public static property FOG_COLOR:             FogParameter read new FogParameter($0B66);
    public static property FOG_OFFSET_VALUE_SGIX: FogParameter read new FogParameter($8199);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0B61) then Result := 'FOG_INDEX' else
      if self.val = UInt32($0B62) then Result := 'FOG_DENSITY' else
      if self.val = UInt32($0B63) then Result := 'FOG_START' else
      if self.val = UInt32($0B64) then Result := 'FOG_END' else
      if self.val = UInt32($0B65) then Result := 'FOG_MODE' else
      if self.val = UInt32($0B66) then Result := 'FOG_COLOR' else
      if self.val = UInt32($8199) then Result := 'FOG_OFFSET_VALUE_SGIX' else
        Result := $'FogParameter[{self.val}]';
    end;
    
  end;
  
  FogPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FOG_INDEX:     FogPName read new FogPName($0B61);
    public static property FOG_DENSITY:   FogPName read new FogPName($0B62);
    public static property FOG_START:     FogPName read new FogPName($0B63);
    public static property FOG_END:       FogPName read new FogPName($0B64);
    public static property FOG_MODE:      FogPName read new FogPName($0B65);
    public static property FOG_COORD_SRC: FogPName read new FogPName($8450);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0B61) then Result := 'FOG_INDEX' else
      if self.val = UInt32($0B62) then Result := 'FOG_DENSITY' else
      if self.val = UInt32($0B63) then Result := 'FOG_START' else
      if self.val = UInt32($0B64) then Result := 'FOG_END' else
      if self.val = UInt32($0B65) then Result := 'FOG_MODE' else
      if self.val = UInt32($8450) then Result := 'FOG_COORD_SRC' else
        Result := $'FogPName[{self.val}]';
    end;
    
  end;
  
  FramebufferAttachment = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DEPTH_STENCIL_ATTACHMENT: FramebufferAttachment read new FramebufferAttachment($821A);
    public static property COLOR_ATTACHMENT0:        FramebufferAttachment read new FramebufferAttachment($8CE0);
    public static property COLOR_ATTACHMENT1:        FramebufferAttachment read new FramebufferAttachment($8CE1);
    public static property COLOR_ATTACHMENT2:        FramebufferAttachment read new FramebufferAttachment($8CE2);
    public static property COLOR_ATTACHMENT3:        FramebufferAttachment read new FramebufferAttachment($8CE3);
    public static property COLOR_ATTACHMENT4:        FramebufferAttachment read new FramebufferAttachment($8CE4);
    public static property COLOR_ATTACHMENT5:        FramebufferAttachment read new FramebufferAttachment($8CE5);
    public static property COLOR_ATTACHMENT6:        FramebufferAttachment read new FramebufferAttachment($8CE6);
    public static property COLOR_ATTACHMENT7:        FramebufferAttachment read new FramebufferAttachment($8CE7);
    public static property COLOR_ATTACHMENT8:        FramebufferAttachment read new FramebufferAttachment($8CE8);
    public static property COLOR_ATTACHMENT9:        FramebufferAttachment read new FramebufferAttachment($8CE9);
    public static property COLOR_ATTACHMENT10:       FramebufferAttachment read new FramebufferAttachment($8CEA);
    public static property COLOR_ATTACHMENT11:       FramebufferAttachment read new FramebufferAttachment($8CEB);
    public static property COLOR_ATTACHMENT12:       FramebufferAttachment read new FramebufferAttachment($8CEC);
    public static property COLOR_ATTACHMENT13:       FramebufferAttachment read new FramebufferAttachment($8CED);
    public static property COLOR_ATTACHMENT14:       FramebufferAttachment read new FramebufferAttachment($8CEE);
    public static property COLOR_ATTACHMENT15:       FramebufferAttachment read new FramebufferAttachment($8CEF);
    public static property COLOR_ATTACHMENT16:       FramebufferAttachment read new FramebufferAttachment($8CF0);
    public static property COLOR_ATTACHMENT17:       FramebufferAttachment read new FramebufferAttachment($8CF1);
    public static property COLOR_ATTACHMENT18:       FramebufferAttachment read new FramebufferAttachment($8CF2);
    public static property COLOR_ATTACHMENT19:       FramebufferAttachment read new FramebufferAttachment($8CF3);
    public static property COLOR_ATTACHMENT20:       FramebufferAttachment read new FramebufferAttachment($8CF4);
    public static property COLOR_ATTACHMENT21:       FramebufferAttachment read new FramebufferAttachment($8CF5);
    public static property COLOR_ATTACHMENT22:       FramebufferAttachment read new FramebufferAttachment($8CF6);
    public static property COLOR_ATTACHMENT23:       FramebufferAttachment read new FramebufferAttachment($8CF7);
    public static property COLOR_ATTACHMENT24:       FramebufferAttachment read new FramebufferAttachment($8CF8);
    public static property COLOR_ATTACHMENT25:       FramebufferAttachment read new FramebufferAttachment($8CF9);
    public static property COLOR_ATTACHMENT26:       FramebufferAttachment read new FramebufferAttachment($8CFA);
    public static property COLOR_ATTACHMENT27:       FramebufferAttachment read new FramebufferAttachment($8CFB);
    public static property COLOR_ATTACHMENT28:       FramebufferAttachment read new FramebufferAttachment($8CFC);
    public static property COLOR_ATTACHMENT29:       FramebufferAttachment read new FramebufferAttachment($8CFD);
    public static property COLOR_ATTACHMENT30:       FramebufferAttachment read new FramebufferAttachment($8CFE);
    public static property COLOR_ATTACHMENT31:       FramebufferAttachment read new FramebufferAttachment($8CFF);
    public static property DEPTH_ATTACHMENT:         FramebufferAttachment read new FramebufferAttachment($8D00);
    public static property STENCIL_ATTACHMENT:       FramebufferAttachment read new FramebufferAttachment($8D20);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($821A) then Result := 'DEPTH_STENCIL_ATTACHMENT' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15' else
      if self.val = UInt32($8CF0) then Result := 'COLOR_ATTACHMENT16' else
      if self.val = UInt32($8CF1) then Result := 'COLOR_ATTACHMENT17' else
      if self.val = UInt32($8CF2) then Result := 'COLOR_ATTACHMENT18' else
      if self.val = UInt32($8CF3) then Result := 'COLOR_ATTACHMENT19' else
      if self.val = UInt32($8CF4) then Result := 'COLOR_ATTACHMENT20' else
      if self.val = UInt32($8CF5) then Result := 'COLOR_ATTACHMENT21' else
      if self.val = UInt32($8CF6) then Result := 'COLOR_ATTACHMENT22' else
      if self.val = UInt32($8CF7) then Result := 'COLOR_ATTACHMENT23' else
      if self.val = UInt32($8CF8) then Result := 'COLOR_ATTACHMENT24' else
      if self.val = UInt32($8CF9) then Result := 'COLOR_ATTACHMENT25' else
      if self.val = UInt32($8CFA) then Result := 'COLOR_ATTACHMENT26' else
      if self.val = UInt32($8CFB) then Result := 'COLOR_ATTACHMENT27' else
      if self.val = UInt32($8CFC) then Result := 'COLOR_ATTACHMENT28' else
      if self.val = UInt32($8CFD) then Result := 'COLOR_ATTACHMENT29' else
      if self.val = UInt32($8CFE) then Result := 'COLOR_ATTACHMENT30' else
      if self.val = UInt32($8CFF) then Result := 'COLOR_ATTACHMENT31' else
      if self.val = UInt32($8D00) then Result := 'DEPTH_ATTACHMENT' else
      if self.val = UInt32($8D20) then Result := 'STENCIL_ATTACHMENT' else
        Result := $'FramebufferAttachment[{self.val}]';
    end;
    
  end;
  
  FramebufferAttachmentParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:              FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8210);
    public static property FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT:          FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8210);
    public static property FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:              FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8211);
    public static property FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT:          FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8211);
    public static property FRAMEBUFFER_ATTACHMENT_RED_SIZE:                    FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8212);
    public static property FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:                  FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8213);
    public static property FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:                   FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8214);
    public static property FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:                  FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8215);
    public static property FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:                  FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8216);
    public static property FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:                FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8217);
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:                 FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD0);
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT:             FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD0);
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES:             FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD0);
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:                 FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD1);
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT:             FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD1);
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES:             FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD1);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:               FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD2);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT:           FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD2);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES:           FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD2);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:       FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD3);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT:   FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD3);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES:   FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD3);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT:      FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD4);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES:      FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD4);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:               FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD4);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT:           FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8CD4);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT:         FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8D6C);
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED:                     FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8DA7);
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED_ARB:                 FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8DA7);
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED_EXT:                 FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8DA7);
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED_OES:                 FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($8DA7);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG:           FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($913F);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR:       FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($9630);
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR: FramebufferAttachmentParameterName read new FramebufferAttachmentParameterName($9632);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8210) then Result := 'FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING' else
      if self.val = UInt32($8210) then Result := 'FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT' else
      if self.val = UInt32($8211) then Result := 'FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE' else
      if self.val = UInt32($8211) then Result := 'FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT' else
      if self.val = UInt32($8212) then Result := 'FRAMEBUFFER_ATTACHMENT_RED_SIZE' else
      if self.val = UInt32($8213) then Result := 'FRAMEBUFFER_ATTACHMENT_GREEN_SIZE' else
      if self.val = UInt32($8214) then Result := 'FRAMEBUFFER_ATTACHMENT_BLUE_SIZE' else
      if self.val = UInt32($8215) then Result := 'FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE' else
      if self.val = UInt32($8216) then Result := 'FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE' else
      if self.val = UInt32($8217) then Result := 'FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE' else
      if self.val = UInt32($8CD0) then Result := 'FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE' else
      if self.val = UInt32($8CD0) then Result := 'FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT' else
      if self.val = UInt32($8CD0) then Result := 'FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES' else
      if self.val = UInt32($8CD1) then Result := 'FRAMEBUFFER_ATTACHMENT_OBJECT_NAME' else
      if self.val = UInt32($8CD1) then Result := 'FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT' else
      if self.val = UInt32($8CD1) then Result := 'FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES' else
      if self.val = UInt32($8CD2) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL' else
      if self.val = UInt32($8CD2) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT' else
      if self.val = UInt32($8CD2) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES' else
      if self.val = UInt32($8CD3) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE' else
      if self.val = UInt32($8CD3) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT' else
      if self.val = UInt32($8CD3) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES' else
      if self.val = UInt32($8CD4) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT' else
      if self.val = UInt32($8CD4) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES' else
      if self.val = UInt32($8CD4) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER' else
      if self.val = UInt32($8CD4) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT' else
      if self.val = UInt32($8D6C) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT' else
      if self.val = UInt32($8DA7) then Result := 'FRAMEBUFFER_ATTACHMENT_LAYERED' else
      if self.val = UInt32($8DA7) then Result := 'FRAMEBUFFER_ATTACHMENT_LAYERED_ARB' else
      if self.val = UInt32($8DA7) then Result := 'FRAMEBUFFER_ATTACHMENT_LAYERED_EXT' else
      if self.val = UInt32($8DA7) then Result := 'FRAMEBUFFER_ATTACHMENT_LAYERED_OES' else
      if self.val = UInt32($913F) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG' else
      if self.val = UInt32($9630) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR' else
      if self.val = UInt32($9632) then Result := 'FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR' else
        Result := $'FramebufferAttachmentParameterName[{self.val}]';
    end;
    
  end;
  
  FramebufferParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAMEBUFFER_DEFAULT_WIDTH:                  FramebufferParameterName read new FramebufferParameterName($9310);
    public static property FRAMEBUFFER_DEFAULT_HEIGHT:                 FramebufferParameterName read new FramebufferParameterName($9311);
    public static property FRAMEBUFFER_DEFAULT_LAYERS:                 FramebufferParameterName read new FramebufferParameterName($9312);
    public static property FRAMEBUFFER_DEFAULT_SAMPLES:                FramebufferParameterName read new FramebufferParameterName($9313);
    public static property FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS: FramebufferParameterName read new FramebufferParameterName($9314);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9310) then Result := 'FRAMEBUFFER_DEFAULT_WIDTH' else
      if self.val = UInt32($9311) then Result := 'FRAMEBUFFER_DEFAULT_HEIGHT' else
      if self.val = UInt32($9312) then Result := 'FRAMEBUFFER_DEFAULT_LAYERS' else
      if self.val = UInt32($9313) then Result := 'FRAMEBUFFER_DEFAULT_SAMPLES' else
      if self.val = UInt32($9314) then Result := 'FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS' else
        Result := $'FramebufferParameterName[{self.val}]';
    end;
    
  end;
  
  FramebufferStatus = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAMEBUFFER_UNDEFINED:                     FramebufferStatus read new FramebufferStatus($8219);
    public static property FRAMEBUFFER_COMPLETE:                      FramebufferStatus read new FramebufferStatus($8CD5);
    public static property FRAMEBUFFER_INCOMPLETE_ATTACHMENT:         FramebufferStatus read new FramebufferStatus($8CD6);
    public static property FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: FramebufferStatus read new FramebufferStatus($8CD7);
    public static property FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER:        FramebufferStatus read new FramebufferStatus($8CDB);
    public static property FRAMEBUFFER_INCOMPLETE_READ_BUFFER:        FramebufferStatus read new FramebufferStatus($8CDC);
    public static property FRAMEBUFFER_UNSUPPORTED:                   FramebufferStatus read new FramebufferStatus($8CDD);
    public static property FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:        FramebufferStatus read new FramebufferStatus($8D56);
    public static property FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS:      FramebufferStatus read new FramebufferStatus($8DA8);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8219) then Result := 'FRAMEBUFFER_UNDEFINED' else
      if self.val = UInt32($8CD5) then Result := 'FRAMEBUFFER_COMPLETE' else
      if self.val = UInt32($8CD6) then Result := 'FRAMEBUFFER_INCOMPLETE_ATTACHMENT' else
      if self.val = UInt32($8CD7) then Result := 'FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT' else
      if self.val = UInt32($8CDB) then Result := 'FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER' else
      if self.val = UInt32($8CDC) then Result := 'FRAMEBUFFER_INCOMPLETE_READ_BUFFER' else
      if self.val = UInt32($8CDD) then Result := 'FRAMEBUFFER_UNSUPPORTED' else
      if self.val = UInt32($8D56) then Result := 'FRAMEBUFFER_INCOMPLETE_MULTISAMPLE' else
      if self.val = UInt32($8DA8) then Result := 'FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS' else
        Result := $'FramebufferStatus[{self.val}]';
    end;
    
  end;
  
  FramebufferTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property READ_FRAMEBUFFER: FramebufferTarget read new FramebufferTarget($8CA8);
    public static property DRAW_FRAMEBUFFER: FramebufferTarget read new FramebufferTarget($8CA9);
    public static property FRAMEBUFFER:      FramebufferTarget read new FramebufferTarget($8D40);
    public static property FRAMEBUFFER_OES:  FramebufferTarget read new FramebufferTarget($8D40);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8CA8) then Result := 'READ_FRAMEBUFFER' else
      if self.val = UInt32($8CA9) then Result := 'DRAW_FRAMEBUFFER' else
      if self.val = UInt32($8D40) then Result := 'FRAMEBUFFER' else
      if self.val = UInt32($8D40) then Result := 'FRAMEBUFFER_OES' else
        Result := $'FramebufferTarget[{self.val}]';
    end;
    
  end;
  
  FrontFaceDirection = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CW:  FrontFaceDirection read new FrontFaceDirection($0900);
    public static property CCW: FrontFaceDirection read new FrontFaceDirection($0901);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0900) then Result := 'CW' else
      if self.val = UInt32($0901) then Result := 'CCW' else
        Result := $'FrontFaceDirection[{self.val}]';
    end;
    
  end;
  
  GDI_LayerPlaneFlags = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DOUBLEBUFFER:   GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0001);
    public static property STEREO:         GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0002);
    public static property SUPPORT_GDI:    GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0010);
    public static property SUPPORT_OPENGL: GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0020);
    public static property SHARE_DEPTH:    GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0040);
    public static property SHARE_STENCIL:  GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0080);
    public static property SHARE_ACCUM:    GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0100);
    public static property SWAP_EXCHANGE:  GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0200);
    public static property SWAP_COPY:      GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($0400);
    public static property TRANSPARENT:    GDI_LayerPlaneFlags read new GDI_LayerPlaneFlags($1000);
    
    public static function operator+(f1,f2: GDI_LayerPlaneFlags) := new GDI_LayerPlaneFlags(f1.val or f2.val);
    public static function operator or(f1,f2: GDI_LayerPlaneFlags) := f1+f2;
    
    public property HAS_FLAG_DOUBLEBUFFER:   boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_STEREO:         boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_SUPPORT_GDI:    boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_SUPPORT_OPENGL: boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_SHARE_DEPTH:    boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_SHARE_STENCIL:  boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_SHARE_ACCUM:    boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_SWAP_EXCHANGE:  boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_SWAP_COPY:      boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_TRANSPARENT:    boolean read self.val and $1000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'DOUBLEBUFFER+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'STEREO+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'SUPPORT_GDI+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'SUPPORT_OPENGL+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'SHARE_DEPTH+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'SHARE_STENCIL+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'SHARE_ACCUM+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'SWAP_EXCHANGE+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'SWAP_COPY+';
      if self.val and UInt32($1000) = UInt32($1000) then res += 'TRANSPARENT+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'GDI_LayerPlaneFlags[{self.val}]';
    end;
    
  end;
  
  GDI_PixelDataType = record
    public val: Byte;
    public constructor(val: Byte) := self.val := val;
    
    public static property RGBA:       GDI_PixelDataType read new GDI_PixelDataType($0000);
    public static property COLORINDEX: GDI_PixelDataType read new GDI_PixelDataType($0001);
    
    public function ToString: string; override;
    begin
      if self.val = Byte($0000) then Result := 'RGBA' else
      if self.val = Byte($0001) then Result := 'COLORINDEX' else
        Result := $'GDI_PixelDataType[{self.val}]';
    end;
    
  end;
  
  GDI_PixelFormatFlags = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DOUBLEBUFFER:          GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0001);
    public static property STEREO:                GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0002);
    public static property DRAW_TO_WINDOW:        GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0004);
    public static property DRAW_TO_BITMAP:        GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0008);
    public static property SUPPORT_GDI:           GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0010);
    public static property SUPPORT_OPENGL:        GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0020);
    public static property GENERIC_FORMAT:        GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0040);
    public static property NEED_PALETTE:          GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0080);
    public static property NEED_SYSTEM_PALETTE:   GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0100);
    public static property SWAP_EXCHANGE:         GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0200);
    public static property SWAP_COPY:             GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0400);
    public static property SWAP_LAYER_BUFFERS:    GDI_PixelFormatFlags read new GDI_PixelFormatFlags($0800);
    public static property GENERIC_ACCELERATED:   GDI_PixelFormatFlags read new GDI_PixelFormatFlags($1000);
    public static property SUPPORT_DIRECTDRAW:    GDI_PixelFormatFlags read new GDI_PixelFormatFlags($2000);
    public static property DEPTH_DONTCARE:        GDI_PixelFormatFlags read new GDI_PixelFormatFlags($20000000);
    public static property DOUBLEBUFFER_DONTCARE: GDI_PixelFormatFlags read new GDI_PixelFormatFlags($40000000);
    public static property STEREO_DONTCARE:       GDI_PixelFormatFlags read new GDI_PixelFormatFlags($80000000);
    
    public static function operator+(f1,f2: GDI_PixelFormatFlags) := new GDI_PixelFormatFlags(f1.val or f2.val);
    public static function operator or(f1,f2: GDI_PixelFormatFlags) := f1+f2;
    
    public property HAS_FLAG_DOUBLEBUFFER:          boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_STEREO:                boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_DRAW_TO_WINDOW:        boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_DRAW_TO_BITMAP:        boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_SUPPORT_GDI:           boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_SUPPORT_OPENGL:        boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_GENERIC_FORMAT:        boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_NEED_PALETTE:          boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_NEED_SYSTEM_PALETTE:   boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_SWAP_EXCHANGE:         boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_SWAP_COPY:             boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_SWAP_LAYER_BUFFERS:    boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_GENERIC_ACCELERATED:   boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_SUPPORT_DIRECTDRAW:    boolean read self.val and $2000 <> 0;
    public property HAS_FLAG_DEPTH_DONTCARE:        boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_DOUBLEBUFFER_DONTCARE: boolean read self.val and $40000000 <> 0;
    public property HAS_FLAG_STEREO_DONTCARE:       boolean read self.val and $80000000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'DOUBLEBUFFER+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'STEREO+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'DRAW_TO_WINDOW+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'DRAW_TO_BITMAP+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'SUPPORT_GDI+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'SUPPORT_OPENGL+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'GENERIC_FORMAT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'NEED_PALETTE+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'NEED_SYSTEM_PALETTE+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'SWAP_EXCHANGE+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'SWAP_COPY+';
      if self.val and UInt32($0800) = UInt32($0800) then res += 'SWAP_LAYER_BUFFERS+';
      if self.val and UInt32($1000) = UInt32($1000) then res += 'GENERIC_ACCELERATED+';
      if self.val and UInt32($2000) = UInt32($2000) then res += 'SUPPORT_DIRECTDRAW+';
      if self.val and UInt32($20000000) = UInt32($20000000) then res += 'DEPTH_DONTCARE+';
      if self.val and UInt32($40000000) = UInt32($40000000) then res += 'DOUBLEBUFFER_DONTCARE+';
      if self.val and UInt32($80000000) = UInt32($80000000) then res += 'STEREO_DONTCARE+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'GDI_PixelFormatFlags[{self.val}]';
    end;
    
  end;
  
  GetFramebufferParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DOUBLEBUFFER:                               GetFramebufferParameter read new GetFramebufferParameter($0C32);
    public static property STEREO:                                     GetFramebufferParameter read new GetFramebufferParameter($0C33);
    public static property SAMPLE_BUFFERS:                             GetFramebufferParameter read new GetFramebufferParameter($80A8);
    public static property SAMPLES:                                    GetFramebufferParameter read new GetFramebufferParameter($80A9);
    public static property IMPLEMENTATION_COLOR_READ_TYPE:             GetFramebufferParameter read new GetFramebufferParameter($8B9A);
    public static property IMPLEMENTATION_COLOR_READ_FORMAT:           GetFramebufferParameter read new GetFramebufferParameter($8B9B);
    public static property FRAMEBUFFER_DEFAULT_WIDTH:                  GetFramebufferParameter read new GetFramebufferParameter($9310);
    public static property FRAMEBUFFER_DEFAULT_HEIGHT:                 GetFramebufferParameter read new GetFramebufferParameter($9311);
    public static property FRAMEBUFFER_DEFAULT_LAYERS:                 GetFramebufferParameter read new GetFramebufferParameter($9312);
    public static property FRAMEBUFFER_DEFAULT_SAMPLES:                GetFramebufferParameter read new GetFramebufferParameter($9313);
    public static property FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS: GetFramebufferParameter read new GetFramebufferParameter($9314);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0C32) then Result := 'DOUBLEBUFFER' else
      if self.val = UInt32($0C33) then Result := 'STEREO' else
      if self.val = UInt32($80A8) then Result := 'SAMPLE_BUFFERS' else
      if self.val = UInt32($80A9) then Result := 'SAMPLES' else
      if self.val = UInt32($8B9A) then Result := 'IMPLEMENTATION_COLOR_READ_TYPE' else
      if self.val = UInt32($8B9B) then Result := 'IMPLEMENTATION_COLOR_READ_FORMAT' else
      if self.val = UInt32($9310) then Result := 'FRAMEBUFFER_DEFAULT_WIDTH' else
      if self.val = UInt32($9311) then Result := 'FRAMEBUFFER_DEFAULT_HEIGHT' else
      if self.val = UInt32($9312) then Result := 'FRAMEBUFFER_DEFAULT_LAYERS' else
      if self.val = UInt32($9313) then Result := 'FRAMEBUFFER_DEFAULT_SAMPLES' else
      if self.val = UInt32($9314) then Result := 'FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS' else
        Result := $'GetFramebufferParameter[{self.val}]';
    end;
    
  end;
  
  GetMapQuery = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COEFF:  GetMapQuery read new GetMapQuery($0A00);
    public static property ORDER:  GetMapQuery read new GetMapQuery($0A01);
    public static property DOMAIN: GetMapQuery read new GetMapQuery($0A02);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0A00) then Result := 'COEFF' else
      if self.val = UInt32($0A01) then Result := 'ORDER' else
      if self.val = UInt32($0A02) then Result := 'DOMAIN' else
        Result := $'GetMapQuery[{self.val}]';
    end;
    
  end;
  
  GetPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CURRENT_COLOR:                                  GetPName read new GetPName($0B00);
    public static property CURRENT_INDEX:                                  GetPName read new GetPName($0B01);
    public static property CURRENT_NORMAL:                                 GetPName read new GetPName($0B02);
    public static property CURRENT_TEXTURE_COORDS:                         GetPName read new GetPName($0B03);
    public static property CURRENT_RASTER_COLOR:                           GetPName read new GetPName($0B04);
    public static property CURRENT_RASTER_INDEX:                           GetPName read new GetPName($0B05);
    public static property CURRENT_RASTER_TEXTURE_COORDS:                  GetPName read new GetPName($0B06);
    public static property CURRENT_RASTER_POSITION:                        GetPName read new GetPName($0B07);
    public static property CURRENT_RASTER_POSITION_VALID:                  GetPName read new GetPName($0B08);
    public static property CURRENT_RASTER_DISTANCE:                        GetPName read new GetPName($0B09);
    public static property POINT_SMOOTH:                                   GetPName read new GetPName($0B10);
    public static property POINT_SIZE:                                     GetPName read new GetPName($0B11);
    public static property POINT_SIZE_RANGE:                               GetPName read new GetPName($0B12);
    public static property SMOOTH_POINT_SIZE_RANGE:                        GetPName read new GetPName($0B12);
    public static property POINT_SIZE_GRANULARITY:                         GetPName read new GetPName($0B13);
    public static property SMOOTH_POINT_SIZE_GRANULARITY:                  GetPName read new GetPName($0B13);
    public static property LINE_SMOOTH:                                    GetPName read new GetPName($0B20);
    public static property LINE_WIDTH:                                     GetPName read new GetPName($0B21);
    public static property LINE_WIDTH_RANGE:                               GetPName read new GetPName($0B22);
    public static property SMOOTH_LINE_WIDTH_RANGE:                        GetPName read new GetPName($0B22);
    public static property LINE_WIDTH_GRANULARITY:                         GetPName read new GetPName($0B23);
    public static property SMOOTH_LINE_WIDTH_GRANULARITY:                  GetPName read new GetPName($0B23);
    public static property LINE_STIPPLE:                                   GetPName read new GetPName($0B24);
    public static property LINE_STIPPLE_PATTERN:                           GetPName read new GetPName($0B25);
    public static property LINE_STIPPLE_REPEAT:                            GetPName read new GetPName($0B26);
    public static property LIST_MODE:                                      GetPName read new GetPName($0B30);
    public static property MAX_LIST_NESTING:                               GetPName read new GetPName($0B31);
    public static property LIST_BASE:                                      GetPName read new GetPName($0B32);
    public static property LIST_INDEX:                                     GetPName read new GetPName($0B33);
    public static property POLYGON_MODE:                                   GetPName read new GetPName($0B40);
    public static property POLYGON_SMOOTH:                                 GetPName read new GetPName($0B41);
    public static property POLYGON_STIPPLE:                                GetPName read new GetPName($0B42);
    public static property EDGE_FLAG:                                      GetPName read new GetPName($0B43);
    public static property CULL_FACE:                                      GetPName read new GetPName($0B44);
    public static property CULL_FACE_MODE:                                 GetPName read new GetPName($0B45);
    public static property FRONT_FACE:                                     GetPName read new GetPName($0B46);
    public static property LIGHTING:                                       GetPName read new GetPName($0B50);
    public static property LIGHT_MODEL_LOCAL_VIEWER:                       GetPName read new GetPName($0B51);
    public static property LIGHT_MODEL_TWO_SIDE:                           GetPName read new GetPName($0B52);
    public static property LIGHT_MODEL_AMBIENT:                            GetPName read new GetPName($0B53);
    public static property SHADE_MODEL:                                    GetPName read new GetPName($0B54);
    public static property COLOR_MATERIAL_FACE:                            GetPName read new GetPName($0B55);
    public static property COLOR_MATERIAL_PARAMETER:                       GetPName read new GetPName($0B56);
    public static property COLOR_MATERIAL:                                 GetPName read new GetPName($0B57);
    public static property FOG:                                            GetPName read new GetPName($0B60);
    public static property FOG_INDEX:                                      GetPName read new GetPName($0B61);
    public static property FOG_DENSITY:                                    GetPName read new GetPName($0B62);
    public static property FOG_START:                                      GetPName read new GetPName($0B63);
    public static property FOG_END:                                        GetPName read new GetPName($0B64);
    public static property FOG_MODE:                                       GetPName read new GetPName($0B65);
    public static property FOG_COLOR:                                      GetPName read new GetPName($0B66);
    public static property DEPTH_RANGE:                                    GetPName read new GetPName($0B70);
    public static property DEPTH_TEST:                                     GetPName read new GetPName($0B71);
    public static property DEPTH_WRITEMASK:                                GetPName read new GetPName($0B72);
    public static property DEPTH_CLEAR_VALUE:                              GetPName read new GetPName($0B73);
    public static property DEPTH_FUNC:                                     GetPName read new GetPName($0B74);
    public static property ACCUM_CLEAR_VALUE:                              GetPName read new GetPName($0B80);
    public static property STENCIL_TEST:                                   GetPName read new GetPName($0B90);
    public static property STENCIL_CLEAR_VALUE:                            GetPName read new GetPName($0B91);
    public static property STENCIL_FUNC:                                   GetPName read new GetPName($0B92);
    public static property STENCIL_VALUE_MASK:                             GetPName read new GetPName($0B93);
    public static property STENCIL_FAIL:                                   GetPName read new GetPName($0B94);
    public static property STENCIL_PASS_DEPTH_FAIL:                        GetPName read new GetPName($0B95);
    public static property STENCIL_PASS_DEPTH_PASS:                        GetPName read new GetPName($0B96);
    public static property STENCIL_REF:                                    GetPName read new GetPName($0B97);
    public static property STENCIL_WRITEMASK:                              GetPName read new GetPName($0B98);
    public static property MATRIX_MODE:                                    GetPName read new GetPName($0BA0);
    public static property NORMALIZE:                                      GetPName read new GetPName($0BA1);
    public static property VIEWPORT:                                       GetPName read new GetPName($0BA2);
    public static property MODELVIEW_STACK_DEPTH:                          GetPName read new GetPName($0BA3);
    public static property MODELVIEW0_STACK_DEPTH_EXT:                     GetPName read new GetPName($0BA3);
    public static property PROJECTION_STACK_DEPTH:                         GetPName read new GetPName($0BA4);
    public static property TEXTURE_STACK_DEPTH:                            GetPName read new GetPName($0BA5);
    public static property MODELVIEW_MATRIX:                               GetPName read new GetPName($0BA6);
    public static property MODELVIEW0_MATRIX_EXT:                          GetPName read new GetPName($0BA6);
    public static property PROJECTION_MATRIX:                              GetPName read new GetPName($0BA7);
    public static property TEXTURE_MATRIX:                                 GetPName read new GetPName($0BA8);
    public static property ATTRIB_STACK_DEPTH:                             GetPName read new GetPName($0BB0);
    public static property CLIENT_ATTRIB_STACK_DEPTH:                      GetPName read new GetPName($0BB1);
    public static property ALPHA_TEST:                                     GetPName read new GetPName($0BC0);
    public static property ALPHA_TEST_QCOM:                                GetPName read new GetPName($0BC0);
    public static property ALPHA_TEST_FUNC:                                GetPName read new GetPName($0BC1);
    public static property ALPHA_TEST_FUNC_QCOM:                           GetPName read new GetPName($0BC1);
    public static property ALPHA_TEST_REF:                                 GetPName read new GetPName($0BC2);
    public static property ALPHA_TEST_REF_QCOM:                            GetPName read new GetPName($0BC2);
    public static property DITHER:                                         GetPName read new GetPName($0BD0);
    public static property BLEND_DST:                                      GetPName read new GetPName($0BE0);
    public static property BLEND_SRC:                                      GetPName read new GetPName($0BE1);
    public static property BLEND:                                          GetPName read new GetPName($0BE2);
    public static property LOGIC_OP_MODE:                                  GetPName read new GetPName($0BF0);
    public static property INDEX_LOGIC_OP:                                 GetPName read new GetPName($0BF1);
    public static property LOGIC_OP:                                       GetPName read new GetPName($0BF1);
    public static property COLOR_LOGIC_OP:                                 GetPName read new GetPName($0BF2);
    public static property AUX_BUFFERS:                                    GetPName read new GetPName($0C00);
    public static property DRAW_BUFFER:                                    GetPName read new GetPName($0C01);
    public static property DRAW_BUFFER_EXT:                                GetPName read new GetPName($0C01);
    public static property READ_BUFFER:                                    GetPName read new GetPName($0C02);
    public static property READ_BUFFER_EXT:                                GetPName read new GetPName($0C02);
    public static property READ_BUFFER_NV:                                 GetPName read new GetPName($0C02);
    public static property SCISSOR_BOX:                                    GetPName read new GetPName($0C10);
    public static property SCISSOR_TEST:                                   GetPName read new GetPName($0C11);
    public static property INDEX_CLEAR_VALUE:                              GetPName read new GetPName($0C20);
    public static property INDEX_WRITEMASK:                                GetPName read new GetPName($0C21);
    public static property COLOR_CLEAR_VALUE:                              GetPName read new GetPName($0C22);
    public static property COLOR_WRITEMASK:                                GetPName read new GetPName($0C23);
    public static property INDEX_MODE:                                     GetPName read new GetPName($0C30);
    public static property RGBA_MODE:                                      GetPName read new GetPName($0C31);
    public static property DOUBLEBUFFER:                                   GetPName read new GetPName($0C32);
    public static property STEREO:                                         GetPName read new GetPName($0C33);
    public static property RENDER_MODE:                                    GetPName read new GetPName($0C40);
    public static property PERSPECTIVE_CORRECTION_HINT:                    GetPName read new GetPName($0C50);
    public static property POINT_SMOOTH_HINT:                              GetPName read new GetPName($0C51);
    public static property LINE_SMOOTH_HINT:                               GetPName read new GetPName($0C52);
    public static property POLYGON_SMOOTH_HINT:                            GetPName read new GetPName($0C53);
    public static property FOG_HINT:                                       GetPName read new GetPName($0C54);
    public static property TEXTURE_GEN_S:                                  GetPName read new GetPName($0C60);
    public static property TEXTURE_GEN_T:                                  GetPName read new GetPName($0C61);
    public static property TEXTURE_GEN_R:                                  GetPName read new GetPName($0C62);
    public static property TEXTURE_GEN_Q:                                  GetPName read new GetPName($0C63);
    public static property PIXEL_MAP_I_TO_I_SIZE:                          GetPName read new GetPName($0CB0);
    public static property PIXEL_MAP_S_TO_S_SIZE:                          GetPName read new GetPName($0CB1);
    public static property PIXEL_MAP_I_TO_R_SIZE:                          GetPName read new GetPName($0CB2);
    public static property PIXEL_MAP_I_TO_G_SIZE:                          GetPName read new GetPName($0CB3);
    public static property PIXEL_MAP_I_TO_B_SIZE:                          GetPName read new GetPName($0CB4);
    public static property PIXEL_MAP_I_TO_A_SIZE:                          GetPName read new GetPName($0CB5);
    public static property PIXEL_MAP_R_TO_R_SIZE:                          GetPName read new GetPName($0CB6);
    public static property PIXEL_MAP_G_TO_G_SIZE:                          GetPName read new GetPName($0CB7);
    public static property PIXEL_MAP_B_TO_B_SIZE:                          GetPName read new GetPName($0CB8);
    public static property PIXEL_MAP_A_TO_A_SIZE:                          GetPName read new GetPName($0CB9);
    public static property UNPACK_SWAP_BYTES:                              GetPName read new GetPName($0CF0);
    public static property UNPACK_LSB_FIRST:                               GetPName read new GetPName($0CF1);
    public static property UNPACK_ROW_LENGTH:                              GetPName read new GetPName($0CF2);
    public static property UNPACK_SKIP_ROWS:                               GetPName read new GetPName($0CF3);
    public static property UNPACK_SKIP_PIXELS:                             GetPName read new GetPName($0CF4);
    public static property UNPACK_ALIGNMENT:                               GetPName read new GetPName($0CF5);
    public static property PACK_SWAP_BYTES:                                GetPName read new GetPName($0D00);
    public static property PACK_LSB_FIRST:                                 GetPName read new GetPName($0D01);
    public static property PACK_ROW_LENGTH:                                GetPName read new GetPName($0D02);
    public static property PACK_SKIP_ROWS:                                 GetPName read new GetPName($0D03);
    public static property PACK_SKIP_PIXELS:                               GetPName read new GetPName($0D04);
    public static property PACK_ALIGNMENT:                                 GetPName read new GetPName($0D05);
    public static property MAP_COLOR:                                      GetPName read new GetPName($0D10);
    public static property MAP_STENCIL:                                    GetPName read new GetPName($0D11);
    public static property INDEX_SHIFT:                                    GetPName read new GetPName($0D12);
    public static property INDEX_OFFSET:                                   GetPName read new GetPName($0D13);
    public static property RED_SCALE:                                      GetPName read new GetPName($0D14);
    public static property RED_BIAS:                                       GetPName read new GetPName($0D15);
    public static property ZOOM_X:                                         GetPName read new GetPName($0D16);
    public static property ZOOM_Y:                                         GetPName read new GetPName($0D17);
    public static property GREEN_SCALE:                                    GetPName read new GetPName($0D18);
    public static property GREEN_BIAS:                                     GetPName read new GetPName($0D19);
    public static property BLUE_SCALE:                                     GetPName read new GetPName($0D1A);
    public static property BLUE_BIAS:                                      GetPName read new GetPName($0D1B);
    public static property ALPHA_SCALE:                                    GetPName read new GetPName($0D1C);
    public static property ALPHA_BIAS:                                     GetPName read new GetPName($0D1D);
    public static property DEPTH_SCALE:                                    GetPName read new GetPName($0D1E);
    public static property DEPTH_BIAS:                                     GetPName read new GetPName($0D1F);
    public static property MAX_EVAL_ORDER:                                 GetPName read new GetPName($0D30);
    public static property MAX_LIGHTS:                                     GetPName read new GetPName($0D31);
    public static property MAX_CLIP_DISTANCES:                             GetPName read new GetPName($0D32);
    public static property MAX_CLIP_PLANES:                                GetPName read new GetPName($0D32);
    public static property MAX_TEXTURE_SIZE:                               GetPName read new GetPName($0D33);
    public static property MAX_PIXEL_MAP_TABLE:                            GetPName read new GetPName($0D34);
    public static property MAX_ATTRIB_STACK_DEPTH:                         GetPName read new GetPName($0D35);
    public static property MAX_MODELVIEW_STACK_DEPTH:                      GetPName read new GetPName($0D36);
    public static property MAX_NAME_STACK_DEPTH:                           GetPName read new GetPName($0D37);
    public static property MAX_PROJECTION_STACK_DEPTH:                     GetPName read new GetPName($0D38);
    public static property MAX_TEXTURE_STACK_DEPTH:                        GetPName read new GetPName($0D39);
    public static property MAX_VIEWPORT_DIMS:                              GetPName read new GetPName($0D3A);
    public static property MAX_CLIENT_ATTRIB_STACK_DEPTH:                  GetPName read new GetPName($0D3B);
    public static property SUBPIXEL_BITS:                                  GetPName read new GetPName($0D50);
    public static property INDEX_BITS:                                     GetPName read new GetPName($0D51);
    public static property RED_BITS:                                       GetPName read new GetPName($0D52);
    public static property GREEN_BITS:                                     GetPName read new GetPName($0D53);
    public static property BLUE_BITS:                                      GetPName read new GetPName($0D54);
    public static property ALPHA_BITS:                                     GetPName read new GetPName($0D55);
    public static property DEPTH_BITS:                                     GetPName read new GetPName($0D56);
    public static property STENCIL_BITS:                                   GetPName read new GetPName($0D57);
    public static property ACCUM_RED_BITS:                                 GetPName read new GetPName($0D58);
    public static property ACCUM_GREEN_BITS:                               GetPName read new GetPName($0D59);
    public static property ACCUM_BLUE_BITS:                                GetPName read new GetPName($0D5A);
    public static property ACCUM_ALPHA_BITS:                               GetPName read new GetPName($0D5B);
    public static property NAME_STACK_DEPTH:                               GetPName read new GetPName($0D70);
    public static property AUTO_NORMAL:                                    GetPName read new GetPName($0D80);
    public static property MAP1_COLOR_4:                                   GetPName read new GetPName($0D90);
    public static property MAP1_INDEX:                                     GetPName read new GetPName($0D91);
    public static property MAP1_NORMAL:                                    GetPName read new GetPName($0D92);
    public static property MAP1_TEXTURE_COORD_1:                           GetPName read new GetPName($0D93);
    public static property MAP1_TEXTURE_COORD_2:                           GetPName read new GetPName($0D94);
    public static property MAP1_TEXTURE_COORD_3:                           GetPName read new GetPName($0D95);
    public static property MAP1_TEXTURE_COORD_4:                           GetPName read new GetPName($0D96);
    public static property MAP1_VERTEX_3:                                  GetPName read new GetPName($0D97);
    public static property MAP1_VERTEX_4:                                  GetPName read new GetPName($0D98);
    public static property MAP2_COLOR_4:                                   GetPName read new GetPName($0DB0);
    public static property MAP2_INDEX:                                     GetPName read new GetPName($0DB1);
    public static property MAP2_NORMAL:                                    GetPName read new GetPName($0DB2);
    public static property MAP2_TEXTURE_COORD_1:                           GetPName read new GetPName($0DB3);
    public static property MAP2_TEXTURE_COORD_2:                           GetPName read new GetPName($0DB4);
    public static property MAP2_TEXTURE_COORD_3:                           GetPName read new GetPName($0DB5);
    public static property MAP2_TEXTURE_COORD_4:                           GetPName read new GetPName($0DB6);
    public static property MAP2_VERTEX_3:                                  GetPName read new GetPName($0DB7);
    public static property MAP2_VERTEX_4:                                  GetPName read new GetPName($0DB8);
    public static property MAP1_GRID_DOMAIN:                               GetPName read new GetPName($0DD0);
    public static property MAP1_GRID_SEGMENTS:                             GetPName read new GetPName($0DD1);
    public static property MAP2_GRID_DOMAIN:                               GetPName read new GetPName($0DD2);
    public static property MAP2_GRID_SEGMENTS:                             GetPName read new GetPName($0DD3);
    public static property TEXTURE_1D:                                     GetPName read new GetPName($0DE0);
    public static property TEXTURE_2D:                                     GetPName read new GetPName($0DE1);
    public static property FEEDBACK_BUFFER_SIZE:                           GetPName read new GetPName($0DF1);
    public static property FEEDBACK_BUFFER_TYPE:                           GetPName read new GetPName($0DF2);
    public static property SELECTION_BUFFER_SIZE:                          GetPName read new GetPName($0DF4);
    public static property POLYGON_OFFSET_UNITS:                           GetPName read new GetPName($2A00);
    public static property POLYGON_OFFSET_POINT:                           GetPName read new GetPName($2A01);
    public static property POLYGON_OFFSET_LINE:                            GetPName read new GetPName($2A02);
    public static property CLIP_PLANE0:                                    GetPName read new GetPName($3000);
    public static property CLIP_PLANE1:                                    GetPName read new GetPName($3001);
    public static property CLIP_PLANE2:                                    GetPName read new GetPName($3002);
    public static property CLIP_PLANE3:                                    GetPName read new GetPName($3003);
    public static property CLIP_PLANE4:                                    GetPName read new GetPName($3004);
    public static property CLIP_PLANE5:                                    GetPName read new GetPName($3005);
    public static property LIGHT0:                                         GetPName read new GetPName($4000);
    public static property LIGHT1:                                         GetPName read new GetPName($4001);
    public static property LIGHT2:                                         GetPName read new GetPName($4002);
    public static property LIGHT3:                                         GetPName read new GetPName($4003);
    public static property LIGHT4:                                         GetPName read new GetPName($4004);
    public static property LIGHT5:                                         GetPName read new GetPName($4005);
    public static property LIGHT6:                                         GetPName read new GetPName($4006);
    public static property LIGHT7:                                         GetPName read new GetPName($4007);
    public static property BLEND_COLOR:                                    GetPName read new GetPName($8005);
    public static property BLEND_COLOR_EXT:                                GetPName read new GetPName($8005);
    public static property BLEND_EQUATION_EXT:                             GetPName read new GetPName($8009);
    public static property BLEND_EQUATION_RGB:                             GetPName read new GetPName($8009);
    public static property PACK_CMYK_HINT_EXT:                             GetPName read new GetPName($800E);
    public static property UNPACK_CMYK_HINT_EXT:                           GetPName read new GetPName($800F);
    public static property CONVOLUTION_1D_EXT:                             GetPName read new GetPName($8010);
    public static property CONVOLUTION_2D_EXT:                             GetPName read new GetPName($8011);
    public static property SEPARABLE_2D_EXT:                               GetPName read new GetPName($8012);
    public static property POST_CONVOLUTION_RED_SCALE_EXT:                 GetPName read new GetPName($801C);
    public static property POST_CONVOLUTION_GREEN_SCALE_EXT:               GetPName read new GetPName($801D);
    public static property POST_CONVOLUTION_BLUE_SCALE_EXT:                GetPName read new GetPName($801E);
    public static property POST_CONVOLUTION_ALPHA_SCALE_EXT:               GetPName read new GetPName($801F);
    public static property POST_CONVOLUTION_RED_BIAS_EXT:                  GetPName read new GetPName($8020);
    public static property POST_CONVOLUTION_GREEN_BIAS_EXT:                GetPName read new GetPName($8021);
    public static property POST_CONVOLUTION_BLUE_BIAS_EXT:                 GetPName read new GetPName($8022);
    public static property POST_CONVOLUTION_ALPHA_BIAS_EXT:                GetPName read new GetPName($8023);
    public static property HISTOGRAM_EXT:                                  GetPName read new GetPName($8024);
    public static property MINMAX_EXT:                                     GetPName read new GetPName($802E);
    public static property POLYGON_OFFSET_FILL:                            GetPName read new GetPName($8037);
    public static property POLYGON_OFFSET_FACTOR:                          GetPName read new GetPName($8038);
    public static property POLYGON_OFFSET_BIAS_EXT:                        GetPName read new GetPName($8039);
    public static property RESCALE_NORMAL_EXT:                             GetPName read new GetPName($803A);
    public static property TEXTURE_BINDING_1D:                             GetPName read new GetPName($8068);
    public static property TEXTURE_BINDING_2D:                             GetPName read new GetPName($8069);
    public static property TEXTURE_3D_BINDING_EXT:                         GetPName read new GetPName($806A);
    public static property TEXTURE_BINDING_3D:                             GetPName read new GetPName($806A);
    public static property PACK_SKIP_IMAGES:                               GetPName read new GetPName($806B);
    public static property PACK_SKIP_IMAGES_EXT:                           GetPName read new GetPName($806B);
    public static property PACK_IMAGE_HEIGHT:                              GetPName read new GetPName($806C);
    public static property PACK_IMAGE_HEIGHT_EXT:                          GetPName read new GetPName($806C);
    public static property UNPACK_SKIP_IMAGES:                             GetPName read new GetPName($806D);
    public static property UNPACK_SKIP_IMAGES_EXT:                         GetPName read new GetPName($806D);
    public static property UNPACK_IMAGE_HEIGHT:                            GetPName read new GetPName($806E);
    public static property UNPACK_IMAGE_HEIGHT_EXT:                        GetPName read new GetPName($806E);
    public static property TEXTURE_3D_EXT:                                 GetPName read new GetPName($806F);
    public static property MAX_3D_TEXTURE_SIZE:                            GetPName read new GetPName($8073);
    public static property MAX_3D_TEXTURE_SIZE_EXT:                        GetPName read new GetPName($8073);
    public static property VERTEX_ARRAY:                                   GetPName read new GetPName($8074);
    public static property NORMAL_ARRAY:                                   GetPName read new GetPName($8075);
    public static property COLOR_ARRAY:                                    GetPName read new GetPName($8076);
    public static property INDEX_ARRAY:                                    GetPName read new GetPName($8077);
    public static property TEXTURE_COORD_ARRAY:                            GetPName read new GetPName($8078);
    public static property EDGE_FLAG_ARRAY:                                GetPName read new GetPName($8079);
    public static property VERTEX_ARRAY_SIZE:                              GetPName read new GetPName($807A);
    public static property VERTEX_ARRAY_TYPE:                              GetPName read new GetPName($807B);
    public static property VERTEX_ARRAY_STRIDE:                            GetPName read new GetPName($807C);
    public static property VERTEX_ARRAY_COUNT_EXT:                         GetPName read new GetPName($807D);
    public static property NORMAL_ARRAY_TYPE:                              GetPName read new GetPName($807E);
    public static property NORMAL_ARRAY_STRIDE:                            GetPName read new GetPName($807F);
    public static property NORMAL_ARRAY_COUNT_EXT:                         GetPName read new GetPName($8080);
    public static property COLOR_ARRAY_SIZE:                               GetPName read new GetPName($8081);
    public static property COLOR_ARRAY_TYPE:                               GetPName read new GetPName($8082);
    public static property COLOR_ARRAY_STRIDE:                             GetPName read new GetPName($8083);
    public static property COLOR_ARRAY_COUNT_EXT:                          GetPName read new GetPName($8084);
    public static property INDEX_ARRAY_TYPE:                               GetPName read new GetPName($8085);
    public static property INDEX_ARRAY_STRIDE:                             GetPName read new GetPName($8086);
    public static property INDEX_ARRAY_COUNT_EXT:                          GetPName read new GetPName($8087);
    public static property TEXTURE_COORD_ARRAY_SIZE:                       GetPName read new GetPName($8088);
    public static property TEXTURE_COORD_ARRAY_TYPE:                       GetPName read new GetPName($8089);
    public static property TEXTURE_COORD_ARRAY_STRIDE:                     GetPName read new GetPName($808A);
    public static property TEXTURE_COORD_ARRAY_COUNT_EXT:                  GetPName read new GetPName($808B);
    public static property EDGE_FLAG_ARRAY_STRIDE:                         GetPName read new GetPName($808C);
    public static property EDGE_FLAG_ARRAY_COUNT_EXT:                      GetPName read new GetPName($808D);
    public static property INTERLACE_SGIX:                                 GetPName read new GetPName($8094);
    public static property DETAIL_TEXTURE_2D_BINDING_SGIS:                 GetPName read new GetPName($8096);
    public static property MULTISAMPLE_SGIS:                               GetPName read new GetPName($809D);
    public static property SAMPLE_ALPHA_TO_MASK_SGIS:                      GetPName read new GetPName($809E);
    public static property SAMPLE_ALPHA_TO_ONE_SGIS:                       GetPName read new GetPName($809F);
    public static property SAMPLE_MASK_SGIS:                               GetPName read new GetPName($80A0);
    public static property SAMPLE_BUFFERS:                                 GetPName read new GetPName($80A8);
    public static property SAMPLE_BUFFERS_SGIS:                            GetPName read new GetPName($80A8);
    public static property SAMPLES:                                        GetPName read new GetPName($80A9);
    public static property SAMPLES_SGIS:                                   GetPName read new GetPName($80A9);
    public static property SAMPLE_COVERAGE_VALUE:                          GetPName read new GetPName($80AA);
    public static property SAMPLE_MASK_VALUE_SGIS:                         GetPName read new GetPName($80AA);
    public static property SAMPLE_COVERAGE_INVERT:                         GetPName read new GetPName($80AB);
    public static property SAMPLE_MASK_INVERT_SGIS:                        GetPName read new GetPName($80AB);
    public static property SAMPLE_PATTERN_SGIS:                            GetPName read new GetPName($80AC);
    public static property COLOR_MATRIX_SGI:                               GetPName read new GetPName($80B1);
    public static property COLOR_MATRIX_STACK_DEPTH_SGI:                   GetPName read new GetPName($80B2);
    public static property MAX_COLOR_MATRIX_STACK_DEPTH_SGI:               GetPName read new GetPName($80B3);
    public static property POST_COLOR_MATRIX_RED_SCALE_SGI:                GetPName read new GetPName($80B4);
    public static property POST_COLOR_MATRIX_GREEN_SCALE_SGI:              GetPName read new GetPName($80B5);
    public static property POST_COLOR_MATRIX_BLUE_SCALE_SGI:               GetPName read new GetPName($80B6);
    public static property POST_COLOR_MATRIX_ALPHA_SCALE_SGI:              GetPName read new GetPName($80B7);
    public static property POST_COLOR_MATRIX_RED_BIAS_SGI:                 GetPName read new GetPName($80B8);
    public static property POST_COLOR_MATRIX_GREEN_BIAS_SGI:               GetPName read new GetPName($80B9);
    public static property POST_COLOR_MATRIX_BLUE_BIAS_SGI:                GetPName read new GetPName($80BA);
    public static property POST_COLOR_MATRIX_ALPHA_BIAS_SGI:               GetPName read new GetPName($80BB);
    public static property TEXTURE_COLOR_TABLE_SGI:                        GetPName read new GetPName($80BC);
    public static property BLEND_DST_RGB:                                  GetPName read new GetPName($80C8);
    public static property BLEND_SRC_RGB:                                  GetPName read new GetPName($80C9);
    public static property BLEND_DST_ALPHA:                                GetPName read new GetPName($80CA);
    public static property BLEND_SRC_ALPHA:                                GetPName read new GetPName($80CB);
    public static property COLOR_TABLE_SGI:                                GetPName read new GetPName($80D0);
    public static property POST_CONVOLUTION_COLOR_TABLE_SGI:               GetPName read new GetPName($80D1);
    public static property POST_COLOR_MATRIX_COLOR_TABLE_SGI:              GetPName read new GetPName($80D2);
    public static property MAX_ELEMENTS_VERTICES:                          GetPName read new GetPName($80E8);
    public static property MAX_ELEMENTS_INDICES:                           GetPName read new GetPName($80E9);
    public static property POINT_SIZE_MIN_SGIS:                            GetPName read new GetPName($8126);
    public static property POINT_SIZE_MAX_SGIS:                            GetPName read new GetPName($8127);
    public static property POINT_FADE_THRESHOLD_SIZE:                      GetPName read new GetPName($8128);
    public static property POINT_FADE_THRESHOLD_SIZE_SGIS:                 GetPName read new GetPName($8128);
    public static property DISTANCE_ATTENUATION_SGIS:                      GetPName read new GetPName($8129);
    public static property FOG_FUNC_POINTS_SGIS:                           GetPName read new GetPName($812B);
    public static property MAX_FOG_FUNC_POINTS_SGIS:                       GetPName read new GetPName($812C);
    public static property PACK_SKIP_VOLUMES_SGIS:                         GetPName read new GetPName($8130);
    public static property PACK_IMAGE_DEPTH_SGIS:                          GetPName read new GetPName($8131);
    public static property UNPACK_SKIP_VOLUMES_SGIS:                       GetPName read new GetPName($8132);
    public static property UNPACK_IMAGE_DEPTH_SGIS:                        GetPName read new GetPName($8133);
    public static property TEXTURE_4D_SGIS:                                GetPName read new GetPName($8134);
    public static property MAX_4D_TEXTURE_SIZE_SGIS:                       GetPName read new GetPName($8138);
    public static property PIXEL_TEX_GEN_SGIX:                             GetPName read new GetPName($8139);
    public static property PIXEL_TILE_BEST_ALIGNMENT_SGIX:                 GetPName read new GetPName($813E);
    public static property PIXEL_TILE_CACHE_INCREMENT_SGIX:                GetPName read new GetPName($813F);
    public static property PIXEL_TILE_WIDTH_SGIX:                          GetPName read new GetPName($8140);
    public static property PIXEL_TILE_HEIGHT_SGIX:                         GetPName read new GetPName($8141);
    public static property PIXEL_TILE_GRID_WIDTH_SGIX:                     GetPName read new GetPName($8142);
    public static property PIXEL_TILE_GRID_HEIGHT_SGIX:                    GetPName read new GetPName($8143);
    public static property PIXEL_TILE_GRID_DEPTH_SGIX:                     GetPName read new GetPName($8144);
    public static property PIXEL_TILE_CACHE_SIZE_SGIX:                     GetPName read new GetPName($8145);
    public static property SPRITE_SGIX:                                    GetPName read new GetPName($8148);
    public static property SPRITE_MODE_SGIX:                               GetPName read new GetPName($8149);
    public static property SPRITE_AXIS_SGIX:                               GetPName read new GetPName($814A);
    public static property SPRITE_TRANSLATION_SGIX:                        GetPName read new GetPName($814B);
    public static property TEXTURE_4D_BINDING_SGIS:                        GetPName read new GetPName($814F);
    public static property MAX_CLIPMAP_DEPTH_SGIX:                         GetPName read new GetPName($8177);
    public static property MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX:                 GetPName read new GetPName($8178);
    public static property POST_TEXTURE_FILTER_BIAS_RANGE_SGIX:            GetPName read new GetPName($817B);
    public static property POST_TEXTURE_FILTER_SCALE_RANGE_SGIX:           GetPName read new GetPName($817C);
    public static property REFERENCE_PLANE_SGIX:                           GetPName read new GetPName($817D);
    public static property REFERENCE_PLANE_EQUATION_SGIX:                  GetPName read new GetPName($817E);
    public static property IR_INSTRUMENT1_SGIX:                            GetPName read new GetPName($817F);
    public static property INSTRUMENT_MEASUREMENTS_SGIX:                   GetPName read new GetPName($8181);
    public static property CALLIGRAPHIC_FRAGMENT_SGIX:                     GetPName read new GetPName($8183);
    public static property FRAMEZOOM_SGIX:                                 GetPName read new GetPName($818B);
    public static property FRAMEZOOM_FACTOR_SGIX:                          GetPName read new GetPName($818C);
    public static property MAX_FRAMEZOOM_FACTOR_SGIX:                      GetPName read new GetPName($818D);
    public static property GENERATE_MIPMAP_HINT_SGIS:                      GetPName read new GetPName($8192);
    public static property DEFORMATIONS_MASK_SGIX:                         GetPName read new GetPName($8196);
    public static property FOG_OFFSET_SGIX:                                GetPName read new GetPName($8198);
    public static property FOG_OFFSET_VALUE_SGIX:                          GetPName read new GetPName($8199);
    public static property LIGHT_MODEL_COLOR_CONTROL:                      GetPName read new GetPName($81F8);
    public static property SHARED_TEXTURE_PALETTE_EXT:                     GetPName read new GetPName($81FB);
    public static property MAJOR_VERSION:                                  GetPName read new GetPName($821B);
    public static property MINOR_VERSION:                                  GetPName read new GetPName($821C);
    public static property NUM_EXTENSIONS:                                 GetPName read new GetPName($821D);
    public static property CONTEXT_FLAGS:                                  GetPName read new GetPName($821E);
    public static property PROGRAM_PIPELINE_BINDING:                       GetPName read new GetPName($825A);
    public static property MAX_VIEWPORTS:                                  GetPName read new GetPName($825B);
    public static property VIEWPORT_SUBPIXEL_BITS:                         GetPName read new GetPName($825C);
    public static property VIEWPORT_BOUNDS_RANGE:                          GetPName read new GetPName($825D);
    public static property LAYER_PROVOKING_VERTEX:                         GetPName read new GetPName($825E);
    public static property VIEWPORT_INDEX_PROVOKING_VERTEX:                GetPName read new GetPName($825F);
    public static property MAX_COMPUTE_UNIFORM_COMPONENTS:                 GetPName read new GetPName($8263);
    public static property MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS:             GetPName read new GetPName($8264);
    public static property MAX_COMPUTE_ATOMIC_COUNTERS:                    GetPName read new GetPName($8265);
    public static property MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS:        GetPName read new GetPName($8266);
    public static property MAX_DEBUG_GROUP_STACK_DEPTH:                    GetPName read new GetPName($826C);
    public static property DEBUG_GROUP_STACK_DEPTH:                        GetPName read new GetPName($826D);
    public static property MAX_UNIFORM_LOCATIONS:                          GetPName read new GetPName($826E);
    public static property VERTEX_BINDING_DIVISOR:                         GetPName read new GetPName($82D6);
    public static property VERTEX_BINDING_OFFSET:                          GetPName read new GetPName($82D7);
    public static property VERTEX_BINDING_STRIDE:                          GetPName read new GetPName($82D8);
    public static property MAX_VERTEX_ATTRIB_RELATIVE_OFFSET:              GetPName read new GetPName($82D9);
    public static property MAX_VERTEX_ATTRIB_BINDINGS:                     GetPName read new GetPName($82DA);
    public static property MAX_LABEL_LENGTH:                               GetPName read new GetPName($82E8);
    public static property CONVOLUTION_HINT_SGIX:                          GetPName read new GetPName($8316);
    public static property ASYNC_MARKER_SGIX:                              GetPName read new GetPName($8329);
    public static property PIXEL_TEX_GEN_MODE_SGIX:                        GetPName read new GetPName($832B);
    public static property ASYNC_HISTOGRAM_SGIX:                           GetPName read new GetPName($832C);
    public static property MAX_ASYNC_HISTOGRAM_SGIX:                       GetPName read new GetPName($832D);
    public static property PIXEL_TEXTURE_SGIS:                             GetPName read new GetPName($8353);
    public static property ASYNC_TEX_IMAGE_SGIX:                           GetPName read new GetPName($835C);
    public static property ASYNC_DRAW_PIXELS_SGIX:                         GetPName read new GetPName($835D);
    public static property ASYNC_READ_PIXELS_SGIX:                         GetPName read new GetPName($835E);
    public static property MAX_ASYNC_TEX_IMAGE_SGIX:                       GetPName read new GetPName($835F);
    public static property MAX_ASYNC_DRAW_PIXELS_SGIX:                     GetPName read new GetPName($8360);
    public static property MAX_ASYNC_READ_PIXELS_SGIX:                     GetPName read new GetPName($8361);
    public static property VERTEX_PRECLIP_SGIX:                            GetPName read new GetPName($83EE);
    public static property VERTEX_PRECLIP_HINT_SGIX:                       GetPName read new GetPName($83EF);
    public static property FRAGMENT_LIGHTING_SGIX:                         GetPName read new GetPName($8400);
    public static property FRAGMENT_COLOR_MATERIAL_SGIX:                   GetPName read new GetPName($8401);
    public static property FRAGMENT_COLOR_MATERIAL_FACE_SGIX:              GetPName read new GetPName($8402);
    public static property FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX:         GetPName read new GetPName($8403);
    public static property MAX_FRAGMENT_LIGHTS_SGIX:                       GetPName read new GetPName($8404);
    public static property MAX_ACTIVE_LIGHTS_SGIX:                         GetPName read new GetPName($8405);
    public static property LIGHT_ENV_MODE_SGIX:                            GetPName read new GetPName($8407);
    public static property FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX:         GetPName read new GetPName($8408);
    public static property FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX:             GetPName read new GetPName($8409);
    public static property FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX:              GetPName read new GetPName($840A);
    public static property FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX: GetPName read new GetPName($840B);
    public static property FRAGMENT_LIGHT0_SGIX:                           GetPName read new GetPName($840C);
    public static property PACK_RESAMPLE_SGIX:                             GetPName read new GetPName($842E);
    public static property UNPACK_RESAMPLE_SGIX:                           GetPName read new GetPName($842F);
    public static property ALIASED_POINT_SIZE_RANGE:                       GetPName read new GetPName($846D);
    public static property ALIASED_LINE_WIDTH_RANGE:                       GetPName read new GetPName($846E);
    public static property ACTIVE_TEXTURE:                                 GetPName read new GetPName($84E0);
    public static property MAX_RENDERBUFFER_SIZE:                          GetPName read new GetPName($84E8);
    public static property TEXTURE_COMPRESSION_HINT:                       GetPName read new GetPName($84EF);
    public static property TEXTURE_BINDING_RECTANGLE:                      GetPName read new GetPName($84F6);
    public static property TEXTURE_BINDING_RECTANGLE_ARB:                  GetPName read new GetPName($84F6);
    public static property TEXTURE_BINDING_RECTANGLE_NV:                   GetPName read new GetPName($84F6);
    public static property MAX_RECTANGLE_TEXTURE_SIZE:                     GetPName read new GetPName($84F8);
    public static property MAX_TEXTURE_LOD_BIAS:                           GetPName read new GetPName($84FD);
    public static property TEXTURE_BINDING_CUBE_MAP:                       GetPName read new GetPName($8514);
    public static property TEXTURE_BINDING_CUBE_MAP_ARB:                   GetPName read new GetPName($8514);
    public static property TEXTURE_BINDING_CUBE_MAP_EXT:                   GetPName read new GetPName($8514);
    public static property TEXTURE_BINDING_CUBE_MAP_OES:                   GetPName read new GetPName($8514);
    public static property MAX_CUBE_MAP_TEXTURE_SIZE:                      GetPName read new GetPName($851C);
    public static property PACK_SUBSAMPLE_RATE_SGIX:                       GetPName read new GetPName($85A0);
    public static property UNPACK_SUBSAMPLE_RATE_SGIX:                     GetPName read new GetPName($85A1);
    public static property VERTEX_ARRAY_BINDING:                           GetPName read new GetPName($85B5);
    public static property PROGRAM_POINT_SIZE:                             GetPName read new GetPName($8642);
    public static property NUM_COMPRESSED_TEXTURE_FORMATS:                 GetPName read new GetPName($86A2);
    public static property COMPRESSED_TEXTURE_FORMATS:                     GetPName read new GetPName($86A3);
    public static property NUM_PROGRAM_BINARY_FORMATS:                     GetPName read new GetPName($87FE);
    public static property PROGRAM_BINARY_FORMATS:                         GetPName read new GetPName($87FF);
    public static property STENCIL_BACK_FUNC:                              GetPName read new GetPName($8800);
    public static property STENCIL_BACK_FAIL:                              GetPName read new GetPName($8801);
    public static property STENCIL_BACK_PASS_DEPTH_FAIL:                   GetPName read new GetPName($8802);
    public static property STENCIL_BACK_PASS_DEPTH_PASS:                   GetPName read new GetPName($8803);
    public static property MAX_DRAW_BUFFERS:                               GetPName read new GetPName($8824);
    public static property BLEND_EQUATION_ALPHA:                           GetPName read new GetPName($883D);
    public static property MAX_VERTEX_ATTRIBS:                             GetPName read new GetPName($8869);
    public static property MAX_TEXTURE_IMAGE_UNITS:                        GetPName read new GetPName($8872);
    public static property ARRAY_BUFFER_BINDING:                           GetPName read new GetPName($8894);
    public static property ELEMENT_ARRAY_BUFFER_BINDING:                   GetPName read new GetPName($8895);
    public static property PIXEL_PACK_BUFFER_BINDING:                      GetPName read new GetPName($88ED);
    public static property PIXEL_UNPACK_BUFFER_BINDING:                    GetPName read new GetPName($88EF);
    public static property MAX_DUAL_SOURCE_DRAW_BUFFERS:                   GetPName read new GetPName($88FC);
    public static property MAX_ARRAY_TEXTURE_LAYERS:                       GetPName read new GetPName($88FF);
    public static property MIN_PROGRAM_TEXEL_OFFSET:                       GetPName read new GetPName($8904);
    public static property MAX_PROGRAM_TEXEL_OFFSET:                       GetPName read new GetPName($8905);
    public static property SAMPLER_BINDING:                                GetPName read new GetPName($8919);
    public static property UNIFORM_BUFFER_BINDING:                         GetPName read new GetPName($8A28);
    public static property UNIFORM_BUFFER_START:                           GetPName read new GetPName($8A29);
    public static property UNIFORM_BUFFER_SIZE:                            GetPName read new GetPName($8A2A);
    public static property MAX_VERTEX_UNIFORM_BLOCKS:                      GetPName read new GetPName($8A2B);
    public static property MAX_GEOMETRY_UNIFORM_BLOCKS:                    GetPName read new GetPName($8A2C);
    public static property MAX_FRAGMENT_UNIFORM_BLOCKS:                    GetPName read new GetPName($8A2D);
    public static property MAX_COMBINED_UNIFORM_BLOCKS:                    GetPName read new GetPName($8A2E);
    public static property MAX_UNIFORM_BUFFER_BINDINGS:                    GetPName read new GetPName($8A2F);
    public static property MAX_UNIFORM_BLOCK_SIZE:                         GetPName read new GetPName($8A30);
    public static property MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:         GetPName read new GetPName($8A31);
    public static property MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS:       GetPName read new GetPName($8A32);
    public static property MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:       GetPName read new GetPName($8A33);
    public static property UNIFORM_BUFFER_OFFSET_ALIGNMENT:                GetPName read new GetPName($8A34);
    public static property MAX_FRAGMENT_UNIFORM_COMPONENTS:                GetPName read new GetPName($8B49);
    public static property MAX_VERTEX_UNIFORM_COMPONENTS:                  GetPName read new GetPName($8B4A);
    public static property MAX_VARYING_COMPONENTS:                         GetPName read new GetPName($8B4B);
    public static property MAX_VARYING_FLOATS:                             GetPName read new GetPName($8B4B);
    public static property MAX_VERTEX_TEXTURE_IMAGE_UNITS:                 GetPName read new GetPName($8B4C);
    public static property MAX_COMBINED_TEXTURE_IMAGE_UNITS:               GetPName read new GetPName($8B4D);
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT:                GetPName read new GetPName($8B8B);
    public static property CURRENT_PROGRAM:                                GetPName read new GetPName($8B8D);
    public static property IMPLEMENTATION_COLOR_READ_TYPE:                 GetPName read new GetPName($8B9A);
    public static property IMPLEMENTATION_COLOR_READ_FORMAT:               GetPName read new GetPName($8B9B);
    public static property TEXTURE_BINDING_1D_ARRAY:                       GetPName read new GetPName($8C1C);
    public static property TEXTURE_BINDING_2D_ARRAY:                       GetPName read new GetPName($8C1D);
    public static property MAX_GEOMETRY_TEXTURE_IMAGE_UNITS:               GetPName read new GetPName($8C29);
    public static property MAX_TEXTURE_BUFFER_SIZE:                        GetPName read new GetPName($8C2B);
    public static property TEXTURE_BINDING_BUFFER:                         GetPName read new GetPName($8C2C);
    public static property TRANSFORM_FEEDBACK_BUFFER_START:                GetPName read new GetPName($8C84);
    public static property TRANSFORM_FEEDBACK_BUFFER_SIZE:                 GetPName read new GetPName($8C85);
    public static property TRANSFORM_FEEDBACK_BUFFER_BINDING:              GetPName read new GetPName($8C8F);
    public static property MOTION_ESTIMATION_SEARCH_BLOCK_X_QCOM:          GetPName read new GetPName($8C90);
    public static property MOTION_ESTIMATION_SEARCH_BLOCK_Y_QCOM:          GetPName read new GetPName($8C91);
    public static property STENCIL_BACK_REF:                               GetPName read new GetPName($8CA3);
    public static property STENCIL_BACK_VALUE_MASK:                        GetPName read new GetPName($8CA4);
    public static property STENCIL_BACK_WRITEMASK:                         GetPName read new GetPName($8CA5);
    public static property DRAW_FRAMEBUFFER_BINDING:                       GetPName read new GetPName($8CA6);
    public static property RENDERBUFFER_BINDING:                           GetPName read new GetPName($8CA7);
    public static property READ_FRAMEBUFFER_BINDING:                       GetPName read new GetPName($8CAA);
    public static property MAX_COLOR_ATTACHMENTS:                          GetPName read new GetPName($8CDF);
    public static property MAX_COLOR_ATTACHMENTS_EXT:                      GetPName read new GetPName($8CDF);
    public static property MAX_COLOR_ATTACHMENTS_NV:                       GetPName read new GetPName($8CDF);
    public static property MAX_ELEMENT_INDEX:                              GetPName read new GetPName($8D6B);
    public static property MAX_GEOMETRY_UNIFORM_COMPONENTS:                GetPName read new GetPName($8DDF);
    public static property SHADER_BINARY_FORMATS:                          GetPName read new GetPName($8DF8);
    public static property NUM_SHADER_BINARY_FORMATS:                      GetPName read new GetPName($8DF9);
    public static property SHADER_COMPILER:                                GetPName read new GetPName($8DFA);
    public static property MAX_VERTEX_UNIFORM_VECTORS:                     GetPName read new GetPName($8DFB);
    public static property MAX_VARYING_VECTORS:                            GetPName read new GetPName($8DFC);
    public static property MAX_FRAGMENT_UNIFORM_VECTORS:                   GetPName read new GetPName($8DFD);
    public static property TIMESTAMP:                                      GetPName read new GetPName($8E28);
    public static property PROVOKING_VERTEX:                               GetPName read new GetPName($8E4F);
    public static property MAX_SAMPLE_MASK_WORDS:                          GetPName read new GetPName($8E59);
    public static property MAX_TESS_CONTROL_UNIFORM_BLOCKS:                GetPName read new GetPName($8E89);
    public static property MAX_TESS_EVALUATION_UNIFORM_BLOCKS:             GetPName read new GetPName($8E8A);
    public static property FETCH_PER_SAMPLE_ARM:                           GetPName read new GetPName($8F65);
    public static property FRAGMENT_SHADER_FRAMEBUFFER_FETCH_MRT_ARM:      GetPName read new GetPName($8F66);
    public static property PRIMITIVE_RESTART_INDEX:                        GetPName read new GetPName($8F9E);
    public static property MIN_MAP_BUFFER_ALIGNMENT:                       GetPName read new GetPName($90BC);
    public static property SHADER_STORAGE_BUFFER_BINDING:                  GetPName read new GetPName($90D3);
    public static property SHADER_STORAGE_BUFFER_START:                    GetPName read new GetPName($90D4);
    public static property SHADER_STORAGE_BUFFER_SIZE:                     GetPName read new GetPName($90D5);
    public static property MAX_VERTEX_SHADER_STORAGE_BLOCKS:               GetPName read new GetPName($90D6);
    public static property MAX_GEOMETRY_SHADER_STORAGE_BLOCKS:             GetPName read new GetPName($90D7);
    public static property MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS:         GetPName read new GetPName($90D8);
    public static property MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS:      GetPName read new GetPName($90D9);
    public static property MAX_FRAGMENT_SHADER_STORAGE_BLOCKS:             GetPName read new GetPName($90DA);
    public static property MAX_COMPUTE_SHADER_STORAGE_BLOCKS:              GetPName read new GetPName($90DB);
    public static property MAX_COMBINED_SHADER_STORAGE_BLOCKS:             GetPName read new GetPName($90DC);
    public static property MAX_SHADER_STORAGE_BUFFER_BINDINGS:             GetPName read new GetPName($90DD);
    public static property SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT:         GetPName read new GetPName($90DF);
    public static property MAX_COMPUTE_WORK_GROUP_INVOCATIONS:             GetPName read new GetPName($90EB);
    public static property DISPATCH_INDIRECT_BUFFER_BINDING:               GetPName read new GetPName($90EF);
    public static property TEXTURE_BINDING_2D_MULTISAMPLE:                 GetPName read new GetPName($9104);
    public static property TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY:           GetPName read new GetPName($9105);
    public static property MAX_COLOR_TEXTURE_SAMPLES:                      GetPName read new GetPName($910E);
    public static property MAX_DEPTH_TEXTURE_SAMPLES:                      GetPName read new GetPName($910F);
    public static property MAX_INTEGER_SAMPLES:                            GetPName read new GetPName($9110);
    public static property MAX_SERVER_WAIT_TIMEOUT:                        GetPName read new GetPName($9111);
    public static property MAX_VERTEX_OUTPUT_COMPONENTS:                   GetPName read new GetPName($9122);
    public static property MAX_GEOMETRY_INPUT_COMPONENTS:                  GetPName read new GetPName($9123);
    public static property MAX_GEOMETRY_OUTPUT_COMPONENTS:                 GetPName read new GetPName($9124);
    public static property MAX_FRAGMENT_INPUT_COMPONENTS:                  GetPName read new GetPName($9125);
    public static property CONTEXT_PROFILE_MASK:                           GetPName read new GetPName($9126);
    public static property TEXTURE_BUFFER_OFFSET_ALIGNMENT:                GetPName read new GetPName($919F);
    public static property MAX_COMPUTE_UNIFORM_BLOCKS:                     GetPName read new GetPName($91BB);
    public static property MAX_COMPUTE_TEXTURE_IMAGE_UNITS:                GetPName read new GetPName($91BC);
    public static property MAX_COMPUTE_WORK_GROUP_COUNT:                   GetPName read new GetPName($91BE);
    public static property MAX_COMPUTE_WORK_GROUP_SIZE:                    GetPName read new GetPName($91BF);
    public static property MAX_VERTEX_ATOMIC_COUNTERS:                     GetPName read new GetPName($92D2);
    public static property MAX_TESS_CONTROL_ATOMIC_COUNTERS:               GetPName read new GetPName($92D3);
    public static property MAX_TESS_EVALUATION_ATOMIC_COUNTERS:            GetPName read new GetPName($92D4);
    public static property MAX_GEOMETRY_ATOMIC_COUNTERS:                   GetPName read new GetPName($92D5);
    public static property MAX_FRAGMENT_ATOMIC_COUNTERS:                   GetPName read new GetPName($92D6);
    public static property MAX_COMBINED_ATOMIC_COUNTERS:                   GetPName read new GetPName($92D7);
    public static property MAX_FRAMEBUFFER_WIDTH:                          GetPName read new GetPName($9315);
    public static property MAX_FRAMEBUFFER_HEIGHT:                         GetPName read new GetPName($9316);
    public static property MAX_FRAMEBUFFER_LAYERS:                         GetPName read new GetPName($9317);
    public static property MAX_FRAMEBUFFER_SAMPLES:                        GetPName read new GetPName($9318);
    public static property NUM_DEVICE_UUIDS_EXT:                           GetPName read new GetPName($9596);
    public static property DEVICE_UUID_EXT:                                GetPName read new GetPName($9597);
    public static property DRIVER_UUID_EXT:                                GetPName read new GetPName($9598);
    public static property DEVICE_LUID_EXT:                                GetPName read new GetPName($9599);
    public static property DEVICE_NODE_MASK_EXT:                           GetPName read new GetPName($959A);
    public static property SHADING_RATE_IMAGE_PER_PRIMITIVE_NV:            GetPName read new GetPName($95B1);
    public static property SHADING_RATE_IMAGE_PALETTE_COUNT_NV:            GetPName read new GetPName($95B2);
    public static property MAX_TIMELINE_SEMAPHORE_VALUE_DIFFERENCE_NV:     GetPName read new GetPName($95B6);
    public static property SHADING_RATE_QCOM:                              GetPName read new GetPName($96A4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0B00) then Result := 'CURRENT_COLOR' else
      if self.val = UInt32($0B01) then Result := 'CURRENT_INDEX' else
      if self.val = UInt32($0B02) then Result := 'CURRENT_NORMAL' else
      if self.val = UInt32($0B03) then Result := 'CURRENT_TEXTURE_COORDS' else
      if self.val = UInt32($0B04) then Result := 'CURRENT_RASTER_COLOR' else
      if self.val = UInt32($0B05) then Result := 'CURRENT_RASTER_INDEX' else
      if self.val = UInt32($0B06) then Result := 'CURRENT_RASTER_TEXTURE_COORDS' else
      if self.val = UInt32($0B07) then Result := 'CURRENT_RASTER_POSITION' else
      if self.val = UInt32($0B08) then Result := 'CURRENT_RASTER_POSITION_VALID' else
      if self.val = UInt32($0B09) then Result := 'CURRENT_RASTER_DISTANCE' else
      if self.val = UInt32($0B10) then Result := 'POINT_SMOOTH' else
      if self.val = UInt32($0B11) then Result := 'POINT_SIZE' else
      if self.val = UInt32($0B12) then Result := 'POINT_SIZE_RANGE' else
      if self.val = UInt32($0B12) then Result := 'SMOOTH_POINT_SIZE_RANGE' else
      if self.val = UInt32($0B13) then Result := 'POINT_SIZE_GRANULARITY' else
      if self.val = UInt32($0B13) then Result := 'SMOOTH_POINT_SIZE_GRANULARITY' else
      if self.val = UInt32($0B20) then Result := 'LINE_SMOOTH' else
      if self.val = UInt32($0B21) then Result := 'LINE_WIDTH' else
      if self.val = UInt32($0B22) then Result := 'LINE_WIDTH_RANGE' else
      if self.val = UInt32($0B22) then Result := 'SMOOTH_LINE_WIDTH_RANGE' else
      if self.val = UInt32($0B23) then Result := 'LINE_WIDTH_GRANULARITY' else
      if self.val = UInt32($0B23) then Result := 'SMOOTH_LINE_WIDTH_GRANULARITY' else
      if self.val = UInt32($0B24) then Result := 'LINE_STIPPLE' else
      if self.val = UInt32($0B25) then Result := 'LINE_STIPPLE_PATTERN' else
      if self.val = UInt32($0B26) then Result := 'LINE_STIPPLE_REPEAT' else
      if self.val = UInt32($0B30) then Result := 'LIST_MODE' else
      if self.val = UInt32($0B31) then Result := 'MAX_LIST_NESTING' else
      if self.val = UInt32($0B32) then Result := 'LIST_BASE' else
      if self.val = UInt32($0B33) then Result := 'LIST_INDEX' else
      if self.val = UInt32($0B40) then Result := 'POLYGON_MODE' else
      if self.val = UInt32($0B41) then Result := 'POLYGON_SMOOTH' else
      if self.val = UInt32($0B42) then Result := 'POLYGON_STIPPLE' else
      if self.val = UInt32($0B43) then Result := 'EDGE_FLAG' else
      if self.val = UInt32($0B44) then Result := 'CULL_FACE' else
      if self.val = UInt32($0B45) then Result := 'CULL_FACE_MODE' else
      if self.val = UInt32($0B46) then Result := 'FRONT_FACE' else
      if self.val = UInt32($0B50) then Result := 'LIGHTING' else
      if self.val = UInt32($0B51) then Result := 'LIGHT_MODEL_LOCAL_VIEWER' else
      if self.val = UInt32($0B52) then Result := 'LIGHT_MODEL_TWO_SIDE' else
      if self.val = UInt32($0B53) then Result := 'LIGHT_MODEL_AMBIENT' else
      if self.val = UInt32($0B54) then Result := 'SHADE_MODEL' else
      if self.val = UInt32($0B55) then Result := 'COLOR_MATERIAL_FACE' else
      if self.val = UInt32($0B56) then Result := 'COLOR_MATERIAL_PARAMETER' else
      if self.val = UInt32($0B57) then Result := 'COLOR_MATERIAL' else
      if self.val = UInt32($0B60) then Result := 'FOG' else
      if self.val = UInt32($0B61) then Result := 'FOG_INDEX' else
      if self.val = UInt32($0B62) then Result := 'FOG_DENSITY' else
      if self.val = UInt32($0B63) then Result := 'FOG_START' else
      if self.val = UInt32($0B64) then Result := 'FOG_END' else
      if self.val = UInt32($0B65) then Result := 'FOG_MODE' else
      if self.val = UInt32($0B66) then Result := 'FOG_COLOR' else
      if self.val = UInt32($0B70) then Result := 'DEPTH_RANGE' else
      if self.val = UInt32($0B71) then Result := 'DEPTH_TEST' else
      if self.val = UInt32($0B72) then Result := 'DEPTH_WRITEMASK' else
      if self.val = UInt32($0B73) then Result := 'DEPTH_CLEAR_VALUE' else
      if self.val = UInt32($0B74) then Result := 'DEPTH_FUNC' else
      if self.val = UInt32($0B80) then Result := 'ACCUM_CLEAR_VALUE' else
      if self.val = UInt32($0B90) then Result := 'STENCIL_TEST' else
      if self.val = UInt32($0B91) then Result := 'STENCIL_CLEAR_VALUE' else
      if self.val = UInt32($0B92) then Result := 'STENCIL_FUNC' else
      if self.val = UInt32($0B93) then Result := 'STENCIL_VALUE_MASK' else
      if self.val = UInt32($0B94) then Result := 'STENCIL_FAIL' else
      if self.val = UInt32($0B95) then Result := 'STENCIL_PASS_DEPTH_FAIL' else
      if self.val = UInt32($0B96) then Result := 'STENCIL_PASS_DEPTH_PASS' else
      if self.val = UInt32($0B97) then Result := 'STENCIL_REF' else
      if self.val = UInt32($0B98) then Result := 'STENCIL_WRITEMASK' else
      if self.val = UInt32($0BA0) then Result := 'MATRIX_MODE' else
      if self.val = UInt32($0BA1) then Result := 'NORMALIZE' else
      if self.val = UInt32($0BA2) then Result := 'VIEWPORT' else
      if self.val = UInt32($0BA3) then Result := 'MODELVIEW_STACK_DEPTH' else
      if self.val = UInt32($0BA3) then Result := 'MODELVIEW0_STACK_DEPTH_EXT' else
      if self.val = UInt32($0BA4) then Result := 'PROJECTION_STACK_DEPTH' else
      if self.val = UInt32($0BA5) then Result := 'TEXTURE_STACK_DEPTH' else
      if self.val = UInt32($0BA6) then Result := 'MODELVIEW_MATRIX' else
      if self.val = UInt32($0BA6) then Result := 'MODELVIEW0_MATRIX_EXT' else
      if self.val = UInt32($0BA7) then Result := 'PROJECTION_MATRIX' else
      if self.val = UInt32($0BA8) then Result := 'TEXTURE_MATRIX' else
      if self.val = UInt32($0BB0) then Result := 'ATTRIB_STACK_DEPTH' else
      if self.val = UInt32($0BB1) then Result := 'CLIENT_ATTRIB_STACK_DEPTH' else
      if self.val = UInt32($0BC0) then Result := 'ALPHA_TEST' else
      if self.val = UInt32($0BC0) then Result := 'ALPHA_TEST_QCOM' else
      if self.val = UInt32($0BC1) then Result := 'ALPHA_TEST_FUNC' else
      if self.val = UInt32($0BC1) then Result := 'ALPHA_TEST_FUNC_QCOM' else
      if self.val = UInt32($0BC2) then Result := 'ALPHA_TEST_REF' else
      if self.val = UInt32($0BC2) then Result := 'ALPHA_TEST_REF_QCOM' else
      if self.val = UInt32($0BD0) then Result := 'DITHER' else
      if self.val = UInt32($0BE0) then Result := 'BLEND_DST' else
      if self.val = UInt32($0BE1) then Result := 'BLEND_SRC' else
      if self.val = UInt32($0BE2) then Result := 'BLEND' else
      if self.val = UInt32($0BF0) then Result := 'LOGIC_OP_MODE' else
      if self.val = UInt32($0BF1) then Result := 'INDEX_LOGIC_OP' else
      if self.val = UInt32($0BF1) then Result := 'LOGIC_OP' else
      if self.val = UInt32($0BF2) then Result := 'COLOR_LOGIC_OP' else
      if self.val = UInt32($0C00) then Result := 'AUX_BUFFERS' else
      if self.val = UInt32($0C01) then Result := 'DRAW_BUFFER' else
      if self.val = UInt32($0C01) then Result := 'DRAW_BUFFER_EXT' else
      if self.val = UInt32($0C02) then Result := 'READ_BUFFER' else
      if self.val = UInt32($0C02) then Result := 'READ_BUFFER_EXT' else
      if self.val = UInt32($0C02) then Result := 'READ_BUFFER_NV' else
      if self.val = UInt32($0C10) then Result := 'SCISSOR_BOX' else
      if self.val = UInt32($0C11) then Result := 'SCISSOR_TEST' else
      if self.val = UInt32($0C20) then Result := 'INDEX_CLEAR_VALUE' else
      if self.val = UInt32($0C21) then Result := 'INDEX_WRITEMASK' else
      if self.val = UInt32($0C22) then Result := 'COLOR_CLEAR_VALUE' else
      if self.val = UInt32($0C23) then Result := 'COLOR_WRITEMASK' else
      if self.val = UInt32($0C30) then Result := 'INDEX_MODE' else
      if self.val = UInt32($0C31) then Result := 'RGBA_MODE' else
      if self.val = UInt32($0C32) then Result := 'DOUBLEBUFFER' else
      if self.val = UInt32($0C33) then Result := 'STEREO' else
      if self.val = UInt32($0C40) then Result := 'RENDER_MODE' else
      if self.val = UInt32($0C50) then Result := 'PERSPECTIVE_CORRECTION_HINT' else
      if self.val = UInt32($0C51) then Result := 'POINT_SMOOTH_HINT' else
      if self.val = UInt32($0C52) then Result := 'LINE_SMOOTH_HINT' else
      if self.val = UInt32($0C53) then Result := 'POLYGON_SMOOTH_HINT' else
      if self.val = UInt32($0C54) then Result := 'FOG_HINT' else
      if self.val = UInt32($0C60) then Result := 'TEXTURE_GEN_S' else
      if self.val = UInt32($0C61) then Result := 'TEXTURE_GEN_T' else
      if self.val = UInt32($0C62) then Result := 'TEXTURE_GEN_R' else
      if self.val = UInt32($0C63) then Result := 'TEXTURE_GEN_Q' else
      if self.val = UInt32($0CB0) then Result := 'PIXEL_MAP_I_TO_I_SIZE' else
      if self.val = UInt32($0CB1) then Result := 'PIXEL_MAP_S_TO_S_SIZE' else
      if self.val = UInt32($0CB2) then Result := 'PIXEL_MAP_I_TO_R_SIZE' else
      if self.val = UInt32($0CB3) then Result := 'PIXEL_MAP_I_TO_G_SIZE' else
      if self.val = UInt32($0CB4) then Result := 'PIXEL_MAP_I_TO_B_SIZE' else
      if self.val = UInt32($0CB5) then Result := 'PIXEL_MAP_I_TO_A_SIZE' else
      if self.val = UInt32($0CB6) then Result := 'PIXEL_MAP_R_TO_R_SIZE' else
      if self.val = UInt32($0CB7) then Result := 'PIXEL_MAP_G_TO_G_SIZE' else
      if self.val = UInt32($0CB8) then Result := 'PIXEL_MAP_B_TO_B_SIZE' else
      if self.val = UInt32($0CB9) then Result := 'PIXEL_MAP_A_TO_A_SIZE' else
      if self.val = UInt32($0CF0) then Result := 'UNPACK_SWAP_BYTES' else
      if self.val = UInt32($0CF1) then Result := 'UNPACK_LSB_FIRST' else
      if self.val = UInt32($0CF2) then Result := 'UNPACK_ROW_LENGTH' else
      if self.val = UInt32($0CF3) then Result := 'UNPACK_SKIP_ROWS' else
      if self.val = UInt32($0CF4) then Result := 'UNPACK_SKIP_PIXELS' else
      if self.val = UInt32($0CF5) then Result := 'UNPACK_ALIGNMENT' else
      if self.val = UInt32($0D00) then Result := 'PACK_SWAP_BYTES' else
      if self.val = UInt32($0D01) then Result := 'PACK_LSB_FIRST' else
      if self.val = UInt32($0D02) then Result := 'PACK_ROW_LENGTH' else
      if self.val = UInt32($0D03) then Result := 'PACK_SKIP_ROWS' else
      if self.val = UInt32($0D04) then Result := 'PACK_SKIP_PIXELS' else
      if self.val = UInt32($0D05) then Result := 'PACK_ALIGNMENT' else
      if self.val = UInt32($0D10) then Result := 'MAP_COLOR' else
      if self.val = UInt32($0D11) then Result := 'MAP_STENCIL' else
      if self.val = UInt32($0D12) then Result := 'INDEX_SHIFT' else
      if self.val = UInt32($0D13) then Result := 'INDEX_OFFSET' else
      if self.val = UInt32($0D14) then Result := 'RED_SCALE' else
      if self.val = UInt32($0D15) then Result := 'RED_BIAS' else
      if self.val = UInt32($0D16) then Result := 'ZOOM_X' else
      if self.val = UInt32($0D17) then Result := 'ZOOM_Y' else
      if self.val = UInt32($0D18) then Result := 'GREEN_SCALE' else
      if self.val = UInt32($0D19) then Result := 'GREEN_BIAS' else
      if self.val = UInt32($0D1A) then Result := 'BLUE_SCALE' else
      if self.val = UInt32($0D1B) then Result := 'BLUE_BIAS' else
      if self.val = UInt32($0D1C) then Result := 'ALPHA_SCALE' else
      if self.val = UInt32($0D1D) then Result := 'ALPHA_BIAS' else
      if self.val = UInt32($0D1E) then Result := 'DEPTH_SCALE' else
      if self.val = UInt32($0D1F) then Result := 'DEPTH_BIAS' else
      if self.val = UInt32($0D30) then Result := 'MAX_EVAL_ORDER' else
      if self.val = UInt32($0D31) then Result := 'MAX_LIGHTS' else
      if self.val = UInt32($0D32) then Result := 'MAX_CLIP_DISTANCES' else
      if self.val = UInt32($0D32) then Result := 'MAX_CLIP_PLANES' else
      if self.val = UInt32($0D33) then Result := 'MAX_TEXTURE_SIZE' else
      if self.val = UInt32($0D34) then Result := 'MAX_PIXEL_MAP_TABLE' else
      if self.val = UInt32($0D35) then Result := 'MAX_ATTRIB_STACK_DEPTH' else
      if self.val = UInt32($0D36) then Result := 'MAX_MODELVIEW_STACK_DEPTH' else
      if self.val = UInt32($0D37) then Result := 'MAX_NAME_STACK_DEPTH' else
      if self.val = UInt32($0D38) then Result := 'MAX_PROJECTION_STACK_DEPTH' else
      if self.val = UInt32($0D39) then Result := 'MAX_TEXTURE_STACK_DEPTH' else
      if self.val = UInt32($0D3A) then Result := 'MAX_VIEWPORT_DIMS' else
      if self.val = UInt32($0D3B) then Result := 'MAX_CLIENT_ATTRIB_STACK_DEPTH' else
      if self.val = UInt32($0D50) then Result := 'SUBPIXEL_BITS' else
      if self.val = UInt32($0D51) then Result := 'INDEX_BITS' else
      if self.val = UInt32($0D52) then Result := 'RED_BITS' else
      if self.val = UInt32($0D53) then Result := 'GREEN_BITS' else
      if self.val = UInt32($0D54) then Result := 'BLUE_BITS' else
      if self.val = UInt32($0D55) then Result := 'ALPHA_BITS' else
      if self.val = UInt32($0D56) then Result := 'DEPTH_BITS' else
      if self.val = UInt32($0D57) then Result := 'STENCIL_BITS' else
      if self.val = UInt32($0D58) then Result := 'ACCUM_RED_BITS' else
      if self.val = UInt32($0D59) then Result := 'ACCUM_GREEN_BITS' else
      if self.val = UInt32($0D5A) then Result := 'ACCUM_BLUE_BITS' else
      if self.val = UInt32($0D5B) then Result := 'ACCUM_ALPHA_BITS' else
      if self.val = UInt32($0D70) then Result := 'NAME_STACK_DEPTH' else
      if self.val = UInt32($0D80) then Result := 'AUTO_NORMAL' else
      if self.val = UInt32($0D90) then Result := 'MAP1_COLOR_4' else
      if self.val = UInt32($0D91) then Result := 'MAP1_INDEX' else
      if self.val = UInt32($0D92) then Result := 'MAP1_NORMAL' else
      if self.val = UInt32($0D93) then Result := 'MAP1_TEXTURE_COORD_1' else
      if self.val = UInt32($0D94) then Result := 'MAP1_TEXTURE_COORD_2' else
      if self.val = UInt32($0D95) then Result := 'MAP1_TEXTURE_COORD_3' else
      if self.val = UInt32($0D96) then Result := 'MAP1_TEXTURE_COORD_4' else
      if self.val = UInt32($0D97) then Result := 'MAP1_VERTEX_3' else
      if self.val = UInt32($0D98) then Result := 'MAP1_VERTEX_4' else
      if self.val = UInt32($0DB0) then Result := 'MAP2_COLOR_4' else
      if self.val = UInt32($0DB1) then Result := 'MAP2_INDEX' else
      if self.val = UInt32($0DB2) then Result := 'MAP2_NORMAL' else
      if self.val = UInt32($0DB3) then Result := 'MAP2_TEXTURE_COORD_1' else
      if self.val = UInt32($0DB4) then Result := 'MAP2_TEXTURE_COORD_2' else
      if self.val = UInt32($0DB5) then Result := 'MAP2_TEXTURE_COORD_3' else
      if self.val = UInt32($0DB6) then Result := 'MAP2_TEXTURE_COORD_4' else
      if self.val = UInt32($0DB7) then Result := 'MAP2_VERTEX_3' else
      if self.val = UInt32($0DB8) then Result := 'MAP2_VERTEX_4' else
      if self.val = UInt32($0DD0) then Result := 'MAP1_GRID_DOMAIN' else
      if self.val = UInt32($0DD1) then Result := 'MAP1_GRID_SEGMENTS' else
      if self.val = UInt32($0DD2) then Result := 'MAP2_GRID_DOMAIN' else
      if self.val = UInt32($0DD3) then Result := 'MAP2_GRID_SEGMENTS' else
      if self.val = UInt32($0DE0) then Result := 'TEXTURE_1D' else
      if self.val = UInt32($0DE1) then Result := 'TEXTURE_2D' else
      if self.val = UInt32($0DF1) then Result := 'FEEDBACK_BUFFER_SIZE' else
      if self.val = UInt32($0DF2) then Result := 'FEEDBACK_BUFFER_TYPE' else
      if self.val = UInt32($0DF4) then Result := 'SELECTION_BUFFER_SIZE' else
      if self.val = UInt32($2A00) then Result := 'POLYGON_OFFSET_UNITS' else
      if self.val = UInt32($2A01) then Result := 'POLYGON_OFFSET_POINT' else
      if self.val = UInt32($2A02) then Result := 'POLYGON_OFFSET_LINE' else
      if self.val = UInt32($3000) then Result := 'CLIP_PLANE0' else
      if self.val = UInt32($3001) then Result := 'CLIP_PLANE1' else
      if self.val = UInt32($3002) then Result := 'CLIP_PLANE2' else
      if self.val = UInt32($3003) then Result := 'CLIP_PLANE3' else
      if self.val = UInt32($3004) then Result := 'CLIP_PLANE4' else
      if self.val = UInt32($3005) then Result := 'CLIP_PLANE5' else
      if self.val = UInt32($4000) then Result := 'LIGHT0' else
      if self.val = UInt32($4001) then Result := 'LIGHT1' else
      if self.val = UInt32($4002) then Result := 'LIGHT2' else
      if self.val = UInt32($4003) then Result := 'LIGHT3' else
      if self.val = UInt32($4004) then Result := 'LIGHT4' else
      if self.val = UInt32($4005) then Result := 'LIGHT5' else
      if self.val = UInt32($4006) then Result := 'LIGHT6' else
      if self.val = UInt32($4007) then Result := 'LIGHT7' else
      if self.val = UInt32($8005) then Result := 'BLEND_COLOR' else
      if self.val = UInt32($8005) then Result := 'BLEND_COLOR_EXT' else
      if self.val = UInt32($8009) then Result := 'BLEND_EQUATION_EXT' else
      if self.val = UInt32($8009) then Result := 'BLEND_EQUATION_RGB' else
      if self.val = UInt32($800E) then Result := 'PACK_CMYK_HINT_EXT' else
      if self.val = UInt32($800F) then Result := 'UNPACK_CMYK_HINT_EXT' else
      if self.val = UInt32($8010) then Result := 'CONVOLUTION_1D_EXT' else
      if self.val = UInt32($8011) then Result := 'CONVOLUTION_2D_EXT' else
      if self.val = UInt32($8012) then Result := 'SEPARABLE_2D_EXT' else
      if self.val = UInt32($801C) then Result := 'POST_CONVOLUTION_RED_SCALE_EXT' else
      if self.val = UInt32($801D) then Result := 'POST_CONVOLUTION_GREEN_SCALE_EXT' else
      if self.val = UInt32($801E) then Result := 'POST_CONVOLUTION_BLUE_SCALE_EXT' else
      if self.val = UInt32($801F) then Result := 'POST_CONVOLUTION_ALPHA_SCALE_EXT' else
      if self.val = UInt32($8020) then Result := 'POST_CONVOLUTION_RED_BIAS_EXT' else
      if self.val = UInt32($8021) then Result := 'POST_CONVOLUTION_GREEN_BIAS_EXT' else
      if self.val = UInt32($8022) then Result := 'POST_CONVOLUTION_BLUE_BIAS_EXT' else
      if self.val = UInt32($8023) then Result := 'POST_CONVOLUTION_ALPHA_BIAS_EXT' else
      if self.val = UInt32($8024) then Result := 'HISTOGRAM_EXT' else
      if self.val = UInt32($802E) then Result := 'MINMAX_EXT' else
      if self.val = UInt32($8037) then Result := 'POLYGON_OFFSET_FILL' else
      if self.val = UInt32($8038) then Result := 'POLYGON_OFFSET_FACTOR' else
      if self.val = UInt32($8039) then Result := 'POLYGON_OFFSET_BIAS_EXT' else
      if self.val = UInt32($803A) then Result := 'RESCALE_NORMAL_EXT' else
      if self.val = UInt32($8068) then Result := 'TEXTURE_BINDING_1D' else
      if self.val = UInt32($8069) then Result := 'TEXTURE_BINDING_2D' else
      if self.val = UInt32($806A) then Result := 'TEXTURE_3D_BINDING_EXT' else
      if self.val = UInt32($806A) then Result := 'TEXTURE_BINDING_3D' else
      if self.val = UInt32($806B) then Result := 'PACK_SKIP_IMAGES' else
      if self.val = UInt32($806B) then Result := 'PACK_SKIP_IMAGES_EXT' else
      if self.val = UInt32($806C) then Result := 'PACK_IMAGE_HEIGHT' else
      if self.val = UInt32($806C) then Result := 'PACK_IMAGE_HEIGHT_EXT' else
      if self.val = UInt32($806D) then Result := 'UNPACK_SKIP_IMAGES' else
      if self.val = UInt32($806D) then Result := 'UNPACK_SKIP_IMAGES_EXT' else
      if self.val = UInt32($806E) then Result := 'UNPACK_IMAGE_HEIGHT' else
      if self.val = UInt32($806E) then Result := 'UNPACK_IMAGE_HEIGHT_EXT' else
      if self.val = UInt32($806F) then Result := 'TEXTURE_3D_EXT' else
      if self.val = UInt32($8073) then Result := 'MAX_3D_TEXTURE_SIZE' else
      if self.val = UInt32($8073) then Result := 'MAX_3D_TEXTURE_SIZE_EXT' else
      if self.val = UInt32($8074) then Result := 'VERTEX_ARRAY' else
      if self.val = UInt32($8075) then Result := 'NORMAL_ARRAY' else
      if self.val = UInt32($8076) then Result := 'COLOR_ARRAY' else
      if self.val = UInt32($8077) then Result := 'INDEX_ARRAY' else
      if self.val = UInt32($8078) then Result := 'TEXTURE_COORD_ARRAY' else
      if self.val = UInt32($8079) then Result := 'EDGE_FLAG_ARRAY' else
      if self.val = UInt32($807A) then Result := 'VERTEX_ARRAY_SIZE' else
      if self.val = UInt32($807B) then Result := 'VERTEX_ARRAY_TYPE' else
      if self.val = UInt32($807C) then Result := 'VERTEX_ARRAY_STRIDE' else
      if self.val = UInt32($807D) then Result := 'VERTEX_ARRAY_COUNT_EXT' else
      if self.val = UInt32($807E) then Result := 'NORMAL_ARRAY_TYPE' else
      if self.val = UInt32($807F) then Result := 'NORMAL_ARRAY_STRIDE' else
      if self.val = UInt32($8080) then Result := 'NORMAL_ARRAY_COUNT_EXT' else
      if self.val = UInt32($8081) then Result := 'COLOR_ARRAY_SIZE' else
      if self.val = UInt32($8082) then Result := 'COLOR_ARRAY_TYPE' else
      if self.val = UInt32($8083) then Result := 'COLOR_ARRAY_STRIDE' else
      if self.val = UInt32($8084) then Result := 'COLOR_ARRAY_COUNT_EXT' else
      if self.val = UInt32($8085) then Result := 'INDEX_ARRAY_TYPE' else
      if self.val = UInt32($8086) then Result := 'INDEX_ARRAY_STRIDE' else
      if self.val = UInt32($8087) then Result := 'INDEX_ARRAY_COUNT_EXT' else
      if self.val = UInt32($8088) then Result := 'TEXTURE_COORD_ARRAY_SIZE' else
      if self.val = UInt32($8089) then Result := 'TEXTURE_COORD_ARRAY_TYPE' else
      if self.val = UInt32($808A) then Result := 'TEXTURE_COORD_ARRAY_STRIDE' else
      if self.val = UInt32($808B) then Result := 'TEXTURE_COORD_ARRAY_COUNT_EXT' else
      if self.val = UInt32($808C) then Result := 'EDGE_FLAG_ARRAY_STRIDE' else
      if self.val = UInt32($808D) then Result := 'EDGE_FLAG_ARRAY_COUNT_EXT' else
      if self.val = UInt32($8094) then Result := 'INTERLACE_SGIX' else
      if self.val = UInt32($8096) then Result := 'DETAIL_TEXTURE_2D_BINDING_SGIS' else
      if self.val = UInt32($809D) then Result := 'MULTISAMPLE_SGIS' else
      if self.val = UInt32($809E) then Result := 'SAMPLE_ALPHA_TO_MASK_SGIS' else
      if self.val = UInt32($809F) then Result := 'SAMPLE_ALPHA_TO_ONE_SGIS' else
      if self.val = UInt32($80A0) then Result := 'SAMPLE_MASK_SGIS' else
      if self.val = UInt32($80A8) then Result := 'SAMPLE_BUFFERS' else
      if self.val = UInt32($80A8) then Result := 'SAMPLE_BUFFERS_SGIS' else
      if self.val = UInt32($80A9) then Result := 'SAMPLES' else
      if self.val = UInt32($80A9) then Result := 'SAMPLES_SGIS' else
      if self.val = UInt32($80AA) then Result := 'SAMPLE_COVERAGE_VALUE' else
      if self.val = UInt32($80AA) then Result := 'SAMPLE_MASK_VALUE_SGIS' else
      if self.val = UInt32($80AB) then Result := 'SAMPLE_COVERAGE_INVERT' else
      if self.val = UInt32($80AB) then Result := 'SAMPLE_MASK_INVERT_SGIS' else
      if self.val = UInt32($80AC) then Result := 'SAMPLE_PATTERN_SGIS' else
      if self.val = UInt32($80B1) then Result := 'COLOR_MATRIX_SGI' else
      if self.val = UInt32($80B2) then Result := 'COLOR_MATRIX_STACK_DEPTH_SGI' else
      if self.val = UInt32($80B3) then Result := 'MAX_COLOR_MATRIX_STACK_DEPTH_SGI' else
      if self.val = UInt32($80B4) then Result := 'POST_COLOR_MATRIX_RED_SCALE_SGI' else
      if self.val = UInt32($80B5) then Result := 'POST_COLOR_MATRIX_GREEN_SCALE_SGI' else
      if self.val = UInt32($80B6) then Result := 'POST_COLOR_MATRIX_BLUE_SCALE_SGI' else
      if self.val = UInt32($80B7) then Result := 'POST_COLOR_MATRIX_ALPHA_SCALE_SGI' else
      if self.val = UInt32($80B8) then Result := 'POST_COLOR_MATRIX_RED_BIAS_SGI' else
      if self.val = UInt32($80B9) then Result := 'POST_COLOR_MATRIX_GREEN_BIAS_SGI' else
      if self.val = UInt32($80BA) then Result := 'POST_COLOR_MATRIX_BLUE_BIAS_SGI' else
      if self.val = UInt32($80BB) then Result := 'POST_COLOR_MATRIX_ALPHA_BIAS_SGI' else
      if self.val = UInt32($80BC) then Result := 'TEXTURE_COLOR_TABLE_SGI' else
      if self.val = UInt32($80C8) then Result := 'BLEND_DST_RGB' else
      if self.val = UInt32($80C9) then Result := 'BLEND_SRC_RGB' else
      if self.val = UInt32($80CA) then Result := 'BLEND_DST_ALPHA' else
      if self.val = UInt32($80CB) then Result := 'BLEND_SRC_ALPHA' else
      if self.val = UInt32($80D0) then Result := 'COLOR_TABLE_SGI' else
      if self.val = UInt32($80D1) then Result := 'POST_CONVOLUTION_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D2) then Result := 'POST_COLOR_MATRIX_COLOR_TABLE_SGI' else
      if self.val = UInt32($80E8) then Result := 'MAX_ELEMENTS_VERTICES' else
      if self.val = UInt32($80E9) then Result := 'MAX_ELEMENTS_INDICES' else
      if self.val = UInt32($8126) then Result := 'POINT_SIZE_MIN_SGIS' else
      if self.val = UInt32($8127) then Result := 'POINT_SIZE_MAX_SGIS' else
      if self.val = UInt32($8128) then Result := 'POINT_FADE_THRESHOLD_SIZE' else
      if self.val = UInt32($8128) then Result := 'POINT_FADE_THRESHOLD_SIZE_SGIS' else
      if self.val = UInt32($8129) then Result := 'DISTANCE_ATTENUATION_SGIS' else
      if self.val = UInt32($812B) then Result := 'FOG_FUNC_POINTS_SGIS' else
      if self.val = UInt32($812C) then Result := 'MAX_FOG_FUNC_POINTS_SGIS' else
      if self.val = UInt32($8130) then Result := 'PACK_SKIP_VOLUMES_SGIS' else
      if self.val = UInt32($8131) then Result := 'PACK_IMAGE_DEPTH_SGIS' else
      if self.val = UInt32($8132) then Result := 'UNPACK_SKIP_VOLUMES_SGIS' else
      if self.val = UInt32($8133) then Result := 'UNPACK_IMAGE_DEPTH_SGIS' else
      if self.val = UInt32($8134) then Result := 'TEXTURE_4D_SGIS' else
      if self.val = UInt32($8138) then Result := 'MAX_4D_TEXTURE_SIZE_SGIS' else
      if self.val = UInt32($8139) then Result := 'PIXEL_TEX_GEN_SGIX' else
      if self.val = UInt32($813E) then Result := 'PIXEL_TILE_BEST_ALIGNMENT_SGIX' else
      if self.val = UInt32($813F) then Result := 'PIXEL_TILE_CACHE_INCREMENT_SGIX' else
      if self.val = UInt32($8140) then Result := 'PIXEL_TILE_WIDTH_SGIX' else
      if self.val = UInt32($8141) then Result := 'PIXEL_TILE_HEIGHT_SGIX' else
      if self.val = UInt32($8142) then Result := 'PIXEL_TILE_GRID_WIDTH_SGIX' else
      if self.val = UInt32($8143) then Result := 'PIXEL_TILE_GRID_HEIGHT_SGIX' else
      if self.val = UInt32($8144) then Result := 'PIXEL_TILE_GRID_DEPTH_SGIX' else
      if self.val = UInt32($8145) then Result := 'PIXEL_TILE_CACHE_SIZE_SGIX' else
      if self.val = UInt32($8148) then Result := 'SPRITE_SGIX' else
      if self.val = UInt32($8149) then Result := 'SPRITE_MODE_SGIX' else
      if self.val = UInt32($814A) then Result := 'SPRITE_AXIS_SGIX' else
      if self.val = UInt32($814B) then Result := 'SPRITE_TRANSLATION_SGIX' else
      if self.val = UInt32($814F) then Result := 'TEXTURE_4D_BINDING_SGIS' else
      if self.val = UInt32($8177) then Result := 'MAX_CLIPMAP_DEPTH_SGIX' else
      if self.val = UInt32($8178) then Result := 'MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX' else
      if self.val = UInt32($817B) then Result := 'POST_TEXTURE_FILTER_BIAS_RANGE_SGIX' else
      if self.val = UInt32($817C) then Result := 'POST_TEXTURE_FILTER_SCALE_RANGE_SGIX' else
      if self.val = UInt32($817D) then Result := 'REFERENCE_PLANE_SGIX' else
      if self.val = UInt32($817E) then Result := 'REFERENCE_PLANE_EQUATION_SGIX' else
      if self.val = UInt32($817F) then Result := 'IR_INSTRUMENT1_SGIX' else
      if self.val = UInt32($8181) then Result := 'INSTRUMENT_MEASUREMENTS_SGIX' else
      if self.val = UInt32($8183) then Result := 'CALLIGRAPHIC_FRAGMENT_SGIX' else
      if self.val = UInt32($818B) then Result := 'FRAMEZOOM_SGIX' else
      if self.val = UInt32($818C) then Result := 'FRAMEZOOM_FACTOR_SGIX' else
      if self.val = UInt32($818D) then Result := 'MAX_FRAMEZOOM_FACTOR_SGIX' else
      if self.val = UInt32($8192) then Result := 'GENERATE_MIPMAP_HINT_SGIS' else
      if self.val = UInt32($8196) then Result := 'DEFORMATIONS_MASK_SGIX' else
      if self.val = UInt32($8198) then Result := 'FOG_OFFSET_SGIX' else
      if self.val = UInt32($8199) then Result := 'FOG_OFFSET_VALUE_SGIX' else
      if self.val = UInt32($81F8) then Result := 'LIGHT_MODEL_COLOR_CONTROL' else
      if self.val = UInt32($81FB) then Result := 'SHARED_TEXTURE_PALETTE_EXT' else
      if self.val = UInt32($821B) then Result := 'MAJOR_VERSION' else
      if self.val = UInt32($821C) then Result := 'MINOR_VERSION' else
      if self.val = UInt32($821D) then Result := 'NUM_EXTENSIONS' else
      if self.val = UInt32($821E) then Result := 'CONTEXT_FLAGS' else
      if self.val = UInt32($825A) then Result := 'PROGRAM_PIPELINE_BINDING' else
      if self.val = UInt32($825B) then Result := 'MAX_VIEWPORTS' else
      if self.val = UInt32($825C) then Result := 'VIEWPORT_SUBPIXEL_BITS' else
      if self.val = UInt32($825D) then Result := 'VIEWPORT_BOUNDS_RANGE' else
      if self.val = UInt32($825E) then Result := 'LAYER_PROVOKING_VERTEX' else
      if self.val = UInt32($825F) then Result := 'VIEWPORT_INDEX_PROVOKING_VERTEX' else
      if self.val = UInt32($8263) then Result := 'MAX_COMPUTE_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8264) then Result := 'MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS' else
      if self.val = UInt32($8265) then Result := 'MAX_COMPUTE_ATOMIC_COUNTERS' else
      if self.val = UInt32($8266) then Result := 'MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS' else
      if self.val = UInt32($826C) then Result := 'MAX_DEBUG_GROUP_STACK_DEPTH' else
      if self.val = UInt32($826D) then Result := 'DEBUG_GROUP_STACK_DEPTH' else
      if self.val = UInt32($826E) then Result := 'MAX_UNIFORM_LOCATIONS' else
      if self.val = UInt32($82D6) then Result := 'VERTEX_BINDING_DIVISOR' else
      if self.val = UInt32($82D7) then Result := 'VERTEX_BINDING_OFFSET' else
      if self.val = UInt32($82D8) then Result := 'VERTEX_BINDING_STRIDE' else
      if self.val = UInt32($82D9) then Result := 'MAX_VERTEX_ATTRIB_RELATIVE_OFFSET' else
      if self.val = UInt32($82DA) then Result := 'MAX_VERTEX_ATTRIB_BINDINGS' else
      if self.val = UInt32($82E8) then Result := 'MAX_LABEL_LENGTH' else
      if self.val = UInt32($8316) then Result := 'CONVOLUTION_HINT_SGIX' else
      if self.val = UInt32($8329) then Result := 'ASYNC_MARKER_SGIX' else
      if self.val = UInt32($832B) then Result := 'PIXEL_TEX_GEN_MODE_SGIX' else
      if self.val = UInt32($832C) then Result := 'ASYNC_HISTOGRAM_SGIX' else
      if self.val = UInt32($832D) then Result := 'MAX_ASYNC_HISTOGRAM_SGIX' else
      if self.val = UInt32($8353) then Result := 'PIXEL_TEXTURE_SGIS' else
      if self.val = UInt32($835C) then Result := 'ASYNC_TEX_IMAGE_SGIX' else
      if self.val = UInt32($835D) then Result := 'ASYNC_DRAW_PIXELS_SGIX' else
      if self.val = UInt32($835E) then Result := 'ASYNC_READ_PIXELS_SGIX' else
      if self.val = UInt32($835F) then Result := 'MAX_ASYNC_TEX_IMAGE_SGIX' else
      if self.val = UInt32($8360) then Result := 'MAX_ASYNC_DRAW_PIXELS_SGIX' else
      if self.val = UInt32($8361) then Result := 'MAX_ASYNC_READ_PIXELS_SGIX' else
      if self.val = UInt32($83EE) then Result := 'VERTEX_PRECLIP_SGIX' else
      if self.val = UInt32($83EF) then Result := 'VERTEX_PRECLIP_HINT_SGIX' else
      if self.val = UInt32($8400) then Result := 'FRAGMENT_LIGHTING_SGIX' else
      if self.val = UInt32($8401) then Result := 'FRAGMENT_COLOR_MATERIAL_SGIX' else
      if self.val = UInt32($8402) then Result := 'FRAGMENT_COLOR_MATERIAL_FACE_SGIX' else
      if self.val = UInt32($8403) then Result := 'FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX' else
      if self.val = UInt32($8404) then Result := 'MAX_FRAGMENT_LIGHTS_SGIX' else
      if self.val = UInt32($8405) then Result := 'MAX_ACTIVE_LIGHTS_SGIX' else
      if self.val = UInt32($8407) then Result := 'LIGHT_ENV_MODE_SGIX' else
      if self.val = UInt32($8408) then Result := 'FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX' else
      if self.val = UInt32($8409) then Result := 'FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX' else
      if self.val = UInt32($840A) then Result := 'FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX' else
      if self.val = UInt32($840B) then Result := 'FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX' else
      if self.val = UInt32($840C) then Result := 'FRAGMENT_LIGHT0_SGIX' else
      if self.val = UInt32($842E) then Result := 'PACK_RESAMPLE_SGIX' else
      if self.val = UInt32($842F) then Result := 'UNPACK_RESAMPLE_SGIX' else
      if self.val = UInt32($846D) then Result := 'ALIASED_POINT_SIZE_RANGE' else
      if self.val = UInt32($846E) then Result := 'ALIASED_LINE_WIDTH_RANGE' else
      if self.val = UInt32($84E0) then Result := 'ACTIVE_TEXTURE' else
      if self.val = UInt32($84E8) then Result := 'MAX_RENDERBUFFER_SIZE' else
      if self.val = UInt32($84EF) then Result := 'TEXTURE_COMPRESSION_HINT' else
      if self.val = UInt32($84F6) then Result := 'TEXTURE_BINDING_RECTANGLE' else
      if self.val = UInt32($84F6) then Result := 'TEXTURE_BINDING_RECTANGLE_ARB' else
      if self.val = UInt32($84F6) then Result := 'TEXTURE_BINDING_RECTANGLE_NV' else
      if self.val = UInt32($84F8) then Result := 'MAX_RECTANGLE_TEXTURE_SIZE' else
      if self.val = UInt32($84FD) then Result := 'MAX_TEXTURE_LOD_BIAS' else
      if self.val = UInt32($8514) then Result := 'TEXTURE_BINDING_CUBE_MAP' else
      if self.val = UInt32($8514) then Result := 'TEXTURE_BINDING_CUBE_MAP_ARB' else
      if self.val = UInt32($8514) then Result := 'TEXTURE_BINDING_CUBE_MAP_EXT' else
      if self.val = UInt32($8514) then Result := 'TEXTURE_BINDING_CUBE_MAP_OES' else
      if self.val = UInt32($851C) then Result := 'MAX_CUBE_MAP_TEXTURE_SIZE' else
      if self.val = UInt32($85A0) then Result := 'PACK_SUBSAMPLE_RATE_SGIX' else
      if self.val = UInt32($85A1) then Result := 'UNPACK_SUBSAMPLE_RATE_SGIX' else
      if self.val = UInt32($85B5) then Result := 'VERTEX_ARRAY_BINDING' else
      if self.val = UInt32($8642) then Result := 'PROGRAM_POINT_SIZE' else
      if self.val = UInt32($86A2) then Result := 'NUM_COMPRESSED_TEXTURE_FORMATS' else
      if self.val = UInt32($86A3) then Result := 'COMPRESSED_TEXTURE_FORMATS' else
      if self.val = UInt32($87FE) then Result := 'NUM_PROGRAM_BINARY_FORMATS' else
      if self.val = UInt32($87FF) then Result := 'PROGRAM_BINARY_FORMATS' else
      if self.val = UInt32($8800) then Result := 'STENCIL_BACK_FUNC' else
      if self.val = UInt32($8801) then Result := 'STENCIL_BACK_FAIL' else
      if self.val = UInt32($8802) then Result := 'STENCIL_BACK_PASS_DEPTH_FAIL' else
      if self.val = UInt32($8803) then Result := 'STENCIL_BACK_PASS_DEPTH_PASS' else
      if self.val = UInt32($8824) then Result := 'MAX_DRAW_BUFFERS' else
      if self.val = UInt32($883D) then Result := 'BLEND_EQUATION_ALPHA' else
      if self.val = UInt32($8869) then Result := 'MAX_VERTEX_ATTRIBS' else
      if self.val = UInt32($8872) then Result := 'MAX_TEXTURE_IMAGE_UNITS' else
      if self.val = UInt32($8894) then Result := 'ARRAY_BUFFER_BINDING' else
      if self.val = UInt32($8895) then Result := 'ELEMENT_ARRAY_BUFFER_BINDING' else
      if self.val = UInt32($88ED) then Result := 'PIXEL_PACK_BUFFER_BINDING' else
      if self.val = UInt32($88EF) then Result := 'PIXEL_UNPACK_BUFFER_BINDING' else
      if self.val = UInt32($88FC) then Result := 'MAX_DUAL_SOURCE_DRAW_BUFFERS' else
      if self.val = UInt32($88FF) then Result := 'MAX_ARRAY_TEXTURE_LAYERS' else
      if self.val = UInt32($8904) then Result := 'MIN_PROGRAM_TEXEL_OFFSET' else
      if self.val = UInt32($8905) then Result := 'MAX_PROGRAM_TEXEL_OFFSET' else
      if self.val = UInt32($8919) then Result := 'SAMPLER_BINDING' else
      if self.val = UInt32($8A28) then Result := 'UNIFORM_BUFFER_BINDING' else
      if self.val = UInt32($8A29) then Result := 'UNIFORM_BUFFER_START' else
      if self.val = UInt32($8A2A) then Result := 'UNIFORM_BUFFER_SIZE' else
      if self.val = UInt32($8A2B) then Result := 'MAX_VERTEX_UNIFORM_BLOCKS' else
      if self.val = UInt32($8A2C) then Result := 'MAX_GEOMETRY_UNIFORM_BLOCKS' else
      if self.val = UInt32($8A2D) then Result := 'MAX_FRAGMENT_UNIFORM_BLOCKS' else
      if self.val = UInt32($8A2E) then Result := 'MAX_COMBINED_UNIFORM_BLOCKS' else
      if self.val = UInt32($8A2F) then Result := 'MAX_UNIFORM_BUFFER_BINDINGS' else
      if self.val = UInt32($8A30) then Result := 'MAX_UNIFORM_BLOCK_SIZE' else
      if self.val = UInt32($8A31) then Result := 'MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8A32) then Result := 'MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8A33) then Result := 'MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8A34) then Result := 'UNIFORM_BUFFER_OFFSET_ALIGNMENT' else
      if self.val = UInt32($8B49) then Result := 'MAX_FRAGMENT_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8B4A) then Result := 'MAX_VERTEX_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8B4B) then Result := 'MAX_VARYING_COMPONENTS' else
      if self.val = UInt32($8B4B) then Result := 'MAX_VARYING_FLOATS' else
      if self.val = UInt32($8B4C) then Result := 'MAX_VERTEX_TEXTURE_IMAGE_UNITS' else
      if self.val = UInt32($8B4D) then Result := 'MAX_COMBINED_TEXTURE_IMAGE_UNITS' else
      if self.val = UInt32($8B8B) then Result := 'FRAGMENT_SHADER_DERIVATIVE_HINT' else
      if self.val = UInt32($8B8D) then Result := 'CURRENT_PROGRAM' else
      if self.val = UInt32($8B9A) then Result := 'IMPLEMENTATION_COLOR_READ_TYPE' else
      if self.val = UInt32($8B9B) then Result := 'IMPLEMENTATION_COLOR_READ_FORMAT' else
      if self.val = UInt32($8C1C) then Result := 'TEXTURE_BINDING_1D_ARRAY' else
      if self.val = UInt32($8C1D) then Result := 'TEXTURE_BINDING_2D_ARRAY' else
      if self.val = UInt32($8C29) then Result := 'MAX_GEOMETRY_TEXTURE_IMAGE_UNITS' else
      if self.val = UInt32($8C2B) then Result := 'MAX_TEXTURE_BUFFER_SIZE' else
      if self.val = UInt32($8C2C) then Result := 'TEXTURE_BINDING_BUFFER' else
      if self.val = UInt32($8C84) then Result := 'TRANSFORM_FEEDBACK_BUFFER_START' else
      if self.val = UInt32($8C85) then Result := 'TRANSFORM_FEEDBACK_BUFFER_SIZE' else
      if self.val = UInt32($8C8F) then Result := 'TRANSFORM_FEEDBACK_BUFFER_BINDING' else
      if self.val = UInt32($8C90) then Result := 'MOTION_ESTIMATION_SEARCH_BLOCK_X_QCOM' else
      if self.val = UInt32($8C91) then Result := 'MOTION_ESTIMATION_SEARCH_BLOCK_Y_QCOM' else
      if self.val = UInt32($8CA3) then Result := 'STENCIL_BACK_REF' else
      if self.val = UInt32($8CA4) then Result := 'STENCIL_BACK_VALUE_MASK' else
      if self.val = UInt32($8CA5) then Result := 'STENCIL_BACK_WRITEMASK' else
      if self.val = UInt32($8CA6) then Result := 'DRAW_FRAMEBUFFER_BINDING' else
      if self.val = UInt32($8CA7) then Result := 'RENDERBUFFER_BINDING' else
      if self.val = UInt32($8CAA) then Result := 'READ_FRAMEBUFFER_BINDING' else
      if self.val = UInt32($8CDF) then Result := 'MAX_COLOR_ATTACHMENTS' else
      if self.val = UInt32($8CDF) then Result := 'MAX_COLOR_ATTACHMENTS_EXT' else
      if self.val = UInt32($8CDF) then Result := 'MAX_COLOR_ATTACHMENTS_NV' else
      if self.val = UInt32($8D6B) then Result := 'MAX_ELEMENT_INDEX' else
      if self.val = UInt32($8DDF) then Result := 'MAX_GEOMETRY_UNIFORM_COMPONENTS' else
      if self.val = UInt32($8DF8) then Result := 'SHADER_BINARY_FORMATS' else
      if self.val = UInt32($8DF9) then Result := 'NUM_SHADER_BINARY_FORMATS' else
      if self.val = UInt32($8DFA) then Result := 'SHADER_COMPILER' else
      if self.val = UInt32($8DFB) then Result := 'MAX_VERTEX_UNIFORM_VECTORS' else
      if self.val = UInt32($8DFC) then Result := 'MAX_VARYING_VECTORS' else
      if self.val = UInt32($8DFD) then Result := 'MAX_FRAGMENT_UNIFORM_VECTORS' else
      if self.val = UInt32($8E28) then Result := 'TIMESTAMP' else
      if self.val = UInt32($8E4F) then Result := 'PROVOKING_VERTEX' else
      if self.val = UInt32($8E59) then Result := 'MAX_SAMPLE_MASK_WORDS' else
      if self.val = UInt32($8E89) then Result := 'MAX_TESS_CONTROL_UNIFORM_BLOCKS' else
      if self.val = UInt32($8E8A) then Result := 'MAX_TESS_EVALUATION_UNIFORM_BLOCKS' else
      if self.val = UInt32($8F65) then Result := 'FETCH_PER_SAMPLE_ARM' else
      if self.val = UInt32($8F66) then Result := 'FRAGMENT_SHADER_FRAMEBUFFER_FETCH_MRT_ARM' else
      if self.val = UInt32($8F9E) then Result := 'PRIMITIVE_RESTART_INDEX' else
      if self.val = UInt32($90BC) then Result := 'MIN_MAP_BUFFER_ALIGNMENT' else
      if self.val = UInt32($90D3) then Result := 'SHADER_STORAGE_BUFFER_BINDING' else
      if self.val = UInt32($90D4) then Result := 'SHADER_STORAGE_BUFFER_START' else
      if self.val = UInt32($90D5) then Result := 'SHADER_STORAGE_BUFFER_SIZE' else
      if self.val = UInt32($90D6) then Result := 'MAX_VERTEX_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90D7) then Result := 'MAX_GEOMETRY_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90D8) then Result := 'MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90D9) then Result := 'MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90DA) then Result := 'MAX_FRAGMENT_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90DB) then Result := 'MAX_COMPUTE_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90DC) then Result := 'MAX_COMBINED_SHADER_STORAGE_BLOCKS' else
      if self.val = UInt32($90DD) then Result := 'MAX_SHADER_STORAGE_BUFFER_BINDINGS' else
      if self.val = UInt32($90DF) then Result := 'SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT' else
      if self.val = UInt32($90EB) then Result := 'MAX_COMPUTE_WORK_GROUP_INVOCATIONS' else
      if self.val = UInt32($90EF) then Result := 'DISPATCH_INDIRECT_BUFFER_BINDING' else
      if self.val = UInt32($9104) then Result := 'TEXTURE_BINDING_2D_MULTISAMPLE' else
      if self.val = UInt32($9105) then Result := 'TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($910E) then Result := 'MAX_COLOR_TEXTURE_SAMPLES' else
      if self.val = UInt32($910F) then Result := 'MAX_DEPTH_TEXTURE_SAMPLES' else
      if self.val = UInt32($9110) then Result := 'MAX_INTEGER_SAMPLES' else
      if self.val = UInt32($9111) then Result := 'MAX_SERVER_WAIT_TIMEOUT' else
      if self.val = UInt32($9122) then Result := 'MAX_VERTEX_OUTPUT_COMPONENTS' else
      if self.val = UInt32($9123) then Result := 'MAX_GEOMETRY_INPUT_COMPONENTS' else
      if self.val = UInt32($9124) then Result := 'MAX_GEOMETRY_OUTPUT_COMPONENTS' else
      if self.val = UInt32($9125) then Result := 'MAX_FRAGMENT_INPUT_COMPONENTS' else
      if self.val = UInt32($9126) then Result := 'CONTEXT_PROFILE_MASK' else
      if self.val = UInt32($919F) then Result := 'TEXTURE_BUFFER_OFFSET_ALIGNMENT' else
      if self.val = UInt32($91BB) then Result := 'MAX_COMPUTE_UNIFORM_BLOCKS' else
      if self.val = UInt32($91BC) then Result := 'MAX_COMPUTE_TEXTURE_IMAGE_UNITS' else
      if self.val = UInt32($91BE) then Result := 'MAX_COMPUTE_WORK_GROUP_COUNT' else
      if self.val = UInt32($91BF) then Result := 'MAX_COMPUTE_WORK_GROUP_SIZE' else
      if self.val = UInt32($92D2) then Result := 'MAX_VERTEX_ATOMIC_COUNTERS' else
      if self.val = UInt32($92D3) then Result := 'MAX_TESS_CONTROL_ATOMIC_COUNTERS' else
      if self.val = UInt32($92D4) then Result := 'MAX_TESS_EVALUATION_ATOMIC_COUNTERS' else
      if self.val = UInt32($92D5) then Result := 'MAX_GEOMETRY_ATOMIC_COUNTERS' else
      if self.val = UInt32($92D6) then Result := 'MAX_FRAGMENT_ATOMIC_COUNTERS' else
      if self.val = UInt32($92D7) then Result := 'MAX_COMBINED_ATOMIC_COUNTERS' else
      if self.val = UInt32($9315) then Result := 'MAX_FRAMEBUFFER_WIDTH' else
      if self.val = UInt32($9316) then Result := 'MAX_FRAMEBUFFER_HEIGHT' else
      if self.val = UInt32($9317) then Result := 'MAX_FRAMEBUFFER_LAYERS' else
      if self.val = UInt32($9318) then Result := 'MAX_FRAMEBUFFER_SAMPLES' else
      if self.val = UInt32($9596) then Result := 'NUM_DEVICE_UUIDS_EXT' else
      if self.val = UInt32($9597) then Result := 'DEVICE_UUID_EXT' else
      if self.val = UInt32($9598) then Result := 'DRIVER_UUID_EXT' else
      if self.val = UInt32($9599) then Result := 'DEVICE_LUID_EXT' else
      if self.val = UInt32($959A) then Result := 'DEVICE_NODE_MASK_EXT' else
      if self.val = UInt32($95B1) then Result := 'SHADING_RATE_IMAGE_PER_PRIMITIVE_NV' else
      if self.val = UInt32($95B2) then Result := 'SHADING_RATE_IMAGE_PALETTE_COUNT_NV' else
      if self.val = UInt32($95B6) then Result := 'MAX_TIMELINE_SEMAPHORE_VALUE_DIFFERENCE_NV' else
      if self.val = UInt32($96A4) then Result := 'SHADING_RATE_QCOM' else
        Result := $'GetPName[{self.val}]';
    end;
    
  end;
  
  GetPointervPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FEEDBACK_BUFFER_POINTER:         GetPointervPName read new GetPointervPName($0DF0);
    public static property SELECTION_BUFFER_POINTER:        GetPointervPName read new GetPointervPName($0DF3);
    public static property VERTEX_ARRAY_POINTER:            GetPointervPName read new GetPointervPName($808E);
    public static property VERTEX_ARRAY_POINTER_EXT:        GetPointervPName read new GetPointervPName($808E);
    public static property NORMAL_ARRAY_POINTER:            GetPointervPName read new GetPointervPName($808F);
    public static property NORMAL_ARRAY_POINTER_EXT:        GetPointervPName read new GetPointervPName($808F);
    public static property COLOR_ARRAY_POINTER:             GetPointervPName read new GetPointervPName($8090);
    public static property COLOR_ARRAY_POINTER_EXT:         GetPointervPName read new GetPointervPName($8090);
    public static property INDEX_ARRAY_POINTER:             GetPointervPName read new GetPointervPName($8091);
    public static property INDEX_ARRAY_POINTER_EXT:         GetPointervPName read new GetPointervPName($8091);
    public static property TEXTURE_COORD_ARRAY_POINTER:     GetPointervPName read new GetPointervPName($8092);
    public static property TEXTURE_COORD_ARRAY_POINTER_EXT: GetPointervPName read new GetPointervPName($8092);
    public static property EDGE_FLAG_ARRAY_POINTER:         GetPointervPName read new GetPointervPName($8093);
    public static property EDGE_FLAG_ARRAY_POINTER_EXT:     GetPointervPName read new GetPointervPName($8093);
    public static property INSTRUMENT_BUFFER_POINTER_SGIX:  GetPointervPName read new GetPointervPName($8180);
    public static property DEBUG_CALLBACK_FUNCTION:         GetPointervPName read new GetPointervPName($8244);
    public static property DEBUG_CALLBACK_USER_PARAM:       GetPointervPName read new GetPointervPName($8245);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0DF0) then Result := 'FEEDBACK_BUFFER_POINTER' else
      if self.val = UInt32($0DF3) then Result := 'SELECTION_BUFFER_POINTER' else
      if self.val = UInt32($808E) then Result := 'VERTEX_ARRAY_POINTER' else
      if self.val = UInt32($808E) then Result := 'VERTEX_ARRAY_POINTER_EXT' else
      if self.val = UInt32($808F) then Result := 'NORMAL_ARRAY_POINTER' else
      if self.val = UInt32($808F) then Result := 'NORMAL_ARRAY_POINTER_EXT' else
      if self.val = UInt32($8090) then Result := 'COLOR_ARRAY_POINTER' else
      if self.val = UInt32($8090) then Result := 'COLOR_ARRAY_POINTER_EXT' else
      if self.val = UInt32($8091) then Result := 'INDEX_ARRAY_POINTER' else
      if self.val = UInt32($8091) then Result := 'INDEX_ARRAY_POINTER_EXT' else
      if self.val = UInt32($8092) then Result := 'TEXTURE_COORD_ARRAY_POINTER' else
      if self.val = UInt32($8092) then Result := 'TEXTURE_COORD_ARRAY_POINTER_EXT' else
      if self.val = UInt32($8093) then Result := 'EDGE_FLAG_ARRAY_POINTER' else
      if self.val = UInt32($8093) then Result := 'EDGE_FLAG_ARRAY_POINTER_EXT' else
      if self.val = UInt32($8180) then Result := 'INSTRUMENT_BUFFER_POINTER_SGIX' else
      if self.val = UInt32($8244) then Result := 'DEBUG_CALLBACK_FUNCTION' else
      if self.val = UInt32($8245) then Result := 'DEBUG_CALLBACK_USER_PARAM' else
        Result := $'GetPointervPName[{self.val}]';
    end;
    
  end;
  
  GetTextureParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_WIDTH:                        GetTextureParameter read new GetTextureParameter($1000);
    public static property TEXTURE_HEIGHT:                       GetTextureParameter read new GetTextureParameter($1001);
    public static property TEXTURE_COMPONENTS:                   GetTextureParameter read new GetTextureParameter($1003);
    public static property TEXTURE_INTERNAL_FORMAT:              GetTextureParameter read new GetTextureParameter($1003);
    public static property TEXTURE_BORDER_COLOR:                 GetTextureParameter read new GetTextureParameter($1004);
    public static property TEXTURE_BORDER_COLOR_NV:              GetTextureParameter read new GetTextureParameter($1004);
    public static property TEXTURE_BORDER:                       GetTextureParameter read new GetTextureParameter($1005);
    public static property TEXTURE_MAG_FILTER:                   GetTextureParameter read new GetTextureParameter($2800);
    public static property TEXTURE_MIN_FILTER:                   GetTextureParameter read new GetTextureParameter($2801);
    public static property TEXTURE_WRAP_S:                       GetTextureParameter read new GetTextureParameter($2802);
    public static property TEXTURE_WRAP_T:                       GetTextureParameter read new GetTextureParameter($2803);
    public static property TEXTURE_RED_SIZE:                     GetTextureParameter read new GetTextureParameter($805C);
    public static property TEXTURE_GREEN_SIZE:                   GetTextureParameter read new GetTextureParameter($805D);
    public static property TEXTURE_BLUE_SIZE:                    GetTextureParameter read new GetTextureParameter($805E);
    public static property TEXTURE_ALPHA_SIZE:                   GetTextureParameter read new GetTextureParameter($805F);
    public static property TEXTURE_LUMINANCE_SIZE:               GetTextureParameter read new GetTextureParameter($8060);
    public static property TEXTURE_INTENSITY_SIZE:               GetTextureParameter read new GetTextureParameter($8061);
    public static property TEXTURE_PRIORITY:                     GetTextureParameter read new GetTextureParameter($8066);
    public static property TEXTURE_RESIDENT:                     GetTextureParameter read new GetTextureParameter($8067);
    public static property TEXTURE_DEPTH_EXT:                    GetTextureParameter read new GetTextureParameter($8071);
    public static property TEXTURE_WRAP_R_EXT:                   GetTextureParameter read new GetTextureParameter($8072);
    public static property DETAIL_TEXTURE_LEVEL_SGIS:            GetTextureParameter read new GetTextureParameter($809A);
    public static property DETAIL_TEXTURE_MODE_SGIS:             GetTextureParameter read new GetTextureParameter($809B);
    public static property DETAIL_TEXTURE_FUNC_POINTS_SGIS:      GetTextureParameter read new GetTextureParameter($809C);
    public static property SHARPEN_TEXTURE_FUNC_POINTS_SGIS:     GetTextureParameter read new GetTextureParameter($80B0);
    public static property SHADOW_AMBIENT_SGIX:                  GetTextureParameter read new GetTextureParameter($80BF);
    public static property DUAL_TEXTURE_SELECT_SGIS:             GetTextureParameter read new GetTextureParameter($8124);
    public static property QUAD_TEXTURE_SELECT_SGIS:             GetTextureParameter read new GetTextureParameter($8125);
    public static property TEXTURE_4DSIZE_SGIS:                  GetTextureParameter read new GetTextureParameter($8136);
    public static property TEXTURE_WRAP_Q_SGIS:                  GetTextureParameter read new GetTextureParameter($8137);
    public static property TEXTURE_MIN_LOD_SGIS:                 GetTextureParameter read new GetTextureParameter($813A);
    public static property TEXTURE_MAX_LOD_SGIS:                 GetTextureParameter read new GetTextureParameter($813B);
    public static property TEXTURE_BASE_LEVEL_SGIS:              GetTextureParameter read new GetTextureParameter($813C);
    public static property TEXTURE_MAX_LEVEL_SGIS:               GetTextureParameter read new GetTextureParameter($813D);
    public static property TEXTURE_FILTER4_SIZE_SGIS:            GetTextureParameter read new GetTextureParameter($8147);
    public static property TEXTURE_CLIPMAP_CENTER_SGIX:          GetTextureParameter read new GetTextureParameter($8171);
    public static property TEXTURE_CLIPMAP_FRAME_SGIX:           GetTextureParameter read new GetTextureParameter($8172);
    public static property TEXTURE_CLIPMAP_OFFSET_SGIX:          GetTextureParameter read new GetTextureParameter($8173);
    public static property TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX:   GetTextureParameter read new GetTextureParameter($8174);
    public static property TEXTURE_CLIPMAP_LOD_OFFSET_SGIX:      GetTextureParameter read new GetTextureParameter($8175);
    public static property TEXTURE_CLIPMAP_DEPTH_SGIX:           GetTextureParameter read new GetTextureParameter($8176);
    public static property POST_TEXTURE_FILTER_BIAS_SGIX:        GetTextureParameter read new GetTextureParameter($8179);
    public static property POST_TEXTURE_FILTER_SCALE_SGIX:       GetTextureParameter read new GetTextureParameter($817A);
    public static property TEXTURE_LOD_BIAS_S_SGIX:              GetTextureParameter read new GetTextureParameter($818E);
    public static property TEXTURE_LOD_BIAS_T_SGIX:              GetTextureParameter read new GetTextureParameter($818F);
    public static property TEXTURE_LOD_BIAS_R_SGIX:              GetTextureParameter read new GetTextureParameter($8190);
    public static property GENERATE_MIPMAP_SGIS:                 GetTextureParameter read new GetTextureParameter($8191);
    public static property TEXTURE_COMPARE_SGIX:                 GetTextureParameter read new GetTextureParameter($819A);
    public static property TEXTURE_COMPARE_OPERATOR_SGIX:        GetTextureParameter read new GetTextureParameter($819B);
    public static property TEXTURE_LEQUAL_R_SGIX:                GetTextureParameter read new GetTextureParameter($819C);
    public static property TEXTURE_GEQUAL_R_SGIX:                GetTextureParameter read new GetTextureParameter($819D);
    public static property TEXTURE_MAX_CLAMP_S_SGIX:             GetTextureParameter read new GetTextureParameter($8369);
    public static property TEXTURE_MAX_CLAMP_T_SGIX:             GetTextureParameter read new GetTextureParameter($836A);
    public static property TEXTURE_MAX_CLAMP_R_SGIX:             GetTextureParameter read new GetTextureParameter($836B);
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: GetTextureParameter read new GetTextureParameter($8F6A);
    public static property SURFACE_COMPRESSION_EXT:              GetTextureParameter read new GetTextureParameter($96C0);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1000) then Result := 'TEXTURE_WIDTH' else
      if self.val = UInt32($1001) then Result := 'TEXTURE_HEIGHT' else
      if self.val = UInt32($1003) then Result := 'TEXTURE_COMPONENTS' else
      if self.val = UInt32($1003) then Result := 'TEXTURE_INTERNAL_FORMAT' else
      if self.val = UInt32($1004) then Result := 'TEXTURE_BORDER_COLOR' else
      if self.val = UInt32($1004) then Result := 'TEXTURE_BORDER_COLOR_NV' else
      if self.val = UInt32($1005) then Result := 'TEXTURE_BORDER' else
      if self.val = UInt32($2800) then Result := 'TEXTURE_MAG_FILTER' else
      if self.val = UInt32($2801) then Result := 'TEXTURE_MIN_FILTER' else
      if self.val = UInt32($2802) then Result := 'TEXTURE_WRAP_S' else
      if self.val = UInt32($2803) then Result := 'TEXTURE_WRAP_T' else
      if self.val = UInt32($805C) then Result := 'TEXTURE_RED_SIZE' else
      if self.val = UInt32($805D) then Result := 'TEXTURE_GREEN_SIZE' else
      if self.val = UInt32($805E) then Result := 'TEXTURE_BLUE_SIZE' else
      if self.val = UInt32($805F) then Result := 'TEXTURE_ALPHA_SIZE' else
      if self.val = UInt32($8060) then Result := 'TEXTURE_LUMINANCE_SIZE' else
      if self.val = UInt32($8061) then Result := 'TEXTURE_INTENSITY_SIZE' else
      if self.val = UInt32($8066) then Result := 'TEXTURE_PRIORITY' else
      if self.val = UInt32($8067) then Result := 'TEXTURE_RESIDENT' else
      if self.val = UInt32($8071) then Result := 'TEXTURE_DEPTH_EXT' else
      if self.val = UInt32($8072) then Result := 'TEXTURE_WRAP_R_EXT' else
      if self.val = UInt32($809A) then Result := 'DETAIL_TEXTURE_LEVEL_SGIS' else
      if self.val = UInt32($809B) then Result := 'DETAIL_TEXTURE_MODE_SGIS' else
      if self.val = UInt32($809C) then Result := 'DETAIL_TEXTURE_FUNC_POINTS_SGIS' else
      if self.val = UInt32($80B0) then Result := 'SHARPEN_TEXTURE_FUNC_POINTS_SGIS' else
      if self.val = UInt32($80BF) then Result := 'SHADOW_AMBIENT_SGIX' else
      if self.val = UInt32($8124) then Result := 'DUAL_TEXTURE_SELECT_SGIS' else
      if self.val = UInt32($8125) then Result := 'QUAD_TEXTURE_SELECT_SGIS' else
      if self.val = UInt32($8136) then Result := 'TEXTURE_4DSIZE_SGIS' else
      if self.val = UInt32($8137) then Result := 'TEXTURE_WRAP_Q_SGIS' else
      if self.val = UInt32($813A) then Result := 'TEXTURE_MIN_LOD_SGIS' else
      if self.val = UInt32($813B) then Result := 'TEXTURE_MAX_LOD_SGIS' else
      if self.val = UInt32($813C) then Result := 'TEXTURE_BASE_LEVEL_SGIS' else
      if self.val = UInt32($813D) then Result := 'TEXTURE_MAX_LEVEL_SGIS' else
      if self.val = UInt32($8147) then Result := 'TEXTURE_FILTER4_SIZE_SGIS' else
      if self.val = UInt32($8171) then Result := 'TEXTURE_CLIPMAP_CENTER_SGIX' else
      if self.val = UInt32($8172) then Result := 'TEXTURE_CLIPMAP_FRAME_SGIX' else
      if self.val = UInt32($8173) then Result := 'TEXTURE_CLIPMAP_OFFSET_SGIX' else
      if self.val = UInt32($8174) then Result := 'TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX' else
      if self.val = UInt32($8175) then Result := 'TEXTURE_CLIPMAP_LOD_OFFSET_SGIX' else
      if self.val = UInt32($8176) then Result := 'TEXTURE_CLIPMAP_DEPTH_SGIX' else
      if self.val = UInt32($8179) then Result := 'POST_TEXTURE_FILTER_BIAS_SGIX' else
      if self.val = UInt32($817A) then Result := 'POST_TEXTURE_FILTER_SCALE_SGIX' else
      if self.val = UInt32($818E) then Result := 'TEXTURE_LOD_BIAS_S_SGIX' else
      if self.val = UInt32($818F) then Result := 'TEXTURE_LOD_BIAS_T_SGIX' else
      if self.val = UInt32($8190) then Result := 'TEXTURE_LOD_BIAS_R_SGIX' else
      if self.val = UInt32($8191) then Result := 'GENERATE_MIPMAP_SGIS' else
      if self.val = UInt32($819A) then Result := 'TEXTURE_COMPARE_SGIX' else
      if self.val = UInt32($819B) then Result := 'TEXTURE_COMPARE_OPERATOR_SGIX' else
      if self.val = UInt32($819C) then Result := 'TEXTURE_LEQUAL_R_SGIX' else
      if self.val = UInt32($819D) then Result := 'TEXTURE_GEQUAL_R_SGIX' else
      if self.val = UInt32($8369) then Result := 'TEXTURE_MAX_CLAMP_S_SGIX' else
      if self.val = UInt32($836A) then Result := 'TEXTURE_MAX_CLAMP_T_SGIX' else
      if self.val = UInt32($836B) then Result := 'TEXTURE_MAX_CLAMP_R_SGIX' else
      if self.val = UInt32($8F6A) then Result := 'TEXTURE_UNNORMALIZED_COORDINATES_ARM' else
      if self.val = UInt32($96C0) then Result := 'SURFACE_COMPRESSION_EXT' else
        Result := $'GetTextureParameter[{self.val}]';
    end;
    
  end;
  
  GraphicsResetStatus = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NO_ERROR:               GraphicsResetStatus read new GraphicsResetStatus($0000);
    public static property GUILTY_CONTEXT_RESET:   GraphicsResetStatus read new GraphicsResetStatus($8253);
    public static property INNOCENT_CONTEXT_RESET: GraphicsResetStatus read new GraphicsResetStatus($8254);
    public static property UNKNOWN_CONTEXT_RESET:  GraphicsResetStatus read new GraphicsResetStatus($8255);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NO_ERROR' else
      if self.val = UInt32($8253) then Result := 'GUILTY_CONTEXT_RESET' else
      if self.val = UInt32($8254) then Result := 'INNOCENT_CONTEXT_RESET' else
      if self.val = UInt32($8255) then Result := 'UNKNOWN_CONTEXT_RESET' else
        Result := $'GraphicsResetStatus[{self.val}]';
    end;
    
  end;
  
  HintMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DONT_CARE: HintMode read new HintMode($1100);
    public static property FASTEST:   HintMode read new HintMode($1101);
    public static property NICEST:    HintMode read new HintMode($1102);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1100) then Result := 'DONT_CARE' else
      if self.val = UInt32($1101) then Result := 'FASTEST' else
      if self.val = UInt32($1102) then Result := 'NICEST' else
        Result := $'HintMode[{self.val}]';
    end;
    
  end;
  
  HintTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PERSPECTIVE_CORRECTION_HINT:         HintTarget read new HintTarget($0C50);
    public static property POINT_SMOOTH_HINT:                   HintTarget read new HintTarget($0C51);
    public static property LINE_SMOOTH_HINT:                    HintTarget read new HintTarget($0C52);
    public static property POLYGON_SMOOTH_HINT:                 HintTarget read new HintTarget($0C53);
    public static property FOG_HINT:                            HintTarget read new HintTarget($0C54);
    public static property PACK_CMYK_HINT_EXT:                  HintTarget read new HintTarget($800E);
    public static property UNPACK_CMYK_HINT_EXT:                HintTarget read new HintTarget($800F);
    public static property PHONG_HINT_WIN:                      HintTarget read new HintTarget($80EB);
    public static property CLIP_VOLUME_CLIPPING_HINT_EXT:       HintTarget read new HintTarget($80F0);
    public static property TEXTURE_MULTI_BUFFER_HINT_SGIX:      HintTarget read new HintTarget($812E);
    public static property GENERATE_MIPMAP_HINT:                HintTarget read new HintTarget($8192);
    public static property GENERATE_MIPMAP_HINT_SGIS:           HintTarget read new HintTarget($8192);
    public static property PROGRAM_BINARY_RETRIEVABLE_HINT:     HintTarget read new HintTarget($8257);
    public static property CONVOLUTION_HINT_SGIX:               HintTarget read new HintTarget($8316);
    public static property SCALEBIAS_HINT_SGIX:                 HintTarget read new HintTarget($8322);
    public static property LINE_QUALITY_HINT_SGIX:              HintTarget read new HintTarget($835B);
    public static property VERTEX_PRECLIP_SGIX:                 HintTarget read new HintTarget($83EE);
    public static property VERTEX_PRECLIP_HINT_SGIX:            HintTarget read new HintTarget($83EF);
    public static property TEXTURE_COMPRESSION_HINT:            HintTarget read new HintTarget($84EF);
    public static property TEXTURE_COMPRESSION_HINT_ARB:        HintTarget read new HintTarget($84EF);
    public static property VERTEX_ARRAY_STORAGE_HINT_APPLE:     HintTarget read new HintTarget($851F);
    public static property MULTISAMPLE_FILTER_HINT_NV:          HintTarget read new HintTarget($8534);
    public static property TRANSFORM_HINT_APPLE:                HintTarget read new HintTarget($85B1);
    public static property TEXTURE_STORAGE_HINT_APPLE:          HintTarget read new HintTarget($85BC);
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT:     HintTarget read new HintTarget($8B8B);
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT_ARB: HintTarget read new HintTarget($8B8B);
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT_OES: HintTarget read new HintTarget($8B8B);
    public static property BINNING_CONTROL_HINT_QCOM:           HintTarget read new HintTarget($8FB0);
    public static property PREFER_DOUBLEBUFFER_HINT_PGI:        HintTarget read new HintTarget($1A1F8);
    public static property CONSERVE_MEMORY_HINT_PGI:            HintTarget read new HintTarget($1A1FD);
    public static property RECLAIM_MEMORY_HINT_PGI:             HintTarget read new HintTarget($1A1FE);
    public static property NATIVE_GRAPHICS_BEGIN_HINT_PGI:      HintTarget read new HintTarget($1A203);
    public static property NATIVE_GRAPHICS_END_HINT_PGI:        HintTarget read new HintTarget($1A204);
    public static property ALWAYS_FAST_HINT_PGI:                HintTarget read new HintTarget($1A20C);
    public static property ALWAYS_SOFT_HINT_PGI:                HintTarget read new HintTarget($1A20D);
    public static property ALLOW_DRAW_OBJ_HINT_PGI:             HintTarget read new HintTarget($1A20E);
    public static property ALLOW_DRAW_WIN_HINT_PGI:             HintTarget read new HintTarget($1A20F);
    public static property ALLOW_DRAW_FRG_HINT_PGI:             HintTarget read new HintTarget($1A210);
    public static property ALLOW_DRAW_MEM_HINT_PGI:             HintTarget read new HintTarget($1A211);
    public static property STRICT_DEPTHFUNC_HINT_PGI:           HintTarget read new HintTarget($1A216);
    public static property STRICT_LIGHTING_HINT_PGI:            HintTarget read new HintTarget($1A217);
    public static property STRICT_SCISSOR_HINT_PGI:             HintTarget read new HintTarget($1A218);
    public static property FULL_STIPPLE_HINT_PGI:               HintTarget read new HintTarget($1A219);
    public static property CLIP_NEAR_HINT_PGI:                  HintTarget read new HintTarget($1A220);
    public static property CLIP_FAR_HINT_PGI:                   HintTarget read new HintTarget($1A221);
    public static property WIDE_LINE_HINT_PGI:                  HintTarget read new HintTarget($1A222);
    public static property BACK_NORMALS_HINT_PGI:               HintTarget read new HintTarget($1A223);
    public static property VERTEX_DATA_HINT_PGI:                HintTarget read new HintTarget($1A22A);
    public static property VERTEX_CONSISTENT_HINT_PGI:          HintTarget read new HintTarget($1A22B);
    public static property MATERIAL_SIDE_HINT_PGI:              HintTarget read new HintTarget($1A22C);
    public static property MAX_VERTEX_HINT_PGI:                 HintTarget read new HintTarget($1A22D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0C50) then Result := 'PERSPECTIVE_CORRECTION_HINT' else
      if self.val = UInt32($0C51) then Result := 'POINT_SMOOTH_HINT' else
      if self.val = UInt32($0C52) then Result := 'LINE_SMOOTH_HINT' else
      if self.val = UInt32($0C53) then Result := 'POLYGON_SMOOTH_HINT' else
      if self.val = UInt32($0C54) then Result := 'FOG_HINT' else
      if self.val = UInt32($800E) then Result := 'PACK_CMYK_HINT_EXT' else
      if self.val = UInt32($800F) then Result := 'UNPACK_CMYK_HINT_EXT' else
      if self.val = UInt32($80EB) then Result := 'PHONG_HINT_WIN' else
      if self.val = UInt32($80F0) then Result := 'CLIP_VOLUME_CLIPPING_HINT_EXT' else
      if self.val = UInt32($812E) then Result := 'TEXTURE_MULTI_BUFFER_HINT_SGIX' else
      if self.val = UInt32($8192) then Result := 'GENERATE_MIPMAP_HINT' else
      if self.val = UInt32($8192) then Result := 'GENERATE_MIPMAP_HINT_SGIS' else
      if self.val = UInt32($8257) then Result := 'PROGRAM_BINARY_RETRIEVABLE_HINT' else
      if self.val = UInt32($8316) then Result := 'CONVOLUTION_HINT_SGIX' else
      if self.val = UInt32($8322) then Result := 'SCALEBIAS_HINT_SGIX' else
      if self.val = UInt32($835B) then Result := 'LINE_QUALITY_HINT_SGIX' else
      if self.val = UInt32($83EE) then Result := 'VERTEX_PRECLIP_SGIX' else
      if self.val = UInt32($83EF) then Result := 'VERTEX_PRECLIP_HINT_SGIX' else
      if self.val = UInt32($84EF) then Result := 'TEXTURE_COMPRESSION_HINT' else
      if self.val = UInt32($84EF) then Result := 'TEXTURE_COMPRESSION_HINT_ARB' else
      if self.val = UInt32($851F) then Result := 'VERTEX_ARRAY_STORAGE_HINT_APPLE' else
      if self.val = UInt32($8534) then Result := 'MULTISAMPLE_FILTER_HINT_NV' else
      if self.val = UInt32($85B1) then Result := 'TRANSFORM_HINT_APPLE' else
      if self.val = UInt32($85BC) then Result := 'TEXTURE_STORAGE_HINT_APPLE' else
      if self.val = UInt32($8B8B) then Result := 'FRAGMENT_SHADER_DERIVATIVE_HINT' else
      if self.val = UInt32($8B8B) then Result := 'FRAGMENT_SHADER_DERIVATIVE_HINT_ARB' else
      if self.val = UInt32($8B8B) then Result := 'FRAGMENT_SHADER_DERIVATIVE_HINT_OES' else
      if self.val = UInt32($8FB0) then Result := 'BINNING_CONTROL_HINT_QCOM' else
      if self.val = UInt32($1A1F8) then Result := 'PREFER_DOUBLEBUFFER_HINT_PGI' else
      if self.val = UInt32($1A1FD) then Result := 'CONSERVE_MEMORY_HINT_PGI' else
      if self.val = UInt32($1A1FE) then Result := 'RECLAIM_MEMORY_HINT_PGI' else
      if self.val = UInt32($1A203) then Result := 'NATIVE_GRAPHICS_BEGIN_HINT_PGI' else
      if self.val = UInt32($1A204) then Result := 'NATIVE_GRAPHICS_END_HINT_PGI' else
      if self.val = UInt32($1A20C) then Result := 'ALWAYS_FAST_HINT_PGI' else
      if self.val = UInt32($1A20D) then Result := 'ALWAYS_SOFT_HINT_PGI' else
      if self.val = UInt32($1A20E) then Result := 'ALLOW_DRAW_OBJ_HINT_PGI' else
      if self.val = UInt32($1A20F) then Result := 'ALLOW_DRAW_WIN_HINT_PGI' else
      if self.val = UInt32($1A210) then Result := 'ALLOW_DRAW_FRG_HINT_PGI' else
      if self.val = UInt32($1A211) then Result := 'ALLOW_DRAW_MEM_HINT_PGI' else
      if self.val = UInt32($1A216) then Result := 'STRICT_DEPTHFUNC_HINT_PGI' else
      if self.val = UInt32($1A217) then Result := 'STRICT_LIGHTING_HINT_PGI' else
      if self.val = UInt32($1A218) then Result := 'STRICT_SCISSOR_HINT_PGI' else
      if self.val = UInt32($1A219) then Result := 'FULL_STIPPLE_HINT_PGI' else
      if self.val = UInt32($1A220) then Result := 'CLIP_NEAR_HINT_PGI' else
      if self.val = UInt32($1A221) then Result := 'CLIP_FAR_HINT_PGI' else
      if self.val = UInt32($1A222) then Result := 'WIDE_LINE_HINT_PGI' else
      if self.val = UInt32($1A223) then Result := 'BACK_NORMALS_HINT_PGI' else
      if self.val = UInt32($1A22A) then Result := 'VERTEX_DATA_HINT_PGI' else
      if self.val = UInt32($1A22B) then Result := 'VERTEX_CONSISTENT_HINT_PGI' else
      if self.val = UInt32($1A22C) then Result := 'MATERIAL_SIDE_HINT_PGI' else
      if self.val = UInt32($1A22D) then Result := 'MAX_VERTEX_HINT_PGI' else
        Result := $'HintTarget[{self.val}]';
    end;
    
  end;
  
  HistogramTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property HISTOGRAM:       HistogramTarget read new HistogramTarget($8024);
    public static property PROXY_HISTOGRAM: HistogramTarget read new HistogramTarget($8025);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8024) then Result := 'HISTOGRAM' else
      if self.val = UInt32($8025) then Result := 'PROXY_HISTOGRAM' else
        Result := $'HistogramTarget[{self.val}]';
    end;
    
  end;
  
  IndexPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SHORT:  IndexPointerType read new IndexPointerType($1402);
    public static property INT:    IndexPointerType read new IndexPointerType($1404);
    public static property FLOAT:  IndexPointerType read new IndexPointerType($1406);
    public static property DOUBLE: IndexPointerType read new IndexPointerType($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'IndexPointerType[{self.val}]';
    end;
    
  end;
  
  InterleavedArrayFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property V2F:             InterleavedArrayFormat read new InterleavedArrayFormat($2A20);
    public static property V3F:             InterleavedArrayFormat read new InterleavedArrayFormat($2A21);
    public static property C4UB_V2F:        InterleavedArrayFormat read new InterleavedArrayFormat($2A22);
    public static property C4UB_V3F:        InterleavedArrayFormat read new InterleavedArrayFormat($2A23);
    public static property C3F_V3F:         InterleavedArrayFormat read new InterleavedArrayFormat($2A24);
    public static property N3F_V3F:         InterleavedArrayFormat read new InterleavedArrayFormat($2A25);
    public static property C4F_N3F_V3F:     InterleavedArrayFormat read new InterleavedArrayFormat($2A26);
    public static property T2F_V3F:         InterleavedArrayFormat read new InterleavedArrayFormat($2A27);
    public static property T4F_V4F:         InterleavedArrayFormat read new InterleavedArrayFormat($2A28);
    public static property T2F_C4UB_V3F:    InterleavedArrayFormat read new InterleavedArrayFormat($2A29);
    public static property T2F_C3F_V3F:     InterleavedArrayFormat read new InterleavedArrayFormat($2A2A);
    public static property T2F_N3F_V3F:     InterleavedArrayFormat read new InterleavedArrayFormat($2A2B);
    public static property T2F_C4F_N3F_V3F: InterleavedArrayFormat read new InterleavedArrayFormat($2A2C);
    public static property T4F_C4F_N3F_V4F: InterleavedArrayFormat read new InterleavedArrayFormat($2A2D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2A20) then Result := 'V2F' else
      if self.val = UInt32($2A21) then Result := 'V3F' else
      if self.val = UInt32($2A22) then Result := 'C4UB_V2F' else
      if self.val = UInt32($2A23) then Result := 'C4UB_V3F' else
      if self.val = UInt32($2A24) then Result := 'C3F_V3F' else
      if self.val = UInt32($2A25) then Result := 'N3F_V3F' else
      if self.val = UInt32($2A26) then Result := 'C4F_N3F_V3F' else
      if self.val = UInt32($2A27) then Result := 'T2F_V3F' else
      if self.val = UInt32($2A28) then Result := 'T4F_V4F' else
      if self.val = UInt32($2A29) then Result := 'T2F_C4UB_V3F' else
      if self.val = UInt32($2A2A) then Result := 'T2F_C3F_V3F' else
      if self.val = UInt32($2A2B) then Result := 'T2F_N3F_V3F' else
      if self.val = UInt32($2A2C) then Result := 'T2F_C4F_N3F_V3F' else
      if self.val = UInt32($2A2D) then Result := 'T4F_C4F_N3F_V4F' else
        Result := $'InterleavedArrayFormat[{self.val}]';
    end;
    
  end;
  
  InternalFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property STENCIL_INDEX:                                 InternalFormat read new InternalFormat($1901);
    public static property STENCIL_INDEX_OES:                             InternalFormat read new InternalFormat($1901);
    public static property DEPTH_COMPONENT:                               InternalFormat read new InternalFormat($1902);
    public static property RED:                                           InternalFormat read new InternalFormat($1903);
    public static property RED_EXT:                                       InternalFormat read new InternalFormat($1903);
    public static property RGB:                                           InternalFormat read new InternalFormat($1907);
    public static property RGBA:                                          InternalFormat read new InternalFormat($1908);
    public static property R3_G3_B2:                                      InternalFormat read new InternalFormat($2A10);
    public static property ALPHA4:                                        InternalFormat read new InternalFormat($803B);
    public static property ALPHA4_EXT:                                    InternalFormat read new InternalFormat($803B);
    public static property ALPHA8:                                        InternalFormat read new InternalFormat($803C);
    public static property ALPHA8_EXT:                                    InternalFormat read new InternalFormat($803C);
    public static property ALPHA8_OES:                                    InternalFormat read new InternalFormat($803C);
    public static property ALPHA12:                                       InternalFormat read new InternalFormat($803D);
    public static property ALPHA12_EXT:                                   InternalFormat read new InternalFormat($803D);
    public static property ALPHA16:                                       InternalFormat read new InternalFormat($803E);
    public static property ALPHA16_EXT:                                   InternalFormat read new InternalFormat($803E);
    public static property LUMINANCE4:                                    InternalFormat read new InternalFormat($803F);
    public static property LUMINANCE4_EXT:                                InternalFormat read new InternalFormat($803F);
    public static property LUMINANCE8:                                    InternalFormat read new InternalFormat($8040);
    public static property LUMINANCE8_EXT:                                InternalFormat read new InternalFormat($8040);
    public static property LUMINANCE8_OES:                                InternalFormat read new InternalFormat($8040);
    public static property LUMINANCE12:                                   InternalFormat read new InternalFormat($8041);
    public static property LUMINANCE12_EXT:                               InternalFormat read new InternalFormat($8041);
    public static property LUMINANCE16:                                   InternalFormat read new InternalFormat($8042);
    public static property LUMINANCE16_EXT:                               InternalFormat read new InternalFormat($8042);
    public static property LUMINANCE4_ALPHA4:                             InternalFormat read new InternalFormat($8043);
    public static property LUMINANCE4_ALPHA4_EXT:                         InternalFormat read new InternalFormat($8043);
    public static property LUMINANCE4_ALPHA4_OES:                         InternalFormat read new InternalFormat($8043);
    public static property LUMINANCE6_ALPHA2:                             InternalFormat read new InternalFormat($8044);
    public static property LUMINANCE6_ALPHA2_EXT:                         InternalFormat read new InternalFormat($8044);
    public static property LUMINANCE8_ALPHA8:                             InternalFormat read new InternalFormat($8045);
    public static property LUMINANCE8_ALPHA8_EXT:                         InternalFormat read new InternalFormat($8045);
    public static property LUMINANCE8_ALPHA8_OES:                         InternalFormat read new InternalFormat($8045);
    public static property LUMINANCE12_ALPHA4:                            InternalFormat read new InternalFormat($8046);
    public static property LUMINANCE12_ALPHA4_EXT:                        InternalFormat read new InternalFormat($8046);
    public static property LUMINANCE12_ALPHA12:                           InternalFormat read new InternalFormat($8047);
    public static property LUMINANCE12_ALPHA12_EXT:                       InternalFormat read new InternalFormat($8047);
    public static property LUMINANCE16_ALPHA16:                           InternalFormat read new InternalFormat($8048);
    public static property LUMINANCE16_ALPHA16_EXT:                       InternalFormat read new InternalFormat($8048);
    public static property INTENSITY:                                     InternalFormat read new InternalFormat($8049);
    public static property INTENSITY4:                                    InternalFormat read new InternalFormat($804A);
    public static property INTENSITY4_EXT:                                InternalFormat read new InternalFormat($804A);
    public static property INTENSITY8:                                    InternalFormat read new InternalFormat($804B);
    public static property INTENSITY8_EXT:                                InternalFormat read new InternalFormat($804B);
    public static property INTENSITY12:                                   InternalFormat read new InternalFormat($804C);
    public static property INTENSITY12_EXT:                               InternalFormat read new InternalFormat($804C);
    public static property INTENSITY16:                                   InternalFormat read new InternalFormat($804D);
    public static property INTENSITY16_EXT:                               InternalFormat read new InternalFormat($804D);
    public static property RGB2_EXT:                                      InternalFormat read new InternalFormat($804E);
    public static property RGB4:                                          InternalFormat read new InternalFormat($804F);
    public static property RGB4_EXT:                                      InternalFormat read new InternalFormat($804F);
    public static property RGB5:                                          InternalFormat read new InternalFormat($8050);
    public static property RGB5_EXT:                                      InternalFormat read new InternalFormat($8050);
    public static property RGB8:                                          InternalFormat read new InternalFormat($8051);
    public static property RGB8_EXT:                                      InternalFormat read new InternalFormat($8051);
    public static property RGB8_OES:                                      InternalFormat read new InternalFormat($8051);
    public static property RGB10:                                         InternalFormat read new InternalFormat($8052);
    public static property RGB10_EXT:                                     InternalFormat read new InternalFormat($8052);
    public static property RGB12:                                         InternalFormat read new InternalFormat($8053);
    public static property RGB12_EXT:                                     InternalFormat read new InternalFormat($8053);
    public static property RGB16:                                         InternalFormat read new InternalFormat($8054);
    public static property RGB16_EXT:                                     InternalFormat read new InternalFormat($8054);
    public static property RGBA2:                                         InternalFormat read new InternalFormat($8055);
    public static property RGBA2_EXT:                                     InternalFormat read new InternalFormat($8055);
    public static property RGBA4:                                         InternalFormat read new InternalFormat($8056);
    public static property RGBA4_EXT:                                     InternalFormat read new InternalFormat($8056);
    public static property RGBA4_OES:                                     InternalFormat read new InternalFormat($8056);
    public static property RGB5_A1:                                       InternalFormat read new InternalFormat($8057);
    public static property RGB5_A1_EXT:                                   InternalFormat read new InternalFormat($8057);
    public static property RGB5_A1_OES:                                   InternalFormat read new InternalFormat($8057);
    public static property RGBA8:                                         InternalFormat read new InternalFormat($8058);
    public static property RGBA8_EXT:                                     InternalFormat read new InternalFormat($8058);
    public static property RGBA8_OES:                                     InternalFormat read new InternalFormat($8058);
    public static property RGB10_A2:                                      InternalFormat read new InternalFormat($8059);
    public static property RGB10_A2_EXT:                                  InternalFormat read new InternalFormat($8059);
    public static property RGBA12:                                        InternalFormat read new InternalFormat($805A);
    public static property RGBA12_EXT:                                    InternalFormat read new InternalFormat($805A);
    public static property RGBA16:                                        InternalFormat read new InternalFormat($805B);
    public static property RGBA16_EXT:                                    InternalFormat read new InternalFormat($805B);
    public static property DUAL_ALPHA4_SGIS:                              InternalFormat read new InternalFormat($8110);
    public static property DUAL_ALPHA8_SGIS:                              InternalFormat read new InternalFormat($8111);
    public static property DUAL_ALPHA12_SGIS:                             InternalFormat read new InternalFormat($8112);
    public static property DUAL_ALPHA16_SGIS:                             InternalFormat read new InternalFormat($8113);
    public static property DUAL_LUMINANCE4_SGIS:                          InternalFormat read new InternalFormat($8114);
    public static property DUAL_LUMINANCE8_SGIS:                          InternalFormat read new InternalFormat($8115);
    public static property DUAL_LUMINANCE12_SGIS:                         InternalFormat read new InternalFormat($8116);
    public static property DUAL_LUMINANCE16_SGIS:                         InternalFormat read new InternalFormat($8117);
    public static property DUAL_INTENSITY4_SGIS:                          InternalFormat read new InternalFormat($8118);
    public static property DUAL_INTENSITY8_SGIS:                          InternalFormat read new InternalFormat($8119);
    public static property DUAL_INTENSITY12_SGIS:                         InternalFormat read new InternalFormat($811A);
    public static property DUAL_INTENSITY16_SGIS:                         InternalFormat read new InternalFormat($811B);
    public static property DUAL_LUMINANCE_ALPHA4_SGIS:                    InternalFormat read new InternalFormat($811C);
    public static property DUAL_LUMINANCE_ALPHA8_SGIS:                    InternalFormat read new InternalFormat($811D);
    public static property QUAD_ALPHA4_SGIS:                              InternalFormat read new InternalFormat($811E);
    public static property QUAD_ALPHA8_SGIS:                              InternalFormat read new InternalFormat($811F);
    public static property QUAD_LUMINANCE4_SGIS:                          InternalFormat read new InternalFormat($8120);
    public static property QUAD_LUMINANCE8_SGIS:                          InternalFormat read new InternalFormat($8121);
    public static property QUAD_INTENSITY4_SGIS:                          InternalFormat read new InternalFormat($8122);
    public static property QUAD_INTENSITY8_SGIS:                          InternalFormat read new InternalFormat($8123);
    public static property DEPTH_COMPONENT16:                             InternalFormat read new InternalFormat($81A5);
    public static property DEPTH_COMPONENT16_ARB:                         InternalFormat read new InternalFormat($81A5);
    public static property DEPTH_COMPONENT16_OES:                         InternalFormat read new InternalFormat($81A5);
    public static property DEPTH_COMPONENT16_SGIX:                        InternalFormat read new InternalFormat($81A5);
    public static property DEPTH_COMPONENT24:                             InternalFormat read new InternalFormat($81A6);
    public static property DEPTH_COMPONENT24_ARB:                         InternalFormat read new InternalFormat($81A6);
    public static property DEPTH_COMPONENT24_OES:                         InternalFormat read new InternalFormat($81A6);
    public static property DEPTH_COMPONENT24_SGIX:                        InternalFormat read new InternalFormat($81A6);
    public static property DEPTH_COMPONENT32:                             InternalFormat read new InternalFormat($81A7);
    public static property DEPTH_COMPONENT32_ARB:                         InternalFormat read new InternalFormat($81A7);
    public static property DEPTH_COMPONENT32_OES:                         InternalFormat read new InternalFormat($81A7);
    public static property DEPTH_COMPONENT32_SGIX:                        InternalFormat read new InternalFormat($81A7);
    public static property COMPRESSED_RED:                                InternalFormat read new InternalFormat($8225);
    public static property COMPRESSED_RG:                                 InternalFormat read new InternalFormat($8226);
    public static property RG:                                            InternalFormat read new InternalFormat($8227);
    public static property R8:                                            InternalFormat read new InternalFormat($8229);
    public static property R8_EXT:                                        InternalFormat read new InternalFormat($8229);
    public static property R16:                                           InternalFormat read new InternalFormat($822A);
    public static property R16_EXT:                                       InternalFormat read new InternalFormat($822A);
    public static property RG8:                                           InternalFormat read new InternalFormat($822B);
    public static property RG8_EXT:                                       InternalFormat read new InternalFormat($822B);
    public static property RG16:                                          InternalFormat read new InternalFormat($822C);
    public static property RG16_EXT:                                      InternalFormat read new InternalFormat($822C);
    public static property R16F:                                          InternalFormat read new InternalFormat($822D);
    public static property R16F_EXT:                                      InternalFormat read new InternalFormat($822D);
    public static property R32F:                                          InternalFormat read new InternalFormat($822E);
    public static property R32F_EXT:                                      InternalFormat read new InternalFormat($822E);
    public static property RG16F:                                         InternalFormat read new InternalFormat($822F);
    public static property RG16F_EXT:                                     InternalFormat read new InternalFormat($822F);
    public static property RG32F:                                         InternalFormat read new InternalFormat($8230);
    public static property RG32F_EXT:                                     InternalFormat read new InternalFormat($8230);
    public static property R8I:                                           InternalFormat read new InternalFormat($8231);
    public static property R8UI:                                          InternalFormat read new InternalFormat($8232);
    public static property R16I:                                          InternalFormat read new InternalFormat($8233);
    public static property R16UI:                                         InternalFormat read new InternalFormat($8234);
    public static property R32I:                                          InternalFormat read new InternalFormat($8235);
    public static property R32UI:                                         InternalFormat read new InternalFormat($8236);
    public static property RG8I:                                          InternalFormat read new InternalFormat($8237);
    public static property RG8UI:                                         InternalFormat read new InternalFormat($8238);
    public static property RG16I:                                         InternalFormat read new InternalFormat($8239);
    public static property RG16UI:                                        InternalFormat read new InternalFormat($823A);
    public static property RG32I:                                         InternalFormat read new InternalFormat($823B);
    public static property RG32UI:                                        InternalFormat read new InternalFormat($823C);
    public static property COMPRESSED_RGB_S3TC_DXT1_EXT:                  InternalFormat read new InternalFormat($83F0);
    public static property COMPRESSED_RGBA_S3TC_DXT1_EXT:                 InternalFormat read new InternalFormat($83F1);
    public static property COMPRESSED_RGBA_S3TC_DXT3_ANGLE:               InternalFormat read new InternalFormat($83F2);
    public static property COMPRESSED_RGBA_S3TC_DXT3_EXT:                 InternalFormat read new InternalFormat($83F2);
    public static property COMPRESSED_RGBA_S3TC_DXT5_ANGLE:               InternalFormat read new InternalFormat($83F3);
    public static property COMPRESSED_RGBA_S3TC_DXT5_EXT:                 InternalFormat read new InternalFormat($83F3);
    public static property COMPRESSED_RGB:                                InternalFormat read new InternalFormat($84ED);
    public static property COMPRESSED_RGBA:                               InternalFormat read new InternalFormat($84EE);
    public static property DEPTH_STENCIL:                                 InternalFormat read new InternalFormat($84F9);
    public static property DEPTH_STENCIL_EXT:                             InternalFormat read new InternalFormat($84F9);
    public static property DEPTH_STENCIL_NV:                              InternalFormat read new InternalFormat($84F9);
    public static property DEPTH_STENCIL_OES:                             InternalFormat read new InternalFormat($84F9);
    public static property DEPTH_STENCIL_MESA:                            InternalFormat read new InternalFormat($8750);
    public static property RGBA32F:                                       InternalFormat read new InternalFormat($8814);
    public static property RGBA32F_ARB:                                   InternalFormat read new InternalFormat($8814);
    public static property RGBA32F_EXT:                                   InternalFormat read new InternalFormat($8814);
    public static property RGB32F:                                        InternalFormat read new InternalFormat($8815);
    public static property RGB32F_ARB:                                    InternalFormat read new InternalFormat($8815);
    public static property RGB32F_EXT:                                    InternalFormat read new InternalFormat($8815);
    public static property RGBA16F:                                       InternalFormat read new InternalFormat($881A);
    public static property RGBA16F_ARB:                                   InternalFormat read new InternalFormat($881A);
    public static property RGBA16F_EXT:                                   InternalFormat read new InternalFormat($881A);
    public static property RGB16F:                                        InternalFormat read new InternalFormat($881B);
    public static property RGB16F_ARB:                                    InternalFormat read new InternalFormat($881B);
    public static property RGB16F_EXT:                                    InternalFormat read new InternalFormat($881B);
    public static property DEPTH24_STENCIL8:                              InternalFormat read new InternalFormat($88F0);
    public static property DEPTH24_STENCIL8_EXT:                          InternalFormat read new InternalFormat($88F0);
    public static property DEPTH24_STENCIL8_OES:                          InternalFormat read new InternalFormat($88F0);
    public static property R11F_G11F_B10F:                                InternalFormat read new InternalFormat($8C3A);
    public static property R11F_G11F_B10F_APPLE:                          InternalFormat read new InternalFormat($8C3A);
    public static property R11F_G11F_B10F_EXT:                            InternalFormat read new InternalFormat($8C3A);
    public static property RGB9_E5:                                       InternalFormat read new InternalFormat($8C3D);
    public static property RGB9_E5_APPLE:                                 InternalFormat read new InternalFormat($8C3D);
    public static property RGB9_E5_EXT:                                   InternalFormat read new InternalFormat($8C3D);
    public static property SRGB:                                          InternalFormat read new InternalFormat($8C40);
    public static property SRGB_EXT:                                      InternalFormat read new InternalFormat($8C40);
    public static property SRGB8:                                         InternalFormat read new InternalFormat($8C41);
    public static property SRGB8_EXT:                                     InternalFormat read new InternalFormat($8C41);
    public static property SRGB8_NV:                                      InternalFormat read new InternalFormat($8C41);
    public static property SRGB_ALPHA:                                    InternalFormat read new InternalFormat($8C42);
    public static property SRGB_ALPHA_EXT:                                InternalFormat read new InternalFormat($8C42);
    public static property SRGB8_ALPHA8:                                  InternalFormat read new InternalFormat($8C43);
    public static property SRGB8_ALPHA8_EXT:                              InternalFormat read new InternalFormat($8C43);
    public static property COMPRESSED_SRGB:                               InternalFormat read new InternalFormat($8C48);
    public static property COMPRESSED_SRGB_ALPHA:                         InternalFormat read new InternalFormat($8C49);
    public static property COMPRESSED_SRGB_S3TC_DXT1_EXT:                 InternalFormat read new InternalFormat($8C4C);
    public static property COMPRESSED_SRGB_S3TC_DXT1_NV:                  InternalFormat read new InternalFormat($8C4C);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT:           InternalFormat read new InternalFormat($8C4D);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV:            InternalFormat read new InternalFormat($8C4D);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT:           InternalFormat read new InternalFormat($8C4E);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV:            InternalFormat read new InternalFormat($8C4E);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT:           InternalFormat read new InternalFormat($8C4F);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV:            InternalFormat read new InternalFormat($8C4F);
    public static property DEPTH_COMPONENT32F:                            InternalFormat read new InternalFormat($8CAC);
    public static property DEPTH32F_STENCIL8:                             InternalFormat read new InternalFormat($8CAD);
    public static property STENCIL_INDEX1:                                InternalFormat read new InternalFormat($8D46);
    public static property STENCIL_INDEX1_EXT:                            InternalFormat read new InternalFormat($8D46);
    public static property STENCIL_INDEX1_OES:                            InternalFormat read new InternalFormat($8D46);
    public static property STENCIL_INDEX4:                                InternalFormat read new InternalFormat($8D47);
    public static property STENCIL_INDEX4_EXT:                            InternalFormat read new InternalFormat($8D47);
    public static property STENCIL_INDEX4_OES:                            InternalFormat read new InternalFormat($8D47);
    public static property STENCIL_INDEX8:                                InternalFormat read new InternalFormat($8D48);
    public static property STENCIL_INDEX8_EXT:                            InternalFormat read new InternalFormat($8D48);
    public static property STENCIL_INDEX8_OES:                            InternalFormat read new InternalFormat($8D48);
    public static property STENCIL_INDEX16:                               InternalFormat read new InternalFormat($8D49);
    public static property STENCIL_INDEX16_EXT:                           InternalFormat read new InternalFormat($8D49);
    public static property RGB565:                                        InternalFormat read new InternalFormat($8D62);
    public static property RGB565_OES:                                    InternalFormat read new InternalFormat($8D62);
    public static property ETC1_RGB8_OES:                                 InternalFormat read new InternalFormat($8D64);
    public static property RGBA32UI:                                      InternalFormat read new InternalFormat($8D70);
    public static property RGBA32UI_EXT:                                  InternalFormat read new InternalFormat($8D70);
    public static property RGB32UI:                                       InternalFormat read new InternalFormat($8D71);
    public static property RGB32UI_EXT:                                   InternalFormat read new InternalFormat($8D71);
    public static property ALPHA32UI_EXT:                                 InternalFormat read new InternalFormat($8D72);
    public static property INTENSITY32UI_EXT:                             InternalFormat read new InternalFormat($8D73);
    public static property LUMINANCE32UI_EXT:                             InternalFormat read new InternalFormat($8D74);
    public static property LUMINANCE_ALPHA32UI_EXT:                       InternalFormat read new InternalFormat($8D75);
    public static property RGBA16UI:                                      InternalFormat read new InternalFormat($8D76);
    public static property RGBA16UI_EXT:                                  InternalFormat read new InternalFormat($8D76);
    public static property RGB16UI:                                       InternalFormat read new InternalFormat($8D77);
    public static property RGB16UI_EXT:                                   InternalFormat read new InternalFormat($8D77);
    public static property ALPHA16UI_EXT:                                 InternalFormat read new InternalFormat($8D78);
    public static property INTENSITY16UI_EXT:                             InternalFormat read new InternalFormat($8D79);
    public static property LUMINANCE16UI_EXT:                             InternalFormat read new InternalFormat($8D7A);
    public static property LUMINANCE_ALPHA16UI_EXT:                       InternalFormat read new InternalFormat($8D7B);
    public static property RGBA8UI:                                       InternalFormat read new InternalFormat($8D7C);
    public static property RGBA8UI_EXT:                                   InternalFormat read new InternalFormat($8D7C);
    public static property RGB8UI:                                        InternalFormat read new InternalFormat($8D7D);
    public static property RGB8UI_EXT:                                    InternalFormat read new InternalFormat($8D7D);
    public static property ALPHA8UI_EXT:                                  InternalFormat read new InternalFormat($8D7E);
    public static property INTENSITY8UI_EXT:                              InternalFormat read new InternalFormat($8D7F);
    public static property LUMINANCE8UI_EXT:                              InternalFormat read new InternalFormat($8D80);
    public static property LUMINANCE_ALPHA8UI_EXT:                        InternalFormat read new InternalFormat($8D81);
    public static property RGBA32I:                                       InternalFormat read new InternalFormat($8D82);
    public static property RGBA32I_EXT:                                   InternalFormat read new InternalFormat($8D82);
    public static property RGB32I:                                        InternalFormat read new InternalFormat($8D83);
    public static property RGB32I_EXT:                                    InternalFormat read new InternalFormat($8D83);
    public static property ALPHA32I_EXT:                                  InternalFormat read new InternalFormat($8D84);
    public static property INTENSITY32I_EXT:                              InternalFormat read new InternalFormat($8D85);
    public static property LUMINANCE32I_EXT:                              InternalFormat read new InternalFormat($8D86);
    public static property LUMINANCE_ALPHA32I_EXT:                        InternalFormat read new InternalFormat($8D87);
    public static property RGBA16I:                                       InternalFormat read new InternalFormat($8D88);
    public static property RGBA16I_EXT:                                   InternalFormat read new InternalFormat($8D88);
    public static property RGB16I:                                        InternalFormat read new InternalFormat($8D89);
    public static property RGB16I_EXT:                                    InternalFormat read new InternalFormat($8D89);
    public static property ALPHA16I_EXT:                                  InternalFormat read new InternalFormat($8D8A);
    public static property INTENSITY16I_EXT:                              InternalFormat read new InternalFormat($8D8B);
    public static property LUMINANCE16I_EXT:                              InternalFormat read new InternalFormat($8D8C);
    public static property LUMINANCE_ALPHA16I_EXT:                        InternalFormat read new InternalFormat($8D8D);
    public static property RGBA8I:                                        InternalFormat read new InternalFormat($8D8E);
    public static property RGBA8I_EXT:                                    InternalFormat read new InternalFormat($8D8E);
    public static property RGB8I:                                         InternalFormat read new InternalFormat($8D8F);
    public static property RGB8I_EXT:                                     InternalFormat read new InternalFormat($8D8F);
    public static property ALPHA8I_EXT:                                   InternalFormat read new InternalFormat($8D90);
    public static property INTENSITY8I_EXT:                               InternalFormat read new InternalFormat($8D91);
    public static property LUMINANCE8I_EXT:                               InternalFormat read new InternalFormat($8D92);
    public static property LUMINANCE_ALPHA8I_EXT:                         InternalFormat read new InternalFormat($8D93);
    public static property DEPTH_COMPONENT32F_NV:                         InternalFormat read new InternalFormat($8DAB);
    public static property DEPTH32F_STENCIL8_NV:                          InternalFormat read new InternalFormat($8DAC);
    public static property COMPRESSED_RED_RGTC1:                          InternalFormat read new InternalFormat($8DBB);
    public static property COMPRESSED_RED_RGTC1_EXT:                      InternalFormat read new InternalFormat($8DBB);
    public static property COMPRESSED_SIGNED_RED_RGTC1:                   InternalFormat read new InternalFormat($8DBC);
    public static property COMPRESSED_SIGNED_RED_RGTC1_EXT:               InternalFormat read new InternalFormat($8DBC);
    public static property COMPRESSED_RED_GREEN_RGTC2_EXT:                InternalFormat read new InternalFormat($8DBD);
    public static property COMPRESSED_RG_RGTC2:                           InternalFormat read new InternalFormat($8DBD);
    public static property COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT:         InternalFormat read new InternalFormat($8DBE);
    public static property COMPRESSED_SIGNED_RG_RGTC2:                    InternalFormat read new InternalFormat($8DBE);
    public static property COMPRESSED_RGBA_BPTC_UNORM:                    InternalFormat read new InternalFormat($8E8C);
    public static property COMPRESSED_RGBA_BPTC_UNORM_ARB:                InternalFormat read new InternalFormat($8E8C);
    public static property COMPRESSED_RGBA_BPTC_UNORM_EXT:                InternalFormat read new InternalFormat($8E8C);
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM:              InternalFormat read new InternalFormat($8E8D);
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB:          InternalFormat read new InternalFormat($8E8D);
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT:          InternalFormat read new InternalFormat($8E8D);
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT:              InternalFormat read new InternalFormat($8E8E);
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB:          InternalFormat read new InternalFormat($8E8E);
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT:          InternalFormat read new InternalFormat($8E8E);
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT:            InternalFormat read new InternalFormat($8E8F);
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB:        InternalFormat read new InternalFormat($8E8F);
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT:        InternalFormat read new InternalFormat($8E8F);
    public static property R8_SNORM:                                      InternalFormat read new InternalFormat($8F94);
    public static property RG8_SNORM:                                     InternalFormat read new InternalFormat($8F95);
    public static property RGB8_SNORM:                                    InternalFormat read new InternalFormat($8F96);
    public static property RGBA8_SNORM:                                   InternalFormat read new InternalFormat($8F97);
    public static property R16_SNORM:                                     InternalFormat read new InternalFormat($8F98);
    public static property R16_SNORM_EXT:                                 InternalFormat read new InternalFormat($8F98);
    public static property RG16_SNORM:                                    InternalFormat read new InternalFormat($8F99);
    public static property RG16_SNORM_EXT:                                InternalFormat read new InternalFormat($8F99);
    public static property RGB16_SNORM:                                   InternalFormat read new InternalFormat($8F9A);
    public static property RGB16_SNORM_EXT:                               InternalFormat read new InternalFormat($8F9A);
    public static property RGBA16_SNORM:                                  InternalFormat read new InternalFormat($8F9B);
    public static property RGBA16_SNORM_EXT:                              InternalFormat read new InternalFormat($8F9B);
    public static property SR8_EXT:                                       InternalFormat read new InternalFormat($8FBD);
    public static property SRG8_EXT:                                      InternalFormat read new InternalFormat($8FBE);
    public static property RGB10_A2UI:                                    InternalFormat read new InternalFormat($906F);
    public static property COMPRESSED_R11_EAC:                            InternalFormat read new InternalFormat($9270);
    public static property COMPRESSED_R11_EAC_OES:                        InternalFormat read new InternalFormat($9270);
    public static property COMPRESSED_SIGNED_R11_EAC:                     InternalFormat read new InternalFormat($9271);
    public static property COMPRESSED_SIGNED_R11_EAC_OES:                 InternalFormat read new InternalFormat($9271);
    public static property COMPRESSED_RG11_EAC:                           InternalFormat read new InternalFormat($9272);
    public static property COMPRESSED_RG11_EAC_OES:                       InternalFormat read new InternalFormat($9272);
    public static property COMPRESSED_SIGNED_RG11_EAC:                    InternalFormat read new InternalFormat($9273);
    public static property COMPRESSED_SIGNED_RG11_EAC_OES:                InternalFormat read new InternalFormat($9273);
    public static property COMPRESSED_RGB8_ETC2:                          InternalFormat read new InternalFormat($9274);
    public static property COMPRESSED_RGB8_ETC2_OES:                      InternalFormat read new InternalFormat($9274);
    public static property COMPRESSED_SRGB8_ETC2:                         InternalFormat read new InternalFormat($9275);
    public static property COMPRESSED_SRGB8_ETC2_OES:                     InternalFormat read new InternalFormat($9275);
    public static property COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:      InternalFormat read new InternalFormat($9276);
    public static property COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES:  InternalFormat read new InternalFormat($9276);
    public static property COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:     InternalFormat read new InternalFormat($9277);
    public static property COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES: InternalFormat read new InternalFormat($9277);
    public static property COMPRESSED_RGBA8_ETC2_EAC:                     InternalFormat read new InternalFormat($9278);
    public static property COMPRESSED_RGBA8_ETC2_EAC_OES:                 InternalFormat read new InternalFormat($9278);
    public static property COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:              InternalFormat read new InternalFormat($9279);
    public static property COMPRESSED_SRGB8_ALPHA8_ETC2_EAC_OES:          InternalFormat read new InternalFormat($9279);
    public static property COMPRESSED_RGBA_ASTC_4x4:                      InternalFormat read new InternalFormat($93B0);
    public static property COMPRESSED_RGBA_ASTC_4x4_KHR:                  InternalFormat read new InternalFormat($93B0);
    public static property COMPRESSED_RGBA_ASTC_5x4:                      InternalFormat read new InternalFormat($93B1);
    public static property COMPRESSED_RGBA_ASTC_5x4_KHR:                  InternalFormat read new InternalFormat($93B1);
    public static property COMPRESSED_RGBA_ASTC_5x5:                      InternalFormat read new InternalFormat($93B2);
    public static property COMPRESSED_RGBA_ASTC_5x5_KHR:                  InternalFormat read new InternalFormat($93B2);
    public static property COMPRESSED_RGBA_ASTC_6x5:                      InternalFormat read new InternalFormat($93B3);
    public static property COMPRESSED_RGBA_ASTC_6x5_KHR:                  InternalFormat read new InternalFormat($93B3);
    public static property COMPRESSED_RGBA_ASTC_6x6:                      InternalFormat read new InternalFormat($93B4);
    public static property COMPRESSED_RGBA_ASTC_6x6_KHR:                  InternalFormat read new InternalFormat($93B4);
    public static property COMPRESSED_RGBA_ASTC_8x5:                      InternalFormat read new InternalFormat($93B5);
    public static property COMPRESSED_RGBA_ASTC_8x5_KHR:                  InternalFormat read new InternalFormat($93B5);
    public static property COMPRESSED_RGBA_ASTC_8x6:                      InternalFormat read new InternalFormat($93B6);
    public static property COMPRESSED_RGBA_ASTC_8x6_KHR:                  InternalFormat read new InternalFormat($93B6);
    public static property COMPRESSED_RGBA_ASTC_8x8:                      InternalFormat read new InternalFormat($93B7);
    public static property COMPRESSED_RGBA_ASTC_8x8_KHR:                  InternalFormat read new InternalFormat($93B7);
    public static property COMPRESSED_RGBA_ASTC_10x5:                     InternalFormat read new InternalFormat($93B8);
    public static property COMPRESSED_RGBA_ASTC_10x5_KHR:                 InternalFormat read new InternalFormat($93B8);
    public static property COMPRESSED_RGBA_ASTC_10x6:                     InternalFormat read new InternalFormat($93B9);
    public static property COMPRESSED_RGBA_ASTC_10x6_KHR:                 InternalFormat read new InternalFormat($93B9);
    public static property COMPRESSED_RGBA_ASTC_10x8:                     InternalFormat read new InternalFormat($93BA);
    public static property COMPRESSED_RGBA_ASTC_10x8_KHR:                 InternalFormat read new InternalFormat($93BA);
    public static property COMPRESSED_RGBA_ASTC_10x10:                    InternalFormat read new InternalFormat($93BB);
    public static property COMPRESSED_RGBA_ASTC_10x10_KHR:                InternalFormat read new InternalFormat($93BB);
    public static property COMPRESSED_RGBA_ASTC_12x10:                    InternalFormat read new InternalFormat($93BC);
    public static property COMPRESSED_RGBA_ASTC_12x10_KHR:                InternalFormat read new InternalFormat($93BC);
    public static property COMPRESSED_RGBA_ASTC_12x12:                    InternalFormat read new InternalFormat($93BD);
    public static property COMPRESSED_RGBA_ASTC_12x12_KHR:                InternalFormat read new InternalFormat($93BD);
    public static property COMPRESSED_RGBA_ASTC_3x3x3_OES:                InternalFormat read new InternalFormat($93C0);
    public static property COMPRESSED_RGBA_ASTC_4x3x3_OES:                InternalFormat read new InternalFormat($93C1);
    public static property COMPRESSED_RGBA_ASTC_4x4x3_OES:                InternalFormat read new InternalFormat($93C2);
    public static property COMPRESSED_RGBA_ASTC_4x4x4_OES:                InternalFormat read new InternalFormat($93C3);
    public static property COMPRESSED_RGBA_ASTC_5x4x4_OES:                InternalFormat read new InternalFormat($93C4);
    public static property COMPRESSED_RGBA_ASTC_5x5x4_OES:                InternalFormat read new InternalFormat($93C5);
    public static property COMPRESSED_RGBA_ASTC_5x5x5_OES:                InternalFormat read new InternalFormat($93C6);
    public static property COMPRESSED_RGBA_ASTC_6x5x5_OES:                InternalFormat read new InternalFormat($93C7);
    public static property COMPRESSED_RGBA_ASTC_6x6x5_OES:                InternalFormat read new InternalFormat($93C8);
    public static property COMPRESSED_RGBA_ASTC_6x6x6_OES:                InternalFormat read new InternalFormat($93C9);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4:              InternalFormat read new InternalFormat($93D0);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR:          InternalFormat read new InternalFormat($93D0);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4:              InternalFormat read new InternalFormat($93D1);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR:          InternalFormat read new InternalFormat($93D1);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5:              InternalFormat read new InternalFormat($93D2);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR:          InternalFormat read new InternalFormat($93D2);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5:              InternalFormat read new InternalFormat($93D3);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR:          InternalFormat read new InternalFormat($93D3);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6:              InternalFormat read new InternalFormat($93D4);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR:          InternalFormat read new InternalFormat($93D4);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x5:              InternalFormat read new InternalFormat($93D5);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR:          InternalFormat read new InternalFormat($93D5);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x6:              InternalFormat read new InternalFormat($93D6);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR:          InternalFormat read new InternalFormat($93D6);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x8:              InternalFormat read new InternalFormat($93D7);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR:          InternalFormat read new InternalFormat($93D7);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x5:             InternalFormat read new InternalFormat($93D8);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR:         InternalFormat read new InternalFormat($93D8);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x6:             InternalFormat read new InternalFormat($93D9);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR:         InternalFormat read new InternalFormat($93D9);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x8:             InternalFormat read new InternalFormat($93DA);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR:         InternalFormat read new InternalFormat($93DA);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x10:            InternalFormat read new InternalFormat($93DB);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR:        InternalFormat read new InternalFormat($93DB);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x10:            InternalFormat read new InternalFormat($93DC);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR:        InternalFormat read new InternalFormat($93DC);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x12:            InternalFormat read new InternalFormat($93DD);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR:        InternalFormat read new InternalFormat($93DD);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES:        InternalFormat read new InternalFormat($93E0);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES:        InternalFormat read new InternalFormat($93E1);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES:        InternalFormat read new InternalFormat($93E2);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES:        InternalFormat read new InternalFormat($93E3);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES:        InternalFormat read new InternalFormat($93E4);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES:        InternalFormat read new InternalFormat($93E5);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES:        InternalFormat read new InternalFormat($93E6);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES:        InternalFormat read new InternalFormat($93E7);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES:        InternalFormat read new InternalFormat($93E8);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES:        InternalFormat read new InternalFormat($93E9);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1901) then Result := 'STENCIL_INDEX' else
      if self.val = UInt32($1901) then Result := 'STENCIL_INDEX_OES' else
      if self.val = UInt32($1902) then Result := 'DEPTH_COMPONENT' else
      if self.val = UInt32($1903) then Result := 'RED' else
      if self.val = UInt32($1903) then Result := 'RED_EXT' else
      if self.val = UInt32($1907) then Result := 'RGB' else
      if self.val = UInt32($1908) then Result := 'RGBA' else
      if self.val = UInt32($2A10) then Result := 'R3_G3_B2' else
      if self.val = UInt32($803B) then Result := 'ALPHA4' else
      if self.val = UInt32($803B) then Result := 'ALPHA4_EXT' else
      if self.val = UInt32($803C) then Result := 'ALPHA8' else
      if self.val = UInt32($803C) then Result := 'ALPHA8_EXT' else
      if self.val = UInt32($803C) then Result := 'ALPHA8_OES' else
      if self.val = UInt32($803D) then Result := 'ALPHA12' else
      if self.val = UInt32($803D) then Result := 'ALPHA12_EXT' else
      if self.val = UInt32($803E) then Result := 'ALPHA16' else
      if self.val = UInt32($803E) then Result := 'ALPHA16_EXT' else
      if self.val = UInt32($803F) then Result := 'LUMINANCE4' else
      if self.val = UInt32($803F) then Result := 'LUMINANCE4_EXT' else
      if self.val = UInt32($8040) then Result := 'LUMINANCE8' else
      if self.val = UInt32($8040) then Result := 'LUMINANCE8_EXT' else
      if self.val = UInt32($8040) then Result := 'LUMINANCE8_OES' else
      if self.val = UInt32($8041) then Result := 'LUMINANCE12' else
      if self.val = UInt32($8041) then Result := 'LUMINANCE12_EXT' else
      if self.val = UInt32($8042) then Result := 'LUMINANCE16' else
      if self.val = UInt32($8042) then Result := 'LUMINANCE16_EXT' else
      if self.val = UInt32($8043) then Result := 'LUMINANCE4_ALPHA4' else
      if self.val = UInt32($8043) then Result := 'LUMINANCE4_ALPHA4_EXT' else
      if self.val = UInt32($8043) then Result := 'LUMINANCE4_ALPHA4_OES' else
      if self.val = UInt32($8044) then Result := 'LUMINANCE6_ALPHA2' else
      if self.val = UInt32($8044) then Result := 'LUMINANCE6_ALPHA2_EXT' else
      if self.val = UInt32($8045) then Result := 'LUMINANCE8_ALPHA8' else
      if self.val = UInt32($8045) then Result := 'LUMINANCE8_ALPHA8_EXT' else
      if self.val = UInt32($8045) then Result := 'LUMINANCE8_ALPHA8_OES' else
      if self.val = UInt32($8046) then Result := 'LUMINANCE12_ALPHA4' else
      if self.val = UInt32($8046) then Result := 'LUMINANCE12_ALPHA4_EXT' else
      if self.val = UInt32($8047) then Result := 'LUMINANCE12_ALPHA12' else
      if self.val = UInt32($8047) then Result := 'LUMINANCE12_ALPHA12_EXT' else
      if self.val = UInt32($8048) then Result := 'LUMINANCE16_ALPHA16' else
      if self.val = UInt32($8048) then Result := 'LUMINANCE16_ALPHA16_EXT' else
      if self.val = UInt32($8049) then Result := 'INTENSITY' else
      if self.val = UInt32($804A) then Result := 'INTENSITY4' else
      if self.val = UInt32($804A) then Result := 'INTENSITY4_EXT' else
      if self.val = UInt32($804B) then Result := 'INTENSITY8' else
      if self.val = UInt32($804B) then Result := 'INTENSITY8_EXT' else
      if self.val = UInt32($804C) then Result := 'INTENSITY12' else
      if self.val = UInt32($804C) then Result := 'INTENSITY12_EXT' else
      if self.val = UInt32($804D) then Result := 'INTENSITY16' else
      if self.val = UInt32($804D) then Result := 'INTENSITY16_EXT' else
      if self.val = UInt32($804E) then Result := 'RGB2_EXT' else
      if self.val = UInt32($804F) then Result := 'RGB4' else
      if self.val = UInt32($804F) then Result := 'RGB4_EXT' else
      if self.val = UInt32($8050) then Result := 'RGB5' else
      if self.val = UInt32($8050) then Result := 'RGB5_EXT' else
      if self.val = UInt32($8051) then Result := 'RGB8' else
      if self.val = UInt32($8051) then Result := 'RGB8_EXT' else
      if self.val = UInt32($8051) then Result := 'RGB8_OES' else
      if self.val = UInt32($8052) then Result := 'RGB10' else
      if self.val = UInt32($8052) then Result := 'RGB10_EXT' else
      if self.val = UInt32($8053) then Result := 'RGB12' else
      if self.val = UInt32($8053) then Result := 'RGB12_EXT' else
      if self.val = UInt32($8054) then Result := 'RGB16' else
      if self.val = UInt32($8054) then Result := 'RGB16_EXT' else
      if self.val = UInt32($8055) then Result := 'RGBA2' else
      if self.val = UInt32($8055) then Result := 'RGBA2_EXT' else
      if self.val = UInt32($8056) then Result := 'RGBA4' else
      if self.val = UInt32($8056) then Result := 'RGBA4_EXT' else
      if self.val = UInt32($8056) then Result := 'RGBA4_OES' else
      if self.val = UInt32($8057) then Result := 'RGB5_A1' else
      if self.val = UInt32($8057) then Result := 'RGB5_A1_EXT' else
      if self.val = UInt32($8057) then Result := 'RGB5_A1_OES' else
      if self.val = UInt32($8058) then Result := 'RGBA8' else
      if self.val = UInt32($8058) then Result := 'RGBA8_EXT' else
      if self.val = UInt32($8058) then Result := 'RGBA8_OES' else
      if self.val = UInt32($8059) then Result := 'RGB10_A2' else
      if self.val = UInt32($8059) then Result := 'RGB10_A2_EXT' else
      if self.val = UInt32($805A) then Result := 'RGBA12' else
      if self.val = UInt32($805A) then Result := 'RGBA12_EXT' else
      if self.val = UInt32($805B) then Result := 'RGBA16' else
      if self.val = UInt32($805B) then Result := 'RGBA16_EXT' else
      if self.val = UInt32($8110) then Result := 'DUAL_ALPHA4_SGIS' else
      if self.val = UInt32($8111) then Result := 'DUAL_ALPHA8_SGIS' else
      if self.val = UInt32($8112) then Result := 'DUAL_ALPHA12_SGIS' else
      if self.val = UInt32($8113) then Result := 'DUAL_ALPHA16_SGIS' else
      if self.val = UInt32($8114) then Result := 'DUAL_LUMINANCE4_SGIS' else
      if self.val = UInt32($8115) then Result := 'DUAL_LUMINANCE8_SGIS' else
      if self.val = UInt32($8116) then Result := 'DUAL_LUMINANCE12_SGIS' else
      if self.val = UInt32($8117) then Result := 'DUAL_LUMINANCE16_SGIS' else
      if self.val = UInt32($8118) then Result := 'DUAL_INTENSITY4_SGIS' else
      if self.val = UInt32($8119) then Result := 'DUAL_INTENSITY8_SGIS' else
      if self.val = UInt32($811A) then Result := 'DUAL_INTENSITY12_SGIS' else
      if self.val = UInt32($811B) then Result := 'DUAL_INTENSITY16_SGIS' else
      if self.val = UInt32($811C) then Result := 'DUAL_LUMINANCE_ALPHA4_SGIS' else
      if self.val = UInt32($811D) then Result := 'DUAL_LUMINANCE_ALPHA8_SGIS' else
      if self.val = UInt32($811E) then Result := 'QUAD_ALPHA4_SGIS' else
      if self.val = UInt32($811F) then Result := 'QUAD_ALPHA8_SGIS' else
      if self.val = UInt32($8120) then Result := 'QUAD_LUMINANCE4_SGIS' else
      if self.val = UInt32($8121) then Result := 'QUAD_LUMINANCE8_SGIS' else
      if self.val = UInt32($8122) then Result := 'QUAD_INTENSITY4_SGIS' else
      if self.val = UInt32($8123) then Result := 'QUAD_INTENSITY8_SGIS' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16_ARB' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16_OES' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16_SGIX' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24_ARB' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24_OES' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24_SGIX' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32_ARB' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32_OES' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32_SGIX' else
      if self.val = UInt32($8225) then Result := 'COMPRESSED_RED' else
      if self.val = UInt32($8226) then Result := 'COMPRESSED_RG' else
      if self.val = UInt32($8227) then Result := 'RG' else
      if self.val = UInt32($8229) then Result := 'R8' else
      if self.val = UInt32($8229) then Result := 'R8_EXT' else
      if self.val = UInt32($822A) then Result := 'R16' else
      if self.val = UInt32($822A) then Result := 'R16_EXT' else
      if self.val = UInt32($822B) then Result := 'RG8' else
      if self.val = UInt32($822B) then Result := 'RG8_EXT' else
      if self.val = UInt32($822C) then Result := 'RG16' else
      if self.val = UInt32($822C) then Result := 'RG16_EXT' else
      if self.val = UInt32($822D) then Result := 'R16F' else
      if self.val = UInt32($822D) then Result := 'R16F_EXT' else
      if self.val = UInt32($822E) then Result := 'R32F' else
      if self.val = UInt32($822E) then Result := 'R32F_EXT' else
      if self.val = UInt32($822F) then Result := 'RG16F' else
      if self.val = UInt32($822F) then Result := 'RG16F_EXT' else
      if self.val = UInt32($8230) then Result := 'RG32F' else
      if self.val = UInt32($8230) then Result := 'RG32F_EXT' else
      if self.val = UInt32($8231) then Result := 'R8I' else
      if self.val = UInt32($8232) then Result := 'R8UI' else
      if self.val = UInt32($8233) then Result := 'R16I' else
      if self.val = UInt32($8234) then Result := 'R16UI' else
      if self.val = UInt32($8235) then Result := 'R32I' else
      if self.val = UInt32($8236) then Result := 'R32UI' else
      if self.val = UInt32($8237) then Result := 'RG8I' else
      if self.val = UInt32($8238) then Result := 'RG8UI' else
      if self.val = UInt32($8239) then Result := 'RG16I' else
      if self.val = UInt32($823A) then Result := 'RG16UI' else
      if self.val = UInt32($823B) then Result := 'RG32I' else
      if self.val = UInt32($823C) then Result := 'RG32UI' else
      if self.val = UInt32($83F0) then Result := 'COMPRESSED_RGB_S3TC_DXT1_EXT' else
      if self.val = UInt32($83F1) then Result := 'COMPRESSED_RGBA_S3TC_DXT1_EXT' else
      if self.val = UInt32($83F2) then Result := 'COMPRESSED_RGBA_S3TC_DXT3_ANGLE' else
      if self.val = UInt32($83F2) then Result := 'COMPRESSED_RGBA_S3TC_DXT3_EXT' else
      if self.val = UInt32($83F3) then Result := 'COMPRESSED_RGBA_S3TC_DXT5_ANGLE' else
      if self.val = UInt32($83F3) then Result := 'COMPRESSED_RGBA_S3TC_DXT5_EXT' else
      if self.val = UInt32($84ED) then Result := 'COMPRESSED_RGB' else
      if self.val = UInt32($84EE) then Result := 'COMPRESSED_RGBA' else
      if self.val = UInt32($84F9) then Result := 'DEPTH_STENCIL' else
      if self.val = UInt32($84F9) then Result := 'DEPTH_STENCIL_EXT' else
      if self.val = UInt32($84F9) then Result := 'DEPTH_STENCIL_NV' else
      if self.val = UInt32($84F9) then Result := 'DEPTH_STENCIL_OES' else
      if self.val = UInt32($8750) then Result := 'DEPTH_STENCIL_MESA' else
      if self.val = UInt32($8814) then Result := 'RGBA32F' else
      if self.val = UInt32($8814) then Result := 'RGBA32F_ARB' else
      if self.val = UInt32($8814) then Result := 'RGBA32F_EXT' else
      if self.val = UInt32($8815) then Result := 'RGB32F' else
      if self.val = UInt32($8815) then Result := 'RGB32F_ARB' else
      if self.val = UInt32($8815) then Result := 'RGB32F_EXT' else
      if self.val = UInt32($881A) then Result := 'RGBA16F' else
      if self.val = UInt32($881A) then Result := 'RGBA16F_ARB' else
      if self.val = UInt32($881A) then Result := 'RGBA16F_EXT' else
      if self.val = UInt32($881B) then Result := 'RGB16F' else
      if self.val = UInt32($881B) then Result := 'RGB16F_ARB' else
      if self.val = UInt32($881B) then Result := 'RGB16F_EXT' else
      if self.val = UInt32($88F0) then Result := 'DEPTH24_STENCIL8' else
      if self.val = UInt32($88F0) then Result := 'DEPTH24_STENCIL8_EXT' else
      if self.val = UInt32($88F0) then Result := 'DEPTH24_STENCIL8_OES' else
      if self.val = UInt32($8C3A) then Result := 'R11F_G11F_B10F' else
      if self.val = UInt32($8C3A) then Result := 'R11F_G11F_B10F_APPLE' else
      if self.val = UInt32($8C3A) then Result := 'R11F_G11F_B10F_EXT' else
      if self.val = UInt32($8C3D) then Result := 'RGB9_E5' else
      if self.val = UInt32($8C3D) then Result := 'RGB9_E5_APPLE' else
      if self.val = UInt32($8C3D) then Result := 'RGB9_E5_EXT' else
      if self.val = UInt32($8C40) then Result := 'SRGB' else
      if self.val = UInt32($8C40) then Result := 'SRGB_EXT' else
      if self.val = UInt32($8C41) then Result := 'SRGB8' else
      if self.val = UInt32($8C41) then Result := 'SRGB8_EXT' else
      if self.val = UInt32($8C41) then Result := 'SRGB8_NV' else
      if self.val = UInt32($8C42) then Result := 'SRGB_ALPHA' else
      if self.val = UInt32($8C42) then Result := 'SRGB_ALPHA_EXT' else
      if self.val = UInt32($8C43) then Result := 'SRGB8_ALPHA8' else
      if self.val = UInt32($8C43) then Result := 'SRGB8_ALPHA8_EXT' else
      if self.val = UInt32($8C48) then Result := 'COMPRESSED_SRGB' else
      if self.val = UInt32($8C49) then Result := 'COMPRESSED_SRGB_ALPHA' else
      if self.val = UInt32($8C4C) then Result := 'COMPRESSED_SRGB_S3TC_DXT1_EXT' else
      if self.val = UInt32($8C4C) then Result := 'COMPRESSED_SRGB_S3TC_DXT1_NV' else
      if self.val = UInt32($8C4D) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT' else
      if self.val = UInt32($8C4D) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV' else
      if self.val = UInt32($8C4E) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT' else
      if self.val = UInt32($8C4E) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV' else
      if self.val = UInt32($8C4F) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT' else
      if self.val = UInt32($8C4F) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV' else
      if self.val = UInt32($8CAC) then Result := 'DEPTH_COMPONENT32F' else
      if self.val = UInt32($8CAD) then Result := 'DEPTH32F_STENCIL8' else
      if self.val = UInt32($8D46) then Result := 'STENCIL_INDEX1' else
      if self.val = UInt32($8D46) then Result := 'STENCIL_INDEX1_EXT' else
      if self.val = UInt32($8D46) then Result := 'STENCIL_INDEX1_OES' else
      if self.val = UInt32($8D47) then Result := 'STENCIL_INDEX4' else
      if self.val = UInt32($8D47) then Result := 'STENCIL_INDEX4_EXT' else
      if self.val = UInt32($8D47) then Result := 'STENCIL_INDEX4_OES' else
      if self.val = UInt32($8D48) then Result := 'STENCIL_INDEX8' else
      if self.val = UInt32($8D48) then Result := 'STENCIL_INDEX8_EXT' else
      if self.val = UInt32($8D48) then Result := 'STENCIL_INDEX8_OES' else
      if self.val = UInt32($8D49) then Result := 'STENCIL_INDEX16' else
      if self.val = UInt32($8D49) then Result := 'STENCIL_INDEX16_EXT' else
      if self.val = UInt32($8D62) then Result := 'RGB565' else
      if self.val = UInt32($8D62) then Result := 'RGB565_OES' else
      if self.val = UInt32($8D64) then Result := 'ETC1_RGB8_OES' else
      if self.val = UInt32($8D70) then Result := 'RGBA32UI' else
      if self.val = UInt32($8D70) then Result := 'RGBA32UI_EXT' else
      if self.val = UInt32($8D71) then Result := 'RGB32UI' else
      if self.val = UInt32($8D71) then Result := 'RGB32UI_EXT' else
      if self.val = UInt32($8D72) then Result := 'ALPHA32UI_EXT' else
      if self.val = UInt32($8D73) then Result := 'INTENSITY32UI_EXT' else
      if self.val = UInt32($8D74) then Result := 'LUMINANCE32UI_EXT' else
      if self.val = UInt32($8D75) then Result := 'LUMINANCE_ALPHA32UI_EXT' else
      if self.val = UInt32($8D76) then Result := 'RGBA16UI' else
      if self.val = UInt32($8D76) then Result := 'RGBA16UI_EXT' else
      if self.val = UInt32($8D77) then Result := 'RGB16UI' else
      if self.val = UInt32($8D77) then Result := 'RGB16UI_EXT' else
      if self.val = UInt32($8D78) then Result := 'ALPHA16UI_EXT' else
      if self.val = UInt32($8D79) then Result := 'INTENSITY16UI_EXT' else
      if self.val = UInt32($8D7A) then Result := 'LUMINANCE16UI_EXT' else
      if self.val = UInt32($8D7B) then Result := 'LUMINANCE_ALPHA16UI_EXT' else
      if self.val = UInt32($8D7C) then Result := 'RGBA8UI' else
      if self.val = UInt32($8D7C) then Result := 'RGBA8UI_EXT' else
      if self.val = UInt32($8D7D) then Result := 'RGB8UI' else
      if self.val = UInt32($8D7D) then Result := 'RGB8UI_EXT' else
      if self.val = UInt32($8D7E) then Result := 'ALPHA8UI_EXT' else
      if self.val = UInt32($8D7F) then Result := 'INTENSITY8UI_EXT' else
      if self.val = UInt32($8D80) then Result := 'LUMINANCE8UI_EXT' else
      if self.val = UInt32($8D81) then Result := 'LUMINANCE_ALPHA8UI_EXT' else
      if self.val = UInt32($8D82) then Result := 'RGBA32I' else
      if self.val = UInt32($8D82) then Result := 'RGBA32I_EXT' else
      if self.val = UInt32($8D83) then Result := 'RGB32I' else
      if self.val = UInt32($8D83) then Result := 'RGB32I_EXT' else
      if self.val = UInt32($8D84) then Result := 'ALPHA32I_EXT' else
      if self.val = UInt32($8D85) then Result := 'INTENSITY32I_EXT' else
      if self.val = UInt32($8D86) then Result := 'LUMINANCE32I_EXT' else
      if self.val = UInt32($8D87) then Result := 'LUMINANCE_ALPHA32I_EXT' else
      if self.val = UInt32($8D88) then Result := 'RGBA16I' else
      if self.val = UInt32($8D88) then Result := 'RGBA16I_EXT' else
      if self.val = UInt32($8D89) then Result := 'RGB16I' else
      if self.val = UInt32($8D89) then Result := 'RGB16I_EXT' else
      if self.val = UInt32($8D8A) then Result := 'ALPHA16I_EXT' else
      if self.val = UInt32($8D8B) then Result := 'INTENSITY16I_EXT' else
      if self.val = UInt32($8D8C) then Result := 'LUMINANCE16I_EXT' else
      if self.val = UInt32($8D8D) then Result := 'LUMINANCE_ALPHA16I_EXT' else
      if self.val = UInt32($8D8E) then Result := 'RGBA8I' else
      if self.val = UInt32($8D8E) then Result := 'RGBA8I_EXT' else
      if self.val = UInt32($8D8F) then Result := 'RGB8I' else
      if self.val = UInt32($8D8F) then Result := 'RGB8I_EXT' else
      if self.val = UInt32($8D90) then Result := 'ALPHA8I_EXT' else
      if self.val = UInt32($8D91) then Result := 'INTENSITY8I_EXT' else
      if self.val = UInt32($8D92) then Result := 'LUMINANCE8I_EXT' else
      if self.val = UInt32($8D93) then Result := 'LUMINANCE_ALPHA8I_EXT' else
      if self.val = UInt32($8DAB) then Result := 'DEPTH_COMPONENT32F_NV' else
      if self.val = UInt32($8DAC) then Result := 'DEPTH32F_STENCIL8_NV' else
      if self.val = UInt32($8DBB) then Result := 'COMPRESSED_RED_RGTC1' else
      if self.val = UInt32($8DBB) then Result := 'COMPRESSED_RED_RGTC1_EXT' else
      if self.val = UInt32($8DBC) then Result := 'COMPRESSED_SIGNED_RED_RGTC1' else
      if self.val = UInt32($8DBC) then Result := 'COMPRESSED_SIGNED_RED_RGTC1_EXT' else
      if self.val = UInt32($8DBD) then Result := 'COMPRESSED_RED_GREEN_RGTC2_EXT' else
      if self.val = UInt32($8DBD) then Result := 'COMPRESSED_RG_RGTC2' else
      if self.val = UInt32($8DBE) then Result := 'COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT' else
      if self.val = UInt32($8DBE) then Result := 'COMPRESSED_SIGNED_RG_RGTC2' else
      if self.val = UInt32($8E8C) then Result := 'COMPRESSED_RGBA_BPTC_UNORM' else
      if self.val = UInt32($8E8C) then Result := 'COMPRESSED_RGBA_BPTC_UNORM_ARB' else
      if self.val = UInt32($8E8C) then Result := 'COMPRESSED_RGBA_BPTC_UNORM_EXT' else
      if self.val = UInt32($8E8D) then Result := 'COMPRESSED_SRGB_ALPHA_BPTC_UNORM' else
      if self.val = UInt32($8E8D) then Result := 'COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB' else
      if self.val = UInt32($8E8D) then Result := 'COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT' else
      if self.val = UInt32($8E8E) then Result := 'COMPRESSED_RGB_BPTC_SIGNED_FLOAT' else
      if self.val = UInt32($8E8E) then Result := 'COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB' else
      if self.val = UInt32($8E8E) then Result := 'COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT' else
      if self.val = UInt32($8E8F) then Result := 'COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT' else
      if self.val = UInt32($8E8F) then Result := 'COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB' else
      if self.val = UInt32($8E8F) then Result := 'COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT' else
      if self.val = UInt32($8F94) then Result := 'R8_SNORM' else
      if self.val = UInt32($8F95) then Result := 'RG8_SNORM' else
      if self.val = UInt32($8F96) then Result := 'RGB8_SNORM' else
      if self.val = UInt32($8F97) then Result := 'RGBA8_SNORM' else
      if self.val = UInt32($8F98) then Result := 'R16_SNORM' else
      if self.val = UInt32($8F98) then Result := 'R16_SNORM_EXT' else
      if self.val = UInt32($8F99) then Result := 'RG16_SNORM' else
      if self.val = UInt32($8F99) then Result := 'RG16_SNORM_EXT' else
      if self.val = UInt32($8F9A) then Result := 'RGB16_SNORM' else
      if self.val = UInt32($8F9A) then Result := 'RGB16_SNORM_EXT' else
      if self.val = UInt32($8F9B) then Result := 'RGBA16_SNORM' else
      if self.val = UInt32($8F9B) then Result := 'RGBA16_SNORM_EXT' else
      if self.val = UInt32($8FBD) then Result := 'SR8_EXT' else
      if self.val = UInt32($8FBE) then Result := 'SRG8_EXT' else
      if self.val = UInt32($906F) then Result := 'RGB10_A2UI' else
      if self.val = UInt32($9270) then Result := 'COMPRESSED_R11_EAC' else
      if self.val = UInt32($9270) then Result := 'COMPRESSED_R11_EAC_OES' else
      if self.val = UInt32($9271) then Result := 'COMPRESSED_SIGNED_R11_EAC' else
      if self.val = UInt32($9271) then Result := 'COMPRESSED_SIGNED_R11_EAC_OES' else
      if self.val = UInt32($9272) then Result := 'COMPRESSED_RG11_EAC' else
      if self.val = UInt32($9272) then Result := 'COMPRESSED_RG11_EAC_OES' else
      if self.val = UInt32($9273) then Result := 'COMPRESSED_SIGNED_RG11_EAC' else
      if self.val = UInt32($9273) then Result := 'COMPRESSED_SIGNED_RG11_EAC_OES' else
      if self.val = UInt32($9274) then Result := 'COMPRESSED_RGB8_ETC2' else
      if self.val = UInt32($9274) then Result := 'COMPRESSED_RGB8_ETC2_OES' else
      if self.val = UInt32($9275) then Result := 'COMPRESSED_SRGB8_ETC2' else
      if self.val = UInt32($9275) then Result := 'COMPRESSED_SRGB8_ETC2_OES' else
      if self.val = UInt32($9276) then Result := 'COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2' else
      if self.val = UInt32($9276) then Result := 'COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES' else
      if self.val = UInt32($9277) then Result := 'COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2' else
      if self.val = UInt32($9277) then Result := 'COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES' else
      if self.val = UInt32($9278) then Result := 'COMPRESSED_RGBA8_ETC2_EAC' else
      if self.val = UInt32($9278) then Result := 'COMPRESSED_RGBA8_ETC2_EAC_OES' else
      if self.val = UInt32($9279) then Result := 'COMPRESSED_SRGB8_ALPHA8_ETC2_EAC' else
      if self.val = UInt32($9279) then Result := 'COMPRESSED_SRGB8_ALPHA8_ETC2_EAC_OES' else
      if self.val = UInt32($93B0) then Result := 'COMPRESSED_RGBA_ASTC_4x4' else
      if self.val = UInt32($93B0) then Result := 'COMPRESSED_RGBA_ASTC_4x4_KHR' else
      if self.val = UInt32($93B1) then Result := 'COMPRESSED_RGBA_ASTC_5x4' else
      if self.val = UInt32($93B1) then Result := 'COMPRESSED_RGBA_ASTC_5x4_KHR' else
      if self.val = UInt32($93B2) then Result := 'COMPRESSED_RGBA_ASTC_5x5' else
      if self.val = UInt32($93B2) then Result := 'COMPRESSED_RGBA_ASTC_5x5_KHR' else
      if self.val = UInt32($93B3) then Result := 'COMPRESSED_RGBA_ASTC_6x5' else
      if self.val = UInt32($93B3) then Result := 'COMPRESSED_RGBA_ASTC_6x5_KHR' else
      if self.val = UInt32($93B4) then Result := 'COMPRESSED_RGBA_ASTC_6x6' else
      if self.val = UInt32($93B4) then Result := 'COMPRESSED_RGBA_ASTC_6x6_KHR' else
      if self.val = UInt32($93B5) then Result := 'COMPRESSED_RGBA_ASTC_8x5' else
      if self.val = UInt32($93B5) then Result := 'COMPRESSED_RGBA_ASTC_8x5_KHR' else
      if self.val = UInt32($93B6) then Result := 'COMPRESSED_RGBA_ASTC_8x6' else
      if self.val = UInt32($93B6) then Result := 'COMPRESSED_RGBA_ASTC_8x6_KHR' else
      if self.val = UInt32($93B7) then Result := 'COMPRESSED_RGBA_ASTC_8x8' else
      if self.val = UInt32($93B7) then Result := 'COMPRESSED_RGBA_ASTC_8x8_KHR' else
      if self.val = UInt32($93B8) then Result := 'COMPRESSED_RGBA_ASTC_10x5' else
      if self.val = UInt32($93B8) then Result := 'COMPRESSED_RGBA_ASTC_10x5_KHR' else
      if self.val = UInt32($93B9) then Result := 'COMPRESSED_RGBA_ASTC_10x6' else
      if self.val = UInt32($93B9) then Result := 'COMPRESSED_RGBA_ASTC_10x6_KHR' else
      if self.val = UInt32($93BA) then Result := 'COMPRESSED_RGBA_ASTC_10x8' else
      if self.val = UInt32($93BA) then Result := 'COMPRESSED_RGBA_ASTC_10x8_KHR' else
      if self.val = UInt32($93BB) then Result := 'COMPRESSED_RGBA_ASTC_10x10' else
      if self.val = UInt32($93BB) then Result := 'COMPRESSED_RGBA_ASTC_10x10_KHR' else
      if self.val = UInt32($93BC) then Result := 'COMPRESSED_RGBA_ASTC_12x10' else
      if self.val = UInt32($93BC) then Result := 'COMPRESSED_RGBA_ASTC_12x10_KHR' else
      if self.val = UInt32($93BD) then Result := 'COMPRESSED_RGBA_ASTC_12x12' else
      if self.val = UInt32($93BD) then Result := 'COMPRESSED_RGBA_ASTC_12x12_KHR' else
      if self.val = UInt32($93C0) then Result := 'COMPRESSED_RGBA_ASTC_3x3x3_OES' else
      if self.val = UInt32($93C1) then Result := 'COMPRESSED_RGBA_ASTC_4x3x3_OES' else
      if self.val = UInt32($93C2) then Result := 'COMPRESSED_RGBA_ASTC_4x4x3_OES' else
      if self.val = UInt32($93C3) then Result := 'COMPRESSED_RGBA_ASTC_4x4x4_OES' else
      if self.val = UInt32($93C4) then Result := 'COMPRESSED_RGBA_ASTC_5x4x4_OES' else
      if self.val = UInt32($93C5) then Result := 'COMPRESSED_RGBA_ASTC_5x5x4_OES' else
      if self.val = UInt32($93C6) then Result := 'COMPRESSED_RGBA_ASTC_5x5x5_OES' else
      if self.val = UInt32($93C7) then Result := 'COMPRESSED_RGBA_ASTC_6x5x5_OES' else
      if self.val = UInt32($93C8) then Result := 'COMPRESSED_RGBA_ASTC_6x6x5_OES' else
      if self.val = UInt32($93C9) then Result := 'COMPRESSED_RGBA_ASTC_6x6x6_OES' else
      if self.val = UInt32($93D0) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4' else
      if self.val = UInt32($93D0) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR' else
      if self.val = UInt32($93D1) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x4' else
      if self.val = UInt32($93D1) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR' else
      if self.val = UInt32($93D2) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5' else
      if self.val = UInt32($93D2) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR' else
      if self.val = UInt32($93D3) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x5' else
      if self.val = UInt32($93D3) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR' else
      if self.val = UInt32($93D4) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6' else
      if self.val = UInt32($93D4) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR' else
      if self.val = UInt32($93D5) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x5' else
      if self.val = UInt32($93D5) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR' else
      if self.val = UInt32($93D6) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x6' else
      if self.val = UInt32($93D6) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR' else
      if self.val = UInt32($93D7) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x8' else
      if self.val = UInt32($93D7) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR' else
      if self.val = UInt32($93D8) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x5' else
      if self.val = UInt32($93D8) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR' else
      if self.val = UInt32($93D9) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x6' else
      if self.val = UInt32($93D9) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR' else
      if self.val = UInt32($93DA) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x8' else
      if self.val = UInt32($93DA) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR' else
      if self.val = UInt32($93DB) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x10' else
      if self.val = UInt32($93DB) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR' else
      if self.val = UInt32($93DC) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x10' else
      if self.val = UInt32($93DC) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR' else
      if self.val = UInt32($93DD) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x12' else
      if self.val = UInt32($93DD) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR' else
      if self.val = UInt32($93E0) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES' else
      if self.val = UInt32($93E1) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES' else
      if self.val = UInt32($93E2) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES' else
      if self.val = UInt32($93E3) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES' else
      if self.val = UInt32($93E4) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES' else
      if self.val = UInt32($93E5) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES' else
      if self.val = UInt32($93E6) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES' else
      if self.val = UInt32($93E7) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES' else
      if self.val = UInt32($93E8) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES' else
      if self.val = UInt32($93E9) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES' else
        Result := $'InternalFormat[{self.val}]';
    end;
    
  end;
  
  InternalFormatPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SAMPLES:                                 InternalFormatPName read new InternalFormatPName($80A9);
    public static property GENERATE_MIPMAP:                         InternalFormatPName read new InternalFormatPName($8191);
    public static property INTERNALFORMAT_SUPPORTED:                InternalFormatPName read new InternalFormatPName($826F);
    public static property INTERNALFORMAT_PREFERRED:                InternalFormatPName read new InternalFormatPName($8270);
    public static property INTERNALFORMAT_RED_SIZE:                 InternalFormatPName read new InternalFormatPName($8271);
    public static property INTERNALFORMAT_GREEN_SIZE:               InternalFormatPName read new InternalFormatPName($8272);
    public static property INTERNALFORMAT_BLUE_SIZE:                InternalFormatPName read new InternalFormatPName($8273);
    public static property INTERNALFORMAT_ALPHA_SIZE:               InternalFormatPName read new InternalFormatPName($8274);
    public static property INTERNALFORMAT_DEPTH_SIZE:               InternalFormatPName read new InternalFormatPName($8275);
    public static property INTERNALFORMAT_STENCIL_SIZE:             InternalFormatPName read new InternalFormatPName($8276);
    public static property INTERNALFORMAT_SHARED_SIZE:              InternalFormatPName read new InternalFormatPName($8277);
    public static property INTERNALFORMAT_RED_TYPE:                 InternalFormatPName read new InternalFormatPName($8278);
    public static property INTERNALFORMAT_GREEN_TYPE:               InternalFormatPName read new InternalFormatPName($8279);
    public static property INTERNALFORMAT_BLUE_TYPE:                InternalFormatPName read new InternalFormatPName($827A);
    public static property INTERNALFORMAT_ALPHA_TYPE:               InternalFormatPName read new InternalFormatPName($827B);
    public static property INTERNALFORMAT_DEPTH_TYPE:               InternalFormatPName read new InternalFormatPName($827C);
    public static property INTERNALFORMAT_STENCIL_TYPE:             InternalFormatPName read new InternalFormatPName($827D);
    public static property MAX_WIDTH:                               InternalFormatPName read new InternalFormatPName($827E);
    public static property MAX_HEIGHT:                              InternalFormatPName read new InternalFormatPName($827F);
    public static property MAX_DEPTH:                               InternalFormatPName read new InternalFormatPName($8280);
    public static property MAX_LAYERS:                              InternalFormatPName read new InternalFormatPName($8281);
    public static property COLOR_COMPONENTS:                        InternalFormatPName read new InternalFormatPName($8283);
    public static property COLOR_RENDERABLE:                        InternalFormatPName read new InternalFormatPName($8286);
    public static property DEPTH_RENDERABLE:                        InternalFormatPName read new InternalFormatPName($8287);
    public static property STENCIL_RENDERABLE:                      InternalFormatPName read new InternalFormatPName($8288);
    public static property FRAMEBUFFER_RENDERABLE:                  InternalFormatPName read new InternalFormatPName($8289);
    public static property FRAMEBUFFER_RENDERABLE_LAYERED:          InternalFormatPName read new InternalFormatPName($828A);
    public static property FRAMEBUFFER_BLEND:                       InternalFormatPName read new InternalFormatPName($828B);
    public static property READ_PIXELS:                             InternalFormatPName read new InternalFormatPName($828C);
    public static property READ_PIXELS_FORMAT:                      InternalFormatPName read new InternalFormatPName($828D);
    public static property READ_PIXELS_TYPE:                        InternalFormatPName read new InternalFormatPName($828E);
    public static property TEXTURE_IMAGE_FORMAT:                    InternalFormatPName read new InternalFormatPName($828F);
    public static property TEXTURE_IMAGE_TYPE:                      InternalFormatPName read new InternalFormatPName($8290);
    public static property GET__TEXTURE_IMAGE_FORMAT:               InternalFormatPName read new InternalFormatPName($8291);
    public static property GET__TEXTURE_IMAGE_TYPE:                 InternalFormatPName read new InternalFormatPName($8292);
    public static property MIPMAP:                                  InternalFormatPName read new InternalFormatPName($8293);
    public static property AUTO_GENERATE_MIPMAP:                    InternalFormatPName read new InternalFormatPName($8295);
    public static property COLOR_ENCODING:                          InternalFormatPName read new InternalFormatPName($8296);
    public static property SRGB_READ:                               InternalFormatPName read new InternalFormatPName($8297);
    public static property SRGB_WRITE:                              InternalFormatPName read new InternalFormatPName($8298);
    public static property FILTER:                                  InternalFormatPName read new InternalFormatPName($829A);
    public static property VERTEX_TEXTURE:                          InternalFormatPName read new InternalFormatPName($829B);
    public static property TESS_CONTROL_TEXTURE:                    InternalFormatPName read new InternalFormatPName($829C);
    public static property TESS_EVALUATION_TEXTURE:                 InternalFormatPName read new InternalFormatPName($829D);
    public static property GEOMETRY_TEXTURE:                        InternalFormatPName read new InternalFormatPName($829E);
    public static property FRAGMENT_TEXTURE:                        InternalFormatPName read new InternalFormatPName($829F);
    public static property COMPUTE_TEXTURE:                         InternalFormatPName read new InternalFormatPName($82A0);
    public static property TEXTURE_SHADOW:                          InternalFormatPName read new InternalFormatPName($82A1);
    public static property TEXTURE_GATHER:                          InternalFormatPName read new InternalFormatPName($82A2);
    public static property TEXTURE_GATHER_SHADOW:                   InternalFormatPName read new InternalFormatPName($82A3);
    public static property SHADER_IMAGE_LOAD:                       InternalFormatPName read new InternalFormatPName($82A4);
    public static property SHADER_IMAGE_STORE:                      InternalFormatPName read new InternalFormatPName($82A5);
    public static property SHADER_IMAGE_ATOMIC:                     InternalFormatPName read new InternalFormatPName($82A6);
    public static property IMAGE_TEXEL_SIZE:                        InternalFormatPName read new InternalFormatPName($82A7);
    public static property IMAGE_COMPATIBILITY_CLASS:               InternalFormatPName read new InternalFormatPName($82A8);
    public static property IMAGE_PIXEL_FORMAT:                      InternalFormatPName read new InternalFormatPName($82A9);
    public static property IMAGE_PIXEL_TYPE:                        InternalFormatPName read new InternalFormatPName($82AA);
    public static property SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST:     InternalFormatPName read new InternalFormatPName($82AC);
    public static property SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST:   InternalFormatPName read new InternalFormatPName($82AD);
    public static property SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE:    InternalFormatPName read new InternalFormatPName($82AE);
    public static property SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE:  InternalFormatPName read new InternalFormatPName($82AF);
    public static property TEXTURE_COMPRESSED_BLOCK_WIDTH:          InternalFormatPName read new InternalFormatPName($82B1);
    public static property TEXTURE_COMPRESSED_BLOCK_HEIGHT:         InternalFormatPName read new InternalFormatPName($82B2);
    public static property TEXTURE_COMPRESSED_BLOCK_SIZE:           InternalFormatPName read new InternalFormatPName($82B3);
    public static property CLEAR_BUFFER:                            InternalFormatPName read new InternalFormatPName($82B4);
    public static property TEXTURE_VIEW:                            InternalFormatPName read new InternalFormatPName($82B5);
    public static property VIEW_COMPATIBILITY_CLASS:                InternalFormatPName read new InternalFormatPName($82B6);
    public static property TEXTURE_COMPRESSED:                      InternalFormatPName read new InternalFormatPName($86A1);
    public static property NUM_SURFACE_COMPRESSION_FIXED_RATES_EXT: InternalFormatPName read new InternalFormatPName($8F6E);
    public static property IMAGE_FORMAT_COMPATIBILITY_TYPE:         InternalFormatPName read new InternalFormatPName($90C7);
    public static property CLEAR_TEXTURE:                           InternalFormatPName read new InternalFormatPName($9365);
    public static property NUM_SAMPLE_COUNTS:                       InternalFormatPName read new InternalFormatPName($9380);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80A9) then Result := 'SAMPLES' else
      if self.val = UInt32($8191) then Result := 'GENERATE_MIPMAP' else
      if self.val = UInt32($826F) then Result := 'INTERNALFORMAT_SUPPORTED' else
      if self.val = UInt32($8270) then Result := 'INTERNALFORMAT_PREFERRED' else
      if self.val = UInt32($8271) then Result := 'INTERNALFORMAT_RED_SIZE' else
      if self.val = UInt32($8272) then Result := 'INTERNALFORMAT_GREEN_SIZE' else
      if self.val = UInt32($8273) then Result := 'INTERNALFORMAT_BLUE_SIZE' else
      if self.val = UInt32($8274) then Result := 'INTERNALFORMAT_ALPHA_SIZE' else
      if self.val = UInt32($8275) then Result := 'INTERNALFORMAT_DEPTH_SIZE' else
      if self.val = UInt32($8276) then Result := 'INTERNALFORMAT_STENCIL_SIZE' else
      if self.val = UInt32($8277) then Result := 'INTERNALFORMAT_SHARED_SIZE' else
      if self.val = UInt32($8278) then Result := 'INTERNALFORMAT_RED_TYPE' else
      if self.val = UInt32($8279) then Result := 'INTERNALFORMAT_GREEN_TYPE' else
      if self.val = UInt32($827A) then Result := 'INTERNALFORMAT_BLUE_TYPE' else
      if self.val = UInt32($827B) then Result := 'INTERNALFORMAT_ALPHA_TYPE' else
      if self.val = UInt32($827C) then Result := 'INTERNALFORMAT_DEPTH_TYPE' else
      if self.val = UInt32($827D) then Result := 'INTERNALFORMAT_STENCIL_TYPE' else
      if self.val = UInt32($827E) then Result := 'MAX_WIDTH' else
      if self.val = UInt32($827F) then Result := 'MAX_HEIGHT' else
      if self.val = UInt32($8280) then Result := 'MAX_DEPTH' else
      if self.val = UInt32($8281) then Result := 'MAX_LAYERS' else
      if self.val = UInt32($8283) then Result := 'COLOR_COMPONENTS' else
      if self.val = UInt32($8286) then Result := 'COLOR_RENDERABLE' else
      if self.val = UInt32($8287) then Result := 'DEPTH_RENDERABLE' else
      if self.val = UInt32($8288) then Result := 'STENCIL_RENDERABLE' else
      if self.val = UInt32($8289) then Result := 'FRAMEBUFFER_RENDERABLE' else
      if self.val = UInt32($828A) then Result := 'FRAMEBUFFER_RENDERABLE_LAYERED' else
      if self.val = UInt32($828B) then Result := 'FRAMEBUFFER_BLEND' else
      if self.val = UInt32($828C) then Result := 'READ_PIXELS' else
      if self.val = UInt32($828D) then Result := 'READ_PIXELS_FORMAT' else
      if self.val = UInt32($828E) then Result := 'READ_PIXELS_TYPE' else
      if self.val = UInt32($828F) then Result := 'TEXTURE_IMAGE_FORMAT' else
      if self.val = UInt32($8290) then Result := 'TEXTURE_IMAGE_TYPE' else
      if self.val = UInt32($8291) then Result := 'GET__TEXTURE_IMAGE_FORMAT' else
      if self.val = UInt32($8292) then Result := 'GET__TEXTURE_IMAGE_TYPE' else
      if self.val = UInt32($8293) then Result := 'MIPMAP' else
      if self.val = UInt32($8295) then Result := 'AUTO_GENERATE_MIPMAP' else
      if self.val = UInt32($8296) then Result := 'COLOR_ENCODING' else
      if self.val = UInt32($8297) then Result := 'SRGB_READ' else
      if self.val = UInt32($8298) then Result := 'SRGB_WRITE' else
      if self.val = UInt32($829A) then Result := 'FILTER' else
      if self.val = UInt32($829B) then Result := 'VERTEX_TEXTURE' else
      if self.val = UInt32($829C) then Result := 'TESS_CONTROL_TEXTURE' else
      if self.val = UInt32($829D) then Result := 'TESS_EVALUATION_TEXTURE' else
      if self.val = UInt32($829E) then Result := 'GEOMETRY_TEXTURE' else
      if self.val = UInt32($829F) then Result := 'FRAGMENT_TEXTURE' else
      if self.val = UInt32($82A0) then Result := 'COMPUTE_TEXTURE' else
      if self.val = UInt32($82A1) then Result := 'TEXTURE_SHADOW' else
      if self.val = UInt32($82A2) then Result := 'TEXTURE_GATHER' else
      if self.val = UInt32($82A3) then Result := 'TEXTURE_GATHER_SHADOW' else
      if self.val = UInt32($82A4) then Result := 'SHADER_IMAGE_LOAD' else
      if self.val = UInt32($82A5) then Result := 'SHADER_IMAGE_STORE' else
      if self.val = UInt32($82A6) then Result := 'SHADER_IMAGE_ATOMIC' else
      if self.val = UInt32($82A7) then Result := 'IMAGE_TEXEL_SIZE' else
      if self.val = UInt32($82A8) then Result := 'IMAGE_COMPATIBILITY_CLASS' else
      if self.val = UInt32($82A9) then Result := 'IMAGE_PIXEL_FORMAT' else
      if self.val = UInt32($82AA) then Result := 'IMAGE_PIXEL_TYPE' else
      if self.val = UInt32($82AC) then Result := 'SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST' else
      if self.val = UInt32($82AD) then Result := 'SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST' else
      if self.val = UInt32($82AE) then Result := 'SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE' else
      if self.val = UInt32($82AF) then Result := 'SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE' else
      if self.val = UInt32($82B1) then Result := 'TEXTURE_COMPRESSED_BLOCK_WIDTH' else
      if self.val = UInt32($82B2) then Result := 'TEXTURE_COMPRESSED_BLOCK_HEIGHT' else
      if self.val = UInt32($82B3) then Result := 'TEXTURE_COMPRESSED_BLOCK_SIZE' else
      if self.val = UInt32($82B4) then Result := 'CLEAR_BUFFER' else
      if self.val = UInt32($82B5) then Result := 'TEXTURE_VIEW' else
      if self.val = UInt32($82B6) then Result := 'VIEW_COMPATIBILITY_CLASS' else
      if self.val = UInt32($86A1) then Result := 'TEXTURE_COMPRESSED' else
      if self.val = UInt32($8F6E) then Result := 'NUM_SURFACE_COMPRESSION_FIXED_RATES_EXT' else
      if self.val = UInt32($90C7) then Result := 'IMAGE_FORMAT_COMPATIBILITY_TYPE' else
      if self.val = UInt32($9365) then Result := 'CLEAR_TEXTURE' else
      if self.val = UInt32($9380) then Result := 'NUM_SAMPLE_COUNTS' else
        Result := $'InternalFormatPName[{self.val}]';
    end;
    
  end;
  
  InvalidateFramebufferAttachment = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COLOR:                    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($1800);
    public static property DEPTH:                    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($1801);
    public static property STENCIL:                  InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($1802);
    public static property DEPTH_STENCIL_ATTACHMENT: InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($821A);
    public static property COLOR_ATTACHMENT0:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE0);
    public static property COLOR_ATTACHMENT0_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE0);
    public static property COLOR_ATTACHMENT0_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE0);
    public static property COLOR_ATTACHMENT0_OES:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE0);
    public static property COLOR_ATTACHMENT1:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE1);
    public static property COLOR_ATTACHMENT1_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE1);
    public static property COLOR_ATTACHMENT1_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE1);
    public static property COLOR_ATTACHMENT2:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE2);
    public static property COLOR_ATTACHMENT2_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE2);
    public static property COLOR_ATTACHMENT2_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE2);
    public static property COLOR_ATTACHMENT3:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE3);
    public static property COLOR_ATTACHMENT3_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE3);
    public static property COLOR_ATTACHMENT3_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE3);
    public static property COLOR_ATTACHMENT4:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE4);
    public static property COLOR_ATTACHMENT4_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE4);
    public static property COLOR_ATTACHMENT4_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE4);
    public static property COLOR_ATTACHMENT5:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE5);
    public static property COLOR_ATTACHMENT5_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE5);
    public static property COLOR_ATTACHMENT5_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE5);
    public static property COLOR_ATTACHMENT6:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE6);
    public static property COLOR_ATTACHMENT6_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE6);
    public static property COLOR_ATTACHMENT6_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE6);
    public static property COLOR_ATTACHMENT7:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE7);
    public static property COLOR_ATTACHMENT7_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE7);
    public static property COLOR_ATTACHMENT7_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE7);
    public static property COLOR_ATTACHMENT8:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE8);
    public static property COLOR_ATTACHMENT8_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE8);
    public static property COLOR_ATTACHMENT8_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE8);
    public static property COLOR_ATTACHMENT9:        InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE9);
    public static property COLOR_ATTACHMENT9_EXT:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE9);
    public static property COLOR_ATTACHMENT9_NV:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CE9);
    public static property COLOR_ATTACHMENT10:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEA);
    public static property COLOR_ATTACHMENT10_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEA);
    public static property COLOR_ATTACHMENT10_NV:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEA);
    public static property COLOR_ATTACHMENT11:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEB);
    public static property COLOR_ATTACHMENT11_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEB);
    public static property COLOR_ATTACHMENT11_NV:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEB);
    public static property COLOR_ATTACHMENT12:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEC);
    public static property COLOR_ATTACHMENT12_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEC);
    public static property COLOR_ATTACHMENT12_NV:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEC);
    public static property COLOR_ATTACHMENT13:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CED);
    public static property COLOR_ATTACHMENT13_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CED);
    public static property COLOR_ATTACHMENT13_NV:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CED);
    public static property COLOR_ATTACHMENT14:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEE);
    public static property COLOR_ATTACHMENT14_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEE);
    public static property COLOR_ATTACHMENT14_NV:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEE);
    public static property COLOR_ATTACHMENT15:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEF);
    public static property COLOR_ATTACHMENT15_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEF);
    public static property COLOR_ATTACHMENT15_NV:    InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CEF);
    public static property COLOR_ATTACHMENT16:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF0);
    public static property COLOR_ATTACHMENT17:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF1);
    public static property COLOR_ATTACHMENT18:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF2);
    public static property COLOR_ATTACHMENT19:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF3);
    public static property COLOR_ATTACHMENT20:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF4);
    public static property COLOR_ATTACHMENT21:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF5);
    public static property COLOR_ATTACHMENT22:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF6);
    public static property COLOR_ATTACHMENT23:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF7);
    public static property COLOR_ATTACHMENT24:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF8);
    public static property COLOR_ATTACHMENT25:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CF9);
    public static property COLOR_ATTACHMENT26:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CFA);
    public static property COLOR_ATTACHMENT27:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CFB);
    public static property COLOR_ATTACHMENT28:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CFC);
    public static property COLOR_ATTACHMENT29:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CFD);
    public static property COLOR_ATTACHMENT30:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CFE);
    public static property COLOR_ATTACHMENT31:       InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8CFF);
    public static property DEPTH_ATTACHMENT:         InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8D00);
    public static property DEPTH_ATTACHMENT_EXT:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8D00);
    public static property DEPTH_ATTACHMENT_OES:     InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8D00);
    public static property STENCIL_ATTACHMENT_EXT:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8D20);
    public static property STENCIL_ATTACHMENT_OES:   InvalidateFramebufferAttachment read new InvalidateFramebufferAttachment($8D20);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1800) then Result := 'COLOR' else
      if self.val = UInt32($1801) then Result := 'DEPTH' else
      if self.val = UInt32($1802) then Result := 'STENCIL' else
      if self.val = UInt32($821A) then Result := 'DEPTH_STENCIL_ATTACHMENT' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0_EXT' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0_NV' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0_OES' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1_EXT' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1_NV' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2_EXT' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2_NV' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3_EXT' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3_NV' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4_EXT' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4_NV' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5_EXT' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5_NV' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6_EXT' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6_NV' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7_EXT' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7_NV' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8_EXT' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8_NV' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9_EXT' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9_NV' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10_EXT' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10_NV' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11_EXT' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11_NV' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12_EXT' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12_NV' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13_EXT' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13_NV' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14_EXT' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14_NV' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15_EXT' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15_NV' else
      if self.val = UInt32($8CF0) then Result := 'COLOR_ATTACHMENT16' else
      if self.val = UInt32($8CF1) then Result := 'COLOR_ATTACHMENT17' else
      if self.val = UInt32($8CF2) then Result := 'COLOR_ATTACHMENT18' else
      if self.val = UInt32($8CF3) then Result := 'COLOR_ATTACHMENT19' else
      if self.val = UInt32($8CF4) then Result := 'COLOR_ATTACHMENT20' else
      if self.val = UInt32($8CF5) then Result := 'COLOR_ATTACHMENT21' else
      if self.val = UInt32($8CF6) then Result := 'COLOR_ATTACHMENT22' else
      if self.val = UInt32($8CF7) then Result := 'COLOR_ATTACHMENT23' else
      if self.val = UInt32($8CF8) then Result := 'COLOR_ATTACHMENT24' else
      if self.val = UInt32($8CF9) then Result := 'COLOR_ATTACHMENT25' else
      if self.val = UInt32($8CFA) then Result := 'COLOR_ATTACHMENT26' else
      if self.val = UInt32($8CFB) then Result := 'COLOR_ATTACHMENT27' else
      if self.val = UInt32($8CFC) then Result := 'COLOR_ATTACHMENT28' else
      if self.val = UInt32($8CFD) then Result := 'COLOR_ATTACHMENT29' else
      if self.val = UInt32($8CFE) then Result := 'COLOR_ATTACHMENT30' else
      if self.val = UInt32($8CFF) then Result := 'COLOR_ATTACHMENT31' else
      if self.val = UInt32($8D00) then Result := 'DEPTH_ATTACHMENT' else
      if self.val = UInt32($8D00) then Result := 'DEPTH_ATTACHMENT_EXT' else
      if self.val = UInt32($8D00) then Result := 'DEPTH_ATTACHMENT_OES' else
      if self.val = UInt32($8D20) then Result := 'STENCIL_ATTACHMENT_EXT' else
      if self.val = UInt32($8D20) then Result := 'STENCIL_ATTACHMENT_OES' else
        Result := $'InvalidateFramebufferAttachment[{self.val}]';
    end;
    
  end;
  
  LightModelParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LIGHT_MODEL_LOCAL_VIEWER:      LightModelParameter read new LightModelParameter($0B51);
    public static property LIGHT_MODEL_TWO_SIDE:          LightModelParameter read new LightModelParameter($0B52);
    public static property LIGHT_MODEL_AMBIENT:           LightModelParameter read new LightModelParameter($0B53);
    public static property LIGHT_MODEL_COLOR_CONTROL:     LightModelParameter read new LightModelParameter($81F8);
    public static property LIGHT_MODEL_COLOR_CONTROL_EXT: LightModelParameter read new LightModelParameter($81F8);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0B51) then Result := 'LIGHT_MODEL_LOCAL_VIEWER' else
      if self.val = UInt32($0B52) then Result := 'LIGHT_MODEL_TWO_SIDE' else
      if self.val = UInt32($0B53) then Result := 'LIGHT_MODEL_AMBIENT' else
      if self.val = UInt32($81F8) then Result := 'LIGHT_MODEL_COLOR_CONTROL' else
      if self.val = UInt32($81F8) then Result := 'LIGHT_MODEL_COLOR_CONTROL_EXT' else
        Result := $'LightModelParameter[{self.val}]';
    end;
    
  end;
  
  LightName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LIGHT0:               LightName read new LightName($4000);
    public static property LIGHT1:               LightName read new LightName($4001);
    public static property LIGHT2:               LightName read new LightName($4002);
    public static property LIGHT3:               LightName read new LightName($4003);
    public static property LIGHT4:               LightName read new LightName($4004);
    public static property LIGHT5:               LightName read new LightName($4005);
    public static property LIGHT6:               LightName read new LightName($4006);
    public static property LIGHT7:               LightName read new LightName($4007);
    public static property FRAGMENT_LIGHT0_SGIX: LightName read new LightName($840C);
    public static property FRAGMENT_LIGHT1_SGIX: LightName read new LightName($840D);
    public static property FRAGMENT_LIGHT2_SGIX: LightName read new LightName($840E);
    public static property FRAGMENT_LIGHT3_SGIX: LightName read new LightName($840F);
    public static property FRAGMENT_LIGHT4_SGIX: LightName read new LightName($8410);
    public static property FRAGMENT_LIGHT5_SGIX: LightName read new LightName($8411);
    public static property FRAGMENT_LIGHT6_SGIX: LightName read new LightName($8412);
    public static property FRAGMENT_LIGHT7_SGIX: LightName read new LightName($8413);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($4000) then Result := 'LIGHT0' else
      if self.val = UInt32($4001) then Result := 'LIGHT1' else
      if self.val = UInt32($4002) then Result := 'LIGHT2' else
      if self.val = UInt32($4003) then Result := 'LIGHT3' else
      if self.val = UInt32($4004) then Result := 'LIGHT4' else
      if self.val = UInt32($4005) then Result := 'LIGHT5' else
      if self.val = UInt32($4006) then Result := 'LIGHT6' else
      if self.val = UInt32($4007) then Result := 'LIGHT7' else
      if self.val = UInt32($840C) then Result := 'FRAGMENT_LIGHT0_SGIX' else
      if self.val = UInt32($840D) then Result := 'FRAGMENT_LIGHT1_SGIX' else
      if self.val = UInt32($840E) then Result := 'FRAGMENT_LIGHT2_SGIX' else
      if self.val = UInt32($840F) then Result := 'FRAGMENT_LIGHT3_SGIX' else
      if self.val = UInt32($8410) then Result := 'FRAGMENT_LIGHT4_SGIX' else
      if self.val = UInt32($8411) then Result := 'FRAGMENT_LIGHT5_SGIX' else
      if self.val = UInt32($8412) then Result := 'FRAGMENT_LIGHT6_SGIX' else
      if self.val = UInt32($8413) then Result := 'FRAGMENT_LIGHT7_SGIX' else
        Result := $'LightName[{self.val}]';
    end;
    
  end;
  
  LightParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POSITION:              LightParameter read new LightParameter($1203);
    public static property SPOT_DIRECTION:        LightParameter read new LightParameter($1204);
    public static property SPOT_EXPONENT:         LightParameter read new LightParameter($1205);
    public static property SPOT_CUTOFF:           LightParameter read new LightParameter($1206);
    public static property CONSTANT_ATTENUATION:  LightParameter read new LightParameter($1207);
    public static property LINEAR_ATTENUATION:    LightParameter read new LightParameter($1208);
    public static property QUADRATIC_ATTENUATION: LightParameter read new LightParameter($1209);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1203) then Result := 'POSITION' else
      if self.val = UInt32($1204) then Result := 'SPOT_DIRECTION' else
      if self.val = UInt32($1205) then Result := 'SPOT_EXPONENT' else
      if self.val = UInt32($1206) then Result := 'SPOT_CUTOFF' else
      if self.val = UInt32($1207) then Result := 'CONSTANT_ATTENUATION' else
      if self.val = UInt32($1208) then Result := 'LINEAR_ATTENUATION' else
      if self.val = UInt32($1209) then Result := 'QUADRATIC_ATTENUATION' else
        Result := $'LightParameter[{self.val}]';
    end;
    
  end;
  
  ListMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COMPILE:             ListMode read new ListMode($1300);
    public static property COMPILE_AND_EXECUTE: ListMode read new ListMode($1301);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1300) then Result := 'COMPILE' else
      if self.val = UInt32($1301) then Result := 'COMPILE_AND_EXECUTE' else
        Result := $'ListMode[{self.val}]';
    end;
    
  end;
  
  ListNameType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:           ListNameType read new ListNameType($1400);
    public static property UNSIGNED_BYTE:  ListNameType read new ListNameType($1401);
    public static property SHORT:          ListNameType read new ListNameType($1402);
    public static property UNSIGNED_SHORT: ListNameType read new ListNameType($1403);
    public static property INT:            ListNameType read new ListNameType($1404);
    public static property UNSIGNED_INT:   ListNameType read new ListNameType($1405);
    public static property FLOAT:          ListNameType read new ListNameType($1406);
    public static property GL_2_BYTES:     ListNameType read new ListNameType($1407);
    public static property GL_3_BYTES:     ListNameType read new ListNameType($1408);
    public static property GL_4_BYTES:     ListNameType read new ListNameType($1409);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($1407) then Result := 'GL_2_BYTES' else
      if self.val = UInt32($1408) then Result := 'GL_3_BYTES' else
      if self.val = UInt32($1409) then Result := 'GL_4_BYTES' else
        Result := $'ListNameType[{self.val}]';
    end;
    
  end;
  
  ListParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LIST_PRIORITY_SGIX: ListParameterName read new ListParameterName($8182);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8182) then Result := 'LIST_PRIORITY_SGIX' else
        Result := $'ListParameterName[{self.val}]';
    end;
    
  end;
  
  LogicOp = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CLEAR:         LogicOp read new LogicOp($1500);
    public static property &AND:          LogicOp read new LogicOp($1501);
    public static property AND_REVERSE:   LogicOp read new LogicOp($1502);
    public static property COPY:          LogicOp read new LogicOp($1503);
    public static property AND_INVERTED:  LogicOp read new LogicOp($1504);
    public static property NOOP:          LogicOp read new LogicOp($1505);
    public static property &XOR:          LogicOp read new LogicOp($1506);
    public static property &OR:           LogicOp read new LogicOp($1507);
    public static property NOR:           LogicOp read new LogicOp($1508);
    public static property EQUIV:         LogicOp read new LogicOp($1509);
    public static property INVERT:        LogicOp read new LogicOp($150A);
    public static property OR_REVERSE:    LogicOp read new LogicOp($150B);
    public static property COPY_INVERTED: LogicOp read new LogicOp($150C);
    public static property OR_INVERTED:   LogicOp read new LogicOp($150D);
    public static property NAND:          LogicOp read new LogicOp($150E);
    public static property &SET:          LogicOp read new LogicOp($150F);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1500) then Result := 'CLEAR' else
      if self.val = UInt32($1501) then Result := 'AND' else
      if self.val = UInt32($1502) then Result := 'AND_REVERSE' else
      if self.val = UInt32($1503) then Result := 'COPY' else
      if self.val = UInt32($1504) then Result := 'AND_INVERTED' else
      if self.val = UInt32($1505) then Result := 'NOOP' else
      if self.val = UInt32($1506) then Result := 'XOR' else
      if self.val = UInt32($1507) then Result := 'OR' else
      if self.val = UInt32($1508) then Result := 'NOR' else
      if self.val = UInt32($1509) then Result := 'EQUIV' else
      if self.val = UInt32($150A) then Result := 'INVERT' else
      if self.val = UInt32($150B) then Result := 'OR_REVERSE' else
      if self.val = UInt32($150C) then Result := 'COPY_INVERTED' else
      if self.val = UInt32($150D) then Result := 'OR_INVERTED' else
      if self.val = UInt32($150E) then Result := 'NAND' else
      if self.val = UInt32($150F) then Result := 'SET' else
        Result := $'LogicOp[{self.val}]';
    end;
    
  end;
  
  MapBufferAccessMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MAP_READ_BIT:                  MapBufferAccessMask read new MapBufferAccessMask($0001);
    public static property MAP_READ_BIT_EXT:              MapBufferAccessMask read new MapBufferAccessMask($0001);
    public static property MAP_WRITE_BIT:                 MapBufferAccessMask read new MapBufferAccessMask($0002);
    public static property MAP_WRITE_BIT_EXT:             MapBufferAccessMask read new MapBufferAccessMask($0002);
    public static property MAP_INVALIDATE_RANGE_BIT:      MapBufferAccessMask read new MapBufferAccessMask($0004);
    public static property MAP_INVALIDATE_RANGE_BIT_EXT:  MapBufferAccessMask read new MapBufferAccessMask($0004);
    public static property MAP_INVALIDATE_BUFFER_BIT:     MapBufferAccessMask read new MapBufferAccessMask($0008);
    public static property MAP_INVALIDATE_BUFFER_BIT_EXT: MapBufferAccessMask read new MapBufferAccessMask($0008);
    public static property MAP_FLUSH_EXPLICIT_BIT:        MapBufferAccessMask read new MapBufferAccessMask($0010);
    public static property MAP_FLUSH_EXPLICIT_BIT_EXT:    MapBufferAccessMask read new MapBufferAccessMask($0010);
    public static property MAP_UNSYNCHRONIZED_BIT:        MapBufferAccessMask read new MapBufferAccessMask($0020);
    public static property MAP_UNSYNCHRONIZED_BIT_EXT:    MapBufferAccessMask read new MapBufferAccessMask($0020);
    public static property MAP_PERSISTENT_BIT:            MapBufferAccessMask read new MapBufferAccessMask($0040);
    public static property MAP_PERSISTENT_BIT_EXT:        MapBufferAccessMask read new MapBufferAccessMask($0040);
    public static property MAP_COHERENT_BIT:              MapBufferAccessMask read new MapBufferAccessMask($0080);
    public static property MAP_COHERENT_BIT_EXT:          MapBufferAccessMask read new MapBufferAccessMask($0080);
    
    public static function operator+(f1,f2: MapBufferAccessMask) := new MapBufferAccessMask(f1.val or f2.val);
    public static function operator or(f1,f2: MapBufferAccessMask) := f1+f2;
    
    public property HAS_FLAG_MAP_READ_BIT:                  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_READ_BIT_EXT:              boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT:                 boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT_EXT:             boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_RANGE_BIT:      boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_RANGE_BIT_EXT:  boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_BUFFER_BIT:     boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_BUFFER_BIT_EXT: boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_MAP_FLUSH_EXPLICIT_BIT:        boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_MAP_FLUSH_EXPLICIT_BIT_EXT:    boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_MAP_UNSYNCHRONIZED_BIT:        boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_MAP_UNSYNCHRONIZED_BIT_EXT:    boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT:            boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT_EXT:        boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT:              boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT_EXT:          boolean read self.val and $0080 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'MAP_READ_BIT+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'MAP_READ_BIT_EXT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'MAP_WRITE_BIT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'MAP_WRITE_BIT_EXT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'MAP_INVALIDATE_RANGE_BIT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'MAP_INVALIDATE_RANGE_BIT_EXT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'MAP_INVALIDATE_BUFFER_BIT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'MAP_INVALIDATE_BUFFER_BIT_EXT+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'MAP_FLUSH_EXPLICIT_BIT+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'MAP_FLUSH_EXPLICIT_BIT_EXT+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'MAP_UNSYNCHRONIZED_BIT+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'MAP_UNSYNCHRONIZED_BIT_EXT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'MAP_PERSISTENT_BIT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'MAP_PERSISTENT_BIT_EXT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'MAP_COHERENT_BIT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'MAP_COHERENT_BIT_EXT+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'MapBufferAccessMask[{self.val}]';
    end;
    
  end;
  
  MapQuery = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COEFF:  MapQuery read new MapQuery($0A00);
    public static property ORDER:  MapQuery read new MapQuery($0A01);
    public static property DOMAIN: MapQuery read new MapQuery($0A02);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0A00) then Result := 'COEFF' else
      if self.val = UInt32($0A01) then Result := 'ORDER' else
      if self.val = UInt32($0A02) then Result := 'DOMAIN' else
        Result := $'MapQuery[{self.val}]';
    end;
    
  end;
  
  MapTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MAP1_COLOR_4:              MapTarget read new MapTarget($0D90);
    public static property MAP1_INDEX:                MapTarget read new MapTarget($0D91);
    public static property MAP1_NORMAL:               MapTarget read new MapTarget($0D92);
    public static property MAP1_TEXTURE_COORD_1:      MapTarget read new MapTarget($0D93);
    public static property MAP1_TEXTURE_COORD_2:      MapTarget read new MapTarget($0D94);
    public static property MAP1_TEXTURE_COORD_3:      MapTarget read new MapTarget($0D95);
    public static property MAP1_TEXTURE_COORD_4:      MapTarget read new MapTarget($0D96);
    public static property MAP1_VERTEX_3:             MapTarget read new MapTarget($0D97);
    public static property MAP1_VERTEX_4:             MapTarget read new MapTarget($0D98);
    public static property MAP2_COLOR_4:              MapTarget read new MapTarget($0DB0);
    public static property MAP2_INDEX:                MapTarget read new MapTarget($0DB1);
    public static property MAP2_NORMAL:               MapTarget read new MapTarget($0DB2);
    public static property MAP2_TEXTURE_COORD_1:      MapTarget read new MapTarget($0DB3);
    public static property MAP2_TEXTURE_COORD_2:      MapTarget read new MapTarget($0DB4);
    public static property MAP2_TEXTURE_COORD_3:      MapTarget read new MapTarget($0DB5);
    public static property MAP2_TEXTURE_COORD_4:      MapTarget read new MapTarget($0DB6);
    public static property MAP2_VERTEX_3:             MapTarget read new MapTarget($0DB7);
    public static property MAP2_VERTEX_4:             MapTarget read new MapTarget($0DB8);
    public static property GEOMETRY_DEFORMATION_SGIX: MapTarget read new MapTarget($8194);
    public static property TEXTURE_DEFORMATION_SGIX:  MapTarget read new MapTarget($8195);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0D90) then Result := 'MAP1_COLOR_4' else
      if self.val = UInt32($0D91) then Result := 'MAP1_INDEX' else
      if self.val = UInt32($0D92) then Result := 'MAP1_NORMAL' else
      if self.val = UInt32($0D93) then Result := 'MAP1_TEXTURE_COORD_1' else
      if self.val = UInt32($0D94) then Result := 'MAP1_TEXTURE_COORD_2' else
      if self.val = UInt32($0D95) then Result := 'MAP1_TEXTURE_COORD_3' else
      if self.val = UInt32($0D96) then Result := 'MAP1_TEXTURE_COORD_4' else
      if self.val = UInt32($0D97) then Result := 'MAP1_VERTEX_3' else
      if self.val = UInt32($0D98) then Result := 'MAP1_VERTEX_4' else
      if self.val = UInt32($0DB0) then Result := 'MAP2_COLOR_4' else
      if self.val = UInt32($0DB1) then Result := 'MAP2_INDEX' else
      if self.val = UInt32($0DB2) then Result := 'MAP2_NORMAL' else
      if self.val = UInt32($0DB3) then Result := 'MAP2_TEXTURE_COORD_1' else
      if self.val = UInt32($0DB4) then Result := 'MAP2_TEXTURE_COORD_2' else
      if self.val = UInt32($0DB5) then Result := 'MAP2_TEXTURE_COORD_3' else
      if self.val = UInt32($0DB6) then Result := 'MAP2_TEXTURE_COORD_4' else
      if self.val = UInt32($0DB7) then Result := 'MAP2_VERTEX_3' else
      if self.val = UInt32($0DB8) then Result := 'MAP2_VERTEX_4' else
      if self.val = UInt32($8194) then Result := 'GEOMETRY_DEFORMATION_SGIX' else
      if self.val = UInt32($8195) then Result := 'TEXTURE_DEFORMATION_SGIX' else
        Result := $'MapTarget[{self.val}]';
    end;
    
  end;
  
  MaterialFace = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRONT:          MaterialFace read new MaterialFace($0404);
    public static property BACK:           MaterialFace read new MaterialFace($0405);
    public static property FRONT_AND_BACK: MaterialFace read new MaterialFace($0408);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0404) then Result := 'FRONT' else
      if self.val = UInt32($0405) then Result := 'BACK' else
      if self.val = UInt32($0408) then Result := 'FRONT_AND_BACK' else
        Result := $'MaterialFace[{self.val}]';
    end;
    
  end;
  
  MaterialParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property AMBIENT:             MaterialParameter read new MaterialParameter($1200);
    public static property DIFFUSE:             MaterialParameter read new MaterialParameter($1201);
    public static property SPECULAR:            MaterialParameter read new MaterialParameter($1202);
    public static property EMISSION:            MaterialParameter read new MaterialParameter($1600);
    public static property SHININESS:           MaterialParameter read new MaterialParameter($1601);
    public static property AMBIENT_AND_DIFFUSE: MaterialParameter read new MaterialParameter($1602);
    public static property COLOR_INDEXES:       MaterialParameter read new MaterialParameter($1603);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1200) then Result := 'AMBIENT' else
      if self.val = UInt32($1201) then Result := 'DIFFUSE' else
      if self.val = UInt32($1202) then Result := 'SPECULAR' else
      if self.val = UInt32($1600) then Result := 'EMISSION' else
      if self.val = UInt32($1601) then Result := 'SHININESS' else
      if self.val = UInt32($1602) then Result := 'AMBIENT_AND_DIFFUSE' else
      if self.val = UInt32($1603) then Result := 'COLOR_INDEXES' else
        Result := $'MaterialParameter[{self.val}]';
    end;
    
  end;
  
  MatrixMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MODELVIEW:      MatrixMode read new MatrixMode($1700);
    public static property MODELVIEW0_EXT: MatrixMode read new MatrixMode($1700);
    public static property PROJECTION:     MatrixMode read new MatrixMode($1701);
    public static property TEXTURE:        MatrixMode read new MatrixMode($1702);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1700) then Result := 'MODELVIEW' else
      if self.val = UInt32($1700) then Result := 'MODELVIEW0_EXT' else
      if self.val = UInt32($1701) then Result := 'PROJECTION' else
      if self.val = UInt32($1702) then Result := 'TEXTURE' else
        Result := $'MatrixMode[{self.val}]';
    end;
    
  end;
  
  MemoryBarrierMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_ATTRIB_ARRAY_BARRIER_BIT:      MemoryBarrierMask read new MemoryBarrierMask($0001);
    public static property VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT:  MemoryBarrierMask read new MemoryBarrierMask($0001);
    public static property ELEMENT_ARRAY_BARRIER_BIT:            MemoryBarrierMask read new MemoryBarrierMask($0002);
    public static property ELEMENT_ARRAY_BARRIER_BIT_EXT:        MemoryBarrierMask read new MemoryBarrierMask($0002);
    public static property UNIFORM_BARRIER_BIT:                  MemoryBarrierMask read new MemoryBarrierMask($0004);
    public static property UNIFORM_BARRIER_BIT_EXT:              MemoryBarrierMask read new MemoryBarrierMask($0004);
    public static property TEXTURE_FETCH_BARRIER_BIT:            MemoryBarrierMask read new MemoryBarrierMask($0008);
    public static property TEXTURE_FETCH_BARRIER_BIT_EXT:        MemoryBarrierMask read new MemoryBarrierMask($0008);
    public static property SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV:  MemoryBarrierMask read new MemoryBarrierMask($0010);
    public static property SHADER_IMAGE_ACCESS_BARRIER_BIT:      MemoryBarrierMask read new MemoryBarrierMask($0020);
    public static property SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT:  MemoryBarrierMask read new MemoryBarrierMask($0020);
    public static property COMMAND_BARRIER_BIT:                  MemoryBarrierMask read new MemoryBarrierMask($0040);
    public static property COMMAND_BARRIER_BIT_EXT:              MemoryBarrierMask read new MemoryBarrierMask($0040);
    public static property PIXEL_BUFFER_BARRIER_BIT:             MemoryBarrierMask read new MemoryBarrierMask($0080);
    public static property PIXEL_BUFFER_BARRIER_BIT_EXT:         MemoryBarrierMask read new MemoryBarrierMask($0080);
    public static property TEXTURE_UPDATE_BARRIER_BIT:           MemoryBarrierMask read new MemoryBarrierMask($0100);
    public static property TEXTURE_UPDATE_BARRIER_BIT_EXT:       MemoryBarrierMask read new MemoryBarrierMask($0100);
    public static property BUFFER_UPDATE_BARRIER_BIT:            MemoryBarrierMask read new MemoryBarrierMask($0200);
    public static property BUFFER_UPDATE_BARRIER_BIT_EXT:        MemoryBarrierMask read new MemoryBarrierMask($0200);
    public static property FRAMEBUFFER_BARRIER_BIT:              MemoryBarrierMask read new MemoryBarrierMask($0400);
    public static property FRAMEBUFFER_BARRIER_BIT_EXT:          MemoryBarrierMask read new MemoryBarrierMask($0400);
    public static property TRANSFORM_FEEDBACK_BARRIER_BIT:       MemoryBarrierMask read new MemoryBarrierMask($0800);
    public static property TRANSFORM_FEEDBACK_BARRIER_BIT_EXT:   MemoryBarrierMask read new MemoryBarrierMask($0800);
    public static property ATOMIC_COUNTER_BARRIER_BIT:           MemoryBarrierMask read new MemoryBarrierMask($1000);
    public static property ATOMIC_COUNTER_BARRIER_BIT_EXT:       MemoryBarrierMask read new MemoryBarrierMask($1000);
    public static property SHADER_STORAGE_BARRIER_BIT:           MemoryBarrierMask read new MemoryBarrierMask($2000);
    public static property CLIENT_MAPPED_BUFFER_BARRIER_BIT:     MemoryBarrierMask read new MemoryBarrierMask($4000);
    public static property CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT: MemoryBarrierMask read new MemoryBarrierMask($4000);
    public static property QUERY_BUFFER_BARRIER_BIT:             MemoryBarrierMask read new MemoryBarrierMask($8000);
    public static property ALL_BARRIER_BITS:                     MemoryBarrierMask read new MemoryBarrierMask($FFFFFFFF);
    public static property ALL_BARRIER_BITS_EXT:                 MemoryBarrierMask read new MemoryBarrierMask($FFFFFFFF);
    
    public static function operator+(f1,f2: MemoryBarrierMask) := new MemoryBarrierMask(f1.val or f2.val);
    public static function operator or(f1,f2: MemoryBarrierMask) := f1+f2;
    
    public property HAS_FLAG_VERTEX_ATTRIB_ARRAY_BARRIER_BIT:      boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT:  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_ELEMENT_ARRAY_BARRIER_BIT:            boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_ELEMENT_ARRAY_BARRIER_BIT_EXT:        boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_UNIFORM_BARRIER_BIT:                  boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_UNIFORM_BARRIER_BIT_EXT:              boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_TEXTURE_FETCH_BARRIER_BIT:            boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TEXTURE_FETCH_BARRIER_BIT_EXT:        boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV:  boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_SHADER_IMAGE_ACCESS_BARRIER_BIT:      boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT:  boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_COMMAND_BARRIER_BIT:                  boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_COMMAND_BARRIER_BIT_EXT:              boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_PIXEL_BUFFER_BARRIER_BIT:             boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_PIXEL_BUFFER_BARRIER_BIT_EXT:         boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_TEXTURE_UPDATE_BARRIER_BIT:           boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_TEXTURE_UPDATE_BARRIER_BIT_EXT:       boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_BUFFER_UPDATE_BARRIER_BIT:            boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_BUFFER_UPDATE_BARRIER_BIT_EXT:        boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_FRAMEBUFFER_BARRIER_BIT:              boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_FRAMEBUFFER_BARRIER_BIT_EXT:          boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_TRANSFORM_FEEDBACK_BARRIER_BIT:       boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_TRANSFORM_FEEDBACK_BARRIER_BIT_EXT:   boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_ATOMIC_COUNTER_BARRIER_BIT:           boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_ATOMIC_COUNTER_BARRIER_BIT_EXT:       boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_SHADER_STORAGE_BARRIER_BIT:           boolean read self.val and $2000 <> 0;
    public property HAS_FLAG_CLIENT_MAPPED_BUFFER_BARRIER_BIT:     boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT: boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_QUERY_BUFFER_BARRIER_BIT:             boolean read self.val and $8000 <> 0;
    public property HAS_FLAG_ALL_BARRIER_BITS:                     boolean read self.val and $FFFFFFFF <> 0;
    public property HAS_FLAG_ALL_BARRIER_BITS_EXT:                 boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'VERTEX_ATTRIB_ARRAY_BARRIER_BIT+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'ELEMENT_ARRAY_BARRIER_BIT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'ELEMENT_ARRAY_BARRIER_BIT_EXT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'UNIFORM_BARRIER_BIT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'UNIFORM_BARRIER_BIT_EXT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'TEXTURE_FETCH_BARRIER_BIT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'TEXTURE_FETCH_BARRIER_BIT_EXT+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'SHADER_IMAGE_ACCESS_BARRIER_BIT+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'COMMAND_BARRIER_BIT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'COMMAND_BARRIER_BIT_EXT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'PIXEL_BUFFER_BARRIER_BIT+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'PIXEL_BUFFER_BARRIER_BIT_EXT+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'TEXTURE_UPDATE_BARRIER_BIT+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'TEXTURE_UPDATE_BARRIER_BIT_EXT+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'BUFFER_UPDATE_BARRIER_BIT+';
      if self.val and UInt32($0200) = UInt32($0200) then res += 'BUFFER_UPDATE_BARRIER_BIT_EXT+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'FRAMEBUFFER_BARRIER_BIT+';
      if self.val and UInt32($0400) = UInt32($0400) then res += 'FRAMEBUFFER_BARRIER_BIT_EXT+';
      if self.val and UInt32($0800) = UInt32($0800) then res += 'TRANSFORM_FEEDBACK_BARRIER_BIT+';
      if self.val and UInt32($0800) = UInt32($0800) then res += 'TRANSFORM_FEEDBACK_BARRIER_BIT_EXT+';
      if self.val and UInt32($1000) = UInt32($1000) then res += 'ATOMIC_COUNTER_BARRIER_BIT+';
      if self.val and UInt32($1000) = UInt32($1000) then res += 'ATOMIC_COUNTER_BARRIER_BIT_EXT+';
      if self.val and UInt32($2000) = UInt32($2000) then res += 'SHADER_STORAGE_BARRIER_BIT+';
      if self.val and UInt32($4000) = UInt32($4000) then res += 'CLIENT_MAPPED_BUFFER_BARRIER_BIT+';
      if self.val and UInt32($4000) = UInt32($4000) then res += 'CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT+';
      if self.val and UInt32($8000) = UInt32($8000) then res += 'QUERY_BUFFER_BARRIER_BIT+';
      if self.val and UInt32($FFFFFFFF) = UInt32($FFFFFFFF) then res += 'ALL_BARRIER_BITS+';
      if self.val and UInt32($FFFFFFFF) = UInt32($FFFFFFFF) then res += 'ALL_BARRIER_BITS_EXT+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'MemoryBarrierMask[{self.val}]';
    end;
    
  end;
  
  MemoryObjectParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DEDICATED_MEMORY_OBJECT_EXT: MemoryObjectParameterName read new MemoryObjectParameterName($9581);
    public static property PROTECTED_MEMORY_OBJECT_EXT: MemoryObjectParameterName read new MemoryObjectParameterName($959B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9581) then Result := 'DEDICATED_MEMORY_OBJECT_EXT' else
      if self.val = UInt32($959B) then Result := 'PROTECTED_MEMORY_OBJECT_EXT' else
        Result := $'MemoryObjectParameterName[{self.val}]';
    end;
    
  end;
  
  MeshMode1 = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POINT: MeshMode1 read new MeshMode1($1B00);
    public static property LINE:  MeshMode1 read new MeshMode1($1B01);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1B00) then Result := 'POINT' else
      if self.val = UInt32($1B01) then Result := 'LINE' else
        Result := $'MeshMode1[{self.val}]';
    end;
    
  end;
  
  MeshMode2 = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POINT: MeshMode2 read new MeshMode2($1B00);
    public static property LINE:  MeshMode2 read new MeshMode2($1B01);
    public static property FILL:  MeshMode2 read new MeshMode2($1B02);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1B00) then Result := 'POINT' else
      if self.val = UInt32($1B01) then Result := 'LINE' else
      if self.val = UInt32($1B02) then Result := 'FILL' else
        Result := $'MeshMode2[{self.val}]';
    end;
    
  end;
  
  MinmaxTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MINMAX: MinmaxTarget read new MinmaxTarget($802E);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($802E) then Result := 'MINMAX' else
        Result := $'MinmaxTarget[{self.val}]';
    end;
    
  end;
  
  NormalPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:   NormalPointerType read new NormalPointerType($1400);
    public static property SHORT:  NormalPointerType read new NormalPointerType($1402);
    public static property INT:    NormalPointerType read new NormalPointerType($1404);
    public static property FLOAT:  NormalPointerType read new NormalPointerType($1406);
    public static property DOUBLE: NormalPointerType read new NormalPointerType($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'NormalPointerType[{self.val}]';
    end;
    
  end;
  
  ObjectIdentifier = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE:            ObjectIdentifier read new ObjectIdentifier($1702);
    public static property VERTEX_ARRAY:       ObjectIdentifier read new ObjectIdentifier($8074);
    public static property BUFFER:             ObjectIdentifier read new ObjectIdentifier($82E0);
    public static property SHADER:             ObjectIdentifier read new ObjectIdentifier($82E1);
    public static property &PROGRAM:           ObjectIdentifier read new ObjectIdentifier($82E2);
    public static property QUERY:              ObjectIdentifier read new ObjectIdentifier($82E3);
    public static property PROGRAM_PIPELINE:   ObjectIdentifier read new ObjectIdentifier($82E4);
    public static property SAMPLER:            ObjectIdentifier read new ObjectIdentifier($82E6);
    public static property FRAMEBUFFER:        ObjectIdentifier read new ObjectIdentifier($8D40);
    public static property RENDERBUFFER:       ObjectIdentifier read new ObjectIdentifier($8D41);
    public static property TRANSFORM_FEEDBACK: ObjectIdentifier read new ObjectIdentifier($8E22);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1702) then Result := 'TEXTURE' else
      if self.val = UInt32($8074) then Result := 'VERTEX_ARRAY' else
      if self.val = UInt32($82E0) then Result := 'BUFFER' else
      if self.val = UInt32($82E1) then Result := 'SHADER' else
      if self.val = UInt32($82E2) then Result := 'PROGRAM' else
      if self.val = UInt32($82E3) then Result := 'QUERY' else
      if self.val = UInt32($82E4) then Result := 'PROGRAM_PIPELINE' else
      if self.val = UInt32($82E6) then Result := 'SAMPLER' else
      if self.val = UInt32($8D40) then Result := 'FRAMEBUFFER' else
      if self.val = UInt32($8D41) then Result := 'RENDERBUFFER' else
      if self.val = UInt32($8E22) then Result := 'TRANSFORM_FEEDBACK' else
        Result := $'ObjectIdentifier[{self.val}]';
    end;
    
  end;
  
  PatchParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PATCH_VERTICES:            PatchParameterName read new PatchParameterName($8E72);
    public static property PATCH_DEFAULT_INNER_LEVEL: PatchParameterName read new PatchParameterName($8E73);
    public static property PATCH_DEFAULT_OUTER_LEVEL: PatchParameterName read new PatchParameterName($8E74);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E72) then Result := 'PATCH_VERTICES' else
      if self.val = UInt32($8E73) then Result := 'PATCH_DEFAULT_INNER_LEVEL' else
      if self.val = UInt32($8E74) then Result := 'PATCH_DEFAULT_OUTER_LEVEL' else
        Result := $'PatchParameterName[{self.val}]';
    end;
    
  end;
  
  PathColor = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PRIMARY_COLOR_NV:   PathColor read new PathColor($852C);
    public static property SECONDARY_COLOR_NV: PathColor read new PathColor($852D);
    public static property PRIMARY_COLOR:      PathColor read new PathColor($8577);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($852C) then Result := 'PRIMARY_COLOR_NV' else
      if self.val = UInt32($852D) then Result := 'SECONDARY_COLOR_NV' else
      if self.val = UInt32($8577) then Result := 'PRIMARY_COLOR' else
        Result := $'PathColor[{self.val}]';
    end;
    
  end;
  
  PathColorFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:            PathColorFormat read new PathColorFormat($0000);
    public static property ALPHA:           PathColorFormat read new PathColorFormat($1906);
    public static property RGB:             PathColorFormat read new PathColorFormat($1907);
    public static property RGBA:            PathColorFormat read new PathColorFormat($1908);
    public static property LUMINANCE:       PathColorFormat read new PathColorFormat($1909);
    public static property LUMINANCE_ALPHA: PathColorFormat read new PathColorFormat($190A);
    public static property INTENSITY:       PathColorFormat read new PathColorFormat($8049);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($1906) then Result := 'ALPHA' else
      if self.val = UInt32($1907) then Result := 'RGB' else
      if self.val = UInt32($1908) then Result := 'RGBA' else
      if self.val = UInt32($1909) then Result := 'LUMINANCE' else
      if self.val = UInt32($190A) then Result := 'LUMINANCE_ALPHA' else
      if self.val = UInt32($8049) then Result := 'INTENSITY' else
        Result := $'PathColorFormat[{self.val}]';
    end;
    
  end;
  
  PathCoordType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CLOSE_PATH_NV:                         PathCoordType read new PathCoordType($0000);
    public static property MOVE_TO_NV:                            PathCoordType read new PathCoordType($0002);
    public static property RELATIVE_MOVE_TO_NV:                   PathCoordType read new PathCoordType($0003);
    public static property LINE_TO_NV:                            PathCoordType read new PathCoordType($0004);
    public static property RELATIVE_LINE_TO_NV:                   PathCoordType read new PathCoordType($0005);
    public static property HORIZONTAL_LINE_TO_NV:                 PathCoordType read new PathCoordType($0006);
    public static property RELATIVE_HORIZONTAL_LINE_TO_NV:        PathCoordType read new PathCoordType($0007);
    public static property VERTICAL_LINE_TO_NV:                   PathCoordType read new PathCoordType($0008);
    public static property RELATIVE_VERTICAL_LINE_TO_NV:          PathCoordType read new PathCoordType($0009);
    public static property QUADRATIC_CURVE_TO_NV:                 PathCoordType read new PathCoordType($000A);
    public static property RELATIVE_QUADRATIC_CURVE_TO_NV:        PathCoordType read new PathCoordType($000B);
    public static property CUBIC_CURVE_TO_NV:                     PathCoordType read new PathCoordType($000C);
    public static property RELATIVE_CUBIC_CURVE_TO_NV:            PathCoordType read new PathCoordType($000D);
    public static property SMOOTH_QUADRATIC_CURVE_TO_NV:          PathCoordType read new PathCoordType($000E);
    public static property RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV: PathCoordType read new PathCoordType($000F);
    public static property SMOOTH_CUBIC_CURVE_TO_NV:              PathCoordType read new PathCoordType($0010);
    public static property RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV:     PathCoordType read new PathCoordType($0011);
    public static property SMALL_CCW_ARC_TO_NV:                   PathCoordType read new PathCoordType($0012);
    public static property RELATIVE_SMALL_CCW_ARC_TO_NV:          PathCoordType read new PathCoordType($0013);
    public static property SMALL_CW_ARC_TO_NV:                    PathCoordType read new PathCoordType($0014);
    public static property RELATIVE_SMALL_CW_ARC_TO_NV:           PathCoordType read new PathCoordType($0015);
    public static property LARGE_CCW_ARC_TO_NV:                   PathCoordType read new PathCoordType($0016);
    public static property RELATIVE_LARGE_CCW_ARC_TO_NV:          PathCoordType read new PathCoordType($0017);
    public static property LARGE_CW_ARC_TO_NV:                    PathCoordType read new PathCoordType($0018);
    public static property RELATIVE_LARGE_CW_ARC_TO_NV:           PathCoordType read new PathCoordType($0019);
    public static property CONIC_CURVE_TO_NV:                     PathCoordType read new PathCoordType($001A);
    public static property RELATIVE_CONIC_CURVE_TO_NV:            PathCoordType read new PathCoordType($001B);
    public static property ROUNDED_RECT_NV:                       PathCoordType read new PathCoordType($00E8);
    public static property RELATIVE_ROUNDED_RECT_NV:              PathCoordType read new PathCoordType($00E9);
    public static property ROUNDED_RECT2_NV:                      PathCoordType read new PathCoordType($00EA);
    public static property RELATIVE_ROUNDED_RECT2_NV:             PathCoordType read new PathCoordType($00EB);
    public static property ROUNDED_RECT4_NV:                      PathCoordType read new PathCoordType($00EC);
    public static property RELATIVE_ROUNDED_RECT4_NV:             PathCoordType read new PathCoordType($00ED);
    public static property ROUNDED_RECT8_NV:                      PathCoordType read new PathCoordType($00EE);
    public static property RELATIVE_ROUNDED_RECT8_NV:             PathCoordType read new PathCoordType($00EF);
    public static property RESTART_PATH_NV:                       PathCoordType read new PathCoordType($00F0);
    public static property DUP_FIRST_CUBIC_CURVE_TO_NV:           PathCoordType read new PathCoordType($00F2);
    public static property DUP_LAST_CUBIC_CURVE_TO_NV:            PathCoordType read new PathCoordType($00F4);
    public static property RECT_NV:                               PathCoordType read new PathCoordType($00F6);
    public static property RELATIVE_RECT_NV:                      PathCoordType read new PathCoordType($00F7);
    public static property CIRCULAR_CCW_ARC_TO_NV:                PathCoordType read new PathCoordType($00F8);
    public static property CIRCULAR_CW_ARC_TO_NV:                 PathCoordType read new PathCoordType($00FA);
    public static property CIRCULAR_TANGENT_ARC_TO_NV:            PathCoordType read new PathCoordType($00FC);
    public static property ARC_TO_NV:                             PathCoordType read new PathCoordType($00FE);
    public static property RELATIVE_ARC_TO_NV:                    PathCoordType read new PathCoordType($00FF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'CLOSE_PATH_NV' else
      if self.val = UInt32($0002) then Result := 'MOVE_TO_NV' else
      if self.val = UInt32($0003) then Result := 'RELATIVE_MOVE_TO_NV' else
      if self.val = UInt32($0004) then Result := 'LINE_TO_NV' else
      if self.val = UInt32($0005) then Result := 'RELATIVE_LINE_TO_NV' else
      if self.val = UInt32($0006) then Result := 'HORIZONTAL_LINE_TO_NV' else
      if self.val = UInt32($0007) then Result := 'RELATIVE_HORIZONTAL_LINE_TO_NV' else
      if self.val = UInt32($0008) then Result := 'VERTICAL_LINE_TO_NV' else
      if self.val = UInt32($0009) then Result := 'RELATIVE_VERTICAL_LINE_TO_NV' else
      if self.val = UInt32($000A) then Result := 'QUADRATIC_CURVE_TO_NV' else
      if self.val = UInt32($000B) then Result := 'RELATIVE_QUADRATIC_CURVE_TO_NV' else
      if self.val = UInt32($000C) then Result := 'CUBIC_CURVE_TO_NV' else
      if self.val = UInt32($000D) then Result := 'RELATIVE_CUBIC_CURVE_TO_NV' else
      if self.val = UInt32($000E) then Result := 'SMOOTH_QUADRATIC_CURVE_TO_NV' else
      if self.val = UInt32($000F) then Result := 'RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV' else
      if self.val = UInt32($0010) then Result := 'SMOOTH_CUBIC_CURVE_TO_NV' else
      if self.val = UInt32($0011) then Result := 'RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV' else
      if self.val = UInt32($0012) then Result := 'SMALL_CCW_ARC_TO_NV' else
      if self.val = UInt32($0013) then Result := 'RELATIVE_SMALL_CCW_ARC_TO_NV' else
      if self.val = UInt32($0014) then Result := 'SMALL_CW_ARC_TO_NV' else
      if self.val = UInt32($0015) then Result := 'RELATIVE_SMALL_CW_ARC_TO_NV' else
      if self.val = UInt32($0016) then Result := 'LARGE_CCW_ARC_TO_NV' else
      if self.val = UInt32($0017) then Result := 'RELATIVE_LARGE_CCW_ARC_TO_NV' else
      if self.val = UInt32($0018) then Result := 'LARGE_CW_ARC_TO_NV' else
      if self.val = UInt32($0019) then Result := 'RELATIVE_LARGE_CW_ARC_TO_NV' else
      if self.val = UInt32($001A) then Result := 'CONIC_CURVE_TO_NV' else
      if self.val = UInt32($001B) then Result := 'RELATIVE_CONIC_CURVE_TO_NV' else
      if self.val = UInt32($00E8) then Result := 'ROUNDED_RECT_NV' else
      if self.val = UInt32($00E9) then Result := 'RELATIVE_ROUNDED_RECT_NV' else
      if self.val = UInt32($00EA) then Result := 'ROUNDED_RECT2_NV' else
      if self.val = UInt32($00EB) then Result := 'RELATIVE_ROUNDED_RECT2_NV' else
      if self.val = UInt32($00EC) then Result := 'ROUNDED_RECT4_NV' else
      if self.val = UInt32($00ED) then Result := 'RELATIVE_ROUNDED_RECT4_NV' else
      if self.val = UInt32($00EE) then Result := 'ROUNDED_RECT8_NV' else
      if self.val = UInt32($00EF) then Result := 'RELATIVE_ROUNDED_RECT8_NV' else
      if self.val = UInt32($00F0) then Result := 'RESTART_PATH_NV' else
      if self.val = UInt32($00F2) then Result := 'DUP_FIRST_CUBIC_CURVE_TO_NV' else
      if self.val = UInt32($00F4) then Result := 'DUP_LAST_CUBIC_CURVE_TO_NV' else
      if self.val = UInt32($00F6) then Result := 'RECT_NV' else
      if self.val = UInt32($00F7) then Result := 'RELATIVE_RECT_NV' else
      if self.val = UInt32($00F8) then Result := 'CIRCULAR_CCW_ARC_TO_NV' else
      if self.val = UInt32($00FA) then Result := 'CIRCULAR_CW_ARC_TO_NV' else
      if self.val = UInt32($00FC) then Result := 'CIRCULAR_TANGENT_ARC_TO_NV' else
      if self.val = UInt32($00FE) then Result := 'ARC_TO_NV' else
      if self.val = UInt32($00FF) then Result := 'RELATIVE_ARC_TO_NV' else
        Result := $'PathCoordType[{self.val}]';
    end;
    
  end;
  
  PathCoverMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PATH_FILL_COVER_MODE_NV:           PathCoverMode read new PathCoverMode($9082);
    public static property CONVEX_HULL_NV:                    PathCoverMode read new PathCoverMode($908B);
    public static property BOUNDING_BOX_NV:                   PathCoverMode read new PathCoverMode($908D);
    public static property BOUNDING_BOX_OF_BOUNDING_BOXES_NV: PathCoverMode read new PathCoverMode($909C);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9082) then Result := 'PATH_FILL_COVER_MODE_NV' else
      if self.val = UInt32($908B) then Result := 'CONVEX_HULL_NV' else
      if self.val = UInt32($908D) then Result := 'BOUNDING_BOX_NV' else
      if self.val = UInt32($909C) then Result := 'BOUNDING_BOX_OF_BOUNDING_BOXES_NV' else
        Result := $'PathCoverMode[{self.val}]';
    end;
    
  end;
  
  PathElementType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UTF8_NV:  PathElementType read new PathElementType($909A);
    public static property UTF16_NV: PathElementType read new PathElementType($909B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($909A) then Result := 'UTF8_NV' else
      if self.val = UInt32($909B) then Result := 'UTF16_NV' else
        Result := $'PathElementType[{self.val}]';
    end;
    
  end;
  
  PathFillMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property INVERT:            PathFillMode read new PathFillMode($150A);
    public static property PATH_FILL_MODE_NV: PathFillMode read new PathFillMode($9080);
    public static property COUNT_UP_NV:       PathFillMode read new PathFillMode($9088);
    public static property COUNT_DOWN_NV:     PathFillMode read new PathFillMode($9089);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($150A) then Result := 'INVERT' else
      if self.val = UInt32($9080) then Result := 'PATH_FILL_MODE_NV' else
      if self.val = UInt32($9088) then Result := 'COUNT_UP_NV' else
      if self.val = UInt32($9089) then Result := 'COUNT_DOWN_NV' else
        Result := $'PathFillMode[{self.val}]';
    end;
    
  end;
  
  PathFontStyle = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:          PathFontStyle read new PathFontStyle($0000);
    public static property BOLD_BIT_NV:   PathFontStyle read new PathFontStyle($0001);
    public static property ITALIC_BIT_NV: PathFontStyle read new PathFontStyle($0002);
    
    public static function operator+(f1,f2: PathFontStyle) := new PathFontStyle(f1.val or f2.val);
    public static function operator or(f1,f2: PathFontStyle) := f1+f2;
    
    public property ANY_FLAGS: boolean read self.val<>0;
    public property HAS_FLAG_BOLD_BIT_NV:   boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_ITALIC_BIT_NV: boolean read self.val and $0002 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0000) = UInt32($0000) then res += 'NONE+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'BOLD_BIT_NV+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'ITALIC_BIT_NV+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'PathFontStyle[{self.val}]';
    end;
    
  end;
  
  PathFontTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property STANDARD_FONT_NAME_NV: PathFontTarget read new PathFontTarget($9072);
    public static property SYSTEM_FONT_NAME_NV:   PathFontTarget read new PathFontTarget($9073);
    public static property FILE_NAME_NV:          PathFontTarget read new PathFontTarget($9074);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9072) then Result := 'STANDARD_FONT_NAME_NV' else
      if self.val = UInt32($9073) then Result := 'SYSTEM_FONT_NAME_NV' else
      if self.val = UInt32($9074) then Result := 'FILE_NAME_NV' else
        Result := $'PathFontTarget[{self.val}]';
    end;
    
  end;
  
  PathGenMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:                        PathGenMode read new PathGenMode($0000);
    public static property EYE_LINEAR:                  PathGenMode read new PathGenMode($2400);
    public static property OBJECT_LINEAR:               PathGenMode read new PathGenMode($2401);
    public static property CONSTANT:                    PathGenMode read new PathGenMode($8576);
    public static property PATH_OBJECT_BOUNDING_BOX_NV: PathGenMode read new PathGenMode($908A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($2400) then Result := 'EYE_LINEAR' else
      if self.val = UInt32($2401) then Result := 'OBJECT_LINEAR' else
      if self.val = UInt32($8576) then Result := 'CONSTANT' else
      if self.val = UInt32($908A) then Result := 'PATH_OBJECT_BOUNDING_BOX_NV' else
        Result := $'PathGenMode[{self.val}]';
    end;
    
  end;
  
  PathHandleMissingGlyphs = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SKIP_MISSING_GLYPH_NV: PathHandleMissingGlyphs read new PathHandleMissingGlyphs($90A9);
    public static property USE_MISSING_GLYPH_NV:  PathHandleMissingGlyphs read new PathHandleMissingGlyphs($90AA);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($90A9) then Result := 'SKIP_MISSING_GLYPH_NV' else
      if self.val = UInt32($90AA) then Result := 'USE_MISSING_GLYPH_NV' else
        Result := $'PathHandleMissingGlyphs[{self.val}]';
    end;
    
  end;
  
  PathListMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ACCUM_ADJACENT_PAIRS_NV: PathListMode read new PathListMode($90AD);
    public static property ADJACENT_PAIRS_NV:       PathListMode read new PathListMode($90AE);
    public static property FIRST_TO_REST_NV:        PathListMode read new PathListMode($90AF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($90AD) then Result := 'ACCUM_ADJACENT_PAIRS_NV' else
      if self.val = UInt32($90AE) then Result := 'ADJACENT_PAIRS_NV' else
      if self.val = UInt32($90AF) then Result := 'FIRST_TO_REST_NV' else
        Result := $'PathListMode[{self.val}]';
    end;
    
  end;
  
  PathMetricMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property GLYPH_WIDTH_BIT_NV:                      PathMetricMask read new PathMetricMask($0001);
    public static property GLYPH_HEIGHT_BIT_NV:                     PathMetricMask read new PathMetricMask($0002);
    public static property GLYPH_HORIZONTAL_BEARING_X_BIT_NV:       PathMetricMask read new PathMetricMask($0004);
    public static property GLYPH_HORIZONTAL_BEARING_Y_BIT_NV:       PathMetricMask read new PathMetricMask($0008);
    public static property GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV: PathMetricMask read new PathMetricMask($0010);
    public static property GLYPH_VERTICAL_BEARING_X_BIT_NV:         PathMetricMask read new PathMetricMask($0020);
    public static property GLYPH_VERTICAL_BEARING_Y_BIT_NV:         PathMetricMask read new PathMetricMask($0040);
    public static property GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV:   PathMetricMask read new PathMetricMask($0080);
    public static property GLYPH_HAS_KERNING_BIT_NV:                PathMetricMask read new PathMetricMask($0100);
    public static property FONT_X_MIN_BOUNDS_BIT_NV:                PathMetricMask read new PathMetricMask($10000);
    public static property FONT_Y_MIN_BOUNDS_BIT_NV:                PathMetricMask read new PathMetricMask($20000);
    public static property FONT_X_MAX_BOUNDS_BIT_NV:                PathMetricMask read new PathMetricMask($40000);
    public static property FONT_Y_MAX_BOUNDS_BIT_NV:                PathMetricMask read new PathMetricMask($80000);
    public static property FONT_UNITS_PER_EM_BIT_NV:                PathMetricMask read new PathMetricMask($100000);
    public static property FONT_ASCENDER_BIT_NV:                    PathMetricMask read new PathMetricMask($200000);
    public static property FONT_DESCENDER_BIT_NV:                   PathMetricMask read new PathMetricMask($400000);
    public static property FONT_HEIGHT_BIT_NV:                      PathMetricMask read new PathMetricMask($800000);
    public static property FONT_MAX_ADVANCE_WIDTH_BIT_NV:           PathMetricMask read new PathMetricMask($1000000);
    public static property FONT_MAX_ADVANCE_HEIGHT_BIT_NV:          PathMetricMask read new PathMetricMask($2000000);
    public static property FONT_UNDERLINE_POSITION_BIT_NV:          PathMetricMask read new PathMetricMask($4000000);
    public static property FONT_UNDERLINE_THICKNESS_BIT_NV:         PathMetricMask read new PathMetricMask($8000000);
    public static property FONT_HAS_KERNING_BIT_NV:                 PathMetricMask read new PathMetricMask($10000000);
    public static property FONT_NUM_GLYPH_INDICES_BIT_NV:           PathMetricMask read new PathMetricMask($20000000);
    
    public static function operator+(f1,f2: PathMetricMask) := new PathMetricMask(f1.val or f2.val);
    public static function operator or(f1,f2: PathMetricMask) := f1+f2;
    
    public property HAS_FLAG_GLYPH_WIDTH_BIT_NV:                      boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_GLYPH_HEIGHT_BIT_NV:                     boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_GLYPH_HORIZONTAL_BEARING_X_BIT_NV:       boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_GLYPH_HORIZONTAL_BEARING_Y_BIT_NV:       boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV: boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_GLYPH_VERTICAL_BEARING_X_BIT_NV:         boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_GLYPH_VERTICAL_BEARING_Y_BIT_NV:         boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV:   boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_GLYPH_HAS_KERNING_BIT_NV:                boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_FONT_X_MIN_BOUNDS_BIT_NV:                boolean read self.val and $10000 <> 0;
    public property HAS_FLAG_FONT_Y_MIN_BOUNDS_BIT_NV:                boolean read self.val and $20000 <> 0;
    public property HAS_FLAG_FONT_X_MAX_BOUNDS_BIT_NV:                boolean read self.val and $40000 <> 0;
    public property HAS_FLAG_FONT_Y_MAX_BOUNDS_BIT_NV:                boolean read self.val and $80000 <> 0;
    public property HAS_FLAG_FONT_UNITS_PER_EM_BIT_NV:                boolean read self.val and $100000 <> 0;
    public property HAS_FLAG_FONT_ASCENDER_BIT_NV:                    boolean read self.val and $200000 <> 0;
    public property HAS_FLAG_FONT_DESCENDER_BIT_NV:                   boolean read self.val and $400000 <> 0;
    public property HAS_FLAG_FONT_HEIGHT_BIT_NV:                      boolean read self.val and $800000 <> 0;
    public property HAS_FLAG_FONT_MAX_ADVANCE_WIDTH_BIT_NV:           boolean read self.val and $1000000 <> 0;
    public property HAS_FLAG_FONT_MAX_ADVANCE_HEIGHT_BIT_NV:          boolean read self.val and $2000000 <> 0;
    public property HAS_FLAG_FONT_UNDERLINE_POSITION_BIT_NV:          boolean read self.val and $4000000 <> 0;
    public property HAS_FLAG_FONT_UNDERLINE_THICKNESS_BIT_NV:         boolean read self.val and $8000000 <> 0;
    public property HAS_FLAG_FONT_HAS_KERNING_BIT_NV:                 boolean read self.val and $10000000 <> 0;
    public property HAS_FLAG_FONT_NUM_GLYPH_INDICES_BIT_NV:           boolean read self.val and $20000000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'GLYPH_WIDTH_BIT_NV+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'GLYPH_HEIGHT_BIT_NV+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'GLYPH_HORIZONTAL_BEARING_X_BIT_NV+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'GLYPH_HORIZONTAL_BEARING_Y_BIT_NV+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'GLYPH_VERTICAL_BEARING_X_BIT_NV+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'GLYPH_VERTICAL_BEARING_Y_BIT_NV+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV+';
      if self.val and UInt32($0100) = UInt32($0100) then res += 'GLYPH_HAS_KERNING_BIT_NV+';
      if self.val and UInt32($10000) = UInt32($10000) then res += 'FONT_X_MIN_BOUNDS_BIT_NV+';
      if self.val and UInt32($20000) = UInt32($20000) then res += 'FONT_Y_MIN_BOUNDS_BIT_NV+';
      if self.val and UInt32($40000) = UInt32($40000) then res += 'FONT_X_MAX_BOUNDS_BIT_NV+';
      if self.val and UInt32($80000) = UInt32($80000) then res += 'FONT_Y_MAX_BOUNDS_BIT_NV+';
      if self.val and UInt32($100000) = UInt32($100000) then res += 'FONT_UNITS_PER_EM_BIT_NV+';
      if self.val and UInt32($200000) = UInt32($200000) then res += 'FONT_ASCENDER_BIT_NV+';
      if self.val and UInt32($400000) = UInt32($400000) then res += 'FONT_DESCENDER_BIT_NV+';
      if self.val and UInt32($800000) = UInt32($800000) then res += 'FONT_HEIGHT_BIT_NV+';
      if self.val and UInt32($1000000) = UInt32($1000000) then res += 'FONT_MAX_ADVANCE_WIDTH_BIT_NV+';
      if self.val and UInt32($2000000) = UInt32($2000000) then res += 'FONT_MAX_ADVANCE_HEIGHT_BIT_NV+';
      if self.val and UInt32($4000000) = UInt32($4000000) then res += 'FONT_UNDERLINE_POSITION_BIT_NV+';
      if self.val and UInt32($8000000) = UInt32($8000000) then res += 'FONT_UNDERLINE_THICKNESS_BIT_NV+';
      if self.val and UInt32($10000000) = UInt32($10000000) then res += 'FONT_HAS_KERNING_BIT_NV+';
      if self.val and UInt32($20000000) = UInt32($20000000) then res += 'FONT_NUM_GLYPH_INDICES_BIT_NV+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'PathMetricMask[{self.val}]';
    end;
    
  end;
  
  PathParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PATH_STROKE_WIDTH_NV:        PathParameter read new PathParameter($9075);
    public static property PATH_END_CAPS_NV:            PathParameter read new PathParameter($9076);
    public static property PATH_INITIAL_END_CAP_NV:     PathParameter read new PathParameter($9077);
    public static property PATH_TERMINAL_END_CAP_NV:    PathParameter read new PathParameter($9078);
    public static property PATH_JOIN_STYLE_NV:          PathParameter read new PathParameter($9079);
    public static property PATH_MITER_LIMIT_NV:         PathParameter read new PathParameter($907A);
    public static property PATH_DASH_CAPS_NV:           PathParameter read new PathParameter($907B);
    public static property PATH_INITIAL_DASH_CAP_NV:    PathParameter read new PathParameter($907C);
    public static property PATH_TERMINAL_DASH_CAP_NV:   PathParameter read new PathParameter($907D);
    public static property PATH_DASH_OFFSET_NV:         PathParameter read new PathParameter($907E);
    public static property PATH_CLIENT_LENGTH_NV:       PathParameter read new PathParameter($907F);
    public static property PATH_FILL_MODE_NV:           PathParameter read new PathParameter($9080);
    public static property PATH_FILL_MASK_NV:           PathParameter read new PathParameter($9081);
    public static property PATH_FILL_COVER_MODE_NV:     PathParameter read new PathParameter($9082);
    public static property PATH_STROKE_COVER_MODE_NV:   PathParameter read new PathParameter($9083);
    public static property PATH_STROKE_MASK_NV:         PathParameter read new PathParameter($9084);
    public static property PATH_OBJECT_BOUNDING_BOX_NV: PathParameter read new PathParameter($908A);
    public static property PATH_COMMAND_COUNT_NV:       PathParameter read new PathParameter($909D);
    public static property PATH_COORD_COUNT_NV:         PathParameter read new PathParameter($909E);
    public static property PATH_DASH_ARRAY_COUNT_NV:    PathParameter read new PathParameter($909F);
    public static property PATH_COMPUTED_LENGTH_NV:     PathParameter read new PathParameter($90A0);
    public static property PATH_FILL_BOUNDING_BOX_NV:   PathParameter read new PathParameter($90A1);
    public static property PATH_STROKE_BOUNDING_BOX_NV: PathParameter read new PathParameter($90A2);
    public static property PATH_DASH_OFFSET_RESET_NV:   PathParameter read new PathParameter($90B4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9075) then Result := 'PATH_STROKE_WIDTH_NV' else
      if self.val = UInt32($9076) then Result := 'PATH_END_CAPS_NV' else
      if self.val = UInt32($9077) then Result := 'PATH_INITIAL_END_CAP_NV' else
      if self.val = UInt32($9078) then Result := 'PATH_TERMINAL_END_CAP_NV' else
      if self.val = UInt32($9079) then Result := 'PATH_JOIN_STYLE_NV' else
      if self.val = UInt32($907A) then Result := 'PATH_MITER_LIMIT_NV' else
      if self.val = UInt32($907B) then Result := 'PATH_DASH_CAPS_NV' else
      if self.val = UInt32($907C) then Result := 'PATH_INITIAL_DASH_CAP_NV' else
      if self.val = UInt32($907D) then Result := 'PATH_TERMINAL_DASH_CAP_NV' else
      if self.val = UInt32($907E) then Result := 'PATH_DASH_OFFSET_NV' else
      if self.val = UInt32($907F) then Result := 'PATH_CLIENT_LENGTH_NV' else
      if self.val = UInt32($9080) then Result := 'PATH_FILL_MODE_NV' else
      if self.val = UInt32($9081) then Result := 'PATH_FILL_MASK_NV' else
      if self.val = UInt32($9082) then Result := 'PATH_FILL_COVER_MODE_NV' else
      if self.val = UInt32($9083) then Result := 'PATH_STROKE_COVER_MODE_NV' else
      if self.val = UInt32($9084) then Result := 'PATH_STROKE_MASK_NV' else
      if self.val = UInt32($908A) then Result := 'PATH_OBJECT_BOUNDING_BOX_NV' else
      if self.val = UInt32($909D) then Result := 'PATH_COMMAND_COUNT_NV' else
      if self.val = UInt32($909E) then Result := 'PATH_COORD_COUNT_NV' else
      if self.val = UInt32($909F) then Result := 'PATH_DASH_ARRAY_COUNT_NV' else
      if self.val = UInt32($90A0) then Result := 'PATH_COMPUTED_LENGTH_NV' else
      if self.val = UInt32($90A1) then Result := 'PATH_FILL_BOUNDING_BOX_NV' else
      if self.val = UInt32($90A2) then Result := 'PATH_STROKE_BOUNDING_BOX_NV' else
      if self.val = UInt32($90B4) then Result := 'PATH_DASH_OFFSET_RESET_NV' else
        Result := $'PathParameter[{self.val}]';
    end;
    
  end;
  
  PathStringFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PATH_FORMAT_SVG_NV: PathStringFormat read new PathStringFormat($9070);
    public static property PATH_FORMAT_PS_NV:  PathStringFormat read new PathStringFormat($9071);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9070) then Result := 'PATH_FORMAT_SVG_NV' else
      if self.val = UInt32($9071) then Result := 'PATH_FORMAT_PS_NV' else
        Result := $'PathStringFormat[{self.val}]';
    end;
    
  end;
  
  PathTransformType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:                   PathTransformType read new PathTransformType($0000);
    public static property TRANSLATE_X_NV:         PathTransformType read new PathTransformType($908E);
    public static property TRANSLATE_Y_NV:         PathTransformType read new PathTransformType($908F);
    public static property TRANSLATE_2D_NV:        PathTransformType read new PathTransformType($9090);
    public static property TRANSLATE_3D_NV:        PathTransformType read new PathTransformType($9091);
    public static property AFFINE_2D_NV:           PathTransformType read new PathTransformType($9092);
    public static property AFFINE_3D_NV:           PathTransformType read new PathTransformType($9094);
    public static property TRANSPOSE_AFFINE_2D_NV: PathTransformType read new PathTransformType($9096);
    public static property TRANSPOSE_AFFINE_3D_NV: PathTransformType read new PathTransformType($9098);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($908E) then Result := 'TRANSLATE_X_NV' else
      if self.val = UInt32($908F) then Result := 'TRANSLATE_Y_NV' else
      if self.val = UInt32($9090) then Result := 'TRANSLATE_2D_NV' else
      if self.val = UInt32($9091) then Result := 'TRANSLATE_3D_NV' else
      if self.val = UInt32($9092) then Result := 'AFFINE_2D_NV' else
      if self.val = UInt32($9094) then Result := 'AFFINE_3D_NV' else
      if self.val = UInt32($9096) then Result := 'TRANSPOSE_AFFINE_2D_NV' else
      if self.val = UInt32($9098) then Result := 'TRANSPOSE_AFFINE_3D_NV' else
        Result := $'PathTransformType[{self.val}]';
    end;
    
  end;
  
  PipelineParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ACTIVE_PROGRAM:         PipelineParameterName read new PipelineParameterName($8259);
    public static property FRAGMENT_SHADER:        PipelineParameterName read new PipelineParameterName($8B30);
    public static property VERTEX_SHADER:          PipelineParameterName read new PipelineParameterName($8B31);
    public static property INFO_LOG_LENGTH:        PipelineParameterName read new PipelineParameterName($8B84);
    public static property GEOMETRY_SHADER:        PipelineParameterName read new PipelineParameterName($8DD9);
    public static property TESS_EVALUATION_SHADER: PipelineParameterName read new PipelineParameterName($8E87);
    public static property TESS_CONTROL_SHADER:    PipelineParameterName read new PipelineParameterName($8E88);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8259) then Result := 'ACTIVE_PROGRAM' else
      if self.val = UInt32($8B30) then Result := 'FRAGMENT_SHADER' else
      if self.val = UInt32($8B31) then Result := 'VERTEX_SHADER' else
      if self.val = UInt32($8B84) then Result := 'INFO_LOG_LENGTH' else
      if self.val = UInt32($8DD9) then Result := 'GEOMETRY_SHADER' else
      if self.val = UInt32($8E87) then Result := 'TESS_EVALUATION_SHADER' else
      if self.val = UInt32($8E88) then Result := 'TESS_CONTROL_SHADER' else
        Result := $'PipelineParameterName[{self.val}]';
    end;
    
  end;
  
  PipeParticipationTypeFlags = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DISPLAY_PIPE_SGIX: PipeParticipationTypeFlags read new PipeParticipationTypeFlags($0001);
    public static property RENDER_PIPE_SGIX:  PipeParticipationTypeFlags read new PipeParticipationTypeFlags($0002);
    
    public static function operator+(f1,f2: PipeParticipationTypeFlags) := new PipeParticipationTypeFlags(f1.val or f2.val);
    public static function operator or(f1,f2: PipeParticipationTypeFlags) := f1+f2;
    
    public property HAS_FLAG_DISPLAY_PIPE_SGIX: boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_RENDER_PIPE_SGIX:  boolean read self.val and $0002 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'DISPLAY_PIPE_SGIX+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'RENDER_PIPE_SGIX+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'PipeParticipationTypeFlags[{self.val}]';
    end;
    
  end;
  
  PixelCopyType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COLOR:       PixelCopyType read new PixelCopyType($1800);
    public static property COLOR_EXT:   PixelCopyType read new PixelCopyType($1800);
    public static property DEPTH:       PixelCopyType read new PixelCopyType($1801);
    public static property DEPTH_EXT:   PixelCopyType read new PixelCopyType($1801);
    public static property STENCIL:     PixelCopyType read new PixelCopyType($1802);
    public static property STENCIL_EXT: PixelCopyType read new PixelCopyType($1802);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1800) then Result := 'COLOR' else
      if self.val = UInt32($1800) then Result := 'COLOR_EXT' else
      if self.val = UInt32($1801) then Result := 'DEPTH' else
      if self.val = UInt32($1801) then Result := 'DEPTH_EXT' else
      if self.val = UInt32($1802) then Result := 'STENCIL' else
      if self.val = UInt32($1802) then Result := 'STENCIL_EXT' else
        Result := $'PixelCopyType[{self.val}]';
    end;
    
  end;
  
  PixelFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_SHORT:  PixelFormat read new PixelFormat($1403);
    public static property UNSIGNED_INT:    PixelFormat read new PixelFormat($1405);
    public static property COLOR_INDEX:     PixelFormat read new PixelFormat($1900);
    public static property STENCIL_INDEX:   PixelFormat read new PixelFormat($1901);
    public static property DEPTH_COMPONENT: PixelFormat read new PixelFormat($1902);
    public static property RED:             PixelFormat read new PixelFormat($1903);
    public static property RED_EXT:         PixelFormat read new PixelFormat($1903);
    public static property GREEN:           PixelFormat read new PixelFormat($1904);
    public static property BLUE:            PixelFormat read new PixelFormat($1905);
    public static property ALPHA:           PixelFormat read new PixelFormat($1906);
    public static property RGB:             PixelFormat read new PixelFormat($1907);
    public static property RGBA:            PixelFormat read new PixelFormat($1908);
    public static property LUMINANCE:       PixelFormat read new PixelFormat($1909);
    public static property LUMINANCE_ALPHA: PixelFormat read new PixelFormat($190A);
    public static property ABGR_EXT:        PixelFormat read new PixelFormat($8000);
    public static property CMYK_EXT:        PixelFormat read new PixelFormat($800C);
    public static property CMYKA_EXT:       PixelFormat read new PixelFormat($800D);
    public static property BGR:             PixelFormat read new PixelFormat($80E0);
    public static property BGRA:            PixelFormat read new PixelFormat($80E1);
    public static property YCRCB_422_SGIX:  PixelFormat read new PixelFormat($81BB);
    public static property YCRCB_444_SGIX:  PixelFormat read new PixelFormat($81BC);
    public static property RG:              PixelFormat read new PixelFormat($8227);
    public static property RG_INTEGER:      PixelFormat read new PixelFormat($8228);
    public static property DEPTH_STENCIL:   PixelFormat read new PixelFormat($84F9);
    public static property RED_INTEGER:     PixelFormat read new PixelFormat($8D94);
    public static property GREEN_INTEGER:   PixelFormat read new PixelFormat($8D95);
    public static property BLUE_INTEGER:    PixelFormat read new PixelFormat($8D96);
    public static property RGB_INTEGER:     PixelFormat read new PixelFormat($8D98);
    public static property RGBA_INTEGER:    PixelFormat read new PixelFormat($8D99);
    public static property BGR_INTEGER:     PixelFormat read new PixelFormat($8D9A);
    public static property BGRA_INTEGER:    PixelFormat read new PixelFormat($8D9B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1900) then Result := 'COLOR_INDEX' else
      if self.val = UInt32($1901) then Result := 'STENCIL_INDEX' else
      if self.val = UInt32($1902) then Result := 'DEPTH_COMPONENT' else
      if self.val = UInt32($1903) then Result := 'RED' else
      if self.val = UInt32($1903) then Result := 'RED_EXT' else
      if self.val = UInt32($1904) then Result := 'GREEN' else
      if self.val = UInt32($1905) then Result := 'BLUE' else
      if self.val = UInt32($1906) then Result := 'ALPHA' else
      if self.val = UInt32($1907) then Result := 'RGB' else
      if self.val = UInt32($1908) then Result := 'RGBA' else
      if self.val = UInt32($1909) then Result := 'LUMINANCE' else
      if self.val = UInt32($190A) then Result := 'LUMINANCE_ALPHA' else
      if self.val = UInt32($8000) then Result := 'ABGR_EXT' else
      if self.val = UInt32($800C) then Result := 'CMYK_EXT' else
      if self.val = UInt32($800D) then Result := 'CMYKA_EXT' else
      if self.val = UInt32($80E0) then Result := 'BGR' else
      if self.val = UInt32($80E1) then Result := 'BGRA' else
      if self.val = UInt32($81BB) then Result := 'YCRCB_422_SGIX' else
      if self.val = UInt32($81BC) then Result := 'YCRCB_444_SGIX' else
      if self.val = UInt32($8227) then Result := 'RG' else
      if self.val = UInt32($8228) then Result := 'RG_INTEGER' else
      if self.val = UInt32($84F9) then Result := 'DEPTH_STENCIL' else
      if self.val = UInt32($8D94) then Result := 'RED_INTEGER' else
      if self.val = UInt32($8D95) then Result := 'GREEN_INTEGER' else
      if self.val = UInt32($8D96) then Result := 'BLUE_INTEGER' else
      if self.val = UInt32($8D98) then Result := 'RGB_INTEGER' else
      if self.val = UInt32($8D99) then Result := 'RGBA_INTEGER' else
      if self.val = UInt32($8D9A) then Result := 'BGR_INTEGER' else
      if self.val = UInt32($8D9B) then Result := 'BGRA_INTEGER' else
        Result := $'PixelFormat[{self.val}]';
    end;
    
  end;
  
  PixelMap = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PIXEL_MAP_I_TO_I: PixelMap read new PixelMap($0C70);
    public static property PIXEL_MAP_S_TO_S: PixelMap read new PixelMap($0C71);
    public static property PIXEL_MAP_I_TO_R: PixelMap read new PixelMap($0C72);
    public static property PIXEL_MAP_I_TO_G: PixelMap read new PixelMap($0C73);
    public static property PIXEL_MAP_I_TO_B: PixelMap read new PixelMap($0C74);
    public static property PIXEL_MAP_I_TO_A: PixelMap read new PixelMap($0C75);
    public static property PIXEL_MAP_R_TO_R: PixelMap read new PixelMap($0C76);
    public static property PIXEL_MAP_G_TO_G: PixelMap read new PixelMap($0C77);
    public static property PIXEL_MAP_B_TO_B: PixelMap read new PixelMap($0C78);
    public static property PIXEL_MAP_A_TO_A: PixelMap read new PixelMap($0C79);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0C70) then Result := 'PIXEL_MAP_I_TO_I' else
      if self.val = UInt32($0C71) then Result := 'PIXEL_MAP_S_TO_S' else
      if self.val = UInt32($0C72) then Result := 'PIXEL_MAP_I_TO_R' else
      if self.val = UInt32($0C73) then Result := 'PIXEL_MAP_I_TO_G' else
      if self.val = UInt32($0C74) then Result := 'PIXEL_MAP_I_TO_B' else
      if self.val = UInt32($0C75) then Result := 'PIXEL_MAP_I_TO_A' else
      if self.val = UInt32($0C76) then Result := 'PIXEL_MAP_R_TO_R' else
      if self.val = UInt32($0C77) then Result := 'PIXEL_MAP_G_TO_G' else
      if self.val = UInt32($0C78) then Result := 'PIXEL_MAP_B_TO_B' else
      if self.val = UInt32($0C79) then Result := 'PIXEL_MAP_A_TO_A' else
        Result := $'PixelMap[{self.val}]';
    end;
    
  end;
  
  PixelStoreParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNPACK_SWAP_BYTES:           PixelStoreParameter read new PixelStoreParameter($0CF0);
    public static property UNPACK_LSB_FIRST:            PixelStoreParameter read new PixelStoreParameter($0CF1);
    public static property UNPACK_ROW_LENGTH:           PixelStoreParameter read new PixelStoreParameter($0CF2);
    public static property UNPACK_ROW_LENGTH_EXT:       PixelStoreParameter read new PixelStoreParameter($0CF2);
    public static property UNPACK_SKIP_ROWS:            PixelStoreParameter read new PixelStoreParameter($0CF3);
    public static property UNPACK_SKIP_ROWS_EXT:        PixelStoreParameter read new PixelStoreParameter($0CF3);
    public static property UNPACK_SKIP_PIXELS:          PixelStoreParameter read new PixelStoreParameter($0CF4);
    public static property UNPACK_SKIP_PIXELS_EXT:      PixelStoreParameter read new PixelStoreParameter($0CF4);
    public static property UNPACK_ALIGNMENT:            PixelStoreParameter read new PixelStoreParameter($0CF5);
    public static property PACK_SWAP_BYTES:             PixelStoreParameter read new PixelStoreParameter($0D00);
    public static property PACK_LSB_FIRST:              PixelStoreParameter read new PixelStoreParameter($0D01);
    public static property PACK_ROW_LENGTH:             PixelStoreParameter read new PixelStoreParameter($0D02);
    public static property PACK_SKIP_ROWS:              PixelStoreParameter read new PixelStoreParameter($0D03);
    public static property PACK_SKIP_PIXELS:            PixelStoreParameter read new PixelStoreParameter($0D04);
    public static property PACK_ALIGNMENT:              PixelStoreParameter read new PixelStoreParameter($0D05);
    public static property PACK_SKIP_IMAGES:            PixelStoreParameter read new PixelStoreParameter($806B);
    public static property PACK_SKIP_IMAGES_EXT:        PixelStoreParameter read new PixelStoreParameter($806B);
    public static property PACK_IMAGE_HEIGHT:           PixelStoreParameter read new PixelStoreParameter($806C);
    public static property PACK_IMAGE_HEIGHT_EXT:       PixelStoreParameter read new PixelStoreParameter($806C);
    public static property UNPACK_SKIP_IMAGES:          PixelStoreParameter read new PixelStoreParameter($806D);
    public static property UNPACK_SKIP_IMAGES_EXT:      PixelStoreParameter read new PixelStoreParameter($806D);
    public static property UNPACK_IMAGE_HEIGHT:         PixelStoreParameter read new PixelStoreParameter($806E);
    public static property UNPACK_IMAGE_HEIGHT_EXT:     PixelStoreParameter read new PixelStoreParameter($806E);
    public static property PACK_SKIP_VOLUMES_SGIS:      PixelStoreParameter read new PixelStoreParameter($8130);
    public static property PACK_IMAGE_DEPTH_SGIS:       PixelStoreParameter read new PixelStoreParameter($8131);
    public static property UNPACK_SKIP_VOLUMES_SGIS:    PixelStoreParameter read new PixelStoreParameter($8132);
    public static property UNPACK_IMAGE_DEPTH_SGIS:     PixelStoreParameter read new PixelStoreParameter($8133);
    public static property PIXEL_TILE_WIDTH_SGIX:       PixelStoreParameter read new PixelStoreParameter($8140);
    public static property PIXEL_TILE_HEIGHT_SGIX:      PixelStoreParameter read new PixelStoreParameter($8141);
    public static property PIXEL_TILE_GRID_WIDTH_SGIX:  PixelStoreParameter read new PixelStoreParameter($8142);
    public static property PIXEL_TILE_GRID_HEIGHT_SGIX: PixelStoreParameter read new PixelStoreParameter($8143);
    public static property PIXEL_TILE_GRID_DEPTH_SGIX:  PixelStoreParameter read new PixelStoreParameter($8144);
    public static property PIXEL_TILE_CACHE_SIZE_SGIX:  PixelStoreParameter read new PixelStoreParameter($8145);
    public static property PACK_RESAMPLE_SGIX:          PixelStoreParameter read new PixelStoreParameter($842E);
    public static property UNPACK_RESAMPLE_SGIX:        PixelStoreParameter read new PixelStoreParameter($842F);
    public static property PACK_SUBSAMPLE_RATE_SGIX:    PixelStoreParameter read new PixelStoreParameter($85A0);
    public static property UNPACK_SUBSAMPLE_RATE_SGIX:  PixelStoreParameter read new PixelStoreParameter($85A1);
    public static property PACK_RESAMPLE_OML:           PixelStoreParameter read new PixelStoreParameter($8984);
    public static property UNPACK_RESAMPLE_OML:         PixelStoreParameter read new PixelStoreParameter($8985);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0CF0) then Result := 'UNPACK_SWAP_BYTES' else
      if self.val = UInt32($0CF1) then Result := 'UNPACK_LSB_FIRST' else
      if self.val = UInt32($0CF2) then Result := 'UNPACK_ROW_LENGTH' else
      if self.val = UInt32($0CF2) then Result := 'UNPACK_ROW_LENGTH_EXT' else
      if self.val = UInt32($0CF3) then Result := 'UNPACK_SKIP_ROWS' else
      if self.val = UInt32($0CF3) then Result := 'UNPACK_SKIP_ROWS_EXT' else
      if self.val = UInt32($0CF4) then Result := 'UNPACK_SKIP_PIXELS' else
      if self.val = UInt32($0CF4) then Result := 'UNPACK_SKIP_PIXELS_EXT' else
      if self.val = UInt32($0CF5) then Result := 'UNPACK_ALIGNMENT' else
      if self.val = UInt32($0D00) then Result := 'PACK_SWAP_BYTES' else
      if self.val = UInt32($0D01) then Result := 'PACK_LSB_FIRST' else
      if self.val = UInt32($0D02) then Result := 'PACK_ROW_LENGTH' else
      if self.val = UInt32($0D03) then Result := 'PACK_SKIP_ROWS' else
      if self.val = UInt32($0D04) then Result := 'PACK_SKIP_PIXELS' else
      if self.val = UInt32($0D05) then Result := 'PACK_ALIGNMENT' else
      if self.val = UInt32($806B) then Result := 'PACK_SKIP_IMAGES' else
      if self.val = UInt32($806B) then Result := 'PACK_SKIP_IMAGES_EXT' else
      if self.val = UInt32($806C) then Result := 'PACK_IMAGE_HEIGHT' else
      if self.val = UInt32($806C) then Result := 'PACK_IMAGE_HEIGHT_EXT' else
      if self.val = UInt32($806D) then Result := 'UNPACK_SKIP_IMAGES' else
      if self.val = UInt32($806D) then Result := 'UNPACK_SKIP_IMAGES_EXT' else
      if self.val = UInt32($806E) then Result := 'UNPACK_IMAGE_HEIGHT' else
      if self.val = UInt32($806E) then Result := 'UNPACK_IMAGE_HEIGHT_EXT' else
      if self.val = UInt32($8130) then Result := 'PACK_SKIP_VOLUMES_SGIS' else
      if self.val = UInt32($8131) then Result := 'PACK_IMAGE_DEPTH_SGIS' else
      if self.val = UInt32($8132) then Result := 'UNPACK_SKIP_VOLUMES_SGIS' else
      if self.val = UInt32($8133) then Result := 'UNPACK_IMAGE_DEPTH_SGIS' else
      if self.val = UInt32($8140) then Result := 'PIXEL_TILE_WIDTH_SGIX' else
      if self.val = UInt32($8141) then Result := 'PIXEL_TILE_HEIGHT_SGIX' else
      if self.val = UInt32($8142) then Result := 'PIXEL_TILE_GRID_WIDTH_SGIX' else
      if self.val = UInt32($8143) then Result := 'PIXEL_TILE_GRID_HEIGHT_SGIX' else
      if self.val = UInt32($8144) then Result := 'PIXEL_TILE_GRID_DEPTH_SGIX' else
      if self.val = UInt32($8145) then Result := 'PIXEL_TILE_CACHE_SIZE_SGIX' else
      if self.val = UInt32($842E) then Result := 'PACK_RESAMPLE_SGIX' else
      if self.val = UInt32($842F) then Result := 'UNPACK_RESAMPLE_SGIX' else
      if self.val = UInt32($85A0) then Result := 'PACK_SUBSAMPLE_RATE_SGIX' else
      if self.val = UInt32($85A1) then Result := 'UNPACK_SUBSAMPLE_RATE_SGIX' else
      if self.val = UInt32($8984) then Result := 'PACK_RESAMPLE_OML' else
      if self.val = UInt32($8985) then Result := 'UNPACK_RESAMPLE_OML' else
        Result := $'PixelStoreParameter[{self.val}]';
    end;
    
  end;
  
  PixelTransferParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MAP_COLOR:                         PixelTransferParameter read new PixelTransferParameter($0D10);
    public static property MAP_STENCIL:                       PixelTransferParameter read new PixelTransferParameter($0D11);
    public static property INDEX_SHIFT:                       PixelTransferParameter read new PixelTransferParameter($0D12);
    public static property INDEX_OFFSET:                      PixelTransferParameter read new PixelTransferParameter($0D13);
    public static property RED_SCALE:                         PixelTransferParameter read new PixelTransferParameter($0D14);
    public static property RED_BIAS:                          PixelTransferParameter read new PixelTransferParameter($0D15);
    public static property GREEN_SCALE:                       PixelTransferParameter read new PixelTransferParameter($0D18);
    public static property GREEN_BIAS:                        PixelTransferParameter read new PixelTransferParameter($0D19);
    public static property BLUE_SCALE:                        PixelTransferParameter read new PixelTransferParameter($0D1A);
    public static property BLUE_BIAS:                         PixelTransferParameter read new PixelTransferParameter($0D1B);
    public static property ALPHA_SCALE:                       PixelTransferParameter read new PixelTransferParameter($0D1C);
    public static property ALPHA_BIAS:                        PixelTransferParameter read new PixelTransferParameter($0D1D);
    public static property DEPTH_SCALE:                       PixelTransferParameter read new PixelTransferParameter($0D1E);
    public static property DEPTH_BIAS:                        PixelTransferParameter read new PixelTransferParameter($0D1F);
    public static property POST_CONVOLUTION_RED_SCALE:        PixelTransferParameter read new PixelTransferParameter($801C);
    public static property POST_CONVOLUTION_RED_SCALE_EXT:    PixelTransferParameter read new PixelTransferParameter($801C);
    public static property POST_CONVOLUTION_GREEN_SCALE:      PixelTransferParameter read new PixelTransferParameter($801D);
    public static property POST_CONVOLUTION_GREEN_SCALE_EXT:  PixelTransferParameter read new PixelTransferParameter($801D);
    public static property POST_CONVOLUTION_BLUE_SCALE:       PixelTransferParameter read new PixelTransferParameter($801E);
    public static property POST_CONVOLUTION_BLUE_SCALE_EXT:   PixelTransferParameter read new PixelTransferParameter($801E);
    public static property POST_CONVOLUTION_ALPHA_SCALE:      PixelTransferParameter read new PixelTransferParameter($801F);
    public static property POST_CONVOLUTION_ALPHA_SCALE_EXT:  PixelTransferParameter read new PixelTransferParameter($801F);
    public static property POST_CONVOLUTION_RED_BIAS:         PixelTransferParameter read new PixelTransferParameter($8020);
    public static property POST_CONVOLUTION_RED_BIAS_EXT:     PixelTransferParameter read new PixelTransferParameter($8020);
    public static property POST_CONVOLUTION_GREEN_BIAS:       PixelTransferParameter read new PixelTransferParameter($8021);
    public static property POST_CONVOLUTION_GREEN_BIAS_EXT:   PixelTransferParameter read new PixelTransferParameter($8021);
    public static property POST_CONVOLUTION_BLUE_BIAS:        PixelTransferParameter read new PixelTransferParameter($8022);
    public static property POST_CONVOLUTION_BLUE_BIAS_EXT:    PixelTransferParameter read new PixelTransferParameter($8022);
    public static property POST_CONVOLUTION_ALPHA_BIAS:       PixelTransferParameter read new PixelTransferParameter($8023);
    public static property POST_CONVOLUTION_ALPHA_BIAS_EXT:   PixelTransferParameter read new PixelTransferParameter($8023);
    public static property POST_COLOR_MATRIX_RED_SCALE:       PixelTransferParameter read new PixelTransferParameter($80B4);
    public static property POST_COLOR_MATRIX_RED_SCALE_SGI:   PixelTransferParameter read new PixelTransferParameter($80B4);
    public static property POST_COLOR_MATRIX_GREEN_SCALE:     PixelTransferParameter read new PixelTransferParameter($80B5);
    public static property POST_COLOR_MATRIX_GREEN_SCALE_SGI: PixelTransferParameter read new PixelTransferParameter($80B5);
    public static property POST_COLOR_MATRIX_BLUE_SCALE:      PixelTransferParameter read new PixelTransferParameter($80B6);
    public static property POST_COLOR_MATRIX_BLUE_SCALE_SGI:  PixelTransferParameter read new PixelTransferParameter($80B6);
    public static property POST_COLOR_MATRIX_ALPHA_SCALE:     PixelTransferParameter read new PixelTransferParameter($80B7);
    public static property POST_COLOR_MATRIX_ALPHA_SCALE_SGI: PixelTransferParameter read new PixelTransferParameter($80B7);
    public static property POST_COLOR_MATRIX_RED_BIAS:        PixelTransferParameter read new PixelTransferParameter($80B8);
    public static property POST_COLOR_MATRIX_RED_BIAS_SGI:    PixelTransferParameter read new PixelTransferParameter($80B8);
    public static property POST_COLOR_MATRIX_GREEN_BIAS:      PixelTransferParameter read new PixelTransferParameter($80B9);
    public static property POST_COLOR_MATRIX_GREEN_BIAS_SGI:  PixelTransferParameter read new PixelTransferParameter($80B9);
    public static property POST_COLOR_MATRIX_BLUE_BIAS:       PixelTransferParameter read new PixelTransferParameter($80BA);
    public static property POST_COLOR_MATRIX_BLUE_BIAS_SGI:   PixelTransferParameter read new PixelTransferParameter($80BA);
    public static property POST_COLOR_MATRIX_ALPHA_BIAS:      PixelTransferParameter read new PixelTransferParameter($80BB);
    public static property POST_COLOR_MATRIX_ALPHA_BIAS_SGI:  PixelTransferParameter read new PixelTransferParameter($80BB);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0D10) then Result := 'MAP_COLOR' else
      if self.val = UInt32($0D11) then Result := 'MAP_STENCIL' else
      if self.val = UInt32($0D12) then Result := 'INDEX_SHIFT' else
      if self.val = UInt32($0D13) then Result := 'INDEX_OFFSET' else
      if self.val = UInt32($0D14) then Result := 'RED_SCALE' else
      if self.val = UInt32($0D15) then Result := 'RED_BIAS' else
      if self.val = UInt32($0D18) then Result := 'GREEN_SCALE' else
      if self.val = UInt32($0D19) then Result := 'GREEN_BIAS' else
      if self.val = UInt32($0D1A) then Result := 'BLUE_SCALE' else
      if self.val = UInt32($0D1B) then Result := 'BLUE_BIAS' else
      if self.val = UInt32($0D1C) then Result := 'ALPHA_SCALE' else
      if self.val = UInt32($0D1D) then Result := 'ALPHA_BIAS' else
      if self.val = UInt32($0D1E) then Result := 'DEPTH_SCALE' else
      if self.val = UInt32($0D1F) then Result := 'DEPTH_BIAS' else
      if self.val = UInt32($801C) then Result := 'POST_CONVOLUTION_RED_SCALE' else
      if self.val = UInt32($801C) then Result := 'POST_CONVOLUTION_RED_SCALE_EXT' else
      if self.val = UInt32($801D) then Result := 'POST_CONVOLUTION_GREEN_SCALE' else
      if self.val = UInt32($801D) then Result := 'POST_CONVOLUTION_GREEN_SCALE_EXT' else
      if self.val = UInt32($801E) then Result := 'POST_CONVOLUTION_BLUE_SCALE' else
      if self.val = UInt32($801E) then Result := 'POST_CONVOLUTION_BLUE_SCALE_EXT' else
      if self.val = UInt32($801F) then Result := 'POST_CONVOLUTION_ALPHA_SCALE' else
      if self.val = UInt32($801F) then Result := 'POST_CONVOLUTION_ALPHA_SCALE_EXT' else
      if self.val = UInt32($8020) then Result := 'POST_CONVOLUTION_RED_BIAS' else
      if self.val = UInt32($8020) then Result := 'POST_CONVOLUTION_RED_BIAS_EXT' else
      if self.val = UInt32($8021) then Result := 'POST_CONVOLUTION_GREEN_BIAS' else
      if self.val = UInt32($8021) then Result := 'POST_CONVOLUTION_GREEN_BIAS_EXT' else
      if self.val = UInt32($8022) then Result := 'POST_CONVOLUTION_BLUE_BIAS' else
      if self.val = UInt32($8022) then Result := 'POST_CONVOLUTION_BLUE_BIAS_EXT' else
      if self.val = UInt32($8023) then Result := 'POST_CONVOLUTION_ALPHA_BIAS' else
      if self.val = UInt32($8023) then Result := 'POST_CONVOLUTION_ALPHA_BIAS_EXT' else
      if self.val = UInt32($80B4) then Result := 'POST_COLOR_MATRIX_RED_SCALE' else
      if self.val = UInt32($80B4) then Result := 'POST_COLOR_MATRIX_RED_SCALE_SGI' else
      if self.val = UInt32($80B5) then Result := 'POST_COLOR_MATRIX_GREEN_SCALE' else
      if self.val = UInt32($80B5) then Result := 'POST_COLOR_MATRIX_GREEN_SCALE_SGI' else
      if self.val = UInt32($80B6) then Result := 'POST_COLOR_MATRIX_BLUE_SCALE' else
      if self.val = UInt32($80B6) then Result := 'POST_COLOR_MATRIX_BLUE_SCALE_SGI' else
      if self.val = UInt32($80B7) then Result := 'POST_COLOR_MATRIX_ALPHA_SCALE' else
      if self.val = UInt32($80B7) then Result := 'POST_COLOR_MATRIX_ALPHA_SCALE_SGI' else
      if self.val = UInt32($80B8) then Result := 'POST_COLOR_MATRIX_RED_BIAS' else
      if self.val = UInt32($80B8) then Result := 'POST_COLOR_MATRIX_RED_BIAS_SGI' else
      if self.val = UInt32($80B9) then Result := 'POST_COLOR_MATRIX_GREEN_BIAS' else
      if self.val = UInt32($80B9) then Result := 'POST_COLOR_MATRIX_GREEN_BIAS_SGI' else
      if self.val = UInt32($80BA) then Result := 'POST_COLOR_MATRIX_BLUE_BIAS' else
      if self.val = UInt32($80BA) then Result := 'POST_COLOR_MATRIX_BLUE_BIAS_SGI' else
      if self.val = UInt32($80BB) then Result := 'POST_COLOR_MATRIX_ALPHA_BIAS' else
      if self.val = UInt32($80BB) then Result := 'POST_COLOR_MATRIX_ALPHA_BIAS_SGI' else
        Result := $'PixelTransferParameter[{self.val}]';
    end;
    
  end;
  
  PixelType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:                        PixelType read new PixelType($1400);
    public static property UNSIGNED_BYTE:               PixelType read new PixelType($1401);
    public static property SHORT:                       PixelType read new PixelType($1402);
    public static property UNSIGNED_SHORT:              PixelType read new PixelType($1403);
    public static property INT:                         PixelType read new PixelType($1404);
    public static property UNSIGNED_INT:                PixelType read new PixelType($1405);
    public static property FLOAT:                       PixelType read new PixelType($1406);
    public static property BITMAP:                      PixelType read new PixelType($1A00);
    public static property UNSIGNED_BYTE_3_3_2:         PixelType read new PixelType($8032);
    public static property UNSIGNED_BYTE_3_3_2_EXT:     PixelType read new PixelType($8032);
    public static property UNSIGNED_SHORT_4_4_4_4:      PixelType read new PixelType($8033);
    public static property UNSIGNED_SHORT_4_4_4_4_EXT:  PixelType read new PixelType($8033);
    public static property UNSIGNED_SHORT_5_5_5_1:      PixelType read new PixelType($8034);
    public static property UNSIGNED_SHORT_5_5_5_1_EXT:  PixelType read new PixelType($8034);
    public static property UNSIGNED_INT_8_8_8_8:        PixelType read new PixelType($8035);
    public static property UNSIGNED_INT_8_8_8_8_EXT:    PixelType read new PixelType($8035);
    public static property UNSIGNED_INT_10_10_10_2:     PixelType read new PixelType($8036);
    public static property UNSIGNED_INT_10_10_10_2_EXT: PixelType read new PixelType($8036);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($1A00) then Result := 'BITMAP' else
      if self.val = UInt32($8032) then Result := 'UNSIGNED_BYTE_3_3_2' else
      if self.val = UInt32($8032) then Result := 'UNSIGNED_BYTE_3_3_2_EXT' else
      if self.val = UInt32($8033) then Result := 'UNSIGNED_SHORT_4_4_4_4' else
      if self.val = UInt32($8033) then Result := 'UNSIGNED_SHORT_4_4_4_4_EXT' else
      if self.val = UInt32($8034) then Result := 'UNSIGNED_SHORT_5_5_5_1' else
      if self.val = UInt32($8034) then Result := 'UNSIGNED_SHORT_5_5_5_1_EXT' else
      if self.val = UInt32($8035) then Result := 'UNSIGNED_INT_8_8_8_8' else
      if self.val = UInt32($8035) then Result := 'UNSIGNED_INT_8_8_8_8_EXT' else
      if self.val = UInt32($8036) then Result := 'UNSIGNED_INT_10_10_10_2' else
      if self.val = UInt32($8036) then Result := 'UNSIGNED_INT_10_10_10_2_EXT' else
        Result := $'PixelType[{self.val}]';
    end;
    
  end;
  
  PolygonMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POINT: PolygonMode read new PolygonMode($1B00);
    public static property LINE:  PolygonMode read new PolygonMode($1B01);
    public static property FILL:  PolygonMode read new PolygonMode($1B02);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1B00) then Result := 'POINT' else
      if self.val = UInt32($1B01) then Result := 'LINE' else
      if self.val = UInt32($1B02) then Result := 'FILL' else
        Result := $'PolygonMode[{self.val}]';
    end;
    
  end;
  
  PrecisionType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LOW_FLOAT:    PrecisionType read new PrecisionType($8DF0);
    public static property MEDIUM_FLOAT: PrecisionType read new PrecisionType($8DF1);
    public static property HIGH_FLOAT:   PrecisionType read new PrecisionType($8DF2);
    public static property LOW_INT:      PrecisionType read new PrecisionType($8DF3);
    public static property MEDIUM_INT:   PrecisionType read new PrecisionType($8DF4);
    public static property HIGH_INT:     PrecisionType read new PrecisionType($8DF5);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8DF0) then Result := 'LOW_FLOAT' else
      if self.val = UInt32($8DF1) then Result := 'MEDIUM_FLOAT' else
      if self.val = UInt32($8DF2) then Result := 'HIGH_FLOAT' else
      if self.val = UInt32($8DF3) then Result := 'LOW_INT' else
      if self.val = UInt32($8DF4) then Result := 'MEDIUM_INT' else
      if self.val = UInt32($8DF5) then Result := 'HIGH_INT' else
        Result := $'PrecisionType[{self.val}]';
    end;
    
  end;
  
  PrimitiveType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POINTS:                       PrimitiveType read new PrimitiveType($0000);
    public static property LINES:                        PrimitiveType read new PrimitiveType($0001);
    public static property LINE_LOOP:                    PrimitiveType read new PrimitiveType($0002);
    public static property LINE_STRIP:                   PrimitiveType read new PrimitiveType($0003);
    public static property TRIANGLES:                    PrimitiveType read new PrimitiveType($0004);
    public static property TRIANGLE_STRIP:               PrimitiveType read new PrimitiveType($0005);
    public static property TRIANGLE_FAN:                 PrimitiveType read new PrimitiveType($0006);
    public static property QUADS:                        PrimitiveType read new PrimitiveType($0007);
    public static property QUADS_EXT:                    PrimitiveType read new PrimitiveType($0007);
    public static property QUAD_STRIP:                   PrimitiveType read new PrimitiveType($0008);
    public static property POLYGON:                      PrimitiveType read new PrimitiveType($0009);
    public static property LINES_ADJACENCY:              PrimitiveType read new PrimitiveType($000A);
    public static property LINES_ADJACENCY_ARB:          PrimitiveType read new PrimitiveType($000A);
    public static property LINES_ADJACENCY_EXT:          PrimitiveType read new PrimitiveType($000A);
    public static property LINE_STRIP_ADJACENCY:         PrimitiveType read new PrimitiveType($000B);
    public static property LINE_STRIP_ADJACENCY_ARB:     PrimitiveType read new PrimitiveType($000B);
    public static property LINE_STRIP_ADJACENCY_EXT:     PrimitiveType read new PrimitiveType($000B);
    public static property TRIANGLES_ADJACENCY:          PrimitiveType read new PrimitiveType($000C);
    public static property TRIANGLES_ADJACENCY_ARB:      PrimitiveType read new PrimitiveType($000C);
    public static property TRIANGLES_ADJACENCY_EXT:      PrimitiveType read new PrimitiveType($000C);
    public static property TRIANGLE_STRIP_ADJACENCY:     PrimitiveType read new PrimitiveType($000D);
    public static property TRIANGLE_STRIP_ADJACENCY_ARB: PrimitiveType read new PrimitiveType($000D);
    public static property TRIANGLE_STRIP_ADJACENCY_EXT: PrimitiveType read new PrimitiveType($000D);
    public static property PATCHES:                      PrimitiveType read new PrimitiveType($000E);
    public static property PATCHES_EXT:                  PrimitiveType read new PrimitiveType($000E);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'POINTS' else
      if self.val = UInt32($0001) then Result := 'LINES' else
      if self.val = UInt32($0002) then Result := 'LINE_LOOP' else
      if self.val = UInt32($0003) then Result := 'LINE_STRIP' else
      if self.val = UInt32($0004) then Result := 'TRIANGLES' else
      if self.val = UInt32($0005) then Result := 'TRIANGLE_STRIP' else
      if self.val = UInt32($0006) then Result := 'TRIANGLE_FAN' else
      if self.val = UInt32($0007) then Result := 'QUADS' else
      if self.val = UInt32($0007) then Result := 'QUADS_EXT' else
      if self.val = UInt32($0008) then Result := 'QUAD_STRIP' else
      if self.val = UInt32($0009) then Result := 'POLYGON' else
      if self.val = UInt32($000A) then Result := 'LINES_ADJACENCY' else
      if self.val = UInt32($000A) then Result := 'LINES_ADJACENCY_ARB' else
      if self.val = UInt32($000A) then Result := 'LINES_ADJACENCY_EXT' else
      if self.val = UInt32($000B) then Result := 'LINE_STRIP_ADJACENCY' else
      if self.val = UInt32($000B) then Result := 'LINE_STRIP_ADJACENCY_ARB' else
      if self.val = UInt32($000B) then Result := 'LINE_STRIP_ADJACENCY_EXT' else
      if self.val = UInt32($000C) then Result := 'TRIANGLES_ADJACENCY' else
      if self.val = UInt32($000C) then Result := 'TRIANGLES_ADJACENCY_ARB' else
      if self.val = UInt32($000C) then Result := 'TRIANGLES_ADJACENCY_EXT' else
      if self.val = UInt32($000D) then Result := 'TRIANGLE_STRIP_ADJACENCY' else
      if self.val = UInt32($000D) then Result := 'TRIANGLE_STRIP_ADJACENCY_ARB' else
      if self.val = UInt32($000D) then Result := 'TRIANGLE_STRIP_ADJACENCY_EXT' else
      if self.val = UInt32($000E) then Result := 'PATCHES' else
      if self.val = UInt32($000E) then Result := 'PATCHES_EXT' else
        Result := $'PrimitiveType[{self.val}]';
    end;
    
  end;
  
  ProgramFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PROGRAM_FORMAT_ASCII_ARB: ProgramFormat read new ProgramFormat($8875);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8875) then Result := 'PROGRAM_FORMAT_ASCII_ARB' else
        Result := $'ProgramFormat[{self.val}]';
    end;
    
  end;
  
  ProgramInterface = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TRANSFORM_FEEDBACK_BUFFER:          ProgramInterface read new ProgramInterface($8C8E);
    public static property UNIFORM:                            ProgramInterface read new ProgramInterface($92E1);
    public static property UNIFORM_BLOCK:                      ProgramInterface read new ProgramInterface($92E2);
    public static property PROGRAM_INPUT:                      ProgramInterface read new ProgramInterface($92E3);
    public static property PROGRAM_OUTPUT:                     ProgramInterface read new ProgramInterface($92E4);
    public static property BUFFER_VARIABLE:                    ProgramInterface read new ProgramInterface($92E5);
    public static property SHADER_STORAGE_BLOCK:               ProgramInterface read new ProgramInterface($92E6);
    public static property VERTEX_SUBROUTINE:                  ProgramInterface read new ProgramInterface($92E8);
    public static property TESS_CONTROL_SUBROUTINE:            ProgramInterface read new ProgramInterface($92E9);
    public static property TESS_EVALUATION_SUBROUTINE:         ProgramInterface read new ProgramInterface($92EA);
    public static property GEOMETRY_SUBROUTINE:                ProgramInterface read new ProgramInterface($92EB);
    public static property FRAGMENT_SUBROUTINE:                ProgramInterface read new ProgramInterface($92EC);
    public static property COMPUTE_SUBROUTINE:                 ProgramInterface read new ProgramInterface($92ED);
    public static property VERTEX_SUBROUTINE_UNIFORM:          ProgramInterface read new ProgramInterface($92EE);
    public static property TESS_CONTROL_SUBROUTINE_UNIFORM:    ProgramInterface read new ProgramInterface($92EF);
    public static property TESS_EVALUATION_SUBROUTINE_UNIFORM: ProgramInterface read new ProgramInterface($92F0);
    public static property GEOMETRY_SUBROUTINE_UNIFORM:        ProgramInterface read new ProgramInterface($92F1);
    public static property FRAGMENT_SUBROUTINE_UNIFORM:        ProgramInterface read new ProgramInterface($92F2);
    public static property COMPUTE_SUBROUTINE_UNIFORM:         ProgramInterface read new ProgramInterface($92F3);
    public static property TRANSFORM_FEEDBACK_VARYING:         ProgramInterface read new ProgramInterface($92F4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8C8E) then Result := 'TRANSFORM_FEEDBACK_BUFFER' else
      if self.val = UInt32($92E1) then Result := 'UNIFORM' else
      if self.val = UInt32($92E2) then Result := 'UNIFORM_BLOCK' else
      if self.val = UInt32($92E3) then Result := 'PROGRAM_INPUT' else
      if self.val = UInt32($92E4) then Result := 'PROGRAM_OUTPUT' else
      if self.val = UInt32($92E5) then Result := 'BUFFER_VARIABLE' else
      if self.val = UInt32($92E6) then Result := 'SHADER_STORAGE_BLOCK' else
      if self.val = UInt32($92E8) then Result := 'VERTEX_SUBROUTINE' else
      if self.val = UInt32($92E9) then Result := 'TESS_CONTROL_SUBROUTINE' else
      if self.val = UInt32($92EA) then Result := 'TESS_EVALUATION_SUBROUTINE' else
      if self.val = UInt32($92EB) then Result := 'GEOMETRY_SUBROUTINE' else
      if self.val = UInt32($92EC) then Result := 'FRAGMENT_SUBROUTINE' else
      if self.val = UInt32($92ED) then Result := 'COMPUTE_SUBROUTINE' else
      if self.val = UInt32($92EE) then Result := 'VERTEX_SUBROUTINE_UNIFORM' else
      if self.val = UInt32($92EF) then Result := 'TESS_CONTROL_SUBROUTINE_UNIFORM' else
      if self.val = UInt32($92F0) then Result := 'TESS_EVALUATION_SUBROUTINE_UNIFORM' else
      if self.val = UInt32($92F1) then Result := 'GEOMETRY_SUBROUTINE_UNIFORM' else
      if self.val = UInt32($92F2) then Result := 'FRAGMENT_SUBROUTINE_UNIFORM' else
      if self.val = UInt32($92F3) then Result := 'COMPUTE_SUBROUTINE_UNIFORM' else
      if self.val = UInt32($92F4) then Result := 'TRANSFORM_FEEDBACK_VARYING' else
        Result := $'ProgramInterface[{self.val}]';
    end;
    
  end;
  
  ProgramInterfacePName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ACTIVE_RESOURCES:               ProgramInterfacePName read new ProgramInterfacePName($92F5);
    public static property MAX_NAME_LENGTH:                ProgramInterfacePName read new ProgramInterfacePName($92F6);
    public static property MAX_NUM_ACTIVE_VARIABLES:       ProgramInterfacePName read new ProgramInterfacePName($92F7);
    public static property MAX_NUM_COMPATIBLE_SUBROUTINES: ProgramInterfacePName read new ProgramInterfacePName($92F8);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($92F5) then Result := 'ACTIVE_RESOURCES' else
      if self.val = UInt32($92F6) then Result := 'MAX_NAME_LENGTH' else
      if self.val = UInt32($92F7) then Result := 'MAX_NUM_ACTIVE_VARIABLES' else
      if self.val = UInt32($92F8) then Result := 'MAX_NUM_COMPATIBLE_SUBROUTINES' else
        Result := $'ProgramInterfacePName[{self.val}]';
    end;
    
  end;
  
  ProgramParameterPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PROGRAM_BINARY_RETRIEVABLE_HINT: ProgramParameterPName read new ProgramParameterPName($8257);
    public static property PROGRAM_SEPARABLE:               ProgramParameterPName read new ProgramParameterPName($8258);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8257) then Result := 'PROGRAM_BINARY_RETRIEVABLE_HINT' else
      if self.val = UInt32($8258) then Result := 'PROGRAM_SEPARABLE' else
        Result := $'ProgramParameterPName[{self.val}]';
    end;
    
  end;
  
  ProgramResourceProperty = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NUM_COMPATIBLE_SUBROUTINES:           ProgramResourceProperty read new ProgramResourceProperty($8E4A);
    public static property COMPATIBLE_SUBROUTINES:               ProgramResourceProperty read new ProgramResourceProperty($8E4B);
    public static property UNIFORM:                              ProgramResourceProperty read new ProgramResourceProperty($92E1);
    public static property IS_PER_PATCH:                         ProgramResourceProperty read new ProgramResourceProperty($92E7);
    public static property NAME_LENGTH:                          ProgramResourceProperty read new ProgramResourceProperty($92F9);
    public static property &TYPE:                                ProgramResourceProperty read new ProgramResourceProperty($92FA);
    public static property ARRAY_SIZE:                           ProgramResourceProperty read new ProgramResourceProperty($92FB);
    public static property OFFSET:                               ProgramResourceProperty read new ProgramResourceProperty($92FC);
    public static property BLOCK_INDEX:                          ProgramResourceProperty read new ProgramResourceProperty($92FD);
    public static property ARRAY_STRIDE:                         ProgramResourceProperty read new ProgramResourceProperty($92FE);
    public static property MATRIX_STRIDE:                        ProgramResourceProperty read new ProgramResourceProperty($92FF);
    public static property IS_ROW_MAJOR:                         ProgramResourceProperty read new ProgramResourceProperty($9300);
    public static property ATOMIC_COUNTER_BUFFER_INDEX:          ProgramResourceProperty read new ProgramResourceProperty($9301);
    public static property BUFFER_BINDING:                       ProgramResourceProperty read new ProgramResourceProperty($9302);
    public static property BUFFER_DATA_SIZE:                     ProgramResourceProperty read new ProgramResourceProperty($9303);
    public static property NUM_ACTIVE_VARIABLES:                 ProgramResourceProperty read new ProgramResourceProperty($9304);
    public static property ACTIVE_VARIABLES:                     ProgramResourceProperty read new ProgramResourceProperty($9305);
    public static property REFERENCED_BY_VERTEX_SHADER:          ProgramResourceProperty read new ProgramResourceProperty($9306);
    public static property REFERENCED_BY_TESS_CONTROL_SHADER:    ProgramResourceProperty read new ProgramResourceProperty($9307);
    public static property REFERENCED_BY_TESS_EVALUATION_SHADER: ProgramResourceProperty read new ProgramResourceProperty($9308);
    public static property REFERENCED_BY_GEOMETRY_SHADER:        ProgramResourceProperty read new ProgramResourceProperty($9309);
    public static property REFERENCED_BY_FRAGMENT_SHADER:        ProgramResourceProperty read new ProgramResourceProperty($930A);
    public static property REFERENCED_BY_COMPUTE_SHADER:         ProgramResourceProperty read new ProgramResourceProperty($930B);
    public static property TOP_LEVEL_ARRAY_SIZE:                 ProgramResourceProperty read new ProgramResourceProperty($930C);
    public static property TOP_LEVEL_ARRAY_STRIDE:               ProgramResourceProperty read new ProgramResourceProperty($930D);
    public static property LOCATION:                             ProgramResourceProperty read new ProgramResourceProperty($930E);
    public static property LOCATION_INDEX:                       ProgramResourceProperty read new ProgramResourceProperty($930F);
    public static property LOCATION_COMPONENT:                   ProgramResourceProperty read new ProgramResourceProperty($934A);
    public static property TRANSFORM_FEEDBACK_BUFFER_INDEX:      ProgramResourceProperty read new ProgramResourceProperty($934B);
    public static property TRANSFORM_FEEDBACK_BUFFER_STRIDE:     ProgramResourceProperty read new ProgramResourceProperty($934C);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E4A) then Result := 'NUM_COMPATIBLE_SUBROUTINES' else
      if self.val = UInt32($8E4B) then Result := 'COMPATIBLE_SUBROUTINES' else
      if self.val = UInt32($92E1) then Result := 'UNIFORM' else
      if self.val = UInt32($92E7) then Result := 'IS_PER_PATCH' else
      if self.val = UInt32($92F9) then Result := 'NAME_LENGTH' else
      if self.val = UInt32($92FA) then Result := 'TYPE' else
      if self.val = UInt32($92FB) then Result := 'ARRAY_SIZE' else
      if self.val = UInt32($92FC) then Result := 'OFFSET' else
      if self.val = UInt32($92FD) then Result := 'BLOCK_INDEX' else
      if self.val = UInt32($92FE) then Result := 'ARRAY_STRIDE' else
      if self.val = UInt32($92FF) then Result := 'MATRIX_STRIDE' else
      if self.val = UInt32($9300) then Result := 'IS_ROW_MAJOR' else
      if self.val = UInt32($9301) then Result := 'ATOMIC_COUNTER_BUFFER_INDEX' else
      if self.val = UInt32($9302) then Result := 'BUFFER_BINDING' else
      if self.val = UInt32($9303) then Result := 'BUFFER_DATA_SIZE' else
      if self.val = UInt32($9304) then Result := 'NUM_ACTIVE_VARIABLES' else
      if self.val = UInt32($9305) then Result := 'ACTIVE_VARIABLES' else
      if self.val = UInt32($9306) then Result := 'REFERENCED_BY_VERTEX_SHADER' else
      if self.val = UInt32($9307) then Result := 'REFERENCED_BY_TESS_CONTROL_SHADER' else
      if self.val = UInt32($9308) then Result := 'REFERENCED_BY_TESS_EVALUATION_SHADER' else
      if self.val = UInt32($9309) then Result := 'REFERENCED_BY_GEOMETRY_SHADER' else
      if self.val = UInt32($930A) then Result := 'REFERENCED_BY_FRAGMENT_SHADER' else
      if self.val = UInt32($930B) then Result := 'REFERENCED_BY_COMPUTE_SHADER' else
      if self.val = UInt32($930C) then Result := 'TOP_LEVEL_ARRAY_SIZE' else
      if self.val = UInt32($930D) then Result := 'TOP_LEVEL_ARRAY_STRIDE' else
      if self.val = UInt32($930E) then Result := 'LOCATION' else
      if self.val = UInt32($930F) then Result := 'LOCATION_INDEX' else
      if self.val = UInt32($934A) then Result := 'LOCATION_COMPONENT' else
      if self.val = UInt32($934B) then Result := 'TRANSFORM_FEEDBACK_BUFFER_INDEX' else
      if self.val = UInt32($934C) then Result := 'TRANSFORM_FEEDBACK_BUFFER_STRIDE' else
        Result := $'ProgramResourceProperty[{self.val}]';
    end;
    
  end;
  
  ProgramStagePName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ACTIVE_SUBROUTINES:                   ProgramStagePName read new ProgramStagePName($8DE5);
    public static property ACTIVE_SUBROUTINE_UNIFORMS:           ProgramStagePName read new ProgramStagePName($8DE6);
    public static property ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS:  ProgramStagePName read new ProgramStagePName($8E47);
    public static property ACTIVE_SUBROUTINE_MAX_LENGTH:         ProgramStagePName read new ProgramStagePName($8E48);
    public static property ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH: ProgramStagePName read new ProgramStagePName($8E49);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8DE5) then Result := 'ACTIVE_SUBROUTINES' else
      if self.val = UInt32($8DE6) then Result := 'ACTIVE_SUBROUTINE_UNIFORMS' else
      if self.val = UInt32($8E47) then Result := 'ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS' else
      if self.val = UInt32($8E48) then Result := 'ACTIVE_SUBROUTINE_MAX_LENGTH' else
      if self.val = UInt32($8E49) then Result := 'ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH' else
        Result := $'ProgramStagePName[{self.val}]';
    end;
    
  end;
  
  ProgramStringProperty = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PROGRAM_STRING_ARB: ProgramStringProperty read new ProgramStringProperty($8628);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8628) then Result := 'PROGRAM_STRING_ARB' else
        Result := $'ProgramStringProperty[{self.val}]';
    end;
    
  end;
  
  ProgramTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXT_FRAGMENT_SHADER_ATI:   ProgramTarget read new ProgramTarget($8200);
    public static property VERTEX_PROGRAM_ARB:         ProgramTarget read new ProgramTarget($8620);
    public static property FRAGMENT_PROGRAM_ARB:       ProgramTarget read new ProgramTarget($8804);
    public static property TESS_CONTROL_PROGRAM_NV:    ProgramTarget read new ProgramTarget($891E);
    public static property TESS_EVALUATION_PROGRAM_NV: ProgramTarget read new ProgramTarget($891F);
    public static property GEOMETRY_PROGRAM_NV:        ProgramTarget read new ProgramTarget($8C26);
    public static property COMPUTE_PROGRAM_NV:         ProgramTarget read new ProgramTarget($90FB);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8200) then Result := 'TEXT_FRAGMENT_SHADER_ATI' else
      if self.val = UInt32($8620) then Result := 'VERTEX_PROGRAM_ARB' else
      if self.val = UInt32($8804) then Result := 'FRAGMENT_PROGRAM_ARB' else
      if self.val = UInt32($891E) then Result := 'TESS_CONTROL_PROGRAM_NV' else
      if self.val = UInt32($891F) then Result := 'TESS_EVALUATION_PROGRAM_NV' else
      if self.val = UInt32($8C26) then Result := 'GEOMETRY_PROGRAM_NV' else
      if self.val = UInt32($90FB) then Result := 'COMPUTE_PROGRAM_NV' else
        Result := $'ProgramTarget[{self.val}]';
    end;
    
  end;
  
  QueryCounterTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TIMESTAMP: QueryCounterTarget read new QueryCounterTarget($8E28);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E28) then Result := 'TIMESTAMP' else
        Result := $'QueryCounterTarget[{self.val}]';
    end;
    
  end;
  
  QueryObjectParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property QUERY_TARGET:           QueryObjectParameterName read new QueryObjectParameterName($82EA);
    public static property QUERY_RESULT:           QueryObjectParameterName read new QueryObjectParameterName($8866);
    public static property QUERY_RESULT_AVAILABLE: QueryObjectParameterName read new QueryObjectParameterName($8867);
    public static property QUERY_RESULT_NO_WAIT:   QueryObjectParameterName read new QueryObjectParameterName($9194);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($82EA) then Result := 'QUERY_TARGET' else
      if self.val = UInt32($8866) then Result := 'QUERY_RESULT' else
      if self.val = UInt32($8867) then Result := 'QUERY_RESULT_AVAILABLE' else
      if self.val = UInt32($9194) then Result := 'QUERY_RESULT_NO_WAIT' else
        Result := $'QueryObjectParameterName[{self.val}]';
    end;
    
  end;
  
  QueryParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property QUERY_COUNTER_BITS: QueryParameterName read new QueryParameterName($8864);
    public static property CURRENT_QUERY:      QueryParameterName read new QueryParameterName($8865);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8864) then Result := 'QUERY_COUNTER_BITS' else
      if self.val = UInt32($8865) then Result := 'CURRENT_QUERY' else
        Result := $'QueryParameterName[{self.val}]';
    end;
    
  end;
  
  QueryTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TRANSFORM_FEEDBACK_OVERFLOW:           QueryTarget read new QueryTarget($82EC);
    public static property VERTICES_SUBMITTED:                    QueryTarget read new QueryTarget($82EE);
    public static property PRIMITIVES_SUBMITTED:                  QueryTarget read new QueryTarget($82EF);
    public static property VERTEX_SHADER_INVOCATIONS:             QueryTarget read new QueryTarget($82F0);
    public static property TIME_ELAPSED:                          QueryTarget read new QueryTarget($88BF);
    public static property SAMPLES_PASSED:                        QueryTarget read new QueryTarget($8914);
    public static property ANY_SAMPLES_PASSED:                    QueryTarget read new QueryTarget($8C2F);
    public static property PRIMITIVES_GENERATED:                  QueryTarget read new QueryTarget($8C87);
    public static property TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN: QueryTarget read new QueryTarget($8C88);
    public static property ANY_SAMPLES_PASSED_CONSERVATIVE:       QueryTarget read new QueryTarget($8D6A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($82EC) then Result := 'TRANSFORM_FEEDBACK_OVERFLOW' else
      if self.val = UInt32($82EE) then Result := 'VERTICES_SUBMITTED' else
      if self.val = UInt32($82EF) then Result := 'PRIMITIVES_SUBMITTED' else
      if self.val = UInt32($82F0) then Result := 'VERTEX_SHADER_INVOCATIONS' else
      if self.val = UInt32($88BF) then Result := 'TIME_ELAPSED' else
      if self.val = UInt32($8914) then Result := 'SAMPLES_PASSED' else
      if self.val = UInt32($8C2F) then Result := 'ANY_SAMPLES_PASSED' else
      if self.val = UInt32($8C87) then Result := 'PRIMITIVES_GENERATED' else
      if self.val = UInt32($8C88) then Result := 'TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN' else
      if self.val = UInt32($8D6A) then Result := 'ANY_SAMPLES_PASSED_CONSERVATIVE' else
        Result := $'QueryTarget[{self.val}]';
    end;
    
  end;
  
  ReadBufferMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:               ReadBufferMode read new ReadBufferMode($0000);
    public static property NONE_OES:           ReadBufferMode read new ReadBufferMode($0000);
    public static property FRONT_LEFT:         ReadBufferMode read new ReadBufferMode($0400);
    public static property FRONT_RIGHT:        ReadBufferMode read new ReadBufferMode($0401);
    public static property BACK_LEFT:          ReadBufferMode read new ReadBufferMode($0402);
    public static property BACK_RIGHT:         ReadBufferMode read new ReadBufferMode($0403);
    public static property FRONT:              ReadBufferMode read new ReadBufferMode($0404);
    public static property BACK:               ReadBufferMode read new ReadBufferMode($0405);
    public static property LEFT:               ReadBufferMode read new ReadBufferMode($0406);
    public static property RIGHT:              ReadBufferMode read new ReadBufferMode($0407);
    public static property AUX0:               ReadBufferMode read new ReadBufferMode($0409);
    public static property AUX1:               ReadBufferMode read new ReadBufferMode($040A);
    public static property AUX2:               ReadBufferMode read new ReadBufferMode($040B);
    public static property AUX3:               ReadBufferMode read new ReadBufferMode($040C);
    public static property COLOR_ATTACHMENT0:  ReadBufferMode read new ReadBufferMode($8CE0);
    public static property COLOR_ATTACHMENT1:  ReadBufferMode read new ReadBufferMode($8CE1);
    public static property COLOR_ATTACHMENT2:  ReadBufferMode read new ReadBufferMode($8CE2);
    public static property COLOR_ATTACHMENT3:  ReadBufferMode read new ReadBufferMode($8CE3);
    public static property COLOR_ATTACHMENT4:  ReadBufferMode read new ReadBufferMode($8CE4);
    public static property COLOR_ATTACHMENT5:  ReadBufferMode read new ReadBufferMode($8CE5);
    public static property COLOR_ATTACHMENT6:  ReadBufferMode read new ReadBufferMode($8CE6);
    public static property COLOR_ATTACHMENT7:  ReadBufferMode read new ReadBufferMode($8CE7);
    public static property COLOR_ATTACHMENT8:  ReadBufferMode read new ReadBufferMode($8CE8);
    public static property COLOR_ATTACHMENT9:  ReadBufferMode read new ReadBufferMode($8CE9);
    public static property COLOR_ATTACHMENT10: ReadBufferMode read new ReadBufferMode($8CEA);
    public static property COLOR_ATTACHMENT11: ReadBufferMode read new ReadBufferMode($8CEB);
    public static property COLOR_ATTACHMENT12: ReadBufferMode read new ReadBufferMode($8CEC);
    public static property COLOR_ATTACHMENT13: ReadBufferMode read new ReadBufferMode($8CED);
    public static property COLOR_ATTACHMENT14: ReadBufferMode read new ReadBufferMode($8CEE);
    public static property COLOR_ATTACHMENT15: ReadBufferMode read new ReadBufferMode($8CEF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($0000) then Result := 'NONE_OES' else
      if self.val = UInt32($0400) then Result := 'FRONT_LEFT' else
      if self.val = UInt32($0401) then Result := 'FRONT_RIGHT' else
      if self.val = UInt32($0402) then Result := 'BACK_LEFT' else
      if self.val = UInt32($0403) then Result := 'BACK_RIGHT' else
      if self.val = UInt32($0404) then Result := 'FRONT' else
      if self.val = UInt32($0405) then Result := 'BACK' else
      if self.val = UInt32($0406) then Result := 'LEFT' else
      if self.val = UInt32($0407) then Result := 'RIGHT' else
      if self.val = UInt32($0409) then Result := 'AUX0' else
      if self.val = UInt32($040A) then Result := 'AUX1' else
      if self.val = UInt32($040B) then Result := 'AUX2' else
      if self.val = UInt32($040C) then Result := 'AUX3' else
      if self.val = UInt32($8CE0) then Result := 'COLOR_ATTACHMENT0' else
      if self.val = UInt32($8CE1) then Result := 'COLOR_ATTACHMENT1' else
      if self.val = UInt32($8CE2) then Result := 'COLOR_ATTACHMENT2' else
      if self.val = UInt32($8CE3) then Result := 'COLOR_ATTACHMENT3' else
      if self.val = UInt32($8CE4) then Result := 'COLOR_ATTACHMENT4' else
      if self.val = UInt32($8CE5) then Result := 'COLOR_ATTACHMENT5' else
      if self.val = UInt32($8CE6) then Result := 'COLOR_ATTACHMENT6' else
      if self.val = UInt32($8CE7) then Result := 'COLOR_ATTACHMENT7' else
      if self.val = UInt32($8CE8) then Result := 'COLOR_ATTACHMENT8' else
      if self.val = UInt32($8CE9) then Result := 'COLOR_ATTACHMENT9' else
      if self.val = UInt32($8CEA) then Result := 'COLOR_ATTACHMENT10' else
      if self.val = UInt32($8CEB) then Result := 'COLOR_ATTACHMENT11' else
      if self.val = UInt32($8CEC) then Result := 'COLOR_ATTACHMENT12' else
      if self.val = UInt32($8CED) then Result := 'COLOR_ATTACHMENT13' else
      if self.val = UInt32($8CEE) then Result := 'COLOR_ATTACHMENT14' else
      if self.val = UInt32($8CEF) then Result := 'COLOR_ATTACHMENT15' else
        Result := $'ReadBufferMode[{self.val}]';
    end;
    
  end;
  
  RenderbufferParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property RENDERBUFFER_COVERAGE_SAMPLES_NV: RenderbufferParameterName read new RenderbufferParameterName($8CAB);
    public static property RENDERBUFFER_SAMPLES:             RenderbufferParameterName read new RenderbufferParameterName($8CAB);
    public static property RENDERBUFFER_SAMPLES_ANGLE:       RenderbufferParameterName read new RenderbufferParameterName($8CAB);
    public static property RENDERBUFFER_SAMPLES_APPLE:       RenderbufferParameterName read new RenderbufferParameterName($8CAB);
    public static property RENDERBUFFER_SAMPLES_EXT:         RenderbufferParameterName read new RenderbufferParameterName($8CAB);
    public static property RENDERBUFFER_SAMPLES_NV:          RenderbufferParameterName read new RenderbufferParameterName($8CAB);
    public static property RENDERBUFFER_WIDTH:               RenderbufferParameterName read new RenderbufferParameterName($8D42);
    public static property RENDERBUFFER_WIDTH_EXT:           RenderbufferParameterName read new RenderbufferParameterName($8D42);
    public static property RENDERBUFFER_WIDTH_OES:           RenderbufferParameterName read new RenderbufferParameterName($8D42);
    public static property RENDERBUFFER_HEIGHT:              RenderbufferParameterName read new RenderbufferParameterName($8D43);
    public static property RENDERBUFFER_HEIGHT_EXT:          RenderbufferParameterName read new RenderbufferParameterName($8D43);
    public static property RENDERBUFFER_HEIGHT_OES:          RenderbufferParameterName read new RenderbufferParameterName($8D43);
    public static property RENDERBUFFER_INTERNAL_FORMAT:     RenderbufferParameterName read new RenderbufferParameterName($8D44);
    public static property RENDERBUFFER_INTERNAL_FORMAT_EXT: RenderbufferParameterName read new RenderbufferParameterName($8D44);
    public static property RENDERBUFFER_INTERNAL_FORMAT_OES: RenderbufferParameterName read new RenderbufferParameterName($8D44);
    public static property RENDERBUFFER_RED_SIZE:            RenderbufferParameterName read new RenderbufferParameterName($8D50);
    public static property RENDERBUFFER_RED_SIZE_EXT:        RenderbufferParameterName read new RenderbufferParameterName($8D50);
    public static property RENDERBUFFER_RED_SIZE_OES:        RenderbufferParameterName read new RenderbufferParameterName($8D50);
    public static property RENDERBUFFER_GREEN_SIZE:          RenderbufferParameterName read new RenderbufferParameterName($8D51);
    public static property RENDERBUFFER_GREEN_SIZE_EXT:      RenderbufferParameterName read new RenderbufferParameterName($8D51);
    public static property RENDERBUFFER_GREEN_SIZE_OES:      RenderbufferParameterName read new RenderbufferParameterName($8D51);
    public static property RENDERBUFFER_BLUE_SIZE:           RenderbufferParameterName read new RenderbufferParameterName($8D52);
    public static property RENDERBUFFER_BLUE_SIZE_EXT:       RenderbufferParameterName read new RenderbufferParameterName($8D52);
    public static property RENDERBUFFER_BLUE_SIZE_OES:       RenderbufferParameterName read new RenderbufferParameterName($8D52);
    public static property RENDERBUFFER_ALPHA_SIZE:          RenderbufferParameterName read new RenderbufferParameterName($8D53);
    public static property RENDERBUFFER_ALPHA_SIZE_EXT:      RenderbufferParameterName read new RenderbufferParameterName($8D53);
    public static property RENDERBUFFER_ALPHA_SIZE_OES:      RenderbufferParameterName read new RenderbufferParameterName($8D53);
    public static property RENDERBUFFER_DEPTH_SIZE:          RenderbufferParameterName read new RenderbufferParameterName($8D54);
    public static property RENDERBUFFER_DEPTH_SIZE_EXT:      RenderbufferParameterName read new RenderbufferParameterName($8D54);
    public static property RENDERBUFFER_DEPTH_SIZE_OES:      RenderbufferParameterName read new RenderbufferParameterName($8D54);
    public static property RENDERBUFFER_STENCIL_SIZE:        RenderbufferParameterName read new RenderbufferParameterName($8D55);
    public static property RENDERBUFFER_STENCIL_SIZE_EXT:    RenderbufferParameterName read new RenderbufferParameterName($8D55);
    public static property RENDERBUFFER_STENCIL_SIZE_OES:    RenderbufferParameterName read new RenderbufferParameterName($8D55);
    public static property RENDERBUFFER_COLOR_SAMPLES_NV:    RenderbufferParameterName read new RenderbufferParameterName($8E10);
    public static property RENDERBUFFER_SAMPLES_IMG:         RenderbufferParameterName read new RenderbufferParameterName($9133);
    public static property RENDERBUFFER_STORAGE_SAMPLES_AMD: RenderbufferParameterName read new RenderbufferParameterName($91B2);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8CAB) then Result := 'RENDERBUFFER_COVERAGE_SAMPLES_NV' else
      if self.val = UInt32($8CAB) then Result := 'RENDERBUFFER_SAMPLES' else
      if self.val = UInt32($8CAB) then Result := 'RENDERBUFFER_SAMPLES_ANGLE' else
      if self.val = UInt32($8CAB) then Result := 'RENDERBUFFER_SAMPLES_APPLE' else
      if self.val = UInt32($8CAB) then Result := 'RENDERBUFFER_SAMPLES_EXT' else
      if self.val = UInt32($8CAB) then Result := 'RENDERBUFFER_SAMPLES_NV' else
      if self.val = UInt32($8D42) then Result := 'RENDERBUFFER_WIDTH' else
      if self.val = UInt32($8D42) then Result := 'RENDERBUFFER_WIDTH_EXT' else
      if self.val = UInt32($8D42) then Result := 'RENDERBUFFER_WIDTH_OES' else
      if self.val = UInt32($8D43) then Result := 'RENDERBUFFER_HEIGHT' else
      if self.val = UInt32($8D43) then Result := 'RENDERBUFFER_HEIGHT_EXT' else
      if self.val = UInt32($8D43) then Result := 'RENDERBUFFER_HEIGHT_OES' else
      if self.val = UInt32($8D44) then Result := 'RENDERBUFFER_INTERNAL_FORMAT' else
      if self.val = UInt32($8D44) then Result := 'RENDERBUFFER_INTERNAL_FORMAT_EXT' else
      if self.val = UInt32($8D44) then Result := 'RENDERBUFFER_INTERNAL_FORMAT_OES' else
      if self.val = UInt32($8D50) then Result := 'RENDERBUFFER_RED_SIZE' else
      if self.val = UInt32($8D50) then Result := 'RENDERBUFFER_RED_SIZE_EXT' else
      if self.val = UInt32($8D50) then Result := 'RENDERBUFFER_RED_SIZE_OES' else
      if self.val = UInt32($8D51) then Result := 'RENDERBUFFER_GREEN_SIZE' else
      if self.val = UInt32($8D51) then Result := 'RENDERBUFFER_GREEN_SIZE_EXT' else
      if self.val = UInt32($8D51) then Result := 'RENDERBUFFER_GREEN_SIZE_OES' else
      if self.val = UInt32($8D52) then Result := 'RENDERBUFFER_BLUE_SIZE' else
      if self.val = UInt32($8D52) then Result := 'RENDERBUFFER_BLUE_SIZE_EXT' else
      if self.val = UInt32($8D52) then Result := 'RENDERBUFFER_BLUE_SIZE_OES' else
      if self.val = UInt32($8D53) then Result := 'RENDERBUFFER_ALPHA_SIZE' else
      if self.val = UInt32($8D53) then Result := 'RENDERBUFFER_ALPHA_SIZE_EXT' else
      if self.val = UInt32($8D53) then Result := 'RENDERBUFFER_ALPHA_SIZE_OES' else
      if self.val = UInt32($8D54) then Result := 'RENDERBUFFER_DEPTH_SIZE' else
      if self.val = UInt32($8D54) then Result := 'RENDERBUFFER_DEPTH_SIZE_EXT' else
      if self.val = UInt32($8D54) then Result := 'RENDERBUFFER_DEPTH_SIZE_OES' else
      if self.val = UInt32($8D55) then Result := 'RENDERBUFFER_STENCIL_SIZE' else
      if self.val = UInt32($8D55) then Result := 'RENDERBUFFER_STENCIL_SIZE_EXT' else
      if self.val = UInt32($8D55) then Result := 'RENDERBUFFER_STENCIL_SIZE_OES' else
      if self.val = UInt32($8E10) then Result := 'RENDERBUFFER_COLOR_SAMPLES_NV' else
      if self.val = UInt32($9133) then Result := 'RENDERBUFFER_SAMPLES_IMG' else
      if self.val = UInt32($91B2) then Result := 'RENDERBUFFER_STORAGE_SAMPLES_AMD' else
        Result := $'RenderbufferParameterName[{self.val}]';
    end;
    
  end;
  
  RenderbufferTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property RENDERBUFFER:     RenderbufferTarget read new RenderbufferTarget($8D41);
    public static property RENDERBUFFER_OES: RenderbufferTarget read new RenderbufferTarget($8D41);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8D41) then Result := 'RENDERBUFFER' else
      if self.val = UInt32($8D41) then Result := 'RENDERBUFFER_OES' else
        Result := $'RenderbufferTarget[{self.val}]';
    end;
    
  end;
  
  RenderingMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property RENDER:   RenderingMode read new RenderingMode($1C00);
    public static property FEEDBACK: RenderingMode read new RenderingMode($1C01);
    public static property SELECT:   RenderingMode read new RenderingMode($1C02);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1C00) then Result := 'RENDER' else
      if self.val = UInt32($1C01) then Result := 'FEEDBACK' else
      if self.val = UInt32($1C02) then Result := 'SELECT' else
        Result := $'RenderingMode[{self.val}]';
    end;
    
  end;
  
  SamplerParameterF = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_BORDER_COLOR:                 SamplerParameterF read new SamplerParameterF($1004);
    public static property TEXTURE_MIN_LOD:                      SamplerParameterF read new SamplerParameterF($813A);
    public static property TEXTURE_MAX_LOD:                      SamplerParameterF read new SamplerParameterF($813B);
    public static property TEXTURE_MAX_ANISOTROPY:               SamplerParameterF read new SamplerParameterF($84FE);
    public static property TEXTURE_LOD_BIAS:                     SamplerParameterF read new SamplerParameterF($8501);
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: SamplerParameterF read new SamplerParameterF($8F6A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1004) then Result := 'TEXTURE_BORDER_COLOR' else
      if self.val = UInt32($813A) then Result := 'TEXTURE_MIN_LOD' else
      if self.val = UInt32($813B) then Result := 'TEXTURE_MAX_LOD' else
      if self.val = UInt32($84FE) then Result := 'TEXTURE_MAX_ANISOTROPY' else
      if self.val = UInt32($8501) then Result := 'TEXTURE_LOD_BIAS' else
      if self.val = UInt32($8F6A) then Result := 'TEXTURE_UNNORMALIZED_COORDINATES_ARM' else
        Result := $'SamplerParameterF[{self.val}]';
    end;
    
  end;
  
  SamplerParameterI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_MAG_FILTER:                   SamplerParameterI read new SamplerParameterI($2800);
    public static property TEXTURE_MIN_FILTER:                   SamplerParameterI read new SamplerParameterI($2801);
    public static property TEXTURE_WRAP_S:                       SamplerParameterI read new SamplerParameterI($2802);
    public static property TEXTURE_WRAP_T:                       SamplerParameterI read new SamplerParameterI($2803);
    public static property TEXTURE_WRAP_R:                       SamplerParameterI read new SamplerParameterI($8072);
    public static property TEXTURE_COMPARE_MODE:                 SamplerParameterI read new SamplerParameterI($884C);
    public static property TEXTURE_COMPARE_FUNC:                 SamplerParameterI read new SamplerParameterI($884D);
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: SamplerParameterI read new SamplerParameterI($8F6A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2800) then Result := 'TEXTURE_MAG_FILTER' else
      if self.val = UInt32($2801) then Result := 'TEXTURE_MIN_FILTER' else
      if self.val = UInt32($2802) then Result := 'TEXTURE_WRAP_S' else
      if self.val = UInt32($2803) then Result := 'TEXTURE_WRAP_T' else
      if self.val = UInt32($8072) then Result := 'TEXTURE_WRAP_R' else
      if self.val = UInt32($884C) then Result := 'TEXTURE_COMPARE_MODE' else
      if self.val = UInt32($884D) then Result := 'TEXTURE_COMPARE_FUNC' else
      if self.val = UInt32($8F6A) then Result := 'TEXTURE_UNNORMALIZED_COORDINATES_ARM' else
        Result := $'SamplerParameterI[{self.val}]';
    end;
    
  end;
  
  ScalarType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_BYTE:  ScalarType read new ScalarType($1401);
    public static property UNSIGNED_SHORT: ScalarType read new ScalarType($1403);
    public static property UNSIGNED_INT:   ScalarType read new ScalarType($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'ScalarType[{self.val}]';
    end;
    
  end;
  
  SemaphoreParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property D3D12_FENCE_VALUE_EXT:       SemaphoreParameterName read new SemaphoreParameterName($9595);
    public static property TIMELINE_SEMAPHORE_VALUE_NV: SemaphoreParameterName read new SemaphoreParameterName($9595);
    public static property SEMAPHORE_TYPE_NV:           SemaphoreParameterName read new SemaphoreParameterName($95B3);
    public static property SEMAPHORE_TYPE_BINARY_NV:    SemaphoreParameterName read new SemaphoreParameterName($95B4);
    public static property SEMAPHORE_TYPE_TIMELINE_NV:  SemaphoreParameterName read new SemaphoreParameterName($95B5);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9595) then Result := 'D3D12_FENCE_VALUE_EXT' else
      if self.val = UInt32($9595) then Result := 'TIMELINE_SEMAPHORE_VALUE_NV' else
      if self.val = UInt32($95B3) then Result := 'SEMAPHORE_TYPE_NV' else
      if self.val = UInt32($95B4) then Result := 'SEMAPHORE_TYPE_BINARY_NV' else
      if self.val = UInt32($95B5) then Result := 'SEMAPHORE_TYPE_TIMELINE_NV' else
        Result := $'SemaphoreParameterName[{self.val}]';
    end;
    
  end;
  
  SeparableTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SEPARABLE_2D: SeparableTarget read new SeparableTarget($8012);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8012) then Result := 'SEPARABLE_2D' else
        Result := $'SeparableTarget[{self.val}]';
    end;
    
  end;
  
  ShaderBinaryFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SGX_BINARY_IMG:              ShaderBinaryFormat read new ShaderBinaryFormat($8C0A);
    public static property MALI_SHADER_BINARY_ARM:      ShaderBinaryFormat read new ShaderBinaryFormat($8F60);
    public static property SHADER_BINARY_VIV:           ShaderBinaryFormat read new ShaderBinaryFormat($8FC4);
    public static property SHADER_BINARY_DMP:           ShaderBinaryFormat read new ShaderBinaryFormat($9250);
    public static property GCCSO_SHADER_BINARY_FJ:      ShaderBinaryFormat read new ShaderBinaryFormat($9260);
    public static property SHADER_BINARY_FORMAT_SPIR_V: ShaderBinaryFormat read new ShaderBinaryFormat($9551);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8C0A) then Result := 'SGX_BINARY_IMG' else
      if self.val = UInt32($8F60) then Result := 'MALI_SHADER_BINARY_ARM' else
      if self.val = UInt32($8FC4) then Result := 'SHADER_BINARY_VIV' else
      if self.val = UInt32($9250) then Result := 'SHADER_BINARY_DMP' else
      if self.val = UInt32($9260) then Result := 'GCCSO_SHADER_BINARY_FJ' else
      if self.val = UInt32($9551) then Result := 'SHADER_BINARY_FORMAT_SPIR_V' else
        Result := $'ShaderBinaryFormat[{self.val}]';
    end;
    
  end;
  
  ShaderParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SHADER_TYPE:          ShaderParameterName read new ShaderParameterName($8B4F);
    public static property DELETE_STATUS:        ShaderParameterName read new ShaderParameterName($8B80);
    public static property COMPILE_STATUS:       ShaderParameterName read new ShaderParameterName($8B81);
    public static property INFO_LOG_LENGTH:      ShaderParameterName read new ShaderParameterName($8B84);
    public static property SHADER_SOURCE_LENGTH: ShaderParameterName read new ShaderParameterName($8B88);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8B4F) then Result := 'SHADER_TYPE' else
      if self.val = UInt32($8B80) then Result := 'DELETE_STATUS' else
      if self.val = UInt32($8B81) then Result := 'COMPILE_STATUS' else
      if self.val = UInt32($8B84) then Result := 'INFO_LOG_LENGTH' else
      if self.val = UInt32($8B88) then Result := 'SHADER_SOURCE_LENGTH' else
        Result := $'ShaderParameterName[{self.val}]';
    end;
    
  end;
  
  ShaderType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAGMENT_SHADER:        ShaderType read new ShaderType($8B30);
    public static property FRAGMENT_SHADER_ARB:    ShaderType read new ShaderType($8B30);
    public static property VERTEX_SHADER:          ShaderType read new ShaderType($8B31);
    public static property VERTEX_SHADER_ARB:      ShaderType read new ShaderType($8B31);
    public static property GEOMETRY_SHADER:        ShaderType read new ShaderType($8DD9);
    public static property TESS_EVALUATION_SHADER: ShaderType read new ShaderType($8E87);
    public static property TESS_CONTROL_SHADER:    ShaderType read new ShaderType($8E88);
    public static property COMPUTE_SHADER:         ShaderType read new ShaderType($91B9);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8B30) then Result := 'FRAGMENT_SHADER' else
      if self.val = UInt32($8B30) then Result := 'FRAGMENT_SHADER_ARB' else
      if self.val = UInt32($8B31) then Result := 'VERTEX_SHADER' else
      if self.val = UInt32($8B31) then Result := 'VERTEX_SHADER_ARB' else
      if self.val = UInt32($8DD9) then Result := 'GEOMETRY_SHADER' else
      if self.val = UInt32($8E87) then Result := 'TESS_EVALUATION_SHADER' else
      if self.val = UInt32($8E88) then Result := 'TESS_CONTROL_SHADER' else
      if self.val = UInt32($91B9) then Result := 'COMPUTE_SHADER' else
        Result := $'ShaderType[{self.val}]';
    end;
    
  end;
  
  ShadingModel = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FLAT:   ShadingModel read new ShadingModel($1D00);
    public static property SMOOTH: ShadingModel read new ShadingModel($1D01);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1D00) then Result := 'FLAT' else
      if self.val = UInt32($1D01) then Result := 'SMOOTH' else
        Result := $'ShadingModel[{self.val}]';
    end;
    
  end;
  
  SizedInternalFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property R3_G3_B2:                                      SizedInternalFormat read new SizedInternalFormat($2A10);
    public static property ALPHA4:                                        SizedInternalFormat read new SizedInternalFormat($803B);
    public static property ALPHA4_EXT:                                    SizedInternalFormat read new SizedInternalFormat($803B);
    public static property ALPHA8:                                        SizedInternalFormat read new SizedInternalFormat($803C);
    public static property ALPHA8_EXT:                                    SizedInternalFormat read new SizedInternalFormat($803C);
    public static property ALPHA8_OES:                                    SizedInternalFormat read new SizedInternalFormat($803C);
    public static property ALPHA12:                                       SizedInternalFormat read new SizedInternalFormat($803D);
    public static property ALPHA12_EXT:                                   SizedInternalFormat read new SizedInternalFormat($803D);
    public static property ALPHA16:                                       SizedInternalFormat read new SizedInternalFormat($803E);
    public static property ALPHA16_EXT:                                   SizedInternalFormat read new SizedInternalFormat($803E);
    public static property LUMINANCE4:                                    SizedInternalFormat read new SizedInternalFormat($803F);
    public static property LUMINANCE4_EXT:                                SizedInternalFormat read new SizedInternalFormat($803F);
    public static property LUMINANCE8:                                    SizedInternalFormat read new SizedInternalFormat($8040);
    public static property LUMINANCE8_EXT:                                SizedInternalFormat read new SizedInternalFormat($8040);
    public static property LUMINANCE8_OES:                                SizedInternalFormat read new SizedInternalFormat($8040);
    public static property LUMINANCE12:                                   SizedInternalFormat read new SizedInternalFormat($8041);
    public static property LUMINANCE12_EXT:                               SizedInternalFormat read new SizedInternalFormat($8041);
    public static property LUMINANCE16:                                   SizedInternalFormat read new SizedInternalFormat($8042);
    public static property LUMINANCE16_EXT:                               SizedInternalFormat read new SizedInternalFormat($8042);
    public static property LUMINANCE4_ALPHA4:                             SizedInternalFormat read new SizedInternalFormat($8043);
    public static property LUMINANCE4_ALPHA4_EXT:                         SizedInternalFormat read new SizedInternalFormat($8043);
    public static property LUMINANCE4_ALPHA4_OES:                         SizedInternalFormat read new SizedInternalFormat($8043);
    public static property LUMINANCE6_ALPHA2:                             SizedInternalFormat read new SizedInternalFormat($8044);
    public static property LUMINANCE6_ALPHA2_EXT:                         SizedInternalFormat read new SizedInternalFormat($8044);
    public static property LUMINANCE8_ALPHA8:                             SizedInternalFormat read new SizedInternalFormat($8045);
    public static property LUMINANCE8_ALPHA8_EXT:                         SizedInternalFormat read new SizedInternalFormat($8045);
    public static property LUMINANCE8_ALPHA8_OES:                         SizedInternalFormat read new SizedInternalFormat($8045);
    public static property LUMINANCE12_ALPHA4:                            SizedInternalFormat read new SizedInternalFormat($8046);
    public static property LUMINANCE12_ALPHA4_EXT:                        SizedInternalFormat read new SizedInternalFormat($8046);
    public static property LUMINANCE12_ALPHA12:                           SizedInternalFormat read new SizedInternalFormat($8047);
    public static property LUMINANCE12_ALPHA12_EXT:                       SizedInternalFormat read new SizedInternalFormat($8047);
    public static property LUMINANCE16_ALPHA16:                           SizedInternalFormat read new SizedInternalFormat($8048);
    public static property LUMINANCE16_ALPHA16_EXT:                       SizedInternalFormat read new SizedInternalFormat($8048);
    public static property INTENSITY4:                                    SizedInternalFormat read new SizedInternalFormat($804A);
    public static property INTENSITY4_EXT:                                SizedInternalFormat read new SizedInternalFormat($804A);
    public static property INTENSITY8:                                    SizedInternalFormat read new SizedInternalFormat($804B);
    public static property INTENSITY8_EXT:                                SizedInternalFormat read new SizedInternalFormat($804B);
    public static property INTENSITY12:                                   SizedInternalFormat read new SizedInternalFormat($804C);
    public static property INTENSITY12_EXT:                               SizedInternalFormat read new SizedInternalFormat($804C);
    public static property INTENSITY16:                                   SizedInternalFormat read new SizedInternalFormat($804D);
    public static property INTENSITY16_EXT:                               SizedInternalFormat read new SizedInternalFormat($804D);
    public static property RGB2_EXT:                                      SizedInternalFormat read new SizedInternalFormat($804E);
    public static property RGB4:                                          SizedInternalFormat read new SizedInternalFormat($804F);
    public static property RGB4_EXT:                                      SizedInternalFormat read new SizedInternalFormat($804F);
    public static property RGB5:                                          SizedInternalFormat read new SizedInternalFormat($8050);
    public static property RGB5_EXT:                                      SizedInternalFormat read new SizedInternalFormat($8050);
    public static property RGB8:                                          SizedInternalFormat read new SizedInternalFormat($8051);
    public static property RGB8_EXT:                                      SizedInternalFormat read new SizedInternalFormat($8051);
    public static property RGB8_OES:                                      SizedInternalFormat read new SizedInternalFormat($8051);
    public static property RGB10:                                         SizedInternalFormat read new SizedInternalFormat($8052);
    public static property RGB10_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8052);
    public static property RGB12:                                         SizedInternalFormat read new SizedInternalFormat($8053);
    public static property RGB12_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8053);
    public static property RGB16:                                         SizedInternalFormat read new SizedInternalFormat($8054);
    public static property RGB16_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8054);
    public static property RGBA2:                                         SizedInternalFormat read new SizedInternalFormat($8055);
    public static property RGBA2_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8055);
    public static property RGBA4:                                         SizedInternalFormat read new SizedInternalFormat($8056);
    public static property RGBA4_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8056);
    public static property RGBA4_OES:                                     SizedInternalFormat read new SizedInternalFormat($8056);
    public static property RGB5_A1:                                       SizedInternalFormat read new SizedInternalFormat($8057);
    public static property RGB5_A1_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8057);
    public static property RGB5_A1_OES:                                   SizedInternalFormat read new SizedInternalFormat($8057);
    public static property RGBA8:                                         SizedInternalFormat read new SizedInternalFormat($8058);
    public static property RGBA8_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8058);
    public static property RGBA8_OES:                                     SizedInternalFormat read new SizedInternalFormat($8058);
    public static property RGB10_A2:                                      SizedInternalFormat read new SizedInternalFormat($8059);
    public static property RGB10_A2_EXT:                                  SizedInternalFormat read new SizedInternalFormat($8059);
    public static property RGBA12:                                        SizedInternalFormat read new SizedInternalFormat($805A);
    public static property RGBA12_EXT:                                    SizedInternalFormat read new SizedInternalFormat($805A);
    public static property RGBA16:                                        SizedInternalFormat read new SizedInternalFormat($805B);
    public static property RGBA16_EXT:                                    SizedInternalFormat read new SizedInternalFormat($805B);
    public static property DEPTH_COMPONENT16:                             SizedInternalFormat read new SizedInternalFormat($81A5);
    public static property DEPTH_COMPONENT16_ARB:                         SizedInternalFormat read new SizedInternalFormat($81A5);
    public static property DEPTH_COMPONENT16_OES:                         SizedInternalFormat read new SizedInternalFormat($81A5);
    public static property DEPTH_COMPONENT16_SGIX:                        SizedInternalFormat read new SizedInternalFormat($81A5);
    public static property DEPTH_COMPONENT24:                             SizedInternalFormat read new SizedInternalFormat($81A6);
    public static property DEPTH_COMPONENT24_ARB:                         SizedInternalFormat read new SizedInternalFormat($81A6);
    public static property DEPTH_COMPONENT24_OES:                         SizedInternalFormat read new SizedInternalFormat($81A6);
    public static property DEPTH_COMPONENT24_SGIX:                        SizedInternalFormat read new SizedInternalFormat($81A6);
    public static property DEPTH_COMPONENT32:                             SizedInternalFormat read new SizedInternalFormat($81A7);
    public static property DEPTH_COMPONENT32_ARB:                         SizedInternalFormat read new SizedInternalFormat($81A7);
    public static property DEPTH_COMPONENT32_OES:                         SizedInternalFormat read new SizedInternalFormat($81A7);
    public static property DEPTH_COMPONENT32_SGIX:                        SizedInternalFormat read new SizedInternalFormat($81A7);
    public static property R8:                                            SizedInternalFormat read new SizedInternalFormat($8229);
    public static property R8_EXT:                                        SizedInternalFormat read new SizedInternalFormat($8229);
    public static property R16:                                           SizedInternalFormat read new SizedInternalFormat($822A);
    public static property R16_EXT:                                       SizedInternalFormat read new SizedInternalFormat($822A);
    public static property RG8:                                           SizedInternalFormat read new SizedInternalFormat($822B);
    public static property RG8_EXT:                                       SizedInternalFormat read new SizedInternalFormat($822B);
    public static property RG16:                                          SizedInternalFormat read new SizedInternalFormat($822C);
    public static property RG16_EXT:                                      SizedInternalFormat read new SizedInternalFormat($822C);
    public static property R16F:                                          SizedInternalFormat read new SizedInternalFormat($822D);
    public static property R16F_EXT:                                      SizedInternalFormat read new SizedInternalFormat($822D);
    public static property R32F:                                          SizedInternalFormat read new SizedInternalFormat($822E);
    public static property R32F_EXT:                                      SizedInternalFormat read new SizedInternalFormat($822E);
    public static property RG16F:                                         SizedInternalFormat read new SizedInternalFormat($822F);
    public static property RG16F_EXT:                                     SizedInternalFormat read new SizedInternalFormat($822F);
    public static property RG32F:                                         SizedInternalFormat read new SizedInternalFormat($8230);
    public static property RG32F_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8230);
    public static property R8I:                                           SizedInternalFormat read new SizedInternalFormat($8231);
    public static property R8UI:                                          SizedInternalFormat read new SizedInternalFormat($8232);
    public static property R16I:                                          SizedInternalFormat read new SizedInternalFormat($8233);
    public static property R16UI:                                         SizedInternalFormat read new SizedInternalFormat($8234);
    public static property R32I:                                          SizedInternalFormat read new SizedInternalFormat($8235);
    public static property R32UI:                                         SizedInternalFormat read new SizedInternalFormat($8236);
    public static property RG8I:                                          SizedInternalFormat read new SizedInternalFormat($8237);
    public static property RG8UI:                                         SizedInternalFormat read new SizedInternalFormat($8238);
    public static property RG16I:                                         SizedInternalFormat read new SizedInternalFormat($8239);
    public static property RG16UI:                                        SizedInternalFormat read new SizedInternalFormat($823A);
    public static property RG32I:                                         SizedInternalFormat read new SizedInternalFormat($823B);
    public static property RG32UI:                                        SizedInternalFormat read new SizedInternalFormat($823C);
    public static property COMPRESSED_RGB_S3TC_DXT1_EXT:                  SizedInternalFormat read new SizedInternalFormat($83F0);
    public static property COMPRESSED_RGBA_S3TC_DXT1_EXT:                 SizedInternalFormat read new SizedInternalFormat($83F1);
    public static property COMPRESSED_RGBA_S3TC_DXT3_ANGLE:               SizedInternalFormat read new SizedInternalFormat($83F2);
    public static property COMPRESSED_RGBA_S3TC_DXT3_EXT:                 SizedInternalFormat read new SizedInternalFormat($83F2);
    public static property COMPRESSED_RGBA_S3TC_DXT5_ANGLE:               SizedInternalFormat read new SizedInternalFormat($83F3);
    public static property COMPRESSED_RGBA_S3TC_DXT5_EXT:                 SizedInternalFormat read new SizedInternalFormat($83F3);
    public static property RGBA32F:                                       SizedInternalFormat read new SizedInternalFormat($8814);
    public static property RGBA32F_ARB:                                   SizedInternalFormat read new SizedInternalFormat($8814);
    public static property RGBA32F_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8814);
    public static property RGB32F:                                        SizedInternalFormat read new SizedInternalFormat($8815);
    public static property RGB32F_ARB:                                    SizedInternalFormat read new SizedInternalFormat($8815);
    public static property RGB32F_EXT:                                    SizedInternalFormat read new SizedInternalFormat($8815);
    public static property RGBA16F:                                       SizedInternalFormat read new SizedInternalFormat($881A);
    public static property RGBA16F_ARB:                                   SizedInternalFormat read new SizedInternalFormat($881A);
    public static property RGBA16F_EXT:                                   SizedInternalFormat read new SizedInternalFormat($881A);
    public static property RGB16F:                                        SizedInternalFormat read new SizedInternalFormat($881B);
    public static property RGB16F_ARB:                                    SizedInternalFormat read new SizedInternalFormat($881B);
    public static property RGB16F_EXT:                                    SizedInternalFormat read new SizedInternalFormat($881B);
    public static property DEPTH24_STENCIL8:                              SizedInternalFormat read new SizedInternalFormat($88F0);
    public static property DEPTH24_STENCIL8_EXT:                          SizedInternalFormat read new SizedInternalFormat($88F0);
    public static property DEPTH24_STENCIL8_OES:                          SizedInternalFormat read new SizedInternalFormat($88F0);
    public static property R11F_G11F_B10F:                                SizedInternalFormat read new SizedInternalFormat($8C3A);
    public static property R11F_G11F_B10F_APPLE:                          SizedInternalFormat read new SizedInternalFormat($8C3A);
    public static property R11F_G11F_B10F_EXT:                            SizedInternalFormat read new SizedInternalFormat($8C3A);
    public static property RGB9_E5:                                       SizedInternalFormat read new SizedInternalFormat($8C3D);
    public static property RGB9_E5_APPLE:                                 SizedInternalFormat read new SizedInternalFormat($8C3D);
    public static property RGB9_E5_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8C3D);
    public static property SRGB8:                                         SizedInternalFormat read new SizedInternalFormat($8C41);
    public static property SRGB8_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8C41);
    public static property SRGB8_NV:                                      SizedInternalFormat read new SizedInternalFormat($8C41);
    public static property SRGB8_ALPHA8:                                  SizedInternalFormat read new SizedInternalFormat($8C43);
    public static property SRGB8_ALPHA8_EXT:                              SizedInternalFormat read new SizedInternalFormat($8C43);
    public static property COMPRESSED_SRGB_S3TC_DXT1_EXT:                 SizedInternalFormat read new SizedInternalFormat($8C4C);
    public static property COMPRESSED_SRGB_S3TC_DXT1_NV:                  SizedInternalFormat read new SizedInternalFormat($8C4C);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT:           SizedInternalFormat read new SizedInternalFormat($8C4D);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV:            SizedInternalFormat read new SizedInternalFormat($8C4D);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT:           SizedInternalFormat read new SizedInternalFormat($8C4E);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV:            SizedInternalFormat read new SizedInternalFormat($8C4E);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT:           SizedInternalFormat read new SizedInternalFormat($8C4F);
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV:            SizedInternalFormat read new SizedInternalFormat($8C4F);
    public static property DEPTH_COMPONENT32F:                            SizedInternalFormat read new SizedInternalFormat($8CAC);
    public static property DEPTH32F_STENCIL8:                             SizedInternalFormat read new SizedInternalFormat($8CAD);
    public static property STENCIL_INDEX1:                                SizedInternalFormat read new SizedInternalFormat($8D46);
    public static property STENCIL_INDEX1_EXT:                            SizedInternalFormat read new SizedInternalFormat($8D46);
    public static property STENCIL_INDEX1_OES:                            SizedInternalFormat read new SizedInternalFormat($8D46);
    public static property STENCIL_INDEX4:                                SizedInternalFormat read new SizedInternalFormat($8D47);
    public static property STENCIL_INDEX4_EXT:                            SizedInternalFormat read new SizedInternalFormat($8D47);
    public static property STENCIL_INDEX4_OES:                            SizedInternalFormat read new SizedInternalFormat($8D47);
    public static property STENCIL_INDEX8:                                SizedInternalFormat read new SizedInternalFormat($8D48);
    public static property STENCIL_INDEX8_EXT:                            SizedInternalFormat read new SizedInternalFormat($8D48);
    public static property STENCIL_INDEX8_OES:                            SizedInternalFormat read new SizedInternalFormat($8D48);
    public static property STENCIL_INDEX16:                               SizedInternalFormat read new SizedInternalFormat($8D49);
    public static property STENCIL_INDEX16_EXT:                           SizedInternalFormat read new SizedInternalFormat($8D49);
    public static property RGB565:                                        SizedInternalFormat read new SizedInternalFormat($8D62);
    public static property RGB565_OES:                                    SizedInternalFormat read new SizedInternalFormat($8D62);
    public static property ETC1_RGB8_OES:                                 SizedInternalFormat read new SizedInternalFormat($8D64);
    public static property RGBA32UI:                                      SizedInternalFormat read new SizedInternalFormat($8D70);
    public static property RGBA32UI_EXT:                                  SizedInternalFormat read new SizedInternalFormat($8D70);
    public static property RGB32UI:                                       SizedInternalFormat read new SizedInternalFormat($8D71);
    public static property RGB32UI_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8D71);
    public static property ALPHA32UI_EXT:                                 SizedInternalFormat read new SizedInternalFormat($8D72);
    public static property INTENSITY32UI_EXT:                             SizedInternalFormat read new SizedInternalFormat($8D73);
    public static property LUMINANCE32UI_EXT:                             SizedInternalFormat read new SizedInternalFormat($8D74);
    public static property LUMINANCE_ALPHA32UI_EXT:                       SizedInternalFormat read new SizedInternalFormat($8D75);
    public static property RGBA16UI:                                      SizedInternalFormat read new SizedInternalFormat($8D76);
    public static property RGBA16UI_EXT:                                  SizedInternalFormat read new SizedInternalFormat($8D76);
    public static property RGB16UI:                                       SizedInternalFormat read new SizedInternalFormat($8D77);
    public static property RGB16UI_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8D77);
    public static property ALPHA16UI_EXT:                                 SizedInternalFormat read new SizedInternalFormat($8D78);
    public static property INTENSITY16UI_EXT:                             SizedInternalFormat read new SizedInternalFormat($8D79);
    public static property LUMINANCE16UI_EXT:                             SizedInternalFormat read new SizedInternalFormat($8D7A);
    public static property LUMINANCE_ALPHA16UI_EXT:                       SizedInternalFormat read new SizedInternalFormat($8D7B);
    public static property RGBA8UI:                                       SizedInternalFormat read new SizedInternalFormat($8D7C);
    public static property RGBA8UI_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8D7C);
    public static property RGB8UI:                                        SizedInternalFormat read new SizedInternalFormat($8D7D);
    public static property RGB8UI_EXT:                                    SizedInternalFormat read new SizedInternalFormat($8D7D);
    public static property ALPHA8UI_EXT:                                  SizedInternalFormat read new SizedInternalFormat($8D7E);
    public static property INTENSITY8UI_EXT:                              SizedInternalFormat read new SizedInternalFormat($8D7F);
    public static property LUMINANCE8UI_EXT:                              SizedInternalFormat read new SizedInternalFormat($8D80);
    public static property LUMINANCE_ALPHA8UI_EXT:                        SizedInternalFormat read new SizedInternalFormat($8D81);
    public static property RGBA32I:                                       SizedInternalFormat read new SizedInternalFormat($8D82);
    public static property RGBA32I_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8D82);
    public static property RGB32I:                                        SizedInternalFormat read new SizedInternalFormat($8D83);
    public static property RGB32I_EXT:                                    SizedInternalFormat read new SizedInternalFormat($8D83);
    public static property ALPHA32I_EXT:                                  SizedInternalFormat read new SizedInternalFormat($8D84);
    public static property INTENSITY32I_EXT:                              SizedInternalFormat read new SizedInternalFormat($8D85);
    public static property LUMINANCE32I_EXT:                              SizedInternalFormat read new SizedInternalFormat($8D86);
    public static property LUMINANCE_ALPHA32I_EXT:                        SizedInternalFormat read new SizedInternalFormat($8D87);
    public static property RGBA16I:                                       SizedInternalFormat read new SizedInternalFormat($8D88);
    public static property RGBA16I_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8D88);
    public static property RGB16I:                                        SizedInternalFormat read new SizedInternalFormat($8D89);
    public static property RGB16I_EXT:                                    SizedInternalFormat read new SizedInternalFormat($8D89);
    public static property ALPHA16I_EXT:                                  SizedInternalFormat read new SizedInternalFormat($8D8A);
    public static property INTENSITY16I_EXT:                              SizedInternalFormat read new SizedInternalFormat($8D8B);
    public static property LUMINANCE16I_EXT:                              SizedInternalFormat read new SizedInternalFormat($8D8C);
    public static property LUMINANCE_ALPHA16I_EXT:                        SizedInternalFormat read new SizedInternalFormat($8D8D);
    public static property RGBA8I:                                        SizedInternalFormat read new SizedInternalFormat($8D8E);
    public static property RGBA8I_EXT:                                    SizedInternalFormat read new SizedInternalFormat($8D8E);
    public static property RGB8I:                                         SizedInternalFormat read new SizedInternalFormat($8D8F);
    public static property RGB8I_EXT:                                     SizedInternalFormat read new SizedInternalFormat($8D8F);
    public static property ALPHA8I_EXT:                                   SizedInternalFormat read new SizedInternalFormat($8D90);
    public static property INTENSITY8I_EXT:                               SizedInternalFormat read new SizedInternalFormat($8D91);
    public static property LUMINANCE8I_EXT:                               SizedInternalFormat read new SizedInternalFormat($8D92);
    public static property LUMINANCE_ALPHA8I_EXT:                         SizedInternalFormat read new SizedInternalFormat($8D93);
    public static property DEPTH_COMPONENT32F_NV:                         SizedInternalFormat read new SizedInternalFormat($8DAB);
    public static property DEPTH32F_STENCIL8_NV:                          SizedInternalFormat read new SizedInternalFormat($8DAC);
    public static property COMPRESSED_RED_RGTC1:                          SizedInternalFormat read new SizedInternalFormat($8DBB);
    public static property COMPRESSED_RED_RGTC1_EXT:                      SizedInternalFormat read new SizedInternalFormat($8DBB);
    public static property COMPRESSED_SIGNED_RED_RGTC1:                   SizedInternalFormat read new SizedInternalFormat($8DBC);
    public static property COMPRESSED_SIGNED_RED_RGTC1_EXT:               SizedInternalFormat read new SizedInternalFormat($8DBC);
    public static property COMPRESSED_RED_GREEN_RGTC2_EXT:                SizedInternalFormat read new SizedInternalFormat($8DBD);
    public static property COMPRESSED_RG_RGTC2:                           SizedInternalFormat read new SizedInternalFormat($8DBD);
    public static property COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT:         SizedInternalFormat read new SizedInternalFormat($8DBE);
    public static property COMPRESSED_SIGNED_RG_RGTC2:                    SizedInternalFormat read new SizedInternalFormat($8DBE);
    public static property COMPRESSED_RGBA_BPTC_UNORM:                    SizedInternalFormat read new SizedInternalFormat($8E8C);
    public static property COMPRESSED_RGBA_BPTC_UNORM_ARB:                SizedInternalFormat read new SizedInternalFormat($8E8C);
    public static property COMPRESSED_RGBA_BPTC_UNORM_EXT:                SizedInternalFormat read new SizedInternalFormat($8E8C);
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM:              SizedInternalFormat read new SizedInternalFormat($8E8D);
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB:          SizedInternalFormat read new SizedInternalFormat($8E8D);
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT:          SizedInternalFormat read new SizedInternalFormat($8E8D);
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT:              SizedInternalFormat read new SizedInternalFormat($8E8E);
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB:          SizedInternalFormat read new SizedInternalFormat($8E8E);
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT:          SizedInternalFormat read new SizedInternalFormat($8E8E);
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT:            SizedInternalFormat read new SizedInternalFormat($8E8F);
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB:        SizedInternalFormat read new SizedInternalFormat($8E8F);
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT:        SizedInternalFormat read new SizedInternalFormat($8E8F);
    public static property R8_SNORM:                                      SizedInternalFormat read new SizedInternalFormat($8F94);
    public static property RG8_SNORM:                                     SizedInternalFormat read new SizedInternalFormat($8F95);
    public static property RGB8_SNORM:                                    SizedInternalFormat read new SizedInternalFormat($8F96);
    public static property RGBA8_SNORM:                                   SizedInternalFormat read new SizedInternalFormat($8F97);
    public static property R16_SNORM:                                     SizedInternalFormat read new SizedInternalFormat($8F98);
    public static property R16_SNORM_EXT:                                 SizedInternalFormat read new SizedInternalFormat($8F98);
    public static property RG16_SNORM:                                    SizedInternalFormat read new SizedInternalFormat($8F99);
    public static property RG16_SNORM_EXT:                                SizedInternalFormat read new SizedInternalFormat($8F99);
    public static property RGB16_SNORM:                                   SizedInternalFormat read new SizedInternalFormat($8F9A);
    public static property RGB16_SNORM_EXT:                               SizedInternalFormat read new SizedInternalFormat($8F9A);
    public static property RGBA16_SNORM:                                  SizedInternalFormat read new SizedInternalFormat($8F9B);
    public static property RGBA16_SNORM_EXT:                              SizedInternalFormat read new SizedInternalFormat($8F9B);
    public static property RGB10_A2UI:                                    SizedInternalFormat read new SizedInternalFormat($906F);
    public static property COMPRESSED_R11_EAC:                            SizedInternalFormat read new SizedInternalFormat($9270);
    public static property COMPRESSED_R11_EAC_OES:                        SizedInternalFormat read new SizedInternalFormat($9270);
    public static property COMPRESSED_SIGNED_R11_EAC:                     SizedInternalFormat read new SizedInternalFormat($9271);
    public static property COMPRESSED_SIGNED_R11_EAC_OES:                 SizedInternalFormat read new SizedInternalFormat($9271);
    public static property COMPRESSED_RG11_EAC:                           SizedInternalFormat read new SizedInternalFormat($9272);
    public static property COMPRESSED_RG11_EAC_OES:                       SizedInternalFormat read new SizedInternalFormat($9272);
    public static property COMPRESSED_SIGNED_RG11_EAC:                    SizedInternalFormat read new SizedInternalFormat($9273);
    public static property COMPRESSED_SIGNED_RG11_EAC_OES:                SizedInternalFormat read new SizedInternalFormat($9273);
    public static property COMPRESSED_RGB8_ETC2:                          SizedInternalFormat read new SizedInternalFormat($9274);
    public static property COMPRESSED_RGB8_ETC2_OES:                      SizedInternalFormat read new SizedInternalFormat($9274);
    public static property COMPRESSED_SRGB8_ETC2:                         SizedInternalFormat read new SizedInternalFormat($9275);
    public static property COMPRESSED_SRGB8_ETC2_OES:                     SizedInternalFormat read new SizedInternalFormat($9275);
    public static property COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:      SizedInternalFormat read new SizedInternalFormat($9276);
    public static property COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES:  SizedInternalFormat read new SizedInternalFormat($9276);
    public static property COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:     SizedInternalFormat read new SizedInternalFormat($9277);
    public static property COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES: SizedInternalFormat read new SizedInternalFormat($9277);
    public static property COMPRESSED_RGBA8_ETC2_EAC:                     SizedInternalFormat read new SizedInternalFormat($9278);
    public static property COMPRESSED_RGBA8_ETC2_EAC_OES:                 SizedInternalFormat read new SizedInternalFormat($9278);
    public static property COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:              SizedInternalFormat read new SizedInternalFormat($9279);
    public static property COMPRESSED_SRGB8_ALPHA8_ETC2_EAC_OES:          SizedInternalFormat read new SizedInternalFormat($9279);
    public static property COMPRESSED_RGBA_ASTC_4x4:                      SizedInternalFormat read new SizedInternalFormat($93B0);
    public static property COMPRESSED_RGBA_ASTC_4x4_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B0);
    public static property COMPRESSED_RGBA_ASTC_5x4:                      SizedInternalFormat read new SizedInternalFormat($93B1);
    public static property COMPRESSED_RGBA_ASTC_5x4_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B1);
    public static property COMPRESSED_RGBA_ASTC_5x5:                      SizedInternalFormat read new SizedInternalFormat($93B2);
    public static property COMPRESSED_RGBA_ASTC_5x5_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B2);
    public static property COMPRESSED_RGBA_ASTC_6x5:                      SizedInternalFormat read new SizedInternalFormat($93B3);
    public static property COMPRESSED_RGBA_ASTC_6x5_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B3);
    public static property COMPRESSED_RGBA_ASTC_6x6:                      SizedInternalFormat read new SizedInternalFormat($93B4);
    public static property COMPRESSED_RGBA_ASTC_6x6_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B4);
    public static property COMPRESSED_RGBA_ASTC_8x5:                      SizedInternalFormat read new SizedInternalFormat($93B5);
    public static property COMPRESSED_RGBA_ASTC_8x5_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B5);
    public static property COMPRESSED_RGBA_ASTC_8x6:                      SizedInternalFormat read new SizedInternalFormat($93B6);
    public static property COMPRESSED_RGBA_ASTC_8x6_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B6);
    public static property COMPRESSED_RGBA_ASTC_8x8:                      SizedInternalFormat read new SizedInternalFormat($93B7);
    public static property COMPRESSED_RGBA_ASTC_8x8_KHR:                  SizedInternalFormat read new SizedInternalFormat($93B7);
    public static property COMPRESSED_RGBA_ASTC_10x5:                     SizedInternalFormat read new SizedInternalFormat($93B8);
    public static property COMPRESSED_RGBA_ASTC_10x5_KHR:                 SizedInternalFormat read new SizedInternalFormat($93B8);
    public static property COMPRESSED_RGBA_ASTC_10x6:                     SizedInternalFormat read new SizedInternalFormat($93B9);
    public static property COMPRESSED_RGBA_ASTC_10x6_KHR:                 SizedInternalFormat read new SizedInternalFormat($93B9);
    public static property COMPRESSED_RGBA_ASTC_10x8:                     SizedInternalFormat read new SizedInternalFormat($93BA);
    public static property COMPRESSED_RGBA_ASTC_10x8_KHR:                 SizedInternalFormat read new SizedInternalFormat($93BA);
    public static property COMPRESSED_RGBA_ASTC_10x10:                    SizedInternalFormat read new SizedInternalFormat($93BB);
    public static property COMPRESSED_RGBA_ASTC_10x10_KHR:                SizedInternalFormat read new SizedInternalFormat($93BB);
    public static property COMPRESSED_RGBA_ASTC_12x10:                    SizedInternalFormat read new SizedInternalFormat($93BC);
    public static property COMPRESSED_RGBA_ASTC_12x10_KHR:                SizedInternalFormat read new SizedInternalFormat($93BC);
    public static property COMPRESSED_RGBA_ASTC_12x12:                    SizedInternalFormat read new SizedInternalFormat($93BD);
    public static property COMPRESSED_RGBA_ASTC_12x12_KHR:                SizedInternalFormat read new SizedInternalFormat($93BD);
    public static property COMPRESSED_RGBA_ASTC_3x3x3_OES:                SizedInternalFormat read new SizedInternalFormat($93C0);
    public static property COMPRESSED_RGBA_ASTC_4x3x3_OES:                SizedInternalFormat read new SizedInternalFormat($93C1);
    public static property COMPRESSED_RGBA_ASTC_4x4x3_OES:                SizedInternalFormat read new SizedInternalFormat($93C2);
    public static property COMPRESSED_RGBA_ASTC_4x4x4_OES:                SizedInternalFormat read new SizedInternalFormat($93C3);
    public static property COMPRESSED_RGBA_ASTC_5x4x4_OES:                SizedInternalFormat read new SizedInternalFormat($93C4);
    public static property COMPRESSED_RGBA_ASTC_5x5x4_OES:                SizedInternalFormat read new SizedInternalFormat($93C5);
    public static property COMPRESSED_RGBA_ASTC_5x5x5_OES:                SizedInternalFormat read new SizedInternalFormat($93C6);
    public static property COMPRESSED_RGBA_ASTC_6x5x5_OES:                SizedInternalFormat read new SizedInternalFormat($93C7);
    public static property COMPRESSED_RGBA_ASTC_6x6x5_OES:                SizedInternalFormat read new SizedInternalFormat($93C8);
    public static property COMPRESSED_RGBA_ASTC_6x6x6_OES:                SizedInternalFormat read new SizedInternalFormat($93C9);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4:              SizedInternalFormat read new SizedInternalFormat($93D0);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR:          SizedInternalFormat read new SizedInternalFormat($93D0);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4:              SizedInternalFormat read new SizedInternalFormat($93D1);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR:          SizedInternalFormat read new SizedInternalFormat($93D1);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5:              SizedInternalFormat read new SizedInternalFormat($93D2);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR:          SizedInternalFormat read new SizedInternalFormat($93D2);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5:              SizedInternalFormat read new SizedInternalFormat($93D3);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR:          SizedInternalFormat read new SizedInternalFormat($93D3);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6:              SizedInternalFormat read new SizedInternalFormat($93D4);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR:          SizedInternalFormat read new SizedInternalFormat($93D4);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x5:              SizedInternalFormat read new SizedInternalFormat($93D5);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR:          SizedInternalFormat read new SizedInternalFormat($93D5);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x6:              SizedInternalFormat read new SizedInternalFormat($93D6);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR:          SizedInternalFormat read new SizedInternalFormat($93D6);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x8:              SizedInternalFormat read new SizedInternalFormat($93D7);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR:          SizedInternalFormat read new SizedInternalFormat($93D7);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x5:             SizedInternalFormat read new SizedInternalFormat($93D8);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR:         SizedInternalFormat read new SizedInternalFormat($93D8);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x6:             SizedInternalFormat read new SizedInternalFormat($93D9);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR:         SizedInternalFormat read new SizedInternalFormat($93D9);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x8:             SizedInternalFormat read new SizedInternalFormat($93DA);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR:         SizedInternalFormat read new SizedInternalFormat($93DA);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x10:            SizedInternalFormat read new SizedInternalFormat($93DB);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR:        SizedInternalFormat read new SizedInternalFormat($93DB);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x10:            SizedInternalFormat read new SizedInternalFormat($93DC);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR:        SizedInternalFormat read new SizedInternalFormat($93DC);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x12:            SizedInternalFormat read new SizedInternalFormat($93DD);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR:        SizedInternalFormat read new SizedInternalFormat($93DD);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES:        SizedInternalFormat read new SizedInternalFormat($93E0);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES:        SizedInternalFormat read new SizedInternalFormat($93E1);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES:        SizedInternalFormat read new SizedInternalFormat($93E2);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES:        SizedInternalFormat read new SizedInternalFormat($93E3);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES:        SizedInternalFormat read new SizedInternalFormat($93E4);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES:        SizedInternalFormat read new SizedInternalFormat($93E5);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES:        SizedInternalFormat read new SizedInternalFormat($93E6);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES:        SizedInternalFormat read new SizedInternalFormat($93E7);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES:        SizedInternalFormat read new SizedInternalFormat($93E8);
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES:        SizedInternalFormat read new SizedInternalFormat($93E9);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2A10) then Result := 'R3_G3_B2' else
      if self.val = UInt32($803B) then Result := 'ALPHA4' else
      if self.val = UInt32($803B) then Result := 'ALPHA4_EXT' else
      if self.val = UInt32($803C) then Result := 'ALPHA8' else
      if self.val = UInt32($803C) then Result := 'ALPHA8_EXT' else
      if self.val = UInt32($803C) then Result := 'ALPHA8_OES' else
      if self.val = UInt32($803D) then Result := 'ALPHA12' else
      if self.val = UInt32($803D) then Result := 'ALPHA12_EXT' else
      if self.val = UInt32($803E) then Result := 'ALPHA16' else
      if self.val = UInt32($803E) then Result := 'ALPHA16_EXT' else
      if self.val = UInt32($803F) then Result := 'LUMINANCE4' else
      if self.val = UInt32($803F) then Result := 'LUMINANCE4_EXT' else
      if self.val = UInt32($8040) then Result := 'LUMINANCE8' else
      if self.val = UInt32($8040) then Result := 'LUMINANCE8_EXT' else
      if self.val = UInt32($8040) then Result := 'LUMINANCE8_OES' else
      if self.val = UInt32($8041) then Result := 'LUMINANCE12' else
      if self.val = UInt32($8041) then Result := 'LUMINANCE12_EXT' else
      if self.val = UInt32($8042) then Result := 'LUMINANCE16' else
      if self.val = UInt32($8042) then Result := 'LUMINANCE16_EXT' else
      if self.val = UInt32($8043) then Result := 'LUMINANCE4_ALPHA4' else
      if self.val = UInt32($8043) then Result := 'LUMINANCE4_ALPHA4_EXT' else
      if self.val = UInt32($8043) then Result := 'LUMINANCE4_ALPHA4_OES' else
      if self.val = UInt32($8044) then Result := 'LUMINANCE6_ALPHA2' else
      if self.val = UInt32($8044) then Result := 'LUMINANCE6_ALPHA2_EXT' else
      if self.val = UInt32($8045) then Result := 'LUMINANCE8_ALPHA8' else
      if self.val = UInt32($8045) then Result := 'LUMINANCE8_ALPHA8_EXT' else
      if self.val = UInt32($8045) then Result := 'LUMINANCE8_ALPHA8_OES' else
      if self.val = UInt32($8046) then Result := 'LUMINANCE12_ALPHA4' else
      if self.val = UInt32($8046) then Result := 'LUMINANCE12_ALPHA4_EXT' else
      if self.val = UInt32($8047) then Result := 'LUMINANCE12_ALPHA12' else
      if self.val = UInt32($8047) then Result := 'LUMINANCE12_ALPHA12_EXT' else
      if self.val = UInt32($8048) then Result := 'LUMINANCE16_ALPHA16' else
      if self.val = UInt32($8048) then Result := 'LUMINANCE16_ALPHA16_EXT' else
      if self.val = UInt32($804A) then Result := 'INTENSITY4' else
      if self.val = UInt32($804A) then Result := 'INTENSITY4_EXT' else
      if self.val = UInt32($804B) then Result := 'INTENSITY8' else
      if self.val = UInt32($804B) then Result := 'INTENSITY8_EXT' else
      if self.val = UInt32($804C) then Result := 'INTENSITY12' else
      if self.val = UInt32($804C) then Result := 'INTENSITY12_EXT' else
      if self.val = UInt32($804D) then Result := 'INTENSITY16' else
      if self.val = UInt32($804D) then Result := 'INTENSITY16_EXT' else
      if self.val = UInt32($804E) then Result := 'RGB2_EXT' else
      if self.val = UInt32($804F) then Result := 'RGB4' else
      if self.val = UInt32($804F) then Result := 'RGB4_EXT' else
      if self.val = UInt32($8050) then Result := 'RGB5' else
      if self.val = UInt32($8050) then Result := 'RGB5_EXT' else
      if self.val = UInt32($8051) then Result := 'RGB8' else
      if self.val = UInt32($8051) then Result := 'RGB8_EXT' else
      if self.val = UInt32($8051) then Result := 'RGB8_OES' else
      if self.val = UInt32($8052) then Result := 'RGB10' else
      if self.val = UInt32($8052) then Result := 'RGB10_EXT' else
      if self.val = UInt32($8053) then Result := 'RGB12' else
      if self.val = UInt32($8053) then Result := 'RGB12_EXT' else
      if self.val = UInt32($8054) then Result := 'RGB16' else
      if self.val = UInt32($8054) then Result := 'RGB16_EXT' else
      if self.val = UInt32($8055) then Result := 'RGBA2' else
      if self.val = UInt32($8055) then Result := 'RGBA2_EXT' else
      if self.val = UInt32($8056) then Result := 'RGBA4' else
      if self.val = UInt32($8056) then Result := 'RGBA4_EXT' else
      if self.val = UInt32($8056) then Result := 'RGBA4_OES' else
      if self.val = UInt32($8057) then Result := 'RGB5_A1' else
      if self.val = UInt32($8057) then Result := 'RGB5_A1_EXT' else
      if self.val = UInt32($8057) then Result := 'RGB5_A1_OES' else
      if self.val = UInt32($8058) then Result := 'RGBA8' else
      if self.val = UInt32($8058) then Result := 'RGBA8_EXT' else
      if self.val = UInt32($8058) then Result := 'RGBA8_OES' else
      if self.val = UInt32($8059) then Result := 'RGB10_A2' else
      if self.val = UInt32($8059) then Result := 'RGB10_A2_EXT' else
      if self.val = UInt32($805A) then Result := 'RGBA12' else
      if self.val = UInt32($805A) then Result := 'RGBA12_EXT' else
      if self.val = UInt32($805B) then Result := 'RGBA16' else
      if self.val = UInt32($805B) then Result := 'RGBA16_EXT' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16_ARB' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16_OES' else
      if self.val = UInt32($81A5) then Result := 'DEPTH_COMPONENT16_SGIX' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24_ARB' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24_OES' else
      if self.val = UInt32($81A6) then Result := 'DEPTH_COMPONENT24_SGIX' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32_ARB' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32_OES' else
      if self.val = UInt32($81A7) then Result := 'DEPTH_COMPONENT32_SGIX' else
      if self.val = UInt32($8229) then Result := 'R8' else
      if self.val = UInt32($8229) then Result := 'R8_EXT' else
      if self.val = UInt32($822A) then Result := 'R16' else
      if self.val = UInt32($822A) then Result := 'R16_EXT' else
      if self.val = UInt32($822B) then Result := 'RG8' else
      if self.val = UInt32($822B) then Result := 'RG8_EXT' else
      if self.val = UInt32($822C) then Result := 'RG16' else
      if self.val = UInt32($822C) then Result := 'RG16_EXT' else
      if self.val = UInt32($822D) then Result := 'R16F' else
      if self.val = UInt32($822D) then Result := 'R16F_EXT' else
      if self.val = UInt32($822E) then Result := 'R32F' else
      if self.val = UInt32($822E) then Result := 'R32F_EXT' else
      if self.val = UInt32($822F) then Result := 'RG16F' else
      if self.val = UInt32($822F) then Result := 'RG16F_EXT' else
      if self.val = UInt32($8230) then Result := 'RG32F' else
      if self.val = UInt32($8230) then Result := 'RG32F_EXT' else
      if self.val = UInt32($8231) then Result := 'R8I' else
      if self.val = UInt32($8232) then Result := 'R8UI' else
      if self.val = UInt32($8233) then Result := 'R16I' else
      if self.val = UInt32($8234) then Result := 'R16UI' else
      if self.val = UInt32($8235) then Result := 'R32I' else
      if self.val = UInt32($8236) then Result := 'R32UI' else
      if self.val = UInt32($8237) then Result := 'RG8I' else
      if self.val = UInt32($8238) then Result := 'RG8UI' else
      if self.val = UInt32($8239) then Result := 'RG16I' else
      if self.val = UInt32($823A) then Result := 'RG16UI' else
      if self.val = UInt32($823B) then Result := 'RG32I' else
      if self.val = UInt32($823C) then Result := 'RG32UI' else
      if self.val = UInt32($83F0) then Result := 'COMPRESSED_RGB_S3TC_DXT1_EXT' else
      if self.val = UInt32($83F1) then Result := 'COMPRESSED_RGBA_S3TC_DXT1_EXT' else
      if self.val = UInt32($83F2) then Result := 'COMPRESSED_RGBA_S3TC_DXT3_ANGLE' else
      if self.val = UInt32($83F2) then Result := 'COMPRESSED_RGBA_S3TC_DXT3_EXT' else
      if self.val = UInt32($83F3) then Result := 'COMPRESSED_RGBA_S3TC_DXT5_ANGLE' else
      if self.val = UInt32($83F3) then Result := 'COMPRESSED_RGBA_S3TC_DXT5_EXT' else
      if self.val = UInt32($8814) then Result := 'RGBA32F' else
      if self.val = UInt32($8814) then Result := 'RGBA32F_ARB' else
      if self.val = UInt32($8814) then Result := 'RGBA32F_EXT' else
      if self.val = UInt32($8815) then Result := 'RGB32F' else
      if self.val = UInt32($8815) then Result := 'RGB32F_ARB' else
      if self.val = UInt32($8815) then Result := 'RGB32F_EXT' else
      if self.val = UInt32($881A) then Result := 'RGBA16F' else
      if self.val = UInt32($881A) then Result := 'RGBA16F_ARB' else
      if self.val = UInt32($881A) then Result := 'RGBA16F_EXT' else
      if self.val = UInt32($881B) then Result := 'RGB16F' else
      if self.val = UInt32($881B) then Result := 'RGB16F_ARB' else
      if self.val = UInt32($881B) then Result := 'RGB16F_EXT' else
      if self.val = UInt32($88F0) then Result := 'DEPTH24_STENCIL8' else
      if self.val = UInt32($88F0) then Result := 'DEPTH24_STENCIL8_EXT' else
      if self.val = UInt32($88F0) then Result := 'DEPTH24_STENCIL8_OES' else
      if self.val = UInt32($8C3A) then Result := 'R11F_G11F_B10F' else
      if self.val = UInt32($8C3A) then Result := 'R11F_G11F_B10F_APPLE' else
      if self.val = UInt32($8C3A) then Result := 'R11F_G11F_B10F_EXT' else
      if self.val = UInt32($8C3D) then Result := 'RGB9_E5' else
      if self.val = UInt32($8C3D) then Result := 'RGB9_E5_APPLE' else
      if self.val = UInt32($8C3D) then Result := 'RGB9_E5_EXT' else
      if self.val = UInt32($8C41) then Result := 'SRGB8' else
      if self.val = UInt32($8C41) then Result := 'SRGB8_EXT' else
      if self.val = UInt32($8C41) then Result := 'SRGB8_NV' else
      if self.val = UInt32($8C43) then Result := 'SRGB8_ALPHA8' else
      if self.val = UInt32($8C43) then Result := 'SRGB8_ALPHA8_EXT' else
      if self.val = UInt32($8C4C) then Result := 'COMPRESSED_SRGB_S3TC_DXT1_EXT' else
      if self.val = UInt32($8C4C) then Result := 'COMPRESSED_SRGB_S3TC_DXT1_NV' else
      if self.val = UInt32($8C4D) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT' else
      if self.val = UInt32($8C4D) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV' else
      if self.val = UInt32($8C4E) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT' else
      if self.val = UInt32($8C4E) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV' else
      if self.val = UInt32($8C4F) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT' else
      if self.val = UInt32($8C4F) then Result := 'COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV' else
      if self.val = UInt32($8CAC) then Result := 'DEPTH_COMPONENT32F' else
      if self.val = UInt32($8CAD) then Result := 'DEPTH32F_STENCIL8' else
      if self.val = UInt32($8D46) then Result := 'STENCIL_INDEX1' else
      if self.val = UInt32($8D46) then Result := 'STENCIL_INDEX1_EXT' else
      if self.val = UInt32($8D46) then Result := 'STENCIL_INDEX1_OES' else
      if self.val = UInt32($8D47) then Result := 'STENCIL_INDEX4' else
      if self.val = UInt32($8D47) then Result := 'STENCIL_INDEX4_EXT' else
      if self.val = UInt32($8D47) then Result := 'STENCIL_INDEX4_OES' else
      if self.val = UInt32($8D48) then Result := 'STENCIL_INDEX8' else
      if self.val = UInt32($8D48) then Result := 'STENCIL_INDEX8_EXT' else
      if self.val = UInt32($8D48) then Result := 'STENCIL_INDEX8_OES' else
      if self.val = UInt32($8D49) then Result := 'STENCIL_INDEX16' else
      if self.val = UInt32($8D49) then Result := 'STENCIL_INDEX16_EXT' else
      if self.val = UInt32($8D62) then Result := 'RGB565' else
      if self.val = UInt32($8D62) then Result := 'RGB565_OES' else
      if self.val = UInt32($8D64) then Result := 'ETC1_RGB8_OES' else
      if self.val = UInt32($8D70) then Result := 'RGBA32UI' else
      if self.val = UInt32($8D70) then Result := 'RGBA32UI_EXT' else
      if self.val = UInt32($8D71) then Result := 'RGB32UI' else
      if self.val = UInt32($8D71) then Result := 'RGB32UI_EXT' else
      if self.val = UInt32($8D72) then Result := 'ALPHA32UI_EXT' else
      if self.val = UInt32($8D73) then Result := 'INTENSITY32UI_EXT' else
      if self.val = UInt32($8D74) then Result := 'LUMINANCE32UI_EXT' else
      if self.val = UInt32($8D75) then Result := 'LUMINANCE_ALPHA32UI_EXT' else
      if self.val = UInt32($8D76) then Result := 'RGBA16UI' else
      if self.val = UInt32($8D76) then Result := 'RGBA16UI_EXT' else
      if self.val = UInt32($8D77) then Result := 'RGB16UI' else
      if self.val = UInt32($8D77) then Result := 'RGB16UI_EXT' else
      if self.val = UInt32($8D78) then Result := 'ALPHA16UI_EXT' else
      if self.val = UInt32($8D79) then Result := 'INTENSITY16UI_EXT' else
      if self.val = UInt32($8D7A) then Result := 'LUMINANCE16UI_EXT' else
      if self.val = UInt32($8D7B) then Result := 'LUMINANCE_ALPHA16UI_EXT' else
      if self.val = UInt32($8D7C) then Result := 'RGBA8UI' else
      if self.val = UInt32($8D7C) then Result := 'RGBA8UI_EXT' else
      if self.val = UInt32($8D7D) then Result := 'RGB8UI' else
      if self.val = UInt32($8D7D) then Result := 'RGB8UI_EXT' else
      if self.val = UInt32($8D7E) then Result := 'ALPHA8UI_EXT' else
      if self.val = UInt32($8D7F) then Result := 'INTENSITY8UI_EXT' else
      if self.val = UInt32($8D80) then Result := 'LUMINANCE8UI_EXT' else
      if self.val = UInt32($8D81) then Result := 'LUMINANCE_ALPHA8UI_EXT' else
      if self.val = UInt32($8D82) then Result := 'RGBA32I' else
      if self.val = UInt32($8D82) then Result := 'RGBA32I_EXT' else
      if self.val = UInt32($8D83) then Result := 'RGB32I' else
      if self.val = UInt32($8D83) then Result := 'RGB32I_EXT' else
      if self.val = UInt32($8D84) then Result := 'ALPHA32I_EXT' else
      if self.val = UInt32($8D85) then Result := 'INTENSITY32I_EXT' else
      if self.val = UInt32($8D86) then Result := 'LUMINANCE32I_EXT' else
      if self.val = UInt32($8D87) then Result := 'LUMINANCE_ALPHA32I_EXT' else
      if self.val = UInt32($8D88) then Result := 'RGBA16I' else
      if self.val = UInt32($8D88) then Result := 'RGBA16I_EXT' else
      if self.val = UInt32($8D89) then Result := 'RGB16I' else
      if self.val = UInt32($8D89) then Result := 'RGB16I_EXT' else
      if self.val = UInt32($8D8A) then Result := 'ALPHA16I_EXT' else
      if self.val = UInt32($8D8B) then Result := 'INTENSITY16I_EXT' else
      if self.val = UInt32($8D8C) then Result := 'LUMINANCE16I_EXT' else
      if self.val = UInt32($8D8D) then Result := 'LUMINANCE_ALPHA16I_EXT' else
      if self.val = UInt32($8D8E) then Result := 'RGBA8I' else
      if self.val = UInt32($8D8E) then Result := 'RGBA8I_EXT' else
      if self.val = UInt32($8D8F) then Result := 'RGB8I' else
      if self.val = UInt32($8D8F) then Result := 'RGB8I_EXT' else
      if self.val = UInt32($8D90) then Result := 'ALPHA8I_EXT' else
      if self.val = UInt32($8D91) then Result := 'INTENSITY8I_EXT' else
      if self.val = UInt32($8D92) then Result := 'LUMINANCE8I_EXT' else
      if self.val = UInt32($8D93) then Result := 'LUMINANCE_ALPHA8I_EXT' else
      if self.val = UInt32($8DAB) then Result := 'DEPTH_COMPONENT32F_NV' else
      if self.val = UInt32($8DAC) then Result := 'DEPTH32F_STENCIL8_NV' else
      if self.val = UInt32($8DBB) then Result := 'COMPRESSED_RED_RGTC1' else
      if self.val = UInt32($8DBB) then Result := 'COMPRESSED_RED_RGTC1_EXT' else
      if self.val = UInt32($8DBC) then Result := 'COMPRESSED_SIGNED_RED_RGTC1' else
      if self.val = UInt32($8DBC) then Result := 'COMPRESSED_SIGNED_RED_RGTC1_EXT' else
      if self.val = UInt32($8DBD) then Result := 'COMPRESSED_RED_GREEN_RGTC2_EXT' else
      if self.val = UInt32($8DBD) then Result := 'COMPRESSED_RG_RGTC2' else
      if self.val = UInt32($8DBE) then Result := 'COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT' else
      if self.val = UInt32($8DBE) then Result := 'COMPRESSED_SIGNED_RG_RGTC2' else
      if self.val = UInt32($8E8C) then Result := 'COMPRESSED_RGBA_BPTC_UNORM' else
      if self.val = UInt32($8E8C) then Result := 'COMPRESSED_RGBA_BPTC_UNORM_ARB' else
      if self.val = UInt32($8E8C) then Result := 'COMPRESSED_RGBA_BPTC_UNORM_EXT' else
      if self.val = UInt32($8E8D) then Result := 'COMPRESSED_SRGB_ALPHA_BPTC_UNORM' else
      if self.val = UInt32($8E8D) then Result := 'COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB' else
      if self.val = UInt32($8E8D) then Result := 'COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT' else
      if self.val = UInt32($8E8E) then Result := 'COMPRESSED_RGB_BPTC_SIGNED_FLOAT' else
      if self.val = UInt32($8E8E) then Result := 'COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB' else
      if self.val = UInt32($8E8E) then Result := 'COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT' else
      if self.val = UInt32($8E8F) then Result := 'COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT' else
      if self.val = UInt32($8E8F) then Result := 'COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB' else
      if self.val = UInt32($8E8F) then Result := 'COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT' else
      if self.val = UInt32($8F94) then Result := 'R8_SNORM' else
      if self.val = UInt32($8F95) then Result := 'RG8_SNORM' else
      if self.val = UInt32($8F96) then Result := 'RGB8_SNORM' else
      if self.val = UInt32($8F97) then Result := 'RGBA8_SNORM' else
      if self.val = UInt32($8F98) then Result := 'R16_SNORM' else
      if self.val = UInt32($8F98) then Result := 'R16_SNORM_EXT' else
      if self.val = UInt32($8F99) then Result := 'RG16_SNORM' else
      if self.val = UInt32($8F99) then Result := 'RG16_SNORM_EXT' else
      if self.val = UInt32($8F9A) then Result := 'RGB16_SNORM' else
      if self.val = UInt32($8F9A) then Result := 'RGB16_SNORM_EXT' else
      if self.val = UInt32($8F9B) then Result := 'RGBA16_SNORM' else
      if self.val = UInt32($8F9B) then Result := 'RGBA16_SNORM_EXT' else
      if self.val = UInt32($906F) then Result := 'RGB10_A2UI' else
      if self.val = UInt32($9270) then Result := 'COMPRESSED_R11_EAC' else
      if self.val = UInt32($9270) then Result := 'COMPRESSED_R11_EAC_OES' else
      if self.val = UInt32($9271) then Result := 'COMPRESSED_SIGNED_R11_EAC' else
      if self.val = UInt32($9271) then Result := 'COMPRESSED_SIGNED_R11_EAC_OES' else
      if self.val = UInt32($9272) then Result := 'COMPRESSED_RG11_EAC' else
      if self.val = UInt32($9272) then Result := 'COMPRESSED_RG11_EAC_OES' else
      if self.val = UInt32($9273) then Result := 'COMPRESSED_SIGNED_RG11_EAC' else
      if self.val = UInt32($9273) then Result := 'COMPRESSED_SIGNED_RG11_EAC_OES' else
      if self.val = UInt32($9274) then Result := 'COMPRESSED_RGB8_ETC2' else
      if self.val = UInt32($9274) then Result := 'COMPRESSED_RGB8_ETC2_OES' else
      if self.val = UInt32($9275) then Result := 'COMPRESSED_SRGB8_ETC2' else
      if self.val = UInt32($9275) then Result := 'COMPRESSED_SRGB8_ETC2_OES' else
      if self.val = UInt32($9276) then Result := 'COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2' else
      if self.val = UInt32($9276) then Result := 'COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES' else
      if self.val = UInt32($9277) then Result := 'COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2' else
      if self.val = UInt32($9277) then Result := 'COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2_OES' else
      if self.val = UInt32($9278) then Result := 'COMPRESSED_RGBA8_ETC2_EAC' else
      if self.val = UInt32($9278) then Result := 'COMPRESSED_RGBA8_ETC2_EAC_OES' else
      if self.val = UInt32($9279) then Result := 'COMPRESSED_SRGB8_ALPHA8_ETC2_EAC' else
      if self.val = UInt32($9279) then Result := 'COMPRESSED_SRGB8_ALPHA8_ETC2_EAC_OES' else
      if self.val = UInt32($93B0) then Result := 'COMPRESSED_RGBA_ASTC_4x4' else
      if self.val = UInt32($93B0) then Result := 'COMPRESSED_RGBA_ASTC_4x4_KHR' else
      if self.val = UInt32($93B1) then Result := 'COMPRESSED_RGBA_ASTC_5x4' else
      if self.val = UInt32($93B1) then Result := 'COMPRESSED_RGBA_ASTC_5x4_KHR' else
      if self.val = UInt32($93B2) then Result := 'COMPRESSED_RGBA_ASTC_5x5' else
      if self.val = UInt32($93B2) then Result := 'COMPRESSED_RGBA_ASTC_5x5_KHR' else
      if self.val = UInt32($93B3) then Result := 'COMPRESSED_RGBA_ASTC_6x5' else
      if self.val = UInt32($93B3) then Result := 'COMPRESSED_RGBA_ASTC_6x5_KHR' else
      if self.val = UInt32($93B4) then Result := 'COMPRESSED_RGBA_ASTC_6x6' else
      if self.val = UInt32($93B4) then Result := 'COMPRESSED_RGBA_ASTC_6x6_KHR' else
      if self.val = UInt32($93B5) then Result := 'COMPRESSED_RGBA_ASTC_8x5' else
      if self.val = UInt32($93B5) then Result := 'COMPRESSED_RGBA_ASTC_8x5_KHR' else
      if self.val = UInt32($93B6) then Result := 'COMPRESSED_RGBA_ASTC_8x6' else
      if self.val = UInt32($93B6) then Result := 'COMPRESSED_RGBA_ASTC_8x6_KHR' else
      if self.val = UInt32($93B7) then Result := 'COMPRESSED_RGBA_ASTC_8x8' else
      if self.val = UInt32($93B7) then Result := 'COMPRESSED_RGBA_ASTC_8x8_KHR' else
      if self.val = UInt32($93B8) then Result := 'COMPRESSED_RGBA_ASTC_10x5' else
      if self.val = UInt32($93B8) then Result := 'COMPRESSED_RGBA_ASTC_10x5_KHR' else
      if self.val = UInt32($93B9) then Result := 'COMPRESSED_RGBA_ASTC_10x6' else
      if self.val = UInt32($93B9) then Result := 'COMPRESSED_RGBA_ASTC_10x6_KHR' else
      if self.val = UInt32($93BA) then Result := 'COMPRESSED_RGBA_ASTC_10x8' else
      if self.val = UInt32($93BA) then Result := 'COMPRESSED_RGBA_ASTC_10x8_KHR' else
      if self.val = UInt32($93BB) then Result := 'COMPRESSED_RGBA_ASTC_10x10' else
      if self.val = UInt32($93BB) then Result := 'COMPRESSED_RGBA_ASTC_10x10_KHR' else
      if self.val = UInt32($93BC) then Result := 'COMPRESSED_RGBA_ASTC_12x10' else
      if self.val = UInt32($93BC) then Result := 'COMPRESSED_RGBA_ASTC_12x10_KHR' else
      if self.val = UInt32($93BD) then Result := 'COMPRESSED_RGBA_ASTC_12x12' else
      if self.val = UInt32($93BD) then Result := 'COMPRESSED_RGBA_ASTC_12x12_KHR' else
      if self.val = UInt32($93C0) then Result := 'COMPRESSED_RGBA_ASTC_3x3x3_OES' else
      if self.val = UInt32($93C1) then Result := 'COMPRESSED_RGBA_ASTC_4x3x3_OES' else
      if self.val = UInt32($93C2) then Result := 'COMPRESSED_RGBA_ASTC_4x4x3_OES' else
      if self.val = UInt32($93C3) then Result := 'COMPRESSED_RGBA_ASTC_4x4x4_OES' else
      if self.val = UInt32($93C4) then Result := 'COMPRESSED_RGBA_ASTC_5x4x4_OES' else
      if self.val = UInt32($93C5) then Result := 'COMPRESSED_RGBA_ASTC_5x5x4_OES' else
      if self.val = UInt32($93C6) then Result := 'COMPRESSED_RGBA_ASTC_5x5x5_OES' else
      if self.val = UInt32($93C7) then Result := 'COMPRESSED_RGBA_ASTC_6x5x5_OES' else
      if self.val = UInt32($93C8) then Result := 'COMPRESSED_RGBA_ASTC_6x6x5_OES' else
      if self.val = UInt32($93C9) then Result := 'COMPRESSED_RGBA_ASTC_6x6x6_OES' else
      if self.val = UInt32($93D0) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4' else
      if self.val = UInt32($93D0) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR' else
      if self.val = UInt32($93D1) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x4' else
      if self.val = UInt32($93D1) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR' else
      if self.val = UInt32($93D2) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5' else
      if self.val = UInt32($93D2) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR' else
      if self.val = UInt32($93D3) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x5' else
      if self.val = UInt32($93D3) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR' else
      if self.val = UInt32($93D4) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6' else
      if self.val = UInt32($93D4) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR' else
      if self.val = UInt32($93D5) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x5' else
      if self.val = UInt32($93D5) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR' else
      if self.val = UInt32($93D6) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x6' else
      if self.val = UInt32($93D6) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR' else
      if self.val = UInt32($93D7) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x8' else
      if self.val = UInt32($93D7) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR' else
      if self.val = UInt32($93D8) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x5' else
      if self.val = UInt32($93D8) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR' else
      if self.val = UInt32($93D9) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x6' else
      if self.val = UInt32($93D9) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR' else
      if self.val = UInt32($93DA) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x8' else
      if self.val = UInt32($93DA) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR' else
      if self.val = UInt32($93DB) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x10' else
      if self.val = UInt32($93DB) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR' else
      if self.val = UInt32($93DC) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x10' else
      if self.val = UInt32($93DC) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR' else
      if self.val = UInt32($93DD) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x12' else
      if self.val = UInt32($93DD) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR' else
      if self.val = UInt32($93E0) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES' else
      if self.val = UInt32($93E1) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES' else
      if self.val = UInt32($93E2) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES' else
      if self.val = UInt32($93E3) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES' else
      if self.val = UInt32($93E4) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES' else
      if self.val = UInt32($93E5) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES' else
      if self.val = UInt32($93E6) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES' else
      if self.val = UInt32($93E7) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES' else
      if self.val = UInt32($93E8) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES' else
      if self.val = UInt32($93E9) then Result := 'COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES' else
        Result := $'SizedInternalFormat[{self.val}]';
    end;
    
  end;
  
  StencilFaceDirection = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRONT:          StencilFaceDirection read new StencilFaceDirection($0404);
    public static property BACK:           StencilFaceDirection read new StencilFaceDirection($0405);
    public static property FRONT_AND_BACK: StencilFaceDirection read new StencilFaceDirection($0408);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0404) then Result := 'FRONT' else
      if self.val = UInt32($0405) then Result := 'BACK' else
      if self.val = UInt32($0408) then Result := 'FRONT_AND_BACK' else
        Result := $'StencilFaceDirection[{self.val}]';
    end;
    
  end;
  
  StencilFunction = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NEVER:    StencilFunction read new StencilFunction($0200);
    public static property LESS:     StencilFunction read new StencilFunction($0201);
    public static property EQUAL:    StencilFunction read new StencilFunction($0202);
    public static property LEQUAL:   StencilFunction read new StencilFunction($0203);
    public static property GREATER:  StencilFunction read new StencilFunction($0204);
    public static property NOTEQUAL: StencilFunction read new StencilFunction($0205);
    public static property GEQUAL:   StencilFunction read new StencilFunction($0206);
    public static property ALWAYS:   StencilFunction read new StencilFunction($0207);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0200) then Result := 'NEVER' else
      if self.val = UInt32($0201) then Result := 'LESS' else
      if self.val = UInt32($0202) then Result := 'EQUAL' else
      if self.val = UInt32($0203) then Result := 'LEQUAL' else
      if self.val = UInt32($0204) then Result := 'GREATER' else
      if self.val = UInt32($0205) then Result := 'NOTEQUAL' else
      if self.val = UInt32($0206) then Result := 'GEQUAL' else
      if self.val = UInt32($0207) then Result := 'ALWAYS' else
        Result := $'StencilFunction[{self.val}]';
    end;
    
  end;
  
  StencilOp = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ZERO:      StencilOp read new StencilOp($0000);
    public static property INVERT:    StencilOp read new StencilOp($150A);
    public static property KEEP:      StencilOp read new StencilOp($1E00);
    public static property REPLACE:   StencilOp read new StencilOp($1E01);
    public static property INCR:      StencilOp read new StencilOp($1E02);
    public static property DECR:      StencilOp read new StencilOp($1E03);
    public static property INCR_WRAP: StencilOp read new StencilOp($8507);
    public static property DECR_WRAP: StencilOp read new StencilOp($8508);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'ZERO' else
      if self.val = UInt32($150A) then Result := 'INVERT' else
      if self.val = UInt32($1E00) then Result := 'KEEP' else
      if self.val = UInt32($1E01) then Result := 'REPLACE' else
      if self.val = UInt32($1E02) then Result := 'INCR' else
      if self.val = UInt32($1E03) then Result := 'DECR' else
      if self.val = UInt32($8507) then Result := 'INCR_WRAP' else
      if self.val = UInt32($8508) then Result := 'DECR_WRAP' else
        Result := $'StencilOp[{self.val}]';
    end;
    
  end;
  
  StringName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VENDOR:                   StringName read new StringName($1F00);
    public static property RENDERER:                 StringName read new StringName($1F01);
    public static property VERSION:                  StringName read new StringName($1F02);
    public static property EXTENSIONS:               StringName read new StringName($1F03);
    public static property SHADING_LANGUAGE_VERSION: StringName read new StringName($8B8C);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1F00) then Result := 'VENDOR' else
      if self.val = UInt32($1F01) then Result := 'RENDERER' else
      if self.val = UInt32($1F02) then Result := 'VERSION' else
      if self.val = UInt32($1F03) then Result := 'EXTENSIONS' else
      if self.val = UInt32($8B8C) then Result := 'SHADING_LANGUAGE_VERSION' else
        Result := $'StringName[{self.val}]';
    end;
    
  end;
  
  SubroutineParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNIFORM_SIZE:               SubroutineParameterName read new SubroutineParameterName($8A38);
    public static property UNIFORM_NAME_LENGTH:        SubroutineParameterName read new SubroutineParameterName($8A39);
    public static property NUM_COMPATIBLE_SUBROUTINES: SubroutineParameterName read new SubroutineParameterName($8E4A);
    public static property COMPATIBLE_SUBROUTINES:     SubroutineParameterName read new SubroutineParameterName($8E4B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8A38) then Result := 'UNIFORM_SIZE' else
      if self.val = UInt32($8A39) then Result := 'UNIFORM_NAME_LENGTH' else
      if self.val = UInt32($8E4A) then Result := 'NUM_COMPATIBLE_SUBROUTINES' else
      if self.val = UInt32($8E4B) then Result := 'COMPATIBLE_SUBROUTINES' else
        Result := $'SubroutineParameterName[{self.val}]';
    end;
    
  end;
  
  SyncCondition = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SYNC_GPU_COMMANDS_COMPLETE: SyncCondition read new SyncCondition($9117);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9117) then Result := 'SYNC_GPU_COMMANDS_COMPLETE' else
        Result := $'SyncCondition[{self.val}]';
    end;
    
  end;
  
  SyncObjectMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SYNC_FLUSH_COMMANDS_BIT:       SyncObjectMask read new SyncObjectMask($0001);
    public static property SYNC_FLUSH_COMMANDS_BIT_APPLE: SyncObjectMask read new SyncObjectMask($0001);
    
    public static function operator+(f1,f2: SyncObjectMask) := new SyncObjectMask(f1.val or f2.val);
    public static function operator or(f1,f2: SyncObjectMask) := f1+f2;
    
    public property HAS_FLAG_SYNC_FLUSH_COMMANDS_BIT:       boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_SYNC_FLUSH_COMMANDS_BIT_APPLE: boolean read self.val and $0001 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'SYNC_FLUSH_COMMANDS_BIT+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'SYNC_FLUSH_COMMANDS_BIT_APPLE+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'SyncObjectMask[{self.val}]';
    end;
    
  end;
  
  SyncParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property OBJECT_TYPE:    SyncParameterName read new SyncParameterName($9112);
    public static property SYNC_CONDITION: SyncParameterName read new SyncParameterName($9113);
    public static property SYNC_STATUS:    SyncParameterName read new SyncParameterName($9114);
    public static property SYNC_FLAGS:     SyncParameterName read new SyncParameterName($9115);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9112) then Result := 'OBJECT_TYPE' else
      if self.val = UInt32($9113) then Result := 'SYNC_CONDITION' else
      if self.val = UInt32($9114) then Result := 'SYNC_STATUS' else
      if self.val = UInt32($9115) then Result := 'SYNC_FLAGS' else
        Result := $'SyncParameterName[{self.val}]';
    end;
    
  end;
  
  SyncStatus = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ALREADY_SIGNALED:    SyncStatus read new SyncStatus($911A);
    public static property TIMEOUT_EXPIRED:     SyncStatus read new SyncStatus($911B);
    public static property CONDITION_SATISFIED: SyncStatus read new SyncStatus($911C);
    public static property WAIT_FAILED:         SyncStatus read new SyncStatus($911D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($911A) then Result := 'ALREADY_SIGNALED' else
      if self.val = UInt32($911B) then Result := 'TIMEOUT_EXPIRED' else
      if self.val = UInt32($911C) then Result := 'CONDITION_SATISFIED' else
      if self.val = UInt32($911D) then Result := 'WAIT_FAILED' else
        Result := $'SyncStatus[{self.val}]';
    end;
    
  end;
  
  TexCoordPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SHORT:  TexCoordPointerType read new TexCoordPointerType($1402);
    public static property INT:    TexCoordPointerType read new TexCoordPointerType($1404);
    public static property FLOAT:  TexCoordPointerType read new TexCoordPointerType($1406);
    public static property DOUBLE: TexCoordPointerType read new TexCoordPointerType($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'TexCoordPointerType[{self.val}]';
    end;
    
  end;
  
  TextureCoordName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property S: TextureCoordName read new TextureCoordName($2000);
    public static property T: TextureCoordName read new TextureCoordName($2001);
    public static property R: TextureCoordName read new TextureCoordName($2002);
    public static property Q: TextureCoordName read new TextureCoordName($2003);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2000) then Result := 'S' else
      if self.val = UInt32($2001) then Result := 'T' else
      if self.val = UInt32($2002) then Result := 'R' else
      if self.val = UInt32($2003) then Result := 'Q' else
        Result := $'TextureCoordName[{self.val}]';
    end;
    
  end;
  
  TextureEnvParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_ENV_MODE:  TextureEnvParameter read new TextureEnvParameter($2200);
    public static property TEXTURE_ENV_COLOR: TextureEnvParameter read new TextureEnvParameter($2201);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2200) then Result := 'TEXTURE_ENV_MODE' else
      if self.val = UInt32($2201) then Result := 'TEXTURE_ENV_COLOR' else
        Result := $'TextureEnvParameter[{self.val}]';
    end;
    
  end;
  
  TextureEnvTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_ENV: TextureEnvTarget read new TextureEnvTarget($2300);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2300) then Result := 'TEXTURE_ENV' else
        Result := $'TextureEnvTarget[{self.val}]';
    end;
    
  end;
  
  TextureGenParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_GEN_MODE:  TextureGenParameter read new TextureGenParameter($2500);
    public static property OBJECT_PLANE:      TextureGenParameter read new TextureGenParameter($2501);
    public static property EYE_PLANE:         TextureGenParameter read new TextureGenParameter($2502);
    public static property EYE_POINT_SGIS:    TextureGenParameter read new TextureGenParameter($81F4);
    public static property OBJECT_POINT_SGIS: TextureGenParameter read new TextureGenParameter($81F5);
    public static property EYE_LINE_SGIS:     TextureGenParameter read new TextureGenParameter($81F6);
    public static property OBJECT_LINE_SGIS:  TextureGenParameter read new TextureGenParameter($81F7);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($2500) then Result := 'TEXTURE_GEN_MODE' else
      if self.val = UInt32($2501) then Result := 'OBJECT_PLANE' else
      if self.val = UInt32($2502) then Result := 'EYE_PLANE' else
      if self.val = UInt32($81F4) then Result := 'EYE_POINT_SGIS' else
      if self.val = UInt32($81F5) then Result := 'OBJECT_POINT_SGIS' else
      if self.val = UInt32($81F6) then Result := 'EYE_LINE_SGIS' else
      if self.val = UInt32($81F7) then Result := 'OBJECT_LINE_SGIS' else
        Result := $'TextureGenParameter[{self.val}]';
    end;
    
  end;
  
  TextureLayout = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT: TextureLayout read new TextureLayout($9530);
    public static property LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT: TextureLayout read new TextureLayout($9531);
    public static property LAYOUT_GENERAL_EXT:                            TextureLayout read new TextureLayout($958D);
    public static property LAYOUT_COLOR_ATTACHMENT_EXT:                   TextureLayout read new TextureLayout($958E);
    public static property LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT:           TextureLayout read new TextureLayout($958F);
    public static property LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT:            TextureLayout read new TextureLayout($9590);
    public static property LAYOUT_SHADER_READ_ONLY_EXT:                   TextureLayout read new TextureLayout($9591);
    public static property LAYOUT_TRANSFER_SRC_EXT:                       TextureLayout read new TextureLayout($9592);
    public static property LAYOUT_TRANSFER_DST_EXT:                       TextureLayout read new TextureLayout($9593);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($9530) then Result := 'LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT' else
      if self.val = UInt32($9531) then Result := 'LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT' else
      if self.val = UInt32($958D) then Result := 'LAYOUT_GENERAL_EXT' else
      if self.val = UInt32($958E) then Result := 'LAYOUT_COLOR_ATTACHMENT_EXT' else
      if self.val = UInt32($958F) then Result := 'LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT' else
      if self.val = UInt32($9590) then Result := 'LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT' else
      if self.val = UInt32($9591) then Result := 'LAYOUT_SHADER_READ_ONLY_EXT' else
      if self.val = UInt32($9592) then Result := 'LAYOUT_TRANSFER_SRC_EXT' else
      if self.val = UInt32($9593) then Result := 'LAYOUT_TRANSFER_DST_EXT' else
        Result := $'TextureLayout[{self.val}]';
    end;
    
  end;
  
  TextureParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_WIDTH:                        TextureParameterName read new TextureParameterName($1000);
    public static property TEXTURE_HEIGHT:                       TextureParameterName read new TextureParameterName($1001);
    public static property TEXTURE_COMPONENTS:                   TextureParameterName read new TextureParameterName($1003);
    public static property TEXTURE_INTERNAL_FORMAT:              TextureParameterName read new TextureParameterName($1003);
    public static property TEXTURE_BORDER_COLOR:                 TextureParameterName read new TextureParameterName($1004);
    public static property TEXTURE_BORDER_COLOR_NV:              TextureParameterName read new TextureParameterName($1004);
    public static property TEXTURE_BORDER:                       TextureParameterName read new TextureParameterName($1005);
    public static property TEXTURE_MAG_FILTER:                   TextureParameterName read new TextureParameterName($2800);
    public static property TEXTURE_MIN_FILTER:                   TextureParameterName read new TextureParameterName($2801);
    public static property TEXTURE_WRAP_S:                       TextureParameterName read new TextureParameterName($2802);
    public static property TEXTURE_WRAP_T:                       TextureParameterName read new TextureParameterName($2803);
    public static property TEXTURE_RED_SIZE:                     TextureParameterName read new TextureParameterName($805C);
    public static property TEXTURE_GREEN_SIZE:                   TextureParameterName read new TextureParameterName($805D);
    public static property TEXTURE_BLUE_SIZE:                    TextureParameterName read new TextureParameterName($805E);
    public static property TEXTURE_ALPHA_SIZE:                   TextureParameterName read new TextureParameterName($805F);
    public static property TEXTURE_LUMINANCE_SIZE:               TextureParameterName read new TextureParameterName($8060);
    public static property TEXTURE_INTENSITY_SIZE:               TextureParameterName read new TextureParameterName($8061);
    public static property TEXTURE_PRIORITY:                     TextureParameterName read new TextureParameterName($8066);
    public static property TEXTURE_PRIORITY_EXT:                 TextureParameterName read new TextureParameterName($8066);
    public static property TEXTURE_RESIDENT:                     TextureParameterName read new TextureParameterName($8067);
    public static property TEXTURE_DEPTH_EXT:                    TextureParameterName read new TextureParameterName($8071);
    public static property TEXTURE_WRAP_R:                       TextureParameterName read new TextureParameterName($8072);
    public static property TEXTURE_WRAP_R_EXT:                   TextureParameterName read new TextureParameterName($8072);
    public static property TEXTURE_WRAP_R_OES:                   TextureParameterName read new TextureParameterName($8072);
    public static property DETAIL_TEXTURE_LEVEL_SGIS:            TextureParameterName read new TextureParameterName($809A);
    public static property DETAIL_TEXTURE_MODE_SGIS:             TextureParameterName read new TextureParameterName($809B);
    public static property DETAIL_TEXTURE_FUNC_POINTS_SGIS:      TextureParameterName read new TextureParameterName($809C);
    public static property SHARPEN_TEXTURE_FUNC_POINTS_SGIS:     TextureParameterName read new TextureParameterName($80B0);
    public static property SHADOW_AMBIENT_SGIX:                  TextureParameterName read new TextureParameterName($80BF);
    public static property DUAL_TEXTURE_SELECT_SGIS:             TextureParameterName read new TextureParameterName($8124);
    public static property QUAD_TEXTURE_SELECT_SGIS:             TextureParameterName read new TextureParameterName($8125);
    public static property TEXTURE_4DSIZE_SGIS:                  TextureParameterName read new TextureParameterName($8136);
    public static property TEXTURE_WRAP_Q_SGIS:                  TextureParameterName read new TextureParameterName($8137);
    public static property TEXTURE_MIN_LOD:                      TextureParameterName read new TextureParameterName($813A);
    public static property TEXTURE_MIN_LOD_SGIS:                 TextureParameterName read new TextureParameterName($813A);
    public static property TEXTURE_MAX_LOD:                      TextureParameterName read new TextureParameterName($813B);
    public static property TEXTURE_MAX_LOD_SGIS:                 TextureParameterName read new TextureParameterName($813B);
    public static property TEXTURE_BASE_LEVEL:                   TextureParameterName read new TextureParameterName($813C);
    public static property TEXTURE_BASE_LEVEL_SGIS:              TextureParameterName read new TextureParameterName($813C);
    public static property TEXTURE_MAX_LEVEL:                    TextureParameterName read new TextureParameterName($813D);
    public static property TEXTURE_MAX_LEVEL_SGIS:               TextureParameterName read new TextureParameterName($813D);
    public static property TEXTURE_FILTER4_SIZE_SGIS:            TextureParameterName read new TextureParameterName($8147);
    public static property TEXTURE_CLIPMAP_CENTER_SGIX:          TextureParameterName read new TextureParameterName($8171);
    public static property TEXTURE_CLIPMAP_FRAME_SGIX:           TextureParameterName read new TextureParameterName($8172);
    public static property TEXTURE_CLIPMAP_OFFSET_SGIX:          TextureParameterName read new TextureParameterName($8173);
    public static property TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX:   TextureParameterName read new TextureParameterName($8174);
    public static property TEXTURE_CLIPMAP_LOD_OFFSET_SGIX:      TextureParameterName read new TextureParameterName($8175);
    public static property TEXTURE_CLIPMAP_DEPTH_SGIX:           TextureParameterName read new TextureParameterName($8176);
    public static property POST_TEXTURE_FILTER_BIAS_SGIX:        TextureParameterName read new TextureParameterName($8179);
    public static property POST_TEXTURE_FILTER_SCALE_SGIX:       TextureParameterName read new TextureParameterName($817A);
    public static property TEXTURE_LOD_BIAS_S_SGIX:              TextureParameterName read new TextureParameterName($818E);
    public static property TEXTURE_LOD_BIAS_T_SGIX:              TextureParameterName read new TextureParameterName($818F);
    public static property TEXTURE_LOD_BIAS_R_SGIX:              TextureParameterName read new TextureParameterName($8190);
    public static property GENERATE_MIPMAP:                      TextureParameterName read new TextureParameterName($8191);
    public static property GENERATE_MIPMAP_SGIS:                 TextureParameterName read new TextureParameterName($8191);
    public static property TEXTURE_COMPARE_SGIX:                 TextureParameterName read new TextureParameterName($819A);
    public static property TEXTURE_COMPARE_OPERATOR_SGIX:        TextureParameterName read new TextureParameterName($819B);
    public static property TEXTURE_LEQUAL_R_SGIX:                TextureParameterName read new TextureParameterName($819C);
    public static property TEXTURE_GEQUAL_R_SGIX:                TextureParameterName read new TextureParameterName($819D);
    public static property TEXTURE_MAX_CLAMP_S_SGIX:             TextureParameterName read new TextureParameterName($8369);
    public static property TEXTURE_MAX_CLAMP_T_SGIX:             TextureParameterName read new TextureParameterName($836A);
    public static property TEXTURE_MAX_CLAMP_R_SGIX:             TextureParameterName read new TextureParameterName($836B);
    public static property TEXTURE_MAX_ANISOTROPY:               TextureParameterName read new TextureParameterName($84FE);
    public static property TEXTURE_LOD_BIAS:                     TextureParameterName read new TextureParameterName($8501);
    public static property TEXTURE_COMPARE_MODE:                 TextureParameterName read new TextureParameterName($884C);
    public static property TEXTURE_COMPARE_FUNC:                 TextureParameterName read new TextureParameterName($884D);
    public static property TEXTURE_SWIZZLE_R:                    TextureParameterName read new TextureParameterName($8E42);
    public static property TEXTURE_SWIZZLE_G:                    TextureParameterName read new TextureParameterName($8E43);
    public static property TEXTURE_SWIZZLE_B:                    TextureParameterName read new TextureParameterName($8E44);
    public static property TEXTURE_SWIZZLE_A:                    TextureParameterName read new TextureParameterName($8E45);
    public static property TEXTURE_SWIZZLE_RGBA:                 TextureParameterName read new TextureParameterName($8E46);
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: TextureParameterName read new TextureParameterName($8F6A);
    public static property DEPTH_STENCIL_TEXTURE_MODE:           TextureParameterName read new TextureParameterName($90EA);
    public static property TEXTURE_TILING_EXT:                   TextureParameterName read new TextureParameterName($9580);
    public static property TEXTURE_FOVEATED_CUTOFF_DENSITY_QCOM: TextureParameterName read new TextureParameterName($96A0);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1000) then Result := 'TEXTURE_WIDTH' else
      if self.val = UInt32($1001) then Result := 'TEXTURE_HEIGHT' else
      if self.val = UInt32($1003) then Result := 'TEXTURE_COMPONENTS' else
      if self.val = UInt32($1003) then Result := 'TEXTURE_INTERNAL_FORMAT' else
      if self.val = UInt32($1004) then Result := 'TEXTURE_BORDER_COLOR' else
      if self.val = UInt32($1004) then Result := 'TEXTURE_BORDER_COLOR_NV' else
      if self.val = UInt32($1005) then Result := 'TEXTURE_BORDER' else
      if self.val = UInt32($2800) then Result := 'TEXTURE_MAG_FILTER' else
      if self.val = UInt32($2801) then Result := 'TEXTURE_MIN_FILTER' else
      if self.val = UInt32($2802) then Result := 'TEXTURE_WRAP_S' else
      if self.val = UInt32($2803) then Result := 'TEXTURE_WRAP_T' else
      if self.val = UInt32($805C) then Result := 'TEXTURE_RED_SIZE' else
      if self.val = UInt32($805D) then Result := 'TEXTURE_GREEN_SIZE' else
      if self.val = UInt32($805E) then Result := 'TEXTURE_BLUE_SIZE' else
      if self.val = UInt32($805F) then Result := 'TEXTURE_ALPHA_SIZE' else
      if self.val = UInt32($8060) then Result := 'TEXTURE_LUMINANCE_SIZE' else
      if self.val = UInt32($8061) then Result := 'TEXTURE_INTENSITY_SIZE' else
      if self.val = UInt32($8066) then Result := 'TEXTURE_PRIORITY' else
      if self.val = UInt32($8066) then Result := 'TEXTURE_PRIORITY_EXT' else
      if self.val = UInt32($8067) then Result := 'TEXTURE_RESIDENT' else
      if self.val = UInt32($8071) then Result := 'TEXTURE_DEPTH_EXT' else
      if self.val = UInt32($8072) then Result := 'TEXTURE_WRAP_R' else
      if self.val = UInt32($8072) then Result := 'TEXTURE_WRAP_R_EXT' else
      if self.val = UInt32($8072) then Result := 'TEXTURE_WRAP_R_OES' else
      if self.val = UInt32($809A) then Result := 'DETAIL_TEXTURE_LEVEL_SGIS' else
      if self.val = UInt32($809B) then Result := 'DETAIL_TEXTURE_MODE_SGIS' else
      if self.val = UInt32($809C) then Result := 'DETAIL_TEXTURE_FUNC_POINTS_SGIS' else
      if self.val = UInt32($80B0) then Result := 'SHARPEN_TEXTURE_FUNC_POINTS_SGIS' else
      if self.val = UInt32($80BF) then Result := 'SHADOW_AMBIENT_SGIX' else
      if self.val = UInt32($8124) then Result := 'DUAL_TEXTURE_SELECT_SGIS' else
      if self.val = UInt32($8125) then Result := 'QUAD_TEXTURE_SELECT_SGIS' else
      if self.val = UInt32($8136) then Result := 'TEXTURE_4DSIZE_SGIS' else
      if self.val = UInt32($8137) then Result := 'TEXTURE_WRAP_Q_SGIS' else
      if self.val = UInt32($813A) then Result := 'TEXTURE_MIN_LOD' else
      if self.val = UInt32($813A) then Result := 'TEXTURE_MIN_LOD_SGIS' else
      if self.val = UInt32($813B) then Result := 'TEXTURE_MAX_LOD' else
      if self.val = UInt32($813B) then Result := 'TEXTURE_MAX_LOD_SGIS' else
      if self.val = UInt32($813C) then Result := 'TEXTURE_BASE_LEVEL' else
      if self.val = UInt32($813C) then Result := 'TEXTURE_BASE_LEVEL_SGIS' else
      if self.val = UInt32($813D) then Result := 'TEXTURE_MAX_LEVEL' else
      if self.val = UInt32($813D) then Result := 'TEXTURE_MAX_LEVEL_SGIS' else
      if self.val = UInt32($8147) then Result := 'TEXTURE_FILTER4_SIZE_SGIS' else
      if self.val = UInt32($8171) then Result := 'TEXTURE_CLIPMAP_CENTER_SGIX' else
      if self.val = UInt32($8172) then Result := 'TEXTURE_CLIPMAP_FRAME_SGIX' else
      if self.val = UInt32($8173) then Result := 'TEXTURE_CLIPMAP_OFFSET_SGIX' else
      if self.val = UInt32($8174) then Result := 'TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX' else
      if self.val = UInt32($8175) then Result := 'TEXTURE_CLIPMAP_LOD_OFFSET_SGIX' else
      if self.val = UInt32($8176) then Result := 'TEXTURE_CLIPMAP_DEPTH_SGIX' else
      if self.val = UInt32($8179) then Result := 'POST_TEXTURE_FILTER_BIAS_SGIX' else
      if self.val = UInt32($817A) then Result := 'POST_TEXTURE_FILTER_SCALE_SGIX' else
      if self.val = UInt32($818E) then Result := 'TEXTURE_LOD_BIAS_S_SGIX' else
      if self.val = UInt32($818F) then Result := 'TEXTURE_LOD_BIAS_T_SGIX' else
      if self.val = UInt32($8190) then Result := 'TEXTURE_LOD_BIAS_R_SGIX' else
      if self.val = UInt32($8191) then Result := 'GENERATE_MIPMAP' else
      if self.val = UInt32($8191) then Result := 'GENERATE_MIPMAP_SGIS' else
      if self.val = UInt32($819A) then Result := 'TEXTURE_COMPARE_SGIX' else
      if self.val = UInt32($819B) then Result := 'TEXTURE_COMPARE_OPERATOR_SGIX' else
      if self.val = UInt32($819C) then Result := 'TEXTURE_LEQUAL_R_SGIX' else
      if self.val = UInt32($819D) then Result := 'TEXTURE_GEQUAL_R_SGIX' else
      if self.val = UInt32($8369) then Result := 'TEXTURE_MAX_CLAMP_S_SGIX' else
      if self.val = UInt32($836A) then Result := 'TEXTURE_MAX_CLAMP_T_SGIX' else
      if self.val = UInt32($836B) then Result := 'TEXTURE_MAX_CLAMP_R_SGIX' else
      if self.val = UInt32($84FE) then Result := 'TEXTURE_MAX_ANISOTROPY' else
      if self.val = UInt32($8501) then Result := 'TEXTURE_LOD_BIAS' else
      if self.val = UInt32($884C) then Result := 'TEXTURE_COMPARE_MODE' else
      if self.val = UInt32($884D) then Result := 'TEXTURE_COMPARE_FUNC' else
      if self.val = UInt32($8E42) then Result := 'TEXTURE_SWIZZLE_R' else
      if self.val = UInt32($8E43) then Result := 'TEXTURE_SWIZZLE_G' else
      if self.val = UInt32($8E44) then Result := 'TEXTURE_SWIZZLE_B' else
      if self.val = UInt32($8E45) then Result := 'TEXTURE_SWIZZLE_A' else
      if self.val = UInt32($8E46) then Result := 'TEXTURE_SWIZZLE_RGBA' else
      if self.val = UInt32($8F6A) then Result := 'TEXTURE_UNNORMALIZED_COORDINATES_ARM' else
      if self.val = UInt32($90EA) then Result := 'DEPTH_STENCIL_TEXTURE_MODE' else
      if self.val = UInt32($9580) then Result := 'TEXTURE_TILING_EXT' else
      if self.val = UInt32($96A0) then Result := 'TEXTURE_FOVEATED_CUTOFF_DENSITY_QCOM' else
        Result := $'TextureParameterName[{self.val}]';
    end;
    
  end;
  
  TextureTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_1D:                         TextureTarget read new TextureTarget($0DE0);
    public static property TEXTURE_2D:                         TextureTarget read new TextureTarget($0DE1);
    public static property PROXY_TEXTURE_1D:                   TextureTarget read new TextureTarget($8063);
    public static property PROXY_TEXTURE_1D_EXT:               TextureTarget read new TextureTarget($8063);
    public static property PROXY_TEXTURE_2D:                   TextureTarget read new TextureTarget($8064);
    public static property PROXY_TEXTURE_2D_EXT:               TextureTarget read new TextureTarget($8064);
    public static property TEXTURE_3D:                         TextureTarget read new TextureTarget($806F);
    public static property TEXTURE_3D_EXT:                     TextureTarget read new TextureTarget($806F);
    public static property TEXTURE_3D_OES:                     TextureTarget read new TextureTarget($806F);
    public static property PROXY_TEXTURE_3D:                   TextureTarget read new TextureTarget($8070);
    public static property PROXY_TEXTURE_3D_EXT:               TextureTarget read new TextureTarget($8070);
    public static property DETAIL_TEXTURE_2D_SGIS:             TextureTarget read new TextureTarget($8095);
    public static property TEXTURE_4D_SGIS:                    TextureTarget read new TextureTarget($8134);
    public static property PROXY_TEXTURE_4D_SGIS:              TextureTarget read new TextureTarget($8135);
    public static property TEXTURE_RECTANGLE:                  TextureTarget read new TextureTarget($84F5);
    public static property TEXTURE_RECTANGLE_ARB:              TextureTarget read new TextureTarget($84F5);
    public static property TEXTURE_RECTANGLE_NV:               TextureTarget read new TextureTarget($84F5);
    public static property PROXY_TEXTURE_RECTANGLE:            TextureTarget read new TextureTarget($84F7);
    public static property PROXY_TEXTURE_RECTANGLE_ARB:        TextureTarget read new TextureTarget($84F7);
    public static property PROXY_TEXTURE_RECTANGLE_NV:         TextureTarget read new TextureTarget($84F7);
    public static property TEXTURE_CUBE_MAP:                   TextureTarget read new TextureTarget($8513);
    public static property TEXTURE_CUBE_MAP_ARB:               TextureTarget read new TextureTarget($8513);
    public static property TEXTURE_CUBE_MAP_EXT:               TextureTarget read new TextureTarget($8513);
    public static property TEXTURE_CUBE_MAP_OES:               TextureTarget read new TextureTarget($8513);
    public static property TEXTURE_CUBE_MAP_POSITIVE_X:        TextureTarget read new TextureTarget($8515);
    public static property TEXTURE_CUBE_MAP_NEGATIVE_X:        TextureTarget read new TextureTarget($8516);
    public static property TEXTURE_CUBE_MAP_POSITIVE_Y:        TextureTarget read new TextureTarget($8517);
    public static property TEXTURE_CUBE_MAP_NEGATIVE_Y:        TextureTarget read new TextureTarget($8518);
    public static property TEXTURE_CUBE_MAP_POSITIVE_Z:        TextureTarget read new TextureTarget($8519);
    public static property TEXTURE_CUBE_MAP_NEGATIVE_Z:        TextureTarget read new TextureTarget($851A);
    public static property PROXY_TEXTURE_CUBE_MAP:             TextureTarget read new TextureTarget($851B);
    public static property PROXY_TEXTURE_CUBE_MAP_ARB:         TextureTarget read new TextureTarget($851B);
    public static property PROXY_TEXTURE_CUBE_MAP_EXT:         TextureTarget read new TextureTarget($851B);
    public static property TEXTURE_1D_ARRAY:                   TextureTarget read new TextureTarget($8C18);
    public static property PROXY_TEXTURE_1D_ARRAY:             TextureTarget read new TextureTarget($8C19);
    public static property PROXY_TEXTURE_1D_ARRAY_EXT:         TextureTarget read new TextureTarget($8C19);
    public static property TEXTURE_2D_ARRAY:                   TextureTarget read new TextureTarget($8C1A);
    public static property PROXY_TEXTURE_2D_ARRAY:             TextureTarget read new TextureTarget($8C1B);
    public static property PROXY_TEXTURE_2D_ARRAY_EXT:         TextureTarget read new TextureTarget($8C1B);
    public static property TEXTURE_BUFFER:                     TextureTarget read new TextureTarget($8C2A);
    public static property RENDERBUFFER:                       TextureTarget read new TextureTarget($8D41);
    public static property TEXTURE_CUBE_MAP_ARRAY:             TextureTarget read new TextureTarget($9009);
    public static property TEXTURE_CUBE_MAP_ARRAY_ARB:         TextureTarget read new TextureTarget($9009);
    public static property TEXTURE_CUBE_MAP_ARRAY_EXT:         TextureTarget read new TextureTarget($9009);
    public static property TEXTURE_CUBE_MAP_ARRAY_OES:         TextureTarget read new TextureTarget($9009);
    public static property PROXY_TEXTURE_CUBE_MAP_ARRAY:       TextureTarget read new TextureTarget($900B);
    public static property PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB:   TextureTarget read new TextureTarget($900B);
    public static property TEXTURE_2D_MULTISAMPLE:             TextureTarget read new TextureTarget($9100);
    public static property PROXY_TEXTURE_2D_MULTISAMPLE:       TextureTarget read new TextureTarget($9101);
    public static property TEXTURE_2D_MULTISAMPLE_ARRAY:       TextureTarget read new TextureTarget($9102);
    public static property PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY: TextureTarget read new TextureTarget($9103);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0DE0) then Result := 'TEXTURE_1D' else
      if self.val = UInt32($0DE1) then Result := 'TEXTURE_2D' else
      if self.val = UInt32($8063) then Result := 'PROXY_TEXTURE_1D' else
      if self.val = UInt32($8063) then Result := 'PROXY_TEXTURE_1D_EXT' else
      if self.val = UInt32($8064) then Result := 'PROXY_TEXTURE_2D' else
      if self.val = UInt32($8064) then Result := 'PROXY_TEXTURE_2D_EXT' else
      if self.val = UInt32($806F) then Result := 'TEXTURE_3D' else
      if self.val = UInt32($806F) then Result := 'TEXTURE_3D_EXT' else
      if self.val = UInt32($806F) then Result := 'TEXTURE_3D_OES' else
      if self.val = UInt32($8070) then Result := 'PROXY_TEXTURE_3D' else
      if self.val = UInt32($8070) then Result := 'PROXY_TEXTURE_3D_EXT' else
      if self.val = UInt32($8095) then Result := 'DETAIL_TEXTURE_2D_SGIS' else
      if self.val = UInt32($8134) then Result := 'TEXTURE_4D_SGIS' else
      if self.val = UInt32($8135) then Result := 'PROXY_TEXTURE_4D_SGIS' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE_ARB' else
      if self.val = UInt32($84F5) then Result := 'TEXTURE_RECTANGLE_NV' else
      if self.val = UInt32($84F7) then Result := 'PROXY_TEXTURE_RECTANGLE' else
      if self.val = UInt32($84F7) then Result := 'PROXY_TEXTURE_RECTANGLE_ARB' else
      if self.val = UInt32($84F7) then Result := 'PROXY_TEXTURE_RECTANGLE_NV' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP_ARB' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP_EXT' else
      if self.val = UInt32($8513) then Result := 'TEXTURE_CUBE_MAP_OES' else
      if self.val = UInt32($8515) then Result := 'TEXTURE_CUBE_MAP_POSITIVE_X' else
      if self.val = UInt32($8516) then Result := 'TEXTURE_CUBE_MAP_NEGATIVE_X' else
      if self.val = UInt32($8517) then Result := 'TEXTURE_CUBE_MAP_POSITIVE_Y' else
      if self.val = UInt32($8518) then Result := 'TEXTURE_CUBE_MAP_NEGATIVE_Y' else
      if self.val = UInt32($8519) then Result := 'TEXTURE_CUBE_MAP_POSITIVE_Z' else
      if self.val = UInt32($851A) then Result := 'TEXTURE_CUBE_MAP_NEGATIVE_Z' else
      if self.val = UInt32($851B) then Result := 'PROXY_TEXTURE_CUBE_MAP' else
      if self.val = UInt32($851B) then Result := 'PROXY_TEXTURE_CUBE_MAP_ARB' else
      if self.val = UInt32($851B) then Result := 'PROXY_TEXTURE_CUBE_MAP_EXT' else
      if self.val = UInt32($8C18) then Result := 'TEXTURE_1D_ARRAY' else
      if self.val = UInt32($8C19) then Result := 'PROXY_TEXTURE_1D_ARRAY' else
      if self.val = UInt32($8C19) then Result := 'PROXY_TEXTURE_1D_ARRAY_EXT' else
      if self.val = UInt32($8C1A) then Result := 'TEXTURE_2D_ARRAY' else
      if self.val = UInt32($8C1B) then Result := 'PROXY_TEXTURE_2D_ARRAY' else
      if self.val = UInt32($8C1B) then Result := 'PROXY_TEXTURE_2D_ARRAY_EXT' else
      if self.val = UInt32($8C2A) then Result := 'TEXTURE_BUFFER' else
      if self.val = UInt32($8D41) then Result := 'RENDERBUFFER' else
      if self.val = UInt32($9009) then Result := 'TEXTURE_CUBE_MAP_ARRAY' else
      if self.val = UInt32($9009) then Result := 'TEXTURE_CUBE_MAP_ARRAY_ARB' else
      if self.val = UInt32($9009) then Result := 'TEXTURE_CUBE_MAP_ARRAY_EXT' else
      if self.val = UInt32($9009) then Result := 'TEXTURE_CUBE_MAP_ARRAY_OES' else
      if self.val = UInt32($900B) then Result := 'PROXY_TEXTURE_CUBE_MAP_ARRAY' else
      if self.val = UInt32($900B) then Result := 'PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB' else
      if self.val = UInt32($9100) then Result := 'TEXTURE_2D_MULTISAMPLE' else
      if self.val = UInt32($9101) then Result := 'PROXY_TEXTURE_2D_MULTISAMPLE' else
      if self.val = UInt32($9102) then Result := 'TEXTURE_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($9103) then Result := 'PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY' else
        Result := $'TextureTarget[{self.val}]';
    end;
    
  end;
  
  TextureUnit = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE0:  TextureUnit read new TextureUnit($84C0);
    public static property TEXTURE1:  TextureUnit read new TextureUnit($84C1);
    public static property TEXTURE2:  TextureUnit read new TextureUnit($84C2);
    public static property TEXTURE3:  TextureUnit read new TextureUnit($84C3);
    public static property TEXTURE4:  TextureUnit read new TextureUnit($84C4);
    public static property TEXTURE5:  TextureUnit read new TextureUnit($84C5);
    public static property TEXTURE6:  TextureUnit read new TextureUnit($84C6);
    public static property TEXTURE7:  TextureUnit read new TextureUnit($84C7);
    public static property TEXTURE8:  TextureUnit read new TextureUnit($84C8);
    public static property TEXTURE9:  TextureUnit read new TextureUnit($84C9);
    public static property TEXTURE10: TextureUnit read new TextureUnit($84CA);
    public static property TEXTURE11: TextureUnit read new TextureUnit($84CB);
    public static property TEXTURE12: TextureUnit read new TextureUnit($84CC);
    public static property TEXTURE13: TextureUnit read new TextureUnit($84CD);
    public static property TEXTURE14: TextureUnit read new TextureUnit($84CE);
    public static property TEXTURE15: TextureUnit read new TextureUnit($84CF);
    public static property TEXTURE16: TextureUnit read new TextureUnit($84D0);
    public static property TEXTURE17: TextureUnit read new TextureUnit($84D1);
    public static property TEXTURE18: TextureUnit read new TextureUnit($84D2);
    public static property TEXTURE19: TextureUnit read new TextureUnit($84D3);
    public static property TEXTURE20: TextureUnit read new TextureUnit($84D4);
    public static property TEXTURE21: TextureUnit read new TextureUnit($84D5);
    public static property TEXTURE22: TextureUnit read new TextureUnit($84D6);
    public static property TEXTURE23: TextureUnit read new TextureUnit($84D7);
    public static property TEXTURE24: TextureUnit read new TextureUnit($84D8);
    public static property TEXTURE25: TextureUnit read new TextureUnit($84D9);
    public static property TEXTURE26: TextureUnit read new TextureUnit($84DA);
    public static property TEXTURE27: TextureUnit read new TextureUnit($84DB);
    public static property TEXTURE28: TextureUnit read new TextureUnit($84DC);
    public static property TEXTURE29: TextureUnit read new TextureUnit($84DD);
    public static property TEXTURE30: TextureUnit read new TextureUnit($84DE);
    public static property TEXTURE31: TextureUnit read new TextureUnit($84DF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($84C0) then Result := 'TEXTURE0' else
      if self.val = UInt32($84C1) then Result := 'TEXTURE1' else
      if self.val = UInt32($84C2) then Result := 'TEXTURE2' else
      if self.val = UInt32($84C3) then Result := 'TEXTURE3' else
      if self.val = UInt32($84C4) then Result := 'TEXTURE4' else
      if self.val = UInt32($84C5) then Result := 'TEXTURE5' else
      if self.val = UInt32($84C6) then Result := 'TEXTURE6' else
      if self.val = UInt32($84C7) then Result := 'TEXTURE7' else
      if self.val = UInt32($84C8) then Result := 'TEXTURE8' else
      if self.val = UInt32($84C9) then Result := 'TEXTURE9' else
      if self.val = UInt32($84CA) then Result := 'TEXTURE10' else
      if self.val = UInt32($84CB) then Result := 'TEXTURE11' else
      if self.val = UInt32($84CC) then Result := 'TEXTURE12' else
      if self.val = UInt32($84CD) then Result := 'TEXTURE13' else
      if self.val = UInt32($84CE) then Result := 'TEXTURE14' else
      if self.val = UInt32($84CF) then Result := 'TEXTURE15' else
      if self.val = UInt32($84D0) then Result := 'TEXTURE16' else
      if self.val = UInt32($84D1) then Result := 'TEXTURE17' else
      if self.val = UInt32($84D2) then Result := 'TEXTURE18' else
      if self.val = UInt32($84D3) then Result := 'TEXTURE19' else
      if self.val = UInt32($84D4) then Result := 'TEXTURE20' else
      if self.val = UInt32($84D5) then Result := 'TEXTURE21' else
      if self.val = UInt32($84D6) then Result := 'TEXTURE22' else
      if self.val = UInt32($84D7) then Result := 'TEXTURE23' else
      if self.val = UInt32($84D8) then Result := 'TEXTURE24' else
      if self.val = UInt32($84D9) then Result := 'TEXTURE25' else
      if self.val = UInt32($84DA) then Result := 'TEXTURE26' else
      if self.val = UInt32($84DB) then Result := 'TEXTURE27' else
      if self.val = UInt32($84DC) then Result := 'TEXTURE28' else
      if self.val = UInt32($84DD) then Result := 'TEXTURE29' else
      if self.val = UInt32($84DE) then Result := 'TEXTURE30' else
      if self.val = UInt32($84DF) then Result := 'TEXTURE31' else
        Result := $'TextureUnit[{self.val}]';
    end;
    
  end;
  
  TransformFeedbackBufferMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property INTERLEAVED_ATTRIBS: TransformFeedbackBufferMode read new TransformFeedbackBufferMode($8C8C);
    public static property SEPARATE_ATTRIBS:    TransformFeedbackBufferMode read new TransformFeedbackBufferMode($8C8D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8C8C) then Result := 'INTERLEAVED_ATTRIBS' else
      if self.val = UInt32($8C8D) then Result := 'SEPARATE_ATTRIBS' else
        Result := $'TransformFeedbackBufferMode[{self.val}]';
    end;
    
  end;
  
  TransformFeedbackPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TRANSFORM_FEEDBACK_BUFFER_START:   TransformFeedbackPName read new TransformFeedbackPName($8C84);
    public static property TRANSFORM_FEEDBACK_BUFFER_SIZE:    TransformFeedbackPName read new TransformFeedbackPName($8C85);
    public static property TRANSFORM_FEEDBACK_BUFFER_BINDING: TransformFeedbackPName read new TransformFeedbackPName($8C8F);
    public static property TRANSFORM_FEEDBACK_PAUSED:         TransformFeedbackPName read new TransformFeedbackPName($8E23);
    public static property TRANSFORM_FEEDBACK_ACTIVE:         TransformFeedbackPName read new TransformFeedbackPName($8E24);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8C84) then Result := 'TRANSFORM_FEEDBACK_BUFFER_START' else
      if self.val = UInt32($8C85) then Result := 'TRANSFORM_FEEDBACK_BUFFER_SIZE' else
      if self.val = UInt32($8C8F) then Result := 'TRANSFORM_FEEDBACK_BUFFER_BINDING' else
      if self.val = UInt32($8E23) then Result := 'TRANSFORM_FEEDBACK_PAUSED' else
      if self.val = UInt32($8E24) then Result := 'TRANSFORM_FEEDBACK_ACTIVE' else
        Result := $'TransformFeedbackPName[{self.val}]';
    end;
    
  end;
  
  UniformBlockPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER:    UniformBlockPName read new UniformBlockPName($84F0);
    public static property UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER: UniformBlockPName read new UniformBlockPName($84F1);
    public static property UNIFORM_BLOCK_BINDING:                              UniformBlockPName read new UniformBlockPName($8A3F);
    public static property UNIFORM_BLOCK_DATA_SIZE:                            UniformBlockPName read new UniformBlockPName($8A40);
    public static property UNIFORM_BLOCK_NAME_LENGTH:                          UniformBlockPName read new UniformBlockPName($8A41);
    public static property UNIFORM_BLOCK_ACTIVE_UNIFORMS:                      UniformBlockPName read new UniformBlockPName($8A42);
    public static property UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:               UniformBlockPName read new UniformBlockPName($8A43);
    public static property UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:          UniformBlockPName read new UniformBlockPName($8A44);
    public static property UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER:        UniformBlockPName read new UniformBlockPName($8A45);
    public static property UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:        UniformBlockPName read new UniformBlockPName($8A46);
    public static property UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER:         UniformBlockPName read new UniformBlockPName($90EC);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($84F0) then Result := 'UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER' else
      if self.val = UInt32($84F1) then Result := 'UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER' else
      if self.val = UInt32($8A3F) then Result := 'UNIFORM_BLOCK_BINDING' else
      if self.val = UInt32($8A40) then Result := 'UNIFORM_BLOCK_DATA_SIZE' else
      if self.val = UInt32($8A41) then Result := 'UNIFORM_BLOCK_NAME_LENGTH' else
      if self.val = UInt32($8A42) then Result := 'UNIFORM_BLOCK_ACTIVE_UNIFORMS' else
      if self.val = UInt32($8A43) then Result := 'UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES' else
      if self.val = UInt32($8A44) then Result := 'UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER' else
      if self.val = UInt32($8A45) then Result := 'UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER' else
      if self.val = UInt32($8A46) then Result := 'UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER' else
      if self.val = UInt32($90EC) then Result := 'UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER' else
        Result := $'UniformBlockPName[{self.val}]';
    end;
    
  end;
  
  UniformPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNIFORM_TYPE:                        UniformPName read new UniformPName($8A37);
    public static property UNIFORM_SIZE:                        UniformPName read new UniformPName($8A38);
    public static property UNIFORM_NAME_LENGTH:                 UniformPName read new UniformPName($8A39);
    public static property UNIFORM_BLOCK_INDEX:                 UniformPName read new UniformPName($8A3A);
    public static property UNIFORM_OFFSET:                      UniformPName read new UniformPName($8A3B);
    public static property UNIFORM_ARRAY_STRIDE:                UniformPName read new UniformPName($8A3C);
    public static property UNIFORM_MATRIX_STRIDE:               UniformPName read new UniformPName($8A3D);
    public static property UNIFORM_IS_ROW_MAJOR:                UniformPName read new UniformPName($8A3E);
    public static property UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX: UniformPName read new UniformPName($92DA);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8A37) then Result := 'UNIFORM_TYPE' else
      if self.val = UInt32($8A38) then Result := 'UNIFORM_SIZE' else
      if self.val = UInt32($8A39) then Result := 'UNIFORM_NAME_LENGTH' else
      if self.val = UInt32($8A3A) then Result := 'UNIFORM_BLOCK_INDEX' else
      if self.val = UInt32($8A3B) then Result := 'UNIFORM_OFFSET' else
      if self.val = UInt32($8A3C) then Result := 'UNIFORM_ARRAY_STRIDE' else
      if self.val = UInt32($8A3D) then Result := 'UNIFORM_MATRIX_STRIDE' else
      if self.val = UInt32($8A3E) then Result := 'UNIFORM_IS_ROW_MAJOR' else
      if self.val = UInt32($92DA) then Result := 'UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX' else
        Result := $'UniformPName[{self.val}]';
    end;
    
  end;
  
  UniformType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property INT:                                       UniformType read new UniformType($1404);
    public static property UNSIGNED_INT:                              UniformType read new UniformType($1405);
    public static property FLOAT:                                     UniformType read new UniformType($1406);
    public static property DOUBLE:                                    UniformType read new UniformType($140A);
    public static property FLOAT_VEC2:                                UniformType read new UniformType($8B50);
    public static property FLOAT_VEC3:                                UniformType read new UniformType($8B51);
    public static property FLOAT_VEC4:                                UniformType read new UniformType($8B52);
    public static property INT_VEC2:                                  UniformType read new UniformType($8B53);
    public static property INT_VEC3:                                  UniformType read new UniformType($8B54);
    public static property INT_VEC4:                                  UniformType read new UniformType($8B55);
    public static property BOOL:                                      UniformType read new UniformType($8B56);
    public static property BOOL_VEC2:                                 UniformType read new UniformType($8B57);
    public static property BOOL_VEC3:                                 UniformType read new UniformType($8B58);
    public static property BOOL_VEC4:                                 UniformType read new UniformType($8B59);
    public static property FLOAT_MAT2:                                UniformType read new UniformType($8B5A);
    public static property FLOAT_MAT3:                                UniformType read new UniformType($8B5B);
    public static property FLOAT_MAT4:                                UniformType read new UniformType($8B5C);
    public static property SAMPLER_1D:                                UniformType read new UniformType($8B5D);
    public static property SAMPLER_2D:                                UniformType read new UniformType($8B5E);
    public static property SAMPLER_3D:                                UniformType read new UniformType($8B5F);
    public static property SAMPLER_CUBE:                              UniformType read new UniformType($8B60);
    public static property SAMPLER_1D_SHADOW:                         UniformType read new UniformType($8B61);
    public static property SAMPLER_2D_SHADOW:                         UniformType read new UniformType($8B62);
    public static property SAMPLER_2D_RECT:                           UniformType read new UniformType($8B63);
    public static property SAMPLER_2D_RECT_SHADOW:                    UniformType read new UniformType($8B64);
    public static property FLOAT_MAT2x3:                              UniformType read new UniformType($8B65);
    public static property FLOAT_MAT2x4:                              UniformType read new UniformType($8B66);
    public static property FLOAT_MAT3x2:                              UniformType read new UniformType($8B67);
    public static property FLOAT_MAT3x4:                              UniformType read new UniformType($8B68);
    public static property FLOAT_MAT4x2:                              UniformType read new UniformType($8B69);
    public static property FLOAT_MAT4x3:                              UniformType read new UniformType($8B6A);
    public static property SAMPLER_1D_ARRAY:                          UniformType read new UniformType($8DC0);
    public static property SAMPLER_2D_ARRAY:                          UniformType read new UniformType($8DC1);
    public static property SAMPLER_BUFFER:                            UniformType read new UniformType($8DC2);
    public static property SAMPLER_1D_ARRAY_SHADOW:                   UniformType read new UniformType($8DC3);
    public static property SAMPLER_2D_ARRAY_SHADOW:                   UniformType read new UniformType($8DC4);
    public static property SAMPLER_CUBE_SHADOW:                       UniformType read new UniformType($8DC5);
    public static property UNSIGNED_INT_VEC2:                         UniformType read new UniformType($8DC6);
    public static property UNSIGNED_INT_VEC3:                         UniformType read new UniformType($8DC7);
    public static property UNSIGNED_INT_VEC4:                         UniformType read new UniformType($8DC8);
    public static property INT_SAMPLER_1D:                            UniformType read new UniformType($8DC9);
    public static property INT_SAMPLER_2D:                            UniformType read new UniformType($8DCA);
    public static property INT_SAMPLER_3D:                            UniformType read new UniformType($8DCB);
    public static property INT_SAMPLER_CUBE:                          UniformType read new UniformType($8DCC);
    public static property INT_SAMPLER_2D_RECT:                       UniformType read new UniformType($8DCD);
    public static property INT_SAMPLER_1D_ARRAY:                      UniformType read new UniformType($8DCE);
    public static property INT_SAMPLER_2D_ARRAY:                      UniformType read new UniformType($8DCF);
    public static property INT_SAMPLER_BUFFER:                        UniformType read new UniformType($8DD0);
    public static property UNSIGNED_INT_SAMPLER_1D:                   UniformType read new UniformType($8DD1);
    public static property UNSIGNED_INT_SAMPLER_2D:                   UniformType read new UniformType($8DD2);
    public static property UNSIGNED_INT_SAMPLER_3D:                   UniformType read new UniformType($8DD3);
    public static property UNSIGNED_INT_SAMPLER_CUBE:                 UniformType read new UniformType($8DD4);
    public static property UNSIGNED_INT_SAMPLER_2D_RECT:              UniformType read new UniformType($8DD5);
    public static property UNSIGNED_INT_SAMPLER_1D_ARRAY:             UniformType read new UniformType($8DD6);
    public static property UNSIGNED_INT_SAMPLER_2D_ARRAY:             UniformType read new UniformType($8DD7);
    public static property UNSIGNED_INT_SAMPLER_BUFFER:               UniformType read new UniformType($8DD8);
    public static property DOUBLE_MAT2:                               UniformType read new UniformType($8F46);
    public static property DOUBLE_MAT3:                               UniformType read new UniformType($8F47);
    public static property DOUBLE_MAT4:                               UniformType read new UniformType($8F48);
    public static property DOUBLE_MAT2x3:                             UniformType read new UniformType($8F49);
    public static property DOUBLE_MAT2x4:                             UniformType read new UniformType($8F4A);
    public static property DOUBLE_MAT3x2:                             UniformType read new UniformType($8F4B);
    public static property DOUBLE_MAT3x4:                             UniformType read new UniformType($8F4C);
    public static property DOUBLE_MAT4x2:                             UniformType read new UniformType($8F4D);
    public static property DOUBLE_MAT4x3:                             UniformType read new UniformType($8F4E);
    public static property DOUBLE_VEC2:                               UniformType read new UniformType($8FFC);
    public static property DOUBLE_VEC3:                               UniformType read new UniformType($8FFD);
    public static property DOUBLE_VEC4:                               UniformType read new UniformType($8FFE);
    public static property SAMPLER_CUBE_MAP_ARRAY:                    UniformType read new UniformType($900C);
    public static property SAMPLER_CUBE_MAP_ARRAY_SHADOW:             UniformType read new UniformType($900D);
    public static property INT_SAMPLER_CUBE_MAP_ARRAY:                UniformType read new UniformType($900E);
    public static property UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY:       UniformType read new UniformType($900F);
    public static property SAMPLER_2D_MULTISAMPLE:                    UniformType read new UniformType($9108);
    public static property INT_SAMPLER_2D_MULTISAMPLE:                UniformType read new UniformType($9109);
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE:       UniformType read new UniformType($910A);
    public static property SAMPLER_2D_MULTISAMPLE_ARRAY:              UniformType read new UniformType($910B);
    public static property INT_SAMPLER_2D_MULTISAMPLE_ARRAY:          UniformType read new UniformType($910C);
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY: UniformType read new UniformType($910D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
      if self.val = UInt32($8B50) then Result := 'FLOAT_VEC2' else
      if self.val = UInt32($8B51) then Result := 'FLOAT_VEC3' else
      if self.val = UInt32($8B52) then Result := 'FLOAT_VEC4' else
      if self.val = UInt32($8B53) then Result := 'INT_VEC2' else
      if self.val = UInt32($8B54) then Result := 'INT_VEC3' else
      if self.val = UInt32($8B55) then Result := 'INT_VEC4' else
      if self.val = UInt32($8B56) then Result := 'BOOL' else
      if self.val = UInt32($8B57) then Result := 'BOOL_VEC2' else
      if self.val = UInt32($8B58) then Result := 'BOOL_VEC3' else
      if self.val = UInt32($8B59) then Result := 'BOOL_VEC4' else
      if self.val = UInt32($8B5A) then Result := 'FLOAT_MAT2' else
      if self.val = UInt32($8B5B) then Result := 'FLOAT_MAT3' else
      if self.val = UInt32($8B5C) then Result := 'FLOAT_MAT4' else
      if self.val = UInt32($8B5D) then Result := 'SAMPLER_1D' else
      if self.val = UInt32($8B5E) then Result := 'SAMPLER_2D' else
      if self.val = UInt32($8B5F) then Result := 'SAMPLER_3D' else
      if self.val = UInt32($8B60) then Result := 'SAMPLER_CUBE' else
      if self.val = UInt32($8B61) then Result := 'SAMPLER_1D_SHADOW' else
      if self.val = UInt32($8B62) then Result := 'SAMPLER_2D_SHADOW' else
      if self.val = UInt32($8B63) then Result := 'SAMPLER_2D_RECT' else
      if self.val = UInt32($8B64) then Result := 'SAMPLER_2D_RECT_SHADOW' else
      if self.val = UInt32($8B65) then Result := 'FLOAT_MAT2x3' else
      if self.val = UInt32($8B66) then Result := 'FLOAT_MAT2x4' else
      if self.val = UInt32($8B67) then Result := 'FLOAT_MAT3x2' else
      if self.val = UInt32($8B68) then Result := 'FLOAT_MAT3x4' else
      if self.val = UInt32($8B69) then Result := 'FLOAT_MAT4x2' else
      if self.val = UInt32($8B6A) then Result := 'FLOAT_MAT4x3' else
      if self.val = UInt32($8DC0) then Result := 'SAMPLER_1D_ARRAY' else
      if self.val = UInt32($8DC1) then Result := 'SAMPLER_2D_ARRAY' else
      if self.val = UInt32($8DC2) then Result := 'SAMPLER_BUFFER' else
      if self.val = UInt32($8DC3) then Result := 'SAMPLER_1D_ARRAY_SHADOW' else
      if self.val = UInt32($8DC4) then Result := 'SAMPLER_2D_ARRAY_SHADOW' else
      if self.val = UInt32($8DC5) then Result := 'SAMPLER_CUBE_SHADOW' else
      if self.val = UInt32($8DC6) then Result := 'UNSIGNED_INT_VEC2' else
      if self.val = UInt32($8DC7) then Result := 'UNSIGNED_INT_VEC3' else
      if self.val = UInt32($8DC8) then Result := 'UNSIGNED_INT_VEC4' else
      if self.val = UInt32($8DC9) then Result := 'INT_SAMPLER_1D' else
      if self.val = UInt32($8DCA) then Result := 'INT_SAMPLER_2D' else
      if self.val = UInt32($8DCB) then Result := 'INT_SAMPLER_3D' else
      if self.val = UInt32($8DCC) then Result := 'INT_SAMPLER_CUBE' else
      if self.val = UInt32($8DCD) then Result := 'INT_SAMPLER_2D_RECT' else
      if self.val = UInt32($8DCE) then Result := 'INT_SAMPLER_1D_ARRAY' else
      if self.val = UInt32($8DCF) then Result := 'INT_SAMPLER_2D_ARRAY' else
      if self.val = UInt32($8DD0) then Result := 'INT_SAMPLER_BUFFER' else
      if self.val = UInt32($8DD1) then Result := 'UNSIGNED_INT_SAMPLER_1D' else
      if self.val = UInt32($8DD2) then Result := 'UNSIGNED_INT_SAMPLER_2D' else
      if self.val = UInt32($8DD3) then Result := 'UNSIGNED_INT_SAMPLER_3D' else
      if self.val = UInt32($8DD4) then Result := 'UNSIGNED_INT_SAMPLER_CUBE' else
      if self.val = UInt32($8DD5) then Result := 'UNSIGNED_INT_SAMPLER_2D_RECT' else
      if self.val = UInt32($8DD6) then Result := 'UNSIGNED_INT_SAMPLER_1D_ARRAY' else
      if self.val = UInt32($8DD7) then Result := 'UNSIGNED_INT_SAMPLER_2D_ARRAY' else
      if self.val = UInt32($8DD8) then Result := 'UNSIGNED_INT_SAMPLER_BUFFER' else
      if self.val = UInt32($8F46) then Result := 'DOUBLE_MAT2' else
      if self.val = UInt32($8F47) then Result := 'DOUBLE_MAT3' else
      if self.val = UInt32($8F48) then Result := 'DOUBLE_MAT4' else
      if self.val = UInt32($8F49) then Result := 'DOUBLE_MAT2x3' else
      if self.val = UInt32($8F4A) then Result := 'DOUBLE_MAT2x4' else
      if self.val = UInt32($8F4B) then Result := 'DOUBLE_MAT3x2' else
      if self.val = UInt32($8F4C) then Result := 'DOUBLE_MAT3x4' else
      if self.val = UInt32($8F4D) then Result := 'DOUBLE_MAT4x2' else
      if self.val = UInt32($8F4E) then Result := 'DOUBLE_MAT4x3' else
      if self.val = UInt32($8FFC) then Result := 'DOUBLE_VEC2' else
      if self.val = UInt32($8FFD) then Result := 'DOUBLE_VEC3' else
      if self.val = UInt32($8FFE) then Result := 'DOUBLE_VEC4' else
      if self.val = UInt32($900C) then Result := 'SAMPLER_CUBE_MAP_ARRAY' else
      if self.val = UInt32($900D) then Result := 'SAMPLER_CUBE_MAP_ARRAY_SHADOW' else
      if self.val = UInt32($900E) then Result := 'INT_SAMPLER_CUBE_MAP_ARRAY' else
      if self.val = UInt32($900F) then Result := 'UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY' else
      if self.val = UInt32($9108) then Result := 'SAMPLER_2D_MULTISAMPLE' else
      if self.val = UInt32($9109) then Result := 'INT_SAMPLER_2D_MULTISAMPLE' else
      if self.val = UInt32($910A) then Result := 'UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE' else
      if self.val = UInt32($910B) then Result := 'SAMPLER_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($910C) then Result := 'INT_SAMPLER_2D_MULTISAMPLE_ARRAY' else
      if self.val = UInt32($910D) then Result := 'UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY' else
        Result := $'UniformType[{self.val}]';
    end;
    
  end;
  
  UseProgramStageMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_SHADER_BIT:              UseProgramStageMask read new UseProgramStageMask($0001);
    public static property VERTEX_SHADER_BIT_EXT:          UseProgramStageMask read new UseProgramStageMask($0001);
    public static property FRAGMENT_SHADER_BIT:            UseProgramStageMask read new UseProgramStageMask($0002);
    public static property FRAGMENT_SHADER_BIT_EXT:        UseProgramStageMask read new UseProgramStageMask($0002);
    public static property GEOMETRY_SHADER_BIT:            UseProgramStageMask read new UseProgramStageMask($0004);
    public static property GEOMETRY_SHADER_BIT_EXT:        UseProgramStageMask read new UseProgramStageMask($0004);
    public static property GEOMETRY_SHADER_BIT_OES:        UseProgramStageMask read new UseProgramStageMask($0004);
    public static property TESS_CONTROL_SHADER_BIT:        UseProgramStageMask read new UseProgramStageMask($0008);
    public static property TESS_CONTROL_SHADER_BIT_EXT:    UseProgramStageMask read new UseProgramStageMask($0008);
    public static property TESS_CONTROL_SHADER_BIT_OES:    UseProgramStageMask read new UseProgramStageMask($0008);
    public static property TESS_EVALUATION_SHADER_BIT:     UseProgramStageMask read new UseProgramStageMask($0010);
    public static property TESS_EVALUATION_SHADER_BIT_EXT: UseProgramStageMask read new UseProgramStageMask($0010);
    public static property TESS_EVALUATION_SHADER_BIT_OES: UseProgramStageMask read new UseProgramStageMask($0010);
    public static property COMPUTE_SHADER_BIT:             UseProgramStageMask read new UseProgramStageMask($0020);
    public static property MESH_SHADER_BIT_NV:             UseProgramStageMask read new UseProgramStageMask($0040);
    public static property TASK_SHADER_BIT_NV:             UseProgramStageMask read new UseProgramStageMask($0080);
    public static property ALL_SHADER_BITS:                UseProgramStageMask read new UseProgramStageMask($FFFFFFFF);
    public static property ALL_SHADER_BITS_EXT:            UseProgramStageMask read new UseProgramStageMask($FFFFFFFF);
    
    public static function operator+(f1,f2: UseProgramStageMask) := new UseProgramStageMask(f1.val or f2.val);
    public static function operator or(f1,f2: UseProgramStageMask) := f1+f2;
    
    public property HAS_FLAG_VERTEX_SHADER_BIT:              boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_VERTEX_SHADER_BIT_EXT:          boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_FRAGMENT_SHADER_BIT:            boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_FRAGMENT_SHADER_BIT_EXT:        boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_GEOMETRY_SHADER_BIT:            boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_GEOMETRY_SHADER_BIT_EXT:        boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_GEOMETRY_SHADER_BIT_OES:        boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_TESS_CONTROL_SHADER_BIT:        boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TESS_CONTROL_SHADER_BIT_EXT:    boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TESS_CONTROL_SHADER_BIT_OES:    boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TESS_EVALUATION_SHADER_BIT:     boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_TESS_EVALUATION_SHADER_BIT_EXT: boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_TESS_EVALUATION_SHADER_BIT_OES: boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_COMPUTE_SHADER_BIT:             boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_MESH_SHADER_BIT_NV:             boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_TASK_SHADER_BIT_NV:             boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_ALL_SHADER_BITS:                boolean read self.val and $FFFFFFFF <> 0;
    public property HAS_FLAG_ALL_SHADER_BITS_EXT:            boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'VERTEX_SHADER_BIT+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'VERTEX_SHADER_BIT_EXT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'FRAGMENT_SHADER_BIT+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'FRAGMENT_SHADER_BIT_EXT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'GEOMETRY_SHADER_BIT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'GEOMETRY_SHADER_BIT_EXT+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'GEOMETRY_SHADER_BIT_OES+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'TESS_CONTROL_SHADER_BIT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'TESS_CONTROL_SHADER_BIT_EXT+';
      if self.val and UInt32($0008) = UInt32($0008) then res += 'TESS_CONTROL_SHADER_BIT_OES+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'TESS_EVALUATION_SHADER_BIT+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'TESS_EVALUATION_SHADER_BIT_EXT+';
      if self.val and UInt32($0010) = UInt32($0010) then res += 'TESS_EVALUATION_SHADER_BIT_OES+';
      if self.val and UInt32($0020) = UInt32($0020) then res += 'COMPUTE_SHADER_BIT+';
      if self.val and UInt32($0040) = UInt32($0040) then res += 'MESH_SHADER_BIT_NV+';
      if self.val and UInt32($0080) = UInt32($0080) then res += 'TASK_SHADER_BIT_NV+';
      if self.val and UInt32($FFFFFFFF) = UInt32($FFFFFFFF) then res += 'ALL_SHADER_BITS+';
      if self.val and UInt32($FFFFFFFF) = UInt32($FFFFFFFF) then res += 'ALL_SHADER_BITS_EXT+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'UseProgramStageMask[{self.val}]';
    end;
    
  end;
  
  VertexArrayPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_ATTRIB_RELATIVE_OFFSET:  VertexArrayPName read new VertexArrayPName($82D5);
    public static property VERTEX_ATTRIB_ARRAY_ENABLED:    VertexArrayPName read new VertexArrayPName($8622);
    public static property VERTEX_ATTRIB_ARRAY_SIZE:       VertexArrayPName read new VertexArrayPName($8623);
    public static property VERTEX_ATTRIB_ARRAY_STRIDE:     VertexArrayPName read new VertexArrayPName($8624);
    public static property VERTEX_ATTRIB_ARRAY_TYPE:       VertexArrayPName read new VertexArrayPName($8625);
    public static property VERTEX_ATTRIB_ARRAY_LONG:       VertexArrayPName read new VertexArrayPName($874E);
    public static property VERTEX_ATTRIB_ARRAY_NORMALIZED: VertexArrayPName read new VertexArrayPName($886A);
    public static property VERTEX_ATTRIB_ARRAY_INTEGER:    VertexArrayPName read new VertexArrayPName($88FD);
    public static property VERTEX_ATTRIB_ARRAY_DIVISOR:    VertexArrayPName read new VertexArrayPName($88FE);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($82D5) then Result := 'VERTEX_ATTRIB_RELATIVE_OFFSET' else
      if self.val = UInt32($8622) then Result := 'VERTEX_ATTRIB_ARRAY_ENABLED' else
      if self.val = UInt32($8623) then Result := 'VERTEX_ATTRIB_ARRAY_SIZE' else
      if self.val = UInt32($8624) then Result := 'VERTEX_ATTRIB_ARRAY_STRIDE' else
      if self.val = UInt32($8625) then Result := 'VERTEX_ATTRIB_ARRAY_TYPE' else
      if self.val = UInt32($874E) then Result := 'VERTEX_ATTRIB_ARRAY_LONG' else
      if self.val = UInt32($886A) then Result := 'VERTEX_ATTRIB_ARRAY_NORMALIZED' else
      if self.val = UInt32($88FD) then Result := 'VERTEX_ATTRIB_ARRAY_INTEGER' else
      if self.val = UInt32($88FE) then Result := 'VERTEX_ATTRIB_ARRAY_DIVISOR' else
        Result := $'VertexArrayPName[{self.val}]';
    end;
    
  end;
  
  VertexAttribEnum = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_ATTRIB_ARRAY_ENABLED:        VertexAttribEnum read new VertexAttribEnum($8622);
    public static property VERTEX_ATTRIB_ARRAY_SIZE:           VertexAttribEnum read new VertexAttribEnum($8623);
    public static property VERTEX_ATTRIB_ARRAY_STRIDE:         VertexAttribEnum read new VertexAttribEnum($8624);
    public static property VERTEX_ATTRIB_ARRAY_TYPE:           VertexAttribEnum read new VertexAttribEnum($8625);
    public static property CURRENT_VERTEX_ATTRIB:              VertexAttribEnum read new VertexAttribEnum($8626);
    public static property VERTEX_ATTRIB_ARRAY_NORMALIZED:     VertexAttribEnum read new VertexAttribEnum($886A);
    public static property VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: VertexAttribEnum read new VertexAttribEnum($889F);
    public static property VERTEX_ATTRIB_ARRAY_INTEGER:        VertexAttribEnum read new VertexAttribEnum($88FD);
    public static property VERTEX_ATTRIB_ARRAY_DIVISOR:        VertexAttribEnum read new VertexAttribEnum($88FE);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8622) then Result := 'VERTEX_ATTRIB_ARRAY_ENABLED' else
      if self.val = UInt32($8623) then Result := 'VERTEX_ATTRIB_ARRAY_SIZE' else
      if self.val = UInt32($8624) then Result := 'VERTEX_ATTRIB_ARRAY_STRIDE' else
      if self.val = UInt32($8625) then Result := 'VERTEX_ATTRIB_ARRAY_TYPE' else
      if self.val = UInt32($8626) then Result := 'CURRENT_VERTEX_ATTRIB' else
      if self.val = UInt32($886A) then Result := 'VERTEX_ATTRIB_ARRAY_NORMALIZED' else
      if self.val = UInt32($889F) then Result := 'VERTEX_ATTRIB_ARRAY_BUFFER_BINDING' else
      if self.val = UInt32($88FD) then Result := 'VERTEX_ATTRIB_ARRAY_INTEGER' else
      if self.val = UInt32($88FE) then Result := 'VERTEX_ATTRIB_ARRAY_DIVISOR' else
        Result := $'VertexAttribEnum[{self.val}]';
    end;
    
  end;
  
  VertexAttribIType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:           VertexAttribIType read new VertexAttribIType($1400);
    public static property UNSIGNED_BYTE:  VertexAttribIType read new VertexAttribIType($1401);
    public static property SHORT:          VertexAttribIType read new VertexAttribIType($1402);
    public static property UNSIGNED_SHORT: VertexAttribIType read new VertexAttribIType($1403);
    public static property INT:            VertexAttribIType read new VertexAttribIType($1404);
    public static property UNSIGNED_INT:   VertexAttribIType read new VertexAttribIType($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'VertexAttribIType[{self.val}]';
    end;
    
  end;
  
  VertexAttribLType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DOUBLE: VertexAttribLType read new VertexAttribLType($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'VertexAttribLType[{self.val}]';
    end;
    
  end;
  
  VertexAttribPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:                         VertexAttribPointerType read new VertexAttribPointerType($1400);
    public static property UNSIGNED_BYTE:                VertexAttribPointerType read new VertexAttribPointerType($1401);
    public static property SHORT:                        VertexAttribPointerType read new VertexAttribPointerType($1402);
    public static property UNSIGNED_SHORT:               VertexAttribPointerType read new VertexAttribPointerType($1403);
    public static property INT:                          VertexAttribPointerType read new VertexAttribPointerType($1404);
    public static property UNSIGNED_INT:                 VertexAttribPointerType read new VertexAttribPointerType($1405);
    public static property FLOAT:                        VertexAttribPointerType read new VertexAttribPointerType($1406);
    public static property DOUBLE:                       VertexAttribPointerType read new VertexAttribPointerType($140A);
    public static property HALF_FLOAT:                   VertexAttribPointerType read new VertexAttribPointerType($140B);
    public static property FIXED:                        VertexAttribPointerType read new VertexAttribPointerType($140C);
    public static property INT64_ARB:                    VertexAttribPointerType read new VertexAttribPointerType($140E);
    public static property INT64_NV:                     VertexAttribPointerType read new VertexAttribPointerType($140E);
    public static property UNSIGNED_INT64_ARB:           VertexAttribPointerType read new VertexAttribPointerType($140F);
    public static property UNSIGNED_INT64_NV:            VertexAttribPointerType read new VertexAttribPointerType($140F);
    public static property UNSIGNED_INT_2_10_10_10_REV:  VertexAttribPointerType read new VertexAttribPointerType($8368);
    public static property UNSIGNED_INT_10F_11F_11F_REV: VertexAttribPointerType read new VertexAttribPointerType($8C3B);
    public static property INT_2_10_10_10_REV:           VertexAttribPointerType read new VertexAttribPointerType($8D9F);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
      if self.val = UInt32($140B) then Result := 'HALF_FLOAT' else
      if self.val = UInt32($140C) then Result := 'FIXED' else
      if self.val = UInt32($140E) then Result := 'INT64_ARB' else
      if self.val = UInt32($140E) then Result := 'INT64_NV' else
      if self.val = UInt32($140F) then Result := 'UNSIGNED_INT64_ARB' else
      if self.val = UInt32($140F) then Result := 'UNSIGNED_INT64_NV' else
      if self.val = UInt32($8368) then Result := 'UNSIGNED_INT_2_10_10_10_REV' else
      if self.val = UInt32($8C3B) then Result := 'UNSIGNED_INT_10F_11F_11F_REV' else
      if self.val = UInt32($8D9F) then Result := 'INT_2_10_10_10_REV' else
        Result := $'VertexAttribPointerType[{self.val}]';
    end;
    
  end;
  
  VertexAttribType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:                         VertexAttribType read new VertexAttribType($1400);
    public static property UNSIGNED_BYTE:                VertexAttribType read new VertexAttribType($1401);
    public static property SHORT:                        VertexAttribType read new VertexAttribType($1402);
    public static property UNSIGNED_SHORT:               VertexAttribType read new VertexAttribType($1403);
    public static property INT:                          VertexAttribType read new VertexAttribType($1404);
    public static property UNSIGNED_INT:                 VertexAttribType read new VertexAttribType($1405);
    public static property FLOAT:                        VertexAttribType read new VertexAttribType($1406);
    public static property DOUBLE:                       VertexAttribType read new VertexAttribType($140A);
    public static property HALF_FLOAT:                   VertexAttribType read new VertexAttribType($140B);
    public static property FIXED:                        VertexAttribType read new VertexAttribType($140C);
    public static property UNSIGNED_INT_2_10_10_10_REV:  VertexAttribType read new VertexAttribType($8368);
    public static property UNSIGNED_INT_10F_11F_11F_REV: VertexAttribType read new VertexAttribType($8C3B);
    public static property INT_2_10_10_10_REV:           VertexAttribType read new VertexAttribType($8D9F);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
      if self.val = UInt32($140B) then Result := 'HALF_FLOAT' else
      if self.val = UInt32($140C) then Result := 'FIXED' else
      if self.val = UInt32($8368) then Result := 'UNSIGNED_INT_2_10_10_10_REV' else
      if self.val = UInt32($8C3B) then Result := 'UNSIGNED_INT_10F_11F_11F_REV' else
      if self.val = UInt32($8D9F) then Result := 'INT_2_10_10_10_REV' else
        Result := $'VertexAttribType[{self.val}]';
    end;
    
  end;
  
  VertexBufferObjectUsage = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property STREAM_DRAW:  VertexBufferObjectUsage read new VertexBufferObjectUsage($88E0);
    public static property STREAM_READ:  VertexBufferObjectUsage read new VertexBufferObjectUsage($88E1);
    public static property STREAM_COPY:  VertexBufferObjectUsage read new VertexBufferObjectUsage($88E2);
    public static property STATIC_DRAW:  VertexBufferObjectUsage read new VertexBufferObjectUsage($88E4);
    public static property STATIC_READ:  VertexBufferObjectUsage read new VertexBufferObjectUsage($88E5);
    public static property STATIC_COPY:  VertexBufferObjectUsage read new VertexBufferObjectUsage($88E6);
    public static property DYNAMIC_DRAW: VertexBufferObjectUsage read new VertexBufferObjectUsage($88E8);
    public static property DYNAMIC_READ: VertexBufferObjectUsage read new VertexBufferObjectUsage($88E9);
    public static property DYNAMIC_COPY: VertexBufferObjectUsage read new VertexBufferObjectUsage($88EA);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($88E0) then Result := 'STREAM_DRAW' else
      if self.val = UInt32($88E1) then Result := 'STREAM_READ' else
      if self.val = UInt32($88E2) then Result := 'STREAM_COPY' else
      if self.val = UInt32($88E4) then Result := 'STATIC_DRAW' else
      if self.val = UInt32($88E5) then Result := 'STATIC_READ' else
      if self.val = UInt32($88E6) then Result := 'STATIC_COPY' else
      if self.val = UInt32($88E8) then Result := 'DYNAMIC_DRAW' else
      if self.val = UInt32($88E9) then Result := 'DYNAMIC_READ' else
      if self.val = UInt32($88EA) then Result := 'DYNAMIC_COPY' else
        Result := $'VertexBufferObjectUsage[{self.val}]';
    end;
    
  end;
  
  VertexPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SHORT:  VertexPointerType read new VertexPointerType($1402);
    public static property INT:    VertexPointerType read new VertexPointerType($1404);
    public static property FLOAT:  VertexPointerType read new VertexPointerType($1406);
    public static property DOUBLE: VertexPointerType read new VertexPointerType($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'VertexPointerType[{self.val}]';
    end;
    
  end;
  
  VertexProvokingMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FIRST_VERTEX_CONVENTION: VertexProvokingMode read new VertexProvokingMode($8E4D);
    public static property LAST_VERTEX_CONVENTION:  VertexProvokingMode read new VertexProvokingMode($8E4E);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E4D) then Result := 'FIRST_VERTEX_CONVENTION' else
      if self.val = UInt32($8E4E) then Result := 'LAST_VERTEX_CONVENTION' else
        Result := $'VertexProvokingMode[{self.val}]';
    end;
    
  end;
  
  VertexShaderTextureUnitParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CURRENT_TEXTURE_COORDS: VertexShaderTextureUnitParameter read new VertexShaderTextureUnitParameter($0B03);
    public static property TEXTURE_MATRIX:         VertexShaderTextureUnitParameter read new VertexShaderTextureUnitParameter($0BA8);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0B03) then Result := 'CURRENT_TEXTURE_COORDS' else
      if self.val = UInt32($0BA8) then Result := 'TEXTURE_MATRIX' else
        Result := $'VertexShaderTextureUnitParameter[{self.val}]';
    end;
    
  end;
  
  {$endregion Core}
  
  {$region ARB}
  
  BufferAccessARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property READ_ONLY:  BufferAccessARB read new BufferAccessARB($88B8);
    public static property WRITE_ONLY: BufferAccessARB read new BufferAccessARB($88B9);
    public static property READ_WRITE: BufferAccessARB read new BufferAccessARB($88BA);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($88B8) then Result := 'READ_ONLY' else
      if self.val = UInt32($88B9) then Result := 'WRITE_ONLY' else
      if self.val = UInt32($88BA) then Result := 'READ_WRITE' else
        Result := $'BufferAccessARB[{self.val}]';
    end;
    
  end;
  
  BufferPNameARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BUFFER_IMMUTABLE_STORAGE: BufferPNameARB read new BufferPNameARB($821F);
    public static property BUFFER_STORAGE_FLAGS:     BufferPNameARB read new BufferPNameARB($8220);
    public static property BUFFER_SIZE:              BufferPNameARB read new BufferPNameARB($8764);
    public static property BUFFER_SIZE_ARB:          BufferPNameARB read new BufferPNameARB($8764);
    public static property BUFFER_USAGE:             BufferPNameARB read new BufferPNameARB($8765);
    public static property BUFFER_USAGE_ARB:         BufferPNameARB read new BufferPNameARB($8765);
    public static property BUFFER_ACCESS:            BufferPNameARB read new BufferPNameARB($88BB);
    public static property BUFFER_ACCESS_ARB:        BufferPNameARB read new BufferPNameARB($88BB);
    public static property BUFFER_MAPPED:            BufferPNameARB read new BufferPNameARB($88BC);
    public static property BUFFER_MAPPED_ARB:        BufferPNameARB read new BufferPNameARB($88BC);
    public static property BUFFER_ACCESS_FLAGS:      BufferPNameARB read new BufferPNameARB($911F);
    public static property BUFFER_MAP_LENGTH:        BufferPNameARB read new BufferPNameARB($9120);
    public static property BUFFER_MAP_OFFSET:        BufferPNameARB read new BufferPNameARB($9121);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($821F) then Result := 'BUFFER_IMMUTABLE_STORAGE' else
      if self.val = UInt32($8220) then Result := 'BUFFER_STORAGE_FLAGS' else
      if self.val = UInt32($8764) then Result := 'BUFFER_SIZE' else
      if self.val = UInt32($8764) then Result := 'BUFFER_SIZE_ARB' else
      if self.val = UInt32($8765) then Result := 'BUFFER_USAGE' else
      if self.val = UInt32($8765) then Result := 'BUFFER_USAGE_ARB' else
      if self.val = UInt32($88BB) then Result := 'BUFFER_ACCESS' else
      if self.val = UInt32($88BB) then Result := 'BUFFER_ACCESS_ARB' else
      if self.val = UInt32($88BC) then Result := 'BUFFER_MAPPED' else
      if self.val = UInt32($88BC) then Result := 'BUFFER_MAPPED_ARB' else
      if self.val = UInt32($911F) then Result := 'BUFFER_ACCESS_FLAGS' else
      if self.val = UInt32($9120) then Result := 'BUFFER_MAP_LENGTH' else
      if self.val = UInt32($9121) then Result := 'BUFFER_MAP_OFFSET' else
        Result := $'BufferPNameARB[{self.val}]';
    end;
    
  end;
  
  BufferPointerNameARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BUFFER_MAP_POINTER:     BufferPointerNameARB read new BufferPointerNameARB($88BD);
    public static property BUFFER_MAP_POINTER_ARB: BufferPointerNameARB read new BufferPointerNameARB($88BD);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($88BD) then Result := 'BUFFER_MAP_POINTER' else
      if self.val = UInt32($88BD) then Result := 'BUFFER_MAP_POINTER_ARB' else
        Result := $'BufferPointerNameARB[{self.val}]';
    end;
    
  end;
  
  BufferUsageARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property STREAM_DRAW:  BufferUsageARB read new BufferUsageARB($88E0);
    public static property STREAM_READ:  BufferUsageARB read new BufferUsageARB($88E1);
    public static property STREAM_COPY:  BufferUsageARB read new BufferUsageARB($88E2);
    public static property STATIC_DRAW:  BufferUsageARB read new BufferUsageARB($88E4);
    public static property STATIC_READ:  BufferUsageARB read new BufferUsageARB($88E5);
    public static property STATIC_COPY:  BufferUsageARB read new BufferUsageARB($88E6);
    public static property DYNAMIC_DRAW: BufferUsageARB read new BufferUsageARB($88E8);
    public static property DYNAMIC_READ: BufferUsageARB read new BufferUsageARB($88E9);
    public static property DYNAMIC_COPY: BufferUsageARB read new BufferUsageARB($88EA);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($88E0) then Result := 'STREAM_DRAW' else
      if self.val = UInt32($88E1) then Result := 'STREAM_READ' else
      if self.val = UInt32($88E2) then Result := 'STREAM_COPY' else
      if self.val = UInt32($88E4) then Result := 'STATIC_DRAW' else
      if self.val = UInt32($88E5) then Result := 'STATIC_READ' else
      if self.val = UInt32($88E6) then Result := 'STATIC_COPY' else
      if self.val = UInt32($88E8) then Result := 'DYNAMIC_DRAW' else
      if self.val = UInt32($88E9) then Result := 'DYNAMIC_READ' else
      if self.val = UInt32($88EA) then Result := 'DYNAMIC_COPY' else
        Result := $'BufferUsageARB[{self.val}]';
    end;
    
  end;
  
  ClampColorModeARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FALSE:          ClampColorModeARB read new ClampColorModeARB($0000);
    public static property TRUE:           ClampColorModeARB read new ClampColorModeARB($0001);
    public static property FIXED_ONLY:     ClampColorModeARB read new ClampColorModeARB($891D);
    public static property FIXED_ONLY_ARB: ClampColorModeARB read new ClampColorModeARB($891D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'FALSE' else
      if self.val = UInt32($0001) then Result := 'TRUE' else
      if self.val = UInt32($891D) then Result := 'FIXED_ONLY' else
      if self.val = UInt32($891D) then Result := 'FIXED_ONLY_ARB' else
        Result := $'ClampColorModeARB[{self.val}]';
    end;
    
  end;
  
  ClampColorTargetARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CLAMP_VERTEX_COLOR_ARB:   ClampColorTargetARB read new ClampColorTargetARB($891A);
    public static property CLAMP_FRAGMENT_COLOR_ARB: ClampColorTargetARB read new ClampColorTargetARB($891B);
    public static property CLAMP_READ_COLOR:         ClampColorTargetARB read new ClampColorTargetARB($891C);
    public static property CLAMP_READ_COLOR_ARB:     ClampColorTargetARB read new ClampColorTargetARB($891C);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($891A) then Result := 'CLAMP_VERTEX_COLOR_ARB' else
      if self.val = UInt32($891B) then Result := 'CLAMP_FRAGMENT_COLOR_ARB' else
      if self.val = UInt32($891C) then Result := 'CLAMP_READ_COLOR' else
      if self.val = UInt32($891C) then Result := 'CLAMP_READ_COLOR_ARB' else
        Result := $'ClampColorTargetARB[{self.val}]';
    end;
    
  end;
  
  MatrixIndexPointerTypeARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_BYTE:  MatrixIndexPointerTypeARB read new MatrixIndexPointerTypeARB($1401);
    public static property UNSIGNED_SHORT: MatrixIndexPointerTypeARB read new MatrixIndexPointerTypeARB($1403);
    public static property UNSIGNED_INT:   MatrixIndexPointerTypeARB read new MatrixIndexPointerTypeARB($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'MatrixIndexPointerTypeARB[{self.val}]';
    end;
    
  end;
  
  PointParameterNameARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property POINT_SIZE_MIN_EXT:            PointParameterNameARB read new PointParameterNameARB($8126);
    public static property POINT_SIZE_MAX_EXT:            PointParameterNameARB read new PointParameterNameARB($8127);
    public static property POINT_FADE_THRESHOLD_SIZE:     PointParameterNameARB read new PointParameterNameARB($8128);
    public static property POINT_FADE_THRESHOLD_SIZE_EXT: PointParameterNameARB read new PointParameterNameARB($8128);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8126) then Result := 'POINT_SIZE_MIN_EXT' else
      if self.val = UInt32($8127) then Result := 'POINT_SIZE_MAX_EXT' else
      if self.val = UInt32($8128) then Result := 'POINT_FADE_THRESHOLD_SIZE' else
      if self.val = UInt32($8128) then Result := 'POINT_FADE_THRESHOLD_SIZE_EXT' else
        Result := $'PointParameterNameARB[{self.val}]';
    end;
    
  end;
  
  ProgramPropertyARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COMPUTE_WORK_GROUP_SIZE:               ProgramPropertyARB read new ProgramPropertyARB($8267);
    public static property PROGRAM_BINARY_LENGTH:                 ProgramPropertyARB read new ProgramPropertyARB($8741);
    public static property GEOMETRY_VERTICES_OUT:                 ProgramPropertyARB read new ProgramPropertyARB($8916);
    public static property GEOMETRY_INPUT_TYPE:                   ProgramPropertyARB read new ProgramPropertyARB($8917);
    public static property GEOMETRY_OUTPUT_TYPE:                  ProgramPropertyARB read new ProgramPropertyARB($8918);
    public static property ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH:  ProgramPropertyARB read new ProgramPropertyARB($8A35);
    public static property ACTIVE_UNIFORM_BLOCKS:                 ProgramPropertyARB read new ProgramPropertyARB($8A36);
    public static property DELETE_STATUS:                         ProgramPropertyARB read new ProgramPropertyARB($8B80);
    public static property LINK_STATUS:                           ProgramPropertyARB read new ProgramPropertyARB($8B82);
    public static property VALIDATE_STATUS:                       ProgramPropertyARB read new ProgramPropertyARB($8B83);
    public static property INFO_LOG_LENGTH:                       ProgramPropertyARB read new ProgramPropertyARB($8B84);
    public static property ATTACHED_SHADERS:                      ProgramPropertyARB read new ProgramPropertyARB($8B85);
    public static property ACTIVE_UNIFORMS:                       ProgramPropertyARB read new ProgramPropertyARB($8B86);
    public static property ACTIVE_UNIFORM_MAX_LENGTH:             ProgramPropertyARB read new ProgramPropertyARB($8B87);
    public static property ACTIVE_ATTRIBUTES:                     ProgramPropertyARB read new ProgramPropertyARB($8B89);
    public static property ACTIVE_ATTRIBUTE_MAX_LENGTH:           ProgramPropertyARB read new ProgramPropertyARB($8B8A);
    public static property TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH: ProgramPropertyARB read new ProgramPropertyARB($8C76);
    public static property TRANSFORM_FEEDBACK_BUFFER_MODE:        ProgramPropertyARB read new ProgramPropertyARB($8C7F);
    public static property TRANSFORM_FEEDBACK_VARYINGS:           ProgramPropertyARB read new ProgramPropertyARB($8C83);
    public static property ACTIVE_ATOMIC_COUNTER_BUFFERS:         ProgramPropertyARB read new ProgramPropertyARB($92D9);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8267) then Result := 'COMPUTE_WORK_GROUP_SIZE' else
      if self.val = UInt32($8741) then Result := 'PROGRAM_BINARY_LENGTH' else
      if self.val = UInt32($8916) then Result := 'GEOMETRY_VERTICES_OUT' else
      if self.val = UInt32($8917) then Result := 'GEOMETRY_INPUT_TYPE' else
      if self.val = UInt32($8918) then Result := 'GEOMETRY_OUTPUT_TYPE' else
      if self.val = UInt32($8A35) then Result := 'ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH' else
      if self.val = UInt32($8A36) then Result := 'ACTIVE_UNIFORM_BLOCKS' else
      if self.val = UInt32($8B80) then Result := 'DELETE_STATUS' else
      if self.val = UInt32($8B82) then Result := 'LINK_STATUS' else
      if self.val = UInt32($8B83) then Result := 'VALIDATE_STATUS' else
      if self.val = UInt32($8B84) then Result := 'INFO_LOG_LENGTH' else
      if self.val = UInt32($8B85) then Result := 'ATTACHED_SHADERS' else
      if self.val = UInt32($8B86) then Result := 'ACTIVE_UNIFORMS' else
      if self.val = UInt32($8B87) then Result := 'ACTIVE_UNIFORM_MAX_LENGTH' else
      if self.val = UInt32($8B89) then Result := 'ACTIVE_ATTRIBUTES' else
      if self.val = UInt32($8B8A) then Result := 'ACTIVE_ATTRIBUTE_MAX_LENGTH' else
      if self.val = UInt32($8C76) then Result := 'TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH' else
      if self.val = UInt32($8C7F) then Result := 'TRANSFORM_FEEDBACK_BUFFER_MODE' else
      if self.val = UInt32($8C83) then Result := 'TRANSFORM_FEEDBACK_VARYINGS' else
      if self.val = UInt32($92D9) then Result := 'ACTIVE_ATOMIC_COUNTER_BUFFERS' else
        Result := $'ProgramPropertyARB[{self.val}]';
    end;
    
  end;
  
  VertexAttribPointerPropertyARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_ATTRIB_ARRAY_POINTER:     VertexAttribPointerPropertyARB read new VertexAttribPointerPropertyARB($8645);
    public static property VERTEX_ATTRIB_ARRAY_POINTER_ARB: VertexAttribPointerPropertyARB read new VertexAttribPointerPropertyARB($8645);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8645) then Result := 'VERTEX_ATTRIB_ARRAY_POINTER' else
      if self.val = UInt32($8645) then Result := 'VERTEX_ATTRIB_ARRAY_POINTER_ARB' else
        Result := $'VertexAttribPointerPropertyARB[{self.val}]';
    end;
    
  end;
  
  VertexAttribPropertyARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_ATTRIB_BINDING:              VertexAttribPropertyARB read new VertexAttribPropertyARB($82D4);
    public static property VERTEX_ATTRIB_RELATIVE_OFFSET:      VertexAttribPropertyARB read new VertexAttribPropertyARB($82D5);
    public static property VERTEX_ATTRIB_ARRAY_ENABLED:        VertexAttribPropertyARB read new VertexAttribPropertyARB($8622);
    public static property VERTEX_ATTRIB_ARRAY_SIZE:           VertexAttribPropertyARB read new VertexAttribPropertyARB($8623);
    public static property VERTEX_ATTRIB_ARRAY_STRIDE:         VertexAttribPropertyARB read new VertexAttribPropertyARB($8624);
    public static property VERTEX_ATTRIB_ARRAY_TYPE:           VertexAttribPropertyARB read new VertexAttribPropertyARB($8625);
    public static property CURRENT_VERTEX_ATTRIB:              VertexAttribPropertyARB read new VertexAttribPropertyARB($8626);
    public static property VERTEX_ATTRIB_ARRAY_LONG:           VertexAttribPropertyARB read new VertexAttribPropertyARB($874E);
    public static property VERTEX_ATTRIB_ARRAY_NORMALIZED:     VertexAttribPropertyARB read new VertexAttribPropertyARB($886A);
    public static property VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: VertexAttribPropertyARB read new VertexAttribPropertyARB($889F);
    public static property VERTEX_ATTRIB_ARRAY_INTEGER:        VertexAttribPropertyARB read new VertexAttribPropertyARB($88FD);
    public static property VERTEX_ATTRIB_ARRAY_INTEGER_EXT:    VertexAttribPropertyARB read new VertexAttribPropertyARB($88FD);
    public static property VERTEX_ATTRIB_ARRAY_DIVISOR:        VertexAttribPropertyARB read new VertexAttribPropertyARB($88FE);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($82D4) then Result := 'VERTEX_ATTRIB_BINDING' else
      if self.val = UInt32($82D5) then Result := 'VERTEX_ATTRIB_RELATIVE_OFFSET' else
      if self.val = UInt32($8622) then Result := 'VERTEX_ATTRIB_ARRAY_ENABLED' else
      if self.val = UInt32($8623) then Result := 'VERTEX_ATTRIB_ARRAY_SIZE' else
      if self.val = UInt32($8624) then Result := 'VERTEX_ATTRIB_ARRAY_STRIDE' else
      if self.val = UInt32($8625) then Result := 'VERTEX_ATTRIB_ARRAY_TYPE' else
      if self.val = UInt32($8626) then Result := 'CURRENT_VERTEX_ATTRIB' else
      if self.val = UInt32($874E) then Result := 'VERTEX_ATTRIB_ARRAY_LONG' else
      if self.val = UInt32($886A) then Result := 'VERTEX_ATTRIB_ARRAY_NORMALIZED' else
      if self.val = UInt32($889F) then Result := 'VERTEX_ATTRIB_ARRAY_BUFFER_BINDING' else
      if self.val = UInt32($88FD) then Result := 'VERTEX_ATTRIB_ARRAY_INTEGER' else
      if self.val = UInt32($88FD) then Result := 'VERTEX_ATTRIB_ARRAY_INTEGER_EXT' else
      if self.val = UInt32($88FE) then Result := 'VERTEX_ATTRIB_ARRAY_DIVISOR' else
        Result := $'VertexAttribPropertyARB[{self.val}]';
    end;
    
  end;
  
  WeightPointerTypeARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:           WeightPointerTypeARB read new WeightPointerTypeARB($1400);
    public static property UNSIGNED_BYTE:  WeightPointerTypeARB read new WeightPointerTypeARB($1401);
    public static property SHORT:          WeightPointerTypeARB read new WeightPointerTypeARB($1402);
    public static property UNSIGNED_SHORT: WeightPointerTypeARB read new WeightPointerTypeARB($1403);
    public static property INT:            WeightPointerTypeARB read new WeightPointerTypeARB($1404);
    public static property UNSIGNED_INT:   WeightPointerTypeARB read new WeightPointerTypeARB($1405);
    public static property FLOAT:          WeightPointerTypeARB read new WeightPointerTypeARB($1406);
    public static property DOUBLE:         WeightPointerTypeARB read new WeightPointerTypeARB($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'WeightPointerTypeARB[{self.val}]';
    end;
    
  end;
  
  {$endregion ARB}
  
  {$region EXT}
  
  BinormalPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:       BinormalPointerTypeEXT read new BinormalPointerTypeEXT($1400);
    public static property SHORT:      BinormalPointerTypeEXT read new BinormalPointerTypeEXT($1402);
    public static property INT:        BinormalPointerTypeEXT read new BinormalPointerTypeEXT($1404);
    public static property FLOAT:      BinormalPointerTypeEXT read new BinormalPointerTypeEXT($1406);
    public static property DOUBLE:     BinormalPointerTypeEXT read new BinormalPointerTypeEXT($140A);
    public static property DOUBLE_EXT: BinormalPointerTypeEXT read new BinormalPointerTypeEXT($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
      if self.val = UInt32($140A) then Result := 'DOUBLE_EXT' else
        Result := $'BinormalPointerTypeEXT[{self.val}]';
    end;
    
  end;
  
  BlendEquationModeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FUNC_ADD:                  BlendEquationModeEXT read new BlendEquationModeEXT($8006);
    public static property FUNC_ADD_EXT:              BlendEquationModeEXT read new BlendEquationModeEXT($8006);
    public static property MIN:                       BlendEquationModeEXT read new BlendEquationModeEXT($8007);
    public static property MIN_EXT:                   BlendEquationModeEXT read new BlendEquationModeEXT($8007);
    public static property MAX:                       BlendEquationModeEXT read new BlendEquationModeEXT($8008);
    public static property MAX_EXT:                   BlendEquationModeEXT read new BlendEquationModeEXT($8008);
    public static property FUNC_SUBTRACT:             BlendEquationModeEXT read new BlendEquationModeEXT($800A);
    public static property FUNC_SUBTRACT_EXT:         BlendEquationModeEXT read new BlendEquationModeEXT($800A);
    public static property FUNC_REVERSE_SUBTRACT:     BlendEquationModeEXT read new BlendEquationModeEXT($800B);
    public static property FUNC_REVERSE_SUBTRACT_EXT: BlendEquationModeEXT read new BlendEquationModeEXT($800B);
    public static property ALPHA_MIN_SGIX:            BlendEquationModeEXT read new BlendEquationModeEXT($8320);
    public static property ALPHA_MAX_SGIX:            BlendEquationModeEXT read new BlendEquationModeEXT($8321);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8006) then Result := 'FUNC_ADD' else
      if self.val = UInt32($8006) then Result := 'FUNC_ADD_EXT' else
      if self.val = UInt32($8007) then Result := 'MIN' else
      if self.val = UInt32($8007) then Result := 'MIN_EXT' else
      if self.val = UInt32($8008) then Result := 'MAX' else
      if self.val = UInt32($8008) then Result := 'MAX_EXT' else
      if self.val = UInt32($800A) then Result := 'FUNC_SUBTRACT' else
      if self.val = UInt32($800A) then Result := 'FUNC_SUBTRACT_EXT' else
      if self.val = UInt32($800B) then Result := 'FUNC_REVERSE_SUBTRACT' else
      if self.val = UInt32($800B) then Result := 'FUNC_REVERSE_SUBTRACT_EXT' else
      if self.val = UInt32($8320) then Result := 'ALPHA_MIN_SGIX' else
      if self.val = UInt32($8321) then Result := 'ALPHA_MAX_SGIX' else
        Result := $'BlendEquationModeEXT[{self.val}]';
    end;
    
  end;
  
  ConvolutionParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CONVOLUTION_BORDER_MODE:      ConvolutionParameterEXT read new ConvolutionParameterEXT($8013);
    public static property CONVOLUTION_BORDER_MODE_EXT:  ConvolutionParameterEXT read new ConvolutionParameterEXT($8013);
    public static property CONVOLUTION_FILTER_SCALE:     ConvolutionParameterEXT read new ConvolutionParameterEXT($8014);
    public static property CONVOLUTION_FILTER_SCALE_EXT: ConvolutionParameterEXT read new ConvolutionParameterEXT($8014);
    public static property CONVOLUTION_FILTER_BIAS:      ConvolutionParameterEXT read new ConvolutionParameterEXT($8015);
    public static property CONVOLUTION_FILTER_BIAS_EXT:  ConvolutionParameterEXT read new ConvolutionParameterEXT($8015);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8013) then Result := 'CONVOLUTION_BORDER_MODE' else
      if self.val = UInt32($8013) then Result := 'CONVOLUTION_BORDER_MODE_EXT' else
      if self.val = UInt32($8014) then Result := 'CONVOLUTION_FILTER_SCALE' else
      if self.val = UInt32($8014) then Result := 'CONVOLUTION_FILTER_SCALE_EXT' else
      if self.val = UInt32($8015) then Result := 'CONVOLUTION_FILTER_BIAS' else
      if self.val = UInt32($8015) then Result := 'CONVOLUTION_FILTER_BIAS_EXT' else
        Result := $'ConvolutionParameterEXT[{self.val}]';
    end;
    
  end;
  
  ConvolutionTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CONVOLUTION_1D:     ConvolutionTargetEXT read new ConvolutionTargetEXT($8010);
    public static property CONVOLUTION_1D_EXT: ConvolutionTargetEXT read new ConvolutionTargetEXT($8010);
    public static property CONVOLUTION_2D:     ConvolutionTargetEXT read new ConvolutionTargetEXT($8011);
    public static property CONVOLUTION_2D_EXT: ConvolutionTargetEXT read new ConvolutionTargetEXT($8011);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8010) then Result := 'CONVOLUTION_1D' else
      if self.val = UInt32($8010) then Result := 'CONVOLUTION_1D_EXT' else
      if self.val = UInt32($8011) then Result := 'CONVOLUTION_2D' else
      if self.val = UInt32($8011) then Result := 'CONVOLUTION_2D_EXT' else
        Result := $'ConvolutionTargetEXT[{self.val}]';
    end;
    
  end;
  
  CullParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CULL_VERTEX_EYE_POSITION_EXT:    CullParameterEXT read new CullParameterEXT($81AB);
    public static property CULL_VERTEX_OBJECT_POSITION_EXT: CullParameterEXT read new CullParameterEXT($81AC);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($81AB) then Result := 'CULL_VERTEX_EYE_POSITION_EXT' else
      if self.val = UInt32($81AC) then Result := 'CULL_VERTEX_OBJECT_POSITION_EXT' else
        Result := $'CullParameterEXT[{self.val}]';
    end;
    
  end;
  
  DataTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SCALAR_EXT: DataTypeEXT read new DataTypeEXT($87BE);
    public static property VECTOR_EXT: DataTypeEXT read new DataTypeEXT($87BF);
    public static property MATRIX_EXT: DataTypeEXT read new DataTypeEXT($87C0);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87BE) then Result := 'SCALAR_EXT' else
      if self.val = UInt32($87BF) then Result := 'VECTOR_EXT' else
      if self.val = UInt32($87C0) then Result := 'MATRIX_EXT' else
        Result := $'DataTypeEXT[{self.val}]';
    end;
    
  end;
  
  FogPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FLOAT:  FogPointerTypeEXT read new FogPointerTypeEXT($1406);
    public static property DOUBLE: FogPointerTypeEXT read new FogPointerTypeEXT($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'FogPointerTypeEXT[{self.val}]';
    end;
    
  end;
  
  GetHistogramParameterPNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property HISTOGRAM_WIDTH:              GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8026);
    public static property HISTOGRAM_WIDTH_EXT:          GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8026);
    public static property HISTOGRAM_FORMAT:             GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8027);
    public static property HISTOGRAM_FORMAT_EXT:         GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8027);
    public static property HISTOGRAM_RED_SIZE:           GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8028);
    public static property HISTOGRAM_RED_SIZE_EXT:       GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8028);
    public static property HISTOGRAM_GREEN_SIZE:         GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8029);
    public static property HISTOGRAM_GREEN_SIZE_EXT:     GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($8029);
    public static property HISTOGRAM_BLUE_SIZE:          GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802A);
    public static property HISTOGRAM_BLUE_SIZE_EXT:      GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802A);
    public static property HISTOGRAM_ALPHA_SIZE:         GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802B);
    public static property HISTOGRAM_ALPHA_SIZE_EXT:     GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802B);
    public static property HISTOGRAM_LUMINANCE_SIZE:     GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802C);
    public static property HISTOGRAM_LUMINANCE_SIZE_EXT: GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802C);
    public static property HISTOGRAM_SINK:               GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802D);
    public static property HISTOGRAM_SINK_EXT:           GetHistogramParameterPNameEXT read new GetHistogramParameterPNameEXT($802D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8026) then Result := 'HISTOGRAM_WIDTH' else
      if self.val = UInt32($8026) then Result := 'HISTOGRAM_WIDTH_EXT' else
      if self.val = UInt32($8027) then Result := 'HISTOGRAM_FORMAT' else
      if self.val = UInt32($8027) then Result := 'HISTOGRAM_FORMAT_EXT' else
      if self.val = UInt32($8028) then Result := 'HISTOGRAM_RED_SIZE' else
      if self.val = UInt32($8028) then Result := 'HISTOGRAM_RED_SIZE_EXT' else
      if self.val = UInt32($8029) then Result := 'HISTOGRAM_GREEN_SIZE' else
      if self.val = UInt32($8029) then Result := 'HISTOGRAM_GREEN_SIZE_EXT' else
      if self.val = UInt32($802A) then Result := 'HISTOGRAM_BLUE_SIZE' else
      if self.val = UInt32($802A) then Result := 'HISTOGRAM_BLUE_SIZE_EXT' else
      if self.val = UInt32($802B) then Result := 'HISTOGRAM_ALPHA_SIZE' else
      if self.val = UInt32($802B) then Result := 'HISTOGRAM_ALPHA_SIZE_EXT' else
      if self.val = UInt32($802C) then Result := 'HISTOGRAM_LUMINANCE_SIZE' else
      if self.val = UInt32($802C) then Result := 'HISTOGRAM_LUMINANCE_SIZE_EXT' else
      if self.val = UInt32($802D) then Result := 'HISTOGRAM_SINK' else
      if self.val = UInt32($802D) then Result := 'HISTOGRAM_SINK_EXT' else
        Result := $'GetHistogramParameterPNameEXT[{self.val}]';
    end;
    
  end;
  
  GetMinmaxParameterPNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MINMAX_FORMAT:     GetMinmaxParameterPNameEXT read new GetMinmaxParameterPNameEXT($802F);
    public static property MINMAX_FORMAT_EXT: GetMinmaxParameterPNameEXT read new GetMinmaxParameterPNameEXT($802F);
    public static property MINMAX_SINK:       GetMinmaxParameterPNameEXT read new GetMinmaxParameterPNameEXT($8030);
    public static property MINMAX_SINK_EXT:   GetMinmaxParameterPNameEXT read new GetMinmaxParameterPNameEXT($8030);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($802F) then Result := 'MINMAX_FORMAT' else
      if self.val = UInt32($802F) then Result := 'MINMAX_FORMAT_EXT' else
      if self.val = UInt32($8030) then Result := 'MINMAX_SINK' else
      if self.val = UInt32($8030) then Result := 'MINMAX_SINK_EXT' else
        Result := $'GetMinmaxParameterPNameEXT[{self.val}]';
    end;
    
  end;
  
  GetVariantValueEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VARIANT_VALUE_EXT:        GetVariantValueEXT read new GetVariantValueEXT($87E4);
    public static property VARIANT_DATATYPE_EXT:     GetVariantValueEXT read new GetVariantValueEXT($87E5);
    public static property VARIANT_ARRAY_STRIDE_EXT: GetVariantValueEXT read new GetVariantValueEXT($87E6);
    public static property VARIANT_ARRAY_TYPE_EXT:   GetVariantValueEXT read new GetVariantValueEXT($87E7);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87E4) then Result := 'VARIANT_VALUE_EXT' else
      if self.val = UInt32($87E5) then Result := 'VARIANT_DATATYPE_EXT' else
      if self.val = UInt32($87E6) then Result := 'VARIANT_ARRAY_STRIDE_EXT' else
      if self.val = UInt32($87E7) then Result := 'VARIANT_ARRAY_TYPE_EXT' else
        Result := $'GetVariantValueEXT[{self.val}]';
    end;
    
  end;
  
  HistogramTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property HISTOGRAM:           HistogramTargetEXT read new HistogramTargetEXT($8024);
    public static property HISTOGRAM_EXT:       HistogramTargetEXT read new HistogramTargetEXT($8024);
    public static property PROXY_HISTOGRAM:     HistogramTargetEXT read new HistogramTargetEXT($8025);
    public static property PROXY_HISTOGRAM_EXT: HistogramTargetEXT read new HistogramTargetEXT($8025);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8024) then Result := 'HISTOGRAM' else
      if self.val = UInt32($8024) then Result := 'HISTOGRAM_EXT' else
      if self.val = UInt32($8025) then Result := 'PROXY_HISTOGRAM' else
      if self.val = UInt32($8025) then Result := 'PROXY_HISTOGRAM_EXT' else
        Result := $'HistogramTargetEXT[{self.val}]';
    end;
    
  end;
  
  IndexFunctionEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NEVER:    IndexFunctionEXT read new IndexFunctionEXT($0200);
    public static property LESS:     IndexFunctionEXT read new IndexFunctionEXT($0201);
    public static property EQUAL:    IndexFunctionEXT read new IndexFunctionEXT($0202);
    public static property LEQUAL:   IndexFunctionEXT read new IndexFunctionEXT($0203);
    public static property GREATER:  IndexFunctionEXT read new IndexFunctionEXT($0204);
    public static property NOTEQUAL: IndexFunctionEXT read new IndexFunctionEXT($0205);
    public static property GEQUAL:   IndexFunctionEXT read new IndexFunctionEXT($0206);
    public static property ALWAYS:   IndexFunctionEXT read new IndexFunctionEXT($0207);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0200) then Result := 'NEVER' else
      if self.val = UInt32($0201) then Result := 'LESS' else
      if self.val = UInt32($0202) then Result := 'EQUAL' else
      if self.val = UInt32($0203) then Result := 'LEQUAL' else
      if self.val = UInt32($0204) then Result := 'GREATER' else
      if self.val = UInt32($0205) then Result := 'NOTEQUAL' else
      if self.val = UInt32($0206) then Result := 'GEQUAL' else
      if self.val = UInt32($0207) then Result := 'ALWAYS' else
        Result := $'IndexFunctionEXT[{self.val}]';
    end;
    
  end;
  
  IndexMaterialParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property INDEX_OFFSET: IndexMaterialParameterEXT read new IndexMaterialParameterEXT($0D13);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0D13) then Result := 'INDEX_OFFSET' else
        Result := $'IndexMaterialParameterEXT[{self.val}]';
    end;
    
  end;
  
  LightTextureModeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAGMENT_MATERIAL_EXT: LightTextureModeEXT read new LightTextureModeEXT($8349);
    public static property FRAGMENT_NORMAL_EXT:   LightTextureModeEXT read new LightTextureModeEXT($834A);
    public static property FRAGMENT_COLOR_EXT:    LightTextureModeEXT read new LightTextureModeEXT($834C);
    public static property FRAGMENT_DEPTH_EXT:    LightTextureModeEXT read new LightTextureModeEXT($8452);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8349) then Result := 'FRAGMENT_MATERIAL_EXT' else
      if self.val = UInt32($834A) then Result := 'FRAGMENT_NORMAL_EXT' else
      if self.val = UInt32($834C) then Result := 'FRAGMENT_COLOR_EXT' else
      if self.val = UInt32($8452) then Result := 'FRAGMENT_DEPTH_EXT' else
        Result := $'LightTextureModeEXT[{self.val}]';
    end;
    
  end;
  
  LightTexturePNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ATTENUATION_EXT:        LightTexturePNameEXT read new LightTexturePNameEXT($834D);
    public static property SHADOW_ATTENUATION_EXT: LightTexturePNameEXT read new LightTexturePNameEXT($834E);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($834D) then Result := 'ATTENUATION_EXT' else
      if self.val = UInt32($834E) then Result := 'SHADOW_ATTENUATION_EXT' else
        Result := $'LightTexturePNameEXT[{self.val}]';
    end;
    
  end;
  
  MinmaxTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MINMAX:     MinmaxTargetEXT read new MinmaxTargetEXT($802E);
    public static property MINMAX_EXT: MinmaxTargetEXT read new MinmaxTargetEXT($802E);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($802E) then Result := 'MINMAX' else
      if self.val = UInt32($802E) then Result := 'MINMAX_EXT' else
        Result := $'MinmaxTargetEXT[{self.val}]';
    end;
    
  end;
  
  ParameterRangeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NORMALIZED_RANGE_EXT: ParameterRangeEXT read new ParameterRangeEXT($87E0);
    public static property FULL_RANGE_EXT:       ParameterRangeEXT read new ParameterRangeEXT($87E1);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87E0) then Result := 'NORMALIZED_RANGE_EXT' else
      if self.val = UInt32($87E1) then Result := 'FULL_RANGE_EXT' else
        Result := $'ParameterRangeEXT[{self.val}]';
    end;
    
  end;
  
  PixelTransformPNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PIXEL_MAG_FILTER_EXT:   PixelTransformPNameEXT read new PixelTransformPNameEXT($8331);
    public static property PIXEL_MIN_FILTER_EXT:   PixelTransformPNameEXT read new PixelTransformPNameEXT($8332);
    public static property PIXEL_CUBIC_WEIGHT_EXT: PixelTransformPNameEXT read new PixelTransformPNameEXT($8333);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8331) then Result := 'PIXEL_MAG_FILTER_EXT' else
      if self.val = UInt32($8332) then Result := 'PIXEL_MIN_FILTER_EXT' else
      if self.val = UInt32($8333) then Result := 'PIXEL_CUBIC_WEIGHT_EXT' else
        Result := $'PixelTransformPNameEXT[{self.val}]';
    end;
    
  end;
  
  PixelTransformTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PIXEL_TRANSFORM_2D_EXT: PixelTransformTargetEXT read new PixelTransformTargetEXT($8330);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8330) then Result := 'PIXEL_TRANSFORM_2D_EXT' else
        Result := $'PixelTransformTargetEXT[{self.val}]';
    end;
    
  end;
  
  SamplePatternEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property GL_1PASS_EXT:   SamplePatternEXT read new SamplePatternEXT($80A1);
    public static property GL_2PASS_0_EXT: SamplePatternEXT read new SamplePatternEXT($80A2);
    public static property GL_2PASS_1_EXT: SamplePatternEXT read new SamplePatternEXT($80A3);
    public static property GL_4PASS_0_EXT: SamplePatternEXT read new SamplePatternEXT($80A4);
    public static property GL_4PASS_1_EXT: SamplePatternEXT read new SamplePatternEXT($80A5);
    public static property GL_4PASS_2_EXT: SamplePatternEXT read new SamplePatternEXT($80A6);
    public static property GL_4PASS_3_EXT: SamplePatternEXT read new SamplePatternEXT($80A7);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80A1) then Result := 'GL_1PASS_EXT' else
      if self.val = UInt32($80A2) then Result := 'GL_2PASS_0_EXT' else
      if self.val = UInt32($80A3) then Result := 'GL_2PASS_1_EXT' else
      if self.val = UInt32($80A4) then Result := 'GL_4PASS_0_EXT' else
      if self.val = UInt32($80A5) then Result := 'GL_4PASS_1_EXT' else
      if self.val = UInt32($80A6) then Result := 'GL_4PASS_2_EXT' else
      if self.val = UInt32($80A7) then Result := 'GL_4PASS_3_EXT' else
        Result := $'SamplePatternEXT[{self.val}]';
    end;
    
  end;
  
  SeparableTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SEPARABLE_2D:     SeparableTargetEXT read new SeparableTargetEXT($8012);
    public static property SEPARABLE_2D_EXT: SeparableTargetEXT read new SeparableTargetEXT($8012);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8012) then Result := 'SEPARABLE_2D' else
      if self.val = UInt32($8012) then Result := 'SEPARABLE_2D_EXT' else
        Result := $'SeparableTargetEXT[{self.val}]';
    end;
    
  end;
  
  TangentPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BYTE:       TangentPointerTypeEXT read new TangentPointerTypeEXT($1400);
    public static property SHORT:      TangentPointerTypeEXT read new TangentPointerTypeEXT($1402);
    public static property INT:        TangentPointerTypeEXT read new TangentPointerTypeEXT($1404);
    public static property FLOAT:      TangentPointerTypeEXT read new TangentPointerTypeEXT($1406);
    public static property DOUBLE:     TangentPointerTypeEXT read new TangentPointerTypeEXT($140A);
    public static property DOUBLE_EXT: TangentPointerTypeEXT read new TangentPointerTypeEXT($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1400) then Result := 'BYTE' else
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
      if self.val = UInt32($140A) then Result := 'DOUBLE_EXT' else
        Result := $'TangentPointerTypeEXT[{self.val}]';
    end;
    
  end;
  
  TextureNormalModeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PERTURB_EXT: TextureNormalModeEXT read new TextureNormalModeEXT($85AE);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($85AE) then Result := 'PERTURB_EXT' else
        Result := $'TextureNormalModeEXT[{self.val}]';
    end;
    
  end;
  
  VariantCapEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VARIANT_ARRAY_EXT: VariantCapEXT read new VariantCapEXT($87E8);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87E8) then Result := 'VARIANT_ARRAY_EXT' else
        Result := $'VariantCapEXT[{self.val}]';
    end;
    
  end;
  
  VertexShaderCoordOutEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property X_EXT:            VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87D5);
    public static property Y_EXT:            VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87D6);
    public static property Z_EXT:            VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87D7);
    public static property W_EXT:            VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87D8);
    public static property NEGATIVE_X_EXT:   VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87D9);
    public static property NEGATIVE_Y_EXT:   VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87DA);
    public static property NEGATIVE_Z_EXT:   VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87DB);
    public static property NEGATIVE_W_EXT:   VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87DC);
    public static property ZERO_EXT:         VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87DD);
    public static property ONE_EXT:          VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87DE);
    public static property NEGATIVE_ONE_EXT: VertexShaderCoordOutEXT read new VertexShaderCoordOutEXT($87DF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87D5) then Result := 'X_EXT' else
      if self.val = UInt32($87D6) then Result := 'Y_EXT' else
      if self.val = UInt32($87D7) then Result := 'Z_EXT' else
      if self.val = UInt32($87D8) then Result := 'W_EXT' else
      if self.val = UInt32($87D9) then Result := 'NEGATIVE_X_EXT' else
      if self.val = UInt32($87DA) then Result := 'NEGATIVE_Y_EXT' else
      if self.val = UInt32($87DB) then Result := 'NEGATIVE_Z_EXT' else
      if self.val = UInt32($87DC) then Result := 'NEGATIVE_W_EXT' else
      if self.val = UInt32($87DD) then Result := 'ZERO_EXT' else
      if self.val = UInt32($87DE) then Result := 'ONE_EXT' else
      if self.val = UInt32($87DF) then Result := 'NEGATIVE_ONE_EXT' else
        Result := $'VertexShaderCoordOutEXT[{self.val}]';
    end;
    
  end;
  
  VertexShaderOpEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property OP_INDEX_EXT:           VertexShaderOpEXT read new VertexShaderOpEXT($8782);
    public static property OP_NEGATE_EXT:          VertexShaderOpEXT read new VertexShaderOpEXT($8783);
    public static property OP_DOT3_EXT:            VertexShaderOpEXT read new VertexShaderOpEXT($8784);
    public static property OP_DOT4_EXT:            VertexShaderOpEXT read new VertexShaderOpEXT($8785);
    public static property OP_MUL_EXT:             VertexShaderOpEXT read new VertexShaderOpEXT($8786);
    public static property OP_ADD_EXT:             VertexShaderOpEXT read new VertexShaderOpEXT($8787);
    public static property OP_MADD_EXT:            VertexShaderOpEXT read new VertexShaderOpEXT($8788);
    public static property OP_FRAC_EXT:            VertexShaderOpEXT read new VertexShaderOpEXT($8789);
    public static property OP_MAX_EXT:             VertexShaderOpEXT read new VertexShaderOpEXT($878A);
    public static property OP_MIN_EXT:             VertexShaderOpEXT read new VertexShaderOpEXT($878B);
    public static property OP_SET_GE_EXT:          VertexShaderOpEXT read new VertexShaderOpEXT($878C);
    public static property OP_SET_LT_EXT:          VertexShaderOpEXT read new VertexShaderOpEXT($878D);
    public static property OP_CLAMP_EXT:           VertexShaderOpEXT read new VertexShaderOpEXT($878E);
    public static property OP_FLOOR_EXT:           VertexShaderOpEXT read new VertexShaderOpEXT($878F);
    public static property OP_ROUND_EXT:           VertexShaderOpEXT read new VertexShaderOpEXT($8790);
    public static property OP_EXP_BASE_2_EXT:      VertexShaderOpEXT read new VertexShaderOpEXT($8791);
    public static property OP_LOG_BASE_2_EXT:      VertexShaderOpEXT read new VertexShaderOpEXT($8792);
    public static property OP_POWER_EXT:           VertexShaderOpEXT read new VertexShaderOpEXT($8793);
    public static property OP_RECIP_EXT:           VertexShaderOpEXT read new VertexShaderOpEXT($8794);
    public static property OP_RECIP_SQRT_EXT:      VertexShaderOpEXT read new VertexShaderOpEXT($8795);
    public static property OP_SUB_EXT:             VertexShaderOpEXT read new VertexShaderOpEXT($8796);
    public static property OP_CROSS_PRODUCT_EXT:   VertexShaderOpEXT read new VertexShaderOpEXT($8797);
    public static property OP_MULTIPLY_MATRIX_EXT: VertexShaderOpEXT read new VertexShaderOpEXT($8798);
    public static property OP_MOV_EXT:             VertexShaderOpEXT read new VertexShaderOpEXT($8799);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8782) then Result := 'OP_INDEX_EXT' else
      if self.val = UInt32($8783) then Result := 'OP_NEGATE_EXT' else
      if self.val = UInt32($8784) then Result := 'OP_DOT3_EXT' else
      if self.val = UInt32($8785) then Result := 'OP_DOT4_EXT' else
      if self.val = UInt32($8786) then Result := 'OP_MUL_EXT' else
      if self.val = UInt32($8787) then Result := 'OP_ADD_EXT' else
      if self.val = UInt32($8788) then Result := 'OP_MADD_EXT' else
      if self.val = UInt32($8789) then Result := 'OP_FRAC_EXT' else
      if self.val = UInt32($878A) then Result := 'OP_MAX_EXT' else
      if self.val = UInt32($878B) then Result := 'OP_MIN_EXT' else
      if self.val = UInt32($878C) then Result := 'OP_SET_GE_EXT' else
      if self.val = UInt32($878D) then Result := 'OP_SET_LT_EXT' else
      if self.val = UInt32($878E) then Result := 'OP_CLAMP_EXT' else
      if self.val = UInt32($878F) then Result := 'OP_FLOOR_EXT' else
      if self.val = UInt32($8790) then Result := 'OP_ROUND_EXT' else
      if self.val = UInt32($8791) then Result := 'OP_EXP_BASE_2_EXT' else
      if self.val = UInt32($8792) then Result := 'OP_LOG_BASE_2_EXT' else
      if self.val = UInt32($8793) then Result := 'OP_POWER_EXT' else
      if self.val = UInt32($8794) then Result := 'OP_RECIP_EXT' else
      if self.val = UInt32($8795) then Result := 'OP_RECIP_SQRT_EXT' else
      if self.val = UInt32($8796) then Result := 'OP_SUB_EXT' else
      if self.val = UInt32($8797) then Result := 'OP_CROSS_PRODUCT_EXT' else
      if self.val = UInt32($8798) then Result := 'OP_MULTIPLY_MATRIX_EXT' else
      if self.val = UInt32($8799) then Result := 'OP_MOV_EXT' else
        Result := $'VertexShaderOpEXT[{self.val}]';
    end;
    
  end;
  
  VertexShaderParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property CURRENT_VERTEX_EXT: VertexShaderParameterEXT read new VertexShaderParameterEXT($87E2);
    public static property MVP_MATRIX_EXT:     VertexShaderParameterEXT read new VertexShaderParameterEXT($87E3);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87E2) then Result := 'CURRENT_VERTEX_EXT' else
      if self.val = UInt32($87E3) then Result := 'MVP_MATRIX_EXT' else
        Result := $'VertexShaderParameterEXT[{self.val}]';
    end;
    
  end;
  
  VertexShaderStorageTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VARIANT_EXT:        VertexShaderStorageTypeEXT read new VertexShaderStorageTypeEXT($87C1);
    public static property INVARIANT_EXT:      VertexShaderStorageTypeEXT read new VertexShaderStorageTypeEXT($87C2);
    public static property LOCAL_CONSTANT_EXT: VertexShaderStorageTypeEXT read new VertexShaderStorageTypeEXT($87C3);
    public static property LOCAL_EXT:          VertexShaderStorageTypeEXT read new VertexShaderStorageTypeEXT($87C4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87C1) then Result := 'VARIANT_EXT' else
      if self.val = UInt32($87C2) then Result := 'INVARIANT_EXT' else
      if self.val = UInt32($87C3) then Result := 'LOCAL_CONSTANT_EXT' else
      if self.val = UInt32($87C4) then Result := 'LOCAL_EXT' else
        Result := $'VertexShaderStorageTypeEXT[{self.val}]';
    end;
    
  end;
  
  VertexShaderWriteMaskEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FALSE: VertexShaderWriteMaskEXT read new VertexShaderWriteMaskEXT($0000);
    public static property TRUE:  VertexShaderWriteMaskEXT read new VertexShaderWriteMaskEXT($0001);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'FALSE' else
      if self.val = UInt32($0001) then Result := 'TRUE' else
        Result := $'VertexShaderWriteMaskEXT[{self.val}]';
    end;
    
  end;
  
  VertexWeightPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FLOAT: VertexWeightPointerTypeEXT read new VertexWeightPointerTypeEXT($1406);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1406) then Result := 'FLOAT' else
        Result := $'VertexWeightPointerTypeEXT[{self.val}]';
    end;
    
  end;
  
  {$endregion EXT}
  
  {$region AMD}
  
  TextureStorageMaskAMD = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_STORAGE_SPARSE_BIT_AMD: TextureStorageMaskAMD read new TextureStorageMaskAMD($0001);
    
    public static function operator+(f1,f2: TextureStorageMaskAMD) := new TextureStorageMaskAMD(f1.val or f2.val);
    public static function operator or(f1,f2: TextureStorageMaskAMD) := f1+f2;
    
    public property HAS_FLAG_TEXTURE_STORAGE_SPARSE_BIT_AMD: boolean read self.val and $0001 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'TEXTURE_STORAGE_SPARSE_BIT_AMD+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'TextureStorageMaskAMD[{self.val}]';
    end;
    
  end;
  
  {$endregion AMD}
  
  {$region APPLE}
  
  ObjectTypeAPPLE = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property DRAW_PIXELS_APPLE: ObjectTypeAPPLE read new ObjectTypeAPPLE($8A0A);
    public static property FENCE_APPLE:       ObjectTypeAPPLE read new ObjectTypeAPPLE($8A0B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8A0A) then Result := 'DRAW_PIXELS_APPLE' else
      if self.val = UInt32($8A0B) then Result := 'FENCE_APPLE' else
        Result := $'ObjectTypeAPPLE[{self.val}]';
    end;
    
  end;
  
  VertexArrayPNameAPPLE = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property STORAGE_CLIENT_APPLE: VertexArrayPNameAPPLE read new VertexArrayPNameAPPLE($85B4);
    public static property STORAGE_CACHED_APPLE: VertexArrayPNameAPPLE read new VertexArrayPNameAPPLE($85BE);
    public static property STORAGE_SHARED_APPLE: VertexArrayPNameAPPLE read new VertexArrayPNameAPPLE($85BF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($85B4) then Result := 'STORAGE_CLIENT_APPLE' else
      if self.val = UInt32($85BE) then Result := 'STORAGE_CACHED_APPLE' else
      if self.val = UInt32($85BF) then Result := 'STORAGE_SHARED_APPLE' else
        Result := $'VertexArrayPNameAPPLE[{self.val}]';
    end;
    
  end;
  
  {$endregion APPLE}
  
  {$region ATI}
  
  ArrayObjectPNameATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property OBJECT_BUFFER_SIZE_ATI:  ArrayObjectPNameATI read new ArrayObjectPNameATI($8764);
    public static property OBJECT_BUFFER_USAGE_ATI: ArrayObjectPNameATI read new ArrayObjectPNameATI($8765);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8764) then Result := 'OBJECT_BUFFER_SIZE_ATI' else
      if self.val = UInt32($8765) then Result := 'OBJECT_BUFFER_USAGE_ATI' else
        Result := $'ArrayObjectPNameATI[{self.val}]';
    end;
    
  end;
  
  ArrayObjectUsageATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property STATIC_ATI:  ArrayObjectUsageATI read new ArrayObjectUsageATI($8760);
    public static property DYNAMIC_ATI: ArrayObjectUsageATI read new ArrayObjectUsageATI($8761);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8760) then Result := 'STATIC_ATI' else
      if self.val = UInt32($8761) then Result := 'DYNAMIC_ATI' else
        Result := $'ArrayObjectUsageATI[{self.val}]';
    end;
    
  end;
  
  ElementPointerTypeATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_BYTE:  ElementPointerTypeATI read new ElementPointerTypeATI($1401);
    public static property UNSIGNED_SHORT: ElementPointerTypeATI read new ElementPointerTypeATI($1403);
    public static property UNSIGNED_INT:   ElementPointerTypeATI read new ElementPointerTypeATI($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'ElementPointerTypeATI[{self.val}]';
    end;
    
  end;
  
  FragmentOpATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MOV_ATI:      FragmentOpATI read new FragmentOpATI($8961);
    public static property ADD_ATI:      FragmentOpATI read new FragmentOpATI($8963);
    public static property MUL_ATI:      FragmentOpATI read new FragmentOpATI($8964);
    public static property SUB_ATI:      FragmentOpATI read new FragmentOpATI($8965);
    public static property DOT3_ATI:     FragmentOpATI read new FragmentOpATI($8966);
    public static property DOT4_ATI:     FragmentOpATI read new FragmentOpATI($8967);
    public static property MAD_ATI:      FragmentOpATI read new FragmentOpATI($8968);
    public static property LERP_ATI:     FragmentOpATI read new FragmentOpATI($8969);
    public static property CND_ATI:      FragmentOpATI read new FragmentOpATI($896A);
    public static property CND0_ATI:     FragmentOpATI read new FragmentOpATI($896B);
    public static property DOT2_ADD_ATI: FragmentOpATI read new FragmentOpATI($896C);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8961) then Result := 'MOV_ATI' else
      if self.val = UInt32($8963) then Result := 'ADD_ATI' else
      if self.val = UInt32($8964) then Result := 'MUL_ATI' else
      if self.val = UInt32($8965) then Result := 'SUB_ATI' else
      if self.val = UInt32($8966) then Result := 'DOT3_ATI' else
      if self.val = UInt32($8967) then Result := 'DOT4_ATI' else
      if self.val = UInt32($8968) then Result := 'MAD_ATI' else
      if self.val = UInt32($8969) then Result := 'LERP_ATI' else
      if self.val = UInt32($896A) then Result := 'CND_ATI' else
      if self.val = UInt32($896B) then Result := 'CND0_ATI' else
      if self.val = UInt32($896C) then Result := 'DOT2_ADD_ATI' else
        Result := $'FragmentOpATI[{self.val}]';
    end;
    
  end;
  
  GetTexBumpParameterATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BUMP_ROT_MATRIX_ATI:      GetTexBumpParameterATI read new GetTexBumpParameterATI($8775);
    public static property BUMP_ROT_MATRIX_SIZE_ATI: GetTexBumpParameterATI read new GetTexBumpParameterATI($8776);
    public static property BUMP_NUM_TEX_UNITS_ATI:   GetTexBumpParameterATI read new GetTexBumpParameterATI($8777);
    public static property BUMP_TEX_UNITS_ATI:       GetTexBumpParameterATI read new GetTexBumpParameterATI($8778);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8775) then Result := 'BUMP_ROT_MATRIX_ATI' else
      if self.val = UInt32($8776) then Result := 'BUMP_ROT_MATRIX_SIZE_ATI' else
      if self.val = UInt32($8777) then Result := 'BUMP_NUM_TEX_UNITS_ATI' else
      if self.val = UInt32($8778) then Result := 'BUMP_TEX_UNITS_ATI' else
        Result := $'GetTexBumpParameterATI[{self.val}]';
    end;
    
  end;
  
  PNTrianglesPNameATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PN_TRIANGLES_POINT_MODE_ATI:        PNTrianglesPNameATI read new PNTrianglesPNameATI($87F2);
    public static property PN_TRIANGLES_NORMAL_MODE_ATI:       PNTrianglesPNameATI read new PNTrianglesPNameATI($87F3);
    public static property PN_TRIANGLES_TESSELATION_LEVEL_ATI: PNTrianglesPNameATI read new PNTrianglesPNameATI($87F4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($87F2) then Result := 'PN_TRIANGLES_POINT_MODE_ATI' else
      if self.val = UInt32($87F3) then Result := 'PN_TRIANGLES_NORMAL_MODE_ATI' else
      if self.val = UInt32($87F4) then Result := 'PN_TRIANGLES_TESSELATION_LEVEL_ATI' else
        Result := $'PNTrianglesPNameATI[{self.val}]';
    end;
    
  end;
  
  PreserveModeATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PRESERVE_ATI: PreserveModeATI read new PreserveModeATI($8762);
    public static property DISCARD_ATI:  PreserveModeATI read new PreserveModeATI($8763);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8762) then Result := 'PRESERVE_ATI' else
      if self.val = UInt32($8763) then Result := 'DISCARD_ATI' else
        Result := $'PreserveModeATI[{self.val}]';
    end;
    
  end;
  
  SwizzleOpATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SWIZZLE_STR_ATI:    SwizzleOpATI read new SwizzleOpATI($8976);
    public static property SWIZZLE_STQ_ATI:    SwizzleOpATI read new SwizzleOpATI($8977);
    public static property SWIZZLE_STR_DR_ATI: SwizzleOpATI read new SwizzleOpATI($8978);
    public static property SWIZZLE_STQ_DQ_ATI: SwizzleOpATI read new SwizzleOpATI($8979);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8976) then Result := 'SWIZZLE_STR_ATI' else
      if self.val = UInt32($8977) then Result := 'SWIZZLE_STQ_ATI' else
      if self.val = UInt32($8978) then Result := 'SWIZZLE_STR_DR_ATI' else
      if self.val = UInt32($8979) then Result := 'SWIZZLE_STQ_DQ_ATI' else
        Result := $'SwizzleOpATI[{self.val}]';
    end;
    
  end;
  
  TexBumpParameterATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BUMP_ROT_MATRIX_ATI: TexBumpParameterATI read new TexBumpParameterATI($8775);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8775) then Result := 'BUMP_ROT_MATRIX_ATI' else
        Result := $'TexBumpParameterATI[{self.val}]';
    end;
    
  end;
  
  VertexStreamATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_STREAM0_ATI: VertexStreamATI read new VertexStreamATI($876C);
    public static property VERTEX_STREAM1_ATI: VertexStreamATI read new VertexStreamATI($876D);
    public static property VERTEX_STREAM2_ATI: VertexStreamATI read new VertexStreamATI($876E);
    public static property VERTEX_STREAM3_ATI: VertexStreamATI read new VertexStreamATI($876F);
    public static property VERTEX_STREAM4_ATI: VertexStreamATI read new VertexStreamATI($8770);
    public static property VERTEX_STREAM5_ATI: VertexStreamATI read new VertexStreamATI($8771);
    public static property VERTEX_STREAM6_ATI: VertexStreamATI read new VertexStreamATI($8772);
    public static property VERTEX_STREAM7_ATI: VertexStreamATI read new VertexStreamATI($8773);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($876C) then Result := 'VERTEX_STREAM0_ATI' else
      if self.val = UInt32($876D) then Result := 'VERTEX_STREAM1_ATI' else
      if self.val = UInt32($876E) then Result := 'VERTEX_STREAM2_ATI' else
      if self.val = UInt32($876F) then Result := 'VERTEX_STREAM3_ATI' else
      if self.val = UInt32($8770) then Result := 'VERTEX_STREAM4_ATI' else
      if self.val = UInt32($8771) then Result := 'VERTEX_STREAM5_ATI' else
      if self.val = UInt32($8772) then Result := 'VERTEX_STREAM6_ATI' else
      if self.val = UInt32($8773) then Result := 'VERTEX_STREAM7_ATI' else
        Result := $'VertexStreamATI[{self.val}]';
    end;
    
  end;
  
  {$endregion ATI}
  
  {$region HP}
  
  ImageTransformPNameHP = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property IMAGE_SCALE_X_HP:         ImageTransformPNameHP read new ImageTransformPNameHP($8155);
    public static property IMAGE_SCALE_Y_HP:         ImageTransformPNameHP read new ImageTransformPNameHP($8156);
    public static property IMAGE_TRANSLATE_X_HP:     ImageTransformPNameHP read new ImageTransformPNameHP($8157);
    public static property IMAGE_TRANSLATE_Y_HP:     ImageTransformPNameHP read new ImageTransformPNameHP($8158);
    public static property IMAGE_ROTATE_ANGLE_HP:    ImageTransformPNameHP read new ImageTransformPNameHP($8159);
    public static property IMAGE_ROTATE_ORIGIN_X_HP: ImageTransformPNameHP read new ImageTransformPNameHP($815A);
    public static property IMAGE_ROTATE_ORIGIN_Y_HP: ImageTransformPNameHP read new ImageTransformPNameHP($815B);
    public static property IMAGE_MAG_FILTER_HP:      ImageTransformPNameHP read new ImageTransformPNameHP($815C);
    public static property IMAGE_MIN_FILTER_HP:      ImageTransformPNameHP read new ImageTransformPNameHP($815D);
    public static property IMAGE_CUBIC_WEIGHT_HP:    ImageTransformPNameHP read new ImageTransformPNameHP($815E);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8155) then Result := 'IMAGE_SCALE_X_HP' else
      if self.val = UInt32($8156) then Result := 'IMAGE_SCALE_Y_HP' else
      if self.val = UInt32($8157) then Result := 'IMAGE_TRANSLATE_X_HP' else
      if self.val = UInt32($8158) then Result := 'IMAGE_TRANSLATE_Y_HP' else
      if self.val = UInt32($8159) then Result := 'IMAGE_ROTATE_ANGLE_HP' else
      if self.val = UInt32($815A) then Result := 'IMAGE_ROTATE_ORIGIN_X_HP' else
      if self.val = UInt32($815B) then Result := 'IMAGE_ROTATE_ORIGIN_Y_HP' else
      if self.val = UInt32($815C) then Result := 'IMAGE_MAG_FILTER_HP' else
      if self.val = UInt32($815D) then Result := 'IMAGE_MIN_FILTER_HP' else
      if self.val = UInt32($815E) then Result := 'IMAGE_CUBIC_WEIGHT_HP' else
        Result := $'ImageTransformPNameHP[{self.val}]';
    end;
    
  end;
  
  ImageTransformTargetHP = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property IMAGE_TRANSFORM_2D_HP: ImageTransformTargetHP read new ImageTransformTargetHP($8161);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8161) then Result := 'IMAGE_TRANSFORM_2D_HP' else
        Result := $'ImageTransformTargetHP[{self.val}]';
    end;
    
  end;
  
  {$endregion HP}
  
  {$region IBM}
  
  FogPointerTypeIBM = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FLOAT:  FogPointerTypeIBM read new FogPointerTypeIBM($1406);
    public static property DOUBLE: FogPointerTypeIBM read new FogPointerTypeIBM($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'FogPointerTypeIBM[{self.val}]';
    end;
    
  end;
  
  SecondaryColorPointerTypeIBM = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SHORT:  SecondaryColorPointerTypeIBM read new SecondaryColorPointerTypeIBM($1402);
    public static property INT:    SecondaryColorPointerTypeIBM read new SecondaryColorPointerTypeIBM($1404);
    public static property FLOAT:  SecondaryColorPointerTypeIBM read new SecondaryColorPointerTypeIBM($1406);
    public static property DOUBLE: SecondaryColorPointerTypeIBM read new SecondaryColorPointerTypeIBM($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1402) then Result := 'SHORT' else
      if self.val = UInt32($1404) then Result := 'INT' else
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'SecondaryColorPointerTypeIBM[{self.val}]';
    end;
    
  end;
  
  {$endregion IBM}
  
  {$region INTEL}
  
  PerfQueryCapFlagsINTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PERFQUERY_SINGLE_CONTEXT_INTEL: PerfQueryCapFlagsINTEL read new PerfQueryCapFlagsINTEL($0000);
    public static property PERFQUERY_GLOBAL_CONTEXT_INTEL: PerfQueryCapFlagsINTEL read new PerfQueryCapFlagsINTEL($0001);
    
    public static function operator+(f1,f2: PerfQueryCapFlagsINTEL) := new PerfQueryCapFlagsINTEL(f1.val or f2.val);
    public static function operator or(f1,f2: PerfQueryCapFlagsINTEL) := f1+f2;
    
    public property ANY_FLAGS: boolean read self.val<>0;
    public property HAS_FLAG_PERFQUERY_GLOBAL_CONTEXT_INTEL: boolean read self.val and $0001 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0000) = UInt32($0000) then res += 'PERFQUERY_SINGLE_CONTEXT_INTEL+';
      if self.val and UInt32($0001) = UInt32($0001) then res += 'PERFQUERY_GLOBAL_CONTEXT_INTEL+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'PerfQueryCapFlagsINTEL[{self.val}]';
    end;
    
  end;
  
  PerfQueryDataFlagsINTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PERFQUERY_DONOT_FLUSH_INTEL: PerfQueryDataFlagsINTEL read new PerfQueryDataFlagsINTEL($83F9);
    public static property PERFQUERY_FLUSH_INTEL:       PerfQueryDataFlagsINTEL read new PerfQueryDataFlagsINTEL($83FA);
    public static property PERFQUERY_WAIT_INTEL:        PerfQueryDataFlagsINTEL read new PerfQueryDataFlagsINTEL($83FB);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($83F9) then Result := 'PERFQUERY_DONOT_FLUSH_INTEL' else
      if self.val = UInt32($83FA) then Result := 'PERFQUERY_FLUSH_INTEL' else
      if self.val = UInt32($83FB) then Result := 'PERFQUERY_WAIT_INTEL' else
        Result := $'PerfQueryDataFlagsINTEL[{self.val}]';
    end;
    
  end;
  
  {$endregion INTEL}
  
  {$region NV}
  
  CombinerBiasNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:                         CombinerBiasNV read new CombinerBiasNV($0000);
    public static property BIAS_BY_NEGATIVE_ONE_HALF_NV: CombinerBiasNV read new CombinerBiasNV($8541);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($8541) then Result := 'BIAS_BY_NEGATIVE_ONE_HALF_NV' else
        Result := $'CombinerBiasNV[{self.val}]';
    end;
    
  end;
  
  CombinerComponentUsageNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property BLUE:  CombinerComponentUsageNV read new CombinerComponentUsageNV($1905);
    public static property ALPHA: CombinerComponentUsageNV read new CombinerComponentUsageNV($1906);
    public static property RGB:   CombinerComponentUsageNV read new CombinerComponentUsageNV($1907);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1905) then Result := 'BLUE' else
      if self.val = UInt32($1906) then Result := 'ALPHA' else
      if self.val = UInt32($1907) then Result := 'RGB' else
        Result := $'CombinerComponentUsageNV[{self.val}]';
    end;
    
  end;
  
  CombinerMappingNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_IDENTITY_NV: CombinerMappingNV read new CombinerMappingNV($8536);
    public static property UNSIGNED_INVERT_NV:   CombinerMappingNV read new CombinerMappingNV($8537);
    public static property EXPAND_NORMAL_NV:     CombinerMappingNV read new CombinerMappingNV($8538);
    public static property EXPAND_NEGATE_NV:     CombinerMappingNV read new CombinerMappingNV($8539);
    public static property HALF_BIAS_NORMAL_NV:  CombinerMappingNV read new CombinerMappingNV($853A);
    public static property HALF_BIAS_NEGATE_NV:  CombinerMappingNV read new CombinerMappingNV($853B);
    public static property SIGNED_IDENTITY_NV:   CombinerMappingNV read new CombinerMappingNV($853C);
    public static property SIGNED_NEGATE_NV:     CombinerMappingNV read new CombinerMappingNV($853D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8536) then Result := 'UNSIGNED_IDENTITY_NV' else
      if self.val = UInt32($8537) then Result := 'UNSIGNED_INVERT_NV' else
      if self.val = UInt32($8538) then Result := 'EXPAND_NORMAL_NV' else
      if self.val = UInt32($8539) then Result := 'EXPAND_NEGATE_NV' else
      if self.val = UInt32($853A) then Result := 'HALF_BIAS_NORMAL_NV' else
      if self.val = UInt32($853B) then Result := 'HALF_BIAS_NEGATE_NV' else
      if self.val = UInt32($853C) then Result := 'SIGNED_IDENTITY_NV' else
      if self.val = UInt32($853D) then Result := 'SIGNED_NEGATE_NV' else
        Result := $'CombinerMappingNV[{self.val}]';
    end;
    
  end;
  
  CombinerParameterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COMBINER_INPUT_NV:           CombinerParameterNV read new CombinerParameterNV($8542);
    public static property COMBINER_MAPPING_NV:         CombinerParameterNV read new CombinerParameterNV($8543);
    public static property COMBINER_COMPONENT_USAGE_NV: CombinerParameterNV read new CombinerParameterNV($8544);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8542) then Result := 'COMBINER_INPUT_NV' else
      if self.val = UInt32($8543) then Result := 'COMBINER_MAPPING_NV' else
      if self.val = UInt32($8544) then Result := 'COMBINER_COMPONENT_USAGE_NV' else
        Result := $'CombinerParameterNV[{self.val}]';
    end;
    
  end;
  
  CombinerPortionNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ALPHA: CombinerPortionNV read new CombinerPortionNV($1906);
    public static property RGB:   CombinerPortionNV read new CombinerPortionNV($1907);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1906) then Result := 'ALPHA' else
      if self.val = UInt32($1907) then Result := 'RGB' else
        Result := $'CombinerPortionNV[{self.val}]';
    end;
    
  end;
  
  CombinerRegisterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE0_ARB:       CombinerRegisterNV read new CombinerRegisterNV($84C0);
    public static property TEXTURE1_ARB:       CombinerRegisterNV read new CombinerRegisterNV($84C1);
    public static property PRIMARY_COLOR_NV:   CombinerRegisterNV read new CombinerRegisterNV($852C);
    public static property SECONDARY_COLOR_NV: CombinerRegisterNV read new CombinerRegisterNV($852D);
    public static property SPARE0_NV:          CombinerRegisterNV read new CombinerRegisterNV($852E);
    public static property SPARE1_NV:          CombinerRegisterNV read new CombinerRegisterNV($852F);
    public static property DISCARD_NV:         CombinerRegisterNV read new CombinerRegisterNV($8530);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($84C0) then Result := 'TEXTURE0_ARB' else
      if self.val = UInt32($84C1) then Result := 'TEXTURE1_ARB' else
      if self.val = UInt32($852C) then Result := 'PRIMARY_COLOR_NV' else
      if self.val = UInt32($852D) then Result := 'SECONDARY_COLOR_NV' else
      if self.val = UInt32($852E) then Result := 'SPARE0_NV' else
      if self.val = UInt32($852F) then Result := 'SPARE1_NV' else
      if self.val = UInt32($8530) then Result := 'DISCARD_NV' else
        Result := $'CombinerRegisterNV[{self.val}]';
    end;
    
  end;
  
  CombinerScaleNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property NONE:                 CombinerScaleNV read new CombinerScaleNV($0000);
    public static property SCALE_BY_TWO_NV:      CombinerScaleNV read new CombinerScaleNV($853E);
    public static property SCALE_BY_FOUR_NV:     CombinerScaleNV read new CombinerScaleNV($853F);
    public static property SCALE_BY_ONE_HALF_NV: CombinerScaleNV read new CombinerScaleNV($8540);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($0000) then Result := 'NONE' else
      if self.val = UInt32($853E) then Result := 'SCALE_BY_TWO_NV' else
      if self.val = UInt32($853F) then Result := 'SCALE_BY_FOUR_NV' else
      if self.val = UInt32($8540) then Result := 'SCALE_BY_ONE_HALF_NV' else
        Result := $'CombinerScaleNV[{self.val}]';
    end;
    
  end;
  
  CombinerStageNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COMBINER0_NV: CombinerStageNV read new CombinerStageNV($8550);
    public static property COMBINER1_NV: CombinerStageNV read new CombinerStageNV($8551);
    public static property COMBINER2_NV: CombinerStageNV read new CombinerStageNV($8552);
    public static property COMBINER3_NV: CombinerStageNV read new CombinerStageNV($8553);
    public static property COMBINER4_NV: CombinerStageNV read new CombinerStageNV($8554);
    public static property COMBINER5_NV: CombinerStageNV read new CombinerStageNV($8555);
    public static property COMBINER6_NV: CombinerStageNV read new CombinerStageNV($8556);
    public static property COMBINER7_NV: CombinerStageNV read new CombinerStageNV($8557);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8550) then Result := 'COMBINER0_NV' else
      if self.val = UInt32($8551) then Result := 'COMBINER1_NV' else
      if self.val = UInt32($8552) then Result := 'COMBINER2_NV' else
      if self.val = UInt32($8553) then Result := 'COMBINER3_NV' else
      if self.val = UInt32($8554) then Result := 'COMBINER4_NV' else
      if self.val = UInt32($8555) then Result := 'COMBINER5_NV' else
      if self.val = UInt32($8556) then Result := 'COMBINER6_NV' else
      if self.val = UInt32($8557) then Result := 'COMBINER7_NV' else
        Result := $'CombinerStageNV[{self.val}]';
    end;
    
  end;
  
  CombinerVariableNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VARIABLE_A_NV: CombinerVariableNV read new CombinerVariableNV($8523);
    public static property VARIABLE_B_NV: CombinerVariableNV read new CombinerVariableNV($8524);
    public static property VARIABLE_C_NV: CombinerVariableNV read new CombinerVariableNV($8525);
    public static property VARIABLE_D_NV: CombinerVariableNV read new CombinerVariableNV($8526);
    public static property VARIABLE_E_NV: CombinerVariableNV read new CombinerVariableNV($8527);
    public static property VARIABLE_F_NV: CombinerVariableNV read new CombinerVariableNV($8528);
    public static property VARIABLE_G_NV: CombinerVariableNV read new CombinerVariableNV($8529);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8523) then Result := 'VARIABLE_A_NV' else
      if self.val = UInt32($8524) then Result := 'VARIABLE_B_NV' else
      if self.val = UInt32($8525) then Result := 'VARIABLE_C_NV' else
      if self.val = UInt32($8526) then Result := 'VARIABLE_D_NV' else
      if self.val = UInt32($8527) then Result := 'VARIABLE_E_NV' else
      if self.val = UInt32($8528) then Result := 'VARIABLE_F_NV' else
      if self.val = UInt32($8529) then Result := 'VARIABLE_G_NV' else
        Result := $'CombinerVariableNV[{self.val}]';
    end;
    
  end;
  
  EvalMapsModeNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FILL_NV: EvalMapsModeNV read new EvalMapsModeNV($1B02);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1B02) then Result := 'FILL_NV' else
        Result := $'EvalMapsModeNV[{self.val}]';
    end;
    
  end;
  
  EvalTargetNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property EVAL_2D_NV:            EvalTargetNV read new EvalTargetNV($86C0);
    public static property EVAL_TRIANGULAR_2D_NV: EvalTargetNV read new EvalTargetNV($86C1);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($86C0) then Result := 'EVAL_2D_NV' else
      if self.val = UInt32($86C1) then Result := 'EVAL_TRIANGULAR_2D_NV' else
        Result := $'EvalTargetNV[{self.val}]';
    end;
    
  end;
  
  FenceConditionNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ALL_COMPLETED_NV: FenceConditionNV read new FenceConditionNV($84F2);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($84F2) then Result := 'ALL_COMPLETED_NV' else
        Result := $'FenceConditionNV[{self.val}]';
    end;
    
  end;
  
  FenceParameterNameNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FENCE_STATUS_NV:    FenceParameterNameNV read new FenceParameterNameNV($84F3);
    public static property FENCE_CONDITION_NV: FenceParameterNameNV read new FenceParameterNameNV($84F4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($84F3) then Result := 'FENCE_STATUS_NV' else
      if self.val = UInt32($84F4) then Result := 'FENCE_CONDITION_NV' else
        Result := $'FenceParameterNameNV[{self.val}]';
    end;
    
  end;
  
  GetMultisamplePNameNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SAMPLE_LOCATION_ARB:              GetMultisamplePNameNV read new GetMultisamplePNameNV($8E50);
    public static property SAMPLE_POSITION:                  GetMultisamplePNameNV read new GetMultisamplePNameNV($8E50);
    public static property PROGRAMMABLE_SAMPLE_LOCATION_ARB: GetMultisamplePNameNV read new GetMultisamplePNameNV($9341);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8E50) then Result := 'SAMPLE_LOCATION_ARB' else
      if self.val = UInt32($8E50) then Result := 'SAMPLE_POSITION' else
      if self.val = UInt32($9341) then Result := 'PROGRAMMABLE_SAMPLE_LOCATION_ARB' else
        Result := $'GetMultisamplePNameNV[{self.val}]';
    end;
    
  end;
  
  GPUDisplayDeviceFlagsNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property ATTACHED_TO_DESKTOP: GPUDisplayDeviceFlagsNV read new GPUDisplayDeviceFlagsNV($0001);
    public static property PRIMARY_DEVICE:      GPUDisplayDeviceFlagsNV read new GPUDisplayDeviceFlagsNV($0004);
    
    public static function operator+(f1,f2: GPUDisplayDeviceFlagsNV) := new GPUDisplayDeviceFlagsNV(f1.val or f2.val);
    public static function operator or(f1,f2: GPUDisplayDeviceFlagsNV) := f1+f2;
    
    public property HAS_FLAG_ATTACHED_TO_DESKTOP: boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_PRIMARY_DEVICE:      boolean read self.val and $0004 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'ATTACHED_TO_DESKTOP+';
      if self.val and UInt32($0004) = UInt32($0004) then res += 'PRIMARY_DEVICE+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'GPUDisplayDeviceFlagsNV[{self.val}]';
    end;
    
  end;
  
  MapAttribParameterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MAP_ATTRIB_U_ORDER_NV: MapAttribParameterNV read new MapAttribParameterNV($86C3);
    public static property MAP_ATTRIB_V_ORDER_NV: MapAttribParameterNV read new MapAttribParameterNV($86C4);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($86C3) then Result := 'MAP_ATTRIB_U_ORDER_NV' else
      if self.val = UInt32($86C4) then Result := 'MAP_ATTRIB_V_ORDER_NV' else
        Result := $'MapAttribParameterNV[{self.val}]';
    end;
    
  end;
  
  MapParameterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property MAP_TESSELLATION_NV: MapParameterNV read new MapParameterNV($86C2);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($86C2) then Result := 'MAP_TESSELLATION_NV' else
        Result := $'MapParameterNV[{self.val}]';
    end;
    
  end;
  
  MapTypeNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FLOAT:  MapTypeNV read new MapTypeNV($1406);
    public static property DOUBLE: MapTypeNV read new MapTypeNV($140A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1406) then Result := 'FLOAT' else
      if self.val = UInt32($140A) then Result := 'DOUBLE' else
        Result := $'MapTypeNV[{self.val}]';
    end;
    
  end;
  
  OcclusionQueryParameterNameNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PIXEL_COUNT_NV:           OcclusionQueryParameterNameNV read new OcclusionQueryParameterNameNV($8866);
    public static property PIXEL_COUNT_AVAILABLE_NV: OcclusionQueryParameterNameNV read new OcclusionQueryParameterNameNV($8867);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8866) then Result := 'PIXEL_COUNT_NV' else
      if self.val = UInt32($8867) then Result := 'PIXEL_COUNT_AVAILABLE_NV' else
        Result := $'OcclusionQueryParameterNameNV[{self.val}]';
    end;
    
  end;
  
  PixelDataRangeTargetNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property WRITE_PIXEL_DATA_RANGE_NV: PixelDataRangeTargetNV read new PixelDataRangeTargetNV($8878);
    public static property READ_PIXEL_DATA_RANGE_NV:  PixelDataRangeTargetNV read new PixelDataRangeTargetNV($8879);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8878) then Result := 'WRITE_PIXEL_DATA_RANGE_NV' else
      if self.val = UInt32($8879) then Result := 'READ_PIXEL_DATA_RANGE_NV' else
        Result := $'PixelDataRangeTargetNV[{self.val}]';
    end;
    
  end;
  
  VertexAttribEnumNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PROGRAM_PARAMETER_NV: VertexAttribEnumNV read new VertexAttribEnumNV($8644);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8644) then Result := 'PROGRAM_PARAMETER_NV' else
        Result := $'VertexAttribEnumNV[{self.val}]';
    end;
    
  end;
  
  {$endregion NV}
  
  {$region PGI}
  
  HintTargetPGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property VERTEX_DATA_HINT_PGI:       HintTargetPGI read new HintTargetPGI($1A22A);
    public static property VERTEX_CONSISTENT_HINT_PGI: HintTargetPGI read new HintTargetPGI($1A22B);
    public static property MATERIAL_SIDE_HINT_PGI:     HintTargetPGI read new HintTargetPGI($1A22C);
    public static property MAX_VERTEX_HINT_PGI:        HintTargetPGI read new HintTargetPGI($1A22D);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1A22A) then Result := 'VERTEX_DATA_HINT_PGI' else
      if self.val = UInt32($1A22B) then Result := 'VERTEX_CONSISTENT_HINT_PGI' else
      if self.val = UInt32($1A22C) then Result := 'MATERIAL_SIDE_HINT_PGI' else
      if self.val = UInt32($1A22D) then Result := 'MAX_VERTEX_HINT_PGI' else
        Result := $'HintTargetPGI[{self.val}]';
    end;
    
  end;
  
  {$endregion PGI}
  
  {$region SGI}
  
  ColorTableParameterPNameSGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COLOR_TABLE_SCALE:              ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D6);
    public static property COLOR_TABLE_SCALE_SGI:          ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D6);
    public static property COLOR_TABLE_BIAS:               ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D7);
    public static property COLOR_TABLE_BIAS_SGI:           ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D7);
    public static property COLOR_TABLE_FORMAT:             ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D8);
    public static property COLOR_TABLE_FORMAT_SGI:         ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D8);
    public static property COLOR_TABLE_WIDTH:              ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D9);
    public static property COLOR_TABLE_WIDTH_SGI:          ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80D9);
    public static property COLOR_TABLE_RED_SIZE:           ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DA);
    public static property COLOR_TABLE_RED_SIZE_SGI:       ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DA);
    public static property COLOR_TABLE_GREEN_SIZE:         ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DB);
    public static property COLOR_TABLE_GREEN_SIZE_SGI:     ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DB);
    public static property COLOR_TABLE_BLUE_SIZE:          ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DC);
    public static property COLOR_TABLE_BLUE_SIZE_SGI:      ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DC);
    public static property COLOR_TABLE_ALPHA_SIZE:         ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DD);
    public static property COLOR_TABLE_ALPHA_SIZE_SGI:     ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DD);
    public static property COLOR_TABLE_LUMINANCE_SIZE:     ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DE);
    public static property COLOR_TABLE_LUMINANCE_SIZE_SGI: ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DE);
    public static property COLOR_TABLE_INTENSITY_SIZE:     ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DF);
    public static property COLOR_TABLE_INTENSITY_SIZE_SGI: ColorTableParameterPNameSGI read new ColorTableParameterPNameSGI($80DF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80D6) then Result := 'COLOR_TABLE_SCALE' else
      if self.val = UInt32($80D6) then Result := 'COLOR_TABLE_SCALE_SGI' else
      if self.val = UInt32($80D7) then Result := 'COLOR_TABLE_BIAS' else
      if self.val = UInt32($80D7) then Result := 'COLOR_TABLE_BIAS_SGI' else
      if self.val = UInt32($80D8) then Result := 'COLOR_TABLE_FORMAT' else
      if self.val = UInt32($80D8) then Result := 'COLOR_TABLE_FORMAT_SGI' else
      if self.val = UInt32($80D9) then Result := 'COLOR_TABLE_WIDTH' else
      if self.val = UInt32($80D9) then Result := 'COLOR_TABLE_WIDTH_SGI' else
      if self.val = UInt32($80DA) then Result := 'COLOR_TABLE_RED_SIZE' else
      if self.val = UInt32($80DA) then Result := 'COLOR_TABLE_RED_SIZE_SGI' else
      if self.val = UInt32($80DB) then Result := 'COLOR_TABLE_GREEN_SIZE' else
      if self.val = UInt32($80DB) then Result := 'COLOR_TABLE_GREEN_SIZE_SGI' else
      if self.val = UInt32($80DC) then Result := 'COLOR_TABLE_BLUE_SIZE' else
      if self.val = UInt32($80DC) then Result := 'COLOR_TABLE_BLUE_SIZE_SGI' else
      if self.val = UInt32($80DD) then Result := 'COLOR_TABLE_ALPHA_SIZE' else
      if self.val = UInt32($80DD) then Result := 'COLOR_TABLE_ALPHA_SIZE_SGI' else
      if self.val = UInt32($80DE) then Result := 'COLOR_TABLE_LUMINANCE_SIZE' else
      if self.val = UInt32($80DE) then Result := 'COLOR_TABLE_LUMINANCE_SIZE_SGI' else
      if self.val = UInt32($80DF) then Result := 'COLOR_TABLE_INTENSITY_SIZE' else
      if self.val = UInt32($80DF) then Result := 'COLOR_TABLE_INTENSITY_SIZE_SGI' else
        Result := $'ColorTableParameterPNameSGI[{self.val}]';
    end;
    
  end;
  
  ColorTableTargetSGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_COLOR_TABLE_SGI:                 ColorTableTargetSGI read new ColorTableTargetSGI($80BC);
    public static property PROXY_TEXTURE_COLOR_TABLE_SGI:           ColorTableTargetSGI read new ColorTableTargetSGI($80BD);
    public static property COLOR_TABLE:                             ColorTableTargetSGI read new ColorTableTargetSGI($80D0);
    public static property COLOR_TABLE_SGI:                         ColorTableTargetSGI read new ColorTableTargetSGI($80D0);
    public static property POST_CONVOLUTION_COLOR_TABLE:            ColorTableTargetSGI read new ColorTableTargetSGI($80D1);
    public static property POST_CONVOLUTION_COLOR_TABLE_SGI:        ColorTableTargetSGI read new ColorTableTargetSGI($80D1);
    public static property POST_COLOR_MATRIX_COLOR_TABLE:           ColorTableTargetSGI read new ColorTableTargetSGI($80D2);
    public static property POST_COLOR_MATRIX_COLOR_TABLE_SGI:       ColorTableTargetSGI read new ColorTableTargetSGI($80D2);
    public static property PROXY_COLOR_TABLE:                       ColorTableTargetSGI read new ColorTableTargetSGI($80D3);
    public static property PROXY_COLOR_TABLE_SGI:                   ColorTableTargetSGI read new ColorTableTargetSGI($80D3);
    public static property PROXY_POST_CONVOLUTION_COLOR_TABLE:      ColorTableTargetSGI read new ColorTableTargetSGI($80D4);
    public static property PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI:  ColorTableTargetSGI read new ColorTableTargetSGI($80D4);
    public static property PROXY_POST_COLOR_MATRIX_COLOR_TABLE:     ColorTableTargetSGI read new ColorTableTargetSGI($80D5);
    public static property PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI: ColorTableTargetSGI read new ColorTableTargetSGI($80D5);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80BC) then Result := 'TEXTURE_COLOR_TABLE_SGI' else
      if self.val = UInt32($80BD) then Result := 'PROXY_TEXTURE_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D0) then Result := 'COLOR_TABLE' else
      if self.val = UInt32($80D0) then Result := 'COLOR_TABLE_SGI' else
      if self.val = UInt32($80D1) then Result := 'POST_CONVOLUTION_COLOR_TABLE' else
      if self.val = UInt32($80D1) then Result := 'POST_CONVOLUTION_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D2) then Result := 'POST_COLOR_MATRIX_COLOR_TABLE' else
      if self.val = UInt32($80D2) then Result := 'POST_COLOR_MATRIX_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D3) then Result := 'PROXY_COLOR_TABLE' else
      if self.val = UInt32($80D3) then Result := 'PROXY_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D4) then Result := 'PROXY_POST_CONVOLUTION_COLOR_TABLE' else
      if self.val = UInt32($80D4) then Result := 'PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI' else
      if self.val = UInt32($80D5) then Result := 'PROXY_POST_COLOR_MATRIX_COLOR_TABLE' else
      if self.val = UInt32($80D5) then Result := 'PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI' else
        Result := $'ColorTableTargetSGI[{self.val}]';
    end;
    
  end;
  
  GetColorTableParameterPNameSGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property COLOR_TABLE_SCALE:              GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D6);
    public static property COLOR_TABLE_SCALE_SGI:          GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D6);
    public static property COLOR_TABLE_BIAS:               GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D7);
    public static property COLOR_TABLE_BIAS_SGI:           GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D7);
    public static property COLOR_TABLE_FORMAT:             GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D8);
    public static property COLOR_TABLE_FORMAT_SGI:         GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D8);
    public static property COLOR_TABLE_WIDTH:              GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D9);
    public static property COLOR_TABLE_WIDTH_SGI:          GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80D9);
    public static property COLOR_TABLE_RED_SIZE:           GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DA);
    public static property COLOR_TABLE_RED_SIZE_SGI:       GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DA);
    public static property COLOR_TABLE_GREEN_SIZE:         GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DB);
    public static property COLOR_TABLE_GREEN_SIZE_SGI:     GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DB);
    public static property COLOR_TABLE_BLUE_SIZE:          GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DC);
    public static property COLOR_TABLE_BLUE_SIZE_SGI:      GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DC);
    public static property COLOR_TABLE_ALPHA_SIZE:         GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DD);
    public static property COLOR_TABLE_ALPHA_SIZE_SGI:     GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DD);
    public static property COLOR_TABLE_LUMINANCE_SIZE:     GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DE);
    public static property COLOR_TABLE_LUMINANCE_SIZE_SGI: GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DE);
    public static property COLOR_TABLE_INTENSITY_SIZE:     GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DF);
    public static property COLOR_TABLE_INTENSITY_SIZE_SGI: GetColorTableParameterPNameSGI read new GetColorTableParameterPNameSGI($80DF);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80D6) then Result := 'COLOR_TABLE_SCALE' else
      if self.val = UInt32($80D6) then Result := 'COLOR_TABLE_SCALE_SGI' else
      if self.val = UInt32($80D7) then Result := 'COLOR_TABLE_BIAS' else
      if self.val = UInt32($80D7) then Result := 'COLOR_TABLE_BIAS_SGI' else
      if self.val = UInt32($80D8) then Result := 'COLOR_TABLE_FORMAT' else
      if self.val = UInt32($80D8) then Result := 'COLOR_TABLE_FORMAT_SGI' else
      if self.val = UInt32($80D9) then Result := 'COLOR_TABLE_WIDTH' else
      if self.val = UInt32($80D9) then Result := 'COLOR_TABLE_WIDTH_SGI' else
      if self.val = UInt32($80DA) then Result := 'COLOR_TABLE_RED_SIZE' else
      if self.val = UInt32($80DA) then Result := 'COLOR_TABLE_RED_SIZE_SGI' else
      if self.val = UInt32($80DB) then Result := 'COLOR_TABLE_GREEN_SIZE' else
      if self.val = UInt32($80DB) then Result := 'COLOR_TABLE_GREEN_SIZE_SGI' else
      if self.val = UInt32($80DC) then Result := 'COLOR_TABLE_BLUE_SIZE' else
      if self.val = UInt32($80DC) then Result := 'COLOR_TABLE_BLUE_SIZE_SGI' else
      if self.val = UInt32($80DD) then Result := 'COLOR_TABLE_ALPHA_SIZE' else
      if self.val = UInt32($80DD) then Result := 'COLOR_TABLE_ALPHA_SIZE_SGI' else
      if self.val = UInt32($80DE) then Result := 'COLOR_TABLE_LUMINANCE_SIZE' else
      if self.val = UInt32($80DE) then Result := 'COLOR_TABLE_LUMINANCE_SIZE_SGI' else
      if self.val = UInt32($80DF) then Result := 'COLOR_TABLE_INTENSITY_SIZE' else
      if self.val = UInt32($80DF) then Result := 'COLOR_TABLE_INTENSITY_SIZE_SGI' else
        Result := $'GetColorTableParameterPNameSGI[{self.val}]';
    end;
    
  end;
  
  {$endregion SGI}
  
  {$region SGIS}
  
  PixelTexGenParameterNameSGIS = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PIXEL_FRAGMENT_RGB_SOURCE_SGIS:   PixelTexGenParameterNameSGIS read new PixelTexGenParameterNameSGIS($8354);
    public static property PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS: PixelTexGenParameterNameSGIS read new PixelTexGenParameterNameSGIS($8355);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8354) then Result := 'PIXEL_FRAGMENT_RGB_SOURCE_SGIS' else
      if self.val = UInt32($8355) then Result := 'PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS' else
        Result := $'PixelTexGenParameterNameSGIS[{self.val}]';
    end;
    
  end;
  
  SamplePatternSGIS = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property GL_1PASS_EXT:    SamplePatternSGIS read new SamplePatternSGIS($80A1);
    public static property GL_1PASS_SGIS:   SamplePatternSGIS read new SamplePatternSGIS($80A1);
    public static property GL_2PASS_0_EXT:  SamplePatternSGIS read new SamplePatternSGIS($80A2);
    public static property GL_2PASS_0_SGIS: SamplePatternSGIS read new SamplePatternSGIS($80A2);
    public static property GL_2PASS_1_EXT:  SamplePatternSGIS read new SamplePatternSGIS($80A3);
    public static property GL_2PASS_1_SGIS: SamplePatternSGIS read new SamplePatternSGIS($80A3);
    public static property GL_4PASS_0_EXT:  SamplePatternSGIS read new SamplePatternSGIS($80A4);
    public static property GL_4PASS_0_SGIS: SamplePatternSGIS read new SamplePatternSGIS($80A4);
    public static property GL_4PASS_1_EXT:  SamplePatternSGIS read new SamplePatternSGIS($80A5);
    public static property GL_4PASS_1_SGIS: SamplePatternSGIS read new SamplePatternSGIS($80A5);
    public static property GL_4PASS_2_EXT:  SamplePatternSGIS read new SamplePatternSGIS($80A6);
    public static property GL_4PASS_2_SGIS: SamplePatternSGIS read new SamplePatternSGIS($80A6);
    public static property GL_4PASS_3_EXT:  SamplePatternSGIS read new SamplePatternSGIS($80A7);
    public static property GL_4PASS_3_SGIS: SamplePatternSGIS read new SamplePatternSGIS($80A7);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($80A1) then Result := 'GL_1PASS_EXT' else
      if self.val = UInt32($80A1) then Result := 'GL_1PASS_SGIS' else
      if self.val = UInt32($80A2) then Result := 'GL_2PASS_0_EXT' else
      if self.val = UInt32($80A2) then Result := 'GL_2PASS_0_SGIS' else
      if self.val = UInt32($80A3) then Result := 'GL_2PASS_1_EXT' else
      if self.val = UInt32($80A3) then Result := 'GL_2PASS_1_SGIS' else
      if self.val = UInt32($80A4) then Result := 'GL_4PASS_0_EXT' else
      if self.val = UInt32($80A4) then Result := 'GL_4PASS_0_SGIS' else
      if self.val = UInt32($80A5) then Result := 'GL_4PASS_1_EXT' else
      if self.val = UInt32($80A5) then Result := 'GL_4PASS_1_SGIS' else
      if self.val = UInt32($80A6) then Result := 'GL_4PASS_2_EXT' else
      if self.val = UInt32($80A6) then Result := 'GL_4PASS_2_SGIS' else
      if self.val = UInt32($80A7) then Result := 'GL_4PASS_3_EXT' else
      if self.val = UInt32($80A7) then Result := 'GL_4PASS_3_SGIS' else
        Result := $'SamplePatternSGIS[{self.val}]';
    end;
    
  end;
  
  TextureFilterSGIS = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FILTER4_SGIS: TextureFilterSGIS read new TextureFilterSGIS($8146);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8146) then Result := 'FILTER4_SGIS' else
        Result := $'TextureFilterSGIS[{self.val}]';
    end;
    
  end;
  
  {$endregion SGIS}
  
  {$region SGIX}
  
  FfdMaskSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property TEXTURE_DEFORMATION_BIT_SGIX:  FfdMaskSGIX read new FfdMaskSGIX($0001);
    public static property GEOMETRY_DEFORMATION_BIT_SGIX: FfdMaskSGIX read new FfdMaskSGIX($0002);
    
    public static function operator+(f1,f2: FfdMaskSGIX) := new FfdMaskSGIX(f1.val or f2.val);
    public static function operator or(f1,f2: FfdMaskSGIX) := f1+f2;
    
    public property HAS_FLAG_TEXTURE_DEFORMATION_BIT_SGIX:  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_GEOMETRY_DEFORMATION_BIT_SGIX: boolean read self.val and $0002 <> 0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      if self.val and UInt32($0001) = UInt32($0001) then res += 'TEXTURE_DEFORMATION_BIT_SGIX+';
      if self.val and UInt32($0002) = UInt32($0002) then res += 'GEOMETRY_DEFORMATION_BIT_SGIX+';
      if res.Length<>0 then
      begin
        res.Length -= 1;
        Result := res.ToString;
      end else
        Result := $'FfdMaskSGIX[{self.val}]';
    end;
    
  end;
  
  FfdTargetSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property GEOMETRY_DEFORMATION_SGIX: FfdTargetSGIX read new FfdTargetSGIX($8194);
    public static property TEXTURE_DEFORMATION_SGIX:  FfdTargetSGIX read new FfdTargetSGIX($8195);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8194) then Result := 'GEOMETRY_DEFORMATION_SGIX' else
      if self.val = UInt32($8195) then Result := 'TEXTURE_DEFORMATION_SGIX' else
        Result := $'FfdTargetSGIX[{self.val}]';
    end;
    
  end;
  
  FragmentLightModelParameterSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX:         FragmentLightModelParameterSGIX read new FragmentLightModelParameterSGIX($8408);
    public static property FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX:             FragmentLightModelParameterSGIX read new FragmentLightModelParameterSGIX($8409);
    public static property FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX:              FragmentLightModelParameterSGIX read new FragmentLightModelParameterSGIX($840A);
    public static property FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX: FragmentLightModelParameterSGIX read new FragmentLightModelParameterSGIX($840B);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8408) then Result := 'FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX' else
      if self.val = UInt32($8409) then Result := 'FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX' else
      if self.val = UInt32($840A) then Result := 'FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX' else
      if self.val = UInt32($840B) then Result := 'FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX' else
        Result := $'FragmentLightModelParameterSGIX[{self.val}]';
    end;
    
  end;
  
  FragmentLightNameSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property FRAGMENT_LIGHT0_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($840C);
    public static property FRAGMENT_LIGHT1_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($840D);
    public static property FRAGMENT_LIGHT2_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($840E);
    public static property FRAGMENT_LIGHT3_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($840F);
    public static property FRAGMENT_LIGHT4_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($8410);
    public static property FRAGMENT_LIGHT5_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($8411);
    public static property FRAGMENT_LIGHT6_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($8412);
    public static property FRAGMENT_LIGHT7_SGIX: FragmentLightNameSGIX read new FragmentLightNameSGIX($8413);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($840C) then Result := 'FRAGMENT_LIGHT0_SGIX' else
      if self.val = UInt32($840D) then Result := 'FRAGMENT_LIGHT1_SGIX' else
      if self.val = UInt32($840E) then Result := 'FRAGMENT_LIGHT2_SGIX' else
      if self.val = UInt32($840F) then Result := 'FRAGMENT_LIGHT3_SGIX' else
      if self.val = UInt32($8410) then Result := 'FRAGMENT_LIGHT4_SGIX' else
      if self.val = UInt32($8411) then Result := 'FRAGMENT_LIGHT5_SGIX' else
      if self.val = UInt32($8412) then Result := 'FRAGMENT_LIGHT6_SGIX' else
      if self.val = UInt32($8413) then Result := 'FRAGMENT_LIGHT7_SGIX' else
        Result := $'FragmentLightNameSGIX[{self.val}]';
    end;
    
  end;
  
  FragmentLightParameterSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property AMBIENT:               FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1200);
    public static property DIFFUSE:               FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1201);
    public static property SPECULAR:              FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1202);
    public static property POSITION:              FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1203);
    public static property SPOT_DIRECTION:        FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1204);
    public static property SPOT_EXPONENT:         FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1205);
    public static property SPOT_CUTOFF:           FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1206);
    public static property CONSTANT_ATTENUATION:  FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1207);
    public static property LINEAR_ATTENUATION:    FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1208);
    public static property QUADRATIC_ATTENUATION: FragmentLightParameterSGIX read new FragmentLightParameterSGIX($1209);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1200) then Result := 'AMBIENT' else
      if self.val = UInt32($1201) then Result := 'DIFFUSE' else
      if self.val = UInt32($1202) then Result := 'SPECULAR' else
      if self.val = UInt32($1203) then Result := 'POSITION' else
      if self.val = UInt32($1204) then Result := 'SPOT_DIRECTION' else
      if self.val = UInt32($1205) then Result := 'SPOT_EXPONENT' else
      if self.val = UInt32($1206) then Result := 'SPOT_CUTOFF' else
      if self.val = UInt32($1207) then Result := 'CONSTANT_ATTENUATION' else
      if self.val = UInt32($1208) then Result := 'LINEAR_ATTENUATION' else
      if self.val = UInt32($1209) then Result := 'QUADRATIC_ATTENUATION' else
        Result := $'FragmentLightParameterSGIX[{self.val}]';
    end;
    
  end;
  
  LightEnvParameterSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property LIGHT_ENV_MODE_SGIX: LightEnvParameterSGIX read new LightEnvParameterSGIX($8407);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8407) then Result := 'LIGHT_ENV_MODE_SGIX' else
        Result := $'LightEnvParameterSGIX[{self.val}]';
    end;
    
  end;
  
  PixelTexGenModeSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property PIXEL_TEX_GEN_Q_CEILING_SGIX: PixelTexGenModeSGIX read new PixelTexGenModeSGIX($8184);
    public static property PIXEL_TEX_GEN_Q_ROUND_SGIX:   PixelTexGenModeSGIX read new PixelTexGenModeSGIX($8185);
    public static property PIXEL_TEX_GEN_Q_FLOOR_SGIX:   PixelTexGenModeSGIX read new PixelTexGenModeSGIX($8186);
    public static property PIXEL_TEX_GEN_ALPHA_LS_SGIX:  PixelTexGenModeSGIX read new PixelTexGenModeSGIX($8189);
    public static property PIXEL_TEX_GEN_ALPHA_MS_SGIX:  PixelTexGenModeSGIX read new PixelTexGenModeSGIX($818A);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8184) then Result := 'PIXEL_TEX_GEN_Q_CEILING_SGIX' else
      if self.val = UInt32($8185) then Result := 'PIXEL_TEX_GEN_Q_ROUND_SGIX' else
      if self.val = UInt32($8186) then Result := 'PIXEL_TEX_GEN_Q_FLOOR_SGIX' else
      if self.val = UInt32($8189) then Result := 'PIXEL_TEX_GEN_ALPHA_LS_SGIX' else
      if self.val = UInt32($818A) then Result := 'PIXEL_TEX_GEN_ALPHA_MS_SGIX' else
        Result := $'PixelTexGenModeSGIX[{self.val}]';
    end;
    
  end;
  
  SpriteParameterNameSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property SPRITE_MODE_SGIX: SpriteParameterNameSGIX read new SpriteParameterNameSGIX($8149);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($8149) then Result := 'SPRITE_MODE_SGIX' else
        Result := $'SpriteParameterNameSGIX[{self.val}]';
    end;
    
  end;
  
  {$endregion SGIX}
  
  {$region SUN}
  
  ReplacementCodeTypeSUN = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    public static property UNSIGNED_BYTE:  ReplacementCodeTypeSUN read new ReplacementCodeTypeSUN($1401);
    public static property UNSIGNED_SHORT: ReplacementCodeTypeSUN read new ReplacementCodeTypeSUN($1403);
    public static property UNSIGNED_INT:   ReplacementCodeTypeSUN read new ReplacementCodeTypeSUN($1405);
    
    public function ToString: string; override;
    begin
      if self.val = UInt32($1401) then Result := 'UNSIGNED_BYTE' else
      if self.val = UInt32($1403) then Result := 'UNSIGNED_SHORT' else
      if self.val = UInt32($1405) then Result := 'UNSIGNED_INT' else
        Result := $'ReplacementCodeTypeSUN[{self.val}]';
    end;
    
  end;
  
  {$endregion SUN}
  
  {$endregion Перечисления}
  
  {$region Делегаты}
  
  [UnmanagedFunctionPointer(CallingConvention.StdCall)]
  GL_DEBUG_PROC = procedure(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; message_text: IntPtr; userParam: pointer);
  
  [UnmanagedFunctionPointer(CallingConvention.StdCall)]
  GL_VULKAN_PROC_NV = procedure;
  
  {$endregion Делегаты}
  
  {$region Записи}
  
  {$region Vec}
  
  {$region Vec1}
  
  Vec1b = record
    public val0: SByte;
    
    public constructor(val0: SByte);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1b): Vec1b := new Vec1b(-v.val0);
    public static function operator+(v: Vec1b): Vec1b := v;
    public static function operator*(v: Vec1b; k: SByte): Vec1b := new Vec1b(v.val0*k);
    public static function operator div(v: Vec1b; k: SByte): Vec1b := new Vec1b(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1b): SByte := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1b): Vec1b := new Vec1b(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1b): Vec1b := new Vec1b(v1.val0-v2.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: SByte): Vec1b;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1ub = record
    public val0: Byte;
    
    public constructor(val0: Byte);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1ub): Vec1ub := v;
    public static function operator*(v: Vec1ub; k: Byte): Vec1ub := new Vec1ub(v.val0*k);
    public static function operator div(v: Vec1ub; k: Byte): Vec1ub := new Vec1ub(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1ub): Byte := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1ub): Vec1ub := new Vec1ub(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1ub): Vec1ub := new Vec1ub(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1ub := new Vec1ub(v.val0);
    public static function operator implicit(v: Vec1ub): Vec1b := new Vec1b(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: Byte): Vec1ub;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1s = record
    public val0: Int16;
    
    public constructor(val0: Int16);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1s): Vec1s := new Vec1s(-v.val0);
    public static function operator+(v: Vec1s): Vec1s := v;
    public static function operator*(v: Vec1s; k: Int16): Vec1s := new Vec1s(v.val0*k);
    public static function operator div(v: Vec1s; k: Int16): Vec1s := new Vec1s(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1s): Int16 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1s): Vec1s := new Vec1s(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1s): Vec1s := new Vec1s(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1s := new Vec1s(v.val0);
    public static function operator implicit(v: Vec1s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1s := new Vec1s(v.val0);
    public static function operator implicit(v: Vec1s): Vec1ub := new Vec1ub(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: Int16): Vec1s;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1us = record
    public val0: UInt16;
    
    public constructor(val0: UInt16);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1us): Vec1us := v;
    public static function operator*(v: Vec1us; k: UInt16): Vec1us := new Vec1us(v.val0*k);
    public static function operator div(v: Vec1us; k: UInt16): Vec1us := new Vec1us(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1us): UInt16 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1us): Vec1us := new Vec1us(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1us): Vec1us := new Vec1us(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1us := new Vec1us(v.val0);
    public static function operator implicit(v: Vec1us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1us := new Vec1us(v.val0);
    public static function operator implicit(v: Vec1us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1us := new Vec1us(v.val0);
    public static function operator implicit(v: Vec1us): Vec1s := new Vec1s(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: UInt16): Vec1us;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1i = record
    public val0: Int32;
    
    public constructor(val0: Int32);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1i): Vec1i := new Vec1i(-v.val0);
    public static function operator+(v: Vec1i): Vec1i := v;
    public static function operator*(v: Vec1i; k: Int32): Vec1i := new Vec1i(v.val0*k);
    public static function operator div(v: Vec1i; k: Int32): Vec1i := new Vec1i(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1i): Int32 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1i): Vec1i := new Vec1i(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1i): Vec1i := new Vec1i(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1us := new Vec1us(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: Int32): Vec1i;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1ui = record
    public val0: UInt32;
    
    public constructor(val0: UInt32);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1ui): Vec1ui := v;
    public static function operator*(v: Vec1ui; k: UInt32): Vec1ui := new Vec1ui(v.val0*k);
    public static function operator div(v: Vec1ui; k: UInt32): Vec1ui := new Vec1ui(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1ui): UInt32 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1ui): Vec1ui := new Vec1ui(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1ui): Vec1ui := new Vec1ui(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1i := new Vec1i(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: UInt32): Vec1ui;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1i64 = record
    public val0: Int64;
    
    public constructor(val0: Int64);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1i64): Vec1i64 := new Vec1i64(-v.val0);
    public static function operator+(v: Vec1i64): Vec1i64 := v;
    public static function operator*(v: Vec1i64; k: Int64): Vec1i64 := new Vec1i64(v.val0*k);
    public static function operator div(v: Vec1i64; k: Int64): Vec1i64 := new Vec1i64(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1i64): Int64 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1i64): Vec1i64 := new Vec1i64(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1i64): Vec1i64 := new Vec1i64(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1ui := new Vec1ui(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: Int64): Vec1i64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1ui64 = record
    public val0: UInt64;
    
    public constructor(val0: UInt64);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1ui64): Vec1ui64 := v;
    public static function operator*(v: Vec1ui64; k: UInt64): Vec1ui64 := new Vec1ui64(v.val0*k);
    public static function operator div(v: Vec1ui64; k: UInt64): Vec1ui64 := new Vec1ui64(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1ui64): UInt64 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1ui64): Vec1ui64 := new Vec1ui64(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1ui64): Vec1ui64 := new Vec1ui64(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public function SqrLength := val0*val0;
    
    public static function Random(min, max: UInt64): Vec1ui64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1f = record
    public val0: single;
    
    public constructor(val0: single);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1f): Vec1f := new Vec1f(-v.val0);
    public static function operator+(v: Vec1f): Vec1f := v;
    public static function operator*(v: Vec1f; k: single): Vec1f := new Vec1f(v.val0*k);
    public static function operator/(v: Vec1f; k: single): Vec1f := new Vec1f(v.val0/k);
    
    public static function operator*(v1, v2: Vec1f): single := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1f): Vec1f := new Vec1f(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1f): Vec1f := new Vec1f(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public function SqrLength := val0*val0;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public static function Random(min, max: single): Vec1f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec1fPtrCallbackP = procedure(var ptr: Vec1f);
  UseVec1fPtrCallbackF<T> = function(var ptr: Vec1f): T;
  
  Vec1d = record
    public val0: double;
    
    public constructor(val0: double);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1d): Vec1d := new Vec1d(-v.val0);
    public static function operator+(v: Vec1d): Vec1d := v;
    public static function operator*(v: Vec1d; k: double): Vec1d := new Vec1d(v.val0*k);
    public static function operator/(v: Vec1d; k: double): Vec1d := new Vec1d(v.val0/k);
    
    public static function operator*(v1, v2: Vec1d): double := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1d): Vec1d := new Vec1d(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1d): Vec1d := new Vec1d(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1f := new Vec1f(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public static function Random(min, max: double): Vec1d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec1d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0);
    end;
    public static function Readln(prompt: string := nil): Vec1d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec1dPtrCallbackP = procedure(var ptr: Vec1d);
  UseVec1dPtrCallbackF<T> = function(var ptr: Vec1d): T;
  
  {$endregion Vec1}
  
  {$region Vec2}
  
  Vec2b = record
    public val0: SByte;
    public val1: SByte;
    
    public constructor(val0, val1: SByte);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2b): Vec2b := new Vec2b(-v.val0, -v.val1);
    public static function operator+(v: Vec2b): Vec2b := v;
    public static function operator*(v: Vec2b; k: SByte): Vec2b := new Vec2b(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2b; k: SByte): Vec2b := new Vec2b(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2b): SByte := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2b): Vec2b := new Vec2b(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2b): Vec2b := new Vec2b(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), 0);
    public static function operator implicit(v: Vec2b): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), 0);
    public static function operator implicit(v: Vec2b): Vec1d := new Vec1d(v.val0);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: SByte): Vec2b;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2ub = record
    public val0: Byte;
    public val1: Byte;
    
    public constructor(val0, val1: Byte);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2ub): Vec2ub := v;
    public static function operator*(v: Vec2ub; k: Byte): Vec2ub := new Vec2ub(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2ub; k: Byte): Vec2ub := new Vec2ub(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2ub): Byte := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2ub): Vec2ub := new Vec2ub(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2ub): Vec2ub := new Vec2ub(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), 0);
    public static function operator implicit(v: Vec2ub): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), 0);
    public static function operator implicit(v: Vec2ub): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2ub := new Vec2ub(v.val0, v.val1);
    public static function operator implicit(v: Vec2ub): Vec2b := new Vec2b(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: Byte): Vec2ub;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2s = record
    public val0: Int16;
    public val1: Int16;
    
    public constructor(val0, val1: Int16);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2s): Vec2s := new Vec2s(-v.val0, -v.val1);
    public static function operator+(v: Vec2s): Vec2s := v;
    public static function operator*(v: Vec2s; k: Int16): Vec2s := new Vec2s(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2s; k: Int16): Vec2s := new Vec2s(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2s): Int16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2s): Vec2s := new Vec2s(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2s): Vec2s := new Vec2s(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), 0);
    public static function operator implicit(v: Vec2s): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), 0);
    public static function operator implicit(v: Vec2s): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2s := new Vec2s(v.val0, v.val1);
    public static function operator implicit(v: Vec2s): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2s := new Vec2s(v.val0, v.val1);
    public static function operator implicit(v: Vec2s): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: Int16): Vec2s;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2us = record
    public val0: UInt16;
    public val1: UInt16;
    
    public constructor(val0, val1: UInt16);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2us): Vec2us := v;
    public static function operator*(v: Vec2us; k: UInt16): Vec2us := new Vec2us(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2us; k: UInt16): Vec2us := new Vec2us(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2us): UInt16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2us): Vec2us := new Vec2us(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2us): Vec2us := new Vec2us(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), 0);
    public static function operator implicit(v: Vec2us): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), 0);
    public static function operator implicit(v: Vec2us): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2us := new Vec2us(v.val0, v.val1);
    public static function operator implicit(v: Vec2us): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2us := new Vec2us(v.val0, v.val1);
    public static function operator implicit(v: Vec2us): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2us := new Vec2us(v.val0, v.val1);
    public static function operator implicit(v: Vec2us): Vec2s := new Vec2s(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: UInt16): Vec2us;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2i = record
    public val0: Int32;
    public val1: Int32;
    
    public constructor(val0, val1: Int32);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2i): Vec2i := new Vec2i(-v.val0, -v.val1);
    public static function operator+(v: Vec2i): Vec2i := v;
    public static function operator*(v: Vec2i; k: Int32): Vec2i := new Vec2i(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2i; k: Int32): Vec2i := new Vec2i(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2i): Int32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2i): Vec2i := new Vec2i(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2i): Vec2i := new Vec2i(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), 0);
    public static function operator implicit(v: Vec2i): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), 0);
    public static function operator implicit(v: Vec2i): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2us := new Vec2us(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: Int32): Vec2i;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2ui = record
    public val0: UInt32;
    public val1: UInt32;
    
    public constructor(val0, val1: UInt32);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2ui): Vec2ui := v;
    public static function operator*(v: Vec2ui; k: UInt32): Vec2ui := new Vec2ui(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2ui; k: UInt32): Vec2ui := new Vec2ui(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2ui): UInt32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2ui): Vec2ui := new Vec2ui(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2ui): Vec2ui := new Vec2ui(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), 0);
    public static function operator implicit(v: Vec2ui): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), 0);
    public static function operator implicit(v: Vec2ui): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2i := new Vec2i(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: UInt32): Vec2ui;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2i64 = record
    public val0: Int64;
    public val1: Int64;
    
    public constructor(val0, val1: Int64);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2i64): Vec2i64 := new Vec2i64(-v.val0, -v.val1);
    public static function operator+(v: Vec2i64): Vec2i64 := v;
    public static function operator*(v: Vec2i64; k: Int64): Vec2i64 := new Vec2i64(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2i64; k: Int64): Vec2i64 := new Vec2i64(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2i64): Int64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2i64): Vec2i64 := new Vec2i64(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2i64): Vec2i64 := new Vec2i64(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), 0);
    public static function operator implicit(v: Vec2i64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), 0);
    public static function operator implicit(v: Vec2i64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: Int64): Vec2i64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2ui64 = record
    public val0: UInt64;
    public val1: UInt64;
    
    public constructor(val0, val1: UInt64);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2ui64): Vec2ui64 := v;
    public static function operator*(v: Vec2ui64; k: UInt64): Vec2ui64 := new Vec2ui64(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2ui64; k: UInt64): Vec2ui64 := new Vec2ui64(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2ui64): UInt64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2ui64): Vec2ui64 := new Vec2ui64(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2ui64): Vec2ui64 := new Vec2ui64(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), 0);
    public static function operator implicit(v: Vec2ui64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), 0);
    public static function operator implicit(v: Vec2ui64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public static function Random(min, max: UInt64): Vec2ui64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2f = record
    public val0: single;
    public val1: single;
    
    public constructor(val0, val1: single);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2f): Vec2f := new Vec2f(-v.val0, -v.val1);
    public static function operator+(v: Vec2f): Vec2f := v;
    public static function operator*(v: Vec2f; k: single): Vec2f := new Vec2f(v.val0*k, v.val1*k);
    public static function operator/(v: Vec2f; k: single): Vec2f := new Vec2f(v.val0/k, v.val1/k);
    
    public static function operator*(v1, v2: Vec2f): single := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2f): Vec2f := new Vec2f(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2f): Vec2f := new Vec2f(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public static function Random(min, max: single): Vec2f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec2fPtrCallbackP = procedure(var ptr: Vec2f);
  UseVec2fPtrCallbackF<T> = function(var ptr: Vec2f): T;
  
  Vec2d = record
    public val0: double;
    public val1: double;
    
    public constructor(val0, val1: double);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2d): Vec2d := new Vec2d(-v.val0, -v.val1);
    public static function operator+(v: Vec2d): Vec2d := v;
    public static function operator*(v: Vec2d; k: double): Vec2d := new Vec2d(v.val0*k, v.val1*k);
    public static function operator/(v: Vec2d; k: double): Vec2d := new Vec2d(v.val0/k, v.val1/k);
    
    public static function operator*(v1, v2: Vec2d): double := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2d): Vec2d := new Vec2d(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2d): Vec2d := new Vec2d(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2f := new Vec2f(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public static function Random(min, max: double): Vec2d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1);
    end;
    public static function Readln(prompt: string := nil): Vec2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec2dPtrCallbackP = procedure(var ptr: Vec2d);
  UseVec2dPtrCallbackF<T> = function(var ptr: Vec2d): T;
  
  {$endregion Vec2}
  
  {$region Vec3}
  
  Vec3b = record
    public val0: SByte;
    public val1: SByte;
    public val2: SByte;
    
    public constructor(val0, val1, val2: SByte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3b): Vec3b := new Vec3b(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3b): Vec3b := v;
    public static function operator*(v: Vec3b; k: SByte): Vec3b := new Vec3b(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3b; k: SByte): Vec3b := new Vec3b(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3b): SByte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3b): Vec3b := new Vec3b(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3b): Vec3b := new Vec3b(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3b): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3b): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0);
    public static function operator implicit(v: Vec3b): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0);
    public static function operator implicit(v: Vec3b): Vec2d := new Vec2d(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3b) :=
    new Vec3b(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    public static function CrossCCW(v1,v2: Vec3b) := CrossCW(v2,v1);
    
    public static function Random(min, max: SByte): Vec3b;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3ub = record
    public val0: Byte;
    public val1: Byte;
    public val2: Byte;
    
    public constructor(val0, val1, val2: Byte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3ub): Vec3ub := v;
    public static function operator*(v: Vec3ub; k: Byte): Vec3ub := new Vec3ub(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3ub; k: Byte): Vec3ub := new Vec3ub(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3ub): Byte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3ub): Vec3ub := new Vec3ub(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3ub): Vec3ub := new Vec3ub(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0);
    public static function operator implicit(v: Vec3ub): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0);
    public static function operator implicit(v: Vec3ub): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ub): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function Random(min, max: Byte): Vec3ub;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3s = record
    public val0: Int16;
    public val1: Int16;
    public val2: Int16;
    
    public constructor(val0, val1, val2: Int16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3s): Vec3s := new Vec3s(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3s): Vec3s := v;
    public static function operator*(v: Vec3s; k: Int16): Vec3s := new Vec3s(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3s; k: Int16): Vec3s := new Vec3s(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3s): Int16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3s): Vec3s := new Vec3s(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3s): Vec3s := new Vec3s(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3s): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3s): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0);
    public static function operator implicit(v: Vec3s): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0);
    public static function operator implicit(v: Vec3s): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3s): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3s): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3s) :=
    new Vec3s(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    public static function CrossCCW(v1,v2: Vec3s) := CrossCW(v2,v1);
    
    public static function Random(min, max: Int16): Vec3s;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3us = record
    public val0: UInt16;
    public val1: UInt16;
    public val2: UInt16;
    
    public constructor(val0, val1, val2: UInt16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3us): Vec3us := v;
    public static function operator*(v: Vec3us; k: UInt16): Vec3us := new Vec3us(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3us; k: UInt16): Vec3us := new Vec3us(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3us): UInt16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3us): Vec3us := new Vec3us(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3us): Vec3us := new Vec3us(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3us): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3us): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0);
    public static function operator implicit(v: Vec3us): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0);
    public static function operator implicit(v: Vec3us): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3us): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3us): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3us): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function Random(min, max: UInt16): Vec3us;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3i = record
    public val0: Int32;
    public val1: Int32;
    public val2: Int32;
    
    public constructor(val0, val1, val2: Int32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3i): Vec3i := new Vec3i(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3i): Vec3i := v;
    public static function operator*(v: Vec3i; k: Int32): Vec3i := new Vec3i(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3i; k: Int32): Vec3i := new Vec3i(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3i): Int32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3i): Vec3i := new Vec3i(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3i): Vec3i := new Vec3i(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0);
    public static function operator implicit(v: Vec3i): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0);
    public static function operator implicit(v: Vec3i): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3i) :=
    new Vec3i(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    public static function CrossCCW(v1,v2: Vec3i) := CrossCW(v2,v1);
    
    public static function Random(min, max: Int32): Vec3i;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3ui = record
    public val0: UInt32;
    public val1: UInt32;
    public val2: UInt32;
    
    public constructor(val0, val1, val2: UInt32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3ui): Vec3ui := v;
    public static function operator*(v: Vec3ui; k: UInt32): Vec3ui := new Vec3ui(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3ui; k: UInt32): Vec3ui := new Vec3ui(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3ui): UInt32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3ui): Vec3ui := new Vec3ui(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3ui): Vec3ui := new Vec3ui(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0);
    public static function operator implicit(v: Vec3ui): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0);
    public static function operator implicit(v: Vec3ui): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function Random(min, max: UInt32): Vec3ui;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3i64 = record
    public val0: Int64;
    public val1: Int64;
    public val2: Int64;
    
    public constructor(val0, val1, val2: Int64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3i64): Vec3i64 := new Vec3i64(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3i64): Vec3i64 := v;
    public static function operator*(v: Vec3i64; k: Int64): Vec3i64 := new Vec3i64(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3i64; k: Int64): Vec3i64 := new Vec3i64(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3i64): Int64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3i64): Vec3i64 := new Vec3i64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3i64): Vec3i64 := new Vec3i64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0);
    public static function operator implicit(v: Vec3i64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0);
    public static function operator implicit(v: Vec3i64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3i64) :=
    new Vec3i64(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    public static function CrossCCW(v1,v2: Vec3i64) := CrossCW(v2,v1);
    
    public static function Random(min, max: Int64): Vec3i64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3ui64 = record
    public val0: UInt64;
    public val1: UInt64;
    public val2: UInt64;
    
    public constructor(val0, val1, val2: UInt64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3ui64): Vec3ui64 := v;
    public static function operator*(v: Vec3ui64; k: UInt64): Vec3ui64 := new Vec3ui64(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3ui64; k: UInt64): Vec3ui64 := new Vec3ui64(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3ui64): UInt64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3ui64): Vec3ui64 := new Vec3ui64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3ui64): Vec3ui64 := new Vec3ui64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0);
    public static function operator implicit(v: Vec3ui64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0);
    public static function operator implicit(v: Vec3ui64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function Random(min, max: UInt64): Vec3ui64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3f = record
    public val0: single;
    public val1: single;
    public val2: single;
    
    public constructor(val0, val1, val2: single);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3f): Vec3f := new Vec3f(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3f): Vec3f := v;
    public static function operator*(v: Vec3f; k: single): Vec3f := new Vec3f(v.val0*k, v.val1*k, v.val2*k);
    public static function operator/(v: Vec3f; k: single): Vec3f := new Vec3f(v.val0/k, v.val1/k, v.val2/k);
    
    public static function operator*(v1, v2: Vec3f): single := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3f): Vec3f := new Vec3f(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3f): Vec3f := new Vec3f(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public static function CrossCW(v1,v2: Vec3f) :=
    new Vec3f(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    public static function CrossCCW(v1,v2: Vec3f) := CrossCW(v2,v1);
    
    public static function Random(min, max: single): Vec3f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec3fPtrCallbackP = procedure(var ptr: Vec3f);
  UseVec3fPtrCallbackF<T> = function(var ptr: Vec3f): T;
  
  Vec3d = record
    public val0: double;
    public val1: double;
    public val2: double;
    
    public constructor(val0, val1, val2: double);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3d): Vec3d := new Vec3d(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3d): Vec3d := v;
    public static function operator*(v: Vec3d; k: double): Vec3d := new Vec3d(v.val0*k, v.val1*k, v.val2*k);
    public static function operator/(v: Vec3d; k: double): Vec3d := new Vec3d(v.val0/k, v.val1/k, v.val2/k);
    
    public static function operator*(v1, v2: Vec3d): double := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3d): Vec3d := new Vec3d(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3d): Vec3d := new Vec3d(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public static function operator implicit(v: Vec3f): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public static function CrossCW(v1,v2: Vec3d) :=
    new Vec3d(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    public static function CrossCCW(v1,v2: Vec3d) := CrossCW(v2,v1);
    
    public static function Random(min, max: double): Vec3d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2);
    end;
    public static function Readln(prompt: string := nil): Vec3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec3dPtrCallbackP = procedure(var ptr: Vec3d);
  UseVec3dPtrCallbackF<T> = function(var ptr: Vec3d): T;
  
  {$endregion Vec3}
  
  {$region Vec4}
  
  Vec4b = record
    public val0: SByte;
    public val1: SByte;
    public val2: SByte;
    public val3: SByte;
    
    public constructor(val0, val1, val2, val3: SByte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4b): Vec4b := new Vec4b(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4b): Vec4b := v;
    public static function operator*(v: Vec4b; k: SByte): Vec4b := new Vec4b(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4b; k: SByte): Vec4b := new Vec4b(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4b): SByte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4b): Vec4b := new Vec4b(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4b): Vec4b := new Vec4b(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4b): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4b): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), 0);
    public static function operator implicit(v: Vec4b): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), 0);
    public static function operator implicit(v: Vec4b): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: SByte): Vec4b;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4b;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4ub = record
    public val0: Byte;
    public val1: Byte;
    public val2: Byte;
    public val3: Byte;
    
    public constructor(val0, val1, val2, val3: Byte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4ub): Vec4ub := v;
    public static function operator*(v: Vec4ub; k: Byte): Vec4ub := new Vec4ub(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4ub; k: Byte): Vec4ub := new Vec4ub(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4ub): Byte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4ub): Vec4ub := new Vec4ub(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4ub): Vec4ub := new Vec4ub(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), 0);
    public static function operator implicit(v: Vec4ub): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), 0);
    public static function operator implicit(v: Vec4ub): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ub): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: Byte): Vec4ub;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4ub;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4s = record
    public val0: Int16;
    public val1: Int16;
    public val2: Int16;
    public val3: Int16;
    
    public constructor(val0, val1, val2, val3: Int16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4s): Vec4s := new Vec4s(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4s): Vec4s := v;
    public static function operator*(v: Vec4s; k: Int16): Vec4s := new Vec4s(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4s; k: Int16): Vec4s := new Vec4s(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4s): Int16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4s): Vec4s := new Vec4s(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4s): Vec4s := new Vec4s(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4s): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4s): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), 0);
    public static function operator implicit(v: Vec4s): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), 0);
    public static function operator implicit(v: Vec4s): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4s): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4s): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: Int16): Vec4s;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4s;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4us = record
    public val0: UInt16;
    public val1: UInt16;
    public val2: UInt16;
    public val3: UInt16;
    
    public constructor(val0, val1, val2, val3: UInt16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4us): Vec4us := v;
    public static function operator*(v: Vec4us; k: UInt16): Vec4us := new Vec4us(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4us; k: UInt16): Vec4us := new Vec4us(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4us): UInt16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4us): Vec4us := new Vec4us(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4us): Vec4us := new Vec4us(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4us): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4us): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), 0);
    public static function operator implicit(v: Vec4us): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), 0);
    public static function operator implicit(v: Vec4us): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4us): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4us): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4us): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: UInt16): Vec4us;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4us;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4i = record
    public val0: Int32;
    public val1: Int32;
    public val2: Int32;
    public val3: Int32;
    
    public constructor(val0, val1, val2, val3: Int32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4i): Vec4i := new Vec4i(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4i): Vec4i := v;
    public static function operator*(v: Vec4i; k: Int32): Vec4i := new Vec4i(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4i; k: Int32): Vec4i := new Vec4i(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4i): Int32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4i): Vec4i := new Vec4i(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4i): Vec4i := new Vec4i(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), 0);
    public static function operator implicit(v: Vec4i): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), 0);
    public static function operator implicit(v: Vec4i): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: Int32): Vec4i;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4i;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4ui = record
    public val0: UInt32;
    public val1: UInt32;
    public val2: UInt32;
    public val3: UInt32;
    
    public constructor(val0, val1, val2, val3: UInt32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4ui): Vec4ui := v;
    public static function operator*(v: Vec4ui; k: UInt32): Vec4ui := new Vec4ui(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4ui; k: UInt32): Vec4ui := new Vec4ui(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4ui): UInt32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4ui): Vec4ui := new Vec4ui(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4ui): Vec4ui := new Vec4ui(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), 0);
    public static function operator implicit(v: Vec4ui): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), 0);
    public static function operator implicit(v: Vec4ui): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: UInt32): Vec4ui;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4ui;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4i64 = record
    public val0: Int64;
    public val1: Int64;
    public val2: Int64;
    public val3: Int64;
    
    public constructor(val0, val1, val2, val3: Int64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4i64): Vec4i64 := new Vec4i64(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4i64): Vec4i64 := v;
    public static function operator*(v: Vec4i64; k: Int64): Vec4i64 := new Vec4i64(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4i64; k: Int64): Vec4i64 := new Vec4i64(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4i64): Int64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4i64): Vec4i64 := new Vec4i64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4i64): Vec4i64 := new Vec4i64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), 0);
    public static function operator implicit(v: Vec4i64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), 0);
    public static function operator implicit(v: Vec4i64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ui): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: Int64): Vec4i64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4i64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4ui64 = record
    public val0: UInt64;
    public val1: UInt64;
    public val2: UInt64;
    public val3: UInt64;
    
    public constructor(val0, val1, val2, val3: UInt64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4ui64): Vec4ui64 := v;
    public static function operator*(v: Vec4ui64; k: UInt64): Vec4ui64 := new Vec4ui64(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4ui64; k: UInt64): Vec4ui64 := new Vec4ui64(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4ui64): UInt64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4ui64): Vec4ui64 := new Vec4ui64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4ui64): Vec4ui64 := new Vec4ui64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), 0);
    public static function operator implicit(v: Vec4ui64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), 0);
    public static function operator implicit(v: Vec4ui64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ui): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public static function Random(min, max: UInt64): Vec4ui64;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4ui64;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4f = record
    public val0: single;
    public val1: single;
    public val2: single;
    public val3: single;
    
    public constructor(val0, val1, val2, val3: single);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4f): Vec4f := new Vec4f(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4f): Vec4f := v;
    public static function operator*(v: Vec4f; k: single): Vec4f := new Vec4f(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator/(v: Vec4f; k: single): Vec4f := new Vec4f(v.val0/k, v.val1/k, v.val2/k, v.val3/k);
    
    public static function operator*(v1, v2: Vec4f): single := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4f): Vec4f := new Vec4f(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4f): Vec4f := new Vec4f(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public static function operator implicit(v: Vec3f): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), Convert.ToSByte(v.val3));
    
    public static function operator implicit(v: Vec4ub): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), Convert.ToByte(v.val3));
    
    public static function operator implicit(v: Vec4s): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), Convert.ToInt16(v.val3));
    
    public static function operator implicit(v: Vec4us): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), Convert.ToUInt16(v.val3));
    
    public static function operator implicit(v: Vec4i): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), Convert.ToInt32(v.val3));
    
    public static function operator implicit(v: Vec4ui): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), Convert.ToUInt32(v.val3));
    
    public static function operator implicit(v: Vec4i64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), Convert.ToInt64(v.val3));
    
    public static function operator implicit(v: Vec4ui64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), Convert.ToUInt64(v.val3));
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public static function Random(min, max: single): Vec4f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec4fPtrCallbackP = procedure(var ptr: Vec4f);
  UseVec4fPtrCallbackF<T> = function(var ptr: Vec4f): T;
  
  Vec4d = record
    public val0: double;
    public val1: double;
    public val2: double;
    public val3: double;
    
    public constructor(val0, val1, val2, val3: double);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4d): Vec4d := new Vec4d(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4d): Vec4d := v;
    public static function operator*(v: Vec4d; k: double): Vec4d := new Vec4d(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator/(v: Vec4d; k: double): Vec4d := new Vec4d(v.val0/k, v.val1/k, v.val2/k, v.val3/k);
    
    public static function operator*(v1, v2: Vec4d): double := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4d): Vec4d := new Vec4d(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4d): Vec4d := new Vec4d(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public static function operator implicit(v: Vec3f): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), Convert.ToSByte(v.val3));
    
    public static function operator implicit(v: Vec4ub): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), Convert.ToByte(v.val3));
    
    public static function operator implicit(v: Vec4s): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), Convert.ToInt16(v.val3));
    
    public static function operator implicit(v: Vec4us): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), Convert.ToUInt16(v.val3));
    
    public static function operator implicit(v: Vec4i): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), Convert.ToInt32(v.val3));
    
    public static function operator implicit(v: Vec4ui): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), Convert.ToUInt32(v.val3));
    
    public static function operator implicit(v: Vec4i64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), Convert.ToInt64(v.val3));
    
    public static function operator implicit(v: Vec4ui64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), Convert.ToUInt64(v.val3));
    
    public static function operator implicit(v: Vec4f): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public static function Random(min, max: double): Vec4d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val0 := min + PABCSystem.Random(r);
      Result.val1 := min + PABCSystem.Random(r);
      Result.val2 := min + PABCSystem.Random(r);
      Result.val3 := min + PABCSystem.Random(r);
    end;
    
    public static function Read(prompt: string := nil): Vec4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    public static function Readln(prompt: string := nil): Vec4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Readln(Result.val0, Result.val1, Result.val2, Result.val3);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec4dPtrCallbackP = procedure(var ptr: Vec4d);
  UseVec4dPtrCallbackF<T> = function(var ptr: Vec4d): T;
  
  {$endregion Vec4}
  
  {$endregion Vec}
  
  {$region Mtr}
  
  Mtr2x2f = record
    public val00, val10: single;
    public val01, val11: single;
    
    public constructor(val00, val01, val10, val11: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
    end;
    
    public static property Identity: Mtr2x2f read new Mtr2x2f(1.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec2f read new Vec2f(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2f read new Vec2f(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    
    public property Col0: Vec2f read new Vec2f(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2f read new Vec2f(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    
    public property ColPtr0: ^Vec2f read pointer(@val00);
    public property ColPtr1: ^Vec2f read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec2f read pointer(IntPtr(pointer(@self)) + x*8);
    
    public procedure UseColPtr0(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val01))^); end;
    
    public static function Scale(k: single): Mtr2x2f := new Mtr2x2f(k, 0.0, 0.0, k);
    
    public static function Traslate(X: single): Mtr2x2f := new Mtr2x2f(1.0, X, 0.0, 1.0);
    public static function TraslateTransposed(X: single): Mtr2x2f := new Mtr2x2f(1.0, 0.0, X, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr2x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x2f(
         cr, +sr,
        -sr,  cr
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x2f(
         cr, -sr,
        +sr,  cr
      );
    end;
    
    public function Det: single;
    begin
      Result := val00 * val11 - val01 * val10;
    end;
    
    public static function Random(min, max: single): Mtr2x2f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr2x2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01);
      PABCSystem.Read(Result.val10, Result.val11);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr2x2f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11);
    end;
    public static function ReadCols(prompt: string := nil): Mtr2x2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10);
      PABCSystem.Read(Result.val01, Result.val11);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr2x2f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x2f; v: Vec2f): Vec2f := new Vec2f(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1);
    public static function operator*(v: Vec2f; m: Mtr2x2f): Vec2f := new Vec2f(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1);
    
  end;
  Mtr2f = Mtr2x2f;
  
  Mtr3x3f = record
    public val00, val10, val20: single;
    public val01, val11, val21: single;
    public val02, val12, val22: single;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
    end;
    
    public static property Identity: Mtr3x3f read new Mtr3x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec3f read new Vec3f(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3f read new Vec3f(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3f read new Vec3f(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    
    public property Col0: Vec3f read new Vec3f(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3f read new Vec3f(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3f read new Vec3f(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    
    public property ColPtr0: ^Vec3f read pointer(@val00);
    public property ColPtr1: ^Vec3f read pointer(@val01);
    public property ColPtr2: ^Vec3f read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec3f read pointer(IntPtr(pointer(@self)) + x*12);
    
    public procedure UseColPtr0(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val02))^); end;
    
    public static function Scale(k: single): Mtr3x3f := new Mtr3x3f(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y: single): Mtr3x3f := new Mtr3x3f(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y: single): Mtr3x3f := new Mtr3x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr3x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr3x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function Det: single;
    begin
      var det2_01 := val10 * val21 - val11 * val20;
      var det2_02 := val10 * val22 - val12 * val20;
      var det2_12 := val11 * val22 - val12 * val21;
      Result := val00 * det2_12 - val01 * det2_02 + val02 * det2_01;
    end;
    
    public static function Random(min, max: single): Mtr3x3f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr3x3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr3x3f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22);
    end;
    public static function ReadCols(prompt: string := nil): Mtr3x3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr3x3f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x3f; v: Vec3f): Vec3f := new Vec3f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2);
    public static function operator*(v: Vec3f; m: Mtr3x3f): Vec3f := new Vec3f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
  end;
  Mtr3f = Mtr3x3f;
  
  Mtr4x4f = record
    public val00, val10, val20, val30: single;
    public val01, val11, val21, val31: single;
    public val02, val12, val22, val32: single;
    public val03, val13, val23, val33: single;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23, val30, val31, val32, val33: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
      self.val33 := val33;
    end;
    
    public static property Identity: Mtr4x4f read new Mtr4x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec4f read new Vec4f(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4f read new Vec4f(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4f read new Vec4f(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    public property Row3: Vec4f read new Vec4f(self.val30, self.val31, self.val32, self.val33) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; self.val33 := value.val3; end;
    
    public property Col0: Vec4f read new Vec4f(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4f read new Vec4f(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4f read new Vec4f(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    public property Col3: Vec4f read new Vec4f(self.val03, self.val13, self.val23, self.val33) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; self.val33 := value.val3; end;
    
    public property ColPtr0: ^Vec4f read pointer(@val00);
    public property ColPtr1: ^Vec4f read pointer(@val01);
    public property ColPtr2: ^Vec4f read pointer(@val02);
    public property ColPtr3: ^Vec4f read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec4f read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val03))^); end;
    
    public static function Scale(k: single): Mtr4x4f := new Mtr4x4f(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y, Z: single): Mtr4x4f := new Mtr4x4f(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z, 0.0, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y, Z: single): Mtr4x4f := new Mtr4x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, Z, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr4x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr4x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public function Det: single;
    begin
      var det2_01 := val20 * val31 - val21 * val30;
      var det2_02 := val20 * val32 - val22 * val30;
      var det2_03 := val20 * val33 - val23 * val30;
      var det2_12 := val21 * val32 - val22 * val31;
      var det2_13 := val21 * val33 - val23 * val31;
      var det2_23 := val22 * val33 - val23 * val32;
      var det3_012 := val10 * det2_12 - val11 * det2_02 + val12 * det2_01;
      var det3_013 := val10 * det2_13 - val11 * det2_03 + val13 * det2_01;
      var det3_023 := val10 * det2_23 - val12 * det2_03 + val13 * det2_02;
      var det3_123 := val11 * det2_23 - val12 * det2_13 + val13 * det2_12;
      Result := val00 * det3_123 - val01 * det3_023 + val02 * det3_013 - val03 * det3_012;
    end;
    
    public static function Random(min, max: single): Mtr4x4f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r); Result.val03 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r); Result.val13 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r); Result.val23 := min + PABCSystem.Random(r);
      Result.val30 := min + PABCSystem.Random(r); Result.val31 := min + PABCSystem.Random(r); Result.val32 := min + PABCSystem.Random(r); Result.val33 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr4x4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02, Result.val03);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12, Result.val13);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22, Result.val23);
      PABCSystem.Read(Result.val30, Result.val31, Result.val32, Result.val33);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr4x4f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02, Result.val03);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12, Result.val13);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22, Result.val23);
      if row_prompt <> nil then row_prompt(3).Print;
      PABCSystem.Readln(Result.val30, Result.val31, Result.val32, Result.val33);
    end;
    public static function ReadCols(prompt: string := nil): Mtr4x4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20, Result.val30);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21, Result.val31);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22, Result.val32);
      PABCSystem.Read(Result.val03, Result.val13, Result.val23, Result.val33);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr4x4f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20, Result.val30);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21, Result.val31);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22, Result.val32);
      if col_prompt <> nil then col_prompt(3).Print;
      PABCSystem.Readln(Result.val03, Result.val13, Result.val23, Result.val33);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      ElStrs[3,3] := (Sign(val33)=-1?'-':'+') + Abs(val33).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x4f; v: Vec4f): Vec4f := new Vec4f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2+m.val33*v.val3);
    public static function operator*(v: Vec4f; m: Mtr4x4f): Vec4f := new Vec4f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2+m.val33*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
  end;
  Mtr4f = Mtr4x4f;
  
  Mtr2x3f = record
    public val00, val10: single;
    public val01, val11: single;
    public val02, val12: single;
    
    public constructor(val00, val01, val02, val10, val11, val12: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
    end;
    
    public static property Identity: Mtr2x3f read new Mtr2x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec3f read new Vec3f(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3f read new Vec3f(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    
    public property Col0: Vec2f read new Vec2f(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2f read new Vec2f(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2f read new Vec2f(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    
    public property ColPtr0: ^Vec2f read pointer(@val00);
    public property ColPtr1: ^Vec2f read pointer(@val01);
    public property ColPtr2: ^Vec2f read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec2f read pointer(IntPtr(pointer(@self)) + x*8);
    
    public procedure UseColPtr0(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val02))^); end;
    
    public static function Scale(k: single): Mtr2x3f := new Mtr2x3f(k, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y: single): Mtr2x3f := new Mtr2x3f(1.0, 0.0, X, 0.0, 1.0, Y);
    public static function TraslateTransposed(X: single): Mtr2x3f := new Mtr2x3f(1.0, 0.0, 0.0, X, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x3f(
         cr, +sr, 0.0,
        -sr,  cr, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x3f(
         cr, -sr, 0.0,
        +sr,  cr, 0.0
      );
    end;
    
    public static function Random(min, max: single): Mtr2x3f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr2x3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr2x3f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12);
    end;
    public static function ReadCols(prompt: string := nil): Mtr2x3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10);
      PABCSystem.Read(Result.val01, Result.val11);
      PABCSystem.Read(Result.val02, Result.val12);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr2x3f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x3f; v: Vec3f): Vec2f := new Vec2f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2);
    public static function operator*(v: Vec2f; m: Mtr2x3f): Vec3f := new Vec3f(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
  end;
  
  Mtr3x2f = record
    public val00, val10, val20: single;
    public val01, val11, val21: single;
    
    public constructor(val00, val01, val10, val11, val20, val21: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
    end;
    
    public static property Identity: Mtr3x2f read new Mtr3x2f(1.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec2f read new Vec2f(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2f read new Vec2f(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2f read new Vec2f(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    
    public property Col0: Vec3f read new Vec3f(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3f read new Vec3f(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    
    public property ColPtr0: ^Vec3f read pointer(@val00);
    public property ColPtr1: ^Vec3f read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec3f read pointer(IntPtr(pointer(@self)) + x*12);
    
    public procedure UseColPtr0(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val01))^); end;
    
    public static function Scale(k: single): Mtr3x2f := new Mtr3x2f(k, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X: single): Mtr3x2f := new Mtr3x2f(1.0, X, 0.0, 1.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: single): Mtr3x2f := new Mtr3x2f(1.0, 0.0, 0.0, 1.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr3x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x2f(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x2f(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0
      );
    end;
    
    public static function Random(min, max: single): Mtr3x2f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr3x2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01);
      PABCSystem.Read(Result.val10, Result.val11);
      PABCSystem.Read(Result.val20, Result.val21);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr3x2f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21);
    end;
    public static function ReadCols(prompt: string := nil): Mtr3x2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr3x2f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x2f; v: Vec2f): Vec3f := new Vec3f(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1);
    public static function operator*(v: Vec3f; m: Mtr3x2f): Vec2f := new Vec2f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
  end;
  
  Mtr2x4f = record
    public val00, val10: single;
    public val01, val11: single;
    public val02, val12: single;
    public val03, val13: single;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
    end;
    
    public static property Identity: Mtr2x4f read new Mtr2x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec4f read new Vec4f(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4f read new Vec4f(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    
    public property Col0: Vec2f read new Vec2f(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2f read new Vec2f(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2f read new Vec2f(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    public property Col3: Vec2f read new Vec2f(self.val03, self.val13) write begin self.val03 := value.val0; self.val13 := value.val1; end;
    
    public property ColPtr0: ^Vec2f read pointer(@val00);
    public property ColPtr1: ^Vec2f read pointer(@val01);
    public property ColPtr2: ^Vec2f read pointer(@val02);
    public property ColPtr3: ^Vec2f read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec2f read pointer(IntPtr(pointer(@self)) + x*8);
    
    public procedure UseColPtr0(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val03))^); end;
    
    public static function Scale(k: single): Mtr2x4f := new Mtr2x4f(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X, Y: single): Mtr2x4f := new Mtr2x4f(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y);
    public static function TraslateTransposed(X: single): Mtr2x4f := new Mtr2x4f(1.0, 0.0, 0.0, 0.0, X, 1.0, 0.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x4f(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x4f(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0
      );
    end;
    
    public static function Random(min, max: single): Mtr2x4f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r); Result.val03 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r); Result.val13 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr2x4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02, Result.val03);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12, Result.val13);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr2x4f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02, Result.val03);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12, Result.val13);
    end;
    public static function ReadCols(prompt: string := nil): Mtr2x4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10);
      PABCSystem.Read(Result.val01, Result.val11);
      PABCSystem.Read(Result.val02, Result.val12);
      PABCSystem.Read(Result.val03, Result.val13);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr2x4f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12);
      if col_prompt <> nil then col_prompt(3).Print;
      PABCSystem.Readln(Result.val03, Result.val13);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x4f; v: Vec4f): Vec2f := new Vec2f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3);
    public static function operator*(v: Vec2f; m: Mtr2x4f): Vec4f := new Vec4f(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1, m.val03*v.val0+m.val13*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr4x2f = record
    public val00, val10, val20, val30: single;
    public val01, val11, val21, val31: single;
    
    public constructor(val00, val01, val10, val11, val20, val21, val30, val31: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
      self.val30 := val30;
      self.val31 := val31;
    end;
    
    public static property Identity: Mtr4x2f read new Mtr4x2f(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec2f read new Vec2f(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2f read new Vec2f(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2f read new Vec2f(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    public property Row3: Vec2f read new Vec2f(self.val30, self.val31) write begin self.val30 := value.val0; self.val31 := value.val1; end;
    
    public property Col0: Vec4f read new Vec4f(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4f read new Vec4f(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    
    public property ColPtr0: ^Vec4f read pointer(@val00);
    public property ColPtr1: ^Vec4f read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec4f read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val01))^); end;
    
    public static function Scale(k: single): Mtr4x2f := new Mtr4x2f(k, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0);
    
    public static function Traslate(X: single): Mtr4x2f := new Mtr4x2f(1.0, X, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: single): Mtr4x2f := new Mtr4x2f(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr4x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x2f(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x2f(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    
    public static function Random(min, max: single): Mtr4x2f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r);
      Result.val30 := min + PABCSystem.Random(r); Result.val31 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr4x2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01);
      PABCSystem.Read(Result.val10, Result.val11);
      PABCSystem.Read(Result.val20, Result.val21);
      PABCSystem.Read(Result.val30, Result.val31);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr4x2f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21);
      if row_prompt <> nil then row_prompt(3).Print;
      PABCSystem.Readln(Result.val30, Result.val31);
    end;
    public static function ReadCols(prompt: string := nil): Mtr4x2f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20, Result.val30);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21, Result.val31);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr4x2f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20, Result.val30);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21, Result.val31);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x2f; v: Vec2f): Vec4f := new Vec4f(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1, m.val30*v.val0+m.val31*v.val1);
    public static function operator*(v: Vec4f; m: Mtr4x2f): Vec2f := new Vec2f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr3x4f = record
    public val00, val10, val20: single;
    public val01, val11, val21: single;
    public val02, val12, val22: single;
    public val03, val13, val23: single;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
    end;
    
    public static property Identity: Mtr3x4f read new Mtr3x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec4f read new Vec4f(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4f read new Vec4f(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4f read new Vec4f(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    
    public property Col0: Vec3f read new Vec3f(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3f read new Vec3f(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3f read new Vec3f(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    public property Col3: Vec3f read new Vec3f(self.val03, self.val13, self.val23) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; end;
    
    public property ColPtr0: ^Vec3f read pointer(@val00);
    public property ColPtr1: ^Vec3f read pointer(@val01);
    public property ColPtr2: ^Vec3f read pointer(@val02);
    public property ColPtr3: ^Vec3f read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec3f read pointer(IntPtr(pointer(@self)) + x*12);
    
    public procedure UseColPtr0(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val03))^); end;
    
    public static function Scale(k: single): Mtr3x4f := new Mtr3x4f(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y, Z: single): Mtr3x4f := new Mtr3x4f(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z);
    public static function TraslateTransposed(X, Y: single): Mtr3x4f := new Mtr3x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr3x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr3x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Random(min, max: single): Mtr3x4f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r); Result.val03 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r); Result.val13 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r); Result.val23 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr3x4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02, Result.val03);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12, Result.val13);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22, Result.val23);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr3x4f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02, Result.val03);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12, Result.val13);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22, Result.val23);
    end;
    public static function ReadCols(prompt: string := nil): Mtr3x4f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22);
      PABCSystem.Read(Result.val03, Result.val13, Result.val23);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr3x4f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22);
      if col_prompt <> nil then col_prompt(3).Print;
      PABCSystem.Readln(Result.val03, Result.val13, Result.val23);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x4f; v: Vec4f): Vec3f := new Vec3f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3);
    public static function operator*(v: Vec3f; m: Mtr3x4f): Vec4f := new Vec4f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
  end;
  
  Mtr4x3f = record
    public val00, val10, val20, val30: single;
    public val01, val11, val21, val31: single;
    public val02, val12, val22, val32: single;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22, val30, val31, val32: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
    end;
    
    public static property Identity: Mtr4x3f read new Mtr4x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec3f read new Vec3f(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3f read new Vec3f(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3f read new Vec3f(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    public property Row3: Vec3f read new Vec3f(self.val30, self.val31, self.val32) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; end;
    
    public property Col0: Vec4f read new Vec4f(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4f read new Vec4f(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4f read new Vec4f(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    
    public property ColPtr0: ^Vec4f read pointer(@val00);
    public property ColPtr1: ^Vec4f read pointer(@val01);
    public property ColPtr2: ^Vec4f read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec4f read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val02))^); end;
    
    public static function Scale(k: single): Mtr4x3f := new Mtr4x3f(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0);
    
    public static function Traslate(X, Y: single): Mtr4x3f := new Mtr4x3f(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y, Z: single): Mtr4x3f := new Mtr4x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, X, Y, Z);
    
    public static function RotateXYcw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr4x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr4x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Random(min, max: single): Mtr4x3f;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r);
      Result.val30 := min + PABCSystem.Random(r); Result.val31 := min + PABCSystem.Random(r); Result.val32 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr4x3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22);
      PABCSystem.Read(Result.val30, Result.val31, Result.val32);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr4x3f;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22);
      if row_prompt <> nil then row_prompt(3).Print;
      PABCSystem.Readln(Result.val30, Result.val31, Result.val32);
    end;
    public static function ReadCols(prompt: string := nil): Mtr4x3f;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20, Result.val30);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21, Result.val31);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22, Result.val32);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr4x3f;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20, Result.val30);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21, Result.val31);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22, Result.val32);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x3f; v: Vec3f): Vec4f := new Vec4f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2);
    public static function operator*(v: Vec4f; m: Mtr4x3f): Vec3f := new Vec3f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
  end;
  
  Mtr2x2d = record
    public val00, val10: double;
    public val01, val11: double;
    
    public constructor(val00, val01, val10, val11: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
    end;
    
    public static property Identity: Mtr2x2d read new Mtr2x2d(1.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec2d read new Vec2d(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2d read new Vec2d(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    
    public property Col0: Vec2d read new Vec2d(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2d read new Vec2d(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    
    public property ColPtr0: ^Vec2d read pointer(@val00);
    public property ColPtr1: ^Vec2d read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec2d read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val01))^); end;
    
    public static function Scale(k: double): Mtr2x2d := new Mtr2x2d(k, 0.0, 0.0, k);
    
    public static function Traslate(X: double): Mtr2x2d := new Mtr2x2d(1.0, X, 0.0, 1.0);
    public static function TraslateTransposed(X: double): Mtr2x2d := new Mtr2x2d(1.0, 0.0, X, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr2x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x2d(
         cr, +sr,
        -sr,  cr
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x2d(
         cr, -sr,
        +sr,  cr
      );
    end;
    
    public function Det: double;
    begin
      Result := val00 * val11 - val01 * val10;
    end;
    
    public static function Random(min, max: double): Mtr2x2d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr2x2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01);
      PABCSystem.Read(Result.val10, Result.val11);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr2x2d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11);
    end;
    public static function ReadCols(prompt: string := nil): Mtr2x2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10);
      PABCSystem.Read(Result.val01, Result.val11);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr2x2d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x2d; v: Vec2d): Vec2d := new Vec2d(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1);
    public static function operator*(v: Vec2d; m: Mtr2x2d): Vec2d := new Vec2d(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x4f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
  end;
  Mtr2d = Mtr2x2d;
  
  Mtr3x3d = record
    public val00, val10, val20: double;
    public val01, val11, val21: double;
    public val02, val12, val22: double;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
    end;
    
    public static property Identity: Mtr3x3d read new Mtr3x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec3d read new Vec3d(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3d read new Vec3d(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3d read new Vec3d(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    
    public property Col0: Vec3d read new Vec3d(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3d read new Vec3d(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3d read new Vec3d(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    
    public property ColPtr0: ^Vec3d read pointer(@val00);
    public property ColPtr1: ^Vec3d read pointer(@val01);
    public property ColPtr2: ^Vec3d read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec3d read pointer(IntPtr(pointer(@self)) + x*24);
    
    public procedure UseColPtr0(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val02))^); end;
    
    public static function Scale(k: double): Mtr3x3d := new Mtr3x3d(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y: double): Mtr3x3d := new Mtr3x3d(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y: double): Mtr3x3d := new Mtr3x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr3x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr3x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function Det: double;
    begin
      var det2_01 := val10 * val21 - val11 * val20;
      var det2_02 := val10 * val22 - val12 * val20;
      var det2_12 := val11 * val22 - val12 * val21;
      Result := val00 * det2_12 - val01 * det2_02 + val02 * det2_01;
    end;
    
    public static function Random(min, max: double): Mtr3x3d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr3x3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr3x3d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22);
    end;
    public static function ReadCols(prompt: string := nil): Mtr3x3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr3x3d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x3d; v: Vec3d): Vec3d := new Vec3d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2);
    public static function operator*(v: Vec3d; m: Mtr3x3d): Vec3d := new Vec3d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
  end;
  Mtr3d = Mtr3x3d;
  
  Mtr4x4d = record
    public val00, val10, val20, val30: double;
    public val01, val11, val21, val31: double;
    public val02, val12, val22, val32: double;
    public val03, val13, val23, val33: double;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23, val30, val31, val32, val33: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
      self.val33 := val33;
    end;
    
    public static property Identity: Mtr4x4d read new Mtr4x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec4d read new Vec4d(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4d read new Vec4d(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4d read new Vec4d(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    public property Row3: Vec4d read new Vec4d(self.val30, self.val31, self.val32, self.val33) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; self.val33 := value.val3; end;
    
    public property Col0: Vec4d read new Vec4d(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4d read new Vec4d(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4d read new Vec4d(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    public property Col3: Vec4d read new Vec4d(self.val03, self.val13, self.val23, self.val33) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; self.val33 := value.val3; end;
    
    public property ColPtr0: ^Vec4d read pointer(@val00);
    public property ColPtr1: ^Vec4d read pointer(@val01);
    public property ColPtr2: ^Vec4d read pointer(@val02);
    public property ColPtr3: ^Vec4d read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec4d read pointer(IntPtr(pointer(@self)) + x*32);
    
    public procedure UseColPtr0(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val03))^); end;
    
    public static function Scale(k: double): Mtr4x4d := new Mtr4x4d(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y, Z: double): Mtr4x4d := new Mtr4x4d(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z, 0.0, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y, Z: double): Mtr4x4d := new Mtr4x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, Z, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr4x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr4x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public function Det: double;
    begin
      var det2_01 := val20 * val31 - val21 * val30;
      var det2_02 := val20 * val32 - val22 * val30;
      var det2_03 := val20 * val33 - val23 * val30;
      var det2_12 := val21 * val32 - val22 * val31;
      var det2_13 := val21 * val33 - val23 * val31;
      var det2_23 := val22 * val33 - val23 * val32;
      var det3_012 := val10 * det2_12 - val11 * det2_02 + val12 * det2_01;
      var det3_013 := val10 * det2_13 - val11 * det2_03 + val13 * det2_01;
      var det3_023 := val10 * det2_23 - val12 * det2_03 + val13 * det2_02;
      var det3_123 := val11 * det2_23 - val12 * det2_13 + val13 * det2_12;
      Result := val00 * det3_123 - val01 * det3_023 + val02 * det3_013 - val03 * det3_012;
    end;
    
    public static function Random(min, max: double): Mtr4x4d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r); Result.val03 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r); Result.val13 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r); Result.val23 := min + PABCSystem.Random(r);
      Result.val30 := min + PABCSystem.Random(r); Result.val31 := min + PABCSystem.Random(r); Result.val32 := min + PABCSystem.Random(r); Result.val33 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr4x4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02, Result.val03);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12, Result.val13);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22, Result.val23);
      PABCSystem.Read(Result.val30, Result.val31, Result.val32, Result.val33);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr4x4d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02, Result.val03);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12, Result.val13);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22, Result.val23);
      if row_prompt <> nil then row_prompt(3).Print;
      PABCSystem.Readln(Result.val30, Result.val31, Result.val32, Result.val33);
    end;
    public static function ReadCols(prompt: string := nil): Mtr4x4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20, Result.val30);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21, Result.val31);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22, Result.val32);
      PABCSystem.Read(Result.val03, Result.val13, Result.val23, Result.val33);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr4x4d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20, Result.val30);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21, Result.val31);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22, Result.val32);
      if col_prompt <> nil then col_prompt(3).Print;
      PABCSystem.Readln(Result.val03, Result.val13, Result.val23, Result.val33);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      ElStrs[3,3] := (Sign(val33)=-1?'-':'+') + Abs(val33).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x4d; v: Vec4d): Vec4d := new Vec4d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2+m.val33*v.val3);
    public static function operator*(v: Vec4d; m: Mtr4x4d): Vec4d := new Vec4d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2+m.val33*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, m.val30, m.val31, m.val32, m.val33);
    public static function operator implicit(m: Mtr4x4d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, m.val30, m.val31, m.val32, m.val33);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    
    public static function operator implicit(m: Mtr4x3f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    
    public static function operator implicit(m: Mtr2x2d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
  end;
  Mtr4d = Mtr4x4d;
  
  Mtr2x3d = record
    public val00, val10: double;
    public val01, val11: double;
    public val02, val12: double;
    
    public constructor(val00, val01, val02, val10, val11, val12: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
    end;
    
    public static property Identity: Mtr2x3d read new Mtr2x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec3d read new Vec3d(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3d read new Vec3d(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    
    public property Col0: Vec2d read new Vec2d(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2d read new Vec2d(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2d read new Vec2d(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    
    public property ColPtr0: ^Vec2d read pointer(@val00);
    public property ColPtr1: ^Vec2d read pointer(@val01);
    public property ColPtr2: ^Vec2d read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec2d read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val02))^); end;
    
    public static function Scale(k: double): Mtr2x3d := new Mtr2x3d(k, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y: double): Mtr2x3d := new Mtr2x3d(1.0, 0.0, X, 0.0, 1.0, Y);
    public static function TraslateTransposed(X: double): Mtr2x3d := new Mtr2x3d(1.0, 0.0, 0.0, X, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x3d(
         cr, +sr, 0.0,
        -sr,  cr, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x3d(
         cr, -sr, 0.0,
        +sr,  cr, 0.0
      );
    end;
    
    public static function Random(min, max: double): Mtr2x3d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr2x3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr2x3d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12);
    end;
    public static function ReadCols(prompt: string := nil): Mtr2x3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10);
      PABCSystem.Read(Result.val01, Result.val11);
      PABCSystem.Read(Result.val02, Result.val12);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr2x3d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x3d; v: Vec3d): Vec2d := new Vec2d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2);
    public static function operator*(v: Vec2d; m: Mtr2x3d): Vec3d := new Vec3d(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x4f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
  end;
  
  Mtr3x2d = record
    public val00, val10, val20: double;
    public val01, val11, val21: double;
    
    public constructor(val00, val01, val10, val11, val20, val21: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
    end;
    
    public static property Identity: Mtr3x2d read new Mtr3x2d(1.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec2d read new Vec2d(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2d read new Vec2d(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2d read new Vec2d(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    
    public property Col0: Vec3d read new Vec3d(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3d read new Vec3d(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    
    public property ColPtr0: ^Vec3d read pointer(@val00);
    public property ColPtr1: ^Vec3d read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec3d read pointer(IntPtr(pointer(@self)) + x*24);
    
    public procedure UseColPtr0(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val01))^); end;
    
    public static function Scale(k: double): Mtr3x2d := new Mtr3x2d(k, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X: double): Mtr3x2d := new Mtr3x2d(1.0, X, 0.0, 1.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: double): Mtr3x2d := new Mtr3x2d(1.0, 0.0, 0.0, 1.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr3x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x2d(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x2d(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0
      );
    end;
    
    public static function Random(min, max: double): Mtr3x2d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr3x2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01);
      PABCSystem.Read(Result.val10, Result.val11);
      PABCSystem.Read(Result.val20, Result.val21);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr3x2d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21);
    end;
    public static function ReadCols(prompt: string := nil): Mtr3x2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr3x2d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x2d; v: Vec2d): Vec3d := new Vec3d(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1);
    public static function operator*(v: Vec3d; m: Mtr3x2d): Vec2d := new Vec2d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
  end;
  
  Mtr2x4d = record
    public val00, val10: double;
    public val01, val11: double;
    public val02, val12: double;
    public val03, val13: double;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
    end;
    
    public static property Identity: Mtr2x4d read new Mtr2x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec4d read new Vec4d(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4d read new Vec4d(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    
    public property Col0: Vec2d read new Vec2d(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2d read new Vec2d(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2d read new Vec2d(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    public property Col3: Vec2d read new Vec2d(self.val03, self.val13) write begin self.val03 := value.val0; self.val13 := value.val1; end;
    
    public property ColPtr0: ^Vec2d read pointer(@val00);
    public property ColPtr1: ^Vec2d read pointer(@val01);
    public property ColPtr2: ^Vec2d read pointer(@val02);
    public property ColPtr3: ^Vec2d read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec2d read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val03))^); end;
    
    public static function Scale(k: double): Mtr2x4d := new Mtr2x4d(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X, Y: double): Mtr2x4d := new Mtr2x4d(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y);
    public static function TraslateTransposed(X: double): Mtr2x4d := new Mtr2x4d(1.0, 0.0, 0.0, 0.0, X, 1.0, 0.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x4d(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x4d(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0
      );
    end;
    
    public static function Random(min, max: double): Mtr2x4d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r); Result.val03 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r); Result.val13 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr2x4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02, Result.val03);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12, Result.val13);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr2x4d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02, Result.val03);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12, Result.val13);
    end;
    public static function ReadCols(prompt: string := nil): Mtr2x4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10);
      PABCSystem.Read(Result.val01, Result.val11);
      PABCSystem.Read(Result.val02, Result.val12);
      PABCSystem.Read(Result.val03, Result.val13);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr2x4d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12);
      if col_prompt <> nil then col_prompt(3).Print;
      PABCSystem.Readln(Result.val03, Result.val13);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x4d; v: Vec4d): Vec2d := new Vec2d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3);
    public static function operator*(v: Vec2d; m: Mtr2x4d): Vec4d := new Vec4d(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1, m.val03*v.val0+m.val13*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x4f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr4x2d = record
    public val00, val10, val20, val30: double;
    public val01, val11, val21, val31: double;
    
    public constructor(val00, val01, val10, val11, val20, val21, val30, val31: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
      self.val30 := val30;
      self.val31 := val31;
    end;
    
    public static property Identity: Mtr4x2d read new Mtr4x2d(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec2d read new Vec2d(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2d read new Vec2d(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2d read new Vec2d(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    public property Row3: Vec2d read new Vec2d(self.val30, self.val31) write begin self.val30 := value.val0; self.val31 := value.val1; end;
    
    public property Col0: Vec4d read new Vec4d(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4d read new Vec4d(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    
    public property ColPtr0: ^Vec4d read pointer(@val00);
    public property ColPtr1: ^Vec4d read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec4d read pointer(IntPtr(pointer(@self)) + x*32);
    
    public procedure UseColPtr0(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val01))^); end;
    
    public static function Scale(k: double): Mtr4x2d := new Mtr4x2d(k, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0);
    
    public static function Traslate(X: double): Mtr4x2d := new Mtr4x2d(1.0, X, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: double): Mtr4x2d := new Mtr4x2d(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr4x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x2d(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x2d(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    
    public static function Random(min, max: double): Mtr4x2d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r);
      Result.val30 := min + PABCSystem.Random(r); Result.val31 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr4x2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01);
      PABCSystem.Read(Result.val10, Result.val11);
      PABCSystem.Read(Result.val20, Result.val21);
      PABCSystem.Read(Result.val30, Result.val31);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr4x2d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21);
      if row_prompt <> nil then row_prompt(3).Print;
      PABCSystem.Readln(Result.val30, Result.val31);
    end;
    public static function ReadCols(prompt: string := nil): Mtr4x2d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20, Result.val30);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21, Result.val31);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr4x2d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20, Result.val30);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21, Result.val31);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x2d; v: Vec2d): Vec4d := new Vec4d(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1, m.val30*v.val0+m.val31*v.val1);
    public static function operator*(v: Vec4d; m: Mtr4x2d): Vec2d := new Vec2d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr3x4d = record
    public val00, val10, val20: double;
    public val01, val11, val21: double;
    public val02, val12, val22: double;
    public val03, val13, val23: double;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
    end;
    
    public static property Identity: Mtr3x4d read new Mtr3x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec4d read new Vec4d(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4d read new Vec4d(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4d read new Vec4d(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    
    public property Col0: Vec3d read new Vec3d(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3d read new Vec3d(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3d read new Vec3d(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    public property Col3: Vec3d read new Vec3d(self.val03, self.val13, self.val23) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; end;
    
    public property ColPtr0: ^Vec3d read pointer(@val00);
    public property ColPtr1: ^Vec3d read pointer(@val01);
    public property ColPtr2: ^Vec3d read pointer(@val02);
    public property ColPtr3: ^Vec3d read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec3d read pointer(IntPtr(pointer(@self)) + x*24);
    
    public procedure UseColPtr0(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val03))^); end;
    
    public static function Scale(k: double): Mtr3x4d := new Mtr3x4d(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y, Z: double): Mtr3x4d := new Mtr3x4d(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z);
    public static function TraslateTransposed(X, Y: double): Mtr3x4d := new Mtr3x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr3x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr3x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Random(min, max: double): Mtr3x4d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r); Result.val03 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r); Result.val13 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r); Result.val23 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr3x4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02, Result.val03);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12, Result.val13);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22, Result.val23);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr3x4d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02, Result.val03);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12, Result.val13);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22, Result.val23);
    end;
    public static function ReadCols(prompt: string := nil): Mtr3x4d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22);
      PABCSystem.Read(Result.val03, Result.val13, Result.val23);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr3x4d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22);
      if col_prompt <> nil then col_prompt(3).Print;
      PABCSystem.Readln(Result.val03, Result.val13, Result.val23);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x4d; v: Vec4d): Vec3d := new Vec3d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3);
    public static function operator*(v: Vec3d; m: Mtr3x4d): Vec4d := new Vec4d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    
    public static function operator implicit(m: Mtr4x3f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
  end;
  
  Mtr4x3d = record
    public val00, val10, val20, val30: double;
    public val01, val11, val21, val31: double;
    public val02, val12, val22, val32: double;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22, val30, val31, val32: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
    end;
    
    public static property Identity: Mtr4x3d read new Mtr4x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec3d read new Vec3d(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3d read new Vec3d(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3d read new Vec3d(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    public property Row3: Vec3d read new Vec3d(self.val30, self.val31, self.val32) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; end;
    
    public property Col0: Vec4d read new Vec4d(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4d read new Vec4d(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4d read new Vec4d(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    
    public property ColPtr0: ^Vec4d read pointer(@val00);
    public property ColPtr1: ^Vec4d read pointer(@val01);
    public property ColPtr2: ^Vec4d read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec4d read pointer(IntPtr(pointer(@self)) + x*32);
    
    public procedure UseColPtr0(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val02))^); end;
    
    public static function Scale(k: double): Mtr4x3d := new Mtr4x3d(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0);
    
    public static function Traslate(X, Y: double): Mtr4x3d := new Mtr4x3d(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y, Z: double): Mtr4x3d := new Mtr4x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, X, Y, Z);
    
    public static function RotateXYcw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr4x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr4x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Random(min, max: double): Mtr4x3d;
    begin
      if min>max then Swap(min,max);
      var r := max-min;
      Result.val00 := min + PABCSystem.Random(r); Result.val01 := min + PABCSystem.Random(r); Result.val02 := min + PABCSystem.Random(r);
      Result.val10 := min + PABCSystem.Random(r); Result.val11 := min + PABCSystem.Random(r); Result.val12 := min + PABCSystem.Random(r);
      Result.val20 := min + PABCSystem.Random(r); Result.val21 := min + PABCSystem.Random(r); Result.val22 := min + PABCSystem.Random(r);
      Result.val30 := min + PABCSystem.Random(r); Result.val31 := min + PABCSystem.Random(r); Result.val32 := min + PABCSystem.Random(r);
    end;
    
    public static function ReadRows(prompt: string := nil): Mtr4x3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val01, Result.val02);
      PABCSystem.Read(Result.val10, Result.val11, Result.val12);
      PABCSystem.Read(Result.val20, Result.val21, Result.val22);
      PABCSystem.Read(Result.val30, Result.val31, Result.val32);
    end;
    public static function ReadlnRows(prompt: string := nil; row_prompt: integer->string := nil): Mtr4x3d;
    begin
      if prompt <> nil then prompt.Println;
      if row_prompt <> nil then row_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val01, Result.val02);
      if row_prompt <> nil then row_prompt(1).Print;
      PABCSystem.Readln(Result.val10, Result.val11, Result.val12);
      if row_prompt <> nil then row_prompt(2).Print;
      PABCSystem.Readln(Result.val20, Result.val21, Result.val22);
      if row_prompt <> nil then row_prompt(3).Print;
      PABCSystem.Readln(Result.val30, Result.val31, Result.val32);
    end;
    public static function ReadCols(prompt: string := nil): Mtr4x3d;
    begin
      if prompt <> nil then prompt.Print;
      PABCSystem.Read(Result.val00, Result.val10, Result.val20, Result.val30);
      PABCSystem.Read(Result.val01, Result.val11, Result.val21, Result.val31);
      PABCSystem.Read(Result.val02, Result.val12, Result.val22, Result.val32);
    end;
    public static function ReadlnCols(prompt: string := nil; col_prompt: integer->string := nil): Mtr4x3d;
    begin
      if prompt <> nil then prompt.Println;
      if col_prompt <> nil then col_prompt(0).Print;
      PABCSystem.Readln(Result.val00, Result.val10, Result.val20, Result.val30);
      if col_prompt <> nil then col_prompt(1).Print;
      PABCSystem.Readln(Result.val01, Result.val11, Result.val21, Result.val31);
      if col_prompt <> nil then col_prompt(2).Print;
      PABCSystem.Readln(Result.val02, Result.val12, Result.val22, Result.val32);
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x3d; v: Vec3d): Vec4d := new Vec4d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2);
    public static function operator*(v: Vec4d; m: Mtr4x3d): Vec3d := new Vec3d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    
    public static function operator implicit(m: Mtr2x2d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
  end;
  
  {$endregion Mtr}
  
  {$region Misc}
  
  Fixed = record
    public val: UInt32;
    
    public constructor(val: UInt32);
    begin
      self.val := val;
    end;
    
  end;
  
  gdi_colorref = record
    private a: byte := 0;
    public r: byte;
    public g: byte;
    public b: byte;
    
    public constructor(r: byte; g: byte; b: byte);
    begin
      self.r := r;
      self.g := g;
      self.b := b;
    end;
    
  end;
  
  gdi_glyphmetrics_float = record
    public gmfBlackBoxX: single;
    public gmfBlackBoxY: single;
    public gmfptGlyphOriginX: single;
    public gmfptGlyphOriginY: single;
    public gmfCellIncX: single;
    public gmfCellIncY: single;
    
    public constructor(gmfBlackBoxX: single; gmfBlackBoxY: single; gmfptGlyphOriginX: single; gmfptGlyphOriginY: single; gmfCellIncX: single; gmfCellIncY: single);
    begin
      self.gmfBlackBoxX := gmfBlackBoxX;
      self.gmfBlackBoxY := gmfBlackBoxY;
      self.gmfptGlyphOriginX := gmfptGlyphOriginX;
      self.gmfptGlyphOriginY := gmfptGlyphOriginY;
      self.gmfCellIncX := gmfCellIncX;
      self.gmfCellIncY := gmfCellIncY;
    end;
    
  end;
  
  gdi_layer_plane_descriptor = record
    public nSize: UInt16 := sizeof(gdi_layer_plane_descriptor);
    public nVersion: UInt16 := 1;
    
    public dwFlags: GDI_LayerPlaneFlags;
    public iPixelType: GDI_PixelDataType;
    
    public cColorBits: Byte; // Кол-во бит для R+G+B
    public cRedBits: Byte; // Если оставить эти 6 нулями - их заполнит автоматически
    public cRedShift: Byte;
    public cGreenBits: Byte;
    public cGreenShift: Byte;
    public cBlueBits: Byte;
    public cBlueShift: Byte;
    public cAlphaBits: Byte; // Последние 2 не работают на Windows
    public cAlphaShift: Byte;
    
    public cAccumBits: Byte;
    public cAccumRedBits: Byte;
    public cAccumGreenBits: Byte;
    public cAccumBlueBits: Byte;
    public cAccumAlphaBits: Byte;
    public cDepthBits: Byte;
    public cStencilBits: Byte;
    
    public cAuxBuffers: Byte; // Устарело
    public iLayerPlane: Byte;
    public bReserved: Byte;
    
    public crTransparent: gdi_colorref; // Прозрачный цвет работает только если в dwFlags добавить LayerPlaneFlagsGDI.TRANSPARENT
    
    public constructor(dwFlags: GDI_LayerPlaneFlags; iPixelType: GDI_PixelDataType; cColorBits: Byte; cRedBits: Byte; cRedShift: Byte; cGreenBits: Byte; cGreenShift: Byte; cBlueBits: Byte; cBlueShift: Byte; cAlphaBits: Byte; cAlphaShift: Byte; cAccumBits: Byte; cAccumRedBits: Byte; cAccumGreenBits: Byte; cAccumBlueBits: Byte; cAccumAlphaBits: Byte; cDepthBits: Byte; cStencilBits: Byte; cAuxBuffers: Byte; iLayerPlane: Byte; bReserved: Byte; crTransparent: gdi_colorref);
    begin
      self.dwFlags := dwFlags;
      self.iPixelType := iPixelType;
      self.cColorBits := cColorBits;
      self.cRedBits := cRedBits;
      self.cRedShift := cRedShift;
      self.cGreenBits := cGreenBits;
      self.cGreenShift := cGreenShift;
      self.cBlueBits := cBlueBits;
      self.cBlueShift := cBlueShift;
      self.cAlphaBits := cAlphaBits;
      self.cAlphaShift := cAlphaShift;
      self.cAccumBits := cAccumBits;
      self.cAccumRedBits := cAccumRedBits;
      self.cAccumGreenBits := cAccumGreenBits;
      self.cAccumBlueBits := cAccumBlueBits;
      self.cAccumAlphaBits := cAccumAlphaBits;
      self.cDepthBits := cDepthBits;
      self.cStencilBits := cStencilBits;
      self.cAuxBuffers := cAuxBuffers;
      self.iLayerPlane := iLayerPlane;
      self.bReserved := bReserved;
      self.crTransparent := crTransparent;
    end;
    
  end;
  
  gdi_pixel_format_descriptor = record
    public nSize: UInt16 := sizeof(gdi_pixel_format_descriptor);
    public nVersion: UInt16 := 1;
    
    public dwFlags: GDI_PixelFormatFlags;
    public iPixelType: GDI_PixelDataType;
    
    public cColorBits: Byte; // Кол-во бит для R+G+B
    public cRedBits: Byte; // Если оставить эти 6 нулями - их заполнит автоматически
    public cRedShift: Byte;
    public cGreenBits: Byte;
    public cGreenShift: Byte;
    public cBlueBits: Byte;
    public cBlueShift: Byte;
    public cAlphaBits: Byte; // Последние 2 не работают на Windows
    public cAlphaShift: Byte;
    
    public cAccumBits: Byte;
    public cAccumRedBits: Byte;
    public cAccumGreenBits: Byte;
    public cAccumBlueBits: Byte;
    public cAccumAlphaBits: Byte;
    
    public cDepthBits: Byte;
    public cStencilBits: Byte;
    public cAuxBuffers: Byte; // Устарело
    
    public iLayerType: Byte; // Устарело
    public bLayersSize: Byte; // Устарело
    
    public dwLayerMask: UInt32; // Не могу найти нормальное описание последних 3, но все оставляют их нулями
    public dwVisibleMask: UInt32;
    public dwDamageMask: UInt32;
    
    public constructor(dwFlags: GDI_PixelFormatFlags; iPixelType: GDI_PixelDataType; cColorBits: Byte; cRedBits: Byte; cRedShift: Byte; cGreenBits: Byte; cGreenShift: Byte; cBlueBits: Byte; cBlueShift: Byte; cAlphaBits: Byte; cAlphaShift: Byte; cAccumBits: Byte; cAccumRedBits: Byte; cAccumGreenBits: Byte; cAccumBlueBits: Byte; cAccumAlphaBits: Byte; cDepthBits: Byte; cStencilBits: Byte; cAuxBuffers: Byte; iLayerType: Byte; bLayersSize: Byte; dwLayerMask: UInt32; dwVisibleMask: UInt32; dwDamageMask: UInt32);
    begin
      self.dwFlags := dwFlags;
      self.iPixelType := iPixelType;
      self.cColorBits := cColorBits;
      self.cRedBits := cRedBits;
      self.cRedShift := cRedShift;
      self.cGreenBits := cGreenBits;
      self.cGreenShift := cGreenShift;
      self.cBlueBits := cBlueBits;
      self.cBlueShift := cBlueShift;
      self.cAlphaBits := cAlphaBits;
      self.cAlphaShift := cAlphaShift;
      self.cAccumBits := cAccumBits;
      self.cAccumRedBits := cAccumRedBits;
      self.cAccumGreenBits := cAccumGreenBits;
      self.cAccumBlueBits := cAccumBlueBits;
      self.cAccumAlphaBits := cAccumAlphaBits;
      self.cDepthBits := cDepthBits;
      self.cStencilBits := cStencilBits;
      self.cAuxBuffers := cAuxBuffers;
      self.iLayerType := iLayerType;
      self.bLayersSize := bLayersSize;
      self.dwLayerMask := dwLayerMask;
      self.dwVisibleMask := dwVisibleMask;
      self.dwDamageMask := dwDamageMask;
    end;
    
  end;
  
  [StructLayout(LayoutKind.Explicit, Size = 80)]
  ///--
  _ValueString_80 = record
    
    public property NtvChars[i: integer]: Byte
    read Marshal.ReadByte(new IntPtr(@self), i)
    write Marshal.WriteByte(new IntPtr(@self), i, value);    public property Chars[i: integer]: char read ChrAnsi(NtvChars[i]) write NtvChars[i] := OrdAnsi(value); default;
    
    public constructor(s: string);
    begin
      if s.Length >= 80 then raise new System.OverflowException;
      
      for var i := 0 to s.Length-1 do
        self[i] := s[i+1];
      self.NtvChars[s.Length] := 0;
      
    end;
    
    public function ToString: string; override :=
    Marshal.PtrToStringAnsi(new IntPtr(@self));
    
  end;
  
  glx_hyperpipe_config_SGIX = record
    public pipeName: _ValueString_80;
    public channel: Int32;
    public participationType: PipeParticipationTypeFlags;
    public timeSlice: Int32;
    
    public constructor(pipeName: _ValueString_80; channel: Int32; participationType: PipeParticipationTypeFlags; timeSlice: Int32);
    begin
      self.pipeName := pipeName;
      self.channel := channel;
      self.participationType := participationType;
      self.timeSlice := timeSlice;
    end;
    
  end;
  
  glx_hyperpipe_network_SGIX = record
    public pipeName: _ValueString_80;
    public networkId: Int32;
    
    public constructor(pipeName: _ValueString_80; networkId: Int32);
    begin
      self.pipeName := pipeName;
      self.networkId := networkId;
    end;
    
  end;
  
  glx_pipe_rect_limits_SGIX = record
    public pipeName: _ValueString_80;
    public XOrigin: Int32;
    public YOrigin: Int32;
    public maxHeight: Int32;
    public maxWidth: Int32;
    
    public constructor(pipeName: _ValueString_80; XOrigin: Int32; YOrigin: Int32; maxHeight: Int32; maxWidth: Int32);
    begin
      self.pipeName := pipeName;
      self.XOrigin := XOrigin;
      self.YOrigin := YOrigin;
      self.maxHeight := maxHeight;
      self.maxWidth := maxWidth;
    end;
    
  end;
  
  glx_pipe_rect_SGIX = record
    public pipeName: _ValueString_80;
    public srcXOrigin: Int32;
    public srcYOrigin: Int32;
    public srcWidth: Int32;
    public srcHeight: Int32;
    public destXOrigin: Int32;
    public destYOrigin: Int32;
    public destWidth: Int32;
    public destHeight: Int32;
    
    public constructor(pipeName: _ValueString_80; srcXOrigin: Int32; srcYOrigin: Int32; srcWidth: Int32; srcHeight: Int32; destXOrigin: Int32; destYOrigin: Int32; destWidth: Int32; destHeight: Int32);
    begin
      self.pipeName := pipeName;
      self.srcXOrigin := srcXOrigin;
      self.srcYOrigin := srcYOrigin;
      self.srcWidth := srcWidth;
      self.srcHeight := srcHeight;
      self.destXOrigin := destXOrigin;
      self.destYOrigin := destYOrigin;
      self.destWidth := destWidth;
      self.destHeight := destHeight;
    end;
    
  end;
  
  Half = record
    public val: UInt16;
    
    public constructor(val: UInt16);
    begin
      self.val := val;
    end;
    
  end;
  
  [StructLayout(LayoutKind.Explicit, Size = 32)]
  ///--
  _ValueString_32 = record
    
    public property NtvChars[i: integer]: Byte
    read Marshal.ReadByte(new IntPtr(@self), i)
    write Marshal.WriteByte(new IntPtr(@self), i, value);    public property Chars[i: integer]: char read ChrAnsi(NtvChars[i]) write NtvChars[i] := OrdAnsi(value); default;
    
    public constructor(s: string);
    begin
      if s.Length >= 32 then raise new System.OverflowException;
      
      for var i := 0 to s.Length-1 do
        self[i] := s[i+1];
      self.NtvChars[s.Length] := 0;
      
    end;
    
    public function ToString: string; override :=
    Marshal.PtrToStringAnsi(new IntPtr(@self));
    
  end;
  
  [StructLayout(LayoutKind.Explicit, Size = 128)]
  ///--
  _ValueString_128 = record
    
    public property NtvChars[i: integer]: Byte
    read Marshal.ReadByte(new IntPtr(@self), i)
    write Marshal.WriteByte(new IntPtr(@self), i, value);    public property Chars[i: integer]: char read ChrAnsi(NtvChars[i]) write NtvChars[i] := OrdAnsi(value); default;
    
    public constructor(s: string);
    begin
      if s.Length >= 128 then raise new System.OverflowException;
      
      for var i := 0 to s.Length-1 do
        self[i] := s[i+1];
      self.NtvChars[s.Length] := 0;
      
    end;
    
    public function ToString: string; override :=
    Marshal.PtrToStringAnsi(new IntPtr(@self));
    
  end;
  
  wgl_GPU_device_NV = record
    public cb: UInt32 := sizeof(wgl_GPU_device_NV);
    public DeviceName: _ValueString_32;
    public DeviceString: _ValueString_128;
    public Flags: GPUDisplayDeviceFlagsNV;
    public rcVirtualScreen: record left, top, right, bottom: Int64; end := (left: 0; top: 0; right: 0; bottom: 0);
    
    public constructor(DeviceName: _ValueString_32; DeviceString: _ValueString_128; Flags: GPUDisplayDeviceFlagsNV);
    begin
      self.DeviceName := DeviceName;
      self.DeviceString := DeviceString;
      self.Flags := Flags;
    end;
    
  end;
  
  {$endregion Misc}
  
  {$endregion Записи}
  
  {$region Другие типы}
  
  DummyEnum = UInt32;
  DummyFlags = UInt32;
  
  OpenGLException = sealed class(Exception)
    private ec: ErrorCode;
    public property Code: ErrorCode read ec;
    
    public constructor(ec: ErrorCode);
    begin
      inherited Create($'Ошибка OpenGL: "{ec}"');
      self.ec := ec;
    end;
    
  end;
  
  PlatformLoader = abstract class
    
    protected static function LoadLibrary(name: string): IntPtr;
    external 'kernel32.dll';
    protected static function GetProcAddress(lib: IntPtr; name: string): IntPtr;
    external 'kernel32.dll';
    
    public function GetProcAddress(name: string): IntPtr; abstract;
    
  end;
  
  {$endregion Другие типы}
  
  {$region Функции}
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  gl = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    // added in gl4.1
    private z_ActiveShaderProgram_adr := GetProcAddress('glActiveShaderProgram');
    private z_ActiveShaderProgram_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; &program: gl_program)>(z_ActiveShaderProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveShaderProgram(pipeline: gl_program_pipeline; &program: gl_program) :=
    z_ActiveShaderProgram_ovr_0(pipeline, &program);
    
    // added in gl1.3
    private z_ActiveTexture_adr := GetProcAddress('glActiveTexture');
    private z_ActiveTexture_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit)>(z_ActiveTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveTexture(texture: TextureUnit) :=
    z_ActiveTexture_ovr_0(texture);
    
    // added in gl2.0
    private z_AttachShader_adr := GetProcAddress('glAttachShader');
    private z_AttachShader_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; shader: gl_shader)>(z_AttachShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AttachShader(&program: gl_program; shader: gl_shader) :=
    z_AttachShader_ovr_0(&program, shader);
    
    // added in gl3.0
    private z_BeginConditionalRender_adr := GetProcAddress('glBeginConditionalRender');
    private z_BeginConditionalRender_ovr_0 := GetProcOrNil&<procedure(id: UInt32; mode: ConditionalRenderMode)>(z_BeginConditionalRender_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginConditionalRender(id: UInt32; mode: ConditionalRenderMode) :=
    z_BeginConditionalRender_ovr_0(id, mode);
    
    // added in gl1.5
    private z_BeginQuery_adr := GetProcAddress('glBeginQuery');
    private z_BeginQuery_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; id: gl_query)>(z_BeginQuery_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQuery(target: QueryTarget; id: gl_query) :=
    z_BeginQuery_ovr_0(target, id);
    
    // added in gl4.0
    private z_BeginQueryIndexed_adr := GetProcAddress('glBeginQueryIndexed');
    private z_BeginQueryIndexed_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; id: gl_query)>(z_BeginQueryIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQueryIndexed(target: QueryTarget; index: UInt32; id: gl_query) :=
    z_BeginQueryIndexed_ovr_0(target, index, id);
    
    // added in gl3.0
    private z_BeginTransformFeedback_adr := GetProcAddress('glBeginTransformFeedback');
    private z_BeginTransformFeedback_ovr_0 := GetProcOrNil&<procedure(primitiveMode: PrimitiveType)>(z_BeginTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginTransformFeedback(primitiveMode: PrimitiveType) :=
    z_BeginTransformFeedback_ovr_0(primitiveMode);
    
    // added in gl2.0
    private z_BindAttribLocation_adr := GetProcAddress('glBindAttribLocation');
    private z_BindAttribLocation_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; name: IntPtr)>(z_BindAttribLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocation(&program: gl_program; index: UInt32; name: string);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_BindAttribLocation_ovr_0(&program, index, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocation(&program: gl_program; index: UInt32; name: IntPtr) :=
    z_BindAttribLocation_ovr_0(&program, index, name);
    
    // added in gl1.5
    private z_BindBuffer_adr := GetProcAddress('glBindBuffer');
    private z_BindBuffer_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; buffer: gl_buffer)>(z_BindBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffer(target: BufferTarget; buffer: gl_buffer) :=
    z_BindBuffer_ovr_0(target, buffer);
    
    // added in gl3.0
    private z_BindBufferBase_adr := GetProcAddress('glBindBufferBase');
    private z_BindBufferBase_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer)>(z_BindBufferBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBase(target: BufferTarget; index: UInt32; buffer: gl_buffer) :=
    z_BindBufferBase_ovr_0(target, index, buffer);
    
    // added in gl3.0
    private z_BindBufferRange_adr := GetProcAddress('glBindBufferRange');
    private z_BindBufferRange_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_BindBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRange(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRange_ovr_0(target, index, buffer, offset, size);
    
    // added in gl4.4
    private z_BindBuffersBase_adr := GetProcAddress('glBindBuffersBase');
    private z_BindBuffersBase_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer)>(z_BindBuffersBase_adr);
    private z_BindBuffersBase_ovr_0_anh00001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr)>(z_BindBuffersBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersBase_ovr_0(target, first, count, buffers[0]) else
      z_BindBuffersBase_ovr_0_anh00001(target, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer) :=
    z_BindBuffersBase_ovr_0(target, first, count, buffers);
    private z_BindBuffersBase_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr)>(z_BindBuffersBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr) :=
    z_BindBuffersBase_ovr_2(target, first, count, buffers);
    
    // added in gl4.4
    private z_BindBuffersRange_adr := GetProcAddress('glBindBuffersRange');
    private z_BindBuffersRange_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000110 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000101 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000011 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000111 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000111(target, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_1_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_1_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_1_anh0000110 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000110 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_3_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_3_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_3_anh0000101 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindBuffersRange_ovr_4_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_5_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_6 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000101 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindBuffersRange_ovr_7_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_8 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_8_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_8(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_8_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_9_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_9_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_9_anh0000011 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_10_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_11_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_12_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_15_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_8(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_18 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000011 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_19_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_20 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_20_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_20_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_21_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_24 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_24_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_24_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_26 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_26(target, first, count, buffers, offsets, sizes);
    
    // added in gl3.0
    private z_BindFragDataLocation_adr := GetProcAddress('glBindFragDataLocation');
    private z_BindFragDataLocation_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; color: UInt32; name: IntPtr)>(z_BindFragDataLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocation(&program: gl_program; color: UInt32; name: string);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_BindFragDataLocation_ovr_0(&program, color, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocation(&program: gl_program; color: UInt32; name: IntPtr) :=
    z_BindFragDataLocation_ovr_0(&program, color, name);
    
    // added in gl3.3
    private z_BindFragDataLocationIndexed_adr := GetProcAddress('glBindFragDataLocationIndexed');
    private z_BindFragDataLocationIndexed_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; colorNumber: UInt32; index: UInt32; name: IntPtr)>(z_BindFragDataLocationIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: gl_program; colorNumber: UInt32; index: UInt32; name: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: gl_program; colorNumber: UInt32; index: UInt32; name: IntPtr) :=
    z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, name);
    
    // added in gl3.0
    private z_BindFramebuffer_adr := GetProcAddress('glBindFramebuffer');
    private z_BindFramebuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; framebuffer: gl_framebuffer)>(z_BindFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFramebuffer(target: FramebufferTarget; framebuffer: gl_framebuffer) :=
    z_BindFramebuffer_ovr_0(target, framebuffer);
    
    // added in gl4.2
    private z_BindImageTexture_adr := GetProcAddress('glBindImageTexture');
    private z_BindImageTexture_ovr_0 := GetProcOrNil&<procedure(&unit: UInt32; texture: gl_texture; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat)>(z_BindImageTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTexture(&unit: UInt32; texture: gl_texture; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat) :=
    z_BindImageTexture_ovr_0(&unit, texture, level, layered, layer, access, format);
    
    // added in gl4.4
    private z_BindImageTextures_adr := GetProcAddress('glBindImageTextures');
    private z_BindImageTextures_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var textures: gl_texture)>(z_BindImageTextures_adr);
    private z_BindImageTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindImageTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindImageTextures_ovr_0(first, count, textures[0]) else
      z_BindImageTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; var textures: gl_texture) :=
    z_BindImageTextures_ovr_0(first, count, textures);
    private z_BindImageTextures_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindImageTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindImageTextures_ovr_2(first, count, textures);
    
    // added in gl4.1
    private z_BindProgramPipeline_adr := GetProcAddress('glBindProgramPipeline');
    private z_BindProgramPipeline_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline)>(z_BindProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramPipeline(pipeline: gl_program_pipeline) :=
    z_BindProgramPipeline_ovr_0(pipeline);
    
    // added in gl3.0
    private z_BindRenderbuffer_adr := GetProcAddress('glBindRenderbuffer');
    private z_BindRenderbuffer_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_BindRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindRenderbuffer(target: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_BindRenderbuffer_ovr_0(target, renderbuffer);
    
    // added in gl3.3
    private z_BindSampler_adr := GetProcAddress('glBindSampler');
    private z_BindSampler_ovr_0 := GetProcOrNil&<procedure(&unit: UInt32; sampler: gl_sampler)>(z_BindSampler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSampler(&unit: UInt32; sampler: gl_sampler) :=
    z_BindSampler_ovr_0(&unit, sampler);
    
    // added in gl4.4
    private z_BindSamplers_adr := GetProcAddress('glBindSamplers');
    private z_BindSamplers_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var samplers: gl_sampler)>(z_BindSamplers_adr);
    private z_BindSamplers_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; samplers: IntPtr)>(z_BindSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_BindSamplers_ovr_0(first, count, samplers[0]) else
      z_BindSamplers_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; var samplers: gl_sampler) :=
    z_BindSamplers_ovr_0(first, count, samplers);
    private z_BindSamplers_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; samplers: IntPtr)>(z_BindSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: IntPtr) :=
    z_BindSamplers_ovr_2(first, count, samplers);
    
    // added in gl1.1
    private z_BindTexture_adr := GetProcAddress('glBindTexture');
    private z_BindTexture_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; texture: gl_texture)>(z_BindTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTexture(target: TextureTarget; texture: gl_texture) :=
    z_BindTexture_ovr_0(target, texture);
    
    // added in gl4.4
    private z_BindTextures_adr := GetProcAddress('glBindTextures');
    private z_BindTextures_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var textures: gl_texture)>(z_BindTextures_adr);
    private z_BindTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindTextures_ovr_0(first, count, textures[0]) else
      z_BindTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; var textures: gl_texture) :=
    z_BindTextures_ovr_0(first, count, textures);
    private z_BindTextures_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindTextures_ovr_2(first, count, textures);
    
    // added in gl4.5
    private z_BindTextureUnit_adr := GetProcAddress('glBindTextureUnit');
    private z_BindTextureUnit_ovr_0 := GetProcOrNil&<procedure(&unit: UInt32; texture: gl_texture)>(z_BindTextureUnit_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextureUnit(&unit: UInt32; texture: gl_texture) :=
    z_BindTextureUnit_ovr_0(&unit, texture);
    
    // added in gl4.0
    private z_BindTransformFeedback_adr := GetProcAddress('glBindTransformFeedback');
    private z_BindTransformFeedback_ovr_0 := GetProcOrNil&<procedure(target: BindTransformFeedbackTarget; id: gl_transform_feedback)>(z_BindTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTransformFeedback(target: BindTransformFeedbackTarget; id: gl_transform_feedback) :=
    z_BindTransformFeedback_ovr_0(target, id);
    
    // added in gl3.0
    private z_BindVertexArray_adr := GetProcAddress('glBindVertexArray');
    private z_BindVertexArray_ovr_0 := GetProcOrNil&<procedure(&array: gl_vertex_array)>(z_BindVertexArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexArray(&array: gl_vertex_array) :=
    z_BindVertexArray_ovr_0(&array);
    
    // added in gl4.3
    private z_BindVertexBuffer_adr := GetProcAddress('glBindVertexBuffer');
    private z_BindVertexBuffer_ovr_0 := GetProcOrNil&<procedure(bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32)>(z_BindVertexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffer(bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32) :=
    z_BindVertexBuffer_ovr_0(bindingindex, buffer, offset, stride);
    
    // added in gl4.4
    private z_BindVertexBuffers_adr := GetProcAddress('glBindVertexBuffers');
    private z_BindVertexBuffers_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000110 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000101 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000011 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000111 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000111(first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_1_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_1_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_1_anh000110 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000110 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_3_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_3_anh000101 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_4_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_5_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_6 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000101 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_7_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_8 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_8_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_8(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_8_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_9_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_9_anh000011 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_10_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_11_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_2(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_8(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_18 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000011 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_19_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_20 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_20_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_20(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_20_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_20(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_24 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_24_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_24_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_26 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_26(first, count, buffers, offsets, strides);
    
    // added in gl1.4
    private z_BlendColor_adr := GetProcAddress('glBlendColor');
    private z_BlendColor_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_BlendColor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColor(red: single; green: single; blue: single; alpha: single) :=
    z_BlendColor_ovr_0(red, green, blue, alpha);
    
    // added in gl1.4
    private z_BlendEquation_adr := GetProcAddress('glBlendEquation');
    private z_BlendEquation_ovr_0 := GetProcOrNil&<procedure(mode: BlendEquationModeEXT)>(z_BlendEquation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquation(mode: BlendEquationModeEXT) :=
    z_BlendEquation_ovr_0(mode);
    
    // added in gl4.0
    private z_BlendEquationi_adr := GetProcAddress('glBlendEquationi');
    private z_BlendEquationi_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; mode: BlendEquationModeEXT)>(z_BlendEquationi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationi(buf: UInt32; mode: BlendEquationModeEXT) :=
    z_BlendEquationi_ovr_0(buf, mode);
    
    // added in gl2.0
    private z_BlendEquationSeparate_adr := GetProcAddress('glBlendEquationSeparate');
    private z_BlendEquationSeparate_ovr_0 := GetProcOrNil&<procedure(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparate(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparate_ovr_0(modeRGB, modeAlpha);
    
    // added in gl4.0
    private z_BlendEquationSeparatei_adr := GetProcAddress('glBlendEquationSeparatei');
    private z_BlendEquationSeparatei_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparatei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparatei(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparatei_ovr_0(buf, modeRGB, modeAlpha);
    
    // added in gl1.0
    private z_BlendFunc_adr := GetProcAddress('glBlendFunc');
    private z_BlendFunc_ovr_0 := GetProcOrNil&<procedure(sfactor: BlendingFactor; dfactor: BlendingFactor)>(z_BlendFunc_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFunc(sfactor: BlendingFactor; dfactor: BlendingFactor) :=
    z_BlendFunc_ovr_0(sfactor, dfactor);
    
    // added in gl4.0
    private z_BlendFunci_adr := GetProcAddress('glBlendFunci');
    private z_BlendFunci_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; src: BlendingFactor; dst: BlendingFactor)>(z_BlendFunci_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFunci(buf: UInt32; src: BlendingFactor; dst: BlendingFactor) :=
    z_BlendFunci_ovr_0(buf, src, dst);
    
    // added in gl1.4
    private z_BlendFuncSeparate_adr := GetProcAddress('glBlendFuncSeparate');
    private z_BlendFuncSeparate_ovr_0 := GetProcOrNil&<procedure(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor)>(z_BlendFuncSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparate(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor) :=
    z_BlendFuncSeparate_ovr_0(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
    
    // added in gl4.0
    private z_BlendFuncSeparatei_adr := GetProcAddress('glBlendFuncSeparatei');
    private z_BlendFuncSeparatei_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor)>(z_BlendFuncSeparatei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparatei(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor) :=
    z_BlendFuncSeparatei_ovr_0(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
    
    // added in gl3.0
    private z_BlitFramebuffer_adr := GetProcAddress('glBlitFramebuffer');
    private z_BlitFramebuffer_ovr_0 := GetProcOrNil&<procedure(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitFramebuffer(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitFramebuffer_ovr_0(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    // added in gl4.5
    private z_BlitNamedFramebuffer_adr := GetProcAddress('glBlitNamedFramebuffer');
    private z_BlitNamedFramebuffer_ovr_0 := GetProcOrNil&<procedure(readFramebuffer: gl_framebuffer; drawFramebuffer: gl_framebuffer; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitNamedFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitNamedFramebuffer(readFramebuffer: gl_framebuffer; drawFramebuffer: gl_framebuffer; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitNamedFramebuffer_ovr_0(readFramebuffer, drawFramebuffer, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    // added in gl1.5
    private z_BufferData_adr := GetProcAddress('glBufferData');
    private z_BufferData_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; size: IntPtr; data: IntPtr; usage: BufferUsageARB)>(z_BufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferData(target: BufferTarget; size: IntPtr; data: IntPtr; usage: BufferUsageARB) :=
    z_BufferData_ovr_0(target, size, data, usage);
    
    // added in gl4.4
    private z_BufferStorage_adr := GetProcAddress('glBufferStorage');
    private z_BufferStorage_ovr_0 := GetProcOrNil&<procedure(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_BufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorage(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_BufferStorage_ovr_0(target, size, data, flags);
    
    // added in gl1.5
    private z_BufferSubData_adr := GetProcAddress('glBufferSubData');
    private z_BufferSubData_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_BufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferSubData(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_BufferSubData_ovr_0(target, offset, size, data);
    
    // added in gl3.0
    private z_CheckFramebufferStatus_adr := GetProcAddress('glCheckFramebufferStatus');
    private z_CheckFramebufferStatus_ovr_0 := GetProcOrNil&<function(target: FramebufferTarget): FramebufferStatus>(z_CheckFramebufferStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckFramebufferStatus(target: FramebufferTarget): FramebufferStatus :=
    z_CheckFramebufferStatus_ovr_0(target);
    
    // added in gl4.5
    private z_CheckNamedFramebufferStatus_adr := GetProcAddress('glCheckNamedFramebufferStatus');
    private z_CheckNamedFramebufferStatus_ovr_0 := GetProcOrNil&<function(framebuffer: gl_framebuffer; target: FramebufferTarget): FramebufferStatus>(z_CheckNamedFramebufferStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckNamedFramebufferStatus(framebuffer: gl_framebuffer; target: FramebufferTarget): FramebufferStatus :=
    z_CheckNamedFramebufferStatus_ovr_0(framebuffer, target);
    
    // added in gl3.0
    private z_ClampColor_adr := GetProcAddress('glClampColor');
    private z_ClampColor_ovr_0 := GetProcOrNil&<procedure(target: ClampColorTargetARB; clamp: ClampColorModeARB)>(z_ClampColor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClampColor(target: ClampColorTargetARB; clamp: ClampColorModeARB) :=
    z_ClampColor_ovr_0(target, clamp);
    
    // added in gl1.0
    private z_Clear_adr := GetProcAddress('glClear');
    private z_Clear_ovr_0 := GetProcOrNil&<procedure(mask: ClearBufferMask)>(z_Clear_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Clear(mask: ClearBufferMask) :=
    z_Clear_ovr_0(mask);
    
    // added in gl4.3
    private z_ClearBufferData_adr := GetProcAddress('glClearBufferData');
    private z_ClearBufferData_ovr_0 := GetProcOrNil&<procedure(target: BufferStorageTarget; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferData(target: BufferStorageTarget; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferData_ovr_0(target, internalformat, format, &type, data);
    
    // added in gl3.0
    private z_ClearBufferfi_adr := GetProcAddress('glClearBufferfi');
    private z_ClearBufferfi_ovr_0 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32)>(z_ClearBufferfi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfi(_buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32) :=
    z_ClearBufferfi_ovr_0(_buffer, drawbuffer, depth, stencil);
    
    // added in gl3.0
    private z_ClearBufferfv_adr := GetProcAddress('glClearBufferfv');
    private z_ClearBufferfv_ovr_0 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; var value: single)>(z_ClearBufferfv_adr);
    private z_ClearBufferfv_ovr_0_anh0001 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfv(_buffer: Buffer; drawbuffer: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearBufferfv_ovr_0(_buffer, drawbuffer, value[0]) else
      z_ClearBufferfv_ovr_0_anh0001(_buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfv(_buffer: Buffer; drawbuffer: Int32; var value: single) :=
    z_ClearBufferfv_ovr_0(_buffer, drawbuffer, value);
    private z_ClearBufferfv_ovr_2 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfv(_buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearBufferfv_ovr_2(_buffer, drawbuffer, value);
    
    // added in gl3.0
    private z_ClearBufferiv_adr := GetProcAddress('glClearBufferiv');
    private z_ClearBufferiv_ovr_0 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; var value: Int32)>(z_ClearBufferiv_adr);
    private z_ClearBufferiv_ovr_0_anh0001 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferiv(_buffer: Buffer; drawbuffer: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearBufferiv_ovr_0(_buffer, drawbuffer, value[0]) else
      z_ClearBufferiv_ovr_0_anh0001(_buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferiv(_buffer: Buffer; drawbuffer: Int32; var value: Int32) :=
    z_ClearBufferiv_ovr_0(_buffer, drawbuffer, value);
    private z_ClearBufferiv_ovr_2 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferiv(_buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearBufferiv_ovr_2(_buffer, drawbuffer, value);
    
    // added in gl4.3
    private z_ClearBufferSubData_adr := GetProcAddress('glClearBufferSubData');
    private z_ClearBufferSubData_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferSubData(target: BufferTarget; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferSubData_ovr_0(target, internalformat, offset, size, format, &type, data);
    
    // added in gl3.0
    private z_ClearBufferuiv_adr := GetProcAddress('glClearBufferuiv');
    private z_ClearBufferuiv_ovr_0 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; var value: UInt32)>(z_ClearBufferuiv_adr);
    private z_ClearBufferuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferuiv(_buffer: Buffer; drawbuffer: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearBufferuiv_ovr_0(_buffer, drawbuffer, value[0]) else
      z_ClearBufferuiv_ovr_0_anh0001(_buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferuiv(_buffer: Buffer; drawbuffer: Int32; var value: UInt32) :=
    z_ClearBufferuiv_ovr_0(_buffer, drawbuffer, value);
    private z_ClearBufferuiv_ovr_2 := GetProcOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferuiv(_buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearBufferuiv_ovr_2(_buffer, drawbuffer, value);
    
    // added in gl1.0
    private z_ClearColor_adr := GetProcAddress('glClearColor');
    private z_ClearColor_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_ClearColor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColor(red: single; green: single; blue: single; alpha: single) :=
    z_ClearColor_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0
    private z_ClearDepth_adr := GetProcAddress('glClearDepth');
    private z_ClearDepth_ovr_0 := GetProcOrNil&<procedure(depth: real)>(z_ClearDepth_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepth(depth: real) :=
    z_ClearDepth_ovr_0(depth);
    
    // added in gl4.1
    private z_ClearDepthf_adr := GetProcAddress('glClearDepthf');
    private z_ClearDepthf_ovr_0 := GetProcOrNil&<procedure(d: single)>(z_ClearDepthf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthf(d: single) :=
    z_ClearDepthf_ovr_0(d);
    
    // added in gl4.5
    private z_ClearNamedBufferData_adr := GetProcAddress('glClearNamedBufferData');
    private z_ClearNamedBufferData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferData(buffer: gl_buffer; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferData_ovr_0(buffer, internalformat, format, &type, data);
    
    // added in gl4.5
    private z_ClearNamedBufferSubData_adr := GetProcAddress('glClearNamedBufferSubData');
    private z_ClearNamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferSubData(buffer: gl_buffer; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferSubData_ovr_0(buffer, internalformat, offset, size, format, &type, data);
    
    // added in gl4.5
    private z_ClearNamedFramebufferfi_adr := GetProcAddress('glClearNamedFramebufferfi');
    private z_ClearNamedFramebufferfi_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32)>(z_ClearNamedFramebufferfi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfi(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32) :=
    z_ClearNamedFramebufferfi_ovr_0(framebuffer, _buffer, drawbuffer, depth, stencil);
    
    // added in gl4.5
    private z_ClearNamedFramebufferfv_adr := GetProcAddress('glClearNamedFramebufferfv');
    private z_ClearNamedFramebufferfv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: single)>(z_ClearNamedFramebufferfv_adr);
    private z_ClearNamedFramebufferfv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferfv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: single) :=
    z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferfv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferfv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    // added in gl4.5
    private z_ClearNamedFramebufferiv_adr := GetProcAddress('glClearNamedFramebufferiv');
    private z_ClearNamedFramebufferiv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: Int32)>(z_ClearNamedFramebufferiv_adr);
    private z_ClearNamedFramebufferiv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: Int32) :=
    z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferiv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    // added in gl4.5
    private z_ClearNamedFramebufferuiv_adr := GetProcAddress('glClearNamedFramebufferuiv');
    private z_ClearNamedFramebufferuiv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: UInt32)>(z_ClearNamedFramebufferuiv_adr);
    private z_ClearNamedFramebufferuiv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferuiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: UInt32) :=
    z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferuiv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferuiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    // added in gl1.0
    private z_ClearStencil_adr := GetProcAddress('glClearStencil');
    private z_ClearStencil_ovr_0 := GetProcOrNil&<procedure(s: Int32)>(z_ClearStencil_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearStencil(s: Int32) :=
    z_ClearStencil_ovr_0(s);
    
    // added in gl4.4
    private z_ClearTexImage_adr := GetProcAddress('glClearTexImage');
    private z_ClearTexImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexImage(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexImage_ovr_0(texture, level, format, &type, data);
    
    // added in gl4.4
    private z_ClearTexSubImage_adr := GetProcAddress('glClearTexSubImage');
    private z_ClearTexSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearTexSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, data);
    
    // added in gl3.2
    private z_ClientWaitSync_adr := GetProcAddress('glClientWaitSync');
    private z_ClientWaitSync_ovr_0 := GetProcOrNil&<function(sync: gl_sync; flags: SyncObjectMask; timeout: UInt64): SyncStatus>(z_ClientWaitSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ClientWaitSync(sync: gl_sync; flags: SyncObjectMask; timeout: UInt64): SyncStatus :=
    z_ClientWaitSync_ovr_0(sync, flags, timeout);
    
    // added in gl4.5
    private z_ClipControl_adr := GetProcAddress('glClipControl');
    private z_ClipControl_ovr_0 := GetProcOrNil&<procedure(origin: ClipControlOrigin; depth: ClipControlDepth)>(z_ClipControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipControl(origin: ClipControlOrigin; depth: ClipControlDepth) :=
    z_ClipControl_ovr_0(origin, depth);
    
    // added in gl1.0
    private z_ColorMask_adr := GetProcAddress('glColorMask');
    private z_ColorMask_ovr_0 := GetProcOrNil&<procedure(red: boolean; green: boolean; blue: boolean; alpha: boolean)>(z_ColorMask_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMask(red: boolean; green: boolean; blue: boolean; alpha: boolean) :=
    z_ColorMask_ovr_0(red, green, blue, alpha);
    
    // added in gl3.0
    private z_ColorMaski_adr := GetProcAddress('glColorMaski');
    private z_ColorMaski_ovr_0 := GetProcOrNil&<procedure(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean)>(z_ColorMaski_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMaski(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean) :=
    z_ColorMaski_ovr_0(index, r, g, b, a);
    
    // added in gl3.3
    private z_ColorP3ui_adr := GetProcAddress('glColorP3ui');
    private z_ColorP3ui_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_ColorP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP3ui_ovr_0(&type, color);
    
    // added in gl3.3
    private z_ColorP3uiv_adr := GetProcAddress('glColorP3uiv');
    private z_ColorP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_ColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP3uiv_ovr_0(&type, color);
    private z_ColorP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP3uiv_ovr_1(&type, color);
    
    // added in gl3.3
    private z_ColorP4ui_adr := GetProcAddress('glColorP4ui');
    private z_ColorP4ui_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_ColorP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP4ui_ovr_0(&type, color);
    
    // added in gl3.3
    private z_ColorP4uiv_adr := GetProcAddress('glColorP4uiv');
    private z_ColorP4uiv_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_ColorP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP4uiv_ovr_0(&type, color);
    private z_ColorP4uiv_ovr_1 := GetProcOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP4uiv_ovr_1(&type, color);
    
    // added in gl2.0
    private z_CompileShader_adr := GetProcAddress('glCompileShader');
    private z_CompileShader_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader)>(z_CompileShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShader(shader: gl_shader) :=
    z_CompileShader_ovr_0(shader);
    
    // added in gl1.3
    private z_CompressedTexImage1D_adr := GetProcAddress('glCompressedTexImage1D');
    private z_CompressedTexImage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage1D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage1D_ovr_0(target, level, _internalformat, width, border, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexImage2D_adr := GetProcAddress('glCompressedTexImage2D');
    private z_CompressedTexImage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage2D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage2D_ovr_0(target, level, _internalformat, width, height, border, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexImage3D_adr := GetProcAddress('glCompressedTexImage3D');
    private z_CompressedTexImage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage3D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage3D_ovr_0(target, level, _internalformat, width, height, depth, border, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexSubImage1D_adr := GetProcAddress('glCompressedTexSubImage1D');
    private z_CompressedTexSubImage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage1D(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage1D_ovr_0(target, level, xoffset, width, format, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexSubImage2D_adr := GetProcAddress('glCompressedTexSubImage2D');
    private z_CompressedTexSubImage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage2D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage2D_ovr_0(target, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexSubImage3D_adr := GetProcAddress('glCompressedTexSubImage3D');
    private z_CompressedTexSubImage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage3D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage3D_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    // added in gl4.5
    private z_CompressedTextureSubImage1D_adr := GetProcAddress('glCompressedTextureSubImage1D');
    private z_CompressedTextureSubImage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage1D(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage1D_ovr_0(texture, level, xoffset, width, format, imageSize, data);
    
    // added in gl4.5
    private z_CompressedTextureSubImage2D_adr := GetProcAddress('glCompressedTextureSubImage2D');
    private z_CompressedTextureSubImage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage2D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    // added in gl4.5
    private z_CompressedTextureSubImage3D_adr := GetProcAddress('glCompressedTextureSubImage3D');
    private z_CompressedTextureSubImage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage3D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    // added in gl3.1
    private z_CopyBufferSubData_adr := GetProcAddress('glCopyBufferSubData');
    private z_CopyBufferSubData_ovr_0 := GetProcOrNil&<procedure(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyBufferSubData(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyBufferSubData_ovr_0(readTarget, writeTarget, readOffset, writeOffset, size);
    
    // added in gl4.3
    private z_CopyImageSubData_adr := GetProcAddress('glCopyImageSubData');
    private z_CopyImageSubData_ovr_0 := GetProcOrNil&<procedure(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32)>(z_CopyImageSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubData(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32) :=
    z_CopyImageSubData_ovr_0(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
    
    // added in gl4.5
    private z_CopyNamedBufferSubData_adr := GetProcAddress('glCopyNamedBufferSubData');
    private z_CopyNamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyNamedBufferSubData(readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyNamedBufferSubData_ovr_0(readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    // added in gl1.1
    private z_CopyTexImage1D_adr := GetProcAddress('glCopyTexImage1D');
    private z_CopyTexImage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32)>(z_CopyTexImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage1D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyTexImage1D_ovr_0(target, level, _internalformat, x, y, width, border);
    
    // added in gl1.1
    private z_CopyTexImage2D_adr := GetProcAddress('glCopyTexImage2D');
    private z_CopyTexImage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32)>(z_CopyTexImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage2D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyTexImage2D_ovr_0(target, level, _internalformat, x, y, width, height, border);
    
    // added in gl1.1
    private z_CopyTexSubImage1D_adr := GetProcAddress('glCopyTexSubImage1D');
    private z_CopyTexSubImage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyTexSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage1D(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTexSubImage1D_ovr_0(target, level, xoffset, x, y, width);
    
    // added in gl1.1
    private z_CopyTexSubImage2D_adr := GetProcAddress('glCopyTexSubImage2D');
    private z_CopyTexSubImage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTexSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage2D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage2D_ovr_0(target, level, xoffset, yoffset, x, y, width, height);
    
    // added in gl1.2
    private z_CopyTexSubImage3D_adr := GetProcAddress('glCopyTexSubImage3D');
    private z_CopyTexSubImage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTexSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage3D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage3D_ovr_0(target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    // added in gl4.5
    private z_CopyTextureSubImage1D_adr := GetProcAddress('glCopyTextureSubImage1D');
    private z_CopyTextureSubImage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyTextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage1D(texture: gl_texture; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTextureSubImage1D_ovr_0(texture, level, xoffset, x, y, width);
    
    // added in gl4.5
    private z_CopyTextureSubImage2D_adr := GetProcAddress('glCopyTextureSubImage2D');
    private z_CopyTextureSubImage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage2D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, x, y, width, height);
    
    // added in gl4.5
    private z_CopyTextureSubImage3D_adr := GetProcAddress('glCopyTextureSubImage3D');
    private z_CopyTextureSubImage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage3D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    // added in gl4.5
    private z_CreateBuffers_adr := GetProcAddress('glCreateBuffers');
    private z_CreateBuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var buffers: gl_buffer)>(z_CreateBuffers_adr);
    private z_CreateBuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_CreateBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_CreateBuffers_ovr_0(n, buffers[0]) else
      z_CreateBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; var buffers: gl_buffer) :=
    z_CreateBuffers_ovr_0(n, buffers);
    private z_CreateBuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_CreateBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: IntPtr) :=
    z_CreateBuffers_ovr_2(n, buffers);
    
    // added in gl4.5
    private z_CreateFramebuffers_adr := GetProcAddress('glCreateFramebuffers');
    private z_CreateFramebuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_CreateFramebuffers_adr);
    private z_CreateFramebuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_CreateFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_CreateFramebuffers_ovr_0(n, framebuffers[0]) else
      z_CreateFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; var framebuffers: gl_framebuffer) :=
    z_CreateFramebuffers_ovr_0(n, framebuffers);
    private z_CreateFramebuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_CreateFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_CreateFramebuffers_ovr_2(n, framebuffers);
    
    // added in gl2.0
    private z_CreateProgram_adr := GetProcAddress('glCreateProgram');
    private z_CreateProgram_ovr_0 := GetProcOrNil&<function: gl_program>(z_CreateProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateProgram: gl_program :=
    z_CreateProgram_ovr_0;
    
    // added in gl4.5
    private z_CreateProgramPipelines_adr := GetProcAddress('glCreateProgramPipelines');
    private z_CreateProgramPipelines_ovr_0 := GetProcOrNil&<procedure(n: Int32; var pipelines: gl_program_pipeline)>(z_CreateProgramPipelines_adr);
    private z_CreateProgramPipelines_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_CreateProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: array of gl_program_pipeline) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_CreateProgramPipelines_ovr_0(n, pipelines[0]) else
      z_CreateProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; var pipelines: gl_program_pipeline) :=
    z_CreateProgramPipelines_ovr_0(n, pipelines);
    private z_CreateProgramPipelines_ovr_2 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_CreateProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_CreateProgramPipelines_ovr_2(n, pipelines);
    
    // added in gl4.5
    private z_CreateQueries_adr := GetProcAddress('glCreateQueries');
    private z_CreateQueries_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; n: Int32; var ids: gl_query)>(z_CreateQueries_adr);
    private z_CreateQueries_ovr_0_anh0001 := GetProcOrNil&<procedure(target: QueryTarget; n: Int32; ids: IntPtr)>(z_CreateQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: array of gl_query) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateQueries_ovr_0(target, n, ids[0]) else
      z_CreateQueries_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; var ids: gl_query) :=
    z_CreateQueries_ovr_0(target, n, ids);
    private z_CreateQueries_ovr_2 := GetProcOrNil&<procedure(target: QueryTarget; n: Int32; ids: IntPtr)>(z_CreateQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: IntPtr) :=
    z_CreateQueries_ovr_2(target, n, ids);
    
    // added in gl4.5
    private z_CreateRenderbuffers_adr := GetProcAddress('glCreateRenderbuffers');
    private z_CreateRenderbuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_CreateRenderbuffers_adr);
    private z_CreateRenderbuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_CreateRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_CreateRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_CreateRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_CreateRenderbuffers_ovr_0(n, renderbuffers);
    private z_CreateRenderbuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_CreateRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_CreateRenderbuffers_ovr_2(n, renderbuffers);
    
    // added in gl4.5
    private z_CreateSamplers_adr := GetProcAddress('glCreateSamplers');
    private z_CreateSamplers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var samplers: gl_sampler)>(z_CreateSamplers_adr);
    private z_CreateSamplers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; samplers: IntPtr)>(z_CreateSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_CreateSamplers_ovr_0(n, samplers[0]) else
      z_CreateSamplers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; var samplers: gl_sampler) :=
    z_CreateSamplers_ovr_0(n, samplers);
    private z_CreateSamplers_ovr_2 := GetProcOrNil&<procedure(n: Int32; samplers: IntPtr)>(z_CreateSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: IntPtr) :=
    z_CreateSamplers_ovr_2(n, samplers);
    
    // added in gl2.0
    private z_CreateShader_adr := GetProcAddress('glCreateShader');
    private z_CreateShader_ovr_0 := GetProcOrNil&<function(&type: ShaderType): gl_shader>(z_CreateShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShader(&type: ShaderType): gl_shader :=
    z_CreateShader_ovr_0(&type);
    
    // added in gl4.1
    private z_CreateShaderProgramv_adr := GetProcAddress('glCreateShaderProgramv');
    private z_CreateShaderProgramv_ovr_0 := GetProcOrNil&<function(&type: ShaderType; count: Int32; var strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    private z_CreateShaderProgramv_ovr_0_anh0001 := GetProcOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of string): gl_program;
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := strings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          Result := z_CreateShaderProgramv_ovr_0(&type, count, par_3_str_ptr[0]) else
          Result := z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_CreateShaderProgramv_ovr_1_anh0001 := GetProcOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of IntPtr): gl_program :=
    if (strings<>nil) and (strings.Length<>0) then
      z_CreateShaderProgramv_ovr_0(&type, count, strings[0]) else
      z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
    private z_CreateShaderProgramv_ovr_2 := GetProcOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: IntPtr): gl_program :=
    z_CreateShaderProgramv_ovr_2(&type, count, strings);
    
    // added in gl4.5
    private z_CreateTextures_adr := GetProcAddress('glCreateTextures');
    private z_CreateTextures_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; var textures: gl_texture)>(z_CreateTextures_adr);
    private z_CreateTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; textures: IntPtr)>(z_CreateTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_CreateTextures_ovr_0(target, n, textures[0]) else
      z_CreateTextures_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; var textures: gl_texture) :=
    z_CreateTextures_ovr_0(target, n, textures);
    private z_CreateTextures_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; textures: IntPtr)>(z_CreateTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: IntPtr) :=
    z_CreateTextures_ovr_2(target, n, textures);
    
    // added in gl4.5
    private z_CreateTransformFeedbacks_adr := GetProcAddress('glCreateTransformFeedbacks');
    private z_CreateTransformFeedbacks_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_CreateTransformFeedbacks_adr);
    private z_CreateTransformFeedbacks_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_CreateTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateTransformFeedbacks_ovr_0(n, ids[0]) else
      z_CreateTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; var ids: gl_transform_feedback) :=
    z_CreateTransformFeedbacks_ovr_0(n, ids);
    private z_CreateTransformFeedbacks_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_CreateTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_CreateTransformFeedbacks_ovr_2(n, ids);
    
    // added in gl4.5
    private z_CreateVertexArrays_adr := GetProcAddress('glCreateVertexArrays');
    private z_CreateVertexArrays_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_CreateVertexArrays_adr);
    private z_CreateVertexArrays_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_CreateVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_CreateVertexArrays_ovr_0(n, arrays[0]) else
      z_CreateVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; var arrays: gl_vertex_array) :=
    z_CreateVertexArrays_ovr_0(n, arrays);
    private z_CreateVertexArrays_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_CreateVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: IntPtr) :=
    z_CreateVertexArrays_ovr_2(n, arrays);
    
    // added in gl1.0
    private z_CullFace_adr := GetProcAddress('glCullFace');
    private z_CullFace_ovr_0 := GetProcOrNil&<procedure(mode: CullFaceMode)>(z_CullFace_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullFace(mode: CullFaceMode) :=
    z_CullFace_ovr_0(mode);
    
    // added in gl4.3
    private z_DebugMessageCallback_adr := GetProcAddress('glDebugMessageCallback');
    private z_DebugMessageCallback_ovr_0 := GetProcOrNil&<procedure(callback: GL_DEBUG_PROC; userParam: IntPtr)>(z_DebugMessageCallback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallback(callback: GL_DEBUG_PROC; userParam: IntPtr) :=
    z_DebugMessageCallback_ovr_0(callback, userParam);
    
    // added in gl4.3
    private z_DebugMessageControl_adr := GetProcAddress('glDebugMessageControl');
    private z_DebugMessageControl_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean)>(z_DebugMessageControl_adr);
    private z_DebugMessageControl_ovr_0_anh0000010 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageControl_ovr_0(source, &type, severity, count, ids[0], enabled) else
      z_DebugMessageControl_ovr_0_anh0000010(source, &type, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageControl_ovr_0(source, &type, severity, count, ids, enabled);
    private z_DebugMessageControl_ovr_2 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageControl_ovr_2(source, &type, severity, count, ids, enabled);
    
    // added in gl4.3
    private z_DebugMessageInsert_adr := GetProcAddress('glDebugMessageInsert');
    private z_DebugMessageInsert_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr)>(z_DebugMessageInsert_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: string);
    begin
      var par_6_str_ptr: IntPtr;
      try
        par_6_str_ptr := Marshal.StringToHGlobalAnsi(buf);
        z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, par_6_str_ptr);
      finally
        Marshal.FreeHGlobal(par_6_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, buf);
    
    // added in gl1.5
    private z_DeleteBuffers_adr := GetProcAddress('glDeleteBuffers');
    private z_DeleteBuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var buffers: gl_buffer)>(z_DeleteBuffers_adr);
    private z_DeleteBuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_DeleteBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffers(n: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_DeleteBuffers_ovr_0(n, buffers[0]) else
      z_DeleteBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffers(n: Int32; var buffers: gl_buffer) :=
    z_DeleteBuffers_ovr_0(n, buffers);
    private z_DeleteBuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_DeleteBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffers(n: Int32; buffers: IntPtr) :=
    z_DeleteBuffers_ovr_2(n, buffers);
    
    // added in gl3.0
    private z_DeleteFramebuffers_adr := GetProcAddress('glDeleteFramebuffers');
    private z_DeleteFramebuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_DeleteFramebuffers_adr);
    private z_DeleteFramebuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_DeleteFramebuffers_ovr_0(n, framebuffers[0]) else
      z_DeleteFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; var framebuffers: gl_framebuffer) :=
    z_DeleteFramebuffers_ovr_0(n, framebuffers);
    private z_DeleteFramebuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_DeleteFramebuffers_ovr_2(n, framebuffers);
    
    // added in gl2.0
    private z_DeleteProgram_adr := GetProcAddress('glDeleteProgram');
    private z_DeleteProgram_ovr_0 := GetProcOrNil&<procedure(&program: gl_program)>(z_DeleteProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgram(&program: gl_program) :=
    z_DeleteProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_DeleteProgramPipelines_adr := GetProcAddress('glDeleteProgramPipelines');
    private z_DeleteProgramPipelines_ovr_0 := GetProcOrNil&<procedure(n: Int32; var pipelines: gl_program_pipeline)>(z_DeleteProgramPipelines_adr);
    private z_DeleteProgramPipelines_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_DeleteProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: array of gl_program_pipeline) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_DeleteProgramPipelines_ovr_0(n, pipelines[0]) else
      z_DeleteProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; var pipelines: gl_program_pipeline) :=
    z_DeleteProgramPipelines_ovr_0(n, pipelines);
    private z_DeleteProgramPipelines_ovr_2 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_DeleteProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_DeleteProgramPipelines_ovr_2(n, pipelines);
    
    // added in gl1.5
    private z_DeleteQueries_adr := GetProcAddress('glDeleteQueries');
    private z_DeleteQueries_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_query)>(z_DeleteQueries_adr);
    private z_DeleteQueries_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueries(n: Int32; ids: array of gl_query) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteQueries_ovr_0(n, ids[0]) else
      z_DeleteQueries_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueries(n: Int32; var ids: gl_query) :=
    z_DeleteQueries_ovr_0(n, ids);
    private z_DeleteQueries_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueries(n: Int32; ids: IntPtr) :=
    z_DeleteQueries_ovr_2(n, ids);
    
    // added in gl3.0
    private z_DeleteRenderbuffers_adr := GetProcAddress('glDeleteRenderbuffers');
    private z_DeleteRenderbuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_DeleteRenderbuffers_adr);
    private z_DeleteRenderbuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_DeleteRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_DeleteRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_DeleteRenderbuffers_ovr_0(n, renderbuffers);
    private z_DeleteRenderbuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_DeleteRenderbuffers_ovr_2(n, renderbuffers);
    
    // added in gl3.3
    private z_DeleteSamplers_adr := GetProcAddress('glDeleteSamplers');
    private z_DeleteSamplers_ovr_0 := GetProcOrNil&<procedure(count: Int32; var samplers: gl_sampler)>(z_DeleteSamplers_adr);
    private z_DeleteSamplers_ovr_0_anh001 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_DeleteSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_DeleteSamplers_ovr_0(count, samplers[0]) else
      z_DeleteSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; var samplers: gl_sampler) :=
    z_DeleteSamplers_ovr_0(count, samplers);
    private z_DeleteSamplers_ovr_2 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_DeleteSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: IntPtr) :=
    z_DeleteSamplers_ovr_2(count, samplers);
    
    // added in gl2.0
    private z_DeleteShader_adr := GetProcAddress('glDeleteShader');
    private z_DeleteShader_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader)>(z_DeleteShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteShader(shader: gl_shader) :=
    z_DeleteShader_ovr_0(shader);
    
    // added in gl3.2
    private z_DeleteSync_adr := GetProcAddress('glDeleteSync');
    private z_DeleteSync_ovr_0 := GetProcOrNil&<procedure(sync: gl_sync)>(z_DeleteSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSync(sync: gl_sync) :=
    z_DeleteSync_ovr_0(sync);
    
    // added in gl1.1
    private z_DeleteTextures_adr := GetProcAddress('glDeleteTextures');
    private z_DeleteTextures_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture)>(z_DeleteTextures_adr);
    private z_DeleteTextures_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_DeleteTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTextures(n: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_DeleteTextures_ovr_0(n, textures[0]) else
      z_DeleteTextures_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTextures(n: Int32; var textures: gl_texture) :=
    z_DeleteTextures_ovr_0(n, textures);
    private z_DeleteTextures_ovr_2 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_DeleteTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTextures(n: Int32; textures: IntPtr) :=
    z_DeleteTextures_ovr_2(n, textures);
    
    // added in gl4.0
    private z_DeleteTransformFeedbacks_adr := GetProcAddress('glDeleteTransformFeedbacks');
    private z_DeleteTransformFeedbacks_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_DeleteTransformFeedbacks_adr);
    private z_DeleteTransformFeedbacks_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteTransformFeedbacks_ovr_0(n, ids[0]) else
      z_DeleteTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; var ids: gl_transform_feedback) :=
    z_DeleteTransformFeedbacks_ovr_0(n, ids);
    private z_DeleteTransformFeedbacks_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_DeleteTransformFeedbacks_ovr_2(n, ids);
    
    // added in gl3.0
    private z_DeleteVertexArrays_adr := GetProcAddress('glDeleteVertexArrays');
    private z_DeleteVertexArrays_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_DeleteVertexArrays_adr);
    private z_DeleteVertexArrays_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_DeleteVertexArrays_ovr_0(n, arrays[0]) else
      z_DeleteVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; var arrays: gl_vertex_array) :=
    z_DeleteVertexArrays_ovr_0(n, arrays);
    private z_DeleteVertexArrays_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: IntPtr) :=
    z_DeleteVertexArrays_ovr_2(n, arrays);
    
    // added in gl1.0
    private z_DepthFunc_adr := GetProcAddress('glDepthFunc');
    private z_DepthFunc_ovr_0 := GetProcOrNil&<procedure(func: DepthFunction)>(z_DepthFunc_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthFunc(func: DepthFunction) :=
    z_DepthFunc_ovr_0(func);
    
    // added in gl1.0
    private z_DepthMask_adr := GetProcAddress('glDepthMask');
    private z_DepthMask_ovr_0 := GetProcOrNil&<procedure(flag: boolean)>(z_DepthMask_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthMask(flag: boolean) :=
    z_DepthMask_ovr_0(flag);
    
    // added in gl1.0
    private z_DepthRange_adr := GetProcAddress('glDepthRange');
    private z_DepthRange_ovr_0 := GetProcOrNil&<procedure(n: real; f: real)>(z_DepthRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRange(n: real; f: real) :=
    z_DepthRange_ovr_0(n, f);
    
    // added in gl4.1
    private z_DepthRangeArrayv_adr := GetProcAddress('glDepthRangeArrayv');
    private z_DepthRangeArrayv_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: real)>(z_DepthRangeArrayv_adr);
    private z_DepthRangeArrayv_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_DepthRangeArrayv_ovr_0(first, count, v[0]) else
      z_DepthRangeArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; var v: real) :=
    z_DepthRangeArrayv_ovr_0(first, count, v);
    private z_DepthRangeArrayv_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_DepthRangeArrayv_ovr_2(first, count, v);
    
    // added in gl4.1
    private z_DepthRangef_adr := GetProcAddress('glDepthRangef');
    private z_DepthRangef_ovr_0 := GetProcOrNil&<procedure(n: single; f: single)>(z_DepthRangef_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangef(n: single; f: single) :=
    z_DepthRangef_ovr_0(n, f);
    
    // added in gl4.1
    private z_DepthRangeIndexed_adr := GetProcAddress('glDepthRangeIndexed');
    private z_DepthRangeIndexed_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: real; f: real)>(z_DepthRangeIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeIndexed(index: UInt32; n: real; f: real) :=
    z_DepthRangeIndexed_ovr_0(index, n, f);
    
    // added in gl2.0
    private z_DetachShader_adr := GetProcAddress('glDetachShader');
    private z_DetachShader_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; shader: gl_shader)>(z_DetachShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetachShader(&program: gl_program; shader: gl_shader) :=
    z_DetachShader_ovr_0(&program, shader);
    
    // added in gl1.0
    private z_Disable_adr := GetProcAddress('glDisable');
    private z_Disable_ovr_0 := GetProcOrNil&<procedure(cap: EnableCap)>(z_Disable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Disable(cap: EnableCap) :=
    z_Disable_ovr_0(cap);
    
    // added in gl3.0
    private z_Disablei_adr := GetProcAddress('glDisablei');
    private z_Disablei_ovr_0 := GetProcOrNil&<procedure(target: EnableCap; index: UInt32)>(z_Disablei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Disablei(target: EnableCap; index: UInt32) :=
    z_Disablei_ovr_0(target, index);
    
    // added in gl4.5
    private z_DisableVertexArrayAttrib_adr := GetProcAddress('glDisableVertexArrayAttrib');
    private z_DisableVertexArrayAttrib_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32)>(z_DisableVertexArrayAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayAttrib(vaobj: gl_vertex_array; index: UInt32) :=
    z_DisableVertexArrayAttrib_ovr_0(vaobj, index);
    
    // added in gl2.0
    private z_DisableVertexAttribArray_adr := GetProcAddress('glDisableVertexAttribArray');
    private z_DisableVertexAttribArray_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_DisableVertexAttribArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribArray(index: UInt32) :=
    z_DisableVertexAttribArray_ovr_0(index);
    
    // added in gl4.3
    private z_DispatchCompute_adr := GetProcAddress('glDispatchCompute');
    private z_DispatchCompute_ovr_0 := GetProcOrNil&<procedure(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32)>(z_DispatchCompute_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchCompute(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32) :=
    z_DispatchCompute_ovr_0(num_groups_x, num_groups_y, num_groups_z);
    
    // added in gl4.3
    private z_DispatchComputeIndirect_adr := GetProcAddress('glDispatchComputeIndirect');
    private z_DispatchComputeIndirect_ovr_0 := GetProcOrNil&<procedure(indirect: IntPtr)>(z_DispatchComputeIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchComputeIndirect(indirect: IntPtr) :=
    z_DispatchComputeIndirect_ovr_0(indirect);
    
    // added in gl1.1
    private z_DrawArrays_adr := GetProcAddress('glDrawArrays');
    private z_DrawArrays_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32)>(z_DrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArrays(mode: PrimitiveType; first: Int32; count: Int32) :=
    z_DrawArrays_ovr_0(mode, first, count);
    
    // added in gl4.0
    private z_DrawArraysIndirect_adr := GetProcAddress('glDrawArraysIndirect');
    private z_DrawArraysIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr)>(z_DrawArraysIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr) :=
    z_DrawArraysIndirect_ovr_0(mode, indirect);
    
    // added in gl3.1
    private z_DrawArraysInstanced_adr := GetProcAddress('glDrawArraysInstanced');
    private z_DrawArraysInstanced_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32)>(z_DrawArraysInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstanced(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32) :=
    z_DrawArraysInstanced_ovr_0(mode, first, count, instancecount);
    
    // added in gl4.2
    private z_DrawArraysInstancedBaseInstance_adr := GetProcAddress('glDrawArraysInstancedBaseInstance');
    private z_DrawArraysInstancedBaseInstance_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32)>(z_DrawArraysInstancedBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedBaseInstance(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawArraysInstancedBaseInstance_ovr_0(mode, first, count, instancecount, baseinstance);
    
    // added in gl1.0
    private z_DrawBuffer_adr := GetProcAddress('glDrawBuffer');
    private z_DrawBuffer_ovr_0 := GetProcOrNil&<procedure(buf: DrawBufferMode)>(z_DrawBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffer(buf: DrawBufferMode) :=
    z_DrawBuffer_ovr_0(buf);
    
    // added in gl2.0
    private z_DrawBuffers_adr := GetProcAddress('glDrawBuffers');
    private z_DrawBuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var bufs: DrawBufferMode)>(z_DrawBuffers_adr);
    private z_DrawBuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffers(n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_DrawBuffers_ovr_0(n, bufs[0]) else
      z_DrawBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffers(n: Int32; var bufs: DrawBufferMode) :=
    z_DrawBuffers_ovr_0(n, bufs);
    private z_DrawBuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffers(n: Int32; bufs: IntPtr) :=
    z_DrawBuffers_ovr_2(n, bufs);
    
    // added in gl1.1
    private z_DrawElements_adr := GetProcAddress('glDrawElements');
    private z_DrawElements_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr)>(z_DrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElements(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr) :=
    z_DrawElements_ovr_0(mode, count, &type, indices);
    
    // added in gl3.2
    private z_DrawElementsBaseVertex_adr := GetProcAddress('glDrawElementsBaseVertex');
    private z_DrawElementsBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32)>(z_DrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawElementsBaseVertex_ovr_0(mode, count, &type, indices, basevertex);
    
    // added in gl4.0
    private z_DrawElementsIndirect_adr := GetProcAddress('glDrawElementsIndirect');
    private z_DrawElementsIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr)>(z_DrawElementsIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr) :=
    z_DrawElementsIndirect_ovr_0(mode, &type, indirect);
    
    // added in gl3.1
    private z_DrawElementsInstanced_adr := GetProcAddress('glDrawElementsInstanced');
    private z_DrawElementsInstanced_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32)>(z_DrawElementsInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstanced(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32) :=
    z_DrawElementsInstanced_ovr_0(mode, count, &type, indices, instancecount);
    
    // added in gl4.2
    private z_DrawElementsInstancedBaseInstance_adr := GetProcAddress('glDrawElementsInstancedBaseInstance');
    private z_DrawElementsInstancedBaseInstance_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32)>(z_DrawElementsInstancedBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseInstance(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseInstance_ovr_0(mode, count, &type, indices, instancecount, baseinstance);
    
    // added in gl3.2
    private z_DrawElementsInstancedBaseVertex_adr := GetProcAddress('glDrawElementsInstancedBaseVertex');
    private z_DrawElementsInstancedBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32)>(z_DrawElementsInstancedBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32) :=
    z_DrawElementsInstancedBaseVertex_ovr_0(mode, count, &type, indices, instancecount, basevertex);
    
    // added in gl4.2
    private z_DrawElementsInstancedBaseVertexBaseInstance_adr := GetProcAddress('glDrawElementsInstancedBaseVertexBaseInstance');
    private z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32)>(z_DrawElementsInstancedBaseVertexBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertexBaseInstance(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0(mode, count, &type, indices, instancecount, basevertex, baseinstance);
    
    // added in gl1.2
    private z_DrawRangeElements_adr := GetProcAddress('glDrawRangeElements');
    private z_DrawRangeElements_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr)>(z_DrawRangeElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElements(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr) :=
    z_DrawRangeElements_ovr_0(mode, start, &end, count, &type, indices);
    
    // added in gl3.2
    private z_DrawRangeElementsBaseVertex_adr := GetProcAddress('glDrawRangeElementsBaseVertex');
    private z_DrawRangeElementsBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32)>(z_DrawRangeElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementsBaseVertex(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawRangeElementsBaseVertex_ovr_0(mode, start, &end, count, &type, indices, basevertex);
    
    // added in gl4.0
    private z_DrawTransformFeedback_adr := GetProcAddress('glDrawTransformFeedback');
    private z_DrawTransformFeedback_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback)>(z_DrawTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedback(mode: PrimitiveType; id: gl_transform_feedback) :=
    z_DrawTransformFeedback_ovr_0(mode, id);
    
    // added in gl4.2
    private z_DrawTransformFeedbackInstanced_adr := GetProcAddress('glDrawTransformFeedbackInstanced');
    private z_DrawTransformFeedbackInstanced_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback; instancecount: Int32)>(z_DrawTransformFeedbackInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackInstanced(mode: PrimitiveType; id: gl_transform_feedback; instancecount: Int32) :=
    z_DrawTransformFeedbackInstanced_ovr_0(mode, id, instancecount);
    
    // added in gl4.0
    private z_DrawTransformFeedbackStream_adr := GetProcAddress('glDrawTransformFeedbackStream');
    private z_DrawTransformFeedbackStream_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32)>(z_DrawTransformFeedbackStream_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStream(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32) :=
    z_DrawTransformFeedbackStream_ovr_0(mode, id, stream);
    
    // added in gl4.2
    private z_DrawTransformFeedbackStreamInstanced_adr := GetProcAddress('glDrawTransformFeedbackStreamInstanced');
    private z_DrawTransformFeedbackStreamInstanced_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32; instancecount: Int32)>(z_DrawTransformFeedbackStreamInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStreamInstanced(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32; instancecount: Int32) :=
    z_DrawTransformFeedbackStreamInstanced_ovr_0(mode, id, stream, instancecount);
    
    // added in gl1.0
    private z_Enable_adr := GetProcAddress('glEnable');
    private z_Enable_ovr_0 := GetProcOrNil&<procedure(cap: EnableCap)>(z_Enable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Enable(cap: EnableCap) :=
    z_Enable_ovr_0(cap);
    
    // added in gl3.0
    private z_Enablei_adr := GetProcAddress('glEnablei');
    private z_Enablei_ovr_0 := GetProcOrNil&<procedure(target: EnableCap; index: UInt32)>(z_Enablei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Enablei(target: EnableCap; index: UInt32) :=
    z_Enablei_ovr_0(target, index);
    
    // added in gl4.5
    private z_EnableVertexArrayAttrib_adr := GetProcAddress('glEnableVertexArrayAttrib');
    private z_EnableVertexArrayAttrib_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32)>(z_EnableVertexArrayAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayAttrib(vaobj: gl_vertex_array; index: UInt32) :=
    z_EnableVertexArrayAttrib_ovr_0(vaobj, index);
    
    // added in gl2.0
    private z_EnableVertexAttribArray_adr := GetProcAddress('glEnableVertexAttribArray');
    private z_EnableVertexAttribArray_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_EnableVertexAttribArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribArray(index: UInt32) :=
    z_EnableVertexAttribArray_ovr_0(index);
    
    // added in gl3.0
    private z_EndConditionalRender_adr := GetProcAddress('glEndConditionalRender');
    private z_EndConditionalRender_ovr_0 := GetProcOrNil&<procedure>(z_EndConditionalRender_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndConditionalRender :=
    z_EndConditionalRender_ovr_0;
    
    // added in gl1.5
    private z_EndQuery_adr := GetProcAddress('glEndQuery');
    private z_EndQuery_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget)>(z_EndQuery_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQuery(target: QueryTarget) :=
    z_EndQuery_ovr_0(target);
    
    // added in gl4.0
    private z_EndQueryIndexed_adr := GetProcAddress('glEndQueryIndexed');
    private z_EndQueryIndexed_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32)>(z_EndQueryIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQueryIndexed(target: QueryTarget; index: UInt32) :=
    z_EndQueryIndexed_ovr_0(target, index);
    
    // added in gl3.0
    private z_EndTransformFeedback_adr := GetProcAddress('glEndTransformFeedback');
    private z_EndTransformFeedback_ovr_0 := GetProcOrNil&<procedure>(z_EndTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndTransformFeedback :=
    z_EndTransformFeedback_ovr_0;
    
    // added in gl3.2
    private z_FenceSync_adr := GetProcAddress('glFenceSync');
    private z_FenceSync_ovr_0 := GetProcOrNil&<function(condition: SyncCondition; flags: DummyFlags): gl_sync>(z_FenceSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FenceSync(condition: SyncCondition; flags: DummyFlags): gl_sync :=
    z_FenceSync_ovr_0(condition, flags);
    
    // added in gl1.0
    private z_Finish_adr := GetProcAddress('glFinish');
    private z_Finish_ovr_0 := GetProcOrNil&<procedure>(z_Finish_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Finish :=
    z_Finish_ovr_0;
    
    // added in gl1.0
    private z_Flush_adr := GetProcAddress('glFlush');
    private z_Flush_ovr_0 := GetProcOrNil&<procedure>(z_Flush_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Flush :=
    z_Flush_ovr_0;
    
    // added in gl3.0
    private z_FlushMappedBufferRange_adr := GetProcAddress('glFlushMappedBufferRange');
    private z_FlushMappedBufferRange_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; length: IntPtr)>(z_FlushMappedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedBufferRange(target: BufferTarget; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedBufferRange_ovr_0(target, offset, length);
    
    // added in gl4.5
    private z_FlushMappedNamedBufferRange_adr := GetProcAddress('glFlushMappedNamedBufferRange');
    private z_FlushMappedNamedBufferRange_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; length: IntPtr)>(z_FlushMappedNamedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedNamedBufferRange(buffer: gl_buffer; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedNamedBufferRange_ovr_0(buffer, offset, length);
    
    // added in gl4.3
    private z_FramebufferParameteri_adr := GetProcAddress('glFramebufferParameteri');
    private z_FramebufferParameteri_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32)>(z_FramebufferParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferParameteri(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32) :=
    z_FramebufferParameteri_ovr_0(target, pname, param);
    
    // added in gl3.0
    private z_FramebufferRenderbuffer_adr := GetProcAddress('glFramebufferRenderbuffer');
    private z_FramebufferRenderbuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_FramebufferRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferRenderbuffer(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_FramebufferRenderbuffer_ovr_0(target, attachment, _renderbuffertarget, renderbuffer);
    
    // added in gl3.2
    private z_FramebufferTexture_adr := GetProcAddress('glFramebufferTexture');
    private z_FramebufferTexture_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32)>(z_FramebufferTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture_ovr_0(target, attachment, texture, level);
    
    // added in gl3.0
    private z_FramebufferTexture1D_adr := GetProcAddress('glFramebufferTexture1D');
    private z_FramebufferTexture1D_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_FramebufferTexture1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture1D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture1D_ovr_0(target, attachment, textarget, texture, level);
    
    // added in gl3.0
    private z_FramebufferTexture2D_adr := GetProcAddress('glFramebufferTexture2D');
    private z_FramebufferTexture2D_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_FramebufferTexture2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture2D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture2D_ovr_0(target, attachment, textarget, texture, level);
    
    // added in gl3.0
    private z_FramebufferTexture3D_adr := GetProcAddress('glFramebufferTexture3D');
    private z_FramebufferTexture3D_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32)>(z_FramebufferTexture3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture3D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32) :=
    z_FramebufferTexture3D_ovr_0(target, attachment, textarget, texture, level, zoffset);
    
    // added in gl3.0
    private z_FramebufferTextureLayer_adr := GetProcAddress('glFramebufferTextureLayer');
    private z_FramebufferTextureLayer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_FramebufferTextureLayer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayer(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayer_ovr_0(target, attachment, texture, level, layer);
    
    // added in gl1.0
    private z_FrontFace_adr := GetProcAddress('glFrontFace');
    private z_FrontFace_ovr_0 := GetProcOrNil&<procedure(mode: FrontFaceDirection)>(z_FrontFace_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrontFace(mode: FrontFaceDirection) :=
    z_FrontFace_ovr_0(mode);
    
    // added in gl1.5
    private z_GenBuffers_adr := GetProcAddress('glGenBuffers');
    private z_GenBuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var buffers: gl_buffer)>(z_GenBuffers_adr);
    private z_GenBuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_GenBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffers(n: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_GenBuffers_ovr_0(n, buffers[0]) else
      z_GenBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffers(n: Int32; var buffers: gl_buffer) :=
    z_GenBuffers_ovr_0(n, buffers);
    private z_GenBuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_GenBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffers(n: Int32; buffers: IntPtr) :=
    z_GenBuffers_ovr_2(n, buffers);
    
    // added in gl3.0
    private z_GenerateMipmap_adr := GetProcAddress('glGenerateMipmap');
    private z_GenerateMipmap_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget)>(z_GenerateMipmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMipmap(target: TextureTarget) :=
    z_GenerateMipmap_ovr_0(target);
    
    // added in gl4.5
    private z_GenerateTextureMipmap_adr := GetProcAddress('glGenerateTextureMipmap');
    private z_GenerateTextureMipmap_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture)>(z_GenerateTextureMipmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateTextureMipmap(texture: gl_texture) :=
    z_GenerateTextureMipmap_ovr_0(texture);
    
    // added in gl3.0
    private z_GenFramebuffers_adr := GetProcAddress('glGenFramebuffers');
    private z_GenFramebuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_GenFramebuffers_adr);
    private z_GenFramebuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_GenFramebuffers_ovr_0(n, framebuffers[0]) else
      z_GenFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; var framebuffers: gl_framebuffer) :=
    z_GenFramebuffers_ovr_0(n, framebuffers);
    private z_GenFramebuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_GenFramebuffers_ovr_2(n, framebuffers);
    
    // added in gl4.1
    private z_GenProgramPipelines_adr := GetProcAddress('glGenProgramPipelines');
    private z_GenProgramPipelines_ovr_0 := GetProcOrNil&<procedure(n: Int32; var pipelines: gl_program_pipeline)>(z_GenProgramPipelines_adr);
    private z_GenProgramPipelines_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_GenProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: array of gl_program_pipeline) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_GenProgramPipelines_ovr_0(n, pipelines[0]) else
      z_GenProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; var pipelines: gl_program_pipeline) :=
    z_GenProgramPipelines_ovr_0(n, pipelines);
    private z_GenProgramPipelines_ovr_2 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_GenProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_GenProgramPipelines_ovr_2(n, pipelines);
    
    // added in gl1.5
    private z_GenQueries_adr := GetProcAddress('glGenQueries');
    private z_GenQueries_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_query)>(z_GenQueries_adr);
    private z_GenQueries_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueries(n: Int32; ids: array of gl_query) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenQueries_ovr_0(n, ids[0]) else
      z_GenQueries_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueries(n: Int32; var ids: gl_query) :=
    z_GenQueries_ovr_0(n, ids);
    private z_GenQueries_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueries(n: Int32; ids: IntPtr) :=
    z_GenQueries_ovr_2(n, ids);
    
    // added in gl3.0
    private z_GenRenderbuffers_adr := GetProcAddress('glGenRenderbuffers');
    private z_GenRenderbuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_GenRenderbuffers_adr);
    private z_GenRenderbuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_GenRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_GenRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_GenRenderbuffers_ovr_0(n, renderbuffers);
    private z_GenRenderbuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_GenRenderbuffers_ovr_2(n, renderbuffers);
    
    // added in gl3.3
    private z_GenSamplers_adr := GetProcAddress('glGenSamplers');
    private z_GenSamplers_ovr_0 := GetProcOrNil&<procedure(count: Int32; var samplers: gl_sampler)>(z_GenSamplers_adr);
    private z_GenSamplers_ovr_0_anh001 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_GenSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_GenSamplers_ovr_0(count, samplers[0]) else
      z_GenSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; var samplers: gl_sampler) :=
    z_GenSamplers_ovr_0(count, samplers);
    private z_GenSamplers_ovr_2 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_GenSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: IntPtr) :=
    z_GenSamplers_ovr_2(count, samplers);
    
    // added in gl1.1
    private z_GenTextures_adr := GetProcAddress('glGenTextures');
    private z_GenTextures_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture)>(z_GenTextures_adr);
    private z_GenTextures_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_GenTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTextures(n: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_GenTextures_ovr_0(n, textures[0]) else
      z_GenTextures_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTextures(n: Int32; var textures: gl_texture) :=
    z_GenTextures_ovr_0(n, textures);
    private z_GenTextures_ovr_2 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_GenTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTextures(n: Int32; textures: IntPtr) :=
    z_GenTextures_ovr_2(n, textures);
    
    // added in gl4.0
    private z_GenTransformFeedbacks_adr := GetProcAddress('glGenTransformFeedbacks');
    private z_GenTransformFeedbacks_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_GenTransformFeedbacks_adr);
    private z_GenTransformFeedbacks_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenTransformFeedbacks_ovr_0(n, ids[0]) else
      z_GenTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; var ids: gl_transform_feedback) :=
    z_GenTransformFeedbacks_ovr_0(n, ids);
    private z_GenTransformFeedbacks_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_GenTransformFeedbacks_ovr_2(n, ids);
    
    // added in gl3.0
    private z_GenVertexArrays_adr := GetProcAddress('glGenVertexArrays');
    private z_GenVertexArrays_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_GenVertexArrays_adr);
    private z_GenVertexArrays_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_GenVertexArrays_ovr_0(n, arrays[0]) else
      z_GenVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; var arrays: gl_vertex_array) :=
    z_GenVertexArrays_ovr_0(n, arrays);
    private z_GenVertexArrays_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: IntPtr) :=
    z_GenVertexArrays_ovr_2(n, arrays);
    
    // added in gl4.2
    private z_GetActiveAtomicCounterBufferiv_adr := GetProcAddress('glGetActiveAtomicCounterBufferiv');
    private z_GetActiveAtomicCounterBufferiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32)>(z_GetActiveAtomicCounterBufferiv_adr);
    private z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr)>(z_GetActiveAtomicCounterBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params[0]) else
      z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001(&program, bufferIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32) :=
    z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params);
    private z_GetActiveAtomicCounterBufferiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr)>(z_GetActiveAtomicCounterBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr) :=
    z_GetActiveAtomicCounterBufferiv_ovr_2(&program, bufferIndex, pname, &params);
    
    // added in gl2.0
    private z_GetActiveAttrib_adr := GetProcAddress('glGetActiveAttrib');
    private z_GetActiveAttrib_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_0(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_1(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_2(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_3(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_4 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_4(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_5(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_6(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_7 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_7(&program, index, bufSize, length, size, &type, name);
    
    // added in gl4.0
    private z_GetActiveSubroutineName_adr := GetProcAddress('glGetActiveSubroutineName');
    private z_GetActiveSubroutineName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private z_GetActiveSubroutineName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_1(&program, _shadertype, index, bufSize, length, name);
    
    // added in gl4.0
    private z_GetActiveSubroutineUniformiv_adr := GetProcAddress('glGetActiveSubroutineUniformiv');
    private z_GetActiveSubroutineUniformiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32)>(z_GetActiveSubroutineUniformiv_adr);
    private z_GetActiveSubroutineUniformiv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr)>(z_GetActiveSubroutineUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values[0]) else
      z_GetActiveSubroutineUniformiv_ovr_0_anh000001(&program, _shadertype, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32) :=
    z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values);
    private z_GetActiveSubroutineUniformiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr)>(z_GetActiveSubroutineUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr) :=
    z_GetActiveSubroutineUniformiv_ovr_2(&program, _shadertype, index, pname, values);
    
    // added in gl4.0
    private z_GetActiveSubroutineUniformName_adr := GetProcAddress('glGetActiveSubroutineUniformName');
    private z_GetActiveSubroutineUniformName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private z_GetActiveSubroutineUniformName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_1(&program, _shadertype, index, bufSize, length, name);
    
    // added in gl2.0
    private z_GetActiveUniform_adr := GetProcAddress('glGetActiveUniform');
    private z_GetActiveUniform_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_0(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_1(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_2(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_3(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_4 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_4(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_5(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_6(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_7 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_7(&program, index, bufSize, length, size, &type, name);
    
    // added in gl3.1
    private z_GetActiveUniformBlockiv_adr := GetProcAddress('glGetActiveUniformBlockiv');
    private z_GetActiveUniformBlockiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32)>(z_GetActiveUniformBlockiv_adr);
    private z_GetActiveUniformBlockiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr)>(z_GetActiveUniformBlockiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params[0]) else
      z_GetActiveUniformBlockiv_ovr_0_anh00001(&program, uniformBlockIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32) :=
    z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params);
    private z_GetActiveUniformBlockiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr)>(z_GetActiveUniformBlockiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr) :=
    z_GetActiveUniformBlockiv_ovr_2(&program, uniformBlockIndex, pname, &params);
    
    // added in gl3.1
    private z_GetActiveUniformBlockName_adr := GetProcAddress('glGetActiveUniformBlockName');
    private z_GetActiveUniformBlockName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_0(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    private z_GetActiveUniformBlockName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_1(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    
    // added in gl3.1
    private z_GetActiveUniformName_adr := GetProcAddress('glGetActiveUniformName');
    private z_GetActiveUniformName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_0(&program, uniformIndex, bufSize, length, uniformName);
    private z_GetActiveUniformName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_1(&program, uniformIndex, bufSize, length, uniformName);
    
    // added in gl3.1
    private z_GetActiveUniformsiv_adr := GetProcAddress('glGetActiveUniformsiv');
    private z_GetActiveUniformsiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000100 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000101 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: array of Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices[0], pname, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000101(&program, uniformCount, IntPtr.Zero, pname, IntPtr.Zero);
    private z_GetActiveUniformsiv_ovr_1_anh000100 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; var &params: Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    private z_GetActiveUniformsiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_2_anh000100 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: IntPtr) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_2_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices, pname, &params);
    private z_GetActiveUniformsiv_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_6_anh000001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_6_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params);
    private z_GetActiveUniformsiv_ovr_8 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_8(&program, uniformCount, uniformIndices, pname, &params);
    
    // added in gl2.0
    private z_GetAttachedShaders_adr := GetProcAddress('glGetAttachedShaders');
    private z_GetAttachedShaders_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; maxCount: Int32; var count: Int32; var shaders: gl_shader)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; maxCount: Int32; var count: Int32; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: gl_program; maxCount: Int32; var count: Int32; shaders: array of gl_shader) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_GetAttachedShaders_ovr_0(&program, maxCount, count, shaders[0]) else
      z_GetAttachedShaders_ovr_0_anh00001(&program, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: gl_program; maxCount: Int32; var count: Int32; var shaders: gl_shader) :=
    z_GetAttachedShaders_ovr_0(&program, maxCount, count, shaders);
    private z_GetAttachedShaders_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; maxCount: Int32; var count: Int32; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: gl_program; maxCount: Int32; var count: Int32; shaders: IntPtr) :=
    z_GetAttachedShaders_ovr_2(&program, maxCount, count, shaders);
    private z_GetAttachedShaders_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; maxCount: Int32; count: IntPtr; var shaders: gl_shader)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_3_anh00001 := GetProcOrNil&<procedure(&program: gl_program; maxCount: Int32; count: IntPtr; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: gl_program; maxCount: Int32; count: IntPtr; shaders: array of gl_shader) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_GetAttachedShaders_ovr_3(&program, maxCount, count, shaders[0]) else
      z_GetAttachedShaders_ovr_3_anh00001(&program, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: gl_program; maxCount: Int32; count: IntPtr; var shaders: gl_shader) :=
    z_GetAttachedShaders_ovr_3(&program, maxCount, count, shaders);
    private z_GetAttachedShaders_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; maxCount: Int32; count: IntPtr; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: gl_program; maxCount: Int32; count: IntPtr; shaders: IntPtr) :=
    z_GetAttachedShaders_ovr_5(&program, maxCount, count, shaders);
    
    // added in gl2.0
    private z_GetAttribLocation_adr := GetProcAddress('glGetAttribLocation');
    private z_GetAttribLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetAttribLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocation(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetAttribLocation_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocation(&program: gl_program; name: IntPtr): Int32 :=
    z_GetAttribLocation_ovr_0(&program, name);
    
    // added in gl3.0
    private z_GetBooleani_v_adr := GetProcAddress('glGetBooleani_v');
    private z_GetBooleani_v_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; var data: boolean)>(z_GetBooleani_v_adr);
    private z_GetBooleani_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; data: IntPtr)>(z_GetBooleani_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleani_v(target: BufferTarget; index: UInt32; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleani_v_ovr_0(target, index, data[0]) else
      z_GetBooleani_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleani_v(target: BufferTarget; index: UInt32; var data: boolean) :=
    z_GetBooleani_v_ovr_0(target, index, data);
    private z_GetBooleani_v_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; data: IntPtr)>(z_GetBooleani_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleani_v(target: BufferTarget; index: UInt32; data: IntPtr) :=
    z_GetBooleani_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private z_GetBooleanv_adr := GetProcAddress('glGetBooleanv');
    private z_GetBooleanv_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: boolean)>(z_GetBooleanv_adr);
    private z_GetBooleanv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetBooleanv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanv(pname: GetPName; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleanv_ovr_0(pname, data[0]) else
      z_GetBooleanv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanv(pname: GetPName; var data: boolean) :=
    z_GetBooleanv_ovr_0(pname, data);
    private z_GetBooleanv_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetBooleanv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanv(pname: GetPName; data: IntPtr) :=
    z_GetBooleanv_ovr_2(pname, data);
    
    // added in gl3.2
    private z_GetBufferParameteri64v_adr := GetProcAddress('glGetBufferParameteri64v');
    private z_GetBufferParameteri64v_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; var &params: Int64)>(z_GetBufferParameteri64v_adr);
    private z_GetBufferParameteri64v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteri64v(target: BufferTarget; pname: BufferPNameARB; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameteri64v_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameteri64v_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteri64v(target: BufferTarget; pname: BufferPNameARB; var &params: Int64) :=
    z_GetBufferParameteri64v_ovr_0(target, pname, &params);
    private z_GetBufferParameteri64v_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteri64v(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetBufferParameteri64v_ovr_2(target, pname, &params);
    
    // added in gl1.5
    private z_GetBufferParameteriv_adr := GetProcAddress('glGetBufferParameteriv');
    private z_GetBufferParameteriv_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; var &params: Int32)>(z_GetBufferParameteriv_adr);
    private z_GetBufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteriv(target: BufferTarget; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteriv(target: BufferTarget; pname: BufferPNameARB; var &params: Int32) :=
    z_GetBufferParameteriv_ovr_0(target, pname, &params);
    private z_GetBufferParameteriv_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteriv(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetBufferParameteriv_ovr_2(target, pname, &params);
    
    // added in gl1.5
    private z_GetBufferPointerv_adr := GetProcAddress('glGetBufferPointerv');
    private z_GetBufferPointerv_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPointerNameARB; var &params: IntPtr)>(z_GetBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointerv(target: BufferTarget; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetBufferPointerv_ovr_0(target, pname, &params);
    private z_GetBufferPointerv_ovr_1 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPointerNameARB; &params: pointer)>(z_GetBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointerv(target: BufferTarget; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetBufferPointerv_ovr_1(target, pname, &params);
    
    // added in gl1.5
    private z_GetBufferSubData_adr := GetProcAddress('glGetBufferSubData');
    private z_GetBufferSubData_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferSubData(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetBufferSubData_ovr_0(target, offset, size, data);
    
    // added in gl1.3
    private z_GetCompressedTexImage_adr := GetProcAddress('glGetCompressedTexImage');
    private z_GetCompressedTexImage_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; img: IntPtr)>(z_GetCompressedTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTexImage(target: TextureTarget; level: Int32; img: IntPtr) :=
    z_GetCompressedTexImage_ovr_0(target, level, img);
    
    // added in gl4.5
    private z_GetCompressedTextureImage_adr := GetProcAddress('glGetCompressedTextureImage');
    private z_GetCompressedTextureImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetCompressedTextureImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureImage(texture: gl_texture; level: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureImage_ovr_0(texture, level, bufSize, pixels);
    
    // added in gl4.5
    private z_GetCompressedTextureSubImage_adr := GetProcAddress('glGetCompressedTextureSubImage');
    private z_GetCompressedTextureSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetCompressedTextureSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, bufSize, pixels);
    
    // added in gl4.3
    private z_GetDebugMessageLog_adr := GetProcAddress('glGetDebugMessageLog');
    private z_GetDebugMessageLog_ovr_0 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32>(z_GetDebugMessageLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_0(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    private z_GetDebugMessageLog_ovr_1 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32>(z_GetDebugMessageLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_1(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    
    // added in gl4.1
    private z_GetDoublei_v_adr := GetProcAddress('glGetDoublei_v');
    private z_GetDoublei_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: real)>(z_GetDoublei_v_adr);
    private z_GetDoublei_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetDoublei_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: GetPName; index: UInt32; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoublei_v_ovr_0(target, index, data[0]) else
      z_GetDoublei_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: GetPName; index: UInt32; var data: real) :=
    z_GetDoublei_v_ovr_0(target, index, data);
    private z_GetDoublei_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetDoublei_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetDoublei_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private z_GetDoublev_adr := GetProcAddress('glGetDoublev');
    private z_GetDoublev_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: real)>(z_GetDoublev_adr);
    private z_GetDoublev_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetDoublev_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublev(pname: GetPName; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoublev_ovr_0(pname, data[0]) else
      z_GetDoublev_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublev(pname: GetPName; var data: real) :=
    z_GetDoublev_ovr_0(pname, data);
    private z_GetDoublev_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetDoublev_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublev(pname: GetPName; data: IntPtr) :=
    z_GetDoublev_ovr_2(pname, data);
    
    // added in gl1.0
    private z_GetError_adr := GetProcAddress('glGetError');
    private z_GetError_ovr_0 := GetProcOrNil&<function: ErrorCode>(z_GetError_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetError: ErrorCode :=
    z_GetError_ovr_0;
    
    // added in gl4.1
    private z_GetFloati_v_adr := GetProcAddress('glGetFloati_v');
    private z_GetFloati_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: single)>(z_GetFloati_v_adr);
    private z_GetFloati_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetFloati_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: GetPName; index: UInt32; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloati_v_ovr_0(target, index, data[0]) else
      z_GetFloati_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: GetPName; index: UInt32; var data: single) :=
    z_GetFloati_v_ovr_0(target, index, data);
    private z_GetFloati_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetFloati_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetFloati_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private z_GetFloatv_adr := GetProcAddress('glGetFloatv');
    private z_GetFloatv_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: single)>(z_GetFloatv_adr);
    private z_GetFloatv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetFloatv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatv(pname: GetPName; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloatv_ovr_0(pname, data[0]) else
      z_GetFloatv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatv(pname: GetPName; var data: single) :=
    z_GetFloatv_ovr_0(pname, data);
    private z_GetFloatv_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetFloatv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatv(pname: GetPName; data: IntPtr) :=
    z_GetFloatv_ovr_2(pname, data);
    
    // added in gl3.3
    private z_GetFragDataIndex_adr := GetProcAddress('glGetFragDataIndex');
    private z_GetFragDataIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetFragDataIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetFragDataIndex_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: gl_program; name: IntPtr): Int32 :=
    z_GetFragDataIndex_ovr_0(&program, name);
    
    // added in gl3.0
    private z_GetFragDataLocation_adr := GetProcAddress('glGetFragDataLocation');
    private z_GetFragDataLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetFragDataLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocation(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetFragDataLocation_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocation(&program: gl_program; name: IntPtr): Int32 :=
    z_GetFragDataLocation_ovr_0(&program, name);
    
    // added in gl3.0
    private z_GetFramebufferAttachmentParameteriv_adr := GetProcAddress('glGetFramebufferAttachmentParameteriv');
    private z_GetFramebufferAttachmentParameteriv_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferAttachmentParameteriv_adr);
    private z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params[0]) else
      z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001(target, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params);
    private z_GetFramebufferAttachmentParameteriv_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferAttachmentParameteriv_ovr_2(target, attachment, pname, &params);
    
    // added in gl4.3
    private z_GetFramebufferParameteriv_adr := GetProcAddress('glGetFramebufferParameteriv');
    private z_GetFramebufferParameteriv_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferParameteriv_adr);
    private z_GetFramebufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetFramebufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferParameteriv_ovr_0(target, pname, &params);
    private z_GetFramebufferParameteriv_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferParameteriv_ovr_2(target, pname, &params);
    
    // added in gl4.5
    private z_GetGraphicsResetStatus_adr := GetProcAddress('glGetGraphicsResetStatus');
    private z_GetGraphicsResetStatus_ovr_0 := GetProcOrNil&<function: GraphicsResetStatus>(z_GetGraphicsResetStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGraphicsResetStatus: GraphicsResetStatus :=
    z_GetGraphicsResetStatus_ovr_0;
    
    // added in gl3.2
    private z_GetInteger64i_v_adr := GetProcAddress('glGetInteger64i_v');
    private z_GetInteger64i_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: Int64)>(z_GetInteger64i_v_adr);
    private z_GetInteger64i_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetInteger64i_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64i_v(target: GetPName; index: UInt32; data: array of Int64) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInteger64i_v_ovr_0(target, index, data[0]) else
      z_GetInteger64i_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64i_v(target: GetPName; index: UInt32; var data: Int64) :=
    z_GetInteger64i_v_ovr_0(target, index, data);
    private z_GetInteger64i_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetInteger64i_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64i_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetInteger64i_v_ovr_2(target, index, data);
    
    // added in gl3.2
    private z_GetInteger64v_adr := GetProcAddress('glGetInteger64v');
    private z_GetInteger64v_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: Int64)>(z_GetInteger64v_adr);
    private z_GetInteger64v_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetInteger64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: array of Int64) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInteger64v_ovr_0(pname, data[0]) else
      z_GetInteger64v_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; var data: Int64) :=
    z_GetInteger64v_ovr_0(pname, data);
    private z_GetInteger64v_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetInteger64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: IntPtr) :=
    z_GetInteger64v_ovr_2(pname, data);
    
    // added in gl3.0
    private z_GetIntegeri_v_adr := GetProcAddress('glGetIntegeri_v');
    private z_GetIntegeri_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: Int32)>(z_GetIntegeri_v_adr);
    private z_GetIntegeri_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegeri_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: GetPName; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegeri_v_ovr_0(target, index, data[0]) else
      z_GetIntegeri_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: GetPName; index: UInt32; var data: Int32) :=
    z_GetIntegeri_v_ovr_0(target, index, data);
    private z_GetIntegeri_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegeri_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetIntegeri_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private z_GetIntegerv_adr := GetProcAddress('glGetIntegerv');
    private z_GetIntegerv_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: Int32)>(z_GetIntegerv_adr);
    private z_GetIntegerv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetIntegerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerv(pname: GetPName; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegerv_ovr_0(pname, data[0]) else
      z_GetIntegerv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerv(pname: GetPName; var data: Int32) :=
    z_GetIntegerv_ovr_0(pname, data);
    private z_GetIntegerv_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetIntegerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerv(pname: GetPName; data: IntPtr) :=
    z_GetIntegerv_ovr_2(pname, data);
    
    // added in gl4.3
    private z_GetInternalformati64v_adr := GetProcAddress('glGetInternalformati64v');
    private z_GetInternalformati64v_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64)>(z_GetInternalformati64v_adr);
    private z_GetInternalformati64v_ovr_0_anh000001 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformati64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformati64v_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64) :=
    z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params);
    private z_GetInternalformati64v_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformati64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformati64v_ovr_2(target, _internalformat, pname, count, &params);
    
    // added in gl4.2
    private z_GetInternalformativ_adr := GetProcAddress('glGetInternalformativ');
    private z_GetInternalformativ_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32)>(z_GetInternalformativ_adr);
    private z_GetInternalformativ_ovr_0_anh000001 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformativ_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformativ_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32) :=
    z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params);
    private z_GetInternalformativ_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformativ_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformativ_ovr_2(target, _internalformat, pname, count, &params);
    
    // added in gl3.2
    private z_GetMultisamplefv_adr := GetProcAddress('glGetMultisamplefv');
    private z_GetMultisamplefv_ovr_0 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; var val: single)>(z_GetMultisamplefv_adr);
    private z_GetMultisamplefv_ovr_0_anh0001 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_GetMultisamplefv_ovr_0(pname, index, val[0]) else
      z_GetMultisamplefv_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; var val: single) :=
    z_GetMultisamplefv_ovr_0(pname, index, val);
    private z_GetMultisamplefv_ovr_2 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr) :=
    z_GetMultisamplefv_ovr_2(pname, index, val);
    
    // added in gl4.5
    private z_GetNamedBufferParameteri64v_adr := GetProcAddress('glGetNamedBufferParameteri64v');
    private z_GetNamedBufferParameteri64v_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int64)>(z_GetNamedBufferParameteri64v_adr);
    private z_GetNamedBufferParameteri64v_ovr_0_anh0001 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: gl_buffer; pname: BufferPNameARB; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteri64v_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int64) :=
    z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameteri64v_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetNamedBufferParameteri64v_ovr_2(buffer, pname, &params);
    
    // added in gl4.5
    private z_GetNamedBufferParameteriv_adr := GetProcAddress('glGetNamedBufferParameteriv');
    private z_GetNamedBufferParameteriv_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int32)>(z_GetNamedBufferParameteriv_adr);
    private z_GetNamedBufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: gl_buffer; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteriv_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int32) :=
    z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameteriv_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetNamedBufferParameteriv_ovr_2(buffer, pname, &params);
    
    // added in gl4.5
    private z_GetNamedBufferPointerv_adr := GetProcAddress('glGetNamedBufferPointerv');
    private z_GetNamedBufferPointerv_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPointerNameARB; var &params: IntPtr)>(z_GetNamedBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: gl_buffer; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetNamedBufferPointerv_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferPointerv_ovr_1 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPointerNameARB; &params: pointer)>(z_GetNamedBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: gl_buffer; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetNamedBufferPointerv_ovr_1(buffer, pname, &params);
    
    // added in gl4.5
    private z_GetNamedBufferSubData_adr := GetProcAddress('glGetNamedBufferSubData');
    private z_GetNamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: Byte)>(z_GetNamedBufferSubData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_GetNamedBufferSubData_ovr_0<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_GetNamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_GetNamedBufferSubData_ovr_0_anh00001(buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_GetNamedBufferSubData_ovr_0(buffer, offset, size, PByte(nil)^);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: array of T); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_GetNamedBufferSubData_ovr_0(buffer, offset, size, data[0]) else
        temp_GetNamedBufferSubData_ovr_0_anh00001(buffer, offset, size);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_GetNamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private z_GetNamedBufferSubData_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetNamedBufferSubData_ovr_2(buffer, offset, size, data);
    
    // added in gl4.5
    private z_GetNamedFramebufferAttachmentParameteriv_adr := GetProcAddress('glGetNamedFramebufferAttachmentParameteriv');
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params[0]) else
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001(framebuffer, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params);
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_2(framebuffer, attachment, pname, &params);
    
    // added in gl4.5
    private z_GetNamedFramebufferParameteriv_adr := GetProcAddress('glGetNamedFramebufferParameteriv');
    private z_GetNamedFramebufferParameteriv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var param: Int32)>(z_GetNamedFramebufferParameteriv_adr);
    private z_GetNamedFramebufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: IntPtr)>(z_GetNamedFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param[0]) else
      z_GetNamedFramebufferParameteriv_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var param: Int32) :=
    z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param);
    private z_GetNamedFramebufferParameteriv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: IntPtr)>(z_GetNamedFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: IntPtr) :=
    z_GetNamedFramebufferParameteriv_ovr_2(framebuffer, pname, param);
    
    // added in gl4.5
    private z_GetNamedRenderbufferParameteriv_adr := GetProcAddress('glGetNamedRenderbufferParameteriv');
    private z_GetNamedRenderbufferParameteriv_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; var &params: Int32)>(z_GetNamedRenderbufferParameteriv_adr);
    private z_GetNamedRenderbufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params[0]) else
      z_GetNamedRenderbufferParameteriv_ovr_0_anh0001(renderbuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params);
    private z_GetNamedRenderbufferParameteriv_ovr_2 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetNamedRenderbufferParameteriv_ovr_2(renderbuffer, pname, &params);
    
    // added in gl4.5
    private z_GetnColorTable_adr := GetProcAddress('glGetnColorTable');
    private z_GetnColorTable_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr)>(z_GetnColorTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnColorTable(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr) :=
    z_GetnColorTable_ovr_0(target, format, &type, bufSize, table);
    
    // added in gl4.5
    private z_GetnCompressedTexImage_adr := GetProcAddress('glGetnCompressedTexImage');
    private z_GetnCompressedTexImage_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; lod: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetnCompressedTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnCompressedTexImage(target: TextureTarget; lod: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetnCompressedTexImage_ovr_0(target, lod, bufSize, pixels);
    
    // added in gl4.5
    private z_GetnConvolutionFilter_adr := GetProcAddress('glGetnConvolutionFilter');
    private z_GetnConvolutionFilter_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr)>(z_GetnConvolutionFilter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnConvolutionFilter(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr) :=
    z_GetnConvolutionFilter_ovr_0(target, format, &type, bufSize, image);
    
    // added in gl4.5
    private z_GetnHistogram_adr := GetProcAddress('glGetnHistogram');
    private z_GetnHistogram_ovr_0 := GetProcOrNil&<procedure(target: HistogramTarget; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr)>(z_GetnHistogram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnHistogram(target: HistogramTarget; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnHistogram_ovr_0(target, reset, format, &type, bufSize, values);
    
    // added in gl4.5
    private z_GetnMapdv_adr := GetProcAddress('glGetnMapdv');
    private z_GetnMapdv_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real)>(z_GetnMapdv_adr);
    private z_GetnMapdv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdv(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapdv_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapdv_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdv(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real) :=
    z_GetnMapdv_ovr_0(target, query, bufSize, v);
    private z_GetnMapdv_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdv(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapdv_ovr_2(target, query, bufSize, v);
    
    // added in gl4.5
    private z_GetnMapfv_adr := GetProcAddress('glGetnMapfv');
    private z_GetnMapfv_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single)>(z_GetnMapfv_adr);
    private z_GetnMapfv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfv(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapfv_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapfv_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfv(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single) :=
    z_GetnMapfv_ovr_0(target, query, bufSize, v);
    private z_GetnMapfv_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfv(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapfv_ovr_2(target, query, bufSize, v);
    
    // added in gl4.5
    private z_GetnMapiv_adr := GetProcAddress('glGetnMapiv');
    private z_GetnMapiv_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32)>(z_GetnMapiv_adr);
    private z_GetnMapiv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapiv(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapiv_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapiv_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapiv(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32) :=
    z_GetnMapiv_ovr_0(target, query, bufSize, v);
    private z_GetnMapiv_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapiv(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapiv_ovr_2(target, query, bufSize, v);
    
    // added in gl4.5
    private z_GetnMinmax_adr := GetProcAddress('glGetnMinmax');
    private z_GetnMinmax_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTarget; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr)>(z_GetnMinmax_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMinmax(target: MinmaxTarget; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnMinmax_ovr_0(target, reset, format, &type, bufSize, values);
    
    // added in gl4.5
    private z_GetnPixelMapfv_adr := GetProcAddress('glGetnPixelMapfv');
    private z_GetnPixelMapfv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: single)>(z_GetnPixelMapfv_adr);
    private z_GetnPixelMapfv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfv(map: PixelMap; bufSize: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapfv_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapfv_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfv(map: PixelMap; bufSize: Int32; var values: single) :=
    z_GetnPixelMapfv_ovr_0(map, bufSize, values);
    private z_GetnPixelMapfv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfv(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapfv_ovr_2(map, bufSize, values);
    
    // added in gl4.5
    private z_GetnPixelMapuiv_adr := GetProcAddress('glGetnPixelMapuiv');
    private z_GetnPixelMapuiv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: UInt32)>(z_GetnPixelMapuiv_adr);
    private z_GetnPixelMapuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuiv(map: PixelMap; bufSize: Int32; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapuiv_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapuiv_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuiv(map: PixelMap; bufSize: Int32; var values: UInt32) :=
    z_GetnPixelMapuiv_ovr_0(map, bufSize, values);
    private z_GetnPixelMapuiv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuiv(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapuiv_ovr_2(map, bufSize, values);
    
    // added in gl4.5
    private z_GetnPixelMapusv_adr := GetProcAddress('glGetnPixelMapusv');
    private z_GetnPixelMapusv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: UInt16)>(z_GetnPixelMapusv_adr);
    private z_GetnPixelMapusv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusv(map: PixelMap; bufSize: Int32; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapusv_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapusv_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusv(map: PixelMap; bufSize: Int32; var values: UInt16) :=
    z_GetnPixelMapusv_ovr_0(map, bufSize, values);
    private z_GetnPixelMapusv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusv(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapusv_ovr_2(map, bufSize, values);
    
    // added in gl4.5
    private z_GetnPolygonStipple_adr := GetProcAddress('glGetnPolygonStipple');
    private z_GetnPolygonStipple_ovr_0 := GetProcOrNil&<procedure(bufSize: Int32; var pattern: Byte)>(z_GetnPolygonStipple_adr);
    private z_GetnPolygonStipple_ovr_0_anh001 := GetProcOrNil&<procedure(bufSize: Int32; pattern: IntPtr)>(z_GetnPolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStipple(bufSize: Int32; pattern: array of Byte) :=
    if (pattern<>nil) and (pattern.Length<>0) then
      z_GetnPolygonStipple_ovr_0(bufSize, pattern[0]) else
      z_GetnPolygonStipple_ovr_0_anh001(bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStipple(bufSize: Int32; var pattern: Byte) :=
    z_GetnPolygonStipple_ovr_0(bufSize, pattern);
    private z_GetnPolygonStipple_ovr_2 := GetProcOrNil&<procedure(bufSize: Int32; pattern: IntPtr)>(z_GetnPolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStipple(bufSize: Int32; pattern: IntPtr) :=
    z_GetnPolygonStipple_ovr_2(bufSize, pattern);
    
    // added in gl4.5
    private z_GetnSeparableFilter_adr := GetProcAddress('glGetnSeparableFilter');
    private z_GetnSeparableFilter_ovr_0 := GetProcOrNil&<procedure(target: SeparableTarget; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr)>(z_GetnSeparableFilter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnSeparableFilter(target: SeparableTarget; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr) :=
    z_GetnSeparableFilter_ovr_0(target, format, &type, rowBufSize, row, columnBufSize, column, span);
    
    // added in gl4.5
    private z_GetnTexImage_adr := GetProcAddress('glGetnTexImage');
    private z_GetnTexImage_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetnTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnTexImage(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetnTexImage_ovr_0(target, level, format, &type, bufSize, pixels);
    
    // added in gl4.5
    private z_GetnUniformdv_adr := GetProcAddress('glGetnUniformdv');
    private z_GetnUniformdv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: real)>(z_GetnUniformdv_adr);
    private z_GetnUniformdv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformdv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformdv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdv(&program: gl_program; location: Int32; bufSize: Int32; var &params: real) :=
    z_GetnUniformdv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformdv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformdv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.5
    private z_GetnUniformfv_adr := GetProcAddress('glGetnUniformfv');
    private z_GetnUniformfv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: single)>(z_GetnUniformfv_adr);
    private z_GetnUniformfv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformfv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformfv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: gl_program; location: Int32; bufSize: Int32; var &params: single) :=
    z_GetnUniformfv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformfv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformfv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.5
    private z_GetnUniformiv_adr := GetProcAddress('glGetnUniformiv');
    private z_GetnUniformiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int32)>(z_GetnUniformiv_adr);
    private z_GetnUniformiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int32) :=
    z_GetnUniformiv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformiv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.5
    private z_GetnUniformuiv_adr := GetProcAddress('glGetnUniformuiv');
    private z_GetnUniformuiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt32)>(z_GetnUniformuiv_adr);
    private z_GetnUniformuiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformuiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt32) :=
    z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformuiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformuiv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.3
    private z_GetObjectLabel_adr := GetProcAddress('glGetObjectLabel');
    private z_GetObjectLabel_ovr_0 := GetProcOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectLabel_ovr_0(identifier, name, bufSize, length, &label);
    private z_GetObjectLabel_ovr_1 := GetProcOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectLabel_ovr_1(identifier, name, bufSize, length, &label);
    
    // added in gl4.3
    private z_GetObjectPtrLabel_adr := GetProcAddress('glGetObjectPtrLabel');
    private z_GetObjectPtrLabel_ovr_0 := GetProcOrNil&<procedure(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_0(ptr, bufSize, length, &label);
    private z_GetObjectPtrLabel_ovr_1 := GetProcOrNil&<procedure(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_1(ptr, bufSize, length, &label);
    
    // added in gl4.3
    private z_GetPointerv_adr := GetProcAddress('glGetPointerv');
    private z_GetPointerv_ovr_0 := GetProcOrNil&<procedure(pname: GetPointervPName; var &params: IntPtr)>(z_GetPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; var &params: IntPtr) :=
    z_GetPointerv_ovr_0(pname, &params);
    private z_GetPointerv_ovr_1 := GetProcOrNil&<procedure(pname: GetPointervPName; &params: pointer)>(z_GetPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; &params: pointer) :=
    z_GetPointerv_ovr_1(pname, &params);
    
    // added in gl4.1
    private z_GetProgramBinary_adr := GetProcAddress('glGetProgramBinary');
    private z_GetProgramBinary_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_0(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_1(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_2(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_3(&program, bufSize, length, binaryFormat, binary);
    
    // added in gl2.0
    private z_GetProgramInfoLog_adr := GetProcAddress('glGetProgramInfoLog');
    private z_GetProgramInfoLog_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetProgramInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInfoLog(&program: gl_program; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetProgramInfoLog_ovr_0(&program, bufSize, length, infoLog);
    private z_GetProgramInfoLog_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetProgramInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInfoLog(&program: gl_program; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetProgramInfoLog_ovr_1(&program, bufSize, length, infoLog);
    
    // added in gl4.3
    private z_GetProgramInterfaceiv_adr := GetProcAddress('glGetProgramInterfaceiv');
    private z_GetProgramInterfaceiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32)>(z_GetProgramInterfaceiv_adr);
    private z_GetProgramInterfaceiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr)>(z_GetProgramInterfaceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params[0]) else
      z_GetProgramInterfaceiv_ovr_0_anh00001(&program, _programInterface, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32) :=
    z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params);
    private z_GetProgramInterfaceiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr)>(z_GetProgramInterfaceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr) :=
    z_GetProgramInterfaceiv_ovr_2(&program, _programInterface, pname, &params);
    
    // added in gl2.0
    private z_GetProgramiv_adr := GetProcAddress('glGetProgramiv');
    private z_GetProgramiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramPropertyARB; var &params: Int32)>(z_GetProgramiv_adr);
    private z_GetProgramiv_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetProgramiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramiv(&program: gl_program; pname: ProgramPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramiv_ovr_0(&program, pname, &params[0]) else
      z_GetProgramiv_ovr_0_anh0001(&program, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramiv(&program: gl_program; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetProgramiv_ovr_0(&program, pname, &params);
    private z_GetProgramiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetProgramiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramiv(&program: gl_program; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetProgramiv_ovr_2(&program, pname, &params);
    
    // added in gl4.1
    private z_GetProgramPipelineInfoLog_adr := GetProcAddress('glGetProgramPipelineInfoLog');
    private z_GetProgramPipelineInfoLog_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: gl_program_pipeline; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_0(pipeline, bufSize, length, infoLog);
    private z_GetProgramPipelineInfoLog_ovr_1 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: gl_program_pipeline; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_1(pipeline, bufSize, length, infoLog);
    
    // added in gl4.1
    private z_GetProgramPipelineiv_adr := GetProcAddress('glGetProgramPipelineiv');
    private z_GetProgramPipelineiv_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; pname: PipelineParameterName; var &params: Int32)>(z_GetProgramPipelineiv_adr);
    private z_GetProgramPipelineiv_ovr_0_anh0001 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: IntPtr)>(z_GetProgramPipelineiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params[0]) else
      z_GetProgramPipelineiv_ovr_0_anh0001(pipeline, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: gl_program_pipeline; pname: PipelineParameterName; var &params: Int32) :=
    z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params);
    private z_GetProgramPipelineiv_ovr_2 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: IntPtr)>(z_GetProgramPipelineiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: IntPtr) :=
    z_GetProgramPipelineiv_ovr_2(pipeline, pname, &params);
    
    // added in gl4.3
    private z_GetProgramResourceIndex_adr := GetProcAddress('glGetProgramResourceIndex');
    private z_GetProgramResourceIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): UInt32>(z_GetProgramResourceIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: gl_program; _programInterface: ProgramInterface; name: string): UInt32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetProgramResourceIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): UInt32 :=
    z_GetProgramResourceIndex_ovr_0(&program, _programInterface, name);
    
    // added in gl4.3
    private z_GetProgramResourceiv_adr := GetProcAddress('glGetProgramResourceiv');
    private z_GetProgramResourceiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_1_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_2_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000001001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_3_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_3_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_3_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_4_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_3_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_5_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_5(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_5_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_3_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_5(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_12 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_12_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_12(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_12_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_12(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_14 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_14(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_15 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_15_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_15(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_15_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_15(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_17 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_17(&program, _programInterface, index, propCount, props, count, length, &params);
    
    // added in gl4.3
    private z_GetProgramResourceLocation_adr := GetProcAddress('glGetProgramResourceLocation');
    private z_GetProgramResourceLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32>(z_GetProgramResourceLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: gl_program; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetProgramResourceLocation_ovr_0(&program, _programInterface, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocation_ovr_0(&program, _programInterface, name);
    
    // added in gl4.3
    private z_GetProgramResourceLocationIndex_adr := GetProcAddress('glGetProgramResourceLocationIndex');
    private z_GetProgramResourceLocationIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32>(z_GetProgramResourceLocationIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: gl_program; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, name);
    
    // added in gl4.3
    private z_GetProgramResourceName_adr := GetProcAddress('glGetProgramResourceName');
    private z_GetProgramResourceName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetProgramResourceName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetProgramResourceName_ovr_0(&program, _programInterface, index, bufSize, length, name);
    private z_GetProgramResourceName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetProgramResourceName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetProgramResourceName_ovr_1(&program, _programInterface, index, bufSize, length, name);
    
    // added in gl4.0
    private z_GetProgramStageiv_adr := GetProcAddress('glGetProgramStageiv');
    private z_GetProgramStageiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32)>(z_GetProgramStageiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32) :=
    z_GetProgramStageiv_ovr_0(&program, _shadertype, pname, values);
    private z_GetProgramStageiv_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr)>(z_GetProgramStageiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr) :=
    z_GetProgramStageiv_ovr_1(&program, _shadertype, pname, values);
    
    // added in gl4.5
    private z_GetQueryBufferObjecti64v_adr := GetProcAddress('glGetQueryBufferObjecti64v');
    private z_GetQueryBufferObjecti64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjecti64v(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjecti64v_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.5
    private z_GetQueryBufferObjectiv_adr := GetProcAddress('glGetQueryBufferObjectiv');
    private z_GetQueryBufferObjectiv_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectiv(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectiv_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.5
    private z_GetQueryBufferObjectui64v_adr := GetProcAddress('glGetQueryBufferObjectui64v');
    private z_GetQueryBufferObjectui64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectui64v(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectui64v_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.5
    private z_GetQueryBufferObjectuiv_adr := GetProcAddress('glGetQueryBufferObjectuiv');
    private z_GetQueryBufferObjectuiv_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectuiv(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectuiv_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.0
    private z_GetQueryIndexediv_adr := GetProcAddress('glGetQueryIndexediv');
    private z_GetQueryIndexediv_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32)>(z_GetQueryIndexediv_adr);
    private z_GetQueryIndexediv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryIndexediv_ovr_0(target, index, pname, &params[0]) else
      z_GetQueryIndexediv_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryIndexediv_ovr_0(target, index, pname, &params);
    private z_GetQueryIndexediv_ovr_2 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryIndexediv_ovr_2(target, index, pname, &params);
    
    // added in gl1.5
    private z_GetQueryiv_adr := GetProcAddress('glGetQueryiv');
    private z_GetQueryiv_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; var &params: Int32)>(z_GetQueryiv_adr);
    private z_GetQueryiv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryiv(target: QueryTarget; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryiv_ovr_0(target, pname, &params[0]) else
      z_GetQueryiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryiv(target: QueryTarget; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryiv_ovr_0(target, pname, &params);
    private z_GetQueryiv_ovr_2 := GetProcOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryiv(target: QueryTarget; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryiv_ovr_2(target, pname, &params);
    
    // added in gl3.3
    private z_GetQueryObjecti64v_adr := GetProcAddress('glGetQueryObjecti64v');
    private z_GetQueryObjecti64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: Int64)>(z_GetQueryObjecti64v_adr);
    private z_GetQueryObjecti64v_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: gl_query; pname: QueryObjectParameterName; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjecti64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjecti64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: gl_query; pname: QueryObjectParameterName; var &params: Int64) :=
    z_GetQueryObjecti64v_ovr_0(id, pname, &params);
    private z_GetQueryObjecti64v_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjecti64v_ovr_2(id, pname, &params);
    
    // added in gl1.5
    private z_GetQueryObjectiv_adr := GetProcAddress('glGetQueryObjectiv');
    private z_GetQueryObjectiv_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: Int32)>(z_GetQueryObjectiv_adr);
    private z_GetQueryObjectiv_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectiv(id: gl_query; pname: QueryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectiv_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectiv_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectiv(id: gl_query; pname: QueryObjectParameterName; var &params: Int32) :=
    z_GetQueryObjectiv_ovr_0(id, pname, &params);
    private z_GetQueryObjectiv_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectiv(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectiv_ovr_2(id, pname, &params);
    
    // added in gl3.3
    private z_GetQueryObjectui64v_adr := GetProcAddress('glGetQueryObjectui64v');
    private z_GetQueryObjectui64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: UInt64)>(z_GetQueryObjectui64v_adr);
    private z_GetQueryObjectui64v_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: gl_query; pname: QueryObjectParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectui64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectui64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: gl_query; pname: QueryObjectParameterName; var &params: UInt64) :=
    z_GetQueryObjectui64v_ovr_0(id, pname, &params);
    private z_GetQueryObjectui64v_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectui64v_ovr_2(id, pname, &params);
    
    // added in gl1.5
    private z_GetQueryObjectuiv_adr := GetProcAddress('glGetQueryObjectuiv');
    private z_GetQueryObjectuiv_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: UInt32)>(z_GetQueryObjectuiv_adr);
    private z_GetQueryObjectuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuiv(id: gl_query; pname: QueryObjectParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectuiv_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectuiv_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuiv(id: gl_query; pname: QueryObjectParameterName; var &params: UInt32) :=
    z_GetQueryObjectuiv_ovr_0(id, pname, &params);
    private z_GetQueryObjectuiv_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuiv(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectuiv_ovr_2(id, pname, &params);
    
    // added in gl3.0
    private z_GetRenderbufferParameteriv_adr := GetProcAddress('glGetRenderbufferParameteriv');
    private z_GetRenderbufferParameteriv_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32)>(z_GetRenderbufferParameteriv_adr);
    private z_GetRenderbufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetRenderbufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetRenderbufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetRenderbufferParameteriv_ovr_0(target, pname, &params);
    private z_GetRenderbufferParameteriv_ovr_2 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetRenderbufferParameteriv_ovr_2(target, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameterfv_adr := GetProcAddress('glGetSamplerParameterfv');
    private z_GetSamplerParameterfv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterF; var &params: single)>(z_GetSamplerParameterfv_adr);
    private z_GetSamplerParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterF; &params: IntPtr)>(z_GetSamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: gl_sampler; pname: SamplerParameterF; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterfv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: gl_sampler; pname: SamplerParameterF; var &params: single) :=
    z_GetSamplerParameterfv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterfv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterF; &params: IntPtr)>(z_GetSamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: gl_sampler; pname: SamplerParameterF; &params: IntPtr) :=
    z_GetSamplerParameterfv_ovr_2(sampler, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameterIiv_adr := GetProcAddress('glGetSamplerParameterIiv');
    private z_GetSamplerParameterIiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; var &params: Int32)>(z_GetSamplerParameterIiv_adr);
    private z_GetSamplerParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: gl_sampler; pname: SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: gl_sampler; pname: SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterIiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIiv_ovr_2(sampler, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameterIuiv_adr := GetProcAddress('glGetSamplerParameterIuiv');
    private z_GetSamplerParameterIuiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; var &params: UInt32)>(z_GetSamplerParameterIuiv_adr);
    private z_GetSamplerParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: gl_sampler; pname: SamplerParameterI; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: gl_sampler; pname: SamplerParameterI; var &params: UInt32) :=
    z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterIuiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIuiv_ovr_2(sampler, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameteriv_adr := GetProcAddress('glGetSamplerParameteriv');
    private z_GetSamplerParameteriv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; var &params: Int32)>(z_GetSamplerParameteriv_adr);
    private z_GetSamplerParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: gl_sampler; pname: SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameteriv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: gl_sampler; pname: SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameteriv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameteriv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: gl_sampler; pname: SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameteriv_ovr_2(sampler, pname, &params);
    
    // added in gl2.0
    private z_GetShaderInfoLog_adr := GetProcAddress('glGetShaderInfoLog');
    private z_GetShaderInfoLog_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetShaderInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderInfoLog(shader: gl_shader; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetShaderInfoLog_ovr_0(shader, bufSize, length, infoLog);
    private z_GetShaderInfoLog_ovr_1 := GetProcOrNil&<procedure(shader: gl_shader; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetShaderInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderInfoLog(shader: gl_shader; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetShaderInfoLog_ovr_1(shader, bufSize, length, infoLog);
    
    // added in gl2.0
    private z_GetShaderiv_adr := GetProcAddress('glGetShaderiv');
    private z_GetShaderiv_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; pname: ShaderParameterName; var &params: Int32)>(z_GetShaderiv_adr);
    private z_GetShaderiv_ovr_0_anh0001 := GetProcOrNil&<procedure(shader: gl_shader; pname: ShaderParameterName; &params: IntPtr)>(z_GetShaderiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderiv(shader: gl_shader; pname: ShaderParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetShaderiv_ovr_0(shader, pname, &params[0]) else
      z_GetShaderiv_ovr_0_anh0001(shader, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderiv(shader: gl_shader; pname: ShaderParameterName; var &params: Int32) :=
    z_GetShaderiv_ovr_0(shader, pname, &params);
    private z_GetShaderiv_ovr_2 := GetProcOrNil&<procedure(shader: gl_shader; pname: ShaderParameterName; &params: IntPtr)>(z_GetShaderiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderiv(shader: gl_shader; pname: ShaderParameterName; &params: IntPtr) :=
    z_GetShaderiv_ovr_2(shader, pname, &params);
    
    // added in gl4.1
    private z_GetShaderPrecisionFormat_adr := GetProcAddress('glGetShaderPrecisionFormat');
    private z_GetShaderPrecisionFormat_ovr_0 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_0_anh00010 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; var precision: Int32) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    private z_GetShaderPrecisionFormat_ovr_1 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_1_anh00010 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; precision: IntPtr) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_1(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_1_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_1(_shadertype, _precisiontype, range, precision);
    private z_GetShaderPrecisionFormat_ovr_4 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_4(_shadertype, _precisiontype, range, precision);
    private z_GetShaderPrecisionFormat_ovr_5 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_5(_shadertype, _precisiontype, range, precision);
    
    // added in gl2.0
    private z_GetShaderSource_adr := GetProcAddress('glGetShaderSource');
    private z_GetShaderSource_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; bufSize: Int32; var length: Int32; source: IntPtr)>(z_GetShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSource(shader: gl_shader; bufSize: Int32; var length: Int32; source: IntPtr) :=
    z_GetShaderSource_ovr_0(shader, bufSize, length, source);
    private z_GetShaderSource_ovr_1 := GetProcOrNil&<procedure(shader: gl_shader; bufSize: Int32; length: IntPtr; source: IntPtr)>(z_GetShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSource(shader: gl_shader; bufSize: Int32; length: IntPtr; source: IntPtr) :=
    z_GetShaderSource_ovr_1(shader, bufSize, length, source);
    
    // added in gl1.0
    private z_GetString_adr := GetProcAddress('glGetString');
    private z_GetString_ovr_0 := GetProcOrNil&<function(name: StringName): IntPtr>(z_GetString_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetString(name: StringName): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_GetString_ovr_0(name);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in gl3.0
    private z_GetStringi_adr := GetProcAddress('glGetStringi');
    private z_GetStringi_ovr_0 := GetProcOrNil&<function(name: StringName; index: UInt32): IntPtr>(z_GetStringi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetStringi(name: StringName; index: UInt32): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_GetStringi_ovr_0(name, index);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in gl4.0
    private z_GetSubroutineIndex_adr := GetProcAddress('glGetSubroutineIndex');
    private z_GetSubroutineIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; _shadertype: ShaderType; name: IntPtr): UInt32>(z_GetSubroutineIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: gl_program; _shadertype: ShaderType; name: string): UInt32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetSubroutineIndex_ovr_0(&program, _shadertype, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: gl_program; _shadertype: ShaderType; name: IntPtr): UInt32 :=
    z_GetSubroutineIndex_ovr_0(&program, _shadertype, name);
    
    // added in gl4.0
    private z_GetSubroutineUniformLocation_adr := GetProcAddress('glGetSubroutineUniformLocation');
    private z_GetSubroutineUniformLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; _shadertype: ShaderType; name: IntPtr): Int32>(z_GetSubroutineUniformLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: gl_program; _shadertype: ShaderType; name: string): Int32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: gl_program; _shadertype: ShaderType; name: IntPtr): Int32 :=
    z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, name);
    
    // added in gl3.2
    private z_GetSynciv_adr := GetProcAddress('glGetSynciv');
    private z_GetSynciv_ovr_0 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_0_anh000001 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_0(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_0_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32) :=
    z_GetSynciv_ovr_0(sync, pname, count, length, values);
    private z_GetSynciv_ovr_2 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr) :=
    z_GetSynciv_ovr_2(sync, pname, count, length, values);
    private z_GetSynciv_ovr_3 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_3_anh000001 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_3(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_3_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32) :=
    z_GetSynciv_ovr_3(sync, pname, count, length, values);
    private z_GetSynciv_ovr_5 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr) :=
    z_GetSynciv_ovr_5(sync, pname, count, length, values);
    
    // added in gl1.0
    private z_GetTexImage_adr := GetProcAddress('glGetTexImage');
    private z_GetTexImage_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_GetTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexImage(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_GetTexImage_ovr_0(target, level, format, &type, pixels);
    
    // added in gl1.0
    private z_GetTexLevelParameterfv_adr := GetProcAddress('glGetTexLevelParameterfv');
    private z_GetTexLevelParameterfv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single)>(z_GetTexLevelParameterfv_adr);
    private z_GetTexLevelParameterfv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterfv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexLevelParameterfv_ovr_0(target, level, pname, &params[0]) else
      z_GetTexLevelParameterfv_ovr_0_anh00001(target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterfv(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTexLevelParameterfv_ovr_0(target, level, pname, &params);
    private z_GetTexLevelParameterfv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterfv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexLevelParameterfv_ovr_2(target, level, pname, &params);
    
    // added in gl1.0
    private z_GetTexLevelParameteriv_adr := GetProcAddress('glGetTexLevelParameteriv');
    private z_GetTexLevelParameteriv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32)>(z_GetTexLevelParameteriv_adr);
    private z_GetTexLevelParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameteriv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexLevelParameteriv_ovr_0(target, level, pname, &params[0]) else
      z_GetTexLevelParameteriv_ovr_0_anh00001(target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameteriv(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexLevelParameteriv_ovr_0(target, level, pname, &params);
    private z_GetTexLevelParameteriv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameteriv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexLevelParameteriv_ovr_2(target, level, pname, &params);
    
    // added in gl1.0
    private z_GetTexParameterfv_adr := GetProcAddress('glGetTexParameterfv');
    private z_GetTexParameterfv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: single)>(z_GetTexParameterfv_adr);
    private z_GetTexParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterfv(target: TextureTarget; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterfv(target: TextureTarget; pname: GetTextureParameter; var &params: single) :=
    z_GetTexParameterfv_ovr_0(target, pname, &params);
    private z_GetTexParameterfv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterfv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterfv_ovr_2(target, pname, &params);
    
    // added in gl3.0
    private z_GetTexParameterIiv_adr := GetProcAddress('glGetTexParameterIiv');
    private z_GetTexParameterIiv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetTexParameterIiv_adr);
    private z_GetTexParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIiv(target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIiv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIiv(target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexParameterIiv_ovr_0(target, pname, &params);
    private z_GetTexParameterIiv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIiv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIiv_ovr_2(target, pname, &params);
    
    // added in gl3.0
    private z_GetTexParameterIuiv_adr := GetProcAddress('glGetTexParameterIuiv');
    private z_GetTexParameterIuiv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32)>(z_GetTexParameterIuiv_adr);
    private z_GetTexParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuiv(target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIuiv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIuiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuiv(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTexParameterIuiv_ovr_0(target, pname, &params);
    private z_GetTexParameterIuiv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuiv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIuiv_ovr_2(target, pname, &params);
    
    // added in gl1.0
    private z_GetTexParameteriv_adr := GetProcAddress('glGetTexParameteriv');
    private z_GetTexParameteriv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetTexParameteriv_adr);
    private z_GetTexParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameteriv(target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameteriv(target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexParameteriv_ovr_0(target, pname, &params);
    private z_GetTexParameteriv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameteriv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameteriv_ovr_2(target, pname, &params);
    
    // added in gl4.5
    private z_GetTextureImage_adr := GetProcAddress('glGetTextureImage');
    private z_GetTextureImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetTextureImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureImage(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureImage_ovr_0(texture, level, format, &type, bufSize, pixels);
    
    // added in gl4.5
    private z_GetTextureLevelParameterfv_adr := GetProcAddress('glGetTextureLevelParameterfv');
    private z_GetTextureLevelParameterfv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: single)>(z_GetTextureLevelParameterfv_adr);
    private z_GetTextureLevelParameterfv_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameterfv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params);
    private z_GetTextureLevelParameterfv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterfv_ovr_2(texture, level, pname, &params);
    
    // added in gl4.5
    private z_GetTextureLevelParameteriv_adr := GetProcAddress('glGetTextureLevelParameteriv');
    private z_GetTextureLevelParameteriv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureLevelParameteriv_adr);
    private z_GetTextureLevelParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameteriv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params);
    private z_GetTextureLevelParameteriv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameteriv_ovr_2(texture, level, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameterfv_adr := GetProcAddress('glGetTextureParameterfv');
    private z_GetTextureParameterfv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: single)>(z_GetTextureParameterfv_adr);
    private z_GetTextureParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: gl_texture; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterfv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: gl_texture; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureParameterfv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterfv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterfv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameterIiv_adr := GetProcAddress('glGetTextureParameterIiv');
    private z_GetTextureParameterIiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameterIiv_adr);
    private z_GetTextureParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: gl_texture; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: gl_texture; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterIiv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterIiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameterIuiv_adr := GetProcAddress('glGetTextureParameterIuiv');
    private z_GetTextureParameterIuiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: UInt32)>(z_GetTextureParameterIuiv_adr);
    private z_GetTextureParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: gl_texture; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: gl_texture; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTextureParameterIuiv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterIuiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIuiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameteriv_adr := GetProcAddress('glGetTextureParameteriv');
    private z_GetTextureParameteriv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameteriv_adr);
    private z_GetTextureParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: gl_texture; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameteriv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: gl_texture; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameteriv_ovr_0(texture, pname, &params);
    private z_GetTextureParameteriv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameteriv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureSubImage_adr := GetProcAddress('glGetTextureSubImage');
    private z_GetTextureSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetTextureSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, bufSize, pixels);
    
    // added in gl4.5
    private z_GetTransformFeedbacki_v_adr := GetProcAddress('glGetTransformFeedbacki_v');
    private z_GetTransformFeedbacki_v_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int32)>(z_GetTransformFeedbacki_v_adr);
    private z_GetTransformFeedbacki_v_ovr_0_anh00001 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int32) :=
    z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param);
    private z_GetTransformFeedbacki_v_ovr_2 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki_v_ovr_2(xfb, pname, index, param);
    
    // added in gl4.5
    private z_GetTransformFeedbacki64_v_adr := GetProcAddress('glGetTransformFeedbacki64_v');
    private z_GetTransformFeedbacki64_v_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int64)>(z_GetTransformFeedbacki64_v_adr);
    private z_GetTransformFeedbacki64_v_ovr_0_anh00001 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki64_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki64_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int64) :=
    z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param);
    private z_GetTransformFeedbacki64_v_ovr_2 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki64_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki64_v_ovr_2(xfb, pname, index, param);
    
    // added in gl4.5
    private z_GetTransformFeedbackiv_adr := GetProcAddress('glGetTransformFeedbackiv');
    private z_GetTransformFeedbackiv_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; var param: Int32)>(z_GetTransformFeedbackiv_adr);
    private z_GetTransformFeedbackiv_ovr_0_anh0001 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: IntPtr)>(z_GetTransformFeedbackiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbackiv_ovr_0(xfb, pname, param[0]) else
      z_GetTransformFeedbackiv_ovr_0_anh0001(xfb, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: gl_transform_feedback; pname: TransformFeedbackPName; var param: Int32) :=
    z_GetTransformFeedbackiv_ovr_0(xfb, pname, param);
    private z_GetTransformFeedbackiv_ovr_2 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: IntPtr)>(z_GetTransformFeedbackiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: IntPtr) :=
    z_GetTransformFeedbackiv_ovr_2(xfb, pname, param);
    
    // added in gl3.0
    private z_GetTransformFeedbackVarying_adr := GetProcAddress('glGetTransformFeedbackVarying');
    private z_GetTransformFeedbackVarying_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_1(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_2(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_3(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_4 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_4(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_5(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_6(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_7 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_7(&program, index, bufSize, length, size, &type, name);
    
    // added in gl3.1
    private z_GetUniformBlockIndex_adr := GetProcAddress('glGetUniformBlockIndex');
    private z_GetUniformBlockIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; uniformBlockName: IntPtr): UInt32>(z_GetUniformBlockIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: gl_program; uniformBlockName: string): UInt32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(uniformBlockName);
        Result := z_GetUniformBlockIndex_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: gl_program; uniformBlockName: IntPtr): UInt32 :=
    z_GetUniformBlockIndex_ovr_0(&program, uniformBlockName);
    
    // added in gl4.0
    private z_GetUniformdv_adr := GetProcAddress('glGetUniformdv');
    private z_GetUniformdv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: real)>(z_GetUniformdv_adr);
    private z_GetUniformdv_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: gl_program; location: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformdv_ovr_0(&program, location, &params[0]) else
      z_GetUniformdv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: gl_program; location: Int32; var &params: real) :=
    z_GetUniformdv_ovr_0(&program, location, &params);
    private z_GetUniformdv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformdv_ovr_2(&program, location, &params);
    
    // added in gl2.0
    private z_GetUniformfv_adr := GetProcAddress('glGetUniformfv');
    private z_GetUniformfv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: single)>(z_GetUniformfv_adr);
    private z_GetUniformfv_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfv(&program: gl_program; location: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformfv_ovr_0(&program, location, &params[0]) else
      z_GetUniformfv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfv(&program: gl_program; location: Int32; var &params: single) :=
    z_GetUniformfv_ovr_0(&program, location, &params);
    private z_GetUniformfv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfv(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformfv_ovr_2(&program, location, &params);
    
    // added in gl3.1
    private z_GetUniformIndices_adr := GetProcAddress('glGetUniformIndices');
    private z_GetUniformIndices_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00011 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of string; uniformIndices: array of UInt32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
            z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices[0]) else
            z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, par_3_str_ptr[0], IntPtr.Zero) else
          if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
            z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
            z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_GetUniformIndices_ovr_1_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of string; var uniformIndices: UInt32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
          z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_GetUniformIndices_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_2_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of string; uniformIndices: IntPtr);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_GetUniformIndices_ovr_2(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
          z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_GetUniformIndices_ovr_3_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_3_anh00011 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: array of UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, uniformNames[0], IntPtr.Zero) else
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
    private z_GetUniformIndices_ovr_4_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of IntPtr; var uniformIndices: UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private z_GetUniformIndices_ovr_5_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: IntPtr) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_2(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private z_GetUniformIndices_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_6_anh00001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: array of UInt32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices[0]) else
      z_GetUniformIndices_ovr_6_anh00001(&program, uniformCount, uniformNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32) :=
    z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices);
    private z_GetUniformIndices_ovr_8 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr) :=
    z_GetUniformIndices_ovr_8(&program, uniformCount, uniformNames, uniformIndices);
    
    // added in gl2.0
    private z_GetUniformiv_adr := GetProcAddress('glGetUniformiv');
    private z_GetUniformiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: Int32)>(z_GetUniformiv_adr);
    private z_GetUniformiv_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformiv(&program: gl_program; location: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformiv_ovr_0(&program, location, &params[0]) else
      z_GetUniformiv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformiv(&program: gl_program; location: Int32; var &params: Int32) :=
    z_GetUniformiv_ovr_0(&program, location, &params);
    private z_GetUniformiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformiv(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformiv_ovr_2(&program, location, &params);
    
    // added in gl2.0
    private z_GetUniformLocation_adr := GetProcAddress('glGetUniformLocation');
    private z_GetUniformLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetUniformLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocation(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetUniformLocation_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocation(&program: gl_program; name: IntPtr): Int32 :=
    z_GetUniformLocation_ovr_0(&program, name);
    
    // added in gl4.0
    private z_GetUniformSubroutineuiv_adr := GetProcAddress('glGetUniformSubroutineuiv');
    private z_GetUniformSubroutineuiv_ovr_0 := GetProcOrNil&<procedure(_shadertype: ShaderType; location: Int32; var &params: UInt32)>(z_GetUniformSubroutineuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; var &params: UInt32) :=
    z_GetUniformSubroutineuiv_ovr_0(_shadertype, location, &params);
    private z_GetUniformSubroutineuiv_ovr_1 := GetProcOrNil&<procedure(_shadertype: ShaderType; location: Int32; &params: IntPtr)>(z_GetUniformSubroutineuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; &params: IntPtr) :=
    z_GetUniformSubroutineuiv_ovr_1(_shadertype, location, &params);
    
    // added in gl3.0
    private z_GetUniformuiv_adr := GetProcAddress('glGetUniformuiv');
    private z_GetUniformuiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: UInt32)>(z_GetUniformuiv_adr);
    private z_GetUniformuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuiv(&program: gl_program; location: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformuiv_ovr_0(&program, location, &params[0]) else
      z_GetUniformuiv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuiv(&program: gl_program; location: Int32; var &params: UInt32) :=
    z_GetUniformuiv_ovr_0(&program, location, &params);
    private z_GetUniformuiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuiv(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformuiv_ovr_2(&program, location, &params);
    
    // added in gl4.5
    private z_GetVertexArrayIndexed64iv_adr := GetProcAddress('glGetVertexArrayIndexed64iv');
    private z_GetVertexArrayIndexed64iv_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int64)>(z_GetVertexArrayIndexed64iv_adr);
    private z_GetVertexArrayIndexed64iv_ovr_0_anh00001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexed64iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexed64iv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int64) :=
    z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIndexed64iv_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexed64iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexed64iv_ovr_2(vaobj, index, pname, param);
    
    // added in gl4.5
    private z_GetVertexArrayIndexediv_adr := GetProcAddress('glGetVertexArrayIndexediv');
    private z_GetVertexArrayIndexediv_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayIndexediv_adr);
    private z_GetVertexArrayIndexediv_ovr_0_anh00001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexediv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIndexediv_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexediv_ovr_2(vaobj, index, pname, param);
    
    // added in gl4.5
    private z_GetVertexArrayiv_adr := GetProcAddress('glGetVertexArrayiv');
    private z_GetVertexArrayiv_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayiv_adr);
    private z_GetVertexArrayiv_ovr_0_anh0001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: gl_vertex_array; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayiv_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayiv_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayiv_ovr_0(vaobj, pname, param);
    private z_GetVertexArrayiv_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayiv_ovr_2(vaobj, pname, param);
    
    // added in gl2.0
    private z_GetVertexAttribdv_adr := GetProcAddress('glGetVertexAttribdv');
    private z_GetVertexAttribdv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: real)>(z_GetVertexAttribdv_adr);
    private z_GetVertexAttribdv_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdv(index: UInt32; pname: VertexAttribPropertyARB; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdv(index: UInt32; pname: VertexAttribPropertyARB; var &params: real) :=
    z_GetVertexAttribdv_ovr_0(index, pname, &params);
    private z_GetVertexAttribdv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdv(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribdv_ovr_2(index, pname, &params);
    
    // added in gl2.0
    private z_GetVertexAttribfv_adr := GetProcAddress('glGetVertexAttribfv');
    private z_GetVertexAttribfv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: single)>(z_GetVertexAttribfv_adr);
    private z_GetVertexAttribfv_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfv(index: UInt32; pname: VertexAttribPropertyARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfv(index: UInt32; pname: VertexAttribPropertyARB; var &params: single) :=
    z_GetVertexAttribfv_ovr_0(index, pname, &params);
    private z_GetVertexAttribfv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfv(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribfv_ovr_2(index, pname, &params);
    
    // added in gl3.0
    private z_GetVertexAttribIiv_adr := GetProcAddress('glGetVertexAttribIiv');
    private z_GetVertexAttribIiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: Int32)>(z_GetVertexAttribIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIiv(index: UInt32; pname: VertexAttribEnum; var &params: Int32) :=
    z_GetVertexAttribIiv_ovr_0(index, pname, &params);
    private z_GetVertexAttribIiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIiv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIiv_ovr_1(index, pname, &params);
    
    // added in gl3.0
    private z_GetVertexAttribIuiv_adr := GetProcAddress('glGetVertexAttribIuiv');
    private z_GetVertexAttribIuiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: UInt32)>(z_GetVertexAttribIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuiv(index: UInt32; pname: VertexAttribEnum; var &params: UInt32) :=
    z_GetVertexAttribIuiv_ovr_0(index, pname, &params);
    private z_GetVertexAttribIuiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuiv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIuiv_ovr_1(index, pname, &params);
    
    // added in gl2.0
    private z_GetVertexAttribiv_adr := GetProcAddress('glGetVertexAttribiv');
    private z_GetVertexAttribiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32)>(z_GetVertexAttribiv_adr);
    private z_GetVertexAttribiv_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribiv(index: UInt32; pname: VertexAttribPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribiv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribiv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribiv(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32) :=
    z_GetVertexAttribiv_ovr_0(index, pname, &params);
    private z_GetVertexAttribiv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribiv(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribiv_ovr_2(index, pname, &params);
    
    // added in gl4.1
    private z_GetVertexAttribLdv_adr := GetProcAddress('glGetVertexAttribLdv');
    private z_GetVertexAttribLdv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: real)>(z_GetVertexAttribLdv_adr);
    private z_GetVertexAttribLdv_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLdv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLdv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; var &params: real) :=
    z_GetVertexAttribLdv_ovr_0(index, pname, &params);
    private z_GetVertexAttribLdv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLdv_ovr_2(index, pname, &params);
    
    // added in gl2.0
    private z_GetVertexAttribPointerv_adr := GetProcAddress('glGetVertexAttribPointerv');
    private z_GetVertexAttribPointerv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr)>(z_GetVertexAttribPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointerv(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr) :=
    z_GetVertexAttribPointerv_ovr_0(index, pname, _pointer);
    private z_GetVertexAttribPointerv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer)>(z_GetVertexAttribPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointerv(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer) :=
    z_GetVertexAttribPointerv_ovr_1(index, pname, _pointer);
    
    // added in gl1.0
    private z_Hint_adr := GetProcAddress('glHint');
    private z_Hint_ovr_0 := GetProcOrNil&<procedure(target: HintTarget; mode: HintMode)>(z_Hint_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Hint(target: HintTarget; mode: HintMode) :=
    z_Hint_ovr_0(target, mode);
    
    // added in gl4.3
    private z_InvalidateBufferData_adr := GetProcAddress('glInvalidateBufferData');
    private z_InvalidateBufferData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer)>(z_InvalidateBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferData(buffer: gl_buffer) :=
    z_InvalidateBufferData_ovr_0(buffer);
    
    // added in gl4.3
    private z_InvalidateBufferSubData_adr := GetProcAddress('glInvalidateBufferSubData');
    private z_InvalidateBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; length: IntPtr)>(z_InvalidateBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferSubData(buffer: gl_buffer; offset: IntPtr; length: IntPtr) :=
    z_InvalidateBufferSubData_ovr_0(buffer, offset, length);
    
    // added in gl4.3
    private z_InvalidateFramebuffer_adr := GetProcAddress('glInvalidateFramebuffer');
    private z_InvalidateFramebuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment)>(z_InvalidateFramebuffer_adr);
    private z_InvalidateFramebuffer_ovr_0_anh0001 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments[0]) else
      z_InvalidateFramebuffer_ovr_0_anh0001(target, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment) :=
    z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments);
    private z_InvalidateFramebuffer_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateFramebuffer_ovr_2(target, numAttachments, attachments);
    
    // added in gl4.5
    private z_InvalidateNamedFramebufferData_adr := GetProcAddress('glInvalidateNamedFramebufferData');
    private z_InvalidateNamedFramebufferData_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment)>(z_InvalidateNamedFramebufferData_adr);
    private z_InvalidateNamedFramebufferData_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateNamedFramebufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: array of FramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments[0]) else
      z_InvalidateNamedFramebufferData_ovr_0_anh0001(framebuffer, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment) :=
    z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments);
    private z_InvalidateNamedFramebufferData_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateNamedFramebufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateNamedFramebufferData_ovr_2(framebuffer, numAttachments, attachments);
    
    // added in gl4.5
    private z_InvalidateNamedFramebufferSubData_adr := GetProcAddress('glInvalidateNamedFramebufferSubData');
    private z_InvalidateNamedFramebufferSubData_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    private z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: array of FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000(framebuffer, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments, x, y, width, height);
    private z_InvalidateNamedFramebufferSubData_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_2(framebuffer, numAttachments, attachments, x, y, width, height);
    
    // added in gl4.3
    private z_InvalidateSubFramebuffer_adr := GetProcAddress('glInvalidateSubFramebuffer');
    private z_InvalidateSubFramebuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    private z_InvalidateSubFramebuffer_ovr_0_anh00010000 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateSubFramebuffer_ovr_0_anh00010000(target, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments, x, y, width, height);
    private z_InvalidateSubFramebuffer_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_2(target, numAttachments, attachments, x, y, width, height);
    
    // added in gl4.3
    private z_InvalidateTexImage_adr := GetProcAddress('glInvalidateTexImage');
    private z_InvalidateTexImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32)>(z_InvalidateTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexImage(texture: gl_texture; level: Int32) :=
    z_InvalidateTexImage_ovr_0(texture, level);
    
    // added in gl4.3
    private z_InvalidateTexSubImage_adr := GetProcAddress('glInvalidateTexSubImage');
    private z_InvalidateTexSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32)>(z_InvalidateTexSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_InvalidateTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth);
    
    // added in gl1.5
    private z_IsBuffer_adr := GetProcAddress('glIsBuffer');
    private z_IsBuffer_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_IsBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsBuffer(buffer: gl_buffer): boolean :=
    z_IsBuffer_ovr_0(buffer);
    
    // added in gl1.0
    private z_IsEnabled_adr := GetProcAddress('glIsEnabled');
    private z_IsEnabled_ovr_0 := GetProcOrNil&<function(cap: EnableCap): boolean>(z_IsEnabled_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabled(cap: EnableCap): boolean :=
    z_IsEnabled_ovr_0(cap);
    
    // added in gl3.0
    private z_IsEnabledi_adr := GetProcAddress('glIsEnabledi');
    private z_IsEnabledi_ovr_0 := GetProcOrNil&<function(target: EnableCap; index: UInt32): boolean>(z_IsEnabledi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledi(target: EnableCap; index: UInt32): boolean :=
    z_IsEnabledi_ovr_0(target, index);
    
    // added in gl3.0
    private z_IsFramebuffer_adr := GetProcAddress('glIsFramebuffer');
    private z_IsFramebuffer_ovr_0 := GetProcOrNil&<function(framebuffer: gl_framebuffer): boolean>(z_IsFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFramebuffer(framebuffer: gl_framebuffer): boolean :=
    z_IsFramebuffer_ovr_0(framebuffer);
    
    // added in gl2.0
    private z_IsProgram_adr := GetProcAddress('glIsProgram');
    private z_IsProgram_ovr_0 := GetProcOrNil&<function(&program: gl_program): boolean>(z_IsProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgram(&program: gl_program): boolean :=
    z_IsProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_IsProgramPipeline_adr := GetProcAddress('glIsProgramPipeline');
    private z_IsProgramPipeline_ovr_0 := GetProcOrNil&<function(pipeline: gl_program_pipeline): boolean>(z_IsProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramPipeline(pipeline: gl_program_pipeline): boolean :=
    z_IsProgramPipeline_ovr_0(pipeline);
    
    // added in gl1.5
    private z_IsQuery_adr := GetProcAddress('glIsQuery');
    private z_IsQuery_ovr_0 := GetProcOrNil&<function(id: gl_query): boolean>(z_IsQuery_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsQuery(id: gl_query): boolean :=
    z_IsQuery_ovr_0(id);
    
    // added in gl3.0
    private z_IsRenderbuffer_adr := GetProcAddress('glIsRenderbuffer');
    private z_IsRenderbuffer_ovr_0 := GetProcOrNil&<function(renderbuffer: gl_renderbuffer): boolean>(z_IsRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsRenderbuffer(renderbuffer: gl_renderbuffer): boolean :=
    z_IsRenderbuffer_ovr_0(renderbuffer);
    
    // added in gl3.3
    private z_IsSampler_adr := GetProcAddress('glIsSampler');
    private z_IsSampler_ovr_0 := GetProcOrNil&<function(sampler: gl_sampler): boolean>(z_IsSampler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSampler(sampler: gl_sampler): boolean :=
    z_IsSampler_ovr_0(sampler);
    
    // added in gl2.0
    private z_IsShader_adr := GetProcAddress('glIsShader');
    private z_IsShader_ovr_0 := GetProcOrNil&<function(shader: gl_shader): boolean>(z_IsShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsShader(shader: gl_shader): boolean :=
    z_IsShader_ovr_0(shader);
    
    // added in gl3.2
    private z_IsSync_adr := GetProcAddress('glIsSync');
    private z_IsSync_ovr_0 := GetProcOrNil&<function(sync: gl_sync): boolean>(z_IsSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSync(sync: gl_sync): boolean :=
    z_IsSync_ovr_0(sync);
    
    // added in gl1.1
    private z_IsTexture_adr := GetProcAddress('glIsTexture');
    private z_IsTexture_ovr_0 := GetProcOrNil&<function(texture: gl_texture): boolean>(z_IsTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTexture(texture: gl_texture): boolean :=
    z_IsTexture_ovr_0(texture);
    
    // added in gl4.0
    private z_IsTransformFeedback_adr := GetProcAddress('glIsTransformFeedback');
    private z_IsTransformFeedback_ovr_0 := GetProcOrNil&<function(id: gl_transform_feedback): boolean>(z_IsTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTransformFeedback(id: gl_transform_feedback): boolean :=
    z_IsTransformFeedback_ovr_0(id);
    
    // added in gl3.0
    private z_IsVertexArray_adr := GetProcAddress('glIsVertexArray');
    private z_IsVertexArray_ovr_0 := GetProcOrNil&<function(&array: gl_vertex_array): boolean>(z_IsVertexArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexArray(&array: gl_vertex_array): boolean :=
    z_IsVertexArray_ovr_0(&array);
    
    // added in gl1.0
    private z_LineWidth_adr := GetProcAddress('glLineWidth');
    private z_LineWidth_ovr_0 := GetProcOrNil&<procedure(width: single)>(z_LineWidth_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LineWidth(width: single) :=
    z_LineWidth_ovr_0(width);
    
    // added in gl2.0
    private z_LinkProgram_adr := GetProcAddress('glLinkProgram');
    private z_LinkProgram_ovr_0 := GetProcOrNil&<procedure(&program: gl_program)>(z_LinkProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LinkProgram(&program: gl_program) :=
    z_LinkProgram_ovr_0(&program);
    
    // added in gl1.0
    private z_LogicOp_adr := GetProcAddress('glLogicOp');
    private z_LogicOp_ovr_0 := GetProcOrNil&<procedure(opcode: OpenGL.LogicOp)>(z_LogicOp_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LogicOp(opcode: OpenGL.LogicOp) :=
    z_LogicOp_ovr_0(opcode);
    
    // added in gl1.5
    private z_MapBuffer_adr := GetProcAddress('glMapBuffer');
    private z_MapBuffer_ovr_0 := GetProcOrNil&<function(target: BufferTarget; access: BufferAccessARB): IntPtr>(z_MapBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBuffer(target: BufferTarget; access: BufferAccessARB): IntPtr :=
    z_MapBuffer_ovr_0(target, access);
    
    // added in gl3.0
    private z_MapBufferRange_adr := GetProcAddress('glMapBufferRange');
    private z_MapBufferRange_ovr_0 := GetProcOrNil&<function(target: BufferTarget; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBufferRange(target: BufferTarget; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapBufferRange_ovr_0(target, offset, length, access);
    
    // added in gl4.5
    private z_MapNamedBuffer_adr := GetProcAddress('glMapNamedBuffer');
    private z_MapNamedBuffer_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer; access: BufferAccessARB): IntPtr>(z_MapNamedBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBuffer(buffer: gl_buffer; access: BufferAccessARB): IntPtr :=
    z_MapNamedBuffer_ovr_0(buffer, access);
    
    // added in gl4.5
    private z_MapNamedBufferRange_adr := GetProcAddress('glMapNamedBufferRange');
    private z_MapNamedBufferRange_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapNamedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferRange(buffer: gl_buffer; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapNamedBufferRange_ovr_0(buffer, offset, length, access);
    
    // added in gl4.2
    private z_MemoryBarrier_adr := GetProcAddress('glMemoryBarrier');
    private z_MemoryBarrier_ovr_0 := GetProcOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrier_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrier(barriers: MemoryBarrierMask) :=
    z_MemoryBarrier_ovr_0(barriers);
    
    // added in gl4.5
    private z_MemoryBarrierByRegion_adr := GetProcAddress('glMemoryBarrierByRegion');
    private z_MemoryBarrierByRegion_ovr_0 := GetProcOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrierByRegion_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrierByRegion(barriers: MemoryBarrierMask) :=
    z_MemoryBarrierByRegion_ovr_0(barriers);
    
    // added in gl4.0
    private z_MinSampleShading_adr := GetProcAddress('glMinSampleShading');
    private z_MinSampleShading_ovr_0 := GetProcOrNil&<procedure(value: single)>(z_MinSampleShading_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MinSampleShading(value: single) :=
    z_MinSampleShading_ovr_0(value);
    
    // added in gl1.4
    private z_MultiDrawArrays_adr := GetProcAddress('glMultiDrawArrays');
    private z_MultiDrawArrays_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_0_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_0_anh00010 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_0_anh00110 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: array of Int32; count: array of Int32; drawcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArrays_ovr_0(mode, first[0], count[0], drawcount) else
        z_MultiDrawArrays_ovr_0_anh00010(mode, first[0], IntPtr.Zero, drawcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArrays_ovr_0_anh00100(mode, IntPtr.Zero, count[0], drawcount) else
        z_MultiDrawArrays_ovr_0_anh00110(mode, IntPtr.Zero, IntPtr.Zero, drawcount);
    private z_MultiDrawArrays_ovr_1_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: array of Int32; var count: Int32; drawcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArrays_ovr_0(mode, first[0], count, drawcount) else
      z_MultiDrawArrays_ovr_0_anh00100(mode, IntPtr.Zero, count, drawcount);
    private z_MultiDrawArrays_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_2_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: array of Int32; count: IntPtr; drawcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArrays_ovr_2(mode, first[0], count, drawcount) else
      z_MultiDrawArrays_ovr_2_anh00100(mode, IntPtr.Zero, count, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; var first: Int32; count: array of Int32; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArrays_ovr_0(mode, first, count[0], drawcount) else
      z_MultiDrawArrays_ovr_0_anh00010(mode, first, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; var first: Int32; var count: Int32; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_0(mode, first, count, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; var first: Int32; count: IntPtr; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_2(mode, first, count, drawcount);
    private z_MultiDrawArrays_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_6_anh00010 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: IntPtr; count: array of Int32; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArrays_ovr_6(mode, first, count[0], drawcount) else
      z_MultiDrawArrays_ovr_6_anh00010(mode, first, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_6(mode, first, count, drawcount);
    private z_MultiDrawArrays_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_8(mode, first, count, drawcount);
    
    // added in gl4.3
    private z_MultiDrawArraysIndirect_adr := GetProcAddress('glMultiDrawArraysIndirect');
    private z_MultiDrawArraysIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirect_ovr_0(mode, indirect, drawcount, stride);
    
    // added in gl4.6
    private z_MultiDrawArraysIndirectCount_adr := GetProcAddress('glMultiDrawArraysIndirectCount');
    private z_MultiDrawArraysIndirectCount_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirectCount_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectCount(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirectCount_ovr_0(mode, indirect, drawcount, maxdrawcount, stride);
    
    // added in gl1.4
    private z_MultiDrawElements_adr := GetProcAddress('glMultiDrawElements');
    private z_MultiDrawElements_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_0_anh001000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_0_anh000010 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_0_anh001010 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElements_ovr_0(mode, count[0], &type, indices[0], drawcount) else
        z_MultiDrawElements_ovr_0_anh000010(mode, count[0], &type, IntPtr.Zero, drawcount) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElements_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices[0], drawcount) else
        z_MultiDrawElements_ovr_0_anh001010(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount);
    private z_MultiDrawElements_ovr_1_anh001000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElements_ovr_0(mode, count[0], &type, indices, drawcount) else
      z_MultiDrawElements_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_2_anh001000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElements_ovr_2(mode, count[0], &type, indices, drawcount) else
      z_MultiDrawElements_ovr_2_anh001000(mode, IntPtr.Zero, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_3_anh000010 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElements_ovr_0(mode, count, &type, indices[0], drawcount) else
      z_MultiDrawElements_ovr_0_anh000010(mode, count, &type, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32) :=
    z_MultiDrawElements_ovr_0(mode, count, &type, indices, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32) :=
    z_MultiDrawElements_ovr_2(mode, count, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_6_anh000010 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElements_ovr_6(mode, count, &type, indices[0], drawcount) else
      z_MultiDrawElements_ovr_6_anh000010(mode, count, &type, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32) :=
    z_MultiDrawElements_ovr_6(mode, count, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32) :=
    z_MultiDrawElements_ovr_8(mode, count, &type, indices, drawcount);
    
    // added in gl3.2
    private z_MultiDrawElementsBaseVertex_adr := GetProcAddress('glMultiDrawElementsBaseVertex');
    private z_MultiDrawElementsBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000101 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010101 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count[0], &type, IntPtr.Zero, drawcount, IntPtr.Zero) else
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010101(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0010100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0010100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_3_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_3_anh0010001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_4_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_5_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0010001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_7_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_8_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_8(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_8_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_9_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_9_anh0000101 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_10_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_11_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_8(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_18 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000101 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_19_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_20 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_20_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_20_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_24 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_24_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_24_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_26 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_26(mode, count, &type, indices, drawcount, basevertex);
    
    // added in gl4.3
    private z_MultiDrawElementsIndirect_adr := GetProcAddress('glMultiDrawElementsIndirect');
    private z_MultiDrawElementsIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirect_ovr_0(mode, &type, indirect, drawcount, stride);
    
    // added in gl4.6
    private z_MultiDrawElementsIndirectCount_adr := GetProcAddress('glMultiDrawElementsIndirectCount');
    private z_MultiDrawElementsIndirectCount_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirectCount_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectCount(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirectCount_ovr_0(mode, &type, indirect, drawcount, maxdrawcount, stride);
    
    // added in gl3.3
    private z_MultiTexCoordP1ui_adr := GetProcAddress('glMultiTexCoordP1ui');
    private z_MultiTexCoordP1ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP1ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP1uiv_adr := GetProcAddress('glMultiTexCoordP1uiv');
    private z_MultiTexCoordP1uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP1uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP1uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP1uiv_ovr_1(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP2ui_adr := GetProcAddress('glMultiTexCoordP2ui');
    private z_MultiTexCoordP2ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP2ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP2uiv_adr := GetProcAddress('glMultiTexCoordP2uiv');
    private z_MultiTexCoordP2uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP2uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP2uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP2uiv_ovr_1(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP3ui_adr := GetProcAddress('glMultiTexCoordP3ui');
    private z_MultiTexCoordP3ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP3ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP3uiv_adr := GetProcAddress('glMultiTexCoordP3uiv');
    private z_MultiTexCoordP3uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP3uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP3uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP3uiv_ovr_1(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP4ui_adr := GetProcAddress('glMultiTexCoordP4ui');
    private z_MultiTexCoordP4ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP4ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP4uiv_adr := GetProcAddress('glMultiTexCoordP4uiv');
    private z_MultiTexCoordP4uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP4uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP4uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP4uiv_ovr_1(texture, &type, coords);
    
    // added in gl4.5
    private z_NamedBufferData_adr := GetProcAddress('glNamedBufferData');
    private z_NamedBufferData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; var data: Byte; usage: VertexBufferObjectUsage)>(z_NamedBufferData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferData_ovr_0<T>(buffer: gl_buffer; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferData_ovr_0_anh00010(buffer: gl_buffer; size: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_0(buffer, size, PByte(nil)^, usage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: gl_buffer; size: IntPtr; data: array of T; usage: VertexBufferObjectUsage); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_NamedBufferData_ovr_0(buffer, size, data[0], usage) else
        temp_NamedBufferData_ovr_0_anh00010(buffer, size, usage);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: gl_buffer; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private z_NamedBufferData_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage)>(z_NamedBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData(buffer: gl_buffer; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_2(buffer, size, data, usage);
    
    // added in gl4.5
    private z_NamedBufferStorage_adr := GetProcAddress('glNamedBufferStorage');
    private z_NamedBufferStorage_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_NamedBufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorage(buffer: gl_buffer; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_NamedBufferStorage_ovr_0(buffer, size, data, flags);
    
    // added in gl4.5
    private z_NamedBufferSubData_adr := GetProcAddress('glNamedBufferSubData');
    private z_NamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: Byte)>(z_NamedBufferSubData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferSubData_ovr_0<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_NamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferSubData_ovr_0_anh00001(buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_NamedBufferSubData_ovr_0(buffer, offset, size, PByte(nil)^);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: array of T); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_NamedBufferSubData_ovr_0(buffer, offset, size, data[0]) else
        temp_NamedBufferSubData_ovr_0_anh00001(buffer, offset, size);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_NamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private z_NamedBufferSubData_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_NamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_NamedBufferSubData_ovr_2(buffer, offset, size, data);
    
    // added in gl4.5
    private z_NamedFramebufferDrawBuffer_adr := GetProcAddress('glNamedFramebufferDrawBuffer');
    private z_NamedFramebufferDrawBuffer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; buf: ColorBuffer)>(z_NamedFramebufferDrawBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffer(framebuffer: gl_framebuffer; buf: ColorBuffer) :=
    z_NamedFramebufferDrawBuffer_ovr_0(framebuffer, buf);
    
    // added in gl4.5
    private z_NamedFramebufferDrawBuffers_adr := GetProcAddress('glNamedFramebufferDrawBuffers');
    private z_NamedFramebufferDrawBuffers_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; var bufs: ColorBuffer)>(z_NamedFramebufferDrawBuffers_adr);
    private z_NamedFramebufferDrawBuffers_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr)>(z_NamedFramebufferDrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: gl_framebuffer; n: Int32; bufs: array of ColorBuffer) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs[0]) else
      z_NamedFramebufferDrawBuffers_ovr_0_anh0001(framebuffer, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: gl_framebuffer; n: Int32; var bufs: ColorBuffer) :=
    z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs);
    private z_NamedFramebufferDrawBuffers_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr)>(z_NamedFramebufferDrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr) :=
    z_NamedFramebufferDrawBuffers_ovr_2(framebuffer, n, bufs);
    
    // added in gl4.5
    private z_NamedFramebufferParameteri_adr := GetProcAddress('glNamedFramebufferParameteri');
    private z_NamedFramebufferParameteri_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: FramebufferParameterName; param: Int32)>(z_NamedFramebufferParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferParameteri(framebuffer: gl_framebuffer; pname: FramebufferParameterName; param: Int32) :=
    z_NamedFramebufferParameteri_ovr_0(framebuffer, pname, param);
    
    // added in gl4.5
    private z_NamedFramebufferReadBuffer_adr := GetProcAddress('glNamedFramebufferReadBuffer');
    private z_NamedFramebufferReadBuffer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; src: ColorBuffer)>(z_NamedFramebufferReadBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferReadBuffer(framebuffer: gl_framebuffer; src: ColorBuffer) :=
    z_NamedFramebufferReadBuffer_ovr_0(framebuffer, src);
    
    // added in gl4.5
    private z_NamedFramebufferRenderbuffer_adr := GetProcAddress('glNamedFramebufferRenderbuffer');
    private z_NamedFramebufferRenderbuffer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_NamedFramebufferRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferRenderbuffer(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_NamedFramebufferRenderbuffer_ovr_0(framebuffer, attachment, _renderbuffertarget, renderbuffer);
    
    // added in gl4.5
    private z_NamedFramebufferTexture_adr := GetProcAddress('glNamedFramebufferTexture');
    private z_NamedFramebufferTexture_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32)>(z_NamedFramebufferTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32) :=
    z_NamedFramebufferTexture_ovr_0(framebuffer, attachment, texture, level);
    
    // added in gl4.5
    private z_NamedFramebufferTextureLayer_adr := GetProcAddress('glNamedFramebufferTextureLayer');
    private z_NamedFramebufferTextureLayer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_NamedFramebufferTextureLayer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureLayer(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_NamedFramebufferTextureLayer_ovr_0(framebuffer, attachment, texture, level, layer);
    
    // added in gl4.5
    private z_NamedRenderbufferStorage_adr := GetProcAddress('glNamedRenderbufferStorage');
    private z_NamedRenderbufferStorage_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorage(renderbuffer: gl_renderbuffer; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorage_ovr_0(renderbuffer, _internalformat, width, height);
    
    // added in gl4.5
    private z_NamedRenderbufferStorageMultisample_adr := GetProcAddress('glNamedRenderbufferStorageMultisample');
    private z_NamedRenderbufferStorageMultisample_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisample(renderbuffer: gl_renderbuffer; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisample_ovr_0(renderbuffer, samples, _internalformat, width, height);
    
    // added in gl3.3
    private z_NormalP3ui_adr := GetProcAddress('glNormalP3ui');
    private z_NormalP3ui_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; coords: UInt32)>(z_NormalP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3ui(&type: NormalPointerType; coords: UInt32) :=
    z_NormalP3ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_NormalP3uiv_adr := GetProcAddress('glNormalP3uiv');
    private z_NormalP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; var coords: UInt32)>(z_NormalP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; var coords: UInt32) :=
    z_NormalP3uiv_ovr_0(&type, coords);
    private z_NormalP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: NormalPointerType; coords: IntPtr)>(z_NormalP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; coords: IntPtr) :=
    z_NormalP3uiv_ovr_1(&type, coords);
    
    // added in gl4.3
    private z_ObjectLabel_adr := GetProcAddress('glObjectLabel');
    private z_ObjectLabel_ovr_0 := GetProcOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr)>(z_ObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(&label);
        z_ObjectLabel_ovr_0(identifier, name, length, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr) :=
    z_ObjectLabel_ovr_0(identifier, name, length, &label);
    
    // added in gl4.3
    private z_ObjectPtrLabel_adr := GetProcAddress('glObjectPtrLabel');
    private z_ObjectPtrLabel_ovr_0 := GetProcOrNil&<procedure(ptr: IntPtr; length: Int32; &label: IntPtr)>(z_ObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: string);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(&label);
        z_ObjectPtrLabel_ovr_0(ptr, length, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: IntPtr) :=
    z_ObjectPtrLabel_ovr_0(ptr, length, &label);
    
    // added in gl4.0
    private z_PatchParameterfv_adr := GetProcAddress('glPatchParameterfv');
    private z_PatchParameterfv_ovr_0 := GetProcOrNil&<procedure(pname: PatchParameterName; var values: single)>(z_PatchParameterfv_adr);
    private z_PatchParameterfv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PatchParameterName; values: IntPtr)>(z_PatchParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_PatchParameterfv_ovr_0(pname, values[0]) else
      z_PatchParameterfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; var values: single) :=
    z_PatchParameterfv_ovr_0(pname, values);
    private z_PatchParameterfv_ovr_2 := GetProcOrNil&<procedure(pname: PatchParameterName; values: IntPtr)>(z_PatchParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: IntPtr) :=
    z_PatchParameterfv_ovr_2(pname, values);
    
    // added in gl4.0
    private z_PatchParameteri_adr := GetProcAddress('glPatchParameteri');
    private z_PatchParameteri_ovr_0 := GetProcOrNil&<procedure(pname: PatchParameterName; value: Int32)>(z_PatchParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameteri(pname: PatchParameterName; value: Int32) :=
    z_PatchParameteri_ovr_0(pname, value);
    
    // added in gl4.0
    private z_PauseTransformFeedback_adr := GetProcAddress('glPauseTransformFeedback');
    private z_PauseTransformFeedback_ovr_0 := GetProcOrNil&<procedure>(z_PauseTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PauseTransformFeedback :=
    z_PauseTransformFeedback_ovr_0;
    
    // added in gl1.0
    private z_PixelStoref_adr := GetProcAddress('glPixelStoref');
    private z_PixelStoref_ovr_0 := GetProcOrNil&<procedure(pname: PixelStoreParameter; param: single)>(z_PixelStoref_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelStoref(pname: PixelStoreParameter; param: single) :=
    z_PixelStoref_ovr_0(pname, param);
    
    // added in gl1.0
    private z_PixelStorei_adr := GetProcAddress('glPixelStorei');
    private z_PixelStorei_ovr_0 := GetProcOrNil&<procedure(pname: PixelStoreParameter; param: Int32)>(z_PixelStorei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelStorei(pname: PixelStoreParameter; param: Int32) :=
    z_PixelStorei_ovr_0(pname, param);
    
    // added in gl1.4
    private z_PointParameterf_adr := GetProcAddress('glPointParameterf');
    private z_PointParameterf_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; param: single)>(z_PointParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterf(pname: PointParameterNameARB; param: single) :=
    z_PointParameterf_ovr_0(pname, param);
    
    // added in gl1.4
    private z_PointParameterfv_adr := GetProcAddress('glPointParameterfv');
    private z_PointParameterfv_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: single)>(z_PointParameterfv_adr);
    private z_PointParameterfv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfv(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfv_ovr_0(pname, &params[0]) else
      z_PointParameterfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfv(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfv_ovr_0(pname, &params);
    private z_PointParameterfv_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfv(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfv_ovr_2(pname, &params);
    
    // added in gl1.4
    private z_PointParameteri_adr := GetProcAddress('glPointParameteri');
    private z_PointParameteri_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; param: Int32)>(z_PointParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteri(pname: PointParameterNameARB; param: Int32) :=
    z_PointParameteri_ovr_0(pname, param);
    
    // added in gl1.4
    private z_PointParameteriv_adr := GetProcAddress('glPointParameteriv');
    private z_PointParameteriv_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: Int32)>(z_PointParameteriv_adr);
    private z_PointParameteriv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriv(pname: PointParameterNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameteriv_ovr_0(pname, &params[0]) else
      z_PointParameteriv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriv(pname: PointParameterNameARB; var &params: Int32) :=
    z_PointParameteriv_ovr_0(pname, &params);
    private z_PointParameteriv_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriv(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameteriv_ovr_2(pname, &params);
    
    // added in gl1.0
    private z_PointSize_adr := GetProcAddress('glPointSize');
    private z_PointSize_ovr_0 := GetProcOrNil&<procedure(size: single)>(z_PointSize_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointSize(size: single) :=
    z_PointSize_ovr_0(size);
    
    // added in gl1.0
    private z_PolygonMode_adr := GetProcAddress('glPolygonMode');
    private z_PolygonMode_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; mode: OpenGL.PolygonMode)>(z_PolygonMode_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonMode(face: MaterialFace; mode: OpenGL.PolygonMode) :=
    z_PolygonMode_ovr_0(face, mode);
    
    // added in gl1.1
    private z_PolygonOffset_adr := GetProcAddress('glPolygonOffset');
    private z_PolygonOffset_ovr_0 := GetProcOrNil&<procedure(factor: single; units: single)>(z_PolygonOffset_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffset(factor: single; units: single) :=
    z_PolygonOffset_ovr_0(factor, units);
    
    // added in gl4.6
    private z_PolygonOffsetClamp_adr := GetProcAddress('glPolygonOffsetClamp');
    private z_PolygonOffsetClamp_ovr_0 := GetProcOrNil&<procedure(factor: single; units: single; clamp: single)>(z_PolygonOffsetClamp_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetClamp(factor: single; units: single; clamp: single) :=
    z_PolygonOffsetClamp_ovr_0(factor, units, clamp);
    
    // added in gl4.3
    private z_PopDebugGroup_adr := GetProcAddress('glPopDebugGroup');
    private z_PopDebugGroup_ovr_0 := GetProcOrNil&<procedure>(z_PopDebugGroup_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopDebugGroup :=
    z_PopDebugGroup_ovr_0;
    
    // added in gl3.1
    private z_PrimitiveRestartIndex_adr := GetProcAddress('glPrimitiveRestartIndex');
    private z_PrimitiveRestartIndex_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_PrimitiveRestartIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveRestartIndex(index: UInt32) :=
    z_PrimitiveRestartIndex_ovr_0(index);
    
    // added in gl4.1
    private z_ProgramBinary_adr := GetProcAddress('glProgramBinary');
    private z_ProgramBinary_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; binaryFormat: DummyEnum; binary: IntPtr; length: Int32)>(z_ProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBinary(&program: gl_program; binaryFormat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ProgramBinary_ovr_0(&program, binaryFormat, binary, length);
    
    // added in gl4.1
    private z_ProgramParameteri_adr := GetProcAddress('glProgramParameteri');
    private z_ProgramParameteri_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramParameterPName; value: Int32)>(z_ProgramParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteri(&program: gl_program; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteri_ovr_0(&program, pname, value);
    
    // added in gl4.1
    private z_ProgramUniform1d_adr := GetProcAddress('glProgramUniform1d');
    private z_ProgramUniform1d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real)>(z_ProgramUniform1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1d(&program: gl_program; location: Int32; v0: real) :=
    z_ProgramUniform1d_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1dv_adr := GetProcAddress('glProgramUniform1dv');
    private z_ProgramUniform1dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform1dv_adr);
    private z_ProgramUniform1dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform1dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform1f_adr := GetProcAddress('glProgramUniform1f');
    private z_ProgramUniform1f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single)>(z_ProgramUniform1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1f(&program: gl_program; location: Int32; v0: single) :=
    z_ProgramUniform1f_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1fv_adr := GetProcAddress('glProgramUniform1fv');
    private z_ProgramUniform1fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform1fv_adr);
    private z_ProgramUniform1fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform1fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform1i_adr := GetProcAddress('glProgramUniform1i');
    private z_ProgramUniform1i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32)>(z_ProgramUniform1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i(&program: gl_program; location: Int32; v0: Int32) :=
    z_ProgramUniform1i_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1iv_adr := GetProcAddress('glProgramUniform1iv');
    private z_ProgramUniform1iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform1iv_adr);
    private z_ProgramUniform1iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform1iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform1ui_adr := GetProcAddress('glProgramUniform1ui');
    private z_ProgramUniform1ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32)>(z_ProgramUniform1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui(&program: gl_program; location: Int32; v0: UInt32) :=
    z_ProgramUniform1ui_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1uiv_adr := GetProcAddress('glProgramUniform1uiv');
    private z_ProgramUniform1uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform1uiv_adr);
    private z_ProgramUniform1uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform1uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2d_adr := GetProcAddress('glProgramUniform2d');
    private z_ProgramUniform2d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real; v1: real)>(z_ProgramUniform2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2d(&program: gl_program; location: Int32; v0: real; v1: real) :=
    z_ProgramUniform2d_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2dv_adr := GetProcAddress('glProgramUniform2dv');
    private z_ProgramUniform2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform2dv_adr);
    private z_ProgramUniform2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform2dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2f_adr := GetProcAddress('glProgramUniform2f');
    private z_ProgramUniform2f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single)>(z_ProgramUniform2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2f(&program: gl_program; location: Int32; v0: single; v1: single) :=
    z_ProgramUniform2f_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2fv_adr := GetProcAddress('glProgramUniform2fv');
    private z_ProgramUniform2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform2fv_adr);
    private z_ProgramUniform2fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform2fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2i_adr := GetProcAddress('glProgramUniform2i');
    private z_ProgramUniform2i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32)>(z_ProgramUniform2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i(&program: gl_program; location: Int32; v0: Int32; v1: Int32) :=
    z_ProgramUniform2i_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2iv_adr := GetProcAddress('glProgramUniform2iv');
    private z_ProgramUniform2iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform2iv_adr);
    private z_ProgramUniform2iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform2iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2ui_adr := GetProcAddress('glProgramUniform2ui');
    private z_ProgramUniform2ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32)>(z_ProgramUniform2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32) :=
    z_ProgramUniform2ui_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2uiv_adr := GetProcAddress('glProgramUniform2uiv');
    private z_ProgramUniform2uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform2uiv_adr);
    private z_ProgramUniform2uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform2uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3d_adr := GetProcAddress('glProgramUniform3d');
    private z_ProgramUniform3d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real; v1: real; v2: real)>(z_ProgramUniform3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3d(&program: gl_program; location: Int32; v0: real; v1: real; v2: real) :=
    z_ProgramUniform3d_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3dv_adr := GetProcAddress('glProgramUniform3dv');
    private z_ProgramUniform3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform3dv_adr);
    private z_ProgramUniform3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform3dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3f_adr := GetProcAddress('glProgramUniform3f');
    private z_ProgramUniform3f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single; v2: single)>(z_ProgramUniform3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3f(&program: gl_program; location: Int32; v0: single; v1: single; v2: single) :=
    z_ProgramUniform3f_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3fv_adr := GetProcAddress('glProgramUniform3fv');
    private z_ProgramUniform3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform3fv_adr);
    private z_ProgramUniform3fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform3fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3i_adr := GetProcAddress('glProgramUniform3i');
    private z_ProgramUniform3i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_ProgramUniform3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_ProgramUniform3i_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3iv_adr := GetProcAddress('glProgramUniform3iv');
    private z_ProgramUniform3iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform3iv_adr);
    private z_ProgramUniform3iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform3iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3ui_adr := GetProcAddress('glProgramUniform3ui');
    private z_ProgramUniform3ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_ProgramUniform3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_ProgramUniform3ui_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3uiv_adr := GetProcAddress('glProgramUniform3uiv');
    private z_ProgramUniform3uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform3uiv_adr);
    private z_ProgramUniform3uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform3uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4d_adr := GetProcAddress('glProgramUniform4d');
    private z_ProgramUniform4d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real; v1: real; v2: real; v3: real)>(z_ProgramUniform4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4d(&program: gl_program; location: Int32; v0: real; v1: real; v2: real; v3: real) :=
    z_ProgramUniform4d_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4dv_adr := GetProcAddress('glProgramUniform4dv');
    private z_ProgramUniform4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform4dv_adr);
    private z_ProgramUniform4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform4dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4f_adr := GetProcAddress('glProgramUniform4f');
    private z_ProgramUniform4f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_ProgramUniform4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4f(&program: gl_program; location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_ProgramUniform4f_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4fv_adr := GetProcAddress('glProgramUniform4fv');
    private z_ProgramUniform4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform4fv_adr);
    private z_ProgramUniform4fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform4fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4i_adr := GetProcAddress('glProgramUniform4i');
    private z_ProgramUniform4i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_ProgramUniform4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_ProgramUniform4i_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4iv_adr := GetProcAddress('glProgramUniform4iv');
    private z_ProgramUniform4iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform4iv_adr);
    private z_ProgramUniform4iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform4iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4ui_adr := GetProcAddress('glProgramUniform4ui');
    private z_ProgramUniform4ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_ProgramUniform4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_ProgramUniform4ui_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4uiv_adr := GetProcAddress('glProgramUniform4uiv');
    private z_ProgramUniform4uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform4uiv_adr);
    private z_ProgramUniform4uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform4uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2dv_adr := GetProcAddress('glProgramUniformMatrix2dv');
    private z_ProgramUniformMatrix2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2dv_adr);
    private z_ProgramUniformMatrix2dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2fv_adr := GetProcAddress('glProgramUniformMatrix2fv');
    private z_ProgramUniformMatrix2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2fv_adr);
    private z_ProgramUniformMatrix2fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x3dv_adr := GetProcAddress('glProgramUniformMatrix2x3dv');
    private z_ProgramUniformMatrix2x3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x3dv_adr);
    private z_ProgramUniformMatrix2x3dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x3fv_adr := GetProcAddress('glProgramUniformMatrix2x3fv');
    private z_ProgramUniformMatrix2x3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x3fv_adr);
    private z_ProgramUniformMatrix2x3fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x4dv_adr := GetProcAddress('glProgramUniformMatrix2x4dv');
    private z_ProgramUniformMatrix2x4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x4dv_adr);
    private z_ProgramUniformMatrix2x4dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x4fv_adr := GetProcAddress('glProgramUniformMatrix2x4fv');
    private z_ProgramUniformMatrix2x4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x4fv_adr);
    private z_ProgramUniformMatrix2x4fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3dv_adr := GetProcAddress('glProgramUniformMatrix3dv');
    private z_ProgramUniformMatrix3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3dv_adr);
    private z_ProgramUniformMatrix3dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3fv_adr := GetProcAddress('glProgramUniformMatrix3fv');
    private z_ProgramUniformMatrix3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3fv_adr);
    private z_ProgramUniformMatrix3fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x2dv_adr := GetProcAddress('glProgramUniformMatrix3x2dv');
    private z_ProgramUniformMatrix3x2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x2dv_adr);
    private z_ProgramUniformMatrix3x2dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x2fv_adr := GetProcAddress('glProgramUniformMatrix3x2fv');
    private z_ProgramUniformMatrix3x2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x2fv_adr);
    private z_ProgramUniformMatrix3x2fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x4dv_adr := GetProcAddress('glProgramUniformMatrix3x4dv');
    private z_ProgramUniformMatrix3x4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x4dv_adr);
    private z_ProgramUniformMatrix3x4dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x4fv_adr := GetProcAddress('glProgramUniformMatrix3x4fv');
    private z_ProgramUniformMatrix3x4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x4fv_adr);
    private z_ProgramUniformMatrix3x4fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4dv_adr := GetProcAddress('glProgramUniformMatrix4dv');
    private z_ProgramUniformMatrix4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4dv_adr);
    private z_ProgramUniformMatrix4dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4fv_adr := GetProcAddress('glProgramUniformMatrix4fv');
    private z_ProgramUniformMatrix4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4fv_adr);
    private z_ProgramUniformMatrix4fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x2dv_adr := GetProcAddress('glProgramUniformMatrix4x2dv');
    private z_ProgramUniformMatrix4x2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x2dv_adr);
    private z_ProgramUniformMatrix4x2dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x2fv_adr := GetProcAddress('glProgramUniformMatrix4x2fv');
    private z_ProgramUniformMatrix4x2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x2fv_adr);
    private z_ProgramUniformMatrix4x2fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x3dv_adr := GetProcAddress('glProgramUniformMatrix4x3dv');
    private z_ProgramUniformMatrix4x3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x3dv_adr);
    private z_ProgramUniformMatrix4x3dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x3fv_adr := GetProcAddress('glProgramUniformMatrix4x3fv');
    private z_ProgramUniformMatrix4x3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x3fv_adr);
    private z_ProgramUniformMatrix4x3fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl3.2
    private z_ProvokingVertex_adr := GetProcAddress('glProvokingVertex');
    private z_ProvokingVertex_ovr_0 := GetProcOrNil&<procedure(mode: VertexProvokingMode)>(z_ProvokingVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProvokingVertex(mode: VertexProvokingMode) :=
    z_ProvokingVertex_ovr_0(mode);
    
    // added in gl4.3
    private z_PushDebugGroup_adr := GetProcAddress('glPushDebugGroup');
    private z_PushDebugGroup_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; id: UInt32; length: Int32; message: IntPtr)>(z_PushDebugGroup_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(message);
        z_PushDebugGroup_ovr_0(source, id, length, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: IntPtr) :=
    z_PushDebugGroup_ovr_0(source, id, length, message);
    
    // added in gl3.3
    private z_QueryCounter_adr := GetProcAddress('glQueryCounter');
    private z_QueryCounter_ovr_0 := GetProcOrNil&<procedure(id: gl_query; target: QueryCounterTarget)>(z_QueryCounter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryCounter(id: gl_query; target: QueryCounterTarget) :=
    z_QueryCounter_ovr_0(id, target);
    
    // added in gl1.0
    private z_ReadBuffer_adr := GetProcAddress('glReadBuffer');
    private z_ReadBuffer_ovr_0 := GetProcOrNil&<procedure(src: ReadBufferMode)>(z_ReadBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadBuffer(src: ReadBufferMode) :=
    z_ReadBuffer_ovr_0(src);
    
    // added in gl4.5
    private z_ReadnPixels_adr := GetProcAddress('glReadnPixels');
    private z_ReadnPixels_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr)>(z_ReadnPixels_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadnPixels(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr) :=
    z_ReadnPixels_ovr_0(x, y, width, height, format, &type, bufSize, data);
    
    // added in gl1.0
    private z_ReadPixels_adr := GetProcAddress('glReadPixels');
    private z_ReadPixels_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_ReadPixels_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadPixels(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_ReadPixels_ovr_0(x, y, width, height, format, &type, pixels);
    
    // added in gl4.1
    private z_ReleaseShaderCompiler_adr := GetProcAddress('glReleaseShaderCompiler');
    private z_ReleaseShaderCompiler_ovr_0 := GetProcOrNil&<procedure>(z_ReleaseShaderCompiler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReleaseShaderCompiler :=
    z_ReleaseShaderCompiler_ovr_0;
    
    // added in gl3.0
    private z_RenderbufferStorage_adr := GetProcAddress('glRenderbufferStorage');
    private z_RenderbufferStorage_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorage(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorage_ovr_0(target, _internalformat, width, height);
    
    // added in gl3.0
    private z_RenderbufferStorageMultisample_adr := GetProcAddress('glRenderbufferStorageMultisample');
    private z_RenderbufferStorageMultisample_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisample(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisample_ovr_0(target, samples, _internalformat, width, height);
    
    // added in gl4.0
    private z_ResumeTransformFeedback_adr := GetProcAddress('glResumeTransformFeedback');
    private z_ResumeTransformFeedback_ovr_0 := GetProcOrNil&<procedure>(z_ResumeTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResumeTransformFeedback :=
    z_ResumeTransformFeedback_ovr_0;
    
    // added in gl1.3
    private z_SampleCoverage_adr := GetProcAddress('glSampleCoverage');
    private z_SampleCoverage_ovr_0 := GetProcOrNil&<procedure(value: single; invert: boolean)>(z_SampleCoverage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleCoverage(value: single; invert: boolean) :=
    z_SampleCoverage_ovr_0(value, invert);
    
    // added in gl3.2
    private z_SampleMaski_adr := GetProcAddress('glSampleMaski');
    private z_SampleMaski_ovr_0 := GetProcOrNil&<procedure(maskNumber: UInt32; mask: DummyFlags)>(z_SampleMaski_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaski(maskNumber: UInt32; mask: DummyFlags) :=
    z_SampleMaski_ovr_0(maskNumber, mask);
    
    // added in gl3.3
    private z_SamplerParameterf_adr := GetProcAddress('glSamplerParameterf');
    private z_SamplerParameterf_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: single)>(z_SamplerParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterf(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: single) :=
    z_SamplerParameterf_ovr_0(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameterfv_adr := GetProcAddress('glSamplerParameterfv');
    private z_SamplerParameterfv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; var param: single)>(z_SamplerParameterfv_adr);
    private z_SamplerParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: IntPtr)>(z_SamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterfv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; var param: single) :=
    z_SamplerParameterfv_ovr_0(sampler, pname, param);
    private z_SamplerParameterfv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: IntPtr)>(z_SamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: IntPtr) :=
    z_SamplerParameterfv_ovr_2(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameteri_adr := GetProcAddress('glSamplerParameteri');
    private z_SamplerParameteri_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: Int32)>(z_SamplerParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteri(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: Int32) :=
    z_SamplerParameteri_ovr_0(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameterIiv_adr := GetProcAddress('glSamplerParameterIiv');
    private z_SamplerParameterIiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32)>(z_SamplerParameterIiv_adr);
    private z_SamplerParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameterIiv_ovr_0(sampler, pname, param);
    private z_SamplerParameterIiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIiv_ovr_2(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameterIuiv_adr := GetProcAddress('glSamplerParameterIuiv');
    private z_SamplerParameterIuiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: UInt32)>(z_SamplerParameterIuiv_adr);
    private z_SamplerParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: array of UInt32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIuiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: UInt32) :=
    z_SamplerParameterIuiv_ovr_0(sampler, pname, param);
    private z_SamplerParameterIuiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIuiv_ovr_2(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameteriv_adr := GetProcAddress('glSamplerParameteriv');
    private z_SamplerParameteriv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32)>(z_SamplerParameteriv_adr);
    private z_SamplerParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameteriv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameteriv_ovr_0(sampler, pname, param);
    private z_SamplerParameteriv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameteriv_ovr_2(sampler, pname, param);
    
    // added in gl1.0
    private z_Scissor_adr := GetProcAddress('glScissor');
    private z_Scissor_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32)>(z_Scissor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Scissor(x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_Scissor_ovr_0(x, y, width, height);
    
    // added in gl4.1
    private z_ScissorArrayv_adr := GetProcAddress('glScissorArrayv');
    private z_ScissorArrayv_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: Int32)>(z_ScissorArrayv_adr);
    private z_ScissorArrayv_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorArrayv_ovr_0(first, count, v[0]) else
      z_ScissorArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; var v: Int32) :=
    z_ScissorArrayv_ovr_0(first, count, v);
    private z_ScissorArrayv_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ScissorArrayv_ovr_2(first, count, v);
    
    // added in gl4.1
    private z_ScissorIndexed_adr := GetProcAddress('glScissorIndexed');
    private z_ScissorIndexed_ovr_0 := GetProcOrNil&<procedure(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32)>(z_ScissorIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexed(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32) :=
    z_ScissorIndexed_ovr_0(index, left, bottom, width, height);
    
    // added in gl4.1
    private z_ScissorIndexedv_adr := GetProcAddress('glScissorIndexedv');
    private z_ScissorIndexedv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_ScissorIndexedv_adr);
    private z_ScissorIndexedv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ScissorIndexedv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorIndexedv_ovr_0(index, v[0]) else
      z_ScissorIndexedv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; var v: Int32) :=
    z_ScissorIndexedv_ovr_0(index, v);
    private z_ScissorIndexedv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ScissorIndexedv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: IntPtr) :=
    z_ScissorIndexedv_ovr_2(index, v);
    
    // added in gl3.3
    private z_SecondaryColorP3ui_adr := GetProcAddress('glSecondaryColorP3ui');
    private z_SecondaryColorP3ui_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_SecondaryColorP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_SecondaryColorP3ui_ovr_0(&type, color);
    
    // added in gl3.3
    private z_SecondaryColorP3uiv_adr := GetProcAddress('glSecondaryColorP3uiv');
    private z_SecondaryColorP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_SecondaryColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_SecondaryColorP3uiv_ovr_0(&type, color);
    private z_SecondaryColorP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_SecondaryColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_SecondaryColorP3uiv_ovr_1(&type, color);
    
    // added in gl4.1
    private z_ShaderBinary_adr := GetProcAddress('glShaderBinary');
    private z_ShaderBinary_ovr_0 := GetProcOrNil&<procedure(count: Int32; var shaders: gl_shader; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    private z_ShaderBinary_ovr_0_anh001000 := GetProcOrNil&<procedure(count: Int32; shaders: IntPtr; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: array of gl_shader; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_ShaderBinary_ovr_0(count, shaders[0], binaryFormat, binary, length) else
      z_ShaderBinary_ovr_0_anh001000(count, IntPtr.Zero, binaryFormat, binary, length);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; var shaders: gl_shader; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_0(count, shaders, binaryFormat, binary, length);
    private z_ShaderBinary_ovr_2 := GetProcOrNil&<procedure(count: Int32; shaders: IntPtr; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: IntPtr; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_2(count, shaders, binaryFormat, binary, length);
    
    // added in gl2.0
    private z_ShaderSource_adr := GetProcAddress('glShaderSource');
    private z_ShaderSource_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; var _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_0_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_0_anh00001 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; var _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_0_anh00011 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: array of string; length: array of Int32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          if (length<>nil) and (length.Length<>0) then
            z_ShaderSource_ovr_0(shader, count, par_3_str_ptr[0], length[0]) else
            z_ShaderSource_ovr_0_anh00001(shader, count, par_3_str_ptr[0], IntPtr.Zero) else
          if (length<>nil) and (length.Length<>0) then
            z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
            z_ShaderSource_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_ShaderSource_ovr_1_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: array of string; var length: Int32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_ShaderSource_ovr_0(shader, count, par_3_str_ptr[0], length) else
          z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_ShaderSource_ovr_2 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; var _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_2_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: array of string; length: IntPtr);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_ShaderSource_ovr_2(shader, count, par_3_str_ptr[0], length) else
          z_ShaderSource_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_ShaderSource_ovr_3_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_3_anh00011 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: array of IntPtr; length: array of Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSource_ovr_0(shader, count, _string[0], length[0]) else
        z_ShaderSource_ovr_0_anh00001(shader, count, _string[0], IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
        z_ShaderSource_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
    private z_ShaderSource_ovr_4_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: array of IntPtr; var length: Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSource_ovr_0(shader, count, _string[0], length) else
      z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
    private z_ShaderSource_ovr_5_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: array of IntPtr; length: IntPtr) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSource_ovr_2(shader, count, _string[0], length) else
      z_ShaderSource_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
    private z_ShaderSource_ovr_6 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_6_anh00001 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: IntPtr; length: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_ShaderSource_ovr_6(shader, count, _string, length[0]) else
      z_ShaderSource_ovr_6_anh00001(shader, count, _string, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: IntPtr; var length: Int32) :=
    z_ShaderSource_ovr_6(shader, count, _string, length);
    private z_ShaderSource_ovr_8 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: gl_shader; count: Int32; _string: IntPtr; length: IntPtr) :=
    z_ShaderSource_ovr_8(shader, count, _string, length);
    
    // added in gl4.3
    private z_ShaderStorageBlockBinding_adr := GetProcAddress('glShaderStorageBlockBinding');
    private z_ShaderStorageBlockBinding_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; storageBlockIndex: UInt32; storageBlockBinding: UInt32)>(z_ShaderStorageBlockBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderStorageBlockBinding(&program: gl_program; storageBlockIndex: UInt32; storageBlockBinding: UInt32) :=
    z_ShaderStorageBlockBinding_ovr_0(&program, storageBlockIndex, storageBlockBinding);
    
    // added in gl4.6
    private z_SpecializeShader_adr := GetProcAddress('glSpecializeShader');
    private z_SpecializeShader_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_0_anh000010 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_0_anh000001 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_0_anh000011 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
          if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
            z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
            z_SpecializeShader_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
          if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
            z_SpecializeShader_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
            z_SpecializeShader_ovr_0_anh000011(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShader_ovr_1_anh000010 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
          z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
          z_SpecializeShader_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShader_ovr_2 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_2_anh000010 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
          z_SpecializeShader_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
          z_SpecializeShader_ovr_2_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
          z_SpecializeShader_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShader_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShader_ovr_6 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_6_anh000001 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShader_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
          z_SpecializeShader_ovr_6_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShader_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShader_ovr_8 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShader_ovr_8(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
        z_SpecializeShader_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShader_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
        z_SpecializeShader_ovr_0_anh000011(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShader_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShader_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShader_ovr_2_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShader_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32) :=
    z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr) :=
    z_SpecializeShader_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShader_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShader_ovr_6_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32) :=
    z_SpecializeShader_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr) :=
    z_SpecializeShader_ovr_8(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    
    // added in gl1.0
    private z_StencilFunc_adr := GetProcAddress('glStencilFunc');
    private z_StencilFunc_ovr_0 := GetProcOrNil&<procedure(func: StencilFunction; ref: Int32; mask: UInt32)>(z_StencilFunc_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFunc(func: StencilFunction; ref: Int32; mask: UInt32) :=
    z_StencilFunc_ovr_0(func, ref, mask);
    
    // added in gl2.0
    private z_StencilFuncSeparate_adr := GetProcAddress('glStencilFuncSeparate');
    private z_StencilFuncSeparate_ovr_0 := GetProcOrNil&<procedure(face: StencilFaceDirection; func: StencilFunction; ref: Int32; mask: UInt32)>(z_StencilFuncSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFuncSeparate(face: StencilFaceDirection; func: StencilFunction; ref: Int32; mask: UInt32) :=
    z_StencilFuncSeparate_ovr_0(face, func, ref, mask);
    
    // added in gl1.0
    private z_StencilMask_adr := GetProcAddress('glStencilMask');
    private z_StencilMask_ovr_0 := GetProcOrNil&<procedure(mask: UInt32)>(z_StencilMask_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilMask(mask: UInt32) :=
    z_StencilMask_ovr_0(mask);
    
    // added in gl2.0
    private z_StencilMaskSeparate_adr := GetProcAddress('glStencilMaskSeparate');
    private z_StencilMaskSeparate_ovr_0 := GetProcOrNil&<procedure(face: StencilFaceDirection; mask: UInt32)>(z_StencilMaskSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilMaskSeparate(face: StencilFaceDirection; mask: UInt32) :=
    z_StencilMaskSeparate_ovr_0(face, mask);
    
    // added in gl1.0
    private z_StencilOp_adr := GetProcAddress('glStencilOp');
    private z_StencilOp_ovr_0 := GetProcOrNil&<procedure(fail: OpenGL.StencilOp; zfail: OpenGL.StencilOp; zpass: OpenGL.StencilOp)>(z_StencilOp_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOp(fail: OpenGL.StencilOp; zfail: OpenGL.StencilOp; zpass: OpenGL.StencilOp) :=
    z_StencilOp_ovr_0(fail, zfail, zpass);
    
    // added in gl2.0
    private z_StencilOpSeparate_adr := GetProcAddress('glStencilOpSeparate');
    private z_StencilOpSeparate_ovr_0 := GetProcOrNil&<procedure(face: StencilFaceDirection; sfail: OpenGL.StencilOp; dpfail: OpenGL.StencilOp; dppass: OpenGL.StencilOp)>(z_StencilOpSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOpSeparate(face: StencilFaceDirection; sfail: OpenGL.StencilOp; dpfail: OpenGL.StencilOp; dppass: OpenGL.StencilOp) :=
    z_StencilOpSeparate_ovr_0(face, sfail, dpfail, dppass);
    
    // added in gl3.1
    private z_TexBuffer_adr := GetProcAddress('glTexBuffer');
    private z_TexBuffer_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer)>(z_TexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBuffer(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer) :=
    z_TexBuffer_ovr_0(target, internalformat, buffer);
    
    // added in gl4.3
    private z_TexBufferRange_adr := GetProcAddress('glTexBufferRange');
    private z_TexBufferRange_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TexBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferRange(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TexBufferRange_ovr_0(target, internalformat, buffer, offset, size);
    
    // added in gl3.3
    private z_TexCoordP1ui_adr := GetProcAddress('glTexCoordP1ui');
    private z_TexCoordP1ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP1ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP1uiv_adr := GetProcAddress('glTexCoordP1uiv');
    private z_TexCoordP1uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP1uiv_ovr_0(&type, coords);
    private z_TexCoordP1uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP1uiv_ovr_1(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP2ui_adr := GetProcAddress('glTexCoordP2ui');
    private z_TexCoordP2ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP2ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP2uiv_adr := GetProcAddress('glTexCoordP2uiv');
    private z_TexCoordP2uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP2uiv_ovr_0(&type, coords);
    private z_TexCoordP2uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP2uiv_ovr_1(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP3ui_adr := GetProcAddress('glTexCoordP3ui');
    private z_TexCoordP3ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP3ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP3uiv_adr := GetProcAddress('glTexCoordP3uiv');
    private z_TexCoordP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP3uiv_ovr_0(&type, coords);
    private z_TexCoordP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP3uiv_ovr_1(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP4ui_adr := GetProcAddress('glTexCoordP4ui');
    private z_TexCoordP4ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP4ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP4uiv_adr := GetProcAddress('glTexCoordP4uiv');
    private z_TexCoordP4uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP4uiv_ovr_0(&type, coords);
    private z_TexCoordP4uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP4uiv_ovr_1(&type, coords);
    
    // added in gl1.0
    private z_TexImage1D_adr := GetProcAddress('glTexImage1D');
    private z_TexImage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage1D(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage1D_ovr_0(target, level, internalformat, width, border, format, &type, pixels);
    
    // added in gl1.0
    private z_TexImage2D_adr := GetProcAddress('glTexImage2D');
    private z_TexImage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2D(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage2D_ovr_0(target, level, internalformat, width, height, border, format, &type, pixels);
    
    // added in gl3.2
    private z_TexImage2DMultisample_adr := GetProcAddress('glTexImage2DMultisample');
    private z_TexImage2DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TexImage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexImage2DMultisample_ovr_0(target, samples, _internalformat, width, height, fixedsamplelocations);
    
    // added in gl1.2
    private z_TexImage3D_adr := GetProcAddress('glTexImage3D');
    private z_TexImage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3D(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage3D_ovr_0(target, level, internalformat, width, height, depth, border, format, &type, pixels);
    
    // added in gl3.2
    private z_TexImage3DMultisample_adr := GetProcAddress('glTexImage3DMultisample');
    private z_TexImage3DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TexImage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexImage3DMultisample_ovr_0(target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    // added in gl1.0
    private z_TexParameterf_adr := GetProcAddress('glTexParameterf');
    private z_TexParameterf_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; param: single)>(z_TexParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterf(target: TextureTarget; pname: TextureParameterName; param: single) :=
    z_TexParameterf_ovr_0(target, pname, param);
    
    // added in gl1.0
    private z_TexParameterfv_adr := GetProcAddress('glTexParameterfv');
    private z_TexParameterfv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: single)>(z_TexParameterfv_adr);
    private z_TexParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterfv(target: TextureTarget; pname: TextureParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterfv_ovr_0(target, pname, &params[0]) else
      z_TexParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterfv(target: TextureTarget; pname: TextureParameterName; var &params: single) :=
    z_TexParameterfv_ovr_0(target, pname, &params);
    private z_TexParameterfv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterfv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterfv_ovr_2(target, pname, &params);
    
    // added in gl1.0
    private z_TexParameteri_adr := GetProcAddress('glTexParameteri');
    private z_TexParameteri_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; param: Int32)>(z_TexParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteri(target: TextureTarget; pname: TextureParameterName; param: Int32) :=
    z_TexParameteri_ovr_0(target, pname, param);
    
    // added in gl3.0
    private z_TexParameterIiv_adr := GetProcAddress('glTexParameterIiv');
    private z_TexParameterIiv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_TexParameterIiv_adr);
    private z_TexParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIiv(target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIiv_ovr_0(target, pname, &params[0]) else
      z_TexParameterIiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIiv(target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TexParameterIiv_ovr_0(target, pname, &params);
    private z_TexParameterIiv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIiv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIiv_ovr_2(target, pname, &params);
    
    // added in gl3.0
    private z_TexParameterIuiv_adr := GetProcAddress('glTexParameterIuiv');
    private z_TexParameterIuiv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: UInt32)>(z_TexParameterIuiv_adr);
    private z_TexParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuiv(target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIuiv_ovr_0(target, pname, &params[0]) else
      z_TexParameterIuiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuiv(target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_TexParameterIuiv_ovr_0(target, pname, &params);
    private z_TexParameterIuiv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuiv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIuiv_ovr_2(target, pname, &params);
    
    // added in gl1.0
    private z_TexParameteriv_adr := GetProcAddress('glTexParameteriv');
    private z_TexParameteriv_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_TexParameteriv_adr);
    private z_TexParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteriv(target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameteriv_ovr_0(target, pname, &params[0]) else
      z_TexParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteriv(target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TexParameteriv_ovr_0(target, pname, &params);
    private z_TexParameteriv_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteriv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameteriv_ovr_2(target, pname, &params);
    
    // added in gl4.2
    private z_TexStorage1D_adr := GetProcAddress('glTexStorage1D');
    private z_TexStorage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TexStorage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage1D(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TexStorage1D_ovr_0(target, levels, internalformat, width);
    
    // added in gl4.2
    private z_TexStorage2D_adr := GetProcAddress('glTexStorage2D');
    private z_TexStorage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TexStorage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2D(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TexStorage2D_ovr_0(target, levels, internalformat, width, height);
    
    // added in gl4.3
    private z_TexStorage2DMultisample_adr := GetProcAddress('glTexStorage2DMultisample');
    private z_TexStorage2DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TexStorage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2DMultisample(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage2DMultisample_ovr_0(target, samples, internalformat, width, height, fixedsamplelocations);
    
    // added in gl4.2
    private z_TexStorage3D_adr := GetProcAddress('glTexStorage3D');
    private z_TexStorage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TexStorage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3D(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TexStorage3D_ovr_0(target, levels, internalformat, width, height, depth);
    
    // added in gl4.3
    private z_TexStorage3DMultisample_adr := GetProcAddress('glTexStorage3DMultisample');
    private z_TexStorage3DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TexStorage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3DMultisample(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage3DMultisample_ovr_0(target, samples, internalformat, width, height, depth, fixedsamplelocations);
    
    // added in gl1.1
    private z_TexSubImage1D_adr := GetProcAddress('glTexSubImage1D');
    private z_TexSubImage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage1D(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage1D_ovr_0(target, level, xoffset, width, format, &type, pixels);
    
    // added in gl1.1
    private z_TexSubImage2D_adr := GetProcAddress('glTexSubImage2D');
    private z_TexSubImage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage2D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage2D_ovr_0(target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    // added in gl1.2
    private z_TexSubImage3D_adr := GetProcAddress('glTexSubImage3D');
    private z_TexSubImage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage3D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage3D_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    // added in gl4.5
    private z_TextureBarrier_adr := GetProcAddress('glTextureBarrier');
    private z_TextureBarrier_ovr_0 := GetProcOrNil&<procedure>(z_TextureBarrier_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBarrier :=
    z_TextureBarrier_ovr_0;
    
    // added in gl4.5
    private z_TextureBuffer_adr := GetProcAddress('glTextureBuffer');
    private z_TextureBuffer_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer)>(z_TextureBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBuffer(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer) :=
    z_TextureBuffer_ovr_0(texture, internalformat, buffer);
    
    // added in gl4.5
    private z_TextureBufferRange_adr := GetProcAddress('glTextureBufferRange');
    private z_TextureBufferRange_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TextureBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferRange(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TextureBufferRange_ovr_0(texture, internalformat, buffer, offset, size);
    
    // added in gl4.5
    private z_TextureParameterf_adr := GetProcAddress('glTextureParameterf');
    private z_TextureParameterf_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: single)>(z_TextureParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterf(texture: gl_texture; pname: TextureParameterName; param: single) :=
    z_TextureParameterf_ovr_0(texture, pname, param);
    
    // added in gl4.5
    private z_TextureParameterfv_adr := GetProcAddress('glTextureParameterfv');
    private z_TextureParameterfv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var param: single)>(z_TextureParameterfv_adr);
    private z_TextureParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: gl_texture; pname: TextureParameterName; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameterfv_ovr_0(texture, pname, param[0]) else
      z_TextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: gl_texture; pname: TextureParameterName; var param: single) :=
    z_TextureParameterfv_ovr_0(texture, pname, param);
    private z_TextureParameterfv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: gl_texture; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameterfv_ovr_2(texture, pname, param);
    
    // added in gl4.5
    private z_TextureParameteri_adr := GetProcAddress('glTextureParameteri');
    private z_TextureParameteri_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: Int32)>(z_TextureParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteri(texture: gl_texture; pname: TextureParameterName; param: Int32) :=
    z_TextureParameteri_ovr_0(texture, pname, param);
    
    // added in gl4.5
    private z_TextureParameterIiv_adr := GetProcAddress('glTextureParameterIiv');
    private z_TextureParameterIiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var &params: Int32)>(z_TextureParameterIiv_adr);
    private z_TextureParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: gl_texture; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: gl_texture; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterIiv_ovr_0(texture, pname, &params);
    private z_TextureParameterIiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: gl_texture; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_TextureParameterIuiv_adr := GetProcAddress('glTextureParameterIuiv');
    private z_TextureParameterIuiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var &params: UInt32)>(z_TextureParameterIuiv_adr);
    private z_TextureParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: gl_texture; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: gl_texture; pname: TextureParameterName; var &params: UInt32) :=
    z_TextureParameterIuiv_ovr_0(texture, pname, &params);
    private z_TextureParameterIuiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: gl_texture; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIuiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_TextureParameteriv_adr := GetProcAddress('glTextureParameteriv');
    private z_TextureParameteriv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var param: Int32)>(z_TextureParameteriv_adr);
    private z_TextureParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: gl_texture; pname: TextureParameterName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameteriv_ovr_0(texture, pname, param[0]) else
      z_TextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: gl_texture; pname: TextureParameterName; var param: Int32) :=
    z_TextureParameteriv_ovr_0(texture, pname, param);
    private z_TextureParameteriv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: gl_texture; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameteriv_ovr_2(texture, pname, param);
    
    // added in gl4.5
    private z_TextureStorage1D_adr := GetProcAddress('glTextureStorage1D');
    private z_TextureStorage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TextureStorage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1D(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TextureStorage1D_ovr_0(texture, levels, internalformat, width);
    
    // added in gl4.5
    private z_TextureStorage2D_adr := GetProcAddress('glTextureStorage2D');
    private z_TextureStorage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TextureStorage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2D(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2D_ovr_0(texture, levels, internalformat, width, height);
    
    // added in gl4.5
    private z_TextureStorage2DMultisample_adr := GetProcAddress('glTextureStorage2DMultisample');
    private z_TextureStorage2DMultisample_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TextureStorage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DMultisample(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage2DMultisample_ovr_0(texture, samples, internalformat, width, height, fixedsamplelocations);
    
    // added in gl4.5
    private z_TextureStorage3D_adr := GetProcAddress('glTextureStorage3D');
    private z_TextureStorage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TextureStorage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3D(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3D_ovr_0(texture, levels, internalformat, width, height, depth);
    
    // added in gl4.5
    private z_TextureStorage3DMultisample_adr := GetProcAddress('glTextureStorage3DMultisample');
    private z_TextureStorage3DMultisample_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TextureStorage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DMultisample(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage3DMultisample_ovr_0(texture, samples, internalformat, width, height, depth, fixedsamplelocations);
    
    // added in gl4.5
    private z_TextureSubImage1D_adr := GetProcAddress('glTextureSubImage1D');
    private z_TextureSubImage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage1D(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage1D_ovr_0(texture, level, xoffset, width, format, &type, pixels);
    
    // added in gl4.5
    private z_TextureSubImage2D_adr := GetProcAddress('glTextureSubImage2D');
    private z_TextureSubImage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage2D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    // added in gl4.5
    private z_TextureSubImage3D_adr := GetProcAddress('glTextureSubImage3D');
    private z_TextureSubImage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage3D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    // added in gl4.3
    private z_TextureView_adr := GetProcAddress('glTextureView');
    private z_TextureView_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; origtexture: gl_texture; internalformat: SizedInternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32)>(z_TextureView_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureView(texture: gl_texture; target: TextureTarget; origtexture: gl_texture; internalformat: SizedInternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32) :=
    z_TextureView_ovr_0(texture, target, origtexture, internalformat, minlevel, numlevels, minlayer, numlayers);
    
    // added in gl4.5
    private z_TransformFeedbackBufferBase_adr := GetProcAddress('glTransformFeedbackBufferBase');
    private z_TransformFeedbackBufferBase_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer)>(z_TransformFeedbackBufferBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferBase(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer) :=
    z_TransformFeedbackBufferBase_ovr_0(xfb, index, buffer);
    
    // added in gl4.5
    private z_TransformFeedbackBufferRange_adr := GetProcAddress('glTransformFeedbackBufferRange');
    private z_TransformFeedbackBufferRange_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TransformFeedbackBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferRange(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TransformFeedbackBufferRange_ovr_0(xfb, index, buffer, offset, size);
    
    // added in gl3.0
    private z_TransformFeedbackVaryings_adr := GetProcAddress('glTransformFeedbackVaryings');
    private z_TransformFeedbackVaryings_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; var varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    private z_TransformFeedbackVaryings_ovr_0_anh00010 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryings(&program: gl_program; count: Int32; varyings: array of string; bufferMode: TransformFeedbackBufferMode);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := varyings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_TransformFeedbackVaryings_ovr_0(&program, count, par_3_str_ptr[0], bufferMode) else
          z_TransformFeedbackVaryings_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_TransformFeedbackVaryings_ovr_1_anh00010 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryings(&program: gl_program; count: Int32; varyings: array of IntPtr; bufferMode: TransformFeedbackBufferMode) :=
    if (varyings<>nil) and (varyings.Length<>0) then
      z_TransformFeedbackVaryings_ovr_0(&program, count, varyings[0], bufferMode) else
      z_TransformFeedbackVaryings_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
    private z_TransformFeedbackVaryings_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryings(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode) :=
    z_TransformFeedbackVaryings_ovr_2(&program, count, varyings, bufferMode);
    
    // added in gl4.0
    private z_Uniform1d_adr := GetProcAddress('glUniform1d');
    private z_Uniform1d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real)>(z_Uniform1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1d(location: Int32; x: real) :=
    z_Uniform1d_ovr_0(location, x);
    
    // added in gl4.0
    private z_Uniform1dv_adr := GetProcAddress('glUniform1dv');
    private z_Uniform1dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform1dv_adr);
    private z_Uniform1dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1dv_ovr_0(location, count, value[0]) else
      z_Uniform1dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform1dv_ovr_0(location, count, value);
    private z_Uniform1dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec1d)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; var value: Vec1d) :=
    z_Uniform1dv_ovr_2(location, count, value);
    private z_Uniform1dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1dv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform1f_adr := GetProcAddress('glUniform1f');
    private z_Uniform1f_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single)>(z_Uniform1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1f(location: Int32; v0: single) :=
    z_Uniform1f_ovr_0(location, v0);
    
    // added in gl2.0
    private z_Uniform1fv_adr := GetProcAddress('glUniform1fv');
    private z_Uniform1fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform1fv_adr);
    private z_Uniform1fv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1fv_ovr_0(location, count, value[0]) else
      z_Uniform1fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform1fv_ovr_0(location, count, value);
    private z_Uniform1fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec1f)>(z_Uniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; var value: Vec1f) :=
    z_Uniform1fv_ovr_2(location, count, value);
    private z_Uniform1fv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1fv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform1i_adr := GetProcAddress('glUniform1i');
    private z_Uniform1i_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32)>(z_Uniform1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i(location: Int32; v0: Int32) :=
    z_Uniform1i_ovr_0(location, v0);
    
    // added in gl2.0
    private z_Uniform1iv_adr := GetProcAddress('glUniform1iv');
    private z_Uniform1iv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform1iv_adr);
    private z_Uniform1iv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1iv_ovr_0(location, count, value[0]) else
      z_Uniform1iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform1iv_ovr_0(location, count, value);
    private z_Uniform1iv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec1i)>(z_Uniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; var value: Vec1i) :=
    z_Uniform1iv_ovr_2(location, count, value);
    private z_Uniform1iv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1iv_ovr_3(location, count, value);
    
    // added in gl3.0
    private z_Uniform1ui_adr := GetProcAddress('glUniform1ui');
    private z_Uniform1ui_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32)>(z_Uniform1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui(location: Int32; v0: UInt32) :=
    z_Uniform1ui_ovr_0(location, v0);
    
    // added in gl3.0
    private z_Uniform1uiv_adr := GetProcAddress('glUniform1uiv');
    private z_Uniform1uiv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform1uiv_adr);
    private z_Uniform1uiv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1uiv_ovr_0(location, count, value[0]) else
      z_Uniform1uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform1uiv_ovr_0(location, count, value);
    private z_Uniform1uiv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec1ui)>(z_Uniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; var value: Vec1ui) :=
    z_Uniform1uiv_ovr_2(location, count, value);
    private z_Uniform1uiv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1uiv_ovr_3(location, count, value);
    
    // added in gl4.0
    private z_Uniform2d_adr := GetProcAddress('glUniform2d');
    private z_Uniform2d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real; y: real)>(z_Uniform2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2d(location: Int32; x: real; y: real) :=
    z_Uniform2d_ovr_0(location, x, y);
    
    // added in gl4.0
    private z_Uniform2dv_adr := GetProcAddress('glUniform2dv');
    private z_Uniform2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform2dv_adr);
    private z_Uniform2dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2dv_ovr_0(location, count, value[0]) else
      z_Uniform2dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform2dv_ovr_0(location, count, value);
    private z_Uniform2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec2d)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; var value: Vec2d) :=
    z_Uniform2dv_ovr_2(location, count, value);
    private z_Uniform2dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2dv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform2f_adr := GetProcAddress('glUniform2f');
    private z_Uniform2f_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single; v1: single)>(z_Uniform2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2f(location: Int32; v0: single; v1: single) :=
    z_Uniform2f_ovr_0(location, v0, v1);
    
    // added in gl2.0
    private z_Uniform2fv_adr := GetProcAddress('glUniform2fv');
    private z_Uniform2fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform2fv_adr);
    private z_Uniform2fv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2fv_ovr_0(location, count, value[0]) else
      z_Uniform2fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform2fv_ovr_0(location, count, value);
    private z_Uniform2fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec2f)>(z_Uniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; var value: Vec2f) :=
    z_Uniform2fv_ovr_2(location, count, value);
    private z_Uniform2fv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2fv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform2i_adr := GetProcAddress('glUniform2i');
    private z_Uniform2i_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32; v1: Int32)>(z_Uniform2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i(location: Int32; v0: Int32; v1: Int32) :=
    z_Uniform2i_ovr_0(location, v0, v1);
    
    // added in gl2.0
    private z_Uniform2iv_adr := GetProcAddress('glUniform2iv');
    private z_Uniform2iv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform2iv_adr);
    private z_Uniform2iv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2iv_ovr_0(location, count, value[0]) else
      z_Uniform2iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform2iv_ovr_0(location, count, value);
    private z_Uniform2iv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec2i)>(z_Uniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; var value: Vec2i) :=
    z_Uniform2iv_ovr_2(location, count, value);
    private z_Uniform2iv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2iv_ovr_3(location, count, value);
    
    // added in gl3.0
    private z_Uniform2ui_adr := GetProcAddress('glUniform2ui');
    private z_Uniform2ui_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32)>(z_Uniform2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui(location: Int32; v0: UInt32; v1: UInt32) :=
    z_Uniform2ui_ovr_0(location, v0, v1);
    
    // added in gl3.0
    private z_Uniform2uiv_adr := GetProcAddress('glUniform2uiv');
    private z_Uniform2uiv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform2uiv_adr);
    private z_Uniform2uiv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2uiv_ovr_0(location, count, value[0]) else
      z_Uniform2uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform2uiv_ovr_0(location, count, value);
    private z_Uniform2uiv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec2ui)>(z_Uniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; var value: Vec2ui) :=
    z_Uniform2uiv_ovr_2(location, count, value);
    private z_Uniform2uiv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2uiv_ovr_3(location, count, value);
    
    // added in gl4.0
    private z_Uniform3d_adr := GetProcAddress('glUniform3d');
    private z_Uniform3d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real; y: real; z: real)>(z_Uniform3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3d(location: Int32; x: real; y: real; z: real) :=
    z_Uniform3d_ovr_0(location, x, y, z);
    
    // added in gl4.0
    private z_Uniform3dv_adr := GetProcAddress('glUniform3dv');
    private z_Uniform3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform3dv_adr);
    private z_Uniform3dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3dv_ovr_0(location, count, value[0]) else
      z_Uniform3dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform3dv_ovr_0(location, count, value);
    private z_Uniform3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec3d)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; var value: Vec3d) :=
    z_Uniform3dv_ovr_2(location, count, value);
    private z_Uniform3dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3dv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform3f_adr := GetProcAddress('glUniform3f');
    private z_Uniform3f_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single; v1: single; v2: single)>(z_Uniform3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3f(location: Int32; v0: single; v1: single; v2: single) :=
    z_Uniform3f_ovr_0(location, v0, v1, v2);
    
    // added in gl2.0
    private z_Uniform3fv_adr := GetProcAddress('glUniform3fv');
    private z_Uniform3fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform3fv_adr);
    private z_Uniform3fv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3fv_ovr_0(location, count, value[0]) else
      z_Uniform3fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform3fv_ovr_0(location, count, value);
    private z_Uniform3fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec3f)>(z_Uniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; var value: Vec3f) :=
    z_Uniform3fv_ovr_2(location, count, value);
    private z_Uniform3fv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3fv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform3i_adr := GetProcAddress('glUniform3i');
    private z_Uniform3i_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_Uniform3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i(location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_Uniform3i_ovr_0(location, v0, v1, v2);
    
    // added in gl2.0
    private z_Uniform3iv_adr := GetProcAddress('glUniform3iv');
    private z_Uniform3iv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform3iv_adr);
    private z_Uniform3iv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3iv_ovr_0(location, count, value[0]) else
      z_Uniform3iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform3iv_ovr_0(location, count, value);
    private z_Uniform3iv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec3i)>(z_Uniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; var value: Vec3i) :=
    z_Uniform3iv_ovr_2(location, count, value);
    private z_Uniform3iv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3iv_ovr_3(location, count, value);
    
    // added in gl3.0
    private z_Uniform3ui_adr := GetProcAddress('glUniform3ui');
    private z_Uniform3ui_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_Uniform3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_Uniform3ui_ovr_0(location, v0, v1, v2);
    
    // added in gl3.0
    private z_Uniform3uiv_adr := GetProcAddress('glUniform3uiv');
    private z_Uniform3uiv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform3uiv_adr);
    private z_Uniform3uiv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3uiv_ovr_0(location, count, value[0]) else
      z_Uniform3uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform3uiv_ovr_0(location, count, value);
    private z_Uniform3uiv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec3ui)>(z_Uniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; var value: Vec3ui) :=
    z_Uniform3uiv_ovr_2(location, count, value);
    private z_Uniform3uiv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3uiv_ovr_3(location, count, value);
    
    // added in gl4.0
    private z_Uniform4d_adr := GetProcAddress('glUniform4d');
    private z_Uniform4d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real; y: real; z: real; w: real)>(z_Uniform4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4d(location: Int32; x: real; y: real; z: real; w: real) :=
    z_Uniform4d_ovr_0(location, x, y, z, w);
    
    // added in gl4.0
    private z_Uniform4dv_adr := GetProcAddress('glUniform4dv');
    private z_Uniform4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform4dv_adr);
    private z_Uniform4dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4dv_ovr_0(location, count, value[0]) else
      z_Uniform4dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform4dv_ovr_0(location, count, value);
    private z_Uniform4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec4d)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; var value: Vec4d) :=
    z_Uniform4dv_ovr_2(location, count, value);
    private z_Uniform4dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4dv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform4f_adr := GetProcAddress('glUniform4f');
    private z_Uniform4f_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_Uniform4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4f(location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_Uniform4f_ovr_0(location, v0, v1, v2, v3);
    
    // added in gl2.0
    private z_Uniform4fv_adr := GetProcAddress('glUniform4fv');
    private z_Uniform4fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform4fv_adr);
    private z_Uniform4fv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4fv_ovr_0(location, count, value[0]) else
      z_Uniform4fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform4fv_ovr_0(location, count, value);
    private z_Uniform4fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec4f)>(z_Uniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; var value: Vec4f) :=
    z_Uniform4fv_ovr_2(location, count, value);
    private z_Uniform4fv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4fv_ovr_3(location, count, value);
    
    // added in gl2.0
    private z_Uniform4i_adr := GetProcAddress('glUniform4i');
    private z_Uniform4i_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_Uniform4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_Uniform4i_ovr_0(location, v0, v1, v2, v3);
    
    // added in gl2.0
    private z_Uniform4iv_adr := GetProcAddress('glUniform4iv');
    private z_Uniform4iv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform4iv_adr);
    private z_Uniform4iv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4iv_ovr_0(location, count, value[0]) else
      z_Uniform4iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform4iv_ovr_0(location, count, value);
    private z_Uniform4iv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec4i)>(z_Uniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; var value: Vec4i) :=
    z_Uniform4iv_ovr_2(location, count, value);
    private z_Uniform4iv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4iv_ovr_3(location, count, value);
    
    // added in gl3.0
    private z_Uniform4ui_adr := GetProcAddress('glUniform4ui');
    private z_Uniform4ui_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_Uniform4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_Uniform4ui_ovr_0(location, v0, v1, v2, v3);
    
    // added in gl3.0
    private z_Uniform4uiv_adr := GetProcAddress('glUniform4uiv');
    private z_Uniform4uiv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform4uiv_adr);
    private z_Uniform4uiv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4uiv_ovr_0(location, count, value[0]) else
      z_Uniform4uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform4uiv_ovr_0(location, count, value);
    private z_Uniform4uiv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec4ui)>(z_Uniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; var value: Vec4ui) :=
    z_Uniform4uiv_ovr_2(location, count, value);
    private z_Uniform4uiv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4uiv_ovr_3(location, count, value);
    
    // added in gl3.1
    private z_UniformBlockBinding_adr := GetProcAddress('glUniformBlockBinding');
    private z_UniformBlockBinding_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32)>(z_UniformBlockBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformBlockBinding(&program: gl_program; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32) :=
    z_UniformBlockBinding_ovr_0(&program, uniformBlockIndex, uniformBlockBinding);
    
    // added in gl4.0
    private z_UniformMatrix2dv_adr := GetProcAddress('glUniformMatrix2dv');
    private z_UniformMatrix2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2dv_adr);
    private z_UniformMatrix2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.0
    private z_UniformMatrix2fv_adr := GetProcAddress('glUniformMatrix2fv');
    private z_UniformMatrix2fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2fv_adr);
    private z_UniformMatrix2fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix2x3dv_adr := GetProcAddress('glUniformMatrix2x3dv');
    private z_UniformMatrix2x3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2x3dv_adr);
    private z_UniformMatrix2x3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x3dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix2x3fv_adr := GetProcAddress('glUniformMatrix2x3fv');
    private z_UniformMatrix2x3fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2x3fv_adr);
    private z_UniformMatrix2x3fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x3fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x3fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2x3fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x3fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x3fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix2x4dv_adr := GetProcAddress('glUniformMatrix2x4dv');
    private z_UniformMatrix2x4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2x4dv_adr);
    private z_UniformMatrix2x4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x4dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix2x4fv_adr := GetProcAddress('glUniformMatrix2x4fv');
    private z_UniformMatrix2x4fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2x4fv_adr);
    private z_UniformMatrix2x4fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x4fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x4fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2x4fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x4fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x4fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix3dv_adr := GetProcAddress('glUniformMatrix3dv');
    private z_UniformMatrix3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3dv_adr);
    private z_UniformMatrix3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.0
    private z_UniformMatrix3fv_adr := GetProcAddress('glUniformMatrix3fv');
    private z_UniformMatrix3fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3fv_adr);
    private z_UniformMatrix3fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix3x2dv_adr := GetProcAddress('glUniformMatrix3x2dv');
    private z_UniformMatrix3x2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3x2dv_adr);
    private z_UniformMatrix3x2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x2dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix3x2fv_adr := GetProcAddress('glUniformMatrix3x2fv');
    private z_UniformMatrix3x2fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3x2fv_adr);
    private z_UniformMatrix3x2fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x2fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x2fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3x2fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x2fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x2fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix3x4dv_adr := GetProcAddress('glUniformMatrix3x4dv');
    private z_UniformMatrix3x4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3x4dv_adr);
    private z_UniformMatrix3x4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x4dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix3x4fv_adr := GetProcAddress('glUniformMatrix3x4fv');
    private z_UniformMatrix3x4fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3x4fv_adr);
    private z_UniformMatrix3x4fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x4fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x4fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3x4fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x4fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x4fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix4dv_adr := GetProcAddress('glUniformMatrix4dv');
    private z_UniformMatrix4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4dv_adr);
    private z_UniformMatrix4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.0
    private z_UniformMatrix4fv_adr := GetProcAddress('glUniformMatrix4fv');
    private z_UniformMatrix4fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4fv_adr);
    private z_UniformMatrix4fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix4x2dv_adr := GetProcAddress('glUniformMatrix4x2dv');
    private z_UniformMatrix4x2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4x2dv_adr);
    private z_UniformMatrix4x2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x2dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix4x2fv_adr := GetProcAddress('glUniformMatrix4x2fv');
    private z_UniformMatrix4x2fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4x2fv_adr);
    private z_UniformMatrix4x2fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x2fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x2fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4x2fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x2fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x2fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix4x3dv_adr := GetProcAddress('glUniformMatrix4x3dv');
    private z_UniformMatrix4x3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4x3dv_adr);
    private z_UniformMatrix4x3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x3dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix4x3fv_adr := GetProcAddress('glUniformMatrix4x3fv');
    private z_UniformMatrix4x3fv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4x3fv_adr);
    private z_UniformMatrix4x3fv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x3fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x3fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4x3fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x3fv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x3fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformSubroutinesuiv_adr := GetProcAddress('glUniformSubroutinesuiv');
    private z_UniformSubroutinesuiv_ovr_0 := GetProcOrNil&<procedure(_shadertype: ShaderType; count: Int32; var indices: UInt32)>(z_UniformSubroutinesuiv_adr);
    private z_UniformSubroutinesuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(_shadertype: ShaderType; count: Int32; indices: IntPtr)>(z_UniformSubroutinesuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: array of UInt32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices[0]) else
      z_UniformSubroutinesuiv_ovr_0_anh0001(_shadertype, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; var indices: UInt32) :=
    z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices);
    private z_UniformSubroutinesuiv_ovr_2 := GetProcOrNil&<procedure(_shadertype: ShaderType; count: Int32; indices: IntPtr)>(z_UniformSubroutinesuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: IntPtr) :=
    z_UniformSubroutinesuiv_ovr_2(_shadertype, count, indices);
    
    // added in gl1.5
    private z_UnmapBuffer_adr := GetProcAddress('glUnmapBuffer');
    private z_UnmapBuffer_ovr_0 := GetProcOrNil&<function(target: BufferTarget): boolean>(z_UnmapBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapBuffer(target: BufferTarget): boolean :=
    z_UnmapBuffer_ovr_0(target);
    
    // added in gl4.5
    private z_UnmapNamedBuffer_adr := GetProcAddress('glUnmapNamedBuffer');
    private z_UnmapNamedBuffer_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_UnmapNamedBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapNamedBuffer(buffer: gl_buffer): boolean :=
    z_UnmapNamedBuffer_ovr_0(buffer);
    
    // added in gl2.0
    private z_UseProgram_adr := GetProcAddress('glUseProgram');
    private z_UseProgram_ovr_0 := GetProcOrNil&<procedure(&program: gl_program)>(z_UseProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgram(&program: gl_program) :=
    z_UseProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_UseProgramStages_adr := GetProcAddress('glUseProgramStages');
    private z_UseProgramStages_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; stages: UseProgramStageMask; &program: gl_program)>(z_UseProgramStages_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgramStages(pipeline: gl_program_pipeline; stages: UseProgramStageMask; &program: gl_program) :=
    z_UseProgramStages_ovr_0(pipeline, stages, &program);
    
    // added in gl2.0
    private z_ValidateProgram_adr := GetProcAddress('glValidateProgram');
    private z_ValidateProgram_ovr_0 := GetProcOrNil&<procedure(&program: gl_program)>(z_ValidateProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgram(&program: gl_program) :=
    z_ValidateProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_ValidateProgramPipeline_adr := GetProcAddress('glValidateProgramPipeline');
    private z_ValidateProgramPipeline_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline)>(z_ValidateProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgramPipeline(pipeline: gl_program_pipeline) :=
    z_ValidateProgramPipeline_ovr_0(pipeline);
    
    // added in gl4.5
    private z_VertexArrayAttribBinding_adr := GetProcAddress('glVertexArrayAttribBinding');
    private z_VertexArrayAttribBinding_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; bindingindex: UInt32)>(z_VertexArrayAttribBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribBinding(vaobj: gl_vertex_array; attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexArrayAttribBinding_ovr_0(vaobj, attribindex, bindingindex);
    
    // added in gl4.5
    private z_VertexArrayAttribFormat_adr := GetProcAddress('glVertexArrayAttribFormat');
    private z_VertexArrayAttribFormat_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexArrayAttribFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribFormat(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexArrayAttribFormat_ovr_0(vaobj, attribindex, size, &type, normalized, relativeoffset);
    
    // added in gl4.5
    private z_VertexArrayAttribIFormat_adr := GetProcAddress('glVertexArrayAttribIFormat');
    private z_VertexArrayAttribIFormat_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexArrayAttribIFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribIFormat(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexArrayAttribIFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    // added in gl4.5
    private z_VertexArrayAttribLFormat_adr := GetProcAddress('glVertexArrayAttribLFormat');
    private z_VertexArrayAttribLFormat_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexArrayAttribLFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribLFormat(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexArrayAttribLFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    // added in gl4.5
    private z_VertexArrayBindingDivisor_adr := GetProcAddress('glVertexArrayBindingDivisor');
    private z_VertexArrayBindingDivisor_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; bindingindex: UInt32; divisor: UInt32)>(z_VertexArrayBindingDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayBindingDivisor(vaobj: gl_vertex_array; bindingindex: UInt32; divisor: UInt32) :=
    z_VertexArrayBindingDivisor_ovr_0(vaobj, bindingindex, divisor);
    
    // added in gl4.5
    private z_VertexArrayElementBuffer_adr := GetProcAddress('glVertexArrayElementBuffer');
    private z_VertexArrayElementBuffer_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer)>(z_VertexArrayElementBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayElementBuffer(vaobj: gl_vertex_array; buffer: gl_buffer) :=
    z_VertexArrayElementBuffer_ovr_0(vaobj, buffer);
    
    // added in gl4.5
    private z_VertexArrayVertexBuffer_adr := GetProcAddress('glVertexArrayVertexBuffer');
    private z_VertexArrayVertexBuffer_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32)>(z_VertexArrayVertexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffer(vaobj: gl_vertex_array; bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32) :=
    z_VertexArrayVertexBuffer_ovr_0(vaobj, bindingindex, buffer, offset, stride);
    
    // added in gl4.5
    private z_VertexArrayVertexBuffers_adr := GetProcAddress('glVertexArrayVertexBuffers');
    private z_VertexArrayVertexBuffers_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000110 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000101 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000011 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000111 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000111(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000110 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000110 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_3_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_3_anh0000101 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_4_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_5_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_6 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000101 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_7_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_8 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_8_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_8_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_9_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_9_anh0000011 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_10_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_11_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_18 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000011 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_19_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_20 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_20_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_20_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_24 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_24_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_24_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_26 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_26(vaobj, first, count, buffers, offsets, strides);
    
    // added in gl2.0
    private z_VertexAttrib1d_adr := GetProcAddress('glVertexAttrib1d');
    private z_VertexAttrib1d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttrib1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1d(index: UInt32; x: real) :=
    z_VertexAttrib1d_ovr_0(index, x);
    
    // added in gl2.0
    private z_VertexAttrib1dv_adr := GetProcAddress('glVertexAttrib1dv');
    private z_VertexAttrib1dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dv(index: UInt32; var v: real) :=
    z_VertexAttrib1dv_ovr_0(index, v);
    private z_VertexAttrib1dv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dv_ovr_1(index, v);
    
    // added in gl2.0
    private z_VertexAttrib1f_adr := GetProcAddress('glVertexAttrib1f');
    private z_VertexAttrib1f_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single)>(z_VertexAttrib1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1f(index: UInt32; x: single) :=
    z_VertexAttrib1f_ovr_0(index, x);
    
    // added in gl2.0
    private z_VertexAttrib1fv_adr := GetProcAddress('glVertexAttrib1fv');
    private z_VertexAttrib1fv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fv(index: UInt32; var v: single) :=
    z_VertexAttrib1fv_ovr_0(index, v);
    private z_VertexAttrib1fv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fv_ovr_1(index, v);
    
    // added in gl2.0
    private z_VertexAttrib1s_adr := GetProcAddress('glVertexAttrib1s');
    private z_VertexAttrib1s_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16)>(z_VertexAttrib1s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1s(index: UInt32; x: Int16) :=
    z_VertexAttrib1s_ovr_0(index, x);
    
    // added in gl2.0
    private z_VertexAttrib1sv_adr := GetProcAddress('glVertexAttrib1sv');
    private z_VertexAttrib1sv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib1sv_ovr_0(index, v);
    private z_VertexAttrib1sv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1sv_ovr_1(index, v);
    
    // added in gl2.0
    private z_VertexAttrib2d_adr := GetProcAddress('glVertexAttrib2d');
    private z_VertexAttrib2d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttrib2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2d(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2d_ovr_0(index, x, y);
    
    // added in gl2.0
    private z_VertexAttrib2dv_adr := GetProcAddress('glVertexAttrib2dv');
    private z_VertexAttrib2dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib2dv_adr);
    private z_VertexAttrib2dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dv_ovr_0(index, v[0]) else
      z_VertexAttrib2dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dv(index: UInt32; var v: real) :=
    z_VertexAttrib2dv_ovr_0(index, v);
    private z_VertexAttrib2dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib2f_adr := GetProcAddress('glVertexAttrib2f');
    private z_VertexAttrib2f_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single)>(z_VertexAttrib2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2f(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2f_ovr_0(index, x, y);
    
    // added in gl2.0
    private z_VertexAttrib2fv_adr := GetProcAddress('glVertexAttrib2fv');
    private z_VertexAttrib2fv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib2fv_adr);
    private z_VertexAttrib2fv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fv_ovr_0(index, v[0]) else
      z_VertexAttrib2fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fv(index: UInt32; var v: single) :=
    z_VertexAttrib2fv_ovr_0(index, v);
    private z_VertexAttrib2fv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib2s_adr := GetProcAddress('glVertexAttrib2s');
    private z_VertexAttrib2s_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16)>(z_VertexAttrib2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2s(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2s_ovr_0(index, x, y);
    
    // added in gl2.0
    private z_VertexAttrib2sv_adr := GetProcAddress('glVertexAttrib2sv');
    private z_VertexAttrib2sv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib2sv_adr);
    private z_VertexAttrib2sv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2sv_ovr_0(index, v[0]) else
      z_VertexAttrib2sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib2sv_ovr_0(index, v);
    private z_VertexAttrib2sv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib3d_adr := GetProcAddress('glVertexAttrib3d');
    private z_VertexAttrib3d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttrib3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3d(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3d_ovr_0(index, x, y, z);
    
    // added in gl2.0
    private z_VertexAttrib3dv_adr := GetProcAddress('glVertexAttrib3dv');
    private z_VertexAttrib3dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib3dv_adr);
    private z_VertexAttrib3dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dv_ovr_0(index, v[0]) else
      z_VertexAttrib3dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dv(index: UInt32; var v: real) :=
    z_VertexAttrib3dv_ovr_0(index, v);
    private z_VertexAttrib3dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib3f_adr := GetProcAddress('glVertexAttrib3f');
    private z_VertexAttrib3f_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single)>(z_VertexAttrib3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3f(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3f_ovr_0(index, x, y, z);
    
    // added in gl2.0
    private z_VertexAttrib3fv_adr := GetProcAddress('glVertexAttrib3fv');
    private z_VertexAttrib3fv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib3fv_adr);
    private z_VertexAttrib3fv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fv_ovr_0(index, v[0]) else
      z_VertexAttrib3fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fv(index: UInt32; var v: single) :=
    z_VertexAttrib3fv_ovr_0(index, v);
    private z_VertexAttrib3fv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib3s_adr := GetProcAddress('glVertexAttrib3s');
    private z_VertexAttrib3s_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16)>(z_VertexAttrib3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3s(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3s_ovr_0(index, x, y, z);
    
    // added in gl2.0
    private z_VertexAttrib3sv_adr := GetProcAddress('glVertexAttrib3sv');
    private z_VertexAttrib3sv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib3sv_adr);
    private z_VertexAttrib3sv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3sv_ovr_0(index, v[0]) else
      z_VertexAttrib3sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib3sv_ovr_0(index, v);
    private z_VertexAttrib3sv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4bv_adr := GetProcAddress('glVertexAttrib4bv');
    private z_VertexAttrib4bv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4bv_adr);
    private z_VertexAttrib4bv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bv(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4bv_ovr_0(index, v[0]) else
      z_VertexAttrib4bv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bv(index: UInt32; var v: SByte) :=
    z_VertexAttrib4bv_ovr_0(index, v);
    private z_VertexAttrib4bv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4bv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4d_adr := GetProcAddress('glVertexAttrib4d');
    private z_VertexAttrib4d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttrib4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4d(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4d_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4dv_adr := GetProcAddress('glVertexAttrib4dv');
    private z_VertexAttrib4dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib4dv_adr);
    private z_VertexAttrib4dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dv_ovr_0(index, v[0]) else
      z_VertexAttrib4dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dv(index: UInt32; var v: real) :=
    z_VertexAttrib4dv_ovr_0(index, v);
    private z_VertexAttrib4dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4f_adr := GetProcAddress('glVertexAttrib4f');
    private z_VertexAttrib4f_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single; w: single)>(z_VertexAttrib4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4f(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4f_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4fv_adr := GetProcAddress('glVertexAttrib4fv');
    private z_VertexAttrib4fv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib4fv_adr);
    private z_VertexAttrib4fv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fv_ovr_0(index, v[0]) else
      z_VertexAttrib4fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fv(index: UInt32; var v: single) :=
    z_VertexAttrib4fv_ovr_0(index, v);
    private z_VertexAttrib4fv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4iv_adr := GetProcAddress('glVertexAttrib4iv');
    private z_VertexAttrib4iv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4iv_adr);
    private z_VertexAttrib4iv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4iv_ovr_0(index, v[0]) else
      z_VertexAttrib4iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4iv(index: UInt32; var v: Int32) :=
    z_VertexAttrib4iv_ovr_0(index, v);
    private z_VertexAttrib4iv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4iv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4iv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nbv_adr := GetProcAddress('glVertexAttrib4Nbv');
    private z_VertexAttrib4Nbv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4Nbv_adr);
    private z_VertexAttrib4Nbv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nbv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nbv(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nbv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nbv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nbv(index: UInt32; var v: SByte) :=
    z_VertexAttrib4Nbv_ovr_0(index, v);
    private z_VertexAttrib4Nbv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nbv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nbv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nbv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Niv_adr := GetProcAddress('glVertexAttrib4Niv');
    private z_VertexAttrib4Niv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4Niv_adr);
    private z_VertexAttrib4Niv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Niv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Niv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Niv_ovr_0(index, v[0]) else
      z_VertexAttrib4Niv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Niv(index: UInt32; var v: Int32) :=
    z_VertexAttrib4Niv_ovr_0(index, v);
    private z_VertexAttrib4Niv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Niv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Niv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Niv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nsv_adr := GetProcAddress('glVertexAttrib4Nsv');
    private z_VertexAttrib4Nsv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4Nsv_adr);
    private z_VertexAttrib4Nsv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nsv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nsv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nsv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nsv(index: UInt32; var v: Int16) :=
    z_VertexAttrib4Nsv_ovr_0(index, v);
    private z_VertexAttrib4Nsv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nsv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nsv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nub_adr := GetProcAddress('glVertexAttrib4Nub');
    private z_VertexAttrib4Nub_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte)>(z_VertexAttrib4Nub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nub(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4Nub_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4Nubv_adr := GetProcAddress('glVertexAttrib4Nubv');
    private z_VertexAttrib4Nubv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4Nubv_adr);
    private z_VertexAttrib4Nubv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nubv(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nubv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nubv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nubv(index: UInt32; var v: Byte) :=
    z_VertexAttrib4Nubv_ovr_0(index, v);
    private z_VertexAttrib4Nubv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nubv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nubv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nuiv_adr := GetProcAddress('glVertexAttrib4Nuiv');
    private z_VertexAttrib4Nuiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4Nuiv_adr);
    private z_VertexAttrib4Nuiv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nuiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nuiv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nuiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nuiv(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4Nuiv_ovr_0(index, v);
    private z_VertexAttrib4Nuiv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nuiv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nuiv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nusv_adr := GetProcAddress('glVertexAttrib4Nusv');
    private z_VertexAttrib4Nusv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4Nusv_adr);
    private z_VertexAttrib4Nusv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nusv(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nusv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nusv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nusv(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4Nusv_ovr_0(index, v);
    private z_VertexAttrib4Nusv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nusv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nusv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4s_adr := GetProcAddress('glVertexAttrib4s');
    private z_VertexAttrib4s_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16)>(z_VertexAttrib4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4s(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4s_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4sv_adr := GetProcAddress('glVertexAttrib4sv');
    private z_VertexAttrib4sv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4sv_adr);
    private z_VertexAttrib4sv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4sv_ovr_0(index, v[0]) else
      z_VertexAttrib4sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib4sv_ovr_0(index, v);
    private z_VertexAttrib4sv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4ubv_adr := GetProcAddress('glVertexAttrib4ubv');
    private z_VertexAttrib4ubv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4ubv_adr);
    private z_VertexAttrib4ubv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubv(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubv_ovr_0(index, v[0]) else
      z_VertexAttrib4ubv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubv(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubv_ovr_0(index, v);
    private z_VertexAttrib4ubv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4uiv_adr := GetProcAddress('glVertexAttrib4uiv');
    private z_VertexAttrib4uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4uiv_adr);
    private z_VertexAttrib4uiv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4uiv_ovr_0(index, v[0]) else
      z_VertexAttrib4uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4uiv_ovr_0(index, v);
    private z_VertexAttrib4uiv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4uiv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4usv_adr := GetProcAddress('glVertexAttrib4usv');
    private z_VertexAttrib4usv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4usv_adr);
    private z_VertexAttrib4usv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usv(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4usv_ovr_0(index, v[0]) else
      z_VertexAttrib4usv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usv(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4usv_ovr_0(index, v);
    private z_VertexAttrib4usv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4usv_ovr_2(index, v);
    
    // added in gl4.3
    private z_VertexAttribBinding_adr := GetProcAddress('glVertexAttribBinding');
    private z_VertexAttribBinding_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; bindingindex: UInt32)>(z_VertexAttribBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribBinding(attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexAttribBinding_ovr_0(attribindex, bindingindex);
    
    // added in gl3.3
    private z_VertexAttribDivisor_adr := GetProcAddress('glVertexAttribDivisor');
    private z_VertexAttribDivisor_ovr_0 := GetProcOrNil&<procedure(index: UInt32; divisor: UInt32)>(z_VertexAttribDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribDivisor(index: UInt32; divisor: UInt32) :=
    z_VertexAttribDivisor_ovr_0(index, divisor);
    
    // added in gl4.3
    private z_VertexAttribFormat_adr := GetProcAddress('glVertexAttribFormat');
    private z_VertexAttribFormat_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexAttribFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribFormat(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexAttribFormat_ovr_0(attribindex, size, &type, normalized, relativeoffset);
    
    // added in gl3.0
    private z_VertexAttribI1i_adr := GetProcAddress('glVertexAttribI1i');
    private z_VertexAttribI1i_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32)>(z_VertexAttribI1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1i(index: UInt32; x: Int32) :=
    z_VertexAttribI1i_ovr_0(index, x);
    
    // added in gl3.0
    private z_VertexAttribI1iv_adr := GetProcAddress('glVertexAttribI1iv');
    private z_VertexAttribI1iv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI1iv_ovr_0(index, v);
    private z_VertexAttribI1iv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1iv_ovr_1(index, v);
    
    // added in gl3.0
    private z_VertexAttribI1ui_adr := GetProcAddress('glVertexAttribI1ui');
    private z_VertexAttribI1ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32)>(z_VertexAttribI1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ui(index: UInt32; x: UInt32) :=
    z_VertexAttribI1ui_ovr_0(index, x);
    
    // added in gl3.0
    private z_VertexAttribI1uiv_adr := GetProcAddress('glVertexAttribI1uiv');
    private z_VertexAttribI1uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI1uiv_ovr_0(index, v);
    private z_VertexAttribI1uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1uiv_ovr_1(index, v);
    
    // added in gl3.0
    private z_VertexAttribI2i_adr := GetProcAddress('glVertexAttribI2i');
    private z_VertexAttribI2i_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32)>(z_VertexAttribI2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2i(index: UInt32; x: Int32; y: Int32) :=
    z_VertexAttribI2i_ovr_0(index, x, y);
    
    // added in gl3.0
    private z_VertexAttribI2iv_adr := GetProcAddress('glVertexAttribI2iv');
    private z_VertexAttribI2iv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI2iv_adr);
    private z_VertexAttribI2iv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2iv_ovr_0(index, v[0]) else
      z_VertexAttribI2iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI2iv_ovr_0(index, v);
    private z_VertexAttribI2iv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI2ui_adr := GetProcAddress('glVertexAttribI2ui');
    private z_VertexAttribI2ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32)>(z_VertexAttribI2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ui(index: UInt32; x: UInt32; y: UInt32) :=
    z_VertexAttribI2ui_ovr_0(index, x, y);
    
    // added in gl3.0
    private z_VertexAttribI2uiv_adr := GetProcAddress('glVertexAttribI2uiv');
    private z_VertexAttribI2uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI2uiv_adr);
    private z_VertexAttribI2uiv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2uiv_ovr_0(index, v[0]) else
      z_VertexAttribI2uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI2uiv_ovr_0(index, v);
    private z_VertexAttribI2uiv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI3i_adr := GetProcAddress('glVertexAttribI3i');
    private z_VertexAttribI3i_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32)>(z_VertexAttribI3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3i(index: UInt32; x: Int32; y: Int32; z: Int32) :=
    z_VertexAttribI3i_ovr_0(index, x, y, z);
    
    // added in gl3.0
    private z_VertexAttribI3iv_adr := GetProcAddress('glVertexAttribI3iv');
    private z_VertexAttribI3iv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI3iv_adr);
    private z_VertexAttribI3iv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3iv_ovr_0(index, v[0]) else
      z_VertexAttribI3iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI3iv_ovr_0(index, v);
    private z_VertexAttribI3iv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI3ui_adr := GetProcAddress('glVertexAttribI3ui');
    private z_VertexAttribI3ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32)>(z_VertexAttribI3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ui(index: UInt32; x: UInt32; y: UInt32; z: UInt32) :=
    z_VertexAttribI3ui_ovr_0(index, x, y, z);
    
    // added in gl3.0
    private z_VertexAttribI3uiv_adr := GetProcAddress('glVertexAttribI3uiv');
    private z_VertexAttribI3uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI3uiv_adr);
    private z_VertexAttribI3uiv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3uiv_ovr_0(index, v[0]) else
      z_VertexAttribI3uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI3uiv_ovr_0(index, v);
    private z_VertexAttribI3uiv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4bv_adr := GetProcAddress('glVertexAttribI4bv');
    private z_VertexAttribI4bv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttribI4bv_adr);
    private z_VertexAttribI4bv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bv(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4bv_ovr_0(index, v[0]) else
      z_VertexAttribI4bv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bv(index: UInt32; var v: SByte) :=
    z_VertexAttribI4bv_ovr_0(index, v);
    private z_VertexAttribI4bv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4bv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4i_adr := GetProcAddress('glVertexAttribI4i');
    private z_VertexAttribI4i_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_VertexAttribI4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4i(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexAttribI4i_ovr_0(index, x, y, z, w);
    
    // added in gl3.0
    private z_VertexAttribI4iv_adr := GetProcAddress('glVertexAttribI4iv');
    private z_VertexAttribI4iv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI4iv_adr);
    private z_VertexAttribI4iv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4iv_ovr_0(index, v[0]) else
      z_VertexAttribI4iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI4iv_ovr_0(index, v);
    private z_VertexAttribI4iv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4sv_adr := GetProcAddress('glVertexAttribI4sv');
    private z_VertexAttribI4sv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttribI4sv_adr);
    private z_VertexAttribI4sv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4sv_ovr_0(index, v[0]) else
      z_VertexAttribI4sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4sv(index: UInt32; var v: Int16) :=
    z_VertexAttribI4sv_ovr_0(index, v);
    private z_VertexAttribI4sv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4sv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4sv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4ubv_adr := GetProcAddress('glVertexAttribI4ubv');
    private z_VertexAttribI4ubv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttribI4ubv_adr);
    private z_VertexAttribI4ubv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubv(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ubv_ovr_0(index, v[0]) else
      z_VertexAttribI4ubv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubv(index: UInt32; var v: Byte) :=
    z_VertexAttribI4ubv_ovr_0(index, v);
    private z_VertexAttribI4ubv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ubv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4ui_adr := GetProcAddress('glVertexAttribI4ui');
    private z_VertexAttribI4ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_VertexAttribI4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ui(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_VertexAttribI4ui_ovr_0(index, x, y, z, w);
    
    // added in gl3.0
    private z_VertexAttribI4uiv_adr := GetProcAddress('glVertexAttribI4uiv');
    private z_VertexAttribI4uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI4uiv_adr);
    private z_VertexAttribI4uiv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4uiv_ovr_0(index, v[0]) else
      z_VertexAttribI4uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI4uiv_ovr_0(index, v);
    private z_VertexAttribI4uiv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4usv_adr := GetProcAddress('glVertexAttribI4usv');
    private z_VertexAttribI4usv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttribI4usv_adr);
    private z_VertexAttribI4usv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usv(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4usv_ovr_0(index, v[0]) else
      z_VertexAttribI4usv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usv(index: UInt32; var v: UInt16) :=
    z_VertexAttribI4usv_ovr_0(index, v);
    private z_VertexAttribI4usv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4usv_ovr_2(index, v);
    
    // added in gl4.3
    private z_VertexAttribIFormat_adr := GetProcAddress('glVertexAttribIFormat');
    private z_VertexAttribIFormat_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexAttribIFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIFormat(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexAttribIFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    // added in gl3.0
    private z_VertexAttribIPointer_adr := GetProcAddress('glVertexAttribIPointer');
    private z_VertexAttribIPointer_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32; pointer: IntPtr)>(z_VertexAttribIPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIPointer(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribIPointer_ovr_0(index, size, &type, stride, pointer);
    
    // added in gl4.1
    private z_VertexAttribL1d_adr := GetProcAddress('glVertexAttribL1d');
    private z_VertexAttribL1d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttribL1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1d(index: UInt32; x: real) :=
    z_VertexAttribL1d_ovr_0(index, x);
    
    // added in gl4.1
    private z_VertexAttribL1dv_adr := GetProcAddress('glVertexAttribL1dv');
    private z_VertexAttribL1dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; var v: real) :=
    z_VertexAttribL1dv_ovr_0(index, v);
    private z_VertexAttribL1dv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1dv_ovr_1(index, v);
    
    // added in gl4.1
    private z_VertexAttribL2d_adr := GetProcAddress('glVertexAttribL2d');
    private z_VertexAttribL2d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttribL2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2d(index: UInt32; x: real; y: real) :=
    z_VertexAttribL2d_ovr_0(index, x, y);
    
    // added in gl4.1
    private z_VertexAttribL2dv_adr := GetProcAddress('glVertexAttribL2dv');
    private z_VertexAttribL2dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL2dv_adr);
    private z_VertexAttribL2dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2dv_ovr_0(index, v[0]) else
      z_VertexAttribL2dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; var v: real) :=
    z_VertexAttribL2dv_ovr_0(index, v);
    private z_VertexAttribL2dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2dv_ovr_2(index, v);
    
    // added in gl4.1
    private z_VertexAttribL3d_adr := GetProcAddress('glVertexAttribL3d');
    private z_VertexAttribL3d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttribL3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3d(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttribL3d_ovr_0(index, x, y, z);
    
    // added in gl4.1
    private z_VertexAttribL3dv_adr := GetProcAddress('glVertexAttribL3dv');
    private z_VertexAttribL3dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL3dv_adr);
    private z_VertexAttribL3dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3dv_ovr_0(index, v[0]) else
      z_VertexAttribL3dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; var v: real) :=
    z_VertexAttribL3dv_ovr_0(index, v);
    private z_VertexAttribL3dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3dv_ovr_2(index, v);
    
    // added in gl4.1
    private z_VertexAttribL4d_adr := GetProcAddress('glVertexAttribL4d');
    private z_VertexAttribL4d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttribL4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4d(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttribL4d_ovr_0(index, x, y, z, w);
    
    // added in gl4.1
    private z_VertexAttribL4dv_adr := GetProcAddress('glVertexAttribL4dv');
    private z_VertexAttribL4dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL4dv_adr);
    private z_VertexAttribL4dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4dv_ovr_0(index, v[0]) else
      z_VertexAttribL4dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; var v: real) :=
    z_VertexAttribL4dv_ovr_0(index, v);
    private z_VertexAttribL4dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4dv_ovr_2(index, v);
    
    // added in gl4.3
    private z_VertexAttribLFormat_adr := GetProcAddress('glVertexAttribLFormat');
    private z_VertexAttribLFormat_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexAttribLFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLFormat(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexAttribLFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    // added in gl4.1
    private z_VertexAttribLPointer_adr := GetProcAddress('glVertexAttribLPointer');
    private z_VertexAttribLPointer_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; pointer: IntPtr)>(z_VertexAttribLPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLPointer(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribLPointer_ovr_0(index, size, &type, stride, pointer);
    
    // added in gl3.3
    private z_VertexAttribP1ui_adr := GetProcAddress('glVertexAttribP1ui');
    private z_VertexAttribP1ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP1ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP1uiv_adr := GetProcAddress('glVertexAttribP1uiv');
    private z_VertexAttribP1uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP1uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP1uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP1uiv_ovr_1(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP2ui_adr := GetProcAddress('glVertexAttribP2ui');
    private z_VertexAttribP2ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP2ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP2uiv_adr := GetProcAddress('glVertexAttribP2uiv');
    private z_VertexAttribP2uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP2uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP2uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP2uiv_ovr_1(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP3ui_adr := GetProcAddress('glVertexAttribP3ui');
    private z_VertexAttribP3ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP3ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP3uiv_adr := GetProcAddress('glVertexAttribP3uiv');
    private z_VertexAttribP3uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP3uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP3uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP3uiv_ovr_1(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP4ui_adr := GetProcAddress('glVertexAttribP4ui');
    private z_VertexAttribP4ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP4ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP4uiv_adr := GetProcAddress('glVertexAttribP4uiv');
    private z_VertexAttribP4uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP4uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP4uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP4uiv_ovr_1(index, &type, normalized, value);
    
    // added in gl2.0
    private z_VertexAttribPointer_adr := GetProcAddress('glVertexAttribPointer');
    private z_VertexAttribPointer_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr)>(z_VertexAttribPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointer(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointer_ovr_0(index, size, &type, normalized, stride, pointer);
    
    // added in gl4.3
    private z_VertexBindingDivisor_adr := GetProcAddress('glVertexBindingDivisor');
    private z_VertexBindingDivisor_ovr_0 := GetProcOrNil&<procedure(bindingindex: UInt32; divisor: UInt32)>(z_VertexBindingDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBindingDivisor(bindingindex: UInt32; divisor: UInt32) :=
    z_VertexBindingDivisor_ovr_0(bindingindex, divisor);
    
    // added in gl3.3
    private z_VertexP2ui_adr := GetProcAddress('glVertexP2ui');
    private z_VertexP2ui_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP2ui_ovr_0(&type, value);
    
    // added in gl3.3
    private z_VertexP2uiv_adr := GetProcAddress('glVertexP2uiv');
    private z_VertexP2uiv_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP2uiv_ovr_0(&type, value);
    private z_VertexP2uiv_ovr_1 := GetProcOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP2uiv_ovr_1(&type, value);
    
    // added in gl3.3
    private z_VertexP3ui_adr := GetProcAddress('glVertexP3ui');
    private z_VertexP3ui_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP3ui_ovr_0(&type, value);
    
    // added in gl3.3
    private z_VertexP3uiv_adr := GetProcAddress('glVertexP3uiv');
    private z_VertexP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP3uiv_ovr_0(&type, value);
    private z_VertexP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP3uiv_ovr_1(&type, value);
    
    // added in gl3.3
    private z_VertexP4ui_adr := GetProcAddress('glVertexP4ui');
    private z_VertexP4ui_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP4ui_ovr_0(&type, value);
    
    // added in gl3.3
    private z_VertexP4uiv_adr := GetProcAddress('glVertexP4uiv');
    private z_VertexP4uiv_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP4uiv_ovr_0(&type, value);
    private z_VertexP4uiv_ovr_1 := GetProcOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP4uiv_ovr_1(&type, value);
    
    // added in gl1.0
    private z_Viewport_adr := GetProcAddress('glViewport');
    private z_Viewport_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32)>(z_Viewport_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Viewport(x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_Viewport_ovr_0(x, y, width, height);
    
    // added in gl4.1
    private z_ViewportArrayv_adr := GetProcAddress('glViewportArrayv');
    private z_ViewportArrayv_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: single)>(z_ViewportArrayv_adr);
    private z_ViewportArrayv_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ViewportArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportArrayv_ovr_0(first, count, v[0]) else
      z_ViewportArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; var v: single) :=
    z_ViewportArrayv_ovr_0(first, count, v);
    private z_ViewportArrayv_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ViewportArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ViewportArrayv_ovr_2(first, count, v);
    
    // added in gl4.1
    private z_ViewportIndexedf_adr := GetProcAddress('glViewportIndexedf');
    private z_ViewportIndexedf_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; w: single; h: single)>(z_ViewportIndexedf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedf(index: UInt32; x: single; y: single; w: single; h: single) :=
    z_ViewportIndexedf_ovr_0(index, x, y, w, h);
    
    // added in gl4.1
    private z_ViewportIndexedfv_adr := GetProcAddress('glViewportIndexedfv');
    private z_ViewportIndexedfv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_ViewportIndexedfv_adr);
    private z_ViewportIndexedfv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ViewportIndexedfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportIndexedfv_ovr_0(index, v[0]) else
      z_ViewportIndexedfv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; var v: single) :=
    z_ViewportIndexedfv_ovr_0(index, v);
    private z_ViewportIndexedfv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ViewportIndexedfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: IntPtr) :=
    z_ViewportIndexedfv_ovr_2(index, v);
    
    // added in gl3.2
    private z_WaitSync_adr := GetProcAddress('glWaitSync');
    private z_WaitSync_ovr_0 := GetProcOrNil&<procedure(sync: gl_sync; flags: DummyFlags; timeout: UInt64)>(z_WaitSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSync(sync: gl_sync; flags: DummyFlags; timeout: UInt64) :=
    z_WaitSync_ovr_0(sync, flags, timeout);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Accum_adr := GetProcAddress('glAccum');
    private z_Accum_ovr_0 := GetProcOrNil&<procedure(op: AccumOp; value: single)>(z_Accum_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Accum(op: AccumOp; value: single) :=
    z_Accum_ovr_0(op, value);
    
    // added in gl1.0, deprecated in gl3.2
    private z_AlphaFunc_adr := GetProcAddress('glAlphaFunc');
    private z_AlphaFunc_ovr_0 := GetProcOrNil&<procedure(func: AlphaFunction; ref: single)>(z_AlphaFunc_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFunc(func: AlphaFunction; ref: single) :=
    z_AlphaFunc_ovr_0(func, ref);
    
    // added in gl1.1, deprecated in gl3.2
    private z_AreTexturesResident_adr := GetProcAddress('glAreTexturesResident');
    private z_AreTexturesResident_ovr_0 := GetProcOrNil&<function(n: Int32; var textures: gl_texture; var residences: boolean): boolean>(z_AreTexturesResident_adr);
    private z_AreTexturesResident_ovr_0_anh0010 := GetProcOrNil&<function(n: Int32; textures: IntPtr; var residences: boolean): boolean>(z_AreTexturesResident_adr);
    private z_AreTexturesResident_ovr_0_anh0001 := GetProcOrNil&<function(n: Int32; var textures: gl_texture; residences: IntPtr): boolean>(z_AreTexturesResident_adr);
    private z_AreTexturesResident_ovr_0_anh0011 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResident_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: array of gl_texture; residences: array of boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResident_ovr_0(n, textures[0], residences[0]) else
        z_AreTexturesResident_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResident_ovr_0_anh0010(n, IntPtr.Zero, residences[0]) else
        z_AreTexturesResident_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private z_AreTexturesResident_ovr_1_anh0010 := GetProcOrNil&<function(n: Int32; textures: IntPtr; var residences: boolean): boolean>(z_AreTexturesResident_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: array of gl_texture; var residences: boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResident_ovr_0(n, textures[0], residences) else
      z_AreTexturesResident_ovr_0_anh0010(n, IntPtr.Zero, residences);
    private z_AreTexturesResident_ovr_2 := GetProcOrNil&<function(n: Int32; var textures: gl_texture; residences: IntPtr): boolean>(z_AreTexturesResident_adr);
    private z_AreTexturesResident_ovr_2_anh0010 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResident_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: array of gl_texture; residences: IntPtr): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResident_ovr_2(n, textures[0], residences) else
      z_AreTexturesResident_ovr_2_anh0010(n, IntPtr.Zero, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; var textures: gl_texture; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResident_ovr_0(n, textures, residences[0]) else
      z_AreTexturesResident_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; var textures: gl_texture; var residences: boolean): boolean :=
    z_AreTexturesResident_ovr_0(n, textures, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; var textures: gl_texture; residences: IntPtr): boolean :=
    z_AreTexturesResident_ovr_2(n, textures, residences);
    private z_AreTexturesResident_ovr_6 := GetProcOrNil&<function(n: Int32; textures: IntPtr; var residences: boolean): boolean>(z_AreTexturesResident_adr);
    private z_AreTexturesResident_ovr_6_anh0001 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResident_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: IntPtr; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResident_ovr_6(n, textures, residences[0]) else
      z_AreTexturesResident_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: IntPtr; var residences: boolean): boolean :=
    z_AreTexturesResident_ovr_6(n, textures, residences);
    private z_AreTexturesResident_ovr_8 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResident_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: IntPtr; residences: IntPtr): boolean :=
    z_AreTexturesResident_ovr_8(n, textures, residences);
    
    // added in gl1.1, deprecated in gl3.2
    private z_ArrayElement_adr := GetProcAddress('glArrayElement');
    private z_ArrayElement_ovr_0 := GetProcOrNil&<procedure(i: Int32)>(z_ArrayElement_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ArrayElement(i: Int32) :=
    z_ArrayElement_ovr_0(i);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Begin_adr := GetProcAddress('glBegin');
    private z_Begin_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType)>(z_Begin_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure &Begin(mode: PrimitiveType) :=
    z_Begin_ovr_0(mode);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Bitmap_adr := GetProcAddress('glBitmap');
    private z_Bitmap_ovr_0 := GetProcOrNil&<procedure(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; var bitmap: Byte)>(z_Bitmap_adr);
    private z_Bitmap_ovr_0_anh00000001 := GetProcOrNil&<procedure(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: IntPtr)>(z_Bitmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Bitmap(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: array of Byte) :=
    if (bitmap<>nil) and (bitmap.Length<>0) then
      z_Bitmap_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap[0]) else
      z_Bitmap_ovr_0_anh00000001(width, height, xorig, yorig, xmove, ymove, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Bitmap(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; var bitmap: Byte) :=
    z_Bitmap_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap);
    private z_Bitmap_ovr_2 := GetProcOrNil&<procedure(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: IntPtr)>(z_Bitmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Bitmap(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: IntPtr) :=
    z_Bitmap_ovr_2(width, height, xorig, yorig, xmove, ymove, bitmap);
    
    // added in gl1.0, deprecated in gl3.2
    private z_CallList_adr := GetProcAddress('glCallList');
    private z_CallList_ovr_0 := GetProcOrNil&<procedure(list: UInt32)>(z_CallList_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CallList(list: UInt32) :=
    z_CallList_ovr_0(list);
    
    // added in gl1.0, deprecated in gl3.2
    private z_CallLists_adr := GetProcAddress('glCallLists');
    private z_CallLists_ovr_0 := GetProcOrNil&<procedure(n: Int32; &type: ListNameType; lists: IntPtr)>(z_CallLists_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CallLists(n: Int32; &type: ListNameType; lists: IntPtr) :=
    z_CallLists_ovr_0(n, &type, lists);
    
    // added in gl1.0, deprecated in gl3.2
    private z_ClearAccum_adr := GetProcAddress('glClearAccum');
    private z_ClearAccum_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_ClearAccum_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearAccum(red: single; green: single; blue: single; alpha: single) :=
    z_ClearAccum_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_ClearIndex_adr := GetProcAddress('glClearIndex');
    private z_ClearIndex_ovr_0 := GetProcOrNil&<procedure(c: single)>(z_ClearIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearIndex(c: single) :=
    z_ClearIndex_ovr_0(c);
    
    // added in gl1.3, deprecated in gl3.2
    private z_ClientActiveTexture_adr := GetProcAddress('glClientActiveTexture');
    private z_ClientActiveTexture_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit)>(z_ClientActiveTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientActiveTexture(texture: TextureUnit) :=
    z_ClientActiveTexture_ovr_0(texture);
    
    // added in gl1.0, deprecated in gl3.2
    private z_ClipPlane_adr := GetProcAddress('glClipPlane');
    private z_ClipPlane_ovr_0 := GetProcOrNil&<procedure(plane: ClipPlaneName; var equation: real)>(z_ClipPlane_adr);
    private z_ClipPlane_ovr_0_anh001 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_ClipPlane_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlane(plane: ClipPlaneName; equation: array of real) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ClipPlane_ovr_0(plane, equation[0]) else
      z_ClipPlane_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlane(plane: ClipPlaneName; var equation: real) :=
    z_ClipPlane_ovr_0(plane, equation);
    private z_ClipPlane_ovr_2 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_ClipPlane_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlane(plane: ClipPlaneName; equation: IntPtr) :=
    z_ClipPlane_ovr_2(plane, equation);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3b_adr := GetProcAddress('glColor3b');
    private z_Color3b_ovr_0 := GetProcOrNil&<procedure(red: SByte; green: SByte; blue: SByte)>(z_Color3b_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3b(red: SByte; green: SByte; blue: SByte) :=
    z_Color3b_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3bv_adr := GetProcAddress('glColor3bv');
    private z_Color3bv_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_Color3bv_adr);
    private z_Color3bv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3bv_ovr_0(v[0]) else
      z_Color3bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3bv(var v: SByte) :=
    z_Color3bv_ovr_0(v);
    private z_Color3bv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3bv(v: IntPtr) :=
    z_Color3bv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3d_adr := GetProcAddress('glColor3d');
    private z_Color3d_ovr_0 := GetProcOrNil&<procedure(red: real; green: real; blue: real)>(z_Color3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3d(red: real; green: real; blue: real) :=
    z_Color3d_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3dv_adr := GetProcAddress('glColor3dv');
    private z_Color3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Color3dv_adr);
    private z_Color3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3dv_ovr_0(v[0]) else
      z_Color3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3dv(var v: real) :=
    z_Color3dv_ovr_0(v);
    private z_Color3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3dv(v: IntPtr) :=
    z_Color3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3f_adr := GetProcAddress('glColor3f');
    private z_Color3f_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single)>(z_Color3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3f(red: single; green: single; blue: single) :=
    z_Color3f_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3fv_adr := GetProcAddress('glColor3fv');
    private z_Color3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Color3fv_adr);
    private z_Color3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3fv_ovr_0(v[0]) else
      z_Color3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fv(var v: single) :=
    z_Color3fv_ovr_0(v);
    private z_Color3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fv(v: IntPtr) :=
    z_Color3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3i_adr := GetProcAddress('glColor3i');
    private z_Color3i_ovr_0 := GetProcOrNil&<procedure(red: Int32; green: Int32; blue: Int32)>(z_Color3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3i(red: Int32; green: Int32; blue: Int32) :=
    z_Color3i_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3iv_adr := GetProcAddress('glColor3iv');
    private z_Color3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Color3iv_adr);
    private z_Color3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3iv_ovr_0(v[0]) else
      z_Color3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3iv(var v: Int32) :=
    z_Color3iv_ovr_0(v);
    private z_Color3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3iv(v: IntPtr) :=
    z_Color3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3s_adr := GetProcAddress('glColor3s');
    private z_Color3s_ovr_0 := GetProcOrNil&<procedure(red: Int16; green: Int16; blue: Int16)>(z_Color3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3s(red: Int16; green: Int16; blue: Int16) :=
    z_Color3s_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3sv_adr := GetProcAddress('glColor3sv');
    private z_Color3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Color3sv_adr);
    private z_Color3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3sv_ovr_0(v[0]) else
      z_Color3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3sv(var v: Int16) :=
    z_Color3sv_ovr_0(v);
    private z_Color3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3sv(v: IntPtr) :=
    z_Color3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3ub_adr := GetProcAddress('glColor3ub');
    private z_Color3ub_ovr_0 := GetProcOrNil&<procedure(red: Byte; green: Byte; blue: Byte)>(z_Color3ub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ub(red: Byte; green: Byte; blue: Byte) :=
    z_Color3ub_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3ubv_adr := GetProcAddress('glColor3ubv');
    private z_Color3ubv_ovr_0 := GetProcOrNil&<procedure(var v: Byte)>(z_Color3ubv_adr);
    private z_Color3ubv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ubv(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3ubv_ovr_0(v[0]) else
      z_Color3ubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ubv(var v: Byte) :=
    z_Color3ubv_ovr_0(v);
    private z_Color3ubv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ubv(v: IntPtr) :=
    z_Color3ubv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3ui_adr := GetProcAddress('glColor3ui');
    private z_Color3ui_ovr_0 := GetProcOrNil&<procedure(red: UInt32; green: UInt32; blue: UInt32)>(z_Color3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ui(red: UInt32; green: UInt32; blue: UInt32) :=
    z_Color3ui_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3uiv_adr := GetProcAddress('glColor3uiv');
    private z_Color3uiv_ovr_0 := GetProcOrNil&<procedure(var v: UInt32)>(z_Color3uiv_adr);
    private z_Color3uiv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3uiv(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3uiv_ovr_0(v[0]) else
      z_Color3uiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3uiv(var v: UInt32) :=
    z_Color3uiv_ovr_0(v);
    private z_Color3uiv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3uiv(v: IntPtr) :=
    z_Color3uiv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3us_adr := GetProcAddress('glColor3us');
    private z_Color3us_ovr_0 := GetProcOrNil&<procedure(red: UInt16; green: UInt16; blue: UInt16)>(z_Color3us_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3us(red: UInt16; green: UInt16; blue: UInt16) :=
    z_Color3us_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color3usv_adr := GetProcAddress('glColor3usv');
    private z_Color3usv_ovr_0 := GetProcOrNil&<procedure(var v: UInt16)>(z_Color3usv_adr);
    private z_Color3usv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3usv(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3usv_ovr_0(v[0]) else
      z_Color3usv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3usv(var v: UInt16) :=
    z_Color3usv_ovr_0(v);
    private z_Color3usv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3usv(v: IntPtr) :=
    z_Color3usv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4b_adr := GetProcAddress('glColor4b');
    private z_Color4b_ovr_0 := GetProcOrNil&<procedure(red: SByte; green: SByte; blue: SByte; alpha: SByte)>(z_Color4b_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4b(red: SByte; green: SByte; blue: SByte; alpha: SByte) :=
    z_Color4b_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4bv_adr := GetProcAddress('glColor4bv');
    private z_Color4bv_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_Color4bv_adr);
    private z_Color4bv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4bv_ovr_0(v[0]) else
      z_Color4bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4bv(var v: SByte) :=
    z_Color4bv_ovr_0(v);
    private z_Color4bv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4bv(v: IntPtr) :=
    z_Color4bv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4d_adr := GetProcAddress('glColor4d');
    private z_Color4d_ovr_0 := GetProcOrNil&<procedure(red: real; green: real; blue: real; alpha: real)>(z_Color4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4d(red: real; green: real; blue: real; alpha: real) :=
    z_Color4d_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4dv_adr := GetProcAddress('glColor4dv');
    private z_Color4dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Color4dv_adr);
    private z_Color4dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4dv_ovr_0(v[0]) else
      z_Color4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4dv(var v: real) :=
    z_Color4dv_ovr_0(v);
    private z_Color4dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4dv(v: IntPtr) :=
    z_Color4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4f_adr := GetProcAddress('glColor4f');
    private z_Color4f_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_Color4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4f(red: single; green: single; blue: single; alpha: single) :=
    z_Color4f_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4fv_adr := GetProcAddress('glColor4fv');
    private z_Color4fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Color4fv_adr);
    private z_Color4fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4fv_ovr_0(v[0]) else
      z_Color4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fv(var v: single) :=
    z_Color4fv_ovr_0(v);
    private z_Color4fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fv(v: IntPtr) :=
    z_Color4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4i_adr := GetProcAddress('glColor4i');
    private z_Color4i_ovr_0 := GetProcOrNil&<procedure(red: Int32; green: Int32; blue: Int32; alpha: Int32)>(z_Color4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4i(red: Int32; green: Int32; blue: Int32; alpha: Int32) :=
    z_Color4i_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4iv_adr := GetProcAddress('glColor4iv');
    private z_Color4iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Color4iv_adr);
    private z_Color4iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4iv_ovr_0(v[0]) else
      z_Color4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4iv(var v: Int32) :=
    z_Color4iv_ovr_0(v);
    private z_Color4iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4iv(v: IntPtr) :=
    z_Color4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4s_adr := GetProcAddress('glColor4s');
    private z_Color4s_ovr_0 := GetProcOrNil&<procedure(red: Int16; green: Int16; blue: Int16; alpha: Int16)>(z_Color4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4s(red: Int16; green: Int16; blue: Int16; alpha: Int16) :=
    z_Color4s_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4sv_adr := GetProcAddress('glColor4sv');
    private z_Color4sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Color4sv_adr);
    private z_Color4sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4sv_ovr_0(v[0]) else
      z_Color4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4sv(var v: Int16) :=
    z_Color4sv_ovr_0(v);
    private z_Color4sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4sv(v: IntPtr) :=
    z_Color4sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4ub_adr := GetProcAddress('glColor4ub');
    private z_Color4ub_ovr_0 := GetProcOrNil&<procedure(red: Byte; green: Byte; blue: Byte; alpha: Byte)>(z_Color4ub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ub(red: Byte; green: Byte; blue: Byte; alpha: Byte) :=
    z_Color4ub_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4ubv_adr := GetProcAddress('glColor4ubv');
    private z_Color4ubv_ovr_0 := GetProcOrNil&<procedure(var v: Byte)>(z_Color4ubv_adr);
    private z_Color4ubv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubv(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4ubv_ovr_0(v[0]) else
      z_Color4ubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubv(var v: Byte) :=
    z_Color4ubv_ovr_0(v);
    private z_Color4ubv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubv(v: IntPtr) :=
    z_Color4ubv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4ui_adr := GetProcAddress('glColor4ui');
    private z_Color4ui_ovr_0 := GetProcOrNil&<procedure(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32)>(z_Color4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ui(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32) :=
    z_Color4ui_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4uiv_adr := GetProcAddress('glColor4uiv');
    private z_Color4uiv_ovr_0 := GetProcOrNil&<procedure(var v: UInt32)>(z_Color4uiv_adr);
    private z_Color4uiv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4uiv(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4uiv_ovr_0(v[0]) else
      z_Color4uiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4uiv(var v: UInt32) :=
    z_Color4uiv_ovr_0(v);
    private z_Color4uiv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4uiv(v: IntPtr) :=
    z_Color4uiv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4us_adr := GetProcAddress('glColor4us');
    private z_Color4us_ovr_0 := GetProcOrNil&<procedure(red: UInt16; green: UInt16; blue: UInt16; alpha: UInt16)>(z_Color4us_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4us(red: UInt16; green: UInt16; blue: UInt16; alpha: UInt16) :=
    z_Color4us_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Color4usv_adr := GetProcAddress('glColor4usv');
    private z_Color4usv_ovr_0 := GetProcOrNil&<procedure(var v: UInt16)>(z_Color4usv_adr);
    private z_Color4usv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4usv(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4usv_ovr_0(v[0]) else
      z_Color4usv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4usv(var v: UInt16) :=
    z_Color4usv_ovr_0(v);
    private z_Color4usv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4usv(v: IntPtr) :=
    z_Color4usv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_ColorMaterial_adr := GetProcAddress('glColorMaterial');
    private z_ColorMaterial_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; mode: ColorMaterialParameter)>(z_ColorMaterial_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMaterial(face: MaterialFace; mode: ColorMaterialParameter) :=
    z_ColorMaterial_ovr_0(face, mode);
    
    // added in gl1.1, deprecated in gl3.2
    private z_ColorPointer_adr := GetProcAddress('glColorPointer');
    private z_ColorPointer_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr)>(z_ColorPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointer(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr) :=
    z_ColorPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_CopyPixels_adr := GetProcAddress('glCopyPixels');
    private z_CopyPixels_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32; &type: PixelCopyType)>(z_CopyPixels_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyPixels(x: Int32; y: Int32; width: Int32; height: Int32; &type: PixelCopyType) :=
    z_CopyPixels_ovr_0(x, y, width, height, &type);
    
    // added in gl1.0, deprecated in gl3.2
    private z_DeleteLists_adr := GetProcAddress('glDeleteLists');
    private z_DeleteLists_ovr_0 := GetProcOrNil&<procedure(list: gl_display_list; range: Int32)>(z_DeleteLists_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteLists(list: gl_display_list; range: Int32) :=
    z_DeleteLists_ovr_0(list, range);
    
    // added in gl1.1, deprecated in gl3.2
    private z_DisableClientState_adr := GetProcAddress('glDisableClientState');
    private z_DisableClientState_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap)>(z_DisableClientState_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableClientState(&array: EnableCap) :=
    z_DisableClientState_ovr_0(&array);
    
    // added in gl1.0, deprecated in gl3.2
    private z_DrawPixels_adr := GetProcAddress('glDrawPixels');
    private z_DrawPixels_ovr_0 := GetProcOrNil&<procedure(width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_DrawPixels_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawPixels(width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_DrawPixels_ovr_0(width, height, format, &type, pixels);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EdgeFlag_adr := GetProcAddress('glEdgeFlag');
    private z_EdgeFlag_ovr_0 := GetProcOrNil&<procedure(flag: boolean)>(z_EdgeFlag_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlag(flag: boolean) :=
    z_EdgeFlag_ovr_0(flag);
    
    // added in gl1.1, deprecated in gl3.2
    private z_EdgeFlagPointer_adr := GetProcAddress('glEdgeFlagPointer');
    private z_EdgeFlagPointer_ovr_0 := GetProcOrNil&<procedure(stride: Int32; pointer: IntPtr)>(z_EdgeFlagPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointer(stride: Int32; pointer: IntPtr) :=
    z_EdgeFlagPointer_ovr_0(stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EdgeFlagv_adr := GetProcAddress('glEdgeFlagv');
    private z_EdgeFlagv_ovr_0 := GetProcOrNil&<procedure(var flag: boolean)>(z_EdgeFlagv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagv(var flag: boolean) :=
    z_EdgeFlagv_ovr_0(flag);
    private z_EdgeFlagv_ovr_1 := GetProcOrNil&<procedure(flag: IntPtr)>(z_EdgeFlagv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagv(flag: IntPtr) :=
    z_EdgeFlagv_ovr_1(flag);
    
    // added in gl1.1, deprecated in gl3.2
    private z_EnableClientState_adr := GetProcAddress('glEnableClientState');
    private z_EnableClientState_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap)>(z_EnableClientState_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableClientState(&array: EnableCap) :=
    z_EnableClientState_ovr_0(&array);
    
    // added in gl1.0, deprecated in gl3.2
    private z_End_adr := GetProcAddress('glEnd');
    private z_End_ovr_0 := GetProcOrNil&<procedure>(z_End_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure &End :=
    z_End_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private z_EndList_adr := GetProcAddress('glEndList');
    private z_EndList_ovr_0 := GetProcOrNil&<procedure>(z_EndList_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndList :=
    z_EndList_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord1d_adr := GetProcAddress('glEvalCoord1d');
    private z_EvalCoord1d_ovr_0 := GetProcOrNil&<procedure(u: real)>(z_EvalCoord1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1d(u: real) :=
    z_EvalCoord1d_ovr_0(u);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord1dv_adr := GetProcAddress('glEvalCoord1dv');
    private z_EvalCoord1dv_ovr_0 := GetProcOrNil&<procedure(var u: real)>(z_EvalCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1dv(var u: real) :=
    z_EvalCoord1dv_ovr_0(u);
    private z_EvalCoord1dv_ovr_1 := GetProcOrNil&<procedure(u: IntPtr)>(z_EvalCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1dv(u: IntPtr) :=
    z_EvalCoord1dv_ovr_1(u);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord1f_adr := GetProcAddress('glEvalCoord1f');
    private z_EvalCoord1f_ovr_0 := GetProcOrNil&<procedure(u: single)>(z_EvalCoord1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1f(u: single) :=
    z_EvalCoord1f_ovr_0(u);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord1fv_adr := GetProcAddress('glEvalCoord1fv');
    private z_EvalCoord1fv_ovr_0 := GetProcOrNil&<procedure(var u: single)>(z_EvalCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1fv(var u: single) :=
    z_EvalCoord1fv_ovr_0(u);
    private z_EvalCoord1fv_ovr_1 := GetProcOrNil&<procedure(u: IntPtr)>(z_EvalCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1fv(u: IntPtr) :=
    z_EvalCoord1fv_ovr_1(u);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord2d_adr := GetProcAddress('glEvalCoord2d');
    private z_EvalCoord2d_ovr_0 := GetProcOrNil&<procedure(u: real; v: real)>(z_EvalCoord2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2d(u: real; v: real) :=
    z_EvalCoord2d_ovr_0(u, v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord2dv_adr := GetProcAddress('glEvalCoord2dv');
    private z_EvalCoord2dv_ovr_0 := GetProcOrNil&<procedure(var u: real)>(z_EvalCoord2dv_adr);
    private z_EvalCoord2dv_ovr_0_anh01 := GetProcOrNil&<procedure(u: IntPtr)>(z_EvalCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2dv(u: array of real) :=
    if (u<>nil) and (u.Length<>0) then
      z_EvalCoord2dv_ovr_0(u[0]) else
      z_EvalCoord2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2dv(var u: real) :=
    z_EvalCoord2dv_ovr_0(u);
    private z_EvalCoord2dv_ovr_2 := GetProcOrNil&<procedure(u: IntPtr)>(z_EvalCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2dv(u: IntPtr) :=
    z_EvalCoord2dv_ovr_2(u);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord2f_adr := GetProcAddress('glEvalCoord2f');
    private z_EvalCoord2f_ovr_0 := GetProcOrNil&<procedure(u: single; v: single)>(z_EvalCoord2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2f(u: single; v: single) :=
    z_EvalCoord2f_ovr_0(u, v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalCoord2fv_adr := GetProcAddress('glEvalCoord2fv');
    private z_EvalCoord2fv_ovr_0 := GetProcOrNil&<procedure(var u: single)>(z_EvalCoord2fv_adr);
    private z_EvalCoord2fv_ovr_0_anh01 := GetProcOrNil&<procedure(u: IntPtr)>(z_EvalCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2fv(u: array of single) :=
    if (u<>nil) and (u.Length<>0) then
      z_EvalCoord2fv_ovr_0(u[0]) else
      z_EvalCoord2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2fv(var u: single) :=
    z_EvalCoord2fv_ovr_0(u);
    private z_EvalCoord2fv_ovr_2 := GetProcOrNil&<procedure(u: IntPtr)>(z_EvalCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2fv(u: IntPtr) :=
    z_EvalCoord2fv_ovr_2(u);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalMesh1_adr := GetProcAddress('glEvalMesh1');
    private z_EvalMesh1_ovr_0 := GetProcOrNil&<procedure(mode: MeshMode1; i1: Int32; i2: Int32)>(z_EvalMesh1_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalMesh1(mode: MeshMode1; i1: Int32; i2: Int32) :=
    z_EvalMesh1_ovr_0(mode, i1, i2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalMesh2_adr := GetProcAddress('glEvalMesh2');
    private z_EvalMesh2_ovr_0 := GetProcOrNil&<procedure(mode: MeshMode2; i1: Int32; i2: Int32; j1: Int32; j2: Int32)>(z_EvalMesh2_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalMesh2(mode: MeshMode2; i1: Int32; i2: Int32; j1: Int32; j2: Int32) :=
    z_EvalMesh2_ovr_0(mode, i1, i2, j1, j2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalPoint1_adr := GetProcAddress('glEvalPoint1');
    private z_EvalPoint1_ovr_0 := GetProcOrNil&<procedure(i: Int32)>(z_EvalPoint1_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalPoint1(i: Int32) :=
    z_EvalPoint1_ovr_0(i);
    
    // added in gl1.0, deprecated in gl3.2
    private z_EvalPoint2_adr := GetProcAddress('glEvalPoint2');
    private z_EvalPoint2_ovr_0 := GetProcOrNil&<procedure(i: Int32; j: Int32)>(z_EvalPoint2_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalPoint2(i: Int32; j: Int32) :=
    z_EvalPoint2_ovr_0(i, j);
    
    // added in gl1.0, deprecated in gl3.2
    private z_FeedbackBuffer_adr := GetProcAddress('glFeedbackBuffer');
    private z_FeedbackBuffer_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: FeedbackType; var buffer: single)>(z_FeedbackBuffer_adr);
    private z_FeedbackBuffer_ovr_0_anh0001 := GetProcOrNil&<procedure(size: Int32; &type: FeedbackType; buffer: IntPtr)>(z_FeedbackBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBuffer(size: Int32; &type: FeedbackType; buffer: array of single) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_FeedbackBuffer_ovr_0(size, &type, buffer[0]) else
      z_FeedbackBuffer_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBuffer(size: Int32; &type: FeedbackType; var buffer: single) :=
    z_FeedbackBuffer_ovr_0(size, &type, buffer);
    private z_FeedbackBuffer_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: FeedbackType; buffer: IntPtr)>(z_FeedbackBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBuffer(size: Int32; &type: FeedbackType; buffer: IntPtr) :=
    z_FeedbackBuffer_ovr_2(size, &type, buffer);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordd_adr := GetProcAddress('glFogCoordd');
    private z_FogCoordd_ovr_0 := GetProcOrNil&<procedure(coord: real)>(z_FogCoordd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordd(coord: real) :=
    z_FogCoordd_ovr_0(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoorddv_adr := GetProcAddress('glFogCoorddv');
    private z_FogCoorddv_ovr_0 := GetProcOrNil&<procedure(var coord: real)>(z_FogCoorddv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddv(var coord: real) :=
    z_FogCoorddv_ovr_0(coord);
    private z_FogCoorddv_ovr_1 := GetProcOrNil&<procedure(coord: IntPtr)>(z_FogCoorddv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddv(coord: IntPtr) :=
    z_FogCoorddv_ovr_1(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordf_adr := GetProcAddress('glFogCoordf');
    private z_FogCoordf_ovr_0 := GetProcOrNil&<procedure(coord: single)>(z_FogCoordf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordf(coord: single) :=
    z_FogCoordf_ovr_0(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordfv_adr := GetProcAddress('glFogCoordfv');
    private z_FogCoordfv_ovr_0 := GetProcOrNil&<procedure(var coord: single)>(z_FogCoordfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfv(var coord: single) :=
    z_FogCoordfv_ovr_0(coord);
    private z_FogCoordfv_ovr_1 := GetProcOrNil&<procedure(coord: IntPtr)>(z_FogCoordfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfv(coord: IntPtr) :=
    z_FogCoordfv_ovr_1(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordPointer_adr := GetProcAddress('glFogCoordPointer');
    private z_FogCoordPointer_ovr_0 := GetProcOrNil&<procedure(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr)>(z_FogCoordPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointer(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_FogCoordPointer_ovr_0(&type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Fogf_adr := GetProcAddress('glFogf');
    private z_Fogf_ovr_0 := GetProcOrNil&<procedure(pname: FogParameter; param: single)>(z_Fogf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogf(pname: FogParameter; param: single) :=
    z_Fogf_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Fogfv_adr := GetProcAddress('glFogfv');
    private z_Fogfv_ovr_0 := GetProcOrNil&<procedure(pname: FogParameter; var &params: single)>(z_Fogfv_adr);
    private z_Fogfv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: FogParameter; &params: IntPtr)>(z_Fogfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogfv(pname: FogParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Fogfv_ovr_0(pname, &params[0]) else
      z_Fogfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogfv(pname: FogParameter; var &params: single) :=
    z_Fogfv_ovr_0(pname, &params);
    private z_Fogfv_ovr_2 := GetProcOrNil&<procedure(pname: FogParameter; &params: IntPtr)>(z_Fogfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogfv(pname: FogParameter; &params: IntPtr) :=
    z_Fogfv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Fogi_adr := GetProcAddress('glFogi');
    private z_Fogi_ovr_0 := GetProcOrNil&<procedure(pname: FogParameter; param: Int32)>(z_Fogi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogi(pname: FogParameter; param: Int32) :=
    z_Fogi_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Fogiv_adr := GetProcAddress('glFogiv');
    private z_Fogiv_ovr_0 := GetProcOrNil&<procedure(pname: FogParameter; var &params: Int32)>(z_Fogiv_adr);
    private z_Fogiv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: FogParameter; &params: IntPtr)>(z_Fogiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogiv(pname: FogParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Fogiv_ovr_0(pname, &params[0]) else
      z_Fogiv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogiv(pname: FogParameter; var &params: Int32) :=
    z_Fogiv_ovr_0(pname, &params);
    private z_Fogiv_ovr_2 := GetProcOrNil&<procedure(pname: FogParameter; &params: IntPtr)>(z_Fogiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogiv(pname: FogParameter; &params: IntPtr) :=
    z_Fogiv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Frustum_adr := GetProcAddress('glFrustum');
    private z_Frustum_ovr_0 := GetProcOrNil&<procedure(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real)>(z_Frustum_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Frustum(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_Frustum_ovr_0(left, right, bottom, top, zNear, zFar);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GenLists_adr := GetProcAddress('glGenLists');
    private z_GenLists_ovr_0 := GetProcOrNil&<function(range: Int32): gl_display_list>(z_GenLists_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenLists(range: Int32): gl_display_list :=
    z_GenLists_ovr_0(range);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetClipPlane_adr := GetProcAddress('glGetClipPlane');
    private z_GetClipPlane_ovr_0 := GetProcOrNil&<procedure(plane: ClipPlaneName; var equation: real)>(z_GetClipPlane_adr);
    private z_GetClipPlane_ovr_0_anh001 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_GetClipPlane_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlane(plane: ClipPlaneName; equation: array of real) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_GetClipPlane_ovr_0(plane, equation[0]) else
      z_GetClipPlane_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlane(plane: ClipPlaneName; var equation: real) :=
    z_GetClipPlane_ovr_0(plane, equation);
    private z_GetClipPlane_ovr_2 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_GetClipPlane_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlane(plane: ClipPlaneName; equation: IntPtr) :=
    z_GetClipPlane_ovr_2(plane, equation);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetLightfv_adr := GetProcAddress('glGetLightfv');
    private z_GetLightfv_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; var &params: single)>(z_GetLightfv_adr);
    private z_GetLightfv_ovr_0_anh0001 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_GetLightfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightfv(light: LightName; pname: LightParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetLightfv_ovr_0(light, pname, &params[0]) else
      z_GetLightfv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightfv(light: LightName; pname: LightParameter; var &params: single) :=
    z_GetLightfv_ovr_0(light, pname, &params);
    private z_GetLightfv_ovr_2 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_GetLightfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightfv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_GetLightfv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetLightiv_adr := GetProcAddress('glGetLightiv');
    private z_GetLightiv_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; var &params: Int32)>(z_GetLightiv_adr);
    private z_GetLightiv_ovr_0_anh0001 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_GetLightiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightiv(light: LightName; pname: LightParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetLightiv_ovr_0(light, pname, &params[0]) else
      z_GetLightiv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightiv(light: LightName; pname: LightParameter; var &params: Int32) :=
    z_GetLightiv_ovr_0(light, pname, &params);
    private z_GetLightiv_ovr_2 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_GetLightiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightiv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_GetLightiv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetMapdv_adr := GetProcAddress('glGetMapdv');
    private z_GetMapdv_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; var v: real)>(z_GetMapdv_adr);
    private z_GetMapdv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapdv(target: MapTarget; query: GetMapQuery; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapdv_ovr_0(target, query, v[0]) else
      z_GetMapdv_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapdv(target: MapTarget; query: GetMapQuery; var v: real) :=
    z_GetMapdv_ovr_0(target, query, v);
    private z_GetMapdv_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapdv(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapdv_ovr_2(target, query, v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetMapfv_adr := GetProcAddress('glGetMapfv');
    private z_GetMapfv_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; var v: single)>(z_GetMapfv_adr);
    private z_GetMapfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapfv(target: MapTarget; query: GetMapQuery; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapfv_ovr_0(target, query, v[0]) else
      z_GetMapfv_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapfv(target: MapTarget; query: GetMapQuery; var v: single) :=
    z_GetMapfv_ovr_0(target, query, v);
    private z_GetMapfv_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapfv(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapfv_ovr_2(target, query, v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetMapiv_adr := GetProcAddress('glGetMapiv');
    private z_GetMapiv_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; var v: Int32)>(z_GetMapiv_adr);
    private z_GetMapiv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapiv(target: MapTarget; query: GetMapQuery; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapiv_ovr_0(target, query, v[0]) else
      z_GetMapiv_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapiv(target: MapTarget; query: GetMapQuery; var v: Int32) :=
    z_GetMapiv_ovr_0(target, query, v);
    private z_GetMapiv_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapiv(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapiv_ovr_2(target, query, v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetMaterialfv_adr := GetProcAddress('glGetMaterialfv');
    private z_GetMaterialfv_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: single)>(z_GetMaterialfv_adr);
    private z_GetMaterialfv_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetMaterialfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialfv(face: MaterialFace; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMaterialfv_ovr_0(face, pname, &params[0]) else
      z_GetMaterialfv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialfv(face: MaterialFace; pname: MaterialParameter; var &params: single) :=
    z_GetMaterialfv_ovr_0(face, pname, &params);
    private z_GetMaterialfv_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetMaterialfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialfv(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_GetMaterialfv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetMaterialiv_adr := GetProcAddress('glGetMaterialiv');
    private z_GetMaterialiv_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: Int32)>(z_GetMaterialiv_adr);
    private z_GetMaterialiv_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetMaterialiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialiv(face: MaterialFace; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMaterialiv_ovr_0(face, pname, &params[0]) else
      z_GetMaterialiv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialiv(face: MaterialFace; pname: MaterialParameter; var &params: Int32) :=
    z_GetMaterialiv_ovr_0(face, pname, &params);
    private z_GetMaterialiv_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetMaterialiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialiv(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_GetMaterialiv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetPixelMapfv_adr := GetProcAddress('glGetPixelMapfv');
    private z_GetPixelMapfv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; var values: single)>(z_GetPixelMapfv_adr);
    private z_GetPixelMapfv_ovr_0_anh001 := GetProcOrNil&<procedure(map: PixelMap; values: IntPtr)>(z_GetPixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapfv(map: PixelMap; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapfv_ovr_0(map, values[0]) else
      z_GetPixelMapfv_ovr_0_anh001(map, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapfv(map: PixelMap; var values: single) :=
    z_GetPixelMapfv_ovr_0(map, values);
    private z_GetPixelMapfv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; values: IntPtr)>(z_GetPixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapfv(map: PixelMap; values: IntPtr) :=
    z_GetPixelMapfv_ovr_2(map, values);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetPixelMapuiv_adr := GetProcAddress('glGetPixelMapuiv');
    private z_GetPixelMapuiv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; var values: UInt32)>(z_GetPixelMapuiv_adr);
    private z_GetPixelMapuiv_ovr_0_anh001 := GetProcOrNil&<procedure(map: PixelMap; values: IntPtr)>(z_GetPixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapuiv(map: PixelMap; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapuiv_ovr_0(map, values[0]) else
      z_GetPixelMapuiv_ovr_0_anh001(map, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapuiv(map: PixelMap; var values: UInt32) :=
    z_GetPixelMapuiv_ovr_0(map, values);
    private z_GetPixelMapuiv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; values: IntPtr)>(z_GetPixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapuiv(map: PixelMap; values: IntPtr) :=
    z_GetPixelMapuiv_ovr_2(map, values);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetPixelMapusv_adr := GetProcAddress('glGetPixelMapusv');
    private z_GetPixelMapusv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; var values: UInt16)>(z_GetPixelMapusv_adr);
    private z_GetPixelMapusv_ovr_0_anh001 := GetProcOrNil&<procedure(map: PixelMap; values: IntPtr)>(z_GetPixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapusv(map: PixelMap; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapusv_ovr_0(map, values[0]) else
      z_GetPixelMapusv_ovr_0_anh001(map, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapusv(map: PixelMap; var values: UInt16) :=
    z_GetPixelMapusv_ovr_0(map, values);
    private z_GetPixelMapusv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; values: IntPtr)>(z_GetPixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapusv(map: PixelMap; values: IntPtr) :=
    z_GetPixelMapusv_ovr_2(map, values);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetPolygonStipple_adr := GetProcAddress('glGetPolygonStipple');
    private z_GetPolygonStipple_ovr_0 := GetProcOrNil&<procedure(var mask: Byte)>(z_GetPolygonStipple_adr);
    private z_GetPolygonStipple_ovr_0_anh01 := GetProcOrNil&<procedure(mask: IntPtr)>(z_GetPolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPolygonStipple(mask: array of Byte) :=
    if (mask<>nil) and (mask.Length<>0) then
      z_GetPolygonStipple_ovr_0(mask[0]) else
      z_GetPolygonStipple_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPolygonStipple(var mask: Byte) :=
    z_GetPolygonStipple_ovr_0(mask);
    private z_GetPolygonStipple_ovr_2 := GetProcOrNil&<procedure(mask: IntPtr)>(z_GetPolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPolygonStipple(mask: IntPtr) :=
    z_GetPolygonStipple_ovr_2(mask);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetTexEnvfv_adr := GetProcAddress('glGetTexEnvfv');
    private z_GetTexEnvfv_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single)>(z_GetTexEnvfv_adr);
    private z_GetTexEnvfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetTexEnvfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexEnvfv_ovr_0(target, pname, &params[0]) else
      z_GetTexEnvfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_GetTexEnvfv_ovr_0(target, pname, &params);
    private z_GetTexEnvfv_ovr_2 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetTexEnvfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetTexEnvfv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetTexEnviv_adr := GetProcAddress('glGetTexEnviv');
    private z_GetTexEnviv_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32)>(z_GetTexEnviv_adr);
    private z_GetTexEnviv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetTexEnviv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexEnviv_ovr_0(target, pname, &params[0]) else
      z_GetTexEnviv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_GetTexEnviv_ovr_0(target, pname, &params);
    private z_GetTexEnviv_ovr_2 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetTexEnviv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetTexEnviv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetTexGendv_adr := GetProcAddress('glGetTexGendv');
    private z_GetTexGendv_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: real)>(z_GetTexGendv_adr);
    private z_GetTexGendv_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGendv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGendv_ovr_0(coord, pname, &params[0]) else
      z_GetTexGendv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGendv(coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_GetTexGendv_ovr_0(coord, pname, &params);
    private z_GetTexGendv_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGendv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGendv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetTexGenfv_adr := GetProcAddress('glGetTexGenfv');
    private z_GetTexGenfv_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: single)>(z_GetTexGenfv_adr);
    private z_GetTexGenfv_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGenfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGenfv_ovr_0(coord, pname, &params[0]) else
      z_GetTexGenfv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenfv(coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_GetTexGenfv_ovr_0(coord, pname, &params);
    private z_GetTexGenfv_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGenfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGenfv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_GetTexGeniv_adr := GetProcAddress('glGetTexGeniv');
    private z_GetTexGeniv_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32)>(z_GetTexGeniv_adr);
    private z_GetTexGeniv_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGeniv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGeniv_ovr_0(coord, pname, &params[0]) else
      z_GetTexGeniv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGeniv(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_GetTexGeniv_ovr_0(coord, pname, &params);
    private z_GetTexGeniv_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGeniv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGeniv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexd_adr := GetProcAddress('glIndexd');
    private z_Indexd_ovr_0 := GetProcOrNil&<procedure(c: real)>(z_Indexd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexd(c: real) :=
    z_Indexd_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexdv_adr := GetProcAddress('glIndexdv');
    private z_Indexdv_ovr_0 := GetProcOrNil&<procedure(var c: real)>(z_Indexdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexdv(var c: real) :=
    z_Indexdv_ovr_0(c);
    private z_Indexdv_ovr_1 := GetProcOrNil&<procedure(c: IntPtr)>(z_Indexdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexdv(c: IntPtr) :=
    z_Indexdv_ovr_1(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexf_adr := GetProcAddress('glIndexf');
    private z_Indexf_ovr_0 := GetProcOrNil&<procedure(c: single)>(z_Indexf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexf(c: single) :=
    z_Indexf_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexfv_adr := GetProcAddress('glIndexfv');
    private z_Indexfv_ovr_0 := GetProcOrNil&<procedure(var c: single)>(z_Indexfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexfv(var c: single) :=
    z_Indexfv_ovr_0(c);
    private z_Indexfv_ovr_1 := GetProcOrNil&<procedure(c: IntPtr)>(z_Indexfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexfv(c: IntPtr) :=
    z_Indexfv_ovr_1(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexi_adr := GetProcAddress('glIndexi');
    private z_Indexi_ovr_0 := GetProcOrNil&<procedure(c: Int32)>(z_Indexi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexi(c: Int32) :=
    z_Indexi_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexiv_adr := GetProcAddress('glIndexiv');
    private z_Indexiv_ovr_0 := GetProcOrNil&<procedure(var c: Int32)>(z_Indexiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexiv(var c: Int32) :=
    z_Indexiv_ovr_0(c);
    private z_Indexiv_ovr_1 := GetProcOrNil&<procedure(c: IntPtr)>(z_Indexiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexiv(c: IntPtr) :=
    z_Indexiv_ovr_1(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_IndexMask_adr := GetProcAddress('glIndexMask');
    private z_IndexMask_ovr_0 := GetProcOrNil&<procedure(mask: UInt32)>(z_IndexMask_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexMask(mask: UInt32) :=
    z_IndexMask_ovr_0(mask);
    
    // added in gl1.1, deprecated in gl3.2
    private z_IndexPointer_adr := GetProcAddress('glIndexPointer');
    private z_IndexPointer_ovr_0 := GetProcOrNil&<procedure(&type: IndexPointerType; stride: Int32; pointer: IntPtr)>(z_IndexPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointer(&type: IndexPointerType; stride: Int32; pointer: IntPtr) :=
    z_IndexPointer_ovr_0(&type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexs_adr := GetProcAddress('glIndexs');
    private z_Indexs_ovr_0 := GetProcOrNil&<procedure(c: Int16)>(z_Indexs_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexs(c: Int16) :=
    z_Indexs_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Indexsv_adr := GetProcAddress('glIndexsv');
    private z_Indexsv_ovr_0 := GetProcOrNil&<procedure(var c: Int16)>(z_Indexsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexsv(var c: Int16) :=
    z_Indexsv_ovr_0(c);
    private z_Indexsv_ovr_1 := GetProcOrNil&<procedure(c: IntPtr)>(z_Indexsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexsv(c: IntPtr) :=
    z_Indexsv_ovr_1(c);
    
    // added in gl1.1, deprecated in gl3.2
    private z_Indexub_adr := GetProcAddress('glIndexub');
    private z_Indexub_ovr_0 := GetProcOrNil&<procedure(c: Byte)>(z_Indexub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexub(c: Byte) :=
    z_Indexub_ovr_0(c);
    
    // added in gl1.1, deprecated in gl3.2
    private z_Indexubv_adr := GetProcAddress('glIndexubv');
    private z_Indexubv_ovr_0 := GetProcOrNil&<procedure(var c: Byte)>(z_Indexubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexubv(var c: Byte) :=
    z_Indexubv_ovr_0(c);
    private z_Indexubv_ovr_1 := GetProcOrNil&<procedure(c: IntPtr)>(z_Indexubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexubv(c: IntPtr) :=
    z_Indexubv_ovr_1(c);
    
    // added in gl1.0, deprecated in gl3.2
    private z_InitNames_adr := GetProcAddress('glInitNames');
    private z_InitNames_ovr_0 := GetProcOrNil&<procedure>(z_InitNames_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InitNames :=
    z_InitNames_ovr_0;
    
    // added in gl1.1, deprecated in gl3.2
    private z_InterleavedArrays_adr := GetProcAddress('glInterleavedArrays');
    private z_InterleavedArrays_ovr_0 := GetProcOrNil&<procedure(format: InterleavedArrayFormat; stride: Int32; pointer: IntPtr)>(z_InterleavedArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InterleavedArrays(format: InterleavedArrayFormat; stride: Int32; pointer: IntPtr) :=
    z_InterleavedArrays_ovr_0(format, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_IsList_adr := GetProcAddress('glIsList');
    private z_IsList_ovr_0 := GetProcOrNil&<function(list: gl_display_list): boolean>(z_IsList_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsList(list: gl_display_list): boolean :=
    z_IsList_ovr_0(list);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Lightf_adr := GetProcAddress('glLightf');
    private z_Lightf_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; param: single)>(z_Lightf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightf(light: LightName; pname: LightParameter; param: single) :=
    z_Lightf_ovr_0(light, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Lightfv_adr := GetProcAddress('glLightfv');
    private z_Lightfv_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; var &params: single)>(z_Lightfv_adr);
    private z_Lightfv_ovr_0_anh0001 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_Lightfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightfv(light: LightName; pname: LightParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Lightfv_ovr_0(light, pname, &params[0]) else
      z_Lightfv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightfv(light: LightName; pname: LightParameter; var &params: single) :=
    z_Lightfv_ovr_0(light, pname, &params);
    private z_Lightfv_ovr_2 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_Lightfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightfv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_Lightfv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Lighti_adr := GetProcAddress('glLighti');
    private z_Lighti_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; param: Int32)>(z_Lighti_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lighti(light: LightName; pname: LightParameter; param: Int32) :=
    z_Lighti_ovr_0(light, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Lightiv_adr := GetProcAddress('glLightiv');
    private z_Lightiv_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; var &params: Int32)>(z_Lightiv_adr);
    private z_Lightiv_ovr_0_anh0001 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_Lightiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightiv(light: LightName; pname: LightParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Lightiv_ovr_0(light, pname, &params[0]) else
      z_Lightiv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightiv(light: LightName; pname: LightParameter; var &params: Int32) :=
    z_Lightiv_ovr_0(light, pname, &params);
    private z_Lightiv_ovr_2 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_Lightiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightiv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_Lightiv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LightModelf_adr := GetProcAddress('glLightModelf');
    private z_LightModelf_ovr_0 := GetProcOrNil&<procedure(pname: LightModelParameter; param: single)>(z_LightModelf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelf(pname: LightModelParameter; param: single) :=
    z_LightModelf_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LightModelfv_adr := GetProcAddress('glLightModelfv');
    private z_LightModelfv_ovr_0 := GetProcOrNil&<procedure(pname: LightModelParameter; var &params: single)>(z_LightModelfv_adr);
    private z_LightModelfv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: LightModelParameter; &params: IntPtr)>(z_LightModelfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelfv(pname: LightModelParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_LightModelfv_ovr_0(pname, &params[0]) else
      z_LightModelfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelfv(pname: LightModelParameter; var &params: single) :=
    z_LightModelfv_ovr_0(pname, &params);
    private z_LightModelfv_ovr_2 := GetProcOrNil&<procedure(pname: LightModelParameter; &params: IntPtr)>(z_LightModelfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelfv(pname: LightModelParameter; &params: IntPtr) :=
    z_LightModelfv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LightModeli_adr := GetProcAddress('glLightModeli');
    private z_LightModeli_ovr_0 := GetProcOrNil&<procedure(pname: LightModelParameter; param: Int32)>(z_LightModeli_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeli(pname: LightModelParameter; param: Int32) :=
    z_LightModeli_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LightModeliv_adr := GetProcAddress('glLightModeliv');
    private z_LightModeliv_ovr_0 := GetProcOrNil&<procedure(pname: LightModelParameter; var &params: Int32)>(z_LightModeliv_adr);
    private z_LightModeliv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: LightModelParameter; &params: IntPtr)>(z_LightModeliv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeliv(pname: LightModelParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_LightModeliv_ovr_0(pname, &params[0]) else
      z_LightModeliv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeliv(pname: LightModelParameter; var &params: Int32) :=
    z_LightModeliv_ovr_0(pname, &params);
    private z_LightModeliv_ovr_2 := GetProcOrNil&<procedure(pname: LightModelParameter; &params: IntPtr)>(z_LightModeliv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeliv(pname: LightModelParameter; &params: IntPtr) :=
    z_LightModeliv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LineStipple_adr := GetProcAddress('glLineStipple');
    private z_LineStipple_ovr_0 := GetProcOrNil&<procedure(factor: Int32; pattern: UInt16)>(z_LineStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LineStipple(factor: Int32; pattern: UInt16) :=
    z_LineStipple_ovr_0(factor, pattern);
    
    // added in gl1.0, deprecated in gl3.2
    private z_ListBase_adr := GetProcAddress('glListBase');
    private z_ListBase_ovr_0 := GetProcOrNil&<procedure(base: UInt32)>(z_ListBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListBase(base: UInt32) :=
    z_ListBase_ovr_0(base);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LoadIdentity_adr := GetProcAddress('glLoadIdentity');
    private z_LoadIdentity_ovr_0 := GetProcOrNil&<procedure>(z_LoadIdentity_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadIdentity :=
    z_LoadIdentity_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private z_LoadMatrixd_adr := GetProcAddress('glLoadMatrixd');
    private z_LoadMatrixd_ovr_0 := GetProcOrNil&<procedure(var m: real)>(z_LoadMatrixd_adr);
    private z_LoadMatrixd_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadMatrixd_ovr_0(m[0]) else
      z_LoadMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixd(var m: real) :=
    z_LoadMatrixd_ovr_0(m);
    private z_LoadMatrixd_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixd(m: IntPtr) :=
    z_LoadMatrixd_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LoadMatrixf_adr := GetProcAddress('glLoadMatrixf');
    private z_LoadMatrixf_ovr_0 := GetProcOrNil&<procedure(var m: single)>(z_LoadMatrixf_adr);
    private z_LoadMatrixf_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadMatrixf_ovr_0(m[0]) else
      z_LoadMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixf(var m: single) :=
    z_LoadMatrixf_ovr_0(m);
    private z_LoadMatrixf_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixf(m: IntPtr) :=
    z_LoadMatrixf_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private z_LoadName_adr := GetProcAddress('glLoadName');
    private z_LoadName_ovr_0 := GetProcOrNil&<procedure(name: UInt32)>(z_LoadName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadName(name: UInt32) :=
    z_LoadName_ovr_0(name);
    
    // added in gl1.3, deprecated in gl3.2
    private z_LoadTransposeMatrixd_adr := GetProcAddress('glLoadTransposeMatrixd');
    private z_LoadTransposeMatrixd_ovr_0 := GetProcOrNil&<procedure(var m: real)>(z_LoadTransposeMatrixd_adr);
    private z_LoadTransposeMatrixd_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixd_ovr_0(m[0]) else
      z_LoadTransposeMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixd(var m: real) :=
    z_LoadTransposeMatrixd_ovr_0(m);
    private z_LoadTransposeMatrixd_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixd(m: IntPtr) :=
    z_LoadTransposeMatrixd_ovr_2(m);
    
    // added in gl1.3, deprecated in gl3.2
    private z_LoadTransposeMatrixf_adr := GetProcAddress('glLoadTransposeMatrixf');
    private z_LoadTransposeMatrixf_ovr_0 := GetProcOrNil&<procedure(var m: single)>(z_LoadTransposeMatrixf_adr);
    private z_LoadTransposeMatrixf_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixf_ovr_0(m[0]) else
      z_LoadTransposeMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixf(var m: single) :=
    z_LoadTransposeMatrixf_ovr_0(m);
    private z_LoadTransposeMatrixf_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixf(m: IntPtr) :=
    z_LoadTransposeMatrixf_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Map1d_adr := GetProcAddress('glMap1d');
    private z_Map1d_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; var points: real)>(z_Map1d_adr);
    private z_Map1d_ovr_0_anh0000001 := GetProcOrNil&<procedure(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr)>(z_Map1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1d(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map1d_ovr_0(target, u1, u2, stride, order, points[0]) else
      z_Map1d_ovr_0_anh0000001(target, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1d(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; var points: real) :=
    z_Map1d_ovr_0(target, u1, u2, stride, order, points);
    private z_Map1d_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr)>(z_Map1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1d(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr) :=
    z_Map1d_ovr_2(target, u1, u2, stride, order, points);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Map1f_adr := GetProcAddress('glMap1f');
    private z_Map1f_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; var points: single)>(z_Map1f_adr);
    private z_Map1f_ovr_0_anh0000001 := GetProcOrNil&<procedure(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr)>(z_Map1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1f(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map1f_ovr_0(target, u1, u2, stride, order, points[0]) else
      z_Map1f_ovr_0_anh0000001(target, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1f(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; var points: single) :=
    z_Map1f_ovr_0(target, u1, u2, stride, order, points);
    private z_Map1f_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr)>(z_Map1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1f(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr) :=
    z_Map1f_ovr_2(target, u1, u2, stride, order, points);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Map2d_adr := GetProcAddress('glMap2d');
    private z_Map2d_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real)>(z_Map2d_adr);
    private z_Map2d_ovr_0_anh00000000001 := GetProcOrNil&<procedure(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr)>(z_Map2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2d(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map2d_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_Map2d_ovr_0_anh00000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2d(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real) :=
    z_Map2d_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private z_Map2d_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr)>(z_Map2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2d(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_Map2d_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Map2f_adr := GetProcAddress('glMap2f');
    private z_Map2f_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single)>(z_Map2f_adr);
    private z_Map2f_ovr_0_anh00000000001 := GetProcOrNil&<procedure(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr)>(z_Map2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2f(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map2f_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_Map2f_ovr_0_anh00000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2f(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single) :=
    z_Map2f_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private z_Map2f_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr)>(z_Map2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2f(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_Map2f_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MapGrid1d_adr := GetProcAddress('glMapGrid1d');
    private z_MapGrid1d_ovr_0 := GetProcOrNil&<procedure(un: Int32; u1: real; u2: real)>(z_MapGrid1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid1d(un: Int32; u1: real; u2: real) :=
    z_MapGrid1d_ovr_0(un, u1, u2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MapGrid1f_adr := GetProcAddress('glMapGrid1f');
    private z_MapGrid1f_ovr_0 := GetProcOrNil&<procedure(un: Int32; u1: single; u2: single)>(z_MapGrid1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid1f(un: Int32; u1: single; u2: single) :=
    z_MapGrid1f_ovr_0(un, u1, u2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MapGrid2d_adr := GetProcAddress('glMapGrid2d');
    private z_MapGrid2d_ovr_0 := GetProcOrNil&<procedure(un: Int32; u1: real; u2: real; vn: Int32; v1: real; v2: real)>(z_MapGrid2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid2d(un: Int32; u1: real; u2: real; vn: Int32; v1: real; v2: real) :=
    z_MapGrid2d_ovr_0(un, u1, u2, vn, v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MapGrid2f_adr := GetProcAddress('glMapGrid2f');
    private z_MapGrid2f_ovr_0 := GetProcOrNil&<procedure(un: Int32; u1: single; u2: single; vn: Int32; v1: single; v2: single)>(z_MapGrid2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid2f(un: Int32; u1: single; u2: single; vn: Int32; v1: single; v2: single) :=
    z_MapGrid2f_ovr_0(un, u1, u2, vn, v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Materialf_adr := GetProcAddress('glMaterialf');
    private z_Materialf_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: single)>(z_Materialf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialf(face: MaterialFace; pname: MaterialParameter; param: single) :=
    z_Materialf_ovr_0(face, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Materialfv_adr := GetProcAddress('glMaterialfv');
    private z_Materialfv_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: single)>(z_Materialfv_adr);
    private z_Materialfv_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_Materialfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialfv(face: MaterialFace; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Materialfv_ovr_0(face, pname, &params[0]) else
      z_Materialfv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialfv(face: MaterialFace; pname: MaterialParameter; var &params: single) :=
    z_Materialfv_ovr_0(face, pname, &params);
    private z_Materialfv_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_Materialfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialfv(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_Materialfv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Materiali_adr := GetProcAddress('glMateriali');
    private z_Materiali_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: Int32)>(z_Materiali_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materiali(face: MaterialFace; pname: MaterialParameter; param: Int32) :=
    z_Materiali_ovr_0(face, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Materialiv_adr := GetProcAddress('glMaterialiv');
    private z_Materialiv_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: Int32)>(z_Materialiv_adr);
    private z_Materialiv_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_Materialiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialiv(face: MaterialFace; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Materialiv_ovr_0(face, pname, &params[0]) else
      z_Materialiv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialiv(face: MaterialFace; pname: MaterialParameter; var &params: Int32) :=
    z_Materialiv_ovr_0(face, pname, &params);
    private z_Materialiv_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_Materialiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialiv(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_Materialiv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MatrixMode_adr := GetProcAddress('glMatrixMode');
    private z_MatrixMode_ovr_0 := GetProcOrNil&<procedure(mode: OpenGL.MatrixMode)>(z_MatrixMode_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMode(mode: OpenGL.MatrixMode) :=
    z_MatrixMode_ovr_0(mode);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1d_adr := GetProcAddress('glMultiTexCoord1d');
    private z_MultiTexCoord1d_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real)>(z_MultiTexCoord1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1d(target: TextureUnit; s: real) :=
    z_MultiTexCoord1d_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1dv_adr := GetProcAddress('glMultiTexCoord1dv');
    private z_MultiTexCoord1dv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord1dv_ovr_0(target, v);
    private z_MultiTexCoord1dv_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1dv_ovr_1(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1f_adr := GetProcAddress('glMultiTexCoord1f');
    private z_MultiTexCoord1f_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single)>(z_MultiTexCoord1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1f(target: TextureUnit; s: single) :=
    z_MultiTexCoord1f_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1fv_adr := GetProcAddress('glMultiTexCoord1fv');
    private z_MultiTexCoord1fv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord1fv_ovr_0(target, v);
    private z_MultiTexCoord1fv_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1fv_ovr_1(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1i_adr := GetProcAddress('glMultiTexCoord1i');
    private z_MultiTexCoord1i_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32)>(z_MultiTexCoord1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1i(target: TextureUnit; s: Int32) :=
    z_MultiTexCoord1i_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1iv_adr := GetProcAddress('glMultiTexCoord1iv');
    private z_MultiTexCoord1iv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord1iv_ovr_0(target, v);
    private z_MultiTexCoord1iv_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1iv_ovr_1(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1s_adr := GetProcAddress('glMultiTexCoord1s');
    private z_MultiTexCoord1s_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16)>(z_MultiTexCoord1s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1s(target: TextureUnit; s: Int16) :=
    z_MultiTexCoord1s_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1sv_adr := GetProcAddress('glMultiTexCoord1sv');
    private z_MultiTexCoord1sv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord1sv_ovr_0(target, v);
    private z_MultiTexCoord1sv_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1sv_ovr_1(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2d_adr := GetProcAddress('glMultiTexCoord2d');
    private z_MultiTexCoord2d_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real; t: real)>(z_MultiTexCoord2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2d(target: TextureUnit; s: real; t: real) :=
    z_MultiTexCoord2d_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2dv_adr := GetProcAddress('glMultiTexCoord2dv');
    private z_MultiTexCoord2dv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord2dv_adr);
    private z_MultiTexCoord2dv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2dv_ovr_0(target, v[0]) else
      z_MultiTexCoord2dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord2dv_ovr_0(target, v);
    private z_MultiTexCoord2dv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2f_adr := GetProcAddress('glMultiTexCoord2f');
    private z_MultiTexCoord2f_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single; t: single)>(z_MultiTexCoord2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2f(target: TextureUnit; s: single; t: single) :=
    z_MultiTexCoord2f_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2fv_adr := GetProcAddress('glMultiTexCoord2fv');
    private z_MultiTexCoord2fv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord2fv_adr);
    private z_MultiTexCoord2fv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2fv_ovr_0(target, v[0]) else
      z_MultiTexCoord2fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord2fv_ovr_0(target, v);
    private z_MultiTexCoord2fv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2i_adr := GetProcAddress('glMultiTexCoord2i');
    private z_MultiTexCoord2i_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32)>(z_MultiTexCoord2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2i(target: TextureUnit; s: Int32; t: Int32) :=
    z_MultiTexCoord2i_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2iv_adr := GetProcAddress('glMultiTexCoord2iv');
    private z_MultiTexCoord2iv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord2iv_adr);
    private z_MultiTexCoord2iv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2iv_ovr_0(target, v[0]) else
      z_MultiTexCoord2iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord2iv_ovr_0(target, v);
    private z_MultiTexCoord2iv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2s_adr := GetProcAddress('glMultiTexCoord2s');
    private z_MultiTexCoord2s_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16)>(z_MultiTexCoord2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2s(target: TextureUnit; s: Int16; t: Int16) :=
    z_MultiTexCoord2s_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2sv_adr := GetProcAddress('glMultiTexCoord2sv');
    private z_MultiTexCoord2sv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord2sv_adr);
    private z_MultiTexCoord2sv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2sv_ovr_0(target, v[0]) else
      z_MultiTexCoord2sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord2sv_ovr_0(target, v);
    private z_MultiTexCoord2sv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2sv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3d_adr := GetProcAddress('glMultiTexCoord3d');
    private z_MultiTexCoord3d_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real; t: real; r: real)>(z_MultiTexCoord3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3d(target: TextureUnit; s: real; t: real; r: real) :=
    z_MultiTexCoord3d_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3dv_adr := GetProcAddress('glMultiTexCoord3dv');
    private z_MultiTexCoord3dv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord3dv_adr);
    private z_MultiTexCoord3dv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3dv_ovr_0(target, v[0]) else
      z_MultiTexCoord3dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord3dv_ovr_0(target, v);
    private z_MultiTexCoord3dv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3f_adr := GetProcAddress('glMultiTexCoord3f');
    private z_MultiTexCoord3f_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single; t: single; r: single)>(z_MultiTexCoord3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3f(target: TextureUnit; s: single; t: single; r: single) :=
    z_MultiTexCoord3f_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3fv_adr := GetProcAddress('glMultiTexCoord3fv');
    private z_MultiTexCoord3fv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord3fv_adr);
    private z_MultiTexCoord3fv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3fv_ovr_0(target, v[0]) else
      z_MultiTexCoord3fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord3fv_ovr_0(target, v);
    private z_MultiTexCoord3fv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3i_adr := GetProcAddress('glMultiTexCoord3i');
    private z_MultiTexCoord3i_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32; r: Int32)>(z_MultiTexCoord3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3i(target: TextureUnit; s: Int32; t: Int32; r: Int32) :=
    z_MultiTexCoord3i_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3iv_adr := GetProcAddress('glMultiTexCoord3iv');
    private z_MultiTexCoord3iv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord3iv_adr);
    private z_MultiTexCoord3iv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3iv_ovr_0(target, v[0]) else
      z_MultiTexCoord3iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord3iv_ovr_0(target, v);
    private z_MultiTexCoord3iv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3s_adr := GetProcAddress('glMultiTexCoord3s');
    private z_MultiTexCoord3s_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16; r: Int16)>(z_MultiTexCoord3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3s(target: TextureUnit; s: Int16; t: Int16; r: Int16) :=
    z_MultiTexCoord3s_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3sv_adr := GetProcAddress('glMultiTexCoord3sv');
    private z_MultiTexCoord3sv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord3sv_adr);
    private z_MultiTexCoord3sv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3sv_ovr_0(target, v[0]) else
      z_MultiTexCoord3sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord3sv_ovr_0(target, v);
    private z_MultiTexCoord3sv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3sv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4d_adr := GetProcAddress('glMultiTexCoord4d');
    private z_MultiTexCoord4d_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real; t: real; r: real; q: real)>(z_MultiTexCoord4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4d(target: TextureUnit; s: real; t: real; r: real; q: real) :=
    z_MultiTexCoord4d_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4dv_adr := GetProcAddress('glMultiTexCoord4dv');
    private z_MultiTexCoord4dv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord4dv_adr);
    private z_MultiTexCoord4dv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4dv_ovr_0(target, v[0]) else
      z_MultiTexCoord4dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord4dv_ovr_0(target, v);
    private z_MultiTexCoord4dv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4f_adr := GetProcAddress('glMultiTexCoord4f');
    private z_MultiTexCoord4f_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single; t: single; r: single; q: single)>(z_MultiTexCoord4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4f(target: TextureUnit; s: single; t: single; r: single; q: single) :=
    z_MultiTexCoord4f_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4fv_adr := GetProcAddress('glMultiTexCoord4fv');
    private z_MultiTexCoord4fv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord4fv_adr);
    private z_MultiTexCoord4fv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4fv_ovr_0(target, v[0]) else
      z_MultiTexCoord4fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord4fv_ovr_0(target, v);
    private z_MultiTexCoord4fv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4i_adr := GetProcAddress('glMultiTexCoord4i');
    private z_MultiTexCoord4i_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32)>(z_MultiTexCoord4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4i(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32) :=
    z_MultiTexCoord4i_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4iv_adr := GetProcAddress('glMultiTexCoord4iv');
    private z_MultiTexCoord4iv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord4iv_adr);
    private z_MultiTexCoord4iv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4iv_ovr_0(target, v[0]) else
      z_MultiTexCoord4iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord4iv_ovr_0(target, v);
    private z_MultiTexCoord4iv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4s_adr := GetProcAddress('glMultiTexCoord4s');
    private z_MultiTexCoord4s_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16)>(z_MultiTexCoord4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4s(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16) :=
    z_MultiTexCoord4s_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4sv_adr := GetProcAddress('glMultiTexCoord4sv');
    private z_MultiTexCoord4sv_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord4sv_adr);
    private z_MultiTexCoord4sv_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4sv_ovr_0(target, v[0]) else
      z_MultiTexCoord4sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord4sv_ovr_0(target, v);
    private z_MultiTexCoord4sv_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4sv_ovr_2(target, v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MultMatrixd_adr := GetProcAddress('glMultMatrixd');
    private z_MultMatrixd_ovr_0 := GetProcOrNil&<procedure(var m: real)>(z_MultMatrixd_adr);
    private z_MultMatrixd_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultMatrixd_ovr_0(m[0]) else
      z_MultMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixd(var m: real) :=
    z_MultMatrixd_ovr_0(m);
    private z_MultMatrixd_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixd(m: IntPtr) :=
    z_MultMatrixd_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private z_MultMatrixf_adr := GetProcAddress('glMultMatrixf');
    private z_MultMatrixf_ovr_0 := GetProcOrNil&<procedure(var m: single)>(z_MultMatrixf_adr);
    private z_MultMatrixf_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultMatrixf_ovr_0(m[0]) else
      z_MultMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixf(var m: single) :=
    z_MultMatrixf_ovr_0(m);
    private z_MultMatrixf_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixf(m: IntPtr) :=
    z_MultMatrixf_ovr_2(m);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultTransposeMatrixd_adr := GetProcAddress('glMultTransposeMatrixd');
    private z_MultTransposeMatrixd_ovr_0 := GetProcOrNil&<procedure(var m: real)>(z_MultTransposeMatrixd_adr);
    private z_MultTransposeMatrixd_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixd_ovr_0(m[0]) else
      z_MultTransposeMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixd(var m: real) :=
    z_MultTransposeMatrixd_ovr_0(m);
    private z_MultTransposeMatrixd_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixd(m: IntPtr) :=
    z_MultTransposeMatrixd_ovr_2(m);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultTransposeMatrixf_adr := GetProcAddress('glMultTransposeMatrixf');
    private z_MultTransposeMatrixf_ovr_0 := GetProcOrNil&<procedure(var m: single)>(z_MultTransposeMatrixf_adr);
    private z_MultTransposeMatrixf_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixf_ovr_0(m[0]) else
      z_MultTransposeMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixf(var m: single) :=
    z_MultTransposeMatrixf_ovr_0(m);
    private z_MultTransposeMatrixf_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixf(m: IntPtr) :=
    z_MultTransposeMatrixf_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private z_NewList_adr := GetProcAddress('glNewList');
    private z_NewList_ovr_0 := GetProcOrNil&<procedure(list: UInt32; mode: ListMode)>(z_NewList_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NewList(list: UInt32; mode: ListMode) :=
    z_NewList_ovr_0(list, mode);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3b_adr := GetProcAddress('glNormal3b');
    private z_Normal3b_ovr_0 := GetProcOrNil&<procedure(nx: SByte; ny: SByte; nz: SByte)>(z_Normal3b_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3b(nx: SByte; ny: SByte; nz: SByte) :=
    z_Normal3b_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3bv_adr := GetProcAddress('glNormal3bv');
    private z_Normal3bv_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_Normal3bv_adr);
    private z_Normal3bv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3bv_ovr_0(v[0]) else
      z_Normal3bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3bv(var v: SByte) :=
    z_Normal3bv_ovr_0(v);
    private z_Normal3bv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3bv(v: IntPtr) :=
    z_Normal3bv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3d_adr := GetProcAddress('glNormal3d');
    private z_Normal3d_ovr_0 := GetProcOrNil&<procedure(nx: real; ny: real; nz: real)>(z_Normal3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3d(nx: real; ny: real; nz: real) :=
    z_Normal3d_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3dv_adr := GetProcAddress('glNormal3dv');
    private z_Normal3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Normal3dv_adr);
    private z_Normal3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3dv_ovr_0(v[0]) else
      z_Normal3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3dv(var v: real) :=
    z_Normal3dv_ovr_0(v);
    private z_Normal3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3dv(v: IntPtr) :=
    z_Normal3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3f_adr := GetProcAddress('glNormal3f');
    private z_Normal3f_ovr_0 := GetProcOrNil&<procedure(nx: single; ny: single; nz: single)>(z_Normal3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3f(nx: single; ny: single; nz: single) :=
    z_Normal3f_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3fv_adr := GetProcAddress('glNormal3fv');
    private z_Normal3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Normal3fv_adr);
    private z_Normal3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3fv_ovr_0(v[0]) else
      z_Normal3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fv(var v: single) :=
    z_Normal3fv_ovr_0(v);
    private z_Normal3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fv(v: IntPtr) :=
    z_Normal3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3i_adr := GetProcAddress('glNormal3i');
    private z_Normal3i_ovr_0 := GetProcOrNil&<procedure(nx: Int32; ny: Int32; nz: Int32)>(z_Normal3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3i(nx: Int32; ny: Int32; nz: Int32) :=
    z_Normal3i_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3iv_adr := GetProcAddress('glNormal3iv');
    private z_Normal3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Normal3iv_adr);
    private z_Normal3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3iv_ovr_0(v[0]) else
      z_Normal3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3iv(var v: Int32) :=
    z_Normal3iv_ovr_0(v);
    private z_Normal3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3iv(v: IntPtr) :=
    z_Normal3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3s_adr := GetProcAddress('glNormal3s');
    private z_Normal3s_ovr_0 := GetProcOrNil&<procedure(nx: Int16; ny: Int16; nz: Int16)>(z_Normal3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3s(nx: Int16; ny: Int16; nz: Int16) :=
    z_Normal3s_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Normal3sv_adr := GetProcAddress('glNormal3sv');
    private z_Normal3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Normal3sv_adr);
    private z_Normal3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3sv_ovr_0(v[0]) else
      z_Normal3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3sv(var v: Int16) :=
    z_Normal3sv_ovr_0(v);
    private z_Normal3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3sv(v: IntPtr) :=
    z_Normal3sv_ovr_2(v);
    
    // added in gl1.1, deprecated in gl3.2
    private z_NormalPointer_adr := GetProcAddress('glNormalPointer');
    private z_NormalPointer_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; stride: Int32; pointer: IntPtr)>(z_NormalPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointer(&type: NormalPointerType; stride: Int32; pointer: IntPtr) :=
    z_NormalPointer_ovr_0(&type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Ortho_adr := GetProcAddress('glOrtho');
    private z_Ortho_ovr_0 := GetProcOrNil&<procedure(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real)>(z_Ortho_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Ortho(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_Ortho_ovr_0(left, right, bottom, top, zNear, zFar);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PassThrough_adr := GetProcAddress('glPassThrough');
    private z_PassThrough_ovr_0 := GetProcOrNil&<procedure(token: single)>(z_PassThrough_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PassThrough(token: single) :=
    z_PassThrough_ovr_0(token);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PixelMapfv_adr := GetProcAddress('glPixelMapfv');
    private z_PixelMapfv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; var values: single)>(z_PixelMapfv_adr);
    private z_PixelMapfv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; values: IntPtr)>(z_PixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapfv(map: PixelMap; mapsize: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapfv_ovr_0(map, mapsize, values[0]) else
      z_PixelMapfv_ovr_0_anh0001(map, mapsize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapfv(map: PixelMap; mapsize: Int32; var values: single) :=
    z_PixelMapfv_ovr_0(map, mapsize, values);
    private z_PixelMapfv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; values: IntPtr)>(z_PixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapfv(map: PixelMap; mapsize: Int32; values: IntPtr) :=
    z_PixelMapfv_ovr_2(map, mapsize, values);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PixelMapuiv_adr := GetProcAddress('glPixelMapuiv');
    private z_PixelMapuiv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; var values: UInt32)>(z_PixelMapuiv_adr);
    private z_PixelMapuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; values: IntPtr)>(z_PixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapuiv(map: PixelMap; mapsize: Int32; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapuiv_ovr_0(map, mapsize, values[0]) else
      z_PixelMapuiv_ovr_0_anh0001(map, mapsize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapuiv(map: PixelMap; mapsize: Int32; var values: UInt32) :=
    z_PixelMapuiv_ovr_0(map, mapsize, values);
    private z_PixelMapuiv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; values: IntPtr)>(z_PixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapuiv(map: PixelMap; mapsize: Int32; values: IntPtr) :=
    z_PixelMapuiv_ovr_2(map, mapsize, values);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PixelMapusv_adr := GetProcAddress('glPixelMapusv');
    private z_PixelMapusv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; var values: UInt16)>(z_PixelMapusv_adr);
    private z_PixelMapusv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; values: IntPtr)>(z_PixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapusv(map: PixelMap; mapsize: Int32; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapusv_ovr_0(map, mapsize, values[0]) else
      z_PixelMapusv_ovr_0_anh0001(map, mapsize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapusv(map: PixelMap; mapsize: Int32; var values: UInt16) :=
    z_PixelMapusv_ovr_0(map, mapsize, values);
    private z_PixelMapusv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; mapsize: Int32; values: IntPtr)>(z_PixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapusv(map: PixelMap; mapsize: Int32; values: IntPtr) :=
    z_PixelMapusv_ovr_2(map, mapsize, values);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PixelTransferf_adr := GetProcAddress('glPixelTransferf');
    private z_PixelTransferf_ovr_0 := GetProcOrNil&<procedure(pname: PixelTransferParameter; param: single)>(z_PixelTransferf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransferf(pname: PixelTransferParameter; param: single) :=
    z_PixelTransferf_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PixelTransferi_adr := GetProcAddress('glPixelTransferi');
    private z_PixelTransferi_ovr_0 := GetProcOrNil&<procedure(pname: PixelTransferParameter; param: Int32)>(z_PixelTransferi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransferi(pname: PixelTransferParameter; param: Int32) :=
    z_PixelTransferi_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PixelZoom_adr := GetProcAddress('glPixelZoom');
    private z_PixelZoom_ovr_0 := GetProcOrNil&<procedure(xfactor: single; yfactor: single)>(z_PixelZoom_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelZoom(xfactor: single; yfactor: single) :=
    z_PixelZoom_ovr_0(xfactor, yfactor);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PolygonStipple_adr := GetProcAddress('glPolygonStipple');
    private z_PolygonStipple_ovr_0 := GetProcOrNil&<procedure(var mask: Byte)>(z_PolygonStipple_adr);
    private z_PolygonStipple_ovr_0_anh01 := GetProcOrNil&<procedure(mask: IntPtr)>(z_PolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonStipple(mask: array of Byte) :=
    if (mask<>nil) and (mask.Length<>0) then
      z_PolygonStipple_ovr_0(mask[0]) else
      z_PolygonStipple_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonStipple(var mask: Byte) :=
    z_PolygonStipple_ovr_0(mask);
    private z_PolygonStipple_ovr_2 := GetProcOrNil&<procedure(mask: IntPtr)>(z_PolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonStipple(mask: IntPtr) :=
    z_PolygonStipple_ovr_2(mask);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PopAttrib_adr := GetProcAddress('glPopAttrib');
    private z_PopAttrib_ovr_0 := GetProcOrNil&<procedure>(z_PopAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopAttrib :=
    z_PopAttrib_ovr_0;
    
    // added in gl1.1, deprecated in gl3.2
    private z_PopClientAttrib_adr := GetProcAddress('glPopClientAttrib');
    private z_PopClientAttrib_ovr_0 := GetProcOrNil&<procedure>(z_PopClientAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopClientAttrib :=
    z_PopClientAttrib_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private z_PopMatrix_adr := GetProcAddress('glPopMatrix');
    private z_PopMatrix_ovr_0 := GetProcOrNil&<procedure>(z_PopMatrix_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopMatrix :=
    z_PopMatrix_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private z_PopName_adr := GetProcAddress('glPopName');
    private z_PopName_ovr_0 := GetProcOrNil&<procedure>(z_PopName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopName :=
    z_PopName_ovr_0;
    
    // added in gl1.1, deprecated in gl3.2
    private z_PrioritizeTextures_adr := GetProcAddress('glPrioritizeTextures');
    private z_PrioritizeTextures_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; var priorities: single)>(z_PrioritizeTextures_adr);
    private z_PrioritizeTextures_ovr_0_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: single)>(z_PrioritizeTextures_adr);
    private z_PrioritizeTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; priorities: IntPtr)>(z_PrioritizeTextures_adr);
    private z_PrioritizeTextures_ovr_0_anh0011 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: array of gl_texture; priorities: array of single) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTextures_ovr_0(n, textures[0], priorities[0]) else
        z_PrioritizeTextures_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTextures_ovr_0_anh0010(n, IntPtr.Zero, priorities[0]) else
        z_PrioritizeTextures_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private z_PrioritizeTextures_ovr_1_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: single)>(z_PrioritizeTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: array of gl_texture; var priorities: single) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTextures_ovr_0(n, textures[0], priorities) else
      z_PrioritizeTextures_ovr_0_anh0010(n, IntPtr.Zero, priorities);
    private z_PrioritizeTextures_ovr_2 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; priorities: IntPtr)>(z_PrioritizeTextures_adr);
    private z_PrioritizeTextures_ovr_2_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: array of gl_texture; priorities: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTextures_ovr_2(n, textures[0], priorities) else
      z_PrioritizeTextures_ovr_2_anh0010(n, IntPtr.Zero, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; var textures: gl_texture; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTextures_ovr_0(n, textures, priorities[0]) else
      z_PrioritizeTextures_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; var textures: gl_texture; var priorities: single) :=
    z_PrioritizeTextures_ovr_0(n, textures, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; var textures: gl_texture; priorities: IntPtr) :=
    z_PrioritizeTextures_ovr_2(n, textures, priorities);
    private z_PrioritizeTextures_ovr_6 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: single)>(z_PrioritizeTextures_adr);
    private z_PrioritizeTextures_ovr_6_anh0001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: IntPtr; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTextures_ovr_6(n, textures, priorities[0]) else
      z_PrioritizeTextures_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: IntPtr; var priorities: single) :=
    z_PrioritizeTextures_ovr_6(n, textures, priorities);
    private z_PrioritizeTextures_ovr_8 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: IntPtr; priorities: IntPtr) :=
    z_PrioritizeTextures_ovr_8(n, textures, priorities);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PushAttrib_adr := GetProcAddress('glPushAttrib');
    private z_PushAttrib_ovr_0 := GetProcOrNil&<procedure(mask: AttribMask)>(z_PushAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushAttrib(mask: AttribMask) :=
    z_PushAttrib_ovr_0(mask);
    
    // added in gl1.1, deprecated in gl3.2
    private z_PushClientAttrib_adr := GetProcAddress('glPushClientAttrib');
    private z_PushClientAttrib_ovr_0 := GetProcOrNil&<procedure(mask: ClientAttribMask)>(z_PushClientAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushClientAttrib(mask: ClientAttribMask) :=
    z_PushClientAttrib_ovr_0(mask);
    
    // added in gl1.0, deprecated in gl3.2
    private z_PushMatrix_adr := GetProcAddress('glPushMatrix');
    private z_PushMatrix_ovr_0 := GetProcOrNil&<procedure>(z_PushMatrix_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushMatrix :=
    z_PushMatrix_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private z_PushName_adr := GetProcAddress('glPushName');
    private z_PushName_ovr_0 := GetProcOrNil&<procedure(name: UInt32)>(z_PushName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushName(name: UInt32) :=
    z_PushName_ovr_0(name);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2d_adr := GetProcAddress('glRasterPos2d');
    private z_RasterPos2d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real)>(z_RasterPos2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2d(x: real; y: real) :=
    z_RasterPos2d_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2dv_adr := GetProcAddress('glRasterPos2dv');
    private z_RasterPos2dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_RasterPos2dv_adr);
    private z_RasterPos2dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2dv_ovr_0(v[0]) else
      z_RasterPos2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2dv(var v: real) :=
    z_RasterPos2dv_ovr_0(v);
    private z_RasterPos2dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2dv(v: IntPtr) :=
    z_RasterPos2dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2f_adr := GetProcAddress('glRasterPos2f');
    private z_RasterPos2f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single)>(z_RasterPos2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2f(x: single; y: single) :=
    z_RasterPos2f_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2fv_adr := GetProcAddress('glRasterPos2fv');
    private z_RasterPos2fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_RasterPos2fv_adr);
    private z_RasterPos2fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2fv_ovr_0(v[0]) else
      z_RasterPos2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2fv(var v: single) :=
    z_RasterPos2fv_ovr_0(v);
    private z_RasterPos2fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2fv(v: IntPtr) :=
    z_RasterPos2fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2i_adr := GetProcAddress('glRasterPos2i');
    private z_RasterPos2i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32)>(z_RasterPos2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2i(x: Int32; y: Int32) :=
    z_RasterPos2i_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2iv_adr := GetProcAddress('glRasterPos2iv');
    private z_RasterPos2iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_RasterPos2iv_adr);
    private z_RasterPos2iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2iv_ovr_0(v[0]) else
      z_RasterPos2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2iv(var v: Int32) :=
    z_RasterPos2iv_ovr_0(v);
    private z_RasterPos2iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2iv(v: IntPtr) :=
    z_RasterPos2iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2s_adr := GetProcAddress('glRasterPos2s');
    private z_RasterPos2s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16)>(z_RasterPos2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2s(x: Int16; y: Int16) :=
    z_RasterPos2s_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos2sv_adr := GetProcAddress('glRasterPos2sv');
    private z_RasterPos2sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_RasterPos2sv_adr);
    private z_RasterPos2sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2sv_ovr_0(v[0]) else
      z_RasterPos2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2sv(var v: Int16) :=
    z_RasterPos2sv_ovr_0(v);
    private z_RasterPos2sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2sv(v: IntPtr) :=
    z_RasterPos2sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3d_adr := GetProcAddress('glRasterPos3d');
    private z_RasterPos3d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_RasterPos3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3d(x: real; y: real; z: real) :=
    z_RasterPos3d_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3dv_adr := GetProcAddress('glRasterPos3dv');
    private z_RasterPos3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_RasterPos3dv_adr);
    private z_RasterPos3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3dv_ovr_0(v[0]) else
      z_RasterPos3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3dv(var v: real) :=
    z_RasterPos3dv_ovr_0(v);
    private z_RasterPos3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3dv(v: IntPtr) :=
    z_RasterPos3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3f_adr := GetProcAddress('glRasterPos3f');
    private z_RasterPos3f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_RasterPos3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3f(x: single; y: single; z: single) :=
    z_RasterPos3f_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3fv_adr := GetProcAddress('glRasterPos3fv');
    private z_RasterPos3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_RasterPos3fv_adr);
    private z_RasterPos3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3fv_ovr_0(v[0]) else
      z_RasterPos3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3fv(var v: single) :=
    z_RasterPos3fv_ovr_0(v);
    private z_RasterPos3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3fv(v: IntPtr) :=
    z_RasterPos3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3i_adr := GetProcAddress('glRasterPos3i');
    private z_RasterPos3i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32)>(z_RasterPos3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3i(x: Int32; y: Int32; z: Int32) :=
    z_RasterPos3i_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3iv_adr := GetProcAddress('glRasterPos3iv');
    private z_RasterPos3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_RasterPos3iv_adr);
    private z_RasterPos3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3iv_ovr_0(v[0]) else
      z_RasterPos3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3iv(var v: Int32) :=
    z_RasterPos3iv_ovr_0(v);
    private z_RasterPos3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3iv(v: IntPtr) :=
    z_RasterPos3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3s_adr := GetProcAddress('glRasterPos3s');
    private z_RasterPos3s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16)>(z_RasterPos3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3s(x: Int16; y: Int16; z: Int16) :=
    z_RasterPos3s_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos3sv_adr := GetProcAddress('glRasterPos3sv');
    private z_RasterPos3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_RasterPos3sv_adr);
    private z_RasterPos3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3sv_ovr_0(v[0]) else
      z_RasterPos3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3sv(var v: Int16) :=
    z_RasterPos3sv_ovr_0(v);
    private z_RasterPos3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3sv(v: IntPtr) :=
    z_RasterPos3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4d_adr := GetProcAddress('glRasterPos4d');
    private z_RasterPos4d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real; w: real)>(z_RasterPos4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4d(x: real; y: real; z: real; w: real) :=
    z_RasterPos4d_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4dv_adr := GetProcAddress('glRasterPos4dv');
    private z_RasterPos4dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_RasterPos4dv_adr);
    private z_RasterPos4dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4dv_ovr_0(v[0]) else
      z_RasterPos4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4dv(var v: real) :=
    z_RasterPos4dv_ovr_0(v);
    private z_RasterPos4dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4dv(v: IntPtr) :=
    z_RasterPos4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4f_adr := GetProcAddress('glRasterPos4f');
    private z_RasterPos4f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single; w: single)>(z_RasterPos4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4f(x: single; y: single; z: single; w: single) :=
    z_RasterPos4f_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4fv_adr := GetProcAddress('glRasterPos4fv');
    private z_RasterPos4fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_RasterPos4fv_adr);
    private z_RasterPos4fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4fv_ovr_0(v[0]) else
      z_RasterPos4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4fv(var v: single) :=
    z_RasterPos4fv_ovr_0(v);
    private z_RasterPos4fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4fv(v: IntPtr) :=
    z_RasterPos4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4i_adr := GetProcAddress('glRasterPos4i');
    private z_RasterPos4i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32; w: Int32)>(z_RasterPos4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4i(x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_RasterPos4i_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4iv_adr := GetProcAddress('glRasterPos4iv');
    private z_RasterPos4iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_RasterPos4iv_adr);
    private z_RasterPos4iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4iv_ovr_0(v[0]) else
      z_RasterPos4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4iv(var v: Int32) :=
    z_RasterPos4iv_ovr_0(v);
    private z_RasterPos4iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4iv(v: IntPtr) :=
    z_RasterPos4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4s_adr := GetProcAddress('glRasterPos4s');
    private z_RasterPos4s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16; w: Int16)>(z_RasterPos4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4s(x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_RasterPos4s_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RasterPos4sv_adr := GetProcAddress('glRasterPos4sv');
    private z_RasterPos4sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_RasterPos4sv_adr);
    private z_RasterPos4sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4sv_ovr_0(v[0]) else
      z_RasterPos4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4sv(var v: Int16) :=
    z_RasterPos4sv_ovr_0(v);
    private z_RasterPos4sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_RasterPos4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4sv(v: IntPtr) :=
    z_RasterPos4sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rectd_adr := GetProcAddress('glRectd');
    private z_Rectd_ovr_0 := GetProcOrNil&<procedure(x1: real; y1: real; x2: real; y2: real)>(z_Rectd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectd(x1: real; y1: real; x2: real; y2: real) :=
    z_Rectd_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rectdv_adr := GetProcAddress('glRectdv');
    private z_Rectdv_ovr_0 := GetProcOrNil&<procedure(var v1: real; var v2: real)>(z_Rectdv_adr);
    private z_Rectdv_ovr_0_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: real)>(z_Rectdv_adr);
    private z_Rectdv_ovr_0_anh001 := GetProcOrNil&<procedure(var v1: real; v2: IntPtr)>(z_Rectdv_adr);
    private z_Rectdv_ovr_0_anh011 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: array of real; v2: array of real) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectdv_ovr_0(v1[0], v2[0]) else
        z_Rectdv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectdv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectdv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private z_Rectdv_ovr_1_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: real)>(z_Rectdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: array of real; var v2: real) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectdv_ovr_0(v1[0], v2) else
      z_Rectdv_ovr_0_anh010(IntPtr.Zero, v2);
    private z_Rectdv_ovr_2 := GetProcOrNil&<procedure(var v1: real; v2: IntPtr)>(z_Rectdv_adr);
    private z_Rectdv_ovr_2_anh010 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: array of real; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectdv_ovr_2(v1[0], v2) else
      z_Rectdv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(var v1: real; v2: array of real) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectdv_ovr_0(v1, v2[0]) else
      z_Rectdv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(var v1: real; var v2: real) :=
    z_Rectdv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(var v1: real; v2: IntPtr) :=
    z_Rectdv_ovr_2(v1, v2);
    private z_Rectdv_ovr_6 := GetProcOrNil&<procedure(v1: IntPtr; var v2: real)>(z_Rectdv_adr);
    private z_Rectdv_ovr_6_anh001 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: IntPtr; v2: array of real) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectdv_ovr_6(v1, v2[0]) else
      z_Rectdv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: IntPtr; var v2: real) :=
    z_Rectdv_ovr_6(v1, v2);
    private z_Rectdv_ovr_8 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: IntPtr; v2: IntPtr) :=
    z_Rectdv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rectf_adr := GetProcAddress('glRectf');
    private z_Rectf_ovr_0 := GetProcOrNil&<procedure(x1: single; y1: single; x2: single; y2: single)>(z_Rectf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectf(x1: single; y1: single; x2: single; y2: single) :=
    z_Rectf_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rectfv_adr := GetProcAddress('glRectfv');
    private z_Rectfv_ovr_0 := GetProcOrNil&<procedure(var v1: single; var v2: single)>(z_Rectfv_adr);
    private z_Rectfv_ovr_0_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: single)>(z_Rectfv_adr);
    private z_Rectfv_ovr_0_anh001 := GetProcOrNil&<procedure(var v1: single; v2: IntPtr)>(z_Rectfv_adr);
    private z_Rectfv_ovr_0_anh011 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: array of single; v2: array of single) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectfv_ovr_0(v1[0], v2[0]) else
        z_Rectfv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectfv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectfv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private z_Rectfv_ovr_1_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: single)>(z_Rectfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: array of single; var v2: single) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectfv_ovr_0(v1[0], v2) else
      z_Rectfv_ovr_0_anh010(IntPtr.Zero, v2);
    private z_Rectfv_ovr_2 := GetProcOrNil&<procedure(var v1: single; v2: IntPtr)>(z_Rectfv_adr);
    private z_Rectfv_ovr_2_anh010 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: array of single; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectfv_ovr_2(v1[0], v2) else
      z_Rectfv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(var v1: single; v2: array of single) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectfv_ovr_0(v1, v2[0]) else
      z_Rectfv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(var v1: single; var v2: single) :=
    z_Rectfv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(var v1: single; v2: IntPtr) :=
    z_Rectfv_ovr_2(v1, v2);
    private z_Rectfv_ovr_6 := GetProcOrNil&<procedure(v1: IntPtr; var v2: single)>(z_Rectfv_adr);
    private z_Rectfv_ovr_6_anh001 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: IntPtr; v2: array of single) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectfv_ovr_6(v1, v2[0]) else
      z_Rectfv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: IntPtr; var v2: single) :=
    z_Rectfv_ovr_6(v1, v2);
    private z_Rectfv_ovr_8 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: IntPtr; v2: IntPtr) :=
    z_Rectfv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Recti_adr := GetProcAddress('glRecti');
    private z_Recti_ovr_0 := GetProcOrNil&<procedure(x1: Int32; y1: Int32; x2: Int32; y2: Int32)>(z_Recti_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Recti(x1: Int32; y1: Int32; x2: Int32; y2: Int32) :=
    z_Recti_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rectiv_adr := GetProcAddress('glRectiv');
    private z_Rectiv_ovr_0 := GetProcOrNil&<procedure(var v1: Int32; var v2: Int32)>(z_Rectiv_adr);
    private z_Rectiv_ovr_0_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Int32)>(z_Rectiv_adr);
    private z_Rectiv_ovr_0_anh001 := GetProcOrNil&<procedure(var v1: Int32; v2: IntPtr)>(z_Rectiv_adr);
    private z_Rectiv_ovr_0_anh011 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: array of Int32; v2: array of Int32) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectiv_ovr_0(v1[0], v2[0]) else
        z_Rectiv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectiv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectiv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private z_Rectiv_ovr_1_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Int32)>(z_Rectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: array of Int32; var v2: Int32) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectiv_ovr_0(v1[0], v2) else
      z_Rectiv_ovr_0_anh010(IntPtr.Zero, v2);
    private z_Rectiv_ovr_2 := GetProcOrNil&<procedure(var v1: Int32; v2: IntPtr)>(z_Rectiv_adr);
    private z_Rectiv_ovr_2_anh010 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: array of Int32; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectiv_ovr_2(v1[0], v2) else
      z_Rectiv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(var v1: Int32; v2: array of Int32) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectiv_ovr_0(v1, v2[0]) else
      z_Rectiv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(var v1: Int32; var v2: Int32) :=
    z_Rectiv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(var v1: Int32; v2: IntPtr) :=
    z_Rectiv_ovr_2(v1, v2);
    private z_Rectiv_ovr_6 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Int32)>(z_Rectiv_adr);
    private z_Rectiv_ovr_6_anh001 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: IntPtr; v2: array of Int32) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectiv_ovr_6(v1, v2[0]) else
      z_Rectiv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: IntPtr; var v2: Int32) :=
    z_Rectiv_ovr_6(v1, v2);
    private z_Rectiv_ovr_8 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: IntPtr; v2: IntPtr) :=
    z_Rectiv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rects_adr := GetProcAddress('glRects');
    private z_Rects_ovr_0 := GetProcOrNil&<procedure(x1: Int16; y1: Int16; x2: Int16; y2: Int16)>(z_Rects_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rects(x1: Int16; y1: Int16; x2: Int16; y2: Int16) :=
    z_Rects_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rectsv_adr := GetProcAddress('glRectsv');
    private z_Rectsv_ovr_0 := GetProcOrNil&<procedure(var v1: Int16; var v2: Int16)>(z_Rectsv_adr);
    private z_Rectsv_ovr_0_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Int16)>(z_Rectsv_adr);
    private z_Rectsv_ovr_0_anh001 := GetProcOrNil&<procedure(var v1: Int16; v2: IntPtr)>(z_Rectsv_adr);
    private z_Rectsv_ovr_0_anh011 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: array of Int16; v2: array of Int16) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectsv_ovr_0(v1[0], v2[0]) else
        z_Rectsv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectsv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectsv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private z_Rectsv_ovr_1_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Int16)>(z_Rectsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: array of Int16; var v2: Int16) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectsv_ovr_0(v1[0], v2) else
      z_Rectsv_ovr_0_anh010(IntPtr.Zero, v2);
    private z_Rectsv_ovr_2 := GetProcOrNil&<procedure(var v1: Int16; v2: IntPtr)>(z_Rectsv_adr);
    private z_Rectsv_ovr_2_anh010 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: array of Int16; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectsv_ovr_2(v1[0], v2) else
      z_Rectsv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(var v1: Int16; v2: array of Int16) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectsv_ovr_0(v1, v2[0]) else
      z_Rectsv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(var v1: Int16; var v2: Int16) :=
    z_Rectsv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(var v1: Int16; v2: IntPtr) :=
    z_Rectsv_ovr_2(v1, v2);
    private z_Rectsv_ovr_6 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Int16)>(z_Rectsv_adr);
    private z_Rectsv_ovr_6_anh001 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: IntPtr; v2: array of Int16) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectsv_ovr_6(v1, v2[0]) else
      z_Rectsv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: IntPtr; var v2: Int16) :=
    z_Rectsv_ovr_6(v1, v2);
    private z_Rectsv_ovr_8 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_Rectsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: IntPtr; v2: IntPtr) :=
    z_Rectsv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private z_RenderMode_adr := GetProcAddress('glRenderMode');
    private z_RenderMode_ovr_0 := GetProcOrNil&<function(mode: RenderingMode): Int32>(z_RenderMode_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function RenderMode(mode: RenderingMode): Int32 :=
    z_RenderMode_ovr_0(mode);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rotated_adr := GetProcAddress('glRotated');
    private z_Rotated_ovr_0 := GetProcOrNil&<procedure(angle: real; x: real; y: real; z: real)>(z_Rotated_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rotated(angle: real; x: real; y: real; z: real) :=
    z_Rotated_ovr_0(angle, x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Rotatef_adr := GetProcAddress('glRotatef');
    private z_Rotatef_ovr_0 := GetProcOrNil&<procedure(angle: single; x: single; y: single; z: single)>(z_Rotatef_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rotatef(angle: single; x: single; y: single; z: single) :=
    z_Rotatef_ovr_0(angle, x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Scaled_adr := GetProcAddress('glScaled');
    private z_Scaled_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_Scaled_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Scaled(x: real; y: real; z: real) :=
    z_Scaled_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Scalef_adr := GetProcAddress('glScalef');
    private z_Scalef_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_Scalef_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Scalef(x: single; y: single; z: single) :=
    z_Scalef_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3b_adr := GetProcAddress('glSecondaryColor3b');
    private z_SecondaryColor3b_ovr_0 := GetProcOrNil&<procedure(red: SByte; green: SByte; blue: SByte)>(z_SecondaryColor3b_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3b(red: SByte; green: SByte; blue: SByte) :=
    z_SecondaryColor3b_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3bv_adr := GetProcAddress('glSecondaryColor3bv');
    private z_SecondaryColor3bv_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_SecondaryColor3bv_adr);
    private z_SecondaryColor3bv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3bv_ovr_0(v[0]) else
      z_SecondaryColor3bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bv(var v: SByte) :=
    z_SecondaryColor3bv_ovr_0(v);
    private z_SecondaryColor3bv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bv(v: IntPtr) :=
    z_SecondaryColor3bv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3d_adr := GetProcAddress('glSecondaryColor3d');
    private z_SecondaryColor3d_ovr_0 := GetProcOrNil&<procedure(red: real; green: real; blue: real)>(z_SecondaryColor3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3d(red: real; green: real; blue: real) :=
    z_SecondaryColor3d_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3dv_adr := GetProcAddress('glSecondaryColor3dv');
    private z_SecondaryColor3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_SecondaryColor3dv_adr);
    private z_SecondaryColor3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3dv_ovr_0(v[0]) else
      z_SecondaryColor3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dv(var v: real) :=
    z_SecondaryColor3dv_ovr_0(v);
    private z_SecondaryColor3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dv(v: IntPtr) :=
    z_SecondaryColor3dv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3f_adr := GetProcAddress('glSecondaryColor3f');
    private z_SecondaryColor3f_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single)>(z_SecondaryColor3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3f(red: single; green: single; blue: single) :=
    z_SecondaryColor3f_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3fv_adr := GetProcAddress('glSecondaryColor3fv');
    private z_SecondaryColor3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_SecondaryColor3fv_adr);
    private z_SecondaryColor3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3fv_ovr_0(v[0]) else
      z_SecondaryColor3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fv(var v: single) :=
    z_SecondaryColor3fv_ovr_0(v);
    private z_SecondaryColor3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fv(v: IntPtr) :=
    z_SecondaryColor3fv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3i_adr := GetProcAddress('glSecondaryColor3i');
    private z_SecondaryColor3i_ovr_0 := GetProcOrNil&<procedure(red: Int32; green: Int32; blue: Int32)>(z_SecondaryColor3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3i(red: Int32; green: Int32; blue: Int32) :=
    z_SecondaryColor3i_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3iv_adr := GetProcAddress('glSecondaryColor3iv');
    private z_SecondaryColor3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_SecondaryColor3iv_adr);
    private z_SecondaryColor3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3iv_ovr_0(v[0]) else
      z_SecondaryColor3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iv(var v: Int32) :=
    z_SecondaryColor3iv_ovr_0(v);
    private z_SecondaryColor3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iv(v: IntPtr) :=
    z_SecondaryColor3iv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3s_adr := GetProcAddress('glSecondaryColor3s');
    private z_SecondaryColor3s_ovr_0 := GetProcOrNil&<procedure(red: Int16; green: Int16; blue: Int16)>(z_SecondaryColor3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3s(red: Int16; green: Int16; blue: Int16) :=
    z_SecondaryColor3s_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3sv_adr := GetProcAddress('glSecondaryColor3sv');
    private z_SecondaryColor3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_SecondaryColor3sv_adr);
    private z_SecondaryColor3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3sv_ovr_0(v[0]) else
      z_SecondaryColor3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sv(var v: Int16) :=
    z_SecondaryColor3sv_ovr_0(v);
    private z_SecondaryColor3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sv(v: IntPtr) :=
    z_SecondaryColor3sv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3ub_adr := GetProcAddress('glSecondaryColor3ub');
    private z_SecondaryColor3ub_ovr_0 := GetProcOrNil&<procedure(red: Byte; green: Byte; blue: Byte)>(z_SecondaryColor3ub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ub(red: Byte; green: Byte; blue: Byte) :=
    z_SecondaryColor3ub_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3ubv_adr := GetProcAddress('glSecondaryColor3ubv');
    private z_SecondaryColor3ubv_ovr_0 := GetProcOrNil&<procedure(var v: Byte)>(z_SecondaryColor3ubv_adr);
    private z_SecondaryColor3ubv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubv(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3ubv_ovr_0(v[0]) else
      z_SecondaryColor3ubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubv(var v: Byte) :=
    z_SecondaryColor3ubv_ovr_0(v);
    private z_SecondaryColor3ubv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubv(v: IntPtr) :=
    z_SecondaryColor3ubv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3ui_adr := GetProcAddress('glSecondaryColor3ui');
    private z_SecondaryColor3ui_ovr_0 := GetProcOrNil&<procedure(red: UInt32; green: UInt32; blue: UInt32)>(z_SecondaryColor3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ui(red: UInt32; green: UInt32; blue: UInt32) :=
    z_SecondaryColor3ui_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3uiv_adr := GetProcAddress('glSecondaryColor3uiv');
    private z_SecondaryColor3uiv_ovr_0 := GetProcOrNil&<procedure(var v: UInt32)>(z_SecondaryColor3uiv_adr);
    private z_SecondaryColor3uiv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiv(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3uiv_ovr_0(v[0]) else
      z_SecondaryColor3uiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiv(var v: UInt32) :=
    z_SecondaryColor3uiv_ovr_0(v);
    private z_SecondaryColor3uiv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiv(v: IntPtr) :=
    z_SecondaryColor3uiv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3us_adr := GetProcAddress('glSecondaryColor3us');
    private z_SecondaryColor3us_ovr_0 := GetProcOrNil&<procedure(red: UInt16; green: UInt16; blue: UInt16)>(z_SecondaryColor3us_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3us(red: UInt16; green: UInt16; blue: UInt16) :=
    z_SecondaryColor3us_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3usv_adr := GetProcAddress('glSecondaryColor3usv');
    private z_SecondaryColor3usv_ovr_0 := GetProcOrNil&<procedure(var v: UInt16)>(z_SecondaryColor3usv_adr);
    private z_SecondaryColor3usv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usv(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3usv_ovr_0(v[0]) else
      z_SecondaryColor3usv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usv(var v: UInt16) :=
    z_SecondaryColor3usv_ovr_0(v);
    private z_SecondaryColor3usv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usv(v: IntPtr) :=
    z_SecondaryColor3usv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColorPointer_adr := GetProcAddress('glSecondaryColorPointer');
    private z_SecondaryColorPointer_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr)>(z_SecondaryColorPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointer(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr) :=
    z_SecondaryColorPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_SelectBuffer_adr := GetProcAddress('glSelectBuffer');
    private z_SelectBuffer_ovr_0 := GetProcOrNil&<procedure(size: Int32; var buffer: UInt32)>(z_SelectBuffer_adr);
    private z_SelectBuffer_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; buffer: IntPtr)>(z_SelectBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectBuffer(size: Int32; buffer: array of UInt32) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_SelectBuffer_ovr_0(size, buffer[0]) else
      z_SelectBuffer_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectBuffer(size: Int32; var buffer: UInt32) :=
    z_SelectBuffer_ovr_0(size, buffer);
    private z_SelectBuffer_ovr_2 := GetProcOrNil&<procedure(size: Int32; buffer: IntPtr)>(z_SelectBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectBuffer(size: Int32; buffer: IntPtr) :=
    z_SelectBuffer_ovr_2(size, buffer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_ShadeModel_adr := GetProcAddress('glShadeModel');
    private z_ShadeModel_ovr_0 := GetProcOrNil&<procedure(mode: ShadingModel)>(z_ShadeModel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadeModel(mode: ShadingModel) :=
    z_ShadeModel_ovr_0(mode);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1d_adr := GetProcAddress('glTexCoord1d');
    private z_TexCoord1d_ovr_0 := GetProcOrNil&<procedure(s: real)>(z_TexCoord1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1d(s: real) :=
    z_TexCoord1d_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1dv_adr := GetProcAddress('glTexCoord1dv');
    private z_TexCoord1dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_TexCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1dv(var v: real) :=
    z_TexCoord1dv_ovr_0(v);
    private z_TexCoord1dv_ovr_1 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1dv(v: IntPtr) :=
    z_TexCoord1dv_ovr_1(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1f_adr := GetProcAddress('glTexCoord1f');
    private z_TexCoord1f_ovr_0 := GetProcOrNil&<procedure(s: single)>(z_TexCoord1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1f(s: single) :=
    z_TexCoord1f_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1fv_adr := GetProcAddress('glTexCoord1fv');
    private z_TexCoord1fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_TexCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1fv(var v: single) :=
    z_TexCoord1fv_ovr_0(v);
    private z_TexCoord1fv_ovr_1 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1fv(v: IntPtr) :=
    z_TexCoord1fv_ovr_1(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1i_adr := GetProcAddress('glTexCoord1i');
    private z_TexCoord1i_ovr_0 := GetProcOrNil&<procedure(s: Int32)>(z_TexCoord1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1i(s: Int32) :=
    z_TexCoord1i_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1iv_adr := GetProcAddress('glTexCoord1iv');
    private z_TexCoord1iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_TexCoord1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1iv(var v: Int32) :=
    z_TexCoord1iv_ovr_0(v);
    private z_TexCoord1iv_ovr_1 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1iv(v: IntPtr) :=
    z_TexCoord1iv_ovr_1(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1s_adr := GetProcAddress('glTexCoord1s');
    private z_TexCoord1s_ovr_0 := GetProcOrNil&<procedure(s: Int16)>(z_TexCoord1s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1s(s: Int16) :=
    z_TexCoord1s_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord1sv_adr := GetProcAddress('glTexCoord1sv');
    private z_TexCoord1sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_TexCoord1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1sv(var v: Int16) :=
    z_TexCoord1sv_ovr_0(v);
    private z_TexCoord1sv_ovr_1 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1sv(v: IntPtr) :=
    z_TexCoord1sv_ovr_1(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2d_adr := GetProcAddress('glTexCoord2d');
    private z_TexCoord2d_ovr_0 := GetProcOrNil&<procedure(s: real; t: real)>(z_TexCoord2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2d(s: real; t: real) :=
    z_TexCoord2d_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2dv_adr := GetProcAddress('glTexCoord2dv');
    private z_TexCoord2dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_TexCoord2dv_adr);
    private z_TexCoord2dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2dv_ovr_0(v[0]) else
      z_TexCoord2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2dv(var v: real) :=
    z_TexCoord2dv_ovr_0(v);
    private z_TexCoord2dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2dv(v: IntPtr) :=
    z_TexCoord2dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2f_adr := GetProcAddress('glTexCoord2f');
    private z_TexCoord2f_ovr_0 := GetProcOrNil&<procedure(s: single; t: single)>(z_TexCoord2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2f(s: single; t: single) :=
    z_TexCoord2f_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2fv_adr := GetProcAddress('glTexCoord2fv');
    private z_TexCoord2fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_TexCoord2fv_adr);
    private z_TexCoord2fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2fv_ovr_0(v[0]) else
      z_TexCoord2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fv(var v: single) :=
    z_TexCoord2fv_ovr_0(v);
    private z_TexCoord2fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fv(v: IntPtr) :=
    z_TexCoord2fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2i_adr := GetProcAddress('glTexCoord2i');
    private z_TexCoord2i_ovr_0 := GetProcOrNil&<procedure(s: Int32; t: Int32)>(z_TexCoord2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2i(s: Int32; t: Int32) :=
    z_TexCoord2i_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2iv_adr := GetProcAddress('glTexCoord2iv');
    private z_TexCoord2iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_TexCoord2iv_adr);
    private z_TexCoord2iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2iv_ovr_0(v[0]) else
      z_TexCoord2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2iv(var v: Int32) :=
    z_TexCoord2iv_ovr_0(v);
    private z_TexCoord2iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2iv(v: IntPtr) :=
    z_TexCoord2iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2s_adr := GetProcAddress('glTexCoord2s');
    private z_TexCoord2s_ovr_0 := GetProcOrNil&<procedure(s: Int16; t: Int16)>(z_TexCoord2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2s(s: Int16; t: Int16) :=
    z_TexCoord2s_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord2sv_adr := GetProcAddress('glTexCoord2sv');
    private z_TexCoord2sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_TexCoord2sv_adr);
    private z_TexCoord2sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2sv_ovr_0(v[0]) else
      z_TexCoord2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2sv(var v: Int16) :=
    z_TexCoord2sv_ovr_0(v);
    private z_TexCoord2sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2sv(v: IntPtr) :=
    z_TexCoord2sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3d_adr := GetProcAddress('glTexCoord3d');
    private z_TexCoord3d_ovr_0 := GetProcOrNil&<procedure(s: real; t: real; r: real)>(z_TexCoord3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3d(s: real; t: real; r: real) :=
    z_TexCoord3d_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3dv_adr := GetProcAddress('glTexCoord3dv');
    private z_TexCoord3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_TexCoord3dv_adr);
    private z_TexCoord3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3dv_ovr_0(v[0]) else
      z_TexCoord3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3dv(var v: real) :=
    z_TexCoord3dv_ovr_0(v);
    private z_TexCoord3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3dv(v: IntPtr) :=
    z_TexCoord3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3f_adr := GetProcAddress('glTexCoord3f');
    private z_TexCoord3f_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; r: single)>(z_TexCoord3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3f(s: single; t: single; r: single) :=
    z_TexCoord3f_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3fv_adr := GetProcAddress('glTexCoord3fv');
    private z_TexCoord3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_TexCoord3fv_adr);
    private z_TexCoord3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3fv_ovr_0(v[0]) else
      z_TexCoord3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3fv(var v: single) :=
    z_TexCoord3fv_ovr_0(v);
    private z_TexCoord3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3fv(v: IntPtr) :=
    z_TexCoord3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3i_adr := GetProcAddress('glTexCoord3i');
    private z_TexCoord3i_ovr_0 := GetProcOrNil&<procedure(s: Int32; t: Int32; r: Int32)>(z_TexCoord3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3i(s: Int32; t: Int32; r: Int32) :=
    z_TexCoord3i_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3iv_adr := GetProcAddress('glTexCoord3iv');
    private z_TexCoord3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_TexCoord3iv_adr);
    private z_TexCoord3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3iv_ovr_0(v[0]) else
      z_TexCoord3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3iv(var v: Int32) :=
    z_TexCoord3iv_ovr_0(v);
    private z_TexCoord3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3iv(v: IntPtr) :=
    z_TexCoord3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3s_adr := GetProcAddress('glTexCoord3s');
    private z_TexCoord3s_ovr_0 := GetProcOrNil&<procedure(s: Int16; t: Int16; r: Int16)>(z_TexCoord3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3s(s: Int16; t: Int16; r: Int16) :=
    z_TexCoord3s_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord3sv_adr := GetProcAddress('glTexCoord3sv');
    private z_TexCoord3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_TexCoord3sv_adr);
    private z_TexCoord3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3sv_ovr_0(v[0]) else
      z_TexCoord3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3sv(var v: Int16) :=
    z_TexCoord3sv_ovr_0(v);
    private z_TexCoord3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3sv(v: IntPtr) :=
    z_TexCoord3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4d_adr := GetProcAddress('glTexCoord4d');
    private z_TexCoord4d_ovr_0 := GetProcOrNil&<procedure(s: real; t: real; r: real; q: real)>(z_TexCoord4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4d(s: real; t: real; r: real; q: real) :=
    z_TexCoord4d_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4dv_adr := GetProcAddress('glTexCoord4dv');
    private z_TexCoord4dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_TexCoord4dv_adr);
    private z_TexCoord4dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4dv_ovr_0(v[0]) else
      z_TexCoord4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4dv(var v: real) :=
    z_TexCoord4dv_ovr_0(v);
    private z_TexCoord4dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4dv(v: IntPtr) :=
    z_TexCoord4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4f_adr := GetProcAddress('glTexCoord4f');
    private z_TexCoord4f_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; r: single; q: single)>(z_TexCoord4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4f(s: single; t: single; r: single; q: single) :=
    z_TexCoord4f_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4fv_adr := GetProcAddress('glTexCoord4fv');
    private z_TexCoord4fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_TexCoord4fv_adr);
    private z_TexCoord4fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4fv_ovr_0(v[0]) else
      z_TexCoord4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fv(var v: single) :=
    z_TexCoord4fv_ovr_0(v);
    private z_TexCoord4fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fv(v: IntPtr) :=
    z_TexCoord4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4i_adr := GetProcAddress('glTexCoord4i');
    private z_TexCoord4i_ovr_0 := GetProcOrNil&<procedure(s: Int32; t: Int32; r: Int32; q: Int32)>(z_TexCoord4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4i(s: Int32; t: Int32; r: Int32; q: Int32) :=
    z_TexCoord4i_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4iv_adr := GetProcAddress('glTexCoord4iv');
    private z_TexCoord4iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_TexCoord4iv_adr);
    private z_TexCoord4iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4iv_ovr_0(v[0]) else
      z_TexCoord4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4iv(var v: Int32) :=
    z_TexCoord4iv_ovr_0(v);
    private z_TexCoord4iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4iv(v: IntPtr) :=
    z_TexCoord4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4s_adr := GetProcAddress('glTexCoord4s');
    private z_TexCoord4s_ovr_0 := GetProcOrNil&<procedure(s: Int16; t: Int16; r: Int16; q: Int16)>(z_TexCoord4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4s(s: Int16; t: Int16; r: Int16; q: Int16) :=
    z_TexCoord4s_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexCoord4sv_adr := GetProcAddress('glTexCoord4sv');
    private z_TexCoord4sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_TexCoord4sv_adr);
    private z_TexCoord4sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4sv_ovr_0(v[0]) else
      z_TexCoord4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4sv(var v: Int16) :=
    z_TexCoord4sv_ovr_0(v);
    private z_TexCoord4sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4sv(v: IntPtr) :=
    z_TexCoord4sv_ovr_2(v);
    
    // added in gl1.1, deprecated in gl3.2
    private z_TexCoordPointer_adr := GetProcAddress('glTexCoordPointer');
    private z_TexCoordPointer_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr)>(z_TexCoordPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointer(size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr) :=
    z_TexCoordPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexEnvf_adr := GetProcAddress('glTexEnvf');
    private z_TexEnvf_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; param: single)>(z_TexEnvf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvf(target: TextureEnvTarget; pname: TextureEnvParameter; param: single) :=
    z_TexEnvf_ovr_0(target, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexEnvfv_adr := GetProcAddress('glTexEnvfv');
    private z_TexEnvfv_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single)>(z_TexEnvfv_adr);
    private z_TexEnvfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_TexEnvfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexEnvfv_ovr_0(target, pname, &params[0]) else
      z_TexEnvfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_TexEnvfv_ovr_0(target, pname, &params);
    private z_TexEnvfv_ovr_2 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_TexEnvfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_TexEnvfv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexEnvi_adr := GetProcAddress('glTexEnvi');
    private z_TexEnvi_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32)>(z_TexEnvi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvi(target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32) :=
    z_TexEnvi_ovr_0(target, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexEnviv_adr := GetProcAddress('glTexEnviv');
    private z_TexEnviv_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32)>(z_TexEnviv_adr);
    private z_TexEnviv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_TexEnviv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexEnviv_ovr_0(target, pname, &params[0]) else
      z_TexEnviv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_TexEnviv_ovr_0(target, pname, &params);
    private z_TexEnviv_ovr_2 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_TexEnviv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_TexEnviv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexGend_adr := GetProcAddress('glTexGend');
    private z_TexGend_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; param: real)>(z_TexGend_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGend(coord: TextureCoordName; pname: TextureGenParameter; param: real) :=
    z_TexGend_ovr_0(coord, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexGendv_adr := GetProcAddress('glTexGendv');
    private z_TexGendv_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: real)>(z_TexGendv_adr);
    private z_TexGendv_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGendv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGendv_ovr_0(coord, pname, &params[0]) else
      z_TexGendv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGendv(coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_TexGendv_ovr_0(coord, pname, &params);
    private z_TexGendv_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGendv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGendv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexGenf_adr := GetProcAddress('glTexGenf');
    private z_TexGenf_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; param: single)>(z_TexGenf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenf(coord: TextureCoordName; pname: TextureGenParameter; param: single) :=
    z_TexGenf_ovr_0(coord, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexGenfv_adr := GetProcAddress('glTexGenfv');
    private z_TexGenfv_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: single)>(z_TexGenfv_adr);
    private z_TexGenfv_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGenfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGenfv_ovr_0(coord, pname, &params[0]) else
      z_TexGenfv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenfv(coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_TexGenfv_ovr_0(coord, pname, &params);
    private z_TexGenfv_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGenfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGenfv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexGeni_adr := GetProcAddress('glTexGeni');
    private z_TexGeni_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; param: Int32)>(z_TexGeni_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeni(coord: TextureCoordName; pname: TextureGenParameter; param: Int32) :=
    z_TexGeni_ovr_0(coord, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private z_TexGeniv_adr := GetProcAddress('glTexGeniv');
    private z_TexGeniv_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32)>(z_TexGeniv_adr);
    private z_TexGeniv_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGeniv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGeniv_ovr_0(coord, pname, &params[0]) else
      z_TexGeniv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeniv(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_TexGeniv_ovr_0(coord, pname, &params);
    private z_TexGeniv_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGeniv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGeniv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Translated_adr := GetProcAddress('glTranslated');
    private z_Translated_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_Translated_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Translated(x: real; y: real; z: real) :=
    z_Translated_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Translatef_adr := GetProcAddress('glTranslatef');
    private z_Translatef_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_Translatef_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Translatef(x: single; y: single; z: single) :=
    z_Translatef_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2d_adr := GetProcAddress('glVertex2d');
    private z_Vertex2d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real)>(z_Vertex2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2d(x: real; y: real) :=
    z_Vertex2d_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2dv_adr := GetProcAddress('glVertex2dv');
    private z_Vertex2dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Vertex2dv_adr);
    private z_Vertex2dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2dv_ovr_0(v[0]) else
      z_Vertex2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2dv(var v: real) :=
    z_Vertex2dv_ovr_0(v);
    private z_Vertex2dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2dv(v: IntPtr) :=
    z_Vertex2dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2f_adr := GetProcAddress('glVertex2f');
    private z_Vertex2f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single)>(z_Vertex2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2f(x: single; y: single) :=
    z_Vertex2f_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2fv_adr := GetProcAddress('glVertex2fv');
    private z_Vertex2fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Vertex2fv_adr);
    private z_Vertex2fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2fv_ovr_0(v[0]) else
      z_Vertex2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2fv(var v: single) :=
    z_Vertex2fv_ovr_0(v);
    private z_Vertex2fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2fv(v: IntPtr) :=
    z_Vertex2fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2i_adr := GetProcAddress('glVertex2i');
    private z_Vertex2i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32)>(z_Vertex2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2i(x: Int32; y: Int32) :=
    z_Vertex2i_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2iv_adr := GetProcAddress('glVertex2iv');
    private z_Vertex2iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Vertex2iv_adr);
    private z_Vertex2iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2iv_ovr_0(v[0]) else
      z_Vertex2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2iv(var v: Int32) :=
    z_Vertex2iv_ovr_0(v);
    private z_Vertex2iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2iv(v: IntPtr) :=
    z_Vertex2iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2s_adr := GetProcAddress('glVertex2s');
    private z_Vertex2s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16)>(z_Vertex2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2s(x: Int16; y: Int16) :=
    z_Vertex2s_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex2sv_adr := GetProcAddress('glVertex2sv');
    private z_Vertex2sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Vertex2sv_adr);
    private z_Vertex2sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2sv_ovr_0(v[0]) else
      z_Vertex2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2sv(var v: Int16) :=
    z_Vertex2sv_ovr_0(v);
    private z_Vertex2sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2sv(v: IntPtr) :=
    z_Vertex2sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3d_adr := GetProcAddress('glVertex3d');
    private z_Vertex3d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_Vertex3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3d(x: real; y: real; z: real) :=
    z_Vertex3d_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3dv_adr := GetProcAddress('glVertex3dv');
    private z_Vertex3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Vertex3dv_adr);
    private z_Vertex3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3dv_ovr_0(v[0]) else
      z_Vertex3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3dv(var v: real) :=
    z_Vertex3dv_ovr_0(v);
    private z_Vertex3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3dv(v: IntPtr) :=
    z_Vertex3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3f_adr := GetProcAddress('glVertex3f');
    private z_Vertex3f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_Vertex3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3f(x: single; y: single; z: single) :=
    z_Vertex3f_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3fv_adr := GetProcAddress('glVertex3fv');
    private z_Vertex3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Vertex3fv_adr);
    private z_Vertex3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3fv_ovr_0(v[0]) else
      z_Vertex3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3fv(var v: single) :=
    z_Vertex3fv_ovr_0(v);
    private z_Vertex3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3fv(v: IntPtr) :=
    z_Vertex3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3i_adr := GetProcAddress('glVertex3i');
    private z_Vertex3i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32)>(z_Vertex3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3i(x: Int32; y: Int32; z: Int32) :=
    z_Vertex3i_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3iv_adr := GetProcAddress('glVertex3iv');
    private z_Vertex3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Vertex3iv_adr);
    private z_Vertex3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3iv_ovr_0(v[0]) else
      z_Vertex3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3iv(var v: Int32) :=
    z_Vertex3iv_ovr_0(v);
    private z_Vertex3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3iv(v: IntPtr) :=
    z_Vertex3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3s_adr := GetProcAddress('glVertex3s');
    private z_Vertex3s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16)>(z_Vertex3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3s(x: Int16; y: Int16; z: Int16) :=
    z_Vertex3s_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex3sv_adr := GetProcAddress('glVertex3sv');
    private z_Vertex3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Vertex3sv_adr);
    private z_Vertex3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3sv_ovr_0(v[0]) else
      z_Vertex3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3sv(var v: Int16) :=
    z_Vertex3sv_ovr_0(v);
    private z_Vertex3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3sv(v: IntPtr) :=
    z_Vertex3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4d_adr := GetProcAddress('glVertex4d');
    private z_Vertex4d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real; w: real)>(z_Vertex4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4d(x: real; y: real; z: real; w: real) :=
    z_Vertex4d_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4dv_adr := GetProcAddress('glVertex4dv');
    private z_Vertex4dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Vertex4dv_adr);
    private z_Vertex4dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4dv_ovr_0(v[0]) else
      z_Vertex4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4dv(var v: real) :=
    z_Vertex4dv_ovr_0(v);
    private z_Vertex4dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4dv(v: IntPtr) :=
    z_Vertex4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4f_adr := GetProcAddress('glVertex4f');
    private z_Vertex4f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single; w: single)>(z_Vertex4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4f(x: single; y: single; z: single; w: single) :=
    z_Vertex4f_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4fv_adr := GetProcAddress('glVertex4fv');
    private z_Vertex4fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Vertex4fv_adr);
    private z_Vertex4fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4fv_ovr_0(v[0]) else
      z_Vertex4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4fv(var v: single) :=
    z_Vertex4fv_ovr_0(v);
    private z_Vertex4fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4fv(v: IntPtr) :=
    z_Vertex4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4i_adr := GetProcAddress('glVertex4i');
    private z_Vertex4i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32; w: Int32)>(z_Vertex4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4i(x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_Vertex4i_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4iv_adr := GetProcAddress('glVertex4iv');
    private z_Vertex4iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Vertex4iv_adr);
    private z_Vertex4iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4iv_ovr_0(v[0]) else
      z_Vertex4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4iv(var v: Int32) :=
    z_Vertex4iv_ovr_0(v);
    private z_Vertex4iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4iv(v: IntPtr) :=
    z_Vertex4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4s_adr := GetProcAddress('glVertex4s');
    private z_Vertex4s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16; w: Int16)>(z_Vertex4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4s(x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_Vertex4s_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private z_Vertex4sv_adr := GetProcAddress('glVertex4sv');
    private z_Vertex4sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Vertex4sv_adr);
    private z_Vertex4sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4sv_ovr_0(v[0]) else
      z_Vertex4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4sv(var v: Int16) :=
    z_Vertex4sv_ovr_0(v);
    private z_Vertex4sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4sv(v: IntPtr) :=
    z_Vertex4sv_ovr_2(v);
    
    // added in gl1.1, deprecated in gl3.2
    private z_VertexPointer_adr := GetProcAddress('glVertexPointer');
    private z_VertexPointer_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; stride: Int32; pointer: IntPtr)>(z_VertexPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointer(size: Int32; &type: VertexPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2d_adr := GetProcAddress('glWindowPos2d');
    private z_WindowPos2d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real)>(z_WindowPos2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2d(x: real; y: real) :=
    z_WindowPos2d_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2dv_adr := GetProcAddress('glWindowPos2dv');
    private z_WindowPos2dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos2dv_adr);
    private z_WindowPos2dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2dv_ovr_0(v[0]) else
      z_WindowPos2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dv(var v: real) :=
    z_WindowPos2dv_ovr_0(v);
    private z_WindowPos2dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dv(v: IntPtr) :=
    z_WindowPos2dv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2f_adr := GetProcAddress('glWindowPos2f');
    private z_WindowPos2f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single)>(z_WindowPos2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2f(x: single; y: single) :=
    z_WindowPos2f_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2fv_adr := GetProcAddress('glWindowPos2fv');
    private z_WindowPos2fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos2fv_adr);
    private z_WindowPos2fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2fv_ovr_0(v[0]) else
      z_WindowPos2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fv(var v: single) :=
    z_WindowPos2fv_ovr_0(v);
    private z_WindowPos2fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fv(v: IntPtr) :=
    z_WindowPos2fv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2i_adr := GetProcAddress('glWindowPos2i');
    private z_WindowPos2i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32)>(z_WindowPos2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2i(x: Int32; y: Int32) :=
    z_WindowPos2i_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2iv_adr := GetProcAddress('glWindowPos2iv');
    private z_WindowPos2iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos2iv_adr);
    private z_WindowPos2iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2iv_ovr_0(v[0]) else
      z_WindowPos2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iv(var v: Int32) :=
    z_WindowPos2iv_ovr_0(v);
    private z_WindowPos2iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iv(v: IntPtr) :=
    z_WindowPos2iv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2s_adr := GetProcAddress('glWindowPos2s');
    private z_WindowPos2s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16)>(z_WindowPos2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2s(x: Int16; y: Int16) :=
    z_WindowPos2s_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2sv_adr := GetProcAddress('glWindowPos2sv');
    private z_WindowPos2sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos2sv_adr);
    private z_WindowPos2sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2sv_ovr_0(v[0]) else
      z_WindowPos2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sv(var v: Int16) :=
    z_WindowPos2sv_ovr_0(v);
    private z_WindowPos2sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sv(v: IntPtr) :=
    z_WindowPos2sv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3d_adr := GetProcAddress('glWindowPos3d');
    private z_WindowPos3d_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_WindowPos3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3d(x: real; y: real; z: real) :=
    z_WindowPos3d_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3dv_adr := GetProcAddress('glWindowPos3dv');
    private z_WindowPos3dv_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos3dv_adr);
    private z_WindowPos3dv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3dv_ovr_0(v[0]) else
      z_WindowPos3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dv(var v: real) :=
    z_WindowPos3dv_ovr_0(v);
    private z_WindowPos3dv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dv(v: IntPtr) :=
    z_WindowPos3dv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3f_adr := GetProcAddress('glWindowPos3f');
    private z_WindowPos3f_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_WindowPos3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3f(x: single; y: single; z: single) :=
    z_WindowPos3f_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3fv_adr := GetProcAddress('glWindowPos3fv');
    private z_WindowPos3fv_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos3fv_adr);
    private z_WindowPos3fv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3fv_ovr_0(v[0]) else
      z_WindowPos3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fv(var v: single) :=
    z_WindowPos3fv_ovr_0(v);
    private z_WindowPos3fv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fv(v: IntPtr) :=
    z_WindowPos3fv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3i_adr := GetProcAddress('glWindowPos3i');
    private z_WindowPos3i_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32)>(z_WindowPos3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3i(x: Int32; y: Int32; z: Int32) :=
    z_WindowPos3i_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3iv_adr := GetProcAddress('glWindowPos3iv');
    private z_WindowPos3iv_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos3iv_adr);
    private z_WindowPos3iv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3iv_ovr_0(v[0]) else
      z_WindowPos3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iv(var v: Int32) :=
    z_WindowPos3iv_ovr_0(v);
    private z_WindowPos3iv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iv(v: IntPtr) :=
    z_WindowPos3iv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3s_adr := GetProcAddress('glWindowPos3s');
    private z_WindowPos3s_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16)>(z_WindowPos3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3s(x: Int16; y: Int16; z: Int16) :=
    z_WindowPos3s_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3sv_adr := GetProcAddress('glWindowPos3sv');
    private z_WindowPos3sv_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos3sv_adr);
    private z_WindowPos3sv_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3sv_ovr_0(v[0]) else
      z_WindowPos3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sv(var v: Int16) :=
    z_WindowPos3sv_ovr_0(v);
    private z_WindowPos3sv_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sv(v: IntPtr) :=
    z_WindowPos3sv_ovr_2(v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wgl = static class
    
    // added in wgl1.0
    private static function z_CopyContext_ovr_0(hglrcSrc: wgl_context; hglrcDst: wgl_context; mask: UInt32): Bool;
    external 'opengl32.dll' name 'wglCopyContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CopyContext(hglrcSrc: wgl_context; hglrcDst: wgl_context; mask: UInt32): Bool :=
    z_CopyContext_ovr_0(hglrcSrc, hglrcDst, mask);
    
    // added in wgl1.0
    private static function z_CreateContext_ovr_0(hDc: gdi_device_context): wgl_context;
    external 'opengl32.dll' name 'wglCreateContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateContext(hDc: gdi_device_context): wgl_context :=
    z_CreateContext_ovr_0(hDc);
    
    // added in wgl1.0
    private static function z_CreateLayerContext_ovr_0(hDc: gdi_device_context; level: Int32): wgl_context;
    external 'opengl32.dll' name 'wglCreateLayerContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateLayerContext(hDc: gdi_device_context; level: Int32): wgl_context :=
    z_CreateLayerContext_ovr_0(hDc, level);
    
    // added in wgl1.0
    private static function z_DeleteContext_ovr_0(oldContext: wgl_context): Bool;
    external 'opengl32.dll' name 'wglDeleteContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DeleteContext(oldContext: wgl_context): Bool :=
    z_DeleteContext_ovr_0(oldContext);
    
    // added in wgl1.0
    private static function z_DescribeLayerPlane_ovr_0(hDc: gdi_device_context; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; var plpd: gdi_layer_plane_descriptor): Bool;
    external 'opengl32.dll' name 'wglDescribeLayerPlane';
    private static function z_DescribeLayerPlane_ovr_0_anh000001(hDc: gdi_device_context; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: IntPtr): Bool;
    external 'opengl32.dll' name 'wglDescribeLayerPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribeLayerPlane(hDc: gdi_device_context; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: array of gdi_layer_plane_descriptor): Bool :=
    if (plpd<>nil) and (plpd.Length<>0) then
      z_DescribeLayerPlane_ovr_0(hDc, pixelFormat, layerPlane, nBytes, plpd[0]) else
      z_DescribeLayerPlane_ovr_0_anh000001(hDc, pixelFormat, layerPlane, nBytes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribeLayerPlane(hDc: gdi_device_context; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; var plpd: gdi_layer_plane_descriptor): Bool :=
    z_DescribeLayerPlane_ovr_0(hDc, pixelFormat, layerPlane, nBytes, plpd);
    private static function z_DescribeLayerPlane_ovr_2(hDc: gdi_device_context; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: IntPtr): Bool;
    external 'opengl32.dll' name 'wglDescribeLayerPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribeLayerPlane(hDc: gdi_device_context; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: IntPtr): Bool :=
    z_DescribeLayerPlane_ovr_2(hDc, pixelFormat, layerPlane, nBytes, plpd);
    
    // added in wgl1.0
    private static function z_GetCurrentContext_ovr_0: wgl_context;
    external 'opengl32.dll' name 'wglGetCurrentContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentContext: wgl_context :=
    z_GetCurrentContext_ovr_0;
    
    // added in wgl1.0
    private static function z_GetCurrentDC_ovr_0: gdi_device_context;
    external 'opengl32.dll' name 'wglGetCurrentDC';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentDC: gdi_device_context :=
    z_GetCurrentDC_ovr_0;
    
    // added in wgl1.0
    private static function z_GetLayerPaletteEntries_ovr_0(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: gdi_colorref): Int32;
    external 'opengl32.dll' name 'wglGetLayerPaletteEntries';
    private static function z_GetLayerPaletteEntries_ovr_0_anh000001(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglGetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetLayerPaletteEntries(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: array of gdi_colorref): Int32 :=
    if (pcr<>nil) and (pcr.Length<>0) then
      z_GetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr[0]) else
      z_GetLayerPaletteEntries_ovr_0_anh000001(hdc, iLayerPlane, iStart, cEntries, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetLayerPaletteEntries(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: gdi_colorref): Int32 :=
    z_GetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr);
    private static function z_GetLayerPaletteEntries_ovr_2(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglGetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetLayerPaletteEntries(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32 :=
    z_GetLayerPaletteEntries_ovr_2(hdc, iLayerPlane, iStart, cEntries, pcr);
    
    // added in wgl1.0
    private static function z_GetProcAddress_ovr_0(lpszProc: IntPtr): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetProcAddress(lpszProc: string): IntPtr;
    begin
      var par_1_str_ptr: IntPtr;
      try
        par_1_str_ptr := Marshal.StringToHGlobalAnsi(lpszProc);
        Result := z_GetProcAddress_ovr_0(par_1_str_ptr);
      finally
        Marshal.FreeHGlobal(par_1_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetProcAddress(lpszProc: IntPtr): IntPtr :=
    z_GetProcAddress_ovr_0(lpszProc);
    
    // added in wgl1.0
    private static function z_MakeCurrent_ovr_0(hDc: gdi_device_context; newContext: wgl_context): Bool;
    external 'opengl32.dll' name 'wglMakeCurrent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeCurrent(hDc: gdi_device_context; newContext: wgl_context): Bool :=
    z_MakeCurrent_ovr_0(hDc, newContext);
    
    // added in wgl1.0
    private static function z_RealizeLayerPalette_ovr_0(hdc: gdi_device_context; iLayerPlane: Int32; bRealize: Bool): Bool;
    external 'opengl32.dll' name 'wglRealizeLayerPalette';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function RealizeLayerPalette(hdc: gdi_device_context; iLayerPlane: Int32; bRealize: Bool): Bool :=
    z_RealizeLayerPalette_ovr_0(hdc, iLayerPlane, bRealize);
    
    // added in wgl1.0
    private static function z_SetLayerPaletteEntries_ovr_0(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: gdi_colorref): Int32;
    external 'opengl32.dll' name 'wglSetLayerPaletteEntries';
    private static function z_SetLayerPaletteEntries_ovr_0_anh000001(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglSetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetLayerPaletteEntries(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: array of gdi_colorref): Int32 :=
    if (pcr<>nil) and (pcr.Length<>0) then
      z_SetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr[0]) else
      z_SetLayerPaletteEntries_ovr_0_anh000001(hdc, iLayerPlane, iStart, cEntries, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetLayerPaletteEntries(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: gdi_colorref): Int32 :=
    z_SetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr);
    private static function z_SetLayerPaletteEntries_ovr_2(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglSetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetLayerPaletteEntries(hdc: gdi_device_context; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32 :=
    z_SetLayerPaletteEntries_ovr_2(hdc, iLayerPlane, iStart, cEntries, pcr);
    
    // added in wgl1.0
    private static function z_ShareLists_ovr_0(hrcSrvShare: wgl_context; hrcSrvSource: wgl_context): Bool;
    external 'opengl32.dll' name 'wglShareLists';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ShareLists(hrcSrvShare: wgl_context; hrcSrvSource: wgl_context): Bool :=
    z_ShareLists_ovr_0(hrcSrvShare, hrcSrvSource);
    
    // added in wgl1.0
    private static function z_SwapLayerBuffers_ovr_0(hdc: gdi_device_context; fuFlags: UInt32): Bool;
    external 'opengl32.dll' name 'wglSwapLayerBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapLayerBuffers(hdc: gdi_device_context; fuFlags: UInt32): Bool :=
    z_SwapLayerBuffers_ovr_0(hdc, fuFlags);
    
    // added in wgl1.0
    private static function z_UseFontBitmaps_ovr_0(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32): Bool;
    external 'opengl32.dll' name 'wglUseFontBitmaps';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontBitmaps(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32): Bool :=
    z_UseFontBitmaps_ovr_0(hDC, first, count, listBase);
    
    // added in wgl1.0
    private static function z_UseFontBitmapsA_ovr_0(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32): Bool;
    external 'opengl32.dll' name 'wglUseFontBitmapsA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontBitmapsA(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32): Bool :=
    z_UseFontBitmapsA_ovr_0(hDC, first, count, listBase);
    
    // added in wgl1.0
    private static function z_UseFontBitmapsW_ovr_0(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32): Bool;
    external 'opengl32.dll' name 'wglUseFontBitmapsW';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontBitmapsW(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32): Bool :=
    z_UseFontBitmapsW_ovr_0(hDC, first, count, listBase);
    
    // added in wgl1.0
    private static function z_UseFontOutlines_ovr_0(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: gdi_glyphmetrics_float): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlines';
    private static function z_UseFontOutlines_ovr_0_anh000000001(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlines(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: array of gdi_glyphmetrics_float): Bool :=
    if (lpgmf<>nil) and (lpgmf.Length<>0) then
      z_UseFontOutlines_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf[0]) else
      z_UseFontOutlines_ovr_0_anh000000001(hDC, first, count, listBase, deviation, extrusion, format, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlines(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: gdi_glyphmetrics_float): Bool :=
    z_UseFontOutlines_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    private static function z_UseFontOutlines_ovr_2(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlines(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool :=
    z_UseFontOutlines_ovr_2(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    
    // added in wgl1.0
    private static function z_UseFontOutlinesA_ovr_0(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: gdi_glyphmetrics_float): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlinesA';
    private static function z_UseFontOutlinesA_ovr_0_anh000000001(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlinesA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesA(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: array of gdi_glyphmetrics_float): Bool :=
    if (lpgmf<>nil) and (lpgmf.Length<>0) then
      z_UseFontOutlinesA_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf[0]) else
      z_UseFontOutlinesA_ovr_0_anh000000001(hDC, first, count, listBase, deviation, extrusion, format, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesA(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: gdi_glyphmetrics_float): Bool :=
    z_UseFontOutlinesA_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    private static function z_UseFontOutlinesA_ovr_2(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlinesA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesA(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool :=
    z_UseFontOutlinesA_ovr_2(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    
    // added in wgl1.0
    private static function z_UseFontOutlinesW_ovr_0(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: gdi_glyphmetrics_float): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlinesW';
    private static function z_UseFontOutlinesW_ovr_0_anh000000001(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlinesW';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesW(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: array of gdi_glyphmetrics_float): Bool :=
    if (lpgmf<>nil) and (lpgmf.Length<>0) then
      z_UseFontOutlinesW_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf[0]) else
      z_UseFontOutlinesW_ovr_0_anh000000001(hDC, first, count, listBase, deviation, extrusion, format, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesW(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: gdi_glyphmetrics_float): Bool :=
    z_UseFontOutlinesW_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    private static function z_UseFontOutlinesW_ovr_2(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool;
    external 'opengl32.dll' name 'wglUseFontOutlinesW';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesW(hDC: gdi_device_context; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): Bool :=
    z_UseFontOutlinesW_ovr_2(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glx = static class
    
    // added in glx1.3
    private static function z_ChooseFBConfig_ovr_0(dpy: x_p_display; screen: Int32; var attrib_list: Int32; var nelements: Int32): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    private static function z_ChooseFBConfig_ovr_0_anh00010(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    private static function z_ChooseFBConfig_ovr_0_anh00001(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    private static function z_ChooseFBConfig_ovr_0_anh00011(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; attrib_list: array of Int32; nelements: array of Int32): ^glx_fb_config :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      if (nelements<>nil) and (nelements.Length<>0) then
        z_ChooseFBConfig_ovr_0(dpy, screen, attrib_list[0], nelements[0]) else
        z_ChooseFBConfig_ovr_0_anh00001(dpy, screen, attrib_list[0], IntPtr.Zero) else
      if (nelements<>nil) and (nelements.Length<>0) then
        z_ChooseFBConfig_ovr_0_anh00010(dpy, screen, IntPtr.Zero, nelements[0]) else
        z_ChooseFBConfig_ovr_0_anh00011(dpy, screen, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChooseFBConfig_ovr_1_anh00010(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; attrib_list: array of Int32; var nelements: Int32): ^glx_fb_config :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_ChooseFBConfig_ovr_0(dpy, screen, attrib_list[0], nelements) else
      z_ChooseFBConfig_ovr_0_anh00010(dpy, screen, IntPtr.Zero, nelements);
    private static function z_ChooseFBConfig_ovr_2(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    private static function z_ChooseFBConfig_ovr_2_anh00010(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; attrib_list: array of Int32; nelements: IntPtr): ^glx_fb_config :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_ChooseFBConfig_ovr_2(dpy, screen, attrib_list[0], nelements) else
      z_ChooseFBConfig_ovr_2_anh00010(dpy, screen, IntPtr.Zero, nelements);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: array of Int32): ^glx_fb_config :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_ChooseFBConfig_ovr_0(dpy, screen, attrib_list, nelements[0]) else
      z_ChooseFBConfig_ovr_0_anh00001(dpy, screen, attrib_list, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; var attrib_list: Int32; var nelements: Int32): ^glx_fb_config :=
    z_ChooseFBConfig_ovr_0(dpy, screen, attrib_list, nelements);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: IntPtr): ^glx_fb_config :=
    z_ChooseFBConfig_ovr_2(dpy, screen, attrib_list, nelements);
    private static function z_ChooseFBConfig_ovr_6(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    private static function z_ChooseFBConfig_ovr_6_anh00001(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: array of Int32): ^glx_fb_config :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_ChooseFBConfig_ovr_6(dpy, screen, attrib_list, nelements[0]) else
      z_ChooseFBConfig_ovr_6_anh00001(dpy, screen, attrib_list, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config :=
    z_ChooseFBConfig_ovr_6(dpy, screen, attrib_list, nelements);
    private static function z_ChooseFBConfig_ovr_8(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXChooseFBConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseFBConfig(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config :=
    z_ChooseFBConfig_ovr_8(dpy, screen, attrib_list, nelements);
    
    // added in glx1.0
    private static function z_ChooseVisual_ovr_0(dpy: x_p_display; screen: Int32; var attribList: Int32): x_p_visual_info;
    external 'libGL.so.1' name 'glXChooseVisual';
    private static function z_ChooseVisual_ovr_0_anh0001(dpy: x_p_display; screen: Int32; attribList: IntPtr): x_p_visual_info;
    external 'libGL.so.1' name 'glXChooseVisual';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseVisual(dpy: x_p_display; screen: Int32; attribList: array of Int32): x_p_visual_info :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_ChooseVisual_ovr_0(dpy, screen, attribList[0]) else
      z_ChooseVisual_ovr_0_anh0001(dpy, screen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseVisual(dpy: x_p_display; screen: Int32; var attribList: Int32): x_p_visual_info :=
    z_ChooseVisual_ovr_0(dpy, screen, attribList);
    private static function z_ChooseVisual_ovr_2(dpy: x_p_display; screen: Int32; attribList: IntPtr): x_p_visual_info;
    external 'libGL.so.1' name 'glXChooseVisual';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChooseVisual(dpy: x_p_display; screen: Int32; attribList: IntPtr): x_p_visual_info :=
    z_ChooseVisual_ovr_2(dpy, screen, attribList);
    
    // added in glx1.0
    private static procedure z_CopyContext_ovr_0(dpy: x_p_display; src: glx_context; dst: glx_context; mask: UInt64);
    external 'libGL.so.1' name 'glXCopyContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure CopyContext(dpy: x_p_display; src: glx_context; dst: glx_context; mask: UInt64) :=
    z_CopyContext_ovr_0(dpy, src, dst, mask);
    
    // added in glx1.0
    private static function z_CreateContext_ovr_0(dpy: x_p_display; vis: x_p_visual_info; shareList: glx_context; direct: Bool): glx_context;
    external 'libGL.so.1' name 'glXCreateContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateContext(dpy: x_p_display; vis: x_p_visual_info; shareList: glx_context; direct: Bool): glx_context :=
    z_CreateContext_ovr_0(dpy, vis, shareList, direct);
    
    // added in glx1.0
    private static function z_CreateGLXPixmap_ovr_0(dpy: x_p_display; visual: x_p_visual_info; pixmap: x_pixmap): glx_pixmap;
    external 'libGL.so.1' name 'glXCreateGLXPixmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateGLXPixmap(dpy: x_p_display; visual: x_p_visual_info; pixmap: x_pixmap): glx_pixmap :=
    z_CreateGLXPixmap_ovr_0(dpy, visual, pixmap);
    
    // added in glx1.3
    private static function z_CreateNewContext_ovr_0(dpy: x_p_display; config: glx_fb_config; render_type: Int32; share_list: glx_context; direct: Bool): glx_context;
    external 'libGL.so.1' name 'glXCreateNewContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateNewContext(dpy: x_p_display; config: glx_fb_config; render_type: Int32; share_list: glx_context; direct: Bool): glx_context :=
    z_CreateNewContext_ovr_0(dpy, config, render_type, share_list, direct);
    
    // added in glx1.3
    private static function z_CreatePbuffer_ovr_0(dpy: x_p_display; config: glx_fb_config; var attrib_list: Int32): glx_pbuffer;
    external 'libGL.so.1' name 'glXCreatePbuffer';
    private static function z_CreatePbuffer_ovr_0_anh0001(dpy: x_p_display; config: glx_fb_config; attrib_list: IntPtr): glx_pbuffer;
    external 'libGL.so.1' name 'glXCreatePbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbuffer(dpy: x_p_display; config: glx_fb_config; attrib_list: array of Int32): glx_pbuffer :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_CreatePbuffer_ovr_0(dpy, config, attrib_list[0]) else
      z_CreatePbuffer_ovr_0_anh0001(dpy, config, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbuffer(dpy: x_p_display; config: glx_fb_config; var attrib_list: Int32): glx_pbuffer :=
    z_CreatePbuffer_ovr_0(dpy, config, attrib_list);
    private static function z_CreatePbuffer_ovr_2(dpy: x_p_display; config: glx_fb_config; attrib_list: IntPtr): glx_pbuffer;
    external 'libGL.so.1' name 'glXCreatePbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbuffer(dpy: x_p_display; config: glx_fb_config; attrib_list: IntPtr): glx_pbuffer :=
    z_CreatePbuffer_ovr_2(dpy, config, attrib_list);
    
    // added in glx1.3
    private static function z_CreatePixmap_ovr_0(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap; var attrib_list: Int32): glx_pixmap;
    external 'libGL.so.1' name 'glXCreatePixmap';
    private static function z_CreatePixmap_ovr_0_anh00001(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap; attrib_list: IntPtr): glx_pixmap;
    external 'libGL.so.1' name 'glXCreatePixmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePixmap(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap; attrib_list: array of Int32): glx_pixmap :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_CreatePixmap_ovr_0(dpy, config, pixmap, attrib_list[0]) else
      z_CreatePixmap_ovr_0_anh00001(dpy, config, pixmap, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePixmap(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap; var attrib_list: Int32): glx_pixmap :=
    z_CreatePixmap_ovr_0(dpy, config, pixmap, attrib_list);
    private static function z_CreatePixmap_ovr_2(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap; attrib_list: IntPtr): glx_pixmap;
    external 'libGL.so.1' name 'glXCreatePixmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePixmap(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap; attrib_list: IntPtr): glx_pixmap :=
    z_CreatePixmap_ovr_2(dpy, config, pixmap, attrib_list);
    
    // added in glx1.3
    private static function z_CreateWindow_ovr_0(dpy: x_p_display; config: glx_fb_config; win: x_window; var attrib_list: Int32): glx_window;
    external 'libGL.so.1' name 'glXCreateWindow';
    private static function z_CreateWindow_ovr_0_anh00001(dpy: x_p_display; config: glx_fb_config; win: x_window; attrib_list: IntPtr): glx_window;
    external 'libGL.so.1' name 'glXCreateWindow';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateWindow(dpy: x_p_display; config: glx_fb_config; win: x_window; attrib_list: array of Int32): glx_window :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_CreateWindow_ovr_0(dpy, config, win, attrib_list[0]) else
      z_CreateWindow_ovr_0_anh00001(dpy, config, win, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateWindow(dpy: x_p_display; config: glx_fb_config; win: x_window; var attrib_list: Int32): glx_window :=
    z_CreateWindow_ovr_0(dpy, config, win, attrib_list);
    private static function z_CreateWindow_ovr_2(dpy: x_p_display; config: glx_fb_config; win: x_window; attrib_list: IntPtr): glx_window;
    external 'libGL.so.1' name 'glXCreateWindow';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateWindow(dpy: x_p_display; config: glx_fb_config; win: x_window; attrib_list: IntPtr): glx_window :=
    z_CreateWindow_ovr_2(dpy, config, win, attrib_list);
    
    // added in glx1.0
    private static procedure z_DestroyContext_ovr_0(dpy: x_p_display; ctx: glx_context);
    external 'libGL.so.1' name 'glXDestroyContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DestroyContext(dpy: x_p_display; ctx: glx_context) :=
    z_DestroyContext_ovr_0(dpy, ctx);
    
    // added in glx1.0
    private static procedure z_DestroyGLXPixmap_ovr_0(dpy: x_p_display; pixmap: glx_pixmap);
    external 'libGL.so.1' name 'glXDestroyGLXPixmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DestroyGLXPixmap(dpy: x_p_display; pixmap: glx_pixmap) :=
    z_DestroyGLXPixmap_ovr_0(dpy, pixmap);
    
    // added in glx1.3
    private static procedure z_DestroyPbuffer_ovr_0(dpy: x_p_display; pbuf: glx_pbuffer);
    external 'libGL.so.1' name 'glXDestroyPbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DestroyPbuffer(dpy: x_p_display; pbuf: glx_pbuffer) :=
    z_DestroyPbuffer_ovr_0(dpy, pbuf);
    
    // added in glx1.3
    private static procedure z_DestroyPixmap_ovr_0(dpy: x_p_display; pixmap: glx_pixmap);
    external 'libGL.so.1' name 'glXDestroyPixmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DestroyPixmap(dpy: x_p_display; pixmap: glx_pixmap) :=
    z_DestroyPixmap_ovr_0(dpy, pixmap);
    
    // added in glx1.3
    private static procedure z_DestroyWindow_ovr_0(dpy: x_p_display; win: glx_window);
    external 'libGL.so.1' name 'glXDestroyWindow';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DestroyWindow(dpy: x_p_display; win: glx_window) :=
    z_DestroyWindow_ovr_0(dpy, win);
    
    // added in glx1.1
    private static function z_GetClientString_ovr_0(dpy: x_p_display; name: Int32): IntPtr;
    external 'libGL.so.1' name 'glXGetClientString';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetClientString(dpy: x_p_display; name: Int32): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_GetClientString_ovr_0(dpy, name);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in glx1.0
    private static function z_GetConfig_ovr_0(dpy: x_p_display; visual: x_p_visual_info; attrib: Int32; var value: Int32): Int32;
    external 'libGL.so.1' name 'glXGetConfig';
    private static function z_GetConfig_ovr_0_anh00001(dpy: x_p_display; visual: x_p_visual_info; attrib: Int32; value: IntPtr): Int32;
    external 'libGL.so.1' name 'glXGetConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetConfig(dpy: x_p_display; visual: x_p_visual_info; attrib: Int32; value: array of Int32): Int32 :=
    if (value<>nil) and (value.Length<>0) then
      z_GetConfig_ovr_0(dpy, visual, attrib, value[0]) else
      z_GetConfig_ovr_0_anh00001(dpy, visual, attrib, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetConfig(dpy: x_p_display; visual: x_p_visual_info; attrib: Int32; var value: Int32): Int32 :=
    z_GetConfig_ovr_0(dpy, visual, attrib, value);
    private static function z_GetConfig_ovr_2(dpy: x_p_display; visual: x_p_visual_info; attrib: Int32; value: IntPtr): Int32;
    external 'libGL.so.1' name 'glXGetConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetConfig(dpy: x_p_display; visual: x_p_visual_info; attrib: Int32; value: IntPtr): Int32 :=
    z_GetConfig_ovr_2(dpy, visual, attrib, value);
    
    // added in glx1.0
    private static function z_GetCurrentContext_ovr_0: glx_context;
    external 'libGL.so.1' name 'glXGetCurrentContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentContext: glx_context :=
    z_GetCurrentContext_ovr_0;
    
    // added in glx1.2
    private static function z_GetCurrentDisplay_ovr_0: x_p_display;
    external 'libGL.so.1' name 'glXGetCurrentDisplay';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentDisplay: x_p_display :=
    z_GetCurrentDisplay_ovr_0;
    
    // added in glx1.0
    private static function z_GetCurrentDrawable_ovr_0: glx_drawable;
    external 'libGL.so.1' name 'glXGetCurrentDrawable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentDrawable: glx_drawable :=
    z_GetCurrentDrawable_ovr_0;
    
    // added in glx1.3
    private static function z_GetCurrentReadDrawable_ovr_0: glx_drawable;
    external 'libGL.so.1' name 'glXGetCurrentReadDrawable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentReadDrawable: glx_drawable :=
    z_GetCurrentReadDrawable_ovr_0;
    
    // added in glx1.3
    private static function z_GetFBConfigAttrib_ovr_0(dpy: x_p_display; config: glx_fb_config; attribute: Int32; var value: Int32): Int32;
    external 'libGL.so.1' name 'glXGetFBConfigAttrib';
    private static function z_GetFBConfigAttrib_ovr_0_anh00001(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: IntPtr): Int32;
    external 'libGL.so.1' name 'glXGetFBConfigAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFBConfigAttrib(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: array of Int32): Int32 :=
    if (value<>nil) and (value.Length<>0) then
      z_GetFBConfigAttrib_ovr_0(dpy, config, attribute, value[0]) else
      z_GetFBConfigAttrib_ovr_0_anh00001(dpy, config, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFBConfigAttrib(dpy: x_p_display; config: glx_fb_config; attribute: Int32; var value: Int32): Int32 :=
    z_GetFBConfigAttrib_ovr_0(dpy, config, attribute, value);
    private static function z_GetFBConfigAttrib_ovr_2(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: IntPtr): Int32;
    external 'libGL.so.1' name 'glXGetFBConfigAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFBConfigAttrib(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: IntPtr): Int32 :=
    z_GetFBConfigAttrib_ovr_2(dpy, config, attribute, value);
    
    // added in glx1.3
    private static function z_GetFBConfigs_ovr_0(dpy: x_p_display; screen: Int32; var nelements: Int32): ^glx_fb_config;
    external 'libGL.so.1' name 'glXGetFBConfigs';
    private static function z_GetFBConfigs_ovr_0_anh0001(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXGetFBConfigs';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFBConfigs(dpy: x_p_display; screen: Int32; nelements: array of Int32): ^glx_fb_config :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_GetFBConfigs_ovr_0(dpy, screen, nelements[0]) else
      z_GetFBConfigs_ovr_0_anh0001(dpy, screen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFBConfigs(dpy: x_p_display; screen: Int32; var nelements: Int32): ^glx_fb_config :=
    z_GetFBConfigs_ovr_0(dpy, screen, nelements);
    private static function z_GetFBConfigs_ovr_2(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^glx_fb_config;
    external 'libGL.so.1' name 'glXGetFBConfigs';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFBConfigs(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^glx_fb_config :=
    z_GetFBConfigs_ovr_2(dpy, screen, nelements);
    
    // added in glx1.4
    private static function z_GetProcAddress_ovr_0(procName: IntPtr): IntPtr;
    external 'libGL.so.1' name 'glXGetProcAddress';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetProcAddress(procName: string): IntPtr;
    begin
      var par_1_str_ptr: IntPtr;
      try
        par_1_str_ptr := Marshal.StringToHGlobalAnsi(procName);
        Result := z_GetProcAddress_ovr_0(par_1_str_ptr);
      finally
        Marshal.FreeHGlobal(par_1_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetProcAddress(procName: IntPtr): IntPtr :=
    z_GetProcAddress_ovr_0(procName);
    
    // added in glx1.3
    private static procedure z_GetSelectedEvent_ovr_0(dpy: x_p_display; draw: glx_drawable; var event_mask: UInt64);
    external 'libGL.so.1' name 'glXGetSelectedEvent';
    private static procedure z_GetSelectedEvent_ovr_0_anh0001(dpy: x_p_display; draw: glx_drawable; event_mask: IntPtr);
    external 'libGL.so.1' name 'glXGetSelectedEvent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure GetSelectedEvent(dpy: x_p_display; draw: glx_drawable; event_mask: array of UInt64) :=
    if (event_mask<>nil) and (event_mask.Length<>0) then
      z_GetSelectedEvent_ovr_0(dpy, draw, event_mask[0]) else
      z_GetSelectedEvent_ovr_0_anh0001(dpy, draw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure GetSelectedEvent(dpy: x_p_display; draw: glx_drawable; var event_mask: UInt64) :=
    z_GetSelectedEvent_ovr_0(dpy, draw, event_mask);
    private static procedure z_GetSelectedEvent_ovr_2(dpy: x_p_display; draw: glx_drawable; event_mask: IntPtr);
    external 'libGL.so.1' name 'glXGetSelectedEvent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure GetSelectedEvent(dpy: x_p_display; draw: glx_drawable; event_mask: IntPtr) :=
    z_GetSelectedEvent_ovr_2(dpy, draw, event_mask);
    
    // added in glx1.3
    private static function z_GetVisualFromFBConfig_ovr_0(dpy: x_p_display; config: glx_fb_config): x_p_visual_info;
    external 'libGL.so.1' name 'glXGetVisualFromFBConfig';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVisualFromFBConfig(dpy: x_p_display; config: glx_fb_config): x_p_visual_info :=
    z_GetVisualFromFBConfig_ovr_0(dpy, config);
    
    // added in glx1.0
    private static function z_IsDirect_ovr_0(dpy: x_p_display; ctx: glx_context): Bool;
    external 'libGL.so.1' name 'glXIsDirect';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsDirect(dpy: x_p_display; ctx: glx_context): Bool :=
    z_IsDirect_ovr_0(dpy, ctx);
    
    // added in glx1.3
    private static function z_MakeContextCurrent_ovr_0(dpy: x_p_display; draw: glx_drawable; read: glx_drawable; ctx: glx_context): Bool;
    external 'libGL.so.1' name 'glXMakeContextCurrent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeContextCurrent(dpy: x_p_display; draw: glx_drawable; read: glx_drawable; ctx: glx_context): Bool :=
    z_MakeContextCurrent_ovr_0(dpy, draw, read, ctx);
    
    // added in glx1.0
    private static function z_MakeCurrent_ovr_0(dpy: x_p_display; drawable: glx_drawable; ctx: glx_context): Bool;
    external 'libGL.so.1' name 'glXMakeCurrent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeCurrent(dpy: x_p_display; drawable: glx_drawable; ctx: glx_context): Bool :=
    z_MakeCurrent_ovr_0(dpy, drawable, ctx);
    
    // added in glx1.3
    private static function z_QueryContext_ovr_0(dpy: x_p_display; ctx: glx_context; attribute: Int32; var value: Int32): Int32;
    external 'libGL.so.1' name 'glXQueryContext';
    private static function z_QueryContext_ovr_0_anh00001(dpy: x_p_display; ctx: glx_context; attribute: Int32; value: IntPtr): Int32;
    external 'libGL.so.1' name 'glXQueryContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryContext(dpy: x_p_display; ctx: glx_context; attribute: Int32; value: array of Int32): Int32 :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryContext_ovr_0(dpy, ctx, attribute, value[0]) else
      z_QueryContext_ovr_0_anh00001(dpy, ctx, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryContext(dpy: x_p_display; ctx: glx_context; attribute: Int32; var value: Int32): Int32 :=
    z_QueryContext_ovr_0(dpy, ctx, attribute, value);
    private static function z_QueryContext_ovr_2(dpy: x_p_display; ctx: glx_context; attribute: Int32; value: IntPtr): Int32;
    external 'libGL.so.1' name 'glXQueryContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryContext(dpy: x_p_display; ctx: glx_context; attribute: Int32; value: IntPtr): Int32 :=
    z_QueryContext_ovr_2(dpy, ctx, attribute, value);
    
    // added in glx1.3
    private static procedure z_QueryDrawable_ovr_0(dpy: x_p_display; draw: glx_drawable; attribute: Int32; var value: UInt32);
    external 'libGL.so.1' name 'glXQueryDrawable';
    private static procedure z_QueryDrawable_ovr_0_anh00001(dpy: x_p_display; draw: glx_drawable; attribute: Int32; value: IntPtr);
    external 'libGL.so.1' name 'glXQueryDrawable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure QueryDrawable(dpy: x_p_display; draw: glx_drawable; attribute: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryDrawable_ovr_0(dpy, draw, attribute, value[0]) else
      z_QueryDrawable_ovr_0_anh00001(dpy, draw, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure QueryDrawable(dpy: x_p_display; draw: glx_drawable; attribute: Int32; var value: UInt32) :=
    z_QueryDrawable_ovr_0(dpy, draw, attribute, value);
    private static procedure z_QueryDrawable_ovr_2(dpy: x_p_display; draw: glx_drawable; attribute: Int32; value: IntPtr);
    external 'libGL.so.1' name 'glXQueryDrawable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure QueryDrawable(dpy: x_p_display; draw: glx_drawable; attribute: Int32; value: IntPtr) :=
    z_QueryDrawable_ovr_2(dpy, draw, attribute, value);
    
    // added in glx1.0
    private static function z_QueryExtension_ovr_0(dpy: x_p_display; var errorb: Int32; var &event: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    private static function z_QueryExtension_ovr_0_anh0010(dpy: x_p_display; errorb: IntPtr; var &event: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    private static function z_QueryExtension_ovr_0_anh0001(dpy: x_p_display; var errorb: Int32; &event: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    private static function z_QueryExtension_ovr_0_anh0011(dpy: x_p_display; errorb: IntPtr; &event: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; errorb: array of Int32; &event: array of Int32): Bool :=
    if (errorb<>nil) and (errorb.Length<>0) then
      if (&event<>nil) and (&event.Length<>0) then
        z_QueryExtension_ovr_0(dpy, errorb[0], &event[0]) else
        z_QueryExtension_ovr_0_anh0001(dpy, errorb[0], IntPtr.Zero) else
      if (&event<>nil) and (&event.Length<>0) then
        z_QueryExtension_ovr_0_anh0010(dpy, IntPtr.Zero, &event[0]) else
        z_QueryExtension_ovr_0_anh0011(dpy, IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryExtension_ovr_1_anh0010(dpy: x_p_display; errorb: IntPtr; var &event: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; errorb: array of Int32; var &event: Int32): Bool :=
    if (errorb<>nil) and (errorb.Length<>0) then
      z_QueryExtension_ovr_0(dpy, errorb[0], &event) else
      z_QueryExtension_ovr_0_anh0010(dpy, IntPtr.Zero, &event);
    private static function z_QueryExtension_ovr_2(dpy: x_p_display; var errorb: Int32; &event: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    private static function z_QueryExtension_ovr_2_anh0010(dpy: x_p_display; errorb: IntPtr; &event: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; errorb: array of Int32; &event: IntPtr): Bool :=
    if (errorb<>nil) and (errorb.Length<>0) then
      z_QueryExtension_ovr_2(dpy, errorb[0], &event) else
      z_QueryExtension_ovr_2_anh0010(dpy, IntPtr.Zero, &event);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; var errorb: Int32; &event: array of Int32): Bool :=
    if (&event<>nil) and (&event.Length<>0) then
      z_QueryExtension_ovr_0(dpy, errorb, &event[0]) else
      z_QueryExtension_ovr_0_anh0001(dpy, errorb, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; var errorb: Int32; var &event: Int32): Bool :=
    z_QueryExtension_ovr_0(dpy, errorb, &event);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; var errorb: Int32; &event: IntPtr): Bool :=
    z_QueryExtension_ovr_2(dpy, errorb, &event);
    private static function z_QueryExtension_ovr_6(dpy: x_p_display; errorb: IntPtr; var &event: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    private static function z_QueryExtension_ovr_6_anh0001(dpy: x_p_display; errorb: IntPtr; &event: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; errorb: IntPtr; &event: array of Int32): Bool :=
    if (&event<>nil) and (&event.Length<>0) then
      z_QueryExtension_ovr_6(dpy, errorb, &event[0]) else
      z_QueryExtension_ovr_6_anh0001(dpy, errorb, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; errorb: IntPtr; var &event: Int32): Bool :=
    z_QueryExtension_ovr_6(dpy, errorb, &event);
    private static function z_QueryExtension_ovr_8(dpy: x_p_display; errorb: IntPtr; &event: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryExtension';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtension(dpy: x_p_display; errorb: IntPtr; &event: IntPtr): Bool :=
    z_QueryExtension_ovr_8(dpy, errorb, &event);
    
    // added in glx1.1
    private static function z_QueryExtensionsString_ovr_0(dpy: x_p_display; screen: Int32): IntPtr;
    external 'libGL.so.1' name 'glXQueryExtensionsString';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryExtensionsString(dpy: x_p_display; screen: Int32): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_QueryExtensionsString_ovr_0(dpy, screen);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in glx1.1
    private static function z_QueryServerString_ovr_0(dpy: x_p_display; screen: Int32; name: Int32): IntPtr;
    external 'libGL.so.1' name 'glXQueryServerString';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryServerString(dpy: x_p_display; screen: Int32; name: Int32): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_QueryServerString_ovr_0(dpy, screen, name);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in glx1.0
    private static function z_QueryVersion_ovr_0(dpy: x_p_display; var maj: Int32; var min: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    private static function z_QueryVersion_ovr_0_anh0010(dpy: x_p_display; maj: IntPtr; var min: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    private static function z_QueryVersion_ovr_0_anh0001(dpy: x_p_display; var maj: Int32; min: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    private static function z_QueryVersion_ovr_0_anh0011(dpy: x_p_display; maj: IntPtr; min: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; maj: array of Int32; min: array of Int32): Bool :=
    if (maj<>nil) and (maj.Length<>0) then
      if (min<>nil) and (min.Length<>0) then
        z_QueryVersion_ovr_0(dpy, maj[0], min[0]) else
        z_QueryVersion_ovr_0_anh0001(dpy, maj[0], IntPtr.Zero) else
      if (min<>nil) and (min.Length<>0) then
        z_QueryVersion_ovr_0_anh0010(dpy, IntPtr.Zero, min[0]) else
        z_QueryVersion_ovr_0_anh0011(dpy, IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryVersion_ovr_1_anh0010(dpy: x_p_display; maj: IntPtr; var min: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; maj: array of Int32; var min: Int32): Bool :=
    if (maj<>nil) and (maj.Length<>0) then
      z_QueryVersion_ovr_0(dpy, maj[0], min) else
      z_QueryVersion_ovr_0_anh0010(dpy, IntPtr.Zero, min);
    private static function z_QueryVersion_ovr_2(dpy: x_p_display; var maj: Int32; min: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    private static function z_QueryVersion_ovr_2_anh0010(dpy: x_p_display; maj: IntPtr; min: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; maj: array of Int32; min: IntPtr): Bool :=
    if (maj<>nil) and (maj.Length<>0) then
      z_QueryVersion_ovr_2(dpy, maj[0], min) else
      z_QueryVersion_ovr_2_anh0010(dpy, IntPtr.Zero, min);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; var maj: Int32; min: array of Int32): Bool :=
    if (min<>nil) and (min.Length<>0) then
      z_QueryVersion_ovr_0(dpy, maj, min[0]) else
      z_QueryVersion_ovr_0_anh0001(dpy, maj, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; var maj: Int32; var min: Int32): Bool :=
    z_QueryVersion_ovr_0(dpy, maj, min);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; var maj: Int32; min: IntPtr): Bool :=
    z_QueryVersion_ovr_2(dpy, maj, min);
    private static function z_QueryVersion_ovr_6(dpy: x_p_display; maj: IntPtr; var min: Int32): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    private static function z_QueryVersion_ovr_6_anh0001(dpy: x_p_display; maj: IntPtr; min: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; maj: IntPtr; min: array of Int32): Bool :=
    if (min<>nil) and (min.Length<>0) then
      z_QueryVersion_ovr_6(dpy, maj, min[0]) else
      z_QueryVersion_ovr_6_anh0001(dpy, maj, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; maj: IntPtr; var min: Int32): Bool :=
    z_QueryVersion_ovr_6(dpy, maj, min);
    private static function z_QueryVersion_ovr_8(dpy: x_p_display; maj: IntPtr; min: IntPtr): Bool;
    external 'libGL.so.1' name 'glXQueryVersion';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVersion(dpy: x_p_display; maj: IntPtr; min: IntPtr): Bool :=
    z_QueryVersion_ovr_8(dpy, maj, min);
    
    // added in glx1.3
    private static procedure z_SelectEvent_ovr_0(dpy: x_p_display; draw: glx_drawable; event_mask: UInt64);
    external 'libGL.so.1' name 'glXSelectEvent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure SelectEvent(dpy: x_p_display; draw: glx_drawable; event_mask: UInt64) :=
    z_SelectEvent_ovr_0(dpy, draw, event_mask);
    
    // added in glx1.0
    private static procedure z_SwapBuffers_ovr_0(dpy: x_p_display; drawable: glx_drawable);
    external 'libGL.so.1' name 'glXSwapBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure SwapBuffers(dpy: x_p_display; drawable: glx_drawable) :=
    z_SwapBuffers_ovr_0(dpy, drawable);
    
    // added in glx1.0
    private static procedure z_UseXFont_ovr_0(font: x_font; first: Int32; count: Int32; list: Int32);
    external 'libGL.so.1' name 'glXUseXFont';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure UseXFont(font: x_font; first: Int32; count: Int32; list: Int32) :=
    z_UseXFont_ovr_0(font, first, count, list);
    
    // added in glx1.0
    private static procedure z_WaitGL_ovr_0;
    external 'libGL.so.1' name 'glXWaitGL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure WaitGL :=
    z_WaitGL_ovr_0;
    
    // added in glx1.0
    private static procedure z_WaitX_ovr_0;
    external 'libGL.so.1' name 'glXWaitX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure WaitX :=
    z_WaitX_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  gdi = static class
    
    private static function z_ChoosePixelFormat_ovr_0(hDc: gdi_device_context; var pPfd: gdi_pixel_format_descriptor): Int32;
    external 'gdi32.dll' name 'ChoosePixelFormat';
    private static function z_ChoosePixelFormat_ovr_0_anh001(hDc: gdi_device_context; pPfd: IntPtr): Int32;
    external 'gdi32.dll' name 'ChoosePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormat(hDc: gdi_device_context; pPfd: array of gdi_pixel_format_descriptor): Int32 :=
    if (pPfd<>nil) and (pPfd.Length<>0) then
      z_ChoosePixelFormat_ovr_0(hDc, pPfd[0]) else
      z_ChoosePixelFormat_ovr_0_anh001(hDc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormat(hDc: gdi_device_context; var pPfd: gdi_pixel_format_descriptor): Int32 :=
    z_ChoosePixelFormat_ovr_0(hDc, pPfd);
    private static function z_ChoosePixelFormat_ovr_2(hDc: gdi_device_context; pPfd: IntPtr): Int32;
    external 'gdi32.dll' name 'ChoosePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormat(hDc: gdi_device_context; pPfd: IntPtr): Int32 :=
    z_ChoosePixelFormat_ovr_2(hDc, pPfd);
    
    private static function z_DescribePixelFormat_ovr_0(hdc: gdi_device_context; ipfd: Int32; cjpfd: UInt32; var ppfd: gdi_pixel_format_descriptor): Int32;
    external 'gdi32.dll' name 'DescribePixelFormat';
    private static function z_DescribePixelFormat_ovr_0_anh00001(hdc: gdi_device_context; ipfd: Int32; cjpfd: UInt32; ppfd: IntPtr): Int32;
    external 'gdi32.dll' name 'DescribePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribePixelFormat(hdc: gdi_device_context; ipfd: Int32; cjpfd: UInt32; ppfd: array of gdi_pixel_format_descriptor): Int32 :=
    if (ppfd<>nil) and (ppfd.Length<>0) then
      z_DescribePixelFormat_ovr_0(hdc, ipfd, cjpfd, ppfd[0]) else
      z_DescribePixelFormat_ovr_0_anh00001(hdc, ipfd, cjpfd, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribePixelFormat(hdc: gdi_device_context; ipfd: Int32; cjpfd: UInt32; var ppfd: gdi_pixel_format_descriptor): Int32 :=
    z_DescribePixelFormat_ovr_0(hdc, ipfd, cjpfd, ppfd);
    private static function z_DescribePixelFormat_ovr_2(hdc: gdi_device_context; ipfd: Int32; cjpfd: UInt32; ppfd: IntPtr): Int32;
    external 'gdi32.dll' name 'DescribePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribePixelFormat(hdc: gdi_device_context; ipfd: Int32; cjpfd: UInt32; ppfd: IntPtr): Int32 :=
    z_DescribePixelFormat_ovr_2(hdc, ipfd, cjpfd, ppfd);
    
    private static function z_GetEnhMetaFilePixelFormat_ovr_0(hemf: gdi_h_enh_metafile; var ppfd: gdi_pixel_format_descriptor): UInt32;
    external 'gdi32.dll' name 'GetEnhMetaFilePixelFormat';
    private static function z_GetEnhMetaFilePixelFormat_ovr_0_anh001(hemf: gdi_h_enh_metafile; ppfd: IntPtr): UInt32;
    external 'gdi32.dll' name 'GetEnhMetaFilePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetEnhMetaFilePixelFormat(hemf: gdi_h_enh_metafile; ppfd: array of gdi_pixel_format_descriptor): UInt32 :=
    if (ppfd<>nil) and (ppfd.Length<>0) then
      z_GetEnhMetaFilePixelFormat_ovr_0(hemf, ppfd[0]) else
      z_GetEnhMetaFilePixelFormat_ovr_0_anh001(hemf, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetEnhMetaFilePixelFormat(hemf: gdi_h_enh_metafile; var ppfd: gdi_pixel_format_descriptor): UInt32 :=
    z_GetEnhMetaFilePixelFormat_ovr_0(hemf, ppfd);
    private static function z_GetEnhMetaFilePixelFormat_ovr_2(hemf: gdi_h_enh_metafile; ppfd: IntPtr): UInt32;
    external 'gdi32.dll' name 'GetEnhMetaFilePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetEnhMetaFilePixelFormat(hemf: gdi_h_enh_metafile; ppfd: IntPtr): UInt32 :=
    z_GetEnhMetaFilePixelFormat_ovr_2(hemf, ppfd);
    
    private static function z_GetPixelFormat_ovr_0(hdc: gdi_device_context): Int32;
    external 'gdi32.dll' name 'GetPixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormat(hdc: gdi_device_context): Int32 :=
    z_GetPixelFormat_ovr_0(hdc);
    
    private static function z_SetPixelFormat_ovr_0(hdc: gdi_device_context; ipfd: Int32; var ppfd: gdi_pixel_format_descriptor): Bool;
    external 'gdi32.dll' name 'SetPixelFormat';
    private static function z_SetPixelFormat_ovr_0_anh0001(hdc: gdi_device_context; ipfd: Int32; ppfd: IntPtr): Bool;
    external 'gdi32.dll' name 'SetPixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPixelFormat(hdc: gdi_device_context; ipfd: Int32; ppfd: array of gdi_pixel_format_descriptor): Bool :=
    if (ppfd<>nil) and (ppfd.Length<>0) then
      z_SetPixelFormat_ovr_0(hdc, ipfd, ppfd[0]) else
      z_SetPixelFormat_ovr_0_anh0001(hdc, ipfd, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPixelFormat(hdc: gdi_device_context; ipfd: Int32; var ppfd: gdi_pixel_format_descriptor): Bool :=
    z_SetPixelFormat_ovr_0(hdc, ipfd, ppfd);
    private static function z_SetPixelFormat_ovr_2(hdc: gdi_device_context; ipfd: Int32; ppfd: IntPtr): Bool;
    external 'gdi32.dll' name 'SetPixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPixelFormat(hdc: gdi_device_context; ipfd: Int32; ppfd: IntPtr): Bool :=
    z_SetPixelFormat_ovr_2(hdc, ipfd, ppfd);
    
    private static function z_SwapBuffers_ovr_0(hdc: gdi_device_context): Bool;
    external 'gdi32.dll' name 'SwapBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapBuffers(hdc: gdi_device_context): Bool :=
    z_SwapBuffers_ovr_0(hdc);
    
  end;
  
  {$region Extensions}
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTbuffer3DFX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = '3DFX_tbuffer';
    
    private z_TbufferMask3DFX_adr := GetProcAddress('glTbufferMask3DFX');
    private z_TbufferMask3DFX_ovr_0 := GetProcOrNil&<procedure(mask: UInt32)>(z_TbufferMask3DFX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TbufferMask3DFX(mask: UInt32) :=
    z_TbufferMask3DFX_ovr_0(mask);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDebugOutputAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_debug_output';
    
    private z_DebugMessageEnableAMD_adr := GetProcAddress('glDebugMessageEnableAMD');
    private z_DebugMessageEnableAMD_ovr_0 := GetProcOrNil&<procedure(category: DummyEnum; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean)>(z_DebugMessageEnableAMD_adr);
    private z_DebugMessageEnableAMD_ovr_0_anh000010 := GetProcOrNil&<procedure(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageEnableAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageEnableAMD(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageEnableAMD_ovr_0(category, severity, count, ids[0], enabled) else
      z_DebugMessageEnableAMD_ovr_0_anh000010(category, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageEnableAMD(category: DummyEnum; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageEnableAMD_ovr_0(category, severity, count, ids, enabled);
    private z_DebugMessageEnableAMD_ovr_2 := GetProcOrNil&<procedure(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageEnableAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageEnableAMD(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageEnableAMD_ovr_2(category, severity, count, ids, enabled);
    
    private z_DebugMessageInsertAMD_adr := GetProcAddress('glDebugMessageInsertAMD');
    private z_DebugMessageInsertAMD_ovr_0 := GetProcOrNil&<procedure(category: DummyEnum; severity: DebugSeverity; id: UInt32; length: Int32; buf: IntPtr)>(z_DebugMessageInsertAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertAMD(category: DummyEnum; severity: DebugSeverity; id: UInt32; length: Int32; buf: string);
    begin
      var par_5_str_ptr: IntPtr;
      try
        par_5_str_ptr := Marshal.StringToHGlobalAnsi(buf);
        z_DebugMessageInsertAMD_ovr_0(category, severity, id, length, par_5_str_ptr);
      finally
        Marshal.FreeHGlobal(par_5_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertAMD(category: DummyEnum; severity: DebugSeverity; id: UInt32; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsertAMD_ovr_0(category, severity, id, length, buf);
    
    private z_DebugMessageCallbackAMD_adr := GetProcAddress('glDebugMessageCallbackAMD');
    private z_DebugMessageCallbackAMD_ovr_0 := GetProcOrNil&<procedure(callback: GL_DEBUG_PROC; userParam: IntPtr)>(z_DebugMessageCallbackAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallbackAMD(callback: GL_DEBUG_PROC; userParam: IntPtr) :=
    z_DebugMessageCallbackAMD_ovr_0(callback, userParam);
    
    private z_GetDebugMessageLogAMD_adr := GetProcAddress('glGetDebugMessageLogAMD');
    private z_GetDebugMessageLogAMD_ovr_0 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; var categories: DummyEnum; var severities: UInt32; var ids: UInt32; var lengths: Int32; message: IntPtr): UInt32>(z_GetDebugMessageLogAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogAMD(count: UInt32; bufSize: Int32; var categories: DummyEnum; var severities: UInt32; var ids: UInt32; var lengths: Int32; message: IntPtr): UInt32 :=
    z_GetDebugMessageLogAMD_ovr_0(count, bufSize, categories, severities, ids, lengths, message);
    private z_GetDebugMessageLogAMD_ovr_1 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; categories: IntPtr; severities: IntPtr; ids: IntPtr; lengths: IntPtr; message: IntPtr): UInt32>(z_GetDebugMessageLogAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogAMD(count: UInt32; bufSize: Int32; categories: IntPtr; severities: IntPtr; ids: IntPtr; lengths: IntPtr; message: IntPtr): UInt32 :=
    z_GetDebugMessageLogAMD_ovr_1(count, bufSize, categories, severities, ids, lengths, message);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawBuffersBlendAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_draw_buffers_blend';
    
    private z_BlendFuncIndexedAMD_adr := GetProcAddress('glBlendFuncIndexedAMD');
    private z_BlendFuncIndexedAMD_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; src: DummyEnum; dst: DummyEnum)>(z_BlendFuncIndexedAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncIndexedAMD(buf: UInt32; src: DummyEnum; dst: DummyEnum) :=
    z_BlendFuncIndexedAMD_ovr_0(buf, src, dst);
    
    private z_BlendFuncSeparateIndexedAMD_adr := GetProcAddress('glBlendFuncSeparateIndexedAMD');
    private z_BlendFuncSeparateIndexedAMD_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor)>(z_BlendFuncSeparateIndexedAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateIndexedAMD(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor) :=
    z_BlendFuncSeparateIndexedAMD_ovr_0(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
    
    private z_BlendEquationIndexedAMD_adr := GetProcAddress('glBlendEquationIndexedAMD');
    private z_BlendEquationIndexedAMD_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; mode: BlendEquationModeEXT)>(z_BlendEquationIndexedAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationIndexedAMD(buf: UInt32; mode: BlendEquationModeEXT) :=
    z_BlendEquationIndexedAMD_ovr_0(buf, mode);
    
    private z_BlendEquationSeparateIndexedAMD_adr := GetProcAddress('glBlendEquationSeparateIndexedAMD');
    private z_BlendEquationSeparateIndexedAMD_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparateIndexedAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparateIndexedAMD(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparateIndexedAMD_ovr_0(buf, modeRGB, modeAlpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferMultisampleAdvancedAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_framebuffer_multisample_advanced';
    
    private z_RenderbufferStorageMultisampleAdvancedAMD_adr := GetProcAddress('glRenderbufferStorageMultisampleAdvancedAMD');
    private z_RenderbufferStorageMultisampleAdvancedAMD_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageMultisampleAdvancedAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisampleAdvancedAMD(target: RenderbufferTarget; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisampleAdvancedAMD_ovr_0(target, samples, storageSamples, _internalformat, width, height);
    
    private z_NamedRenderbufferStorageMultisampleAdvancedAMD_adr := GetProcAddress('glNamedRenderbufferStorageMultisampleAdvancedAMD');
    private z_NamedRenderbufferStorageMultisampleAdvancedAMD_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageMultisampleAdvancedAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisampleAdvancedAMD(renderbuffer: gl_renderbuffer; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisampleAdvancedAMD_ovr_0(renderbuffer, samples, storageSamples, _internalformat, width, height);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferSamplePositionsAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_framebuffer_sample_positions';
    
    private z_FramebufferSamplePositionsfvAMD_adr := GetProcAddress('glFramebufferSamplePositionsfvAMD');
    private z_FramebufferSamplePositionsfvAMD_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; var values: single)>(z_FramebufferSamplePositionsfvAMD_adr);
    private z_FramebufferSamplePositionsfvAMD_ovr_0_anh00001 := GetProcOrNil&<procedure(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: IntPtr)>(z_FramebufferSamplePositionsfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSamplePositionsfvAMD(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_FramebufferSamplePositionsfvAMD_ovr_0(target, numsamples, pixelindex, values[0]) else
      z_FramebufferSamplePositionsfvAMD_ovr_0_anh00001(target, numsamples, pixelindex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSamplePositionsfvAMD(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; var values: single) :=
    z_FramebufferSamplePositionsfvAMD_ovr_0(target, numsamples, pixelindex, values);
    private z_FramebufferSamplePositionsfvAMD_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: IntPtr)>(z_FramebufferSamplePositionsfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSamplePositionsfvAMD(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: IntPtr) :=
    z_FramebufferSamplePositionsfvAMD_ovr_2(target, numsamples, pixelindex, values);
    
    private z_NamedFramebufferSamplePositionsfvAMD_adr := GetProcAddress('glNamedFramebufferSamplePositionsfvAMD');
    private z_NamedFramebufferSamplePositionsfvAMD_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numsamples: UInt32; pixelindex: UInt32; var values: single)>(z_NamedFramebufferSamplePositionsfvAMD_adr);
    private z_NamedFramebufferSamplePositionsfvAMD_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numsamples: UInt32; pixelindex: UInt32; values: IntPtr)>(z_NamedFramebufferSamplePositionsfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSamplePositionsfvAMD(framebuffer: gl_framebuffer; numsamples: UInt32; pixelindex: UInt32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_NamedFramebufferSamplePositionsfvAMD_ovr_0(framebuffer, numsamples, pixelindex, values[0]) else
      z_NamedFramebufferSamplePositionsfvAMD_ovr_0_anh00001(framebuffer, numsamples, pixelindex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSamplePositionsfvAMD(framebuffer: gl_framebuffer; numsamples: UInt32; pixelindex: UInt32; var values: single) :=
    z_NamedFramebufferSamplePositionsfvAMD_ovr_0(framebuffer, numsamples, pixelindex, values);
    private z_NamedFramebufferSamplePositionsfvAMD_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numsamples: UInt32; pixelindex: UInt32; values: IntPtr)>(z_NamedFramebufferSamplePositionsfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSamplePositionsfvAMD(framebuffer: gl_framebuffer; numsamples: UInt32; pixelindex: UInt32; values: IntPtr) :=
    z_NamedFramebufferSamplePositionsfvAMD_ovr_2(framebuffer, numsamples, pixelindex, values);
    
    private z_GetFramebufferParameterfvAMD_adr := GetProcAddress('glGetFramebufferParameterfvAMD');
    private z_GetFramebufferParameterfvAMD_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single)>(z_GetFramebufferParameterfvAMD_adr);
    private z_GetFramebufferParameterfvAMD_ovr_0_anh0000001 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr)>(z_GetFramebufferParameterfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterfvAMD(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetFramebufferParameterfvAMD_ovr_0(target, pname, numsamples, pixelindex, size, values[0]) else
      z_GetFramebufferParameterfvAMD_ovr_0_anh0000001(target, pname, numsamples, pixelindex, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterfvAMD(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single) :=
    z_GetFramebufferParameterfvAMD_ovr_0(target, pname, numsamples, pixelindex, size, values);
    private z_GetFramebufferParameterfvAMD_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr)>(z_GetFramebufferParameterfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterfvAMD(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr) :=
    z_GetFramebufferParameterfvAMD_ovr_2(target, pname, numsamples, pixelindex, size, values);
    
    private z_GetNamedFramebufferParameterfvAMD_adr := GetProcAddress('glGetNamedFramebufferParameterfvAMD');
    private z_GetNamedFramebufferParameterfvAMD_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single)>(z_GetNamedFramebufferParameterfvAMD_adr);
    private z_GetNamedFramebufferParameterfvAMD_ovr_0_anh0000001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr)>(z_GetNamedFramebufferParameterfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterfvAMD(framebuffer: gl_framebuffer; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetNamedFramebufferParameterfvAMD_ovr_0(framebuffer, pname, numsamples, pixelindex, size, values[0]) else
      z_GetNamedFramebufferParameterfvAMD_ovr_0_anh0000001(framebuffer, pname, numsamples, pixelindex, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterfvAMD(framebuffer: gl_framebuffer; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single) :=
    z_GetNamedFramebufferParameterfvAMD_ovr_0(framebuffer, pname, numsamples, pixelindex, size, values);
    private z_GetNamedFramebufferParameterfvAMD_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr)>(z_GetNamedFramebufferParameterfvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterfvAMD(framebuffer: gl_framebuffer; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr) :=
    z_GetNamedFramebufferParameterfvAMD_ovr_2(framebuffer, pname, numsamples, pixelindex, size, values);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuShaderInt64AMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_gpu_shader_int64';
    
    private z_Uniform1i64NV_adr := GetProcAddress('glUniform1i64NV');
    private z_Uniform1i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64)>(z_Uniform1i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64NV(location: Int32; x: Int64) :=
    z_Uniform1i64NV_ovr_0(location, x);
    
    private z_Uniform2i64NV_adr := GetProcAddress('glUniform2i64NV');
    private z_Uniform2i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64)>(z_Uniform2i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64NV(location: Int32; x: Int64; y: Int64) :=
    z_Uniform2i64NV_ovr_0(location, x, y);
    
    private z_Uniform3i64NV_adr := GetProcAddress('glUniform3i64NV');
    private z_Uniform3i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64; z: Int64)>(z_Uniform3i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64NV(location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_Uniform3i64NV_ovr_0(location, x, y, z);
    
    private z_Uniform4i64NV_adr := GetProcAddress('glUniform4i64NV');
    private z_Uniform4i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_Uniform4i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64NV(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_Uniform4i64NV_ovr_0(location, x, y, z, w);
    
    private z_Uniform1i64vNV_adr := GetProcAddress('glUniform1i64vNV');
    private z_Uniform1i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform1i64vNV_adr);
    private z_Uniform1i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform1i64vNV_ovr_0(location, count, value);
    private z_Uniform1i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1i64vNV_ovr_2(location, count, value);
    
    private z_Uniform2i64vNV_adr := GetProcAddress('glUniform2i64vNV');
    private z_Uniform2i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform2i64vNV_adr);
    private z_Uniform2i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform2i64vNV_ovr_0(location, count, value);
    private z_Uniform2i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2i64vNV_ovr_2(location, count, value);
    
    private z_Uniform3i64vNV_adr := GetProcAddress('glUniform3i64vNV');
    private z_Uniform3i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform3i64vNV_adr);
    private z_Uniform3i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform3i64vNV_ovr_0(location, count, value);
    private z_Uniform3i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3i64vNV_ovr_2(location, count, value);
    
    private z_Uniform4i64vNV_adr := GetProcAddress('glUniform4i64vNV');
    private z_Uniform4i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform4i64vNV_adr);
    private z_Uniform4i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform4i64vNV_ovr_0(location, count, value);
    private z_Uniform4i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4i64vNV_ovr_2(location, count, value);
    
    private z_Uniform1ui64NV_adr := GetProcAddress('glUniform1ui64NV');
    private z_Uniform1ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64)>(z_Uniform1ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64NV(location: Int32; x: UInt64) :=
    z_Uniform1ui64NV_ovr_0(location, x);
    
    private z_Uniform2ui64NV_adr := GetProcAddress('glUniform2ui64NV');
    private z_Uniform2ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64)>(z_Uniform2ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64NV(location: Int32; x: UInt64; y: UInt64) :=
    z_Uniform2ui64NV_ovr_0(location, x, y);
    
    private z_Uniform3ui64NV_adr := GetProcAddress('glUniform3ui64NV');
    private z_Uniform3ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64; z: UInt64)>(z_Uniform3ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_Uniform3ui64NV_ovr_0(location, x, y, z);
    
    private z_Uniform4ui64NV_adr := GetProcAddress('glUniform4ui64NV');
    private z_Uniform4ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_Uniform4ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_Uniform4ui64NV_ovr_0(location, x, y, z, w);
    
    private z_Uniform1ui64vNV_adr := GetProcAddress('glUniform1ui64vNV');
    private z_Uniform1ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform1ui64vNV_adr);
    private z_Uniform1ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform1ui64vNV_ovr_0(location, count, value);
    private z_Uniform1ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ui64vNV_ovr_2(location, count, value);
    
    private z_Uniform2ui64vNV_adr := GetProcAddress('glUniform2ui64vNV');
    private z_Uniform2ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform2ui64vNV_adr);
    private z_Uniform2ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform2ui64vNV_ovr_0(location, count, value);
    private z_Uniform2ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ui64vNV_ovr_2(location, count, value);
    
    private z_Uniform3ui64vNV_adr := GetProcAddress('glUniform3ui64vNV');
    private z_Uniform3ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform3ui64vNV_adr);
    private z_Uniform3ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform3ui64vNV_ovr_0(location, count, value);
    private z_Uniform3ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ui64vNV_ovr_2(location, count, value);
    
    private z_Uniform4ui64vNV_adr := GetProcAddress('glUniform4ui64vNV');
    private z_Uniform4ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform4ui64vNV_adr);
    private z_Uniform4ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform4ui64vNV_ovr_0(location, count, value);
    private z_Uniform4ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ui64vNV_ovr_2(location, count, value);
    
    private z_GetUniformi64vNV_adr := GetProcAddress('glGetUniformi64vNV');
    private z_GetUniformi64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: Int64)>(z_GetUniformi64vNV_adr);
    private z_GetUniformi64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: gl_program; location: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformi64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformi64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: gl_program; location: Int32; var &params: Int64) :=
    z_GetUniformi64vNV_ovr_0(&program, location, &params);
    private z_GetUniformi64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformi64vNV_ovr_2(&program, location, &params);
    
    private z_GetUniformui64vNV_adr := GetProcAddress('glGetUniformui64vNV');
    private z_GetUniformui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: UInt64)>(z_GetUniformui64vNV_adr);
    private z_GetUniformui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: gl_program; location: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformui64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformui64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: gl_program; location: Int32; var &params: UInt64) :=
    z_GetUniformui64vNV_ovr_0(&program, location, &params);
    private z_GetUniformui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformui64vNV_ovr_2(&program, location, &params);
    
    private z_ProgramUniform1i64NV_adr := GetProcAddress('glProgramUniform1i64NV');
    private z_ProgramUniform1i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64)>(z_ProgramUniform1i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64NV(&program: gl_program; location: Int32; x: Int64) :=
    z_ProgramUniform1i64NV_ovr_0(&program, location, x);
    
    private z_ProgramUniform2i64NV_adr := GetProcAddress('glProgramUniform2i64NV');
    private z_ProgramUniform2i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64)>(z_ProgramUniform2i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64NV(&program: gl_program; location: Int32; x: Int64; y: Int64) :=
    z_ProgramUniform2i64NV_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3i64NV_adr := GetProcAddress('glProgramUniform3i64NV');
    private z_ProgramUniform3i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64)>(z_ProgramUniform3i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64NV(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_ProgramUniform3i64NV_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4i64NV_adr := GetProcAddress('glProgramUniform4i64NV');
    private z_ProgramUniform4i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_ProgramUniform4i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64NV(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_ProgramUniform4i64NV_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1i64vNV_adr := GetProcAddress('glProgramUniform1i64vNV');
    private z_ProgramUniform1i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform1i64vNV_adr);
    private z_ProgramUniform1i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform1i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2i64vNV_adr := GetProcAddress('glProgramUniform2i64vNV');
    private z_ProgramUniform2i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform2i64vNV_adr);
    private z_ProgramUniform2i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform2i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3i64vNV_adr := GetProcAddress('glProgramUniform3i64vNV');
    private z_ProgramUniform3i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform3i64vNV_adr);
    private z_ProgramUniform3i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform3i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4i64vNV_adr := GetProcAddress('glProgramUniform4i64vNV');
    private z_ProgramUniform4i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform4i64vNV_adr);
    private z_ProgramUniform4i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform4i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1ui64NV_adr := GetProcAddress('glProgramUniform1ui64NV');
    private z_ProgramUniform1ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64)>(z_ProgramUniform1ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64NV(&program: gl_program; location: Int32; x: UInt64) :=
    z_ProgramUniform1ui64NV_ovr_0(&program, location, x);
    
    private z_ProgramUniform2ui64NV_adr := GetProcAddress('glProgramUniform2ui64NV');
    private z_ProgramUniform2ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64)>(z_ProgramUniform2ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64NV(&program: gl_program; location: Int32; x: UInt64; y: UInt64) :=
    z_ProgramUniform2ui64NV_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3ui64NV_adr := GetProcAddress('glProgramUniform3ui64NV');
    private z_ProgramUniform3ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64)>(z_ProgramUniform3ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64NV(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_ProgramUniform3ui64NV_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4ui64NV_adr := GetProcAddress('glProgramUniform4ui64NV');
    private z_ProgramUniform4ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_ProgramUniform4ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64NV(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_ProgramUniform4ui64NV_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1ui64vNV_adr := GetProcAddress('glProgramUniform1ui64vNV');
    private z_ProgramUniform1ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform1ui64vNV_adr);
    private z_ProgramUniform1ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform1ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ui64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2ui64vNV_adr := GetProcAddress('glProgramUniform2ui64vNV');
    private z_ProgramUniform2ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform2ui64vNV_adr);
    private z_ProgramUniform2ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform2ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ui64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3ui64vNV_adr := GetProcAddress('glProgramUniform3ui64vNV');
    private z_ProgramUniform3ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform3ui64vNV_adr);
    private z_ProgramUniform3ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform3ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ui64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4ui64vNV_adr := GetProcAddress('glProgramUniform4ui64vNV');
    private z_ProgramUniform4ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform4ui64vNV_adr);
    private z_ProgramUniform4ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform4ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ui64vNV_ovr_2(&program, location, count, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInterleavedElementsAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_interleaved_elements';
    
    private z_VertexAttribParameteriAMD_adr := GetProcAddress('glVertexAttribParameteriAMD');
    private z_VertexAttribParameteriAMD_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: DummyEnum; param: Int32)>(z_VertexAttribParameteriAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribParameteriAMD(index: UInt32; pname: DummyEnum; param: Int32) :=
    z_VertexAttribParameteriAMD_ovr_0(index, pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultiDrawIndirectAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_multi_draw_indirect';
    
    private z_MultiDrawArraysIndirectAMD_adr := GetProcAddress('glMultiDrawArraysIndirectAMD');
    private z_MultiDrawArraysIndirectAMD_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; primcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirectAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectAMD(mode: PrimitiveType; indirect: IntPtr; primcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirectAMD_ovr_0(mode, indirect, primcount, stride);
    
    private z_MultiDrawElementsIndirectAMD_adr := GetProcAddress('glMultiDrawElementsIndirectAMD');
    private z_MultiDrawElementsIndirectAMD_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; primcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirectAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectAMD(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; primcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirectAMD_ovr_0(mode, &type, indirect, primcount, stride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glNameGenDeleteAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_name_gen_delete';
    
    private z_GenNamesAMD_adr := GetProcAddress('glGenNamesAMD');
    private z_GenNamesAMD_ovr_0 := GetProcOrNil&<procedure(identifier: DummyEnum; num: UInt32; var names: UInt32)>(z_GenNamesAMD_adr);
    private z_GenNamesAMD_ovr_0_anh0001 := GetProcOrNil&<procedure(identifier: DummyEnum; num: UInt32; names: IntPtr)>(z_GenNamesAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenNamesAMD(identifier: DummyEnum; num: UInt32; names: array of UInt32) :=
    if (names<>nil) and (names.Length<>0) then
      z_GenNamesAMD_ovr_0(identifier, num, names[0]) else
      z_GenNamesAMD_ovr_0_anh0001(identifier, num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenNamesAMD(identifier: DummyEnum; num: UInt32; var names: UInt32) :=
    z_GenNamesAMD_ovr_0(identifier, num, names);
    private z_GenNamesAMD_ovr_2 := GetProcOrNil&<procedure(identifier: DummyEnum; num: UInt32; names: IntPtr)>(z_GenNamesAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenNamesAMD(identifier: DummyEnum; num: UInt32; names: IntPtr) :=
    z_GenNamesAMD_ovr_2(identifier, num, names);
    
    private z_DeleteNamesAMD_adr := GetProcAddress('glDeleteNamesAMD');
    private z_DeleteNamesAMD_ovr_0 := GetProcOrNil&<procedure(identifier: DummyEnum; num: UInt32; var names: UInt32)>(z_DeleteNamesAMD_adr);
    private z_DeleteNamesAMD_ovr_0_anh0001 := GetProcOrNil&<procedure(identifier: DummyEnum; num: UInt32; names: IntPtr)>(z_DeleteNamesAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamesAMD(identifier: DummyEnum; num: UInt32; names: array of UInt32) :=
    if (names<>nil) and (names.Length<>0) then
      z_DeleteNamesAMD_ovr_0(identifier, num, names[0]) else
      z_DeleteNamesAMD_ovr_0_anh0001(identifier, num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamesAMD(identifier: DummyEnum; num: UInt32; var names: UInt32) :=
    z_DeleteNamesAMD_ovr_0(identifier, num, names);
    private z_DeleteNamesAMD_ovr_2 := GetProcOrNil&<procedure(identifier: DummyEnum; num: UInt32; names: IntPtr)>(z_DeleteNamesAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamesAMD(identifier: DummyEnum; num: UInt32; names: IntPtr) :=
    z_DeleteNamesAMD_ovr_2(identifier, num, names);
    
    private z_IsNameAMD_adr := GetProcAddress('glIsNameAMD');
    private z_IsNameAMD_ovr_0 := GetProcOrNil&<function(identifier: DummyEnum; name: UInt32): boolean>(z_IsNameAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNameAMD(identifier: DummyEnum; name: UInt32): boolean :=
    z_IsNameAMD_ovr_0(identifier, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glOcclusionQueryEventAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_occlusion_query_event';
    
    private z_QueryObjectParameteruiAMD_adr := GetProcAddress('glQueryObjectParameteruiAMD');
    private z_QueryObjectParameteruiAMD_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; id: gl_query; pname: DummyEnum; param: UInt32)>(z_QueryObjectParameteruiAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryObjectParameteruiAMD(target: QueryTarget; id: gl_query; pname: DummyEnum; param: UInt32) :=
    z_QueryObjectParameteruiAMD_ovr_0(target, id, pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPerformanceMonitorAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_performance_monitor';
    
    private z_GetPerfMonitorGroupsAMD_adr := GetProcAddress('glGetPerfMonitorGroupsAMD');
    private z_GetPerfMonitorGroupsAMD_ovr_0 := GetProcOrNil&<procedure(var numGroups: Int32; groupsSize: Int32; var groups: UInt32)>(z_GetPerfMonitorGroupsAMD_adr);
    private z_GetPerfMonitorGroupsAMD_ovr_0_anh0001 := GetProcOrNil&<procedure(var numGroups: Int32; groupsSize: Int32; groups: IntPtr)>(z_GetPerfMonitorGroupsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(var numGroups: Int32; groupsSize: Int32; groups: array of UInt32) :=
    if (groups<>nil) and (groups.Length<>0) then
      z_GetPerfMonitorGroupsAMD_ovr_0(numGroups, groupsSize, groups[0]) else
      z_GetPerfMonitorGroupsAMD_ovr_0_anh0001(numGroups, groupsSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(var numGroups: Int32; groupsSize: Int32; var groups: UInt32) :=
    z_GetPerfMonitorGroupsAMD_ovr_0(numGroups, groupsSize, groups);
    private z_GetPerfMonitorGroupsAMD_ovr_2 := GetProcOrNil&<procedure(var numGroups: Int32; groupsSize: Int32; groups: IntPtr)>(z_GetPerfMonitorGroupsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(var numGroups: Int32; groupsSize: Int32; groups: IntPtr) :=
    z_GetPerfMonitorGroupsAMD_ovr_2(numGroups, groupsSize, groups);
    private z_GetPerfMonitorGroupsAMD_ovr_3 := GetProcOrNil&<procedure(numGroups: IntPtr; groupsSize: Int32; var groups: UInt32)>(z_GetPerfMonitorGroupsAMD_adr);
    private z_GetPerfMonitorGroupsAMD_ovr_3_anh0001 := GetProcOrNil&<procedure(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr)>(z_GetPerfMonitorGroupsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: IntPtr; groupsSize: Int32; groups: array of UInt32) :=
    if (groups<>nil) and (groups.Length<>0) then
      z_GetPerfMonitorGroupsAMD_ovr_3(numGroups, groupsSize, groups[0]) else
      z_GetPerfMonitorGroupsAMD_ovr_3_anh0001(numGroups, groupsSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: IntPtr; groupsSize: Int32; var groups: UInt32) :=
    z_GetPerfMonitorGroupsAMD_ovr_3(numGroups, groupsSize, groups);
    private z_GetPerfMonitorGroupsAMD_ovr_5 := GetProcOrNil&<procedure(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr)>(z_GetPerfMonitorGroupsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr) :=
    z_GetPerfMonitorGroupsAMD_ovr_5(numGroups, groupsSize, groups);
    
    private z_GetPerfMonitorCountersAMD_adr := GetProcAddress('glGetPerfMonitorCountersAMD');
    private z_GetPerfMonitorCountersAMD_ovr_0 := GetProcOrNil&<procedure(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32)>(z_GetPerfMonitorCountersAMD_adr);
    private z_GetPerfMonitorCountersAMD_ovr_0_anh000001 := GetProcOrNil&<procedure(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_0_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_2 := GetProcOrNil&<procedure(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_2(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_3 := GetProcOrNil&<procedure(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32)>(z_GetPerfMonitorCountersAMD_adr);
    private z_GetPerfMonitorCountersAMD_ovr_3_anh000001 := GetProcOrNil&<procedure(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_3(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_3_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_3(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_5 := GetProcOrNil&<procedure(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_5(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_6 := GetProcOrNil&<procedure(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32)>(z_GetPerfMonitorCountersAMD_adr);
    private z_GetPerfMonitorCountersAMD_ovr_6_anh000001 := GetProcOrNil&<procedure(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_6(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_6_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_6(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_8 := GetProcOrNil&<procedure(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_8(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_9 := GetProcOrNil&<procedure(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32)>(z_GetPerfMonitorCountersAMD_adr);
    private z_GetPerfMonitorCountersAMD_ovr_9_anh000001 := GetProcOrNil&<procedure(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_9(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_9_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_9(group, numCounters, maxActiveCounters, counterSize, counters);
    private z_GetPerfMonitorCountersAMD_ovr_11 := GetProcOrNil&<procedure(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr)>(z_GetPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_11(group, numCounters, maxActiveCounters, counterSize, counters);
    
    private z_GetPerfMonitorGroupStringAMD_adr := GetProcAddress('glGetPerfMonitorGroupStringAMD');
    private z_GetPerfMonitorGroupStringAMD_ovr_0 := GetProcOrNil&<procedure(group: UInt32; bufSize: Int32; var length: Int32; groupString: IntPtr)>(z_GetPerfMonitorGroupStringAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupStringAMD(group: UInt32; bufSize: Int32; var length: Int32; groupString: IntPtr) :=
    z_GetPerfMonitorGroupStringAMD_ovr_0(group, bufSize, length, groupString);
    private z_GetPerfMonitorGroupStringAMD_ovr_1 := GetProcOrNil&<procedure(group: UInt32; bufSize: Int32; length: IntPtr; groupString: IntPtr)>(z_GetPerfMonitorGroupStringAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupStringAMD(group: UInt32; bufSize: Int32; length: IntPtr; groupString: IntPtr) :=
    z_GetPerfMonitorGroupStringAMD_ovr_1(group, bufSize, length, groupString);
    
    private z_GetPerfMonitorCounterStringAMD_adr := GetProcAddress('glGetPerfMonitorCounterStringAMD');
    private z_GetPerfMonitorCounterStringAMD_ovr_0 := GetProcOrNil&<procedure(group: UInt32; counter: UInt32; bufSize: Int32; var length: Int32; counterString: IntPtr)>(z_GetPerfMonitorCounterStringAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterStringAMD(group: UInt32; counter: UInt32; bufSize: Int32; var length: Int32; counterString: IntPtr) :=
    z_GetPerfMonitorCounterStringAMD_ovr_0(group, counter, bufSize, length, counterString);
    private z_GetPerfMonitorCounterStringAMD_ovr_1 := GetProcOrNil&<procedure(group: UInt32; counter: UInt32; bufSize: Int32; length: IntPtr; counterString: IntPtr)>(z_GetPerfMonitorCounterStringAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterStringAMD(group: UInt32; counter: UInt32; bufSize: Int32; length: IntPtr; counterString: IntPtr) :=
    z_GetPerfMonitorCounterStringAMD_ovr_1(group, counter, bufSize, length, counterString);
    
    private z_GetPerfMonitorCounterInfoAMD_adr := GetProcAddress('glGetPerfMonitorCounterInfoAMD');
    private z_GetPerfMonitorCounterInfoAMD_ovr_0 := GetProcOrNil&<procedure(group: UInt32; counter: UInt32; pname: DummyEnum; data: IntPtr)>(z_GetPerfMonitorCounterInfoAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterInfoAMD(group: UInt32; counter: UInt32; pname: DummyEnum; data: IntPtr) :=
    z_GetPerfMonitorCounterInfoAMD_ovr_0(group, counter, pname, data);
    
    private z_GenPerfMonitorsAMD_adr := GetProcAddress('glGenPerfMonitorsAMD');
    private z_GenPerfMonitorsAMD_ovr_0 := GetProcOrNil&<procedure(n: Int32; var monitors: UInt32)>(z_GenPerfMonitorsAMD_adr);
    private z_GenPerfMonitorsAMD_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; monitors: IntPtr)>(z_GenPerfMonitorsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenPerfMonitorsAMD(n: Int32; monitors: array of UInt32) :=
    if (monitors<>nil) and (monitors.Length<>0) then
      z_GenPerfMonitorsAMD_ovr_0(n, monitors[0]) else
      z_GenPerfMonitorsAMD_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenPerfMonitorsAMD(n: Int32; var monitors: UInt32) :=
    z_GenPerfMonitorsAMD_ovr_0(n, monitors);
    private z_GenPerfMonitorsAMD_ovr_2 := GetProcOrNil&<procedure(n: Int32; monitors: IntPtr)>(z_GenPerfMonitorsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenPerfMonitorsAMD(n: Int32; monitors: IntPtr) :=
    z_GenPerfMonitorsAMD_ovr_2(n, monitors);
    
    private z_DeletePerfMonitorsAMD_adr := GetProcAddress('glDeletePerfMonitorsAMD');
    private z_DeletePerfMonitorsAMD_ovr_0 := GetProcOrNil&<procedure(n: Int32; var monitors: UInt32)>(z_DeletePerfMonitorsAMD_adr);
    private z_DeletePerfMonitorsAMD_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; monitors: IntPtr)>(z_DeletePerfMonitorsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfMonitorsAMD(n: Int32; monitors: array of UInt32) :=
    if (monitors<>nil) and (monitors.Length<>0) then
      z_DeletePerfMonitorsAMD_ovr_0(n, monitors[0]) else
      z_DeletePerfMonitorsAMD_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfMonitorsAMD(n: Int32; var monitors: UInt32) :=
    z_DeletePerfMonitorsAMD_ovr_0(n, monitors);
    private z_DeletePerfMonitorsAMD_ovr_2 := GetProcOrNil&<procedure(n: Int32; monitors: IntPtr)>(z_DeletePerfMonitorsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfMonitorsAMD(n: Int32; monitors: IntPtr) :=
    z_DeletePerfMonitorsAMD_ovr_2(n, monitors);
    
    private z_SelectPerfMonitorCountersAMD_adr := GetProcAddress('glSelectPerfMonitorCountersAMD');
    private z_SelectPerfMonitorCountersAMD_ovr_0 := GetProcOrNil&<procedure(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; var counterList: UInt32)>(z_SelectPerfMonitorCountersAMD_adr);
    private z_SelectPerfMonitorCountersAMD_ovr_0_anh000001 := GetProcOrNil&<procedure(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: IntPtr)>(z_SelectPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectPerfMonitorCountersAMD(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: array of UInt32) :=
    if (counterList<>nil) and (counterList.Length<>0) then
      z_SelectPerfMonitorCountersAMD_ovr_0(monitor, enable, group, numCounters, counterList[0]) else
      z_SelectPerfMonitorCountersAMD_ovr_0_anh000001(monitor, enable, group, numCounters, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectPerfMonitorCountersAMD(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; var counterList: UInt32) :=
    z_SelectPerfMonitorCountersAMD_ovr_0(monitor, enable, group, numCounters, counterList);
    private z_SelectPerfMonitorCountersAMD_ovr_2 := GetProcOrNil&<procedure(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: IntPtr)>(z_SelectPerfMonitorCountersAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectPerfMonitorCountersAMD(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: IntPtr) :=
    z_SelectPerfMonitorCountersAMD_ovr_2(monitor, enable, group, numCounters, counterList);
    
    private z_BeginPerfMonitorAMD_adr := GetProcAddress('glBeginPerfMonitorAMD');
    private z_BeginPerfMonitorAMD_ovr_0 := GetProcOrNil&<procedure(monitor: UInt32)>(z_BeginPerfMonitorAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginPerfMonitorAMD(monitor: UInt32) :=
    z_BeginPerfMonitorAMD_ovr_0(monitor);
    
    private z_EndPerfMonitorAMD_adr := GetProcAddress('glEndPerfMonitorAMD');
    private z_EndPerfMonitorAMD_ovr_0 := GetProcOrNil&<procedure(monitor: UInt32)>(z_EndPerfMonitorAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndPerfMonitorAMD(monitor: UInt32) :=
    z_EndPerfMonitorAMD_ovr_0(monitor);
    
    private z_GetPerfMonitorCounterDataAMD_adr := GetProcAddress('glGetPerfMonitorCounterDataAMD');
    private z_GetPerfMonitorCounterDataAMD_ovr_0 := GetProcOrNil&<procedure(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; var bytesWritten: Int32)>(z_GetPerfMonitorCounterDataAMD_adr);
    private z_GetPerfMonitorCounterDataAMD_ovr_0_anh000010 := GetProcOrNil&<procedure(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32)>(z_GetPerfMonitorCounterDataAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: array of UInt32; var bytesWritten: Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetPerfMonitorCounterDataAMD_ovr_0(monitor, pname, dataSize, data[0], bytesWritten) else
      z_GetPerfMonitorCounterDataAMD_ovr_0_anh000010(monitor, pname, dataSize, IntPtr.Zero, bytesWritten);
    private z_GetPerfMonitorCounterDataAMD_ovr_1 := GetProcOrNil&<procedure(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; bytesWritten: IntPtr)>(z_GetPerfMonitorCounterDataAMD_adr);
    private z_GetPerfMonitorCounterDataAMD_ovr_1_anh000010 := GetProcOrNil&<procedure(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr)>(z_GetPerfMonitorCounterDataAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: array of UInt32; bytesWritten: IntPtr) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetPerfMonitorCounterDataAMD_ovr_1(monitor, pname, dataSize, data[0], bytesWritten) else
      z_GetPerfMonitorCounterDataAMD_ovr_1_anh000010(monitor, pname, dataSize, IntPtr.Zero, bytesWritten);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; var bytesWritten: Int32) :=
    z_GetPerfMonitorCounterDataAMD_ovr_0(monitor, pname, dataSize, data, bytesWritten);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; bytesWritten: IntPtr) :=
    z_GetPerfMonitorCounterDataAMD_ovr_1(monitor, pname, dataSize, data, bytesWritten);
    private z_GetPerfMonitorCounterDataAMD_ovr_4 := GetProcOrNil&<procedure(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32)>(z_GetPerfMonitorCounterDataAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32) :=
    z_GetPerfMonitorCounterDataAMD_ovr_4(monitor, pname, dataSize, data, bytesWritten);
    private z_GetPerfMonitorCounterDataAMD_ovr_5 := GetProcOrNil&<procedure(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr)>(z_GetPerfMonitorCounterDataAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr) :=
    z_GetPerfMonitorCounterDataAMD_ovr_5(monitor, pname, dataSize, data, bytesWritten);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSamplePositionsAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_sample_positions';
    
    private z_SetMultisamplefvAMD_adr := GetProcAddress('glSetMultisamplefvAMD');
    private z_SetMultisamplefvAMD_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; index: UInt32; var val: single)>(z_SetMultisamplefvAMD_adr);
    private z_SetMultisamplefvAMD_ovr_0_anh0001 := GetProcOrNil&<procedure(pname: DummyEnum; index: UInt32; val: IntPtr)>(z_SetMultisamplefvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetMultisamplefvAMD(pname: DummyEnum; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_SetMultisamplefvAMD_ovr_0(pname, index, val[0]) else
      z_SetMultisamplefvAMD_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetMultisamplefvAMD(pname: DummyEnum; index: UInt32; var val: single) :=
    z_SetMultisamplefvAMD_ovr_0(pname, index, val);
    private z_SetMultisamplefvAMD_ovr_2 := GetProcOrNil&<procedure(pname: DummyEnum; index: UInt32; val: IntPtr)>(z_SetMultisamplefvAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetMultisamplefvAMD(pname: DummyEnum; index: UInt32; val: IntPtr) :=
    z_SetMultisamplefvAMD_ovr_2(pname, index, val);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSparseTextureAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_sparse_texture';
    
    private z_TexStorageSparseAMD_adr := GetProcAddress('glTexStorageSparseAMD');
    private z_TexStorageSparseAMD_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD)>(z_TexStorageSparseAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageSparseAMD(target: TextureTarget; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD) :=
    z_TexStorageSparseAMD_ovr_0(target, internalFormat, width, height, depth, layers, flags);
    
    private z_TextureStorageSparseAMD_adr := GetProcAddress('glTextureStorageSparseAMD');
    private z_TextureStorageSparseAMD_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD)>(z_TextureStorageSparseAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageSparseAMD(texture: gl_texture; target: DummyEnum; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD) :=
    z_TextureStorageSparseAMD_ovr_0(texture, target, internalFormat, width, height, depth, layers, flags);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glStencilOperationExtendedAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_stencil_operation_extended';
    
    private z_StencilOpValueAMD_adr := GetProcAddress('glStencilOpValueAMD');
    private z_StencilOpValueAMD_ovr_0 := GetProcOrNil&<procedure(face: StencilFaceDirection; value: UInt32)>(z_StencilOpValueAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOpValueAMD(face: StencilFaceDirection; value: UInt32) :=
    z_StencilOpValueAMD_ovr_0(face, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexShaderTessellatorAMD = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_vertex_shader_tessellator';
    
    private z_TessellationFactorAMD_adr := GetProcAddress('glTessellationFactorAMD');
    private z_TessellationFactorAMD_ovr_0 := GetProcOrNil&<procedure(factor: single)>(z_TessellationFactorAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TessellationFactorAMD(factor: single) :=
    z_TessellationFactorAMD_ovr_0(factor);
    
    private z_TessellationModeAMD_adr := GetProcAddress('glTessellationModeAMD');
    private z_TessellationModeAMD_ovr_0 := GetProcOrNil&<procedure(mode: DummyEnum)>(z_TessellationModeAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TessellationModeAMD(mode: DummyEnum) :=
    z_TessellationModeAMD_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glElementArrayAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_element_array';
    
    private z_ElementPointerAPPLE_adr := GetProcAddress('glElementPointerAPPLE');
    private z_ElementPointerAPPLE_ovr_0 := GetProcOrNil&<procedure(&type: ElementPointerTypeATI; pointer: IntPtr)>(z_ElementPointerAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ElementPointerAPPLE(&type: ElementPointerTypeATI; pointer: IntPtr) :=
    z_ElementPointerAPPLE_ovr_0(&type, pointer);
    
    private z_DrawElementArrayAPPLE_adr := GetProcAddress('glDrawElementArrayAPPLE');
    private z_DrawElementArrayAPPLE_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32)>(z_DrawElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementArrayAPPLE(mode: PrimitiveType; first: Int32; count: Int32) :=
    z_DrawElementArrayAPPLE_ovr_0(mode, first, count);
    
    private z_DrawRangeElementArrayAPPLE_adr := GetProcAddress('glDrawRangeElementArrayAPPLE');
    private z_DrawRangeElementArrayAPPLE_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: Int32; count: Int32)>(z_DrawRangeElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: Int32; count: Int32) :=
    z_DrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first, count);
    
    private z_MultiDrawElementArrayAPPLE_adr := GetProcAddress('glMultiDrawElementArrayAPPLE');
    private z_MultiDrawElementArrayAPPLE_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    private z_MultiDrawElementArrayAPPLE_ovr_0_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    private z_MultiDrawElementArrayAPPLE_ovr_0_anh00010 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    private z_MultiDrawElementArrayAPPLE_ovr_0_anh00110 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawElementArrayAPPLE_ovr_0(mode, first[0], count[0], primcount) else
        z_MultiDrawElementArrayAPPLE_ovr_0_anh00010(mode, first[0], IntPtr.Zero, primcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawElementArrayAPPLE_ovr_0_anh00100(mode, IntPtr.Zero, count[0], primcount) else
        z_MultiDrawElementArrayAPPLE_ovr_0_anh00110(mode, IntPtr.Zero, IntPtr.Zero, primcount);
    private z_MultiDrawElementArrayAPPLE_ovr_1_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_0(mode, first[0], count, primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_0_anh00100(mode, IntPtr.Zero, count, primcount);
    private z_MultiDrawElementArrayAPPLE_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    private z_MultiDrawElementArrayAPPLE_ovr_2_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_2(mode, first[0], count, primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_2_anh00100(mode, IntPtr.Zero, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_0(mode, first, count[0], primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_0_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_0(mode, first, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_2(mode, first, count, primcount);
    private z_MultiDrawElementArrayAPPLE_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    private z_MultiDrawElementArrayAPPLE_ovr_6_anh00010 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_6(mode, first, count[0], primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_6_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_6(mode, first, count, primcount);
    private z_MultiDrawElementArrayAPPLE_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_8(mode, first, count, primcount);
    
    private z_MultiDrawRangeElementArrayAPPLE_adr := GetProcAddress('glMultiDrawRangeElementArrayAPPLE');
    private z_MultiDrawRangeElementArrayAPPLE_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; var count: Int32; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000010 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: IntPtr; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000110 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: array of Int32; count: array of Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first[0], count[0], primcount) else
        z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000010(mode, start, &end, first[0], IntPtr.Zero, primcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000100(mode, start, &end, IntPtr.Zero, count[0], primcount) else
        z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000110(mode, start, &end, IntPtr.Zero, IntPtr.Zero, primcount);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_1_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: array of Int32; var count: Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first[0], count, primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000100(mode, start, &end, IntPtr.Zero, count, primcount);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: IntPtr; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_2_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: array of Int32; count: IntPtr; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_2(mode, start, &end, first[0], count, primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_2_anh0000100(mode, start, &end, IntPtr.Zero, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first, count[0], primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000010(mode, start, &end, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; var count: Int32; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: IntPtr; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_2(mode, start, &end, first, count, primcount);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_6_anh0000010 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_6(mode, start, &end, first, count[0], primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_6_anh0000010(mode, start, &end, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_6(mode, start, &end, first, count, primcount);
    private z_MultiDrawRangeElementArrayAPPLE_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawRangeElementArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_8(mode, start, &end, first, count, primcount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFenceAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_fence';
    
    private z_GenFencesAPPLE_adr := GetProcAddress('glGenFencesAPPLE');
    private z_GenFencesAPPLE_ovr_0 := GetProcOrNil&<procedure(n: Int32; var fences: UInt32)>(z_GenFencesAPPLE_adr);
    private z_GenFencesAPPLE_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_GenFencesAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesAPPLE(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_GenFencesAPPLE_ovr_0(n, fences[0]) else
      z_GenFencesAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesAPPLE(n: Int32; var fences: UInt32) :=
    z_GenFencesAPPLE_ovr_0(n, fences);
    private z_GenFencesAPPLE_ovr_2 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_GenFencesAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesAPPLE(n: Int32; fences: IntPtr) :=
    z_GenFencesAPPLE_ovr_2(n, fences);
    
    private z_DeleteFencesAPPLE_adr := GetProcAddress('glDeleteFencesAPPLE');
    private z_DeleteFencesAPPLE_ovr_0 := GetProcOrNil&<procedure(n: Int32; var fences: UInt32)>(z_DeleteFencesAPPLE_adr);
    private z_DeleteFencesAPPLE_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_DeleteFencesAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesAPPLE(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_DeleteFencesAPPLE_ovr_0(n, fences[0]) else
      z_DeleteFencesAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesAPPLE(n: Int32; var fences: UInt32) :=
    z_DeleteFencesAPPLE_ovr_0(n, fences);
    private z_DeleteFencesAPPLE_ovr_2 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_DeleteFencesAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesAPPLE(n: Int32; fences: IntPtr) :=
    z_DeleteFencesAPPLE_ovr_2(n, fences);
    
    private z_SetFenceAPPLE_adr := GetProcAddress('glSetFenceAPPLE');
    private z_SetFenceAPPLE_ovr_0 := GetProcOrNil&<procedure(fence: UInt32)>(z_SetFenceAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFenceAPPLE(fence: UInt32) :=
    z_SetFenceAPPLE_ovr_0(fence);
    
    private z_IsFenceAPPLE_adr := GetProcAddress('glIsFenceAPPLE');
    private z_IsFenceAPPLE_ovr_0 := GetProcOrNil&<function(fence: UInt32): boolean>(z_IsFenceAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFenceAPPLE(fence: UInt32): boolean :=
    z_IsFenceAPPLE_ovr_0(fence);
    
    private z_TestFenceAPPLE_adr := GetProcAddress('glTestFenceAPPLE');
    private z_TestFenceAPPLE_ovr_0 := GetProcOrNil&<function(fence: UInt32): boolean>(z_TestFenceAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function TestFenceAPPLE(fence: UInt32): boolean :=
    z_TestFenceAPPLE_ovr_0(fence);
    
    private z_FinishFenceAPPLE_adr := GetProcAddress('glFinishFenceAPPLE');
    private z_FinishFenceAPPLE_ovr_0 := GetProcOrNil&<procedure(fence: UInt32)>(z_FinishFenceAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishFenceAPPLE(fence: UInt32) :=
    z_FinishFenceAPPLE_ovr_0(fence);
    
    private z_TestObjectAPPLE_adr := GetProcAddress('glTestObjectAPPLE');
    private z_TestObjectAPPLE_ovr_0 := GetProcOrNil&<function(object: ObjectTypeAPPLE; name: UInt32): boolean>(z_TestObjectAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function TestObjectAPPLE(object: ObjectTypeAPPLE; name: UInt32): boolean :=
    z_TestObjectAPPLE_ovr_0(object, name);
    
    private z_FinishObjectAPPLE_adr := GetProcAddress('glFinishObjectAPPLE');
    private z_FinishObjectAPPLE_ovr_0 := GetProcOrNil&<procedure(object: ObjectTypeAPPLE; name: Int32)>(z_FinishObjectAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishObjectAPPLE(object: ObjectTypeAPPLE; name: Int32) :=
    z_FinishObjectAPPLE_ovr_0(object, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFlushBufferRangeAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_flush_buffer_range';
    
    private z_BufferParameteriAPPLE_adr := GetProcAddress('glBufferParameteriAPPLE');
    private z_BufferParameteriAPPLE_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; param: Int32)>(z_BufferParameteriAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferParameteriAPPLE(target: DummyEnum; pname: DummyEnum; param: Int32) :=
    z_BufferParameteriAPPLE_ovr_0(target, pname, param);
    
    private z_FlushMappedBufferRangeAPPLE_adr := GetProcAddress('glFlushMappedBufferRangeAPPLE');
    private z_FlushMappedBufferRangeAPPLE_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; size: IntPtr)>(z_FlushMappedBufferRangeAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedBufferRangeAPPLE(target: BufferTarget; offset: IntPtr; size: IntPtr) :=
    z_FlushMappedBufferRangeAPPLE_ovr_0(target, offset, size);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glObjectPurgeableAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_object_purgeable';
    
    private z_ObjectPurgeableAPPLE_adr := GetProcAddress('glObjectPurgeableAPPLE');
    private z_ObjectPurgeableAPPLE_ovr_0 := GetProcOrNil&<function(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum>(z_ObjectPurgeableAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ObjectPurgeableAPPLE(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum :=
    z_ObjectPurgeableAPPLE_ovr_0(objectType, name, option);
    
    private z_ObjectUnpurgeableAPPLE_adr := GetProcAddress('glObjectUnpurgeableAPPLE');
    private z_ObjectUnpurgeableAPPLE_ovr_0 := GetProcOrNil&<function(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum>(z_ObjectUnpurgeableAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ObjectUnpurgeableAPPLE(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum :=
    z_ObjectUnpurgeableAPPLE_ovr_0(objectType, name, option);
    
    private z_GetObjectParameterivAPPLE_adr := GetProcAddress('glGetObjectParameterivAPPLE');
    private z_GetObjectParameterivAPPLE_ovr_0 := GetProcOrNil&<procedure(objectType: DummyEnum; name: UInt32; pname: DummyEnum; var &params: Int32)>(z_GetObjectParameterivAPPLE_adr);
    private z_GetObjectParameterivAPPLE_ovr_0_anh00001 := GetProcOrNil&<procedure(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetObjectParameterivAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivAPPLE(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectParameterivAPPLE_ovr_0(objectType, name, pname, &params[0]) else
      z_GetObjectParameterivAPPLE_ovr_0_anh00001(objectType, name, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivAPPLE(objectType: DummyEnum; name: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetObjectParameterivAPPLE_ovr_0(objectType, name, pname, &params);
    private z_GetObjectParameterivAPPLE_ovr_2 := GetProcOrNil&<procedure(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetObjectParameterivAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivAPPLE(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetObjectParameterivAPPLE_ovr_2(objectType, name, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureRangeAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_texture_range';
    
    private z_TextureRangeAPPLE_adr := GetProcAddress('glTextureRangeAPPLE');
    private z_TextureRangeAPPLE_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; length: Int32; pointer: IntPtr)>(z_TextureRangeAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureRangeAPPLE(target: DummyEnum; length: Int32; pointer: IntPtr) :=
    z_TextureRangeAPPLE_ovr_0(target, length, pointer);
    
    private z_GetTexParameterPointervAPPLE_adr := GetProcAddress('glGetTexParameterPointervAPPLE');
    private z_GetTexParameterPointervAPPLE_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; var &params: IntPtr)>(z_GetTexParameterPointervAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterPointervAPPLE(target: DummyEnum; pname: DummyEnum; var &params: IntPtr) :=
    z_GetTexParameterPointervAPPLE_ovr_0(target, pname, &params);
    private z_GetTexParameterPointervAPPLE_ovr_1 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: pointer)>(z_GetTexParameterPointervAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterPointervAPPLE(target: DummyEnum; pname: DummyEnum; &params: pointer) :=
    z_GetTexParameterPointervAPPLE_ovr_1(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayObjectAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_vertex_array_object';
    
    private z_BindVertexArrayAPPLE_adr := GetProcAddress('glBindVertexArrayAPPLE');
    private z_BindVertexArrayAPPLE_ovr_0 := GetProcOrNil&<procedure(&array: gl_vertex_array)>(z_BindVertexArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexArrayAPPLE(&array: gl_vertex_array) :=
    z_BindVertexArrayAPPLE_ovr_0(&array);
    
    private z_DeleteVertexArraysAPPLE_adr := GetProcAddress('glDeleteVertexArraysAPPLE');
    private z_DeleteVertexArraysAPPLE_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_DeleteVertexArraysAPPLE_adr);
    private z_DeleteVertexArraysAPPLE_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArraysAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArraysAPPLE(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_DeleteVertexArraysAPPLE_ovr_0(n, arrays[0]) else
      z_DeleteVertexArraysAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArraysAPPLE(n: Int32; var arrays: gl_vertex_array) :=
    z_DeleteVertexArraysAPPLE_ovr_0(n, arrays);
    private z_DeleteVertexArraysAPPLE_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArraysAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArraysAPPLE(n: Int32; arrays: IntPtr) :=
    z_DeleteVertexArraysAPPLE_ovr_2(n, arrays);
    
    private z_GenVertexArraysAPPLE_adr := GetProcAddress('glGenVertexArraysAPPLE');
    private z_GenVertexArraysAPPLE_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_GenVertexArraysAPPLE_adr);
    private z_GenVertexArraysAPPLE_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArraysAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArraysAPPLE(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_GenVertexArraysAPPLE_ovr_0(n, arrays[0]) else
      z_GenVertexArraysAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArraysAPPLE(n: Int32; var arrays: gl_vertex_array) :=
    z_GenVertexArraysAPPLE_ovr_0(n, arrays);
    private z_GenVertexArraysAPPLE_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArraysAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArraysAPPLE(n: Int32; arrays: IntPtr) :=
    z_GenVertexArraysAPPLE_ovr_2(n, arrays);
    
    private z_IsVertexArrayAPPLE_adr := GetProcAddress('glIsVertexArrayAPPLE');
    private z_IsVertexArrayAPPLE_ovr_0 := GetProcOrNil&<function(&array: gl_vertex_array): boolean>(z_IsVertexArrayAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexArrayAPPLE(&array: gl_vertex_array): boolean :=
    z_IsVertexArrayAPPLE_ovr_0(&array);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayRangeAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_vertex_array_range';
    
    private z_VertexArrayRangeAPPLE_adr := GetProcAddress('glVertexArrayRangeAPPLE');
    private z_VertexArrayRangeAPPLE_ovr_0 := GetProcOrNil&<procedure(length: Int32; pointer: IntPtr)>(z_VertexArrayRangeAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayRangeAPPLE(length: Int32; pointer: IntPtr) :=
    z_VertexArrayRangeAPPLE_ovr_0(length, pointer);
    
    private z_FlushVertexArrayRangeAPPLE_adr := GetProcAddress('glFlushVertexArrayRangeAPPLE');
    private z_FlushVertexArrayRangeAPPLE_ovr_0 := GetProcOrNil&<procedure(length: Int32; pointer: IntPtr)>(z_FlushVertexArrayRangeAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushVertexArrayRangeAPPLE(length: Int32; pointer: IntPtr) :=
    z_FlushVertexArrayRangeAPPLE_ovr_0(length, pointer);
    
    private z_VertexArrayParameteriAPPLE_adr := GetProcAddress('glVertexArrayParameteriAPPLE');
    private z_VertexArrayParameteriAPPLE_ovr_0 := GetProcOrNil&<procedure(pname: VertexArrayPNameAPPLE; param: Int32)>(z_VertexArrayParameteriAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayParameteriAPPLE(pname: VertexArrayPNameAPPLE; param: Int32) :=
    z_VertexArrayParameteriAPPLE_ovr_0(pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexProgramEvaluatorsAPPLE = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'APPLE_vertex_program_evaluators';
    
    private z_EnableVertexAttribAPPLE_adr := GetProcAddress('glEnableVertexAttribAPPLE');
    private z_EnableVertexAttribAPPLE_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: DummyEnum)>(z_EnableVertexAttribAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribAPPLE(index: UInt32; pname: DummyEnum) :=
    z_EnableVertexAttribAPPLE_ovr_0(index, pname);
    
    private z_DisableVertexAttribAPPLE_adr := GetProcAddress('glDisableVertexAttribAPPLE');
    private z_DisableVertexAttribAPPLE_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: DummyEnum)>(z_DisableVertexAttribAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribAPPLE(index: UInt32; pname: DummyEnum) :=
    z_DisableVertexAttribAPPLE_ovr_0(index, pname);
    
    private z_IsVertexAttribEnabledAPPLE_adr := GetProcAddress('glIsVertexAttribEnabledAPPLE');
    private z_IsVertexAttribEnabledAPPLE_ovr_0 := GetProcOrNil&<function(index: UInt32; pname: DummyEnum): boolean>(z_IsVertexAttribEnabledAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexAttribEnabledAPPLE(index: UInt32; pname: DummyEnum): boolean :=
    z_IsVertexAttribEnabledAPPLE_ovr_0(index, pname);
    
    private z_MapVertexAttrib1dAPPLE_adr := GetProcAddress('glMapVertexAttrib1dAPPLE');
    private z_MapVertexAttrib1dAPPLE_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; var points: real)>(z_MapVertexAttrib1dAPPLE_adr);
    private z_MapVertexAttrib1dAPPLE_ovr_0_anh00000001 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr)>(z_MapVertexAttrib1dAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib1dAPPLE_ovr_0(index, size, u1, u2, stride, order, points[0]) else
      z_MapVertexAttrib1dAPPLE_ovr_0_anh00000001(index, size, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; var points: real) :=
    z_MapVertexAttrib1dAPPLE_ovr_0(index, size, u1, u2, stride, order, points);
    private z_MapVertexAttrib1dAPPLE_ovr_2 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr)>(z_MapVertexAttrib1dAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr) :=
    z_MapVertexAttrib1dAPPLE_ovr_2(index, size, u1, u2, stride, order, points);
    
    private z_MapVertexAttrib1fAPPLE_adr := GetProcAddress('glMapVertexAttrib1fAPPLE');
    private z_MapVertexAttrib1fAPPLE_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; var points: single)>(z_MapVertexAttrib1fAPPLE_adr);
    private z_MapVertexAttrib1fAPPLE_ovr_0_anh00000001 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr)>(z_MapVertexAttrib1fAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib1fAPPLE_ovr_0(index, size, u1, u2, stride, order, points[0]) else
      z_MapVertexAttrib1fAPPLE_ovr_0_anh00000001(index, size, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; var points: single) :=
    z_MapVertexAttrib1fAPPLE_ovr_0(index, size, u1, u2, stride, order, points);
    private z_MapVertexAttrib1fAPPLE_ovr_2 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr)>(z_MapVertexAttrib1fAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr) :=
    z_MapVertexAttrib1fAPPLE_ovr_2(index, size, u1, u2, stride, order, points);
    
    private z_MapVertexAttrib2dAPPLE_adr := GetProcAddress('glMapVertexAttrib2dAPPLE');
    private z_MapVertexAttrib2dAPPLE_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real)>(z_MapVertexAttrib2dAPPLE_adr);
    private z_MapVertexAttrib2dAPPLE_ovr_0_anh000000000001 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr)>(z_MapVertexAttrib2dAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib2dAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_MapVertexAttrib2dAPPLE_ovr_0_anh000000000001(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real) :=
    z_MapVertexAttrib2dAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private z_MapVertexAttrib2dAPPLE_ovr_2 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr)>(z_MapVertexAttrib2dAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_MapVertexAttrib2dAPPLE_ovr_2(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    private z_MapVertexAttrib2fAPPLE_adr := GetProcAddress('glMapVertexAttrib2fAPPLE');
    private z_MapVertexAttrib2fAPPLE_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single)>(z_MapVertexAttrib2fAPPLE_adr);
    private z_MapVertexAttrib2fAPPLE_ovr_0_anh000000000001 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr)>(z_MapVertexAttrib2fAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib2fAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_MapVertexAttrib2fAPPLE_ovr_0_anh000000000001(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single) :=
    z_MapVertexAttrib2fAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private z_MapVertexAttrib2fAPPLE_ovr_2 := GetProcOrNil&<procedure(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr)>(z_MapVertexAttrib2fAPPLE_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_MapVertexAttrib2fAPPLE_ovr_2(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glES2CompatibilityARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_ES2_compatibility';
    
    private z_ReleaseShaderCompiler_adr := GetProcAddress('glReleaseShaderCompiler');
    private z_ReleaseShaderCompiler_ovr_0 := GetProcOrNil&<procedure>(z_ReleaseShaderCompiler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReleaseShaderCompiler :=
    z_ReleaseShaderCompiler_ovr_0;
    
    private z_ShaderBinary_adr := GetProcAddress('glShaderBinary');
    private z_ShaderBinary_ovr_0 := GetProcOrNil&<procedure(count: Int32; var shaders: gl_shader; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    private z_ShaderBinary_ovr_0_anh001000 := GetProcOrNil&<procedure(count: Int32; shaders: IntPtr; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: array of gl_shader; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_ShaderBinary_ovr_0(count, shaders[0], binaryFormat, binary, length) else
      z_ShaderBinary_ovr_0_anh001000(count, IntPtr.Zero, binaryFormat, binary, length);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; var shaders: gl_shader; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_0(count, shaders, binaryFormat, binary, length);
    private z_ShaderBinary_ovr_2 := GetProcOrNil&<procedure(count: Int32; shaders: IntPtr; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: IntPtr; binaryFormat: ShaderBinaryFormat; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_2(count, shaders, binaryFormat, binary, length);
    
    private z_GetShaderPrecisionFormat_adr := GetProcAddress('glGetShaderPrecisionFormat');
    private z_GetShaderPrecisionFormat_ovr_0 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_0_anh00010 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; var precision: Int32) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    private z_GetShaderPrecisionFormat_ovr_1 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_1_anh00010 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; precision: IntPtr) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_1(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_1_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_1(_shadertype, _precisiontype, range, precision);
    private z_GetShaderPrecisionFormat_ovr_4 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_4(_shadertype, _precisiontype, range, precision);
    private z_GetShaderPrecisionFormat_ovr_5 := GetProcOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_5(_shadertype, _precisiontype, range, precision);
    
    private z_DepthRangef_adr := GetProcAddress('glDepthRangef');
    private z_DepthRangef_ovr_0 := GetProcOrNil&<procedure(n: single; f: single)>(z_DepthRangef_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangef(n: single; f: single) :=
    z_DepthRangef_ovr_0(n, f);
    
    private z_ClearDepthf_adr := GetProcAddress('glClearDepthf');
    private z_ClearDepthf_ovr_0 := GetProcOrNil&<procedure(d: single)>(z_ClearDepthf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthf(d: single) :=
    z_ClearDepthf_ovr_0(d);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glES31CompatibilityARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_ES3_1_compatibility';
    
    private z_MemoryBarrierByRegion_adr := GetProcAddress('glMemoryBarrierByRegion');
    private z_MemoryBarrierByRegion_ovr_0 := GetProcOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrierByRegion_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrierByRegion(barriers: MemoryBarrierMask) :=
    z_MemoryBarrierByRegion_ovr_0(barriers);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glES32CompatibilityARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_ES3_2_compatibility';
    
    private z_PrimitiveBoundingBoxARB_adr := GetProcAddress('glPrimitiveBoundingBoxARB');
    private z_PrimitiveBoundingBoxARB_ovr_0 := GetProcOrNil&<procedure(minX: single; minY: single; minZ: single; minW: single; maxX: single; maxY: single; maxZ: single; maxW: single)>(z_PrimitiveBoundingBoxARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveBoundingBoxARB(minX: single; minY: single; minZ: single; minW: single; maxX: single; maxY: single; maxZ: single; maxW: single) :=
    z_PrimitiveBoundingBoxARB_ovr_0(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBaseInstanceARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_base_instance';
    
    private z_DrawArraysInstancedBaseInstance_adr := GetProcAddress('glDrawArraysInstancedBaseInstance');
    private z_DrawArraysInstancedBaseInstance_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32)>(z_DrawArraysInstancedBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedBaseInstance(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawArraysInstancedBaseInstance_ovr_0(mode, first, count, instancecount, baseinstance);
    
    private z_DrawElementsInstancedBaseInstance_adr := GetProcAddress('glDrawElementsInstancedBaseInstance');
    private z_DrawElementsInstancedBaseInstance_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32)>(z_DrawElementsInstancedBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseInstance(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseInstance_ovr_0(mode, count, &type, indices, instancecount, baseinstance);
    
    private z_DrawElementsInstancedBaseVertexBaseInstance_adr := GetProcAddress('glDrawElementsInstancedBaseVertexBaseInstance');
    private z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32)>(z_DrawElementsInstancedBaseVertexBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertexBaseInstance(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0(mode, count, &type, indices, instancecount, basevertex, baseinstance);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBindlessTextureARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_bindless_texture';
    
    private z_GetTextureHandleARB_adr := GetProcAddress('glGetTextureHandleARB');
    private z_GetTextureHandleARB_ovr_0 := GetProcOrNil&<function(texture: gl_texture): UInt64>(z_GetTextureHandleARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureHandleARB(texture: gl_texture): UInt64 :=
    z_GetTextureHandleARB_ovr_0(texture);
    
    private z_GetTextureSamplerHandleARB_adr := GetProcAddress('glGetTextureSamplerHandleARB');
    private z_GetTextureSamplerHandleARB_ovr_0 := GetProcOrNil&<function(texture: gl_texture; sampler: gl_sampler): UInt64>(z_GetTextureSamplerHandleARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureSamplerHandleARB(texture: gl_texture; sampler: gl_sampler): UInt64 :=
    z_GetTextureSamplerHandleARB_ovr_0(texture, sampler);
    
    private z_MakeTextureHandleResidentARB_adr := GetProcAddress('glMakeTextureHandleResidentARB');
    private z_MakeTextureHandleResidentARB_ovr_0 := GetProcOrNil&<procedure(handle: UInt64)>(z_MakeTextureHandleResidentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleResidentARB(handle: UInt64) :=
    z_MakeTextureHandleResidentARB_ovr_0(handle);
    
    private z_MakeTextureHandleNonResidentARB_adr := GetProcAddress('glMakeTextureHandleNonResidentARB');
    private z_MakeTextureHandleNonResidentARB_ovr_0 := GetProcOrNil&<procedure(handle: UInt64)>(z_MakeTextureHandleNonResidentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleNonResidentARB(handle: UInt64) :=
    z_MakeTextureHandleNonResidentARB_ovr_0(handle);
    
    private z_GetImageHandleARB_adr := GetProcAddress('glGetImageHandleARB');
    private z_GetImageHandleARB_ovr_0 := GetProcOrNil&<function(texture: gl_texture; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64>(z_GetImageHandleARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetImageHandleARB(texture: gl_texture; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64 :=
    z_GetImageHandleARB_ovr_0(texture, level, layered, layer, format);
    
    private z_MakeImageHandleResidentARB_adr := GetProcAddress('glMakeImageHandleResidentARB');
    private z_MakeImageHandleResidentARB_ovr_0 := GetProcOrNil&<procedure(handle: UInt64; access: DummyEnum)>(z_MakeImageHandleResidentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleResidentARB(handle: UInt64; access: DummyEnum) :=
    z_MakeImageHandleResidentARB_ovr_0(handle, access);
    
    private z_MakeImageHandleNonResidentARB_adr := GetProcAddress('glMakeImageHandleNonResidentARB');
    private z_MakeImageHandleNonResidentARB_ovr_0 := GetProcOrNil&<procedure(handle: UInt64)>(z_MakeImageHandleNonResidentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleNonResidentARB(handle: UInt64) :=
    z_MakeImageHandleNonResidentARB_ovr_0(handle);
    
    private z_UniformHandleui64ARB_adr := GetProcAddress('glUniformHandleui64ARB');
    private z_UniformHandleui64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; value: UInt64)>(z_UniformHandleui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64ARB(location: Int32; value: UInt64) :=
    z_UniformHandleui64ARB_ovr_0(location, value);
    
    private z_UniformHandleui64vARB_adr := GetProcAddress('glUniformHandleui64vARB');
    private z_UniformHandleui64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_UniformHandleui64vARB_adr);
    private z_UniformHandleui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_UniformHandleui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformHandleui64vARB_ovr_0(location, count, value[0]) else
      z_UniformHandleui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_UniformHandleui64vARB_ovr_0(location, count, value);
    private z_UniformHandleui64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_UniformHandleui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_UniformHandleui64vARB_ovr_2(location, count, value);
    
    private z_ProgramUniformHandleui64ARB_adr := GetProcAddress('glProgramUniformHandleui64ARB');
    private z_ProgramUniformHandleui64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; value: UInt64)>(z_ProgramUniformHandleui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64ARB(&program: gl_program; location: Int32; value: UInt64) :=
    z_ProgramUniformHandleui64ARB_ovr_0(&program, location, value);
    
    private z_ProgramUniformHandleui64vARB_adr := GetProcAddress('glProgramUniformHandleui64vARB');
    private z_ProgramUniformHandleui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var values: UInt64)>(z_ProgramUniformHandleui64vARB_adr);
    private z_ProgramUniformHandleui64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; values: IntPtr)>(z_ProgramUniformHandleui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vARB(&program: gl_program; location: Int32; count: Int32; values: array of UInt64) :=
    if (values<>nil) and (values.Length<>0) then
      z_ProgramUniformHandleui64vARB_ovr_0(&program, location, count, values[0]) else
      z_ProgramUniformHandleui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vARB(&program: gl_program; location: Int32; count: Int32; var values: UInt64) :=
    z_ProgramUniformHandleui64vARB_ovr_0(&program, location, count, values);
    private z_ProgramUniformHandleui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; values: IntPtr)>(z_ProgramUniformHandleui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vARB(&program: gl_program; location: Int32; count: Int32; values: IntPtr) :=
    z_ProgramUniformHandleui64vARB_ovr_2(&program, location, count, values);
    
    private z_IsTextureHandleResidentARB_adr := GetProcAddress('glIsTextureHandleResidentARB');
    private z_IsTextureHandleResidentARB_ovr_0 := GetProcOrNil&<function(handle: UInt64): boolean>(z_IsTextureHandleResidentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTextureHandleResidentARB(handle: UInt64): boolean :=
    z_IsTextureHandleResidentARB_ovr_0(handle);
    
    private z_IsImageHandleResidentARB_adr := GetProcAddress('glIsImageHandleResidentARB');
    private z_IsImageHandleResidentARB_ovr_0 := GetProcOrNil&<function(handle: UInt64): boolean>(z_IsImageHandleResidentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsImageHandleResidentARB(handle: UInt64): boolean :=
    z_IsImageHandleResidentARB_ovr_0(handle);
    
    private z_VertexAttribL1ui64ARB_adr := GetProcAddress('glVertexAttribL1ui64ARB');
    private z_VertexAttribL1ui64ARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt64)>(z_VertexAttribL1ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64ARB(index: UInt32; x: UInt64) :=
    z_VertexAttribL1ui64ARB_ovr_0(index, x);
    
    private z_VertexAttribL1ui64vARB_adr := GetProcAddress('glVertexAttribL1ui64vARB');
    private z_VertexAttribL1ui64vARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt64)>(z_VertexAttribL1ui64vARB_adr);
    private z_VertexAttribL1ui64vARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vARB(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1ui64vARB_ovr_0(index, v[0]) else
      z_VertexAttribL1ui64vARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vARB(index: UInt32; var v: UInt64) :=
    z_VertexAttribL1ui64vARB_ovr_0(index, v);
    private z_VertexAttribL1ui64vARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vARB(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1ui64vARB_ovr_2(index, v);
    
    private z_GetVertexAttribLui64vARB_adr := GetProcAddress('glGetVertexAttribLui64vARB');
    private z_GetVertexAttribLui64vARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: UInt64)>(z_GetVertexAttribLui64vARB_adr);
    private z_GetVertexAttribLui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vARB(index: UInt32; pname: VertexAttribEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLui64vARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLui64vARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vARB(index: UInt32; pname: VertexAttribEnum; var &params: UInt64) :=
    z_GetVertexAttribLui64vARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribLui64vARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vARB(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLui64vARB_ovr_2(index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendFuncExtendedARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_blend_func_extended';
    
    private z_BindFragDataLocationIndexed_adr := GetProcAddress('glBindFragDataLocationIndexed');
    private z_BindFragDataLocationIndexed_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; colorNumber: UInt32; index: UInt32; name: IntPtr)>(z_BindFragDataLocationIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: gl_program; colorNumber: UInt32; index: UInt32; name: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: gl_program; colorNumber: UInt32; index: UInt32; name: IntPtr) :=
    z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, name);
    
    private z_GetFragDataIndex_adr := GetProcAddress('glGetFragDataIndex');
    private z_GetFragDataIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetFragDataIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetFragDataIndex_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: gl_program; name: IntPtr): Int32 :=
    z_GetFragDataIndex_ovr_0(&program, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBufferStorageARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_buffer_storage';
    
    private z_BufferStorage_adr := GetProcAddress('glBufferStorage');
    private z_BufferStorage_ovr_0 := GetProcOrNil&<procedure(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_BufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorage(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_BufferStorage_ovr_0(target, size, data, flags);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glClEventARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_cl_event';
    
    private z_CreateSyncFromCLeventARB_adr := GetProcAddress('glCreateSyncFromCLeventARB');
    private z_CreateSyncFromCLeventARB_ovr_0 := GetProcOrNil&<function(var context: gl_cl_context; var &event: gl_cl_event; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    private z_CreateSyncFromCLeventARB_ovr_0_anh0100 := GetProcOrNil&<function(context: IntPtr; var &event: gl_cl_event; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    private z_CreateSyncFromCLeventARB_ovr_0_anh0010 := GetProcOrNil&<function(var context: gl_cl_context; &event: IntPtr; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    private z_CreateSyncFromCLeventARB_ovr_0_anh0110 := GetProcOrNil&<function(context: IntPtr; &event: IntPtr; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: array of gl_cl_context; &event: array of gl_cl_event; flags: DummyFlags): gl_sync :=
    if (context<>nil) and (context.Length<>0) then
      if (&event<>nil) and (&event.Length<>0) then
        z_CreateSyncFromCLeventARB_ovr_0(context[0], &event[0], flags) else
        z_CreateSyncFromCLeventARB_ovr_0_anh0010(context[0], IntPtr.Zero, flags) else
      if (&event<>nil) and (&event.Length<>0) then
        z_CreateSyncFromCLeventARB_ovr_0_anh0100(IntPtr.Zero, &event[0], flags) else
        z_CreateSyncFromCLeventARB_ovr_0_anh0110(IntPtr.Zero, IntPtr.Zero, flags);
    private z_CreateSyncFromCLeventARB_ovr_1_anh0100 := GetProcOrNil&<function(context: IntPtr; var &event: gl_cl_event; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: array of gl_cl_context; var &event: gl_cl_event; flags: DummyFlags): gl_sync :=
    if (context<>nil) and (context.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_0(context[0], &event, flags) else
      z_CreateSyncFromCLeventARB_ovr_0_anh0100(IntPtr.Zero, &event, flags);
    private z_CreateSyncFromCLeventARB_ovr_2 := GetProcOrNil&<function(var context: gl_cl_context; &event: IntPtr; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    private z_CreateSyncFromCLeventARB_ovr_2_anh0100 := GetProcOrNil&<function(context: IntPtr; &event: IntPtr; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: array of gl_cl_context; &event: IntPtr; flags: DummyFlags): gl_sync :=
    if (context<>nil) and (context.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_2(context[0], &event, flags) else
      z_CreateSyncFromCLeventARB_ovr_2_anh0100(IntPtr.Zero, &event, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(var context: gl_cl_context; &event: array of gl_cl_event; flags: DummyFlags): gl_sync :=
    if (&event<>nil) and (&event.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_0(context, &event[0], flags) else
      z_CreateSyncFromCLeventARB_ovr_0_anh0010(context, IntPtr.Zero, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(var context: gl_cl_context; var &event: gl_cl_event; flags: DummyFlags): gl_sync :=
    z_CreateSyncFromCLeventARB_ovr_0(context, &event, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(var context: gl_cl_context; &event: IntPtr; flags: DummyFlags): gl_sync :=
    z_CreateSyncFromCLeventARB_ovr_2(context, &event, flags);
    private z_CreateSyncFromCLeventARB_ovr_6 := GetProcOrNil&<function(context: IntPtr; var &event: gl_cl_event; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    private z_CreateSyncFromCLeventARB_ovr_6_anh0010 := GetProcOrNil&<function(context: IntPtr; &event: IntPtr; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: IntPtr; &event: array of gl_cl_event; flags: DummyFlags): gl_sync :=
    if (&event<>nil) and (&event.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_6(context, &event[0], flags) else
      z_CreateSyncFromCLeventARB_ovr_6_anh0010(context, IntPtr.Zero, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: IntPtr; var &event: gl_cl_event; flags: DummyFlags): gl_sync :=
    z_CreateSyncFromCLeventARB_ovr_6(context, &event, flags);
    private z_CreateSyncFromCLeventARB_ovr_8 := GetProcOrNil&<function(context: IntPtr; &event: IntPtr; flags: DummyFlags): gl_sync>(z_CreateSyncFromCLeventARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: IntPtr; &event: IntPtr; flags: DummyFlags): gl_sync :=
    z_CreateSyncFromCLeventARB_ovr_8(context, &event, flags);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glClearBufferObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_clear_buffer_object';
    
    private z_ClearBufferData_adr := GetProcAddress('glClearBufferData');
    private z_ClearBufferData_ovr_0 := GetProcOrNil&<procedure(target: BufferStorageTarget; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferData(target: BufferStorageTarget; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferData_ovr_0(target, internalformat, format, &type, data);
    
    private z_ClearBufferSubData_adr := GetProcAddress('glClearBufferSubData');
    private z_ClearBufferSubData_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferSubData(target: BufferTarget; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferSubData_ovr_0(target, internalformat, offset, size, format, &type, data);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glClearTextureARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_clear_texture';
    
    private z_ClearTexImage_adr := GetProcAddress('glClearTexImage');
    private z_ClearTexImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexImage(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexImage_ovr_0(texture, level, format, &type, data);
    
    private z_ClearTexSubImage_adr := GetProcAddress('glClearTexSubImage');
    private z_ClearTexSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearTexSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, data);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glClipControlARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_clip_control';
    
    private z_ClipControl_adr := GetProcAddress('glClipControl');
    private z_ClipControl_ovr_0 := GetProcOrNil&<procedure(origin: ClipControlOrigin; depth: ClipControlDepth)>(z_ClipControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipControl(origin: ClipControlOrigin; depth: ClipControlDepth) :=
    z_ClipControl_ovr_0(origin, depth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glColorBufferFloatARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_color_buffer_float';
    
    private z_ClampColorARB_adr := GetProcAddress('glClampColorARB');
    private z_ClampColorARB_ovr_0 := GetProcOrNil&<procedure(target: ClampColorTargetARB; clamp: ClampColorModeARB)>(z_ClampColorARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClampColorARB(target: ClampColorTargetARB; clamp: ClampColorModeARB) :=
    z_ClampColorARB_ovr_0(target, clamp);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glComputeShaderARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_compute_shader';
    
    private z_DispatchCompute_adr := GetProcAddress('glDispatchCompute');
    private z_DispatchCompute_ovr_0 := GetProcOrNil&<procedure(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32)>(z_DispatchCompute_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchCompute(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32) :=
    z_DispatchCompute_ovr_0(num_groups_x, num_groups_y, num_groups_z);
    
    private z_DispatchComputeIndirect_adr := GetProcAddress('glDispatchComputeIndirect');
    private z_DispatchComputeIndirect_ovr_0 := GetProcOrNil&<procedure(indirect: IntPtr)>(z_DispatchComputeIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchComputeIndirect(indirect: IntPtr) :=
    z_DispatchComputeIndirect_ovr_0(indirect);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glComputeVariableGroupSizeARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_compute_variable_group_size';
    
    private z_DispatchComputeGroupSizeARB_adr := GetProcAddress('glDispatchComputeGroupSizeARB');
    private z_DispatchComputeGroupSizeARB_ovr_0 := GetProcOrNil&<procedure(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32; group_size_x: UInt32; group_size_y: UInt32; group_size_z: UInt32)>(z_DispatchComputeGroupSizeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchComputeGroupSizeARB(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32; group_size_x: UInt32; group_size_y: UInt32; group_size_z: UInt32) :=
    z_DispatchComputeGroupSizeARB_ovr_0(num_groups_x, num_groups_y, num_groups_z, group_size_x, group_size_y, group_size_z);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCopyBufferARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_copy_buffer';
    
    private z_CopyBufferSubData_adr := GetProcAddress('glCopyBufferSubData');
    private z_CopyBufferSubData_ovr_0 := GetProcOrNil&<procedure(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyBufferSubData(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyBufferSubData_ovr_0(readTarget, writeTarget, readOffset, writeOffset, size);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCopyImageARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_copy_image';
    
    private z_CopyImageSubData_adr := GetProcAddress('glCopyImageSubData');
    private z_CopyImageSubData_ovr_0 := GetProcOrNil&<procedure(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32)>(z_CopyImageSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubData(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32) :=
    z_CopyImageSubData_ovr_0(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDebugOutputARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_debug_output';
    
    private z_DebugMessageControlARB_adr := GetProcAddress('glDebugMessageControlARB');
    private z_DebugMessageControlARB_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean)>(z_DebugMessageControlARB_adr);
    private z_DebugMessageControlARB_ovr_0_anh0000010 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControlARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControlARB(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageControlARB_ovr_0(source, &type, severity, count, ids[0], enabled) else
      z_DebugMessageControlARB_ovr_0_anh0000010(source, &type, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControlARB(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageControlARB_ovr_0(source, &type, severity, count, ids, enabled);
    private z_DebugMessageControlARB_ovr_2 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControlARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControlARB(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageControlARB_ovr_2(source, &type, severity, count, ids, enabled);
    
    private z_DebugMessageInsertARB_adr := GetProcAddress('glDebugMessageInsertARB');
    private z_DebugMessageInsertARB_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr)>(z_DebugMessageInsertARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertARB(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: string);
    begin
      var par_6_str_ptr: IntPtr;
      try
        par_6_str_ptr := Marshal.StringToHGlobalAnsi(buf);
        z_DebugMessageInsertARB_ovr_0(source, &type, id, severity, length, par_6_str_ptr);
      finally
        Marshal.FreeHGlobal(par_6_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertARB(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsertARB_ovr_0(source, &type, id, severity, length, buf);
    
    private z_DebugMessageCallbackARB_adr := GetProcAddress('glDebugMessageCallbackARB');
    private z_DebugMessageCallbackARB_ovr_0 := GetProcOrNil&<procedure(callback: GL_DEBUG_PROC; userParam: IntPtr)>(z_DebugMessageCallbackARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallbackARB(callback: GL_DEBUG_PROC; userParam: IntPtr) :=
    z_DebugMessageCallbackARB_ovr_0(callback, userParam);
    
    private z_GetDebugMessageLogARB_adr := GetProcAddress('glGetDebugMessageLogARB');
    private z_GetDebugMessageLogARB_ovr_0 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32>(z_GetDebugMessageLogARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogARB(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLogARB_ovr_0(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    private z_GetDebugMessageLogARB_ovr_1 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32>(z_GetDebugMessageLogARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogARB(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLogARB_ovr_1(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDirectStateAccessARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_direct_state_access';
    
    private z_CreateTransformFeedbacks_adr := GetProcAddress('glCreateTransformFeedbacks');
    private z_CreateTransformFeedbacks_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_CreateTransformFeedbacks_adr);
    private z_CreateTransformFeedbacks_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_CreateTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateTransformFeedbacks_ovr_0(n, ids[0]) else
      z_CreateTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; var ids: gl_transform_feedback) :=
    z_CreateTransformFeedbacks_ovr_0(n, ids);
    private z_CreateTransformFeedbacks_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_CreateTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_CreateTransformFeedbacks_ovr_2(n, ids);
    
    private z_TransformFeedbackBufferBase_adr := GetProcAddress('glTransformFeedbackBufferBase');
    private z_TransformFeedbackBufferBase_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer)>(z_TransformFeedbackBufferBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferBase(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer) :=
    z_TransformFeedbackBufferBase_ovr_0(xfb, index, buffer);
    
    private z_TransformFeedbackBufferRange_adr := GetProcAddress('glTransformFeedbackBufferRange');
    private z_TransformFeedbackBufferRange_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TransformFeedbackBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferRange(xfb: gl_transform_feedback; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TransformFeedbackBufferRange_ovr_0(xfb, index, buffer, offset, size);
    
    private z_GetTransformFeedbackiv_adr := GetProcAddress('glGetTransformFeedbackiv');
    private z_GetTransformFeedbackiv_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; var param: Int32)>(z_GetTransformFeedbackiv_adr);
    private z_GetTransformFeedbackiv_ovr_0_anh0001 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: IntPtr)>(z_GetTransformFeedbackiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbackiv_ovr_0(xfb, pname, param[0]) else
      z_GetTransformFeedbackiv_ovr_0_anh0001(xfb, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: gl_transform_feedback; pname: TransformFeedbackPName; var param: Int32) :=
    z_GetTransformFeedbackiv_ovr_0(xfb, pname, param);
    private z_GetTransformFeedbackiv_ovr_2 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: IntPtr)>(z_GetTransformFeedbackiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: gl_transform_feedback; pname: TransformFeedbackPName; param: IntPtr) :=
    z_GetTransformFeedbackiv_ovr_2(xfb, pname, param);
    
    private z_GetTransformFeedbacki_v_adr := GetProcAddress('glGetTransformFeedbacki_v');
    private z_GetTransformFeedbacki_v_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int32)>(z_GetTransformFeedbacki_v_adr);
    private z_GetTransformFeedbacki_v_ovr_0_anh00001 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int32) :=
    z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param);
    private z_GetTransformFeedbacki_v_ovr_2 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki_v_ovr_2(xfb, pname, index, param);
    
    private z_GetTransformFeedbacki64_v_adr := GetProcAddress('glGetTransformFeedbacki64_v');
    private z_GetTransformFeedbacki64_v_ovr_0 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int64)>(z_GetTransformFeedbacki64_v_adr);
    private z_GetTransformFeedbacki64_v_ovr_0_anh00001 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki64_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki64_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; var param: Int64) :=
    z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param);
    private z_GetTransformFeedbacki64_v_ovr_2 := GetProcOrNil&<procedure(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki64_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: gl_transform_feedback; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki64_v_ovr_2(xfb, pname, index, param);
    
    private z_CreateBuffers_adr := GetProcAddress('glCreateBuffers');
    private z_CreateBuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var buffers: gl_buffer)>(z_CreateBuffers_adr);
    private z_CreateBuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_CreateBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_CreateBuffers_ovr_0(n, buffers[0]) else
      z_CreateBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; var buffers: gl_buffer) :=
    z_CreateBuffers_ovr_0(n, buffers);
    private z_CreateBuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_CreateBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: IntPtr) :=
    z_CreateBuffers_ovr_2(n, buffers);
    
    private z_NamedBufferStorage_adr := GetProcAddress('glNamedBufferStorage');
    private z_NamedBufferStorage_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_NamedBufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorage(buffer: gl_buffer; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_NamedBufferStorage_ovr_0(buffer, size, data, flags);
    
    private z_NamedBufferData_adr := GetProcAddress('glNamedBufferData');
    private z_NamedBufferData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; var data: Byte; usage: VertexBufferObjectUsage)>(z_NamedBufferData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferData_ovr_0<T>(buffer: gl_buffer; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferData_ovr_0_anh00010(buffer: gl_buffer; size: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_0(buffer, size, PByte(nil)^, usage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: gl_buffer; size: IntPtr; data: array of T; usage: VertexBufferObjectUsage); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_NamedBufferData_ovr_0(buffer, size, data[0], usage) else
        temp_NamedBufferData_ovr_0_anh00010(buffer, size, usage);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: gl_buffer; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private z_NamedBufferData_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage)>(z_NamedBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData(buffer: gl_buffer; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_2(buffer, size, data, usage);
    
    private z_NamedBufferSubData_adr := GetProcAddress('glNamedBufferSubData');
    private z_NamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: Byte)>(z_NamedBufferSubData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferSubData_ovr_0<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_NamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferSubData_ovr_0_anh00001(buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_NamedBufferSubData_ovr_0(buffer, offset, size, PByte(nil)^);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: array of T); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_NamedBufferSubData_ovr_0(buffer, offset, size, data[0]) else
        temp_NamedBufferSubData_ovr_0_anh00001(buffer, offset, size);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_NamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private z_NamedBufferSubData_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_NamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_NamedBufferSubData_ovr_2(buffer, offset, size, data);
    
    private z_CopyNamedBufferSubData_adr := GetProcAddress('glCopyNamedBufferSubData');
    private z_CopyNamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyNamedBufferSubData(readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyNamedBufferSubData_ovr_0(readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    private z_ClearNamedBufferData_adr := GetProcAddress('glClearNamedBufferData');
    private z_ClearNamedBufferData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferData(buffer: gl_buffer; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferData_ovr_0(buffer, internalformat, format, &type, data);
    
    private z_ClearNamedBufferSubData_adr := GetProcAddress('glClearNamedBufferSubData');
    private z_ClearNamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferSubData(buffer: gl_buffer; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferSubData_ovr_0(buffer, internalformat, offset, size, format, &type, data);
    
    private z_MapNamedBuffer_adr := GetProcAddress('glMapNamedBuffer');
    private z_MapNamedBuffer_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer; access: BufferAccessARB): IntPtr>(z_MapNamedBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBuffer(buffer: gl_buffer; access: BufferAccessARB): IntPtr :=
    z_MapNamedBuffer_ovr_0(buffer, access);
    
    private z_MapNamedBufferRange_adr := GetProcAddress('glMapNamedBufferRange');
    private z_MapNamedBufferRange_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapNamedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferRange(buffer: gl_buffer; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapNamedBufferRange_ovr_0(buffer, offset, length, access);
    
    private z_UnmapNamedBuffer_adr := GetProcAddress('glUnmapNamedBuffer');
    private z_UnmapNamedBuffer_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_UnmapNamedBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapNamedBuffer(buffer: gl_buffer): boolean :=
    z_UnmapNamedBuffer_ovr_0(buffer);
    
    private z_FlushMappedNamedBufferRange_adr := GetProcAddress('glFlushMappedNamedBufferRange');
    private z_FlushMappedNamedBufferRange_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; length: IntPtr)>(z_FlushMappedNamedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedNamedBufferRange(buffer: gl_buffer; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedNamedBufferRange_ovr_0(buffer, offset, length);
    
    private z_GetNamedBufferParameteriv_adr := GetProcAddress('glGetNamedBufferParameteriv');
    private z_GetNamedBufferParameteriv_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int32)>(z_GetNamedBufferParameteriv_adr);
    private z_GetNamedBufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: gl_buffer; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteriv_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int32) :=
    z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameteriv_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetNamedBufferParameteriv_ovr_2(buffer, pname, &params);
    
    private z_GetNamedBufferParameteri64v_adr := GetProcAddress('glGetNamedBufferParameteri64v');
    private z_GetNamedBufferParameteri64v_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int64)>(z_GetNamedBufferParameteri64v_adr);
    private z_GetNamedBufferParameteri64v_ovr_0_anh0001 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: gl_buffer; pname: BufferPNameARB; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteri64v_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int64) :=
    z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameteri64v_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetNamedBufferParameteri64v_ovr_2(buffer, pname, &params);
    
    private z_GetNamedBufferPointerv_adr := GetProcAddress('glGetNamedBufferPointerv');
    private z_GetNamedBufferPointerv_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPointerNameARB; var &params: IntPtr)>(z_GetNamedBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: gl_buffer; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetNamedBufferPointerv_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferPointerv_ovr_1 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPointerNameARB; &params: pointer)>(z_GetNamedBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: gl_buffer; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetNamedBufferPointerv_ovr_1(buffer, pname, &params);
    
    private z_GetNamedBufferSubData_adr := GetProcAddress('glGetNamedBufferSubData');
    private z_GetNamedBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: Byte)>(z_GetNamedBufferSubData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_GetNamedBufferSubData_ovr_0<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_GetNamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_GetNamedBufferSubData_ovr_0_anh00001(buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_GetNamedBufferSubData_ovr_0(buffer, offset, size, PByte(nil)^);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: array of T); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_GetNamedBufferSubData_ovr_0(buffer, offset, size, data[0]) else
        temp_GetNamedBufferSubData_ovr_0_anh00001(buffer, offset, size);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData<T>(buffer: gl_buffer; offset: IntPtr; size: IntPtr; var data: T); where T: record;
    begin
      z_GetNamedBufferSubData_ovr_0(buffer, offset, size, PByte(pointer(@data))^);
    end;
    private z_GetNamedBufferSubData_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetNamedBufferSubData_ovr_2(buffer, offset, size, data);
    
    private z_CreateFramebuffers_adr := GetProcAddress('glCreateFramebuffers');
    private z_CreateFramebuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_CreateFramebuffers_adr);
    private z_CreateFramebuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_CreateFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_CreateFramebuffers_ovr_0(n, framebuffers[0]) else
      z_CreateFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; var framebuffers: gl_framebuffer) :=
    z_CreateFramebuffers_ovr_0(n, framebuffers);
    private z_CreateFramebuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_CreateFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_CreateFramebuffers_ovr_2(n, framebuffers);
    
    private z_NamedFramebufferRenderbuffer_adr := GetProcAddress('glNamedFramebufferRenderbuffer');
    private z_NamedFramebufferRenderbuffer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_NamedFramebufferRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferRenderbuffer(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_NamedFramebufferRenderbuffer_ovr_0(framebuffer, attachment, _renderbuffertarget, renderbuffer);
    
    private z_NamedFramebufferParameteri_adr := GetProcAddress('glNamedFramebufferParameteri');
    private z_NamedFramebufferParameteri_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: FramebufferParameterName; param: Int32)>(z_NamedFramebufferParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferParameteri(framebuffer: gl_framebuffer; pname: FramebufferParameterName; param: Int32) :=
    z_NamedFramebufferParameteri_ovr_0(framebuffer, pname, param);
    
    private z_NamedFramebufferTexture_adr := GetProcAddress('glNamedFramebufferTexture');
    private z_NamedFramebufferTexture_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32)>(z_NamedFramebufferTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32) :=
    z_NamedFramebufferTexture_ovr_0(framebuffer, attachment, texture, level);
    
    private z_NamedFramebufferTextureLayer_adr := GetProcAddress('glNamedFramebufferTextureLayer');
    private z_NamedFramebufferTextureLayer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_NamedFramebufferTextureLayer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureLayer(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_NamedFramebufferTextureLayer_ovr_0(framebuffer, attachment, texture, level, layer);
    
    private z_NamedFramebufferDrawBuffer_adr := GetProcAddress('glNamedFramebufferDrawBuffer');
    private z_NamedFramebufferDrawBuffer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; buf: ColorBuffer)>(z_NamedFramebufferDrawBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffer(framebuffer: gl_framebuffer; buf: ColorBuffer) :=
    z_NamedFramebufferDrawBuffer_ovr_0(framebuffer, buf);
    
    private z_NamedFramebufferDrawBuffers_adr := GetProcAddress('glNamedFramebufferDrawBuffers');
    private z_NamedFramebufferDrawBuffers_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; var bufs: ColorBuffer)>(z_NamedFramebufferDrawBuffers_adr);
    private z_NamedFramebufferDrawBuffers_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr)>(z_NamedFramebufferDrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: gl_framebuffer; n: Int32; bufs: array of ColorBuffer) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs[0]) else
      z_NamedFramebufferDrawBuffers_ovr_0_anh0001(framebuffer, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: gl_framebuffer; n: Int32; var bufs: ColorBuffer) :=
    z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs);
    private z_NamedFramebufferDrawBuffers_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr)>(z_NamedFramebufferDrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr) :=
    z_NamedFramebufferDrawBuffers_ovr_2(framebuffer, n, bufs);
    
    private z_NamedFramebufferReadBuffer_adr := GetProcAddress('glNamedFramebufferReadBuffer');
    private z_NamedFramebufferReadBuffer_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; src: ColorBuffer)>(z_NamedFramebufferReadBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferReadBuffer(framebuffer: gl_framebuffer; src: ColorBuffer) :=
    z_NamedFramebufferReadBuffer_ovr_0(framebuffer, src);
    
    private z_InvalidateNamedFramebufferData_adr := GetProcAddress('glInvalidateNamedFramebufferData');
    private z_InvalidateNamedFramebufferData_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment)>(z_InvalidateNamedFramebufferData_adr);
    private z_InvalidateNamedFramebufferData_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateNamedFramebufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: array of FramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments[0]) else
      z_InvalidateNamedFramebufferData_ovr_0_anh0001(framebuffer, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment) :=
    z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments);
    private z_InvalidateNamedFramebufferData_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateNamedFramebufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateNamedFramebufferData_ovr_2(framebuffer, numAttachments, attachments);
    
    private z_InvalidateNamedFramebufferSubData_adr := GetProcAddress('glInvalidateNamedFramebufferSubData');
    private z_InvalidateNamedFramebufferSubData_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    private z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: array of FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000(framebuffer, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: gl_framebuffer; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments, x, y, width, height);
    private z_InvalidateNamedFramebufferSubData_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: gl_framebuffer; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_2(framebuffer, numAttachments, attachments, x, y, width, height);
    
    private z_ClearNamedFramebufferiv_adr := GetProcAddress('glClearNamedFramebufferiv');
    private z_ClearNamedFramebufferiv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: Int32)>(z_ClearNamedFramebufferiv_adr);
    private z_ClearNamedFramebufferiv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: Int32) :=
    z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferiv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    private z_ClearNamedFramebufferuiv_adr := GetProcAddress('glClearNamedFramebufferuiv');
    private z_ClearNamedFramebufferuiv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: UInt32)>(z_ClearNamedFramebufferuiv_adr);
    private z_ClearNamedFramebufferuiv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferuiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: UInt32) :=
    z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferuiv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferuiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    private z_ClearNamedFramebufferfv_adr := GetProcAddress('glClearNamedFramebufferfv');
    private z_ClearNamedFramebufferfv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: single)>(z_ClearNamedFramebufferfv_adr);
    private z_ClearNamedFramebufferfv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferfv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; var value: single) :=
    z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferfv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferfv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    private z_ClearNamedFramebufferfi_adr := GetProcAddress('glClearNamedFramebufferfi');
    private z_ClearNamedFramebufferfi_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32)>(z_ClearNamedFramebufferfi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfi(framebuffer: gl_framebuffer; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32) :=
    z_ClearNamedFramebufferfi_ovr_0(framebuffer, _buffer, drawbuffer, depth, stencil);
    
    private z_BlitNamedFramebuffer_adr := GetProcAddress('glBlitNamedFramebuffer');
    private z_BlitNamedFramebuffer_ovr_0 := GetProcOrNil&<procedure(readFramebuffer: gl_framebuffer; drawFramebuffer: gl_framebuffer; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitNamedFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitNamedFramebuffer(readFramebuffer: gl_framebuffer; drawFramebuffer: gl_framebuffer; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitNamedFramebuffer_ovr_0(readFramebuffer, drawFramebuffer, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    private z_CheckNamedFramebufferStatus_adr := GetProcAddress('glCheckNamedFramebufferStatus');
    private z_CheckNamedFramebufferStatus_ovr_0 := GetProcOrNil&<function(framebuffer: gl_framebuffer; target: FramebufferTarget): FramebufferStatus>(z_CheckNamedFramebufferStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckNamedFramebufferStatus(framebuffer: gl_framebuffer; target: FramebufferTarget): FramebufferStatus :=
    z_CheckNamedFramebufferStatus_ovr_0(framebuffer, target);
    
    private z_GetNamedFramebufferParameteriv_adr := GetProcAddress('glGetNamedFramebufferParameteriv');
    private z_GetNamedFramebufferParameteriv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var param: Int32)>(z_GetNamedFramebufferParameteriv_adr);
    private z_GetNamedFramebufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: IntPtr)>(z_GetNamedFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param[0]) else
      z_GetNamedFramebufferParameteriv_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var param: Int32) :=
    z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param);
    private z_GetNamedFramebufferParameteriv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: IntPtr)>(z_GetNamedFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; param: IntPtr) :=
    z_GetNamedFramebufferParameteriv_ovr_2(framebuffer, pname, param);
    
    private z_GetNamedFramebufferAttachmentParameteriv_adr := GetProcAddress('glGetNamedFramebufferAttachmentParameteriv');
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params[0]) else
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001(framebuffer, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params);
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_2(framebuffer, attachment, pname, &params);
    
    private z_CreateRenderbuffers_adr := GetProcAddress('glCreateRenderbuffers');
    private z_CreateRenderbuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_CreateRenderbuffers_adr);
    private z_CreateRenderbuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_CreateRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_CreateRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_CreateRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_CreateRenderbuffers_ovr_0(n, renderbuffers);
    private z_CreateRenderbuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_CreateRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_CreateRenderbuffers_ovr_2(n, renderbuffers);
    
    private z_NamedRenderbufferStorage_adr := GetProcAddress('glNamedRenderbufferStorage');
    private z_NamedRenderbufferStorage_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorage(renderbuffer: gl_renderbuffer; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorage_ovr_0(renderbuffer, _internalformat, width, height);
    
    private z_NamedRenderbufferStorageMultisample_adr := GetProcAddress('glNamedRenderbufferStorageMultisample');
    private z_NamedRenderbufferStorageMultisample_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisample(renderbuffer: gl_renderbuffer; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisample_ovr_0(renderbuffer, samples, _internalformat, width, height);
    
    private z_GetNamedRenderbufferParameteriv_adr := GetProcAddress('glGetNamedRenderbufferParameteriv');
    private z_GetNamedRenderbufferParameteriv_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; var &params: Int32)>(z_GetNamedRenderbufferParameteriv_adr);
    private z_GetNamedRenderbufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params[0]) else
      z_GetNamedRenderbufferParameteriv_ovr_0_anh0001(renderbuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params);
    private z_GetNamedRenderbufferParameteriv_ovr_2 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetNamedRenderbufferParameteriv_ovr_2(renderbuffer, pname, &params);
    
    private z_CreateTextures_adr := GetProcAddress('glCreateTextures');
    private z_CreateTextures_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; var textures: gl_texture)>(z_CreateTextures_adr);
    private z_CreateTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; textures: IntPtr)>(z_CreateTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_CreateTextures_ovr_0(target, n, textures[0]) else
      z_CreateTextures_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; var textures: gl_texture) :=
    z_CreateTextures_ovr_0(target, n, textures);
    private z_CreateTextures_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; textures: IntPtr)>(z_CreateTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: IntPtr) :=
    z_CreateTextures_ovr_2(target, n, textures);
    
    private z_TextureBuffer_adr := GetProcAddress('glTextureBuffer');
    private z_TextureBuffer_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer)>(z_TextureBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBuffer(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer) :=
    z_TextureBuffer_ovr_0(texture, internalformat, buffer);
    
    private z_TextureBufferRange_adr := GetProcAddress('glTextureBufferRange');
    private z_TextureBufferRange_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TextureBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferRange(texture: gl_texture; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TextureBufferRange_ovr_0(texture, internalformat, buffer, offset, size);
    
    private z_TextureStorage1D_adr := GetProcAddress('glTextureStorage1D');
    private z_TextureStorage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TextureStorage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1D(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TextureStorage1D_ovr_0(texture, levels, internalformat, width);
    
    private z_TextureStorage2D_adr := GetProcAddress('glTextureStorage2D');
    private z_TextureStorage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TextureStorage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2D(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2D_ovr_0(texture, levels, internalformat, width, height);
    
    private z_TextureStorage3D_adr := GetProcAddress('glTextureStorage3D');
    private z_TextureStorage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TextureStorage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3D(texture: gl_texture; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3D_ovr_0(texture, levels, internalformat, width, height, depth);
    
    private z_TextureStorage2DMultisample_adr := GetProcAddress('glTextureStorage2DMultisample');
    private z_TextureStorage2DMultisample_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TextureStorage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DMultisample(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage2DMultisample_ovr_0(texture, samples, internalformat, width, height, fixedsamplelocations);
    
    private z_TextureStorage3DMultisample_adr := GetProcAddress('glTextureStorage3DMultisample');
    private z_TextureStorage3DMultisample_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TextureStorage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DMultisample(texture: gl_texture; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage3DMultisample_ovr_0(texture, samples, internalformat, width, height, depth, fixedsamplelocations);
    
    private z_TextureSubImage1D_adr := GetProcAddress('glTextureSubImage1D');
    private z_TextureSubImage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage1D(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage1D_ovr_0(texture, level, xoffset, width, format, &type, pixels);
    
    private z_TextureSubImage2D_adr := GetProcAddress('glTextureSubImage2D');
    private z_TextureSubImage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage2D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    private z_TextureSubImage3D_adr := GetProcAddress('glTextureSubImage3D');
    private z_TextureSubImage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage3D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    private z_CompressedTextureSubImage1D_adr := GetProcAddress('glCompressedTextureSubImage1D');
    private z_CompressedTextureSubImage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage1D(texture: gl_texture; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage1D_ovr_0(texture, level, xoffset, width, format, imageSize, data);
    
    private z_CompressedTextureSubImage2D_adr := GetProcAddress('glCompressedTextureSubImage2D');
    private z_CompressedTextureSubImage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage2D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    private z_CompressedTextureSubImage3D_adr := GetProcAddress('glCompressedTextureSubImage3D');
    private z_CompressedTextureSubImage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage3D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    private z_CopyTextureSubImage1D_adr := GetProcAddress('glCopyTextureSubImage1D');
    private z_CopyTextureSubImage1D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyTextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage1D(texture: gl_texture; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTextureSubImage1D_ovr_0(texture, level, xoffset, x, y, width);
    
    private z_CopyTextureSubImage2D_adr := GetProcAddress('glCopyTextureSubImage2D');
    private z_CopyTextureSubImage2D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage2D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, x, y, width, height);
    
    private z_CopyTextureSubImage3D_adr := GetProcAddress('glCopyTextureSubImage3D');
    private z_CopyTextureSubImage3D_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage3D(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    private z_TextureParameterf_adr := GetProcAddress('glTextureParameterf');
    private z_TextureParameterf_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: single)>(z_TextureParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterf(texture: gl_texture; pname: TextureParameterName; param: single) :=
    z_TextureParameterf_ovr_0(texture, pname, param);
    
    private z_TextureParameterfv_adr := GetProcAddress('glTextureParameterfv');
    private z_TextureParameterfv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var param: single)>(z_TextureParameterfv_adr);
    private z_TextureParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: gl_texture; pname: TextureParameterName; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameterfv_ovr_0(texture, pname, param[0]) else
      z_TextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: gl_texture; pname: TextureParameterName; var param: single) :=
    z_TextureParameterfv_ovr_0(texture, pname, param);
    private z_TextureParameterfv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: gl_texture; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameterfv_ovr_2(texture, pname, param);
    
    private z_TextureParameteri_adr := GetProcAddress('glTextureParameteri');
    private z_TextureParameteri_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: Int32)>(z_TextureParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteri(texture: gl_texture; pname: TextureParameterName; param: Int32) :=
    z_TextureParameteri_ovr_0(texture, pname, param);
    
    private z_TextureParameterIiv_adr := GetProcAddress('glTextureParameterIiv');
    private z_TextureParameterIiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var &params: Int32)>(z_TextureParameterIiv_adr);
    private z_TextureParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: gl_texture; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: gl_texture; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterIiv_ovr_0(texture, pname, &params);
    private z_TextureParameterIiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: gl_texture; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIiv_ovr_2(texture, pname, &params);
    
    private z_TextureParameterIuiv_adr := GetProcAddress('glTextureParameterIuiv');
    private z_TextureParameterIuiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var &params: UInt32)>(z_TextureParameterIuiv_adr);
    private z_TextureParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: gl_texture; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: gl_texture; pname: TextureParameterName; var &params: UInt32) :=
    z_TextureParameterIuiv_ovr_0(texture, pname, &params);
    private z_TextureParameterIuiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: gl_texture; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIuiv_ovr_2(texture, pname, &params);
    
    private z_TextureParameteriv_adr := GetProcAddress('glTextureParameteriv');
    private z_TextureParameteriv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; var param: Int32)>(z_TextureParameteriv_adr);
    private z_TextureParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: gl_texture; pname: TextureParameterName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameteriv_ovr_0(texture, pname, param[0]) else
      z_TextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: gl_texture; pname: TextureParameterName; var param: Int32) :=
    z_TextureParameteriv_ovr_0(texture, pname, param);
    private z_TextureParameteriv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: TextureParameterName; param: IntPtr)>(z_TextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: gl_texture; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameteriv_ovr_2(texture, pname, param);
    
    private z_GenerateTextureMipmap_adr := GetProcAddress('glGenerateTextureMipmap');
    private z_GenerateTextureMipmap_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture)>(z_GenerateTextureMipmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateTextureMipmap(texture: gl_texture) :=
    z_GenerateTextureMipmap_ovr_0(texture);
    
    private z_BindTextureUnit_adr := GetProcAddress('glBindTextureUnit');
    private z_BindTextureUnit_ovr_0 := GetProcOrNil&<procedure(&unit: UInt32; texture: gl_texture)>(z_BindTextureUnit_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextureUnit(&unit: UInt32; texture: gl_texture) :=
    z_BindTextureUnit_ovr_0(&unit, texture);
    
    private z_GetTextureImage_adr := GetProcAddress('glGetTextureImage');
    private z_GetTextureImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetTextureImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureImage(texture: gl_texture; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureImage_ovr_0(texture, level, format, &type, bufSize, pixels);
    
    private z_GetCompressedTextureImage_adr := GetProcAddress('glGetCompressedTextureImage');
    private z_GetCompressedTextureImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetCompressedTextureImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureImage(texture: gl_texture; level: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureImage_ovr_0(texture, level, bufSize, pixels);
    
    private z_GetTextureLevelParameterfv_adr := GetProcAddress('glGetTextureLevelParameterfv');
    private z_GetTextureLevelParameterfv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: single)>(z_GetTextureLevelParameterfv_adr);
    private z_GetTextureLevelParameterfv_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameterfv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params);
    private z_GetTextureLevelParameterfv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterfv_ovr_2(texture, level, pname, &params);
    
    private z_GetTextureLevelParameteriv_adr := GetProcAddress('glGetTextureLevelParameteriv');
    private z_GetTextureLevelParameteriv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureLevelParameteriv_adr);
    private z_GetTextureLevelParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameteriv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: gl_texture; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params);
    private z_GetTextureLevelParameteriv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: gl_texture; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameteriv_ovr_2(texture, level, pname, &params);
    
    private z_GetTextureParameterfv_adr := GetProcAddress('glGetTextureParameterfv');
    private z_GetTextureParameterfv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: single)>(z_GetTextureParameterfv_adr);
    private z_GetTextureParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: gl_texture; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterfv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: gl_texture; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureParameterfv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterfv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterfv_ovr_2(texture, pname, &params);
    
    private z_GetTextureParameterIiv_adr := GetProcAddress('glGetTextureParameterIiv');
    private z_GetTextureParameterIiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameterIiv_adr);
    private z_GetTextureParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: gl_texture; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: gl_texture; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterIiv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterIiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIiv_ovr_2(texture, pname, &params);
    
    private z_GetTextureParameterIuiv_adr := GetProcAddress('glGetTextureParameterIuiv');
    private z_GetTextureParameterIuiv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: UInt32)>(z_GetTextureParameterIuiv_adr);
    private z_GetTextureParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: gl_texture; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: gl_texture; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTextureParameterIuiv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterIuiv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIuiv_ovr_2(texture, pname, &params);
    
    private z_GetTextureParameteriv_adr := GetProcAddress('glGetTextureParameteriv');
    private z_GetTextureParameteriv_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameteriv_adr);
    private z_GetTextureParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: gl_texture; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameteriv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: gl_texture; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameteriv_ovr_0(texture, pname, &params);
    private z_GetTextureParameteriv_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: gl_texture; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameteriv_ovr_2(texture, pname, &params);
    
    private z_CreateVertexArrays_adr := GetProcAddress('glCreateVertexArrays');
    private z_CreateVertexArrays_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_CreateVertexArrays_adr);
    private z_CreateVertexArrays_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_CreateVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_CreateVertexArrays_ovr_0(n, arrays[0]) else
      z_CreateVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; var arrays: gl_vertex_array) :=
    z_CreateVertexArrays_ovr_0(n, arrays);
    private z_CreateVertexArrays_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_CreateVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: IntPtr) :=
    z_CreateVertexArrays_ovr_2(n, arrays);
    
    private z_DisableVertexArrayAttrib_adr := GetProcAddress('glDisableVertexArrayAttrib');
    private z_DisableVertexArrayAttrib_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32)>(z_DisableVertexArrayAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayAttrib(vaobj: gl_vertex_array; index: UInt32) :=
    z_DisableVertexArrayAttrib_ovr_0(vaobj, index);
    
    private z_EnableVertexArrayAttrib_adr := GetProcAddress('glEnableVertexArrayAttrib');
    private z_EnableVertexArrayAttrib_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32)>(z_EnableVertexArrayAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayAttrib(vaobj: gl_vertex_array; index: UInt32) :=
    z_EnableVertexArrayAttrib_ovr_0(vaobj, index);
    
    private z_VertexArrayElementBuffer_adr := GetProcAddress('glVertexArrayElementBuffer');
    private z_VertexArrayElementBuffer_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer)>(z_VertexArrayElementBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayElementBuffer(vaobj: gl_vertex_array; buffer: gl_buffer) :=
    z_VertexArrayElementBuffer_ovr_0(vaobj, buffer);
    
    private z_VertexArrayVertexBuffer_adr := GetProcAddress('glVertexArrayVertexBuffer');
    private z_VertexArrayVertexBuffer_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32)>(z_VertexArrayVertexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffer(vaobj: gl_vertex_array; bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32) :=
    z_VertexArrayVertexBuffer_ovr_0(vaobj, bindingindex, buffer, offset, stride);
    
    private z_VertexArrayVertexBuffers_adr := GetProcAddress('glVertexArrayVertexBuffers');
    private z_VertexArrayVertexBuffers_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000110 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000101 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000011 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000111 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000111(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000110 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000110 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_3_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_3_anh0000101 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_4_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_5_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_6 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000101 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_7_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_8 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_8_anh0000100 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_8_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_9_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_9_anh0000011 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_10_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_11_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_18 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000011 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_19_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_20 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_20_anh0000010 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_20_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_24 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_24_anh0000001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_24_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_26 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: gl_vertex_array; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_26(vaobj, first, count, buffers, offsets, strides);
    
    private z_VertexArrayAttribBinding_adr := GetProcAddress('glVertexArrayAttribBinding');
    private z_VertexArrayAttribBinding_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; bindingindex: UInt32)>(z_VertexArrayAttribBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribBinding(vaobj: gl_vertex_array; attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexArrayAttribBinding_ovr_0(vaobj, attribindex, bindingindex);
    
    private z_VertexArrayAttribFormat_adr := GetProcAddress('glVertexArrayAttribFormat');
    private z_VertexArrayAttribFormat_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexArrayAttribFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribFormat(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexArrayAttribFormat_ovr_0(vaobj, attribindex, size, &type, normalized, relativeoffset);
    
    private z_VertexArrayAttribIFormat_adr := GetProcAddress('glVertexArrayAttribIFormat');
    private z_VertexArrayAttribIFormat_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexArrayAttribIFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribIFormat(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexArrayAttribIFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private z_VertexArrayAttribLFormat_adr := GetProcAddress('glVertexArrayAttribLFormat');
    private z_VertexArrayAttribLFormat_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexArrayAttribLFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribLFormat(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexArrayAttribLFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private z_VertexArrayBindingDivisor_adr := GetProcAddress('glVertexArrayBindingDivisor');
    private z_VertexArrayBindingDivisor_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; bindingindex: UInt32; divisor: UInt32)>(z_VertexArrayBindingDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayBindingDivisor(vaobj: gl_vertex_array; bindingindex: UInt32; divisor: UInt32) :=
    z_VertexArrayBindingDivisor_ovr_0(vaobj, bindingindex, divisor);
    
    private z_GetVertexArrayiv_adr := GetProcAddress('glGetVertexArrayiv');
    private z_GetVertexArrayiv_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayiv_adr);
    private z_GetVertexArrayiv_ovr_0_anh0001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: gl_vertex_array; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayiv_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayiv_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayiv_ovr_0(vaobj, pname, param);
    private z_GetVertexArrayiv_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayiv_ovr_2(vaobj, pname, param);
    
    private z_GetVertexArrayIndexediv_adr := GetProcAddress('glGetVertexArrayIndexediv');
    private z_GetVertexArrayIndexediv_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayIndexediv_adr);
    private z_GetVertexArrayIndexediv_ovr_0_anh00001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexediv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIndexediv_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexediv_ovr_2(vaobj, index, pname, param);
    
    private z_GetVertexArrayIndexed64iv_adr := GetProcAddress('glGetVertexArrayIndexed64iv');
    private z_GetVertexArrayIndexed64iv_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int64)>(z_GetVertexArrayIndexed64iv_adr);
    private z_GetVertexArrayIndexed64iv_ovr_0_anh00001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexed64iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexed64iv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int64) :=
    z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIndexed64iv_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexed64iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexed64iv_ovr_2(vaobj, index, pname, param);
    
    private z_CreateSamplers_adr := GetProcAddress('glCreateSamplers');
    private z_CreateSamplers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var samplers: gl_sampler)>(z_CreateSamplers_adr);
    private z_CreateSamplers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; samplers: IntPtr)>(z_CreateSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_CreateSamplers_ovr_0(n, samplers[0]) else
      z_CreateSamplers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; var samplers: gl_sampler) :=
    z_CreateSamplers_ovr_0(n, samplers);
    private z_CreateSamplers_ovr_2 := GetProcOrNil&<procedure(n: Int32; samplers: IntPtr)>(z_CreateSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: IntPtr) :=
    z_CreateSamplers_ovr_2(n, samplers);
    
    private z_CreateProgramPipelines_adr := GetProcAddress('glCreateProgramPipelines');
    private z_CreateProgramPipelines_ovr_0 := GetProcOrNil&<procedure(n: Int32; var pipelines: gl_program_pipeline)>(z_CreateProgramPipelines_adr);
    private z_CreateProgramPipelines_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_CreateProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: array of gl_program_pipeline) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_CreateProgramPipelines_ovr_0(n, pipelines[0]) else
      z_CreateProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; var pipelines: gl_program_pipeline) :=
    z_CreateProgramPipelines_ovr_0(n, pipelines);
    private z_CreateProgramPipelines_ovr_2 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_CreateProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_CreateProgramPipelines_ovr_2(n, pipelines);
    
    private z_CreateQueries_adr := GetProcAddress('glCreateQueries');
    private z_CreateQueries_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; n: Int32; var ids: gl_query)>(z_CreateQueries_adr);
    private z_CreateQueries_ovr_0_anh0001 := GetProcOrNil&<procedure(target: QueryTarget; n: Int32; ids: IntPtr)>(z_CreateQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: array of gl_query) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateQueries_ovr_0(target, n, ids[0]) else
      z_CreateQueries_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; var ids: gl_query) :=
    z_CreateQueries_ovr_0(target, n, ids);
    private z_CreateQueries_ovr_2 := GetProcOrNil&<procedure(target: QueryTarget; n: Int32; ids: IntPtr)>(z_CreateQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: IntPtr) :=
    z_CreateQueries_ovr_2(target, n, ids);
    
    private z_GetQueryBufferObjecti64v_adr := GetProcAddress('glGetQueryBufferObjecti64v');
    private z_GetQueryBufferObjecti64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjecti64v(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjecti64v_ovr_0(id, buffer, pname, offset);
    
    private z_GetQueryBufferObjectiv_adr := GetProcAddress('glGetQueryBufferObjectiv');
    private z_GetQueryBufferObjectiv_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectiv(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectiv_ovr_0(id, buffer, pname, offset);
    
    private z_GetQueryBufferObjectui64v_adr := GetProcAddress('glGetQueryBufferObjectui64v');
    private z_GetQueryBufferObjectui64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectui64v(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectui64v_ovr_0(id, buffer, pname, offset);
    
    private z_GetQueryBufferObjectuiv_adr := GetProcAddress('glGetQueryBufferObjectuiv');
    private z_GetQueryBufferObjectuiv_ovr_0 := GetProcOrNil&<procedure(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectuiv(id: gl_query; buffer: gl_buffer; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectuiv_ovr_0(id, buffer, pname, offset);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawBuffersARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_draw_buffers';
    
    private z_DrawBuffersARB_adr := GetProcAddress('glDrawBuffersARB');
    private z_DrawBuffersARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var bufs: DrawBufferMode)>(z_DrawBuffersARB_adr);
    private z_DrawBuffersARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffersARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersARB(n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_DrawBuffersARB_ovr_0(n, bufs[0]) else
      z_DrawBuffersARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersARB(n: Int32; var bufs: DrawBufferMode) :=
    z_DrawBuffersARB_ovr_0(n, bufs);
    private z_DrawBuffersARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffersARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersARB(n: Int32; bufs: IntPtr) :=
    z_DrawBuffersARB_ovr_2(n, bufs);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawBuffersBlendARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_draw_buffers_blend';
    
    private z_BlendEquationiARB_adr := GetProcAddress('glBlendEquationiARB');
    private z_BlendEquationiARB_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; mode: BlendEquationModeEXT)>(z_BlendEquationiARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationiARB(buf: UInt32; mode: BlendEquationModeEXT) :=
    z_BlendEquationiARB_ovr_0(buf, mode);
    
    private z_BlendEquationSeparateiARB_adr := GetProcAddress('glBlendEquationSeparateiARB');
    private z_BlendEquationSeparateiARB_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparateiARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparateiARB(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparateiARB_ovr_0(buf, modeRGB, modeAlpha);
    
    private z_BlendFunciARB_adr := GetProcAddress('glBlendFunciARB');
    private z_BlendFunciARB_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; src: BlendingFactor; dst: BlendingFactor)>(z_BlendFunciARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFunciARB(buf: UInt32; src: BlendingFactor; dst: BlendingFactor) :=
    z_BlendFunciARB_ovr_0(buf, src, dst);
    
    private z_BlendFuncSeparateiARB_adr := GetProcAddress('glBlendFuncSeparateiARB');
    private z_BlendFuncSeparateiARB_ovr_0 := GetProcOrNil&<procedure(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor)>(z_BlendFuncSeparateiARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateiARB(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor) :=
    z_BlendFuncSeparateiARB_ovr_0(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawElementsBaseVertexARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_draw_elements_base_vertex';
    
    private z_DrawElementsBaseVertex_adr := GetProcAddress('glDrawElementsBaseVertex');
    private z_DrawElementsBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32)>(z_DrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawElementsBaseVertex_ovr_0(mode, count, &type, indices, basevertex);
    
    private z_DrawRangeElementsBaseVertex_adr := GetProcAddress('glDrawRangeElementsBaseVertex');
    private z_DrawRangeElementsBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32)>(z_DrawRangeElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementsBaseVertex(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawRangeElementsBaseVertex_ovr_0(mode, start, &end, count, &type, indices, basevertex);
    
    private z_DrawElementsInstancedBaseVertex_adr := GetProcAddress('glDrawElementsInstancedBaseVertex');
    private z_DrawElementsInstancedBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32)>(z_DrawElementsInstancedBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32) :=
    z_DrawElementsInstancedBaseVertex_ovr_0(mode, count, &type, indices, instancecount, basevertex);
    
    private z_MultiDrawElementsBaseVertex_adr := GetProcAddress('glMultiDrawElementsBaseVertex');
    private z_MultiDrawElementsBaseVertex_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000101 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010101 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count[0], &type, IntPtr.Zero, drawcount, IntPtr.Zero) else
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010101(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0010100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0010100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_3_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_3_anh0010001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_4_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_5_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0010001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_7_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_8_anh0010000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_8(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_8_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_9_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_9_anh0000101 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_10_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_11_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_8(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_18 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000101 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_19_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_20 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_20_anh0000100 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_20_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_24 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_24_anh0000001 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_24_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_26 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_26(mode, count, &type, indices, drawcount, basevertex);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawIndirectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_draw_indirect';
    
    private z_DrawArraysIndirect_adr := GetProcAddress('glDrawArraysIndirect');
    private z_DrawArraysIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr)>(z_DrawArraysIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr) :=
    z_DrawArraysIndirect_ovr_0(mode, indirect);
    
    private z_DrawElementsIndirect_adr := GetProcAddress('glDrawElementsIndirect');
    private z_DrawElementsIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr)>(z_DrawElementsIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr) :=
    z_DrawElementsIndirect_ovr_0(mode, &type, indirect);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawInstancedARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_draw_instanced';
    
    private z_DrawArraysInstancedARB_adr := GetProcAddress('glDrawArraysInstancedARB');
    private z_DrawArraysInstancedARB_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; primcount: Int32)>(z_DrawArraysInstancedARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedARB(mode: PrimitiveType; first: Int32; count: Int32; primcount: Int32) :=
    z_DrawArraysInstancedARB_ovr_0(mode, first, count, primcount);
    
    private z_DrawElementsInstancedARB_adr := GetProcAddress('glDrawElementsInstancedARB');
    private z_DrawElementsInstancedARB_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32)>(z_DrawElementsInstancedARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedARB(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32) :=
    z_DrawElementsInstancedARB_ovr_0(mode, count, &type, indices, primcount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFragmentProgramARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_fragment_program';
    
    private z_ProgramStringARB_adr := GetProcAddress('glProgramStringARB');
    private z_ProgramStringARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr)>(z_ProgramStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramStringARB(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr) :=
    z_ProgramStringARB_ovr_0(target, format, len, string);
    
    private z_BindProgramARB_adr := GetProcAddress('glBindProgramARB');
    private z_BindProgramARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; &program: gl_program)>(z_BindProgramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramARB(target: ProgramTarget; &program: gl_program) :=
    z_BindProgramARB_ovr_0(target, &program);
    
    private z_DeleteProgramsARB_adr := GetProcAddress('glDeleteProgramsARB');
    private z_DeleteProgramsARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_DeleteProgramsARB_adr);
    private z_DeleteProgramsARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_DeleteProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_DeleteProgramsARB_ovr_0(n, programs[0]) else
      z_DeleteProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; var programs: gl_program) :=
    z_DeleteProgramsARB_ovr_0(n, programs);
    private z_DeleteProgramsARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_DeleteProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: IntPtr) :=
    z_DeleteProgramsARB_ovr_2(n, programs);
    
    private z_GenProgramsARB_adr := GetProcAddress('glGenProgramsARB');
    private z_GenProgramsARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_GenProgramsARB_adr);
    private z_GenProgramsARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_GenProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_GenProgramsARB_ovr_0(n, programs[0]) else
      z_GenProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; var programs: gl_program) :=
    z_GenProgramsARB_ovr_0(n, programs);
    private z_GenProgramsARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_GenProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: IntPtr) :=
    z_GenProgramsARB_ovr_2(n, programs);
    
    private z_ProgramEnvParameter4dARB_adr := GetProcAddress('glProgramEnvParameter4dARB');
    private z_ProgramEnvParameter4dARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real)>(z_ProgramEnvParameter4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramEnvParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramEnvParameter4dvARB_adr := GetProcAddress('glProgramEnvParameter4dvARB');
    private z_ProgramEnvParameter4dvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_ProgramEnvParameter4dvARB_adr);
    private z_ProgramEnvParameter4dvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params);
    private z_ProgramEnvParameter4dvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4dvARB_ovr_2(target, index, &params);
    
    private z_ProgramEnvParameter4fARB_adr := GetProcAddress('glProgramEnvParameter4fARB');
    private z_ProgramEnvParameter4fARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single)>(z_ProgramEnvParameter4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramEnvParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramEnvParameter4fvARB_adr := GetProcAddress('glProgramEnvParameter4fvARB');
    private z_ProgramEnvParameter4fvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_ProgramEnvParameter4fvARB_adr);
    private z_ProgramEnvParameter4fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params);
    private z_ProgramEnvParameter4fvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4fvARB_ovr_2(target, index, &params);
    
    private z_ProgramLocalParameter4dARB_adr := GetProcAddress('glProgramLocalParameter4dARB');
    private z_ProgramLocalParameter4dARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real)>(z_ProgramLocalParameter4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramLocalParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramLocalParameter4dvARB_adr := GetProcAddress('glProgramLocalParameter4dvARB');
    private z_ProgramLocalParameter4dvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_ProgramLocalParameter4dvARB_adr);
    private z_ProgramLocalParameter4dvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params);
    private z_ProgramLocalParameter4dvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4dvARB_ovr_2(target, index, &params);
    
    private z_ProgramLocalParameter4fARB_adr := GetProcAddress('glProgramLocalParameter4fARB');
    private z_ProgramLocalParameter4fARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single)>(z_ProgramLocalParameter4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramLocalParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramLocalParameter4fvARB_adr := GetProcAddress('glProgramLocalParameter4fvARB');
    private z_ProgramLocalParameter4fvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_ProgramLocalParameter4fvARB_adr);
    private z_ProgramLocalParameter4fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params);
    private z_ProgramLocalParameter4fvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4fvARB_ovr_2(target, index, &params);
    
    private z_GetProgramEnvParameterdvARB_adr := GetProcAddress('glGetProgramEnvParameterdvARB');
    private z_GetProgramEnvParameterdvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_GetProgramEnvParameterdvARB_adr);
    private z_GetProgramEnvParameterdvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params);
    private z_GetProgramEnvParameterdvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterdvARB_ovr_2(target, index, &params);
    
    private z_GetProgramEnvParameterfvARB_adr := GetProcAddress('glGetProgramEnvParameterfvARB');
    private z_GetProgramEnvParameterfvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_GetProgramEnvParameterfvARB_adr);
    private z_GetProgramEnvParameterfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params);
    private z_GetProgramEnvParameterfvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterfvARB_ovr_2(target, index, &params);
    
    private z_GetProgramLocalParameterdvARB_adr := GetProcAddress('glGetProgramLocalParameterdvARB');
    private z_GetProgramLocalParameterdvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_GetProgramLocalParameterdvARB_adr);
    private z_GetProgramLocalParameterdvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params);
    private z_GetProgramLocalParameterdvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterdvARB_ovr_2(target, index, &params);
    
    private z_GetProgramLocalParameterfvARB_adr := GetProcAddress('glGetProgramLocalParameterfvARB');
    private z_GetProgramLocalParameterfvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_GetProgramLocalParameterfvARB_adr);
    private z_GetProgramLocalParameterfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params);
    private z_GetProgramLocalParameterfvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterfvARB_ovr_2(target, index, &params);
    
    private z_GetProgramivARB_adr := GetProcAddress('glGetProgramivARB');
    private z_GetProgramivARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32)>(z_GetProgramivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetProgramivARB_ovr_0(target, pname, &params);
    private z_GetProgramivARB_ovr_1 := GetProcOrNil&<procedure(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetProgramivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetProgramivARB_ovr_1(target, pname, &params);
    
    private z_GetProgramStringARB_adr := GetProcAddress('glGetProgramStringARB');
    private z_GetProgramStringARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr)>(z_GetProgramStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringARB(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr) :=
    z_GetProgramStringARB_ovr_0(target, pname, string);
    
    private z_IsProgramARB_adr := GetProcAddress('glIsProgramARB');
    private z_IsProgramARB_ovr_0 := GetProcOrNil&<function(&program: gl_program): boolean>(z_IsProgramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramARB(&program: gl_program): boolean :=
    z_IsProgramARB_ovr_0(&program);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferNoAttachmentsARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_framebuffer_no_attachments';
    
    private z_FramebufferParameteri_adr := GetProcAddress('glFramebufferParameteri');
    private z_FramebufferParameteri_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32)>(z_FramebufferParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferParameteri(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32) :=
    z_FramebufferParameteri_ovr_0(target, pname, param);
    
    private z_GetFramebufferParameteriv_adr := GetProcAddress('glGetFramebufferParameteriv');
    private z_GetFramebufferParameteriv_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferParameteriv_adr);
    private z_GetFramebufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetFramebufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferParameteriv_ovr_0(target, pname, &params);
    private z_GetFramebufferParameteriv_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferParameteriv_ovr_2(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_framebuffer_object';
    
    private z_IsRenderbuffer_adr := GetProcAddress('glIsRenderbuffer');
    private z_IsRenderbuffer_ovr_0 := GetProcOrNil&<function(renderbuffer: gl_renderbuffer): boolean>(z_IsRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsRenderbuffer(renderbuffer: gl_renderbuffer): boolean :=
    z_IsRenderbuffer_ovr_0(renderbuffer);
    
    private z_BindRenderbuffer_adr := GetProcAddress('glBindRenderbuffer');
    private z_BindRenderbuffer_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_BindRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindRenderbuffer(target: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_BindRenderbuffer_ovr_0(target, renderbuffer);
    
    private z_DeleteRenderbuffers_adr := GetProcAddress('glDeleteRenderbuffers');
    private z_DeleteRenderbuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_DeleteRenderbuffers_adr);
    private z_DeleteRenderbuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_DeleteRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_DeleteRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_DeleteRenderbuffers_ovr_0(n, renderbuffers);
    private z_DeleteRenderbuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_DeleteRenderbuffers_ovr_2(n, renderbuffers);
    
    private z_GenRenderbuffers_adr := GetProcAddress('glGenRenderbuffers');
    private z_GenRenderbuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_GenRenderbuffers_adr);
    private z_GenRenderbuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_GenRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_GenRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_GenRenderbuffers_ovr_0(n, renderbuffers);
    private z_GenRenderbuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_GenRenderbuffers_ovr_2(n, renderbuffers);
    
    private z_RenderbufferStorage_adr := GetProcAddress('glRenderbufferStorage');
    private z_RenderbufferStorage_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorage(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorage_ovr_0(target, _internalformat, width, height);
    
    private z_GetRenderbufferParameteriv_adr := GetProcAddress('glGetRenderbufferParameteriv');
    private z_GetRenderbufferParameteriv_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32)>(z_GetRenderbufferParameteriv_adr);
    private z_GetRenderbufferParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetRenderbufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetRenderbufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetRenderbufferParameteriv_ovr_0(target, pname, &params);
    private z_GetRenderbufferParameteriv_ovr_2 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetRenderbufferParameteriv_ovr_2(target, pname, &params);
    
    private z_IsFramebuffer_adr := GetProcAddress('glIsFramebuffer');
    private z_IsFramebuffer_ovr_0 := GetProcOrNil&<function(framebuffer: gl_framebuffer): boolean>(z_IsFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFramebuffer(framebuffer: gl_framebuffer): boolean :=
    z_IsFramebuffer_ovr_0(framebuffer);
    
    private z_BindFramebuffer_adr := GetProcAddress('glBindFramebuffer');
    private z_BindFramebuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; framebuffer: gl_framebuffer)>(z_BindFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFramebuffer(target: FramebufferTarget; framebuffer: gl_framebuffer) :=
    z_BindFramebuffer_ovr_0(target, framebuffer);
    
    private z_DeleteFramebuffers_adr := GetProcAddress('glDeleteFramebuffers');
    private z_DeleteFramebuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_DeleteFramebuffers_adr);
    private z_DeleteFramebuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_DeleteFramebuffers_ovr_0(n, framebuffers[0]) else
      z_DeleteFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; var framebuffers: gl_framebuffer) :=
    z_DeleteFramebuffers_ovr_0(n, framebuffers);
    private z_DeleteFramebuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_DeleteFramebuffers_ovr_2(n, framebuffers);
    
    private z_GenFramebuffers_adr := GetProcAddress('glGenFramebuffers');
    private z_GenFramebuffers_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_GenFramebuffers_adr);
    private z_GenFramebuffers_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_GenFramebuffers_ovr_0(n, framebuffers[0]) else
      z_GenFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; var framebuffers: gl_framebuffer) :=
    z_GenFramebuffers_ovr_0(n, framebuffers);
    private z_GenFramebuffers_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_GenFramebuffers_ovr_2(n, framebuffers);
    
    private z_CheckFramebufferStatus_adr := GetProcAddress('glCheckFramebufferStatus');
    private z_CheckFramebufferStatus_ovr_0 := GetProcOrNil&<function(target: FramebufferTarget): FramebufferStatus>(z_CheckFramebufferStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckFramebufferStatus(target: FramebufferTarget): FramebufferStatus :=
    z_CheckFramebufferStatus_ovr_0(target);
    
    private z_FramebufferTexture1D_adr := GetProcAddress('glFramebufferTexture1D');
    private z_FramebufferTexture1D_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_FramebufferTexture1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture1D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture1D_ovr_0(target, attachment, textarget, texture, level);
    
    private z_FramebufferTexture2D_adr := GetProcAddress('glFramebufferTexture2D');
    private z_FramebufferTexture2D_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_FramebufferTexture2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture2D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture2D_ovr_0(target, attachment, textarget, texture, level);
    
    private z_FramebufferTexture3D_adr := GetProcAddress('glFramebufferTexture3D');
    private z_FramebufferTexture3D_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32)>(z_FramebufferTexture3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture3D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32) :=
    z_FramebufferTexture3D_ovr_0(target, attachment, textarget, texture, level, zoffset);
    
    private z_FramebufferRenderbuffer_adr := GetProcAddress('glFramebufferRenderbuffer');
    private z_FramebufferRenderbuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_FramebufferRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferRenderbuffer(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_FramebufferRenderbuffer_ovr_0(target, attachment, _renderbuffertarget, renderbuffer);
    
    private z_GetFramebufferAttachmentParameteriv_adr := GetProcAddress('glGetFramebufferAttachmentParameteriv');
    private z_GetFramebufferAttachmentParameteriv_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferAttachmentParameteriv_adr);
    private z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params[0]) else
      z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001(target, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params);
    private z_GetFramebufferAttachmentParameteriv_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferAttachmentParameteriv_ovr_2(target, attachment, pname, &params);
    
    private z_GenerateMipmap_adr := GetProcAddress('glGenerateMipmap');
    private z_GenerateMipmap_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget)>(z_GenerateMipmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMipmap(target: TextureTarget) :=
    z_GenerateMipmap_ovr_0(target);
    
    private z_BlitFramebuffer_adr := GetProcAddress('glBlitFramebuffer');
    private z_BlitFramebuffer_ovr_0 := GetProcOrNil&<procedure(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitFramebuffer(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitFramebuffer_ovr_0(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    private z_RenderbufferStorageMultisample_adr := GetProcAddress('glRenderbufferStorageMultisample');
    private z_RenderbufferStorageMultisample_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisample(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisample_ovr_0(target, samples, _internalformat, width, height);
    
    private z_FramebufferTextureLayer_adr := GetProcAddress('glFramebufferTextureLayer');
    private z_FramebufferTextureLayer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_FramebufferTextureLayer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayer(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayer_ovr_0(target, attachment, texture, level, layer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGeometryShader4ARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_geometry_shader4';
    
    private z_ProgramParameteriARB_adr := GetProcAddress('glProgramParameteriARB');
    private z_ProgramParameteriARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramParameterPName; value: Int32)>(z_ProgramParameteriARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteriARB(&program: gl_program; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteriARB_ovr_0(&program, pname, value);
    
    private z_FramebufferTextureARB_adr := GetProcAddress('glFramebufferTextureARB');
    private z_FramebufferTextureARB_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32)>(z_FramebufferTextureARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureARB(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32) :=
    z_FramebufferTextureARB_ovr_0(target, attachment, texture, level);
    
    private z_FramebufferTextureLayerARB_adr := GetProcAddress('glFramebufferTextureLayerARB');
    private z_FramebufferTextureLayerARB_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_FramebufferTextureLayerARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayerARB(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayerARB_ovr_0(target, attachment, texture, level, layer);
    
    private z_FramebufferTextureFaceARB_adr := GetProcAddress('glFramebufferTextureFaceARB');
    private z_FramebufferTextureFaceARB_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; face: TextureTarget)>(z_FramebufferTextureFaceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureFaceARB(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; face: TextureTarget) :=
    z_FramebufferTextureFaceARB_ovr_0(target, attachment, texture, level, face);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGetProgramBinaryARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_get_program_binary';
    
    private z_GetProgramBinary_adr := GetProcAddress('glGetProgramBinary');
    private z_GetProgramBinary_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_0(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_1(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_2(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: gl_program; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_3(&program, bufSize, length, binaryFormat, binary);
    
    private z_ProgramBinary_adr := GetProcAddress('glProgramBinary');
    private z_ProgramBinary_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; binaryFormat: DummyEnum; binary: IntPtr; length: Int32)>(z_ProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBinary(&program: gl_program; binaryFormat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ProgramBinary_ovr_0(&program, binaryFormat, binary, length);
    
    private z_ProgramParameteri_adr := GetProcAddress('glProgramParameteri');
    private z_ProgramParameteri_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramParameterPName; value: Int32)>(z_ProgramParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteri(&program: gl_program; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteri_ovr_0(&program, pname, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGetTextureSubImageARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_get_texture_sub_image';
    
    private z_GetTextureSubImage_adr := GetProcAddress('glGetTextureSubImage');
    private z_GetTextureSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetTextureSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, bufSize, pixels);
    
    private z_GetCompressedTextureSubImage_adr := GetProcAddress('glGetCompressedTextureSubImage');
    private z_GetCompressedTextureSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetCompressedTextureSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, bufSize, pixels);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGlSpirvARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_gl_spirv';
    
    private z_SpecializeShaderARB_adr := GetProcAddress('glSpecializeShaderARB');
    private z_SpecializeShaderARB_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32)>(z_SpecializeShaderARB_adr);
    private z_SpecializeShaderARB_ovr_0_anh000010 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShaderARB_adr);
    private z_SpecializeShaderARB_ovr_0_anh000001 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr)>(z_SpecializeShaderARB_adr);
    private z_SpecializeShaderARB_ovr_0_anh000011 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShaderARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
          if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
            z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
            z_SpecializeShaderARB_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
          if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
            z_SpecializeShaderARB_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
            z_SpecializeShaderARB_ovr_0_anh000011(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShaderARB_ovr_1_anh000010 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShaderARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
          z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
          z_SpecializeShaderARB_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShaderARB_ovr_2 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr)>(z_SpecializeShaderARB_adr);
    private z_SpecializeShaderARB_ovr_2_anh000010 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShaderARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
          z_SpecializeShaderARB_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
          z_SpecializeShaderARB_ovr_2_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
          z_SpecializeShaderARB_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShaderARB_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShaderARB_ovr_6 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShaderARB_adr);
    private z_SpecializeShaderARB_ovr_6_anh000001 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShaderARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShaderARB_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
          z_SpecializeShaderARB_ovr_6_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShaderARB_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_SpecializeShaderARB_ovr_8 := GetProcOrNil&<procedure(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShaderARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
        z_SpecializeShaderARB_ovr_8(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
        z_SpecializeShaderARB_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShaderARB_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
        z_SpecializeShaderARB_ovr_0_anh000011(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShaderARB_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShaderARB_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShaderARB_ovr_2_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShaderARB_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32) :=
    z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr) :=
    z_SpecializeShaderARB_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShaderARB_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShaderARB_ovr_6_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32) :=
    z_SpecializeShaderARB_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: gl_shader; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr) :=
    z_SpecializeShaderARB_ovr_8(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuShaderFp64ARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_gpu_shader_fp64';
    
    private z_Uniform1d_adr := GetProcAddress('glUniform1d');
    private z_Uniform1d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real)>(z_Uniform1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1d(location: Int32; x: real) :=
    z_Uniform1d_ovr_0(location, x);
    
    private z_Uniform2d_adr := GetProcAddress('glUniform2d');
    private z_Uniform2d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real; y: real)>(z_Uniform2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2d(location: Int32; x: real; y: real) :=
    z_Uniform2d_ovr_0(location, x, y);
    
    private z_Uniform3d_adr := GetProcAddress('glUniform3d');
    private z_Uniform3d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real; y: real; z: real)>(z_Uniform3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3d(location: Int32; x: real; y: real; z: real) :=
    z_Uniform3d_ovr_0(location, x, y, z);
    
    private z_Uniform4d_adr := GetProcAddress('glUniform4d');
    private z_Uniform4d_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: real; y: real; z: real; w: real)>(z_Uniform4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4d(location: Int32; x: real; y: real; z: real; w: real) :=
    z_Uniform4d_ovr_0(location, x, y, z, w);
    
    private z_Uniform1dv_adr := GetProcAddress('glUniform1dv');
    private z_Uniform1dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform1dv_adr);
    private z_Uniform1dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1dv_ovr_0(location, count, value[0]) else
      z_Uniform1dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform1dv_ovr_0(location, count, value);
    private z_Uniform1dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec1d)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; var value: Vec1d) :=
    z_Uniform1dv_ovr_2(location, count, value);
    private z_Uniform1dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1dv_ovr_3(location, count, value);
    
    private z_Uniform2dv_adr := GetProcAddress('glUniform2dv');
    private z_Uniform2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform2dv_adr);
    private z_Uniform2dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2dv_ovr_0(location, count, value[0]) else
      z_Uniform2dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform2dv_ovr_0(location, count, value);
    private z_Uniform2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec2d)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; var value: Vec2d) :=
    z_Uniform2dv_ovr_2(location, count, value);
    private z_Uniform2dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2dv_ovr_3(location, count, value);
    
    private z_Uniform3dv_adr := GetProcAddress('glUniform3dv');
    private z_Uniform3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform3dv_adr);
    private z_Uniform3dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3dv_ovr_0(location, count, value[0]) else
      z_Uniform3dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform3dv_ovr_0(location, count, value);
    private z_Uniform3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec3d)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; var value: Vec3d) :=
    z_Uniform3dv_ovr_2(location, count, value);
    private z_Uniform3dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3dv_ovr_3(location, count, value);
    
    private z_Uniform4dv_adr := GetProcAddress('glUniform4dv');
    private z_Uniform4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform4dv_adr);
    private z_Uniform4dv_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4dv_ovr_0(location, count, value[0]) else
      z_Uniform4dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform4dv_ovr_0(location, count, value);
    private z_Uniform4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Vec4d)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; var value: Vec4d) :=
    z_Uniform4dv_ovr_2(location, count, value);
    private z_Uniform4dv_ovr_3 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4dv_ovr_3(location, count, value);
    
    private z_UniformMatrix2dv_adr := GetProcAddress('glUniformMatrix2dv');
    private z_UniformMatrix2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2dv_adr);
    private z_UniformMatrix2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix3dv_adr := GetProcAddress('glUniformMatrix3dv');
    private z_UniformMatrix3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3dv_adr);
    private z_UniformMatrix3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix4dv_adr := GetProcAddress('glUniformMatrix4dv');
    private z_UniformMatrix4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4dv_adr);
    private z_UniformMatrix4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix2x3dv_adr := GetProcAddress('glUniformMatrix2x3dv');
    private z_UniformMatrix2x3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2x3dv_adr);
    private z_UniformMatrix2x3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x3dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix2x4dv_adr := GetProcAddress('glUniformMatrix2x4dv');
    private z_UniformMatrix2x4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2x4dv_adr);
    private z_UniformMatrix2x4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x4dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix3x2dv_adr := GetProcAddress('glUniformMatrix3x2dv');
    private z_UniformMatrix3x2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3x2dv_adr);
    private z_UniformMatrix3x2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x2dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix3x4dv_adr := GetProcAddress('glUniformMatrix3x4dv');
    private z_UniformMatrix3x4dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3x4dv_adr);
    private z_UniformMatrix3x4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x4dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x4dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix4x2dv_adr := GetProcAddress('glUniformMatrix4x2dv');
    private z_UniformMatrix4x2dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4x2dv_adr);
    private z_UniformMatrix4x2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x2dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x2dv_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix4x3dv_adr := GetProcAddress('glUniformMatrix4x3dv');
    private z_UniformMatrix4x3dv_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4x3dv_adr);
    private z_UniformMatrix4x3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x3dv_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x3dv_ovr_2(location, count, transpose, value);
    
    private z_GetUniformdv_adr := GetProcAddress('glGetUniformdv');
    private z_GetUniformdv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: real)>(z_GetUniformdv_adr);
    private z_GetUniformdv_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: gl_program; location: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformdv_ovr_0(&program, location, &params[0]) else
      z_GetUniformdv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: gl_program; location: Int32; var &params: real) :=
    z_GetUniformdv_ovr_0(&program, location, &params);
    private z_GetUniformdv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformdv_ovr_2(&program, location, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuShaderInt64ARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_gpu_shader_int64';
    
    private z_Uniform1i64ARB_adr := GetProcAddress('glUniform1i64ARB');
    private z_Uniform1i64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64)>(z_Uniform1i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64ARB(location: Int32; x: Int64) :=
    z_Uniform1i64ARB_ovr_0(location, x);
    
    private z_Uniform2i64ARB_adr := GetProcAddress('glUniform2i64ARB');
    private z_Uniform2i64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64)>(z_Uniform2i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64ARB(location: Int32; x: Int64; y: Int64) :=
    z_Uniform2i64ARB_ovr_0(location, x, y);
    
    private z_Uniform3i64ARB_adr := GetProcAddress('glUniform3i64ARB');
    private z_Uniform3i64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64; z: Int64)>(z_Uniform3i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64ARB(location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_Uniform3i64ARB_ovr_0(location, x, y, z);
    
    private z_Uniform4i64ARB_adr := GetProcAddress('glUniform4i64ARB');
    private z_Uniform4i64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_Uniform4i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64ARB(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_Uniform4i64ARB_ovr_0(location, x, y, z, w);
    
    private z_Uniform1i64vARB_adr := GetProcAddress('glUniform1i64vARB');
    private z_Uniform1i64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform1i64vARB_adr);
    private z_Uniform1i64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform1i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform1i64vARB_ovr_0(location, count, value);
    private z_Uniform1i64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1i64vARB_ovr_2(location, count, value);
    
    private z_Uniform2i64vARB_adr := GetProcAddress('glUniform2i64vARB');
    private z_Uniform2i64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform2i64vARB_adr);
    private z_Uniform2i64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform2i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform2i64vARB_ovr_0(location, count, value);
    private z_Uniform2i64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2i64vARB_ovr_2(location, count, value);
    
    private z_Uniform3i64vARB_adr := GetProcAddress('glUniform3i64vARB');
    private z_Uniform3i64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform3i64vARB_adr);
    private z_Uniform3i64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform3i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform3i64vARB_ovr_0(location, count, value);
    private z_Uniform3i64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3i64vARB_ovr_2(location, count, value);
    
    private z_Uniform4i64vARB_adr := GetProcAddress('glUniform4i64vARB');
    private z_Uniform4i64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform4i64vARB_adr);
    private z_Uniform4i64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform4i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform4i64vARB_ovr_0(location, count, value);
    private z_Uniform4i64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4i64vARB_ovr_2(location, count, value);
    
    private z_Uniform1ui64ARB_adr := GetProcAddress('glUniform1ui64ARB');
    private z_Uniform1ui64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64)>(z_Uniform1ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64ARB(location: Int32; x: UInt64) :=
    z_Uniform1ui64ARB_ovr_0(location, x);
    
    private z_Uniform2ui64ARB_adr := GetProcAddress('glUniform2ui64ARB');
    private z_Uniform2ui64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64)>(z_Uniform2ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64ARB(location: Int32; x: UInt64; y: UInt64) :=
    z_Uniform2ui64ARB_ovr_0(location, x, y);
    
    private z_Uniform3ui64ARB_adr := GetProcAddress('glUniform3ui64ARB');
    private z_Uniform3ui64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64; z: UInt64)>(z_Uniform3ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64ARB(location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_Uniform3ui64ARB_ovr_0(location, x, y, z);
    
    private z_Uniform4ui64ARB_adr := GetProcAddress('glUniform4ui64ARB');
    private z_Uniform4ui64ARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_Uniform4ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64ARB(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_Uniform4ui64ARB_ovr_0(location, x, y, z, w);
    
    private z_Uniform1ui64vARB_adr := GetProcAddress('glUniform1ui64vARB');
    private z_Uniform1ui64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform1ui64vARB_adr);
    private z_Uniform1ui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform1ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform1ui64vARB_ovr_0(location, count, value);
    private z_Uniform1ui64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ui64vARB_ovr_2(location, count, value);
    
    private z_Uniform2ui64vARB_adr := GetProcAddress('glUniform2ui64vARB');
    private z_Uniform2ui64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform2ui64vARB_adr);
    private z_Uniform2ui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform2ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform2ui64vARB_ovr_0(location, count, value);
    private z_Uniform2ui64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ui64vARB_ovr_2(location, count, value);
    
    private z_Uniform3ui64vARB_adr := GetProcAddress('glUniform3ui64vARB');
    private z_Uniform3ui64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform3ui64vARB_adr);
    private z_Uniform3ui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform3ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform3ui64vARB_ovr_0(location, count, value);
    private z_Uniform3ui64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ui64vARB_ovr_2(location, count, value);
    
    private z_Uniform4ui64vARB_adr := GetProcAddress('glUniform4ui64vARB');
    private z_Uniform4ui64vARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform4ui64vARB_adr);
    private z_Uniform4ui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform4ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform4ui64vARB_ovr_0(location, count, value);
    private z_Uniform4ui64vARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ui64vARB_ovr_2(location, count, value);
    
    private z_GetUniformi64vARB_adr := GetProcAddress('glGetUniformi64vARB');
    private z_GetUniformi64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: Int64)>(z_GetUniformi64vARB_adr);
    private z_GetUniformi64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformi64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vARB(&program: gl_program; location: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformi64vARB_ovr_0(&program, location, &params[0]) else
      z_GetUniformi64vARB_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vARB(&program: gl_program; location: Int32; var &params: Int64) :=
    z_GetUniformi64vARB_ovr_0(&program, location, &params);
    private z_GetUniformi64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformi64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vARB(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformi64vARB_ovr_2(&program, location, &params);
    
    private z_GetUniformui64vARB_adr := GetProcAddress('glGetUniformui64vARB');
    private z_GetUniformui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: UInt64)>(z_GetUniformui64vARB_adr);
    private z_GetUniformui64vARB_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vARB(&program: gl_program; location: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformui64vARB_ovr_0(&program, location, &params[0]) else
      z_GetUniformui64vARB_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vARB(&program: gl_program; location: Int32; var &params: UInt64) :=
    z_GetUniformui64vARB_ovr_0(&program, location, &params);
    private z_GetUniformui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vARB(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformui64vARB_ovr_2(&program, location, &params);
    
    private z_GetnUniformi64vARB_adr := GetProcAddress('glGetnUniformi64vARB');
    private z_GetnUniformi64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int64)>(z_GetnUniformi64vARB_adr);
    private z_GetnUniformi64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformi64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformi64vARB(&program: gl_program; location: Int32; bufSize: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformi64vARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformi64vARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformi64vARB(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int64) :=
    z_GetnUniformi64vARB_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformi64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformi64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformi64vARB(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformi64vARB_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnUniformui64vARB_adr := GetProcAddress('glGetnUniformui64vARB');
    private z_GetnUniformui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt64)>(z_GetnUniformui64vARB_adr);
    private z_GetnUniformui64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformui64vARB(&program: gl_program; location: Int32; bufSize: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformui64vARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformui64vARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformui64vARB(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt64) :=
    z_GetnUniformui64vARB_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformui64vARB(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformui64vARB_ovr_2(&program, location, bufSize, &params);
    
    private z_ProgramUniform1i64ARB_adr := GetProcAddress('glProgramUniform1i64ARB');
    private z_ProgramUniform1i64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64)>(z_ProgramUniform1i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64ARB(&program: gl_program; location: Int32; x: Int64) :=
    z_ProgramUniform1i64ARB_ovr_0(&program, location, x);
    
    private z_ProgramUniform2i64ARB_adr := GetProcAddress('glProgramUniform2i64ARB');
    private z_ProgramUniform2i64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64)>(z_ProgramUniform2i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64ARB(&program: gl_program; location: Int32; x: Int64; y: Int64) :=
    z_ProgramUniform2i64ARB_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3i64ARB_adr := GetProcAddress('glProgramUniform3i64ARB');
    private z_ProgramUniform3i64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64)>(z_ProgramUniform3i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64ARB(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_ProgramUniform3i64ARB_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4i64ARB_adr := GetProcAddress('glProgramUniform4i64ARB');
    private z_ProgramUniform4i64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_ProgramUniform4i64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64ARB(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_ProgramUniform4i64ARB_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1i64vARB_adr := GetProcAddress('glProgramUniform1i64vARB');
    private z_ProgramUniform1i64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform1i64vARB_adr);
    private z_ProgramUniform1i64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vARB(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vARB(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform1i64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform1i64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1i64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2i64vARB_adr := GetProcAddress('glProgramUniform2i64vARB');
    private z_ProgramUniform2i64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform2i64vARB_adr);
    private z_ProgramUniform2i64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vARB(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vARB(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform2i64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform2i64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2i64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3i64vARB_adr := GetProcAddress('glProgramUniform3i64vARB');
    private z_ProgramUniform3i64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform3i64vARB_adr);
    private z_ProgramUniform3i64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vARB(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vARB(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform3i64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform3i64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3i64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4i64vARB_adr := GetProcAddress('glProgramUniform4i64vARB');
    private z_ProgramUniform4i64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform4i64vARB_adr);
    private z_ProgramUniform4i64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vARB(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vARB(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform4i64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform4i64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4i64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4i64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1ui64ARB_adr := GetProcAddress('glProgramUniform1ui64ARB');
    private z_ProgramUniform1ui64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64)>(z_ProgramUniform1ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64ARB(&program: gl_program; location: Int32; x: UInt64) :=
    z_ProgramUniform1ui64ARB_ovr_0(&program, location, x);
    
    private z_ProgramUniform2ui64ARB_adr := GetProcAddress('glProgramUniform2ui64ARB');
    private z_ProgramUniform2ui64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64)>(z_ProgramUniform2ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64ARB(&program: gl_program; location: Int32; x: UInt64; y: UInt64) :=
    z_ProgramUniform2ui64ARB_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3ui64ARB_adr := GetProcAddress('glProgramUniform3ui64ARB');
    private z_ProgramUniform3ui64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64)>(z_ProgramUniform3ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64ARB(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_ProgramUniform3ui64ARB_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4ui64ARB_adr := GetProcAddress('glProgramUniform4ui64ARB');
    private z_ProgramUniform4ui64ARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_ProgramUniform4ui64ARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64ARB(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_ProgramUniform4ui64ARB_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1ui64vARB_adr := GetProcAddress('glProgramUniform1ui64vARB');
    private z_ProgramUniform1ui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform1ui64vARB_adr);
    private z_ProgramUniform1ui64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vARB(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vARB(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform1ui64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform1ui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ui64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2ui64vARB_adr := GetProcAddress('glProgramUniform2ui64vARB');
    private z_ProgramUniform2ui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform2ui64vARB_adr);
    private z_ProgramUniform2ui64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vARB(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vARB(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform2ui64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform2ui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ui64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3ui64vARB_adr := GetProcAddress('glProgramUniform3ui64vARB');
    private z_ProgramUniform3ui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform3ui64vARB_adr);
    private z_ProgramUniform3ui64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vARB(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vARB(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform3ui64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform3ui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ui64vARB_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4ui64vARB_adr := GetProcAddress('glProgramUniform4ui64vARB');
    private z_ProgramUniform4ui64vARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform4ui64vARB_adr);
    private z_ProgramUniform4ui64vARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vARB(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vARB(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform4ui64vARB_ovr_0(&program, location, count, value);
    private z_ProgramUniform4ui64vARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ui64vARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vARB(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ui64vARB_ovr_2(&program, location, count, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glImagingARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_imaging';
    
    private z_BlendColor_adr := GetProcAddress('glBlendColor');
    private z_BlendColor_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_BlendColor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColor(red: single; green: single; blue: single; alpha: single) :=
    z_BlendColor_ovr_0(red, green, blue, alpha);
    
    private z_BlendEquation_adr := GetProcAddress('glBlendEquation');
    private z_BlendEquation_ovr_0 := GetProcOrNil&<procedure(mode: BlendEquationModeEXT)>(z_BlendEquation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquation(mode: BlendEquationModeEXT) :=
    z_BlendEquation_ovr_0(mode);
    
    private z_ColorTable_adr := GetProcAddress('glColorTable');
    private z_ColorTable_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr)>(z_ColorTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTable(target: ColorTableTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_ColorTable_ovr_0(target, _internalformat, width, format, &type, table);
    
    private z_ColorTableParameterfv_adr := GetProcAddress('glColorTableParameterfv');
    private z_ColorTableParameterfv_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; var &params: single)>(z_ColorTableParameterfv_adr);
    private z_ColorTableParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfv(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameterfv_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfv(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; var &params: single) :=
    z_ColorTableParameterfv_ovr_0(target, pname, &params);
    private z_ColorTableParameterfv_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfv(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: IntPtr) :=
    z_ColorTableParameterfv_ovr_2(target, pname, &params);
    
    private z_ColorTableParameteriv_adr := GetProcAddress('glColorTableParameteriv');
    private z_ColorTableParameteriv_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; var &params: Int32)>(z_ColorTableParameteriv_adr);
    private z_ColorTableParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameteriv(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameteriv_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameteriv(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; var &params: Int32) :=
    z_ColorTableParameteriv_ovr_0(target, pname, &params);
    private z_ColorTableParameteriv_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameteriv(target: ColorTableTarget; pname: ColorTableParameterPNameSGI; &params: IntPtr) :=
    z_ColorTableParameteriv_ovr_2(target, pname, &params);
    
    private z_CopyColorTable_adr := GetProcAddress('glCopyColorTable');
    private z_CopyColorTable_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32)>(z_CopyColorTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorTable(target: ColorTableTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorTable_ovr_0(target, _internalformat, x, y, width);
    
    private z_GetColorTable_adr := GetProcAddress('glGetColorTable');
    private z_GetColorTable_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; format: PixelFormat; &type: PixelType; table: IntPtr)>(z_GetColorTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTable(target: ColorTableTarget; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_GetColorTable_ovr_0(target, format, &type, table);
    
    private z_GetColorTableParameterfv_adr := GetProcAddress('glGetColorTableParameterfv');
    private z_GetColorTableParameterfv_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single)>(z_GetColorTableParameterfv_adr);
    private z_GetColorTableParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single) :=
    z_GetColorTableParameterfv_ovr_0(target, pname, &params);
    private z_GetColorTableParameterfv_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterfv_ovr_2(target, pname, &params);
    
    private z_GetColorTableParameteriv_adr := GetProcAddress('glGetColorTableParameteriv');
    private z_GetColorTableParameteriv_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32)>(z_GetColorTableParameteriv_adr);
    private z_GetColorTableParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameteriv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameteriv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32) :=
    z_GetColorTableParameteriv_ovr_0(target, pname, &params);
    private z_GetColorTableParameteriv_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameteriv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameteriv_ovr_2(target, pname, &params);
    
    private z_ColorSubTable_adr := GetProcAddress('glColorSubTable');
    private z_ColorSubTable_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ColorSubTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorSubTable(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ColorSubTable_ovr_0(target, start, count, format, &type, data);
    
    private z_CopyColorSubTable_adr := GetProcAddress('glCopyColorSubTable');
    private z_CopyColorSubTable_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyColorSubTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorSubTable(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorSubTable_ovr_0(target, start, x, y, width);
    
    private z_ConvolutionFilter1D_adr := GetProcAddress('glConvolutionFilter1D');
    private z_ConvolutionFilter1D_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr)>(z_ConvolutionFilter1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter1D(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter1D_ovr_0(target, _internalformat, width, format, &type, image);
    
    private z_ConvolutionFilter2D_adr := GetProcAddress('glConvolutionFilter2D');
    private z_ConvolutionFilter2D_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr)>(z_ConvolutionFilter2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter2D(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter2D_ovr_0(target, _internalformat, width, height, format, &type, image);
    
    private z_ConvolutionParameterf_adr := GetProcAddress('glConvolutionParameterf');
    private z_ConvolutionParameterf_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: single)>(z_ConvolutionParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterf(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: single) :=
    z_ConvolutionParameterf_ovr_0(target, pname, &params);
    
    private z_ConvolutionParameterfv_adr := GetProcAddress('glConvolutionParameterfv');
    private z_ConvolutionParameterfv_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single)>(z_ConvolutionParameterfv_adr);
    private z_ConvolutionParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterfv_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single) :=
    z_ConvolutionParameterfv_ovr_0(target, pname, &params);
    private z_ConvolutionParameterfv_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterfv_ovr_2(target, pname, &params);
    
    private z_ConvolutionParameteri_adr := GetProcAddress('glConvolutionParameteri');
    private z_ConvolutionParameteri_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: Int32)>(z_ConvolutionParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteri(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: Int32) :=
    z_ConvolutionParameteri_ovr_0(target, pname, &params);
    
    private z_ConvolutionParameteriv_adr := GetProcAddress('glConvolutionParameteriv');
    private z_ConvolutionParameteriv_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32)>(z_ConvolutionParameteriv_adr);
    private z_ConvolutionParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameteriv_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_ConvolutionParameteriv_ovr_0(target, pname, &params);
    private z_ConvolutionParameteriv_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameteriv_ovr_2(target, pname, &params);
    
    private z_CopyConvolutionFilter1D_adr := GetProcAddress('glCopyConvolutionFilter1D');
    private z_CopyConvolutionFilter1D_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32)>(z_CopyConvolutionFilter1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter1D(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyConvolutionFilter1D_ovr_0(target, _internalformat, x, y, width);
    
    private z_CopyConvolutionFilter2D_adr := GetProcAddress('glCopyConvolutionFilter2D');
    private z_CopyConvolutionFilter2D_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyConvolutionFilter2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter2D(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyConvolutionFilter2D_ovr_0(target, _internalformat, x, y, width, height);
    
    private z_GetConvolutionFilter_adr := GetProcAddress('glGetConvolutionFilter');
    private z_GetConvolutionFilter_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; image: IntPtr)>(z_GetConvolutionFilter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionFilter(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_GetConvolutionFilter_ovr_0(target, format, &type, image);
    
    private z_GetConvolutionParameterfv_adr := GetProcAddress('glGetConvolutionParameterfv');
    private z_GetConvolutionParameterfv_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single)>(z_GetConvolutionParameterfv_adr);
    private z_GetConvolutionParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single) :=
    z_GetConvolutionParameterfv_ovr_0(target, pname, &params);
    private z_GetConvolutionParameterfv_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameterfv_ovr_2(target, pname, &params);
    
    private z_GetConvolutionParameteriv_adr := GetProcAddress('glGetConvolutionParameteriv');
    private z_GetConvolutionParameteriv_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32)>(z_GetConvolutionParameteriv_adr);
    private z_GetConvolutionParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_GetConvolutionParameteriv_ovr_0(target, pname, &params);
    private z_GetConvolutionParameteriv_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameteriv_ovr_2(target, pname, &params);
    
    private z_GetSeparableFilter_adr := GetProcAddress('glGetSeparableFilter');
    private z_GetSeparableFilter_ovr_0 := GetProcOrNil&<procedure(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr)>(z_GetSeparableFilter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSeparableFilter(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr) :=
    z_GetSeparableFilter_ovr_0(target, format, &type, row, column, span);
    
    private z_SeparableFilter2D_adr := GetProcAddress('glSeparableFilter2D');
    private z_SeparableFilter2D_ovr_0 := GetProcOrNil&<procedure(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr)>(z_SeparableFilter2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SeparableFilter2D(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr) :=
    z_SeparableFilter2D_ovr_0(target, _internalformat, width, height, format, &type, row, column);
    
    private z_GetHistogram_adr := GetProcAddress('glGetHistogram');
    private z_GetHistogram_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr)>(z_GetHistogram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogram(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetHistogram_ovr_0(target, reset, format, &type, values);
    
    private z_GetHistogramParameterfv_adr := GetProcAddress('glGetHistogramParameterfv');
    private z_GetHistogramParameterfv_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single)>(z_GetHistogramParameterfv_adr);
    private z_GetHistogramParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single) :=
    z_GetHistogramParameterfv_ovr_0(target, pname, &params);
    private z_GetHistogramParameterfv_ovr_2 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterfv_ovr_2(target, pname, &params);
    
    private z_GetHistogramParameteriv_adr := GetProcAddress('glGetHistogramParameteriv');
    private z_GetHistogramParameteriv_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32)>(z_GetHistogramParameteriv_adr);
    private z_GetHistogramParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameteriv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameteriv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32) :=
    z_GetHistogramParameteriv_ovr_0(target, pname, &params);
    private z_GetHistogramParameteriv_ovr_2 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameteriv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameteriv_ovr_2(target, pname, &params);
    
    private z_GetMinmax_adr := GetProcAddress('glGetMinmax');
    private z_GetMinmax_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr)>(z_GetMinmax_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmax(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetMinmax_ovr_0(target, reset, format, &type, values);
    
    private z_GetMinmaxParameterfv_adr := GetProcAddress('glGetMinmaxParameterfv');
    private z_GetMinmaxParameterfv_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single)>(z_GetMinmaxParameterfv_adr);
    private z_GetMinmaxParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single) :=
    z_GetMinmaxParameterfv_ovr_0(target, pname, &params);
    private z_GetMinmaxParameterfv_ovr_2 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameterfv_ovr_2(target, pname, &params);
    
    private z_GetMinmaxParameteriv_adr := GetProcAddress('glGetMinmaxParameteriv');
    private z_GetMinmaxParameteriv_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32)>(z_GetMinmaxParameteriv_adr);
    private z_GetMinmaxParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameteriv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameteriv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32) :=
    z_GetMinmaxParameteriv_ovr_0(target, pname, &params);
    private z_GetMinmaxParameteriv_ovr_2 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameteriv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameteriv_ovr_2(target, pname, &params);
    
    private z_Histogram_adr := GetProcAddress('glHistogram');
    private z_Histogram_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean)>(z_Histogram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Histogram(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean) :=
    z_Histogram_ovr_0(target, width, _internalformat, sink);
    
    private z_Minmax_adr := GetProcAddress('glMinmax');
    private z_Minmax_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean)>(z_Minmax_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Minmax(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean) :=
    z_Minmax_ovr_0(target, _internalformat, sink);
    
    private z_ResetHistogram_adr := GetProcAddress('glResetHistogram');
    private z_ResetHistogram_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT)>(z_ResetHistogram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetHistogram(target: HistogramTargetEXT) :=
    z_ResetHistogram_ovr_0(target);
    
    private z_ResetMinmax_adr := GetProcAddress('glResetMinmax');
    private z_ResetMinmax_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT)>(z_ResetMinmax_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetMinmax(target: MinmaxTargetEXT) :=
    z_ResetMinmax_ovr_0(target);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glIndirectParametersARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_indirect_parameters';
    
    private z_MultiDrawArraysIndirectCountARB_adr := GetProcAddress('glMultiDrawArraysIndirectCountARB');
    private z_MultiDrawArraysIndirectCountARB_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirectCountARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectCountARB(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirectCountARB_ovr_0(mode, indirect, drawcount, maxdrawcount, stride);
    
    private z_MultiDrawElementsIndirectCountARB_adr := GetProcAddress('glMultiDrawElementsIndirectCountARB');
    private z_MultiDrawElementsIndirectCountARB_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirectCountARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectCountARB(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirectCountARB_ovr_0(mode, &type, indirect, drawcount, maxdrawcount, stride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInstancedArraysARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_instanced_arrays';
    
    private z_VertexAttribDivisorARB_adr := GetProcAddress('glVertexAttribDivisorARB');
    private z_VertexAttribDivisorARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; divisor: UInt32)>(z_VertexAttribDivisorARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribDivisorARB(index: UInt32; divisor: UInt32) :=
    z_VertexAttribDivisorARB_ovr_0(index, divisor);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInternalformatQueryARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_internalformat_query';
    
    private z_GetInternalformativ_adr := GetProcAddress('glGetInternalformativ');
    private z_GetInternalformativ_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32)>(z_GetInternalformativ_adr);
    private z_GetInternalformativ_ovr_0_anh000001 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformativ_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformativ_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32) :=
    z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params);
    private z_GetInternalformativ_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformativ_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformativ_ovr_2(target, _internalformat, pname, count, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInternalformatQuery2ARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_internalformat_query2';
    
    private z_GetInternalformati64v_adr := GetProcAddress('glGetInternalformati64v');
    private z_GetInternalformati64v_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64)>(z_GetInternalformati64v_adr);
    private z_GetInternalformati64v_ovr_0_anh000001 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformati64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformati64v_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64) :=
    z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params);
    private z_GetInternalformati64v_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformati64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformati64v_ovr_2(target, _internalformat, pname, count, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInvalidateSubdataARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_invalidate_subdata';
    
    private z_InvalidateTexSubImage_adr := GetProcAddress('glInvalidateTexSubImage');
    private z_InvalidateTexSubImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32)>(z_InvalidateTexSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexSubImage(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_InvalidateTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth);
    
    private z_InvalidateTexImage_adr := GetProcAddress('glInvalidateTexImage');
    private z_InvalidateTexImage_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32)>(z_InvalidateTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexImage(texture: gl_texture; level: Int32) :=
    z_InvalidateTexImage_ovr_0(texture, level);
    
    private z_InvalidateBufferSubData_adr := GetProcAddress('glInvalidateBufferSubData');
    private z_InvalidateBufferSubData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; length: IntPtr)>(z_InvalidateBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferSubData(buffer: gl_buffer; offset: IntPtr; length: IntPtr) :=
    z_InvalidateBufferSubData_ovr_0(buffer, offset, length);
    
    private z_InvalidateBufferData_adr := GetProcAddress('glInvalidateBufferData');
    private z_InvalidateBufferData_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer)>(z_InvalidateBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferData(buffer: gl_buffer) :=
    z_InvalidateBufferData_ovr_0(buffer);
    
    private z_InvalidateFramebuffer_adr := GetProcAddress('glInvalidateFramebuffer');
    private z_InvalidateFramebuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment)>(z_InvalidateFramebuffer_adr);
    private z_InvalidateFramebuffer_ovr_0_anh0001 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments[0]) else
      z_InvalidateFramebuffer_ovr_0_anh0001(target, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment) :=
    z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments);
    private z_InvalidateFramebuffer_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateFramebuffer_ovr_2(target, numAttachments, attachments);
    
    private z_InvalidateSubFramebuffer_adr := GetProcAddress('glInvalidateSubFramebuffer');
    private z_InvalidateSubFramebuffer_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    private z_InvalidateSubFramebuffer_ovr_0_anh00010000 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateSubFramebuffer_ovr_0_anh00010000(target, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments, x, y, width, height);
    private z_InvalidateSubFramebuffer_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_2(target, numAttachments, attachments, x, y, width, height);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMapBufferRangeARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_map_buffer_range';
    
    private z_MapBufferRange_adr := GetProcAddress('glMapBufferRange');
    private z_MapBufferRange_ovr_0 := GetProcOrNil&<function(target: BufferTarget; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBufferRange(target: BufferTarget; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapBufferRange_ovr_0(target, offset, length, access);
    
    private z_FlushMappedBufferRange_adr := GetProcAddress('glFlushMappedBufferRange');
    private z_FlushMappedBufferRange_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; length: IntPtr)>(z_FlushMappedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedBufferRange(target: BufferTarget; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedBufferRange_ovr_0(target, offset, length);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMatrixPaletteARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_matrix_palette';
    
    private z_CurrentPaletteMatrixARB_adr := GetProcAddress('glCurrentPaletteMatrixARB');
    private z_CurrentPaletteMatrixARB_ovr_0 := GetProcOrNil&<procedure(index: Int32)>(z_CurrentPaletteMatrixARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CurrentPaletteMatrixARB(index: Int32) :=
    z_CurrentPaletteMatrixARB_ovr_0(index);
    
    private z_MatrixIndexubvARB_adr := GetProcAddress('glMatrixIndexubvARB');
    private z_MatrixIndexubvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var indices: Byte)>(z_MatrixIndexubvARB_adr);
    private z_MatrixIndexubvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; indices: IntPtr)>(z_MatrixIndexubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexubvARB(size: Int32; indices: array of Byte) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MatrixIndexubvARB_ovr_0(size, indices[0]) else
      z_MatrixIndexubvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexubvARB(size: Int32; var indices: Byte) :=
    z_MatrixIndexubvARB_ovr_0(size, indices);
    private z_MatrixIndexubvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; indices: IntPtr)>(z_MatrixIndexubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexubvARB(size: Int32; indices: IntPtr) :=
    z_MatrixIndexubvARB_ovr_2(size, indices);
    
    private z_MatrixIndexusvARB_adr := GetProcAddress('glMatrixIndexusvARB');
    private z_MatrixIndexusvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var indices: UInt16)>(z_MatrixIndexusvARB_adr);
    private z_MatrixIndexusvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; indices: IntPtr)>(z_MatrixIndexusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexusvARB(size: Int32; indices: array of UInt16) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MatrixIndexusvARB_ovr_0(size, indices[0]) else
      z_MatrixIndexusvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexusvARB(size: Int32; var indices: UInt16) :=
    z_MatrixIndexusvARB_ovr_0(size, indices);
    private z_MatrixIndexusvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; indices: IntPtr)>(z_MatrixIndexusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexusvARB(size: Int32; indices: IntPtr) :=
    z_MatrixIndexusvARB_ovr_2(size, indices);
    
    private z_MatrixIndexuivARB_adr := GetProcAddress('glMatrixIndexuivARB');
    private z_MatrixIndexuivARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var indices: UInt32)>(z_MatrixIndexuivARB_adr);
    private z_MatrixIndexuivARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; indices: IntPtr)>(z_MatrixIndexuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexuivARB(size: Int32; indices: array of UInt32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MatrixIndexuivARB_ovr_0(size, indices[0]) else
      z_MatrixIndexuivARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexuivARB(size: Int32; var indices: UInt32) :=
    z_MatrixIndexuivARB_ovr_0(size, indices);
    private z_MatrixIndexuivARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; indices: IntPtr)>(z_MatrixIndexuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexuivARB(size: Int32; indices: IntPtr) :=
    z_MatrixIndexuivARB_ovr_2(size, indices);
    
    private z_MatrixIndexPointerARB_adr := GetProcAddress('glMatrixIndexPointerARB');
    private z_MatrixIndexPointerARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: MatrixIndexPointerTypeARB; stride: Int32; pointer: IntPtr)>(z_MatrixIndexPointerARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexPointerARB(size: Int32; &type: MatrixIndexPointerTypeARB; stride: Int32; pointer: IntPtr) :=
    z_MatrixIndexPointerARB_ovr_0(size, &type, stride, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultiBindARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_multi_bind';
    
    private z_BindBuffersBase_adr := GetProcAddress('glBindBuffersBase');
    private z_BindBuffersBase_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer)>(z_BindBuffersBase_adr);
    private z_BindBuffersBase_ovr_0_anh00001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr)>(z_BindBuffersBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersBase_ovr_0(target, first, count, buffers[0]) else
      z_BindBuffersBase_ovr_0_anh00001(target, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer) :=
    z_BindBuffersBase_ovr_0(target, first, count, buffers);
    private z_BindBuffersBase_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr)>(z_BindBuffersBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr) :=
    z_BindBuffersBase_ovr_2(target, first, count, buffers);
    
    private z_BindBuffersRange_adr := GetProcAddress('glBindBuffersRange');
    private z_BindBuffersRange_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000110 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000101 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000011 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000111 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000111(target, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_1_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_1_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_1_anh0000110 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000110 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_3_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_3_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_3_anh0000101 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindBuffersRange_ovr_4_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_5_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_6 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000101 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindBuffersRange_ovr_7_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_8 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_8_anh0000100 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_8(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_8_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_9_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_9_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_9_anh0000011 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_10_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_11_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_12_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_15_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_8(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_18 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000011 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_19_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_20 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_20_anh0000010 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_20_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_21_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_24 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_24_anh0000001 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_24_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_26 := GetProcOrNil&<procedure(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTarget; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_26(target, first, count, buffers, offsets, sizes);
    
    private z_BindTextures_adr := GetProcAddress('glBindTextures');
    private z_BindTextures_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var textures: gl_texture)>(z_BindTextures_adr);
    private z_BindTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindTextures_ovr_0(first, count, textures[0]) else
      z_BindTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; var textures: gl_texture) :=
    z_BindTextures_ovr_0(first, count, textures);
    private z_BindTextures_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindTextures_ovr_2(first, count, textures);
    
    private z_BindSamplers_adr := GetProcAddress('glBindSamplers');
    private z_BindSamplers_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var samplers: gl_sampler)>(z_BindSamplers_adr);
    private z_BindSamplers_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; samplers: IntPtr)>(z_BindSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_BindSamplers_ovr_0(first, count, samplers[0]) else
      z_BindSamplers_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; var samplers: gl_sampler) :=
    z_BindSamplers_ovr_0(first, count, samplers);
    private z_BindSamplers_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; samplers: IntPtr)>(z_BindSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: IntPtr) :=
    z_BindSamplers_ovr_2(first, count, samplers);
    
    private z_BindImageTextures_adr := GetProcAddress('glBindImageTextures');
    private z_BindImageTextures_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var textures: gl_texture)>(z_BindImageTextures_adr);
    private z_BindImageTextures_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindImageTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindImageTextures_ovr_0(first, count, textures[0]) else
      z_BindImageTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; var textures: gl_texture) :=
    z_BindImageTextures_ovr_0(first, count, textures);
    private z_BindImageTextures_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindImageTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindImageTextures_ovr_2(first, count, textures);
    
    private z_BindVertexBuffers_adr := GetProcAddress('glBindVertexBuffers');
    private z_BindVertexBuffers_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000110 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000101 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000011 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000111 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000111(first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_1_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_1_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_1_anh000110 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000110 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_3_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_3_anh000101 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_4_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_5_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_6 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000101 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_7_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_8 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_8_anh000100 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of gl_buffer; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_8(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_8_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_9_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_9_anh000011 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_10_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_11_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_2(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: gl_buffer; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_8(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_18 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000011 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_19_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_20 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_20_anh000010 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_20(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_20_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_20(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_24 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_24_anh000001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_24_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_26 := GetProcOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_26(first, count, buffers, offsets, strides);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultiDrawIndirectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_multi_draw_indirect';
    
    private z_MultiDrawArraysIndirect_adr := GetProcAddress('glMultiDrawArraysIndirect');
    private z_MultiDrawArraysIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirect_ovr_0(mode, indirect, drawcount, stride);
    
    private z_MultiDrawElementsIndirect_adr := GetProcAddress('glMultiDrawElementsIndirect');
    private z_MultiDrawElementsIndirect_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirect_ovr_0(mode, &type, indirect, drawcount, stride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultisampleARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_multisample';
    
    private z_SampleCoverageARB_adr := GetProcAddress('glSampleCoverageARB');
    private z_SampleCoverageARB_ovr_0 := GetProcOrNil&<procedure(value: single; invert: boolean)>(z_SampleCoverageARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleCoverageARB(value: single; invert: boolean) :=
    z_SampleCoverageARB_ovr_0(value, invert);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultitextureARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_multitexture';
    
    private z_ActiveTextureARB_adr := GetProcAddress('glActiveTextureARB');
    private z_ActiveTextureARB_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit)>(z_ActiveTextureARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveTextureARB(texture: TextureUnit) :=
    z_ActiveTextureARB_ovr_0(texture);
    
    private z_ClientActiveTextureARB_adr := GetProcAddress('glClientActiveTextureARB');
    private z_ClientActiveTextureARB_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit)>(z_ClientActiveTextureARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientActiveTextureARB(texture: TextureUnit) :=
    z_ClientActiveTextureARB_ovr_0(texture);
    
    private z_MultiTexCoord1dARB_adr := GetProcAddress('glMultiTexCoord1dARB');
    private z_MultiTexCoord1dARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real)>(z_MultiTexCoord1dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dARB(target: TextureUnit; s: real) :=
    z_MultiTexCoord1dARB_ovr_0(target, s);
    
    private z_MultiTexCoord1dvARB_adr := GetProcAddress('glMultiTexCoord1dvARB');
    private z_MultiTexCoord1dvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord1dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord1dvARB_ovr_0(target, v);
    private z_MultiTexCoord1dvARB_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1dvARB_ovr_1(target, v);
    
    private z_MultiTexCoord1fARB_adr := GetProcAddress('glMultiTexCoord1fARB');
    private z_MultiTexCoord1fARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single)>(z_MultiTexCoord1fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fARB(target: TextureUnit; s: single) :=
    z_MultiTexCoord1fARB_ovr_0(target, s);
    
    private z_MultiTexCoord1fvARB_adr := GetProcAddress('glMultiTexCoord1fvARB');
    private z_MultiTexCoord1fvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord1fvARB_ovr_0(target, v);
    private z_MultiTexCoord1fvARB_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1fvARB_ovr_1(target, v);
    
    private z_MultiTexCoord1iARB_adr := GetProcAddress('glMultiTexCoord1iARB');
    private z_MultiTexCoord1iARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32)>(z_MultiTexCoord1iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iARB(target: TextureUnit; s: Int32) :=
    z_MultiTexCoord1iARB_ovr_0(target, s);
    
    private z_MultiTexCoord1ivARB_adr := GetProcAddress('glMultiTexCoord1ivARB');
    private z_MultiTexCoord1ivARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord1ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord1ivARB_ovr_0(target, v);
    private z_MultiTexCoord1ivARB_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1ivARB_ovr_1(target, v);
    
    private z_MultiTexCoord1sARB_adr := GetProcAddress('glMultiTexCoord1sARB');
    private z_MultiTexCoord1sARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16)>(z_MultiTexCoord1sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sARB(target: TextureUnit; s: Int16) :=
    z_MultiTexCoord1sARB_ovr_0(target, s);
    
    private z_MultiTexCoord1svARB_adr := GetProcAddress('glMultiTexCoord1svARB');
    private z_MultiTexCoord1svARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord1svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord1svARB_ovr_0(target, v);
    private z_MultiTexCoord1svARB_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1svARB_ovr_1(target, v);
    
    private z_MultiTexCoord2dARB_adr := GetProcAddress('glMultiTexCoord2dARB');
    private z_MultiTexCoord2dARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real; t: real)>(z_MultiTexCoord2dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dARB(target: TextureUnit; s: real; t: real) :=
    z_MultiTexCoord2dARB_ovr_0(target, s, t);
    
    private z_MultiTexCoord2dvARB_adr := GetProcAddress('glMultiTexCoord2dvARB');
    private z_MultiTexCoord2dvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord2dvARB_adr);
    private z_MultiTexCoord2dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord2dvARB_ovr_0(target, v);
    private z_MultiTexCoord2dvARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2dvARB_ovr_2(target, v);
    
    private z_MultiTexCoord2fARB_adr := GetProcAddress('glMultiTexCoord2fARB');
    private z_MultiTexCoord2fARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single; t: single)>(z_MultiTexCoord2fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fARB(target: TextureUnit; s: single; t: single) :=
    z_MultiTexCoord2fARB_ovr_0(target, s, t);
    
    private z_MultiTexCoord2fvARB_adr := GetProcAddress('glMultiTexCoord2fvARB');
    private z_MultiTexCoord2fvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord2fvARB_adr);
    private z_MultiTexCoord2fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord2fvARB_ovr_0(target, v);
    private z_MultiTexCoord2fvARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2fvARB_ovr_2(target, v);
    
    private z_MultiTexCoord2iARB_adr := GetProcAddress('glMultiTexCoord2iARB');
    private z_MultiTexCoord2iARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32)>(z_MultiTexCoord2iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iARB(target: TextureUnit; s: Int32; t: Int32) :=
    z_MultiTexCoord2iARB_ovr_0(target, s, t);
    
    private z_MultiTexCoord2ivARB_adr := GetProcAddress('glMultiTexCoord2ivARB');
    private z_MultiTexCoord2ivARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord2ivARB_adr);
    private z_MultiTexCoord2ivARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord2ivARB_ovr_0(target, v);
    private z_MultiTexCoord2ivARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2ivARB_ovr_2(target, v);
    
    private z_MultiTexCoord2sARB_adr := GetProcAddress('glMultiTexCoord2sARB');
    private z_MultiTexCoord2sARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16)>(z_MultiTexCoord2sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sARB(target: TextureUnit; s: Int16; t: Int16) :=
    z_MultiTexCoord2sARB_ovr_0(target, s, t);
    
    private z_MultiTexCoord2svARB_adr := GetProcAddress('glMultiTexCoord2svARB');
    private z_MultiTexCoord2svARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord2svARB_adr);
    private z_MultiTexCoord2svARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord2svARB_ovr_0(target, v);
    private z_MultiTexCoord2svARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2svARB_ovr_2(target, v);
    
    private z_MultiTexCoord3dARB_adr := GetProcAddress('glMultiTexCoord3dARB');
    private z_MultiTexCoord3dARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real; t: real; r: real)>(z_MultiTexCoord3dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dARB(target: TextureUnit; s: real; t: real; r: real) :=
    z_MultiTexCoord3dARB_ovr_0(target, s, t, r);
    
    private z_MultiTexCoord3dvARB_adr := GetProcAddress('glMultiTexCoord3dvARB');
    private z_MultiTexCoord3dvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord3dvARB_adr);
    private z_MultiTexCoord3dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord3dvARB_ovr_0(target, v);
    private z_MultiTexCoord3dvARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3dvARB_ovr_2(target, v);
    
    private z_MultiTexCoord3fARB_adr := GetProcAddress('glMultiTexCoord3fARB');
    private z_MultiTexCoord3fARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single; t: single; r: single)>(z_MultiTexCoord3fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fARB(target: TextureUnit; s: single; t: single; r: single) :=
    z_MultiTexCoord3fARB_ovr_0(target, s, t, r);
    
    private z_MultiTexCoord3fvARB_adr := GetProcAddress('glMultiTexCoord3fvARB');
    private z_MultiTexCoord3fvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord3fvARB_adr);
    private z_MultiTexCoord3fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord3fvARB_ovr_0(target, v);
    private z_MultiTexCoord3fvARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3fvARB_ovr_2(target, v);
    
    private z_MultiTexCoord3iARB_adr := GetProcAddress('glMultiTexCoord3iARB');
    private z_MultiTexCoord3iARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32; r: Int32)>(z_MultiTexCoord3iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iARB(target: TextureUnit; s: Int32; t: Int32; r: Int32) :=
    z_MultiTexCoord3iARB_ovr_0(target, s, t, r);
    
    private z_MultiTexCoord3ivARB_adr := GetProcAddress('glMultiTexCoord3ivARB');
    private z_MultiTexCoord3ivARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord3ivARB_adr);
    private z_MultiTexCoord3ivARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord3ivARB_ovr_0(target, v);
    private z_MultiTexCoord3ivARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3ivARB_ovr_2(target, v);
    
    private z_MultiTexCoord3sARB_adr := GetProcAddress('glMultiTexCoord3sARB');
    private z_MultiTexCoord3sARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16; r: Int16)>(z_MultiTexCoord3sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sARB(target: TextureUnit; s: Int16; t: Int16; r: Int16) :=
    z_MultiTexCoord3sARB_ovr_0(target, s, t, r);
    
    private z_MultiTexCoord3svARB_adr := GetProcAddress('glMultiTexCoord3svARB');
    private z_MultiTexCoord3svARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord3svARB_adr);
    private z_MultiTexCoord3svARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord3svARB_ovr_0(target, v);
    private z_MultiTexCoord3svARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3svARB_ovr_2(target, v);
    
    private z_MultiTexCoord4dARB_adr := GetProcAddress('glMultiTexCoord4dARB');
    private z_MultiTexCoord4dARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: real; t: real; r: real; q: real)>(z_MultiTexCoord4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dARB(target: TextureUnit; s: real; t: real; r: real; q: real) :=
    z_MultiTexCoord4dARB_ovr_0(target, s, t, r, q);
    
    private z_MultiTexCoord4dvARB_adr := GetProcAddress('glMultiTexCoord4dvARB');
    private z_MultiTexCoord4dvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord4dvARB_adr);
    private z_MultiTexCoord4dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord4dvARB_ovr_0(target, v);
    private z_MultiTexCoord4dvARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4dvARB_ovr_2(target, v);
    
    private z_MultiTexCoord4fARB_adr := GetProcAddress('glMultiTexCoord4fARB');
    private z_MultiTexCoord4fARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: single; t: single; r: single; q: single)>(z_MultiTexCoord4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fARB(target: TextureUnit; s: single; t: single; r: single; q: single) :=
    z_MultiTexCoord4fARB_ovr_0(target, s, t, r, q);
    
    private z_MultiTexCoord4fvARB_adr := GetProcAddress('glMultiTexCoord4fvARB');
    private z_MultiTexCoord4fvARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord4fvARB_adr);
    private z_MultiTexCoord4fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord4fvARB_ovr_0(target, v);
    private z_MultiTexCoord4fvARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4fvARB_ovr_2(target, v);
    
    private z_MultiTexCoord4iARB_adr := GetProcAddress('glMultiTexCoord4iARB');
    private z_MultiTexCoord4iARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32)>(z_MultiTexCoord4iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iARB(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32) :=
    z_MultiTexCoord4iARB_ovr_0(target, s, t, r, q);
    
    private z_MultiTexCoord4ivARB_adr := GetProcAddress('glMultiTexCoord4ivARB');
    private z_MultiTexCoord4ivARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord4ivARB_adr);
    private z_MultiTexCoord4ivARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord4ivARB_ovr_0(target, v);
    private z_MultiTexCoord4ivARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4ivARB_ovr_2(target, v);
    
    private z_MultiTexCoord4sARB_adr := GetProcAddress('glMultiTexCoord4sARB');
    private z_MultiTexCoord4sARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16)>(z_MultiTexCoord4sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sARB(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16) :=
    z_MultiTexCoord4sARB_ovr_0(target, s, t, r, q);
    
    private z_MultiTexCoord4svARB_adr := GetProcAddress('glMultiTexCoord4svARB');
    private z_MultiTexCoord4svARB_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord4svARB_adr);
    private z_MultiTexCoord4svARB_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord4svARB_ovr_0(target, v);
    private z_MultiTexCoord4svARB_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4svARB_ovr_2(target, v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glOcclusionQueryARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_occlusion_query';
    
    private z_GenQueriesARB_adr := GetProcAddress('glGenQueriesARB');
    private z_GenQueriesARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_query)>(z_GenQueriesARB_adr);
    private z_GenQueriesARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenQueriesARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueriesARB(n: Int32; ids: array of gl_query) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenQueriesARB_ovr_0(n, ids[0]) else
      z_GenQueriesARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueriesARB(n: Int32; var ids: gl_query) :=
    z_GenQueriesARB_ovr_0(n, ids);
    private z_GenQueriesARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenQueriesARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueriesARB(n: Int32; ids: IntPtr) :=
    z_GenQueriesARB_ovr_2(n, ids);
    
    private z_DeleteQueriesARB_adr := GetProcAddress('glDeleteQueriesARB');
    private z_DeleteQueriesARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_query)>(z_DeleteQueriesARB_adr);
    private z_DeleteQueriesARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteQueriesARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueriesARB(n: Int32; ids: array of gl_query) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteQueriesARB_ovr_0(n, ids[0]) else
      z_DeleteQueriesARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueriesARB(n: Int32; var ids: gl_query) :=
    z_DeleteQueriesARB_ovr_0(n, ids);
    private z_DeleteQueriesARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteQueriesARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueriesARB(n: Int32; ids: IntPtr) :=
    z_DeleteQueriesARB_ovr_2(n, ids);
    
    private z_IsQueryARB_adr := GetProcAddress('glIsQueryARB');
    private z_IsQueryARB_ovr_0 := GetProcOrNil&<function(id: gl_query): boolean>(z_IsQueryARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsQueryARB(id: gl_query): boolean :=
    z_IsQueryARB_ovr_0(id);
    
    private z_BeginQueryARB_adr := GetProcAddress('glBeginQueryARB');
    private z_BeginQueryARB_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; id: gl_query)>(z_BeginQueryARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQueryARB(target: QueryTarget; id: gl_query) :=
    z_BeginQueryARB_ovr_0(target, id);
    
    private z_EndQueryARB_adr := GetProcAddress('glEndQueryARB');
    private z_EndQueryARB_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget)>(z_EndQueryARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQueryARB(target: QueryTarget) :=
    z_EndQueryARB_ovr_0(target);
    
    private z_GetQueryivARB_adr := GetProcAddress('glGetQueryivARB');
    private z_GetQueryivARB_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; var &params: Int32)>(z_GetQueryivARB_adr);
    private z_GetQueryivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryivARB(target: QueryTarget; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryivARB_ovr_0(target, pname, &params[0]) else
      z_GetQueryivARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryivARB(target: QueryTarget; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryivARB_ovr_0(target, pname, &params);
    private z_GetQueryivARB_ovr_2 := GetProcOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryivARB(target: QueryTarget; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryivARB_ovr_2(target, pname, &params);
    
    private z_GetQueryObjectivARB_adr := GetProcAddress('glGetQueryObjectivARB');
    private z_GetQueryObjectivARB_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: Int32)>(z_GetQueryObjectivARB_adr);
    private z_GetQueryObjectivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectivARB(id: gl_query; pname: QueryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectivARB_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectivARB_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectivARB(id: gl_query; pname: QueryObjectParameterName; var &params: Int32) :=
    z_GetQueryObjectivARB_ovr_0(id, pname, &params);
    private z_GetQueryObjectivARB_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectivARB(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectivARB_ovr_2(id, pname, &params);
    
    private z_GetQueryObjectuivARB_adr := GetProcAddress('glGetQueryObjectuivARB');
    private z_GetQueryObjectuivARB_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: UInt32)>(z_GetQueryObjectuivARB_adr);
    private z_GetQueryObjectuivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuivARB(id: gl_query; pname: QueryObjectParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectuivARB_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectuivARB_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuivARB(id: gl_query; pname: QueryObjectParameterName; var &params: UInt32) :=
    z_GetQueryObjectuivARB_ovr_0(id, pname, &params);
    private z_GetQueryObjectuivARB_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuivARB(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectuivARB_ovr_2(id, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glParallelShaderCompileARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_parallel_shader_compile';
    
    private z_MaxShaderCompilerThreadsARB_adr := GetProcAddress('glMaxShaderCompilerThreadsARB');
    private z_MaxShaderCompilerThreadsARB_ovr_0 := GetProcOrNil&<procedure(count: UInt32)>(z_MaxShaderCompilerThreadsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaxShaderCompilerThreadsARB(count: UInt32) :=
    z_MaxShaderCompilerThreadsARB_ovr_0(count);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPointParametersARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_point_parameters';
    
    private z_PointParameterfARB_adr := GetProcAddress('glPointParameterfARB');
    private z_PointParameterfARB_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; param: single)>(z_PointParameterfARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfARB(pname: PointParameterNameARB; param: single) :=
    z_PointParameterfARB_ovr_0(pname, param);
    
    private z_PointParameterfvARB_adr := GetProcAddress('glPointParameterfvARB');
    private z_PointParameterfvARB_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: single)>(z_PointParameterfvARB_adr);
    private z_PointParameterfvARB_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvARB(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfvARB_ovr_0(pname, &params[0]) else
      z_PointParameterfvARB_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvARB(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfvARB_ovr_0(pname, &params);
    private z_PointParameterfvARB_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvARB(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfvARB_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPolygonOffsetClampARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_polygon_offset_clamp';
    
    private z_PolygonOffsetClamp_adr := GetProcAddress('glPolygonOffsetClamp');
    private z_PolygonOffsetClamp_ovr_0 := GetProcOrNil&<procedure(factor: single; units: single; clamp: single)>(z_PolygonOffsetClamp_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetClamp(factor: single; units: single; clamp: single) :=
    z_PolygonOffsetClamp_ovr_0(factor, units, clamp);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glProgramInterfaceQueryARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_program_interface_query';
    
    private z_GetProgramInterfaceiv_adr := GetProcAddress('glGetProgramInterfaceiv');
    private z_GetProgramInterfaceiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32)>(z_GetProgramInterfaceiv_adr);
    private z_GetProgramInterfaceiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr)>(z_GetProgramInterfaceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params[0]) else
      z_GetProgramInterfaceiv_ovr_0_anh00001(&program, _programInterface, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32) :=
    z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params);
    private z_GetProgramInterfaceiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr)>(z_GetProgramInterfaceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: gl_program; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr) :=
    z_GetProgramInterfaceiv_ovr_2(&program, _programInterface, pname, &params);
    
    private z_GetProgramResourceIndex_adr := GetProcAddress('glGetProgramResourceIndex');
    private z_GetProgramResourceIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): UInt32>(z_GetProgramResourceIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: gl_program; _programInterface: ProgramInterface; name: string): UInt32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetProgramResourceIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): UInt32 :=
    z_GetProgramResourceIndex_ovr_0(&program, _programInterface, name);
    
    private z_GetProgramResourceName_adr := GetProcAddress('glGetProgramResourceName');
    private z_GetProgramResourceName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetProgramResourceName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetProgramResourceName_ovr_0(&program, _programInterface, index, bufSize, length, name);
    private z_GetProgramResourceName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetProgramResourceName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetProgramResourceName_ovr_1(&program, _programInterface, index, bufSize, length, name);
    
    private z_GetProgramResourceiv_adr := GetProcAddress('glGetProgramResourceiv');
    private z_GetProgramResourceiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_1_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_2_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000001001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_3_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_3_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_3_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_4_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_3_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_5_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_5(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_5_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_3_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_3(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_5(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_12 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_12_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_12(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_12_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_12(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_14 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_14(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_15 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_15_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_15(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_15_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_15(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_17 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_17(&program, _programInterface, index, propCount, props, count, length, &params);
    
    private z_GetProgramResourceLocation_adr := GetProcAddress('glGetProgramResourceLocation');
    private z_GetProgramResourceLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32>(z_GetProgramResourceLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: gl_program; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetProgramResourceLocation_ovr_0(&program, _programInterface, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocation_ovr_0(&program, _programInterface, name);
    
    private z_GetProgramResourceLocationIndex_adr := GetProcAddress('glGetProgramResourceLocationIndex');
    private z_GetProgramResourceLocationIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32>(z_GetProgramResourceLocationIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: gl_program; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: gl_program; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glProvokingVertexARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_provoking_vertex';
    
    private z_ProvokingVertex_adr := GetProcAddress('glProvokingVertex');
    private z_ProvokingVertex_ovr_0 := GetProcOrNil&<procedure(mode: VertexProvokingMode)>(z_ProvokingVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProvokingVertex(mode: VertexProvokingMode) :=
    z_ProvokingVertex_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glRobustnessARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_robustness';
    
    private z_GetGraphicsResetStatusARB_adr := GetProcAddress('glGetGraphicsResetStatusARB');
    private z_GetGraphicsResetStatusARB_ovr_0 := GetProcOrNil&<function: GraphicsResetStatus>(z_GetGraphicsResetStatusARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGraphicsResetStatusARB: GraphicsResetStatus :=
    z_GetGraphicsResetStatusARB_ovr_0;
    
    private z_GetnTexImageARB_adr := GetProcAddress('glGetnTexImageARB');
    private z_GetnTexImageARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; img: IntPtr)>(z_GetnTexImageARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnTexImageARB(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; img: IntPtr) :=
    z_GetnTexImageARB_ovr_0(target, level, format, &type, bufSize, img);
    
    private z_ReadnPixelsARB_adr := GetProcAddress('glReadnPixelsARB');
    private z_ReadnPixelsARB_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr)>(z_ReadnPixelsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadnPixelsARB(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr) :=
    z_ReadnPixelsARB_ovr_0(x, y, width, height, format, &type, bufSize, data);
    
    private z_GetnCompressedTexImageARB_adr := GetProcAddress('glGetnCompressedTexImageARB');
    private z_GetnCompressedTexImageARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; lod: Int32; bufSize: Int32; img: IntPtr)>(z_GetnCompressedTexImageARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnCompressedTexImageARB(target: TextureTarget; lod: Int32; bufSize: Int32; img: IntPtr) :=
    z_GetnCompressedTexImageARB_ovr_0(target, lod, bufSize, img);
    
    private z_GetnUniformfvARB_adr := GetProcAddress('glGetnUniformfvARB');
    private z_GetnUniformfvARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: single)>(z_GetnUniformfvARB_adr);
    private z_GetnUniformfvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfvARB(&program: gl_program; location: Int32; bufSize: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformfvARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformfvARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfvARB(&program: gl_program; location: Int32; bufSize: Int32; var &params: single) :=
    z_GetnUniformfvARB_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformfvARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfvARB(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformfvARB_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnUniformivARB_adr := GetProcAddress('glGetnUniformivARB');
    private z_GetnUniformivARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int32)>(z_GetnUniformivARB_adr);
    private z_GetnUniformivARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformivARB(&program: gl_program; location: Int32; bufSize: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformivARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformivARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformivARB(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int32) :=
    z_GetnUniformivARB_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformivARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformivARB(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformivARB_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnUniformuivARB_adr := GetProcAddress('glGetnUniformuivARB');
    private z_GetnUniformuivARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt32)>(z_GetnUniformuivARB_adr);
    private z_GetnUniformuivARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuivARB(&program: gl_program; location: Int32; bufSize: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformuivARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformuivARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuivARB(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt32) :=
    z_GetnUniformuivARB_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformuivARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuivARB(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformuivARB_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnUniformdvARB_adr := GetProcAddress('glGetnUniformdvARB');
    private z_GetnUniformdvARB_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: real)>(z_GetnUniformdvARB_adr);
    private z_GetnUniformdvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdvARB(&program: gl_program; location: Int32; bufSize: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformdvARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformdvARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdvARB(&program: gl_program; location: Int32; bufSize: Int32; var &params: real) :=
    z_GetnUniformdvARB_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformdvARB_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdvARB(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformdvARB_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnMapdvARB_adr := GetProcAddress('glGetnMapdvARB');
    private z_GetnMapdvARB_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real)>(z_GetnMapdvARB_adr);
    private z_GetnMapdvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapdvARB_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapdvARB_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdvARB(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real) :=
    z_GetnMapdvARB_ovr_0(target, query, bufSize, v);
    private z_GetnMapdvARB_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapdvARB_ovr_2(target, query, bufSize, v);
    
    private z_GetnMapfvARB_adr := GetProcAddress('glGetnMapfvARB');
    private z_GetnMapfvARB_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single)>(z_GetnMapfvARB_adr);
    private z_GetnMapfvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapfvARB_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapfvARB_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfvARB(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single) :=
    z_GetnMapfvARB_ovr_0(target, query, bufSize, v);
    private z_GetnMapfvARB_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapfvARB_ovr_2(target, query, bufSize, v);
    
    private z_GetnMapivARB_adr := GetProcAddress('glGetnMapivARB');
    private z_GetnMapivARB_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32)>(z_GetnMapivARB_adr);
    private z_GetnMapivARB_ovr_0_anh00001 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapivARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapivARB_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapivARB_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapivARB(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32) :=
    z_GetnMapivARB_ovr_0(target, query, bufSize, v);
    private z_GetnMapivARB_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapivARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapivARB_ovr_2(target, query, bufSize, v);
    
    private z_GetnPixelMapfvARB_adr := GetProcAddress('glGetnPixelMapfvARB');
    private z_GetnPixelMapfvARB_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: single)>(z_GetnPixelMapfvARB_adr);
    private z_GetnPixelMapfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfvARB(map: PixelMap; bufSize: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapfvARB_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapfvARB_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfvARB(map: PixelMap; bufSize: Int32; var values: single) :=
    z_GetnPixelMapfvARB_ovr_0(map, bufSize, values);
    private z_GetnPixelMapfvARB_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfvARB(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapfvARB_ovr_2(map, bufSize, values);
    
    private z_GetnPixelMapuivARB_adr := GetProcAddress('glGetnPixelMapuivARB');
    private z_GetnPixelMapuivARB_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: UInt32)>(z_GetnPixelMapuivARB_adr);
    private z_GetnPixelMapuivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuivARB(map: PixelMap; bufSize: Int32; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapuivARB_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapuivARB_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuivARB(map: PixelMap; bufSize: Int32; var values: UInt32) :=
    z_GetnPixelMapuivARB_ovr_0(map, bufSize, values);
    private z_GetnPixelMapuivARB_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuivARB(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapuivARB_ovr_2(map, bufSize, values);
    
    private z_GetnPixelMapusvARB_adr := GetProcAddress('glGetnPixelMapusvARB');
    private z_GetnPixelMapusvARB_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: UInt16)>(z_GetnPixelMapusvARB_adr);
    private z_GetnPixelMapusvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusvARB(map: PixelMap; bufSize: Int32; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapusvARB_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapusvARB_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusvARB(map: PixelMap; bufSize: Int32; var values: UInt16) :=
    z_GetnPixelMapusvARB_ovr_0(map, bufSize, values);
    private z_GetnPixelMapusvARB_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusvARB(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapusvARB_ovr_2(map, bufSize, values);
    
    private z_GetnPolygonStippleARB_adr := GetProcAddress('glGetnPolygonStippleARB');
    private z_GetnPolygonStippleARB_ovr_0 := GetProcOrNil&<procedure(bufSize: Int32; var pattern: Byte)>(z_GetnPolygonStippleARB_adr);
    private z_GetnPolygonStippleARB_ovr_0_anh001 := GetProcOrNil&<procedure(bufSize: Int32; pattern: IntPtr)>(z_GetnPolygonStippleARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStippleARB(bufSize: Int32; pattern: array of Byte) :=
    if (pattern<>nil) and (pattern.Length<>0) then
      z_GetnPolygonStippleARB_ovr_0(bufSize, pattern[0]) else
      z_GetnPolygonStippleARB_ovr_0_anh001(bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStippleARB(bufSize: Int32; var pattern: Byte) :=
    z_GetnPolygonStippleARB_ovr_0(bufSize, pattern);
    private z_GetnPolygonStippleARB_ovr_2 := GetProcOrNil&<procedure(bufSize: Int32; pattern: IntPtr)>(z_GetnPolygonStippleARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStippleARB(bufSize: Int32; pattern: IntPtr) :=
    z_GetnPolygonStippleARB_ovr_2(bufSize, pattern);
    
    private z_GetnColorTableARB_adr := GetProcAddress('glGetnColorTableARB');
    private z_GetnColorTableARB_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr)>(z_GetnColorTableARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnColorTableARB(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr) :=
    z_GetnColorTableARB_ovr_0(target, format, &type, bufSize, table);
    
    private z_GetnConvolutionFilterARB_adr := GetProcAddress('glGetnConvolutionFilterARB');
    private z_GetnConvolutionFilterARB_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr)>(z_GetnConvolutionFilterARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnConvolutionFilterARB(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr) :=
    z_GetnConvolutionFilterARB_ovr_0(target, format, &type, bufSize, image);
    
    private z_GetnSeparableFilterARB_adr := GetProcAddress('glGetnSeparableFilterARB');
    private z_GetnSeparableFilterARB_ovr_0 := GetProcOrNil&<procedure(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr)>(z_GetnSeparableFilterARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnSeparableFilterARB(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr) :=
    z_GetnSeparableFilterARB_ovr_0(target, format, &type, rowBufSize, row, columnBufSize, column, span);
    
    private z_GetnHistogramARB_adr := GetProcAddress('glGetnHistogramARB');
    private z_GetnHistogramARB_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr)>(z_GetnHistogramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnHistogramARB(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnHistogramARB_ovr_0(target, reset, format, &type, bufSize, values);
    
    private z_GetnMinmaxARB_adr := GetProcAddress('glGetnMinmaxARB');
    private z_GetnMinmaxARB_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr)>(z_GetnMinmaxARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMinmaxARB(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnMinmaxARB_ovr_0(target, reset, format, &type, bufSize, values);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSampleLocationsARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_sample_locations';
    
    private z_FramebufferSampleLocationsfvARB_adr := GetProcAddress('glFramebufferSampleLocationsfvARB');
    private z_FramebufferSampleLocationsfvARB_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; start: UInt32; count: Int32; var v: single)>(z_FramebufferSampleLocationsfvARB_adr);
    private z_FramebufferSampleLocationsfvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr)>(z_FramebufferSampleLocationsfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvARB(target: FramebufferTarget; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_FramebufferSampleLocationsfvARB_ovr_0(target, start, count, v[0]) else
      z_FramebufferSampleLocationsfvARB_ovr_0_anh00001(target, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvARB(target: FramebufferTarget; start: UInt32; count: Int32; var v: single) :=
    z_FramebufferSampleLocationsfvARB_ovr_0(target, start, count, v);
    private z_FramebufferSampleLocationsfvARB_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr)>(z_FramebufferSampleLocationsfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvARB(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr) :=
    z_FramebufferSampleLocationsfvARB_ovr_2(target, start, count, v);
    
    private z_NamedFramebufferSampleLocationsfvARB_adr := GetProcAddress('glNamedFramebufferSampleLocationsfvARB');
    private z_NamedFramebufferSampleLocationsfvARB_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; start: UInt32; count: Int32; var v: single)>(z_NamedFramebufferSampleLocationsfvARB_adr);
    private z_NamedFramebufferSampleLocationsfvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr)>(z_NamedFramebufferSampleLocationsfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvARB(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_NamedFramebufferSampleLocationsfvARB_ovr_0(framebuffer, start, count, v[0]) else
      z_NamedFramebufferSampleLocationsfvARB_ovr_0_anh00001(framebuffer, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvARB(framebuffer: gl_framebuffer; start: UInt32; count: Int32; var v: single) :=
    z_NamedFramebufferSampleLocationsfvARB_ovr_0(framebuffer, start, count, v);
    private z_NamedFramebufferSampleLocationsfvARB_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr)>(z_NamedFramebufferSampleLocationsfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvARB(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr) :=
    z_NamedFramebufferSampleLocationsfvARB_ovr_2(framebuffer, start, count, v);
    
    private z_EvaluateDepthValuesARB_adr := GetProcAddress('glEvaluateDepthValuesARB');
    private z_EvaluateDepthValuesARB_ovr_0 := GetProcOrNil&<procedure>(z_EvaluateDepthValuesARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvaluateDepthValuesARB :=
    z_EvaluateDepthValuesARB_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSampleShadingARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_sample_shading';
    
    private z_MinSampleShadingARB_adr := GetProcAddress('glMinSampleShadingARB');
    private z_MinSampleShadingARB_ovr_0 := GetProcOrNil&<procedure(value: single)>(z_MinSampleShadingARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MinSampleShadingARB(value: single) :=
    z_MinSampleShadingARB_ovr_0(value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSamplerObjectsARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_sampler_objects';
    
    private z_GenSamplers_adr := GetProcAddress('glGenSamplers');
    private z_GenSamplers_ovr_0 := GetProcOrNil&<procedure(count: Int32; var samplers: gl_sampler)>(z_GenSamplers_adr);
    private z_GenSamplers_ovr_0_anh001 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_GenSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_GenSamplers_ovr_0(count, samplers[0]) else
      z_GenSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; var samplers: gl_sampler) :=
    z_GenSamplers_ovr_0(count, samplers);
    private z_GenSamplers_ovr_2 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_GenSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: IntPtr) :=
    z_GenSamplers_ovr_2(count, samplers);
    
    private z_DeleteSamplers_adr := GetProcAddress('glDeleteSamplers');
    private z_DeleteSamplers_ovr_0 := GetProcOrNil&<procedure(count: Int32; var samplers: gl_sampler)>(z_DeleteSamplers_adr);
    private z_DeleteSamplers_ovr_0_anh001 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_DeleteSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: array of gl_sampler) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_DeleteSamplers_ovr_0(count, samplers[0]) else
      z_DeleteSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; var samplers: gl_sampler) :=
    z_DeleteSamplers_ovr_0(count, samplers);
    private z_DeleteSamplers_ovr_2 := GetProcOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_DeleteSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: IntPtr) :=
    z_DeleteSamplers_ovr_2(count, samplers);
    
    private z_IsSampler_adr := GetProcAddress('glIsSampler');
    private z_IsSampler_ovr_0 := GetProcOrNil&<function(sampler: gl_sampler): boolean>(z_IsSampler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSampler(sampler: gl_sampler): boolean :=
    z_IsSampler_ovr_0(sampler);
    
    private z_BindSampler_adr := GetProcAddress('glBindSampler');
    private z_BindSampler_ovr_0 := GetProcOrNil&<procedure(&unit: UInt32; sampler: gl_sampler)>(z_BindSampler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSampler(&unit: UInt32; sampler: gl_sampler) :=
    z_BindSampler_ovr_0(&unit, sampler);
    
    private z_SamplerParameteri_adr := GetProcAddress('glSamplerParameteri');
    private z_SamplerParameteri_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: Int32)>(z_SamplerParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteri(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: Int32) :=
    z_SamplerParameteri_ovr_0(sampler, pname, param);
    
    private z_SamplerParameteriv_adr := GetProcAddress('glSamplerParameteriv');
    private z_SamplerParameteriv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32)>(z_SamplerParameteriv_adr);
    private z_SamplerParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameteriv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameteriv_ovr_0(sampler, pname, param);
    private z_SamplerParameteriv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameteriv_ovr_2(sampler, pname, param);
    
    private z_SamplerParameterf_adr := GetProcAddress('glSamplerParameterf');
    private z_SamplerParameterf_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: single)>(z_SamplerParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterf(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: single) :=
    z_SamplerParameterf_ovr_0(sampler, pname, param);
    
    private z_SamplerParameterfv_adr := GetProcAddress('glSamplerParameterfv');
    private z_SamplerParameterfv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; var param: single)>(z_SamplerParameterfv_adr);
    private z_SamplerParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: IntPtr)>(z_SamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterfv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; var param: single) :=
    z_SamplerParameterfv_ovr_0(sampler, pname, param);
    private z_SamplerParameterfv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: IntPtr)>(z_SamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; param: IntPtr) :=
    z_SamplerParameterfv_ovr_2(sampler, pname, param);
    
    private z_SamplerParameterIiv_adr := GetProcAddress('glSamplerParameterIiv');
    private z_SamplerParameterIiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32)>(z_SamplerParameterIiv_adr);
    private z_SamplerParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameterIiv_ovr_0(sampler, pname, param);
    private z_SamplerParameterIiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIiv_ovr_2(sampler, pname, param);
    
    private z_SamplerParameterIuiv_adr := GetProcAddress('glSamplerParameterIuiv');
    private z_SamplerParameterIuiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: UInt32)>(z_SamplerParameterIuiv_adr);
    private z_SamplerParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: array of UInt32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIuiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var param: UInt32) :=
    z_SamplerParameterIuiv_ovr_0(sampler, pname, param);
    private z_SamplerParameterIuiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIuiv_ovr_2(sampler, pname, param);
    
    private z_GetSamplerParameteriv_adr := GetProcAddress('glGetSamplerParameteriv');
    private z_GetSamplerParameteriv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var &params: Int32)>(z_GetSamplerParameteriv_adr);
    private z_GetSamplerParameteriv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameteriv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameteriv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameteriv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameteriv_ovr_2(sampler, pname, &params);
    
    private z_GetSamplerParameterIiv_adr := GetProcAddress('glGetSamplerParameterIiv');
    private z_GetSamplerParameterIiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var &params: Int32)>(z_GetSamplerParameterIiv_adr);
    private z_GetSamplerParameterIiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterIiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIiv_ovr_2(sampler, pname, &params);
    
    private z_GetSamplerParameterfv_adr := GetProcAddress('glGetSamplerParameterfv');
    private z_GetSamplerParameterfv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; var &params: single)>(z_GetSamplerParameterfv_adr);
    private z_GetSamplerParameterfv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; &params: IntPtr)>(z_GetSamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterfv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; var &params: single) :=
    z_GetSamplerParameterfv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterfv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; &params: IntPtr)>(z_GetSamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: gl_sampler; pname: OpenGL.SamplerParameterF; &params: IntPtr) :=
    z_GetSamplerParameterfv_ovr_2(sampler, pname, &params);
    
    private z_GetSamplerParameterIuiv_adr := GetProcAddress('glGetSamplerParameterIuiv');
    private z_GetSamplerParameterIuiv_ovr_0 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var &params: UInt32)>(z_GetSamplerParameterIuiv_adr);
    private z_GetSamplerParameterIuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; var &params: UInt32) :=
    z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterIuiv_ovr_2 := GetProcOrNil&<procedure(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: gl_sampler; pname: OpenGL.SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIuiv_ovr_2(sampler, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSeparateShaderObjectsARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_separate_shader_objects';
    
    private z_UseProgramStages_adr := GetProcAddress('glUseProgramStages');
    private z_UseProgramStages_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; stages: UseProgramStageMask; &program: gl_program)>(z_UseProgramStages_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgramStages(pipeline: gl_program_pipeline; stages: UseProgramStageMask; &program: gl_program) :=
    z_UseProgramStages_ovr_0(pipeline, stages, &program);
    
    private z_ActiveShaderProgram_adr := GetProcAddress('glActiveShaderProgram');
    private z_ActiveShaderProgram_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; &program: gl_program)>(z_ActiveShaderProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveShaderProgram(pipeline: gl_program_pipeline; &program: gl_program) :=
    z_ActiveShaderProgram_ovr_0(pipeline, &program);
    
    private z_CreateShaderProgramv_adr := GetProcAddress('glCreateShaderProgramv');
    private z_CreateShaderProgramv_ovr_0 := GetProcOrNil&<function(&type: ShaderType; count: Int32; var strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    private z_CreateShaderProgramv_ovr_0_anh0001 := GetProcOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of string): gl_program;
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := strings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          Result := z_CreateShaderProgramv_ovr_0(&type, count, par_3_str_ptr[0]) else
          Result := z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_CreateShaderProgramv_ovr_1_anh0001 := GetProcOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of IntPtr): gl_program :=
    if (strings<>nil) and (strings.Length<>0) then
      z_CreateShaderProgramv_ovr_0(&type, count, strings[0]) else
      z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
    private z_CreateShaderProgramv_ovr_2 := GetProcOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): gl_program>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: IntPtr): gl_program :=
    z_CreateShaderProgramv_ovr_2(&type, count, strings);
    
    private z_BindProgramPipeline_adr := GetProcAddress('glBindProgramPipeline');
    private z_BindProgramPipeline_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline)>(z_BindProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramPipeline(pipeline: gl_program_pipeline) :=
    z_BindProgramPipeline_ovr_0(pipeline);
    
    private z_DeleteProgramPipelines_adr := GetProcAddress('glDeleteProgramPipelines');
    private z_DeleteProgramPipelines_ovr_0 := GetProcOrNil&<procedure(n: Int32; var pipelines: gl_program_pipeline)>(z_DeleteProgramPipelines_adr);
    private z_DeleteProgramPipelines_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_DeleteProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: array of gl_program_pipeline) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_DeleteProgramPipelines_ovr_0(n, pipelines[0]) else
      z_DeleteProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; var pipelines: gl_program_pipeline) :=
    z_DeleteProgramPipelines_ovr_0(n, pipelines);
    private z_DeleteProgramPipelines_ovr_2 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_DeleteProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_DeleteProgramPipelines_ovr_2(n, pipelines);
    
    private z_GenProgramPipelines_adr := GetProcAddress('glGenProgramPipelines');
    private z_GenProgramPipelines_ovr_0 := GetProcOrNil&<procedure(n: Int32; var pipelines: gl_program_pipeline)>(z_GenProgramPipelines_adr);
    private z_GenProgramPipelines_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_GenProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: array of gl_program_pipeline) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_GenProgramPipelines_ovr_0(n, pipelines[0]) else
      z_GenProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; var pipelines: gl_program_pipeline) :=
    z_GenProgramPipelines_ovr_0(n, pipelines);
    private z_GenProgramPipelines_ovr_2 := GetProcOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_GenProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_GenProgramPipelines_ovr_2(n, pipelines);
    
    private z_IsProgramPipeline_adr := GetProcAddress('glIsProgramPipeline');
    private z_IsProgramPipeline_ovr_0 := GetProcOrNil&<function(pipeline: gl_program_pipeline): boolean>(z_IsProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramPipeline(pipeline: gl_program_pipeline): boolean :=
    z_IsProgramPipeline_ovr_0(pipeline);
    
    private z_GetProgramPipelineiv_adr := GetProcAddress('glGetProgramPipelineiv');
    private z_GetProgramPipelineiv_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; pname: PipelineParameterName; var &params: Int32)>(z_GetProgramPipelineiv_adr);
    private z_GetProgramPipelineiv_ovr_0_anh0001 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: IntPtr)>(z_GetProgramPipelineiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params[0]) else
      z_GetProgramPipelineiv_ovr_0_anh0001(pipeline, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: gl_program_pipeline; pname: PipelineParameterName; var &params: Int32) :=
    z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params);
    private z_GetProgramPipelineiv_ovr_2 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: IntPtr)>(z_GetProgramPipelineiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: gl_program_pipeline; pname: PipelineParameterName; &params: IntPtr) :=
    z_GetProgramPipelineiv_ovr_2(pipeline, pname, &params);
    
    private z_ProgramParameteri_adr := GetProcAddress('glProgramParameteri');
    private z_ProgramParameteri_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramParameterPName; value: Int32)>(z_ProgramParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteri(&program: gl_program; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteri_ovr_0(&program, pname, value);
    
    private z_ProgramUniform1i_adr := GetProcAddress('glProgramUniform1i');
    private z_ProgramUniform1i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32)>(z_ProgramUniform1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i(&program: gl_program; location: Int32; v0: Int32) :=
    z_ProgramUniform1i_ovr_0(&program, location, v0);
    
    private z_ProgramUniform1iv_adr := GetProcAddress('glProgramUniform1iv');
    private z_ProgramUniform1iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform1iv_adr);
    private z_ProgramUniform1iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform1iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1iv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1f_adr := GetProcAddress('glProgramUniform1f');
    private z_ProgramUniform1f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single)>(z_ProgramUniform1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1f(&program: gl_program; location: Int32; v0: single) :=
    z_ProgramUniform1f_ovr_0(&program, location, v0);
    
    private z_ProgramUniform1fv_adr := GetProcAddress('glProgramUniform1fv');
    private z_ProgramUniform1fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform1fv_adr);
    private z_ProgramUniform1fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform1fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1fv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1d_adr := GetProcAddress('glProgramUniform1d');
    private z_ProgramUniform1d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real)>(z_ProgramUniform1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1d(&program: gl_program; location: Int32; v0: real) :=
    z_ProgramUniform1d_ovr_0(&program, location, v0);
    
    private z_ProgramUniform1dv_adr := GetProcAddress('glProgramUniform1dv');
    private z_ProgramUniform1dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform1dv_adr);
    private z_ProgramUniform1dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform1dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1dv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1ui_adr := GetProcAddress('glProgramUniform1ui');
    private z_ProgramUniform1ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32)>(z_ProgramUniform1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui(&program: gl_program; location: Int32; v0: UInt32) :=
    z_ProgramUniform1ui_ovr_0(&program, location, v0);
    
    private z_ProgramUniform1uiv_adr := GetProcAddress('glProgramUniform1uiv');
    private z_ProgramUniform1uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform1uiv_adr);
    private z_ProgramUniform1uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform1uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1uiv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2i_adr := GetProcAddress('glProgramUniform2i');
    private z_ProgramUniform2i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32)>(z_ProgramUniform2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i(&program: gl_program; location: Int32; v0: Int32; v1: Int32) :=
    z_ProgramUniform2i_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform2iv_adr := GetProcAddress('glProgramUniform2iv');
    private z_ProgramUniform2iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform2iv_adr);
    private z_ProgramUniform2iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform2iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2iv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2f_adr := GetProcAddress('glProgramUniform2f');
    private z_ProgramUniform2f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single)>(z_ProgramUniform2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2f(&program: gl_program; location: Int32; v0: single; v1: single) :=
    z_ProgramUniform2f_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform2fv_adr := GetProcAddress('glProgramUniform2fv');
    private z_ProgramUniform2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform2fv_adr);
    private z_ProgramUniform2fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform2fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2fv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2d_adr := GetProcAddress('glProgramUniform2d');
    private z_ProgramUniform2d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real; v1: real)>(z_ProgramUniform2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2d(&program: gl_program; location: Int32; v0: real; v1: real) :=
    z_ProgramUniform2d_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform2dv_adr := GetProcAddress('glProgramUniform2dv');
    private z_ProgramUniform2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform2dv_adr);
    private z_ProgramUniform2dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform2dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2dv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2ui_adr := GetProcAddress('glProgramUniform2ui');
    private z_ProgramUniform2ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32)>(z_ProgramUniform2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32) :=
    z_ProgramUniform2ui_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform2uiv_adr := GetProcAddress('glProgramUniform2uiv');
    private z_ProgramUniform2uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform2uiv_adr);
    private z_ProgramUniform2uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform2uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2uiv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3i_adr := GetProcAddress('glProgramUniform3i');
    private z_ProgramUniform3i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_ProgramUniform3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_ProgramUniform3i_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform3iv_adr := GetProcAddress('glProgramUniform3iv');
    private z_ProgramUniform3iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform3iv_adr);
    private z_ProgramUniform3iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform3iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3iv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3f_adr := GetProcAddress('glProgramUniform3f');
    private z_ProgramUniform3f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single; v2: single)>(z_ProgramUniform3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3f(&program: gl_program; location: Int32; v0: single; v1: single; v2: single) :=
    z_ProgramUniform3f_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform3fv_adr := GetProcAddress('glProgramUniform3fv');
    private z_ProgramUniform3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform3fv_adr);
    private z_ProgramUniform3fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform3fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3fv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3d_adr := GetProcAddress('glProgramUniform3d');
    private z_ProgramUniform3d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real; v1: real; v2: real)>(z_ProgramUniform3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3d(&program: gl_program; location: Int32; v0: real; v1: real; v2: real) :=
    z_ProgramUniform3d_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform3dv_adr := GetProcAddress('glProgramUniform3dv');
    private z_ProgramUniform3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform3dv_adr);
    private z_ProgramUniform3dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform3dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3dv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3ui_adr := GetProcAddress('glProgramUniform3ui');
    private z_ProgramUniform3ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_ProgramUniform3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_ProgramUniform3ui_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform3uiv_adr := GetProcAddress('glProgramUniform3uiv');
    private z_ProgramUniform3uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform3uiv_adr);
    private z_ProgramUniform3uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform3uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3uiv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4i_adr := GetProcAddress('glProgramUniform4i');
    private z_ProgramUniform4i_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_ProgramUniform4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_ProgramUniform4i_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform4iv_adr := GetProcAddress('glProgramUniform4iv');
    private z_ProgramUniform4iv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform4iv_adr);
    private z_ProgramUniform4iv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform4iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4iv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4iv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4f_adr := GetProcAddress('glProgramUniform4f');
    private z_ProgramUniform4f_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_ProgramUniform4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4f(&program: gl_program; location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_ProgramUniform4f_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform4fv_adr := GetProcAddress('glProgramUniform4fv');
    private z_ProgramUniform4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform4fv_adr);
    private z_ProgramUniform4fv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform4fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4fv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4d_adr := GetProcAddress('glProgramUniform4d');
    private z_ProgramUniform4d_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: real; v1: real; v2: real; v3: real)>(z_ProgramUniform4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4d(&program: gl_program; location: Int32; v0: real; v1: real; v2: real; v3: real) :=
    z_ProgramUniform4d_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform4dv_adr := GetProcAddress('glProgramUniform4dv');
    private z_ProgramUniform4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform4dv_adr);
    private z_ProgramUniform4dv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform4dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4dv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4ui_adr := GetProcAddress('glProgramUniform4ui');
    private z_ProgramUniform4ui_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_ProgramUniform4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_ProgramUniform4ui_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform4uiv_adr := GetProcAddress('glProgramUniform4uiv');
    private z_ProgramUniform4uiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform4uiv_adr);
    private z_ProgramUniform4uiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform4uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4uiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4uiv_ovr_2(&program, location, count, value);
    
    private z_ProgramUniformMatrix2fv_adr := GetProcAddress('glProgramUniformMatrix2fv');
    private z_ProgramUniformMatrix2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2fv_adr);
    private z_ProgramUniformMatrix2fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3fv_adr := GetProcAddress('glProgramUniformMatrix3fv');
    private z_ProgramUniformMatrix3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3fv_adr);
    private z_ProgramUniformMatrix3fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4fv_adr := GetProcAddress('glProgramUniformMatrix4fv');
    private z_ProgramUniformMatrix4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4fv_adr);
    private z_ProgramUniformMatrix4fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2dv_adr := GetProcAddress('glProgramUniformMatrix2dv');
    private z_ProgramUniformMatrix2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2dv_adr);
    private z_ProgramUniformMatrix2dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3dv_adr := GetProcAddress('glProgramUniformMatrix3dv');
    private z_ProgramUniformMatrix3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3dv_adr);
    private z_ProgramUniformMatrix3dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4dv_adr := GetProcAddress('glProgramUniformMatrix4dv');
    private z_ProgramUniformMatrix4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4dv_adr);
    private z_ProgramUniformMatrix4dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x3fv_adr := GetProcAddress('glProgramUniformMatrix2x3fv');
    private z_ProgramUniformMatrix2x3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x3fv_adr);
    private z_ProgramUniformMatrix2x3fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x2fv_adr := GetProcAddress('glProgramUniformMatrix3x2fv');
    private z_ProgramUniformMatrix3x2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x2fv_adr);
    private z_ProgramUniformMatrix3x2fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x4fv_adr := GetProcAddress('glProgramUniformMatrix2x4fv');
    private z_ProgramUniformMatrix2x4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x4fv_adr);
    private z_ProgramUniformMatrix2x4fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x2fv_adr := GetProcAddress('glProgramUniformMatrix4x2fv');
    private z_ProgramUniformMatrix4x2fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x2fv_adr);
    private z_ProgramUniformMatrix4x2fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x4fv_adr := GetProcAddress('glProgramUniformMatrix3x4fv');
    private z_ProgramUniformMatrix3x4fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x4fv_adr);
    private z_ProgramUniformMatrix3x4fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x3fv_adr := GetProcAddress('glProgramUniformMatrix4x3fv');
    private z_ProgramUniformMatrix4x3fv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x3fv_adr);
    private z_ProgramUniformMatrix4x3fv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3fv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3fv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x3dv_adr := GetProcAddress('glProgramUniformMatrix2x3dv');
    private z_ProgramUniformMatrix2x3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x3dv_adr);
    private z_ProgramUniformMatrix2x3dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x2dv_adr := GetProcAddress('glProgramUniformMatrix3x2dv');
    private z_ProgramUniformMatrix3x2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x2dv_adr);
    private z_ProgramUniformMatrix3x2dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x4dv_adr := GetProcAddress('glProgramUniformMatrix2x4dv');
    private z_ProgramUniformMatrix2x4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x4dv_adr);
    private z_ProgramUniformMatrix2x4dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x2dv_adr := GetProcAddress('glProgramUniformMatrix4x2dv');
    private z_ProgramUniformMatrix4x2dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x2dv_adr);
    private z_ProgramUniformMatrix4x2dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x4dv_adr := GetProcAddress('glProgramUniformMatrix3x4dv');
    private z_ProgramUniformMatrix3x4dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x4dv_adr);
    private z_ProgramUniformMatrix3x4dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x3dv_adr := GetProcAddress('glProgramUniformMatrix4x3dv');
    private z_ProgramUniformMatrix4x3dv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x3dv_adr);
    private z_ProgramUniformMatrix4x3dv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3dv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3dv_ovr_2(&program, location, count, transpose, value);
    
    private z_ValidateProgramPipeline_adr := GetProcAddress('glValidateProgramPipeline');
    private z_ValidateProgramPipeline_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline)>(z_ValidateProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgramPipeline(pipeline: gl_program_pipeline) :=
    z_ValidateProgramPipeline_ovr_0(pipeline);
    
    private z_GetProgramPipelineInfoLog_adr := GetProcAddress('glGetProgramPipelineInfoLog');
    private z_GetProgramPipelineInfoLog_ovr_0 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: gl_program_pipeline; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_0(pipeline, bufSize, length, infoLog);
    private z_GetProgramPipelineInfoLog_ovr_1 := GetProcOrNil&<procedure(pipeline: gl_program_pipeline; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: gl_program_pipeline; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_1(pipeline, bufSize, length, infoLog);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderAtomicCountersARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_shader_atomic_counters';
    
    private z_GetActiveAtomicCounterBufferiv_adr := GetProcAddress('glGetActiveAtomicCounterBufferiv');
    private z_GetActiveAtomicCounterBufferiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32)>(z_GetActiveAtomicCounterBufferiv_adr);
    private z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr)>(z_GetActiveAtomicCounterBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params[0]) else
      z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001(&program, bufferIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32) :=
    z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params);
    private z_GetActiveAtomicCounterBufferiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr)>(z_GetActiveAtomicCounterBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: gl_program; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr) :=
    z_GetActiveAtomicCounterBufferiv_ovr_2(&program, bufferIndex, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderImageLoadStoreARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_shader_image_load_store';
    
    private z_BindImageTexture_adr := GetProcAddress('glBindImageTexture');
    private z_BindImageTexture_ovr_0 := GetProcOrNil&<procedure(&unit: UInt32; texture: gl_texture; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat)>(z_BindImageTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTexture(&unit: UInt32; texture: gl_texture; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat) :=
    z_BindImageTexture_ovr_0(&unit, texture, level, layered, layer, access, format);
    
    private z_MemoryBarrier_adr := GetProcAddress('glMemoryBarrier');
    private z_MemoryBarrier_ovr_0 := GetProcOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrier_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrier(barriers: MemoryBarrierMask) :=
    z_MemoryBarrier_ovr_0(barriers);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderObjectsARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_shader_objects';
    
    private z_DeleteObjectARB_adr := GetProcAddress('glDeleteObjectARB');
    private z_DeleteObjectARB_ovr_0 := GetProcOrNil&<procedure(obj: gl_handle_ARB)>(z_DeleteObjectARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteObjectARB(obj: gl_handle_ARB) :=
    z_DeleteObjectARB_ovr_0(obj);
    
    private z_GetHandleARB_adr := GetProcAddress('glGetHandleARB');
    private z_GetHandleARB_ovr_0 := GetProcOrNil&<function(pname: DummyEnum): gl_handle_ARB>(z_GetHandleARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetHandleARB(pname: DummyEnum): gl_handle_ARB :=
    z_GetHandleARB_ovr_0(pname);
    
    private z_DetachObjectARB_adr := GetProcAddress('glDetachObjectARB');
    private z_DetachObjectARB_ovr_0 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; attachedObj: gl_handle_ARB)>(z_DetachObjectARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetachObjectARB(containerObj: gl_handle_ARB; attachedObj: gl_handle_ARB) :=
    z_DetachObjectARB_ovr_0(containerObj, attachedObj);
    
    private z_CreateShaderObjectARB_adr := GetProcAddress('glCreateShaderObjectARB');
    private z_CreateShaderObjectARB_ovr_0 := GetProcOrNil&<function(_shaderType: ShaderType): gl_handle_ARB>(z_CreateShaderObjectARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderObjectARB(_shaderType: ShaderType): gl_handle_ARB :=
    z_CreateShaderObjectARB_ovr_0(_shaderType);
    
    private z_ShaderSourceARB_adr := GetProcAddress('glShaderSourceARB');
    private z_ShaderSourceARB_ovr_0 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; var _string: IntPtr; var length: Int32)>(z_ShaderSourceARB_adr);
    private z_ShaderSourceARB_ovr_0_anh00010 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSourceARB_adr);
    private z_ShaderSourceARB_ovr_0_anh00001 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; var _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    private z_ShaderSourceARB_ovr_0_anh00011 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: array of string; length: array of Int32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          if (length<>nil) and (length.Length<>0) then
            z_ShaderSourceARB_ovr_0(shaderObj, count, par_3_str_ptr[0], length[0]) else
            z_ShaderSourceARB_ovr_0_anh00001(shaderObj, count, par_3_str_ptr[0], IntPtr.Zero) else
          if (length<>nil) and (length.Length<>0) then
            z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length[0]) else
            z_ShaderSourceARB_ovr_0_anh00011(shaderObj, count, IntPtr.Zero, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_ShaderSourceARB_ovr_1_anh00010 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: array of string; var length: Int32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_ShaderSourceARB_ovr_0(shaderObj, count, par_3_str_ptr[0], length) else
          z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_ShaderSourceARB_ovr_2 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; var _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    private z_ShaderSourceARB_ovr_2_anh00010 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: array of string; length: IntPtr);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_ShaderSourceARB_ovr_2(shaderObj, count, par_3_str_ptr[0], length) else
          z_ShaderSourceARB_ovr_2_anh00010(shaderObj, count, IntPtr.Zero, length);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_ShaderSourceARB_ovr_3_anh00010 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSourceARB_adr);
    private z_ShaderSourceARB_ovr_3_anh00011 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: array of IntPtr; length: array of Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSourceARB_ovr_0(shaderObj, count, _string[0], length[0]) else
        z_ShaderSourceARB_ovr_0_anh00001(shaderObj, count, _string[0], IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length[0]) else
        z_ShaderSourceARB_ovr_0_anh00011(shaderObj, count, IntPtr.Zero, IntPtr.Zero);
    private z_ShaderSourceARB_ovr_4_anh00010 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: array of IntPtr; var length: Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSourceARB_ovr_0(shaderObj, count, _string[0], length) else
      z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length);
    private z_ShaderSourceARB_ovr_5_anh00010 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: array of IntPtr; length: IntPtr) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSourceARB_ovr_2(shaderObj, count, _string[0], length) else
      z_ShaderSourceARB_ovr_2_anh00010(shaderObj, count, IntPtr.Zero, length);
    private z_ShaderSourceARB_ovr_6 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSourceARB_adr);
    private z_ShaderSourceARB_ovr_6_anh00001 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_ShaderSourceARB_ovr_6(shaderObj, count, _string, length[0]) else
      z_ShaderSourceARB_ovr_6_anh00001(shaderObj, count, _string, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; var length: Int32) :=
    z_ShaderSourceARB_ovr_6(shaderObj, count, _string, length);
    private z_ShaderSourceARB_ovr_8 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: gl_handle_ARB; count: Int32; _string: IntPtr; length: IntPtr) :=
    z_ShaderSourceARB_ovr_8(shaderObj, count, _string, length);
    
    private z_CompileShaderARB_adr := GetProcAddress('glCompileShaderARB');
    private z_CompileShaderARB_ovr_0 := GetProcOrNil&<procedure(shaderObj: gl_handle_ARB)>(z_CompileShaderARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderARB(shaderObj: gl_handle_ARB) :=
    z_CompileShaderARB_ovr_0(shaderObj);
    
    private z_CreateProgramObjectARB_adr := GetProcAddress('glCreateProgramObjectARB');
    private z_CreateProgramObjectARB_ovr_0 := GetProcOrNil&<function: gl_handle_ARB>(z_CreateProgramObjectARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateProgramObjectARB: gl_handle_ARB :=
    z_CreateProgramObjectARB_ovr_0;
    
    private z_AttachObjectARB_adr := GetProcAddress('glAttachObjectARB');
    private z_AttachObjectARB_ovr_0 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; obj: gl_handle_ARB)>(z_AttachObjectARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AttachObjectARB(containerObj: gl_handle_ARB; obj: gl_handle_ARB) :=
    z_AttachObjectARB_ovr_0(containerObj, obj);
    
    private z_LinkProgramARB_adr := GetProcAddress('glLinkProgramARB');
    private z_LinkProgramARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB)>(z_LinkProgramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LinkProgramARB(programObj: gl_handle_ARB) :=
    z_LinkProgramARB_ovr_0(programObj);
    
    private z_UseProgramObjectARB_adr := GetProcAddress('glUseProgramObjectARB');
    private z_UseProgramObjectARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB)>(z_UseProgramObjectARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgramObjectARB(programObj: gl_handle_ARB) :=
    z_UseProgramObjectARB_ovr_0(programObj);
    
    private z_ValidateProgramARB_adr := GetProcAddress('glValidateProgramARB');
    private z_ValidateProgramARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB)>(z_ValidateProgramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgramARB(programObj: gl_handle_ARB) :=
    z_ValidateProgramARB_ovr_0(programObj);
    
    private z_Uniform1fARB_adr := GetProcAddress('glUniform1fARB');
    private z_Uniform1fARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single)>(z_Uniform1fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fARB(location: Int32; v0: single) :=
    z_Uniform1fARB_ovr_0(location, v0);
    
    private z_Uniform2fARB_adr := GetProcAddress('glUniform2fARB');
    private z_Uniform2fARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single; v1: single)>(z_Uniform2fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fARB(location: Int32; v0: single; v1: single) :=
    z_Uniform2fARB_ovr_0(location, v0, v1);
    
    private z_Uniform3fARB_adr := GetProcAddress('glUniform3fARB');
    private z_Uniform3fARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single; v1: single; v2: single)>(z_Uniform3fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fARB(location: Int32; v0: single; v1: single; v2: single) :=
    z_Uniform3fARB_ovr_0(location, v0, v1, v2);
    
    private z_Uniform4fARB_adr := GetProcAddress('glUniform4fARB');
    private z_Uniform4fARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_Uniform4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fARB(location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_Uniform4fARB_ovr_0(location, v0, v1, v2, v3);
    
    private z_Uniform1iARB_adr := GetProcAddress('glUniform1iARB');
    private z_Uniform1iARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32)>(z_Uniform1iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iARB(location: Int32; v0: Int32) :=
    z_Uniform1iARB_ovr_0(location, v0);
    
    private z_Uniform2iARB_adr := GetProcAddress('glUniform2iARB');
    private z_Uniform2iARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32; v1: Int32)>(z_Uniform2iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iARB(location: Int32; v0: Int32; v1: Int32) :=
    z_Uniform2iARB_ovr_0(location, v0, v1);
    
    private z_Uniform3iARB_adr := GetProcAddress('glUniform3iARB');
    private z_Uniform3iARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_Uniform3iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iARB(location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_Uniform3iARB_ovr_0(location, v0, v1, v2);
    
    private z_Uniform4iARB_adr := GetProcAddress('glUniform4iARB');
    private z_Uniform4iARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_Uniform4iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iARB(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_Uniform4iARB_ovr_0(location, v0, v1, v2, v3);
    
    private z_Uniform1fvARB_adr := GetProcAddress('glUniform1fvARB');
    private z_Uniform1fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform1fvARB_adr);
    private z_Uniform1fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1fvARB_ovr_0(location, count, value[0]) else
      z_Uniform1fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform1fvARB_ovr_0(location, count, value);
    private z_Uniform1fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1fvARB_ovr_2(location, count, value);
    
    private z_Uniform2fvARB_adr := GetProcAddress('glUniform2fvARB');
    private z_Uniform2fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform2fvARB_adr);
    private z_Uniform2fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2fvARB_ovr_0(location, count, value[0]) else
      z_Uniform2fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform2fvARB_ovr_0(location, count, value);
    private z_Uniform2fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2fvARB_ovr_2(location, count, value);
    
    private z_Uniform3fvARB_adr := GetProcAddress('glUniform3fvARB');
    private z_Uniform3fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform3fvARB_adr);
    private z_Uniform3fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3fvARB_ovr_0(location, count, value[0]) else
      z_Uniform3fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform3fvARB_ovr_0(location, count, value);
    private z_Uniform3fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3fvARB_ovr_2(location, count, value);
    
    private z_Uniform4fvARB_adr := GetProcAddress('glUniform4fvARB');
    private z_Uniform4fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform4fvARB_adr);
    private z_Uniform4fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4fvARB_ovr_0(location, count, value[0]) else
      z_Uniform4fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform4fvARB_ovr_0(location, count, value);
    private z_Uniform4fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4fvARB_ovr_2(location, count, value);
    
    private z_Uniform1ivARB_adr := GetProcAddress('glUniform1ivARB');
    private z_Uniform1ivARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform1ivARB_adr);
    private z_Uniform1ivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ivARB_ovr_0(location, count, value[0]) else
      z_Uniform1ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform1ivARB_ovr_0(location, count, value);
    private z_Uniform1ivARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ivARB_ovr_2(location, count, value);
    
    private z_Uniform2ivARB_adr := GetProcAddress('glUniform2ivARB');
    private z_Uniform2ivARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform2ivARB_adr);
    private z_Uniform2ivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ivARB_ovr_0(location, count, value[0]) else
      z_Uniform2ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform2ivARB_ovr_0(location, count, value);
    private z_Uniform2ivARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ivARB_ovr_2(location, count, value);
    
    private z_Uniform3ivARB_adr := GetProcAddress('glUniform3ivARB');
    private z_Uniform3ivARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform3ivARB_adr);
    private z_Uniform3ivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ivARB_ovr_0(location, count, value[0]) else
      z_Uniform3ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform3ivARB_ovr_0(location, count, value);
    private z_Uniform3ivARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ivARB_ovr_2(location, count, value);
    
    private z_Uniform4ivARB_adr := GetProcAddress('glUniform4ivARB');
    private z_Uniform4ivARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform4ivARB_adr);
    private z_Uniform4ivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ivARB_ovr_0(location, count, value[0]) else
      z_Uniform4ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform4ivARB_ovr_0(location, count, value);
    private z_Uniform4ivARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ivARB_ovr_2(location, count, value);
    
    private z_UniformMatrix2fvARB_adr := GetProcAddress('glUniformMatrix2fvARB');
    private z_UniformMatrix2fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2fvARB_adr);
    private z_UniformMatrix2fvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fvARB(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2fvARB_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2fvARB_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fvARB(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2fvARB_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fvARB(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2fvARB_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix3fvARB_adr := GetProcAddress('glUniformMatrix3fvARB');
    private z_UniformMatrix3fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3fvARB_adr);
    private z_UniformMatrix3fvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fvARB(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3fvARB_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3fvARB_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fvARB(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3fvARB_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fvARB(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3fvARB_ovr_2(location, count, transpose, value);
    
    private z_UniformMatrix4fvARB_adr := GetProcAddress('glUniformMatrix4fvARB');
    private z_UniformMatrix4fvARB_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4fvARB_adr);
    private z_UniformMatrix4fvARB_ovr_0_anh00001 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fvARB(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4fvARB_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4fvARB_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fvARB(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4fvARB_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4fvARB_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fvARB(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4fvARB_ovr_2(location, count, transpose, value);
    
    private z_GetObjectParameterfvARB_adr := GetProcAddress('glGetObjectParameterfvARB');
    private z_GetObjectParameterfvARB_ovr_0 := GetProcOrNil&<procedure(obj: gl_handle_ARB; pname: DummyEnum; var &params: single)>(z_GetObjectParameterfvARB_adr);
    private z_GetObjectParameterfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(obj: gl_handle_ARB; pname: DummyEnum; &params: IntPtr)>(z_GetObjectParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterfvARB(obj: gl_handle_ARB; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectParameterfvARB_ovr_0(obj, pname, &params[0]) else
      z_GetObjectParameterfvARB_ovr_0_anh0001(obj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterfvARB(obj: gl_handle_ARB; pname: DummyEnum; var &params: single) :=
    z_GetObjectParameterfvARB_ovr_0(obj, pname, &params);
    private z_GetObjectParameterfvARB_ovr_2 := GetProcOrNil&<procedure(obj: gl_handle_ARB; pname: DummyEnum; &params: IntPtr)>(z_GetObjectParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterfvARB(obj: gl_handle_ARB; pname: DummyEnum; &params: IntPtr) :=
    z_GetObjectParameterfvARB_ovr_2(obj, pname, &params);
    
    private z_GetObjectParameterivARB_adr := GetProcAddress('glGetObjectParameterivARB');
    private z_GetObjectParameterivARB_ovr_0 := GetProcOrNil&<procedure(obj: gl_handle_ARB; pname: DummyEnum; var &params: Int32)>(z_GetObjectParameterivARB_adr);
    private z_GetObjectParameterivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(obj: gl_handle_ARB; pname: DummyEnum; &params: IntPtr)>(z_GetObjectParameterivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivARB(obj: gl_handle_ARB; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectParameterivARB_ovr_0(obj, pname, &params[0]) else
      z_GetObjectParameterivARB_ovr_0_anh0001(obj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivARB(obj: gl_handle_ARB; pname: DummyEnum; var &params: Int32) :=
    z_GetObjectParameterivARB_ovr_0(obj, pname, &params);
    private z_GetObjectParameterivARB_ovr_2 := GetProcOrNil&<procedure(obj: gl_handle_ARB; pname: DummyEnum; &params: IntPtr)>(z_GetObjectParameterivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivARB(obj: gl_handle_ARB; pname: DummyEnum; &params: IntPtr) :=
    z_GetObjectParameterivARB_ovr_2(obj, pname, &params);
    
    private z_GetInfoLogARB_adr := GetProcAddress('glGetInfoLogARB');
    private z_GetInfoLogARB_ovr_0 := GetProcOrNil&<procedure(obj: gl_handle_ARB; maxLength: Int32; var length: Int32; infoLog: IntPtr)>(z_GetInfoLogARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInfoLogARB(obj: gl_handle_ARB; maxLength: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetInfoLogARB_ovr_0(obj, maxLength, length, infoLog);
    private z_GetInfoLogARB_ovr_1 := GetProcOrNil&<procedure(obj: gl_handle_ARB; maxLength: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetInfoLogARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInfoLogARB(obj: gl_handle_ARB; maxLength: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetInfoLogARB_ovr_1(obj, maxLength, length, infoLog);
    
    private z_GetAttachedObjectsARB_adr := GetProcAddress('glGetAttachedObjectsARB');
    private z_GetAttachedObjectsARB_ovr_0 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; maxCount: Int32; var count: Int32; var obj: gl_handle_ARB)>(z_GetAttachedObjectsARB_adr);
    private z_GetAttachedObjectsARB_ovr_0_anh00001 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; maxCount: Int32; var count: Int32; obj: IntPtr)>(z_GetAttachedObjectsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: gl_handle_ARB; maxCount: Int32; var count: Int32; obj: array of gl_handle_ARB) :=
    if (obj<>nil) and (obj.Length<>0) then
      z_GetAttachedObjectsARB_ovr_0(containerObj, maxCount, count, obj[0]) else
      z_GetAttachedObjectsARB_ovr_0_anh00001(containerObj, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: gl_handle_ARB; maxCount: Int32; var count: Int32; var obj: gl_handle_ARB) :=
    z_GetAttachedObjectsARB_ovr_0(containerObj, maxCount, count, obj);
    private z_GetAttachedObjectsARB_ovr_2 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; maxCount: Int32; var count: Int32; obj: IntPtr)>(z_GetAttachedObjectsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: gl_handle_ARB; maxCount: Int32; var count: Int32; obj: IntPtr) :=
    z_GetAttachedObjectsARB_ovr_2(containerObj, maxCount, count, obj);
    private z_GetAttachedObjectsARB_ovr_3 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; maxCount: Int32; count: IntPtr; var obj: gl_handle_ARB)>(z_GetAttachedObjectsARB_adr);
    private z_GetAttachedObjectsARB_ovr_3_anh00001 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; maxCount: Int32; count: IntPtr; obj: IntPtr)>(z_GetAttachedObjectsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: gl_handle_ARB; maxCount: Int32; count: IntPtr; obj: array of gl_handle_ARB) :=
    if (obj<>nil) and (obj.Length<>0) then
      z_GetAttachedObjectsARB_ovr_3(containerObj, maxCount, count, obj[0]) else
      z_GetAttachedObjectsARB_ovr_3_anh00001(containerObj, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: gl_handle_ARB; maxCount: Int32; count: IntPtr; var obj: gl_handle_ARB) :=
    z_GetAttachedObjectsARB_ovr_3(containerObj, maxCount, count, obj);
    private z_GetAttachedObjectsARB_ovr_5 := GetProcOrNil&<procedure(containerObj: gl_handle_ARB; maxCount: Int32; count: IntPtr; obj: IntPtr)>(z_GetAttachedObjectsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: gl_handle_ARB; maxCount: Int32; count: IntPtr; obj: IntPtr) :=
    z_GetAttachedObjectsARB_ovr_5(containerObj, maxCount, count, obj);
    
    private z_GetUniformLocationARB_adr := GetProcAddress('glGetUniformLocationARB');
    private z_GetUniformLocationARB_ovr_0 := GetProcOrNil&<function(programObj: gl_handle_ARB; name: IntPtr): Int32>(z_GetUniformLocationARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocationARB(programObj: gl_handle_ARB; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetUniformLocationARB_ovr_0(programObj, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocationARB(programObj: gl_handle_ARB; name: IntPtr): Int32 :=
    z_GetUniformLocationARB_ovr_0(programObj, name);
    
    private z_GetActiveUniformARB_adr := GetProcAddress('glGetActiveUniformARB');
    private z_GetActiveUniformARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_1 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_1(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_2 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_2(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_3 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_3(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_4 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_4(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_5 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_5(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_6 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_6(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveUniformARB_ovr_7 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniformARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_7(programObj, index, maxLength, length, size, &type, name);
    
    private z_GetUniformfvARB_adr := GetProcAddress('glGetUniformfvARB');
    private z_GetUniformfvARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; location: Int32; var &params: single)>(z_GetUniformfvARB_adr);
    private z_GetUniformfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; location: Int32; &params: IntPtr)>(z_GetUniformfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfvARB(programObj: gl_handle_ARB; location: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformfvARB_ovr_0(programObj, location, &params[0]) else
      z_GetUniformfvARB_ovr_0_anh0001(programObj, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfvARB(programObj: gl_handle_ARB; location: Int32; var &params: single) :=
    z_GetUniformfvARB_ovr_0(programObj, location, &params);
    private z_GetUniformfvARB_ovr_2 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; location: Int32; &params: IntPtr)>(z_GetUniformfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfvARB(programObj: gl_handle_ARB; location: Int32; &params: IntPtr) :=
    z_GetUniformfvARB_ovr_2(programObj, location, &params);
    
    private z_GetUniformivARB_adr := GetProcAddress('glGetUniformivARB');
    private z_GetUniformivARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; location: Int32; var &params: Int32)>(z_GetUniformivARB_adr);
    private z_GetUniformivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; location: Int32; &params: IntPtr)>(z_GetUniformivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformivARB(programObj: gl_handle_ARB; location: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformivARB_ovr_0(programObj, location, &params[0]) else
      z_GetUniformivARB_ovr_0_anh0001(programObj, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformivARB(programObj: gl_handle_ARB; location: Int32; var &params: Int32) :=
    z_GetUniformivARB_ovr_0(programObj, location, &params);
    private z_GetUniformivARB_ovr_2 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; location: Int32; &params: IntPtr)>(z_GetUniformivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformivARB(programObj: gl_handle_ARB; location: Int32; &params: IntPtr) :=
    z_GetUniformivARB_ovr_2(programObj, location, &params);
    
    private z_GetShaderSourceARB_adr := GetProcAddress('glGetShaderSourceARB');
    private z_GetShaderSourceARB_ovr_0 := GetProcOrNil&<procedure(obj: gl_handle_ARB; maxLength: Int32; var length: Int32; source: IntPtr)>(z_GetShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSourceARB(obj: gl_handle_ARB; maxLength: Int32; var length: Int32; source: IntPtr) :=
    z_GetShaderSourceARB_ovr_0(obj, maxLength, length, source);
    private z_GetShaderSourceARB_ovr_1 := GetProcOrNil&<procedure(obj: gl_handle_ARB; maxLength: Int32; length: IntPtr; source: IntPtr)>(z_GetShaderSourceARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSourceARB(obj: gl_handle_ARB; maxLength: Int32; length: IntPtr; source: IntPtr) :=
    z_GetShaderSourceARB_ovr_1(obj, maxLength, length, source);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderStorageBufferObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_shader_storage_buffer_object';
    
    private z_ShaderStorageBlockBinding_adr := GetProcAddress('glShaderStorageBlockBinding');
    private z_ShaderStorageBlockBinding_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; storageBlockIndex: UInt32; storageBlockBinding: UInt32)>(z_ShaderStorageBlockBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderStorageBlockBinding(&program: gl_program; storageBlockIndex: UInt32; storageBlockBinding: UInt32) :=
    z_ShaderStorageBlockBinding_ovr_0(&program, storageBlockIndex, storageBlockBinding);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderSubroutineARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_shader_subroutine';
    
    private z_GetSubroutineUniformLocation_adr := GetProcAddress('glGetSubroutineUniformLocation');
    private z_GetSubroutineUniformLocation_ovr_0 := GetProcOrNil&<function(&program: gl_program; _shadertype: ShaderType; name: IntPtr): Int32>(z_GetSubroutineUniformLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: gl_program; _shadertype: ShaderType; name: string): Int32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: gl_program; _shadertype: ShaderType; name: IntPtr): Int32 :=
    z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, name);
    
    private z_GetSubroutineIndex_adr := GetProcAddress('glGetSubroutineIndex');
    private z_GetSubroutineIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; _shadertype: ShaderType; name: IntPtr): UInt32>(z_GetSubroutineIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: gl_program; _shadertype: ShaderType; name: string): UInt32;
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetSubroutineIndex_ovr_0(&program, _shadertype, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: gl_program; _shadertype: ShaderType; name: IntPtr): UInt32 :=
    z_GetSubroutineIndex_ovr_0(&program, _shadertype, name);
    
    private z_GetActiveSubroutineUniformiv_adr := GetProcAddress('glGetActiveSubroutineUniformiv');
    private z_GetActiveSubroutineUniformiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32)>(z_GetActiveSubroutineUniformiv_adr);
    private z_GetActiveSubroutineUniformiv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr)>(z_GetActiveSubroutineUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values[0]) else
      z_GetActiveSubroutineUniformiv_ovr_0_anh000001(&program, _shadertype, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32) :=
    z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values);
    private z_GetActiveSubroutineUniformiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr)>(z_GetActiveSubroutineUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: gl_program; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr) :=
    z_GetActiveSubroutineUniformiv_ovr_2(&program, _shadertype, index, pname, values);
    
    private z_GetActiveSubroutineUniformName_adr := GetProcAddress('glGetActiveSubroutineUniformName');
    private z_GetActiveSubroutineUniformName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private z_GetActiveSubroutineUniformName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_1(&program, _shadertype, index, bufSize, length, name);
    
    private z_GetActiveSubroutineName_adr := GetProcAddress('glGetActiveSubroutineName');
    private z_GetActiveSubroutineName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private z_GetActiveSubroutineName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: gl_program; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_1(&program, _shadertype, index, bufSize, length, name);
    
    private z_UniformSubroutinesuiv_adr := GetProcAddress('glUniformSubroutinesuiv');
    private z_UniformSubroutinesuiv_ovr_0 := GetProcOrNil&<procedure(_shadertype: ShaderType; count: Int32; var indices: UInt32)>(z_UniformSubroutinesuiv_adr);
    private z_UniformSubroutinesuiv_ovr_0_anh0001 := GetProcOrNil&<procedure(_shadertype: ShaderType; count: Int32; indices: IntPtr)>(z_UniformSubroutinesuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: array of UInt32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices[0]) else
      z_UniformSubroutinesuiv_ovr_0_anh0001(_shadertype, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; var indices: UInt32) :=
    z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices);
    private z_UniformSubroutinesuiv_ovr_2 := GetProcOrNil&<procedure(_shadertype: ShaderType; count: Int32; indices: IntPtr)>(z_UniformSubroutinesuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: IntPtr) :=
    z_UniformSubroutinesuiv_ovr_2(_shadertype, count, indices);
    
    private z_GetUniformSubroutineuiv_adr := GetProcAddress('glGetUniformSubroutineuiv');
    private z_GetUniformSubroutineuiv_ovr_0 := GetProcOrNil&<procedure(_shadertype: ShaderType; location: Int32; var &params: UInt32)>(z_GetUniformSubroutineuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; var &params: UInt32) :=
    z_GetUniformSubroutineuiv_ovr_0(_shadertype, location, &params);
    private z_GetUniformSubroutineuiv_ovr_1 := GetProcOrNil&<procedure(_shadertype: ShaderType; location: Int32; &params: IntPtr)>(z_GetUniformSubroutineuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; &params: IntPtr) :=
    z_GetUniformSubroutineuiv_ovr_1(_shadertype, location, &params);
    
    private z_GetProgramStageiv_adr := GetProcAddress('glGetProgramStageiv');
    private z_GetProgramStageiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32)>(z_GetProgramStageiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32) :=
    z_GetProgramStageiv_ovr_0(&program, _shadertype, pname, values);
    private z_GetProgramStageiv_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr)>(z_GetProgramStageiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: gl_program; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr) :=
    z_GetProgramStageiv_ovr_1(&program, _shadertype, pname, values);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShadingLanguageIncludeARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_shading_language_include';
    
    private z_NamedStringARB_adr := GetProcAddress('glNamedStringARB');
    private z_NamedStringARB_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; namelen: Int32; name: IntPtr; stringlen: Int32; _string: IntPtr)>(z_NamedStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: string; stringlen: Int32; _string: string);
    begin
      var par_3_str_ptr, par_5_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        par_5_str_ptr := Marshal.StringToHGlobalAnsi(_string);
        z_NamedStringARB_ovr_0(&type, namelen, par_3_str_ptr, stringlen, par_5_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
        Marshal.FreeHGlobal(par_5_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: string; stringlen: Int32; _string: IntPtr);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_NamedStringARB_ovr_0(&type, namelen, par_3_str_ptr, stringlen, _string);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: IntPtr; stringlen: Int32; _string: string);
    begin
      var par_5_str_ptr: IntPtr;
      try
        par_5_str_ptr := Marshal.StringToHGlobalAnsi(_string);
        z_NamedStringARB_ovr_0(&type, namelen, name, stringlen, par_5_str_ptr);
      finally
        Marshal.FreeHGlobal(par_5_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: IntPtr; stringlen: Int32; _string: IntPtr) :=
    z_NamedStringARB_ovr_0(&type, namelen, name, stringlen, _string);
    
    private z_DeleteNamedStringARB_adr := GetProcAddress('glDeleteNamedStringARB');
    private z_DeleteNamedStringARB_ovr_0 := GetProcOrNil&<procedure(namelen: Int32; name: IntPtr)>(z_DeleteNamedStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamedStringARB(namelen: Int32; name: string);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_DeleteNamedStringARB_ovr_0(namelen, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamedStringARB(namelen: Int32; name: IntPtr) :=
    z_DeleteNamedStringARB_ovr_0(namelen, name);
    
    private z_CompileShaderIncludeARB_adr := GetProcAddress('glCompileShaderIncludeARB');
    private z_CompileShaderIncludeARB_ovr_0 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; var path: IntPtr; var length: Int32)>(z_CompileShaderIncludeARB_adr);
    private z_CompileShaderIncludeARB_ovr_0_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; var length: Int32)>(z_CompileShaderIncludeARB_adr);
    private z_CompileShaderIncludeARB_ovr_0_anh00001 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; var path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    private z_CompileShaderIncludeARB_ovr_0_anh00011 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: array of string; length: array of Int32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := path?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          if (length<>nil) and (length.Length<>0) then
            z_CompileShaderIncludeARB_ovr_0(shader, count, par_3_str_ptr[0], length[0]) else
            z_CompileShaderIncludeARB_ovr_0_anh00001(shader, count, par_3_str_ptr[0], IntPtr.Zero) else
          if (length<>nil) and (length.Length<>0) then
            z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
            z_CompileShaderIncludeARB_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_CompileShaderIncludeARB_ovr_1_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; var length: Int32)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: array of string; var length: Int32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := path?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_CompileShaderIncludeARB_ovr_0(shader, count, par_3_str_ptr[0], length) else
          z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_CompileShaderIncludeARB_ovr_2 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; var path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    private z_CompileShaderIncludeARB_ovr_2_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: array of string; length: IntPtr);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := path?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_CompileShaderIncludeARB_ovr_2(shader, count, par_3_str_ptr[0], length) else
          z_CompileShaderIncludeARB_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_CompileShaderIncludeARB_ovr_3_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; var length: Int32)>(z_CompileShaderIncludeARB_adr);
    private z_CompileShaderIncludeARB_ovr_3_anh00011 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: array of IntPtr; length: array of Int32) :=
    if (path<>nil) and (path.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_CompileShaderIncludeARB_ovr_0(shader, count, path[0], length[0]) else
        z_CompileShaderIncludeARB_ovr_0_anh00001(shader, count, path[0], IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
        z_CompileShaderIncludeARB_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
    private z_CompileShaderIncludeARB_ovr_4_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; var length: Int32)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: array of IntPtr; var length: Int32) :=
    if (path<>nil) and (path.Length<>0) then
      z_CompileShaderIncludeARB_ovr_0(shader, count, path[0], length) else
      z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
    private z_CompileShaderIncludeARB_ovr_5_anh00010 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: array of IntPtr; length: IntPtr) :=
    if (path<>nil) and (path.Length<>0) then
      z_CompileShaderIncludeARB_ovr_2(shader, count, path[0], length) else
      z_CompileShaderIncludeARB_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
    private z_CompileShaderIncludeARB_ovr_6 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; var length: Int32)>(z_CompileShaderIncludeARB_adr);
    private z_CompileShaderIncludeARB_ovr_6_anh00001 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: IntPtr; length: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_CompileShaderIncludeARB_ovr_6(shader, count, path, length[0]) else
      z_CompileShaderIncludeARB_ovr_6_anh00001(shader, count, path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: IntPtr; var length: Int32) :=
    z_CompileShaderIncludeARB_ovr_6(shader, count, path, length);
    private z_CompileShaderIncludeARB_ovr_8 := GetProcOrNil&<procedure(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr)>(z_CompileShaderIncludeARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: gl_shader; count: Int32; path: IntPtr; length: IntPtr) :=
    z_CompileShaderIncludeARB_ovr_8(shader, count, path, length);
    
    private z_IsNamedStringARB_adr := GetProcAddress('glIsNamedStringARB');
    private z_IsNamedStringARB_ovr_0 := GetProcOrNil&<function(namelen: Int32; name: IntPtr): boolean>(z_IsNamedStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNamedStringARB(namelen: Int32; name: string): boolean;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_IsNamedStringARB_ovr_0(namelen, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNamedStringARB(namelen: Int32; name: IntPtr): boolean :=
    z_IsNamedStringARB_ovr_0(namelen, name);
    
    private z_GetNamedStringARB_adr := GetProcAddress('glGetNamedStringARB');
    private z_GetNamedStringARB_ovr_0 := GetProcOrNil&<procedure(namelen: Int32; name: IntPtr; bufSize: Int32; var stringlen: Int32; _string: IntPtr)>(z_GetNamedStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: string; bufSize: Int32; var stringlen: Int32; _string: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_GetNamedStringARB_ovr_0(namelen, par_2_str_ptr, bufSize, stringlen, _string);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_GetNamedStringARB_ovr_1 := GetProcOrNil&<procedure(namelen: Int32; name: IntPtr; bufSize: Int32; stringlen: IntPtr; _string: IntPtr)>(z_GetNamedStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: string; bufSize: Int32; stringlen: IntPtr; _string: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_GetNamedStringARB_ovr_1(namelen, par_2_str_ptr, bufSize, stringlen, _string);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: IntPtr; bufSize: Int32; var stringlen: Int32; _string: IntPtr) :=
    z_GetNamedStringARB_ovr_0(namelen, name, bufSize, stringlen, _string);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: IntPtr; bufSize: Int32; stringlen: IntPtr; _string: IntPtr) :=
    z_GetNamedStringARB_ovr_1(namelen, name, bufSize, stringlen, _string);
    
    private z_GetNamedStringivARB_adr := GetProcAddress('glGetNamedStringivARB');
    private z_GetNamedStringivARB_ovr_0 := GetProcOrNil&<procedure(namelen: Int32; name: IntPtr; pname: DummyEnum; var &params: Int32)>(z_GetNamedStringivARB_adr);
    private z_GetNamedStringivARB_ovr_0_anh00001 := GetProcOrNil&<procedure(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: IntPtr)>(z_GetNamedStringivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: string; pname: DummyEnum; &params: array of Int32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        if (&params<>nil) and (&params.Length<>0) then
          z_GetNamedStringivARB_ovr_0(namelen, par_2_str_ptr, pname, &params[0]) else
          z_GetNamedStringivARB_ovr_0_anh00001(namelen, par_2_str_ptr, pname, IntPtr.Zero);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: string; pname: DummyEnum; var &params: Int32);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_GetNamedStringivARB_ovr_0(namelen, par_2_str_ptr, pname, &params);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    private z_GetNamedStringivARB_ovr_2 := GetProcOrNil&<procedure(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: IntPtr)>(z_GetNamedStringivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: string; pname: DummyEnum; &params: IntPtr);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_GetNamedStringivARB_ovr_2(namelen, par_2_str_ptr, pname, &params);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedStringivARB_ovr_0(namelen, name, pname, &params[0]) else
      z_GetNamedStringivARB_ovr_0_anh00001(namelen, name, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: IntPtr; pname: DummyEnum; var &params: Int32) :=
    z_GetNamedStringivARB_ovr_0(namelen, name, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: IntPtr) :=
    z_GetNamedStringivARB_ovr_2(namelen, name, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSparseBufferARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_sparse_buffer';
    
    private z_BufferPageCommitmentARB_adr := GetProcAddress('glBufferPageCommitmentARB');
    private z_BufferPageCommitmentARB_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; offset: IntPtr; size: IntPtr; commit: boolean)>(z_BufferPageCommitmentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferPageCommitmentARB(target: DummyEnum; offset: IntPtr; size: IntPtr; commit: boolean) :=
    z_BufferPageCommitmentARB_ovr_0(target, offset, size, commit);
    
    private z_NamedBufferPageCommitmentEXT_adr := GetProcAddress('glNamedBufferPageCommitmentEXT');
    private z_NamedBufferPageCommitmentEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; commit: boolean)>(z_NamedBufferPageCommitmentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferPageCommitmentEXT(buffer: gl_buffer; offset: IntPtr; size: IntPtr; commit: boolean) :=
    z_NamedBufferPageCommitmentEXT_ovr_0(buffer, offset, size, commit);
    
    private z_NamedBufferPageCommitmentARB_adr := GetProcAddress('glNamedBufferPageCommitmentARB');
    private z_NamedBufferPageCommitmentARB_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; commit: boolean)>(z_NamedBufferPageCommitmentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferPageCommitmentARB(buffer: gl_buffer; offset: IntPtr; size: IntPtr; commit: boolean) :=
    z_NamedBufferPageCommitmentARB_ovr_0(buffer, offset, size, commit);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSparseTextureARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_sparse_texture';
    
    private z_TexPageCommitmentARB_adr := GetProcAddress('glTexPageCommitmentARB');
    private z_TexPageCommitmentARB_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean)>(z_TexPageCommitmentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexPageCommitmentARB(target: DummyEnum; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean) :=
    z_TexPageCommitmentARB_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, commit);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSyncARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_sync';
    
    private z_FenceSync_adr := GetProcAddress('glFenceSync');
    private z_FenceSync_ovr_0 := GetProcOrNil&<function(condition: SyncCondition; flags: DummyFlags): gl_sync>(z_FenceSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FenceSync(condition: SyncCondition; flags: DummyFlags): gl_sync :=
    z_FenceSync_ovr_0(condition, flags);
    
    private z_IsSync_adr := GetProcAddress('glIsSync');
    private z_IsSync_ovr_0 := GetProcOrNil&<function(sync: gl_sync): boolean>(z_IsSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSync(sync: gl_sync): boolean :=
    z_IsSync_ovr_0(sync);
    
    private z_DeleteSync_adr := GetProcAddress('glDeleteSync');
    private z_DeleteSync_ovr_0 := GetProcOrNil&<procedure(sync: gl_sync)>(z_DeleteSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSync(sync: gl_sync) :=
    z_DeleteSync_ovr_0(sync);
    
    private z_ClientWaitSync_adr := GetProcAddress('glClientWaitSync');
    private z_ClientWaitSync_ovr_0 := GetProcOrNil&<function(sync: gl_sync; flags: SyncObjectMask; timeout: UInt64): SyncStatus>(z_ClientWaitSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ClientWaitSync(sync: gl_sync; flags: SyncObjectMask; timeout: UInt64): SyncStatus :=
    z_ClientWaitSync_ovr_0(sync, flags, timeout);
    
    private z_WaitSync_adr := GetProcAddress('glWaitSync');
    private z_WaitSync_ovr_0 := GetProcOrNil&<procedure(sync: gl_sync; flags: DummyFlags; timeout: UInt64)>(z_WaitSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSync(sync: gl_sync; flags: DummyFlags; timeout: UInt64) :=
    z_WaitSync_ovr_0(sync, flags, timeout);
    
    private z_GetInteger64v_adr := GetProcAddress('glGetInteger64v');
    private z_GetInteger64v_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: Int64)>(z_GetInteger64v_adr);
    private z_GetInteger64v_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetInteger64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: array of Int64) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInteger64v_ovr_0(pname, data[0]) else
      z_GetInteger64v_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; var data: Int64) :=
    z_GetInteger64v_ovr_0(pname, data);
    private z_GetInteger64v_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetInteger64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: IntPtr) :=
    z_GetInteger64v_ovr_2(pname, data);
    
    private z_GetSynciv_adr := GetProcAddress('glGetSynciv');
    private z_GetSynciv_ovr_0 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_0_anh000001 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_0(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_0_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32) :=
    z_GetSynciv_ovr_0(sync, pname, count, length, values);
    private z_GetSynciv_ovr_2 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr) :=
    z_GetSynciv_ovr_2(sync, pname, count, length, values);
    private z_GetSynciv_ovr_3 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_3_anh000001 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_3(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_3_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32) :=
    z_GetSynciv_ovr_3(sync, pname, count, length, values);
    private z_GetSynciv_ovr_5 := GetProcOrNil&<procedure(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: gl_sync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr) :=
    z_GetSynciv_ovr_5(sync, pname, count, length, values);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTessellationShaderARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_tessellation_shader';
    
    private z_PatchParameteri_adr := GetProcAddress('glPatchParameteri');
    private z_PatchParameteri_ovr_0 := GetProcOrNil&<procedure(pname: PatchParameterName; value: Int32)>(z_PatchParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameteri(pname: PatchParameterName; value: Int32) :=
    z_PatchParameteri_ovr_0(pname, value);
    
    private z_PatchParameterfv_adr := GetProcAddress('glPatchParameterfv');
    private z_PatchParameterfv_ovr_0 := GetProcOrNil&<procedure(pname: PatchParameterName; var values: single)>(z_PatchParameterfv_adr);
    private z_PatchParameterfv_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PatchParameterName; values: IntPtr)>(z_PatchParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_PatchParameterfv_ovr_0(pname, values[0]) else
      z_PatchParameterfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; var values: single) :=
    z_PatchParameterfv_ovr_0(pname, values);
    private z_PatchParameterfv_ovr_2 := GetProcOrNil&<procedure(pname: PatchParameterName; values: IntPtr)>(z_PatchParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: IntPtr) :=
    z_PatchParameterfv_ovr_2(pname, values);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureBarrierARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_barrier';
    
    private z_TextureBarrier_adr := GetProcAddress('glTextureBarrier');
    private z_TextureBarrier_ovr_0 := GetProcOrNil&<procedure>(z_TextureBarrier_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBarrier :=
    z_TextureBarrier_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureBufferObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_buffer_object';
    
    private z_TexBufferARB_adr := GetProcAddress('glTexBufferARB');
    private z_TexBufferARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer)>(z_TexBufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferARB(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer) :=
    z_TexBufferARB_ovr_0(target, internalformat, buffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureBufferRangeARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_buffer_range';
    
    private z_TexBufferRange_adr := GetProcAddress('glTexBufferRange');
    private z_TexBufferRange_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TexBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferRange(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TexBufferRange_ovr_0(target, internalformat, buffer, offset, size);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureCompressionARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_compression';
    
    private z_CompressedTexImage3DARB_adr := GetProcAddress('glCompressedTexImage3DARB');
    private z_CompressedTexImage3DARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage3DARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage3DARB(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage3DARB_ovr_0(target, level, _internalformat, width, height, depth, border, imageSize, data);
    
    private z_CompressedTexImage2DARB_adr := GetProcAddress('glCompressedTexImage2DARB');
    private z_CompressedTexImage2DARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage2DARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage2DARB(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage2DARB_ovr_0(target, level, _internalformat, width, height, border, imageSize, data);
    
    private z_CompressedTexImage1DARB_adr := GetProcAddress('glCompressedTexImage1DARB');
    private z_CompressedTexImage1DARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage1DARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage1DARB(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage1DARB_ovr_0(target, level, _internalformat, width, border, imageSize, data);
    
    private z_CompressedTexSubImage3DARB_adr := GetProcAddress('glCompressedTexSubImage3DARB');
    private z_CompressedTexSubImage3DARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage3DARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage3DARB(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage3DARB_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    private z_CompressedTexSubImage2DARB_adr := GetProcAddress('glCompressedTexSubImage2DARB');
    private z_CompressedTexSubImage2DARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage2DARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage2DARB(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage2DARB_ovr_0(target, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    private z_CompressedTexSubImage1DARB_adr := GetProcAddress('glCompressedTexSubImage1DARB');
    private z_CompressedTexSubImage1DARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage1DARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage1DARB(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage1DARB_ovr_0(target, level, xoffset, width, format, imageSize, data);
    
    private z_GetCompressedTexImageARB_adr := GetProcAddress('glGetCompressedTexImageARB');
    private z_GetCompressedTexImageARB_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; img: IntPtr)>(z_GetCompressedTexImageARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTexImageARB(target: TextureTarget; level: Int32; img: IntPtr) :=
    z_GetCompressedTexImageARB_ovr_0(target, level, img);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureMultisampleARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_multisample';
    
    private z_TexImage2DMultisample_adr := GetProcAddress('glTexImage2DMultisample');
    private z_TexImage2DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TexImage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexImage2DMultisample_ovr_0(target, samples, _internalformat, width, height, fixedsamplelocations);
    
    private z_TexImage3DMultisample_adr := GetProcAddress('glTexImage3DMultisample');
    private z_TexImage3DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TexImage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexImage3DMultisample_ovr_0(target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    private z_GetMultisamplefv_adr := GetProcAddress('glGetMultisamplefv');
    private z_GetMultisamplefv_ovr_0 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; var val: single)>(z_GetMultisamplefv_adr);
    private z_GetMultisamplefv_ovr_0_anh0001 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_GetMultisamplefv_ovr_0(pname, index, val[0]) else
      z_GetMultisamplefv_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; var val: single) :=
    z_GetMultisamplefv_ovr_0(pname, index, val);
    private z_GetMultisamplefv_ovr_2 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr) :=
    z_GetMultisamplefv_ovr_2(pname, index, val);
    
    private z_SampleMaski_adr := GetProcAddress('glSampleMaski');
    private z_SampleMaski_ovr_0 := GetProcOrNil&<procedure(maskNumber: UInt32; mask: DummyFlags)>(z_SampleMaski_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaski(maskNumber: UInt32; mask: DummyFlags) :=
    z_SampleMaski_ovr_0(maskNumber, mask);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureStorageARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_storage';
    
    private z_TexStorage1D_adr := GetProcAddress('glTexStorage1D');
    private z_TexStorage1D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TexStorage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage1D(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TexStorage1D_ovr_0(target, levels, internalformat, width);
    
    private z_TexStorage2D_adr := GetProcAddress('glTexStorage2D');
    private z_TexStorage2D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TexStorage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2D(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TexStorage2D_ovr_0(target, levels, internalformat, width, height);
    
    private z_TexStorage3D_adr := GetProcAddress('glTexStorage3D');
    private z_TexStorage3D_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TexStorage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3D(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TexStorage3D_ovr_0(target, levels, internalformat, width, height, depth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureStorageMultisampleARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_storage_multisample';
    
    private z_TexStorage2DMultisample_adr := GetProcAddress('glTexStorage2DMultisample');
    private z_TexStorage2DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TexStorage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2DMultisample(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage2DMultisample_ovr_0(target, samples, internalformat, width, height, fixedsamplelocations);
    
    private z_TexStorage3DMultisample_adr := GetProcAddress('glTexStorage3DMultisample');
    private z_TexStorage3DMultisample_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TexStorage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3DMultisample(target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage3DMultisample_ovr_0(target, samples, internalformat, width, height, depth, fixedsamplelocations);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureViewARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_texture_view';
    
    private z_TextureView_adr := GetProcAddress('glTextureView');
    private z_TextureView_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; origtexture: gl_texture; internalformat: SizedInternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32)>(z_TextureView_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureView(texture: gl_texture; target: TextureTarget; origtexture: gl_texture; internalformat: SizedInternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32) :=
    z_TextureView_ovr_0(texture, target, origtexture, internalformat, minlevel, numlevels, minlayer, numlayers);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTimerQueryARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_timer_query';
    
    private z_QueryCounter_adr := GetProcAddress('glQueryCounter');
    private z_QueryCounter_ovr_0 := GetProcOrNil&<procedure(id: gl_query; target: QueryCounterTarget)>(z_QueryCounter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryCounter(id: gl_query; target: QueryCounterTarget) :=
    z_QueryCounter_ovr_0(id, target);
    
    private z_GetQueryObjecti64v_adr := GetProcAddress('glGetQueryObjecti64v');
    private z_GetQueryObjecti64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: Int64)>(z_GetQueryObjecti64v_adr);
    private z_GetQueryObjecti64v_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: gl_query; pname: QueryObjectParameterName; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjecti64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjecti64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: gl_query; pname: QueryObjectParameterName; var &params: Int64) :=
    z_GetQueryObjecti64v_ovr_0(id, pname, &params);
    private z_GetQueryObjecti64v_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjecti64v_ovr_2(id, pname, &params);
    
    private z_GetQueryObjectui64v_adr := GetProcAddress('glGetQueryObjectui64v');
    private z_GetQueryObjectui64v_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: UInt64)>(z_GetQueryObjectui64v_adr);
    private z_GetQueryObjectui64v_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: gl_query; pname: QueryObjectParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectui64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectui64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: gl_query; pname: QueryObjectParameterName; var &params: UInt64) :=
    z_GetQueryObjectui64v_ovr_0(id, pname, &params);
    private z_GetQueryObjectui64v_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectui64v_ovr_2(id, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransformFeedback2ARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_transform_feedback2';
    
    private z_BindTransformFeedback_adr := GetProcAddress('glBindTransformFeedback');
    private z_BindTransformFeedback_ovr_0 := GetProcOrNil&<procedure(target: BindTransformFeedbackTarget; id: gl_transform_feedback)>(z_BindTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTransformFeedback(target: BindTransformFeedbackTarget; id: gl_transform_feedback) :=
    z_BindTransformFeedback_ovr_0(target, id);
    
    private z_DeleteTransformFeedbacks_adr := GetProcAddress('glDeleteTransformFeedbacks');
    private z_DeleteTransformFeedbacks_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_DeleteTransformFeedbacks_adr);
    private z_DeleteTransformFeedbacks_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteTransformFeedbacks_ovr_0(n, ids[0]) else
      z_DeleteTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; var ids: gl_transform_feedback) :=
    z_DeleteTransformFeedbacks_ovr_0(n, ids);
    private z_DeleteTransformFeedbacks_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_DeleteTransformFeedbacks_ovr_2(n, ids);
    
    private z_GenTransformFeedbacks_adr := GetProcAddress('glGenTransformFeedbacks');
    private z_GenTransformFeedbacks_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_GenTransformFeedbacks_adr);
    private z_GenTransformFeedbacks_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenTransformFeedbacks_ovr_0(n, ids[0]) else
      z_GenTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; var ids: gl_transform_feedback) :=
    z_GenTransformFeedbacks_ovr_0(n, ids);
    private z_GenTransformFeedbacks_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_GenTransformFeedbacks_ovr_2(n, ids);
    
    private z_IsTransformFeedback_adr := GetProcAddress('glIsTransformFeedback');
    private z_IsTransformFeedback_ovr_0 := GetProcOrNil&<function(id: gl_transform_feedback): boolean>(z_IsTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTransformFeedback(id: gl_transform_feedback): boolean :=
    z_IsTransformFeedback_ovr_0(id);
    
    private z_PauseTransformFeedback_adr := GetProcAddress('glPauseTransformFeedback');
    private z_PauseTransformFeedback_ovr_0 := GetProcOrNil&<procedure>(z_PauseTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PauseTransformFeedback :=
    z_PauseTransformFeedback_ovr_0;
    
    private z_ResumeTransformFeedback_adr := GetProcAddress('glResumeTransformFeedback');
    private z_ResumeTransformFeedback_ovr_0 := GetProcOrNil&<procedure>(z_ResumeTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResumeTransformFeedback :=
    z_ResumeTransformFeedback_ovr_0;
    
    private z_DrawTransformFeedback_adr := GetProcAddress('glDrawTransformFeedback');
    private z_DrawTransformFeedback_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback)>(z_DrawTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedback(mode: PrimitiveType; id: gl_transform_feedback) :=
    z_DrawTransformFeedback_ovr_0(mode, id);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransformFeedback3ARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_transform_feedback3';
    
    private z_DrawTransformFeedbackStream_adr := GetProcAddress('glDrawTransformFeedbackStream');
    private z_DrawTransformFeedbackStream_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32)>(z_DrawTransformFeedbackStream_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStream(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32) :=
    z_DrawTransformFeedbackStream_ovr_0(mode, id, stream);
    
    private z_BeginQueryIndexed_adr := GetProcAddress('glBeginQueryIndexed');
    private z_BeginQueryIndexed_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; id: gl_query)>(z_BeginQueryIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQueryIndexed(target: QueryTarget; index: UInt32; id: gl_query) :=
    z_BeginQueryIndexed_ovr_0(target, index, id);
    
    private z_EndQueryIndexed_adr := GetProcAddress('glEndQueryIndexed');
    private z_EndQueryIndexed_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32)>(z_EndQueryIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQueryIndexed(target: QueryTarget; index: UInt32) :=
    z_EndQueryIndexed_ovr_0(target, index);
    
    private z_GetQueryIndexediv_adr := GetProcAddress('glGetQueryIndexediv');
    private z_GetQueryIndexediv_ovr_0 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32)>(z_GetQueryIndexediv_adr);
    private z_GetQueryIndexediv_ovr_0_anh00001 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryIndexediv_ovr_0(target, index, pname, &params[0]) else
      z_GetQueryIndexediv_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryIndexediv_ovr_0(target, index, pname, &params);
    private z_GetQueryIndexediv_ovr_2 := GetProcOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryIndexediv_ovr_2(target, index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransformFeedbackInstancedARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_transform_feedback_instanced';
    
    private z_DrawTransformFeedbackInstanced_adr := GetProcAddress('glDrawTransformFeedbackInstanced');
    private z_DrawTransformFeedbackInstanced_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback; instancecount: Int32)>(z_DrawTransformFeedbackInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackInstanced(mode: PrimitiveType; id: gl_transform_feedback; instancecount: Int32) :=
    z_DrawTransformFeedbackInstanced_ovr_0(mode, id, instancecount);
    
    private z_DrawTransformFeedbackStreamInstanced_adr := GetProcAddress('glDrawTransformFeedbackStreamInstanced');
    private z_DrawTransformFeedbackStreamInstanced_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32; instancecount: Int32)>(z_DrawTransformFeedbackStreamInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStreamInstanced(mode: PrimitiveType; id: gl_transform_feedback; stream: UInt32; instancecount: Int32) :=
    z_DrawTransformFeedbackStreamInstanced_ovr_0(mode, id, stream, instancecount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransposeMatrixARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_transpose_matrix';
    
    private z_LoadTransposeMatrixfARB_adr := GetProcAddress('glLoadTransposeMatrixfARB');
    private z_LoadTransposeMatrixfARB_ovr_0 := GetProcOrNil&<procedure(var m: single)>(z_LoadTransposeMatrixfARB_adr);
    private z_LoadTransposeMatrixfARB_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixfARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixfARB(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixfARB_ovr_0(m[0]) else
      z_LoadTransposeMatrixfARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixfARB(var m: single) :=
    z_LoadTransposeMatrixfARB_ovr_0(m);
    private z_LoadTransposeMatrixfARB_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixfARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixfARB(m: IntPtr) :=
    z_LoadTransposeMatrixfARB_ovr_2(m);
    
    private z_LoadTransposeMatrixdARB_adr := GetProcAddress('glLoadTransposeMatrixdARB');
    private z_LoadTransposeMatrixdARB_ovr_0 := GetProcOrNil&<procedure(var m: real)>(z_LoadTransposeMatrixdARB_adr);
    private z_LoadTransposeMatrixdARB_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixdARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixdARB(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixdARB_ovr_0(m[0]) else
      z_LoadTransposeMatrixdARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixdARB(var m: real) :=
    z_LoadTransposeMatrixdARB_ovr_0(m);
    private z_LoadTransposeMatrixdARB_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixdARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixdARB(m: IntPtr) :=
    z_LoadTransposeMatrixdARB_ovr_2(m);
    
    private z_MultTransposeMatrixfARB_adr := GetProcAddress('glMultTransposeMatrixfARB');
    private z_MultTransposeMatrixfARB_ovr_0 := GetProcOrNil&<procedure(var m: single)>(z_MultTransposeMatrixfARB_adr);
    private z_MultTransposeMatrixfARB_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixfARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixfARB(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixfARB_ovr_0(m[0]) else
      z_MultTransposeMatrixfARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixfARB(var m: single) :=
    z_MultTransposeMatrixfARB_ovr_0(m);
    private z_MultTransposeMatrixfARB_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixfARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixfARB(m: IntPtr) :=
    z_MultTransposeMatrixfARB_ovr_2(m);
    
    private z_MultTransposeMatrixdARB_adr := GetProcAddress('glMultTransposeMatrixdARB');
    private z_MultTransposeMatrixdARB_ovr_0 := GetProcOrNil&<procedure(var m: real)>(z_MultTransposeMatrixdARB_adr);
    private z_MultTransposeMatrixdARB_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixdARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixdARB(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixdARB_ovr_0(m[0]) else
      z_MultTransposeMatrixdARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixdARB(var m: real) :=
    z_MultTransposeMatrixdARB_ovr_0(m);
    private z_MultTransposeMatrixdARB_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixdARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixdARB(m: IntPtr) :=
    z_MultTransposeMatrixdARB_ovr_2(m);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glUniformBufferObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_uniform_buffer_object';
    
    private z_GetUniformIndices_adr := GetProcAddress('glGetUniformIndices');
    private z_GetUniformIndices_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00011 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of string; uniformIndices: array of UInt32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
            z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices[0]) else
            z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, par_3_str_ptr[0], IntPtr.Zero) else
          if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
            z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
            z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_GetUniformIndices_ovr_1_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of string; var uniformIndices: UInt32);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
          z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_GetUniformIndices_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_2_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of string; uniformIndices: IntPtr);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_GetUniformIndices_ovr_2(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
          z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_GetUniformIndices_ovr_3_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_3_anh00011 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: array of UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, uniformNames[0], IntPtr.Zero) else
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
    private z_GetUniformIndices_ovr_4_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of IntPtr; var uniformIndices: UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private z_GetUniformIndices_ovr_5_anh00010 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: IntPtr) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_2(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private z_GetUniformIndices_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_6_anh00001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: array of UInt32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices[0]) else
      z_GetUniformIndices_ovr_6_anh00001(&program, uniformCount, uniformNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32) :=
    z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices);
    private z_GetUniformIndices_ovr_8 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: gl_program; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr) :=
    z_GetUniformIndices_ovr_8(&program, uniformCount, uniformNames, uniformIndices);
    
    private z_GetActiveUniformsiv_adr := GetProcAddress('glGetActiveUniformsiv');
    private z_GetActiveUniformsiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000100 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000101 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: array of Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices[0], pname, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000101(&program, uniformCount, IntPtr.Zero, pname, IntPtr.Zero);
    private z_GetActiveUniformsiv_ovr_1_anh000100 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; var &params: Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    private z_GetActiveUniformsiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_2_anh000100 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: IntPtr) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_2_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices, pname, &params);
    private z_GetActiveUniformsiv_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_6_anh000001 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_6_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params);
    private z_GetActiveUniformsiv_ovr_8 := GetProcOrNil&<procedure(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: gl_program; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_8(&program, uniformCount, uniformIndices, pname, &params);
    
    private z_GetActiveUniformName_adr := GetProcAddress('glGetActiveUniformName');
    private z_GetActiveUniformName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_0(&program, uniformIndex, bufSize, length, uniformName);
    private z_GetActiveUniformName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: gl_program; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_1(&program, uniformIndex, bufSize, length, uniformName);
    
    private z_GetUniformBlockIndex_adr := GetProcAddress('glGetUniformBlockIndex');
    private z_GetUniformBlockIndex_ovr_0 := GetProcOrNil&<function(&program: gl_program; uniformBlockName: IntPtr): UInt32>(z_GetUniformBlockIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: gl_program; uniformBlockName: string): UInt32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(uniformBlockName);
        Result := z_GetUniformBlockIndex_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: gl_program; uniformBlockName: IntPtr): UInt32 :=
    z_GetUniformBlockIndex_ovr_0(&program, uniformBlockName);
    
    private z_GetActiveUniformBlockiv_adr := GetProcAddress('glGetActiveUniformBlockiv');
    private z_GetActiveUniformBlockiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32)>(z_GetActiveUniformBlockiv_adr);
    private z_GetActiveUniformBlockiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr)>(z_GetActiveUniformBlockiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params[0]) else
      z_GetActiveUniformBlockiv_ovr_0_anh00001(&program, uniformBlockIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32) :=
    z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params);
    private z_GetActiveUniformBlockiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr)>(z_GetActiveUniformBlockiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: gl_program; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr) :=
    z_GetActiveUniformBlockiv_ovr_2(&program, uniformBlockIndex, pname, &params);
    
    private z_GetActiveUniformBlockName_adr := GetProcAddress('glGetActiveUniformBlockName');
    private z_GetActiveUniformBlockName_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_0(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    private z_GetActiveUniformBlockName_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: gl_program; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_1(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    
    private z_UniformBlockBinding_adr := GetProcAddress('glUniformBlockBinding');
    private z_UniformBlockBinding_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32)>(z_UniformBlockBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformBlockBinding(&program: gl_program; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32) :=
    z_UniformBlockBinding_ovr_0(&program, uniformBlockIndex, uniformBlockBinding);
    
    private z_BindBufferRange_adr := GetProcAddress('glBindBufferRange');
    private z_BindBufferRange_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_BindBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRange(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRange_ovr_0(target, index, buffer, offset, size);
    
    private z_BindBufferBase_adr := GetProcAddress('glBindBufferBase');
    private z_BindBufferBase_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer)>(z_BindBufferBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBase(target: BufferTarget; index: UInt32; buffer: gl_buffer) :=
    z_BindBufferBase_ovr_0(target, index, buffer);
    
    private z_GetIntegeri_v_adr := GetProcAddress('glGetIntegeri_v');
    private z_GetIntegeri_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: Int32)>(z_GetIntegeri_v_adr);
    private z_GetIntegeri_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegeri_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: GetPName; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegeri_v_ovr_0(target, index, data[0]) else
      z_GetIntegeri_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: GetPName; index: UInt32; var data: Int32) :=
    z_GetIntegeri_v_ovr_0(target, index, data);
    private z_GetIntegeri_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegeri_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetIntegeri_v_ovr_2(target, index, data);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_array_object';
    
    private z_BindVertexArray_adr := GetProcAddress('glBindVertexArray');
    private z_BindVertexArray_ovr_0 := GetProcOrNil&<procedure(&array: gl_vertex_array)>(z_BindVertexArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexArray(&array: gl_vertex_array) :=
    z_BindVertexArray_ovr_0(&array);
    
    private z_DeleteVertexArrays_adr := GetProcAddress('glDeleteVertexArrays');
    private z_DeleteVertexArrays_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_DeleteVertexArrays_adr);
    private z_DeleteVertexArrays_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_DeleteVertexArrays_ovr_0(n, arrays[0]) else
      z_DeleteVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; var arrays: gl_vertex_array) :=
    z_DeleteVertexArrays_ovr_0(n, arrays);
    private z_DeleteVertexArrays_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: IntPtr) :=
    z_DeleteVertexArrays_ovr_2(n, arrays);
    
    private z_GenVertexArrays_adr := GetProcAddress('glGenVertexArrays');
    private z_GenVertexArrays_ovr_0 := GetProcOrNil&<procedure(n: Int32; var arrays: gl_vertex_array)>(z_GenVertexArrays_adr);
    private z_GenVertexArrays_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: array of gl_vertex_array) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_GenVertexArrays_ovr_0(n, arrays[0]) else
      z_GenVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; var arrays: gl_vertex_array) :=
    z_GenVertexArrays_ovr_0(n, arrays);
    private z_GenVertexArrays_ovr_2 := GetProcOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: IntPtr) :=
    z_GenVertexArrays_ovr_2(n, arrays);
    
    private z_IsVertexArray_adr := GetProcAddress('glIsVertexArray');
    private z_IsVertexArray_ovr_0 := GetProcOrNil&<function(&array: gl_vertex_array): boolean>(z_IsVertexArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexArray(&array: gl_vertex_array): boolean :=
    z_IsVertexArray_ovr_0(&array);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexAttrib64bitARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_attrib_64bit';
    
    private z_VertexAttribL1d_adr := GetProcAddress('glVertexAttribL1d');
    private z_VertexAttribL1d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttribL1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1d(index: UInt32; x: real) :=
    z_VertexAttribL1d_ovr_0(index, x);
    
    private z_VertexAttribL2d_adr := GetProcAddress('glVertexAttribL2d');
    private z_VertexAttribL2d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttribL2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2d(index: UInt32; x: real; y: real) :=
    z_VertexAttribL2d_ovr_0(index, x, y);
    
    private z_VertexAttribL3d_adr := GetProcAddress('glVertexAttribL3d');
    private z_VertexAttribL3d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttribL3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3d(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttribL3d_ovr_0(index, x, y, z);
    
    private z_VertexAttribL4d_adr := GetProcAddress('glVertexAttribL4d');
    private z_VertexAttribL4d_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttribL4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4d(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttribL4d_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribL1dv_adr := GetProcAddress('glVertexAttribL1dv');
    private z_VertexAttribL1dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; var v: real) :=
    z_VertexAttribL1dv_ovr_0(index, v);
    private z_VertexAttribL1dv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1dv_ovr_1(index, v);
    
    private z_VertexAttribL2dv_adr := GetProcAddress('glVertexAttribL2dv');
    private z_VertexAttribL2dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL2dv_adr);
    private z_VertexAttribL2dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2dv_ovr_0(index, v[0]) else
      z_VertexAttribL2dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; var v: real) :=
    z_VertexAttribL2dv_ovr_0(index, v);
    private z_VertexAttribL2dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2dv_ovr_2(index, v);
    
    private z_VertexAttribL3dv_adr := GetProcAddress('glVertexAttribL3dv');
    private z_VertexAttribL3dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL3dv_adr);
    private z_VertexAttribL3dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3dv_ovr_0(index, v[0]) else
      z_VertexAttribL3dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; var v: real) :=
    z_VertexAttribL3dv_ovr_0(index, v);
    private z_VertexAttribL3dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3dv_ovr_2(index, v);
    
    private z_VertexAttribL4dv_adr := GetProcAddress('glVertexAttribL4dv');
    private z_VertexAttribL4dv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL4dv_adr);
    private z_VertexAttribL4dv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4dv_ovr_0(index, v[0]) else
      z_VertexAttribL4dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; var v: real) :=
    z_VertexAttribL4dv_ovr_0(index, v);
    private z_VertexAttribL4dv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4dv_ovr_2(index, v);
    
    private z_VertexAttribLPointer_adr := GetProcAddress('glVertexAttribLPointer');
    private z_VertexAttribLPointer_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; pointer: IntPtr)>(z_VertexAttribLPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLPointer(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribLPointer_ovr_0(index, size, &type, stride, pointer);
    
    private z_GetVertexAttribLdv_adr := GetProcAddress('glGetVertexAttribLdv');
    private z_GetVertexAttribLdv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: real)>(z_GetVertexAttribLdv_adr);
    private z_GetVertexAttribLdv_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLdv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLdv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; var &params: real) :=
    z_GetVertexAttribLdv_ovr_0(index, pname, &params);
    private z_GetVertexAttribLdv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLdv_ovr_2(index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexAttribBindingARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_attrib_binding';
    
    private z_BindVertexBuffer_adr := GetProcAddress('glBindVertexBuffer');
    private z_BindVertexBuffer_ovr_0 := GetProcOrNil&<procedure(bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32)>(z_BindVertexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffer(bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32) :=
    z_BindVertexBuffer_ovr_0(bindingindex, buffer, offset, stride);
    
    private z_VertexAttribFormat_adr := GetProcAddress('glVertexAttribFormat');
    private z_VertexAttribFormat_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexAttribFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribFormat(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexAttribFormat_ovr_0(attribindex, size, &type, normalized, relativeoffset);
    
    private z_VertexAttribIFormat_adr := GetProcAddress('glVertexAttribIFormat');
    private z_VertexAttribIFormat_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexAttribIFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIFormat(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexAttribIFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    private z_VertexAttribLFormat_adr := GetProcAddress('glVertexAttribLFormat');
    private z_VertexAttribLFormat_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexAttribLFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLFormat(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexAttribLFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    private z_VertexAttribBinding_adr := GetProcAddress('glVertexAttribBinding');
    private z_VertexAttribBinding_ovr_0 := GetProcOrNil&<procedure(attribindex: UInt32; bindingindex: UInt32)>(z_VertexAttribBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribBinding(attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexAttribBinding_ovr_0(attribindex, bindingindex);
    
    private z_VertexBindingDivisor_adr := GetProcAddress('glVertexBindingDivisor');
    private z_VertexBindingDivisor_ovr_0 := GetProcOrNil&<procedure(bindingindex: UInt32; divisor: UInt32)>(z_VertexBindingDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBindingDivisor(bindingindex: UInt32; divisor: UInt32) :=
    z_VertexBindingDivisor_ovr_0(bindingindex, divisor);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexBlendARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_blend';
    
    private z_WeightbvARB_adr := GetProcAddress('glWeightbvARB');
    private z_WeightbvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: SByte)>(z_WeightbvARB_adr);
    private z_WeightbvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightbvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightbvARB(size: Int32; weights: array of SByte) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightbvARB_ovr_0(size, weights[0]) else
      z_WeightbvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightbvARB(size: Int32; var weights: SByte) :=
    z_WeightbvARB_ovr_0(size, weights);
    private z_WeightbvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightbvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightbvARB(size: Int32; weights: IntPtr) :=
    z_WeightbvARB_ovr_2(size, weights);
    
    private z_WeightsvARB_adr := GetProcAddress('glWeightsvARB');
    private z_WeightsvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: Int16)>(z_WeightsvARB_adr);
    private z_WeightsvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightsvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightsvARB(size: Int32; weights: array of Int16) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightsvARB_ovr_0(size, weights[0]) else
      z_WeightsvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightsvARB(size: Int32; var weights: Int16) :=
    z_WeightsvARB_ovr_0(size, weights);
    private z_WeightsvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightsvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightsvARB(size: Int32; weights: IntPtr) :=
    z_WeightsvARB_ovr_2(size, weights);
    
    private z_WeightivARB_adr := GetProcAddress('glWeightivARB');
    private z_WeightivARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: Int32)>(z_WeightivARB_adr);
    private z_WeightivARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightivARB(size: Int32; weights: array of Int32) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightivARB_ovr_0(size, weights[0]) else
      z_WeightivARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightivARB(size: Int32; var weights: Int32) :=
    z_WeightivARB_ovr_0(size, weights);
    private z_WeightivARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightivARB(size: Int32; weights: IntPtr) :=
    z_WeightivARB_ovr_2(size, weights);
    
    private z_WeightfvARB_adr := GetProcAddress('glWeightfvARB');
    private z_WeightfvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: single)>(z_WeightfvARB_adr);
    private z_WeightfvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightfvARB(size: Int32; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightfvARB_ovr_0(size, weights[0]) else
      z_WeightfvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightfvARB(size: Int32; var weights: single) :=
    z_WeightfvARB_ovr_0(size, weights);
    private z_WeightfvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightfvARB(size: Int32; weights: IntPtr) :=
    z_WeightfvARB_ovr_2(size, weights);
    
    private z_WeightdvARB_adr := GetProcAddress('glWeightdvARB');
    private z_WeightdvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: real)>(z_WeightdvARB_adr);
    private z_WeightdvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightdvARB(size: Int32; weights: array of real) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightdvARB_ovr_0(size, weights[0]) else
      z_WeightdvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightdvARB(size: Int32; var weights: real) :=
    z_WeightdvARB_ovr_0(size, weights);
    private z_WeightdvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightdvARB(size: Int32; weights: IntPtr) :=
    z_WeightdvARB_ovr_2(size, weights);
    
    private z_WeightubvARB_adr := GetProcAddress('glWeightubvARB');
    private z_WeightubvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: Byte)>(z_WeightubvARB_adr);
    private z_WeightubvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightubvARB(size: Int32; weights: array of Byte) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightubvARB_ovr_0(size, weights[0]) else
      z_WeightubvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightubvARB(size: Int32; var weights: Byte) :=
    z_WeightubvARB_ovr_0(size, weights);
    private z_WeightubvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightubvARB(size: Int32; weights: IntPtr) :=
    z_WeightubvARB_ovr_2(size, weights);
    
    private z_WeightusvARB_adr := GetProcAddress('glWeightusvARB');
    private z_WeightusvARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: UInt16)>(z_WeightusvARB_adr);
    private z_WeightusvARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightusvARB(size: Int32; weights: array of UInt16) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightusvARB_ovr_0(size, weights[0]) else
      z_WeightusvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightusvARB(size: Int32; var weights: UInt16) :=
    z_WeightusvARB_ovr_0(size, weights);
    private z_WeightusvARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightusvARB(size: Int32; weights: IntPtr) :=
    z_WeightusvARB_ovr_2(size, weights);
    
    private z_WeightuivARB_adr := GetProcAddress('glWeightuivARB');
    private z_WeightuivARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; var weights: UInt32)>(z_WeightuivARB_adr);
    private z_WeightuivARB_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightuivARB(size: Int32; weights: array of UInt32) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightuivARB_ovr_0(size, weights[0]) else
      z_WeightuivARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightuivARB(size: Int32; var weights: UInt32) :=
    z_WeightuivARB_ovr_0(size, weights);
    private z_WeightuivARB_ovr_2 := GetProcOrNil&<procedure(size: Int32; weights: IntPtr)>(z_WeightuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightuivARB(size: Int32; weights: IntPtr) :=
    z_WeightuivARB_ovr_2(size, weights);
    
    private z_WeightPointerARB_adr := GetProcAddress('glWeightPointerARB');
    private z_WeightPointerARB_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: WeightPointerTypeARB; stride: Int32; pointer: IntPtr)>(z_WeightPointerARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPointerARB(size: Int32; &type: WeightPointerTypeARB; stride: Int32; pointer: IntPtr) :=
    z_WeightPointerARB_ovr_0(size, &type, stride, pointer);
    
    private z_VertexBlendARB_adr := GetProcAddress('glVertexBlendARB');
    private z_VertexBlendARB_ovr_0 := GetProcOrNil&<procedure(count: Int32)>(z_VertexBlendARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBlendARB(count: Int32) :=
    z_VertexBlendARB_ovr_0(count);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexBufferObjectARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_buffer_object';
    
    private z_BindBufferARB_adr := GetProcAddress('glBindBufferARB');
    private z_BindBufferARB_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; buffer: gl_buffer)>(z_BindBufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferARB(target: BufferTarget; buffer: gl_buffer) :=
    z_BindBufferARB_ovr_0(target, buffer);
    
    private z_DeleteBuffersARB_adr := GetProcAddress('glDeleteBuffersARB');
    private z_DeleteBuffersARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var buffers: gl_buffer)>(z_DeleteBuffersARB_adr);
    private z_DeleteBuffersARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_DeleteBuffersARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffersARB(n: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_DeleteBuffersARB_ovr_0(n, buffers[0]) else
      z_DeleteBuffersARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffersARB(n: Int32; var buffers: gl_buffer) :=
    z_DeleteBuffersARB_ovr_0(n, buffers);
    private z_DeleteBuffersARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_DeleteBuffersARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffersARB(n: Int32; buffers: IntPtr) :=
    z_DeleteBuffersARB_ovr_2(n, buffers);
    
    private z_GenBuffersARB_adr := GetProcAddress('glGenBuffersARB');
    private z_GenBuffersARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var buffers: gl_buffer)>(z_GenBuffersARB_adr);
    private z_GenBuffersARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_GenBuffersARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffersARB(n: Int32; buffers: array of gl_buffer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_GenBuffersARB_ovr_0(n, buffers[0]) else
      z_GenBuffersARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffersARB(n: Int32; var buffers: gl_buffer) :=
    z_GenBuffersARB_ovr_0(n, buffers);
    private z_GenBuffersARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_GenBuffersARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffersARB(n: Int32; buffers: IntPtr) :=
    z_GenBuffersARB_ovr_2(n, buffers);
    
    private z_IsBufferARB_adr := GetProcAddress('glIsBufferARB');
    private z_IsBufferARB_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_IsBufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsBufferARB(buffer: gl_buffer): boolean :=
    z_IsBufferARB_ovr_0(buffer);
    
    private z_BufferDataARB_adr := GetProcAddress('glBufferDataARB');
    private z_BufferDataARB_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; size: IntPtr; data: IntPtr; usage: BufferUsageARB)>(z_BufferDataARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferDataARB(target: BufferTarget; size: IntPtr; data: IntPtr; usage: BufferUsageARB) :=
    z_BufferDataARB_ovr_0(target, size, data, usage);
    
    private z_BufferSubDataARB_adr := GetProcAddress('glBufferSubDataARB');
    private z_BufferSubDataARB_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_BufferSubDataARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferSubDataARB(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_BufferSubDataARB_ovr_0(target, offset, size, data);
    
    private z_GetBufferSubDataARB_adr := GetProcAddress('glGetBufferSubDataARB');
    private z_GetBufferSubDataARB_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetBufferSubDataARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferSubDataARB(target: BufferTarget; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetBufferSubDataARB_ovr_0(target, offset, size, data);
    
    private z_MapBufferARB_adr := GetProcAddress('glMapBufferARB');
    private z_MapBufferARB_ovr_0 := GetProcOrNil&<function(target: BufferTarget; access: BufferAccessARB): IntPtr>(z_MapBufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBufferARB(target: BufferTarget; access: BufferAccessARB): IntPtr :=
    z_MapBufferARB_ovr_0(target, access);
    
    private z_UnmapBufferARB_adr := GetProcAddress('glUnmapBufferARB');
    private z_UnmapBufferARB_ovr_0 := GetProcOrNil&<function(target: BufferTarget): boolean>(z_UnmapBufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapBufferARB(target: BufferTarget): boolean :=
    z_UnmapBufferARB_ovr_0(target);
    
    private z_GetBufferParameterivARB_adr := GetProcAddress('glGetBufferParameterivARB');
    private z_GetBufferParameterivARB_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; var &params: Int32)>(z_GetBufferParameterivARB_adr);
    private z_GetBufferParameterivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameterivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterivARB(target: BufferTarget; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameterivARB_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameterivARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterivARB(target: BufferTarget; pname: BufferPNameARB; var &params: Int32) :=
    z_GetBufferParameterivARB_ovr_0(target, pname, &params);
    private z_GetBufferParameterivARB_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameterivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterivARB(target: BufferTarget; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetBufferParameterivARB_ovr_2(target, pname, &params);
    
    private z_GetBufferPointervARB_adr := GetProcAddress('glGetBufferPointervARB');
    private z_GetBufferPointervARB_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPointerNameARB; var &params: IntPtr)>(z_GetBufferPointervARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointervARB(target: BufferTarget; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetBufferPointervARB_ovr_0(target, pname, &params);
    private z_GetBufferPointervARB_ovr_1 := GetProcOrNil&<procedure(target: BufferTarget; pname: BufferPointerNameARB; &params: pointer)>(z_GetBufferPointervARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointervARB(target: BufferTarget; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetBufferPointervARB_ovr_1(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexProgramARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_program';
    
    private z_VertexAttrib1dARB_adr := GetProcAddress('glVertexAttrib1dARB');
    private z_VertexAttrib1dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttrib1dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dARB(index: UInt32; x: real) :=
    z_VertexAttrib1dARB_ovr_0(index, x);
    
    private z_VertexAttrib1dvARB_adr := GetProcAddress('glVertexAttrib1dvARB');
    private z_VertexAttrib1dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib1dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib1dvARB_ovr_0(index, v);
    private z_VertexAttrib1dvARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dvARB_ovr_1(index, v);
    
    private z_VertexAttrib1fARB_adr := GetProcAddress('glVertexAttrib1fARB');
    private z_VertexAttrib1fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single)>(z_VertexAttrib1fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fARB(index: UInt32; x: single) :=
    z_VertexAttrib1fARB_ovr_0(index, x);
    
    private z_VertexAttrib1fvARB_adr := GetProcAddress('glVertexAttrib1fvARB');
    private z_VertexAttrib1fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib1fvARB_ovr_0(index, v);
    private z_VertexAttrib1fvARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fvARB_ovr_1(index, v);
    
    private z_VertexAttrib1sARB_adr := GetProcAddress('glVertexAttrib1sARB');
    private z_VertexAttrib1sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16)>(z_VertexAttrib1sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sARB(index: UInt32; x: Int16) :=
    z_VertexAttrib1sARB_ovr_0(index, x);
    
    private z_VertexAttrib1svARB_adr := GetProcAddress('glVertexAttrib1svARB');
    private z_VertexAttrib1svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib1svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib1svARB_ovr_0(index, v);
    private z_VertexAttrib1svARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1svARB_ovr_1(index, v);
    
    private z_VertexAttrib2dARB_adr := GetProcAddress('glVertexAttrib2dARB');
    private z_VertexAttrib2dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttrib2dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dARB(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2dARB_ovr_0(index, x, y);
    
    private z_VertexAttrib2dvARB_adr := GetProcAddress('glVertexAttrib2dvARB');
    private z_VertexAttrib2dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib2dvARB_adr);
    private z_VertexAttrib2dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib2dvARB_ovr_0(index, v);
    private z_VertexAttrib2dvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dvARB_ovr_2(index, v);
    
    private z_VertexAttrib2fARB_adr := GetProcAddress('glVertexAttrib2fARB');
    private z_VertexAttrib2fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single)>(z_VertexAttrib2fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fARB(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2fARB_ovr_0(index, x, y);
    
    private z_VertexAttrib2fvARB_adr := GetProcAddress('glVertexAttrib2fvARB');
    private z_VertexAttrib2fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib2fvARB_adr);
    private z_VertexAttrib2fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib2fvARB_ovr_0(index, v);
    private z_VertexAttrib2fvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fvARB_ovr_2(index, v);
    
    private z_VertexAttrib2sARB_adr := GetProcAddress('glVertexAttrib2sARB');
    private z_VertexAttrib2sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16)>(z_VertexAttrib2sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sARB(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2sARB_ovr_0(index, x, y);
    
    private z_VertexAttrib2svARB_adr := GetProcAddress('glVertexAttrib2svARB');
    private z_VertexAttrib2svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib2svARB_adr);
    private z_VertexAttrib2svARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2svARB_ovr_0(index, v[0]) else
      z_VertexAttrib2svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib2svARB_ovr_0(index, v);
    private z_VertexAttrib2svARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2svARB_ovr_2(index, v);
    
    private z_VertexAttrib3dARB_adr := GetProcAddress('glVertexAttrib3dARB');
    private z_VertexAttrib3dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttrib3dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dARB(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3dARB_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3dvARB_adr := GetProcAddress('glVertexAttrib3dvARB');
    private z_VertexAttrib3dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib3dvARB_adr);
    private z_VertexAttrib3dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib3dvARB_ovr_0(index, v);
    private z_VertexAttrib3dvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dvARB_ovr_2(index, v);
    
    private z_VertexAttrib3fARB_adr := GetProcAddress('glVertexAttrib3fARB');
    private z_VertexAttrib3fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single)>(z_VertexAttrib3fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fARB(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3fARB_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3fvARB_adr := GetProcAddress('glVertexAttrib3fvARB');
    private z_VertexAttrib3fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib3fvARB_adr);
    private z_VertexAttrib3fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib3fvARB_ovr_0(index, v);
    private z_VertexAttrib3fvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fvARB_ovr_2(index, v);
    
    private z_VertexAttrib3sARB_adr := GetProcAddress('glVertexAttrib3sARB');
    private z_VertexAttrib3sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16)>(z_VertexAttrib3sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sARB(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3sARB_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3svARB_adr := GetProcAddress('glVertexAttrib3svARB');
    private z_VertexAttrib3svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib3svARB_adr);
    private z_VertexAttrib3svARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3svARB_ovr_0(index, v[0]) else
      z_VertexAttrib3svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib3svARB_ovr_0(index, v);
    private z_VertexAttrib3svARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3svARB_ovr_2(index, v);
    
    private z_VertexAttrib4NbvARB_adr := GetProcAddress('glVertexAttrib4NbvARB');
    private z_VertexAttrib4NbvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4NbvARB_adr);
    private z_VertexAttrib4NbvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NbvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NbvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NbvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4NbvARB_ovr_0(index, v);
    private z_VertexAttrib4NbvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NbvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NbvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NivARB_adr := GetProcAddress('glVertexAttrib4NivARB');
    private z_VertexAttrib4NivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4NivARB_adr);
    private z_VertexAttrib4NivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4NivARB_ovr_0(index, v);
    private z_VertexAttrib4NivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NivARB_ovr_2(index, v);
    
    private z_VertexAttrib4NsvARB_adr := GetProcAddress('glVertexAttrib4NsvARB');
    private z_VertexAttrib4NsvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4NsvARB_adr);
    private z_VertexAttrib4NsvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NsvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NsvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NsvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4NsvARB_ovr_0(index, v);
    private z_VertexAttrib4NsvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NsvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NsvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NubARB_adr := GetProcAddress('glVertexAttrib4NubARB');
    private z_VertexAttrib4NubARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte)>(z_VertexAttrib4NubARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubARB(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4NubARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4NubvARB_adr := GetProcAddress('glVertexAttrib4NubvARB');
    private z_VertexAttrib4NubvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4NubvARB_adr);
    private z_VertexAttrib4NubvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4NubvARB_ovr_0(index, v);
    private z_VertexAttrib4NubvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NubvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NuivARB_adr := GetProcAddress('glVertexAttrib4NuivARB');
    private z_VertexAttrib4NuivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4NuivARB_adr);
    private z_VertexAttrib4NuivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NuivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NuivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4NuivARB_ovr_0(index, v);
    private z_VertexAttrib4NuivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NuivARB_ovr_2(index, v);
    
    private z_VertexAttrib4NusvARB_adr := GetProcAddress('glVertexAttrib4NusvARB');
    private z_VertexAttrib4NusvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4NusvARB_adr);
    private z_VertexAttrib4NusvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NusvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NusvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4NusvARB_ovr_0(index, v);
    private z_VertexAttrib4NusvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NusvARB_ovr_2(index, v);
    
    private z_VertexAttrib4bvARB_adr := GetProcAddress('glVertexAttrib4bvARB');
    private z_VertexAttrib4bvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4bvARB_adr);
    private z_VertexAttrib4bvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4bvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4bvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4bvARB_ovr_0(index, v);
    private z_VertexAttrib4bvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4bvARB_ovr_2(index, v);
    
    private z_VertexAttrib4dARB_adr := GetProcAddress('glVertexAttrib4dARB');
    private z_VertexAttrib4dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttrib4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dARB(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4dARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4dvARB_adr := GetProcAddress('glVertexAttrib4dvARB');
    private z_VertexAttrib4dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib4dvARB_adr);
    private z_VertexAttrib4dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib4dvARB_ovr_0(index, v);
    private z_VertexAttrib4dvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dvARB_ovr_2(index, v);
    
    private z_VertexAttrib4fARB_adr := GetProcAddress('glVertexAttrib4fARB');
    private z_VertexAttrib4fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single; w: single)>(z_VertexAttrib4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fARB(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4fARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4fvARB_adr := GetProcAddress('glVertexAttrib4fvARB');
    private z_VertexAttrib4fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib4fvARB_adr);
    private z_VertexAttrib4fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib4fvARB_ovr_0(index, v);
    private z_VertexAttrib4fvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fvARB_ovr_2(index, v);
    
    private z_VertexAttrib4ivARB_adr := GetProcAddress('glVertexAttrib4ivARB');
    private z_VertexAttrib4ivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4ivARB_adr);
    private z_VertexAttrib4ivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4ivARB_ovr_0(index, v);
    private z_VertexAttrib4ivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ivARB_ovr_2(index, v);
    
    private z_VertexAttrib4sARB_adr := GetProcAddress('glVertexAttrib4sARB');
    private z_VertexAttrib4sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16)>(z_VertexAttrib4sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sARB(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4sARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4svARB_adr := GetProcAddress('glVertexAttrib4svARB');
    private z_VertexAttrib4svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4svARB_adr);
    private z_VertexAttrib4svARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4svARB_ovr_0(index, v[0]) else
      z_VertexAttrib4svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4svARB_ovr_0(index, v);
    private z_VertexAttrib4svARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4svARB_ovr_2(index, v);
    
    private z_VertexAttrib4ubvARB_adr := GetProcAddress('glVertexAttrib4ubvARB');
    private z_VertexAttrib4ubvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4ubvARB_adr);
    private z_VertexAttrib4ubvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubvARB_ovr_0(index, v);
    private z_VertexAttrib4ubvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubvARB_ovr_2(index, v);
    
    private z_VertexAttrib4uivARB_adr := GetProcAddress('glVertexAttrib4uivARB');
    private z_VertexAttrib4uivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4uivARB_adr);
    private z_VertexAttrib4uivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4uivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4uivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4uivARB_ovr_0(index, v);
    private z_VertexAttrib4uivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4uivARB_ovr_2(index, v);
    
    private z_VertexAttrib4usvARB_adr := GetProcAddress('glVertexAttrib4usvARB');
    private z_VertexAttrib4usvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4usvARB_adr);
    private z_VertexAttrib4usvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4usvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4usvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4usvARB_ovr_0(index, v);
    private z_VertexAttrib4usvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4usvARB_ovr_2(index, v);
    
    private z_VertexAttribPointerARB_adr := GetProcAddress('glVertexAttribPointerARB');
    private z_VertexAttribPointerARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr)>(z_VertexAttribPointerARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointerARB(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointerARB_ovr_0(index, size, &type, normalized, stride, pointer);
    
    private z_EnableVertexAttribArrayARB_adr := GetProcAddress('glEnableVertexAttribArrayARB');
    private z_EnableVertexAttribArrayARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_EnableVertexAttribArrayARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribArrayARB(index: UInt32) :=
    z_EnableVertexAttribArrayARB_ovr_0(index);
    
    private z_DisableVertexAttribArrayARB_adr := GetProcAddress('glDisableVertexAttribArrayARB');
    private z_DisableVertexAttribArrayARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_DisableVertexAttribArrayARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribArrayARB(index: UInt32) :=
    z_DisableVertexAttribArrayARB_ovr_0(index);
    
    private z_ProgramStringARB_adr := GetProcAddress('glProgramStringARB');
    private z_ProgramStringARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr)>(z_ProgramStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramStringARB(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr) :=
    z_ProgramStringARB_ovr_0(target, format, len, string);
    
    private z_BindProgramARB_adr := GetProcAddress('glBindProgramARB');
    private z_BindProgramARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; &program: gl_program)>(z_BindProgramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramARB(target: ProgramTarget; &program: gl_program) :=
    z_BindProgramARB_ovr_0(target, &program);
    
    private z_DeleteProgramsARB_adr := GetProcAddress('glDeleteProgramsARB');
    private z_DeleteProgramsARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_DeleteProgramsARB_adr);
    private z_DeleteProgramsARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_DeleteProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_DeleteProgramsARB_ovr_0(n, programs[0]) else
      z_DeleteProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; var programs: gl_program) :=
    z_DeleteProgramsARB_ovr_0(n, programs);
    private z_DeleteProgramsARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_DeleteProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: IntPtr) :=
    z_DeleteProgramsARB_ovr_2(n, programs);
    
    private z_GenProgramsARB_adr := GetProcAddress('glGenProgramsARB');
    private z_GenProgramsARB_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_GenProgramsARB_adr);
    private z_GenProgramsARB_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_GenProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_GenProgramsARB_ovr_0(n, programs[0]) else
      z_GenProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; var programs: gl_program) :=
    z_GenProgramsARB_ovr_0(n, programs);
    private z_GenProgramsARB_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_GenProgramsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: IntPtr) :=
    z_GenProgramsARB_ovr_2(n, programs);
    
    private z_ProgramEnvParameter4dARB_adr := GetProcAddress('glProgramEnvParameter4dARB');
    private z_ProgramEnvParameter4dARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real)>(z_ProgramEnvParameter4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramEnvParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramEnvParameter4dvARB_adr := GetProcAddress('glProgramEnvParameter4dvARB');
    private z_ProgramEnvParameter4dvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_ProgramEnvParameter4dvARB_adr);
    private z_ProgramEnvParameter4dvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params);
    private z_ProgramEnvParameter4dvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4dvARB_ovr_2(target, index, &params);
    
    private z_ProgramEnvParameter4fARB_adr := GetProcAddress('glProgramEnvParameter4fARB');
    private z_ProgramEnvParameter4fARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single)>(z_ProgramEnvParameter4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramEnvParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramEnvParameter4fvARB_adr := GetProcAddress('glProgramEnvParameter4fvARB');
    private z_ProgramEnvParameter4fvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_ProgramEnvParameter4fvARB_adr);
    private z_ProgramEnvParameter4fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params);
    private z_ProgramEnvParameter4fvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4fvARB_ovr_2(target, index, &params);
    
    private z_ProgramLocalParameter4dARB_adr := GetProcAddress('glProgramLocalParameter4dARB');
    private z_ProgramLocalParameter4dARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real)>(z_ProgramLocalParameter4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramLocalParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramLocalParameter4dvARB_adr := GetProcAddress('glProgramLocalParameter4dvARB');
    private z_ProgramLocalParameter4dvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_ProgramLocalParameter4dvARB_adr);
    private z_ProgramLocalParameter4dvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params);
    private z_ProgramLocalParameter4dvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4dvARB_ovr_2(target, index, &params);
    
    private z_ProgramLocalParameter4fARB_adr := GetProcAddress('glProgramLocalParameter4fARB');
    private z_ProgramLocalParameter4fARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single)>(z_ProgramLocalParameter4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramLocalParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramLocalParameter4fvARB_adr := GetProcAddress('glProgramLocalParameter4fvARB');
    private z_ProgramLocalParameter4fvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_ProgramLocalParameter4fvARB_adr);
    private z_ProgramLocalParameter4fvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params);
    private z_ProgramLocalParameter4fvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameter4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4fvARB_ovr_2(target, index, &params);
    
    private z_GetProgramEnvParameterdvARB_adr := GetProcAddress('glGetProgramEnvParameterdvARB');
    private z_GetProgramEnvParameterdvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_GetProgramEnvParameterdvARB_adr);
    private z_GetProgramEnvParameterdvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params);
    private z_GetProgramEnvParameterdvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterdvARB_ovr_2(target, index, &params);
    
    private z_GetProgramEnvParameterfvARB_adr := GetProcAddress('glGetProgramEnvParameterfvARB');
    private z_GetProgramEnvParameterfvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_GetProgramEnvParameterfvARB_adr);
    private z_GetProgramEnvParameterfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params);
    private z_GetProgramEnvParameterfvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterfvARB_ovr_2(target, index, &params);
    
    private z_GetProgramLocalParameterdvARB_adr := GetProcAddress('glGetProgramLocalParameterdvARB');
    private z_GetProgramLocalParameterdvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: real)>(z_GetProgramLocalParameterdvARB_adr);
    private z_GetProgramLocalParameterdvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params);
    private z_GetProgramLocalParameterdvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterdvARB_ovr_2(target, index, &params);
    
    private z_GetProgramLocalParameterfvARB_adr := GetProcAddress('glGetProgramLocalParameterfvARB');
    private z_GetProgramLocalParameterfvARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: single)>(z_GetProgramLocalParameterfvARB_adr);
    private z_GetProgramLocalParameterfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params);
    private z_GetProgramLocalParameterfvARB_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterfvARB_ovr_2(target, index, &params);
    
    private z_GetProgramivARB_adr := GetProcAddress('glGetProgramivARB');
    private z_GetProgramivARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32)>(z_GetProgramivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetProgramivARB_ovr_0(target, pname, &params);
    private z_GetProgramivARB_ovr_1 := GetProcOrNil&<procedure(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetProgramivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetProgramivARB_ovr_1(target, pname, &params);
    
    private z_GetProgramStringARB_adr := GetProcAddress('glGetProgramStringARB');
    private z_GetProgramStringARB_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr)>(z_GetProgramStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringARB(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr) :=
    z_GetProgramStringARB_ovr_0(target, pname, string);
    
    private z_GetVertexAttribdvARB_adr := GetProcAddress('glGetVertexAttribdvARB');
    private z_GetVertexAttribdvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: real)>(z_GetVertexAttribdvARB_adr);
    private z_GetVertexAttribdvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: real) :=
    z_GetVertexAttribdvARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribdvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribdvARB_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribfvARB_adr := GetProcAddress('glGetVertexAttribfvARB');
    private z_GetVertexAttribfvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: single)>(z_GetVertexAttribfvARB_adr);
    private z_GetVertexAttribfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: single) :=
    z_GetVertexAttribfvARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribfvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribfvARB_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribivARB_adr := GetProcAddress('glGetVertexAttribivARB');
    private z_GetVertexAttribivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32)>(z_GetVertexAttribivARB_adr);
    private z_GetVertexAttribivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribivARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribivARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32) :=
    z_GetVertexAttribivARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribivARB_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribPointervARB_adr := GetProcAddress('glGetVertexAttribPointervARB');
    private z_GetVertexAttribPointervARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr)>(z_GetVertexAttribPointervARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr) :=
    z_GetVertexAttribPointervARB_ovr_0(index, pname, _pointer);
    private z_GetVertexAttribPointervARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer)>(z_GetVertexAttribPointervARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer) :=
    z_GetVertexAttribPointervARB_ovr_1(index, pname, _pointer);
    
    private z_IsProgramARB_adr := GetProcAddress('glIsProgramARB');
    private z_IsProgramARB_ovr_0 := GetProcOrNil&<function(&program: gl_program): boolean>(z_IsProgramARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramARB(&program: gl_program): boolean :=
    z_IsProgramARB_ovr_0(&program);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexShaderARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_shader';
    
    private z_VertexAttrib1fARB_adr := GetProcAddress('glVertexAttrib1fARB');
    private z_VertexAttrib1fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single)>(z_VertexAttrib1fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fARB(index: UInt32; x: single) :=
    z_VertexAttrib1fARB_ovr_0(index, x);
    
    private z_VertexAttrib1sARB_adr := GetProcAddress('glVertexAttrib1sARB');
    private z_VertexAttrib1sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16)>(z_VertexAttrib1sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sARB(index: UInt32; x: Int16) :=
    z_VertexAttrib1sARB_ovr_0(index, x);
    
    private z_VertexAttrib1dARB_adr := GetProcAddress('glVertexAttrib1dARB');
    private z_VertexAttrib1dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttrib1dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dARB(index: UInt32; x: real) :=
    z_VertexAttrib1dARB_ovr_0(index, x);
    
    private z_VertexAttrib2fARB_adr := GetProcAddress('glVertexAttrib2fARB');
    private z_VertexAttrib2fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single)>(z_VertexAttrib2fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fARB(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2fARB_ovr_0(index, x, y);
    
    private z_VertexAttrib2sARB_adr := GetProcAddress('glVertexAttrib2sARB');
    private z_VertexAttrib2sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16)>(z_VertexAttrib2sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sARB(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2sARB_ovr_0(index, x, y);
    
    private z_VertexAttrib2dARB_adr := GetProcAddress('glVertexAttrib2dARB');
    private z_VertexAttrib2dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttrib2dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dARB(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2dARB_ovr_0(index, x, y);
    
    private z_VertexAttrib3fARB_adr := GetProcAddress('glVertexAttrib3fARB');
    private z_VertexAttrib3fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single)>(z_VertexAttrib3fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fARB(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3fARB_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3sARB_adr := GetProcAddress('glVertexAttrib3sARB');
    private z_VertexAttrib3sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16)>(z_VertexAttrib3sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sARB(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3sARB_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3dARB_adr := GetProcAddress('glVertexAttrib3dARB');
    private z_VertexAttrib3dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttrib3dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dARB(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3dARB_ovr_0(index, x, y, z);
    
    private z_VertexAttrib4fARB_adr := GetProcAddress('glVertexAttrib4fARB');
    private z_VertexAttrib4fARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single; w: single)>(z_VertexAttrib4fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fARB(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4fARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4sARB_adr := GetProcAddress('glVertexAttrib4sARB');
    private z_VertexAttrib4sARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16)>(z_VertexAttrib4sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sARB(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4sARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4dARB_adr := GetProcAddress('glVertexAttrib4dARB');
    private z_VertexAttrib4dARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttrib4dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dARB(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4dARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4NubARB_adr := GetProcAddress('glVertexAttrib4NubARB');
    private z_VertexAttrib4NubARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte)>(z_VertexAttrib4NubARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubARB(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4NubARB_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib1fvARB_adr := GetProcAddress('glVertexAttrib1fvARB');
    private z_VertexAttrib1fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib1fvARB_ovr_0(index, v);
    private z_VertexAttrib1fvARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fvARB_ovr_1(index, v);
    
    private z_VertexAttrib1svARB_adr := GetProcAddress('glVertexAttrib1svARB');
    private z_VertexAttrib1svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib1svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib1svARB_ovr_0(index, v);
    private z_VertexAttrib1svARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1svARB_ovr_1(index, v);
    
    private z_VertexAttrib1dvARB_adr := GetProcAddress('glVertexAttrib1dvARB');
    private z_VertexAttrib1dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib1dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib1dvARB_ovr_0(index, v);
    private z_VertexAttrib1dvARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dvARB_ovr_1(index, v);
    
    private z_VertexAttrib2fvARB_adr := GetProcAddress('glVertexAttrib2fvARB');
    private z_VertexAttrib2fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib2fvARB_adr);
    private z_VertexAttrib2fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib2fvARB_ovr_0(index, v);
    private z_VertexAttrib2fvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fvARB_ovr_2(index, v);
    
    private z_VertexAttrib2svARB_adr := GetProcAddress('glVertexAttrib2svARB');
    private z_VertexAttrib2svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib2svARB_adr);
    private z_VertexAttrib2svARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2svARB_ovr_0(index, v[0]) else
      z_VertexAttrib2svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib2svARB_ovr_0(index, v);
    private z_VertexAttrib2svARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2svARB_ovr_2(index, v);
    
    private z_VertexAttrib2dvARB_adr := GetProcAddress('glVertexAttrib2dvARB');
    private z_VertexAttrib2dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib2dvARB_adr);
    private z_VertexAttrib2dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib2dvARB_ovr_0(index, v);
    private z_VertexAttrib2dvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dvARB_ovr_2(index, v);
    
    private z_VertexAttrib3fvARB_adr := GetProcAddress('glVertexAttrib3fvARB');
    private z_VertexAttrib3fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib3fvARB_adr);
    private z_VertexAttrib3fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib3fvARB_ovr_0(index, v);
    private z_VertexAttrib3fvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fvARB_ovr_2(index, v);
    
    private z_VertexAttrib3svARB_adr := GetProcAddress('glVertexAttrib3svARB');
    private z_VertexAttrib3svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib3svARB_adr);
    private z_VertexAttrib3svARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3svARB_ovr_0(index, v[0]) else
      z_VertexAttrib3svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib3svARB_ovr_0(index, v);
    private z_VertexAttrib3svARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3svARB_ovr_2(index, v);
    
    private z_VertexAttrib3dvARB_adr := GetProcAddress('glVertexAttrib3dvARB');
    private z_VertexAttrib3dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib3dvARB_adr);
    private z_VertexAttrib3dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib3dvARB_ovr_0(index, v);
    private z_VertexAttrib3dvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dvARB_ovr_2(index, v);
    
    private z_VertexAttrib4fvARB_adr := GetProcAddress('glVertexAttrib4fvARB');
    private z_VertexAttrib4fvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib4fvARB_adr);
    private z_VertexAttrib4fvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib4fvARB_ovr_0(index, v);
    private z_VertexAttrib4fvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fvARB_ovr_2(index, v);
    
    private z_VertexAttrib4svARB_adr := GetProcAddress('glVertexAttrib4svARB');
    private z_VertexAttrib4svARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4svARB_adr);
    private z_VertexAttrib4svARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4svARB_ovr_0(index, v[0]) else
      z_VertexAttrib4svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4svARB_ovr_0(index, v);
    private z_VertexAttrib4svARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4svARB_ovr_2(index, v);
    
    private z_VertexAttrib4dvARB_adr := GetProcAddress('glVertexAttrib4dvARB');
    private z_VertexAttrib4dvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib4dvARB_adr);
    private z_VertexAttrib4dvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib4dvARB_ovr_0(index, v);
    private z_VertexAttrib4dvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dvARB_ovr_2(index, v);
    
    private z_VertexAttrib4ivARB_adr := GetProcAddress('glVertexAttrib4ivARB');
    private z_VertexAttrib4ivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4ivARB_adr);
    private z_VertexAttrib4ivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4ivARB_ovr_0(index, v);
    private z_VertexAttrib4ivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ivARB_ovr_2(index, v);
    
    private z_VertexAttrib4bvARB_adr := GetProcAddress('glVertexAttrib4bvARB');
    private z_VertexAttrib4bvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4bvARB_adr);
    private z_VertexAttrib4bvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4bvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4bvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4bvARB_ovr_0(index, v);
    private z_VertexAttrib4bvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4bvARB_ovr_2(index, v);
    
    private z_VertexAttrib4ubvARB_adr := GetProcAddress('glVertexAttrib4ubvARB');
    private z_VertexAttrib4ubvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4ubvARB_adr);
    private z_VertexAttrib4ubvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubvARB_ovr_0(index, v);
    private z_VertexAttrib4ubvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubvARB_ovr_2(index, v);
    
    private z_VertexAttrib4usvARB_adr := GetProcAddress('glVertexAttrib4usvARB');
    private z_VertexAttrib4usvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4usvARB_adr);
    private z_VertexAttrib4usvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4usvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4usvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4usvARB_ovr_0(index, v);
    private z_VertexAttrib4usvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4usvARB_ovr_2(index, v);
    
    private z_VertexAttrib4uivARB_adr := GetProcAddress('glVertexAttrib4uivARB');
    private z_VertexAttrib4uivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4uivARB_adr);
    private z_VertexAttrib4uivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4uivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4uivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4uivARB_ovr_0(index, v);
    private z_VertexAttrib4uivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4uivARB_ovr_2(index, v);
    
    private z_VertexAttrib4NbvARB_adr := GetProcAddress('glVertexAttrib4NbvARB');
    private z_VertexAttrib4NbvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4NbvARB_adr);
    private z_VertexAttrib4NbvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NbvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NbvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NbvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4NbvARB_ovr_0(index, v);
    private z_VertexAttrib4NbvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NbvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NbvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NsvARB_adr := GetProcAddress('glVertexAttrib4NsvARB');
    private z_VertexAttrib4NsvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4NsvARB_adr);
    private z_VertexAttrib4NsvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NsvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NsvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NsvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4NsvARB_ovr_0(index, v);
    private z_VertexAttrib4NsvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NsvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NsvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NivARB_adr := GetProcAddress('glVertexAttrib4NivARB');
    private z_VertexAttrib4NivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4NivARB_adr);
    private z_VertexAttrib4NivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4NivARB_ovr_0(index, v);
    private z_VertexAttrib4NivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NivARB_ovr_2(index, v);
    
    private z_VertexAttrib4NubvARB_adr := GetProcAddress('glVertexAttrib4NubvARB');
    private z_VertexAttrib4NubvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4NubvARB_adr);
    private z_VertexAttrib4NubvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4NubvARB_ovr_0(index, v);
    private z_VertexAttrib4NubvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NubvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NubvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NusvARB_adr := GetProcAddress('glVertexAttrib4NusvARB');
    private z_VertexAttrib4NusvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4NusvARB_adr);
    private z_VertexAttrib4NusvARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NusvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NusvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4NusvARB_ovr_0(index, v);
    private z_VertexAttrib4NusvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NusvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NusvARB_ovr_2(index, v);
    
    private z_VertexAttrib4NuivARB_adr := GetProcAddress('glVertexAttrib4NuivARB');
    private z_VertexAttrib4NuivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4NuivARB_adr);
    private z_VertexAttrib4NuivARB_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NuivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NuivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4NuivARB_ovr_0(index, v);
    private z_VertexAttrib4NuivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4NuivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NuivARB_ovr_2(index, v);
    
    private z_VertexAttribPointerARB_adr := GetProcAddress('glVertexAttribPointerARB');
    private z_VertexAttribPointerARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr)>(z_VertexAttribPointerARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointerARB(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointerARB_ovr_0(index, size, &type, normalized, stride, pointer);
    
    private z_EnableVertexAttribArrayARB_adr := GetProcAddress('glEnableVertexAttribArrayARB');
    private z_EnableVertexAttribArrayARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_EnableVertexAttribArrayARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribArrayARB(index: UInt32) :=
    z_EnableVertexAttribArrayARB_ovr_0(index);
    
    private z_DisableVertexAttribArrayARB_adr := GetProcAddress('glDisableVertexAttribArrayARB');
    private z_DisableVertexAttribArrayARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_DisableVertexAttribArrayARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribArrayARB(index: UInt32) :=
    z_DisableVertexAttribArrayARB_ovr_0(index);
    
    private z_BindAttribLocationARB_adr := GetProcAddress('glBindAttribLocationARB');
    private z_BindAttribLocationARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; name: IntPtr)>(z_BindAttribLocationARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocationARB(programObj: gl_handle_ARB; index: UInt32; name: string);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_BindAttribLocationARB_ovr_0(programObj, index, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocationARB(programObj: gl_handle_ARB; index: UInt32; name: IntPtr) :=
    z_BindAttribLocationARB_ovr_0(programObj, index, name);
    
    private z_GetActiveAttribARB_adr := GetProcAddress('glGetActiveAttribARB');
    private z_GetActiveAttribARB_ovr_0 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_1 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_1(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_2 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_2(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_3 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_3(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_4 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_4(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_5 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_5(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_6 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_6(programObj, index, maxLength, length, size, &type, name);
    private z_GetActiveAttribARB_ovr_7 := GetProcOrNil&<procedure(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: gl_handle_ARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_7(programObj, index, maxLength, length, size, &type, name);
    
    private z_GetAttribLocationARB_adr := GetProcAddress('glGetAttribLocationARB');
    private z_GetAttribLocationARB_ovr_0 := GetProcOrNil&<function(programObj: gl_handle_ARB; name: IntPtr): Int32>(z_GetAttribLocationARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocationARB(programObj: gl_handle_ARB; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetAttribLocationARB_ovr_0(programObj, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocationARB(programObj: gl_handle_ARB; name: IntPtr): Int32 :=
    z_GetAttribLocationARB_ovr_0(programObj, name);
    
    private z_GetVertexAttribdvARB_adr := GetProcAddress('glGetVertexAttribdvARB');
    private z_GetVertexAttribdvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: real)>(z_GetVertexAttribdvARB_adr);
    private z_GetVertexAttribdvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: real) :=
    z_GetVertexAttribdvARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribdvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribdvARB_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribfvARB_adr := GetProcAddress('glGetVertexAttribfvARB');
    private z_GetVertexAttribfvARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: single)>(z_GetVertexAttribfvARB_adr);
    private z_GetVertexAttribfvARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: single) :=
    z_GetVertexAttribfvARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribfvARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribfvARB_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribivARB_adr := GetProcAddress('glGetVertexAttribivARB');
    private z_GetVertexAttribivARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32)>(z_GetVertexAttribivARB_adr);
    private z_GetVertexAttribivARB_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribivARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribivARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32) :=
    z_GetVertexAttribivARB_ovr_0(index, pname, &params);
    private z_GetVertexAttribivARB_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribivARB_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribPointervARB_adr := GetProcAddress('glGetVertexAttribPointervARB');
    private z_GetVertexAttribPointervARB_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr)>(z_GetVertexAttribPointervARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr) :=
    z_GetVertexAttribPointervARB_ovr_0(index, pname, _pointer);
    private z_GetVertexAttribPointervARB_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer)>(z_GetVertexAttribPointervARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer) :=
    z_GetVertexAttribPointervARB_ovr_1(index, pname, _pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexType2101010RevARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_vertex_type_2_10_10_10_rev';
    
    private z_VertexAttribP1ui_adr := GetProcAddress('glVertexAttribP1ui');
    private z_VertexAttribP1ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP1ui_ovr_0(index, &type, normalized, value);
    
    private z_VertexAttribP1uiv_adr := GetProcAddress('glVertexAttribP1uiv');
    private z_VertexAttribP1uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP1uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP1uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP1uiv_ovr_1(index, &type, normalized, value);
    
    private z_VertexAttribP2ui_adr := GetProcAddress('glVertexAttribP2ui');
    private z_VertexAttribP2ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP2ui_ovr_0(index, &type, normalized, value);
    
    private z_VertexAttribP2uiv_adr := GetProcAddress('glVertexAttribP2uiv');
    private z_VertexAttribP2uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP2uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP2uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP2uiv_ovr_1(index, &type, normalized, value);
    
    private z_VertexAttribP3ui_adr := GetProcAddress('glVertexAttribP3ui');
    private z_VertexAttribP3ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP3ui_ovr_0(index, &type, normalized, value);
    
    private z_VertexAttribP3uiv_adr := GetProcAddress('glVertexAttribP3uiv');
    private z_VertexAttribP3uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP3uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP3uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP3uiv_ovr_1(index, &type, normalized, value);
    
    private z_VertexAttribP4ui_adr := GetProcAddress('glVertexAttribP4ui');
    private z_VertexAttribP4ui_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP4ui_ovr_0(index, &type, normalized, value);
    
    private z_VertexAttribP4uiv_adr := GetProcAddress('glVertexAttribP4uiv');
    private z_VertexAttribP4uiv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP4uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP4uiv_ovr_1 := GetProcOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP4uiv_ovr_1(index, &type, normalized, value);
    
    private z_VertexP2ui_adr := GetProcAddress('glVertexP2ui');
    private z_VertexP2ui_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP2ui_ovr_0(&type, value);
    
    private z_VertexP2uiv_adr := GetProcAddress('glVertexP2uiv');
    private z_VertexP2uiv_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP2uiv_ovr_0(&type, value);
    private z_VertexP2uiv_ovr_1 := GetProcOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP2uiv_ovr_1(&type, value);
    
    private z_VertexP3ui_adr := GetProcAddress('glVertexP3ui');
    private z_VertexP3ui_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP3ui_ovr_0(&type, value);
    
    private z_VertexP3uiv_adr := GetProcAddress('glVertexP3uiv');
    private z_VertexP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP3uiv_ovr_0(&type, value);
    private z_VertexP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP3uiv_ovr_1(&type, value);
    
    private z_VertexP4ui_adr := GetProcAddress('glVertexP4ui');
    private z_VertexP4ui_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP4ui_ovr_0(&type, value);
    
    private z_VertexP4uiv_adr := GetProcAddress('glVertexP4uiv');
    private z_VertexP4uiv_ovr_0 := GetProcOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP4uiv_ovr_0(&type, value);
    private z_VertexP4uiv_ovr_1 := GetProcOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP4uiv_ovr_1(&type, value);
    
    private z_TexCoordP1ui_adr := GetProcAddress('glTexCoordP1ui');
    private z_TexCoordP1ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP1ui_ovr_0(&type, coords);
    
    private z_TexCoordP1uiv_adr := GetProcAddress('glTexCoordP1uiv');
    private z_TexCoordP1uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP1uiv_ovr_0(&type, coords);
    private z_TexCoordP1uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP1uiv_ovr_1(&type, coords);
    
    private z_TexCoordP2ui_adr := GetProcAddress('glTexCoordP2ui');
    private z_TexCoordP2ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP2ui_ovr_0(&type, coords);
    
    private z_TexCoordP2uiv_adr := GetProcAddress('glTexCoordP2uiv');
    private z_TexCoordP2uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP2uiv_ovr_0(&type, coords);
    private z_TexCoordP2uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP2uiv_ovr_1(&type, coords);
    
    private z_TexCoordP3ui_adr := GetProcAddress('glTexCoordP3ui');
    private z_TexCoordP3ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP3ui_ovr_0(&type, coords);
    
    private z_TexCoordP3uiv_adr := GetProcAddress('glTexCoordP3uiv');
    private z_TexCoordP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP3uiv_ovr_0(&type, coords);
    private z_TexCoordP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP3uiv_ovr_1(&type, coords);
    
    private z_TexCoordP4ui_adr := GetProcAddress('glTexCoordP4ui');
    private z_TexCoordP4ui_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP4ui_ovr_0(&type, coords);
    
    private z_TexCoordP4uiv_adr := GetProcAddress('glTexCoordP4uiv');
    private z_TexCoordP4uiv_ovr_0 := GetProcOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP4uiv_ovr_0(&type, coords);
    private z_TexCoordP4uiv_ovr_1 := GetProcOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP4uiv_ovr_1(&type, coords);
    
    private z_MultiTexCoordP1ui_adr := GetProcAddress('glMultiTexCoordP1ui');
    private z_MultiTexCoordP1ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP1ui_ovr_0(texture, &type, coords);
    
    private z_MultiTexCoordP1uiv_adr := GetProcAddress('glMultiTexCoordP1uiv');
    private z_MultiTexCoordP1uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP1uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP1uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP1uiv_ovr_1(texture, &type, coords);
    
    private z_MultiTexCoordP2ui_adr := GetProcAddress('glMultiTexCoordP2ui');
    private z_MultiTexCoordP2ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP2ui_ovr_0(texture, &type, coords);
    
    private z_MultiTexCoordP2uiv_adr := GetProcAddress('glMultiTexCoordP2uiv');
    private z_MultiTexCoordP2uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP2uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP2uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP2uiv_ovr_1(texture, &type, coords);
    
    private z_MultiTexCoordP3ui_adr := GetProcAddress('glMultiTexCoordP3ui');
    private z_MultiTexCoordP3ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP3ui_ovr_0(texture, &type, coords);
    
    private z_MultiTexCoordP3uiv_adr := GetProcAddress('glMultiTexCoordP3uiv');
    private z_MultiTexCoordP3uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP3uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP3uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP3uiv_ovr_1(texture, &type, coords);
    
    private z_MultiTexCoordP4ui_adr := GetProcAddress('glMultiTexCoordP4ui');
    private z_MultiTexCoordP4ui_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP4ui_ovr_0(texture, &type, coords);
    
    private z_MultiTexCoordP4uiv_adr := GetProcAddress('glMultiTexCoordP4uiv');
    private z_MultiTexCoordP4uiv_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP4uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP4uiv_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP4uiv_ovr_1(texture, &type, coords);
    
    private z_NormalP3ui_adr := GetProcAddress('glNormalP3ui');
    private z_NormalP3ui_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; coords: UInt32)>(z_NormalP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3ui(&type: NormalPointerType; coords: UInt32) :=
    z_NormalP3ui_ovr_0(&type, coords);
    
    private z_NormalP3uiv_adr := GetProcAddress('glNormalP3uiv');
    private z_NormalP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; var coords: UInt32)>(z_NormalP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; var coords: UInt32) :=
    z_NormalP3uiv_ovr_0(&type, coords);
    private z_NormalP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: NormalPointerType; coords: IntPtr)>(z_NormalP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; coords: IntPtr) :=
    z_NormalP3uiv_ovr_1(&type, coords);
    
    private z_ColorP3ui_adr := GetProcAddress('glColorP3ui');
    private z_ColorP3ui_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_ColorP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP3ui_ovr_0(&type, color);
    
    private z_ColorP3uiv_adr := GetProcAddress('glColorP3uiv');
    private z_ColorP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_ColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP3uiv_ovr_0(&type, color);
    private z_ColorP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP3uiv_ovr_1(&type, color);
    
    private z_ColorP4ui_adr := GetProcAddress('glColorP4ui');
    private z_ColorP4ui_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_ColorP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP4ui_ovr_0(&type, color);
    
    private z_ColorP4uiv_adr := GetProcAddress('glColorP4uiv');
    private z_ColorP4uiv_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_ColorP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP4uiv_ovr_0(&type, color);
    private z_ColorP4uiv_ovr_1 := GetProcOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP4uiv_ovr_1(&type, color);
    
    private z_SecondaryColorP3ui_adr := GetProcAddress('glSecondaryColorP3ui');
    private z_SecondaryColorP3ui_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_SecondaryColorP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_SecondaryColorP3ui_ovr_0(&type, color);
    
    private z_SecondaryColorP3uiv_adr := GetProcAddress('glSecondaryColorP3uiv');
    private z_SecondaryColorP3uiv_ovr_0 := GetProcOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_SecondaryColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_SecondaryColorP3uiv_ovr_0(&type, color);
    private z_SecondaryColorP3uiv_ovr_1 := GetProcOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_SecondaryColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_SecondaryColorP3uiv_ovr_1(&type, color);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glViewportArrayARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_viewport_array';
    
    private z_ViewportArrayv_adr := GetProcAddress('glViewportArrayv');
    private z_ViewportArrayv_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: single)>(z_ViewportArrayv_adr);
    private z_ViewportArrayv_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ViewportArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportArrayv_ovr_0(first, count, v[0]) else
      z_ViewportArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; var v: single) :=
    z_ViewportArrayv_ovr_0(first, count, v);
    private z_ViewportArrayv_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ViewportArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ViewportArrayv_ovr_2(first, count, v);
    
    private z_ViewportIndexedf_adr := GetProcAddress('glViewportIndexedf');
    private z_ViewportIndexedf_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; w: single; h: single)>(z_ViewportIndexedf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedf(index: UInt32; x: single; y: single; w: single; h: single) :=
    z_ViewportIndexedf_ovr_0(index, x, y, w, h);
    
    private z_ViewportIndexedfv_adr := GetProcAddress('glViewportIndexedfv');
    private z_ViewportIndexedfv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_ViewportIndexedfv_adr);
    private z_ViewportIndexedfv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ViewportIndexedfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportIndexedfv_ovr_0(index, v[0]) else
      z_ViewportIndexedfv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; var v: single) :=
    z_ViewportIndexedfv_ovr_0(index, v);
    private z_ViewportIndexedfv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ViewportIndexedfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: IntPtr) :=
    z_ViewportIndexedfv_ovr_2(index, v);
    
    private z_ScissorArrayv_adr := GetProcAddress('glScissorArrayv');
    private z_ScissorArrayv_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: Int32)>(z_ScissorArrayv_adr);
    private z_ScissorArrayv_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorArrayv_ovr_0(first, count, v[0]) else
      z_ScissorArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; var v: Int32) :=
    z_ScissorArrayv_ovr_0(first, count, v);
    private z_ScissorArrayv_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ScissorArrayv_ovr_2(first, count, v);
    
    private z_ScissorIndexed_adr := GetProcAddress('glScissorIndexed');
    private z_ScissorIndexed_ovr_0 := GetProcOrNil&<procedure(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32)>(z_ScissorIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexed(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32) :=
    z_ScissorIndexed_ovr_0(index, left, bottom, width, height);
    
    private z_ScissorIndexedv_adr := GetProcAddress('glScissorIndexedv');
    private z_ScissorIndexedv_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_ScissorIndexedv_adr);
    private z_ScissorIndexedv_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ScissorIndexedv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorIndexedv_ovr_0(index, v[0]) else
      z_ScissorIndexedv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; var v: Int32) :=
    z_ScissorIndexedv_ovr_0(index, v);
    private z_ScissorIndexedv_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ScissorIndexedv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: IntPtr) :=
    z_ScissorIndexedv_ovr_2(index, v);
    
    private z_DepthRangeArrayv_adr := GetProcAddress('glDepthRangeArrayv');
    private z_DepthRangeArrayv_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: real)>(z_DepthRangeArrayv_adr);
    private z_DepthRangeArrayv_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_DepthRangeArrayv_ovr_0(first, count, v[0]) else
      z_DepthRangeArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; var v: real) :=
    z_DepthRangeArrayv_ovr_0(first, count, v);
    private z_DepthRangeArrayv_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_DepthRangeArrayv_ovr_2(first, count, v);
    
    private z_DepthRangeIndexed_adr := GetProcAddress('glDepthRangeIndexed');
    private z_DepthRangeIndexed_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: real; f: real)>(z_DepthRangeIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeIndexed(index: UInt32; n: real; f: real) :=
    z_DepthRangeIndexed_ovr_0(index, n, f);
    
    private z_GetFloati_v_adr := GetProcAddress('glGetFloati_v');
    private z_GetFloati_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: single)>(z_GetFloati_v_adr);
    private z_GetFloati_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetFloati_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: GetPName; index: UInt32; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloati_v_ovr_0(target, index, data[0]) else
      z_GetFloati_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: GetPName; index: UInt32; var data: single) :=
    z_GetFloati_v_ovr_0(target, index, data);
    private z_GetFloati_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetFloati_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetFloati_v_ovr_2(target, index, data);
    
    private z_GetDoublei_v_adr := GetProcAddress('glGetDoublei_v');
    private z_GetDoublei_v_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: real)>(z_GetDoublei_v_adr);
    private z_GetDoublei_v_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetDoublei_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: GetPName; index: UInt32; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoublei_v_ovr_0(target, index, data[0]) else
      z_GetDoublei_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: GetPName; index: UInt32; var data: real) :=
    z_GetDoublei_v_ovr_0(target, index, data);
    private z_GetDoublei_v_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetDoublei_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetDoublei_v_ovr_2(target, index, data);
    
    private z_DepthRangeArraydvNV_adr := GetProcAddress('glDepthRangeArraydvNV');
    private z_DepthRangeArraydvNV_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: real)>(z_DepthRangeArraydvNV_adr);
    private z_DepthRangeArraydvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArraydvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArraydvNV(first: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_DepthRangeArraydvNV_ovr_0(first, count, v[0]) else
      z_DepthRangeArraydvNV_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArraydvNV(first: UInt32; count: Int32; var v: real) :=
    z_DepthRangeArraydvNV_ovr_0(first, count, v);
    private z_DepthRangeArraydvNV_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArraydvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArraydvNV(first: UInt32; count: Int32; v: IntPtr) :=
    z_DepthRangeArraydvNV_ovr_2(first, count, v);
    
    private z_DepthRangeIndexeddNV_adr := GetProcAddress('glDepthRangeIndexeddNV');
    private z_DepthRangeIndexeddNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: real; f: real)>(z_DepthRangeIndexeddNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeIndexeddNV(index: UInt32; n: real; f: real) :=
    z_DepthRangeIndexeddNV_ovr_0(index, n, f);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glWindowPosARB = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_window_pos';
    
    private z_WindowPos2dARB_adr := GetProcAddress('glWindowPos2dARB');
    private z_WindowPos2dARB_ovr_0 := GetProcOrNil&<procedure(x: real; y: real)>(z_WindowPos2dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dARB(x: real; y: real) :=
    z_WindowPos2dARB_ovr_0(x, y);
    
    private z_WindowPos2dvARB_adr := GetProcAddress('glWindowPos2dvARB');
    private z_WindowPos2dvARB_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos2dvARB_adr);
    private z_WindowPos2dvARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvARB(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2dvARB_ovr_0(v[0]) else
      z_WindowPos2dvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvARB(var v: real) :=
    z_WindowPos2dvARB_ovr_0(v);
    private z_WindowPos2dvARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvARB(v: IntPtr) :=
    z_WindowPos2dvARB_ovr_2(v);
    
    private z_WindowPos2fARB_adr := GetProcAddress('glWindowPos2fARB');
    private z_WindowPos2fARB_ovr_0 := GetProcOrNil&<procedure(x: single; y: single)>(z_WindowPos2fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fARB(x: single; y: single) :=
    z_WindowPos2fARB_ovr_0(x, y);
    
    private z_WindowPos2fvARB_adr := GetProcAddress('glWindowPos2fvARB');
    private z_WindowPos2fvARB_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos2fvARB_adr);
    private z_WindowPos2fvARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvARB(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2fvARB_ovr_0(v[0]) else
      z_WindowPos2fvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvARB(var v: single) :=
    z_WindowPos2fvARB_ovr_0(v);
    private z_WindowPos2fvARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvARB(v: IntPtr) :=
    z_WindowPos2fvARB_ovr_2(v);
    
    private z_WindowPos2iARB_adr := GetProcAddress('glWindowPos2iARB');
    private z_WindowPos2iARB_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32)>(z_WindowPos2iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iARB(x: Int32; y: Int32) :=
    z_WindowPos2iARB_ovr_0(x, y);
    
    private z_WindowPos2ivARB_adr := GetProcAddress('glWindowPos2ivARB');
    private z_WindowPos2ivARB_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos2ivARB_adr);
    private z_WindowPos2ivARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivARB(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2ivARB_ovr_0(v[0]) else
      z_WindowPos2ivARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivARB(var v: Int32) :=
    z_WindowPos2ivARB_ovr_0(v);
    private z_WindowPos2ivARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivARB(v: IntPtr) :=
    z_WindowPos2ivARB_ovr_2(v);
    
    private z_WindowPos2sARB_adr := GetProcAddress('glWindowPos2sARB');
    private z_WindowPos2sARB_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16)>(z_WindowPos2sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sARB(x: Int16; y: Int16) :=
    z_WindowPos2sARB_ovr_0(x, y);
    
    private z_WindowPos2svARB_adr := GetProcAddress('glWindowPos2svARB');
    private z_WindowPos2svARB_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos2svARB_adr);
    private z_WindowPos2svARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svARB(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2svARB_ovr_0(v[0]) else
      z_WindowPos2svARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svARB(var v: Int16) :=
    z_WindowPos2svARB_ovr_0(v);
    private z_WindowPos2svARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svARB(v: IntPtr) :=
    z_WindowPos2svARB_ovr_2(v);
    
    private z_WindowPos3dARB_adr := GetProcAddress('glWindowPos3dARB');
    private z_WindowPos3dARB_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_WindowPos3dARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dARB(x: real; y: real; z: real) :=
    z_WindowPos3dARB_ovr_0(x, y, z);
    
    private z_WindowPos3dvARB_adr := GetProcAddress('glWindowPos3dvARB');
    private z_WindowPos3dvARB_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos3dvARB_adr);
    private z_WindowPos3dvARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvARB(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3dvARB_ovr_0(v[0]) else
      z_WindowPos3dvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvARB(var v: real) :=
    z_WindowPos3dvARB_ovr_0(v);
    private z_WindowPos3dvARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3dvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvARB(v: IntPtr) :=
    z_WindowPos3dvARB_ovr_2(v);
    
    private z_WindowPos3fARB_adr := GetProcAddress('glWindowPos3fARB');
    private z_WindowPos3fARB_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_WindowPos3fARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fARB(x: single; y: single; z: single) :=
    z_WindowPos3fARB_ovr_0(x, y, z);
    
    private z_WindowPos3fvARB_adr := GetProcAddress('glWindowPos3fvARB');
    private z_WindowPos3fvARB_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos3fvARB_adr);
    private z_WindowPos3fvARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvARB(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3fvARB_ovr_0(v[0]) else
      z_WindowPos3fvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvARB(var v: single) :=
    z_WindowPos3fvARB_ovr_0(v);
    private z_WindowPos3fvARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3fvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvARB(v: IntPtr) :=
    z_WindowPos3fvARB_ovr_2(v);
    
    private z_WindowPos3iARB_adr := GetProcAddress('glWindowPos3iARB');
    private z_WindowPos3iARB_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32)>(z_WindowPos3iARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iARB(x: Int32; y: Int32; z: Int32) :=
    z_WindowPos3iARB_ovr_0(x, y, z);
    
    private z_WindowPos3ivARB_adr := GetProcAddress('glWindowPos3ivARB');
    private z_WindowPos3ivARB_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos3ivARB_adr);
    private z_WindowPos3ivARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivARB(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3ivARB_ovr_0(v[0]) else
      z_WindowPos3ivARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivARB(var v: Int32) :=
    z_WindowPos3ivARB_ovr_0(v);
    private z_WindowPos3ivARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3ivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivARB(v: IntPtr) :=
    z_WindowPos3ivARB_ovr_2(v);
    
    private z_WindowPos3sARB_adr := GetProcAddress('glWindowPos3sARB');
    private z_WindowPos3sARB_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16)>(z_WindowPos3sARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sARB(x: Int16; y: Int16; z: Int16) :=
    z_WindowPos3sARB_ovr_0(x, y, z);
    
    private z_WindowPos3svARB_adr := GetProcAddress('glWindowPos3svARB');
    private z_WindowPos3svARB_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos3svARB_adr);
    private z_WindowPos3svARB_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svARB(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3svARB_ovr_0(v[0]) else
      z_WindowPos3svARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svARB(var v: Int16) :=
    z_WindowPos3svARB_ovr_0(v);
    private z_WindowPos3svARB_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3svARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svARB(v: IntPtr) :=
    z_WindowPos3svARB_ovr_2(v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawBuffersATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_draw_buffers';
    
    private z_DrawBuffersATI_adr := GetProcAddress('glDrawBuffersATI');
    private z_DrawBuffersATI_ovr_0 := GetProcOrNil&<procedure(n: Int32; var bufs: DrawBufferMode)>(z_DrawBuffersATI_adr);
    private z_DrawBuffersATI_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffersATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersATI(n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_DrawBuffersATI_ovr_0(n, bufs[0]) else
      z_DrawBuffersATI_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersATI(n: Int32; var bufs: DrawBufferMode) :=
    z_DrawBuffersATI_ovr_0(n, bufs);
    private z_DrawBuffersATI_ovr_2 := GetProcOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffersATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersATI(n: Int32; bufs: IntPtr) :=
    z_DrawBuffersATI_ovr_2(n, bufs);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glElementArrayATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_element_array';
    
    private z_ElementPointerATI_adr := GetProcAddress('glElementPointerATI');
    private z_ElementPointerATI_ovr_0 := GetProcOrNil&<procedure(&type: ElementPointerTypeATI; pointer: IntPtr)>(z_ElementPointerATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ElementPointerATI(&type: ElementPointerTypeATI; pointer: IntPtr) :=
    z_ElementPointerATI_ovr_0(&type, pointer);
    
    private z_DrawElementArrayATI_adr := GetProcAddress('glDrawElementArrayATI');
    private z_DrawElementArrayATI_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32)>(z_DrawElementArrayATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementArrayATI(mode: PrimitiveType; count: Int32) :=
    z_DrawElementArrayATI_ovr_0(mode, count);
    
    private z_DrawRangeElementArrayATI_adr := GetProcAddress('glDrawRangeElementArrayATI');
    private z_DrawRangeElementArrayATI_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32)>(z_DrawRangeElementArrayATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementArrayATI(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32) :=
    z_DrawRangeElementArrayATI_ovr_0(mode, start, &end, count);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glEnvmapBumpmapATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_envmap_bumpmap';
    
    private z_TexBumpParameterivATI_adr := GetProcAddress('glTexBumpParameterivATI');
    private z_TexBumpParameterivATI_ovr_0 := GetProcOrNil&<procedure(pname: TexBumpParameterATI; var param: Int32)>(z_TexBumpParameterivATI_adr);
    private z_TexBumpParameterivATI_ovr_0_anh001 := GetProcOrNil&<procedure(pname: TexBumpParameterATI; param: IntPtr)>(z_TexBumpParameterivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterivATI(pname: TexBumpParameterATI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_TexBumpParameterivATI_ovr_0(pname, param[0]) else
      z_TexBumpParameterivATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterivATI(pname: TexBumpParameterATI; var param: Int32) :=
    z_TexBumpParameterivATI_ovr_0(pname, param);
    private z_TexBumpParameterivATI_ovr_2 := GetProcOrNil&<procedure(pname: TexBumpParameterATI; param: IntPtr)>(z_TexBumpParameterivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterivATI(pname: TexBumpParameterATI; param: IntPtr) :=
    z_TexBumpParameterivATI_ovr_2(pname, param);
    
    private z_TexBumpParameterfvATI_adr := GetProcAddress('glTexBumpParameterfvATI');
    private z_TexBumpParameterfvATI_ovr_0 := GetProcOrNil&<procedure(pname: TexBumpParameterATI; var param: single)>(z_TexBumpParameterfvATI_adr);
    private z_TexBumpParameterfvATI_ovr_0_anh001 := GetProcOrNil&<procedure(pname: TexBumpParameterATI; param: IntPtr)>(z_TexBumpParameterfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterfvATI(pname: TexBumpParameterATI; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_TexBumpParameterfvATI_ovr_0(pname, param[0]) else
      z_TexBumpParameterfvATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterfvATI(pname: TexBumpParameterATI; var param: single) :=
    z_TexBumpParameterfvATI_ovr_0(pname, param);
    private z_TexBumpParameterfvATI_ovr_2 := GetProcOrNil&<procedure(pname: TexBumpParameterATI; param: IntPtr)>(z_TexBumpParameterfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterfvATI(pname: TexBumpParameterATI; param: IntPtr) :=
    z_TexBumpParameterfvATI_ovr_2(pname, param);
    
    private z_GetTexBumpParameterivATI_adr := GetProcAddress('glGetTexBumpParameterivATI');
    private z_GetTexBumpParameterivATI_ovr_0 := GetProcOrNil&<procedure(pname: GetTexBumpParameterATI; var param: Int32)>(z_GetTexBumpParameterivATI_adr);
    private z_GetTexBumpParameterivATI_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetTexBumpParameterATI; param: IntPtr)>(z_GetTexBumpParameterivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterivATI(pname: GetTexBumpParameterATI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTexBumpParameterivATI_ovr_0(pname, param[0]) else
      z_GetTexBumpParameterivATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterivATI(pname: GetTexBumpParameterATI; var param: Int32) :=
    z_GetTexBumpParameterivATI_ovr_0(pname, param);
    private z_GetTexBumpParameterivATI_ovr_2 := GetProcOrNil&<procedure(pname: GetTexBumpParameterATI; param: IntPtr)>(z_GetTexBumpParameterivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterivATI(pname: GetTexBumpParameterATI; param: IntPtr) :=
    z_GetTexBumpParameterivATI_ovr_2(pname, param);
    
    private z_GetTexBumpParameterfvATI_adr := GetProcAddress('glGetTexBumpParameterfvATI');
    private z_GetTexBumpParameterfvATI_ovr_0 := GetProcOrNil&<procedure(pname: GetTexBumpParameterATI; var param: single)>(z_GetTexBumpParameterfvATI_adr);
    private z_GetTexBumpParameterfvATI_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetTexBumpParameterATI; param: IntPtr)>(z_GetTexBumpParameterfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterfvATI(pname: GetTexBumpParameterATI; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTexBumpParameterfvATI_ovr_0(pname, param[0]) else
      z_GetTexBumpParameterfvATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterfvATI(pname: GetTexBumpParameterATI; var param: single) :=
    z_GetTexBumpParameterfvATI_ovr_0(pname, param);
    private z_GetTexBumpParameterfvATI_ovr_2 := GetProcOrNil&<procedure(pname: GetTexBumpParameterATI; param: IntPtr)>(z_GetTexBumpParameterfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterfvATI(pname: GetTexBumpParameterATI; param: IntPtr) :=
    z_GetTexBumpParameterfvATI_ovr_2(pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFragmentShaderATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_fragment_shader';
    
    private z_GenFragmentShadersATI_adr := GetProcAddress('glGenFragmentShadersATI');
    private z_GenFragmentShadersATI_ovr_0 := GetProcOrNil&<function(range: UInt32): UInt32>(z_GenFragmentShadersATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenFragmentShadersATI(range: UInt32): UInt32 :=
    z_GenFragmentShadersATI_ovr_0(range);
    
    private z_BindFragmentShaderATI_adr := GetProcAddress('glBindFragmentShaderATI');
    private z_BindFragmentShaderATI_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_BindFragmentShaderATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragmentShaderATI(id: UInt32) :=
    z_BindFragmentShaderATI_ovr_0(id);
    
    private z_DeleteFragmentShaderATI_adr := GetProcAddress('glDeleteFragmentShaderATI');
    private z_DeleteFragmentShaderATI_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_DeleteFragmentShaderATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFragmentShaderATI(id: UInt32) :=
    z_DeleteFragmentShaderATI_ovr_0(id);
    
    private z_BeginFragmentShaderATI_adr := GetProcAddress('glBeginFragmentShaderATI');
    private z_BeginFragmentShaderATI_ovr_0 := GetProcOrNil&<procedure>(z_BeginFragmentShaderATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginFragmentShaderATI :=
    z_BeginFragmentShaderATI_ovr_0;
    
    private z_EndFragmentShaderATI_adr := GetProcAddress('glEndFragmentShaderATI');
    private z_EndFragmentShaderATI_ovr_0 := GetProcOrNil&<procedure>(z_EndFragmentShaderATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndFragmentShaderATI :=
    z_EndFragmentShaderATI_ovr_0;
    
    private z_PassTexCoordATI_adr := GetProcAddress('glPassTexCoordATI');
    private z_PassTexCoordATI_ovr_0 := GetProcOrNil&<procedure(dst: UInt32; coord: UInt32; swizzle: SwizzleOpATI)>(z_PassTexCoordATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PassTexCoordATI(dst: UInt32; coord: UInt32; swizzle: SwizzleOpATI) :=
    z_PassTexCoordATI_ovr_0(dst, coord, swizzle);
    
    private z_SampleMapATI_adr := GetProcAddress('glSampleMapATI');
    private z_SampleMapATI_ovr_0 := GetProcOrNil&<procedure(dst: UInt32; interp: UInt32; swizzle: SwizzleOpATI)>(z_SampleMapATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMapATI(dst: UInt32; interp: UInt32; swizzle: SwizzleOpATI) :=
    z_SampleMapATI_ovr_0(dst, interp, swizzle);
    
    private z_ColorFragmentOp1ATI_adr := GetProcAddress('glColorFragmentOp1ATI');
    private z_ColorFragmentOp1ATI_ovr_0 := GetProcOrNil&<procedure(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32)>(z_ColorFragmentOp1ATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFragmentOp1ATI(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32) :=
    z_ColorFragmentOp1ATI_ovr_0(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod);
    
    private z_ColorFragmentOp2ATI_adr := GetProcAddress('glColorFragmentOp2ATI');
    private z_ColorFragmentOp2ATI_ovr_0 := GetProcOrNil&<procedure(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32)>(z_ColorFragmentOp2ATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFragmentOp2ATI(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32) :=
    z_ColorFragmentOp2ATI_ovr_0(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
    
    private z_ColorFragmentOp3ATI_adr := GetProcAddress('glColorFragmentOp3ATI');
    private z_ColorFragmentOp3ATI_ovr_0 := GetProcOrNil&<procedure(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32)>(z_ColorFragmentOp3ATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFragmentOp3ATI(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32) :=
    z_ColorFragmentOp3ATI_ovr_0(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
    
    private z_AlphaFragmentOp1ATI_adr := GetProcAddress('glAlphaFragmentOp1ATI');
    private z_AlphaFragmentOp1ATI_ovr_0 := GetProcOrNil&<procedure(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32)>(z_AlphaFragmentOp1ATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFragmentOp1ATI(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32) :=
    z_AlphaFragmentOp1ATI_ovr_0(op, dst, dstMod, arg1, arg1Rep, arg1Mod);
    
    private z_AlphaFragmentOp2ATI_adr := GetProcAddress('glAlphaFragmentOp2ATI');
    private z_AlphaFragmentOp2ATI_ovr_0 := GetProcOrNil&<procedure(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32)>(z_AlphaFragmentOp2ATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFragmentOp2ATI(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32) :=
    z_AlphaFragmentOp2ATI_ovr_0(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
    
    private z_AlphaFragmentOp3ATI_adr := GetProcAddress('glAlphaFragmentOp3ATI');
    private z_AlphaFragmentOp3ATI_ovr_0 := GetProcOrNil&<procedure(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32)>(z_AlphaFragmentOp3ATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFragmentOp3ATI(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32) :=
    z_AlphaFragmentOp3ATI_ovr_0(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
    
    private z_SetFragmentShaderConstantATI_adr := GetProcAddress('glSetFragmentShaderConstantATI');
    private z_SetFragmentShaderConstantATI_ovr_0 := GetProcOrNil&<procedure(dst: UInt32; var value: single)>(z_SetFragmentShaderConstantATI_adr);
    private z_SetFragmentShaderConstantATI_ovr_0_anh001 := GetProcOrNil&<procedure(dst: UInt32; value: IntPtr)>(z_SetFragmentShaderConstantATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFragmentShaderConstantATI(dst: UInt32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_SetFragmentShaderConstantATI_ovr_0(dst, value[0]) else
      z_SetFragmentShaderConstantATI_ovr_0_anh001(dst, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFragmentShaderConstantATI(dst: UInt32; var value: single) :=
    z_SetFragmentShaderConstantATI_ovr_0(dst, value);
    private z_SetFragmentShaderConstantATI_ovr_2 := GetProcOrNil&<procedure(dst: UInt32; value: IntPtr)>(z_SetFragmentShaderConstantATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFragmentShaderConstantATI(dst: UInt32; value: IntPtr) :=
    z_SetFragmentShaderConstantATI_ovr_2(dst, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMapObjectBufferATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_map_object_buffer';
    
    private z_MapObjectBufferATI_adr := GetProcAddress('glMapObjectBufferATI');
    private z_MapObjectBufferATI_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): IntPtr>(z_MapObjectBufferATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapObjectBufferATI(buffer: gl_buffer): IntPtr :=
    z_MapObjectBufferATI_ovr_0(buffer);
    
    private z_UnmapObjectBufferATI_adr := GetProcAddress('glUnmapObjectBufferATI');
    private z_UnmapObjectBufferATI_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer)>(z_UnmapObjectBufferATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UnmapObjectBufferATI(buffer: gl_buffer) :=
    z_UnmapObjectBufferATI_ovr_0(buffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPnTrianglesATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_pn_triangles';
    
    private z_PNTrianglesiATI_adr := GetProcAddress('glPNTrianglesiATI');
    private z_PNTrianglesiATI_ovr_0 := GetProcOrNil&<procedure(pname: PNTrianglesPNameATI; param: Int32)>(z_PNTrianglesiATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PNTrianglesiATI(pname: PNTrianglesPNameATI; param: Int32) :=
    z_PNTrianglesiATI_ovr_0(pname, param);
    
    private z_PNTrianglesfATI_adr := GetProcAddress('glPNTrianglesfATI');
    private z_PNTrianglesfATI_ovr_0 := GetProcOrNil&<procedure(pname: PNTrianglesPNameATI; param: single)>(z_PNTrianglesfATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PNTrianglesfATI(pname: PNTrianglesPNameATI; param: single) :=
    z_PNTrianglesfATI_ovr_0(pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSeparateStencilATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_separate_stencil';
    
    private z_StencilOpSeparateATI_adr := GetProcAddress('glStencilOpSeparateATI');
    private z_StencilOpSeparateATI_ovr_0 := GetProcOrNil&<procedure(face: StencilFaceDirection; sfail: StencilOp; dpfail: StencilOp; dppass: StencilOp)>(z_StencilOpSeparateATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOpSeparateATI(face: StencilFaceDirection; sfail: StencilOp; dpfail: StencilOp; dppass: StencilOp) :=
    z_StencilOpSeparateATI_ovr_0(face, sfail, dpfail, dppass);
    
    private z_StencilFuncSeparateATI_adr := GetProcAddress('glStencilFuncSeparateATI');
    private z_StencilFuncSeparateATI_ovr_0 := GetProcOrNil&<procedure(frontfunc: StencilFunction; backfunc: StencilFunction; ref: Int32; mask: UInt32)>(z_StencilFuncSeparateATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFuncSeparateATI(frontfunc: StencilFunction; backfunc: StencilFunction; ref: Int32; mask: UInt32) :=
    z_StencilFuncSeparateATI_ovr_0(frontfunc, backfunc, ref, mask);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayObjectATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_vertex_array_object';
    
    private z_NewObjectBufferATI_adr := GetProcAddress('glNewObjectBufferATI');
    private z_NewObjectBufferATI_ovr_0 := GetProcOrNil&<function(size: Int32; pointer: IntPtr; usage: ArrayObjectUsageATI): UInt32>(z_NewObjectBufferATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function NewObjectBufferATI(size: Int32; pointer: IntPtr; usage: ArrayObjectUsageATI): UInt32 :=
    z_NewObjectBufferATI_ovr_0(size, pointer, usage);
    
    private z_IsObjectBufferATI_adr := GetProcAddress('glIsObjectBufferATI');
    private z_IsObjectBufferATI_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_IsObjectBufferATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsObjectBufferATI(buffer: gl_buffer): boolean :=
    z_IsObjectBufferATI_ovr_0(buffer);
    
    private z_UpdateObjectBufferATI_adr := GetProcAddress('glUpdateObjectBufferATI');
    private z_UpdateObjectBufferATI_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: UInt32; size: Int32; pointer: IntPtr; preserve: PreserveModeATI)>(z_UpdateObjectBufferATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UpdateObjectBufferATI(buffer: gl_buffer; offset: UInt32; size: Int32; pointer: IntPtr; preserve: PreserveModeATI) :=
    z_UpdateObjectBufferATI_ovr_0(buffer, offset, size, pointer, preserve);
    
    private z_GetObjectBufferfvATI_adr := GetProcAddress('glGetObjectBufferfvATI');
    private z_GetObjectBufferfvATI_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: ArrayObjectPNameATI; var &params: single)>(z_GetObjectBufferfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferfvATI(buffer: gl_buffer; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetObjectBufferfvATI_ovr_0(buffer, pname, &params);
    private z_GetObjectBufferfvATI_ovr_1 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetObjectBufferfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferfvATI(buffer: gl_buffer; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetObjectBufferfvATI_ovr_1(buffer, pname, &params);
    
    private z_GetObjectBufferivATI_adr := GetProcAddress('glGetObjectBufferivATI');
    private z_GetObjectBufferivATI_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: ArrayObjectPNameATI; var &params: Int32)>(z_GetObjectBufferivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferivATI(buffer: gl_buffer; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetObjectBufferivATI_ovr_0(buffer, pname, &params);
    private z_GetObjectBufferivATI_ovr_1 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetObjectBufferivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferivATI(buffer: gl_buffer; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetObjectBufferivATI_ovr_1(buffer, pname, &params);
    
    private z_FreeObjectBufferATI_adr := GetProcAddress('glFreeObjectBufferATI');
    private z_FreeObjectBufferATI_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer)>(z_FreeObjectBufferATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FreeObjectBufferATI(buffer: gl_buffer) :=
    z_FreeObjectBufferATI_ovr_0(buffer);
    
    private z_ArrayObjectATI_adr := GetProcAddress('glArrayObjectATI');
    private z_ArrayObjectATI_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; size: Int32; &type: ScalarType; stride: Int32; buffer: gl_buffer; offset: UInt32)>(z_ArrayObjectATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ArrayObjectATI(&array: EnableCap; size: Int32; &type: ScalarType; stride: Int32; buffer: gl_buffer; offset: UInt32) :=
    z_ArrayObjectATI_ovr_0(&array, size, &type, stride, buffer, offset);
    
    private z_GetArrayObjectfvATI_adr := GetProcAddress('glGetArrayObjectfvATI');
    private z_GetArrayObjectfvATI_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: single)>(z_GetArrayObjectfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectfvATI(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetArrayObjectfvATI_ovr_0(&array, pname, &params);
    private z_GetArrayObjectfvATI_ovr_1 := GetProcOrNil&<procedure(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetArrayObjectfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectfvATI(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetArrayObjectfvATI_ovr_1(&array, pname, &params);
    
    private z_GetArrayObjectivATI_adr := GetProcAddress('glGetArrayObjectivATI');
    private z_GetArrayObjectivATI_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: Int32)>(z_GetArrayObjectivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectivATI(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetArrayObjectivATI_ovr_0(&array, pname, &params);
    private z_GetArrayObjectivATI_ovr_1 := GetProcOrNil&<procedure(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetArrayObjectivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectivATI(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetArrayObjectivATI_ovr_1(&array, pname, &params);
    
    private z_VariantArrayObjectATI_adr := GetProcAddress('glVariantArrayObjectATI');
    private z_VariantArrayObjectATI_ovr_0 := GetProcOrNil&<procedure(id: UInt32; &type: ScalarType; stride: Int32; buffer: gl_buffer; offset: UInt32)>(z_VariantArrayObjectATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantArrayObjectATI(id: UInt32; &type: ScalarType; stride: Int32; buffer: gl_buffer; offset: UInt32) :=
    z_VariantArrayObjectATI_ovr_0(id, &type, stride, buffer, offset);
    
    private z_GetVariantArrayObjectfvATI_adr := GetProcAddress('glGetVariantArrayObjectfvATI');
    private z_GetVariantArrayObjectfvATI_ovr_0 := GetProcOrNil&<procedure(id: UInt32; pname: ArrayObjectPNameATI; var &params: single)>(z_GetVariantArrayObjectfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectfvATI(id: UInt32; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetVariantArrayObjectfvATI_ovr_0(id, pname, &params);
    private z_GetVariantArrayObjectfvATI_ovr_1 := GetProcOrNil&<procedure(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetVariantArrayObjectfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectfvATI(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVariantArrayObjectfvATI_ovr_1(id, pname, &params);
    
    private z_GetVariantArrayObjectivATI_adr := GetProcAddress('glGetVariantArrayObjectivATI');
    private z_GetVariantArrayObjectivATI_ovr_0 := GetProcOrNil&<procedure(id: UInt32; pname: ArrayObjectPNameATI; var &params: Int32)>(z_GetVariantArrayObjectivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectivATI(id: UInt32; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetVariantArrayObjectivATI_ovr_0(id, pname, &params);
    private z_GetVariantArrayObjectivATI_ovr_1 := GetProcOrNil&<procedure(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetVariantArrayObjectivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectivATI(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVariantArrayObjectivATI_ovr_1(id, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexAttribArrayObjectATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_vertex_attrib_array_object';
    
    private z_VertexAttribArrayObjectATI_adr := GetProcAddress('glVertexAttribArrayObjectATI');
    private z_VertexAttribArrayObjectATI_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; buffer: gl_buffer; offset: UInt32)>(z_VertexAttribArrayObjectATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribArrayObjectATI(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; buffer: gl_buffer; offset: UInt32) :=
    z_VertexAttribArrayObjectATI_ovr_0(index, size, &type, normalized, stride, buffer, offset);
    
    private z_GetVertexAttribArrayObjectfvATI_adr := GetProcAddress('glGetVertexAttribArrayObjectfvATI');
    private z_GetVertexAttribArrayObjectfvATI_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: ArrayObjectPNameATI; var &params: single)>(z_GetVertexAttribArrayObjectfvATI_adr);
    private z_GetVertexAttribArrayObjectfvATI_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetVertexAttribArrayObjectfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectfvATI(index: UInt32; pname: ArrayObjectPNameATI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribArrayObjectfvATI_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribArrayObjectfvATI_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectfvATI(index: UInt32; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetVertexAttribArrayObjectfvATI_ovr_0(index, pname, &params);
    private z_GetVertexAttribArrayObjectfvATI_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetVertexAttribArrayObjectfvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectfvATI(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVertexAttribArrayObjectfvATI_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribArrayObjectivATI_adr := GetProcAddress('glGetVertexAttribArrayObjectivATI');
    private z_GetVertexAttribArrayObjectivATI_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: ArrayObjectPNameATI; var &params: Int32)>(z_GetVertexAttribArrayObjectivATI_adr);
    private z_GetVertexAttribArrayObjectivATI_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetVertexAttribArrayObjectivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectivATI(index: UInt32; pname: ArrayObjectPNameATI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribArrayObjectivATI_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribArrayObjectivATI_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectivATI(index: UInt32; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetVertexAttribArrayObjectivATI_ovr_0(index, pname, &params);
    private z_GetVertexAttribArrayObjectivATI_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr)>(z_GetVertexAttribArrayObjectivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectivATI(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVertexAttribArrayObjectivATI_ovr_2(index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexStreamsATI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ATI_vertex_streams';
    
    private z_VertexStream1sATI_adr := GetProcAddress('glVertexStream1sATI');
    private z_VertexStream1sATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int16)>(z_VertexStream1sATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1sATI(stream: VertexStreamATI; x: Int16) :=
    z_VertexStream1sATI_ovr_0(stream, x);
    
    private z_VertexStream1svATI_adr := GetProcAddress('glVertexStream1svATI');
    private z_VertexStream1svATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int16)>(z_VertexStream1svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream1svATI_ovr_0(stream, coords);
    private z_VertexStream1svATI_ovr_1 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream1svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1svATI_ovr_1(stream, coords);
    
    private z_VertexStream1iATI_adr := GetProcAddress('glVertexStream1iATI');
    private z_VertexStream1iATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int32)>(z_VertexStream1iATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1iATI(stream: VertexStreamATI; x: Int32) :=
    z_VertexStream1iATI_ovr_0(stream, x);
    
    private z_VertexStream1ivATI_adr := GetProcAddress('glVertexStream1ivATI');
    private z_VertexStream1ivATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int32)>(z_VertexStream1ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream1ivATI_ovr_0(stream, coords);
    private z_VertexStream1ivATI_ovr_1 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream1ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1ivATI_ovr_1(stream, coords);
    
    private z_VertexStream1fATI_adr := GetProcAddress('glVertexStream1fATI');
    private z_VertexStream1fATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: single)>(z_VertexStream1fATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fATI(stream: VertexStreamATI; x: single) :=
    z_VertexStream1fATI_ovr_0(stream, x);
    
    private z_VertexStream1fvATI_adr := GetProcAddress('glVertexStream1fvATI');
    private z_VertexStream1fvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: single)>(z_VertexStream1fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream1fvATI_ovr_0(stream, coords);
    private z_VertexStream1fvATI_ovr_1 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream1fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1fvATI_ovr_1(stream, coords);
    
    private z_VertexStream1dATI_adr := GetProcAddress('glVertexStream1dATI');
    private z_VertexStream1dATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: real)>(z_VertexStream1dATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dATI(stream: VertexStreamATI; x: real) :=
    z_VertexStream1dATI_ovr_0(stream, x);
    
    private z_VertexStream1dvATI_adr := GetProcAddress('glVertexStream1dvATI');
    private z_VertexStream1dvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: real)>(z_VertexStream1dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream1dvATI_ovr_0(stream, coords);
    private z_VertexStream1dvATI_ovr_1 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream1dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1dvATI_ovr_1(stream, coords);
    
    private z_VertexStream2sATI_adr := GetProcAddress('glVertexStream2sATI');
    private z_VertexStream2sATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int16; y: Int16)>(z_VertexStream2sATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2sATI(stream: VertexStreamATI; x: Int16; y: Int16) :=
    z_VertexStream2sATI_ovr_0(stream, x, y);
    
    private z_VertexStream2svATI_adr := GetProcAddress('glVertexStream2svATI');
    private z_VertexStream2svATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int16)>(z_VertexStream2svATI_adr);
    private z_VertexStream2svATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2svATI_ovr_0(stream, coords[0]) else
      z_VertexStream2svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream2svATI_ovr_0(stream, coords);
    private z_VertexStream2svATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2svATI_ovr_2(stream, coords);
    
    private z_VertexStream2iATI_adr := GetProcAddress('glVertexStream2iATI');
    private z_VertexStream2iATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int32; y: Int32)>(z_VertexStream2iATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2iATI(stream: VertexStreamATI; x: Int32; y: Int32) :=
    z_VertexStream2iATI_ovr_0(stream, x, y);
    
    private z_VertexStream2ivATI_adr := GetProcAddress('glVertexStream2ivATI');
    private z_VertexStream2ivATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int32)>(z_VertexStream2ivATI_adr);
    private z_VertexStream2ivATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream2ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream2ivATI_ovr_0(stream, coords);
    private z_VertexStream2ivATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2ivATI_ovr_2(stream, coords);
    
    private z_VertexStream2fATI_adr := GetProcAddress('glVertexStream2fATI');
    private z_VertexStream2fATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: single; y: single)>(z_VertexStream2fATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fATI(stream: VertexStreamATI; x: single; y: single) :=
    z_VertexStream2fATI_ovr_0(stream, x, y);
    
    private z_VertexStream2fvATI_adr := GetProcAddress('glVertexStream2fvATI');
    private z_VertexStream2fvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: single)>(z_VertexStream2fvATI_adr);
    private z_VertexStream2fvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream2fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream2fvATI_ovr_0(stream, coords);
    private z_VertexStream2fvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2fvATI_ovr_2(stream, coords);
    
    private z_VertexStream2dATI_adr := GetProcAddress('glVertexStream2dATI');
    private z_VertexStream2dATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: real; y: real)>(z_VertexStream2dATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dATI(stream: VertexStreamATI; x: real; y: real) :=
    z_VertexStream2dATI_ovr_0(stream, x, y);
    
    private z_VertexStream2dvATI_adr := GetProcAddress('glVertexStream2dvATI');
    private z_VertexStream2dvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: real)>(z_VertexStream2dvATI_adr);
    private z_VertexStream2dvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream2dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream2dvATI_ovr_0(stream, coords);
    private z_VertexStream2dvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream2dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2dvATI_ovr_2(stream, coords);
    
    private z_VertexStream3sATI_adr := GetProcAddress('glVertexStream3sATI');
    private z_VertexStream3sATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16)>(z_VertexStream3sATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3sATI(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16) :=
    z_VertexStream3sATI_ovr_0(stream, x, y, z);
    
    private z_VertexStream3svATI_adr := GetProcAddress('glVertexStream3svATI');
    private z_VertexStream3svATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int16)>(z_VertexStream3svATI_adr);
    private z_VertexStream3svATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3svATI_ovr_0(stream, coords[0]) else
      z_VertexStream3svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream3svATI_ovr_0(stream, coords);
    private z_VertexStream3svATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3svATI_ovr_2(stream, coords);
    
    private z_VertexStream3iATI_adr := GetProcAddress('glVertexStream3iATI');
    private z_VertexStream3iATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32)>(z_VertexStream3iATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3iATI(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32) :=
    z_VertexStream3iATI_ovr_0(stream, x, y, z);
    
    private z_VertexStream3ivATI_adr := GetProcAddress('glVertexStream3ivATI');
    private z_VertexStream3ivATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int32)>(z_VertexStream3ivATI_adr);
    private z_VertexStream3ivATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream3ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream3ivATI_ovr_0(stream, coords);
    private z_VertexStream3ivATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3ivATI_ovr_2(stream, coords);
    
    private z_VertexStream3fATI_adr := GetProcAddress('glVertexStream3fATI');
    private z_VertexStream3fATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: single; y: single; z: single)>(z_VertexStream3fATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fATI(stream: VertexStreamATI; x: single; y: single; z: single) :=
    z_VertexStream3fATI_ovr_0(stream, x, y, z);
    
    private z_VertexStream3fvATI_adr := GetProcAddress('glVertexStream3fvATI');
    private z_VertexStream3fvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: single)>(z_VertexStream3fvATI_adr);
    private z_VertexStream3fvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream3fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream3fvATI_ovr_0(stream, coords);
    private z_VertexStream3fvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3fvATI_ovr_2(stream, coords);
    
    private z_VertexStream3dATI_adr := GetProcAddress('glVertexStream3dATI');
    private z_VertexStream3dATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: real; y: real; z: real)>(z_VertexStream3dATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dATI(stream: VertexStreamATI; x: real; y: real; z: real) :=
    z_VertexStream3dATI_ovr_0(stream, x, y, z);
    
    private z_VertexStream3dvATI_adr := GetProcAddress('glVertexStream3dvATI');
    private z_VertexStream3dvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: real)>(z_VertexStream3dvATI_adr);
    private z_VertexStream3dvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream3dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream3dvATI_ovr_0(stream, coords);
    private z_VertexStream3dvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream3dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3dvATI_ovr_2(stream, coords);
    
    private z_VertexStream4sATI_adr := GetProcAddress('glVertexStream4sATI');
    private z_VertexStream4sATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16; w: Int16)>(z_VertexStream4sATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4sATI(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexStream4sATI_ovr_0(stream, x, y, z, w);
    
    private z_VertexStream4svATI_adr := GetProcAddress('glVertexStream4svATI');
    private z_VertexStream4svATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int16)>(z_VertexStream4svATI_adr);
    private z_VertexStream4svATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4svATI_ovr_0(stream, coords[0]) else
      z_VertexStream4svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream4svATI_ovr_0(stream, coords);
    private z_VertexStream4svATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4svATI_ovr_2(stream, coords);
    
    private z_VertexStream4iATI_adr := GetProcAddress('glVertexStream4iATI');
    private z_VertexStream4iATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32; w: Int32)>(z_VertexStream4iATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4iATI(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexStream4iATI_ovr_0(stream, x, y, z, w);
    
    private z_VertexStream4ivATI_adr := GetProcAddress('glVertexStream4ivATI');
    private z_VertexStream4ivATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int32)>(z_VertexStream4ivATI_adr);
    private z_VertexStream4ivATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream4ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream4ivATI_ovr_0(stream, coords);
    private z_VertexStream4ivATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4ivATI_ovr_2(stream, coords);
    
    private z_VertexStream4fATI_adr := GetProcAddress('glVertexStream4fATI');
    private z_VertexStream4fATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: single; y: single; z: single; w: single)>(z_VertexStream4fATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fATI(stream: VertexStreamATI; x: single; y: single; z: single; w: single) :=
    z_VertexStream4fATI_ovr_0(stream, x, y, z, w);
    
    private z_VertexStream4fvATI_adr := GetProcAddress('glVertexStream4fvATI');
    private z_VertexStream4fvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: single)>(z_VertexStream4fvATI_adr);
    private z_VertexStream4fvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream4fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream4fvATI_ovr_0(stream, coords);
    private z_VertexStream4fvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4fvATI_ovr_2(stream, coords);
    
    private z_VertexStream4dATI_adr := GetProcAddress('glVertexStream4dATI');
    private z_VertexStream4dATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; x: real; y: real; z: real; w: real)>(z_VertexStream4dATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dATI(stream: VertexStreamATI; x: real; y: real; z: real; w: real) :=
    z_VertexStream4dATI_ovr_0(stream, x, y, z, w);
    
    private z_VertexStream4dvATI_adr := GetProcAddress('glVertexStream4dvATI');
    private z_VertexStream4dvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: real)>(z_VertexStream4dvATI_adr);
    private z_VertexStream4dvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream4dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream4dvATI_ovr_0(stream, coords);
    private z_VertexStream4dvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_VertexStream4dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4dvATI_ovr_2(stream, coords);
    
    private z_NormalStream3bATI_adr := GetProcAddress('glNormalStream3bATI');
    private z_NormalStream3bATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; nx: SByte; ny: SByte; nz: SByte)>(z_NormalStream3bATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bATI(stream: VertexStreamATI; nx: SByte; ny: SByte; nz: SByte) :=
    z_NormalStream3bATI_ovr_0(stream, nx, ny, nz);
    
    private z_NormalStream3bvATI_adr := GetProcAddress('glNormalStream3bvATI');
    private z_NormalStream3bvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: SByte)>(z_NormalStream3bvATI_adr);
    private z_NormalStream3bvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3bvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bvATI(stream: VertexStreamATI; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3bvATI_ovr_0(stream, coords[0]) else
      z_NormalStream3bvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bvATI(stream: VertexStreamATI; var coords: SByte) :=
    z_NormalStream3bvATI_ovr_0(stream, coords);
    private z_NormalStream3bvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3bvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3bvATI_ovr_2(stream, coords);
    
    private z_NormalStream3sATI_adr := GetProcAddress('glNormalStream3sATI');
    private z_NormalStream3sATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; nx: Int16; ny: Int16; nz: Int16)>(z_NormalStream3sATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3sATI(stream: VertexStreamATI; nx: Int16; ny: Int16; nz: Int16) :=
    z_NormalStream3sATI_ovr_0(stream, nx, ny, nz);
    
    private z_NormalStream3svATI_adr := GetProcAddress('glNormalStream3svATI');
    private z_NormalStream3svATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int16)>(z_NormalStream3svATI_adr);
    private z_NormalStream3svATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3svATI_ovr_0(stream, coords[0]) else
      z_NormalStream3svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_NormalStream3svATI_ovr_0(stream, coords);
    private z_NormalStream3svATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3svATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3svATI_ovr_2(stream, coords);
    
    private z_NormalStream3iATI_adr := GetProcAddress('glNormalStream3iATI');
    private z_NormalStream3iATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; nx: Int32; ny: Int32; nz: Int32)>(z_NormalStream3iATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3iATI(stream: VertexStreamATI; nx: Int32; ny: Int32; nz: Int32) :=
    z_NormalStream3iATI_ovr_0(stream, nx, ny, nz);
    
    private z_NormalStream3ivATI_adr := GetProcAddress('glNormalStream3ivATI');
    private z_NormalStream3ivATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: Int32)>(z_NormalStream3ivATI_adr);
    private z_NormalStream3ivATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3ivATI_ovr_0(stream, coords[0]) else
      z_NormalStream3ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_NormalStream3ivATI_ovr_0(stream, coords);
    private z_NormalStream3ivATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3ivATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3ivATI_ovr_2(stream, coords);
    
    private z_NormalStream3fATI_adr := GetProcAddress('glNormalStream3fATI');
    private z_NormalStream3fATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; nx: single; ny: single; nz: single)>(z_NormalStream3fATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fATI(stream: VertexStreamATI; nx: single; ny: single; nz: single) :=
    z_NormalStream3fATI_ovr_0(stream, nx, ny, nz);
    
    private z_NormalStream3fvATI_adr := GetProcAddress('glNormalStream3fvATI');
    private z_NormalStream3fvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: single)>(z_NormalStream3fvATI_adr);
    private z_NormalStream3fvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3fvATI_ovr_0(stream, coords[0]) else
      z_NormalStream3fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fvATI(stream: VertexStreamATI; var coords: single) :=
    z_NormalStream3fvATI_ovr_0(stream, coords);
    private z_NormalStream3fvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3fvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3fvATI_ovr_2(stream, coords);
    
    private z_NormalStream3dATI_adr := GetProcAddress('glNormalStream3dATI');
    private z_NormalStream3dATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; nx: real; ny: real; nz: real)>(z_NormalStream3dATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dATI(stream: VertexStreamATI; nx: real; ny: real; nz: real) :=
    z_NormalStream3dATI_ovr_0(stream, nx, ny, nz);
    
    private z_NormalStream3dvATI_adr := GetProcAddress('glNormalStream3dvATI');
    private z_NormalStream3dvATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI; var coords: real)>(z_NormalStream3dvATI_adr);
    private z_NormalStream3dvATI_ovr_0_anh001 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3dvATI_ovr_0(stream, coords[0]) else
      z_NormalStream3dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dvATI(stream: VertexStreamATI; var coords: real) :=
    z_NormalStream3dvATI_ovr_0(stream, coords);
    private z_NormalStream3dvATI_ovr_2 := GetProcOrNil&<procedure(stream: VertexStreamATI; coords: IntPtr)>(z_NormalStream3dvATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3dvATI_ovr_2(stream, coords);
    
    private z_ClientActiveVertexStreamATI_adr := GetProcAddress('glClientActiveVertexStreamATI');
    private z_ClientActiveVertexStreamATI_ovr_0 := GetProcOrNil&<procedure(stream: VertexStreamATI)>(z_ClientActiveVertexStreamATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientActiveVertexStreamATI(stream: VertexStreamATI) :=
    z_ClientActiveVertexStreamATI_ovr_0(stream);
    
    private z_VertexBlendEnviATI_adr := GetProcAddress('glVertexBlendEnviATI');
    private z_VertexBlendEnviATI_ovr_0 := GetProcOrNil&<procedure(pname: VertexStreamATI; param: Int32)>(z_VertexBlendEnviATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBlendEnviATI(pname: VertexStreamATI; param: Int32) :=
    z_VertexBlendEnviATI_ovr_0(pname, param);
    
    private z_VertexBlendEnvfATI_adr := GetProcAddress('glVertexBlendEnvfATI');
    private z_VertexBlendEnvfATI_ovr_0 := GetProcOrNil&<procedure(pname: VertexStreamATI; param: single)>(z_VertexBlendEnvfATI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBlendEnvfATI(pname: VertexStreamATI; param: single) :=
    z_VertexBlendEnvfATI_ovr_0(pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glEGLImageStorageEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_EGL_image_storage';
    
    private z_EGLImageTargetTexStorageEXT_adr := GetProcAddress('glEGLImageTargetTexStorageEXT');
    private z_EGLImageTargetTexStorageEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; image: egl_image_OES; var attrib_list: Int32)>(z_EGLImageTargetTexStorageEXT_adr);
    private z_EGLImageTargetTexStorageEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; image: egl_image_OES; attrib_list: IntPtr)>(z_EGLImageTargetTexStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTexStorageEXT(target: DummyEnum; image: egl_image_OES; attrib_list: array of Int32) :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_EGLImageTargetTexStorageEXT_ovr_0(target, image, attrib_list[0]) else
      z_EGLImageTargetTexStorageEXT_ovr_0_anh0001(target, image, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTexStorageEXT(target: DummyEnum; image: egl_image_OES; var attrib_list: Int32) :=
    z_EGLImageTargetTexStorageEXT_ovr_0(target, image, attrib_list);
    private z_EGLImageTargetTexStorageEXT_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; image: egl_image_OES; attrib_list: IntPtr)>(z_EGLImageTargetTexStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTexStorageEXT(target: DummyEnum; image: egl_image_OES; attrib_list: IntPtr) :=
    z_EGLImageTargetTexStorageEXT_ovr_2(target, image, attrib_list);
    
    private z_EGLImageTargetTextureStorageEXT_adr := GetProcAddress('glEGLImageTargetTextureStorageEXT');
    private z_EGLImageTargetTextureStorageEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; image: egl_image_OES; var attrib_list: Int32)>(z_EGLImageTargetTextureStorageEXT_adr);
    private z_EGLImageTargetTextureStorageEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(texture: gl_texture; image: egl_image_OES; attrib_list: IntPtr)>(z_EGLImageTargetTextureStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTextureStorageEXT(texture: gl_texture; image: egl_image_OES; attrib_list: array of Int32) :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_EGLImageTargetTextureStorageEXT_ovr_0(texture, image, attrib_list[0]) else
      z_EGLImageTargetTextureStorageEXT_ovr_0_anh0001(texture, image, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTextureStorageEXT(texture: gl_texture; image: egl_image_OES; var attrib_list: Int32) :=
    z_EGLImageTargetTextureStorageEXT_ovr_0(texture, image, attrib_list);
    private z_EGLImageTargetTextureStorageEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; image: egl_image_OES; attrib_list: IntPtr)>(z_EGLImageTargetTextureStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTextureStorageEXT(texture: gl_texture; image: egl_image_OES; attrib_list: IntPtr) :=
    z_EGLImageTargetTextureStorageEXT_ovr_2(texture, image, attrib_list);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBindableUniformEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_bindable_uniform';
    
    private z_UniformBufferEXT_adr := GetProcAddress('glUniformBufferEXT');
    private z_UniformBufferEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; buffer: gl_buffer)>(z_UniformBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformBufferEXT(&program: gl_program; location: Int32; buffer: gl_buffer) :=
    z_UniformBufferEXT_ovr_0(&program, location, buffer);
    
    private z_GetUniformBufferSizeEXT_adr := GetProcAddress('glGetUniformBufferSizeEXT');
    private z_GetUniformBufferSizeEXT_ovr_0 := GetProcOrNil&<function(&program: gl_program; location: Int32): Int32>(z_GetUniformBufferSizeEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBufferSizeEXT(&program: gl_program; location: Int32): Int32 :=
    z_GetUniformBufferSizeEXT_ovr_0(&program, location);
    
    private z_GetUniformOffsetEXT_adr := GetProcAddress('glGetUniformOffsetEXT');
    private z_GetUniformOffsetEXT_ovr_0 := GetProcOrNil&<function(&program: gl_program; location: Int32): IntPtr>(z_GetUniformOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformOffsetEXT(&program: gl_program; location: Int32): IntPtr :=
    z_GetUniformOffsetEXT_ovr_0(&program, location);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendColorEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_blend_color';
    
    private z_BlendColorEXT_adr := GetProcAddress('glBlendColorEXT');
    private z_BlendColorEXT_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_BlendColorEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColorEXT(red: single; green: single; blue: single; alpha: single) :=
    z_BlendColorEXT_ovr_0(red, green, blue, alpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendEquationSeparateEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_blend_equation_separate';
    
    private z_BlendEquationSeparateEXT_adr := GetProcAddress('glBlendEquationSeparateEXT');
    private z_BlendEquationSeparateEXT_ovr_0 := GetProcOrNil&<procedure(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparateEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparateEXT(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparateEXT_ovr_0(modeRGB, modeAlpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendFuncSeparateEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_blend_func_separate';
    
    private z_BlendFuncSeparateEXT_adr := GetProcAddress('glBlendFuncSeparateEXT');
    private z_BlendFuncSeparateEXT_ovr_0 := GetProcOrNil&<procedure(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor)>(z_BlendFuncSeparateEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateEXT(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor) :=
    z_BlendFuncSeparateEXT_ovr_0(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendMinmaxEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_blend_minmax';
    
    private z_BlendEquationEXT_adr := GetProcAddress('glBlendEquationEXT');
    private z_BlendEquationEXT_ovr_0 := GetProcOrNil&<procedure(mode: BlendEquationModeEXT)>(z_BlendEquationEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationEXT(mode: BlendEquationModeEXT) :=
    z_BlendEquationEXT_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glColorSubtableEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_color_subtable';
    
    private z_ColorSubTableEXT_adr := GetProcAddress('glColorSubTableEXT');
    private z_ColorSubTableEXT_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ColorSubTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorSubTableEXT(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ColorSubTableEXT_ovr_0(target, start, count, format, &type, data);
    
    private z_CopyColorSubTableEXT_adr := GetProcAddress('glCopyColorSubTableEXT');
    private z_CopyColorSubTableEXT_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyColorSubTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorSubTableEXT(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorSubTableEXT_ovr_0(target, start, x, y, width);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCompiledVertexArrayEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_compiled_vertex_array';
    
    private z_LockArraysEXT_adr := GetProcAddress('glLockArraysEXT');
    private z_LockArraysEXT_ovr_0 := GetProcOrNil&<procedure(first: Int32; count: Int32)>(z_LockArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LockArraysEXT(first: Int32; count: Int32) :=
    z_LockArraysEXT_ovr_0(first, count);
    
    private z_UnlockArraysEXT_adr := GetProcAddress('glUnlockArraysEXT');
    private z_UnlockArraysEXT_ovr_0 := GetProcOrNil&<procedure>(z_UnlockArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UnlockArraysEXT :=
    z_UnlockArraysEXT_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConvolutionEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_convolution';
    
    private z_ConvolutionFilter1DEXT_adr := GetProcAddress('glConvolutionFilter1DEXT');
    private z_ConvolutionFilter1DEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr)>(z_ConvolutionFilter1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter1DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter1DEXT_ovr_0(target, _internalformat, width, format, &type, image);
    
    private z_ConvolutionFilter2DEXT_adr := GetProcAddress('glConvolutionFilter2DEXT');
    private z_ConvolutionFilter2DEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr)>(z_ConvolutionFilter2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter2DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter2DEXT_ovr_0(target, _internalformat, width, height, format, &type, image);
    
    private z_ConvolutionParameterfEXT_adr := GetProcAddress('glConvolutionParameterfEXT');
    private z_ConvolutionParameterfEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: single)>(z_ConvolutionParameterfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: single) :=
    z_ConvolutionParameterfEXT_ovr_0(target, pname, &params);
    
    private z_ConvolutionParameterfvEXT_adr := GetProcAddress('glConvolutionParameterfvEXT');
    private z_ConvolutionParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single)>(z_ConvolutionParameterfvEXT_adr);
    private z_ConvolutionParameterfvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single) :=
    z_ConvolutionParameterfvEXT_ovr_0(target, pname, &params);
    private z_ConvolutionParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterfvEXT_ovr_2(target, pname, &params);
    
    private z_ConvolutionParameteriEXT_adr := GetProcAddress('glConvolutionParameteriEXT');
    private z_ConvolutionParameteriEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: Int32)>(z_ConvolutionParameteriEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: Int32) :=
    z_ConvolutionParameteriEXT_ovr_0(target, pname, &params);
    
    private z_ConvolutionParameterivEXT_adr := GetProcAddress('glConvolutionParameterivEXT');
    private z_ConvolutionParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32)>(z_ConvolutionParameterivEXT_adr);
    private z_ConvolutionParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_ConvolutionParameterivEXT_ovr_0(target, pname, &params);
    private z_ConvolutionParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterivEXT_ovr_2(target, pname, &params);
    
    private z_CopyConvolutionFilter1DEXT_adr := GetProcAddress('glCopyConvolutionFilter1DEXT');
    private z_CopyConvolutionFilter1DEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32)>(z_CopyConvolutionFilter1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter1DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyConvolutionFilter1DEXT_ovr_0(target, _internalformat, x, y, width);
    
    private z_CopyConvolutionFilter2DEXT_adr := GetProcAddress('glCopyConvolutionFilter2DEXT');
    private z_CopyConvolutionFilter2DEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyConvolutionFilter2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter2DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyConvolutionFilter2DEXT_ovr_0(target, _internalformat, x, y, width, height);
    
    private z_GetConvolutionFilterEXT_adr := GetProcAddress('glGetConvolutionFilterEXT');
    private z_GetConvolutionFilterEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; format: PixelFormat; &type: PixelType; image: IntPtr)>(z_GetConvolutionFilterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionFilterEXT(target: ConvolutionTargetEXT; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_GetConvolutionFilterEXT_ovr_0(target, format, &type, image);
    
    private z_GetConvolutionParameterfvEXT_adr := GetProcAddress('glGetConvolutionParameterfvEXT');
    private z_GetConvolutionParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single)>(z_GetConvolutionParameterfvEXT_adr);
    private z_GetConvolutionParameterfvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single) :=
    z_GetConvolutionParameterfvEXT_ovr_0(target, pname, &params);
    private z_GetConvolutionParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameterfvEXT_ovr_2(target, pname, &params);
    
    private z_GetConvolutionParameterivEXT_adr := GetProcAddress('glGetConvolutionParameterivEXT');
    private z_GetConvolutionParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32)>(z_GetConvolutionParameterivEXT_adr);
    private z_GetConvolutionParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_GetConvolutionParameterivEXT_ovr_0(target, pname, &params);
    private z_GetConvolutionParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_GetConvolutionParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameterivEXT_ovr_2(target, pname, &params);
    
    private z_GetSeparableFilterEXT_adr := GetProcAddress('glGetSeparableFilterEXT');
    private z_GetSeparableFilterEXT_ovr_0 := GetProcOrNil&<procedure(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr)>(z_GetSeparableFilterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSeparableFilterEXT(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr) :=
    z_GetSeparableFilterEXT_ovr_0(target, format, &type, row, column, span);
    
    private z_SeparableFilter2DEXT_adr := GetProcAddress('glSeparableFilter2DEXT');
    private z_SeparableFilter2DEXT_ovr_0 := GetProcOrNil&<procedure(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr)>(z_SeparableFilter2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SeparableFilter2DEXT(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr) :=
    z_SeparableFilter2DEXT_ovr_0(target, _internalformat, width, height, format, &type, row, column);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCoordinateFrameEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_coordinate_frame';
    
    private z_Tangent3bEXT_adr := GetProcAddress('glTangent3bEXT');
    private z_Tangent3bEXT_ovr_0 := GetProcOrNil&<procedure(tx: SByte; ty: SByte; tz: SByte)>(z_Tangent3bEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bEXT(tx: SByte; ty: SByte; tz: SByte) :=
    z_Tangent3bEXT_ovr_0(tx, ty, tz);
    
    private z_Tangent3bvEXT_adr := GetProcAddress('glTangent3bvEXT');
    private z_Tangent3bvEXT_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_Tangent3bvEXT_adr);
    private z_Tangent3bvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bvEXT(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3bvEXT_ovr_0(v[0]) else
      z_Tangent3bvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bvEXT(var v: SByte) :=
    z_Tangent3bvEXT_ovr_0(v);
    private z_Tangent3bvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bvEXT(v: IntPtr) :=
    z_Tangent3bvEXT_ovr_2(v);
    
    private z_Tangent3dEXT_adr := GetProcAddress('glTangent3dEXT');
    private z_Tangent3dEXT_ovr_0 := GetProcOrNil&<procedure(tx: real; ty: real; tz: real)>(z_Tangent3dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dEXT(tx: real; ty: real; tz: real) :=
    z_Tangent3dEXT_ovr_0(tx, ty, tz);
    
    private z_Tangent3dvEXT_adr := GetProcAddress('glTangent3dvEXT');
    private z_Tangent3dvEXT_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Tangent3dvEXT_adr);
    private z_Tangent3dvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dvEXT(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3dvEXT_ovr_0(v[0]) else
      z_Tangent3dvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dvEXT(var v: real) :=
    z_Tangent3dvEXT_ovr_0(v);
    private z_Tangent3dvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dvEXT(v: IntPtr) :=
    z_Tangent3dvEXT_ovr_2(v);
    
    private z_Tangent3fEXT_adr := GetProcAddress('glTangent3fEXT');
    private z_Tangent3fEXT_ovr_0 := GetProcOrNil&<procedure(tx: single; ty: single; tz: single)>(z_Tangent3fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fEXT(tx: single; ty: single; tz: single) :=
    z_Tangent3fEXT_ovr_0(tx, ty, tz);
    
    private z_Tangent3fvEXT_adr := GetProcAddress('glTangent3fvEXT');
    private z_Tangent3fvEXT_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Tangent3fvEXT_adr);
    private z_Tangent3fvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fvEXT(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3fvEXT_ovr_0(v[0]) else
      z_Tangent3fvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fvEXT(var v: single) :=
    z_Tangent3fvEXT_ovr_0(v);
    private z_Tangent3fvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fvEXT(v: IntPtr) :=
    z_Tangent3fvEXT_ovr_2(v);
    
    private z_Tangent3iEXT_adr := GetProcAddress('glTangent3iEXT');
    private z_Tangent3iEXT_ovr_0 := GetProcOrNil&<procedure(tx: Int32; ty: Int32; tz: Int32)>(z_Tangent3iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3iEXT(tx: Int32; ty: Int32; tz: Int32) :=
    z_Tangent3iEXT_ovr_0(tx, ty, tz);
    
    private z_Tangent3ivEXT_adr := GetProcAddress('glTangent3ivEXT');
    private z_Tangent3ivEXT_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Tangent3ivEXT_adr);
    private z_Tangent3ivEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3ivEXT(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3ivEXT_ovr_0(v[0]) else
      z_Tangent3ivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3ivEXT(var v: Int32) :=
    z_Tangent3ivEXT_ovr_0(v);
    private z_Tangent3ivEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3ivEXT(v: IntPtr) :=
    z_Tangent3ivEXT_ovr_2(v);
    
    private z_Tangent3sEXT_adr := GetProcAddress('glTangent3sEXT');
    private z_Tangent3sEXT_ovr_0 := GetProcOrNil&<procedure(tx: Int16; ty: Int16; tz: Int16)>(z_Tangent3sEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3sEXT(tx: Int16; ty: Int16; tz: Int16) :=
    z_Tangent3sEXT_ovr_0(tx, ty, tz);
    
    private z_Tangent3svEXT_adr := GetProcAddress('glTangent3svEXT');
    private z_Tangent3svEXT_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Tangent3svEXT_adr);
    private z_Tangent3svEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3svEXT(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3svEXT_ovr_0(v[0]) else
      z_Tangent3svEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3svEXT(var v: Int16) :=
    z_Tangent3svEXT_ovr_0(v);
    private z_Tangent3svEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Tangent3svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3svEXT(v: IntPtr) :=
    z_Tangent3svEXT_ovr_2(v);
    
    private z_Binormal3bEXT_adr := GetProcAddress('glBinormal3bEXT');
    private z_Binormal3bEXT_ovr_0 := GetProcOrNil&<procedure(bx: SByte; by: SByte; bz: SByte)>(z_Binormal3bEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bEXT(bx: SByte; by: SByte; bz: SByte) :=
    z_Binormal3bEXT_ovr_0(bx, by, bz);
    
    private z_Binormal3bvEXT_adr := GetProcAddress('glBinormal3bvEXT');
    private z_Binormal3bvEXT_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_Binormal3bvEXT_adr);
    private z_Binormal3bvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bvEXT(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3bvEXT_ovr_0(v[0]) else
      z_Binormal3bvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bvEXT(var v: SByte) :=
    z_Binormal3bvEXT_ovr_0(v);
    private z_Binormal3bvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bvEXT(v: IntPtr) :=
    z_Binormal3bvEXT_ovr_2(v);
    
    private z_Binormal3dEXT_adr := GetProcAddress('glBinormal3dEXT');
    private z_Binormal3dEXT_ovr_0 := GetProcOrNil&<procedure(bx: real; by: real; bz: real)>(z_Binormal3dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dEXT(bx: real; by: real; bz: real) :=
    z_Binormal3dEXT_ovr_0(bx, by, bz);
    
    private z_Binormal3dvEXT_adr := GetProcAddress('glBinormal3dvEXT');
    private z_Binormal3dvEXT_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_Binormal3dvEXT_adr);
    private z_Binormal3dvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dvEXT(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3dvEXT_ovr_0(v[0]) else
      z_Binormal3dvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dvEXT(var v: real) :=
    z_Binormal3dvEXT_ovr_0(v);
    private z_Binormal3dvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dvEXT(v: IntPtr) :=
    z_Binormal3dvEXT_ovr_2(v);
    
    private z_Binormal3fEXT_adr := GetProcAddress('glBinormal3fEXT');
    private z_Binormal3fEXT_ovr_0 := GetProcOrNil&<procedure(bx: single; by: single; bz: single)>(z_Binormal3fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fEXT(bx: single; by: single; bz: single) :=
    z_Binormal3fEXT_ovr_0(bx, by, bz);
    
    private z_Binormal3fvEXT_adr := GetProcAddress('glBinormal3fvEXT');
    private z_Binormal3fvEXT_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_Binormal3fvEXT_adr);
    private z_Binormal3fvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fvEXT(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3fvEXT_ovr_0(v[0]) else
      z_Binormal3fvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fvEXT(var v: single) :=
    z_Binormal3fvEXT_ovr_0(v);
    private z_Binormal3fvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fvEXT(v: IntPtr) :=
    z_Binormal3fvEXT_ovr_2(v);
    
    private z_Binormal3iEXT_adr := GetProcAddress('glBinormal3iEXT');
    private z_Binormal3iEXT_ovr_0 := GetProcOrNil&<procedure(bx: Int32; by: Int32; bz: Int32)>(z_Binormal3iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3iEXT(bx: Int32; by: Int32; bz: Int32) :=
    z_Binormal3iEXT_ovr_0(bx, by, bz);
    
    private z_Binormal3ivEXT_adr := GetProcAddress('glBinormal3ivEXT');
    private z_Binormal3ivEXT_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_Binormal3ivEXT_adr);
    private z_Binormal3ivEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3ivEXT(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3ivEXT_ovr_0(v[0]) else
      z_Binormal3ivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3ivEXT(var v: Int32) :=
    z_Binormal3ivEXT_ovr_0(v);
    private z_Binormal3ivEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3ivEXT(v: IntPtr) :=
    z_Binormal3ivEXT_ovr_2(v);
    
    private z_Binormal3sEXT_adr := GetProcAddress('glBinormal3sEXT');
    private z_Binormal3sEXT_ovr_0 := GetProcOrNil&<procedure(bx: Int16; by: Int16; bz: Int16)>(z_Binormal3sEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3sEXT(bx: Int16; by: Int16; bz: Int16) :=
    z_Binormal3sEXT_ovr_0(bx, by, bz);
    
    private z_Binormal3svEXT_adr := GetProcAddress('glBinormal3svEXT');
    private z_Binormal3svEXT_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_Binormal3svEXT_adr);
    private z_Binormal3svEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3svEXT(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3svEXT_ovr_0(v[0]) else
      z_Binormal3svEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3svEXT(var v: Int16) :=
    z_Binormal3svEXT_ovr_0(v);
    private z_Binormal3svEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Binormal3svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3svEXT(v: IntPtr) :=
    z_Binormal3svEXT_ovr_2(v);
    
    private z_TangentPointerEXT_adr := GetProcAddress('glTangentPointerEXT');
    private z_TangentPointerEXT_ovr_0 := GetProcOrNil&<procedure(&type: TangentPointerTypeEXT; stride: Int32; pointer: IntPtr)>(z_TangentPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TangentPointerEXT(&type: TangentPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_TangentPointerEXT_ovr_0(&type, stride, pointer);
    
    private z_BinormalPointerEXT_adr := GetProcAddress('glBinormalPointerEXT');
    private z_BinormalPointerEXT_ovr_0 := GetProcOrNil&<procedure(&type: BinormalPointerTypeEXT; stride: Int32; pointer: IntPtr)>(z_BinormalPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BinormalPointerEXT(&type: BinormalPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_BinormalPointerEXT_ovr_0(&type, stride, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCopyTextureEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_copy_texture';
    
    private z_CopyTexImage1DEXT_adr := GetProcAddress('glCopyTexImage1DEXT');
    private z_CopyTexImage1DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32)>(z_CopyTexImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage1DEXT(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyTexImage1DEXT_ovr_0(target, level, _internalformat, x, y, width, border);
    
    private z_CopyTexImage2DEXT_adr := GetProcAddress('glCopyTexImage2DEXT');
    private z_CopyTexImage2DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32)>(z_CopyTexImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage2DEXT(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyTexImage2DEXT_ovr_0(target, level, _internalformat, x, y, width, height, border);
    
    private z_CopyTexSubImage1DEXT_adr := GetProcAddress('glCopyTexSubImage1DEXT');
    private z_CopyTexSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyTexSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage1DEXT(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTexSubImage1DEXT_ovr_0(target, level, xoffset, x, y, width);
    
    private z_CopyTexSubImage2DEXT_adr := GetProcAddress('glCopyTexSubImage2DEXT');
    private z_CopyTexSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTexSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage2DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage2DEXT_ovr_0(target, level, xoffset, yoffset, x, y, width, height);
    
    private z_CopyTexSubImage3DEXT_adr := GetProcAddress('glCopyTexSubImage3DEXT');
    private z_CopyTexSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTexSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage3DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage3DEXT_ovr_0(target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCullVertexEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_cull_vertex';
    
    private z_CullParameterdvEXT_adr := GetProcAddress('glCullParameterdvEXT');
    private z_CullParameterdvEXT_ovr_0 := GetProcOrNil&<procedure(pname: CullParameterEXT; var &params: real)>(z_CullParameterdvEXT_adr);
    private z_CullParameterdvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(pname: CullParameterEXT; &params: IntPtr)>(z_CullParameterdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterdvEXT(pname: CullParameterEXT; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CullParameterdvEXT_ovr_0(pname, &params[0]) else
      z_CullParameterdvEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterdvEXT(pname: CullParameterEXT; var &params: real) :=
    z_CullParameterdvEXT_ovr_0(pname, &params);
    private z_CullParameterdvEXT_ovr_2 := GetProcOrNil&<procedure(pname: CullParameterEXT; &params: IntPtr)>(z_CullParameterdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterdvEXT(pname: CullParameterEXT; &params: IntPtr) :=
    z_CullParameterdvEXT_ovr_2(pname, &params);
    
    private z_CullParameterfvEXT_adr := GetProcAddress('glCullParameterfvEXT');
    private z_CullParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(pname: CullParameterEXT; var &params: single)>(z_CullParameterfvEXT_adr);
    private z_CullParameterfvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(pname: CullParameterEXT; &params: IntPtr)>(z_CullParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterfvEXT(pname: CullParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CullParameterfvEXT_ovr_0(pname, &params[0]) else
      z_CullParameterfvEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterfvEXT(pname: CullParameterEXT; var &params: single) :=
    z_CullParameterfvEXT_ovr_0(pname, &params);
    private z_CullParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(pname: CullParameterEXT; &params: IntPtr)>(z_CullParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterfvEXT(pname: CullParameterEXT; &params: IntPtr) :=
    z_CullParameterfvEXT_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDebugLabelEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_debug_label';
    
    private z_LabelObjectEXT_adr := GetProcAddress('glLabelObjectEXT');
    private z_LabelObjectEXT_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; object: UInt32; length: Int32; &label: IntPtr)>(z_LabelObjectEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LabelObjectEXT(&type: DummyEnum; object: UInt32; length: Int32; &label: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(&label);
        z_LabelObjectEXT_ovr_0(&type, object, length, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LabelObjectEXT(&type: DummyEnum; object: UInt32; length: Int32; &label: IntPtr) :=
    z_LabelObjectEXT_ovr_0(&type, object, length, &label);
    
    private z_GetObjectLabelEXT_adr := GetProcAddress('glGetObjectLabelEXT');
    private z_GetObjectLabelEXT_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; object: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectLabelEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabelEXT(&type: DummyEnum; object: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectLabelEXT_ovr_0(&type, object, bufSize, length, &label);
    private z_GetObjectLabelEXT_ovr_1 := GetProcOrNil&<procedure(&type: DummyEnum; object: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectLabelEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabelEXT(&type: DummyEnum; object: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectLabelEXT_ovr_1(&type, object, bufSize, length, &label);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDebugMarkerEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_debug_marker';
    
    private z_InsertEventMarkerEXT_adr := GetProcAddress('glInsertEventMarkerEXT');
    private z_InsertEventMarkerEXT_ovr_0 := GetProcOrNil&<procedure(length: Int32; marker: IntPtr)>(z_InsertEventMarkerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InsertEventMarkerEXT(length: Int32; marker: string);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(marker);
        z_InsertEventMarkerEXT_ovr_0(length, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InsertEventMarkerEXT(length: Int32; marker: IntPtr) :=
    z_InsertEventMarkerEXT_ovr_0(length, marker);
    
    private z_PushGroupMarkerEXT_adr := GetProcAddress('glPushGroupMarkerEXT');
    private z_PushGroupMarkerEXT_ovr_0 := GetProcOrNil&<procedure(length: Int32; marker: IntPtr)>(z_PushGroupMarkerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushGroupMarkerEXT(length: Int32; marker: string);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(marker);
        z_PushGroupMarkerEXT_ovr_0(length, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushGroupMarkerEXT(length: Int32; marker: IntPtr) :=
    z_PushGroupMarkerEXT_ovr_0(length, marker);
    
    private z_PopGroupMarkerEXT_adr := GetProcAddress('glPopGroupMarkerEXT');
    private z_PopGroupMarkerEXT_ovr_0 := GetProcOrNil&<procedure>(z_PopGroupMarkerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopGroupMarkerEXT :=
    z_PopGroupMarkerEXT_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDepthBoundsTestEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_depth_bounds_test';
    
    private z_DepthBoundsEXT_adr := GetProcAddress('glDepthBoundsEXT');
    private z_DepthBoundsEXT_ovr_0 := GetProcOrNil&<procedure(zmin: real; zmax: real)>(z_DepthBoundsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthBoundsEXT(zmin: real; zmax: real) :=
    z_DepthBoundsEXT_ovr_0(zmin, zmax);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDirectStateAccessEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_direct_state_access';
    
    private z_MatrixLoadfEXT_adr := GetProcAddress('glMatrixLoadfEXT');
    private z_MatrixLoadfEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixLoadfEXT_adr);
    private z_MatrixLoadfEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadfEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadfEXT_ovr_0(mode, m);
    private z_MatrixLoadfEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadfEXT_ovr_2(mode, m);
    
    private z_MatrixLoaddEXT_adr := GetProcAddress('glMatrixLoaddEXT');
    private z_MatrixLoaddEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixLoaddEXT_adr);
    private z_MatrixLoaddEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoaddEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoaddEXT_ovr_0(mode, m[0]) else
      z_MatrixLoaddEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoaddEXT_ovr_0(mode, m);
    private z_MatrixLoaddEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoaddEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoaddEXT_ovr_2(mode, m);
    
    private z_MatrixMultfEXT_adr := GetProcAddress('glMatrixMultfEXT');
    private z_MatrixMultfEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixMultfEXT_adr);
    private z_MatrixMultfEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultfEXT_ovr_0(mode, m[0]) else
      z_MatrixMultfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultfEXT_ovr_0(mode, m);
    private z_MatrixMultfEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultfEXT_ovr_2(mode, m);
    
    private z_MatrixMultdEXT_adr := GetProcAddress('glMatrixMultdEXT');
    private z_MatrixMultdEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixMultdEXT_adr);
    private z_MatrixMultdEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultdEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultdEXT_ovr_0(mode, m[0]) else
      z_MatrixMultdEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultdEXT_ovr_0(mode, m);
    private z_MatrixMultdEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultdEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultdEXT_ovr_2(mode, m);
    
    private z_MatrixLoadIdentityEXT_adr := GetProcAddress('glMatrixLoadIdentityEXT');
    private z_MatrixLoadIdentityEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode)>(z_MatrixLoadIdentityEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadIdentityEXT(mode: MatrixMode) :=
    z_MatrixLoadIdentityEXT_ovr_0(mode);
    
    private z_MatrixRotatefEXT_adr := GetProcAddress('glMatrixRotatefEXT');
    private z_MatrixRotatefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; angle: single; x: single; y: single; z: single)>(z_MatrixRotatefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatefEXT(mode: MatrixMode; angle: single; x: single; y: single; z: single) :=
    z_MatrixRotatefEXT_ovr_0(mode, angle, x, y, z);
    
    private z_MatrixRotatedEXT_adr := GetProcAddress('glMatrixRotatedEXT');
    private z_MatrixRotatedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; angle: real; x: real; y: real; z: real)>(z_MatrixRotatedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatedEXT(mode: MatrixMode; angle: real; x: real; y: real; z: real) :=
    z_MatrixRotatedEXT_ovr_0(mode, angle, x, y, z);
    
    private z_MatrixScalefEXT_adr := GetProcAddress('glMatrixScalefEXT');
    private z_MatrixScalefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: single; y: single; z: single)>(z_MatrixScalefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScalefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixScalefEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixScaledEXT_adr := GetProcAddress('glMatrixScaledEXT');
    private z_MatrixScaledEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: real; y: real; z: real)>(z_MatrixScaledEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScaledEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixScaledEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixTranslatefEXT_adr := GetProcAddress('glMatrixTranslatefEXT');
    private z_MatrixTranslatefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: single; y: single; z: single)>(z_MatrixTranslatefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixTranslatefEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixTranslatedEXT_adr := GetProcAddress('glMatrixTranslatedEXT');
    private z_MatrixTranslatedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: real; y: real; z: real)>(z_MatrixTranslatedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatedEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixTranslatedEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixFrustumEXT_adr := GetProcAddress('glMatrixFrustumEXT');
    private z_MatrixFrustumEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real)>(z_MatrixFrustumEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixFrustumEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixFrustumEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private z_MatrixOrthoEXT_adr := GetProcAddress('glMatrixOrthoEXT');
    private z_MatrixOrthoEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real)>(z_MatrixOrthoEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixOrthoEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixOrthoEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private z_MatrixPopEXT_adr := GetProcAddress('glMatrixPopEXT');
    private z_MatrixPopEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode)>(z_MatrixPopEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPopEXT(mode: MatrixMode) :=
    z_MatrixPopEXT_ovr_0(mode);
    
    private z_MatrixPushEXT_adr := GetProcAddress('glMatrixPushEXT');
    private z_MatrixPushEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode)>(z_MatrixPushEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPushEXT(mode: MatrixMode) :=
    z_MatrixPushEXT_ovr_0(mode);
    
    private z_ClientAttribDefaultEXT_adr := GetProcAddress('glClientAttribDefaultEXT');
    private z_ClientAttribDefaultEXT_ovr_0 := GetProcOrNil&<procedure(mask: ClientAttribMask)>(z_ClientAttribDefaultEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientAttribDefaultEXT(mask: ClientAttribMask) :=
    z_ClientAttribDefaultEXT_ovr_0(mask);
    
    private z_PushClientAttribDefaultEXT_adr := GetProcAddress('glPushClientAttribDefaultEXT');
    private z_PushClientAttribDefaultEXT_ovr_0 := GetProcOrNil&<procedure(mask: ClientAttribMask)>(z_PushClientAttribDefaultEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushClientAttribDefaultEXT(mask: ClientAttribMask) :=
    z_PushClientAttribDefaultEXT_ovr_0(mask);
    
    private z_TextureParameterfEXT_adr := GetProcAddress('glTextureParameterfEXT');
    private z_TextureParameterfEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; param: single)>(z_TextureParameterfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; param: single) :=
    z_TextureParameterfEXT_ovr_0(texture, target, pname, param);
    
    private z_TextureParameterfvEXT_adr := GetProcAddress('glTextureParameterfvEXT');
    private z_TextureParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: single)>(z_TextureParameterfvEXT_adr);
    private z_TextureParameterfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfvEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterfvEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterfvEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfvEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: single) :=
    z_TextureParameterfvEXT_ovr_0(texture, target, pname, &params);
    private z_TextureParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfvEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterfvEXT_ovr_2(texture, target, pname, &params);
    
    private z_TextureParameteriEXT_adr := GetProcAddress('glTextureParameteriEXT');
    private z_TextureParameteriEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; param: Int32)>(z_TextureParameteriEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; param: Int32) :=
    z_TextureParameteriEXT_ovr_0(texture, target, pname, param);
    
    private z_TextureParameterivEXT_adr := GetProcAddress('glTextureParameterivEXT');
    private z_TextureParameterivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_TextureParameterivEXT_adr);
    private z_TextureParameterivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterivEXT_ovr_0(texture, target, pname, &params);
    private z_TextureParameterivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterivEXT_ovr_2(texture, target, pname, &params);
    
    private z_TextureImage1DEXT_adr := GetProcAddress('glTextureImage1DEXT');
    private z_TextureImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage1DEXT(texture: gl_texture; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureImage1DEXT_ovr_0(texture, target, level, internalformat, width, border, format, &type, pixels);
    
    private z_TextureImage2DEXT_adr := GetProcAddress('glTextureImage2DEXT');
    private z_TextureImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage2DEXT(texture: gl_texture; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureImage2DEXT_ovr_0(texture, target, level, internalformat, width, height, border, format, &type, pixels);
    
    private z_TextureSubImage1DEXT_adr := GetProcAddress('glTextureSubImage1DEXT');
    private z_TextureSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage1DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage1DEXT_ovr_0(texture, target, level, xoffset, width, format, &type, pixels);
    
    private z_TextureSubImage2DEXT_adr := GetProcAddress('glTextureSubImage2DEXT');
    private z_TextureSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage2DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage2DEXT_ovr_0(texture, target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    private z_CopyTextureImage1DEXT_adr := GetProcAddress('glCopyTextureImage1DEXT');
    private z_CopyTextureImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32)>(z_CopyTextureImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureImage1DEXT(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyTextureImage1DEXT_ovr_0(texture, target, level, _internalformat, x, y, width, border);
    
    private z_CopyTextureImage2DEXT_adr := GetProcAddress('glCopyTextureImage2DEXT');
    private z_CopyTextureImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32)>(z_CopyTextureImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureImage2DEXT(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyTextureImage2DEXT_ovr_0(texture, target, level, _internalformat, x, y, width, height, border);
    
    private z_CopyTextureSubImage1DEXT_adr := GetProcAddress('glCopyTextureSubImage1DEXT');
    private z_CopyTextureSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyTextureSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage1DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTextureSubImage1DEXT_ovr_0(texture, target, level, xoffset, x, y, width);
    
    private z_CopyTextureSubImage2DEXT_adr := GetProcAddress('glCopyTextureSubImage2DEXT');
    private z_CopyTextureSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage2DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage2DEXT_ovr_0(texture, target, level, xoffset, yoffset, x, y, width, height);
    
    private z_GetTextureImageEXT_adr := GetProcAddress('glGetTextureImageEXT');
    private z_GetTextureImageEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_GetTextureImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureImageEXT(texture: gl_texture; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_GetTextureImageEXT_ovr_0(texture, target, level, format, &type, pixels);
    
    private z_GetTextureParameterfvEXT_adr := GetProcAddress('glGetTextureParameterfvEXT');
    private z_GetTextureParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: single)>(z_GetTextureParameterfvEXT_adr);
    private z_GetTextureParameterfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfvEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterfvEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterfvEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfvEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureParameterfvEXT_ovr_0(texture, target, pname, &params);
    private z_GetTextureParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfvEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterfvEXT_ovr_2(texture, target, pname, &params);
    
    private z_GetTextureParameterivEXT_adr := GetProcAddress('glGetTextureParameterivEXT');
    private z_GetTextureParameterivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameterivEXT_adr);
    private z_GetTextureParameterivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterivEXT_ovr_0(texture, target, pname, &params);
    private z_GetTextureParameterivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterivEXT_ovr_2(texture, target, pname, &params);
    
    private z_GetTextureLevelParameterfvEXT_adr := GetProcAddress('glGetTextureLevelParameterfvEXT');
    private z_GetTextureLevelParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single)>(z_GetTextureLevelParameterfvEXT_adr);
    private z_GetTextureLevelParameterfvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfvEXT(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterfvEXT_ovr_0(texture, target, level, pname, &params[0]) else
      z_GetTextureLevelParameterfvEXT_ovr_0_anh000001(texture, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfvEXT(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureLevelParameterfvEXT_ovr_0(texture, target, level, pname, &params);
    private z_GetTextureLevelParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfvEXT(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterfvEXT_ovr_2(texture, target, level, pname, &params);
    
    private z_GetTextureLevelParameterivEXT_adr := GetProcAddress('glGetTextureLevelParameterivEXT');
    private z_GetTextureLevelParameterivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureLevelParameterivEXT_adr);
    private z_GetTextureLevelParameterivEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterivEXT(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterivEXT_ovr_0(texture, target, level, pname, &params[0]) else
      z_GetTextureLevelParameterivEXT_ovr_0_anh000001(texture, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterivEXT(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureLevelParameterivEXT_ovr_0(texture, target, level, pname, &params);
    private z_GetTextureLevelParameterivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterivEXT(texture: gl_texture; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterivEXT_ovr_2(texture, target, level, pname, &params);
    
    private z_TextureImage3DEXT_adr := GetProcAddress('glTextureImage3DEXT');
    private z_TextureImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage3DEXT(texture: gl_texture; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureImage3DEXT_ovr_0(texture, target, level, internalformat, width, height, depth, border, format, &type, pixels);
    
    private z_TextureSubImage3DEXT_adr := GetProcAddress('glTextureSubImage3DEXT');
    private z_TextureSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage3DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage3DEXT_ovr_0(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    private z_CopyTextureSubImage3DEXT_adr := GetProcAddress('glCopyTextureSubImage3DEXT');
    private z_CopyTextureSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage3DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage3DEXT_ovr_0(texture, target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    private z_BindMultiTextureEXT_adr := GetProcAddress('glBindMultiTextureEXT');
    private z_BindMultiTextureEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; texture: gl_texture)>(z_BindMultiTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindMultiTextureEXT(texunit: TextureUnit; target: TextureTarget; texture: gl_texture) :=
    z_BindMultiTextureEXT_ovr_0(texunit, target, texture);
    
    private z_MultiTexCoordPointerEXT_adr := GetProcAddress('glMultiTexCoordPointerEXT');
    private z_MultiTexCoordPointerEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr)>(z_MultiTexCoordPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordPointerEXT(texunit: TextureUnit; size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr) :=
    z_MultiTexCoordPointerEXT_ovr_0(texunit, size, &type, stride, pointer);
    
    private z_MultiTexEnvfEXT_adr := GetProcAddress('glMultiTexEnvfEXT');
    private z_MultiTexEnvfEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: single)>(z_MultiTexEnvfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: single) :=
    z_MultiTexEnvfEXT_ovr_0(texunit, target, pname, param);
    
    private z_MultiTexEnvfvEXT_adr := GetProcAddress('glMultiTexEnvfvEXT');
    private z_MultiTexEnvfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single)>(z_MultiTexEnvfvEXT_adr);
    private z_MultiTexEnvfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_MultiTexEnvfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexEnvfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_MultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params);
    private z_MultiTexEnvfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_MultiTexEnvfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_MultiTexEnvfvEXT_ovr_2(texunit, target, pname, &params);
    
    private z_MultiTexEnviEXT_adr := GetProcAddress('glMultiTexEnviEXT');
    private z_MultiTexEnviEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32)>(z_MultiTexEnviEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnviEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32) :=
    z_MultiTexEnviEXT_ovr_0(texunit, target, pname, param);
    
    private z_MultiTexEnvivEXT_adr := GetProcAddress('glMultiTexEnvivEXT');
    private z_MultiTexEnvivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32)>(z_MultiTexEnvivEXT_adr);
    private z_MultiTexEnvivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_MultiTexEnvivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexEnvivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexEnvivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_MultiTexEnvivEXT_ovr_0(texunit, target, pname, &params);
    private z_MultiTexEnvivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_MultiTexEnvivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_MultiTexEnvivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_MultiTexGendEXT_adr := GetProcAddress('glMultiTexGendEXT');
    private z_MultiTexGendEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: real)>(z_MultiTexGendEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: real) :=
    z_MultiTexGendEXT_ovr_0(texunit, coord, pname, param);
    
    private z_MultiTexGendvEXT_adr := GetProcAddress('glMultiTexGendvEXT');
    private z_MultiTexGendvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real)>(z_MultiTexGendvEXT_adr);
    private z_MultiTexGendvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_MultiTexGendvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexGendvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_MultiTexGendvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_MultiTexGendvEXT_ovr_0(texunit, coord, pname, &params);
    private z_MultiTexGendvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_MultiTexGendvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_MultiTexGendvEXT_ovr_2(texunit, coord, pname, &params);
    
    private z_MultiTexGenfEXT_adr := GetProcAddress('glMultiTexGenfEXT');
    private z_MultiTexGenfEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: single)>(z_MultiTexGenfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: single) :=
    z_MultiTexGenfEXT_ovr_0(texunit, coord, pname, param);
    
    private z_MultiTexGenfvEXT_adr := GetProcAddress('glMultiTexGenfvEXT');
    private z_MultiTexGenfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single)>(z_MultiTexGenfvEXT_adr);
    private z_MultiTexGenfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_MultiTexGenfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_MultiTexGenfvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_MultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params);
    private z_MultiTexGenfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_MultiTexGenfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_MultiTexGenfvEXT_ovr_2(texunit, coord, pname, &params);
    
    private z_MultiTexGeniEXT_adr := GetProcAddress('glMultiTexGeniEXT');
    private z_MultiTexGeniEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: Int32)>(z_MultiTexGeniEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGeniEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: Int32) :=
    z_MultiTexGeniEXT_ovr_0(texunit, coord, pname, param);
    
    private z_MultiTexGenivEXT_adr := GetProcAddress('glMultiTexGenivEXT');
    private z_MultiTexGenivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32)>(z_MultiTexGenivEXT_adr);
    private z_MultiTexGenivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_MultiTexGenivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexGenivEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_MultiTexGenivEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_MultiTexGenivEXT_ovr_0(texunit, coord, pname, &params);
    private z_MultiTexGenivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_MultiTexGenivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_MultiTexGenivEXT_ovr_2(texunit, coord, pname, &params);
    
    private z_GetMultiTexEnvfvEXT_adr := GetProcAddress('glGetMultiTexEnvfvEXT');
    private z_GetMultiTexEnvfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single)>(z_GetMultiTexEnvfvEXT_adr);
    private z_GetMultiTexEnvfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetMultiTexEnvfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexEnvfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_GetMultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params);
    private z_GetMultiTexEnvfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetMultiTexEnvfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetMultiTexEnvfvEXT_ovr_2(texunit, target, pname, &params);
    
    private z_GetMultiTexEnvivEXT_adr := GetProcAddress('glGetMultiTexEnvivEXT');
    private z_GetMultiTexEnvivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32)>(z_GetMultiTexEnvivEXT_adr);
    private z_GetMultiTexEnvivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetMultiTexEnvivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexEnvivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexEnvivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_GetMultiTexEnvivEXT_ovr_0(texunit, target, pname, &params);
    private z_GetMultiTexEnvivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetMultiTexEnvivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetMultiTexEnvivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_GetMultiTexGendvEXT_adr := GetProcAddress('glGetMultiTexGendvEXT');
    private z_GetMultiTexGendvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real)>(z_GetMultiTexGendvEXT_adr);
    private z_GetMultiTexGendvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetMultiTexGendvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexGendvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_GetMultiTexGendvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_GetMultiTexGendvEXT_ovr_0(texunit, coord, pname, &params);
    private z_GetMultiTexGendvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetMultiTexGendvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetMultiTexGendvEXT_ovr_2(texunit, coord, pname, &params);
    
    private z_GetMultiTexGenfvEXT_adr := GetProcAddress('glGetMultiTexGenfvEXT');
    private z_GetMultiTexGenfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single)>(z_GetMultiTexGenfvEXT_adr);
    private z_GetMultiTexGenfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetMultiTexGenfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_GetMultiTexGenfvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_GetMultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params);
    private z_GetMultiTexGenfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetMultiTexGenfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetMultiTexGenfvEXT_ovr_2(texunit, coord, pname, &params);
    
    private z_GetMultiTexGenivEXT_adr := GetProcAddress('glGetMultiTexGenivEXT');
    private z_GetMultiTexGenivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32)>(z_GetMultiTexGenivEXT_adr);
    private z_GetMultiTexGenivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetMultiTexGenivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexGenivEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_GetMultiTexGenivEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_GetMultiTexGenivEXT_ovr_0(texunit, coord, pname, &params);
    private z_GetMultiTexGenivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetMultiTexGenivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetMultiTexGenivEXT_ovr_2(texunit, coord, pname, &params);
    
    private z_MultiTexParameteriEXT_adr := GetProcAddress('glMultiTexParameteriEXT');
    private z_MultiTexParameteriEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: Int32)>(z_MultiTexParameteriEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameteriEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: Int32) :=
    z_MultiTexParameteriEXT_ovr_0(texunit, target, pname, param);
    
    private z_MultiTexParameterivEXT_adr := GetProcAddress('glMultiTexParameterivEXT');
    private z_MultiTexParameterivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_MultiTexParameterivEXT_adr);
    private z_MultiTexParameterivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_MultiTexParameterivEXT_ovr_0(texunit, target, pname, &params);
    private z_MultiTexParameterivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_MultiTexParameterfEXT_adr := GetProcAddress('glMultiTexParameterfEXT');
    private z_MultiTexParameterfEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: single)>(z_MultiTexParameterfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: single) :=
    z_MultiTexParameterfEXT_ovr_0(texunit, target, pname, param);
    
    private z_MultiTexParameterfvEXT_adr := GetProcAddress('glMultiTexParameterfvEXT');
    private z_MultiTexParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: single)>(z_MultiTexParameterfvEXT_adr);
    private z_MultiTexParameterfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: single) :=
    z_MultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params);
    private z_MultiTexParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterfvEXT_ovr_2(texunit, target, pname, &params);
    
    private z_MultiTexImage1DEXT_adr := GetProcAddress('glMultiTexImage1DEXT');
    private z_MultiTexImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_MultiTexImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexImage1DEXT_ovr_0(texunit, target, level, internalformat, width, border, format, &type, pixels);
    
    private z_MultiTexImage2DEXT_adr := GetProcAddress('glMultiTexImage2DEXT');
    private z_MultiTexImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_MultiTexImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexImage2DEXT_ovr_0(texunit, target, level, internalformat, width, height, border, format, &type, pixels);
    
    private z_MultiTexSubImage1DEXT_adr := GetProcAddress('glMultiTexSubImage1DEXT');
    private z_MultiTexSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_MultiTexSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexSubImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexSubImage1DEXT_ovr_0(texunit, target, level, xoffset, width, format, &type, pixels);
    
    private z_MultiTexSubImage2DEXT_adr := GetProcAddress('glMultiTexSubImage2DEXT');
    private z_MultiTexSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_MultiTexSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexSubImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexSubImage2DEXT_ovr_0(texunit, target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    private z_CopyMultiTexImage1DEXT_adr := GetProcAddress('glCopyMultiTexImage1DEXT');
    private z_CopyMultiTexImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32)>(z_CopyMultiTexImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyMultiTexImage1DEXT_ovr_0(texunit, target, level, _internalformat, x, y, width, border);
    
    private z_CopyMultiTexImage2DEXT_adr := GetProcAddress('glCopyMultiTexImage2DEXT');
    private z_CopyMultiTexImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32)>(z_CopyMultiTexImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyMultiTexImage2DEXT_ovr_0(texunit, target, level, _internalformat, x, y, width, height, border);
    
    private z_CopyMultiTexSubImage1DEXT_adr := GetProcAddress('glCopyMultiTexSubImage1DEXT');
    private z_CopyMultiTexSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyMultiTexSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexSubImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyMultiTexSubImage1DEXT_ovr_0(texunit, target, level, xoffset, x, y, width);
    
    private z_CopyMultiTexSubImage2DEXT_adr := GetProcAddress('glCopyMultiTexSubImage2DEXT');
    private z_CopyMultiTexSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyMultiTexSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexSubImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyMultiTexSubImage2DEXT_ovr_0(texunit, target, level, xoffset, yoffset, x, y, width, height);
    
    private z_GetMultiTexImageEXT_adr := GetProcAddress('glGetMultiTexImageEXT');
    private z_GetMultiTexImageEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_GetMultiTexImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexImageEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_GetMultiTexImageEXT_ovr_0(texunit, target, level, format, &type, pixels);
    
    private z_GetMultiTexParameterfvEXT_adr := GetProcAddress('glGetMultiTexParameterfvEXT');
    private z_GetMultiTexParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: single)>(z_GetMultiTexParameterfvEXT_adr);
    private z_GetMultiTexParameterfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: single) :=
    z_GetMultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params);
    private z_GetMultiTexParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterfvEXT_ovr_2(texunit, target, pname, &params);
    
    private z_GetMultiTexParameterivEXT_adr := GetProcAddress('glGetMultiTexParameterivEXT');
    private z_GetMultiTexParameterivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetMultiTexParameterivEXT_adr);
    private z_GetMultiTexParameterivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetMultiTexParameterivEXT_ovr_0(texunit, target, pname, &params);
    private z_GetMultiTexParameterivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_GetMultiTexLevelParameterfvEXT_adr := GetProcAddress('glGetMultiTexLevelParameterfvEXT');
    private z_GetMultiTexLevelParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single)>(z_GetMultiTexLevelParameterfvEXT_adr);
    private z_GetMultiTexLevelParameterfvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexLevelParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterfvEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexLevelParameterfvEXT_ovr_0(texunit, target, level, pname, &params[0]) else
      z_GetMultiTexLevelParameterfvEXT_ovr_0_anh000001(texunit, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterfvEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetMultiTexLevelParameterfvEXT_ovr_0(texunit, target, level, pname, &params);
    private z_GetMultiTexLevelParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexLevelParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterfvEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexLevelParameterfvEXT_ovr_2(texunit, target, level, pname, &params);
    
    private z_GetMultiTexLevelParameterivEXT_adr := GetProcAddress('glGetMultiTexLevelParameterivEXT');
    private z_GetMultiTexLevelParameterivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32)>(z_GetMultiTexLevelParameterivEXT_adr);
    private z_GetMultiTexLevelParameterivEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexLevelParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterivEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexLevelParameterivEXT_ovr_0(texunit, target, level, pname, &params[0]) else
      z_GetMultiTexLevelParameterivEXT_ovr_0_anh000001(texunit, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterivEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetMultiTexLevelParameterivEXT_ovr_0(texunit, target, level, pname, &params);
    private z_GetMultiTexLevelParameterivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexLevelParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterivEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexLevelParameterivEXT_ovr_2(texunit, target, level, pname, &params);
    
    private z_MultiTexImage3DEXT_adr := GetProcAddress('glMultiTexImage3DEXT');
    private z_MultiTexImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_MultiTexImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexImage3DEXT_ovr_0(texunit, target, level, internalformat, width, height, depth, border, format, &type, pixels);
    
    private z_MultiTexSubImage3DEXT_adr := GetProcAddress('glMultiTexSubImage3DEXT');
    private z_MultiTexSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_MultiTexSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexSubImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexSubImage3DEXT_ovr_0(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    private z_CopyMultiTexSubImage3DEXT_adr := GetProcAddress('glCopyMultiTexSubImage3DEXT');
    private z_CopyMultiTexSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyMultiTexSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexSubImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyMultiTexSubImage3DEXT_ovr_0(texunit, target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    private z_EnableClientStateIndexedEXT_adr := GetProcAddress('glEnableClientStateIndexedEXT');
    private z_EnableClientStateIndexedEXT_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; index: UInt32)>(z_EnableClientStateIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableClientStateIndexedEXT(&array: EnableCap; index: UInt32) :=
    z_EnableClientStateIndexedEXT_ovr_0(&array, index);
    
    private z_DisableClientStateIndexedEXT_adr := GetProcAddress('glDisableClientStateIndexedEXT');
    private z_DisableClientStateIndexedEXT_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; index: UInt32)>(z_DisableClientStateIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableClientStateIndexedEXT(&array: EnableCap; index: UInt32) :=
    z_DisableClientStateIndexedEXT_ovr_0(&array, index);
    
    private z_GetFloatIndexedvEXT_adr := GetProcAddress('glGetFloatIndexedvEXT');
    private z_GetFloatIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: single)>(z_GetFloatIndexedvEXT_adr);
    private z_GetFloatIndexedvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetFloatIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatIndexedvEXT(target: GetPName; index: UInt32; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloatIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetFloatIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatIndexedvEXT(target: GetPName; index: UInt32; var data: single) :=
    z_GetFloatIndexedvEXT_ovr_0(target, index, data);
    private z_GetFloatIndexedvEXT_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetFloatIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatIndexedvEXT(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetFloatIndexedvEXT_ovr_2(target, index, data);
    
    private z_GetDoubleIndexedvEXT_adr := GetProcAddress('glGetDoubleIndexedvEXT');
    private z_GetDoubleIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: real)>(z_GetDoubleIndexedvEXT_adr);
    private z_GetDoubleIndexedvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetDoubleIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoubleIndexedvEXT(target: GetPName; index: UInt32; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoubleIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetDoubleIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoubleIndexedvEXT(target: GetPName; index: UInt32; var data: real) :=
    z_GetDoubleIndexedvEXT_ovr_0(target, index, data);
    private z_GetDoubleIndexedvEXT_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetDoubleIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoubleIndexedvEXT(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetDoubleIndexedvEXT_ovr_2(target, index, data);
    
    private z_GetPointerIndexedvEXT_adr := GetProcAddress('glGetPointerIndexedvEXT');
    private z_GetPointerIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; var data: IntPtr)>(z_GetPointerIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerIndexedvEXT(target: DummyEnum; index: UInt32; var data: IntPtr) :=
    z_GetPointerIndexedvEXT_ovr_0(target, index, data);
    private z_GetPointerIndexedvEXT_ovr_1 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; data: pointer)>(z_GetPointerIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerIndexedvEXT(target: DummyEnum; index: UInt32; data: pointer) :=
    z_GetPointerIndexedvEXT_ovr_1(target, index, data);
    
    private z_EnableIndexedEXT_adr := GetProcAddress('glEnableIndexedEXT');
    private z_EnableIndexedEXT_ovr_0 := GetProcOrNil&<procedure(target: EnableCap; index: UInt32)>(z_EnableIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_EnableIndexedEXT_ovr_0(target, index);
    
    private z_DisableIndexedEXT_adr := GetProcAddress('glDisableIndexedEXT');
    private z_DisableIndexedEXT_ovr_0 := GetProcOrNil&<procedure(target: EnableCap; index: UInt32)>(z_DisableIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_DisableIndexedEXT_ovr_0(target, index);
    
    private z_IsEnabledIndexedEXT_adr := GetProcAddress('glIsEnabledIndexedEXT');
    private z_IsEnabledIndexedEXT_ovr_0 := GetProcOrNil&<function(target: EnableCap; index: UInt32): boolean>(z_IsEnabledIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledIndexedEXT(target: EnableCap; index: UInt32): boolean :=
    z_IsEnabledIndexedEXT_ovr_0(target, index);
    
    private z_GetIntegerIndexedvEXT_adr := GetProcAddress('glGetIntegerIndexedvEXT');
    private z_GetIntegerIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: Int32)>(z_GetIntegerIndexedvEXT_adr);
    private z_GetIntegerIndexedvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegerIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: GetPName; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegerIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetIntegerIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: GetPName; index: UInt32; var data: Int32) :=
    z_GetIntegerIndexedvEXT_ovr_0(target, index, data);
    private z_GetIntegerIndexedvEXT_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegerIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetIntegerIndexedvEXT_ovr_2(target, index, data);
    
    private z_GetBooleanIndexedvEXT_adr := GetProcAddress('glGetBooleanIndexedvEXT');
    private z_GetBooleanIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; var data: boolean)>(z_GetBooleanIndexedvEXT_adr);
    private z_GetBooleanIndexedvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; data: IntPtr)>(z_GetBooleanIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTarget; index: UInt32; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleanIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetBooleanIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTarget; index: UInt32; var data: boolean) :=
    z_GetBooleanIndexedvEXT_ovr_0(target, index, data);
    private z_GetBooleanIndexedvEXT_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; data: IntPtr)>(z_GetBooleanIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTarget; index: UInt32; data: IntPtr) :=
    z_GetBooleanIndexedvEXT_ovr_2(target, index, data);
    
    private z_CompressedTextureImage3DEXT_adr := GetProcAddress('glCompressedTextureImage3DEXT');
    private z_CompressedTextureImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr)>(z_CompressedTextureImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureImage3DEXT(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureImage3DEXT_ovr_0(texture, target, level, _internalformat, width, height, depth, border, imageSize, bits);
    
    private z_CompressedTextureImage2DEXT_adr := GetProcAddress('glCompressedTextureImage2DEXT');
    private z_CompressedTextureImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr)>(z_CompressedTextureImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureImage2DEXT(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureImage2DEXT_ovr_0(texture, target, level, _internalformat, width, height, border, imageSize, bits);
    
    private z_CompressedTextureImage1DEXT_adr := GetProcAddress('glCompressedTextureImage1DEXT');
    private z_CompressedTextureImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr)>(z_CompressedTextureImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureImage1DEXT(texture: gl_texture; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureImage1DEXT_ovr_0(texture, target, level, _internalformat, width, border, imageSize, bits);
    
    private z_CompressedTextureSubImage3DEXT_adr := GetProcAddress('glCompressedTextureSubImage3DEXT');
    private z_CompressedTextureSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr)>(z_CompressedTextureSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage3DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureSubImage3DEXT_ovr_0(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
    
    private z_CompressedTextureSubImage2DEXT_adr := GetProcAddress('glCompressedTextureSubImage2DEXT');
    private z_CompressedTextureSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr)>(z_CompressedTextureSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage2DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureSubImage2DEXT_ovr_0(texture, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
    
    private z_CompressedTextureSubImage1DEXT_adr := GetProcAddress('glCompressedTextureSubImage1DEXT');
    private z_CompressedTextureSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr)>(z_CompressedTextureSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage1DEXT(texture: gl_texture; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureSubImage1DEXT_ovr_0(texture, target, level, xoffset, width, format, imageSize, bits);
    
    private z_GetCompressedTextureImageEXT_adr := GetProcAddress('glGetCompressedTextureImageEXT');
    private z_GetCompressedTextureImageEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; lod: Int32; img: IntPtr)>(z_GetCompressedTextureImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureImageEXT(texture: gl_texture; target: TextureTarget; lod: Int32; img: IntPtr) :=
    z_GetCompressedTextureImageEXT_ovr_0(texture, target, lod, img);
    
    private z_CompressedMultiTexImage3DEXT_adr := GetProcAddress('glCompressedMultiTexImage3DEXT');
    private z_CompressedMultiTexImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr)>(z_CompressedMultiTexImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexImage3DEXT_ovr_0(texunit, target, level, _internalformat, width, height, depth, border, imageSize, bits);
    
    private z_CompressedMultiTexImage2DEXT_adr := GetProcAddress('glCompressedMultiTexImage2DEXT');
    private z_CompressedMultiTexImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr)>(z_CompressedMultiTexImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexImage2DEXT_ovr_0(texunit, target, level, _internalformat, width, height, border, imageSize, bits);
    
    private z_CompressedMultiTexImage1DEXT_adr := GetProcAddress('glCompressedMultiTexImage1DEXT');
    private z_CompressedMultiTexImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr)>(z_CompressedMultiTexImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexImage1DEXT_ovr_0(texunit, target, level, _internalformat, width, border, imageSize, bits);
    
    private z_CompressedMultiTexSubImage3DEXT_adr := GetProcAddress('glCompressedMultiTexSubImage3DEXT');
    private z_CompressedMultiTexSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr)>(z_CompressedMultiTexSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexSubImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexSubImage3DEXT_ovr_0(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
    
    private z_CompressedMultiTexSubImage2DEXT_adr := GetProcAddress('glCompressedMultiTexSubImage2DEXT');
    private z_CompressedMultiTexSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr)>(z_CompressedMultiTexSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexSubImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexSubImage2DEXT_ovr_0(texunit, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
    
    private z_CompressedMultiTexSubImage1DEXT_adr := GetProcAddress('glCompressedMultiTexSubImage1DEXT');
    private z_CompressedMultiTexSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr)>(z_CompressedMultiTexSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexSubImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: InternalFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexSubImage1DEXT_ovr_0(texunit, target, level, xoffset, width, format, imageSize, bits);
    
    private z_GetCompressedMultiTexImageEXT_adr := GetProcAddress('glGetCompressedMultiTexImageEXT');
    private z_GetCompressedMultiTexImageEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; lod: Int32; img: IntPtr)>(z_GetCompressedMultiTexImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedMultiTexImageEXT(texunit: TextureUnit; target: TextureTarget; lod: Int32; img: IntPtr) :=
    z_GetCompressedMultiTexImageEXT_ovr_0(texunit, target, lod, img);
    
    private z_MatrixLoadTransposefEXT_adr := GetProcAddress('glMatrixLoadTransposefEXT');
    private z_MatrixLoadTransposefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixLoadTransposefEXT_adr);
    private z_MatrixLoadTransposefEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadTransposefEXT_ovr_0(mode, m);
    private z_MatrixLoadTransposefEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposefEXT_ovr_2(mode, m);
    
    private z_MatrixLoadTransposedEXT_adr := GetProcAddress('glMatrixLoadTransposedEXT');
    private z_MatrixLoadTransposedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixLoadTransposedEXT_adr);
    private z_MatrixLoadTransposedEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoadTransposedEXT_ovr_0(mode, m);
    private z_MatrixLoadTransposedEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposedEXT_ovr_2(mode, m);
    
    private z_MatrixMultTransposefEXT_adr := GetProcAddress('glMatrixMultTransposefEXT');
    private z_MatrixMultTransposefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixMultTransposefEXT_adr);
    private z_MatrixMultTransposefEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultTransposefEXT_ovr_0(mode, m);
    private z_MatrixMultTransposefEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposefEXT_ovr_2(mode, m);
    
    private z_MatrixMultTransposedEXT_adr := GetProcAddress('glMatrixMultTransposedEXT');
    private z_MatrixMultTransposedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixMultTransposedEXT_adr);
    private z_MatrixMultTransposedEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultTransposedEXT_ovr_0(mode, m);
    private z_MatrixMultTransposedEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposedEXT_ovr_2(mode, m);
    
    private z_NamedBufferDataEXT_adr := GetProcAddress('glNamedBufferDataEXT');
    private z_NamedBufferDataEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage)>(z_NamedBufferDataEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferDataEXT(buffer: gl_buffer; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferDataEXT_ovr_0(buffer, size, data, usage);
    
    private z_NamedBufferSubDataEXT_adr := GetProcAddress('glNamedBufferSubDataEXT');
    private z_NamedBufferSubDataEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_NamedBufferSubDataEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubDataEXT(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_NamedBufferSubDataEXT_ovr_0(buffer, offset, size, data);
    
    private z_MapNamedBufferEXT_adr := GetProcAddress('glMapNamedBufferEXT');
    private z_MapNamedBufferEXT_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer; access: BufferAccessARB): IntPtr>(z_MapNamedBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferEXT(buffer: gl_buffer; access: BufferAccessARB): IntPtr :=
    z_MapNamedBufferEXT_ovr_0(buffer, access);
    
    private z_UnmapNamedBufferEXT_adr := GetProcAddress('glUnmapNamedBufferEXT');
    private z_UnmapNamedBufferEXT_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_UnmapNamedBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapNamedBufferEXT(buffer: gl_buffer): boolean :=
    z_UnmapNamedBufferEXT_ovr_0(buffer);
    
    private z_GetNamedBufferParameterivEXT_adr := GetProcAddress('glGetNamedBufferParameterivEXT');
    private z_GetNamedBufferParameterivEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int32)>(z_GetNamedBufferParameterivEXT_adr);
    private z_GetNamedBufferParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterivEXT(buffer: gl_buffer; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameterivEXT_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameterivEXT_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterivEXT(buffer: gl_buffer; pname: BufferPNameARB; var &params: Int32) :=
    z_GetNamedBufferParameterivEXT_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameterivEXT_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterivEXT(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetNamedBufferParameterivEXT_ovr_2(buffer, pname, &params);
    
    private z_GetNamedBufferPointervEXT_adr := GetProcAddress('glGetNamedBufferPointervEXT');
    private z_GetNamedBufferPointervEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPointerNameARB; var &params: IntPtr)>(z_GetNamedBufferPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointervEXT(buffer: gl_buffer; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetNamedBufferPointervEXT_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferPointervEXT_ovr_1 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPointerNameARB; &params: pointer)>(z_GetNamedBufferPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointervEXT(buffer: gl_buffer; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetNamedBufferPointervEXT_ovr_1(buffer, pname, &params);
    
    private z_GetNamedBufferSubDataEXT_adr := GetProcAddress('glGetNamedBufferSubDataEXT');
    private z_GetNamedBufferSubDataEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetNamedBufferSubDataEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubDataEXT(buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetNamedBufferSubDataEXT_ovr_0(buffer, offset, size, data);
    
    private z_ProgramUniform1fEXT_adr := GetProcAddress('glProgramUniform1fEXT');
    private z_ProgramUniform1fEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single)>(z_ProgramUniform1fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fEXT(&program: gl_program; location: Int32; v0: single) :=
    z_ProgramUniform1fEXT_ovr_0(&program, location, v0);
    
    private z_ProgramUniform2fEXT_adr := GetProcAddress('glProgramUniform2fEXT');
    private z_ProgramUniform2fEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single)>(z_ProgramUniform2fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fEXT(&program: gl_program; location: Int32; v0: single; v1: single) :=
    z_ProgramUniform2fEXT_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform3fEXT_adr := GetProcAddress('glProgramUniform3fEXT');
    private z_ProgramUniform3fEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single; v2: single)>(z_ProgramUniform3fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fEXT(&program: gl_program; location: Int32; v0: single; v1: single; v2: single) :=
    z_ProgramUniform3fEXT_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform4fEXT_adr := GetProcAddress('glProgramUniform4fEXT');
    private z_ProgramUniform4fEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_ProgramUniform4fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fEXT(&program: gl_program; location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_ProgramUniform4fEXT_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform1iEXT_adr := GetProcAddress('glProgramUniform1iEXT');
    private z_ProgramUniform1iEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32)>(z_ProgramUniform1iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iEXT(&program: gl_program; location: Int32; v0: Int32) :=
    z_ProgramUniform1iEXT_ovr_0(&program, location, v0);
    
    private z_ProgramUniform2iEXT_adr := GetProcAddress('glProgramUniform2iEXT');
    private z_ProgramUniform2iEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32)>(z_ProgramUniform2iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iEXT(&program: gl_program; location: Int32; v0: Int32; v1: Int32) :=
    z_ProgramUniform2iEXT_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform3iEXT_adr := GetProcAddress('glProgramUniform3iEXT');
    private z_ProgramUniform3iEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_ProgramUniform3iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iEXT(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_ProgramUniform3iEXT_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform4iEXT_adr := GetProcAddress('glProgramUniform4iEXT');
    private z_ProgramUniform4iEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_ProgramUniform4iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iEXT(&program: gl_program; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_ProgramUniform4iEXT_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform1fvEXT_adr := GetProcAddress('glProgramUniform1fvEXT');
    private z_ProgramUniform1fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform1fvEXT_adr);
    private z_ProgramUniform1fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fvEXT(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fvEXT(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform1fvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform1fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1fvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2fvEXT_adr := GetProcAddress('glProgramUniform2fvEXT');
    private z_ProgramUniform2fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform2fvEXT_adr);
    private z_ProgramUniform2fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fvEXT(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fvEXT(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform2fvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform2fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2fvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3fvEXT_adr := GetProcAddress('glProgramUniform3fvEXT');
    private z_ProgramUniform3fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform3fvEXT_adr);
    private z_ProgramUniform3fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fvEXT(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fvEXT(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform3fvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform3fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3fvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4fvEXT_adr := GetProcAddress('glProgramUniform4fvEXT');
    private z_ProgramUniform4fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: single)>(z_ProgramUniform4fvEXT_adr);
    private z_ProgramUniform4fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fvEXT(&program: gl_program; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fvEXT(&program: gl_program; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform4fvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform4fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4fvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1ivEXT_adr := GetProcAddress('glProgramUniform1ivEXT');
    private z_ProgramUniform1ivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform1ivEXT_adr);
    private z_ProgramUniform1ivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ivEXT(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ivEXT(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform1ivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform1ivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2ivEXT_adr := GetProcAddress('glProgramUniform2ivEXT');
    private z_ProgramUniform2ivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform2ivEXT_adr);
    private z_ProgramUniform2ivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ivEXT(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ivEXT(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform2ivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform2ivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3ivEXT_adr := GetProcAddress('glProgramUniform3ivEXT');
    private z_ProgramUniform3ivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform3ivEXT_adr);
    private z_ProgramUniform3ivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ivEXT(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ivEXT(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform3ivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform3ivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4ivEXT_adr := GetProcAddress('glProgramUniform4ivEXT');
    private z_ProgramUniform4ivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform4ivEXT_adr);
    private z_ProgramUniform4ivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ivEXT(&program: gl_program; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ivEXT(&program: gl_program; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform4ivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform4ivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniformMatrix2fvEXT_adr := GetProcAddress('glProgramUniformMatrix2fvEXT');
    private z_ProgramUniformMatrix2fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2fvEXT_adr);
    private z_ProgramUniformMatrix2fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3fvEXT_adr := GetProcAddress('glProgramUniformMatrix3fvEXT');
    private z_ProgramUniformMatrix3fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3fvEXT_adr);
    private z_ProgramUniformMatrix3fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4fvEXT_adr := GetProcAddress('glProgramUniformMatrix4fvEXT');
    private z_ProgramUniformMatrix4fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4fvEXT_adr);
    private z_ProgramUniformMatrix4fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x3fvEXT_adr := GetProcAddress('glProgramUniformMatrix2x3fvEXT');
    private z_ProgramUniformMatrix2x3fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x3fvEXT_adr);
    private z_ProgramUniformMatrix2x3fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x3fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x2fvEXT_adr := GetProcAddress('glProgramUniformMatrix3x2fvEXT');
    private z_ProgramUniformMatrix3x2fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x2fvEXT_adr);
    private z_ProgramUniformMatrix3x2fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x2fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x4fvEXT_adr := GetProcAddress('glProgramUniformMatrix2x4fvEXT');
    private z_ProgramUniformMatrix2x4fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x4fvEXT_adr);
    private z_ProgramUniformMatrix2x4fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x4fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x2fvEXT_adr := GetProcAddress('glProgramUniformMatrix4x2fvEXT');
    private z_ProgramUniformMatrix4x2fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x2fvEXT_adr);
    private z_ProgramUniformMatrix4x2fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x2fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x4fvEXT_adr := GetProcAddress('glProgramUniformMatrix3x4fvEXT');
    private z_ProgramUniformMatrix3x4fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x4fvEXT_adr);
    private z_ProgramUniformMatrix3x4fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x4fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x3fvEXT_adr := GetProcAddress('glProgramUniformMatrix4x3fvEXT');
    private z_ProgramUniformMatrix4x3fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x3fvEXT_adr);
    private z_ProgramUniformMatrix4x3fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x3fvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_TextureBufferEXT_adr := GetProcAddress('glTextureBufferEXT');
    private z_TextureBufferEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer)>(z_TextureBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferEXT(texture: gl_texture; target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer) :=
    z_TextureBufferEXT_ovr_0(texture, target, internalformat, buffer);
    
    private z_MultiTexBufferEXT_adr := GetProcAddress('glMultiTexBufferEXT');
    private z_MultiTexBufferEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; _internalformat: InternalFormat; buffer: gl_buffer)>(z_MultiTexBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexBufferEXT(texunit: TextureUnit; target: TextureTarget; _internalformat: InternalFormat; buffer: gl_buffer) :=
    z_MultiTexBufferEXT_ovr_0(texunit, target, _internalformat, buffer);
    
    private z_TextureParameterIivEXT_adr := GetProcAddress('glTextureParameterIivEXT');
    private z_TextureParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_TextureParameterIivEXT_adr);
    private z_TextureParameterIivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterIivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterIivEXT_ovr_0(texture, target, pname, &params);
    private z_TextureParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIivEXT_ovr_2(texture, target, pname, &params);
    
    private z_TextureParameterIuivEXT_adr := GetProcAddress('glTextureParameterIuivEXT');
    private z_TextureParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: UInt32)>(z_TextureParameterIuivEXT_adr);
    private z_TextureParameterIuivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIuivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterIuivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_TextureParameterIuivEXT_ovr_0(texture, target, pname, &params);
    private z_TextureParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuivEXT(texture: gl_texture; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIuivEXT_ovr_2(texture, target, pname, &params);
    
    private z_GetTextureParameterIivEXT_adr := GetProcAddress('glGetTextureParameterIivEXT');
    private z_GetTextureParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameterIivEXT_adr);
    private z_GetTextureParameterIivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterIivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterIivEXT_ovr_0(texture, target, pname, &params);
    private z_GetTextureParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIivEXT_ovr_2(texture, target, pname, &params);
    
    private z_GetTextureParameterIuivEXT_adr := GetProcAddress('glGetTextureParameterIuivEXT');
    private z_GetTextureParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32)>(z_GetTextureParameterIuivEXT_adr);
    private z_GetTextureParameterIuivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIuivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterIuivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTextureParameterIuivEXT_ovr_0(texture, target, pname, &params);
    private z_GetTextureParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuivEXT(texture: gl_texture; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIuivEXT_ovr_2(texture, target, pname, &params);
    
    private z_MultiTexParameterIivEXT_adr := GetProcAddress('glMultiTexParameterIivEXT');
    private z_MultiTexParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_MultiTexParameterIivEXT_adr);
    private z_MultiTexParameterIivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterIivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_MultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params);
    private z_MultiTexParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterIivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_MultiTexParameterIuivEXT_adr := GetProcAddress('glMultiTexParameterIuivEXT');
    private z_MultiTexParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: UInt32)>(z_MultiTexParameterIuivEXT_adr);
    private z_MultiTexParameterIuivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterIuivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_MultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params);
    private z_MultiTexParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_MultiTexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterIuivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_GetMultiTexParameterIivEXT_adr := GetProcAddress('glGetMultiTexParameterIivEXT');
    private z_GetMultiTexParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetMultiTexParameterIivEXT_adr);
    private z_GetMultiTexParameterIivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterIivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetMultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params);
    private z_GetMultiTexParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterIivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_GetMultiTexParameterIuivEXT_adr := GetProcAddress('glGetMultiTexParameterIuivEXT');
    private z_GetMultiTexParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32)>(z_GetMultiTexParameterIuivEXT_adr);
    private z_GetMultiTexParameterIuivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterIuivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetMultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params);
    private z_GetMultiTexParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetMultiTexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterIuivEXT_ovr_2(texunit, target, pname, &params);
    
    private z_ProgramUniform1uiEXT_adr := GetProcAddress('glProgramUniform1uiEXT');
    private z_ProgramUniform1uiEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32)>(z_ProgramUniform1uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiEXT(&program: gl_program; location: Int32; v0: UInt32) :=
    z_ProgramUniform1uiEXT_ovr_0(&program, location, v0);
    
    private z_ProgramUniform2uiEXT_adr := GetProcAddress('glProgramUniform2uiEXT');
    private z_ProgramUniform2uiEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32)>(z_ProgramUniform2uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiEXT(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32) :=
    z_ProgramUniform2uiEXT_ovr_0(&program, location, v0, v1);
    
    private z_ProgramUniform3uiEXT_adr := GetProcAddress('glProgramUniform3uiEXT');
    private z_ProgramUniform3uiEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_ProgramUniform3uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiEXT(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_ProgramUniform3uiEXT_ovr_0(&program, location, v0, v1, v2);
    
    private z_ProgramUniform4uiEXT_adr := GetProcAddress('glProgramUniform4uiEXT');
    private z_ProgramUniform4uiEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_ProgramUniform4uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiEXT(&program: gl_program; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_ProgramUniform4uiEXT_ovr_0(&program, location, v0, v1, v2, v3);
    
    private z_ProgramUniform1uivEXT_adr := GetProcAddress('glProgramUniform1uivEXT');
    private z_ProgramUniform1uivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform1uivEXT_adr);
    private z_ProgramUniform1uivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uivEXT(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uivEXT(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform1uivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform1uivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1uivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2uivEXT_adr := GetProcAddress('glProgramUniform2uivEXT');
    private z_ProgramUniform2uivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform2uivEXT_adr);
    private z_ProgramUniform2uivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uivEXT(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uivEXT(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform2uivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform2uivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2uivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3uivEXT_adr := GetProcAddress('glProgramUniform3uivEXT');
    private z_ProgramUniform3uivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform3uivEXT_adr);
    private z_ProgramUniform3uivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uivEXT(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uivEXT(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform3uivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform3uivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3uivEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4uivEXT_adr := GetProcAddress('glProgramUniform4uivEXT');
    private z_ProgramUniform4uivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform4uivEXT_adr);
    private z_ProgramUniform4uivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uivEXT(&program: gl_program; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uivEXT(&program: gl_program; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform4uivEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform4uivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uivEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4uivEXT_ovr_2(&program, location, count, value);
    
    private z_NamedProgramLocalParameters4fvEXT_adr := GetProcAddress('glNamedProgramLocalParameters4fvEXT');
    private z_NamedProgramLocalParameters4fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; var &params: single)>(z_NamedProgramLocalParameters4fvEXT_adr);
    private z_NamedProgramLocalParameters4fvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_NamedProgramLocalParameters4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameters4fvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameters4fvEXT_ovr_0(&program, target, index, count, &params[0]) else
      z_NamedProgramLocalParameters4fvEXT_ovr_0_anh000001(&program, target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameters4fvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; var &params: single) :=
    z_NamedProgramLocalParameters4fvEXT_ovr_0(&program, target, index, count, &params);
    private z_NamedProgramLocalParameters4fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_NamedProgramLocalParameters4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameters4fvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_NamedProgramLocalParameters4fvEXT_ovr_2(&program, target, index, count, &params);
    
    private z_NamedProgramLocalParameterI4iEXT_adr := GetProcAddress('glNamedProgramLocalParameterI4iEXT');
    private z_NamedProgramLocalParameterI4iEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_NamedProgramLocalParameterI4iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4iEXT(&program: gl_program; target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_NamedProgramLocalParameterI4iEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private z_NamedProgramLocalParameterI4ivEXT_adr := GetProcAddress('glNamedProgramLocalParameterI4ivEXT');
    private z_NamedProgramLocalParameterI4ivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: Int32)>(z_NamedProgramLocalParameterI4ivEXT_adr);
    private z_NamedProgramLocalParameterI4ivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameterI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4ivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameterI4ivEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameterI4ivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4ivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_NamedProgramLocalParameterI4ivEXT_ovr_0(&program, target, index, &params);
    private z_NamedProgramLocalParameterI4ivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameterI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4ivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameterI4ivEXT_ovr_2(&program, target, index, &params);
    
    private z_NamedProgramLocalParametersI4ivEXT_adr := GetProcAddress('glNamedProgramLocalParametersI4ivEXT');
    private z_NamedProgramLocalParametersI4ivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32)>(z_NamedProgramLocalParametersI4ivEXT_adr);
    private z_NamedProgramLocalParametersI4ivEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_NamedProgramLocalParametersI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4ivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParametersI4ivEXT_ovr_0(&program, target, index, count, &params[0]) else
      z_NamedProgramLocalParametersI4ivEXT_ovr_0_anh000001(&program, target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4ivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32) :=
    z_NamedProgramLocalParametersI4ivEXT_ovr_0(&program, target, index, count, &params);
    private z_NamedProgramLocalParametersI4ivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_NamedProgramLocalParametersI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4ivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_NamedProgramLocalParametersI4ivEXT_ovr_2(&program, target, index, count, &params);
    
    private z_NamedProgramLocalParameterI4uiEXT_adr := GetProcAddress('glNamedProgramLocalParameterI4uiEXT');
    private z_NamedProgramLocalParameterI4uiEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_NamedProgramLocalParameterI4uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uiEXT(&program: gl_program; target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_NamedProgramLocalParameterI4uiEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private z_NamedProgramLocalParameterI4uivEXT_adr := GetProcAddress('glNamedProgramLocalParameterI4uivEXT');
    private z_NamedProgramLocalParameterI4uivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: UInt32)>(z_NamedProgramLocalParameterI4uivEXT_adr);
    private z_NamedProgramLocalParameterI4uivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameterI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameterI4uivEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameterI4uivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_NamedProgramLocalParameterI4uivEXT_ovr_0(&program, target, index, &params);
    private z_NamedProgramLocalParameterI4uivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameterI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameterI4uivEXT_ovr_2(&program, target, index, &params);
    
    private z_NamedProgramLocalParametersI4uivEXT_adr := GetProcAddress('glNamedProgramLocalParametersI4uivEXT');
    private z_NamedProgramLocalParametersI4uivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32)>(z_NamedProgramLocalParametersI4uivEXT_adr);
    private z_NamedProgramLocalParametersI4uivEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_NamedProgramLocalParametersI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4uivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParametersI4uivEXT_ovr_0(&program, target, index, count, &params[0]) else
      z_NamedProgramLocalParametersI4uivEXT_ovr_0_anh000001(&program, target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4uivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32) :=
    z_NamedProgramLocalParametersI4uivEXT_ovr_0(&program, target, index, count, &params);
    private z_NamedProgramLocalParametersI4uivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_NamedProgramLocalParametersI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4uivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_NamedProgramLocalParametersI4uivEXT_ovr_2(&program, target, index, count, &params);
    
    private z_GetNamedProgramLocalParameterIivEXT_adr := GetProcAddress('glGetNamedProgramLocalParameterIivEXT');
    private z_GetNamedProgramLocalParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: Int32)>(z_GetNamedProgramLocalParameterIivEXT_adr);
    private z_GetNamedProgramLocalParameterIivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterIivEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterIivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_GetNamedProgramLocalParameterIivEXT_ovr_0(&program, target, index, &params);
    private z_GetNamedProgramLocalParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterIivEXT_ovr_2(&program, target, index, &params);
    
    private z_GetNamedProgramLocalParameterIuivEXT_adr := GetProcAddress('glGetNamedProgramLocalParameterIuivEXT');
    private z_GetNamedProgramLocalParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: UInt32)>(z_GetNamedProgramLocalParameterIuivEXT_adr);
    private z_GetNamedProgramLocalParameterIuivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIuivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterIuivEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterIuivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIuivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_GetNamedProgramLocalParameterIuivEXT_ovr_0(&program, target, index, &params);
    private z_GetNamedProgramLocalParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIuivEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterIuivEXT_ovr_2(&program, target, index, &params);
    
    private z_EnableClientStateiEXT_adr := GetProcAddress('glEnableClientStateiEXT');
    private z_EnableClientStateiEXT_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; index: UInt32)>(z_EnableClientStateiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableClientStateiEXT(&array: EnableCap; index: UInt32) :=
    z_EnableClientStateiEXT_ovr_0(&array, index);
    
    private z_DisableClientStateiEXT_adr := GetProcAddress('glDisableClientStateiEXT');
    private z_DisableClientStateiEXT_ovr_0 := GetProcOrNil&<procedure(&array: EnableCap; index: UInt32)>(z_DisableClientStateiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableClientStateiEXT(&array: EnableCap; index: UInt32) :=
    z_DisableClientStateiEXT_ovr_0(&array, index);
    
    private z_GetFloati_vEXT_adr := GetProcAddress('glGetFloati_vEXT');
    private z_GetFloati_vEXT_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; index: UInt32; var &params: single)>(z_GetFloati_vEXT_adr);
    private z_GetFloati_vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(pname: GetPName; index: UInt32; &params: IntPtr)>(z_GetFloati_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_vEXT(pname: GetPName; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFloati_vEXT_ovr_0(pname, index, &params[0]) else
      z_GetFloati_vEXT_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_vEXT(pname: GetPName; index: UInt32; var &params: single) :=
    z_GetFloati_vEXT_ovr_0(pname, index, &params);
    private z_GetFloati_vEXT_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; index: UInt32; &params: IntPtr)>(z_GetFloati_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_vEXT(pname: GetPName; index: UInt32; &params: IntPtr) :=
    z_GetFloati_vEXT_ovr_2(pname, index, &params);
    
    private z_GetDoublei_vEXT_adr := GetProcAddress('glGetDoublei_vEXT');
    private z_GetDoublei_vEXT_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; index: UInt32; var &params: real)>(z_GetDoublei_vEXT_adr);
    private z_GetDoublei_vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(pname: GetPName; index: UInt32; &params: IntPtr)>(z_GetDoublei_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_vEXT(pname: GetPName; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetDoublei_vEXT_ovr_0(pname, index, &params[0]) else
      z_GetDoublei_vEXT_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_vEXT(pname: GetPName; index: UInt32; var &params: real) :=
    z_GetDoublei_vEXT_ovr_0(pname, index, &params);
    private z_GetDoublei_vEXT_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; index: UInt32; &params: IntPtr)>(z_GetDoublei_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_vEXT(pname: GetPName; index: UInt32; &params: IntPtr) :=
    z_GetDoublei_vEXT_ovr_2(pname, index, &params);
    
    private z_GetPointeri_vEXT_adr := GetProcAddress('glGetPointeri_vEXT');
    private z_GetPointeri_vEXT_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; index: UInt32; var &params: IntPtr)>(z_GetPointeri_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointeri_vEXT(pname: DummyEnum; index: UInt32; var &params: IntPtr) :=
    z_GetPointeri_vEXT_ovr_0(pname, index, &params);
    private z_GetPointeri_vEXT_ovr_1 := GetProcOrNil&<procedure(pname: DummyEnum; index: UInt32; &params: pointer)>(z_GetPointeri_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointeri_vEXT(pname: DummyEnum; index: UInt32; &params: pointer) :=
    z_GetPointeri_vEXT_ovr_1(pname, index, &params);
    
    private z_NamedProgramStringEXT_adr := GetProcAddress('glNamedProgramStringEXT');
    private z_NamedProgramStringEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr)>(z_NamedProgramStringEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramStringEXT(&program: gl_program; target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr) :=
    z_NamedProgramStringEXT_ovr_0(&program, target, format, len, string);
    
    private z_NamedProgramLocalParameter4dEXT_adr := GetProcAddress('glNamedProgramLocalParameter4dEXT');
    private z_NamedProgramLocalParameter4dEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real)>(z_NamedProgramLocalParameter4dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dEXT(&program: gl_program; target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_NamedProgramLocalParameter4dEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private z_NamedProgramLocalParameter4dvEXT_adr := GetProcAddress('glNamedProgramLocalParameter4dvEXT');
    private z_NamedProgramLocalParameter4dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: real)>(z_NamedProgramLocalParameter4dvEXT_adr);
    private z_NamedProgramLocalParameter4dvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameter4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameter4dvEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameter4dvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: real) :=
    z_NamedProgramLocalParameter4dvEXT_ovr_0(&program, target, index, &params);
    private z_NamedProgramLocalParameter4dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameter4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameter4dvEXT_ovr_2(&program, target, index, &params);
    
    private z_NamedProgramLocalParameter4fEXT_adr := GetProcAddress('glNamedProgramLocalParameter4fEXT');
    private z_NamedProgramLocalParameter4fEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single)>(z_NamedProgramLocalParameter4fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fEXT(&program: gl_program; target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_NamedProgramLocalParameter4fEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private z_NamedProgramLocalParameter4fvEXT_adr := GetProcAddress('glNamedProgramLocalParameter4fvEXT');
    private z_NamedProgramLocalParameter4fvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: single)>(z_NamedProgramLocalParameter4fvEXT_adr);
    private z_NamedProgramLocalParameter4fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameter4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameter4fvEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameter4fvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: single) :=
    z_NamedProgramLocalParameter4fvEXT_ovr_0(&program, target, index, &params);
    private z_NamedProgramLocalParameter4fvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_NamedProgramLocalParameter4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameter4fvEXT_ovr_2(&program, target, index, &params);
    
    private z_GetNamedProgramLocalParameterdvEXT_adr := GetProcAddress('glGetNamedProgramLocalParameterdvEXT');
    private z_GetNamedProgramLocalParameterdvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: real)>(z_GetNamedProgramLocalParameterdvEXT_adr);
    private z_GetNamedProgramLocalParameterdvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterdvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterdvEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterdvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterdvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetNamedProgramLocalParameterdvEXT_ovr_0(&program, target, index, &params);
    private z_GetNamedProgramLocalParameterdvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterdvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterdvEXT_ovr_2(&program, target, index, &params);
    
    private z_GetNamedProgramLocalParameterfvEXT_adr := GetProcAddress('glGetNamedProgramLocalParameterfvEXT');
    private z_GetNamedProgramLocalParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: single)>(z_GetNamedProgramLocalParameterfvEXT_adr);
    private z_GetNamedProgramLocalParameterfvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterfvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterfvEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterfvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterfvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetNamedProgramLocalParameterfvEXT_ovr_0(&program, target, index, &params);
    private z_GetNamedProgramLocalParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetNamedProgramLocalParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterfvEXT(&program: gl_program; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterfvEXT_ovr_2(&program, target, index, &params);
    
    private z_GetNamedProgramivEXT_adr := GetProcAddress('glGetNamedProgramivEXT');
    private z_GetNamedProgramivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32)>(z_GetNamedProgramivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramivEXT(&program: gl_program; target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetNamedProgramivEXT_ovr_0(&program, target, pname, &params);
    private z_GetNamedProgramivEXT_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetNamedProgramivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramivEXT(&program: gl_program; target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetNamedProgramivEXT_ovr_1(&program, target, pname, &params);
    
    private z_GetNamedProgramStringEXT_adr := GetProcAddress('glGetNamedProgramStringEXT');
    private z_GetNamedProgramStringEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr)>(z_GetNamedProgramStringEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramStringEXT(&program: gl_program; target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr) :=
    z_GetNamedProgramStringEXT_ovr_0(&program, target, pname, string);
    
    private z_NamedRenderbufferStorageEXT_adr := GetProcAddress('glNamedRenderbufferStorageEXT');
    private z_NamedRenderbufferStorageEXT_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageEXT(renderbuffer: gl_renderbuffer; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageEXT_ovr_0(renderbuffer, _internalformat, width, height);
    
    private z_GetNamedRenderbufferParameterivEXT_adr := GetProcAddress('glGetNamedRenderbufferParameterivEXT');
    private z_GetNamedRenderbufferParameterivEXT_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; var &params: Int32)>(z_GetNamedRenderbufferParameterivEXT_adr);
    private z_GetNamedRenderbufferParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameterivEXT(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedRenderbufferParameterivEXT_ovr_0(renderbuffer, pname, &params[0]) else
      z_GetNamedRenderbufferParameterivEXT_ovr_0_anh0001(renderbuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameterivEXT(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetNamedRenderbufferParameterivEXT_ovr_0(renderbuffer, pname, &params);
    private z_GetNamedRenderbufferParameterivEXT_ovr_2 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameterivEXT(renderbuffer: gl_renderbuffer; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetNamedRenderbufferParameterivEXT_ovr_2(renderbuffer, pname, &params);
    
    private z_NamedRenderbufferStorageMultisampleEXT_adr := GetProcAddress('glNamedRenderbufferStorageMultisampleEXT');
    private z_NamedRenderbufferStorageMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisampleEXT(renderbuffer: gl_renderbuffer; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisampleEXT_ovr_0(renderbuffer, samples, _internalformat, width, height);
    
    private z_NamedRenderbufferStorageMultisampleCoverageEXT_adr := GetProcAddress('glNamedRenderbufferStorageMultisampleCoverageEXT');
    private z_NamedRenderbufferStorageMultisampleCoverageEXT_ovr_0 := GetProcOrNil&<procedure(renderbuffer: gl_renderbuffer; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageMultisampleCoverageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisampleCoverageEXT(renderbuffer: gl_renderbuffer; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisampleCoverageEXT_ovr_0(renderbuffer, coverageSamples, colorSamples, _internalformat, width, height);
    
    private z_CheckNamedFramebufferStatusEXT_adr := GetProcAddress('glCheckNamedFramebufferStatusEXT');
    private z_CheckNamedFramebufferStatusEXT_ovr_0 := GetProcOrNil&<function(framebuffer: gl_framebuffer; target: FramebufferTarget): FramebufferStatus>(z_CheckNamedFramebufferStatusEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckNamedFramebufferStatusEXT(framebuffer: gl_framebuffer; target: FramebufferTarget): FramebufferStatus :=
    z_CheckNamedFramebufferStatusEXT_ovr_0(framebuffer, target);
    
    private z_NamedFramebufferTexture1DEXT_adr := GetProcAddress('glNamedFramebufferTexture1DEXT');
    private z_NamedFramebufferTexture1DEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_NamedFramebufferTexture1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture1DEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_NamedFramebufferTexture1DEXT_ovr_0(framebuffer, attachment, textarget, texture, level);
    
    private z_NamedFramebufferTexture2DEXT_adr := GetProcAddress('glNamedFramebufferTexture2DEXT');
    private z_NamedFramebufferTexture2DEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_NamedFramebufferTexture2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture2DEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_NamedFramebufferTexture2DEXT_ovr_0(framebuffer, attachment, textarget, texture, level);
    
    private z_NamedFramebufferTexture3DEXT_adr := GetProcAddress('glNamedFramebufferTexture3DEXT');
    private z_NamedFramebufferTexture3DEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32)>(z_NamedFramebufferTexture3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture3DEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32) :=
    z_NamedFramebufferTexture3DEXT_ovr_0(framebuffer, attachment, textarget, texture, level, zoffset);
    
    private z_NamedFramebufferRenderbufferEXT_adr := GetProcAddress('glNamedFramebufferRenderbufferEXT');
    private z_NamedFramebufferRenderbufferEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_NamedFramebufferRenderbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferRenderbufferEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_NamedFramebufferRenderbufferEXT_ovr_0(framebuffer, attachment, _renderbuffertarget, renderbuffer);
    
    private z_GetNamedFramebufferAttachmentParameterivEXT_adr := GetProcAddress('glGetNamedFramebufferAttachmentParameterivEXT');
    private z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetNamedFramebufferAttachmentParameterivEXT_adr);
    private z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameterivEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0(framebuffer, attachment, pname, &params[0]) else
      z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0_anh00001(framebuffer, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameterivEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0(framebuffer, attachment, pname, &params);
    private z_GetNamedFramebufferAttachmentParameterivEXT_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameterivEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetNamedFramebufferAttachmentParameterivEXT_ovr_2(framebuffer, attachment, pname, &params);
    
    private z_GenerateTextureMipmapEXT_adr := GetProcAddress('glGenerateTextureMipmapEXT');
    private z_GenerateTextureMipmapEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget)>(z_GenerateTextureMipmapEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateTextureMipmapEXT(texture: gl_texture; target: TextureTarget) :=
    z_GenerateTextureMipmapEXT_ovr_0(texture, target);
    
    private z_GenerateMultiTexMipmapEXT_adr := GetProcAddress('glGenerateMultiTexMipmapEXT');
    private z_GenerateMultiTexMipmapEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget)>(z_GenerateMultiTexMipmapEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMultiTexMipmapEXT(texunit: TextureUnit; target: TextureTarget) :=
    z_GenerateMultiTexMipmapEXT_ovr_0(texunit, target);
    
    private z_FramebufferDrawBufferEXT_adr := GetProcAddress('glFramebufferDrawBufferEXT');
    private z_FramebufferDrawBufferEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; mode: DrawBufferMode)>(z_FramebufferDrawBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBufferEXT(framebuffer: gl_framebuffer; mode: DrawBufferMode) :=
    z_FramebufferDrawBufferEXT_ovr_0(framebuffer, mode);
    
    private z_FramebufferDrawBuffersEXT_adr := GetProcAddress('glFramebufferDrawBuffersEXT');
    private z_FramebufferDrawBuffersEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; var bufs: DrawBufferMode)>(z_FramebufferDrawBuffersEXT_adr);
    private z_FramebufferDrawBuffersEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr)>(z_FramebufferDrawBuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBuffersEXT(framebuffer: gl_framebuffer; n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_FramebufferDrawBuffersEXT_ovr_0(framebuffer, n, bufs[0]) else
      z_FramebufferDrawBuffersEXT_ovr_0_anh0001(framebuffer, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBuffersEXT(framebuffer: gl_framebuffer; n: Int32; var bufs: DrawBufferMode) :=
    z_FramebufferDrawBuffersEXT_ovr_0(framebuffer, n, bufs);
    private z_FramebufferDrawBuffersEXT_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr)>(z_FramebufferDrawBuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBuffersEXT(framebuffer: gl_framebuffer; n: Int32; bufs: IntPtr) :=
    z_FramebufferDrawBuffersEXT_ovr_2(framebuffer, n, bufs);
    
    private z_FramebufferReadBufferEXT_adr := GetProcAddress('glFramebufferReadBufferEXT');
    private z_FramebufferReadBufferEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; mode: ReadBufferMode)>(z_FramebufferReadBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferReadBufferEXT(framebuffer: gl_framebuffer; mode: ReadBufferMode) :=
    z_FramebufferReadBufferEXT_ovr_0(framebuffer, mode);
    
    private z_GetFramebufferParameterivEXT_adr := GetProcAddress('glGetFramebufferParameterivEXT');
    private z_GetFramebufferParameterivEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var &params: Int32)>(z_GetFramebufferParameterivEXT_adr);
    private z_GetFramebufferParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: IntPtr)>(z_GetFramebufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivEXT(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params[0]) else
      z_GetFramebufferParameterivEXT_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivEXT(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var &params: Int32) :=
    z_GetFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params);
    private z_GetFramebufferParameterivEXT_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: IntPtr)>(z_GetFramebufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivEXT(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: IntPtr) :=
    z_GetFramebufferParameterivEXT_ovr_2(framebuffer, pname, &params);
    
    private z_NamedCopyBufferSubDataEXT_adr := GetProcAddress('glNamedCopyBufferSubDataEXT');
    private z_NamedCopyBufferSubDataEXT_ovr_0 := GetProcOrNil&<procedure(readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_NamedCopyBufferSubDataEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedCopyBufferSubDataEXT(readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_NamedCopyBufferSubDataEXT_ovr_0(readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    private z_NamedFramebufferTextureEXT_adr := GetProcAddress('glNamedFramebufferTextureEXT');
    private z_NamedFramebufferTextureEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32)>(z_NamedFramebufferTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32) :=
    z_NamedFramebufferTextureEXT_ovr_0(framebuffer, attachment, texture, level);
    
    private z_NamedFramebufferTextureLayerEXT_adr := GetProcAddress('glNamedFramebufferTextureLayerEXT');
    private z_NamedFramebufferTextureLayerEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_NamedFramebufferTextureLayerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureLayerEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_NamedFramebufferTextureLayerEXT_ovr_0(framebuffer, attachment, texture, level, layer);
    
    private z_NamedFramebufferTextureFaceEXT_adr := GetProcAddress('glNamedFramebufferTextureFaceEXT');
    private z_NamedFramebufferTextureFaceEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; face: TextureTarget)>(z_NamedFramebufferTextureFaceEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureFaceEXT(framebuffer: gl_framebuffer; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; face: TextureTarget) :=
    z_NamedFramebufferTextureFaceEXT_ovr_0(framebuffer, attachment, texture, level, face);
    
    private z_TextureRenderbufferEXT_adr := GetProcAddress('glTextureRenderbufferEXT');
    private z_TextureRenderbufferEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; renderbuffer: gl_renderbuffer)>(z_TextureRenderbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureRenderbufferEXT(texture: gl_texture; target: TextureTarget; renderbuffer: gl_renderbuffer) :=
    z_TextureRenderbufferEXT_ovr_0(texture, target, renderbuffer);
    
    private z_MultiTexRenderbufferEXT_adr := GetProcAddress('glMultiTexRenderbufferEXT');
    private z_MultiTexRenderbufferEXT_ovr_0 := GetProcOrNil&<procedure(texunit: TextureUnit; target: TextureTarget; renderbuffer: gl_renderbuffer)>(z_MultiTexRenderbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexRenderbufferEXT(texunit: TextureUnit; target: TextureTarget; renderbuffer: gl_renderbuffer) :=
    z_MultiTexRenderbufferEXT_ovr_0(texunit, target, renderbuffer);
    
    private z_VertexArrayVertexOffsetEXT_adr := GetProcAddress('glVertexArrayVertexOffsetEXT');
    private z_VertexArrayVertexOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: VertexPointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayVertexOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: VertexPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private z_VertexArrayColorOffsetEXT_adr := GetProcAddress('glVertexArrayColorOffsetEXT');
    private z_VertexArrayColorOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayColorOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayColorOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayColorOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private z_VertexArrayEdgeFlagOffsetEXT_adr := GetProcAddress('glVertexArrayEdgeFlagOffsetEXT');
    private z_VertexArrayEdgeFlagOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; stride: Int32; offset: IntPtr)>(z_VertexArrayEdgeFlagOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayEdgeFlagOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; stride: Int32; offset: IntPtr) :=
    z_VertexArrayEdgeFlagOffsetEXT_ovr_0(vaobj, buffer, stride, offset);
    
    private z_VertexArrayIndexOffsetEXT_adr := GetProcAddress('glVertexArrayIndexOffsetEXT');
    private z_VertexArrayIndexOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; &type: IndexPointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayIndexOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayIndexOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; &type: IndexPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayIndexOffsetEXT_ovr_0(vaobj, buffer, &type, stride, offset);
    
    private z_VertexArrayNormalOffsetEXT_adr := GetProcAddress('glVertexArrayNormalOffsetEXT');
    private z_VertexArrayNormalOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; &type: NormalPointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayNormalOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayNormalOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; &type: NormalPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayNormalOffsetEXT_ovr_0(vaobj, buffer, &type, stride, offset);
    
    private z_VertexArrayTexCoordOffsetEXT_adr := GetProcAddress('glVertexArrayTexCoordOffsetEXT');
    private z_VertexArrayTexCoordOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayTexCoordOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayTexCoordOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayTexCoordOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private z_VertexArrayMultiTexCoordOffsetEXT_adr := GetProcAddress('glVertexArrayMultiTexCoordOffsetEXT');
    private z_VertexArrayMultiTexCoordOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; texunit: DummyEnum; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayMultiTexCoordOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayMultiTexCoordOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; texunit: DummyEnum; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayMultiTexCoordOffsetEXT_ovr_0(vaobj, buffer, texunit, size, &type, stride, offset);
    
    private z_VertexArrayFogCoordOffsetEXT_adr := GetProcAddress('glVertexArrayFogCoordOffsetEXT');
    private z_VertexArrayFogCoordOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; &type: FogCoordinatePointerType; stride: Int32; offset: IntPtr)>(z_VertexArrayFogCoordOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayFogCoordOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; &type: FogCoordinatePointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayFogCoordOffsetEXT_ovr_0(vaobj, buffer, &type, stride, offset);
    
    private z_VertexArraySecondaryColorOffsetEXT_adr := GetProcAddress('glVertexArraySecondaryColorOffsetEXT');
    private z_VertexArraySecondaryColorOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr)>(z_VertexArraySecondaryColorOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArraySecondaryColorOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArraySecondaryColorOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private z_VertexArrayVertexAttribOffsetEXT_adr := GetProcAddress('glVertexArrayVertexAttribOffsetEXT');
    private z_VertexArrayVertexAttribOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; offset: IntPtr)>(z_VertexArrayVertexAttribOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexAttribOffsetEXT_ovr_0(vaobj, buffer, index, size, &type, normalized, stride, offset);
    
    private z_VertexArrayVertexAttribIOffsetEXT_adr := GetProcAddress('glVertexArrayVertexAttribIOffsetEXT');
    private z_VertexArrayVertexAttribIOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; index: UInt32; size: Int32; &type: VertexAttribType; stride: Int32; offset: IntPtr)>(z_VertexArrayVertexAttribIOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribIOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; index: UInt32; size: Int32; &type: VertexAttribType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexAttribIOffsetEXT_ovr_0(vaobj, buffer, index, size, &type, stride, offset);
    
    private z_EnableVertexArrayEXT_adr := GetProcAddress('glEnableVertexArrayEXT');
    private z_EnableVertexArrayEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; &array: EnableCap)>(z_EnableVertexArrayEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayEXT(vaobj: gl_vertex_array; &array: EnableCap) :=
    z_EnableVertexArrayEXT_ovr_0(vaobj, &array);
    
    private z_DisableVertexArrayEXT_adr := GetProcAddress('glDisableVertexArrayEXT');
    private z_DisableVertexArrayEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; &array: EnableCap)>(z_DisableVertexArrayEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayEXT(vaobj: gl_vertex_array; &array: EnableCap) :=
    z_DisableVertexArrayEXT_ovr_0(vaobj, &array);
    
    private z_EnableVertexArrayAttribEXT_adr := GetProcAddress('glEnableVertexArrayAttribEXT');
    private z_EnableVertexArrayAttribEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32)>(z_EnableVertexArrayAttribEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayAttribEXT(vaobj: gl_vertex_array; index: UInt32) :=
    z_EnableVertexArrayAttribEXT_ovr_0(vaobj, index);
    
    private z_DisableVertexArrayAttribEXT_adr := GetProcAddress('glDisableVertexArrayAttribEXT');
    private z_DisableVertexArrayAttribEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32)>(z_DisableVertexArrayAttribEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayAttribEXT(vaobj: gl_vertex_array; index: UInt32) :=
    z_DisableVertexArrayAttribEXT_ovr_0(vaobj, index);
    
    private z_GetVertexArrayIntegervEXT_adr := GetProcAddress('glGetVertexArrayIntegervEXT');
    private z_GetVertexArrayIntegervEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayIntegervEXT_adr);
    private z_GetVertexArrayIntegervEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegervEXT(vaobj: gl_vertex_array; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIntegervEXT_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayIntegervEXT_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegervEXT(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIntegervEXT_ovr_0(vaobj, pname, param);
    private z_GetVertexArrayIntegervEXT_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegervEXT(vaobj: gl_vertex_array; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIntegervEXT_ovr_2(vaobj, pname, param);
    
    private z_GetVertexArrayPointervEXT_adr := GetProcAddress('glGetVertexArrayPointervEXT');
    private z_GetVertexArrayPointervEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: IntPtr)>(z_GetVertexArrayPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointervEXT(vaobj: gl_vertex_array; pname: VertexArrayPName; var param: IntPtr) :=
    z_GetVertexArrayPointervEXT_ovr_0(vaobj, pname, param);
    private z_GetVertexArrayPointervEXT_ovr_1 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; pname: VertexArrayPName; param: pointer)>(z_GetVertexArrayPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointervEXT(vaobj: gl_vertex_array; pname: VertexArrayPName; param: pointer) :=
    z_GetVertexArrayPointervEXT_ovr_1(vaobj, pname, param);
    
    private z_GetVertexArrayIntegeri_vEXT_adr := GetProcAddress('glGetVertexArrayIntegeri_vEXT');
    private z_GetVertexArrayIntegeri_vEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayIntegeri_vEXT_adr);
    private z_GetVertexArrayIntegeri_vEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIntegeri_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegeri_vEXT(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIntegeri_vEXT_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIntegeri_vEXT_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegeri_vEXT(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIntegeri_vEXT_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIntegeri_vEXT_ovr_2 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIntegeri_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegeri_vEXT(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIntegeri_vEXT_ovr_2(vaobj, index, pname, param);
    
    private z_GetVertexArrayPointeri_vEXT_adr := GetProcAddress('glGetVertexArrayPointeri_vEXT');
    private z_GetVertexArrayPointeri_vEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: IntPtr)>(z_GetVertexArrayPointeri_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointeri_vEXT(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; var param: IntPtr) :=
    z_GetVertexArrayPointeri_vEXT_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayPointeri_vEXT_ovr_1 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: pointer)>(z_GetVertexArrayPointeri_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointeri_vEXT(vaobj: gl_vertex_array; index: UInt32; pname: VertexArrayPName; param: pointer) :=
    z_GetVertexArrayPointeri_vEXT_ovr_1(vaobj, index, pname, param);
    
    private z_MapNamedBufferRangeEXT_adr := GetProcAddress('glMapNamedBufferRangeEXT');
    private z_MapNamedBufferRangeEXT_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapNamedBufferRangeEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferRangeEXT(buffer: gl_buffer; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapNamedBufferRangeEXT_ovr_0(buffer, offset, length, access);
    
    private z_FlushMappedNamedBufferRangeEXT_adr := GetProcAddress('glFlushMappedNamedBufferRangeEXT');
    private z_FlushMappedNamedBufferRangeEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; length: IntPtr)>(z_FlushMappedNamedBufferRangeEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedNamedBufferRangeEXT(buffer: gl_buffer; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedNamedBufferRangeEXT_ovr_0(buffer, offset, length);
    
    private z_NamedBufferStorageEXT_adr := GetProcAddress('glNamedBufferStorageEXT');
    private z_NamedBufferStorageEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_NamedBufferStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorageEXT(buffer: gl_buffer; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_NamedBufferStorageEXT_ovr_0(buffer, size, data, flags);
    
    private z_ClearNamedBufferDataEXT_adr := GetProcAddress('glClearNamedBufferDataEXT');
    private z_ClearNamedBufferDataEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferDataEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferDataEXT(buffer: gl_buffer; internalformat: SizedInternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferDataEXT_ovr_0(buffer, internalformat, format, &type, data);
    
    private z_ClearNamedBufferSubDataEXT_adr := GetProcAddress('glClearNamedBufferSubDataEXT');
    private z_ClearNamedBufferSubDataEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferSubDataEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferSubDataEXT(buffer: gl_buffer; internalformat: SizedInternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferSubDataEXT_ovr_0(buffer, internalformat, offset, size, format, &type, data);
    
    private z_NamedFramebufferParameteriEXT_adr := GetProcAddress('glNamedFramebufferParameteriEXT');
    private z_NamedFramebufferParameteriEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: FramebufferParameterName; param: Int32)>(z_NamedFramebufferParameteriEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferParameteriEXT(framebuffer: gl_framebuffer; pname: FramebufferParameterName; param: Int32) :=
    z_NamedFramebufferParameteriEXT_ovr_0(framebuffer, pname, param);
    
    private z_GetNamedFramebufferParameterivEXT_adr := GetProcAddress('glGetNamedFramebufferParameterivEXT');
    private z_GetNamedFramebufferParameterivEXT_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var &params: Int32)>(z_GetNamedFramebufferParameterivEXT_adr);
    private z_GetNamedFramebufferParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: IntPtr)>(z_GetNamedFramebufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterivEXT(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params[0]) else
      z_GetNamedFramebufferParameterivEXT_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterivEXT(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; var &params: Int32) :=
    z_GetNamedFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params);
    private z_GetNamedFramebufferParameterivEXT_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: IntPtr)>(z_GetNamedFramebufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterivEXT(framebuffer: gl_framebuffer; pname: GetFramebufferParameter; &params: IntPtr) :=
    z_GetNamedFramebufferParameterivEXT_ovr_2(framebuffer, pname, &params);
    
    private z_ProgramUniform1dEXT_adr := GetProcAddress('glProgramUniform1dEXT');
    private z_ProgramUniform1dEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: real)>(z_ProgramUniform1dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dEXT(&program: gl_program; location: Int32; x: real) :=
    z_ProgramUniform1dEXT_ovr_0(&program, location, x);
    
    private z_ProgramUniform2dEXT_adr := GetProcAddress('glProgramUniform2dEXT');
    private z_ProgramUniform2dEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: real; y: real)>(z_ProgramUniform2dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dEXT(&program: gl_program; location: Int32; x: real; y: real) :=
    z_ProgramUniform2dEXT_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3dEXT_adr := GetProcAddress('glProgramUniform3dEXT');
    private z_ProgramUniform3dEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: real; y: real; z: real)>(z_ProgramUniform3dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dEXT(&program: gl_program; location: Int32; x: real; y: real; z: real) :=
    z_ProgramUniform3dEXT_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4dEXT_adr := GetProcAddress('glProgramUniform4dEXT');
    private z_ProgramUniform4dEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: real; y: real; z: real; w: real)>(z_ProgramUniform4dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dEXT(&program: gl_program; location: Int32; x: real; y: real; z: real; w: real) :=
    z_ProgramUniform4dEXT_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1dvEXT_adr := GetProcAddress('glProgramUniform1dvEXT');
    private z_ProgramUniform1dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform1dvEXT_adr);
    private z_ProgramUniform1dvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dvEXT(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dvEXT(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform1dvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform1dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1dvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2dvEXT_adr := GetProcAddress('glProgramUniform2dvEXT');
    private z_ProgramUniform2dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform2dvEXT_adr);
    private z_ProgramUniform2dvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dvEXT(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dvEXT(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform2dvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform2dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2dvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3dvEXT_adr := GetProcAddress('glProgramUniform3dvEXT');
    private z_ProgramUniform3dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform3dvEXT_adr);
    private z_ProgramUniform3dvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dvEXT(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dvEXT(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform3dvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform3dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3dvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4dvEXT_adr := GetProcAddress('glProgramUniform4dvEXT');
    private z_ProgramUniform4dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: real)>(z_ProgramUniform4dvEXT_adr);
    private z_ProgramUniform4dvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dvEXT(&program: gl_program; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dvEXT(&program: gl_program; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform4dvEXT_ovr_0(&program, location, count, value);
    private z_ProgramUniform4dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dvEXT(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4dvEXT_ovr_2(&program, location, count, value);
    
    private z_ProgramUniformMatrix2dvEXT_adr := GetProcAddress('glProgramUniformMatrix2dvEXT');
    private z_ProgramUniformMatrix2dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2dvEXT_adr);
    private z_ProgramUniformMatrix2dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3dvEXT_adr := GetProcAddress('glProgramUniformMatrix3dvEXT');
    private z_ProgramUniformMatrix3dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3dvEXT_adr);
    private z_ProgramUniformMatrix3dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4dvEXT_adr := GetProcAddress('glProgramUniformMatrix4dvEXT');
    private z_ProgramUniformMatrix4dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4dvEXT_adr);
    private z_ProgramUniformMatrix4dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x3dvEXT_adr := GetProcAddress('glProgramUniformMatrix2x3dvEXT');
    private z_ProgramUniformMatrix2x3dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x3dvEXT_adr);
    private z_ProgramUniformMatrix2x3dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x3dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix2x4dvEXT_adr := GetProcAddress('glProgramUniformMatrix2x4dvEXT');
    private z_ProgramUniformMatrix2x4dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x4dvEXT_adr);
    private z_ProgramUniformMatrix2x4dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x4dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x2dvEXT_adr := GetProcAddress('glProgramUniformMatrix3x2dvEXT');
    private z_ProgramUniformMatrix3x2dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x2dvEXT_adr);
    private z_ProgramUniformMatrix3x2dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x2dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix3x4dvEXT_adr := GetProcAddress('glProgramUniformMatrix3x4dvEXT');
    private z_ProgramUniformMatrix3x4dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x4dvEXT_adr);
    private z_ProgramUniformMatrix3x4dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x4dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x2dvEXT_adr := GetProcAddress('glProgramUniformMatrix4x2dvEXT');
    private z_ProgramUniformMatrix4x2dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x2dvEXT_adr);
    private z_ProgramUniformMatrix4x2dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x2dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_ProgramUniformMatrix4x3dvEXT_adr := GetProcAddress('glProgramUniformMatrix4x3dvEXT');
    private z_ProgramUniformMatrix4x3dvEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x3dvEXT_adr);
    private z_ProgramUniformMatrix4x3dvEXT_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x3dvEXT_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3dvEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dvEXT(&program: gl_program; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private z_TextureBufferRangeEXT_adr := GetProcAddress('glTextureBufferRangeEXT');
    private z_TextureBufferRangeEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_TextureBufferRangeEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferRangeEXT(texture: gl_texture; target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_TextureBufferRangeEXT_ovr_0(texture, target, internalformat, buffer, offset, size);
    
    private z_TextureStorage1DEXT_adr := GetProcAddress('glTextureStorage1DEXT');
    private z_TextureStorage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TextureStorage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1DEXT(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TextureStorage1DEXT_ovr_0(texture, target, levels, internalformat, width);
    
    private z_TextureStorage2DEXT_adr := GetProcAddress('glTextureStorage2DEXT');
    private z_TextureStorage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TextureStorage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DEXT(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2DEXT_ovr_0(texture, target, levels, internalformat, width, height);
    
    private z_TextureStorage3DEXT_adr := GetProcAddress('glTextureStorage3DEXT');
    private z_TextureStorage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TextureStorage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DEXT(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3DEXT_ovr_0(texture, target, levels, internalformat, width, height, depth);
    
    private z_TextureStorage2DMultisampleEXT_adr := GetProcAddress('glTextureStorage2DMultisampleEXT');
    private z_TextureStorage2DMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TextureStorage2DMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DMultisampleEXT(texture: gl_texture; target: TextureTarget; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage2DMultisampleEXT_ovr_0(texture, target, samples, internalformat, width, height, fixedsamplelocations);
    
    private z_TextureStorage3DMultisampleEXT_adr := GetProcAddress('glTextureStorage3DMultisampleEXT');
    private z_TextureStorage3DMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TextureStorage3DMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DMultisampleEXT(texture: gl_texture; target: DummyEnum; samples: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage3DMultisampleEXT_ovr_0(texture, target, samples, internalformat, width, height, depth, fixedsamplelocations);
    
    private z_VertexArrayBindVertexBufferEXT_adr := GetProcAddress('glVertexArrayBindVertexBufferEXT');
    private z_VertexArrayBindVertexBufferEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32)>(z_VertexArrayBindVertexBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayBindVertexBufferEXT(vaobj: gl_vertex_array; bindingindex: UInt32; buffer: gl_buffer; offset: IntPtr; stride: Int32) :=
    z_VertexArrayBindVertexBufferEXT_ovr_0(vaobj, bindingindex, buffer, offset, stride);
    
    private z_VertexArrayVertexAttribFormatEXT_adr := GetProcAddress('glVertexArrayVertexAttribFormatEXT');
    private z_VertexArrayVertexAttribFormatEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexArrayVertexAttribFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribFormatEXT(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexArrayVertexAttribFormatEXT_ovr_0(vaobj, attribindex, size, &type, normalized, relativeoffset);
    
    private z_VertexArrayVertexAttribIFormatEXT_adr := GetProcAddress('glVertexArrayVertexAttribIFormatEXT');
    private z_VertexArrayVertexAttribIFormatEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexArrayVertexAttribIFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribIFormatEXT(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexArrayVertexAttribIFormatEXT_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private z_VertexArrayVertexAttribLFormatEXT_adr := GetProcAddress('glVertexArrayVertexAttribLFormatEXT');
    private z_VertexArrayVertexAttribLFormatEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexArrayVertexAttribLFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribLFormatEXT(vaobj: gl_vertex_array; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexArrayVertexAttribLFormatEXT_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private z_VertexArrayVertexAttribBindingEXT_adr := GetProcAddress('glVertexArrayVertexAttribBindingEXT');
    private z_VertexArrayVertexAttribBindingEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; attribindex: UInt32; bindingindex: UInt32)>(z_VertexArrayVertexAttribBindingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribBindingEXT(vaobj: gl_vertex_array; attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexArrayVertexAttribBindingEXT_ovr_0(vaobj, attribindex, bindingindex);
    
    private z_VertexArrayVertexBindingDivisorEXT_adr := GetProcAddress('glVertexArrayVertexBindingDivisorEXT');
    private z_VertexArrayVertexBindingDivisorEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; bindingindex: UInt32; divisor: UInt32)>(z_VertexArrayVertexBindingDivisorEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBindingDivisorEXT(vaobj: gl_vertex_array; bindingindex: UInt32; divisor: UInt32) :=
    z_VertexArrayVertexBindingDivisorEXT_ovr_0(vaobj, bindingindex, divisor);
    
    private z_VertexArrayVertexAttribLOffsetEXT_adr := GetProcAddress('glVertexArrayVertexAttribLOffsetEXT');
    private z_VertexArrayVertexAttribLOffsetEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; buffer: gl_buffer; index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; offset: IntPtr)>(z_VertexArrayVertexAttribLOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribLOffsetEXT(vaobj: gl_vertex_array; buffer: gl_buffer; index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexAttribLOffsetEXT_ovr_0(vaobj, buffer, index, size, &type, stride, offset);
    
    private z_TexturePageCommitmentEXT_adr := GetProcAddress('glTexturePageCommitmentEXT');
    private z_TexturePageCommitmentEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean)>(z_TexturePageCommitmentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexturePageCommitmentEXT(texture: gl_texture; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean) :=
    z_TexturePageCommitmentEXT_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, commit);
    
    private z_VertexArrayVertexAttribDivisorEXT_adr := GetProcAddress('glVertexArrayVertexAttribDivisorEXT');
    private z_VertexArrayVertexAttribDivisorEXT_ovr_0 := GetProcOrNil&<procedure(vaobj: gl_vertex_array; index: UInt32; divisor: UInt32)>(z_VertexArrayVertexAttribDivisorEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribDivisorEXT(vaobj: gl_vertex_array; index: UInt32; divisor: UInt32) :=
    z_VertexArrayVertexAttribDivisorEXT_ovr_0(vaobj, index, divisor);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawBuffers2EXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_draw_buffers2';
    
    private z_ColorMaskIndexedEXT_adr := GetProcAddress('glColorMaskIndexedEXT');
    private z_ColorMaskIndexedEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean)>(z_ColorMaskIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMaskIndexedEXT(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean) :=
    z_ColorMaskIndexedEXT_ovr_0(index, r, g, b, a);
    
    private z_GetBooleanIndexedvEXT_adr := GetProcAddress('glGetBooleanIndexedvEXT');
    private z_GetBooleanIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; var data: boolean)>(z_GetBooleanIndexedvEXT_adr);
    private z_GetBooleanIndexedvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; data: IntPtr)>(z_GetBooleanIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTarget; index: UInt32; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleanIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetBooleanIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTarget; index: UInt32; var data: boolean) :=
    z_GetBooleanIndexedvEXT_ovr_0(target, index, data);
    private z_GetBooleanIndexedvEXT_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; data: IntPtr)>(z_GetBooleanIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTarget; index: UInt32; data: IntPtr) :=
    z_GetBooleanIndexedvEXT_ovr_2(target, index, data);
    
    private z_GetIntegerIndexedvEXT_adr := GetProcAddress('glGetIntegerIndexedvEXT');
    private z_GetIntegerIndexedvEXT_ovr_0 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; var data: Int32)>(z_GetIntegerIndexedvEXT_adr);
    private z_GetIntegerIndexedvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegerIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: GetPName; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegerIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetIntegerIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: GetPName; index: UInt32; var data: Int32) :=
    z_GetIntegerIndexedvEXT_ovr_0(target, index, data);
    private z_GetIntegerIndexedvEXT_ovr_2 := GetProcOrNil&<procedure(target: GetPName; index: UInt32; data: IntPtr)>(z_GetIntegerIndexedvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: GetPName; index: UInt32; data: IntPtr) :=
    z_GetIntegerIndexedvEXT_ovr_2(target, index, data);
    
    private z_EnableIndexedEXT_adr := GetProcAddress('glEnableIndexedEXT');
    private z_EnableIndexedEXT_ovr_0 := GetProcOrNil&<procedure(target: EnableCap; index: UInt32)>(z_EnableIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_EnableIndexedEXT_ovr_0(target, index);
    
    private z_DisableIndexedEXT_adr := GetProcAddress('glDisableIndexedEXT');
    private z_DisableIndexedEXT_ovr_0 := GetProcOrNil&<procedure(target: EnableCap; index: UInt32)>(z_DisableIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_DisableIndexedEXT_ovr_0(target, index);
    
    private z_IsEnabledIndexedEXT_adr := GetProcAddress('glIsEnabledIndexedEXT');
    private z_IsEnabledIndexedEXT_ovr_0 := GetProcOrNil&<function(target: EnableCap; index: UInt32): boolean>(z_IsEnabledIndexedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledIndexedEXT(target: EnableCap; index: UInt32): boolean :=
    z_IsEnabledIndexedEXT_ovr_0(target, index);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawInstancedEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_draw_instanced';
    
    private z_DrawArraysInstancedEXT_adr := GetProcAddress('glDrawArraysInstancedEXT');
    private z_DrawArraysInstancedEXT_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: Int32; count: Int32; primcount: Int32)>(z_DrawArraysInstancedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedEXT(mode: PrimitiveType; start: Int32; count: Int32; primcount: Int32) :=
    z_DrawArraysInstancedEXT_ovr_0(mode, start, count, primcount);
    
    private z_DrawElementsInstancedEXT_adr := GetProcAddress('glDrawElementsInstancedEXT');
    private z_DrawElementsInstancedEXT_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32)>(z_DrawElementsInstancedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedEXT(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32) :=
    z_DrawElementsInstancedEXT_ovr_0(mode, count, &type, indices, primcount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawRangeElementsEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_draw_range_elements';
    
    private z_DrawRangeElementsEXT_adr := GetProcAddress('glDrawRangeElementsEXT');
    private z_DrawRangeElementsEXT_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr)>(z_DrawRangeElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementsEXT(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr) :=
    z_DrawRangeElementsEXT_ovr_0(mode, start, &end, count, &type, indices);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glExternalBufferEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_external_buffer';
    
    private z_BufferStorageExternalEXT_adr := GetProcAddress('glBufferStorageExternalEXT');
    private z_BufferStorageExternalEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; offset: IntPtr; size: IntPtr; clientBuffer: egl_chient_buffer_EXT; flags: BufferStorageMask)>(z_BufferStorageExternalEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorageExternalEXT(target: DummyEnum; offset: IntPtr; size: IntPtr; clientBuffer: egl_chient_buffer_EXT; flags: BufferStorageMask) :=
    z_BufferStorageExternalEXT_ovr_0(target, offset, size, clientBuffer, flags);
    
    private z_NamedBufferStorageExternalEXT_adr := GetProcAddress('glNamedBufferStorageExternalEXT');
    private z_NamedBufferStorageExternalEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; clientBuffer: egl_chient_buffer_EXT; flags: BufferStorageMask)>(z_NamedBufferStorageExternalEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorageExternalEXT(buffer: gl_buffer; offset: IntPtr; size: IntPtr; clientBuffer: egl_chient_buffer_EXT; flags: BufferStorageMask) :=
    z_NamedBufferStorageExternalEXT_ovr_0(buffer, offset, size, clientBuffer, flags);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFogCoordEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_fog_coord';
    
    private z_FogCoordfEXT_adr := GetProcAddress('glFogCoordfEXT');
    private z_FogCoordfEXT_ovr_0 := GetProcOrNil&<procedure(coord: single)>(z_FogCoordfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfEXT(coord: single) :=
    z_FogCoordfEXT_ovr_0(coord);
    
    private z_FogCoordfvEXT_adr := GetProcAddress('glFogCoordfvEXT');
    private z_FogCoordfvEXT_ovr_0 := GetProcOrNil&<procedure(var coord: single)>(z_FogCoordfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfvEXT(var coord: single) :=
    z_FogCoordfvEXT_ovr_0(coord);
    private z_FogCoordfvEXT_ovr_1 := GetProcOrNil&<procedure(coord: IntPtr)>(z_FogCoordfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfvEXT(coord: IntPtr) :=
    z_FogCoordfvEXT_ovr_1(coord);
    
    private z_FogCoorddEXT_adr := GetProcAddress('glFogCoorddEXT');
    private z_FogCoorddEXT_ovr_0 := GetProcOrNil&<procedure(coord: real)>(z_FogCoorddEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddEXT(coord: real) :=
    z_FogCoorddEXT_ovr_0(coord);
    
    private z_FogCoorddvEXT_adr := GetProcAddress('glFogCoorddvEXT');
    private z_FogCoorddvEXT_ovr_0 := GetProcOrNil&<procedure(var coord: real)>(z_FogCoorddvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddvEXT(var coord: real) :=
    z_FogCoorddvEXT_ovr_0(coord);
    private z_FogCoorddvEXT_ovr_1 := GetProcOrNil&<procedure(coord: IntPtr)>(z_FogCoorddvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddvEXT(coord: IntPtr) :=
    z_FogCoorddvEXT_ovr_1(coord);
    
    private z_FogCoordPointerEXT_adr := GetProcAddress('glFogCoordPointerEXT');
    private z_FogCoordPointerEXT_ovr_0 := GetProcOrNil&<procedure(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr)>(z_FogCoordPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerEXT(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_FogCoordPointerEXT_ovr_0(&type, stride, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferBlitEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_framebuffer_blit';
    
    private z_BlitFramebufferEXT_adr := GetProcAddress('glBlitFramebufferEXT');
    private z_BlitFramebufferEXT_ovr_0 := GetProcOrNil&<procedure(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitFramebufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitFramebufferEXT(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitFramebufferEXT_ovr_0(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferMultisampleEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_framebuffer_multisample';
    
    private z_RenderbufferStorageMultisampleEXT_adr := GetProcAddress('glRenderbufferStorageMultisampleEXT');
    private z_RenderbufferStorageMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisampleEXT(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisampleEXT_ovr_0(target, samples, _internalformat, width, height);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferObjectEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_framebuffer_object';
    
    private z_IsRenderbufferEXT_adr := GetProcAddress('glIsRenderbufferEXT');
    private z_IsRenderbufferEXT_ovr_0 := GetProcOrNil&<function(renderbuffer: gl_renderbuffer): boolean>(z_IsRenderbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsRenderbufferEXT(renderbuffer: gl_renderbuffer): boolean :=
    z_IsRenderbufferEXT_ovr_0(renderbuffer);
    
    private z_BindRenderbufferEXT_adr := GetProcAddress('glBindRenderbufferEXT');
    private z_BindRenderbufferEXT_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_BindRenderbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindRenderbufferEXT(target: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_BindRenderbufferEXT_ovr_0(target, renderbuffer);
    
    private z_DeleteRenderbuffersEXT_adr := GetProcAddress('glDeleteRenderbuffersEXT');
    private z_DeleteRenderbuffersEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_DeleteRenderbuffersEXT_adr);
    private z_DeleteRenderbuffersEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffersEXT(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_DeleteRenderbuffersEXT_ovr_0(n, renderbuffers[0]) else
      z_DeleteRenderbuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffersEXT(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_DeleteRenderbuffersEXT_ovr_0(n, renderbuffers);
    private z_DeleteRenderbuffersEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffersEXT(n: Int32; renderbuffers: IntPtr) :=
    z_DeleteRenderbuffersEXT_ovr_2(n, renderbuffers);
    
    private z_GenRenderbuffersEXT_adr := GetProcAddress('glGenRenderbuffersEXT');
    private z_GenRenderbuffersEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var renderbuffers: gl_renderbuffer)>(z_GenRenderbuffersEXT_adr);
    private z_GenRenderbuffersEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffersEXT(n: Int32; renderbuffers: array of gl_renderbuffer) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_GenRenderbuffersEXT_ovr_0(n, renderbuffers[0]) else
      z_GenRenderbuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffersEXT(n: Int32; var renderbuffers: gl_renderbuffer) :=
    z_GenRenderbuffersEXT_ovr_0(n, renderbuffers);
    private z_GenRenderbuffersEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffersEXT(n: Int32; renderbuffers: IntPtr) :=
    z_GenRenderbuffersEXT_ovr_2(n, renderbuffers);
    
    private z_RenderbufferStorageEXT_adr := GetProcAddress('glRenderbufferStorageEXT');
    private z_RenderbufferStorageEXT_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageEXT(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageEXT_ovr_0(target, _internalformat, width, height);
    
    private z_GetRenderbufferParameterivEXT_adr := GetProcAddress('glGetRenderbufferParameterivEXT');
    private z_GetRenderbufferParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32)>(z_GetRenderbufferParameterivEXT_adr);
    private z_GetRenderbufferParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameterivEXT(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetRenderbufferParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetRenderbufferParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameterivEXT(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetRenderbufferParameterivEXT_ovr_0(target, pname, &params);
    private z_GetRenderbufferParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameterivEXT(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetRenderbufferParameterivEXT_ovr_2(target, pname, &params);
    
    private z_IsFramebufferEXT_adr := GetProcAddress('glIsFramebufferEXT');
    private z_IsFramebufferEXT_ovr_0 := GetProcOrNil&<function(framebuffer: gl_framebuffer): boolean>(z_IsFramebufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFramebufferEXT(framebuffer: gl_framebuffer): boolean :=
    z_IsFramebufferEXT_ovr_0(framebuffer);
    
    private z_BindFramebufferEXT_adr := GetProcAddress('glBindFramebufferEXT');
    private z_BindFramebufferEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; framebuffer: gl_framebuffer)>(z_BindFramebufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFramebufferEXT(target: FramebufferTarget; framebuffer: gl_framebuffer) :=
    z_BindFramebufferEXT_ovr_0(target, framebuffer);
    
    private z_DeleteFramebuffersEXT_adr := GetProcAddress('glDeleteFramebuffersEXT');
    private z_DeleteFramebuffersEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_DeleteFramebuffersEXT_adr);
    private z_DeleteFramebuffersEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffersEXT(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_DeleteFramebuffersEXT_ovr_0(n, framebuffers[0]) else
      z_DeleteFramebuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffersEXT(n: Int32; var framebuffers: gl_framebuffer) :=
    z_DeleteFramebuffersEXT_ovr_0(n, framebuffers);
    private z_DeleteFramebuffersEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffersEXT(n: Int32; framebuffers: IntPtr) :=
    z_DeleteFramebuffersEXT_ovr_2(n, framebuffers);
    
    private z_GenFramebuffersEXT_adr := GetProcAddress('glGenFramebuffersEXT');
    private z_GenFramebuffersEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var framebuffers: gl_framebuffer)>(z_GenFramebuffersEXT_adr);
    private z_GenFramebuffersEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffersEXT(n: Int32; framebuffers: array of gl_framebuffer) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_GenFramebuffersEXT_ovr_0(n, framebuffers[0]) else
      z_GenFramebuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffersEXT(n: Int32; var framebuffers: gl_framebuffer) :=
    z_GenFramebuffersEXT_ovr_0(n, framebuffers);
    private z_GenFramebuffersEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffersEXT(n: Int32; framebuffers: IntPtr) :=
    z_GenFramebuffersEXT_ovr_2(n, framebuffers);
    
    private z_CheckFramebufferStatusEXT_adr := GetProcAddress('glCheckFramebufferStatusEXT');
    private z_CheckFramebufferStatusEXT_ovr_0 := GetProcOrNil&<function(target: FramebufferTarget): FramebufferStatus>(z_CheckFramebufferStatusEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckFramebufferStatusEXT(target: FramebufferTarget): FramebufferStatus :=
    z_CheckFramebufferStatusEXT_ovr_0(target);
    
    private z_FramebufferTexture1DEXT_adr := GetProcAddress('glFramebufferTexture1DEXT');
    private z_FramebufferTexture1DEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_FramebufferTexture1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture1DEXT(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture1DEXT_ovr_0(target, attachment, textarget, texture, level);
    
    private z_FramebufferTexture2DEXT_adr := GetProcAddress('glFramebufferTexture2DEXT');
    private z_FramebufferTexture2DEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32)>(z_FramebufferTexture2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture2DEXT(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32) :=
    z_FramebufferTexture2DEXT_ovr_0(target, attachment, textarget, texture, level);
    
    private z_FramebufferTexture3DEXT_adr := GetProcAddress('glFramebufferTexture3DEXT');
    private z_FramebufferTexture3DEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32)>(z_FramebufferTexture3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture3DEXT(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: gl_texture; level: Int32; zoffset: Int32) :=
    z_FramebufferTexture3DEXT_ovr_0(target, attachment, textarget, texture, level, zoffset);
    
    private z_FramebufferRenderbufferEXT_adr := GetProcAddress('glFramebufferRenderbufferEXT');
    private z_FramebufferRenderbufferEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer)>(z_FramebufferRenderbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferRenderbufferEXT(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: gl_renderbuffer) :=
    z_FramebufferRenderbufferEXT_ovr_0(target, attachment, _renderbuffertarget, renderbuffer);
    
    private z_GetFramebufferAttachmentParameterivEXT_adr := GetProcAddress('glGetFramebufferAttachmentParameterivEXT');
    private z_GetFramebufferAttachmentParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferAttachmentParameterivEXT_adr);
    private z_GetFramebufferAttachmentParameterivEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameterivEXT(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferAttachmentParameterivEXT_ovr_0(target, attachment, pname, &params[0]) else
      z_GetFramebufferAttachmentParameterivEXT_ovr_0_anh00001(target, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameterivEXT(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferAttachmentParameterivEXT_ovr_0(target, attachment, pname, &params);
    private z_GetFramebufferAttachmentParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameterivEXT(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferAttachmentParameterivEXT_ovr_2(target, attachment, pname, &params);
    
    private z_GenerateMipmapEXT_adr := GetProcAddress('glGenerateMipmapEXT');
    private z_GenerateMipmapEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget)>(z_GenerateMipmapEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMipmapEXT(target: TextureTarget) :=
    z_GenerateMipmapEXT_ovr_0(target);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGeometryShader4EXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_geometry_shader4';
    
    private z_ProgramParameteriEXT_adr := GetProcAddress('glProgramParameteriEXT');
    private z_ProgramParameteriEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; pname: ProgramParameterPName; value: Int32)>(z_ProgramParameteriEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteriEXT(&program: gl_program; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteriEXT_ovr_0(&program, pname, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuProgramParametersEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_gpu_program_parameters';
    
    private z_ProgramEnvParameters4fvEXT_adr := GetProcAddress('glProgramEnvParameters4fvEXT');
    private z_ProgramEnvParameters4fvEXT_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; var &params: single)>(z_ProgramEnvParameters4fvEXT_adr);
    private z_ProgramEnvParameters4fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramEnvParameters4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameters4fvEXT_ovr_0(target, index, count, &params[0]) else
      z_ProgramEnvParameters4fvEXT_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; var &params: single) :=
    z_ProgramEnvParameters4fvEXT_ovr_0(target, index, count, &params);
    private z_ProgramEnvParameters4fvEXT_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramEnvParameters4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramEnvParameters4fvEXT_ovr_2(target, index, count, &params);
    
    private z_ProgramLocalParameters4fvEXT_adr := GetProcAddress('glProgramLocalParameters4fvEXT');
    private z_ProgramLocalParameters4fvEXT_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; var &params: single)>(z_ProgramLocalParameters4fvEXT_adr);
    private z_ProgramLocalParameters4fvEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramLocalParameters4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameters4fvEXT_ovr_0(target, index, count, &params[0]) else
      z_ProgramLocalParameters4fvEXT_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; var &params: single) :=
    z_ProgramLocalParameters4fvEXT_ovr_0(target, index, count, &params);
    private z_ProgramLocalParameters4fvEXT_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramLocalParameters4fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramLocalParameters4fvEXT_ovr_2(target, index, count, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuShader4EXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_gpu_shader4';
    
    private z_GetUniformuivEXT_adr := GetProcAddress('glGetUniformuivEXT');
    private z_GetUniformuivEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: UInt32)>(z_GetUniformuivEXT_adr);
    private z_GetUniformuivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuivEXT(&program: gl_program; location: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformuivEXT_ovr_0(&program, location, &params[0]) else
      z_GetUniformuivEXT_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuivEXT(&program: gl_program; location: Int32; var &params: UInt32) :=
    z_GetUniformuivEXT_ovr_0(&program, location, &params);
    private z_GetUniformuivEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuivEXT(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformuivEXT_ovr_2(&program, location, &params);
    
    private z_BindFragDataLocationEXT_adr := GetProcAddress('glBindFragDataLocationEXT');
    private z_BindFragDataLocationEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; color: UInt32; name: IntPtr)>(z_BindFragDataLocationEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationEXT(&program: gl_program; color: UInt32; name: string);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_BindFragDataLocationEXT_ovr_0(&program, color, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationEXT(&program: gl_program; color: UInt32; name: IntPtr) :=
    z_BindFragDataLocationEXT_ovr_0(&program, color, name);
    
    private z_GetFragDataLocationEXT_adr := GetProcAddress('glGetFragDataLocationEXT');
    private z_GetFragDataLocationEXT_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetFragDataLocationEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocationEXT(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetFragDataLocationEXT_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocationEXT(&program: gl_program; name: IntPtr): Int32 :=
    z_GetFragDataLocationEXT_ovr_0(&program, name);
    
    private z_Uniform1uiEXT_adr := GetProcAddress('glUniform1uiEXT');
    private z_Uniform1uiEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32)>(z_Uniform1uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiEXT(location: Int32; v0: UInt32) :=
    z_Uniform1uiEXT_ovr_0(location, v0);
    
    private z_Uniform2uiEXT_adr := GetProcAddress('glUniform2uiEXT');
    private z_Uniform2uiEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32)>(z_Uniform2uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiEXT(location: Int32; v0: UInt32; v1: UInt32) :=
    z_Uniform2uiEXT_ovr_0(location, v0, v1);
    
    private z_Uniform3uiEXT_adr := GetProcAddress('glUniform3uiEXT');
    private z_Uniform3uiEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_Uniform3uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiEXT(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_Uniform3uiEXT_ovr_0(location, v0, v1, v2);
    
    private z_Uniform4uiEXT_adr := GetProcAddress('glUniform4uiEXT');
    private z_Uniform4uiEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_Uniform4uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiEXT(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_Uniform4uiEXT_ovr_0(location, v0, v1, v2, v3);
    
    private z_Uniform1uivEXT_adr := GetProcAddress('glUniform1uivEXT');
    private z_Uniform1uivEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform1uivEXT_adr);
    private z_Uniform1uivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform1uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform1uivEXT_ovr_0(location, count, value);
    private z_Uniform1uivEXT_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1uivEXT_ovr_2(location, count, value);
    
    private z_Uniform2uivEXT_adr := GetProcAddress('glUniform2uivEXT');
    private z_Uniform2uivEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform2uivEXT_adr);
    private z_Uniform2uivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform2uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform2uivEXT_ovr_0(location, count, value);
    private z_Uniform2uivEXT_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2uivEXT_ovr_2(location, count, value);
    
    private z_Uniform3uivEXT_adr := GetProcAddress('glUniform3uivEXT');
    private z_Uniform3uivEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform3uivEXT_adr);
    private z_Uniform3uivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform3uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform3uivEXT_ovr_0(location, count, value);
    private z_Uniform3uivEXT_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3uivEXT_ovr_2(location, count, value);
    
    private z_Uniform4uivEXT_adr := GetProcAddress('glUniform4uivEXT');
    private z_Uniform4uivEXT_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform4uivEXT_adr);
    private z_Uniform4uivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform4uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform4uivEXT_ovr_0(location, count, value);
    private z_Uniform4uivEXT_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4uivEXT_ovr_2(location, count, value);
    
    private z_VertexAttribI1iEXT_adr := GetProcAddress('glVertexAttribI1iEXT');
    private z_VertexAttribI1iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32)>(z_VertexAttribI1iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iEXT(index: UInt32; x: Int32) :=
    z_VertexAttribI1iEXT_ovr_0(index, x);
    
    private z_VertexAttribI2iEXT_adr := GetProcAddress('glVertexAttribI2iEXT');
    private z_VertexAttribI2iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32)>(z_VertexAttribI2iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iEXT(index: UInt32; x: Int32; y: Int32) :=
    z_VertexAttribI2iEXT_ovr_0(index, x, y);
    
    private z_VertexAttribI3iEXT_adr := GetProcAddress('glVertexAttribI3iEXT');
    private z_VertexAttribI3iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32)>(z_VertexAttribI3iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iEXT(index: UInt32; x: Int32; y: Int32; z: Int32) :=
    z_VertexAttribI3iEXT_ovr_0(index, x, y, z);
    
    private z_VertexAttribI4iEXT_adr := GetProcAddress('glVertexAttribI4iEXT');
    private z_VertexAttribI4iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_VertexAttribI4iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iEXT(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexAttribI4iEXT_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribI1uiEXT_adr := GetProcAddress('glVertexAttribI1uiEXT');
    private z_VertexAttribI1uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32)>(z_VertexAttribI1uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiEXT(index: UInt32; x: UInt32) :=
    z_VertexAttribI1uiEXT_ovr_0(index, x);
    
    private z_VertexAttribI2uiEXT_adr := GetProcAddress('glVertexAttribI2uiEXT');
    private z_VertexAttribI2uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32)>(z_VertexAttribI2uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiEXT(index: UInt32; x: UInt32; y: UInt32) :=
    z_VertexAttribI2uiEXT_ovr_0(index, x, y);
    
    private z_VertexAttribI3uiEXT_adr := GetProcAddress('glVertexAttribI3uiEXT');
    private z_VertexAttribI3uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32)>(z_VertexAttribI3uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiEXT(index: UInt32; x: UInt32; y: UInt32; z: UInt32) :=
    z_VertexAttribI3uiEXT_ovr_0(index, x, y, z);
    
    private z_VertexAttribI4uiEXT_adr := GetProcAddress('glVertexAttribI4uiEXT');
    private z_VertexAttribI4uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_VertexAttribI4uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiEXT(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_VertexAttribI4uiEXT_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribI1ivEXT_adr := GetProcAddress('glVertexAttribI1ivEXT');
    private z_VertexAttribI1ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI1ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI1ivEXT_ovr_0(index, v);
    private z_VertexAttribI1ivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1ivEXT_ovr_1(index, v);
    
    private z_VertexAttribI2ivEXT_adr := GetProcAddress('glVertexAttribI2ivEXT');
    private z_VertexAttribI2ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI2ivEXT_adr);
    private z_VertexAttribI2ivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI2ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI2ivEXT_ovr_0(index, v);
    private z_VertexAttribI2ivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2ivEXT_ovr_2(index, v);
    
    private z_VertexAttribI3ivEXT_adr := GetProcAddress('glVertexAttribI3ivEXT');
    private z_VertexAttribI3ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI3ivEXT_adr);
    private z_VertexAttribI3ivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI3ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI3ivEXT_ovr_0(index, v);
    private z_VertexAttribI3ivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3ivEXT_ovr_2(index, v);
    
    private z_VertexAttribI4ivEXT_adr := GetProcAddress('glVertexAttribI4ivEXT');
    private z_VertexAttribI4ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI4ivEXT_adr);
    private z_VertexAttribI4ivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI4ivEXT_ovr_0(index, v);
    private z_VertexAttribI4ivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ivEXT_ovr_2(index, v);
    
    private z_VertexAttribI1uivEXT_adr := GetProcAddress('glVertexAttribI1uivEXT');
    private z_VertexAttribI1uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI1uivEXT_ovr_0(index, v);
    private z_VertexAttribI1uivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1uivEXT_ovr_1(index, v);
    
    private z_VertexAttribI2uivEXT_adr := GetProcAddress('glVertexAttribI2uivEXT');
    private z_VertexAttribI2uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI2uivEXT_adr);
    private z_VertexAttribI2uivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI2uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI2uivEXT_ovr_0(index, v);
    private z_VertexAttribI2uivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2uivEXT_ovr_2(index, v);
    
    private z_VertexAttribI3uivEXT_adr := GetProcAddress('glVertexAttribI3uivEXT');
    private z_VertexAttribI3uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI3uivEXT_adr);
    private z_VertexAttribI3uivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI3uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI3uivEXT_ovr_0(index, v);
    private z_VertexAttribI3uivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3uivEXT_ovr_2(index, v);
    
    private z_VertexAttribI4uivEXT_adr := GetProcAddress('glVertexAttribI4uivEXT');
    private z_VertexAttribI4uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI4uivEXT_adr);
    private z_VertexAttribI4uivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI4uivEXT_ovr_0(index, v);
    private z_VertexAttribI4uivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4uivEXT_ovr_2(index, v);
    
    private z_VertexAttribI4bvEXT_adr := GetProcAddress('glVertexAttribI4bvEXT');
    private z_VertexAttribI4bvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttribI4bvEXT_adr);
    private z_VertexAttribI4bvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4bvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4bvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; var v: SByte) :=
    z_VertexAttribI4bvEXT_ovr_0(index, v);
    private z_VertexAttribI4bvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4bvEXT_ovr_2(index, v);
    
    private z_VertexAttribI4svEXT_adr := GetProcAddress('glVertexAttribI4svEXT');
    private z_VertexAttribI4svEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttribI4svEXT_adr);
    private z_VertexAttribI4svEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4svEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4svEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; var v: Int16) :=
    z_VertexAttribI4svEXT_ovr_0(index, v);
    private z_VertexAttribI4svEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4svEXT_ovr_2(index, v);
    
    private z_VertexAttribI4ubvEXT_adr := GetProcAddress('glVertexAttribI4ubvEXT');
    private z_VertexAttribI4ubvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttribI4ubvEXT_adr);
    private z_VertexAttribI4ubvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ubvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4ubvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; var v: Byte) :=
    z_VertexAttribI4ubvEXT_ovr_0(index, v);
    private z_VertexAttribI4ubvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ubvEXT_ovr_2(index, v);
    
    private z_VertexAttribI4usvEXT_adr := GetProcAddress('glVertexAttribI4usvEXT');
    private z_VertexAttribI4usvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttribI4usvEXT_adr);
    private z_VertexAttribI4usvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4usvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4usvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; var v: UInt16) :=
    z_VertexAttribI4usvEXT_ovr_0(index, v);
    private z_VertexAttribI4usvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4usvEXT_ovr_2(index, v);
    
    private z_VertexAttribIPointerEXT_adr := GetProcAddress('glVertexAttribIPointerEXT');
    private z_VertexAttribIPointerEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32; pointer: IntPtr)>(z_VertexAttribIPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIPointerEXT(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribIPointerEXT_ovr_0(index, size, &type, stride, pointer);
    
    private z_GetVertexAttribIivEXT_adr := GetProcAddress('glGetVertexAttribIivEXT');
    private z_GetVertexAttribIivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: Int32)>(z_GetVertexAttribIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; var &params: Int32) :=
    z_GetVertexAttribIivEXT_ovr_0(index, pname, &params);
    private z_GetVertexAttribIivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIivEXT_ovr_1(index, pname, &params);
    
    private z_GetVertexAttribIuivEXT_adr := GetProcAddress('glGetVertexAttribIuivEXT');
    private z_GetVertexAttribIuivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: UInt32)>(z_GetVertexAttribIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; var &params: UInt32) :=
    z_GetVertexAttribIuivEXT_ovr_0(index, pname, &params);
    private z_GetVertexAttribIuivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIuivEXT_ovr_1(index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glHistogramEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_histogram';
    
    private z_GetHistogramEXT_adr := GetProcAddress('glGetHistogramEXT');
    private z_GetHistogramEXT_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr)>(z_GetHistogramEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramEXT(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetHistogramEXT_ovr_0(target, reset, format, &type, values);
    
    private z_GetHistogramParameterfvEXT_adr := GetProcAddress('glGetHistogramParameterfvEXT');
    private z_GetHistogramParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single)>(z_GetHistogramParameterfvEXT_adr);
    private z_GetHistogramParameterfvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfvEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfvEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single) :=
    z_GetHistogramParameterfvEXT_ovr_0(target, pname, &params);
    private z_GetHistogramParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfvEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterfvEXT_ovr_2(target, pname, &params);
    
    private z_GetHistogramParameterivEXT_adr := GetProcAddress('glGetHistogramParameterivEXT');
    private z_GetHistogramParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32)>(z_GetHistogramParameterivEXT_adr);
    private z_GetHistogramParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterivEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterivEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32) :=
    z_GetHistogramParameterivEXT_ovr_0(target, pname, &params);
    private z_GetHistogramParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterivEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterivEXT_ovr_2(target, pname, &params);
    
    private z_GetMinmaxEXT_adr := GetProcAddress('glGetMinmaxEXT');
    private z_GetMinmaxEXT_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr)>(z_GetMinmaxEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxEXT(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetMinmaxEXT_ovr_0(target, reset, format, &type, values);
    
    private z_GetMinmaxParameterfvEXT_adr := GetProcAddress('glGetMinmaxParameterfvEXT');
    private z_GetMinmaxParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single)>(z_GetMinmaxParameterfvEXT_adr);
    private z_GetMinmaxParameterfvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfvEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfvEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single) :=
    z_GetMinmaxParameterfvEXT_ovr_0(target, pname, &params);
    private z_GetMinmaxParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfvEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameterfvEXT_ovr_2(target, pname, &params);
    
    private z_GetMinmaxParameterivEXT_adr := GetProcAddress('glGetMinmaxParameterivEXT');
    private z_GetMinmaxParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32)>(z_GetMinmaxParameterivEXT_adr);
    private z_GetMinmaxParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterivEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterivEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32) :=
    z_GetMinmaxParameterivEXT_ovr_0(target, pname, &params);
    private z_GetMinmaxParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr)>(z_GetMinmaxParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterivEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameterivEXT_ovr_2(target, pname, &params);
    
    private z_HistogramEXT_adr := GetProcAddress('glHistogramEXT');
    private z_HistogramEXT_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean)>(z_HistogramEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure HistogramEXT(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean) :=
    z_HistogramEXT_ovr_0(target, width, _internalformat, sink);
    
    private z_MinmaxEXT_adr := GetProcAddress('glMinmaxEXT');
    private z_MinmaxEXT_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean)>(z_MinmaxEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MinmaxEXT(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean) :=
    z_MinmaxEXT_ovr_0(target, _internalformat, sink);
    
    private z_ResetHistogramEXT_adr := GetProcAddress('glResetHistogramEXT');
    private z_ResetHistogramEXT_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT)>(z_ResetHistogramEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetHistogramEXT(target: HistogramTargetEXT) :=
    z_ResetHistogramEXT_ovr_0(target);
    
    private z_ResetMinmaxEXT_adr := GetProcAddress('glResetMinmaxEXT');
    private z_ResetMinmaxEXT_ovr_0 := GetProcOrNil&<procedure(target: MinmaxTargetEXT)>(z_ResetMinmaxEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetMinmaxEXT(target: MinmaxTargetEXT) :=
    z_ResetMinmaxEXT_ovr_0(target);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glIndexFuncEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_index_func';
    
    private z_IndexFuncEXT_adr := GetProcAddress('glIndexFuncEXT');
    private z_IndexFuncEXT_ovr_0 := GetProcOrNil&<procedure(func: IndexFunctionEXT; ref: single)>(z_IndexFuncEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexFuncEXT(func: IndexFunctionEXT; ref: single) :=
    z_IndexFuncEXT_ovr_0(func, ref);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glIndexMaterialEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_index_material';
    
    private z_IndexMaterialEXT_adr := GetProcAddress('glIndexMaterialEXT');
    private z_IndexMaterialEXT_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; mode: IndexMaterialParameterEXT)>(z_IndexMaterialEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexMaterialEXT(face: MaterialFace; mode: IndexMaterialParameterEXT) :=
    z_IndexMaterialEXT_ovr_0(face, mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glLightTextureEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_light_texture';
    
    private z_ApplyTextureEXT_adr := GetProcAddress('glApplyTextureEXT');
    private z_ApplyTextureEXT_ovr_0 := GetProcOrNil&<procedure(mode: LightTextureModeEXT)>(z_ApplyTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ApplyTextureEXT(mode: LightTextureModeEXT) :=
    z_ApplyTextureEXT_ovr_0(mode);
    
    private z_TextureLightEXT_adr := GetProcAddress('glTextureLightEXT');
    private z_TextureLightEXT_ovr_0 := GetProcOrNil&<procedure(pname: LightTexturePNameEXT)>(z_TextureLightEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureLightEXT(pname: LightTexturePNameEXT) :=
    z_TextureLightEXT_ovr_0(pname);
    
    private z_TextureMaterialEXT_adr := GetProcAddress('glTextureMaterialEXT');
    private z_TextureMaterialEXT_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; mode: MaterialParameter)>(z_TextureMaterialEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureMaterialEXT(face: MaterialFace; mode: MaterialParameter) :=
    z_TextureMaterialEXT_ovr_0(face, mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMemoryObjectEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_memory_object';
    
    private z_GetUnsignedBytevEXT_adr := GetProcAddress('glGetUnsignedBytevEXT');
    private z_GetUnsignedBytevEXT_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: Byte)>(z_GetUnsignedBytevEXT_adr);
    private z_GetUnsignedBytevEXT_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetUnsignedBytevEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytevEXT_ovr_0(pname, data[0]) else
      z_GetUnsignedBytevEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; var data: Byte) :=
    z_GetUnsignedBytevEXT_ovr_0(pname, data);
    private z_GetUnsignedBytevEXT_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetUnsignedBytevEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: IntPtr) :=
    z_GetUnsignedBytevEXT_ovr_2(pname, data);
    
    private z_GetUnsignedBytei_vEXT_adr := GetProcAddress('glGetUnsignedBytei_vEXT');
    private z_GetUnsignedBytei_vEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; var data: Byte)>(z_GetUnsignedBytei_vEXT_adr);
    private z_GetUnsignedBytei_vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetUnsignedBytei_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytei_vEXT_ovr_0(target, index, data[0]) else
      z_GetUnsignedBytei_vEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; var data: Byte) :=
    z_GetUnsignedBytei_vEXT_ovr_0(target, index, data);
    private z_GetUnsignedBytei_vEXT_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetUnsignedBytei_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetUnsignedBytei_vEXT_ovr_2(target, index, data);
    
    private z_DeleteMemoryObjectsEXT_adr := GetProcAddress('glDeleteMemoryObjectsEXT');
    private z_DeleteMemoryObjectsEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var memoryObjects: UInt32)>(z_DeleteMemoryObjectsEXT_adr);
    private z_DeleteMemoryObjectsEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; memoryObjects: IntPtr)>(z_DeleteMemoryObjectsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteMemoryObjectsEXT(n: Int32; memoryObjects: array of UInt32) :=
    if (memoryObjects<>nil) and (memoryObjects.Length<>0) then
      z_DeleteMemoryObjectsEXT_ovr_0(n, memoryObjects[0]) else
      z_DeleteMemoryObjectsEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteMemoryObjectsEXT(n: Int32; var memoryObjects: UInt32) :=
    z_DeleteMemoryObjectsEXT_ovr_0(n, memoryObjects);
    private z_DeleteMemoryObjectsEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; memoryObjects: IntPtr)>(z_DeleteMemoryObjectsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteMemoryObjectsEXT(n: Int32; memoryObjects: IntPtr) :=
    z_DeleteMemoryObjectsEXT_ovr_2(n, memoryObjects);
    
    private z_IsMemoryObjectEXT_adr := GetProcAddress('glIsMemoryObjectEXT');
    private z_IsMemoryObjectEXT_ovr_0 := GetProcOrNil&<function(memoryObject: UInt32): boolean>(z_IsMemoryObjectEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsMemoryObjectEXT(memoryObject: UInt32): boolean :=
    z_IsMemoryObjectEXT_ovr_0(memoryObject);
    
    private z_CreateMemoryObjectsEXT_adr := GetProcAddress('glCreateMemoryObjectsEXT');
    private z_CreateMemoryObjectsEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var memoryObjects: UInt32)>(z_CreateMemoryObjectsEXT_adr);
    private z_CreateMemoryObjectsEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; memoryObjects: IntPtr)>(z_CreateMemoryObjectsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateMemoryObjectsEXT(n: Int32; memoryObjects: array of UInt32) :=
    if (memoryObjects<>nil) and (memoryObjects.Length<>0) then
      z_CreateMemoryObjectsEXT_ovr_0(n, memoryObjects[0]) else
      z_CreateMemoryObjectsEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateMemoryObjectsEXT(n: Int32; var memoryObjects: UInt32) :=
    z_CreateMemoryObjectsEXT_ovr_0(n, memoryObjects);
    private z_CreateMemoryObjectsEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; memoryObjects: IntPtr)>(z_CreateMemoryObjectsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateMemoryObjectsEXT(n: Int32; memoryObjects: IntPtr) :=
    z_CreateMemoryObjectsEXT_ovr_2(n, memoryObjects);
    
    private z_MemoryObjectParameterivEXT_adr := GetProcAddress('glMemoryObjectParameterivEXT');
    private z_MemoryObjectParameterivEXT_ovr_0 := GetProcOrNil&<procedure(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32)>(z_MemoryObjectParameterivEXT_adr);
    private z_MemoryObjectParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr)>(z_MemoryObjectParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params[0]) else
      z_MemoryObjectParameterivEXT_ovr_0_anh0001(memoryObject, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32) :=
    z_MemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params);
    private z_MemoryObjectParameterivEXT_ovr_2 := GetProcOrNil&<procedure(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr)>(z_MemoryObjectParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr) :=
    z_MemoryObjectParameterivEXT_ovr_2(memoryObject, pname, &params);
    
    private z_GetMemoryObjectParameterivEXT_adr := GetProcAddress('glGetMemoryObjectParameterivEXT');
    private z_GetMemoryObjectParameterivEXT_ovr_0 := GetProcOrNil&<procedure(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32)>(z_GetMemoryObjectParameterivEXT_adr);
    private z_GetMemoryObjectParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr)>(z_GetMemoryObjectParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params[0]) else
      z_GetMemoryObjectParameterivEXT_ovr_0_anh0001(memoryObject, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32) :=
    z_GetMemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params);
    private z_GetMemoryObjectParameterivEXT_ovr_2 := GetProcOrNil&<procedure(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr)>(z_GetMemoryObjectParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr) :=
    z_GetMemoryObjectParameterivEXT_ovr_2(memoryObject, pname, &params);
    
    private z_TexStorageMem2DEXT_adr := GetProcAddress('glTexStorageMem2DEXT');
    private z_TexStorageMem2DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; memory: UInt32; offset: UInt64)>(z_TexStorageMem2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem2DEXT(target: TextureTarget; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem2DEXT_ovr_0(target, levels, internalFormat, width, height, memory, offset);
    
    private z_TexStorageMem2DMultisampleEXT_adr := GetProcAddress('glTexStorageMem2DMultisampleEXT');
    private z_TexStorageMem2DMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64)>(z_TexStorageMem2DMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem2DMultisampleEXT(target: TextureTarget; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem2DMultisampleEXT_ovr_0(target, samples, internalFormat, width, height, fixedSampleLocations, memory, offset);
    
    private z_TexStorageMem3DEXT_adr := GetProcAddress('glTexStorageMem3DEXT');
    private z_TexStorageMem3DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64)>(z_TexStorageMem3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem3DEXT(target: TextureTarget; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem3DEXT_ovr_0(target, levels, internalFormat, width, height, depth, memory, offset);
    
    private z_TexStorageMem3DMultisampleEXT_adr := GetProcAddress('glTexStorageMem3DMultisampleEXT');
    private z_TexStorageMem3DMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64)>(z_TexStorageMem3DMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem3DMultisampleEXT(target: TextureTarget; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem3DMultisampleEXT_ovr_0(target, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset);
    
    private z_BufferStorageMemEXT_adr := GetProcAddress('glBufferStorageMemEXT');
    private z_BufferStorageMemEXT_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; size: IntPtr; memory: UInt32; offset: UInt64)>(z_BufferStorageMemEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorageMemEXT(target: BufferTarget; size: IntPtr; memory: UInt32; offset: UInt64) :=
    z_BufferStorageMemEXT_ovr_0(target, size, memory, offset);
    
    private z_TextureStorageMem2DEXT_adr := GetProcAddress('glTextureStorageMem2DEXT');
    private z_TextureStorageMem2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; memory: UInt32; offset: UInt64)>(z_TextureStorageMem2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem2DEXT(texture: gl_texture; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem2DEXT_ovr_0(texture, levels, internalFormat, width, height, memory, offset);
    
    private z_TextureStorageMem2DMultisampleEXT_adr := GetProcAddress('glTextureStorageMem2DMultisampleEXT');
    private z_TextureStorageMem2DMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64)>(z_TextureStorageMem2DMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem2DMultisampleEXT(texture: gl_texture; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem2DMultisampleEXT_ovr_0(texture, samples, internalFormat, width, height, fixedSampleLocations, memory, offset);
    
    private z_TextureStorageMem3DEXT_adr := GetProcAddress('glTextureStorageMem3DEXT');
    private z_TextureStorageMem3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64)>(z_TextureStorageMem3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem3DEXT(texture: gl_texture; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem3DEXT_ovr_0(texture, levels, internalFormat, width, height, depth, memory, offset);
    
    private z_TextureStorageMem3DMultisampleEXT_adr := GetProcAddress('glTextureStorageMem3DMultisampleEXT');
    private z_TextureStorageMem3DMultisampleEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64)>(z_TextureStorageMem3DMultisampleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem3DMultisampleEXT(texture: gl_texture; samples: Int32; internalFormat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem3DMultisampleEXT_ovr_0(texture, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset);
    
    private z_NamedBufferStorageMemEXT_adr := GetProcAddress('glNamedBufferStorageMemEXT');
    private z_NamedBufferStorageMemEXT_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; size: IntPtr; memory: UInt32; offset: UInt64)>(z_NamedBufferStorageMemEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorageMemEXT(buffer: gl_buffer; size: IntPtr; memory: UInt32; offset: UInt64) :=
    z_NamedBufferStorageMemEXT_ovr_0(buffer, size, memory, offset);
    
    private z_TexStorageMem1DEXT_adr := GetProcAddress('glTexStorageMem1DEXT');
    private z_TexStorageMem1DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; memory: UInt32; offset: UInt64)>(z_TexStorageMem1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem1DEXT(target: TextureTarget; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem1DEXT_ovr_0(target, levels, internalFormat, width, memory, offset);
    
    private z_TextureStorageMem1DEXT_adr := GetProcAddress('glTextureStorageMem1DEXT');
    private z_TextureStorageMem1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; memory: UInt32; offset: UInt64)>(z_TextureStorageMem1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem1DEXT(texture: gl_texture; levels: Int32; internalFormat: SizedInternalFormat; width: Int32; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem1DEXT_ovr_0(texture, levels, internalFormat, width, memory, offset);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMemoryObjectFdEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_memory_object_fd';
    
    private z_ImportMemoryFdEXT_adr := GetProcAddress('glImportMemoryFdEXT');
    private z_ImportMemoryFdEXT_ovr_0 := GetProcOrNil&<procedure(memory: UInt32; size: UInt64; handleType: ExternalHandleType; fd: Int32)>(z_ImportMemoryFdEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportMemoryFdEXT(memory: UInt32; size: UInt64; handleType: ExternalHandleType; fd: Int32) :=
    z_ImportMemoryFdEXT_ovr_0(memory, size, handleType, fd);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMemoryObjectWin32EXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_memory_object_win32';
    
    private z_ImportMemoryWin32HandleEXT_adr := GetProcAddress('glImportMemoryWin32HandleEXT');
    private z_ImportMemoryWin32HandleEXT_ovr_0 := GetProcOrNil&<procedure(memory: UInt32; size: UInt64; handleType: ExternalHandleType; handle: IntPtr)>(z_ImportMemoryWin32HandleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportMemoryWin32HandleEXT(memory: UInt32; size: UInt64; handleType: ExternalHandleType; handle: IntPtr) :=
    z_ImportMemoryWin32HandleEXT_ovr_0(memory, size, handleType, handle);
    
    private z_ImportMemoryWin32NameEXT_adr := GetProcAddress('glImportMemoryWin32NameEXT');
    private z_ImportMemoryWin32NameEXT_ovr_0 := GetProcOrNil&<procedure(memory: UInt32; size: UInt64; handleType: ExternalHandleType; name: IntPtr)>(z_ImportMemoryWin32NameEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportMemoryWin32NameEXT(memory: UInt32; size: UInt64; handleType: ExternalHandleType; name: IntPtr) :=
    z_ImportMemoryWin32NameEXT_ovr_0(memory, size, handleType, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultiDrawArraysEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_multi_draw_arrays';
    
    private z_MultiDrawArraysEXT_adr := GetProcAddress('glMultiDrawArraysEXT');
    private z_MultiDrawArraysEXT_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    private z_MultiDrawArraysEXT_ovr_0_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    private z_MultiDrawArraysEXT_ovr_0_anh00010 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    private z_MultiDrawArraysEXT_ovr_0_anh00110 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArraysEXT_ovr_0(mode, first[0], count[0], primcount) else
        z_MultiDrawArraysEXT_ovr_0_anh00010(mode, first[0], IntPtr.Zero, primcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArraysEXT_ovr_0_anh00100(mode, IntPtr.Zero, count[0], primcount) else
        z_MultiDrawArraysEXT_ovr_0_anh00110(mode, IntPtr.Zero, IntPtr.Zero, primcount);
    private z_MultiDrawArraysEXT_ovr_1_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArraysEXT_ovr_0(mode, first[0], count, primcount) else
      z_MultiDrawArraysEXT_ovr_0_anh00100(mode, IntPtr.Zero, count, primcount);
    private z_MultiDrawArraysEXT_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    private z_MultiDrawArraysEXT_ovr_2_anh00100 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArraysEXT_ovr_2(mode, first[0], count, primcount) else
      z_MultiDrawArraysEXT_ovr_2_anh00100(mode, IntPtr.Zero, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArraysEXT_ovr_0(mode, first, count[0], primcount) else
      z_MultiDrawArraysEXT_ovr_0_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_0(mode, first, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_2(mode, first, count, primcount);
    private z_MultiDrawArraysEXT_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    private z_MultiDrawArraysEXT_ovr_6_anh00010 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArraysEXT_ovr_6(mode, first, count[0], primcount) else
      z_MultiDrawArraysEXT_ovr_6_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_6(mode, first, count, primcount);
    private z_MultiDrawArraysEXT_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32)>(z_MultiDrawArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_8(mode, first, count, primcount);
    
    private z_MultiDrawElementsEXT_adr := GetProcAddress('glMultiDrawElementsEXT');
    private z_MultiDrawElementsEXT_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    private z_MultiDrawElementsEXT_ovr_0_anh001000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    private z_MultiDrawElementsEXT_ovr_0_anh000010 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    private z_MultiDrawElementsEXT_ovr_0_anh001010 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsEXT_ovr_0(mode, count[0], &type, indices[0], primcount) else
        z_MultiDrawElementsEXT_ovr_0_anh000010(mode, count[0], &type, IntPtr.Zero, primcount) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsEXT_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices[0], primcount) else
        z_MultiDrawElementsEXT_ovr_0_anh001010(mode, IntPtr.Zero, &type, IntPtr.Zero, primcount);
    private z_MultiDrawElementsEXT_ovr_1_anh001000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsEXT_ovr_0(mode, count[0], &type, indices, primcount) else
      z_MultiDrawElementsEXT_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices, primcount);
    private z_MultiDrawElementsEXT_ovr_2 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    private z_MultiDrawElementsEXT_ovr_2_anh001000 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsEXT_ovr_2(mode, count[0], &type, indices, primcount) else
      z_MultiDrawElementsEXT_ovr_2_anh001000(mode, IntPtr.Zero, &type, indices, primcount);
    private z_MultiDrawElementsEXT_ovr_3_anh000010 := GetProcOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsEXT_ovr_0(mode, count, &type, indices[0], primcount) else
      z_MultiDrawElementsEXT_ovr_0_anh000010(mode, count, &type, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_0(mode, count, &type, indices, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_2(mode, count, &type, indices, primcount);
    private z_MultiDrawElementsEXT_ovr_6 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    private z_MultiDrawElementsEXT_ovr_6_anh000010 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsEXT_ovr_6(mode, count, &type, indices[0], primcount) else
      z_MultiDrawElementsEXT_ovr_6_anh000010(mode, count, &type, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_6(mode, count, &type, indices, primcount);
    private z_MultiDrawElementsEXT_ovr_8 := GetProcOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32)>(z_MultiDrawElementsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_8(mode, count, &type, indices, primcount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultisampleEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_multisample';
    
    private z_SampleMaskEXT_adr := GetProcAddress('glSampleMaskEXT');
    private z_SampleMaskEXT_ovr_0 := GetProcOrNil&<procedure(value: single; invert: boolean)>(z_SampleMaskEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaskEXT(value: single; invert: boolean) :=
    z_SampleMaskEXT_ovr_0(value, invert);
    
    private z_SamplePatternEXT_adr := GetProcAddress('glSamplePatternEXT');
    private z_SamplePatternEXT_ovr_0 := GetProcOrNil&<procedure(pattern: OpenGL.SamplePatternEXT)>(z_SamplePatternEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplePatternEXT(pattern: OpenGL.SamplePatternEXT) :=
    z_SamplePatternEXT_ovr_0(pattern);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPalettedTextureEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_paletted_texture';
    
    private z_ColorTableEXT_adr := GetProcAddress('glColorTableEXT');
    private z_ColorTableEXT_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; _internalFormat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr)>(z_ColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableEXT(target: ColorTableTarget; _internalFormat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_ColorTableEXT_ovr_0(target, _internalFormat, width, format, &type, table);
    
    private z_GetColorTableEXT_adr := GetProcAddress('glGetColorTableEXT');
    private z_GetColorTableEXT_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_GetColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableEXT(target: ColorTableTarget; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_GetColorTableEXT_ovr_0(target, format, &type, data);
    
    private z_GetColorTableParameterivEXT_adr := GetProcAddress('glGetColorTableParameterivEXT');
    private z_GetColorTableParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32)>(z_GetColorTableParameterivEXT_adr);
    private z_GetColorTableParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32) :=
    z_GetColorTableParameterivEXT_ovr_0(target, pname, &params);
    private z_GetColorTableParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterivEXT_ovr_2(target, pname, &params);
    
    private z_GetColorTableParameterfvEXT_adr := GetProcAddress('glGetColorTableParameterfvEXT');
    private z_GetColorTableParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single)>(z_GetColorTableParameterfvEXT_adr);
    private z_GetColorTableParameterfvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single) :=
    z_GetColorTableParameterfvEXT_ovr_0(target, pname, &params);
    private z_GetColorTableParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterfvEXT_ovr_2(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPixelTransformEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_pixel_transform';
    
    private z_PixelTransformParameteriEXT_adr := GetProcAddress('glPixelTransformParameteriEXT');
    private z_PixelTransformParameteriEXT_ovr_0 := GetProcOrNil&<procedure(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: Int32)>(z_PixelTransformParameteriEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameteriEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: Int32) :=
    z_PixelTransformParameteriEXT_ovr_0(target, pname, param);
    
    private z_PixelTransformParameterfEXT_adr := GetProcAddress('glPixelTransformParameterfEXT');
    private z_PixelTransformParameterfEXT_ovr_0 := GetProcOrNil&<procedure(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: single)>(z_PixelTransformParameterfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: single) :=
    z_PixelTransformParameterfEXT_ovr_0(target, pname, param);
    
    private z_PixelTransformParameterivEXT_adr := GetProcAddress('glPixelTransformParameterivEXT');
    private z_PixelTransformParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: Int32)>(z_PixelTransformParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterivEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: Int32) :=
    z_PixelTransformParameterivEXT_ovr_0(target, pname, &params);
    private z_PixelTransformParameterivEXT_ovr_1 := GetProcOrNil&<procedure(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr)>(z_PixelTransformParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterivEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr) :=
    z_PixelTransformParameterivEXT_ovr_1(target, pname, &params);
    
    private z_PixelTransformParameterfvEXT_adr := GetProcAddress('glPixelTransformParameterfvEXT');
    private z_PixelTransformParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: single)>(z_PixelTransformParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfvEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: single) :=
    z_PixelTransformParameterfvEXT_ovr_0(target, pname, &params);
    private z_PixelTransformParameterfvEXT_ovr_1 := GetProcOrNil&<procedure(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr)>(z_PixelTransformParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfvEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr) :=
    z_PixelTransformParameterfvEXT_ovr_1(target, pname, &params);
    
    private z_GetPixelTransformParameterivEXT_adr := GetProcAddress('glGetPixelTransformParameterivEXT');
    private z_GetPixelTransformParameterivEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; var &params: Int32)>(z_GetPixelTransformParameterivEXT_adr);
    private z_GetPixelTransformParameterivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: IntPtr)>(z_GetPixelTransformParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterivEXT(target: DummyEnum; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTransformParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetPixelTransformParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterivEXT(target: DummyEnum; pname: DummyEnum; var &params: Int32) :=
    z_GetPixelTransformParameterivEXT_ovr_0(target, pname, &params);
    private z_GetPixelTransformParameterivEXT_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: IntPtr)>(z_GetPixelTransformParameterivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterivEXT(target: DummyEnum; pname: DummyEnum; &params: IntPtr) :=
    z_GetPixelTransformParameterivEXT_ovr_2(target, pname, &params);
    
    private z_GetPixelTransformParameterfvEXT_adr := GetProcAddress('glGetPixelTransformParameterfvEXT');
    private z_GetPixelTransformParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; var &params: single)>(z_GetPixelTransformParameterfvEXT_adr);
    private z_GetPixelTransformParameterfvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: IntPtr)>(z_GetPixelTransformParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterfvEXT(target: DummyEnum; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTransformParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetPixelTransformParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterfvEXT(target: DummyEnum; pname: DummyEnum; var &params: single) :=
    z_GetPixelTransformParameterfvEXT_ovr_0(target, pname, &params);
    private z_GetPixelTransformParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: IntPtr)>(z_GetPixelTransformParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterfvEXT(target: DummyEnum; pname: DummyEnum; &params: IntPtr) :=
    z_GetPixelTransformParameterfvEXT_ovr_2(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPointParametersEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_point_parameters';
    
    private z_PointParameterfEXT_adr := GetProcAddress('glPointParameterfEXT');
    private z_PointParameterfEXT_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; param: single)>(z_PointParameterfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfEXT(pname: PointParameterNameARB; param: single) :=
    z_PointParameterfEXT_ovr_0(pname, param);
    
    private z_PointParameterfvEXT_adr := GetProcAddress('glPointParameterfvEXT');
    private z_PointParameterfvEXT_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: single)>(z_PointParameterfvEXT_adr);
    private z_PointParameterfvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvEXT(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfvEXT_ovr_0(pname, &params[0]) else
      z_PointParameterfvEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvEXT(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfvEXT_ovr_0(pname, &params);
    private z_PointParameterfvEXT_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvEXT(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfvEXT_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPolygonOffsetEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_polygon_offset';
    
    private z_PolygonOffsetEXT_adr := GetProcAddress('glPolygonOffsetEXT');
    private z_PolygonOffsetEXT_ovr_0 := GetProcOrNil&<procedure(factor: single; bias: single)>(z_PolygonOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetEXT(factor: single; bias: single) :=
    z_PolygonOffsetEXT_ovr_0(factor, bias);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPolygonOffsetClampEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_polygon_offset_clamp';
    
    private z_PolygonOffsetClampEXT_adr := GetProcAddress('glPolygonOffsetClampEXT');
    private z_PolygonOffsetClampEXT_ovr_0 := GetProcOrNil&<procedure(factor: single; units: single; clamp: single)>(z_PolygonOffsetClampEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetClampEXT(factor: single; units: single; clamp: single) :=
    z_PolygonOffsetClampEXT_ovr_0(factor, units, clamp);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glProvokingVertexEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_provoking_vertex';
    
    private z_ProvokingVertexEXT_adr := GetProcAddress('glProvokingVertexEXT');
    private z_ProvokingVertexEXT_ovr_0 := GetProcOrNil&<procedure(mode: VertexProvokingMode)>(z_ProvokingVertexEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProvokingVertexEXT(mode: VertexProvokingMode) :=
    z_ProvokingVertexEXT_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glRasterMultisampleEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_raster_multisample';
    
    private z_RasterSamplesEXT_adr := GetProcAddress('glRasterSamplesEXT');
    private z_RasterSamplesEXT_ovr_0 := GetProcOrNil&<procedure(samples: UInt32; fixedsamplelocations: boolean)>(z_RasterSamplesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterSamplesEXT(samples: UInt32; fixedsamplelocations: boolean) :=
    z_RasterSamplesEXT_ovr_0(samples, fixedsamplelocations);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSemaphoreEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_semaphore';
    
    private z_GetUnsignedBytevEXT_adr := GetProcAddress('glGetUnsignedBytevEXT');
    private z_GetUnsignedBytevEXT_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var data: Byte)>(z_GetUnsignedBytevEXT_adr);
    private z_GetUnsignedBytevEXT_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetUnsignedBytevEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytevEXT_ovr_0(pname, data[0]) else
      z_GetUnsignedBytevEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; var data: Byte) :=
    z_GetUnsignedBytevEXT_ovr_0(pname, data);
    private z_GetUnsignedBytevEXT_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetUnsignedBytevEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: IntPtr) :=
    z_GetUnsignedBytevEXT_ovr_2(pname, data);
    
    private z_GetUnsignedBytei_vEXT_adr := GetProcAddress('glGetUnsignedBytei_vEXT');
    private z_GetUnsignedBytei_vEXT_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; var data: Byte)>(z_GetUnsignedBytei_vEXT_adr);
    private z_GetUnsignedBytei_vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetUnsignedBytei_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytei_vEXT_ovr_0(target, index, data[0]) else
      z_GetUnsignedBytei_vEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; var data: Byte) :=
    z_GetUnsignedBytei_vEXT_ovr_0(target, index, data);
    private z_GetUnsignedBytei_vEXT_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetUnsignedBytei_vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetUnsignedBytei_vEXT_ovr_2(target, index, data);
    
    private z_GenSemaphoresEXT_adr := GetProcAddress('glGenSemaphoresEXT');
    private z_GenSemaphoresEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var semaphores: UInt32)>(z_GenSemaphoresEXT_adr);
    private z_GenSemaphoresEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; semaphores: IntPtr)>(z_GenSemaphoresEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSemaphoresEXT(n: Int32; semaphores: array of UInt32) :=
    if (semaphores<>nil) and (semaphores.Length<>0) then
      z_GenSemaphoresEXT_ovr_0(n, semaphores[0]) else
      z_GenSemaphoresEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSemaphoresEXT(n: Int32; var semaphores: UInt32) :=
    z_GenSemaphoresEXT_ovr_0(n, semaphores);
    private z_GenSemaphoresEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; semaphores: IntPtr)>(z_GenSemaphoresEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSemaphoresEXT(n: Int32; semaphores: IntPtr) :=
    z_GenSemaphoresEXT_ovr_2(n, semaphores);
    
    private z_DeleteSemaphoresEXT_adr := GetProcAddress('glDeleteSemaphoresEXT');
    private z_DeleteSemaphoresEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var semaphores: UInt32)>(z_DeleteSemaphoresEXT_adr);
    private z_DeleteSemaphoresEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; semaphores: IntPtr)>(z_DeleteSemaphoresEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSemaphoresEXT(n: Int32; semaphores: array of UInt32) :=
    if (semaphores<>nil) and (semaphores.Length<>0) then
      z_DeleteSemaphoresEXT_ovr_0(n, semaphores[0]) else
      z_DeleteSemaphoresEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSemaphoresEXT(n: Int32; var semaphores: UInt32) :=
    z_DeleteSemaphoresEXT_ovr_0(n, semaphores);
    private z_DeleteSemaphoresEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; semaphores: IntPtr)>(z_DeleteSemaphoresEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSemaphoresEXT(n: Int32; semaphores: IntPtr) :=
    z_DeleteSemaphoresEXT_ovr_2(n, semaphores);
    
    private z_IsSemaphoreEXT_adr := GetProcAddress('glIsSemaphoreEXT');
    private z_IsSemaphoreEXT_ovr_0 := GetProcOrNil&<function(semaphore: UInt32): boolean>(z_IsSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSemaphoreEXT(semaphore: UInt32): boolean :=
    z_IsSemaphoreEXT_ovr_0(semaphore);
    
    private z_SemaphoreParameterui64vEXT_adr := GetProcAddress('glSemaphoreParameterui64vEXT');
    private z_SemaphoreParameterui64vEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64)>(z_SemaphoreParameterui64vEXT_adr);
    private z_SemaphoreParameterui64vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_SemaphoreParameterui64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params[0]) else
      z_SemaphoreParameterui64vEXT_ovr_0_anh0001(semaphore, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64) :=
    z_SemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params);
    private z_SemaphoreParameterui64vEXT_ovr_2 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_SemaphoreParameterui64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr) :=
    z_SemaphoreParameterui64vEXT_ovr_2(semaphore, pname, &params);
    
    private z_GetSemaphoreParameterui64vEXT_adr := GetProcAddress('glGetSemaphoreParameterui64vEXT');
    private z_GetSemaphoreParameterui64vEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64)>(z_GetSemaphoreParameterui64vEXT_adr);
    private z_GetSemaphoreParameterui64vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_GetSemaphoreParameterui64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params[0]) else
      z_GetSemaphoreParameterui64vEXT_ovr_0_anh0001(semaphore, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64) :=
    z_GetSemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params);
    private z_GetSemaphoreParameterui64vEXT_ovr_2 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_GetSemaphoreParameterui64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr) :=
    z_GetSemaphoreParameterui64vEXT_ovr_2(semaphore, pname, &params);
    
    private z_WaitSemaphoreEXT_adr := GetProcAddress('glWaitSemaphoreEXT');
    private z_WaitSemaphoreEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0001010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0001001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0000011 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_0_anh0001011 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; srcLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], IntPtr.Zero) else
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, IntPtr.Zero) else
      if (textures<>nil) and (textures.Length<>0) then
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], IntPtr.Zero) else
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0001011(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private z_WaitSemaphoreEXT_ovr_1_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_1_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_1_anh0001010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; var srcLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, srcLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_2 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_2_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_2_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_2_anh0001010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; srcLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, srcLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_2_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_3_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_3_anh0001001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private z_WaitSemaphoreEXT_ovr_4_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_5_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_6 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_6_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_6_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_6_anh0001001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_6_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private z_WaitSemaphoreEXT_ovr_7_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_8 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_8_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_8_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; srcLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; var srcLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; srcLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_18 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_18_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_18_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_18_anh0000011 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of gl_texture; srcLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_18_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private z_WaitSemaphoreEXT_ovr_19_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of gl_texture; var srcLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_20 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_20_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of gl_texture; srcLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_20_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_24 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout)>(z_WaitSemaphoreEXT_adr);
    private z_WaitSemaphoreEXT_ovr_24_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_24_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    private z_WaitSemaphoreEXT_ovr_26 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr)>(z_WaitSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_26(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    
    private z_SignalSemaphoreEXT_adr := GetProcAddress('glSignalSemaphoreEXT');
    private z_SignalSemaphoreEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0001010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0001001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0000011 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_0_anh0001011 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; dstLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], IntPtr.Zero) else
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, IntPtr.Zero) else
      if (textures<>nil) and (textures.Length<>0) then
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], IntPtr.Zero) else
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0001011(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private z_SignalSemaphoreEXT_ovr_1_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_1_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_1_anh0001010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; var dstLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, dstLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_2 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_2_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_2_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_2_anh0001010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; dstLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, dstLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_2_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_3_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_3_anh0001001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private z_SignalSemaphoreEXT_ovr_4_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_5_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_6 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_6_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_6_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_6_anh0001001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_6_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private z_SignalSemaphoreEXT_ovr_7_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_8 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_8_anh0001000 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_8_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; dstLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; var dstLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: array of gl_texture; dstLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: gl_buffer; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_18 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_18_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_18_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_18_anh0000011 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of gl_texture; dstLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_18_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private z_SignalSemaphoreEXT_ovr_19_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of gl_texture; var dstLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_20 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_20_anh0000010 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of gl_texture; dstLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_20_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: gl_texture; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_24 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout)>(z_SignalSemaphoreEXT_adr);
    private z_SignalSemaphoreEXT_ovr_24_anh0000001 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_24_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    private z_SignalSemaphoreEXT_ovr_26 := GetProcOrNil&<procedure(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr)>(z_SignalSemaphoreEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_26(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSemaphoreFdEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_semaphore_fd';
    
    private z_ImportSemaphoreFdEXT_adr := GetProcAddress('glImportSemaphoreFdEXT');
    private z_ImportSemaphoreFdEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; handleType: ExternalHandleType; fd: Int32)>(z_ImportSemaphoreFdEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportSemaphoreFdEXT(semaphore: UInt32; handleType: ExternalHandleType; fd: Int32) :=
    z_ImportSemaphoreFdEXT_ovr_0(semaphore, handleType, fd);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSemaphoreWin32EXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_semaphore_win32';
    
    private z_ImportSemaphoreWin32HandleEXT_adr := GetProcAddress('glImportSemaphoreWin32HandleEXT');
    private z_ImportSemaphoreWin32HandleEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; handleType: ExternalHandleType; handle: IntPtr)>(z_ImportSemaphoreWin32HandleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportSemaphoreWin32HandleEXT(semaphore: UInt32; handleType: ExternalHandleType; handle: IntPtr) :=
    z_ImportSemaphoreWin32HandleEXT_ovr_0(semaphore, handleType, handle);
    
    private z_ImportSemaphoreWin32NameEXT_adr := GetProcAddress('glImportSemaphoreWin32NameEXT');
    private z_ImportSemaphoreWin32NameEXT_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; handleType: ExternalHandleType; name: IntPtr)>(z_ImportSemaphoreWin32NameEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportSemaphoreWin32NameEXT(semaphore: UInt32; handleType: ExternalHandleType; name: IntPtr) :=
    z_ImportSemaphoreWin32NameEXT_ovr_0(semaphore, handleType, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSecondaryColorEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_secondary_color';
    
    private z_SecondaryColor3bEXT_adr := GetProcAddress('glSecondaryColor3bEXT');
    private z_SecondaryColor3bEXT_ovr_0 := GetProcOrNil&<procedure(red: SByte; green: SByte; blue: SByte)>(z_SecondaryColor3bEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bEXT(red: SByte; green: SByte; blue: SByte) :=
    z_SecondaryColor3bEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3bvEXT_adr := GetProcAddress('glSecondaryColor3bvEXT');
    private z_SecondaryColor3bvEXT_ovr_0 := GetProcOrNil&<procedure(var v: SByte)>(z_SecondaryColor3bvEXT_adr);
    private z_SecondaryColor3bvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bvEXT(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3bvEXT_ovr_0(v[0]) else
      z_SecondaryColor3bvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bvEXT(var v: SByte) :=
    z_SecondaryColor3bvEXT_ovr_0(v);
    private z_SecondaryColor3bvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bvEXT(v: IntPtr) :=
    z_SecondaryColor3bvEXT_ovr_2(v);
    
    private z_SecondaryColor3dEXT_adr := GetProcAddress('glSecondaryColor3dEXT');
    private z_SecondaryColor3dEXT_ovr_0 := GetProcOrNil&<procedure(red: real; green: real; blue: real)>(z_SecondaryColor3dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dEXT(red: real; green: real; blue: real) :=
    z_SecondaryColor3dEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3dvEXT_adr := GetProcAddress('glSecondaryColor3dvEXT');
    private z_SecondaryColor3dvEXT_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_SecondaryColor3dvEXT_adr);
    private z_SecondaryColor3dvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dvEXT(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3dvEXT_ovr_0(v[0]) else
      z_SecondaryColor3dvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dvEXT(var v: real) :=
    z_SecondaryColor3dvEXT_ovr_0(v);
    private z_SecondaryColor3dvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dvEXT(v: IntPtr) :=
    z_SecondaryColor3dvEXT_ovr_2(v);
    
    private z_SecondaryColor3fEXT_adr := GetProcAddress('glSecondaryColor3fEXT');
    private z_SecondaryColor3fEXT_ovr_0 := GetProcOrNil&<procedure(red: single; green: single; blue: single)>(z_SecondaryColor3fEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fEXT(red: single; green: single; blue: single) :=
    z_SecondaryColor3fEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3fvEXT_adr := GetProcAddress('glSecondaryColor3fvEXT');
    private z_SecondaryColor3fvEXT_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_SecondaryColor3fvEXT_adr);
    private z_SecondaryColor3fvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fvEXT(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3fvEXT_ovr_0(v[0]) else
      z_SecondaryColor3fvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fvEXT(var v: single) :=
    z_SecondaryColor3fvEXT_ovr_0(v);
    private z_SecondaryColor3fvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3fvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fvEXT(v: IntPtr) :=
    z_SecondaryColor3fvEXT_ovr_2(v);
    
    private z_SecondaryColor3iEXT_adr := GetProcAddress('glSecondaryColor3iEXT');
    private z_SecondaryColor3iEXT_ovr_0 := GetProcOrNil&<procedure(red: Int32; green: Int32; blue: Int32)>(z_SecondaryColor3iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iEXT(red: Int32; green: Int32; blue: Int32) :=
    z_SecondaryColor3iEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3ivEXT_adr := GetProcAddress('glSecondaryColor3ivEXT');
    private z_SecondaryColor3ivEXT_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_SecondaryColor3ivEXT_adr);
    private z_SecondaryColor3ivEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ivEXT(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3ivEXT_ovr_0(v[0]) else
      z_SecondaryColor3ivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ivEXT(var v: Int32) :=
    z_SecondaryColor3ivEXT_ovr_0(v);
    private z_SecondaryColor3ivEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ivEXT(v: IntPtr) :=
    z_SecondaryColor3ivEXT_ovr_2(v);
    
    private z_SecondaryColor3sEXT_adr := GetProcAddress('glSecondaryColor3sEXT');
    private z_SecondaryColor3sEXT_ovr_0 := GetProcOrNil&<procedure(red: Int16; green: Int16; blue: Int16)>(z_SecondaryColor3sEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sEXT(red: Int16; green: Int16; blue: Int16) :=
    z_SecondaryColor3sEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3svEXT_adr := GetProcAddress('glSecondaryColor3svEXT');
    private z_SecondaryColor3svEXT_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_SecondaryColor3svEXT_adr);
    private z_SecondaryColor3svEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3svEXT(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3svEXT_ovr_0(v[0]) else
      z_SecondaryColor3svEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3svEXT(var v: Int16) :=
    z_SecondaryColor3svEXT_ovr_0(v);
    private z_SecondaryColor3svEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3svEXT(v: IntPtr) :=
    z_SecondaryColor3svEXT_ovr_2(v);
    
    private z_SecondaryColor3ubEXT_adr := GetProcAddress('glSecondaryColor3ubEXT');
    private z_SecondaryColor3ubEXT_ovr_0 := GetProcOrNil&<procedure(red: Byte; green: Byte; blue: Byte)>(z_SecondaryColor3ubEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubEXT(red: Byte; green: Byte; blue: Byte) :=
    z_SecondaryColor3ubEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3ubvEXT_adr := GetProcAddress('glSecondaryColor3ubvEXT');
    private z_SecondaryColor3ubvEXT_ovr_0 := GetProcOrNil&<procedure(var v: Byte)>(z_SecondaryColor3ubvEXT_adr);
    private z_SecondaryColor3ubvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubvEXT(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3ubvEXT_ovr_0(v[0]) else
      z_SecondaryColor3ubvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubvEXT(var v: Byte) :=
    z_SecondaryColor3ubvEXT_ovr_0(v);
    private z_SecondaryColor3ubvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubvEXT(v: IntPtr) :=
    z_SecondaryColor3ubvEXT_ovr_2(v);
    
    private z_SecondaryColor3uiEXT_adr := GetProcAddress('glSecondaryColor3uiEXT');
    private z_SecondaryColor3uiEXT_ovr_0 := GetProcOrNil&<procedure(red: UInt32; green: UInt32; blue: UInt32)>(z_SecondaryColor3uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiEXT(red: UInt32; green: UInt32; blue: UInt32) :=
    z_SecondaryColor3uiEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3uivEXT_adr := GetProcAddress('glSecondaryColor3uivEXT');
    private z_SecondaryColor3uivEXT_ovr_0 := GetProcOrNil&<procedure(var v: UInt32)>(z_SecondaryColor3uivEXT_adr);
    private z_SecondaryColor3uivEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uivEXT(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3uivEXT_ovr_0(v[0]) else
      z_SecondaryColor3uivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uivEXT(var v: UInt32) :=
    z_SecondaryColor3uivEXT_ovr_0(v);
    private z_SecondaryColor3uivEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uivEXT(v: IntPtr) :=
    z_SecondaryColor3uivEXT_ovr_2(v);
    
    private z_SecondaryColor3usEXT_adr := GetProcAddress('glSecondaryColor3usEXT');
    private z_SecondaryColor3usEXT_ovr_0 := GetProcOrNil&<procedure(red: UInt16; green: UInt16; blue: UInt16)>(z_SecondaryColor3usEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usEXT(red: UInt16; green: UInt16; blue: UInt16) :=
    z_SecondaryColor3usEXT_ovr_0(red, green, blue);
    
    private z_SecondaryColor3usvEXT_adr := GetProcAddress('glSecondaryColor3usvEXT');
    private z_SecondaryColor3usvEXT_ovr_0 := GetProcOrNil&<procedure(var v: UInt16)>(z_SecondaryColor3usvEXT_adr);
    private z_SecondaryColor3usvEXT_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3usvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usvEXT(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3usvEXT_ovr_0(v[0]) else
      z_SecondaryColor3usvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usvEXT(var v: UInt16) :=
    z_SecondaryColor3usvEXT_ovr_0(v);
    private z_SecondaryColor3usvEXT_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3usvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usvEXT(v: IntPtr) :=
    z_SecondaryColor3usvEXT_ovr_2(v);
    
    private z_SecondaryColorPointerEXT_adr := GetProcAddress('glSecondaryColorPointerEXT');
    private z_SecondaryColorPointerEXT_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr)>(z_SecondaryColorPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerEXT(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr) :=
    z_SecondaryColorPointerEXT_ovr_0(size, &type, stride, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSeparateShaderObjectsEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_separate_shader_objects';
    
    private z_UseShaderProgramEXT_adr := GetProcAddress('glUseShaderProgramEXT');
    private z_UseShaderProgramEXT_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; &program: gl_program)>(z_UseShaderProgramEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseShaderProgramEXT(&type: DummyEnum; &program: gl_program) :=
    z_UseShaderProgramEXT_ovr_0(&type, &program);
    
    private z_ActiveProgramEXT_adr := GetProcAddress('glActiveProgramEXT');
    private z_ActiveProgramEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program)>(z_ActiveProgramEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveProgramEXT(&program: gl_program) :=
    z_ActiveProgramEXT_ovr_0(&program);
    
    private z_CreateShaderProgramEXT_adr := GetProcAddress('glCreateShaderProgramEXT');
    private z_CreateShaderProgramEXT_ovr_0 := GetProcOrNil&<function(&type: ShaderType; _string: IntPtr): gl_program>(z_CreateShaderProgramEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramEXT(&type: ShaderType; _string: string): gl_program;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(_string);
        Result := z_CreateShaderProgramEXT_ovr_0(&type, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramEXT(&type: ShaderType; _string: IntPtr): gl_program :=
    z_CreateShaderProgramEXT_ovr_0(&type, _string);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderFramebufferFetchNonCoherentEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_shader_framebuffer_fetch_non_coherent';
    
    private z_FramebufferFetchBarrierEXT_adr := GetProcAddress('glFramebufferFetchBarrierEXT');
    private z_FramebufferFetchBarrierEXT_ovr_0 := GetProcOrNil&<procedure>(z_FramebufferFetchBarrierEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferFetchBarrierEXT :=
    z_FramebufferFetchBarrierEXT_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderImageLoadStoreEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_shader_image_load_store';
    
    private z_BindImageTextureEXT_adr := GetProcAddress('glBindImageTextureEXT');
    private z_BindImageTextureEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; texture: gl_texture; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: Int32)>(z_BindImageTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextureEXT(index: UInt32; texture: gl_texture; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: Int32) :=
    z_BindImageTextureEXT_ovr_0(index, texture, level, layered, layer, access, format);
    
    private z_MemoryBarrierEXT_adr := GetProcAddress('glMemoryBarrierEXT');
    private z_MemoryBarrierEXT_ovr_0 := GetProcOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrierEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrierEXT(barriers: MemoryBarrierMask) :=
    z_MemoryBarrierEXT_ovr_0(barriers);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glStencilClearTagEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_stencil_clear_tag';
    
    private z_StencilClearTagEXT_adr := GetProcAddress('glStencilClearTagEXT');
    private z_StencilClearTagEXT_ovr_0 := GetProcOrNil&<procedure(stencilTagBits: Int32; stencilClearTag: UInt32)>(z_StencilClearTagEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilClearTagEXT(stencilTagBits: Int32; stencilClearTag: UInt32) :=
    z_StencilClearTagEXT_ovr_0(stencilTagBits, stencilClearTag);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glStencilTwoSideEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_stencil_two_side';
    
    private z_ActiveStencilFaceEXT_adr := GetProcAddress('glActiveStencilFaceEXT');
    private z_ActiveStencilFaceEXT_ovr_0 := GetProcOrNil&<procedure(face: StencilFaceDirection)>(z_ActiveStencilFaceEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveStencilFaceEXT(face: StencilFaceDirection) :=
    z_ActiveStencilFaceEXT_ovr_0(face);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSubtextureEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_subtexture';
    
    private z_TexSubImage1DEXT_adr := GetProcAddress('glTexSubImage1DEXT');
    private z_TexSubImage1DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage1DEXT(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage1DEXT_ovr_0(target, level, xoffset, width, format, &type, pixels);
    
    private z_TexSubImage2DEXT_adr := GetProcAddress('glTexSubImage2DEXT');
    private z_TexSubImage2DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage2DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage2DEXT_ovr_0(target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTexture3DEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture3D';
    
    private z_TexImage3DEXT_adr := GetProcAddress('glTexImage3DEXT');
    private z_TexImage3DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DEXT(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage3DEXT_ovr_0(target, level, _internalformat, width, height, depth, border, format, &type, pixels);
    
    private z_TexSubImage3DEXT_adr := GetProcAddress('glTexSubImage3DEXT');
    private z_TexSubImage3DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage3DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage3DEXT_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureArrayEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_array';
    
    private z_FramebufferTextureLayerEXT_adr := GetProcAddress('glFramebufferTextureLayerEXT');
    private z_FramebufferTextureLayerEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_FramebufferTextureLayerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayerEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayerEXT_ovr_0(target, attachment, texture, level, layer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureBufferObjectEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_buffer_object';
    
    private z_TexBufferEXT_adr := GetProcAddress('glTexBufferEXT');
    private z_TexBufferEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer)>(z_TexBufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferEXT(target: TextureTarget; internalformat: SizedInternalFormat; buffer: gl_buffer) :=
    z_TexBufferEXT_ovr_0(target, internalformat, buffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureIntegerEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_integer';
    
    private z_TexParameterIivEXT_adr := GetProcAddress('glTexParameterIivEXT');
    private z_TexParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_TexParameterIivEXT_adr);
    private z_TexParameterIivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIivEXT(target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIivEXT_ovr_0(target, pname, &params[0]) else
      z_TexParameterIivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIivEXT(target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TexParameterIivEXT_ovr_0(target, pname, &params);
    private z_TexParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIivEXT(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIivEXT_ovr_2(target, pname, &params);
    
    private z_TexParameterIuivEXT_adr := GetProcAddress('glTexParameterIuivEXT');
    private z_TexParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: UInt32)>(z_TexParameterIuivEXT_adr);
    private z_TexParameterIuivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuivEXT(target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIuivEXT_ovr_0(target, pname, &params[0]) else
      z_TexParameterIuivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuivEXT(target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_TexParameterIuivEXT_ovr_0(target, pname, &params);
    private z_TexParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuivEXT(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIuivEXT_ovr_2(target, pname, &params);
    
    private z_GetTexParameterIivEXT_adr := GetProcAddress('glGetTexParameterIivEXT');
    private z_GetTexParameterIivEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetTexParameterIivEXT_adr);
    private z_GetTexParameterIivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIivEXT(target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIivEXT_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIivEXT(target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexParameterIivEXT_ovr_0(target, pname, &params);
    private z_GetTexParameterIivEXT_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIivEXT(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIivEXT_ovr_2(target, pname, &params);
    
    private z_GetTexParameterIuivEXT_adr := GetProcAddress('glGetTexParameterIuivEXT');
    private z_GetTexParameterIuivEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32)>(z_GetTexParameterIuivEXT_adr);
    private z_GetTexParameterIuivEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuivEXT(target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIuivEXT_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIuivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuivEXT(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTexParameterIuivEXT_ovr_0(target, pname, &params);
    private z_GetTexParameterIuivEXT_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuivEXT(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIuivEXT_ovr_2(target, pname, &params);
    
    private z_ClearColorIiEXT_adr := GetProcAddress('glClearColorIiEXT');
    private z_ClearColorIiEXT_ovr_0 := GetProcOrNil&<procedure(red: Int32; green: Int32; blue: Int32; alpha: Int32)>(z_ClearColorIiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColorIiEXT(red: Int32; green: Int32; blue: Int32; alpha: Int32) :=
    z_ClearColorIiEXT_ovr_0(red, green, blue, alpha);
    
    private z_ClearColorIuiEXT_adr := GetProcAddress('glClearColorIuiEXT');
    private z_ClearColorIuiEXT_ovr_0 := GetProcOrNil&<procedure(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32)>(z_ClearColorIuiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColorIuiEXT(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32) :=
    z_ClearColorIuiEXT_ovr_0(red, green, blue, alpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureObjectEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_object';
    
    private z_AreTexturesResidentEXT_adr := GetProcAddress('glAreTexturesResidentEXT');
    private z_AreTexturesResidentEXT_ovr_0 := GetProcOrNil&<function(n: Int32; var textures: gl_texture; var residences: boolean): boolean>(z_AreTexturesResidentEXT_adr);
    private z_AreTexturesResidentEXT_ovr_0_anh0010 := GetProcOrNil&<function(n: Int32; textures: IntPtr; var residences: boolean): boolean>(z_AreTexturesResidentEXT_adr);
    private z_AreTexturesResidentEXT_ovr_0_anh0001 := GetProcOrNil&<function(n: Int32; var textures: gl_texture; residences: IntPtr): boolean>(z_AreTexturesResidentEXT_adr);
    private z_AreTexturesResidentEXT_ovr_0_anh0011 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResidentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: array of gl_texture; residences: array of boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResidentEXT_ovr_0(n, textures[0], residences[0]) else
        z_AreTexturesResidentEXT_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResidentEXT_ovr_0_anh0010(n, IntPtr.Zero, residences[0]) else
        z_AreTexturesResidentEXT_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private z_AreTexturesResidentEXT_ovr_1_anh0010 := GetProcOrNil&<function(n: Int32; textures: IntPtr; var residences: boolean): boolean>(z_AreTexturesResidentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: array of gl_texture; var residences: boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResidentEXT_ovr_0(n, textures[0], residences) else
      z_AreTexturesResidentEXT_ovr_0_anh0010(n, IntPtr.Zero, residences);
    private z_AreTexturesResidentEXT_ovr_2 := GetProcOrNil&<function(n: Int32; var textures: gl_texture; residences: IntPtr): boolean>(z_AreTexturesResidentEXT_adr);
    private z_AreTexturesResidentEXT_ovr_2_anh0010 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResidentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: array of gl_texture; residences: IntPtr): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResidentEXT_ovr_2(n, textures[0], residences) else
      z_AreTexturesResidentEXT_ovr_2_anh0010(n, IntPtr.Zero, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; var textures: gl_texture; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResidentEXT_ovr_0(n, textures, residences[0]) else
      z_AreTexturesResidentEXT_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; var textures: gl_texture; var residences: boolean): boolean :=
    z_AreTexturesResidentEXT_ovr_0(n, textures, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; var textures: gl_texture; residences: IntPtr): boolean :=
    z_AreTexturesResidentEXT_ovr_2(n, textures, residences);
    private z_AreTexturesResidentEXT_ovr_6 := GetProcOrNil&<function(n: Int32; textures: IntPtr; var residences: boolean): boolean>(z_AreTexturesResidentEXT_adr);
    private z_AreTexturesResidentEXT_ovr_6_anh0001 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResidentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: IntPtr; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResidentEXT_ovr_6(n, textures, residences[0]) else
      z_AreTexturesResidentEXT_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: IntPtr; var residences: boolean): boolean :=
    z_AreTexturesResidentEXT_ovr_6(n, textures, residences);
    private z_AreTexturesResidentEXT_ovr_8 := GetProcOrNil&<function(n: Int32; textures: IntPtr; residences: IntPtr): boolean>(z_AreTexturesResidentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: IntPtr; residences: IntPtr): boolean :=
    z_AreTexturesResidentEXT_ovr_8(n, textures, residences);
    
    private z_BindTextureEXT_adr := GetProcAddress('glBindTextureEXT');
    private z_BindTextureEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; texture: gl_texture)>(z_BindTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextureEXT(target: TextureTarget; texture: gl_texture) :=
    z_BindTextureEXT_ovr_0(target, texture);
    
    private z_DeleteTexturesEXT_adr := GetProcAddress('glDeleteTexturesEXT');
    private z_DeleteTexturesEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture)>(z_DeleteTexturesEXT_adr);
    private z_DeleteTexturesEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_DeleteTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTexturesEXT(n: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_DeleteTexturesEXT_ovr_0(n, textures[0]) else
      z_DeleteTexturesEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTexturesEXT(n: Int32; var textures: gl_texture) :=
    z_DeleteTexturesEXT_ovr_0(n, textures);
    private z_DeleteTexturesEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_DeleteTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTexturesEXT(n: Int32; textures: IntPtr) :=
    z_DeleteTexturesEXT_ovr_2(n, textures);
    
    private z_GenTexturesEXT_adr := GetProcAddress('glGenTexturesEXT');
    private z_GenTexturesEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture)>(z_GenTexturesEXT_adr);
    private z_GenTexturesEXT_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_GenTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTexturesEXT(n: Int32; textures: array of gl_texture) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_GenTexturesEXT_ovr_0(n, textures[0]) else
      z_GenTexturesEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTexturesEXT(n: Int32; var textures: gl_texture) :=
    z_GenTexturesEXT_ovr_0(n, textures);
    private z_GenTexturesEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr)>(z_GenTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTexturesEXT(n: Int32; textures: IntPtr) :=
    z_GenTexturesEXT_ovr_2(n, textures);
    
    private z_IsTextureEXT_adr := GetProcAddress('glIsTextureEXT');
    private z_IsTextureEXT_ovr_0 := GetProcOrNil&<function(texture: gl_texture): boolean>(z_IsTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTextureEXT(texture: gl_texture): boolean :=
    z_IsTextureEXT_ovr_0(texture);
    
    private z_PrioritizeTexturesEXT_adr := GetProcAddress('glPrioritizeTexturesEXT');
    private z_PrioritizeTexturesEXT_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; var priorities: single)>(z_PrioritizeTexturesEXT_adr);
    private z_PrioritizeTexturesEXT_ovr_0_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: single)>(z_PrioritizeTexturesEXT_adr);
    private z_PrioritizeTexturesEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; priorities: IntPtr)>(z_PrioritizeTexturesEXT_adr);
    private z_PrioritizeTexturesEXT_ovr_0_anh0011 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: array of gl_texture; priorities: array of single) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesEXT_ovr_0(n, textures[0], priorities[0]) else
        z_PrioritizeTexturesEXT_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesEXT_ovr_0_anh0010(n, IntPtr.Zero, priorities[0]) else
        z_PrioritizeTexturesEXT_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private z_PrioritizeTexturesEXT_ovr_1_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: single)>(z_PrioritizeTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: array of gl_texture; var priorities: single) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_0(n, textures[0], priorities) else
      z_PrioritizeTexturesEXT_ovr_0_anh0010(n, IntPtr.Zero, priorities);
    private z_PrioritizeTexturesEXT_ovr_2 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; priorities: IntPtr)>(z_PrioritizeTexturesEXT_adr);
    private z_PrioritizeTexturesEXT_ovr_2_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: array of gl_texture; priorities: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_2(n, textures[0], priorities) else
      z_PrioritizeTexturesEXT_ovr_2_anh0010(n, IntPtr.Zero, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; var textures: gl_texture; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_0(n, textures, priorities[0]) else
      z_PrioritizeTexturesEXT_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; var textures: gl_texture; var priorities: single) :=
    z_PrioritizeTexturesEXT_ovr_0(n, textures, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; var textures: gl_texture; priorities: IntPtr) :=
    z_PrioritizeTexturesEXT_ovr_2(n, textures, priorities);
    private z_PrioritizeTexturesEXT_ovr_6 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: single)>(z_PrioritizeTexturesEXT_adr);
    private z_PrioritizeTexturesEXT_ovr_6_anh0001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: IntPtr; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_6(n, textures, priorities[0]) else
      z_PrioritizeTexturesEXT_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: IntPtr; var priorities: single) :=
    z_PrioritizeTexturesEXT_ovr_6(n, textures, priorities);
    private z_PrioritizeTexturesEXT_ovr_8 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: IntPtr; priorities: IntPtr) :=
    z_PrioritizeTexturesEXT_ovr_8(n, textures, priorities);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTexturePerturbNormalEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_perturb_normal';
    
    private z_TextureNormalEXT_adr := GetProcAddress('glTextureNormalEXT');
    private z_TextureNormalEXT_ovr_0 := GetProcOrNil&<procedure(mode: TextureNormalModeEXT)>(z_TextureNormalEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureNormalEXT(mode: TextureNormalModeEXT) :=
    z_TextureNormalEXT_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureStorageEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_storage';
    
    private z_TexStorage1DEXT_adr := GetProcAddress('glTexStorage1DEXT');
    private z_TexStorage1DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TexStorage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage1DEXT(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TexStorage1DEXT_ovr_0(target, levels, internalformat, width);
    
    private z_TexStorage2DEXT_adr := GetProcAddress('glTexStorage2DEXT');
    private z_TexStorage2DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TexStorage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2DEXT(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TexStorage2DEXT_ovr_0(target, levels, internalformat, width, height);
    
    private z_TexStorage3DEXT_adr := GetProcAddress('glTexStorage3DEXT');
    private z_TexStorage3DEXT_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TexStorage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3DEXT(target: TextureTarget; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TexStorage3DEXT_ovr_0(target, levels, internalformat, width, height, depth);
    
    private z_TextureStorage1DEXT_adr := GetProcAddress('glTextureStorage1DEXT');
    private z_TextureStorage1DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32)>(z_TextureStorage1DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1DEXT(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32) :=
    z_TextureStorage1DEXT_ovr_0(texture, target, levels, internalformat, width);
    
    private z_TextureStorage2DEXT_adr := GetProcAddress('glTextureStorage2DEXT');
    private z_TextureStorage2DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32)>(z_TextureStorage2DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DEXT(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2DEXT_ovr_0(texture, target, levels, internalformat, width, height);
    
    private z_TextureStorage3DEXT_adr := GetProcAddress('glTextureStorage3DEXT');
    private z_TextureStorage3DEXT_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TextureStorage3DEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DEXT(texture: gl_texture; target: DummyEnum; levels: Int32; internalformat: SizedInternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3DEXT_ovr_0(texture, target, levels, internalformat, width, height, depth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTimelineSemaphoreNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_timeline_semaphore';
    
    private z_CreateSemaphoresNV_adr := GetProcAddress('glCreateSemaphoresNV');
    private z_CreateSemaphoresNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var semaphores: UInt32)>(z_CreateSemaphoresNV_adr);
    private z_CreateSemaphoresNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; semaphores: IntPtr)>(z_CreateSemaphoresNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSemaphoresNV(n: Int32; semaphores: array of UInt32) :=
    if (semaphores<>nil) and (semaphores.Length<>0) then
      z_CreateSemaphoresNV_ovr_0(n, semaphores[0]) else
      z_CreateSemaphoresNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSemaphoresNV(n: Int32; var semaphores: UInt32) :=
    z_CreateSemaphoresNV_ovr_0(n, semaphores);
    private z_CreateSemaphoresNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; semaphores: IntPtr)>(z_CreateSemaphoresNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSemaphoresNV(n: Int32; semaphores: IntPtr) :=
    z_CreateSemaphoresNV_ovr_2(n, semaphores);
    
    private z_SemaphoreParameterivNV_adr := GetProcAddress('glSemaphoreParameterivNV');
    private z_SemaphoreParameterivNV_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; var &params: Int32)>(z_SemaphoreParameterivNV_adr);
    private z_SemaphoreParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_SemaphoreParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterivNV(semaphore: UInt32; pname: SemaphoreParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SemaphoreParameterivNV_ovr_0(semaphore, pname, &params[0]) else
      z_SemaphoreParameterivNV_ovr_0_anh0001(semaphore, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterivNV(semaphore: UInt32; pname: SemaphoreParameterName; var &params: Int32) :=
    z_SemaphoreParameterivNV_ovr_0(semaphore, pname, &params);
    private z_SemaphoreParameterivNV_ovr_2 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_SemaphoreParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterivNV(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr) :=
    z_SemaphoreParameterivNV_ovr_2(semaphore, pname, &params);
    
    private z_GetSemaphoreParameterivNV_adr := GetProcAddress('glGetSemaphoreParameterivNV');
    private z_GetSemaphoreParameterivNV_ovr_0 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; var &params: Int32)>(z_GetSemaphoreParameterivNV_adr);
    private z_GetSemaphoreParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_GetSemaphoreParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterivNV(semaphore: UInt32; pname: SemaphoreParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSemaphoreParameterivNV_ovr_0(semaphore, pname, &params[0]) else
      z_GetSemaphoreParameterivNV_ovr_0_anh0001(semaphore, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterivNV(semaphore: UInt32; pname: SemaphoreParameterName; var &params: Int32) :=
    z_GetSemaphoreParameterivNV_ovr_0(semaphore, pname, &params);
    private z_GetSemaphoreParameterivNV_ovr_2 := GetProcOrNil&<procedure(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr)>(z_GetSemaphoreParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterivNV(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr) :=
    z_GetSemaphoreParameterivNV_ovr_2(semaphore, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTimerQueryEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_timer_query';
    
    private z_GetQueryObjecti64vEXT_adr := GetProcAddress('glGetQueryObjecti64vEXT');
    private z_GetQueryObjecti64vEXT_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: Int64)>(z_GetQueryObjecti64vEXT_adr);
    private z_GetQueryObjecti64vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64vEXT(id: gl_query; pname: QueryObjectParameterName; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjecti64vEXT_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjecti64vEXT_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64vEXT(id: gl_query; pname: QueryObjectParameterName; var &params: Int64) :=
    z_GetQueryObjecti64vEXT_ovr_0(id, pname, &params);
    private z_GetQueryObjecti64vEXT_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64vEXT(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjecti64vEXT_ovr_2(id, pname, &params);
    
    private z_GetQueryObjectui64vEXT_adr := GetProcAddress('glGetQueryObjectui64vEXT');
    private z_GetQueryObjectui64vEXT_ovr_0 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; var &params: UInt64)>(z_GetQueryObjectui64vEXT_adr);
    private z_GetQueryObjectui64vEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64vEXT(id: gl_query; pname: QueryObjectParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectui64vEXT_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectui64vEXT_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64vEXT(id: gl_query; pname: QueryObjectParameterName; var &params: UInt64) :=
    z_GetQueryObjectui64vEXT_ovr_0(id, pname, &params);
    private z_GetQueryObjectui64vEXT_ovr_2 := GetProcOrNil&<procedure(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64vEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64vEXT(id: gl_query; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectui64vEXT_ovr_2(id, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransformFeedbackEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_transform_feedback';
    
    private z_BeginTransformFeedbackEXT_adr := GetProcAddress('glBeginTransformFeedbackEXT');
    private z_BeginTransformFeedbackEXT_ovr_0 := GetProcOrNil&<procedure(primitiveMode: PrimitiveType)>(z_BeginTransformFeedbackEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginTransformFeedbackEXT(primitiveMode: PrimitiveType) :=
    z_BeginTransformFeedbackEXT_ovr_0(primitiveMode);
    
    private z_EndTransformFeedbackEXT_adr := GetProcAddress('glEndTransformFeedbackEXT');
    private z_EndTransformFeedbackEXT_ovr_0 := GetProcOrNil&<procedure>(z_EndTransformFeedbackEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndTransformFeedbackEXT :=
    z_EndTransformFeedbackEXT_ovr_0;
    
    private z_BindBufferRangeEXT_adr := GetProcAddress('glBindBufferRangeEXT');
    private z_BindBufferRangeEXT_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_BindBufferRangeEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRangeEXT(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRangeEXT_ovr_0(target, index, buffer, offset, size);
    
    private z_BindBufferOffsetEXT_adr := GetProcAddress('glBindBufferOffsetEXT');
    private z_BindBufferOffsetEXT_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr)>(z_BindBufferOffsetEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferOffsetEXT(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr) :=
    z_BindBufferOffsetEXT_ovr_0(target, index, buffer, offset);
    
    private z_BindBufferBaseEXT_adr := GetProcAddress('glBindBufferBaseEXT');
    private z_BindBufferBaseEXT_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer)>(z_BindBufferBaseEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBaseEXT(target: BufferTarget; index: UInt32; buffer: gl_buffer) :=
    z_BindBufferBaseEXT_ovr_0(target, index, buffer);
    
    private z_TransformFeedbackVaryingsEXT_adr := GetProcAddress('glTransformFeedbackVaryingsEXT');
    private z_TransformFeedbackVaryingsEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; var varyings: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsEXT_adr);
    private z_TransformFeedbackVaryingsEXT_ovr_0_anh00010 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsEXT(&program: gl_program; count: Int32; varyings: array of string; bufferMode: DummyEnum);
    begin
      var par_3_str_ptr: array of IntPtr;
      try
        par_3_str_ptr := varyings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
        if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
          z_TransformFeedbackVaryingsEXT_ovr_0(&program, count, par_3_str_ptr[0], bufferMode) else
          z_TransformFeedbackVaryingsEXT_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
      finally
        foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_TransformFeedbackVaryingsEXT_ovr_1_anh00010 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsEXT(&program: gl_program; count: Int32; varyings: array of IntPtr; bufferMode: DummyEnum) :=
    if (varyings<>nil) and (varyings.Length<>0) then
      z_TransformFeedbackVaryingsEXT_ovr_0(&program, count, varyings[0], bufferMode) else
      z_TransformFeedbackVaryingsEXT_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
    private z_TransformFeedbackVaryingsEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsEXT(&program: gl_program; count: Int32; varyings: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackVaryingsEXT_ovr_2(&program, count, varyings, bufferMode);
    
    private z_GetTransformFeedbackVaryingEXT_adr := GetProcAddress('glGetTransformFeedbackVaryingEXT');
    private z_GetTransformFeedbackVaryingEXT_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_1(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_2(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_3(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_4 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_4(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_5(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_6(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVaryingEXT_ovr_7 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVaryingEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_7(&program, index, bufSize, length, size, &type, name);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_vertex_array';
    
    private z_ArrayElementEXT_adr := GetProcAddress('glArrayElementEXT');
    private z_ArrayElementEXT_ovr_0 := GetProcOrNil&<procedure(i: Int32)>(z_ArrayElementEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ArrayElementEXT(i: Int32) :=
    z_ArrayElementEXT_ovr_0(i);
    
    private z_ColorPointerEXT_adr := GetProcAddress('glColorPointerEXT');
    private z_ColorPointerEXT_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; count: Int32; pointer: IntPtr)>(z_ColorPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerEXT(size: Int32; &type: ColorPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_ColorPointerEXT_ovr_0(size, &type, stride, count, pointer);
    
    private z_DrawArraysEXT_adr := GetProcAddress('glDrawArraysEXT');
    private z_DrawArraysEXT_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32)>(z_DrawArraysEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysEXT(mode: PrimitiveType; first: Int32; count: Int32) :=
    z_DrawArraysEXT_ovr_0(mode, first, count);
    
    private z_EdgeFlagPointerEXT_adr := GetProcAddress('glEdgeFlagPointerEXT');
    private z_EdgeFlagPointerEXT_ovr_0 := GetProcOrNil&<procedure(stride: Int32; count: Int32; var pointer: boolean)>(z_EdgeFlagPointerEXT_adr);
    private z_EdgeFlagPointerEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(stride: Int32; count: Int32; pointer: IntPtr)>(z_EdgeFlagPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerEXT(stride: Int32; count: Int32; pointer: array of boolean) :=
    if (pointer<>nil) and (pointer.Length<>0) then
      z_EdgeFlagPointerEXT_ovr_0(stride, count, pointer[0]) else
      z_EdgeFlagPointerEXT_ovr_0_anh0001(stride, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerEXT(stride: Int32; count: Int32; var pointer: boolean) :=
    z_EdgeFlagPointerEXT_ovr_0(stride, count, pointer);
    private z_EdgeFlagPointerEXT_ovr_2 := GetProcOrNil&<procedure(stride: Int32; count: Int32; pointer: IntPtr)>(z_EdgeFlagPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerEXT(stride: Int32; count: Int32; pointer: IntPtr) :=
    z_EdgeFlagPointerEXT_ovr_2(stride, count, pointer);
    
    private z_GetPointervEXT_adr := GetProcAddress('glGetPointervEXT');
    private z_GetPointervEXT_ovr_0 := GetProcOrNil&<procedure(pname: GetPointervPName; var &params: IntPtr)>(z_GetPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointervEXT(pname: GetPointervPName; var &params: IntPtr) :=
    z_GetPointervEXT_ovr_0(pname, &params);
    private z_GetPointervEXT_ovr_1 := GetProcOrNil&<procedure(pname: GetPointervPName; &params: pointer)>(z_GetPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointervEXT(pname: GetPointervPName; &params: pointer) :=
    z_GetPointervEXT_ovr_1(pname, &params);
    
    private z_IndexPointerEXT_adr := GetProcAddress('glIndexPointerEXT');
    private z_IndexPointerEXT_ovr_0 := GetProcOrNil&<procedure(&type: IndexPointerType; stride: Int32; count: Int32; pointer: IntPtr)>(z_IndexPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerEXT(&type: IndexPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_IndexPointerEXT_ovr_0(&type, stride, count, pointer);
    
    private z_NormalPointerEXT_adr := GetProcAddress('glNormalPointerEXT');
    private z_NormalPointerEXT_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; stride: Int32; count: Int32; pointer: IntPtr)>(z_NormalPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerEXT(&type: NormalPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_NormalPointerEXT_ovr_0(&type, stride, count, pointer);
    
    private z_TexCoordPointerEXT_adr := GetProcAddress('glTexCoordPointerEXT');
    private z_TexCoordPointerEXT_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: TexCoordPointerType; stride: Int32; count: Int32; pointer: IntPtr)>(z_TexCoordPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerEXT(size: Int32; &type: TexCoordPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_TexCoordPointerEXT_ovr_0(size, &type, stride, count, pointer);
    
    private z_VertexPointerEXT_adr := GetProcAddress('glVertexPointerEXT');
    private z_VertexPointerEXT_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; stride: Int32; count: Int32; pointer: IntPtr)>(z_VertexPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerEXT(size: Int32; &type: VertexPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_VertexPointerEXT_ovr_0(size, &type, stride, count, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexAttrib64bitEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_vertex_attrib_64bit';
    
    private z_VertexAttribL1dEXT_adr := GetProcAddress('glVertexAttribL1dEXT');
    private z_VertexAttribL1dEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttribL1dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dEXT(index: UInt32; x: real) :=
    z_VertexAttribL1dEXT_ovr_0(index, x);
    
    private z_VertexAttribL2dEXT_adr := GetProcAddress('glVertexAttribL2dEXT');
    private z_VertexAttribL2dEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttribL2dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dEXT(index: UInt32; x: real; y: real) :=
    z_VertexAttribL2dEXT_ovr_0(index, x, y);
    
    private z_VertexAttribL3dEXT_adr := GetProcAddress('glVertexAttribL3dEXT');
    private z_VertexAttribL3dEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttribL3dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dEXT(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttribL3dEXT_ovr_0(index, x, y, z);
    
    private z_VertexAttribL4dEXT_adr := GetProcAddress('glVertexAttribL4dEXT');
    private z_VertexAttribL4dEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttribL4dEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dEXT(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttribL4dEXT_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribL1dvEXT_adr := GetProcAddress('glVertexAttribL1dvEXT');
    private z_VertexAttribL1dvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL1dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL1dvEXT_ovr_0(index, v);
    private z_VertexAttribL1dvEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1dvEXT_ovr_1(index, v);
    
    private z_VertexAttribL2dvEXT_adr := GetProcAddress('glVertexAttribL2dvEXT');
    private z_VertexAttribL2dvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL2dvEXT_adr);
    private z_VertexAttribL2dvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL2dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL2dvEXT_ovr_0(index, v);
    private z_VertexAttribL2dvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2dvEXT_ovr_2(index, v);
    
    private z_VertexAttribL3dvEXT_adr := GetProcAddress('glVertexAttribL3dvEXT');
    private z_VertexAttribL3dvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL3dvEXT_adr);
    private z_VertexAttribL3dvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL3dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL3dvEXT_ovr_0(index, v);
    private z_VertexAttribL3dvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3dvEXT_ovr_2(index, v);
    
    private z_VertexAttribL4dvEXT_adr := GetProcAddress('glVertexAttribL4dvEXT');
    private z_VertexAttribL4dvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL4dvEXT_adr);
    private z_VertexAttribL4dvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL4dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL4dvEXT_ovr_0(index, v);
    private z_VertexAttribL4dvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4dvEXT_ovr_2(index, v);
    
    private z_VertexAttribLPointerEXT_adr := GetProcAddress('glVertexAttribLPointerEXT');
    private z_VertexAttribLPointerEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; pointer: IntPtr)>(z_VertexAttribLPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLPointerEXT(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribLPointerEXT_ovr_0(index, size, &type, stride, pointer);
    
    private z_GetVertexAttribLdvEXT_adr := GetProcAddress('glGetVertexAttribLdvEXT');
    private z_GetVertexAttribLdvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: real)>(z_GetVertexAttribLdvEXT_adr);
    private z_GetVertexAttribLdvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdvEXT(index: UInt32; pname: VertexAttribEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLdvEXT_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLdvEXT_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdvEXT(index: UInt32; pname: VertexAttribEnum; var &params: real) :=
    z_GetVertexAttribLdvEXT_ovr_0(index, pname, &params);
    private z_GetVertexAttribLdvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdvEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLdvEXT_ovr_2(index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexShaderEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_vertex_shader';
    
    private z_BeginVertexShaderEXT_adr := GetProcAddress('glBeginVertexShaderEXT');
    private z_BeginVertexShaderEXT_ovr_0 := GetProcOrNil&<procedure>(z_BeginVertexShaderEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginVertexShaderEXT :=
    z_BeginVertexShaderEXT_ovr_0;
    
    private z_EndVertexShaderEXT_adr := GetProcAddress('glEndVertexShaderEXT');
    private z_EndVertexShaderEXT_ovr_0 := GetProcOrNil&<procedure>(z_EndVertexShaderEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndVertexShaderEXT :=
    z_EndVertexShaderEXT_ovr_0;
    
    private z_BindVertexShaderEXT_adr := GetProcAddress('glBindVertexShaderEXT');
    private z_BindVertexShaderEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_BindVertexShaderEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexShaderEXT(id: UInt32) :=
    z_BindVertexShaderEXT_ovr_0(id);
    
    private z_GenVertexShadersEXT_adr := GetProcAddress('glGenVertexShadersEXT');
    private z_GenVertexShadersEXT_ovr_0 := GetProcOrNil&<function(range: UInt32): UInt32>(z_GenVertexShadersEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenVertexShadersEXT(range: UInt32): UInt32 :=
    z_GenVertexShadersEXT_ovr_0(range);
    
    private z_DeleteVertexShaderEXT_adr := GetProcAddress('glDeleteVertexShaderEXT');
    private z_DeleteVertexShaderEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_DeleteVertexShaderEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexShaderEXT(id: UInt32) :=
    z_DeleteVertexShaderEXT_ovr_0(id);
    
    private z_ShaderOp1EXT_adr := GetProcAddress('glShaderOp1EXT');
    private z_ShaderOp1EXT_ovr_0 := GetProcOrNil&<procedure(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32)>(z_ShaderOp1EXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderOp1EXT(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32) :=
    z_ShaderOp1EXT_ovr_0(op, res, arg1);
    
    private z_ShaderOp2EXT_adr := GetProcAddress('glShaderOp2EXT');
    private z_ShaderOp2EXT_ovr_0 := GetProcOrNil&<procedure(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32)>(z_ShaderOp2EXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderOp2EXT(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32) :=
    z_ShaderOp2EXT_ovr_0(op, res, arg1, arg2);
    
    private z_ShaderOp3EXT_adr := GetProcAddress('glShaderOp3EXT');
    private z_ShaderOp3EXT_ovr_0 := GetProcOrNil&<procedure(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32; arg3: UInt32)>(z_ShaderOp3EXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderOp3EXT(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32; arg3: UInt32) :=
    z_ShaderOp3EXT_ovr_0(op, res, arg1, arg2, arg3);
    
    private z_SwizzleEXT_adr := GetProcAddress('glSwizzleEXT');
    private z_SwizzleEXT_ovr_0 := GetProcOrNil&<procedure(res: UInt32; &in: UInt32; outX: VertexShaderCoordOutEXT; outY: VertexShaderCoordOutEXT; outZ: VertexShaderCoordOutEXT; outW: VertexShaderCoordOutEXT)>(z_SwizzleEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SwizzleEXT(res: UInt32; &in: UInt32; outX: VertexShaderCoordOutEXT; outY: VertexShaderCoordOutEXT; outZ: VertexShaderCoordOutEXT; outW: VertexShaderCoordOutEXT) :=
    z_SwizzleEXT_ovr_0(res, &in, outX, outY, outZ, outW);
    
    private z_WriteMaskEXT_adr := GetProcAddress('glWriteMaskEXT');
    private z_WriteMaskEXT_ovr_0 := GetProcOrNil&<procedure(res: UInt32; &in: UInt32; outX: VertexShaderWriteMaskEXT; outY: VertexShaderWriteMaskEXT; outZ: VertexShaderWriteMaskEXT; outW: VertexShaderWriteMaskEXT)>(z_WriteMaskEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WriteMaskEXT(res: UInt32; &in: UInt32; outX: VertexShaderWriteMaskEXT; outY: VertexShaderWriteMaskEXT; outZ: VertexShaderWriteMaskEXT; outW: VertexShaderWriteMaskEXT) :=
    z_WriteMaskEXT_ovr_0(res, &in, outX, outY, outZ, outW);
    
    private z_InsertComponentEXT_adr := GetProcAddress('glInsertComponentEXT');
    private z_InsertComponentEXT_ovr_0 := GetProcOrNil&<procedure(res: UInt32; src: UInt32; num: UInt32)>(z_InsertComponentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InsertComponentEXT(res: UInt32; src: UInt32; num: UInt32) :=
    z_InsertComponentEXT_ovr_0(res, src, num);
    
    private z_ExtractComponentEXT_adr := GetProcAddress('glExtractComponentEXT');
    private z_ExtractComponentEXT_ovr_0 := GetProcOrNil&<procedure(res: UInt32; src: UInt32; num: UInt32)>(z_ExtractComponentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExtractComponentEXT(res: UInt32; src: UInt32; num: UInt32) :=
    z_ExtractComponentEXT_ovr_0(res, src, num);
    
    private z_GenSymbolsEXT_adr := GetProcAddress('glGenSymbolsEXT');
    private z_GenSymbolsEXT_ovr_0 := GetProcOrNil&<function(datatype: DataTypeEXT; storagetype: VertexShaderStorageTypeEXT; range: ParameterRangeEXT; components: UInt32): UInt32>(z_GenSymbolsEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenSymbolsEXT(datatype: DataTypeEXT; storagetype: VertexShaderStorageTypeEXT; range: ParameterRangeEXT; components: UInt32): UInt32 :=
    z_GenSymbolsEXT_ovr_0(datatype, storagetype, range, components);
    
    private z_SetInvariantEXT_adr := GetProcAddress('glSetInvariantEXT');
    private z_SetInvariantEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; &type: ScalarType; addr: IntPtr)>(z_SetInvariantEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetInvariantEXT(id: UInt32; &type: ScalarType; addr: IntPtr) :=
    z_SetInvariantEXT_ovr_0(id, &type, addr);
    
    private z_SetLocalConstantEXT_adr := GetProcAddress('glSetLocalConstantEXT');
    private z_SetLocalConstantEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; &type: ScalarType; addr: IntPtr)>(z_SetLocalConstantEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetLocalConstantEXT(id: UInt32; &type: ScalarType; addr: IntPtr) :=
    z_SetLocalConstantEXT_ovr_0(id, &type, addr);
    
    private z_VariantbvEXT_adr := GetProcAddress('glVariantbvEXT');
    private z_VariantbvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: SByte)>(z_VariantbvEXT_adr);
    private z_VariantbvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantbvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantbvEXT(id: UInt32; addr: array of SByte) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantbvEXT_ovr_0(id, addr[0]) else
      z_VariantbvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantbvEXT(id: UInt32; var addr: SByte) :=
    z_VariantbvEXT_ovr_0(id, addr);
    private z_VariantbvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantbvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantbvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantbvEXT_ovr_2(id, addr);
    
    private z_VariantsvEXT_adr := GetProcAddress('glVariantsvEXT');
    private z_VariantsvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: Int16)>(z_VariantsvEXT_adr);
    private z_VariantsvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantsvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantsvEXT(id: UInt32; addr: array of Int16) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantsvEXT_ovr_0(id, addr[0]) else
      z_VariantsvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantsvEXT(id: UInt32; var addr: Int16) :=
    z_VariantsvEXT_ovr_0(id, addr);
    private z_VariantsvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantsvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantsvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantsvEXT_ovr_2(id, addr);
    
    private z_VariantivEXT_adr := GetProcAddress('glVariantivEXT');
    private z_VariantivEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: Int32)>(z_VariantivEXT_adr);
    private z_VariantivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantivEXT(id: UInt32; addr: array of Int32) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantivEXT_ovr_0(id, addr[0]) else
      z_VariantivEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantivEXT(id: UInt32; var addr: Int32) :=
    z_VariantivEXT_ovr_0(id, addr);
    private z_VariantivEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantivEXT(id: UInt32; addr: IntPtr) :=
    z_VariantivEXT_ovr_2(id, addr);
    
    private z_VariantfvEXT_adr := GetProcAddress('glVariantfvEXT');
    private z_VariantfvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: single)>(z_VariantfvEXT_adr);
    private z_VariantfvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantfvEXT(id: UInt32; addr: array of single) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantfvEXT_ovr_0(id, addr[0]) else
      z_VariantfvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantfvEXT(id: UInt32; var addr: single) :=
    z_VariantfvEXT_ovr_0(id, addr);
    private z_VariantfvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantfvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantfvEXT_ovr_2(id, addr);
    
    private z_VariantdvEXT_adr := GetProcAddress('glVariantdvEXT');
    private z_VariantdvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: real)>(z_VariantdvEXT_adr);
    private z_VariantdvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantdvEXT(id: UInt32; addr: array of real) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantdvEXT_ovr_0(id, addr[0]) else
      z_VariantdvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantdvEXT(id: UInt32; var addr: real) :=
    z_VariantdvEXT_ovr_0(id, addr);
    private z_VariantdvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantdvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantdvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantdvEXT_ovr_2(id, addr);
    
    private z_VariantubvEXT_adr := GetProcAddress('glVariantubvEXT');
    private z_VariantubvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: Byte)>(z_VariantubvEXT_adr);
    private z_VariantubvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantubvEXT(id: UInt32; addr: array of Byte) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantubvEXT_ovr_0(id, addr[0]) else
      z_VariantubvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantubvEXT(id: UInt32; var addr: Byte) :=
    z_VariantubvEXT_ovr_0(id, addr);
    private z_VariantubvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantubvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantubvEXT_ovr_2(id, addr);
    
    private z_VariantusvEXT_adr := GetProcAddress('glVariantusvEXT');
    private z_VariantusvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: UInt16)>(z_VariantusvEXT_adr);
    private z_VariantusvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantusvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantusvEXT(id: UInt32; addr: array of UInt16) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantusvEXT_ovr_0(id, addr[0]) else
      z_VariantusvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantusvEXT(id: UInt32; var addr: UInt16) :=
    z_VariantusvEXT_ovr_0(id, addr);
    private z_VariantusvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantusvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantusvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantusvEXT_ovr_2(id, addr);
    
    private z_VariantuivEXT_adr := GetProcAddress('glVariantuivEXT');
    private z_VariantuivEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; var addr: UInt32)>(z_VariantuivEXT_adr);
    private z_VariantuivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantuivEXT(id: UInt32; addr: array of UInt32) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantuivEXT_ovr_0(id, addr[0]) else
      z_VariantuivEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantuivEXT(id: UInt32; var addr: UInt32) :=
    z_VariantuivEXT_ovr_0(id, addr);
    private z_VariantuivEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; addr: IntPtr)>(z_VariantuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantuivEXT(id: UInt32; addr: IntPtr) :=
    z_VariantuivEXT_ovr_2(id, addr);
    
    private z_VariantPointerEXT_adr := GetProcAddress('glVariantPointerEXT');
    private z_VariantPointerEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; &type: ScalarType; stride: UInt32; addr: IntPtr)>(z_VariantPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantPointerEXT(id: UInt32; &type: ScalarType; stride: UInt32; addr: IntPtr) :=
    z_VariantPointerEXT_ovr_0(id, &type, stride, addr);
    
    private z_EnableVariantClientStateEXT_adr := GetProcAddress('glEnableVariantClientStateEXT');
    private z_EnableVariantClientStateEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_EnableVariantClientStateEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVariantClientStateEXT(id: UInt32) :=
    z_EnableVariantClientStateEXT_ovr_0(id);
    
    private z_DisableVariantClientStateEXT_adr := GetProcAddress('glDisableVariantClientStateEXT');
    private z_DisableVariantClientStateEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_DisableVariantClientStateEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVariantClientStateEXT(id: UInt32) :=
    z_DisableVariantClientStateEXT_ovr_0(id);
    
    private z_BindLightParameterEXT_adr := GetProcAddress('glBindLightParameterEXT');
    private z_BindLightParameterEXT_ovr_0 := GetProcOrNil&<function(light: LightName; value: LightParameter): UInt32>(z_BindLightParameterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindLightParameterEXT(light: LightName; value: LightParameter): UInt32 :=
    z_BindLightParameterEXT_ovr_0(light, value);
    
    private z_BindMaterialParameterEXT_adr := GetProcAddress('glBindMaterialParameterEXT');
    private z_BindMaterialParameterEXT_ovr_0 := GetProcOrNil&<function(face: MaterialFace; value: MaterialParameter): UInt32>(z_BindMaterialParameterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindMaterialParameterEXT(face: MaterialFace; value: MaterialParameter): UInt32 :=
    z_BindMaterialParameterEXT_ovr_0(face, value);
    
    private z_BindTexGenParameterEXT_adr := GetProcAddress('glBindTexGenParameterEXT');
    private z_BindTexGenParameterEXT_ovr_0 := GetProcOrNil&<function(&unit: TextureUnit; coord: TextureCoordName; value: TextureGenParameter): UInt32>(z_BindTexGenParameterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindTexGenParameterEXT(&unit: TextureUnit; coord: TextureCoordName; value: TextureGenParameter): UInt32 :=
    z_BindTexGenParameterEXT_ovr_0(&unit, coord, value);
    
    private z_BindTextureUnitParameterEXT_adr := GetProcAddress('glBindTextureUnitParameterEXT');
    private z_BindTextureUnitParameterEXT_ovr_0 := GetProcOrNil&<function(&unit: TextureUnit; value: VertexShaderTextureUnitParameter): UInt32>(z_BindTextureUnitParameterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindTextureUnitParameterEXT(&unit: TextureUnit; value: VertexShaderTextureUnitParameter): UInt32 :=
    z_BindTextureUnitParameterEXT_ovr_0(&unit, value);
    
    private z_BindParameterEXT_adr := GetProcAddress('glBindParameterEXT');
    private z_BindParameterEXT_ovr_0 := GetProcOrNil&<function(value: VertexShaderParameterEXT): UInt32>(z_BindParameterEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindParameterEXT(value: VertexShaderParameterEXT): UInt32 :=
    z_BindParameterEXT_ovr_0(value);
    
    private z_IsVariantEnabledEXT_adr := GetProcAddress('glIsVariantEnabledEXT');
    private z_IsVariantEnabledEXT_ovr_0 := GetProcOrNil&<function(id: UInt32; cap: VariantCapEXT): boolean>(z_IsVariantEnabledEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVariantEnabledEXT(id: UInt32; cap: VariantCapEXT): boolean :=
    z_IsVariantEnabledEXT_ovr_0(id, cap);
    
    private z_GetVariantBooleanvEXT_adr := GetProcAddress('glGetVariantBooleanvEXT');
    private z_GetVariantBooleanvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: boolean)>(z_GetVariantBooleanvEXT_adr);
    private z_GetVariantBooleanvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantBooleanvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantBooleanvEXT_ovr_0(id, value, data[0]) else
      z_GetVariantBooleanvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; var data: boolean) :=
    z_GetVariantBooleanvEXT_ovr_0(id, value, data);
    private z_GetVariantBooleanvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantBooleanvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetVariantBooleanvEXT_ovr_2(id, value, data);
    
    private z_GetVariantIntegervEXT_adr := GetProcAddress('glGetVariantIntegervEXT');
    private z_GetVariantIntegervEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: Int32)>(z_GetVariantIntegervEXT_adr);
    private z_GetVariantIntegervEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantIntegervEXT_ovr_0(id, value, data[0]) else
      z_GetVariantIntegervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; var data: Int32) :=
    z_GetVariantIntegervEXT_ovr_0(id, value, data);
    private z_GetVariantIntegervEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetVariantIntegervEXT_ovr_2(id, value, data);
    
    private z_GetVariantFloatvEXT_adr := GetProcAddress('glGetVariantFloatvEXT');
    private z_GetVariantFloatvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: single)>(z_GetVariantFloatvEXT_adr);
    private z_GetVariantFloatvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantFloatvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantFloatvEXT_ovr_0(id, value, data[0]) else
      z_GetVariantFloatvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; var data: single) :=
    z_GetVariantFloatvEXT_ovr_0(id, value, data);
    private z_GetVariantFloatvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantFloatvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetVariantFloatvEXT_ovr_2(id, value, data);
    
    private z_GetVariantPointervEXT_adr := GetProcAddress('glGetVariantPointervEXT');
    private z_GetVariantPointervEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: IntPtr)>(z_GetVariantPointervEXT_adr);
    private z_GetVariantPointervEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetVariantPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantPointervEXT(id: UInt32; value: GetVariantValueEXT; data: array of IntPtr) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantPointervEXT_ovr_0(id, value, data[0]) else
      z_GetVariantPointervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantPointervEXT(id: UInt32; value: GetVariantValueEXT; var data: IntPtr) :=
    z_GetVariantPointervEXT_ovr_0(id, value, data);
    private z_GetVariantPointervEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: pointer)>(z_GetVariantPointervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantPointervEXT(id: UInt32; value: GetVariantValueEXT; data: pointer) :=
    z_GetVariantPointervEXT_ovr_2(id, value, data);
    
    private z_GetInvariantBooleanvEXT_adr := GetProcAddress('glGetInvariantBooleanvEXT');
    private z_GetInvariantBooleanvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: boolean)>(z_GetInvariantBooleanvEXT_adr);
    private z_GetInvariantBooleanvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetInvariantBooleanvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInvariantBooleanvEXT_ovr_0(id, value, data[0]) else
      z_GetInvariantBooleanvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; var data: boolean) :=
    z_GetInvariantBooleanvEXT_ovr_0(id, value, data);
    private z_GetInvariantBooleanvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetInvariantBooleanvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetInvariantBooleanvEXT_ovr_2(id, value, data);
    
    private z_GetInvariantIntegervEXT_adr := GetProcAddress('glGetInvariantIntegervEXT');
    private z_GetInvariantIntegervEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: Int32)>(z_GetInvariantIntegervEXT_adr);
    private z_GetInvariantIntegervEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetInvariantIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInvariantIntegervEXT_ovr_0(id, value, data[0]) else
      z_GetInvariantIntegervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; var data: Int32) :=
    z_GetInvariantIntegervEXT_ovr_0(id, value, data);
    private z_GetInvariantIntegervEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetInvariantIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetInvariantIntegervEXT_ovr_2(id, value, data);
    
    private z_GetInvariantFloatvEXT_adr := GetProcAddress('glGetInvariantFloatvEXT');
    private z_GetInvariantFloatvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: single)>(z_GetInvariantFloatvEXT_adr);
    private z_GetInvariantFloatvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetInvariantFloatvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInvariantFloatvEXT_ovr_0(id, value, data[0]) else
      z_GetInvariantFloatvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; var data: single) :=
    z_GetInvariantFloatvEXT_ovr_0(id, value, data);
    private z_GetInvariantFloatvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetInvariantFloatvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetInvariantFloatvEXT_ovr_2(id, value, data);
    
    private z_GetLocalConstantBooleanvEXT_adr := GetProcAddress('glGetLocalConstantBooleanvEXT');
    private z_GetLocalConstantBooleanvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: boolean)>(z_GetLocalConstantBooleanvEXT_adr);
    private z_GetLocalConstantBooleanvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetLocalConstantBooleanvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetLocalConstantBooleanvEXT_ovr_0(id, value, data[0]) else
      z_GetLocalConstantBooleanvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; var data: boolean) :=
    z_GetLocalConstantBooleanvEXT_ovr_0(id, value, data);
    private z_GetLocalConstantBooleanvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetLocalConstantBooleanvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetLocalConstantBooleanvEXT_ovr_2(id, value, data);
    
    private z_GetLocalConstantIntegervEXT_adr := GetProcAddress('glGetLocalConstantIntegervEXT');
    private z_GetLocalConstantIntegervEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: Int32)>(z_GetLocalConstantIntegervEXT_adr);
    private z_GetLocalConstantIntegervEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetLocalConstantIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetLocalConstantIntegervEXT_ovr_0(id, value, data[0]) else
      z_GetLocalConstantIntegervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantIntegervEXT(id: UInt32; value: GetVariantValueEXT; var data: Int32) :=
    z_GetLocalConstantIntegervEXT_ovr_0(id, value, data);
    private z_GetLocalConstantIntegervEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetLocalConstantIntegervEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetLocalConstantIntegervEXT_ovr_2(id, value, data);
    
    private z_GetLocalConstantFloatvEXT_adr := GetProcAddress('glGetLocalConstantFloatvEXT');
    private z_GetLocalConstantFloatvEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; var data: single)>(z_GetLocalConstantFloatvEXT_adr);
    private z_GetLocalConstantFloatvEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetLocalConstantFloatvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetLocalConstantFloatvEXT_ovr_0(id, value, data[0]) else
      z_GetLocalConstantFloatvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantFloatvEXT(id: UInt32; value: GetVariantValueEXT; var data: single) :=
    z_GetLocalConstantFloatvEXT_ovr_0(id, value, data);
    private z_GetLocalConstantFloatvEXT_ovr_2 := GetProcOrNil&<procedure(id: UInt32; value: GetVariantValueEXT; data: IntPtr)>(z_GetLocalConstantFloatvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetLocalConstantFloatvEXT_ovr_2(id, value, data);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexWeightingEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_vertex_weighting';
    
    private z_VertexWeightfEXT_adr := GetProcAddress('glVertexWeightfEXT');
    private z_VertexWeightfEXT_ovr_0 := GetProcOrNil&<procedure(weight: single)>(z_VertexWeightfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfEXT(weight: single) :=
    z_VertexWeightfEXT_ovr_0(weight);
    
    private z_VertexWeightfvEXT_adr := GetProcAddress('glVertexWeightfvEXT');
    private z_VertexWeightfvEXT_ovr_0 := GetProcOrNil&<procedure(var weight: single)>(z_VertexWeightfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfvEXT(var weight: single) :=
    z_VertexWeightfvEXT_ovr_0(weight);
    private z_VertexWeightfvEXT_ovr_1 := GetProcOrNil&<procedure(weight: IntPtr)>(z_VertexWeightfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfvEXT(weight: IntPtr) :=
    z_VertexWeightfvEXT_ovr_1(weight);
    
    private z_VertexWeightPointerEXT_adr := GetProcAddress('glVertexWeightPointerEXT');
    private z_VertexWeightPointerEXT_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexWeightPointerTypeEXT; stride: Int32; pointer: IntPtr)>(z_VertexWeightPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightPointerEXT(size: Int32; &type: VertexWeightPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_VertexWeightPointerEXT_ovr_0(size, &type, stride, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glWin32KeyedMutexEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_win32_keyed_mutex';
    
    private z_AcquireKeyedMutexWin32EXT_adr := GetProcAddress('glAcquireKeyedMutexWin32EXT');
    private z_AcquireKeyedMutexWin32EXT_ovr_0 := GetProcOrNil&<function(memory: UInt32; key: UInt64; timeout: UInt32): boolean>(z_AcquireKeyedMutexWin32EXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AcquireKeyedMutexWin32EXT(memory: UInt32; key: UInt64; timeout: UInt32): boolean :=
    z_AcquireKeyedMutexWin32EXT_ovr_0(memory, key, timeout);
    
    private z_ReleaseKeyedMutexWin32EXT_adr := GetProcAddress('glReleaseKeyedMutexWin32EXT');
    private z_ReleaseKeyedMutexWin32EXT_ovr_0 := GetProcOrNil&<function(memory: UInt32; key: UInt64): boolean>(z_ReleaseKeyedMutexWin32EXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseKeyedMutexWin32EXT(memory: UInt32; key: UInt64): boolean :=
    z_ReleaseKeyedMutexWin32EXT_ovr_0(memory, key);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glWindowRectanglesEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_window_rectangles';
    
    private z_WindowRectanglesEXT_adr := GetProcAddress('glWindowRectanglesEXT');
    private z_WindowRectanglesEXT_ovr_0 := GetProcOrNil&<procedure(mode: DummyEnum; count: Int32; var box: Int32)>(z_WindowRectanglesEXT_adr);
    private z_WindowRectanglesEXT_ovr_0_anh0001 := GetProcOrNil&<procedure(mode: DummyEnum; count: Int32; box: IntPtr)>(z_WindowRectanglesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowRectanglesEXT(mode: DummyEnum; count: Int32; box: array of Int32) :=
    if (box<>nil) and (box.Length<>0) then
      z_WindowRectanglesEXT_ovr_0(mode, count, box[0]) else
      z_WindowRectanglesEXT_ovr_0_anh0001(mode, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowRectanglesEXT(mode: DummyEnum; count: Int32; var box: Int32) :=
    z_WindowRectanglesEXT_ovr_0(mode, count, box);
    private z_WindowRectanglesEXT_ovr_2 := GetProcOrNil&<procedure(mode: DummyEnum; count: Int32; box: IntPtr)>(z_WindowRectanglesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowRectanglesEXT(mode: DummyEnum; count: Int32; box: IntPtr) :=
    z_WindowRectanglesEXT_ovr_2(mode, count, box);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glX11SyncObjectEXT = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_x11_sync_object';
    
    private z_ImportSyncEXT_adr := GetProcAddress('glImportSyncEXT');
    private z_ImportSyncEXT_ovr_0 := GetProcOrNil&<function(external_sync_type: DummyEnum; external_sync: IntPtr; flags: DummyFlags): gl_sync>(z_ImportSyncEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ImportSyncEXT(external_sync_type: DummyEnum; external_sync: IntPtr; flags: DummyFlags): gl_sync :=
    z_ImportSyncEXT_ovr_0(external_sync_type, external_sync, flags);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFrameTerminatorGREMEDY = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'GREMEDY_frame_terminator';
    
    private z_FrameTerminatorGREMEDY_adr := GetProcAddress('glFrameTerminatorGREMEDY');
    private z_FrameTerminatorGREMEDY_ovr_0 := GetProcOrNil&<procedure>(z_FrameTerminatorGREMEDY_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrameTerminatorGREMEDY :=
    z_FrameTerminatorGREMEDY_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glStringMarkerGREMEDY = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'GREMEDY_string_marker';
    
    private z_StringMarkerGREMEDY_adr := GetProcAddress('glStringMarkerGREMEDY');
    private z_StringMarkerGREMEDY_ovr_0 := GetProcOrNil&<procedure(len: Int32; string: IntPtr)>(z_StringMarkerGREMEDY_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StringMarkerGREMEDY(len: Int32; string: IntPtr) :=
    z_StringMarkerGREMEDY_ovr_0(len, string);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glImageTransformHP = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'HP_image_transform';
    
    private z_ImageTransformParameteriHP_adr := GetProcAddress('glImageTransformParameteriHP');
    private z_ImageTransformParameteriHP_ovr_0 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: Int32)>(z_ImageTransformParameteriHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameteriHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: Int32) :=
    z_ImageTransformParameteriHP_ovr_0(target, pname, param);
    
    private z_ImageTransformParameterfHP_adr := GetProcAddress('glImageTransformParameterfHP');
    private z_ImageTransformParameterfHP_ovr_0 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: single)>(z_ImageTransformParameterfHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: single) :=
    z_ImageTransformParameterfHP_ovr_0(target, pname, param);
    
    private z_ImageTransformParameterivHP_adr := GetProcAddress('glImageTransformParameterivHP');
    private z_ImageTransformParameterivHP_ovr_0 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32)>(z_ImageTransformParameterivHP_adr);
    private z_ImageTransformParameterivHP_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_ImageTransformParameterivHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ImageTransformParameterivHP_ovr_0(target, pname, &params[0]) else
      z_ImageTransformParameterivHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32) :=
    z_ImageTransformParameterivHP_ovr_0(target, pname, &params);
    private z_ImageTransformParameterivHP_ovr_2 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_ImageTransformParameterivHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_ImageTransformParameterivHP_ovr_2(target, pname, &params);
    
    private z_ImageTransformParameterfvHP_adr := GetProcAddress('glImageTransformParameterfvHP');
    private z_ImageTransformParameterfvHP_ovr_0 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single)>(z_ImageTransformParameterfvHP_adr);
    private z_ImageTransformParameterfvHP_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_ImageTransformParameterfvHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ImageTransformParameterfvHP_ovr_0(target, pname, &params[0]) else
      z_ImageTransformParameterfvHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single) :=
    z_ImageTransformParameterfvHP_ovr_0(target, pname, &params);
    private z_ImageTransformParameterfvHP_ovr_2 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_ImageTransformParameterfvHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_ImageTransformParameterfvHP_ovr_2(target, pname, &params);
    
    private z_GetImageTransformParameterivHP_adr := GetProcAddress('glGetImageTransformParameterivHP');
    private z_GetImageTransformParameterivHP_ovr_0 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32)>(z_GetImageTransformParameterivHP_adr);
    private z_GetImageTransformParameterivHP_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_GetImageTransformParameterivHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetImageTransformParameterivHP_ovr_0(target, pname, &params[0]) else
      z_GetImageTransformParameterivHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32) :=
    z_GetImageTransformParameterivHP_ovr_0(target, pname, &params);
    private z_GetImageTransformParameterivHP_ovr_2 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_GetImageTransformParameterivHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_GetImageTransformParameterivHP_ovr_2(target, pname, &params);
    
    private z_GetImageTransformParameterfvHP_adr := GetProcAddress('glGetImageTransformParameterfvHP');
    private z_GetImageTransformParameterfvHP_ovr_0 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single)>(z_GetImageTransformParameterfvHP_adr);
    private z_GetImageTransformParameterfvHP_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_GetImageTransformParameterfvHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetImageTransformParameterfvHP_ovr_0(target, pname, &params[0]) else
      z_GetImageTransformParameterfvHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single) :=
    z_GetImageTransformParameterfvHP_ovr_0(target, pname, &params);
    private z_GetImageTransformParameterfvHP_ovr_2 := GetProcOrNil&<procedure(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr)>(z_GetImageTransformParameterfvHP_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_GetImageTransformParameterfvHP_ovr_2(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultimodeDrawArraysIBM = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'IBM_multimode_draw_arrays';
    
    private z_MultiModeDrawArraysIBM_adr := GetProcAddress('glMultiModeDrawArraysIBM');
    private z_MultiModeDrawArraysIBM_ovr_0 := GetProcOrNil&<procedure(var mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh001000 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh011000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh010100 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh001100 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_0_anh011100 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (first<>nil) and (first.Length<>0) then
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0(mode[0], first[0], count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode[0], first[0], IntPtr.Zero, primcount, modestride) else
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode[0], IntPtr.Zero, count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh001100(mode[0], IntPtr.Zero, IntPtr.Zero, primcount, modestride) else
      if (first<>nil) and (first.Length<>0) then
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first[0], count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh010100(IntPtr.Zero, first[0], IntPtr.Zero, primcount, modestride) else
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_1_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_1_anh001000 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_1_anh011000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0(mode[0], first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode[0], IntPtr.Zero, count, primcount, modestride) else
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_2 := GetProcOrNil&<procedure(var mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_2_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_2_anh001000 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_2_anh011000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_2(mode[0], first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_2_anh001000(mode[0], IntPtr.Zero, count, primcount, modestride) else
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_2_anh010000(IntPtr.Zero, first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_2_anh011000(IntPtr.Zero, IntPtr.Zero, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_3_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_3_anh010100 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0(mode[0], first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode[0], first, IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh010100(IntPtr.Zero, first, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_4_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_0(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_5_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_2(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_2_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_6 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_6_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_6_anh000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_6_anh010100 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_6(mode[0], first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_6_anh000100(mode[0], first, IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_6_anh010000(IntPtr.Zero, first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_6_anh010100(IntPtr.Zero, first, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_7_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_6(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_6_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_8 := GetProcOrNil&<procedure(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_8_anh010000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_8(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_8_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0(mode, first[0], count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode, first[0], IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode, IntPtr.Zero, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh001100(mode, IntPtr.Zero, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_0(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_2(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_2_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_0(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_0(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_2(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_6(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_6_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_6(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_8(mode, first, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_18 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_18_anh001000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_18_anh000100 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_18_anh001100 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: array of Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_18(mode, first[0], count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_18_anh000100(mode, first[0], IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_18_anh001000(mode, IntPtr.Zero, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_18_anh001100(mode, IntPtr.Zero, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_19_anh001000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: array of Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_18(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_18_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_20 := GetProcOrNil&<procedure(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_20_anh001000 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: array of Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_20(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_20_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; var first: Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_18(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_18_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_18(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_20(mode, first, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_24 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    private z_MultiModeDrawArraysIBM_ovr_24_anh000100 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: IntPtr; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_24(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_24_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_24(mode, first, count, primcount, modestride);
    private z_MultiModeDrawArraysIBM_ovr_26 := GetProcOrNil&<procedure(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawArraysIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_26(mode, first, count, primcount, modestride);
    
    private z_MultiModeDrawElementsIBM_adr := GetProcAddress('glMultiModeDrawElementsIBM');
    private z_MultiModeDrawElementsIBM_ovr_0 := GetProcOrNil&<procedure(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0010000 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0110000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0100100 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0010100 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_0_anh0110100 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0(mode[0], count[0], &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode[0], count[0], &type, IntPtr.Zero, primcount, modestride) else
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode[0], IntPtr.Zero, &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0010100(mode[0], IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count[0], &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0100100(IntPtr.Zero, count[0], &type, IntPtr.Zero, primcount, modestride) else
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0_anh0110000(IntPtr.Zero, IntPtr.Zero, &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0110100(IntPtr.Zero, IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_1_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_1_anh0010000 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_1_anh0110000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0(mode[0], count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode[0], IntPtr.Zero, &type, indices, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0110000(IntPtr.Zero, IntPtr.Zero, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_2 := GetProcOrNil&<procedure(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_2_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_2_anh0010000 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_2_anh0110000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_2(mode[0], count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_2_anh0010000(mode[0], IntPtr.Zero, &type, indices, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_2_anh0100000(IntPtr.Zero, count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_2_anh0110000(IntPtr.Zero, IntPtr.Zero, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_3_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_3_anh0000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_3_anh0100100 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0(mode[0], count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode[0], count, &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0100100(IntPtr.Zero, count, &type, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_4_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_0(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_5_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_2(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_2_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_6 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_6_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_6_anh0000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_6_anh0100100 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_6(mode[0], count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_6_anh0000100(mode[0], count, &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_6_anh0100000(IntPtr.Zero, count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_6_anh0100100(IntPtr.Zero, count, &type, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_7_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_6(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_6_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_8 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_8_anh0100000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_8(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_8_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_9_anh0000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_9_anh0010100 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0(mode, count[0], &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_0(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_2(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_12_anh0000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_0(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_0(mode, count, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_2(mode, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_15_anh0000100 := GetProcOrNil&<procedure(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_6(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_6_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_6(mode, count, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_8(mode, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_18 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_18_anh0010000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_18_anh0000100 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_18_anh0010100 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_18(mode, count[0], &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_18_anh0000100(mode, count[0], &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_18_anh0010000(mode, IntPtr.Zero, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_18_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_19_anh0010000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_18(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_18_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_20 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_20_anh0010000 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_20(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_20_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_21_anh0000100 := GetProcOrNil&<procedure(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_18(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_18(mode, count, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_20(mode, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_24 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    private z_MultiModeDrawElementsIBM_ovr_24_anh0000100 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_24(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_24_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_24(mode, count, &type, indices, primcount, modestride);
    private z_MultiModeDrawElementsIBM_ovr_26 := GetProcOrNil&<procedure(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32)>(z_MultiModeDrawElementsIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_26(mode, count, &type, indices, primcount, modestride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glStaticDataIBM = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'IBM_static_data';
    
    private z_FlushStaticDataIBM_adr := GetProcAddress('glFlushStaticDataIBM');
    private z_FlushStaticDataIBM_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum)>(z_FlushStaticDataIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushStaticDataIBM(target: DummyEnum) :=
    z_FlushStaticDataIBM_ovr_0(target);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayListsIBM = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'IBM_vertex_array_lists';
    
    private z_ColorPointerListIBM_adr := GetProcAddress('glColorPointerListIBM');
    private z_ColorPointerListIBM_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_ColorPointerListIBM_adr);
    private z_ColorPointerListIBM_ovr_0_anh000010 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_ColorPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerListIBM(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_ColorPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_ColorPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerListIBM(size: Int32; &type: ColorPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_ColorPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private z_ColorPointerListIBM_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_ColorPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerListIBM(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_ColorPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
    private z_SecondaryColorPointerListIBM_adr := GetProcAddress('glSecondaryColorPointerListIBM');
    private z_SecondaryColorPointerListIBM_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_SecondaryColorPointerListIBM_adr);
    private z_SecondaryColorPointerListIBM_ovr_0_anh000010 := GetProcOrNil&<procedure(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_SecondaryColorPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerListIBM(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_SecondaryColorPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_SecondaryColorPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerListIBM(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_SecondaryColorPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private z_SecondaryColorPointerListIBM_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_SecondaryColorPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerListIBM(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_SecondaryColorPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
    private z_EdgeFlagPointerListIBM_adr := GetProcAddress('glEdgeFlagPointerListIBM');
    private z_EdgeFlagPointerListIBM_ovr_0 := GetProcOrNil&<procedure(stride: Int32; var pointer: IntPtr; ptrstride: Int32)>(z_EdgeFlagPointerListIBM_adr);
    private z_EdgeFlagPointerListIBM_ovr_0_anh0010 := GetProcOrNil&<procedure(stride: Int32; pointer: IntPtr; ptrstride: Int32)>(z_EdgeFlagPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerListIBM(stride: Int32; pointer: array of array of Byte; ptrstride: Int32);
    begin
      var par_2_temp_arr1: array of IntPtr;
      try
        par_2_temp_arr1 := pointer?.ConvertAll(arr_el1->begin
          if (arr_el1=nil) or (arr_el1.Length=0) then
            Result := IntPtr.Zero else
          begin
            var l := Marshal.SizeOf&<Byte>*arr_el1.Length;
            Result := Marshal.AllocHGlobal(l);
            Marshal.Copy(arr_el1,0,Result,l);
          end;
        end);
        if (par_2_temp_arr1<>nil) and (par_2_temp_arr1.Length<>0) then
          z_EdgeFlagPointerListIBM_ovr_0(stride, par_2_temp_arr1[0], ptrstride) else
          z_EdgeFlagPointerListIBM_ovr_0_anh0010(stride, IntPtr.Zero, ptrstride);
      finally
        if par_2_temp_arr1<>nil then foreach var arr_el1 in par_2_temp_arr1 do Marshal.FreeHGlobal(arr_el1);
      end;
    end;
    private z_EdgeFlagPointerListIBM_ovr_1_anh0010 := GetProcOrNil&<procedure(stride: Int32; pointer: IntPtr; ptrstride: Int32)>(z_EdgeFlagPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerListIBM(stride: Int32; pointer: array of IntPtr; ptrstride: Int32) :=
    if (pointer<>nil) and (pointer.Length<>0) then
      z_EdgeFlagPointerListIBM_ovr_0(stride, pointer[0], ptrstride) else
      z_EdgeFlagPointerListIBM_ovr_0_anh0010(stride, IntPtr.Zero, ptrstride);
    private z_EdgeFlagPointerListIBM_ovr_2 := GetProcOrNil&<procedure(stride: Int32; pointer: IntPtr; ptrstride: Int32)>(z_EdgeFlagPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerListIBM(stride: Int32; pointer: IntPtr; ptrstride: Int32) :=
    z_EdgeFlagPointerListIBM_ovr_2(stride, pointer, ptrstride);
    
    private z_FogCoordPointerListIBM_adr := GetProcAddress('glFogCoordPointerListIBM');
    private z_FogCoordPointerListIBM_ovr_0 := GetProcOrNil&<procedure(&type: FogPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_FogCoordPointerListIBM_adr);
    private z_FogCoordPointerListIBM_ovr_0_anh00010 := GetProcOrNil&<procedure(&type: FogPointerTypeIBM; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_FogCoordPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerListIBM(&type: FogPointerTypeIBM; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_FogCoordPointerListIBM_ovr_0(&type, stride, _pointer[0], ptrstride) else
      z_FogCoordPointerListIBM_ovr_0_anh00010(&type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerListIBM(&type: FogPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_FogCoordPointerListIBM_ovr_0(&type, stride, _pointer, ptrstride);
    private z_FogCoordPointerListIBM_ovr_2 := GetProcOrNil&<procedure(&type: FogPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_FogCoordPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerListIBM(&type: FogPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_FogCoordPointerListIBM_ovr_2(&type, stride, _pointer, ptrstride);
    
    private z_IndexPointerListIBM_adr := GetProcAddress('glIndexPointerListIBM');
    private z_IndexPointerListIBM_ovr_0 := GetProcOrNil&<procedure(&type: IndexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_IndexPointerListIBM_adr);
    private z_IndexPointerListIBM_ovr_0_anh00010 := GetProcOrNil&<procedure(&type: IndexPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_IndexPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerListIBM(&type: IndexPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_IndexPointerListIBM_ovr_0(&type, stride, _pointer[0], ptrstride) else
      z_IndexPointerListIBM_ovr_0_anh00010(&type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerListIBM(&type: IndexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_IndexPointerListIBM_ovr_0(&type, stride, _pointer, ptrstride);
    private z_IndexPointerListIBM_ovr_2 := GetProcOrNil&<procedure(&type: IndexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_IndexPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerListIBM(&type: IndexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_IndexPointerListIBM_ovr_2(&type, stride, _pointer, ptrstride);
    
    private z_NormalPointerListIBM_adr := GetProcAddress('glNormalPointerListIBM');
    private z_NormalPointerListIBM_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_NormalPointerListIBM_adr);
    private z_NormalPointerListIBM_ovr_0_anh00010 := GetProcOrNil&<procedure(&type: NormalPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_NormalPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerListIBM(&type: NormalPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_NormalPointerListIBM_ovr_0(&type, stride, _pointer[0], ptrstride) else
      z_NormalPointerListIBM_ovr_0_anh00010(&type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerListIBM(&type: NormalPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_NormalPointerListIBM_ovr_0(&type, stride, _pointer, ptrstride);
    private z_NormalPointerListIBM_ovr_2 := GetProcOrNil&<procedure(&type: NormalPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_NormalPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerListIBM(&type: NormalPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_NormalPointerListIBM_ovr_2(&type, stride, _pointer, ptrstride);
    
    private z_TexCoordPointerListIBM_adr := GetProcAddress('glTexCoordPointerListIBM');
    private z_TexCoordPointerListIBM_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: TexCoordPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_TexCoordPointerListIBM_adr);
    private z_TexCoordPointerListIBM_ovr_0_anh000010 := GetProcOrNil&<procedure(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_TexCoordPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerListIBM(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_TexCoordPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_TexCoordPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerListIBM(size: Int32; &type: TexCoordPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_TexCoordPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private z_TexCoordPointerListIBM_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_TexCoordPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerListIBM(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_TexCoordPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
    private z_VertexPointerListIBM_adr := GetProcAddress('glVertexPointerListIBM');
    private z_VertexPointerListIBM_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32)>(z_VertexPointerListIBM_adr);
    private z_VertexPointerListIBM_ovr_0_anh000010 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32)>(z_VertexPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerListIBM(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_VertexPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_VertexPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerListIBM(size: Int32; &type: VertexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_VertexPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private z_VertexPointerListIBM_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32)>(z_VertexPointerListIBM_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerListIBM(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_VertexPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendFuncSeparateINGR = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'INGR_blend_func_separate';
    
    private z_BlendFuncSeparateINGR_adr := GetProcAddress('glBlendFuncSeparateINGR');
    private z_BlendFuncSeparateINGR_ovr_0 := GetProcOrNil&<procedure(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor)>(z_BlendFuncSeparateINGR_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateINGR(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor) :=
    z_BlendFuncSeparateINGR_ovr_0(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferCMAAINTEL = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'INTEL_framebuffer_CMAA';
    
    private z_ApplyFramebufferAttachmentCMAAINTEL_adr := GetProcAddress('glApplyFramebufferAttachmentCMAAINTEL');
    private z_ApplyFramebufferAttachmentCMAAINTEL_ovr_0 := GetProcOrNil&<procedure>(z_ApplyFramebufferAttachmentCMAAINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ApplyFramebufferAttachmentCMAAINTEL :=
    z_ApplyFramebufferAttachmentCMAAINTEL_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMapTextureINTEL = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'INTEL_map_texture';
    
    private z_SyncTextureINTEL_adr := GetProcAddress('glSyncTextureINTEL');
    private z_SyncTextureINTEL_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture)>(z_SyncTextureINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SyncTextureINTEL(texture: gl_texture) :=
    z_SyncTextureINTEL_ovr_0(texture);
    
    private z_UnmapTexture2DINTEL_adr := GetProcAddress('glUnmapTexture2DINTEL');
    private z_UnmapTexture2DINTEL_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; level: Int32)>(z_UnmapTexture2DINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UnmapTexture2DINTEL(texture: gl_texture; level: Int32) :=
    z_UnmapTexture2DINTEL_ovr_0(texture, level);
    
    private z_MapTexture2DINTEL_adr := GetProcAddress('glMapTexture2DINTEL');
    private z_MapTexture2DINTEL_ovr_0 := GetProcOrNil&<function(texture: gl_texture; level: Int32; access: DummyFlags; var stride: Int32; var layout: DummyEnum): IntPtr>(z_MapTexture2DINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: gl_texture; level: Int32; access: DummyFlags; var stride: Int32; var layout: DummyEnum): IntPtr :=
    z_MapTexture2DINTEL_ovr_0(texture, level, access, stride, layout);
    private z_MapTexture2DINTEL_ovr_1 := GetProcOrNil&<function(texture: gl_texture; level: Int32; access: DummyFlags; var stride: Int32; layout: IntPtr): IntPtr>(z_MapTexture2DINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: gl_texture; level: Int32; access: DummyFlags; var stride: Int32; layout: IntPtr): IntPtr :=
    z_MapTexture2DINTEL_ovr_1(texture, level, access, stride, layout);
    private z_MapTexture2DINTEL_ovr_2 := GetProcOrNil&<function(texture: gl_texture; level: Int32; access: DummyFlags; stride: IntPtr; var layout: DummyEnum): IntPtr>(z_MapTexture2DINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: gl_texture; level: Int32; access: DummyFlags; stride: IntPtr; var layout: DummyEnum): IntPtr :=
    z_MapTexture2DINTEL_ovr_2(texture, level, access, stride, layout);
    private z_MapTexture2DINTEL_ovr_3 := GetProcOrNil&<function(texture: gl_texture; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr>(z_MapTexture2DINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: gl_texture; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr :=
    z_MapTexture2DINTEL_ovr_3(texture, level, access, stride, layout);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glParallelArraysINTEL = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'INTEL_parallel_arrays';
    
    private z_VertexPointervINTEL_adr := GetProcAddress('glVertexPointervINTEL');
    private z_VertexPointervINTEL_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; var _pointer: IntPtr)>(z_VertexPointervINTEL_adr);
    private z_VertexPointervINTEL_ovr_0_anh0001 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; _pointer: IntPtr)>(z_VertexPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_VertexPointervINTEL_ovr_0(size, &type, _pointer[0]) else
      z_VertexPointervINTEL_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointervINTEL(size: Int32; &type: VertexPointerType; var _pointer: IntPtr) :=
    z_VertexPointervINTEL_ovr_0(size, &type, _pointer);
    private z_VertexPointervINTEL_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; _pointer: pointer)>(z_VertexPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: pointer) :=
    z_VertexPointervINTEL_ovr_2(size, &type, _pointer);
    
    private z_NormalPointervINTEL_adr := GetProcAddress('glNormalPointervINTEL');
    private z_NormalPointervINTEL_ovr_0 := GetProcOrNil&<procedure(&type: NormalPointerType; var _pointer: IntPtr)>(z_NormalPointervINTEL_adr);
    private z_NormalPointervINTEL_ovr_0_anh001 := GetProcOrNil&<procedure(&type: NormalPointerType; _pointer: IntPtr)>(z_NormalPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointervINTEL(&type: NormalPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_NormalPointervINTEL_ovr_0(&type, _pointer[0]) else
      z_NormalPointervINTEL_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointervINTEL(&type: NormalPointerType; var _pointer: IntPtr) :=
    z_NormalPointervINTEL_ovr_0(&type, _pointer);
    private z_NormalPointervINTEL_ovr_2 := GetProcOrNil&<procedure(&type: NormalPointerType; _pointer: pointer)>(z_NormalPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointervINTEL(&type: NormalPointerType; _pointer: pointer) :=
    z_NormalPointervINTEL_ovr_2(&type, _pointer);
    
    private z_ColorPointervINTEL_adr := GetProcAddress('glColorPointervINTEL');
    private z_ColorPointervINTEL_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; var _pointer: IntPtr)>(z_ColorPointervINTEL_adr);
    private z_ColorPointervINTEL_ovr_0_anh0001 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; _pointer: IntPtr)>(z_ColorPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_ColorPointervINTEL_ovr_0(size, &type, _pointer[0]) else
      z_ColorPointervINTEL_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointervINTEL(size: Int32; &type: VertexPointerType; var _pointer: IntPtr) :=
    z_ColorPointervINTEL_ovr_0(size, &type, _pointer);
    private z_ColorPointervINTEL_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; _pointer: pointer)>(z_ColorPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: pointer) :=
    z_ColorPointervINTEL_ovr_2(size, &type, _pointer);
    
    private z_TexCoordPointervINTEL_adr := GetProcAddress('glTexCoordPointervINTEL');
    private z_TexCoordPointervINTEL_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; var _pointer: IntPtr)>(z_TexCoordPointervINTEL_adr);
    private z_TexCoordPointervINTEL_ovr_0_anh0001 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; _pointer: IntPtr)>(z_TexCoordPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_TexCoordPointervINTEL_ovr_0(size, &type, _pointer[0]) else
      z_TexCoordPointervINTEL_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointervINTEL(size: Int32; &type: VertexPointerType; var _pointer: IntPtr) :=
    z_TexCoordPointervINTEL_ovr_0(size, &type, _pointer);
    private z_TexCoordPointervINTEL_ovr_2 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; _pointer: pointer)>(z_TexCoordPointervINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: pointer) :=
    z_TexCoordPointervINTEL_ovr_2(size, &type, _pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPerformanceQueryINTEL = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'INTEL_performance_query';
    
    private z_BeginPerfQueryINTEL_adr := GetProcAddress('glBeginPerfQueryINTEL');
    private z_BeginPerfQueryINTEL_ovr_0 := GetProcOrNil&<procedure(queryHandle: gl_perf_query_handle_INTEL)>(z_BeginPerfQueryINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginPerfQueryINTEL(queryHandle: gl_perf_query_handle_INTEL) :=
    z_BeginPerfQueryINTEL_ovr_0(queryHandle);
    
    private z_CreatePerfQueryINTEL_adr := GetProcAddress('glCreatePerfQueryINTEL');
    private z_CreatePerfQueryINTEL_ovr_0 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; var queryHandle: gl_perf_query_handle_INTEL)>(z_CreatePerfQueryINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreatePerfQueryINTEL(queryId: gl_perf_query_id_INTEL; var queryHandle: gl_perf_query_handle_INTEL) :=
    z_CreatePerfQueryINTEL_ovr_0(queryId, queryHandle);
    private z_CreatePerfQueryINTEL_ovr_1 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; queryHandle: IntPtr)>(z_CreatePerfQueryINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreatePerfQueryINTEL(queryId: gl_perf_query_id_INTEL; queryHandle: IntPtr) :=
    z_CreatePerfQueryINTEL_ovr_1(queryId, queryHandle);
    
    private z_DeletePerfQueryINTEL_adr := GetProcAddress('glDeletePerfQueryINTEL');
    private z_DeletePerfQueryINTEL_ovr_0 := GetProcOrNil&<procedure(queryHandle: gl_perf_query_handle_INTEL)>(z_DeletePerfQueryINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfQueryINTEL(queryHandle: gl_perf_query_handle_INTEL) :=
    z_DeletePerfQueryINTEL_ovr_0(queryHandle);
    
    private z_EndPerfQueryINTEL_adr := GetProcAddress('glEndPerfQueryINTEL');
    private z_EndPerfQueryINTEL_ovr_0 := GetProcOrNil&<procedure(queryHandle: gl_perf_query_handle_INTEL)>(z_EndPerfQueryINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndPerfQueryINTEL(queryHandle: gl_perf_query_handle_INTEL) :=
    z_EndPerfQueryINTEL_ovr_0(queryHandle);
    
    private z_GetFirstPerfQueryIdINTEL_adr := GetProcAddress('glGetFirstPerfQueryIdINTEL');
    private z_GetFirstPerfQueryIdINTEL_ovr_0 := GetProcOrNil&<procedure(var queryId: gl_perf_query_id_INTEL)>(z_GetFirstPerfQueryIdINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFirstPerfQueryIdINTEL(var queryId: gl_perf_query_id_INTEL) :=
    z_GetFirstPerfQueryIdINTEL_ovr_0(queryId);
    private z_GetFirstPerfQueryIdINTEL_ovr_1 := GetProcOrNil&<procedure(queryId: IntPtr)>(z_GetFirstPerfQueryIdINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFirstPerfQueryIdINTEL(queryId: IntPtr) :=
    z_GetFirstPerfQueryIdINTEL_ovr_1(queryId);
    
    private z_GetNextPerfQueryIdINTEL_adr := GetProcAddress('glGetNextPerfQueryIdINTEL');
    private z_GetNextPerfQueryIdINTEL_ovr_0 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; nextQueryId: gl_perf_query_id_INTEL)>(z_GetNextPerfQueryIdINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNextPerfQueryIdINTEL(queryId: gl_perf_query_id_INTEL; nextQueryId: gl_perf_query_id_INTEL) :=
    z_GetNextPerfQueryIdINTEL_ovr_0(queryId, nextQueryId);
    private z_GetNextPerfQueryIdINTEL_ovr_1 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; nextQueryId: IntPtr)>(z_GetNextPerfQueryIdINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNextPerfQueryIdINTEL(queryId: gl_perf_query_id_INTEL; nextQueryId: IntPtr) :=
    z_GetNextPerfQueryIdINTEL_ovr_1(queryId, nextQueryId);
    
    private z_GetPerfCounterInfoINTEL_adr := GetProcAddress('glGetPerfCounterInfoINTEL');
    private z_GetPerfCounterInfoINTEL_ovr_0 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; var counterOffset: UInt32; var counterDataSize: UInt32; var counterTypeEnum: UInt32; var counterDataTypeEnum: UInt32; var rawCounterMaxValue: UInt64)>(z_GetPerfCounterInfoINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfCounterInfoINTEL(queryId: gl_perf_query_id_INTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; var counterOffset: UInt32; var counterDataSize: UInt32; var counterTypeEnum: UInt32; var counterDataTypeEnum: UInt32; var rawCounterMaxValue: UInt64) :=
    z_GetPerfCounterInfoINTEL_ovr_0(queryId, counterId, counterNameLength, counterName, counterDescLength, counterDesc, counterOffset, counterDataSize, counterTypeEnum, counterDataTypeEnum, rawCounterMaxValue);
    private z_GetPerfCounterInfoINTEL_ovr_1 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; counterOffset: IntPtr; counterDataSize: IntPtr; counterTypeEnum: IntPtr; counterDataTypeEnum: IntPtr; rawCounterMaxValue: IntPtr)>(z_GetPerfCounterInfoINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfCounterInfoINTEL(queryId: gl_perf_query_id_INTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; counterOffset: IntPtr; counterDataSize: IntPtr; counterTypeEnum: IntPtr; counterDataTypeEnum: IntPtr; rawCounterMaxValue: IntPtr) :=
    z_GetPerfCounterInfoINTEL_ovr_1(queryId, counterId, counterNameLength, counterName, counterDescLength, counterDesc, counterOffset, counterDataSize, counterTypeEnum, counterDataTypeEnum, rawCounterMaxValue);
    
    private z_GetPerfQueryDataINTEL_adr := GetProcAddress('glGetPerfQueryDataINTEL');
    private z_GetPerfQueryDataINTEL_ovr_0 := GetProcOrNil&<procedure(queryHandle: gl_perf_query_handle_INTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; var bytesWritten: UInt32)>(z_GetPerfQueryDataINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryDataINTEL(queryHandle: gl_perf_query_handle_INTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; var bytesWritten: UInt32) :=
    z_GetPerfQueryDataINTEL_ovr_0(queryHandle, flags, dataSize, data, bytesWritten);
    private z_GetPerfQueryDataINTEL_ovr_1 := GetProcOrNil&<procedure(queryHandle: gl_perf_query_handle_INTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr)>(z_GetPerfQueryDataINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryDataINTEL(queryHandle: gl_perf_query_handle_INTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr) :=
    z_GetPerfQueryDataINTEL_ovr_1(queryHandle, flags, dataSize, data, bytesWritten);
    
    private z_GetPerfQueryIdByNameINTEL_adr := GetProcAddress('glGetPerfQueryIdByNameINTEL');
    private z_GetPerfQueryIdByNameINTEL_ovr_0 := GetProcOrNil&<procedure(queryName: IntPtr; var queryId: gl_perf_query_id_INTEL)>(z_GetPerfQueryIdByNameINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: string; var queryId: gl_perf_query_id_INTEL);
    begin
      var par_1_str_ptr: IntPtr;
      try
        par_1_str_ptr := Marshal.StringToHGlobalAnsi(queryName);
        z_GetPerfQueryIdByNameINTEL_ovr_0(par_1_str_ptr, queryId);
      finally
        Marshal.FreeHGlobal(par_1_str_ptr);
      end;
    end;
    private z_GetPerfQueryIdByNameINTEL_ovr_1 := GetProcOrNil&<procedure(queryName: IntPtr; queryId: IntPtr)>(z_GetPerfQueryIdByNameINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: string; queryId: IntPtr);
    begin
      var par_1_str_ptr: IntPtr;
      try
        par_1_str_ptr := Marshal.StringToHGlobalAnsi(queryName);
        z_GetPerfQueryIdByNameINTEL_ovr_1(par_1_str_ptr, queryId);
      finally
        Marshal.FreeHGlobal(par_1_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: IntPtr; var queryId: gl_perf_query_id_INTEL) :=
    z_GetPerfQueryIdByNameINTEL_ovr_0(queryName, queryId);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: IntPtr; queryId: IntPtr) :=
    z_GetPerfQueryIdByNameINTEL_ovr_1(queryName, queryId);
    
    private z_GetPerfQueryInfoINTEL_adr := GetProcAddress('glGetPerfQueryInfoINTEL');
    private z_GetPerfQueryInfoINTEL_ovr_0 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; queryNameLength: UInt32; queryName: IntPtr; var dataSize: UInt32; var noCounters: UInt32; var noInstances: UInt32; var capsMask: PerfQueryCapFlagsINTEL)>(z_GetPerfQueryInfoINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryInfoINTEL(queryId: gl_perf_query_id_INTEL; queryNameLength: UInt32; queryName: IntPtr; var dataSize: UInt32; var noCounters: UInt32; var noInstances: UInt32; var capsMask: PerfQueryCapFlagsINTEL) :=
    z_GetPerfQueryInfoINTEL_ovr_0(queryId, queryNameLength, queryName, dataSize, noCounters, noInstances, capsMask);
    private z_GetPerfQueryInfoINTEL_ovr_1 := GetProcOrNil&<procedure(queryId: gl_perf_query_id_INTEL; queryNameLength: UInt32; queryName: IntPtr; dataSize: IntPtr; noCounters: IntPtr; noInstances: IntPtr; capsMask: IntPtr)>(z_GetPerfQueryInfoINTEL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryInfoINTEL(queryId: gl_perf_query_id_INTEL; queryNameLength: UInt32; queryName: IntPtr; dataSize: IntPtr; noCounters: IntPtr; noInstances: IntPtr; capsMask: IntPtr) :=
    z_GetPerfQueryInfoINTEL_ovr_1(queryId, queryNameLength, queryName, dataSize, noCounters, noInstances, capsMask);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendEquationAdvancedKHR = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'KHR_blend_equation_advanced';
    
    private z_BlendBarrierKHR_adr := GetProcAddress('glBlendBarrierKHR');
    private z_BlendBarrierKHR_ovr_0 := GetProcOrNil&<procedure>(z_BlendBarrierKHR_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendBarrierKHR :=
    z_BlendBarrierKHR_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDebugKHR = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'KHR_debug';
    
    private z_DebugMessageControl_adr := GetProcAddress('glDebugMessageControl');
    private z_DebugMessageControl_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean)>(z_DebugMessageControl_adr);
    private z_DebugMessageControl_ovr_0_anh0000010 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageControl_ovr_0(source, &type, severity, count, ids[0], enabled) else
      z_DebugMessageControl_ovr_0_anh0000010(source, &type, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageControl_ovr_0(source, &type, severity, count, ids, enabled);
    private z_DebugMessageControl_ovr_2 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageControl_ovr_2(source, &type, severity, count, ids, enabled);
    
    private z_DebugMessageInsert_adr := GetProcAddress('glDebugMessageInsert');
    private z_DebugMessageInsert_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr)>(z_DebugMessageInsert_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: string);
    begin
      var par_6_str_ptr: IntPtr;
      try
        par_6_str_ptr := Marshal.StringToHGlobalAnsi(buf);
        z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, par_6_str_ptr);
      finally
        Marshal.FreeHGlobal(par_6_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, buf);
    
    private z_DebugMessageCallback_adr := GetProcAddress('glDebugMessageCallback');
    private z_DebugMessageCallback_ovr_0 := GetProcOrNil&<procedure(callback: GL_DEBUG_PROC; userParam: IntPtr)>(z_DebugMessageCallback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallback(callback: GL_DEBUG_PROC; userParam: IntPtr) :=
    z_DebugMessageCallback_ovr_0(callback, userParam);
    
    private z_GetDebugMessageLog_adr := GetProcAddress('glGetDebugMessageLog');
    private z_GetDebugMessageLog_ovr_0 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32>(z_GetDebugMessageLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_0(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    private z_GetDebugMessageLog_ovr_1 := GetProcOrNil&<function(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32>(z_GetDebugMessageLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_1(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    
    private z_PushDebugGroup_adr := GetProcAddress('glPushDebugGroup');
    private z_PushDebugGroup_ovr_0 := GetProcOrNil&<procedure(source: DebugSource; id: UInt32; length: Int32; message: IntPtr)>(z_PushDebugGroup_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(message);
        z_PushDebugGroup_ovr_0(source, id, length, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: IntPtr) :=
    z_PushDebugGroup_ovr_0(source, id, length, message);
    
    private z_PopDebugGroup_adr := GetProcAddress('glPopDebugGroup');
    private z_PopDebugGroup_ovr_0 := GetProcOrNil&<procedure>(z_PopDebugGroup_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopDebugGroup :=
    z_PopDebugGroup_ovr_0;
    
    private z_ObjectLabel_adr := GetProcAddress('glObjectLabel');
    private z_ObjectLabel_ovr_0 := GetProcOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr)>(z_ObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: string);
    begin
      var par_4_str_ptr: IntPtr;
      try
        par_4_str_ptr := Marshal.StringToHGlobalAnsi(&label);
        z_ObjectLabel_ovr_0(identifier, name, length, par_4_str_ptr);
      finally
        Marshal.FreeHGlobal(par_4_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr) :=
    z_ObjectLabel_ovr_0(identifier, name, length, &label);
    
    private z_GetObjectLabel_adr := GetProcAddress('glGetObjectLabel');
    private z_GetObjectLabel_ovr_0 := GetProcOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectLabel_ovr_0(identifier, name, bufSize, length, &label);
    private z_GetObjectLabel_ovr_1 := GetProcOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectLabel_ovr_1(identifier, name, bufSize, length, &label);
    
    private z_ObjectPtrLabel_adr := GetProcAddress('glObjectPtrLabel');
    private z_ObjectPtrLabel_ovr_0 := GetProcOrNil&<procedure(ptr: IntPtr; length: Int32; &label: IntPtr)>(z_ObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: string);
    begin
      var par_3_str_ptr: IntPtr;
      try
        par_3_str_ptr := Marshal.StringToHGlobalAnsi(&label);
        z_ObjectPtrLabel_ovr_0(ptr, length, par_3_str_ptr);
      finally
        Marshal.FreeHGlobal(par_3_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: IntPtr) :=
    z_ObjectPtrLabel_ovr_0(ptr, length, &label);
    
    private z_GetObjectPtrLabel_adr := GetProcAddress('glGetObjectPtrLabel');
    private z_GetObjectPtrLabel_ovr_0 := GetProcOrNil&<procedure(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_0(ptr, bufSize, length, &label);
    private z_GetObjectPtrLabel_ovr_1 := GetProcOrNil&<procedure(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_1(ptr, bufSize, length, &label);
    
    private z_GetPointerv_adr := GetProcAddress('glGetPointerv');
    private z_GetPointerv_ovr_0 := GetProcOrNil&<procedure(pname: GetPointervPName; var &params: IntPtr)>(z_GetPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; var &params: IntPtr) :=
    z_GetPointerv_ovr_0(pname, &params);
    private z_GetPointerv_ovr_1 := GetProcOrNil&<procedure(pname: GetPointervPName; &params: pointer)>(z_GetPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; &params: pointer) :=
    z_GetPointerv_ovr_1(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glRobustnessKHR = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'KHR_robustness';
    
    private z_GetGraphicsResetStatus_adr := GetProcAddress('glGetGraphicsResetStatus');
    private z_GetGraphicsResetStatus_ovr_0 := GetProcOrNil&<function: GraphicsResetStatus>(z_GetGraphicsResetStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGraphicsResetStatus: GraphicsResetStatus :=
    z_GetGraphicsResetStatus_ovr_0;
    
    private z_ReadnPixels_adr := GetProcAddress('glReadnPixels');
    private z_ReadnPixels_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr)>(z_ReadnPixels_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadnPixels(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr) :=
    z_ReadnPixels_ovr_0(x, y, width, height, format, &type, bufSize, data);
    
    private z_GetnUniformfv_adr := GetProcAddress('glGetnUniformfv');
    private z_GetnUniformfv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: single)>(z_GetnUniformfv_adr);
    private z_GetnUniformfv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformfv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformfv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: gl_program; location: Int32; bufSize: Int32; var &params: single) :=
    z_GetnUniformfv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformfv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformfv_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnUniformiv_adr := GetProcAddress('glGetnUniformiv');
    private z_GetnUniformiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int32)>(z_GetnUniformiv_adr);
    private z_GetnUniformiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: gl_program; location: Int32; bufSize: Int32; var &params: Int32) :=
    z_GetnUniformiv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformiv_ovr_2(&program, location, bufSize, &params);
    
    private z_GetnUniformuiv_adr := GetProcAddress('glGetnUniformuiv');
    private z_GetnUniformuiv_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt32)>(z_GetnUniformuiv_adr);
    private z_GetnUniformuiv_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: gl_program; location: Int32; bufSize: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformuiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: gl_program; location: Int32; bufSize: Int32; var &params: UInt32) :=
    z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformuiv_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: gl_program; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformuiv_ovr_2(&program, location, bufSize, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glParallelShaderCompileKHR = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'KHR_parallel_shader_compile';
    
    private z_MaxShaderCompilerThreadsKHR_adr := GetProcAddress('glMaxShaderCompilerThreadsKHR');
    private z_MaxShaderCompilerThreadsKHR_ovr_0 := GetProcOrNil&<procedure(count: UInt32)>(z_MaxShaderCompilerThreadsKHR_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaxShaderCompilerThreadsKHR(count: UInt32) :=
    z_MaxShaderCompilerThreadsKHR_ovr_0(count);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferFlipYMESA = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_framebuffer_flip_y';
    
    private z_FramebufferParameteriMESA_adr := GetProcAddress('glFramebufferParameteriMESA');
    private z_FramebufferParameteriMESA_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32)>(z_FramebufferParameteriMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferParameteriMESA(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32) :=
    z_FramebufferParameteriMESA_ovr_0(target, pname, param);
    
    private z_GetFramebufferParameterivMESA_adr := GetProcAddress('glGetFramebufferParameterivMESA');
    private z_GetFramebufferParameterivMESA_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferParameterivMESA_adr);
    private z_GetFramebufferParameterivMESA_ovr_0_anh0001 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameterivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivMESA(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameterivMESA_ovr_0(target, pname, &params[0]) else
      z_GetFramebufferParameterivMESA_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivMESA(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferParameterivMESA_ovr_0(target, pname, &params);
    private z_GetFramebufferParameterivMESA_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameterivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivMESA(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferParameterivMESA_ovr_2(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glResizeBuffersMESA = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_resize_buffers';
    
    private z_ResizeBuffersMESA_adr := GetProcAddress('glResizeBuffersMESA');
    private z_ResizeBuffersMESA_ovr_0 := GetProcOrNil&<procedure>(z_ResizeBuffersMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResizeBuffersMESA :=
    z_ResizeBuffersMESA_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glWindowPosMESA = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_window_pos';
    
    private z_WindowPos2dMESA_adr := GetProcAddress('glWindowPos2dMESA');
    private z_WindowPos2dMESA_ovr_0 := GetProcOrNil&<procedure(x: real; y: real)>(z_WindowPos2dMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dMESA(x: real; y: real) :=
    z_WindowPos2dMESA_ovr_0(x, y);
    
    private z_WindowPos2dvMESA_adr := GetProcAddress('glWindowPos2dvMESA');
    private z_WindowPos2dvMESA_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos2dvMESA_adr);
    private z_WindowPos2dvMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2dvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvMESA(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2dvMESA_ovr_0(v[0]) else
      z_WindowPos2dvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvMESA(var v: real) :=
    z_WindowPos2dvMESA_ovr_0(v);
    private z_WindowPos2dvMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2dvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvMESA(v: IntPtr) :=
    z_WindowPos2dvMESA_ovr_2(v);
    
    private z_WindowPos2fMESA_adr := GetProcAddress('glWindowPos2fMESA');
    private z_WindowPos2fMESA_ovr_0 := GetProcOrNil&<procedure(x: single; y: single)>(z_WindowPos2fMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fMESA(x: single; y: single) :=
    z_WindowPos2fMESA_ovr_0(x, y);
    
    private z_WindowPos2fvMESA_adr := GetProcAddress('glWindowPos2fvMESA');
    private z_WindowPos2fvMESA_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos2fvMESA_adr);
    private z_WindowPos2fvMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2fvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvMESA(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2fvMESA_ovr_0(v[0]) else
      z_WindowPos2fvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvMESA(var v: single) :=
    z_WindowPos2fvMESA_ovr_0(v);
    private z_WindowPos2fvMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2fvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvMESA(v: IntPtr) :=
    z_WindowPos2fvMESA_ovr_2(v);
    
    private z_WindowPos2iMESA_adr := GetProcAddress('glWindowPos2iMESA');
    private z_WindowPos2iMESA_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32)>(z_WindowPos2iMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iMESA(x: Int32; y: Int32) :=
    z_WindowPos2iMESA_ovr_0(x, y);
    
    private z_WindowPos2ivMESA_adr := GetProcAddress('glWindowPos2ivMESA');
    private z_WindowPos2ivMESA_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos2ivMESA_adr);
    private z_WindowPos2ivMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2ivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivMESA(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2ivMESA_ovr_0(v[0]) else
      z_WindowPos2ivMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivMESA(var v: Int32) :=
    z_WindowPos2ivMESA_ovr_0(v);
    private z_WindowPos2ivMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2ivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivMESA(v: IntPtr) :=
    z_WindowPos2ivMESA_ovr_2(v);
    
    private z_WindowPos2sMESA_adr := GetProcAddress('glWindowPos2sMESA');
    private z_WindowPos2sMESA_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16)>(z_WindowPos2sMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sMESA(x: Int16; y: Int16) :=
    z_WindowPos2sMESA_ovr_0(x, y);
    
    private z_WindowPos2svMESA_adr := GetProcAddress('glWindowPos2svMESA');
    private z_WindowPos2svMESA_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos2svMESA_adr);
    private z_WindowPos2svMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2svMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svMESA(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2svMESA_ovr_0(v[0]) else
      z_WindowPos2svMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svMESA(var v: Int16) :=
    z_WindowPos2svMESA_ovr_0(v);
    private z_WindowPos2svMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos2svMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svMESA(v: IntPtr) :=
    z_WindowPos2svMESA_ovr_2(v);
    
    private z_WindowPos3dMESA_adr := GetProcAddress('glWindowPos3dMESA');
    private z_WindowPos3dMESA_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real)>(z_WindowPos3dMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dMESA(x: real; y: real; z: real) :=
    z_WindowPos3dMESA_ovr_0(x, y, z);
    
    private z_WindowPos3dvMESA_adr := GetProcAddress('glWindowPos3dvMESA');
    private z_WindowPos3dvMESA_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos3dvMESA_adr);
    private z_WindowPos3dvMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3dvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvMESA(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3dvMESA_ovr_0(v[0]) else
      z_WindowPos3dvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvMESA(var v: real) :=
    z_WindowPos3dvMESA_ovr_0(v);
    private z_WindowPos3dvMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3dvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvMESA(v: IntPtr) :=
    z_WindowPos3dvMESA_ovr_2(v);
    
    private z_WindowPos3fMESA_adr := GetProcAddress('glWindowPos3fMESA');
    private z_WindowPos3fMESA_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single)>(z_WindowPos3fMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fMESA(x: single; y: single; z: single) :=
    z_WindowPos3fMESA_ovr_0(x, y, z);
    
    private z_WindowPos3fvMESA_adr := GetProcAddress('glWindowPos3fvMESA');
    private z_WindowPos3fvMESA_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos3fvMESA_adr);
    private z_WindowPos3fvMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3fvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvMESA(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3fvMESA_ovr_0(v[0]) else
      z_WindowPos3fvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvMESA(var v: single) :=
    z_WindowPos3fvMESA_ovr_0(v);
    private z_WindowPos3fvMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3fvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvMESA(v: IntPtr) :=
    z_WindowPos3fvMESA_ovr_2(v);
    
    private z_WindowPos3iMESA_adr := GetProcAddress('glWindowPos3iMESA');
    private z_WindowPos3iMESA_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32)>(z_WindowPos3iMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iMESA(x: Int32; y: Int32; z: Int32) :=
    z_WindowPos3iMESA_ovr_0(x, y, z);
    
    private z_WindowPos3ivMESA_adr := GetProcAddress('glWindowPos3ivMESA');
    private z_WindowPos3ivMESA_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos3ivMESA_adr);
    private z_WindowPos3ivMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3ivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivMESA(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3ivMESA_ovr_0(v[0]) else
      z_WindowPos3ivMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivMESA(var v: Int32) :=
    z_WindowPos3ivMESA_ovr_0(v);
    private z_WindowPos3ivMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3ivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivMESA(v: IntPtr) :=
    z_WindowPos3ivMESA_ovr_2(v);
    
    private z_WindowPos3sMESA_adr := GetProcAddress('glWindowPos3sMESA');
    private z_WindowPos3sMESA_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16)>(z_WindowPos3sMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sMESA(x: Int16; y: Int16; z: Int16) :=
    z_WindowPos3sMESA_ovr_0(x, y, z);
    
    private z_WindowPos3svMESA_adr := GetProcAddress('glWindowPos3svMESA');
    private z_WindowPos3svMESA_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos3svMESA_adr);
    private z_WindowPos3svMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3svMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svMESA(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3svMESA_ovr_0(v[0]) else
      z_WindowPos3svMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svMESA(var v: Int16) :=
    z_WindowPos3svMESA_ovr_0(v);
    private z_WindowPos3svMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos3svMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svMESA(v: IntPtr) :=
    z_WindowPos3svMESA_ovr_2(v);
    
    private z_WindowPos4dMESA_adr := GetProcAddress('glWindowPos4dMESA');
    private z_WindowPos4dMESA_ovr_0 := GetProcOrNil&<procedure(x: real; y: real; z: real; w: real)>(z_WindowPos4dMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dMESA(x: real; y: real; z: real; w: real) :=
    z_WindowPos4dMESA_ovr_0(x, y, z, w);
    
    private z_WindowPos4dvMESA_adr := GetProcAddress('glWindowPos4dvMESA');
    private z_WindowPos4dvMESA_ovr_0 := GetProcOrNil&<procedure(var v: real)>(z_WindowPos4dvMESA_adr);
    private z_WindowPos4dvMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4dvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dvMESA(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4dvMESA_ovr_0(v[0]) else
      z_WindowPos4dvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dvMESA(var v: real) :=
    z_WindowPos4dvMESA_ovr_0(v);
    private z_WindowPos4dvMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4dvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dvMESA(v: IntPtr) :=
    z_WindowPos4dvMESA_ovr_2(v);
    
    private z_WindowPos4fMESA_adr := GetProcAddress('glWindowPos4fMESA');
    private z_WindowPos4fMESA_ovr_0 := GetProcOrNil&<procedure(x: single; y: single; z: single; w: single)>(z_WindowPos4fMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fMESA(x: single; y: single; z: single; w: single) :=
    z_WindowPos4fMESA_ovr_0(x, y, z, w);
    
    private z_WindowPos4fvMESA_adr := GetProcAddress('glWindowPos4fvMESA');
    private z_WindowPos4fvMESA_ovr_0 := GetProcOrNil&<procedure(var v: single)>(z_WindowPos4fvMESA_adr);
    private z_WindowPos4fvMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4fvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fvMESA(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4fvMESA_ovr_0(v[0]) else
      z_WindowPos4fvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fvMESA(var v: single) :=
    z_WindowPos4fvMESA_ovr_0(v);
    private z_WindowPos4fvMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4fvMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fvMESA(v: IntPtr) :=
    z_WindowPos4fvMESA_ovr_2(v);
    
    private z_WindowPos4iMESA_adr := GetProcAddress('glWindowPos4iMESA');
    private z_WindowPos4iMESA_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; z: Int32; w: Int32)>(z_WindowPos4iMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4iMESA(x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_WindowPos4iMESA_ovr_0(x, y, z, w);
    
    private z_WindowPos4ivMESA_adr := GetProcAddress('glWindowPos4ivMESA');
    private z_WindowPos4ivMESA_ovr_0 := GetProcOrNil&<procedure(var v: Int32)>(z_WindowPos4ivMESA_adr);
    private z_WindowPos4ivMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4ivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4ivMESA(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4ivMESA_ovr_0(v[0]) else
      z_WindowPos4ivMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4ivMESA(var v: Int32) :=
    z_WindowPos4ivMESA_ovr_0(v);
    private z_WindowPos4ivMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4ivMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4ivMESA(v: IntPtr) :=
    z_WindowPos4ivMESA_ovr_2(v);
    
    private z_WindowPos4sMESA_adr := GetProcAddress('glWindowPos4sMESA');
    private z_WindowPos4sMESA_ovr_0 := GetProcOrNil&<procedure(x: Int16; y: Int16; z: Int16; w: Int16)>(z_WindowPos4sMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4sMESA(x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_WindowPos4sMESA_ovr_0(x, y, z, w);
    
    private z_WindowPos4svMESA_adr := GetProcAddress('glWindowPos4svMESA');
    private z_WindowPos4svMESA_ovr_0 := GetProcOrNil&<procedure(var v: Int16)>(z_WindowPos4svMESA_adr);
    private z_WindowPos4svMESA_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4svMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4svMESA(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4svMESA_ovr_0(v[0]) else
      z_WindowPos4svMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4svMESA(var v: Int16) :=
    z_WindowPos4svMESA_ovr_0(v);
    private z_WindowPos4svMESA_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_WindowPos4svMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4svMESA(v: IntPtr) :=
    z_WindowPos4svMESA_ovr_2(v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConditionalRenderNVX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NVX_conditional_render';
    
    private z_BeginConditionalRenderNVX_adr := GetProcAddress('glBeginConditionalRenderNVX');
    private z_BeginConditionalRenderNVX_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_BeginConditionalRenderNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginConditionalRenderNVX(id: UInt32) :=
    z_BeginConditionalRenderNVX_ovr_0(id);
    
    private z_EndConditionalRenderNVX_adr := GetProcAddress('glEndConditionalRenderNVX');
    private z_EndConditionalRenderNVX_ovr_0 := GetProcOrNil&<procedure>(z_EndConditionalRenderNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndConditionalRenderNVX :=
    z_EndConditionalRenderNVX_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glLinkedGpuMulticastNVX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NVX_linked_gpu_multicast';
    
    private z_LGPUNamedBufferSubDataNVX_adr := GetProcAddress('glLGPUNamedBufferSubDataNVX');
    private z_LGPUNamedBufferSubDataNVX_ovr_0 := GetProcOrNil&<procedure(gpuMask: DummyFlags; buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_LGPUNamedBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LGPUNamedBufferSubDataNVX(gpuMask: DummyFlags; buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_LGPUNamedBufferSubDataNVX_ovr_0(gpuMask, buffer, offset, size, data);
    
    private z_LGPUCopyImageSubDataNVX_adr := GetProcAddress('glLGPUCopyImageSubDataNVX');
    private z_LGPUCopyImageSubDataNVX_ovr_0 := GetProcOrNil&<procedure(sourceGpu: UInt32; destinationGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srxY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32)>(z_LGPUCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LGPUCopyImageSubDataNVX(sourceGpu: UInt32; destinationGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srxY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_LGPUCopyImageSubDataNVX_ovr_0(sourceGpu, destinationGpuMask, srcName, srcTarget, srcLevel, srcX, srxY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
    private z_LGPUInterlockNVX_adr := GetProcAddress('glLGPUInterlockNVX');
    private z_LGPUInterlockNVX_ovr_0 := GetProcOrNil&<procedure>(z_LGPUInterlockNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LGPUInterlockNVX :=
    z_LGPUInterlockNVX_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glAlphaToCoverageDitherControlNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_alpha_to_coverage_dither_control';
    
    private z_AlphaToCoverageDitherControlNV_adr := GetProcAddress('glAlphaToCoverageDitherControlNV');
    private z_AlphaToCoverageDitherControlNV_ovr_0 := GetProcOrNil&<procedure(mode: DummyEnum)>(z_AlphaToCoverageDitherControlNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaToCoverageDitherControlNV(mode: DummyEnum) :=
    z_AlphaToCoverageDitherControlNV_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBindlessMultiDrawIndirectNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_bindless_multi_draw_indirect';
    
    private z_MultiDrawArraysIndirectBindlessNV_adr := GetProcAddress('glMultiDrawArraysIndirectBindlessNV');
    private z_MultiDrawArraysIndirectBindlessNV_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32)>(z_MultiDrawArraysIndirectBindlessNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectBindlessNV(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawArraysIndirectBindlessNV_ovr_0(mode, indirect, drawCount, stride, vertexBufferCount);
    
    private z_MultiDrawElementsIndirectBindlessNV_adr := GetProcAddress('glMultiDrawElementsIndirectBindlessNV');
    private z_MultiDrawElementsIndirectBindlessNV_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32)>(z_MultiDrawElementsIndirectBindlessNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectBindlessNV(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawElementsIndirectBindlessNV_ovr_0(mode, &type, indirect, drawCount, stride, vertexBufferCount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBindlessMultiDrawIndirectCountNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_bindless_multi_draw_indirect_count';
    
    private z_MultiDrawArraysIndirectBindlessCountNV_adr := GetProcAddress('glMultiDrawArraysIndirectBindlessCountNV');
    private z_MultiDrawArraysIndirectBindlessCountNV_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32)>(z_MultiDrawArraysIndirectBindlessCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectBindlessCountNV(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawArraysIndirectBindlessCountNV_ovr_0(mode, indirect, drawCount, maxDrawCount, stride, vertexBufferCount);
    
    private z_MultiDrawElementsIndirectBindlessCountNV_adr := GetProcAddress('glMultiDrawElementsIndirectBindlessCountNV');
    private z_MultiDrawElementsIndirectBindlessCountNV_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32)>(z_MultiDrawElementsIndirectBindlessCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectBindlessCountNV(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawElementsIndirectBindlessCountNV_ovr_0(mode, &type, indirect, drawCount, maxDrawCount, stride, vertexBufferCount);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBindlessTextureNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_bindless_texture';
    
    private z_GetTextureHandleNV_adr := GetProcAddress('glGetTextureHandleNV');
    private z_GetTextureHandleNV_ovr_0 := GetProcOrNil&<function(texture: gl_texture): UInt64>(z_GetTextureHandleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureHandleNV(texture: gl_texture): UInt64 :=
    z_GetTextureHandleNV_ovr_0(texture);
    
    private z_GetTextureSamplerHandleNV_adr := GetProcAddress('glGetTextureSamplerHandleNV');
    private z_GetTextureSamplerHandleNV_ovr_0 := GetProcOrNil&<function(texture: gl_texture; sampler: gl_sampler): UInt64>(z_GetTextureSamplerHandleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureSamplerHandleNV(texture: gl_texture; sampler: gl_sampler): UInt64 :=
    z_GetTextureSamplerHandleNV_ovr_0(texture, sampler);
    
    private z_MakeTextureHandleResidentNV_adr := GetProcAddress('glMakeTextureHandleResidentNV');
    private z_MakeTextureHandleResidentNV_ovr_0 := GetProcOrNil&<procedure(handle: UInt64)>(z_MakeTextureHandleResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleResidentNV(handle: UInt64) :=
    z_MakeTextureHandleResidentNV_ovr_0(handle);
    
    private z_MakeTextureHandleNonResidentNV_adr := GetProcAddress('glMakeTextureHandleNonResidentNV');
    private z_MakeTextureHandleNonResidentNV_ovr_0 := GetProcOrNil&<procedure(handle: UInt64)>(z_MakeTextureHandleNonResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleNonResidentNV(handle: UInt64) :=
    z_MakeTextureHandleNonResidentNV_ovr_0(handle);
    
    private z_GetImageHandleNV_adr := GetProcAddress('glGetImageHandleNV');
    private z_GetImageHandleNV_ovr_0 := GetProcOrNil&<function(texture: gl_texture; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64>(z_GetImageHandleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetImageHandleNV(texture: gl_texture; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64 :=
    z_GetImageHandleNV_ovr_0(texture, level, layered, layer, format);
    
    private z_MakeImageHandleResidentNV_adr := GetProcAddress('glMakeImageHandleResidentNV');
    private z_MakeImageHandleResidentNV_ovr_0 := GetProcOrNil&<procedure(handle: UInt64; access: DummyEnum)>(z_MakeImageHandleResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleResidentNV(handle: UInt64; access: DummyEnum) :=
    z_MakeImageHandleResidentNV_ovr_0(handle, access);
    
    private z_MakeImageHandleNonResidentNV_adr := GetProcAddress('glMakeImageHandleNonResidentNV');
    private z_MakeImageHandleNonResidentNV_ovr_0 := GetProcOrNil&<procedure(handle: UInt64)>(z_MakeImageHandleNonResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleNonResidentNV(handle: UInt64) :=
    z_MakeImageHandleNonResidentNV_ovr_0(handle);
    
    private z_UniformHandleui64NV_adr := GetProcAddress('glUniformHandleui64NV');
    private z_UniformHandleui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; value: UInt64)>(z_UniformHandleui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64NV(location: Int32; value: UInt64) :=
    z_UniformHandleui64NV_ovr_0(location, value);
    
    private z_UniformHandleui64vNV_adr := GetProcAddress('glUniformHandleui64vNV');
    private z_UniformHandleui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_UniformHandleui64vNV_adr);
    private z_UniformHandleui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_UniformHandleui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformHandleui64vNV_ovr_0(location, count, value[0]) else
      z_UniformHandleui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_UniformHandleui64vNV_ovr_0(location, count, value);
    private z_UniformHandleui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_UniformHandleui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_UniformHandleui64vNV_ovr_2(location, count, value);
    
    private z_ProgramUniformHandleui64NV_adr := GetProcAddress('glProgramUniformHandleui64NV');
    private z_ProgramUniformHandleui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; value: UInt64)>(z_ProgramUniformHandleui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64NV(&program: gl_program; location: Int32; value: UInt64) :=
    z_ProgramUniformHandleui64NV_ovr_0(&program, location, value);
    
    private z_ProgramUniformHandleui64vNV_adr := GetProcAddress('glProgramUniformHandleui64vNV');
    private z_ProgramUniformHandleui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var values: UInt64)>(z_ProgramUniformHandleui64vNV_adr);
    private z_ProgramUniformHandleui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; values: IntPtr)>(z_ProgramUniformHandleui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vNV(&program: gl_program; location: Int32; count: Int32; values: array of UInt64) :=
    if (values<>nil) and (values.Length<>0) then
      z_ProgramUniformHandleui64vNV_ovr_0(&program, location, count, values[0]) else
      z_ProgramUniformHandleui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vNV(&program: gl_program; location: Int32; count: Int32; var values: UInt64) :=
    z_ProgramUniformHandleui64vNV_ovr_0(&program, location, count, values);
    private z_ProgramUniformHandleui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; values: IntPtr)>(z_ProgramUniformHandleui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vNV(&program: gl_program; location: Int32; count: Int32; values: IntPtr) :=
    z_ProgramUniformHandleui64vNV_ovr_2(&program, location, count, values);
    
    private z_IsTextureHandleResidentNV_adr := GetProcAddress('glIsTextureHandleResidentNV');
    private z_IsTextureHandleResidentNV_ovr_0 := GetProcOrNil&<function(handle: UInt64): boolean>(z_IsTextureHandleResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTextureHandleResidentNV(handle: UInt64): boolean :=
    z_IsTextureHandleResidentNV_ovr_0(handle);
    
    private z_IsImageHandleResidentNV_adr := GetProcAddress('glIsImageHandleResidentNV');
    private z_IsImageHandleResidentNV_ovr_0 := GetProcOrNil&<function(handle: UInt64): boolean>(z_IsImageHandleResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsImageHandleResidentNV(handle: UInt64): boolean :=
    z_IsImageHandleResidentNV_ovr_0(handle);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glBlendEquationAdvancedNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_blend_equation_advanced';
    
    private z_BlendParameteriNV_adr := GetProcAddress('glBlendParameteriNV');
    private z_BlendParameteriNV_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; value: Int32)>(z_BlendParameteriNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendParameteriNV(pname: DummyEnum; value: Int32) :=
    z_BlendParameteriNV_ovr_0(pname, value);
    
    private z_BlendBarrierNV_adr := GetProcAddress('glBlendBarrierNV');
    private z_BlendBarrierNV_ovr_0 := GetProcOrNil&<procedure>(z_BlendBarrierNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendBarrierNV :=
    z_BlendBarrierNV_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glClipSpaceWScalingNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_clip_space_w_scaling';
    
    private z_ViewportPositionWScaleNV_adr := GetProcAddress('glViewportPositionWScaleNV');
    private z_ViewportPositionWScaleNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; xcoeff: single; ycoeff: single)>(z_ViewportPositionWScaleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportPositionWScaleNV(index: UInt32; xcoeff: single; ycoeff: single) :=
    z_ViewportPositionWScaleNV_ovr_0(index, xcoeff, ycoeff);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCommandListNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_command_list';
    
    private z_CreateStatesNV_adr := GetProcAddress('glCreateStatesNV');
    private z_CreateStatesNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var states: UInt32)>(z_CreateStatesNV_adr);
    private z_CreateStatesNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; states: IntPtr)>(z_CreateStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateStatesNV(n: Int32; states: array of UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_CreateStatesNV_ovr_0(n, states[0]) else
      z_CreateStatesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateStatesNV(n: Int32; var states: UInt32) :=
    z_CreateStatesNV_ovr_0(n, states);
    private z_CreateStatesNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; states: IntPtr)>(z_CreateStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateStatesNV(n: Int32; states: IntPtr) :=
    z_CreateStatesNV_ovr_2(n, states);
    
    private z_DeleteStatesNV_adr := GetProcAddress('glDeleteStatesNV');
    private z_DeleteStatesNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var states: UInt32)>(z_DeleteStatesNV_adr);
    private z_DeleteStatesNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; states: IntPtr)>(z_DeleteStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteStatesNV(n: Int32; states: array of UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DeleteStatesNV_ovr_0(n, states[0]) else
      z_DeleteStatesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteStatesNV(n: Int32; var states: UInt32) :=
    z_DeleteStatesNV_ovr_0(n, states);
    private z_DeleteStatesNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; states: IntPtr)>(z_DeleteStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteStatesNV(n: Int32; states: IntPtr) :=
    z_DeleteStatesNV_ovr_2(n, states);
    
    private z_IsStateNV_adr := GetProcAddress('glIsStateNV');
    private z_IsStateNV_ovr_0 := GetProcOrNil&<function(state: UInt32): boolean>(z_IsStateNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsStateNV(state: UInt32): boolean :=
    z_IsStateNV_ovr_0(state);
    
    private z_StateCaptureNV_adr := GetProcAddress('glStateCaptureNV');
    private z_StateCaptureNV_ovr_0 := GetProcOrNil&<procedure(state: UInt32; mode: DummyEnum)>(z_StateCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StateCaptureNV(state: UInt32; mode: DummyEnum) :=
    z_StateCaptureNV_ovr_0(state, mode);
    
    private z_GetCommandHeaderNV_adr := GetProcAddress('glGetCommandHeaderNV');
    private z_GetCommandHeaderNV_ovr_0 := GetProcOrNil&<function(tokenID: DummyEnum; size: UInt32): UInt32>(z_GetCommandHeaderNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCommandHeaderNV(tokenID: DummyEnum; size: UInt32): UInt32 :=
    z_GetCommandHeaderNV_ovr_0(tokenID, size);
    
    private z_GetStageIndexNV_adr := GetProcAddress('glGetStageIndexNV');
    private z_GetStageIndexNV_ovr_0 := GetProcOrNil&<function(_shadertype: ShaderType): UInt16>(z_GetStageIndexNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetStageIndexNV(_shadertype: ShaderType): UInt16 :=
    z_GetStageIndexNV_ovr_0(_shadertype);
    
    private z_DrawCommandsNV_adr := GetProcAddress('glDrawCommandsNV');
    private z_DrawCommandsNV_ovr_0 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; var sizes: Int32; count: UInt32)>(z_DrawCommandsNV_adr);
    private z_DrawCommandsNV_ovr_0_anh000100 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; var sizes: Int32; count: UInt32)>(z_DrawCommandsNV_adr);
    private z_DrawCommandsNV_ovr_0_anh000010 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsNV_adr);
    private z_DrawCommandsNV_ovr_0_anh000110 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects[0], sizes[0], count) else
        z_DrawCommandsNV_ovr_0_anh000010(primitiveMode, buffer, indirects[0], IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsNV_ovr_0_anh000100(primitiveMode, buffer, IntPtr.Zero, sizes[0], count) else
        z_DrawCommandsNV_ovr_0_anh000110(primitiveMode, buffer, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsNV_ovr_1_anh000100 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; var sizes: Int32; count: UInt32)>(z_DrawCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects[0], sizes, count) else
      z_DrawCommandsNV_ovr_0_anh000100(primitiveMode, buffer, IntPtr.Zero, sizes, count);
    private z_DrawCommandsNV_ovr_2 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsNV_adr);
    private z_DrawCommandsNV_ovr_2_anh000100 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsNV_ovr_2(primitiveMode, buffer, indirects[0], sizes, count) else
      z_DrawCommandsNV_ovr_2_anh000100(primitiveMode, buffer, IntPtr.Zero, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects, sizes[0], count) else
      z_DrawCommandsNV_ovr_0_anh000010(primitiveMode, buffer, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsNV_ovr_2(primitiveMode, buffer, indirects, sizes, count);
    private z_DrawCommandsNV_ovr_6 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; var sizes: Int32; count: UInt32)>(z_DrawCommandsNV_adr);
    private z_DrawCommandsNV_ovr_6_anh000010 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: IntPtr; count: UInt32)>(z_DrawCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsNV_ovr_6(primitiveMode, buffer, indirects, sizes[0], count) else
      z_DrawCommandsNV_ovr_6_anh000010(primitiveMode, buffer, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsNV_ovr_6(primitiveMode, buffer, indirects, sizes, count);
    private z_DrawCommandsNV_ovr_8 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: IntPtr; count: UInt32)>(z_DrawCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsNV_ovr_8(primitiveMode, buffer, indirects, sizes, count);
    
    private z_DrawCommandsAddressNV_adr := GetProcAddress('glDrawCommandsAddressNV');
    private z_DrawCommandsAddressNV_ovr_0 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; var indirects: UInt64; var sizes: Int32; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    private z_DrawCommandsAddressNV_ovr_0_anh00100 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    private z_DrawCommandsAddressNV_ovr_0_anh00010 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; var indirects: UInt64; sizes: IntPtr; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    private z_DrawCommandsAddressNV_ovr_0_anh00110 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: array of UInt64; sizes: array of Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects[0], sizes[0], count) else
        z_DrawCommandsAddressNV_ovr_0_anh00010(primitiveMode, indirects[0], IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsAddressNV_ovr_0_anh00100(primitiveMode, IntPtr.Zero, sizes[0], count) else
        z_DrawCommandsAddressNV_ovr_0_anh00110(primitiveMode, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsAddressNV_ovr_1_anh00100 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: array of UInt64; var sizes: Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects[0], sizes, count) else
      z_DrawCommandsAddressNV_ovr_0_anh00100(primitiveMode, IntPtr.Zero, sizes, count);
    private z_DrawCommandsAddressNV_ovr_2 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; var indirects: UInt64; sizes: IntPtr; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    private z_DrawCommandsAddressNV_ovr_2_anh00100 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: array of UInt64; sizes: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsAddressNV_ovr_2(primitiveMode, indirects[0], sizes, count) else
      z_DrawCommandsAddressNV_ovr_2_anh00100(primitiveMode, IntPtr.Zero, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; var indirects: UInt64; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects, sizes[0], count) else
      z_DrawCommandsAddressNV_ovr_0_anh00010(primitiveMode, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; var indirects: UInt64; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; var indirects: UInt64; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_2(primitiveMode, indirects, sizes, count);
    private z_DrawCommandsAddressNV_ovr_6 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    private z_DrawCommandsAddressNV_ovr_6_anh00010 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: IntPtr; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsAddressNV_ovr_6(primitiveMode, indirects, sizes[0], count) else
      z_DrawCommandsAddressNV_ovr_6_anh00010(primitiveMode, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_6(primitiveMode, indirects, sizes, count);
    private z_DrawCommandsAddressNV_ovr_8 := GetProcOrNil&<procedure(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32)>(z_DrawCommandsAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_8(primitiveMode, indirects, sizes, count);
    
    private z_DrawCommandsStatesNV_adr := GetProcAddress('glDrawCommandsStatesNV');
    private z_DrawCommandsStatesNV_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0001100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0011100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0001010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0011010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0000110 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0010110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0001110 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_0_anh0011110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects[0], sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects[0], IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0001110(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0010110(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0011010(buffer, IntPtr.Zero, IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0011100(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0011110(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_1_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_1_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_1_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_1_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_1_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_1_anh0001100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_1_anh0011100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0011100(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0001100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_2_anh0011100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0001100(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0010100(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0011100(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_3_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_3_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_3_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_3_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_3_anh0001010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_3_anh0011010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0011010(buffer, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_4_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_4_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_4_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_5_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_5_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_5_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_6 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0001010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_6_anh0011010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0001010(buffer, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0010010(buffer, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0011010(buffer, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_7_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_7_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_7_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_6_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_8 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_8_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_8_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_8_anh0011000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_8(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_8_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_8_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_8_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_9_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_9_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_9_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_9_anh0010110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010110(buffer, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_10_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_10_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_11_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_11_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_12_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_12_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_13_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_14_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_15_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_15_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_16_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_17_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_8(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_8_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_18 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0000110 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_18_anh0010110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0000110(buffer, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0010010(buffer, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0010110(buffer, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_19_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_19_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_19_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_18_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_20 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_20_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_20_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_20_anh0010100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_20(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_20_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_20_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_20_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_21_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_21_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_22_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_23_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_20(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_20_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_24 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_24_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_24_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_24_anh0010010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_24(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_24_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_24_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_24_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_25_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_24(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_24_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_26 := GetProcOrNil&<procedure(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_26_anh0010000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_26(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_26_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001110(buffer, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_8(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_8_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_8(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_20(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_20_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_20(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_24(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_24_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_24(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_26(buffer, indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_54 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0001100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0001010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0000110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_54_anh0001110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0000110(buffer, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0001010(buffer, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0001110(buffer, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_55_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_55_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_55_anh0001100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_54_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_56 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_56_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_56_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_56_anh0001100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_56_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_56_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_56_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_57_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_57_anh0001010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_58_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_59_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_56_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_60 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_60_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_60_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_60_anh0001010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_60_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_60_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_60_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_61_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_60_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_62 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_62_anh0001000 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_62(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_62_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_56_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_60_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_62(buffer, indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_72 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_72_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_72_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_72_anh0000110 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_72_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_72_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_72_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesNV_ovr_73_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_72_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesNV_ovr_74 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_74_anh0000100 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_74(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_74_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_72_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_74(buffer, indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_78 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    private z_DrawCommandsStatesNV_ovr_78_anh0000010 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_78(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_78_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_78(buffer, indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesNV_ovr_80 := GetProcOrNil&<procedure(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: gl_buffer; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_80(buffer, indirects, sizes, states, fbos, count);
    
    private z_DrawCommandsStatesAddressNV_adr := GetProcAddress('glDrawCommandsStatesAddressNV');
    private z_DrawCommandsStatesAddressNV_ovr_0 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh000100 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh001100 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh011100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh000010 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh001010 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh011010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh000110 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh010110 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh001110 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_0_anh011110 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects[0], sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects[0], IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects[0], IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh001110(indirects[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh010110(IntPtr.Zero, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh011010(IntPtr.Zero, IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh011110(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh000100 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh001100 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_1_anh011100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_2 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh000100 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh001100 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_2_anh011100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh001100(indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh010100(IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2_anh011000(IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_3_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_3_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_3_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_3_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_3_anh001010 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_3_anh011010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh011010(IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_4_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_4_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_4_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_5_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_5_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_5_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_6 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh000010 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh001010 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_6_anh011010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh001010(indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh010010(IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh011010(IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_7_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_7_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_7_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_8 := GetProcOrNil&<procedure(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_8_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_8_anh001000 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_8_anh011000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_8(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_8_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_8_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_8_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_9_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_9_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_9_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_9_anh010110 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010110(IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_10_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_10_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_11_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_11_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_12_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_12_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_13_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_14_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_15_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_15_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_16_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_17_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_8(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_8_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_18 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh000100 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh000010 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh000110 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_18_anh010110 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh000110(indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh010010(IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh010110(IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_19_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_19_anh000100 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_19_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_20 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_20_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_20_anh000100 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_20_anh010100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_20(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_20_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_20_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_20_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_21_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_21_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_22_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_23_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_20(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_20_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_24 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_24_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_24_anh000010 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_24_anh010010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_24(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_24_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_24_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_24_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_25_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_24(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_24_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_26 := GetProcOrNil&<procedure(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_26_anh010000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_26(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_26_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001110(indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_8(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_8_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_8(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_20(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_20_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_20(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_24(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_24_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_24(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_26(indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_54 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh000100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh001100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh000010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh001010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh000110 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_54_anh001110 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh000110(indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh001010(indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh001110(indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_55_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_55_anh000100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_55_anh001100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_56 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_56_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_56_anh000100 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_56_anh001100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_56_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_56_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_56_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_57_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_57_anh001010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_58_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_59_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_56_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_60 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_60_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_60_anh000010 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_60_anh001010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_60_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_60_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_60_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_61_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_60_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_62 := GetProcOrNil&<procedure(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_62_anh001000 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_62(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_62_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_56_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_60_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_62(indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_72 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_72_anh000100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_72_anh000010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_72_anh000110 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_72_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_72_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_72_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_DrawCommandsStatesAddressNV_ovr_73_anh000100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_72_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_74 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_74_anh000100 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_74(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_74_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_72_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_74(indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_78 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    private z_DrawCommandsStatesAddressNV_ovr_78_anh000010 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_78(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_78_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_78(indirects, sizes, states, fbos, count);
    private z_DrawCommandsStatesAddressNV_ovr_80 := GetProcOrNil&<procedure(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_DrawCommandsStatesAddressNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_80(indirects, sizes, states, fbos, count);
    
    private z_CreateCommandListsNV_adr := GetProcAddress('glCreateCommandListsNV');
    private z_CreateCommandListsNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var lists: UInt32)>(z_CreateCommandListsNV_adr);
    private z_CreateCommandListsNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; lists: IntPtr)>(z_CreateCommandListsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateCommandListsNV(n: Int32; lists: array of UInt32) :=
    if (lists<>nil) and (lists.Length<>0) then
      z_CreateCommandListsNV_ovr_0(n, lists[0]) else
      z_CreateCommandListsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateCommandListsNV(n: Int32; var lists: UInt32) :=
    z_CreateCommandListsNV_ovr_0(n, lists);
    private z_CreateCommandListsNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; lists: IntPtr)>(z_CreateCommandListsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateCommandListsNV(n: Int32; lists: IntPtr) :=
    z_CreateCommandListsNV_ovr_2(n, lists);
    
    private z_DeleteCommandListsNV_adr := GetProcAddress('glDeleteCommandListsNV');
    private z_DeleteCommandListsNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var lists: UInt32)>(z_DeleteCommandListsNV_adr);
    private z_DeleteCommandListsNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; lists: IntPtr)>(z_DeleteCommandListsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteCommandListsNV(n: Int32; lists: array of UInt32) :=
    if (lists<>nil) and (lists.Length<>0) then
      z_DeleteCommandListsNV_ovr_0(n, lists[0]) else
      z_DeleteCommandListsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteCommandListsNV(n: Int32; var lists: UInt32) :=
    z_DeleteCommandListsNV_ovr_0(n, lists);
    private z_DeleteCommandListsNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; lists: IntPtr)>(z_DeleteCommandListsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteCommandListsNV(n: Int32; lists: IntPtr) :=
    z_DeleteCommandListsNV_ovr_2(n, lists);
    
    private z_IsCommandListNV_adr := GetProcAddress('glIsCommandListNV');
    private z_IsCommandListNV_ovr_0 := GetProcOrNil&<function(list: UInt32): boolean>(z_IsCommandListNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsCommandListNV(list: UInt32): boolean :=
    z_IsCommandListNV_ovr_0(list);
    
    private z_ListDrawCommandsStatesClientNV_adr := GetProcAddress('glListDrawCommandsStatesClientNV');
    private z_ListDrawCommandsStatesClientNV_ovr_0 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00011100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00011010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00010110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00001110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_0_anh00011110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes[0], IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects[0], sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects[0], IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001110(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010110(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011010(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011100(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011110(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00001100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_1_anh00011100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011100(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_2 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00001100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_2_anh00011100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00001100(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00010100(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00011100(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_3_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_3_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_3_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_3_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_3_anh00001010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_3_anh00011010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011010(list, segment, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_4_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_4_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_4_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_5_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_5_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_5_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_6 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00001010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_6_anh00011010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00001010(list, segment, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00010010(list, segment, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00011010(list, segment, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_7_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_7_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_7_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_8 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_8_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_8_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_8_anh00011000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_8_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_8_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_8_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_9_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_9_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_9_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_9_anh00010110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010110(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_10_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_10_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_11_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_11_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_12_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_12_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_13_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_14_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_15_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_15_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_16_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_17_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_8_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_18 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00000110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_18_anh00010110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00000110(list, segment, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010010(list, segment, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010110(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_19_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_19_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_19_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_20 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_20_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_20_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_20_anh00010100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_20_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_20_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_20_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_21_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_21_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_22_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_23_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_20_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_24 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_24_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_24_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_24_anh00010010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_24_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_24_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_24_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_25_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_24_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_26 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_26_anh00010000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_26(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_26_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001110(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_8_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_20_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_24_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_26(list, segment, indirects, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_54 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00001100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00001010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00000110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_54_anh00001110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00000110(list, segment, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001010(list, segment, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001110(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_55_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_55_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_55_anh00001100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_56 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_56_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_56_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_56_anh00001100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_56_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_56_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_56_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_57_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_57_anh00001010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_58_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_59_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_56_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_60 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_60_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_60_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_60_anh00001010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_60_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_60_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_60_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_61_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_60_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_62 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_62_anh00001000 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_62(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_62_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_56_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_60_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_62(list, segment, indirects, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_72 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_72_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_72_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_72_anh00000110 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_72_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_72_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_72_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private z_ListDrawCommandsStatesClientNV_ovr_73_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_72_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_74 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_74_anh00000100 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_74(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_74_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_72_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_74(list, segment, indirects, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_78 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    private z_ListDrawCommandsStatesClientNV_ovr_78_anh00000010 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_78(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_78_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_78(list, segment, indirects, sizes, states, fbos, count);
    private z_ListDrawCommandsStatesClientNV_ovr_80 := GetProcOrNil&<procedure(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32)>(z_ListDrawCommandsStatesClientNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_80(list, segment, indirects, sizes, states, fbos, count);
    
    private z_CommandListSegmentsNV_adr := GetProcAddress('glCommandListSegmentsNV');
    private z_CommandListSegmentsNV_ovr_0 := GetProcOrNil&<procedure(list: UInt32; segments: UInt32)>(z_CommandListSegmentsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CommandListSegmentsNV(list: UInt32; segments: UInt32) :=
    z_CommandListSegmentsNV_ovr_0(list, segments);
    
    private z_CompileCommandListNV_adr := GetProcAddress('glCompileCommandListNV');
    private z_CompileCommandListNV_ovr_0 := GetProcOrNil&<procedure(list: UInt32)>(z_CompileCommandListNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileCommandListNV(list: UInt32) :=
    z_CompileCommandListNV_ovr_0(list);
    
    private z_CallCommandListNV_adr := GetProcAddress('glCallCommandListNV');
    private z_CallCommandListNV_ovr_0 := GetProcOrNil&<procedure(list: UInt32)>(z_CallCommandListNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CallCommandListNV(list: UInt32) :=
    z_CallCommandListNV_ovr_0(list);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConditionalRenderNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_conditional_render';
    
    private z_BeginConditionalRenderNV_adr := GetProcAddress('glBeginConditionalRenderNV');
    private z_BeginConditionalRenderNV_ovr_0 := GetProcOrNil&<procedure(id: UInt32; mode: ConditionalRenderMode)>(z_BeginConditionalRenderNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginConditionalRenderNV(id: UInt32; mode: ConditionalRenderMode) :=
    z_BeginConditionalRenderNV_ovr_0(id, mode);
    
    private z_EndConditionalRenderNV_adr := GetProcAddress('glEndConditionalRenderNV');
    private z_EndConditionalRenderNV_ovr_0 := GetProcOrNil&<procedure>(z_EndConditionalRenderNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndConditionalRenderNV :=
    z_EndConditionalRenderNV_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConservativeRasterNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_conservative_raster';
    
    private z_SubpixelPrecisionBiasNV_adr := GetProcAddress('glSubpixelPrecisionBiasNV');
    private z_SubpixelPrecisionBiasNV_ovr_0 := GetProcOrNil&<procedure(xbits: UInt32; ybits: UInt32)>(z_SubpixelPrecisionBiasNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SubpixelPrecisionBiasNV(xbits: UInt32; ybits: UInt32) :=
    z_SubpixelPrecisionBiasNV_ovr_0(xbits, ybits);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConservativeRasterDilateNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_conservative_raster_dilate';
    
    private z_ConservativeRasterParameterfNV_adr := GetProcAddress('glConservativeRasterParameterfNV');
    private z_ConservativeRasterParameterfNV_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; value: single)>(z_ConservativeRasterParameterfNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConservativeRasterParameterfNV(pname: DummyEnum; value: single) :=
    z_ConservativeRasterParameterfNV_ovr_0(pname, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConservativeRasterPreSnapTrianglesNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_conservative_raster_pre_snap_triangles';
    
    private z_ConservativeRasterParameteriNV_adr := GetProcAddress('glConservativeRasterParameteriNV');
    private z_ConservativeRasterParameteriNV_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; param: Int32)>(z_ConservativeRasterParameteriNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConservativeRasterParameteriNV(pname: DummyEnum; param: Int32) :=
    z_ConservativeRasterParameteriNV_ovr_0(pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glCopyImageNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_copy_image';
    
    private z_CopyImageSubDataNV_adr := GetProcAddress('glCopyImageSubDataNV');
    private z_CopyImageSubDataNV_ovr_0 := GetProcOrNil&<procedure(srcName: UInt32; srcTarget: CopyBufferSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyBufferSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32)>(z_CopyImageSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubDataNV(srcName: UInt32; srcTarget: CopyBufferSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyBufferSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_CopyImageSubDataNV_ovr_0(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDepthBufferFloatNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_depth_buffer_float';
    
    private z_DepthRangedNV_adr := GetProcAddress('glDepthRangedNV');
    private z_DepthRangedNV_ovr_0 := GetProcOrNil&<procedure(zNear: real; zFar: real)>(z_DepthRangedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangedNV(zNear: real; zFar: real) :=
    z_DepthRangedNV_ovr_0(zNear, zFar);
    
    private z_ClearDepthdNV_adr := GetProcAddress('glClearDepthdNV');
    private z_ClearDepthdNV_ovr_0 := GetProcOrNil&<procedure(depth: real)>(z_ClearDepthdNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthdNV(depth: real) :=
    z_ClearDepthdNV_ovr_0(depth);
    
    private z_DepthBoundsdNV_adr := GetProcAddress('glDepthBoundsdNV');
    private z_DepthBoundsdNV_ovr_0 := GetProcOrNil&<procedure(zmin: real; zmax: real)>(z_DepthBoundsdNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthBoundsdNV(zmin: real; zmax: real) :=
    z_DepthBoundsdNV_ovr_0(zmin, zmax);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawTextureNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_draw_texture';
    
    private z_DrawTextureNV_adr := GetProcAddress('glDrawTextureNV');
    private z_DrawTextureNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; sampler: gl_sampler; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single)>(z_DrawTextureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTextureNV(texture: gl_texture; sampler: gl_sampler; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single) :=
    z_DrawTextureNV_ovr_0(texture, sampler, x0, y0, x1, y1, z, s0, t0, s1, t1);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDrawVulkanImageNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_draw_vulkan_image';
    
    private z_DrawVkImageNV_adr := GetProcAddress('glDrawVkImageNV');
    private z_DrawVkImageNV_ovr_0 := GetProcOrNil&<procedure(vkImage: UInt64; sampler: gl_sampler; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single)>(z_DrawVkImageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawVkImageNV(vkImage: UInt64; sampler: gl_sampler; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single) :=
    z_DrawVkImageNV_ovr_0(vkImage, sampler, x0, y0, x1, y1, z, s0, t0, s1, t1);
    
    private z_GetVkProcAddrNV_adr := GetProcAddress('glGetVkProcAddrNV');
    private z_GetVkProcAddrNV_ovr_0 := GetProcOrNil&<function(name: IntPtr): GL_VULKAN_PROC_NV>(z_GetVkProcAddrNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVkProcAddrNV(name: string): GL_VULKAN_PROC_NV;
    begin
      var par_1_str_ptr: IntPtr;
      try
        par_1_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetVkProcAddrNV_ovr_0(par_1_str_ptr);
      finally
        Marshal.FreeHGlobal(par_1_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVkProcAddrNV(name: IntPtr): GL_VULKAN_PROC_NV :=
    z_GetVkProcAddrNV_ovr_0(name);
    
    private z_WaitVkSemaphoreNV_adr := GetProcAddress('glWaitVkSemaphoreNV');
    private z_WaitVkSemaphoreNV_ovr_0 := GetProcOrNil&<procedure(vkSemaphore: UInt64)>(z_WaitVkSemaphoreNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitVkSemaphoreNV(vkSemaphore: UInt64) :=
    z_WaitVkSemaphoreNV_ovr_0(vkSemaphore);
    
    private z_SignalVkSemaphoreNV_adr := GetProcAddress('glSignalVkSemaphoreNV');
    private z_SignalVkSemaphoreNV_ovr_0 := GetProcOrNil&<procedure(vkSemaphore: UInt64)>(z_SignalVkSemaphoreNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalVkSemaphoreNV(vkSemaphore: UInt64) :=
    z_SignalVkSemaphoreNV_ovr_0(vkSemaphore);
    
    private z_SignalVkFenceNV_adr := GetProcAddress('glSignalVkFenceNV');
    private z_SignalVkFenceNV_ovr_0 := GetProcOrNil&<procedure(vkFence: UInt64)>(z_SignalVkFenceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalVkFenceNV(vkFence: UInt64) :=
    z_SignalVkFenceNV_ovr_0(vkFence);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glEvaluatorsNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_evaluators';
    
    private z_MapControlPointsNV_adr := GetProcAddress('glMapControlPointsNV');
    private z_MapControlPointsNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; uorder: Int32; vorder: Int32; &packed: boolean; points: IntPtr)>(z_MapControlPointsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapControlPointsNV(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; uorder: Int32; vorder: Int32; &packed: boolean; points: IntPtr) :=
    z_MapControlPointsNV_ovr_0(target, index, &type, ustride, vstride, uorder, vorder, &packed, points);
    
    private z_MapParameterivNV_adr := GetProcAddress('glMapParameterivNV');
    private z_MapParameterivNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32)>(z_MapParameterivNV_adr);
    private z_MapParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_MapParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MapParameterivNV_ovr_0(target, pname, &params[0]) else
      z_MapParameterivNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32) :=
    z_MapParameterivNV_ovr_0(target, pname, &params);
    private z_MapParameterivNV_ovr_2 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_MapParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_MapParameterivNV_ovr_2(target, pname, &params);
    
    private z_MapParameterfvNV_adr := GetProcAddress('glMapParameterfvNV');
    private z_MapParameterfvNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; var &params: single)>(z_MapParameterfvNV_adr);
    private z_MapParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_MapParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MapParameterfvNV_ovr_0(target, pname, &params[0]) else
      z_MapParameterfvNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; var &params: single) :=
    z_MapParameterfvNV_ovr_0(target, pname, &params);
    private z_MapParameterfvNV_ovr_2 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_MapParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_MapParameterfvNV_ovr_2(target, pname, &params);
    
    private z_GetMapControlPointsNV_adr := GetProcAddress('glGetMapControlPointsNV');
    private z_GetMapControlPointsNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; &packed: boolean; points: IntPtr)>(z_GetMapControlPointsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapControlPointsNV(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; &packed: boolean; points: IntPtr) :=
    z_GetMapControlPointsNV_ovr_0(target, index, &type, ustride, vstride, &packed, points);
    
    private z_GetMapParameterivNV_adr := GetProcAddress('glGetMapParameterivNV');
    private z_GetMapParameterivNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32)>(z_GetMapParameterivNV_adr);
    private z_GetMapParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_GetMapParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapParameterivNV_ovr_0(target, pname, &params[0]) else
      z_GetMapParameterivNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32) :=
    z_GetMapParameterivNV_ovr_0(target, pname, &params);
    private z_GetMapParameterivNV_ovr_2 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_GetMapParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_GetMapParameterivNV_ovr_2(target, pname, &params);
    
    private z_GetMapParameterfvNV_adr := GetProcAddress('glGetMapParameterfvNV');
    private z_GetMapParameterfvNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; var &params: single)>(z_GetMapParameterfvNV_adr);
    private z_GetMapParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_GetMapParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapParameterfvNV_ovr_0(target, pname, &params[0]) else
      z_GetMapParameterfvNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; var &params: single) :=
    z_GetMapParameterfvNV_ovr_0(target, pname, &params);
    private z_GetMapParameterfvNV_ovr_2 := GetProcOrNil&<procedure(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr)>(z_GetMapParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_GetMapParameterfvNV_ovr_2(target, pname, &params);
    
    private z_GetMapAttribParameterivNV_adr := GetProcAddress('glGetMapAttribParameterivNV');
    private z_GetMapAttribParameterivNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: Int32)>(z_GetMapAttribParameterivNV_adr);
    private z_GetMapAttribParameterivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr)>(z_GetMapAttribParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterivNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapAttribParameterivNV_ovr_0(target, index, pname, &params[0]) else
      z_GetMapAttribParameterivNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterivNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: Int32) :=
    z_GetMapAttribParameterivNV_ovr_0(target, index, pname, &params);
    private z_GetMapAttribParameterivNV_ovr_2 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr)>(z_GetMapAttribParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterivNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr) :=
    z_GetMapAttribParameterivNV_ovr_2(target, index, pname, &params);
    
    private z_GetMapAttribParameterfvNV_adr := GetProcAddress('glGetMapAttribParameterfvNV');
    private z_GetMapAttribParameterfvNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: single)>(z_GetMapAttribParameterfvNV_adr);
    private z_GetMapAttribParameterfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr)>(z_GetMapAttribParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterfvNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapAttribParameterfvNV_ovr_0(target, index, pname, &params[0]) else
      z_GetMapAttribParameterfvNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterfvNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: single) :=
    z_GetMapAttribParameterfvNV_ovr_0(target, index, pname, &params);
    private z_GetMapAttribParameterfvNV_ovr_2 := GetProcOrNil&<procedure(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr)>(z_GetMapAttribParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterfvNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr) :=
    z_GetMapAttribParameterfvNV_ovr_2(target, index, pname, &params);
    
    private z_EvalMapsNV_adr := GetProcAddress('glEvalMapsNV');
    private z_EvalMapsNV_ovr_0 := GetProcOrNil&<procedure(target: EvalTargetNV; mode: EvalMapsModeNV)>(z_EvalMapsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalMapsNV(target: EvalTargetNV; mode: EvalMapsModeNV) :=
    z_EvalMapsNV_ovr_0(target, mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glExplicitMultisampleNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_explicit_multisample';
    
    private z_GetMultisamplefvNV_adr := GetProcAddress('glGetMultisamplefvNV');
    private z_GetMultisamplefvNV_ovr_0 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; var val: single)>(z_GetMultisamplefvNV_adr);
    private z_GetMultisamplefvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefvNV(pname: GetMultisamplePNameNV; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_GetMultisamplefvNV_ovr_0(pname, index, val[0]) else
      z_GetMultisamplefvNV_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefvNV(pname: GetMultisamplePNameNV; index: UInt32; var val: single) :=
    z_GetMultisamplefvNV_ovr_0(pname, index, val);
    private z_GetMultisamplefvNV_ovr_2 := GetProcOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefvNV(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr) :=
    z_GetMultisamplefvNV_ovr_2(pname, index, val);
    
    private z_SampleMaskIndexedNV_adr := GetProcAddress('glSampleMaskIndexedNV');
    private z_SampleMaskIndexedNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; mask: DummyFlags)>(z_SampleMaskIndexedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaskIndexedNV(index: UInt32; mask: DummyFlags) :=
    z_SampleMaskIndexedNV_ovr_0(index, mask);
    
    private z_TexRenderbufferNV_adr := GetProcAddress('glTexRenderbufferNV');
    private z_TexRenderbufferNV_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; renderbuffer: gl_renderbuffer)>(z_TexRenderbufferNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexRenderbufferNV(target: TextureTarget; renderbuffer: gl_renderbuffer) :=
    z_TexRenderbufferNV_ovr_0(target, renderbuffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFenceNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_fence';
    
    private z_DeleteFencesNV_adr := GetProcAddress('glDeleteFencesNV');
    private z_DeleteFencesNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var fences: UInt32)>(z_DeleteFencesNV_adr);
    private z_DeleteFencesNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_DeleteFencesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesNV(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_DeleteFencesNV_ovr_0(n, fences[0]) else
      z_DeleteFencesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesNV(n: Int32; var fences: UInt32) :=
    z_DeleteFencesNV_ovr_0(n, fences);
    private z_DeleteFencesNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_DeleteFencesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesNV(n: Int32; fences: IntPtr) :=
    z_DeleteFencesNV_ovr_2(n, fences);
    
    private z_GenFencesNV_adr := GetProcAddress('glGenFencesNV');
    private z_GenFencesNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var fences: UInt32)>(z_GenFencesNV_adr);
    private z_GenFencesNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_GenFencesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesNV(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_GenFencesNV_ovr_0(n, fences[0]) else
      z_GenFencesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesNV(n: Int32; var fences: UInt32) :=
    z_GenFencesNV_ovr_0(n, fences);
    private z_GenFencesNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; fences: IntPtr)>(z_GenFencesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesNV(n: Int32; fences: IntPtr) :=
    z_GenFencesNV_ovr_2(n, fences);
    
    private z_IsFenceNV_adr := GetProcAddress('glIsFenceNV');
    private z_IsFenceNV_ovr_0 := GetProcOrNil&<function(fence: UInt32): boolean>(z_IsFenceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFenceNV(fence: UInt32): boolean :=
    z_IsFenceNV_ovr_0(fence);
    
    private z_TestFenceNV_adr := GetProcAddress('glTestFenceNV');
    private z_TestFenceNV_ovr_0 := GetProcOrNil&<function(fence: UInt32): boolean>(z_TestFenceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function TestFenceNV(fence: UInt32): boolean :=
    z_TestFenceNV_ovr_0(fence);
    
    private z_GetFenceivNV_adr := GetProcAddress('glGetFenceivNV');
    private z_GetFenceivNV_ovr_0 := GetProcOrNil&<procedure(fence: UInt32; pname: FenceParameterNameNV; var &params: Int32)>(z_GetFenceivNV_adr);
    private z_GetFenceivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(fence: UInt32; pname: FenceParameterNameNV; &params: IntPtr)>(z_GetFenceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFenceivNV(fence: UInt32; pname: FenceParameterNameNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFenceivNV_ovr_0(fence, pname, &params[0]) else
      z_GetFenceivNV_ovr_0_anh0001(fence, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFenceivNV(fence: UInt32; pname: FenceParameterNameNV; var &params: Int32) :=
    z_GetFenceivNV_ovr_0(fence, pname, &params);
    private z_GetFenceivNV_ovr_2 := GetProcOrNil&<procedure(fence: UInt32; pname: FenceParameterNameNV; &params: IntPtr)>(z_GetFenceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFenceivNV(fence: UInt32; pname: FenceParameterNameNV; &params: IntPtr) :=
    z_GetFenceivNV_ovr_2(fence, pname, &params);
    
    private z_FinishFenceNV_adr := GetProcAddress('glFinishFenceNV');
    private z_FinishFenceNV_ovr_0 := GetProcOrNil&<procedure(fence: UInt32)>(z_FinishFenceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishFenceNV(fence: UInt32) :=
    z_FinishFenceNV_ovr_0(fence);
    
    private z_SetFenceNV_adr := GetProcAddress('glSetFenceNV');
    private z_SetFenceNV_ovr_0 := GetProcOrNil&<procedure(fence: UInt32; condition: FenceConditionNV)>(z_SetFenceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFenceNV(fence: UInt32; condition: FenceConditionNV) :=
    z_SetFenceNV_ovr_0(fence, condition);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFragmentCoverageToColorNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_fragment_coverage_to_color';
    
    private z_FragmentCoverageColorNV_adr := GetProcAddress('glFragmentCoverageColorNV');
    private z_FragmentCoverageColorNV_ovr_0 := GetProcOrNil&<procedure(color: UInt32)>(z_FragmentCoverageColorNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentCoverageColorNV(color: UInt32) :=
    z_FragmentCoverageColorNV_ovr_0(color);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFragmentProgramNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_fragment_program';
    
    private z_ProgramNamedParameter4fNV_adr := GetProcAddress('glProgramNamedParameter4fNV');
    private z_ProgramNamedParameter4fNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; x: single; y: single; z: single; w: single)>(z_ProgramNamedParameter4fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fNV(id: gl_program; len: Int32; var name: Byte; x: single; y: single; z: single; w: single) :=
    z_ProgramNamedParameter4fNV_ovr_0(id, len, name, x, y, z, w);
    private z_ProgramNamedParameter4fNV_ovr_1 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; x: single; y: single; z: single; w: single)>(z_ProgramNamedParameter4fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fNV(id: gl_program; len: Int32; name: IntPtr; x: single; y: single; z: single; w: single) :=
    z_ProgramNamedParameter4fNV_ovr_1(id, len, name, x, y, z, w);
    
    private z_ProgramNamedParameter4fvNV_adr := GetProcAddress('glProgramNamedParameter4fvNV');
    private z_ProgramNamedParameter4fvNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; var v: single)>(z_ProgramNamedParameter4fvNV_adr);
    private z_ProgramNamedParameter4fvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; v: IntPtr)>(z_ProgramNamedParameter4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: gl_program; len: Int32; var name: Byte; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4fvNV_ovr_0(id, len, name, v[0]) else
      z_ProgramNamedParameter4fvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: gl_program; len: Int32; var name: Byte; var v: single) :=
    z_ProgramNamedParameter4fvNV_ovr_0(id, len, name, v);
    private z_ProgramNamedParameter4fvNV_ovr_2 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; v: IntPtr)>(z_ProgramNamedParameter4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: gl_program; len: Int32; var name: Byte; v: IntPtr) :=
    z_ProgramNamedParameter4fvNV_ovr_2(id, len, name, v);
    private z_ProgramNamedParameter4fvNV_ovr_3 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; var v: single)>(z_ProgramNamedParameter4fvNV_adr);
    private z_ProgramNamedParameter4fvNV_ovr_3_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; v: IntPtr)>(z_ProgramNamedParameter4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: gl_program; len: Int32; name: IntPtr; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4fvNV_ovr_3(id, len, name, v[0]) else
      z_ProgramNamedParameter4fvNV_ovr_3_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: gl_program; len: Int32; name: IntPtr; var v: single) :=
    z_ProgramNamedParameter4fvNV_ovr_3(id, len, name, v);
    private z_ProgramNamedParameter4fvNV_ovr_5 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; v: IntPtr)>(z_ProgramNamedParameter4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: gl_program; len: Int32; name: IntPtr; v: IntPtr) :=
    z_ProgramNamedParameter4fvNV_ovr_5(id, len, name, v);
    
    private z_ProgramNamedParameter4dNV_adr := GetProcAddress('glProgramNamedParameter4dNV');
    private z_ProgramNamedParameter4dNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; x: real; y: real; z: real; w: real)>(z_ProgramNamedParameter4dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dNV(id: gl_program; len: Int32; var name: Byte; x: real; y: real; z: real; w: real) :=
    z_ProgramNamedParameter4dNV_ovr_0(id, len, name, x, y, z, w);
    private z_ProgramNamedParameter4dNV_ovr_1 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; x: real; y: real; z: real; w: real)>(z_ProgramNamedParameter4dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dNV(id: gl_program; len: Int32; name: IntPtr; x: real; y: real; z: real; w: real) :=
    z_ProgramNamedParameter4dNV_ovr_1(id, len, name, x, y, z, w);
    
    private z_ProgramNamedParameter4dvNV_adr := GetProcAddress('glProgramNamedParameter4dvNV');
    private z_ProgramNamedParameter4dvNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; var v: real)>(z_ProgramNamedParameter4dvNV_adr);
    private z_ProgramNamedParameter4dvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; v: IntPtr)>(z_ProgramNamedParameter4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: gl_program; len: Int32; var name: Byte; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4dvNV_ovr_0(id, len, name, v[0]) else
      z_ProgramNamedParameter4dvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: gl_program; len: Int32; var name: Byte; var v: real) :=
    z_ProgramNamedParameter4dvNV_ovr_0(id, len, name, v);
    private z_ProgramNamedParameter4dvNV_ovr_2 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; v: IntPtr)>(z_ProgramNamedParameter4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: gl_program; len: Int32; var name: Byte; v: IntPtr) :=
    z_ProgramNamedParameter4dvNV_ovr_2(id, len, name, v);
    private z_ProgramNamedParameter4dvNV_ovr_3 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; var v: real)>(z_ProgramNamedParameter4dvNV_adr);
    private z_ProgramNamedParameter4dvNV_ovr_3_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; v: IntPtr)>(z_ProgramNamedParameter4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: gl_program; len: Int32; name: IntPtr; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4dvNV_ovr_3(id, len, name, v[0]) else
      z_ProgramNamedParameter4dvNV_ovr_3_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: gl_program; len: Int32; name: IntPtr; var v: real) :=
    z_ProgramNamedParameter4dvNV_ovr_3(id, len, name, v);
    private z_ProgramNamedParameter4dvNV_ovr_5 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; v: IntPtr)>(z_ProgramNamedParameter4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: gl_program; len: Int32; name: IntPtr; v: IntPtr) :=
    z_ProgramNamedParameter4dvNV_ovr_5(id, len, name, v);
    
    private z_GetProgramNamedParameterfvNV_adr := GetProcAddress('glGetProgramNamedParameterfvNV');
    private z_GetProgramNamedParameterfvNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; var &params: single)>(z_GetProgramNamedParameterfvNV_adr);
    private z_GetProgramNamedParameterfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; &params: IntPtr)>(z_GetProgramNamedParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: gl_program; len: Int32; var name: Byte; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterfvNV_ovr_0(id, len, name, &params[0]) else
      z_GetProgramNamedParameterfvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: gl_program; len: Int32; var name: Byte; var &params: single) :=
    z_GetProgramNamedParameterfvNV_ovr_0(id, len, name, &params);
    private z_GetProgramNamedParameterfvNV_ovr_2 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; &params: IntPtr)>(z_GetProgramNamedParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: gl_program; len: Int32; var name: Byte; &params: IntPtr) :=
    z_GetProgramNamedParameterfvNV_ovr_2(id, len, name, &params);
    private z_GetProgramNamedParameterfvNV_ovr_3 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; var &params: single)>(z_GetProgramNamedParameterfvNV_adr);
    private z_GetProgramNamedParameterfvNV_ovr_3_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; &params: IntPtr)>(z_GetProgramNamedParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: gl_program; len: Int32; name: IntPtr; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterfvNV_ovr_3(id, len, name, &params[0]) else
      z_GetProgramNamedParameterfvNV_ovr_3_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: gl_program; len: Int32; name: IntPtr; var &params: single) :=
    z_GetProgramNamedParameterfvNV_ovr_3(id, len, name, &params);
    private z_GetProgramNamedParameterfvNV_ovr_5 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; &params: IntPtr)>(z_GetProgramNamedParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: gl_program; len: Int32; name: IntPtr; &params: IntPtr) :=
    z_GetProgramNamedParameterfvNV_ovr_5(id, len, name, &params);
    
    private z_GetProgramNamedParameterdvNV_adr := GetProcAddress('glGetProgramNamedParameterdvNV');
    private z_GetProgramNamedParameterdvNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; var &params: real)>(z_GetProgramNamedParameterdvNV_adr);
    private z_GetProgramNamedParameterdvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; &params: IntPtr)>(z_GetProgramNamedParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: gl_program; len: Int32; var name: Byte; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterdvNV_ovr_0(id, len, name, &params[0]) else
      z_GetProgramNamedParameterdvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: gl_program; len: Int32; var name: Byte; var &params: real) :=
    z_GetProgramNamedParameterdvNV_ovr_0(id, len, name, &params);
    private z_GetProgramNamedParameterdvNV_ovr_2 := GetProcOrNil&<procedure(id: gl_program; len: Int32; var name: Byte; &params: IntPtr)>(z_GetProgramNamedParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: gl_program; len: Int32; var name: Byte; &params: IntPtr) :=
    z_GetProgramNamedParameterdvNV_ovr_2(id, len, name, &params);
    private z_GetProgramNamedParameterdvNV_ovr_3 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; var &params: real)>(z_GetProgramNamedParameterdvNV_adr);
    private z_GetProgramNamedParameterdvNV_ovr_3_anh00001 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; &params: IntPtr)>(z_GetProgramNamedParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: gl_program; len: Int32; name: IntPtr; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterdvNV_ovr_3(id, len, name, &params[0]) else
      z_GetProgramNamedParameterdvNV_ovr_3_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: gl_program; len: Int32; name: IntPtr; var &params: real) :=
    z_GetProgramNamedParameterdvNV_ovr_3(id, len, name, &params);
    private z_GetProgramNamedParameterdvNV_ovr_5 := GetProcOrNil&<procedure(id: gl_program; len: Int32; name: IntPtr; &params: IntPtr)>(z_GetProgramNamedParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: gl_program; len: Int32; name: IntPtr; &params: IntPtr) :=
    z_GetProgramNamedParameterdvNV_ovr_5(id, len, name, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferMixedSamplesNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_framebuffer_mixed_samples';
    
    private z_RasterSamplesEXT_adr := GetProcAddress('glRasterSamplesEXT');
    private z_RasterSamplesEXT_ovr_0 := GetProcOrNil&<procedure(samples: UInt32; fixedsamplelocations: boolean)>(z_RasterSamplesEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterSamplesEXT(samples: UInt32; fixedsamplelocations: boolean) :=
    z_RasterSamplesEXT_ovr_0(samples, fixedsamplelocations);
    
    private z_CoverageModulationTableNV_adr := GetProcAddress('glCoverageModulationTableNV');
    private z_CoverageModulationTableNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var v: single)>(z_CoverageModulationTableNV_adr);
    private z_CoverageModulationTableNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; v: IntPtr)>(z_CoverageModulationTableNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationTableNV(n: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_CoverageModulationTableNV_ovr_0(n, v[0]) else
      z_CoverageModulationTableNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationTableNV(n: Int32; var v: single) :=
    z_CoverageModulationTableNV_ovr_0(n, v);
    private z_CoverageModulationTableNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; v: IntPtr)>(z_CoverageModulationTableNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationTableNV(n: Int32; v: IntPtr) :=
    z_CoverageModulationTableNV_ovr_2(n, v);
    
    private z_GetCoverageModulationTableNV_adr := GetProcAddress('glGetCoverageModulationTableNV');
    private z_GetCoverageModulationTableNV_ovr_0 := GetProcOrNil&<procedure(bufSize: Int32; var v: single)>(z_GetCoverageModulationTableNV_adr);
    private z_GetCoverageModulationTableNV_ovr_0_anh001 := GetProcOrNil&<procedure(bufSize: Int32; v: IntPtr)>(z_GetCoverageModulationTableNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCoverageModulationTableNV(bufSize: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetCoverageModulationTableNV_ovr_0(bufSize, v[0]) else
      z_GetCoverageModulationTableNV_ovr_0_anh001(bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCoverageModulationTableNV(bufSize: Int32; var v: single) :=
    z_GetCoverageModulationTableNV_ovr_0(bufSize, v);
    private z_GetCoverageModulationTableNV_ovr_2 := GetProcOrNil&<procedure(bufSize: Int32; v: IntPtr)>(z_GetCoverageModulationTableNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCoverageModulationTableNV(bufSize: Int32; v: IntPtr) :=
    z_GetCoverageModulationTableNV_ovr_2(bufSize, v);
    
    private z_CoverageModulationNV_adr := GetProcAddress('glCoverageModulationNV');
    private z_CoverageModulationNV_ovr_0 := GetProcOrNil&<procedure(components: DummyEnum)>(z_CoverageModulationNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationNV(components: DummyEnum) :=
    z_CoverageModulationNV_ovr_0(components);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramebufferMultisampleCoverageNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_framebuffer_multisample_coverage';
    
    private z_RenderbufferStorageMultisampleCoverageNV_adr := GetProcAddress('glRenderbufferStorageMultisampleCoverageNV');
    private z_RenderbufferStorageMultisampleCoverageNV_ovr_0 := GetProcOrNil&<procedure(target: RenderbufferTarget; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageMultisampleCoverageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisampleCoverageNV(target: RenderbufferTarget; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisampleCoverageNV_ovr_0(target, coverageSamples, colorSamples, _internalformat, width, height);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGeometryProgram4NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_geometry_program4';
    
    private z_ProgramVertexLimitNV_adr := GetProcAddress('glProgramVertexLimitNV');
    private z_ProgramVertexLimitNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; limit: Int32)>(z_ProgramVertexLimitNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramVertexLimitNV(target: ProgramTarget; limit: Int32) :=
    z_ProgramVertexLimitNV_ovr_0(target, limit);
    
    private z_FramebufferTextureEXT_adr := GetProcAddress('glFramebufferTextureEXT');
    private z_FramebufferTextureEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32)>(z_FramebufferTextureEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32) :=
    z_FramebufferTextureEXT_ovr_0(target, attachment, texture, level);
    
    private z_FramebufferTextureLayerEXT_adr := GetProcAddress('glFramebufferTextureLayerEXT');
    private z_FramebufferTextureLayerEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32)>(z_FramebufferTextureLayerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayerEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayerEXT_ovr_0(target, attachment, texture, level, layer);
    
    private z_FramebufferTextureFaceEXT_adr := GetProcAddress('glFramebufferTextureFaceEXT');
    private z_FramebufferTextureFaceEXT_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; face: TextureTarget)>(z_FramebufferTextureFaceEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureFaceEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; face: TextureTarget) :=
    z_FramebufferTextureFaceEXT_ovr_0(target, attachment, texture, level, face);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuProgram4NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_gpu_program4';
    
    private z_ProgramLocalParameterI4iNV_adr := GetProcAddress('glProgramLocalParameterI4iNV');
    private z_ProgramLocalParameterI4iNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_ProgramLocalParameterI4iNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4iNV(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_ProgramLocalParameterI4iNV_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramLocalParameterI4ivNV_adr := GetProcAddress('glProgramLocalParameterI4ivNV');
    private z_ProgramLocalParameterI4ivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: Int32)>(z_ProgramLocalParameterI4ivNV_adr);
    private z_ProgramLocalParameterI4ivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameterI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameterI4ivNV_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameterI4ivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4ivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_ProgramLocalParameterI4ivNV_ovr_0(target, index, &params);
    private z_ProgramLocalParameterI4ivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameterI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameterI4ivNV_ovr_2(target, index, &params);
    
    private z_ProgramLocalParametersI4ivNV_adr := GetProcAddress('glProgramLocalParametersI4ivNV');
    private z_ProgramLocalParametersI4ivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32)>(z_ProgramLocalParametersI4ivNV_adr);
    private z_ProgramLocalParametersI4ivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramLocalParametersI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParametersI4ivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramLocalParametersI4ivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32) :=
    z_ProgramLocalParametersI4ivNV_ovr_0(target, index, count, &params);
    private z_ProgramLocalParametersI4ivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramLocalParametersI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramLocalParametersI4ivNV_ovr_2(target, index, count, &params);
    
    private z_ProgramLocalParameterI4uiNV_adr := GetProcAddress('glProgramLocalParameterI4uiNV');
    private z_ProgramLocalParameterI4uiNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_ProgramLocalParameterI4uiNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uiNV(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_ProgramLocalParameterI4uiNV_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramLocalParameterI4uivNV_adr := GetProcAddress('glProgramLocalParameterI4uivNV');
    private z_ProgramLocalParameterI4uivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: UInt32)>(z_ProgramLocalParameterI4uivNV_adr);
    private z_ProgramLocalParameterI4uivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameterI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameterI4uivNV_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameterI4uivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_ProgramLocalParameterI4uivNV_ovr_0(target, index, &params);
    private z_ProgramLocalParameterI4uivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramLocalParameterI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameterI4uivNV_ovr_2(target, index, &params);
    
    private z_ProgramLocalParametersI4uivNV_adr := GetProcAddress('glProgramLocalParametersI4uivNV');
    private z_ProgramLocalParametersI4uivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32)>(z_ProgramLocalParametersI4uivNV_adr);
    private z_ProgramLocalParametersI4uivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramLocalParametersI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParametersI4uivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramLocalParametersI4uivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32) :=
    z_ProgramLocalParametersI4uivNV_ovr_0(target, index, count, &params);
    private z_ProgramLocalParametersI4uivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramLocalParametersI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramLocalParametersI4uivNV_ovr_2(target, index, count, &params);
    
    private z_ProgramEnvParameterI4iNV_adr := GetProcAddress('glProgramEnvParameterI4iNV');
    private z_ProgramEnvParameterI4iNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_ProgramEnvParameterI4iNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4iNV(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_ProgramEnvParameterI4iNV_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramEnvParameterI4ivNV_adr := GetProcAddress('glProgramEnvParameterI4ivNV');
    private z_ProgramEnvParameterI4ivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: Int32)>(z_ProgramEnvParameterI4ivNV_adr);
    private z_ProgramEnvParameterI4ivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameterI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameterI4ivNV_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameterI4ivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4ivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_ProgramEnvParameterI4ivNV_ovr_0(target, index, &params);
    private z_ProgramEnvParameterI4ivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameterI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameterI4ivNV_ovr_2(target, index, &params);
    
    private z_ProgramEnvParametersI4ivNV_adr := GetProcAddress('glProgramEnvParametersI4ivNV');
    private z_ProgramEnvParametersI4ivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32)>(z_ProgramEnvParametersI4ivNV_adr);
    private z_ProgramEnvParametersI4ivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramEnvParametersI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParametersI4ivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramEnvParametersI4ivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32) :=
    z_ProgramEnvParametersI4ivNV_ovr_0(target, index, count, &params);
    private z_ProgramEnvParametersI4ivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramEnvParametersI4ivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramEnvParametersI4ivNV_ovr_2(target, index, count, &params);
    
    private z_ProgramEnvParameterI4uiNV_adr := GetProcAddress('glProgramEnvParameterI4uiNV');
    private z_ProgramEnvParameterI4uiNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_ProgramEnvParameterI4uiNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uiNV(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_ProgramEnvParameterI4uiNV_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramEnvParameterI4uivNV_adr := GetProcAddress('glProgramEnvParameterI4uivNV');
    private z_ProgramEnvParameterI4uivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: UInt32)>(z_ProgramEnvParameterI4uivNV_adr);
    private z_ProgramEnvParameterI4uivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameterI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameterI4uivNV_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameterI4uivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_ProgramEnvParameterI4uivNV_ovr_0(target, index, &params);
    private z_ProgramEnvParameterI4uivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_ProgramEnvParameterI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameterI4uivNV_ovr_2(target, index, &params);
    
    private z_ProgramEnvParametersI4uivNV_adr := GetProcAddress('glProgramEnvParametersI4uivNV');
    private z_ProgramEnvParametersI4uivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32)>(z_ProgramEnvParametersI4uivNV_adr);
    private z_ProgramEnvParametersI4uivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramEnvParametersI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParametersI4uivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramEnvParametersI4uivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32) :=
    z_ProgramEnvParametersI4uivNV_ovr_0(target, index, count, &params);
    private z_ProgramEnvParametersI4uivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr)>(z_ProgramEnvParametersI4uivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramEnvParametersI4uivNV_ovr_2(target, index, count, &params);
    
    private z_GetProgramLocalParameterIivNV_adr := GetProcAddress('glGetProgramLocalParameterIivNV');
    private z_GetProgramLocalParameterIivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: Int32)>(z_GetProgramLocalParameterIivNV_adr);
    private z_GetProgramLocalParameterIivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterIivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterIivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterIivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_GetProgramLocalParameterIivNV_ovr_0(target, index, &params);
    private z_GetProgramLocalParameterIivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterIivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterIivNV_ovr_2(target, index, &params);
    
    private z_GetProgramLocalParameterIuivNV_adr := GetProcAddress('glGetProgramLocalParameterIuivNV');
    private z_GetProgramLocalParameterIuivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: UInt32)>(z_GetProgramLocalParameterIuivNV_adr);
    private z_GetProgramLocalParameterIuivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterIuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIuivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterIuivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterIuivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIuivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_GetProgramLocalParameterIuivNV_ovr_0(target, index, &params);
    private z_GetProgramLocalParameterIuivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramLocalParameterIuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIuivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterIuivNV_ovr_2(target, index, &params);
    
    private z_GetProgramEnvParameterIivNV_adr := GetProcAddress('glGetProgramEnvParameterIivNV');
    private z_GetProgramEnvParameterIivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: Int32)>(z_GetProgramEnvParameterIivNV_adr);
    private z_GetProgramEnvParameterIivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterIivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterIivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterIivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_GetProgramEnvParameterIivNV_ovr_0(target, index, &params);
    private z_GetProgramEnvParameterIivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterIivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterIivNV_ovr_2(target, index, &params);
    
    private z_GetProgramEnvParameterIuivNV_adr := GetProcAddress('glGetProgramEnvParameterIuivNV');
    private z_GetProgramEnvParameterIuivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; var &params: UInt32)>(z_GetProgramEnvParameterIuivNV_adr);
    private z_GetProgramEnvParameterIuivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterIuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIuivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterIuivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterIuivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIuivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_GetProgramEnvParameterIuivNV_ovr_0(target, index, &params);
    private z_GetProgramEnvParameterIuivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; index: UInt32; &params: IntPtr)>(z_GetProgramEnvParameterIuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIuivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterIuivNV_ovr_2(target, index, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuProgram5NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_gpu_program5';
    
    private z_ProgramSubroutineParametersuivNV_adr := GetProcAddress('glProgramSubroutineParametersuivNV');
    private z_ProgramSubroutineParametersuivNV_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; count: Int32; var &params: UInt32)>(z_ProgramSubroutineParametersuivNV_adr);
    private z_ProgramSubroutineParametersuivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; count: Int32; &params: IntPtr)>(z_ProgramSubroutineParametersuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramSubroutineParametersuivNV(target: DummyEnum; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramSubroutineParametersuivNV_ovr_0(target, count, &params[0]) else
      z_ProgramSubroutineParametersuivNV_ovr_0_anh0001(target, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramSubroutineParametersuivNV(target: DummyEnum; count: Int32; var &params: UInt32) :=
    z_ProgramSubroutineParametersuivNV_ovr_0(target, count, &params);
    private z_ProgramSubroutineParametersuivNV_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; count: Int32; &params: IntPtr)>(z_ProgramSubroutineParametersuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramSubroutineParametersuivNV(target: DummyEnum; count: Int32; &params: IntPtr) :=
    z_ProgramSubroutineParametersuivNV_ovr_2(target, count, &params);
    
    private z_GetProgramSubroutineParameteruivNV_adr := GetProcAddress('glGetProgramSubroutineParameteruivNV');
    private z_GetProgramSubroutineParameteruivNV_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; var param: UInt32)>(z_GetProgramSubroutineParameteruivNV_adr);
    private z_GetProgramSubroutineParameteruivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; param: IntPtr)>(z_GetProgramSubroutineParameteruivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramSubroutineParameteruivNV(target: DummyEnum; index: UInt32; param: array of UInt32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetProgramSubroutineParameteruivNV_ovr_0(target, index, param[0]) else
      z_GetProgramSubroutineParameteruivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramSubroutineParameteruivNV(target: DummyEnum; index: UInt32; var param: UInt32) :=
    z_GetProgramSubroutineParameteruivNV_ovr_0(target, index, param);
    private z_GetProgramSubroutineParameteruivNV_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; index: UInt32; param: IntPtr)>(z_GetProgramSubroutineParameteruivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramSubroutineParameteruivNV(target: DummyEnum; index: UInt32; param: IntPtr) :=
    z_GetProgramSubroutineParameteruivNV_ovr_2(target, index, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuShader5NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_gpu_shader5';
    
    private z_Uniform1i64NV_adr := GetProcAddress('glUniform1i64NV');
    private z_Uniform1i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64)>(z_Uniform1i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64NV(location: Int32; x: Int64) :=
    z_Uniform1i64NV_ovr_0(location, x);
    
    private z_Uniform2i64NV_adr := GetProcAddress('glUniform2i64NV');
    private z_Uniform2i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64)>(z_Uniform2i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64NV(location: Int32; x: Int64; y: Int64) :=
    z_Uniform2i64NV_ovr_0(location, x, y);
    
    private z_Uniform3i64NV_adr := GetProcAddress('glUniform3i64NV');
    private z_Uniform3i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64; z: Int64)>(z_Uniform3i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64NV(location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_Uniform3i64NV_ovr_0(location, x, y, z);
    
    private z_Uniform4i64NV_adr := GetProcAddress('glUniform4i64NV');
    private z_Uniform4i64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_Uniform4i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64NV(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_Uniform4i64NV_ovr_0(location, x, y, z, w);
    
    private z_Uniform1i64vNV_adr := GetProcAddress('glUniform1i64vNV');
    private z_Uniform1i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform1i64vNV_adr);
    private z_Uniform1i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform1i64vNV_ovr_0(location, count, value);
    private z_Uniform1i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1i64vNV_ovr_2(location, count, value);
    
    private z_Uniform2i64vNV_adr := GetProcAddress('glUniform2i64vNV');
    private z_Uniform2i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform2i64vNV_adr);
    private z_Uniform2i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform2i64vNV_ovr_0(location, count, value);
    private z_Uniform2i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2i64vNV_ovr_2(location, count, value);
    
    private z_Uniform3i64vNV_adr := GetProcAddress('glUniform3i64vNV');
    private z_Uniform3i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform3i64vNV_adr);
    private z_Uniform3i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform3i64vNV_ovr_0(location, count, value);
    private z_Uniform3i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3i64vNV_ovr_2(location, count, value);
    
    private z_Uniform4i64vNV_adr := GetProcAddress('glUniform4i64vNV');
    private z_Uniform4i64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: Int64)>(z_Uniform4i64vNV_adr);
    private z_Uniform4i64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform4i64vNV_ovr_0(location, count, value);
    private z_Uniform4i64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4i64vNV_ovr_2(location, count, value);
    
    private z_Uniform1ui64NV_adr := GetProcAddress('glUniform1ui64NV');
    private z_Uniform1ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64)>(z_Uniform1ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64NV(location: Int32; x: UInt64) :=
    z_Uniform1ui64NV_ovr_0(location, x);
    
    private z_Uniform2ui64NV_adr := GetProcAddress('glUniform2ui64NV');
    private z_Uniform2ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64)>(z_Uniform2ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64NV(location: Int32; x: UInt64; y: UInt64) :=
    z_Uniform2ui64NV_ovr_0(location, x, y);
    
    private z_Uniform3ui64NV_adr := GetProcAddress('glUniform3ui64NV');
    private z_Uniform3ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64; z: UInt64)>(z_Uniform3ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_Uniform3ui64NV_ovr_0(location, x, y, z);
    
    private z_Uniform4ui64NV_adr := GetProcAddress('glUniform4ui64NV');
    private z_Uniform4ui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_Uniform4ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_Uniform4ui64NV_ovr_0(location, x, y, z, w);
    
    private z_Uniform1ui64vNV_adr := GetProcAddress('glUniform1ui64vNV');
    private z_Uniform1ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform1ui64vNV_adr);
    private z_Uniform1ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform1ui64vNV_ovr_0(location, count, value);
    private z_Uniform1ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ui64vNV_ovr_2(location, count, value);
    
    private z_Uniform2ui64vNV_adr := GetProcAddress('glUniform2ui64vNV');
    private z_Uniform2ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform2ui64vNV_adr);
    private z_Uniform2ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform2ui64vNV_ovr_0(location, count, value);
    private z_Uniform2ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ui64vNV_ovr_2(location, count, value);
    
    private z_Uniform3ui64vNV_adr := GetProcAddress('glUniform3ui64vNV');
    private z_Uniform3ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform3ui64vNV_adr);
    private z_Uniform3ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform3ui64vNV_ovr_0(location, count, value);
    private z_Uniform3ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ui64vNV_ovr_2(location, count, value);
    
    private z_Uniform4ui64vNV_adr := GetProcAddress('glUniform4ui64vNV');
    private z_Uniform4ui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniform4ui64vNV_adr);
    private z_Uniform4ui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform4ui64vNV_ovr_0(location, count, value);
    private z_Uniform4ui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ui64vNV_ovr_2(location, count, value);
    
    private z_GetUniformi64vNV_adr := GetProcAddress('glGetUniformi64vNV');
    private z_GetUniformi64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: Int64)>(z_GetUniformi64vNV_adr);
    private z_GetUniformi64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: gl_program; location: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformi64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformi64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: gl_program; location: Int32; var &params: Int64) :=
    z_GetUniformi64vNV_ovr_0(&program, location, &params);
    private z_GetUniformi64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformi64vNV_ovr_2(&program, location, &params);
    
    private z_ProgramUniform1i64NV_adr := GetProcAddress('glProgramUniform1i64NV');
    private z_ProgramUniform1i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64)>(z_ProgramUniform1i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64NV(&program: gl_program; location: Int32; x: Int64) :=
    z_ProgramUniform1i64NV_ovr_0(&program, location, x);
    
    private z_ProgramUniform2i64NV_adr := GetProcAddress('glProgramUniform2i64NV');
    private z_ProgramUniform2i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64)>(z_ProgramUniform2i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64NV(&program: gl_program; location: Int32; x: Int64; y: Int64) :=
    z_ProgramUniform2i64NV_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3i64NV_adr := GetProcAddress('glProgramUniform3i64NV');
    private z_ProgramUniform3i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64)>(z_ProgramUniform3i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64NV(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_ProgramUniform3i64NV_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4i64NV_adr := GetProcAddress('glProgramUniform4i64NV');
    private z_ProgramUniform4i64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_ProgramUniform4i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64NV(&program: gl_program; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_ProgramUniform4i64NV_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1i64vNV_adr := GetProcAddress('glProgramUniform1i64vNV');
    private z_ProgramUniform1i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform1i64vNV_adr);
    private z_ProgramUniform1i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform1i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2i64vNV_adr := GetProcAddress('glProgramUniform2i64vNV');
    private z_ProgramUniform2i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform2i64vNV_adr);
    private z_ProgramUniform2i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform2i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3i64vNV_adr := GetProcAddress('glProgramUniform3i64vNV');
    private z_ProgramUniform3i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform3i64vNV_adr);
    private z_ProgramUniform3i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform3i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4i64vNV_adr := GetProcAddress('glProgramUniform4i64vNV');
    private z_ProgramUniform4i64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: Int64)>(z_ProgramUniform4i64vNV_adr);
    private z_ProgramUniform4i64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: gl_program; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: gl_program; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform4i64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4i64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform1ui64NV_adr := GetProcAddress('glProgramUniform1ui64NV');
    private z_ProgramUniform1ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64)>(z_ProgramUniform1ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64NV(&program: gl_program; location: Int32; x: UInt64) :=
    z_ProgramUniform1ui64NV_ovr_0(&program, location, x);
    
    private z_ProgramUniform2ui64NV_adr := GetProcAddress('glProgramUniform2ui64NV');
    private z_ProgramUniform2ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64)>(z_ProgramUniform2ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64NV(&program: gl_program; location: Int32; x: UInt64; y: UInt64) :=
    z_ProgramUniform2ui64NV_ovr_0(&program, location, x, y);
    
    private z_ProgramUniform3ui64NV_adr := GetProcAddress('glProgramUniform3ui64NV');
    private z_ProgramUniform3ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64)>(z_ProgramUniform3ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64NV(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_ProgramUniform3ui64NV_ovr_0(&program, location, x, y, z);
    
    private z_ProgramUniform4ui64NV_adr := GetProcAddress('glProgramUniform4ui64NV');
    private z_ProgramUniform4ui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_ProgramUniform4ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64NV(&program: gl_program; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_ProgramUniform4ui64NV_ovr_0(&program, location, x, y, z, w);
    
    private z_ProgramUniform1ui64vNV_adr := GetProcAddress('glProgramUniform1ui64vNV');
    private z_ProgramUniform1ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform1ui64vNV_adr);
    private z_ProgramUniform1ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform1ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ui64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform2ui64vNV_adr := GetProcAddress('glProgramUniform2ui64vNV');
    private z_ProgramUniform2ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform2ui64vNV_adr);
    private z_ProgramUniform2ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform2ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ui64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform3ui64vNV_adr := GetProcAddress('glProgramUniform3ui64vNV');
    private z_ProgramUniform3ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform3ui64vNV_adr);
    private z_ProgramUniform3ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform3ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ui64vNV_ovr_2(&program, location, count, value);
    
    private z_ProgramUniform4ui64vNV_adr := GetProcAddress('glProgramUniform4ui64vNV');
    private z_ProgramUniform4ui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniform4ui64vNV_adr);
    private z_ProgramUniform4ui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniform4ui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ui64vNV_ovr_2(&program, location, count, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glHalfFloatNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_half_float';
    
    private z_Vertex2hNV_adr := GetProcAddress('glVertex2hNV');
    private z_Vertex2hNV_ovr_0 := GetProcOrNil&<procedure(x: Half; y: Half)>(z_Vertex2hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hNV(x: Half; y: Half) :=
    z_Vertex2hNV_ovr_0(x, y);
    
    private z_Vertex2hvNV_adr := GetProcAddress('glVertex2hvNV');
    private z_Vertex2hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_Vertex2hvNV_adr);
    private z_Vertex2hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2hvNV_ovr_0(v[0]) else
      z_Vertex2hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hvNV(var v: Half) :=
    z_Vertex2hvNV_ovr_0(v);
    private z_Vertex2hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hvNV(v: IntPtr) :=
    z_Vertex2hvNV_ovr_2(v);
    
    private z_Vertex3hNV_adr := GetProcAddress('glVertex3hNV');
    private z_Vertex3hNV_ovr_0 := GetProcOrNil&<procedure(x: Half; y: Half; z: Half)>(z_Vertex3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hNV(x: Half; y: Half; z: Half) :=
    z_Vertex3hNV_ovr_0(x, y, z);
    
    private z_Vertex3hvNV_adr := GetProcAddress('glVertex3hvNV');
    private z_Vertex3hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_Vertex3hvNV_adr);
    private z_Vertex3hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3hvNV_ovr_0(v[0]) else
      z_Vertex3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hvNV(var v: Half) :=
    z_Vertex3hvNV_ovr_0(v);
    private z_Vertex3hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hvNV(v: IntPtr) :=
    z_Vertex3hvNV_ovr_2(v);
    
    private z_Vertex4hNV_adr := GetProcAddress('glVertex4hNV');
    private z_Vertex4hNV_ovr_0 := GetProcOrNil&<procedure(x: Half; y: Half; z: Half; w: Half)>(z_Vertex4hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hNV(x: Half; y: Half; z: Half; w: Half) :=
    z_Vertex4hNV_ovr_0(x, y, z, w);
    
    private z_Vertex4hvNV_adr := GetProcAddress('glVertex4hvNV');
    private z_Vertex4hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_Vertex4hvNV_adr);
    private z_Vertex4hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4hvNV_ovr_0(v[0]) else
      z_Vertex4hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hvNV(var v: Half) :=
    z_Vertex4hvNV_ovr_0(v);
    private z_Vertex4hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Vertex4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hvNV(v: IntPtr) :=
    z_Vertex4hvNV_ovr_2(v);
    
    private z_Normal3hNV_adr := GetProcAddress('glNormal3hNV');
    private z_Normal3hNV_ovr_0 := GetProcOrNil&<procedure(nx: Half; ny: Half; nz: Half)>(z_Normal3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hNV(nx: Half; ny: Half; nz: Half) :=
    z_Normal3hNV_ovr_0(nx, ny, nz);
    
    private z_Normal3hvNV_adr := GetProcAddress('glNormal3hvNV');
    private z_Normal3hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_Normal3hvNV_adr);
    private z_Normal3hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3hvNV_ovr_0(v[0]) else
      z_Normal3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hvNV(var v: Half) :=
    z_Normal3hvNV_ovr_0(v);
    private z_Normal3hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Normal3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hvNV(v: IntPtr) :=
    z_Normal3hvNV_ovr_2(v);
    
    private z_Color3hNV_adr := GetProcAddress('glColor3hNV');
    private z_Color3hNV_ovr_0 := GetProcOrNil&<procedure(red: Half; green: Half; blue: Half)>(z_Color3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hNV(red: Half; green: Half; blue: Half) :=
    z_Color3hNV_ovr_0(red, green, blue);
    
    private z_Color3hvNV_adr := GetProcAddress('glColor3hvNV');
    private z_Color3hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_Color3hvNV_adr);
    private z_Color3hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3hvNV_ovr_0(v[0]) else
      z_Color3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hvNV(var v: Half) :=
    z_Color3hvNV_ovr_0(v);
    private z_Color3hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hvNV(v: IntPtr) :=
    z_Color3hvNV_ovr_2(v);
    
    private z_Color4hNV_adr := GetProcAddress('glColor4hNV');
    private z_Color4hNV_ovr_0 := GetProcOrNil&<procedure(red: Half; green: Half; blue: Half; alpha: Half)>(z_Color4hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hNV(red: Half; green: Half; blue: Half; alpha: Half) :=
    z_Color4hNV_ovr_0(red, green, blue, alpha);
    
    private z_Color4hvNV_adr := GetProcAddress('glColor4hvNV');
    private z_Color4hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_Color4hvNV_adr);
    private z_Color4hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4hvNV_ovr_0(v[0]) else
      z_Color4hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hvNV(var v: Half) :=
    z_Color4hvNV_ovr_0(v);
    private z_Color4hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_Color4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hvNV(v: IntPtr) :=
    z_Color4hvNV_ovr_2(v);
    
    private z_TexCoord1hNV_adr := GetProcAddress('glTexCoord1hNV');
    private z_TexCoord1hNV_ovr_0 := GetProcOrNil&<procedure(s: Half)>(z_TexCoord1hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hNV(s: Half) :=
    z_TexCoord1hNV_ovr_0(s);
    
    private z_TexCoord1hvNV_adr := GetProcAddress('glTexCoord1hvNV');
    private z_TexCoord1hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_TexCoord1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hvNV(var v: Half) :=
    z_TexCoord1hvNV_ovr_0(v);
    private z_TexCoord1hvNV_ovr_1 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hvNV(v: IntPtr) :=
    z_TexCoord1hvNV_ovr_1(v);
    
    private z_TexCoord2hNV_adr := GetProcAddress('glTexCoord2hNV');
    private z_TexCoord2hNV_ovr_0 := GetProcOrNil&<procedure(s: Half; t: Half)>(z_TexCoord2hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hNV(s: Half; t: Half) :=
    z_TexCoord2hNV_ovr_0(s, t);
    
    private z_TexCoord2hvNV_adr := GetProcAddress('glTexCoord2hvNV');
    private z_TexCoord2hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_TexCoord2hvNV_adr);
    private z_TexCoord2hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2hvNV_ovr_0(v[0]) else
      z_TexCoord2hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hvNV(var v: Half) :=
    z_TexCoord2hvNV_ovr_0(v);
    private z_TexCoord2hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hvNV(v: IntPtr) :=
    z_TexCoord2hvNV_ovr_2(v);
    
    private z_TexCoord3hNV_adr := GetProcAddress('glTexCoord3hNV');
    private z_TexCoord3hNV_ovr_0 := GetProcOrNil&<procedure(s: Half; t: Half; r: Half)>(z_TexCoord3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hNV(s: Half; t: Half; r: Half) :=
    z_TexCoord3hNV_ovr_0(s, t, r);
    
    private z_TexCoord3hvNV_adr := GetProcAddress('glTexCoord3hvNV');
    private z_TexCoord3hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_TexCoord3hvNV_adr);
    private z_TexCoord3hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3hvNV_ovr_0(v[0]) else
      z_TexCoord3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hvNV(var v: Half) :=
    z_TexCoord3hvNV_ovr_0(v);
    private z_TexCoord3hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hvNV(v: IntPtr) :=
    z_TexCoord3hvNV_ovr_2(v);
    
    private z_TexCoord4hNV_adr := GetProcAddress('glTexCoord4hNV');
    private z_TexCoord4hNV_ovr_0 := GetProcOrNil&<procedure(s: Half; t: Half; r: Half; q: Half)>(z_TexCoord4hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hNV(s: Half; t: Half; r: Half; q: Half) :=
    z_TexCoord4hNV_ovr_0(s, t, r, q);
    
    private z_TexCoord4hvNV_adr := GetProcAddress('glTexCoord4hvNV');
    private z_TexCoord4hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_TexCoord4hvNV_adr);
    private z_TexCoord4hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4hvNV_ovr_0(v[0]) else
      z_TexCoord4hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hvNV(var v: Half) :=
    z_TexCoord4hvNV_ovr_0(v);
    private z_TexCoord4hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_TexCoord4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hvNV(v: IntPtr) :=
    z_TexCoord4hvNV_ovr_2(v);
    
    private z_MultiTexCoord1hNV_adr := GetProcAddress('glMultiTexCoord1hNV');
    private z_MultiTexCoord1hNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Half)>(z_MultiTexCoord1hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hNV(target: TextureUnit; s: Half) :=
    z_MultiTexCoord1hNV_ovr_0(target, s);
    
    private z_MultiTexCoord1hvNV_adr := GetProcAddress('glMultiTexCoord1hvNV');
    private z_MultiTexCoord1hvNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Half)>(z_MultiTexCoord1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord1hvNV_ovr_0(target, v);
    private z_MultiTexCoord1hvNV_ovr_1 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1hvNV_ovr_1(target, v);
    
    private z_MultiTexCoord2hNV_adr := GetProcAddress('glMultiTexCoord2hNV');
    private z_MultiTexCoord2hNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Half; t: Half)>(z_MultiTexCoord2hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hNV(target: TextureUnit; s: Half; t: Half) :=
    z_MultiTexCoord2hNV_ovr_0(target, s, t);
    
    private z_MultiTexCoord2hvNV_adr := GetProcAddress('glMultiTexCoord2hvNV');
    private z_MultiTexCoord2hvNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Half)>(z_MultiTexCoord2hvNV_adr);
    private z_MultiTexCoord2hvNV_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord2hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord2hvNV_ovr_0(target, v);
    private z_MultiTexCoord2hvNV_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2hvNV_ovr_2(target, v);
    
    private z_MultiTexCoord3hNV_adr := GetProcAddress('glMultiTexCoord3hNV');
    private z_MultiTexCoord3hNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Half; t: Half; r: Half)>(z_MultiTexCoord3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hNV(target: TextureUnit; s: Half; t: Half; r: Half) :=
    z_MultiTexCoord3hNV_ovr_0(target, s, t, r);
    
    private z_MultiTexCoord3hvNV_adr := GetProcAddress('glMultiTexCoord3hvNV');
    private z_MultiTexCoord3hvNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Half)>(z_MultiTexCoord3hvNV_adr);
    private z_MultiTexCoord3hvNV_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord3hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord3hvNV_ovr_0(target, v);
    private z_MultiTexCoord3hvNV_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3hvNV_ovr_2(target, v);
    
    private z_MultiTexCoord4hNV_adr := GetProcAddress('glMultiTexCoord4hNV');
    private z_MultiTexCoord4hNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; s: Half; t: Half; r: Half; q: Half)>(z_MultiTexCoord4hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hNV(target: TextureUnit; s: Half; t: Half; r: Half; q: Half) :=
    z_MultiTexCoord4hNV_ovr_0(target, s, t, r, q);
    
    private z_MultiTexCoord4hvNV_adr := GetProcAddress('glMultiTexCoord4hvNV');
    private z_MultiTexCoord4hvNV_ovr_0 := GetProcOrNil&<procedure(target: TextureUnit; var v: Half)>(z_MultiTexCoord4hvNV_adr);
    private z_MultiTexCoord4hvNV_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord4hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord4hvNV_ovr_0(target, v);
    private z_MultiTexCoord4hvNV_ovr_2 := GetProcOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4hvNV_ovr_2(target, v);
    
    private z_FogCoordhNV_adr := GetProcAddress('glFogCoordhNV');
    private z_FogCoordhNV_ovr_0 := GetProcOrNil&<procedure(fog: Half)>(z_FogCoordhNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhNV(fog: Half) :=
    z_FogCoordhNV_ovr_0(fog);
    
    private z_FogCoordhvNV_adr := GetProcAddress('glFogCoordhvNV');
    private z_FogCoordhvNV_ovr_0 := GetProcOrNil&<procedure(var fog: Half)>(z_FogCoordhvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhvNV(var fog: Half) :=
    z_FogCoordhvNV_ovr_0(fog);
    private z_FogCoordhvNV_ovr_1 := GetProcOrNil&<procedure(fog: IntPtr)>(z_FogCoordhvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhvNV(fog: IntPtr) :=
    z_FogCoordhvNV_ovr_1(fog);
    
    private z_SecondaryColor3hNV_adr := GetProcAddress('glSecondaryColor3hNV');
    private z_SecondaryColor3hNV_ovr_0 := GetProcOrNil&<procedure(red: Half; green: Half; blue: Half)>(z_SecondaryColor3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hNV(red: Half; green: Half; blue: Half) :=
    z_SecondaryColor3hNV_ovr_0(red, green, blue);
    
    private z_SecondaryColor3hvNV_adr := GetProcAddress('glSecondaryColor3hvNV');
    private z_SecondaryColor3hvNV_ovr_0 := GetProcOrNil&<procedure(var v: Half)>(z_SecondaryColor3hvNV_adr);
    private z_SecondaryColor3hvNV_ovr_0_anh01 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3hvNV_ovr_0(v[0]) else
      z_SecondaryColor3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hvNV(var v: Half) :=
    z_SecondaryColor3hvNV_ovr_0(v);
    private z_SecondaryColor3hvNV_ovr_2 := GetProcOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hvNV(v: IntPtr) :=
    z_SecondaryColor3hvNV_ovr_2(v);
    
    private z_VertexWeighthNV_adr := GetProcAddress('glVertexWeighthNV');
    private z_VertexWeighthNV_ovr_0 := GetProcOrNil&<procedure(weight: Half)>(z_VertexWeighthNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthNV(weight: Half) :=
    z_VertexWeighthNV_ovr_0(weight);
    
    private z_VertexWeighthvNV_adr := GetProcAddress('glVertexWeighthvNV');
    private z_VertexWeighthvNV_ovr_0 := GetProcOrNil&<procedure(var weight: Half)>(z_VertexWeighthvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthvNV(var weight: Half) :=
    z_VertexWeighthvNV_ovr_0(weight);
    private z_VertexWeighthvNV_ovr_1 := GetProcOrNil&<procedure(weight: IntPtr)>(z_VertexWeighthvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthvNV(weight: IntPtr) :=
    z_VertexWeighthvNV_ovr_1(weight);
    
    private z_VertexAttrib1hNV_adr := GetProcAddress('glVertexAttrib1hNV');
    private z_VertexAttrib1hNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Half)>(z_VertexAttrib1hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hNV(index: UInt32; x: Half) :=
    z_VertexAttrib1hNV_ovr_0(index, x);
    
    private z_VertexAttrib1hvNV_adr := GetProcAddress('glVertexAttrib1hvNV');
    private z_VertexAttrib1hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Half)>(z_VertexAttrib1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib1hvNV_ovr_0(index, v);
    private z_VertexAttrib1hvNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1hvNV_ovr_1(index, v);
    
    private z_VertexAttrib2hNV_adr := GetProcAddress('glVertexAttrib2hNV');
    private z_VertexAttrib2hNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Half; y: Half)>(z_VertexAttrib2hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hNV(index: UInt32; x: Half; y: Half) :=
    z_VertexAttrib2hNV_ovr_0(index, x, y);
    
    private z_VertexAttrib2hvNV_adr := GetProcAddress('glVertexAttrib2hvNV');
    private z_VertexAttrib2hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Half)>(z_VertexAttrib2hvNV_adr);
    private z_VertexAttrib2hvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib2hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib2hvNV_ovr_0(index, v);
    private z_VertexAttrib2hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2hvNV_ovr_2(index, v);
    
    private z_VertexAttrib3hNV_adr := GetProcAddress('glVertexAttrib3hNV');
    private z_VertexAttrib3hNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Half; y: Half; z: Half)>(z_VertexAttrib3hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hNV(index: UInt32; x: Half; y: Half; z: Half) :=
    z_VertexAttrib3hNV_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3hvNV_adr := GetProcAddress('glVertexAttrib3hvNV');
    private z_VertexAttrib3hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Half)>(z_VertexAttrib3hvNV_adr);
    private z_VertexAttrib3hvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib3hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib3hvNV_ovr_0(index, v);
    private z_VertexAttrib3hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3hvNV_ovr_2(index, v);
    
    private z_VertexAttrib4hNV_adr := GetProcAddress('glVertexAttrib4hNV');
    private z_VertexAttrib4hNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Half; y: Half; z: Half; w: Half)>(z_VertexAttrib4hNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hNV(index: UInt32; x: Half; y: Half; z: Half; w: Half) :=
    z_VertexAttrib4hNV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4hvNV_adr := GetProcAddress('glVertexAttrib4hvNV');
    private z_VertexAttrib4hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Half)>(z_VertexAttrib4hvNV_adr);
    private z_VertexAttrib4hvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib4hvNV_ovr_0(index, v);
    private z_VertexAttrib4hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4hvNV_ovr_2(index, v);
    
    private z_VertexAttribs1hvNV_adr := GetProcAddress('glVertexAttribs1hvNV');
    private z_VertexAttribs1hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: Int32; var v: Half)>(z_VertexAttribs1hvNV_adr);
    private z_VertexAttribs1hvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs1hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs1hvNV_ovr_0(index, n, v);
    private z_VertexAttribs1hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs1hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs1hvNV_ovr_2(index, n, v);
    
    private z_VertexAttribs2hvNV_adr := GetProcAddress('glVertexAttribs2hvNV');
    private z_VertexAttribs2hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: Int32; var v: Half)>(z_VertexAttribs2hvNV_adr);
    private z_VertexAttribs2hvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs2hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs2hvNV_ovr_0(index, n, v);
    private z_VertexAttribs2hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs2hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs2hvNV_ovr_2(index, n, v);
    
    private z_VertexAttribs3hvNV_adr := GetProcAddress('glVertexAttribs3hvNV');
    private z_VertexAttribs3hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: Int32; var v: Half)>(z_VertexAttribs3hvNV_adr);
    private z_VertexAttribs3hvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs3hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs3hvNV_ovr_0(index, n, v);
    private z_VertexAttribs3hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs3hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs3hvNV_ovr_2(index, n, v);
    
    private z_VertexAttribs4hvNV_adr := GetProcAddress('glVertexAttribs4hvNV');
    private z_VertexAttribs4hvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; n: Int32; var v: Half)>(z_VertexAttribs4hvNV_adr);
    private z_VertexAttribs4hvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs4hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs4hvNV_ovr_0(index, n, v);
    private z_VertexAttribs4hvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; n: Int32; v: IntPtr)>(z_VertexAttribs4hvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs4hvNV_ovr_2(index, n, v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInternalformatSampleQueryNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_internalformat_sample_query';
    
    private z_GetInternalformatSampleivNV_adr := GetProcAddress('glGetInternalformatSampleivNV');
    private z_GetInternalformatSampleivNV_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; var &params: Int32)>(z_GetInternalformatSampleivNV_adr);
    private z_GetInternalformatSampleivNV_ovr_0_anh0000001 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformatSampleivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformatSampleivNV(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformatSampleivNV_ovr_0(target, _internalformat, samples, pname, count, &params[0]) else
      z_GetInternalformatSampleivNV_ovr_0_anh0000001(target, _internalformat, samples, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformatSampleivNV(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; var &params: Int32) :=
    z_GetInternalformatSampleivNV_ovr_0(target, _internalformat, samples, pname, count, &params);
    private z_GetInternalformatSampleivNV_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformatSampleivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformatSampleivNV(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformatSampleivNV_ovr_2(target, _internalformat, samples, pname, count, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuMulticastNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_gpu_multicast';
    
    private z_RenderGpuMaskNV_adr := GetProcAddress('glRenderGpuMaskNV');
    private z_RenderGpuMaskNV_ovr_0 := GetProcOrNil&<procedure(mask: DummyFlags)>(z_RenderGpuMaskNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderGpuMaskNV(mask: DummyFlags) :=
    z_RenderGpuMaskNV_ovr_0(mask);
    
    private z_MulticastBufferSubDataNV_adr := GetProcAddress('glMulticastBufferSubDataNV');
    private z_MulticastBufferSubDataNV_ovr_0 := GetProcOrNil&<procedure(gpuMask: DummyFlags; buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_MulticastBufferSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastBufferSubDataNV(gpuMask: DummyFlags; buffer: gl_buffer; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_MulticastBufferSubDataNV_ovr_0(gpuMask, buffer, offset, size, data);
    
    private z_MulticastCopyBufferSubDataNV_adr := GetProcAddress('glMulticastCopyBufferSubDataNV');
    private z_MulticastCopyBufferSubDataNV_ovr_0 := GetProcOrNil&<procedure(readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_MulticastCopyBufferSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastCopyBufferSubDataNV(readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_MulticastCopyBufferSubDataNV_ovr_0(readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    private z_MulticastCopyImageSubDataNV_adr := GetProcAddress('glMulticastCopyImageSubDataNV');
    private z_MulticastCopyImageSubDataNV_ovr_0 := GetProcOrNil&<procedure(srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32)>(z_MulticastCopyImageSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastCopyImageSubDataNV(srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32) :=
    z_MulticastCopyImageSubDataNV_ovr_0(srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
    
    private z_MulticastBlitFramebufferNV_adr := GetProcAddress('glMulticastBlitFramebufferNV');
    private z_MulticastBlitFramebufferNV_ovr_0 := GetProcOrNil&<procedure(srcGpu: UInt32; dstGpu: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: DummyEnum)>(z_MulticastBlitFramebufferNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastBlitFramebufferNV(srcGpu: UInt32; dstGpu: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: DummyEnum) :=
    z_MulticastBlitFramebufferNV_ovr_0(srcGpu, dstGpu, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    private z_MulticastFramebufferSampleLocationsfvNV_adr := GetProcAddress('glMulticastFramebufferSampleLocationsfvNV');
    private z_MulticastFramebufferSampleLocationsfvNV_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; framebuffer: gl_framebuffer; start: UInt32; count: Int32; var v: single)>(z_MulticastFramebufferSampleLocationsfvNV_adr);
    private z_MulticastFramebufferSampleLocationsfvNV_ovr_0_anh000001 := GetProcOrNil&<procedure(gpu: UInt32; framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr)>(z_MulticastFramebufferSampleLocationsfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastFramebufferSampleLocationsfvNV(gpu: UInt32; framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MulticastFramebufferSampleLocationsfvNV_ovr_0(gpu, framebuffer, start, count, v[0]) else
      z_MulticastFramebufferSampleLocationsfvNV_ovr_0_anh000001(gpu, framebuffer, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastFramebufferSampleLocationsfvNV(gpu: UInt32; framebuffer: gl_framebuffer; start: UInt32; count: Int32; var v: single) :=
    z_MulticastFramebufferSampleLocationsfvNV_ovr_0(gpu, framebuffer, start, count, v);
    private z_MulticastFramebufferSampleLocationsfvNV_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr)>(z_MulticastFramebufferSampleLocationsfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastFramebufferSampleLocationsfvNV(gpu: UInt32; framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr) :=
    z_MulticastFramebufferSampleLocationsfvNV_ovr_2(gpu, framebuffer, start, count, v);
    
    private z_MulticastBarrierNV_adr := GetProcAddress('glMulticastBarrierNV');
    private z_MulticastBarrierNV_ovr_0 := GetProcOrNil&<procedure>(z_MulticastBarrierNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastBarrierNV :=
    z_MulticastBarrierNV_ovr_0;
    
    private z_MulticastWaitSyncNV_adr := GetProcAddress('glMulticastWaitSyncNV');
    private z_MulticastWaitSyncNV_ovr_0 := GetProcOrNil&<procedure(signalGpu: UInt32; waitGpuMask: DummyFlags)>(z_MulticastWaitSyncNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastWaitSyncNV(signalGpu: UInt32; waitGpuMask: DummyFlags) :=
    z_MulticastWaitSyncNV_ovr_0(signalGpu, waitGpuMask);
    
    private z_MulticastGetQueryObjectivNV_adr := GetProcAddress('glMulticastGetQueryObjectivNV');
    private z_MulticastGetQueryObjectivNV_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int32)>(z_MulticastGetQueryObjectivNV_adr);
    private z_MulticastGetQueryObjectivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjectivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjectivNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjectivNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_MulticastGetQueryObjectivNV_ovr_0(gpu, id, pname, &params);
    private z_MulticastGetQueryObjectivNV_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjectivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjectivNV_ovr_2(gpu, id, pname, &params);
    
    private z_MulticastGetQueryObjectuivNV_adr := GetProcAddress('glMulticastGetQueryObjectuivNV');
    private z_MulticastGetQueryObjectuivNV_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt32)>(z_MulticastGetQueryObjectuivNV_adr);
    private z_MulticastGetQueryObjectuivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjectuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectuivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjectuivNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjectuivNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectuivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt32) :=
    z_MulticastGetQueryObjectuivNV_ovr_0(gpu, id, pname, &params);
    private z_MulticastGetQueryObjectuivNV_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjectuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectuivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjectuivNV_ovr_2(gpu, id, pname, &params);
    
    private z_MulticastGetQueryObjecti64vNV_adr := GetProcAddress('glMulticastGetQueryObjecti64vNV');
    private z_MulticastGetQueryObjecti64vNV_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int64)>(z_MulticastGetQueryObjecti64vNV_adr);
    private z_MulticastGetQueryObjecti64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjecti64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjecti64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjecti64vNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjecti64vNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjecti64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int64) :=
    z_MulticastGetQueryObjecti64vNV_ovr_0(gpu, id, pname, &params);
    private z_MulticastGetQueryObjecti64vNV_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjecti64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjecti64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjecti64vNV_ovr_2(gpu, id, pname, &params);
    
    private z_MulticastGetQueryObjectui64vNV_adr := GetProcAddress('glMulticastGetQueryObjectui64vNV');
    private z_MulticastGetQueryObjectui64vNV_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt64)>(z_MulticastGetQueryObjectui64vNV_adr);
    private z_MulticastGetQueryObjectui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjectui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectui64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjectui64vNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjectui64vNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectui64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt64) :=
    z_MulticastGetQueryObjectui64vNV_ovr_0(gpu, id, pname, &params);
    private z_MulticastGetQueryObjectui64vNV_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr)>(z_MulticastGetQueryObjectui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectui64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjectui64vNV_ovr_2(gpu, id, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGpuMulticast2NVX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NVX_gpu_multicast2';
    
    private z_UploadGpuMaskNVX_adr := GetProcAddress('glUploadGpuMaskNVX');
    private z_UploadGpuMaskNVX_ovr_0 := GetProcOrNil&<procedure(mask: DummyFlags)>(z_UploadGpuMaskNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UploadGpuMaskNVX(mask: DummyFlags) :=
    z_UploadGpuMaskNVX_ovr_0(mask);
    
    private z_MulticastViewportArrayvNVX_adr := GetProcAddress('glMulticastViewportArrayvNVX');
    private z_MulticastViewportArrayvNVX_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; first: UInt32; count: Int32; var v: single)>(z_MulticastViewportArrayvNVX_adr);
    private z_MulticastViewportArrayvNVX_ovr_0_anh00001 := GetProcOrNil&<procedure(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr)>(z_MulticastViewportArrayvNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MulticastViewportArrayvNVX_ovr_0(gpu, first, count, v[0]) else
      z_MulticastViewportArrayvNVX_ovr_0_anh00001(gpu, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; var v: single) :=
    z_MulticastViewportArrayvNVX_ovr_0(gpu, first, count, v);
    private z_MulticastViewportArrayvNVX_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr)>(z_MulticastViewportArrayvNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr) :=
    z_MulticastViewportArrayvNVX_ovr_2(gpu, first, count, v);
    
    private z_MulticastViewportPositionWScaleNVX_adr := GetProcAddress('glMulticastViewportPositionWScaleNVX');
    private z_MulticastViewportPositionWScaleNVX_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; index: UInt32; xcoeff: single; ycoeff: single)>(z_MulticastViewportPositionWScaleNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportPositionWScaleNVX(gpu: UInt32; index: UInt32; xcoeff: single; ycoeff: single) :=
    z_MulticastViewportPositionWScaleNVX_ovr_0(gpu, index, xcoeff, ycoeff);
    
    private z_MulticastScissorArrayvNVX_adr := GetProcAddress('glMulticastScissorArrayvNVX');
    private z_MulticastScissorArrayvNVX_ovr_0 := GetProcOrNil&<procedure(gpu: UInt32; first: UInt32; count: Int32; var v: Int32)>(z_MulticastScissorArrayvNVX_adr);
    private z_MulticastScissorArrayvNVX_ovr_0_anh00001 := GetProcOrNil&<procedure(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr)>(z_MulticastScissorArrayvNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastScissorArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MulticastScissorArrayvNVX_ovr_0(gpu, first, count, v[0]) else
      z_MulticastScissorArrayvNVX_ovr_0_anh00001(gpu, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastScissorArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; var v: Int32) :=
    z_MulticastScissorArrayvNVX_ovr_0(gpu, first, count, v);
    private z_MulticastScissorArrayvNVX_ovr_2 := GetProcOrNil&<procedure(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr)>(z_MulticastScissorArrayvNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastScissorArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr) :=
    z_MulticastScissorArrayvNVX_ovr_2(gpu, first, count, v);
    
    private z_AsyncCopyBufferSubDataNVX_adr := GetProcAddress('glAsyncCopyBufferSubDataNVX');
    private z_AsyncCopyBufferSubDataNVX_ovr_0 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000011(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000011(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000011(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00010000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_1_anh00110000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_2 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_3_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_3_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_3_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_3_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_3_anh00010000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_3_anh00110000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_4_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_4_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_4_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_5_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_5_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_5_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_6 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_7_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_7_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_7_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_8 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_8_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_8_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_8_anh00110000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_8_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_8_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_8_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000011(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_10_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_10_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_11_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_11_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_12_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_12_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_13_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_14_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_15_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_15_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_16_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_17_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_8_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_18 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000011(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_19_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_19_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_19_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_20 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_20_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_20_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_21_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_21_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_22_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_23_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_24 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_24_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_24_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_25_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_26 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_26_anh00100000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_26_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_8_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_20_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_24_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_54 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_55_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_55_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_55_anh00010000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_56 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_56_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_56_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_57_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_57_anh00010000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_58_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_59_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_60 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_60_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_60_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_61_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_62 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_62_anh00010000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_62_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_56_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_60_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_72 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyBufferSubDataNVX_ovr_73_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_74 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_74_anh00000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_74_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_78 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    private z_AsyncCopyBufferSubDataNVX_ovr_78_anh00000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_78_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyBufferSubDataNVX_ovr_80 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyBufferSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: gl_buffer; writeBuffer: gl_buffer; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_80(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    
    private z_AsyncCopyImageSubDataNVX_adr := GetProcAddress('glAsyncCopyImageSubDataNVX');
    private z_AsyncCopyImageSubDataNVX_ovr_0 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000011(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000011(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh000100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_1_anh001100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_2 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_3_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_3_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_3_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_3_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_3_anh000100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_3_anh001100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_4_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_4_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_4_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_5_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_5_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_5_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_6 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_7_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_7_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_7_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_8 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_8_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_8_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_8_anh001100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_8_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_8_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_8_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000011(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_10_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_10_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_11_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_11_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_12_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_12_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_13_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_14_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_15_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_15_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_16_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_17_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_8_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_18 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000011(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_19_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_19_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_19_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_20 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_20_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_20_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_21_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_21_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_22_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_23_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_24 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_24_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_24_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_25_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_26 := GetProcOrNil&<function(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_26_anh001000000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_26_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_8_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_20_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_24_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_54 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_55_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_55_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_55_anh000100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_56 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_56_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_56_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_57_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_57_anh000100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_58_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_59_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_60 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_60_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_60_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_61_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_62 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_62_anh000100000000000000000000 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_62_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_56_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_60_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_72 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000011 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private z_AsyncCopyImageSubDataNVX_ovr_73_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_74 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_74_anh000000000000000000000010 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_74_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_78 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    private z_AsyncCopyImageSubDataNVX_ovr_78_anh000000000000000000000001 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_78_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private z_AsyncCopyImageSubDataNVX_ovr_80 := GetProcOrNil&<function(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32>(z_AsyncCopyImageSubDataNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_80(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glProgressFenceNVX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NVX_progress_fence';
    
    private z_CreateProgressFenceNVX_adr := GetProcAddress('glCreateProgressFenceNVX');
    private z_CreateProgressFenceNVX_ovr_0 := GetProcOrNil&<function: UInt32>(z_CreateProgressFenceNVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateProgressFenceNVX: UInt32 :=
    z_CreateProgressFenceNVX_ovr_0;
    
    private z_SignalSemaphoreui64NVX_adr := GetProcAddress('glSignalSemaphoreui64NVX');
    private z_SignalSemaphoreui64NVX_ovr_0 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64)>(z_SignalSemaphoreui64NVX_adr);
    private z_SignalSemaphoreui64NVX_ovr_0_anh00010 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_SignalSemaphoreui64NVX_adr);
    private z_SignalSemaphoreui64NVX_ovr_0_anh00001 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr)>(z_SignalSemaphoreui64NVX_adr);
    private z_SignalSemaphoreui64NVX_ovr_0_anh00011 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_SignalSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: array of UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray[0]) else
        z_SignalSemaphoreui64NVX_ovr_0_anh00001(signalGpu, fenceObjectCount, semaphoreArray[0], IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_SignalSemaphoreui64NVX_ovr_0_anh00010(signalGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray[0]) else
        z_SignalSemaphoreui64NVX_ovr_0_anh00011(signalGpu, fenceObjectCount, IntPtr.Zero, IntPtr.Zero);
    private z_SignalSemaphoreui64NVX_ovr_1_anh00010 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_SignalSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; var fenceValueArray: UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_SignalSemaphoreui64NVX_ovr_0_anh00010(signalGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    private z_SignalSemaphoreui64NVX_ovr_2 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr)>(z_SignalSemaphoreui64NVX_adr);
    private z_SignalSemaphoreui64NVX_ovr_2_anh00010 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_SignalSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: IntPtr) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_2(signalGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_SignalSemaphoreui64NVX_ovr_2_anh00010(signalGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_SignalSemaphoreui64NVX_ovr_0_anh00001(signalGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64) :=
    z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr) :=
    z_SignalSemaphoreui64NVX_ovr_2(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private z_SignalSemaphoreui64NVX_ovr_6 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_SignalSemaphoreui64NVX_adr);
    private z_SignalSemaphoreui64NVX_ovr_6_anh00001 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_SignalSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_6(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_SignalSemaphoreui64NVX_ovr_6_anh00001(signalGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64) :=
    z_SignalSemaphoreui64NVX_ovr_6(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private z_SignalSemaphoreui64NVX_ovr_8 := GetProcOrNil&<procedure(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_SignalSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr) :=
    z_SignalSemaphoreui64NVX_ovr_8(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    
    private z_WaitSemaphoreui64NVX_adr := GetProcAddress('glWaitSemaphoreui64NVX');
    private z_WaitSemaphoreui64NVX_ovr_0 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64)>(z_WaitSemaphoreui64NVX_adr);
    private z_WaitSemaphoreui64NVX_ovr_0_anh00010 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_WaitSemaphoreui64NVX_adr);
    private z_WaitSemaphoreui64NVX_ovr_0_anh00001 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr)>(z_WaitSemaphoreui64NVX_adr);
    private z_WaitSemaphoreui64NVX_ovr_0_anh00011 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_WaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: array of UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray[0]) else
        z_WaitSemaphoreui64NVX_ovr_0_anh00001(waitGpu, fenceObjectCount, semaphoreArray[0], IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_WaitSemaphoreui64NVX_ovr_0_anh00010(waitGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray[0]) else
        z_WaitSemaphoreui64NVX_ovr_0_anh00011(waitGpu, fenceObjectCount, IntPtr.Zero, IntPtr.Zero);
    private z_WaitSemaphoreui64NVX_ovr_1_anh00010 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_WaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; var fenceValueArray: UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_WaitSemaphoreui64NVX_ovr_0_anh00010(waitGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    private z_WaitSemaphoreui64NVX_ovr_2 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr)>(z_WaitSemaphoreui64NVX_adr);
    private z_WaitSemaphoreui64NVX_ovr_2_anh00010 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_WaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: IntPtr) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_2(waitGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_WaitSemaphoreui64NVX_ovr_2_anh00010(waitGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_WaitSemaphoreui64NVX_ovr_0_anh00001(waitGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64) :=
    z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr) :=
    z_WaitSemaphoreui64NVX_ovr_2(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private z_WaitSemaphoreui64NVX_ovr_6 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_WaitSemaphoreui64NVX_adr);
    private z_WaitSemaphoreui64NVX_ovr_6_anh00001 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_WaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_6(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_WaitSemaphoreui64NVX_ovr_6_anh00001(waitGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64) :=
    z_WaitSemaphoreui64NVX_ovr_6(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private z_WaitSemaphoreui64NVX_ovr_8 := GetProcOrNil&<procedure(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_WaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr) :=
    z_WaitSemaphoreui64NVX_ovr_8(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    
    private z_ClientWaitSemaphoreui64NVX_adr := GetProcAddress('glClientWaitSemaphoreui64NVX');
    private z_ClientWaitSemaphoreui64NVX_ovr_0 := GetProcOrNil&<procedure(fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64)>(z_ClientWaitSemaphoreui64NVX_adr);
    private z_ClientWaitSemaphoreui64NVX_ovr_0_anh0010 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_ClientWaitSemaphoreui64NVX_adr);
    private z_ClientWaitSemaphoreui64NVX_ovr_0_anh0001 := GetProcOrNil&<procedure(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr)>(z_ClientWaitSemaphoreui64NVX_adr);
    private z_ClientWaitSemaphoreui64NVX_ovr_0_anh0011 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_ClientWaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: array of UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray[0], fenceValueArray[0]) else
        z_ClientWaitSemaphoreui64NVX_ovr_0_anh0001(fenceObjectCount, semaphoreArray[0], IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_ClientWaitSemaphoreui64NVX_ovr_0_anh0010(fenceObjectCount, IntPtr.Zero, fenceValueArray[0]) else
        z_ClientWaitSemaphoreui64NVX_ovr_0_anh0011(fenceObjectCount, IntPtr.Zero, IntPtr.Zero);
    private z_ClientWaitSemaphoreui64NVX_ovr_1_anh0010 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_ClientWaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: array of UInt32; var fenceValueArray: UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_ClientWaitSemaphoreui64NVX_ovr_0_anh0010(fenceObjectCount, IntPtr.Zero, fenceValueArray);
    private z_ClientWaitSemaphoreui64NVX_ovr_2 := GetProcOrNil&<procedure(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr)>(z_ClientWaitSemaphoreui64NVX_adr);
    private z_ClientWaitSemaphoreui64NVX_ovr_2_anh0010 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_ClientWaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: IntPtr) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_2(fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_ClientWaitSemaphoreui64NVX_ovr_2_anh0010(fenceObjectCount, IntPtr.Zero, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_ClientWaitSemaphoreui64NVX_ovr_0_anh0001(fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64) :=
    z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr) :=
    z_ClientWaitSemaphoreui64NVX_ovr_2(fenceObjectCount, semaphoreArray, fenceValueArray);
    private z_ClientWaitSemaphoreui64NVX_ovr_6 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64)>(z_ClientWaitSemaphoreui64NVX_adr);
    private z_ClientWaitSemaphoreui64NVX_ovr_6_anh0001 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_ClientWaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_6(fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_ClientWaitSemaphoreui64NVX_ovr_6_anh0001(fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64) :=
    z_ClientWaitSemaphoreui64NVX_ovr_6(fenceObjectCount, semaphoreArray, fenceValueArray);
    private z_ClientWaitSemaphoreui64NVX_ovr_8 := GetProcOrNil&<procedure(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr)>(z_ClientWaitSemaphoreui64NVX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr) :=
    z_ClientWaitSemaphoreui64NVX_ovr_8(fenceObjectCount, semaphoreArray, fenceValueArray);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMemoryAttachmentNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_memory_attachment';
    
    private z_GetMemoryObjectDetachedResourcesuivNV_adr := GetProcAddress('glGetMemoryObjectDetachedResourcesuivNV');
    private z_GetMemoryObjectDetachedResourcesuivNV_ovr_0 := GetProcOrNil&<procedure(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; var &params: UInt32)>(z_GetMemoryObjectDetachedResourcesuivNV_adr);
    private z_GetMemoryObjectDetachedResourcesuivNV_ovr_0_anh000001 := GetProcOrNil&<procedure(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: IntPtr)>(z_GetMemoryObjectDetachedResourcesuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectDetachedResourcesuivNV(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMemoryObjectDetachedResourcesuivNV_ovr_0(memory, pname, first, count, &params[0]) else
      z_GetMemoryObjectDetachedResourcesuivNV_ovr_0_anh000001(memory, pname, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectDetachedResourcesuivNV(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; var &params: UInt32) :=
    z_GetMemoryObjectDetachedResourcesuivNV_ovr_0(memory, pname, first, count, &params);
    private z_GetMemoryObjectDetachedResourcesuivNV_ovr_2 := GetProcOrNil&<procedure(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: IntPtr)>(z_GetMemoryObjectDetachedResourcesuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectDetachedResourcesuivNV(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: IntPtr) :=
    z_GetMemoryObjectDetachedResourcesuivNV_ovr_2(memory, pname, first, count, &params);
    
    private z_ResetMemoryObjectParameterNV_adr := GetProcAddress('glResetMemoryObjectParameterNV');
    private z_ResetMemoryObjectParameterNV_ovr_0 := GetProcOrNil&<procedure(memory: UInt32; pname: DummyEnum)>(z_ResetMemoryObjectParameterNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetMemoryObjectParameterNV(memory: UInt32; pname: DummyEnum) :=
    z_ResetMemoryObjectParameterNV_ovr_0(memory, pname);
    
    private z_TexAttachMemoryNV_adr := GetProcAddress('glTexAttachMemoryNV');
    private z_TexAttachMemoryNV_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; memory: UInt32; offset: UInt64)>(z_TexAttachMemoryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexAttachMemoryNV(target: TextureTarget; memory: UInt32; offset: UInt64) :=
    z_TexAttachMemoryNV_ovr_0(target, memory, offset);
    
    private z_BufferAttachMemoryNV_adr := GetProcAddress('glBufferAttachMemoryNV');
    private z_BufferAttachMemoryNV_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; memory: UInt32; offset: UInt64)>(z_BufferAttachMemoryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferAttachMemoryNV(target: BufferTarget; memory: UInt32; offset: UInt64) :=
    z_BufferAttachMemoryNV_ovr_0(target, memory, offset);
    
    private z_TextureAttachMemoryNV_adr := GetProcAddress('glTextureAttachMemoryNV');
    private z_TextureAttachMemoryNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; memory: UInt32; offset: UInt64)>(z_TextureAttachMemoryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureAttachMemoryNV(texture: gl_texture; memory: UInt32; offset: UInt64) :=
    z_TextureAttachMemoryNV_ovr_0(texture, memory, offset);
    
    private z_NamedBufferAttachMemoryNV_adr := GetProcAddress('glNamedBufferAttachMemoryNV');
    private z_NamedBufferAttachMemoryNV_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; memory: UInt32; offset: UInt64)>(z_NamedBufferAttachMemoryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferAttachMemoryNV(buffer: gl_buffer; memory: UInt32; offset: UInt64) :=
    z_NamedBufferAttachMemoryNV_ovr_0(buffer, memory, offset);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMemoryObjectSparseNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_memory_object_sparse';
    
    private z_BufferPageCommitmentMemNV_adr := GetProcAddress('glBufferPageCommitmentMemNV');
    private z_BufferPageCommitmentMemNV_ovr_0 := GetProcOrNil&<procedure(target: BufferStorageTarget; offset: IntPtr; size: IntPtr; memory: UInt32; memOffset: UInt64; commit: boolean)>(z_BufferPageCommitmentMemNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferPageCommitmentMemNV(target: BufferStorageTarget; offset: IntPtr; size: IntPtr; memory: UInt32; memOffset: UInt64; commit: boolean) :=
    z_BufferPageCommitmentMemNV_ovr_0(target, offset, size, memory, memOffset, commit);
    
    private z_TexPageCommitmentMemNV_adr := GetProcAddress('glTexPageCommitmentMemNV');
    private z_TexPageCommitmentMemNV_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; layer: Int32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64; commit: boolean)>(z_TexPageCommitmentMemNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexPageCommitmentMemNV(target: TextureTarget; layer: Int32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64; commit: boolean) :=
    z_TexPageCommitmentMemNV_ovr_0(target, layer, level, xoffset, yoffset, zoffset, width, height, depth, memory, offset, commit);
    
    private z_NamedBufferPageCommitmentMemNV_adr := GetProcAddress('glNamedBufferPageCommitmentMemNV');
    private z_NamedBufferPageCommitmentMemNV_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; offset: IntPtr; size: IntPtr; memory: UInt32; memOffset: UInt64; commit: boolean)>(z_NamedBufferPageCommitmentMemNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferPageCommitmentMemNV(buffer: gl_buffer; offset: IntPtr; size: IntPtr; memory: UInt32; memOffset: UInt64; commit: boolean) :=
    z_NamedBufferPageCommitmentMemNV_ovr_0(buffer, offset, size, memory, memOffset, commit);
    
    private z_TexturePageCommitmentMemNV_adr := GetProcAddress('glTexturePageCommitmentMemNV');
    private z_TexturePageCommitmentMemNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; layer: Int32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64; commit: boolean)>(z_TexturePageCommitmentMemNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexturePageCommitmentMemNV(texture: gl_texture; layer: Int32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64; commit: boolean) :=
    z_TexturePageCommitmentMemNV_ovr_0(texture, layer, level, xoffset, yoffset, zoffset, width, height, depth, memory, offset, commit);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMeshShaderNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_mesh_shader';
    
    private z_DrawMeshTasksNV_adr := GetProcAddress('glDrawMeshTasksNV');
    private z_DrawMeshTasksNV_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: UInt32)>(z_DrawMeshTasksNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawMeshTasksNV(first: UInt32; count: UInt32) :=
    z_DrawMeshTasksNV_ovr_0(first, count);
    
    private z_DrawMeshTasksIndirectNV_adr := GetProcAddress('glDrawMeshTasksIndirectNV');
    private z_DrawMeshTasksIndirectNV_ovr_0 := GetProcOrNil&<procedure(indirect: IntPtr)>(z_DrawMeshTasksIndirectNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawMeshTasksIndirectNV(indirect: IntPtr) :=
    z_DrawMeshTasksIndirectNV_ovr_0(indirect);
    
    private z_MultiDrawMeshTasksIndirectNV_adr := GetProcAddress('glMultiDrawMeshTasksIndirectNV');
    private z_MultiDrawMeshTasksIndirectNV_ovr_0 := GetProcOrNil&<procedure(indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawMeshTasksIndirectNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawMeshTasksIndirectNV(indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawMeshTasksIndirectNV_ovr_0(indirect, drawcount, stride);
    
    private z_MultiDrawMeshTasksIndirectCountNV_adr := GetProcAddress('glMultiDrawMeshTasksIndirectCountNV');
    private z_MultiDrawMeshTasksIndirectCountNV_ovr_0 := GetProcOrNil&<procedure(indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawMeshTasksIndirectCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawMeshTasksIndirectCountNV(indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawMeshTasksIndirectCountNV_ovr_0(indirect, drawcount, maxdrawcount, stride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glOcclusionQueryNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_occlusion_query';
    
    private z_GenOcclusionQueriesNV_adr := GetProcAddress('glGenOcclusionQueriesNV');
    private z_GenOcclusionQueriesNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: UInt32)>(z_GenOcclusionQueriesNV_adr);
    private z_GenOcclusionQueriesNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenOcclusionQueriesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenOcclusionQueriesNV(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenOcclusionQueriesNV_ovr_0(n, ids[0]) else
      z_GenOcclusionQueriesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenOcclusionQueriesNV(n: Int32; var ids: UInt32) :=
    z_GenOcclusionQueriesNV_ovr_0(n, ids);
    private z_GenOcclusionQueriesNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenOcclusionQueriesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenOcclusionQueriesNV(n: Int32; ids: IntPtr) :=
    z_GenOcclusionQueriesNV_ovr_2(n, ids);
    
    private z_DeleteOcclusionQueriesNV_adr := GetProcAddress('glDeleteOcclusionQueriesNV');
    private z_DeleteOcclusionQueriesNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: UInt32)>(z_DeleteOcclusionQueriesNV_adr);
    private z_DeleteOcclusionQueriesNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteOcclusionQueriesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteOcclusionQueriesNV(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteOcclusionQueriesNV_ovr_0(n, ids[0]) else
      z_DeleteOcclusionQueriesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteOcclusionQueriesNV(n: Int32; var ids: UInt32) :=
    z_DeleteOcclusionQueriesNV_ovr_0(n, ids);
    private z_DeleteOcclusionQueriesNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteOcclusionQueriesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteOcclusionQueriesNV(n: Int32; ids: IntPtr) :=
    z_DeleteOcclusionQueriesNV_ovr_2(n, ids);
    
    private z_IsOcclusionQueryNV_adr := GetProcAddress('glIsOcclusionQueryNV');
    private z_IsOcclusionQueryNV_ovr_0 := GetProcOrNil&<function(id: UInt32): boolean>(z_IsOcclusionQueryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsOcclusionQueryNV(id: UInt32): boolean :=
    z_IsOcclusionQueryNV_ovr_0(id);
    
    private z_BeginOcclusionQueryNV_adr := GetProcAddress('glBeginOcclusionQueryNV');
    private z_BeginOcclusionQueryNV_ovr_0 := GetProcOrNil&<procedure(id: UInt32)>(z_BeginOcclusionQueryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginOcclusionQueryNV(id: UInt32) :=
    z_BeginOcclusionQueryNV_ovr_0(id);
    
    private z_EndOcclusionQueryNV_adr := GetProcAddress('glEndOcclusionQueryNV');
    private z_EndOcclusionQueryNV_ovr_0 := GetProcOrNil&<procedure>(z_EndOcclusionQueryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndOcclusionQueryNV :=
    z_EndOcclusionQueryNV_ovr_0;
    
    private z_GetOcclusionQueryivNV_adr := GetProcAddress('glGetOcclusionQueryivNV');
    private z_GetOcclusionQueryivNV_ovr_0 := GetProcOrNil&<procedure(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: Int32)>(z_GetOcclusionQueryivNV_adr);
    private z_GetOcclusionQueryivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr)>(z_GetOcclusionQueryivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetOcclusionQueryivNV_ovr_0(id, pname, &params[0]) else
      z_GetOcclusionQueryivNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: Int32) :=
    z_GetOcclusionQueryivNV_ovr_0(id, pname, &params);
    private z_GetOcclusionQueryivNV_ovr_2 := GetProcOrNil&<procedure(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr)>(z_GetOcclusionQueryivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr) :=
    z_GetOcclusionQueryivNV_ovr_2(id, pname, &params);
    
    private z_GetOcclusionQueryuivNV_adr := GetProcAddress('glGetOcclusionQueryuivNV');
    private z_GetOcclusionQueryuivNV_ovr_0 := GetProcOrNil&<procedure(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: UInt32)>(z_GetOcclusionQueryuivNV_adr);
    private z_GetOcclusionQueryuivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr)>(z_GetOcclusionQueryuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryuivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetOcclusionQueryuivNV_ovr_0(id, pname, &params[0]) else
      z_GetOcclusionQueryuivNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryuivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: UInt32) :=
    z_GetOcclusionQueryuivNV_ovr_0(id, pname, &params);
    private z_GetOcclusionQueryuivNV_ovr_2 := GetProcOrNil&<procedure(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr)>(z_GetOcclusionQueryuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryuivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr) :=
    z_GetOcclusionQueryuivNV_ovr_2(id, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glParameterBufferObjectNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_parameter_buffer_object';
    
    private z_ProgramBufferParametersfvNV_adr := GetProcAddress('glProgramBufferParametersfvNV');
    private z_ProgramBufferParametersfvNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: single)>(z_ProgramBufferParametersfvNV_adr);
    private z_ProgramBufferParametersfvNV_ovr_0_anh000001 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr)>(z_ProgramBufferParametersfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersfvNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramBufferParametersfvNV_ovr_0(target, bindingIndex, wordIndex, count, &params[0]) else
      z_ProgramBufferParametersfvNV_ovr_0_anh000001(target, bindingIndex, wordIndex, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersfvNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: single) :=
    z_ProgramBufferParametersfvNV_ovr_0(target, bindingIndex, wordIndex, count, &params);
    private z_ProgramBufferParametersfvNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr)>(z_ProgramBufferParametersfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersfvNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramBufferParametersfvNV_ovr_2(target, bindingIndex, wordIndex, count, &params);
    
    private z_ProgramBufferParametersIivNV_adr := GetProcAddress('glProgramBufferParametersIivNV');
    private z_ProgramBufferParametersIivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: Int32)>(z_ProgramBufferParametersIivNV_adr);
    private z_ProgramBufferParametersIivNV_ovr_0_anh000001 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr)>(z_ProgramBufferParametersIivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramBufferParametersIivNV_ovr_0(target, bindingIndex, wordIndex, count, &params[0]) else
      z_ProgramBufferParametersIivNV_ovr_0_anh000001(target, bindingIndex, wordIndex, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: Int32) :=
    z_ProgramBufferParametersIivNV_ovr_0(target, bindingIndex, wordIndex, count, &params);
    private z_ProgramBufferParametersIivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr)>(z_ProgramBufferParametersIivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramBufferParametersIivNV_ovr_2(target, bindingIndex, wordIndex, count, &params);
    
    private z_ProgramBufferParametersIuivNV_adr := GetProcAddress('glProgramBufferParametersIuivNV');
    private z_ProgramBufferParametersIuivNV_ovr_0 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: UInt32)>(z_ProgramBufferParametersIuivNV_adr);
    private z_ProgramBufferParametersIuivNV_ovr_0_anh000001 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr)>(z_ProgramBufferParametersIuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIuivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramBufferParametersIuivNV_ovr_0(target, bindingIndex, wordIndex, count, &params[0]) else
      z_ProgramBufferParametersIuivNV_ovr_0_anh000001(target, bindingIndex, wordIndex, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIuivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: UInt32) :=
    z_ProgramBufferParametersIuivNV_ovr_0(target, bindingIndex, wordIndex, count, &params);
    private z_ProgramBufferParametersIuivNV_ovr_2 := GetProcOrNil&<procedure(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr)>(z_ProgramBufferParametersIuivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIuivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramBufferParametersIuivNV_ovr_2(target, bindingIndex, wordIndex, count, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPathRenderingNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_path_rendering';
    
    private z_GenPathsNV_adr := GetProcAddress('glGenPathsNV');
    private z_GenPathsNV_ovr_0 := GetProcOrNil&<function(range: Int32): UInt32>(z_GenPathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenPathsNV(range: Int32): UInt32 :=
    z_GenPathsNV_ovr_0(range);
    
    private z_DeletePathsNV_adr := GetProcAddress('glDeletePathsNV');
    private z_DeletePathsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; range: Int32)>(z_DeletePathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePathsNV(path: UInt32; range: Int32) :=
    z_DeletePathsNV_ovr_0(path, range);
    
    private z_IsPathNV_adr := GetProcAddress('glIsPathNV');
    private z_IsPathNV_ovr_0 := GetProcOrNil&<function(path: UInt32): boolean>(z_IsPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsPathNV(path: UInt32): boolean :=
    z_IsPathNV_ovr_0(path);
    
    private z_PathCommandsNV_adr := GetProcAddress('glPathCommandsNV');
    private z_PathCommandsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathCommandsNV_adr);
    private z_PathCommandsNV_ovr_0_anh0001000 := GetProcOrNil&<procedure(path: UInt32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCommandsNV(path: UInt32; numCommands: Int32; commands: array of Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    if (commands<>nil) and (commands.Length<>0) then
      z_PathCommandsNV_ovr_0(path, numCommands, commands[0], numCoords, coordType, coords) else
      z_PathCommandsNV_ovr_0_anh0001000(path, numCommands, IntPtr.Zero, numCoords, coordType, coords);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCommandsNV(path: UInt32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathCommandsNV_ovr_0(path, numCommands, commands, numCoords, coordType, coords);
    private z_PathCommandsNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCommandsNV(path: UInt32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathCommandsNV_ovr_2(path, numCommands, commands, numCoords, coordType, coords);
    
    private z_PathCoordsNV_adr := GetProcAddress('glPathCoordsNV');
    private z_PathCoordsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathCoordsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCoordsNV(path: UInt32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathCoordsNV_ovr_0(path, numCoords, coordType, coords);
    
    private z_PathSubCommandsNV_adr := GetProcAddress('glPathSubCommandsNV');
    private z_PathSubCommandsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathSubCommandsNV_adr);
    private z_PathSubCommandsNV_ovr_0_anh000001000 := GetProcOrNil&<procedure(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathSubCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCommandsNV(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: array of Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    if (commands<>nil) and (commands.Length<>0) then
      z_PathSubCommandsNV_ovr_0(path, commandStart, commandsToDelete, numCommands, commands[0], numCoords, coordType, coords) else
      z_PathSubCommandsNV_ovr_0_anh000001000(path, commandStart, commandsToDelete, numCommands, IntPtr.Zero, numCoords, coordType, coords);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCommandsNV(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathSubCommandsNV_ovr_0(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords);
    private z_PathSubCommandsNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathSubCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCommandsNV(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathSubCommandsNV_ovr_2(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords);
    
    private z_PathSubCoordsNV_adr := GetProcAddress('glPathSubCoordsNV');
    private z_PathSubCoordsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; coordStart: Int32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr)>(z_PathSubCoordsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCoordsNV(path: UInt32; coordStart: Int32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathSubCoordsNV_ovr_0(path, coordStart, numCoords, coordType, coords);
    
    private z_PathStringNV_adr := GetProcAddress('glPathStringNV');
    private z_PathStringNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; format: PathStringFormat; length: Int32; pathString: IntPtr)>(z_PathStringNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathStringNV(path: UInt32; format: PathStringFormat; length: Int32; pathString: IntPtr) :=
    z_PathStringNV_ovr_0(path, format, length, pathString);
    
    private z_PathGlyphsNV_adr := GetProcAddress('glPathGlyphsNV');
    private z_PathGlyphsNV_ovr_0 := GetProcOrNil&<procedure(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; numGlyphs: Int32; &type: PathElementType; charcodes: IntPtr; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single)>(z_PathGlyphsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathGlyphsNV(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; numGlyphs: Int32; &type: PathElementType; charcodes: IntPtr; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single) :=
    z_PathGlyphsNV_ovr_0(firstPathName, fontTarget, fontName, fontStyle, numGlyphs, &type, charcodes, handleMissingGlyphs, pathParameterTemplate, emScale);
    
    private z_PathGlyphRangeNV_adr := GetProcAddress('glPathGlyphRangeNV');
    private z_PathGlyphRangeNV_ovr_0 := GetProcOrNil&<procedure(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyph: UInt32; numGlyphs: Int32; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single)>(z_PathGlyphRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathGlyphRangeNV(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyph: UInt32; numGlyphs: Int32; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single) :=
    z_PathGlyphRangeNV_ovr_0(firstPathName, fontTarget, fontName, fontStyle, firstGlyph, numGlyphs, handleMissingGlyphs, pathParameterTemplate, emScale);
    
    private z_WeightPathsNV_adr := GetProcAddress('glWeightPathsNV');
    private z_WeightPathsNV_ovr_0 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; var paths: UInt32; var weights: single)>(z_WeightPathsNV_adr);
    private z_WeightPathsNV_ovr_0_anh00010 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single)>(z_WeightPathsNV_adr);
    private z_WeightPathsNV_ovr_0_anh00001 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: IntPtr)>(z_WeightPathsNV_adr);
    private z_WeightPathsNV_ovr_0_anh00011 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr)>(z_WeightPathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: array of UInt32; weights: array of single) :=
    if (paths<>nil) and (paths.Length<>0) then
      if (weights<>nil) and (weights.Length<>0) then
        z_WeightPathsNV_ovr_0(resultPath, numPaths, paths[0], weights[0]) else
        z_WeightPathsNV_ovr_0_anh00001(resultPath, numPaths, paths[0], IntPtr.Zero) else
      if (weights<>nil) and (weights.Length<>0) then
        z_WeightPathsNV_ovr_0_anh00010(resultPath, numPaths, IntPtr.Zero, weights[0]) else
        z_WeightPathsNV_ovr_0_anh00011(resultPath, numPaths, IntPtr.Zero, IntPtr.Zero);
    private z_WeightPathsNV_ovr_1_anh00010 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single)>(z_WeightPathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: array of UInt32; var weights: single) :=
    if (paths<>nil) and (paths.Length<>0) then
      z_WeightPathsNV_ovr_0(resultPath, numPaths, paths[0], weights) else
      z_WeightPathsNV_ovr_0_anh00010(resultPath, numPaths, IntPtr.Zero, weights);
    private z_WeightPathsNV_ovr_2 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: IntPtr)>(z_WeightPathsNV_adr);
    private z_WeightPathsNV_ovr_2_anh00010 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr)>(z_WeightPathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: array of UInt32; weights: IntPtr) :=
    if (paths<>nil) and (paths.Length<>0) then
      z_WeightPathsNV_ovr_2(resultPath, numPaths, paths[0], weights) else
      z_WeightPathsNV_ovr_2_anh00010(resultPath, numPaths, IntPtr.Zero, weights);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightPathsNV_ovr_0(resultPath, numPaths, paths, weights[0]) else
      z_WeightPathsNV_ovr_0_anh00001(resultPath, numPaths, paths, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; var paths: UInt32; var weights: single) :=
    z_WeightPathsNV_ovr_0(resultPath, numPaths, paths, weights);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: IntPtr) :=
    z_WeightPathsNV_ovr_2(resultPath, numPaths, paths, weights);
    private z_WeightPathsNV_ovr_6 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single)>(z_WeightPathsNV_adr);
    private z_WeightPathsNV_ovr_6_anh00001 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr)>(z_WeightPathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightPathsNV_ovr_6(resultPath, numPaths, paths, weights[0]) else
      z_WeightPathsNV_ovr_6_anh00001(resultPath, numPaths, paths, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single) :=
    z_WeightPathsNV_ovr_6(resultPath, numPaths, paths, weights);
    private z_WeightPathsNV_ovr_8 := GetProcOrNil&<procedure(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr)>(z_WeightPathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr) :=
    z_WeightPathsNV_ovr_8(resultPath, numPaths, paths, weights);
    
    private z_CopyPathNV_adr := GetProcAddress('glCopyPathNV');
    private z_CopyPathNV_ovr_0 := GetProcOrNil&<procedure(resultPath: UInt32; srcPath: UInt32)>(z_CopyPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyPathNV(resultPath: UInt32; srcPath: UInt32) :=
    z_CopyPathNV_ovr_0(resultPath, srcPath);
    
    private z_InterpolatePathsNV_adr := GetProcAddress('glInterpolatePathsNV');
    private z_InterpolatePathsNV_ovr_0 := GetProcOrNil&<procedure(resultPath: UInt32; pathA: UInt32; pathB: UInt32; weight: single)>(z_InterpolatePathsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InterpolatePathsNV(resultPath: UInt32; pathA: UInt32; pathB: UInt32; weight: single) :=
    z_InterpolatePathsNV_ovr_0(resultPath, pathA, pathB, weight);
    
    private z_TransformPathNV_adr := GetProcAddress('glTransformPathNV');
    private z_TransformPathNV_ovr_0 := GetProcOrNil&<procedure(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; var transformValues: single)>(z_TransformPathNV_adr);
    private z_TransformPathNV_ovr_0_anh00001 := GetProcOrNil&<procedure(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: IntPtr)>(z_TransformPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformPathNV(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_TransformPathNV_ovr_0(resultPath, srcPath, transformType, transformValues[0]) else
      z_TransformPathNV_ovr_0_anh00001(resultPath, srcPath, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformPathNV(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; var transformValues: single) :=
    z_TransformPathNV_ovr_0(resultPath, srcPath, transformType, transformValues);
    private z_TransformPathNV_ovr_2 := GetProcOrNil&<procedure(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: IntPtr)>(z_TransformPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformPathNV(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: IntPtr) :=
    z_TransformPathNV_ovr_2(resultPath, srcPath, transformType, transformValues);
    
    private z_PathParameterivNV_adr := GetProcAddress('glPathParameterivNV');
    private z_PathParameterivNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; var value: Int32)>(z_PathParameterivNV_adr);
    private z_PathParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_PathParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterivNV(path: UInt32; pname: PathParameter; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_PathParameterivNV_ovr_0(path, pname, value[0]) else
      z_PathParameterivNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterivNV(path: UInt32; pname: PathParameter; var value: Int32) :=
    z_PathParameterivNV_ovr_0(path, pname, value);
    private z_PathParameterivNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_PathParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterivNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_PathParameterivNV_ovr_2(path, pname, value);
    
    private z_PathParameteriNV_adr := GetProcAddress('glPathParameteriNV');
    private z_PathParameteriNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: Int32)>(z_PathParameteriNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameteriNV(path: UInt32; pname: PathParameter; value: Int32) :=
    z_PathParameteriNV_ovr_0(path, pname, value);
    
    private z_PathParameterfvNV_adr := GetProcAddress('glPathParameterfvNV');
    private z_PathParameterfvNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; var value: single)>(z_PathParameterfvNV_adr);
    private z_PathParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_PathParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfvNV(path: UInt32; pname: PathParameter; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_PathParameterfvNV_ovr_0(path, pname, value[0]) else
      z_PathParameterfvNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfvNV(path: UInt32; pname: PathParameter; var value: single) :=
    z_PathParameterfvNV_ovr_0(path, pname, value);
    private z_PathParameterfvNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_PathParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfvNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_PathParameterfvNV_ovr_2(path, pname, value);
    
    private z_PathParameterfNV_adr := GetProcAddress('glPathParameterfNV');
    private z_PathParameterfNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: single)>(z_PathParameterfNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfNV(path: UInt32; pname: PathParameter; value: single) :=
    z_PathParameterfNV_ovr_0(path, pname, value);
    
    private z_PathDashArrayNV_adr := GetProcAddress('glPathDashArrayNV');
    private z_PathDashArrayNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; dashCount: Int32; var dashArray: single)>(z_PathDashArrayNV_adr);
    private z_PathDashArrayNV_ovr_0_anh0001 := GetProcOrNil&<procedure(path: UInt32; dashCount: Int32; dashArray: IntPtr)>(z_PathDashArrayNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathDashArrayNV(path: UInt32; dashCount: Int32; dashArray: array of single) :=
    if (dashArray<>nil) and (dashArray.Length<>0) then
      z_PathDashArrayNV_ovr_0(path, dashCount, dashArray[0]) else
      z_PathDashArrayNV_ovr_0_anh0001(path, dashCount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathDashArrayNV(path: UInt32; dashCount: Int32; var dashArray: single) :=
    z_PathDashArrayNV_ovr_0(path, dashCount, dashArray);
    private z_PathDashArrayNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; dashCount: Int32; dashArray: IntPtr)>(z_PathDashArrayNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathDashArrayNV(path: UInt32; dashCount: Int32; dashArray: IntPtr) :=
    z_PathDashArrayNV_ovr_2(path, dashCount, dashArray);
    
    private z_PathStencilFuncNV_adr := GetProcAddress('glPathStencilFuncNV');
    private z_PathStencilFuncNV_ovr_0 := GetProcOrNil&<procedure(func: StencilFunction; ref: Int32; mask: UInt32)>(z_PathStencilFuncNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathStencilFuncNV(func: StencilFunction; ref: Int32; mask: UInt32) :=
    z_PathStencilFuncNV_ovr_0(func, ref, mask);
    
    private z_PathStencilDepthOffsetNV_adr := GetProcAddress('glPathStencilDepthOffsetNV');
    private z_PathStencilDepthOffsetNV_ovr_0 := GetProcOrNil&<procedure(factor: single; units: single)>(z_PathStencilDepthOffsetNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathStencilDepthOffsetNV(factor: single; units: single) :=
    z_PathStencilDepthOffsetNV_ovr_0(factor, units);
    
    private z_StencilFillPathNV_adr := GetProcAddress('glStencilFillPathNV');
    private z_StencilFillPathNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; fillMode: PathFillMode; mask: UInt32)>(z_StencilFillPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathNV(path: UInt32; fillMode: PathFillMode; mask: UInt32) :=
    z_StencilFillPathNV_ovr_0(path, fillMode, mask);
    
    private z_StencilStrokePathNV_adr := GetProcAddress('glStencilStrokePathNV');
    private z_StencilStrokePathNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; reference: Int32; mask: UInt32)>(z_StencilStrokePathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathNV(path: UInt32; reference: Int32; mask: UInt32) :=
    z_StencilStrokePathNV_ovr_0(path, reference, mask);
    
    private z_StencilFillPathInstancedNV_adr := GetProcAddress('glStencilFillPathInstancedNV');
    private z_StencilFillPathInstancedNV_ovr_0 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; var transformValues: single)>(z_StencilFillPathInstancedNV_adr);
    private z_StencilFillPathInstancedNV_ovr_0_anh000000001 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr)>(z_StencilFillPathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues[0]) else
      z_StencilFillPathInstancedNV_ovr_0_anh000000001(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; var transformValues: single) :=
    z_StencilFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues);
    private z_StencilFillPathInstancedNV_ovr_2 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr)>(z_StencilFillPathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr) :=
    z_StencilFillPathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues);
    
    private z_StencilStrokePathInstancedNV_adr := GetProcAddress('glStencilStrokePathInstancedNV');
    private z_StencilStrokePathInstancedNV_ovr_0 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; var transformValues: single)>(z_StencilStrokePathInstancedNV_adr);
    private z_StencilStrokePathInstancedNV_ovr_0_anh000000001 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr)>(z_StencilStrokePathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues[0]) else
      z_StencilStrokePathInstancedNV_ovr_0_anh000000001(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; var transformValues: single) :=
    z_StencilStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues);
    private z_StencilStrokePathInstancedNV_ovr_2 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr)>(z_StencilStrokePathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr) :=
    z_StencilStrokePathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues);
    
    private z_PathCoverDepthFuncNV_adr := GetProcAddress('glPathCoverDepthFuncNV');
    private z_PathCoverDepthFuncNV_ovr_0 := GetProcOrNil&<procedure(func: DepthFunction)>(z_PathCoverDepthFuncNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCoverDepthFuncNV(func: DepthFunction) :=
    z_PathCoverDepthFuncNV_ovr_0(func);
    
    private z_CoverFillPathNV_adr := GetProcAddress('glCoverFillPathNV');
    private z_CoverFillPathNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; coverMode: PathCoverMode)>(z_CoverFillPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathNV(path: UInt32; coverMode: PathCoverMode) :=
    z_CoverFillPathNV_ovr_0(path, coverMode);
    
    private z_CoverStrokePathNV_adr := GetProcAddress('glCoverStrokePathNV');
    private z_CoverStrokePathNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; coverMode: PathCoverMode)>(z_CoverStrokePathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathNV(path: UInt32; coverMode: PathCoverMode) :=
    z_CoverStrokePathNV_ovr_0(path, coverMode);
    
    private z_CoverFillPathInstancedNV_adr := GetProcAddress('glCoverFillPathInstancedNV');
    private z_CoverFillPathInstancedNV_ovr_0 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single)>(z_CoverFillPathInstancedNV_adr);
    private z_CoverFillPathInstancedNV_ovr_0_anh00000001 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr)>(z_CoverFillPathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_CoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues[0]) else
      z_CoverFillPathInstancedNV_ovr_0_anh00000001(numPaths, pathNameType, paths, pathBase, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single) :=
    z_CoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    private z_CoverFillPathInstancedNV_ovr_2 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr)>(z_CoverFillPathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr) :=
    z_CoverFillPathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    
    private z_CoverStrokePathInstancedNV_adr := GetProcAddress('glCoverStrokePathInstancedNV');
    private z_CoverStrokePathInstancedNV_ovr_0 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single)>(z_CoverStrokePathInstancedNV_adr);
    private z_CoverStrokePathInstancedNV_ovr_0_anh00000001 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr)>(z_CoverStrokePathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_CoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues[0]) else
      z_CoverStrokePathInstancedNV_ovr_0_anh00000001(numPaths, pathNameType, paths, pathBase, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single) :=
    z_CoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    private z_CoverStrokePathInstancedNV_ovr_2 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr)>(z_CoverStrokePathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr) :=
    z_CoverStrokePathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    
    private z_GetPathParameterivNV_adr := GetProcAddress('glGetPathParameterivNV');
    private z_GetPathParameterivNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; var value: Int32)>(z_GetPathParameterivNV_adr);
    private z_GetPathParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_GetPathParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterivNV(path: UInt32; pname: PathParameter; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathParameterivNV_ovr_0(path, pname, value[0]) else
      z_GetPathParameterivNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterivNV(path: UInt32; pname: PathParameter; var value: Int32) :=
    z_GetPathParameterivNV_ovr_0(path, pname, value);
    private z_GetPathParameterivNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_GetPathParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterivNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_GetPathParameterivNV_ovr_2(path, pname, value);
    
    private z_GetPathParameterfvNV_adr := GetProcAddress('glGetPathParameterfvNV');
    private z_GetPathParameterfvNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; var value: single)>(z_GetPathParameterfvNV_adr);
    private z_GetPathParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_GetPathParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterfvNV(path: UInt32; pname: PathParameter; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathParameterfvNV_ovr_0(path, pname, value[0]) else
      z_GetPathParameterfvNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterfvNV(path: UInt32; pname: PathParameter; var value: single) :=
    z_GetPathParameterfvNV_ovr_0(path, pname, value);
    private z_GetPathParameterfvNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; pname: PathParameter; value: IntPtr)>(z_GetPathParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterfvNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_GetPathParameterfvNV_ovr_2(path, pname, value);
    
    private z_GetPathCommandsNV_adr := GetProcAddress('glGetPathCommandsNV');
    private z_GetPathCommandsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; var commands: Byte)>(z_GetPathCommandsNV_adr);
    private z_GetPathCommandsNV_ovr_0_anh001 := GetProcOrNil&<procedure(path: UInt32; commands: IntPtr)>(z_GetPathCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCommandsNV(path: UInt32; commands: array of Byte) :=
    if (commands<>nil) and (commands.Length<>0) then
      z_GetPathCommandsNV_ovr_0(path, commands[0]) else
      z_GetPathCommandsNV_ovr_0_anh001(path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCommandsNV(path: UInt32; var commands: Byte) :=
    z_GetPathCommandsNV_ovr_0(path, commands);
    private z_GetPathCommandsNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; commands: IntPtr)>(z_GetPathCommandsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCommandsNV(path: UInt32; commands: IntPtr) :=
    z_GetPathCommandsNV_ovr_2(path, commands);
    
    private z_GetPathCoordsNV_adr := GetProcAddress('glGetPathCoordsNV');
    private z_GetPathCoordsNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; var coords: single)>(z_GetPathCoordsNV_adr);
    private z_GetPathCoordsNV_ovr_0_anh001 := GetProcOrNil&<procedure(path: UInt32; coords: IntPtr)>(z_GetPathCoordsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCoordsNV(path: UInt32; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_GetPathCoordsNV_ovr_0(path, coords[0]) else
      z_GetPathCoordsNV_ovr_0_anh001(path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCoordsNV(path: UInt32; var coords: single) :=
    z_GetPathCoordsNV_ovr_0(path, coords);
    private z_GetPathCoordsNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; coords: IntPtr)>(z_GetPathCoordsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCoordsNV(path: UInt32; coords: IntPtr) :=
    z_GetPathCoordsNV_ovr_2(path, coords);
    
    private z_GetPathDashArrayNV_adr := GetProcAddress('glGetPathDashArrayNV');
    private z_GetPathDashArrayNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; var dashArray: single)>(z_GetPathDashArrayNV_adr);
    private z_GetPathDashArrayNV_ovr_0_anh001 := GetProcOrNil&<procedure(path: UInt32; dashArray: IntPtr)>(z_GetPathDashArrayNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathDashArrayNV(path: UInt32; dashArray: array of single) :=
    if (dashArray<>nil) and (dashArray.Length<>0) then
      z_GetPathDashArrayNV_ovr_0(path, dashArray[0]) else
      z_GetPathDashArrayNV_ovr_0_anh001(path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathDashArrayNV(path: UInt32; var dashArray: single) :=
    z_GetPathDashArrayNV_ovr_0(path, dashArray);
    private z_GetPathDashArrayNV_ovr_2 := GetProcOrNil&<procedure(path: UInt32; dashArray: IntPtr)>(z_GetPathDashArrayNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathDashArrayNV(path: UInt32; dashArray: IntPtr) :=
    z_GetPathDashArrayNV_ovr_2(path, dashArray);
    
    private z_GetPathMetricsNV_adr := GetProcAddress('glGetPathMetricsNV');
    private z_GetPathMetricsNV_ovr_0 := GetProcOrNil&<procedure(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; var metrics: single)>(z_GetPathMetricsNV_adr);
    private z_GetPathMetricsNV_ovr_0_anh00000001 := GetProcOrNil&<procedure(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: IntPtr)>(z_GetPathMetricsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricsNV(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: array of single) :=
    if (metrics<>nil) and (metrics.Length<>0) then
      z_GetPathMetricsNV_ovr_0(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics[0]) else
      z_GetPathMetricsNV_ovr_0_anh00000001(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricsNV(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; var metrics: single) :=
    z_GetPathMetricsNV_ovr_0(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics);
    private z_GetPathMetricsNV_ovr_2 := GetProcOrNil&<procedure(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: IntPtr)>(z_GetPathMetricsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricsNV(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: IntPtr) :=
    z_GetPathMetricsNV_ovr_2(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics);
    
    private z_GetPathMetricRangeNV_adr := GetProcAddress('glGetPathMetricRangeNV');
    private z_GetPathMetricRangeNV_ovr_0 := GetProcOrNil&<procedure(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; var metrics: single)>(z_GetPathMetricRangeNV_adr);
    private z_GetPathMetricRangeNV_ovr_0_anh000001 := GetProcOrNil&<procedure(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: IntPtr)>(z_GetPathMetricRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricRangeNV(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: array of single) :=
    if (metrics<>nil) and (metrics.Length<>0) then
      z_GetPathMetricRangeNV_ovr_0(metricQueryMask, firstPathName, numPaths, stride, metrics[0]) else
      z_GetPathMetricRangeNV_ovr_0_anh000001(metricQueryMask, firstPathName, numPaths, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricRangeNV(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; var metrics: single) :=
    z_GetPathMetricRangeNV_ovr_0(metricQueryMask, firstPathName, numPaths, stride, metrics);
    private z_GetPathMetricRangeNV_ovr_2 := GetProcOrNil&<procedure(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: IntPtr)>(z_GetPathMetricRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricRangeNV(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: IntPtr) :=
    z_GetPathMetricRangeNV_ovr_2(metricQueryMask, firstPathName, numPaths, stride, metrics);
    
    private z_GetPathSpacingNV_adr := GetProcAddress('glGetPathSpacingNV');
    private z_GetPathSpacingNV_ovr_0 := GetProcOrNil&<procedure(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; var returnedSpacing: single)>(z_GetPathSpacingNV_adr);
    private z_GetPathSpacingNV_ovr_0_anh0000000001 := GetProcOrNil&<procedure(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: IntPtr)>(z_GetPathSpacingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathSpacingNV(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: array of single) :=
    if (returnedSpacing<>nil) and (returnedSpacing.Length<>0) then
      z_GetPathSpacingNV_ovr_0(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing[0]) else
      z_GetPathSpacingNV_ovr_0_anh0000000001(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathSpacingNV(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; var returnedSpacing: single) :=
    z_GetPathSpacingNV_ovr_0(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing);
    private z_GetPathSpacingNV_ovr_2 := GetProcOrNil&<procedure(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: IntPtr)>(z_GetPathSpacingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathSpacingNV(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: IntPtr) :=
    z_GetPathSpacingNV_ovr_2(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing);
    
    private z_IsPointInFillPathNV_adr := GetProcAddress('glIsPointInFillPathNV');
    private z_IsPointInFillPathNV_ovr_0 := GetProcOrNil&<function(path: UInt32; mask: UInt32; x: single; y: single): boolean>(z_IsPointInFillPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsPointInFillPathNV(path: UInt32; mask: UInt32; x: single; y: single): boolean :=
    z_IsPointInFillPathNV_ovr_0(path, mask, x, y);
    
    private z_IsPointInStrokePathNV_adr := GetProcAddress('glIsPointInStrokePathNV');
    private z_IsPointInStrokePathNV_ovr_0 := GetProcOrNil&<function(path: UInt32; x: single; y: single): boolean>(z_IsPointInStrokePathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsPointInStrokePathNV(path: UInt32; x: single; y: single): boolean :=
    z_IsPointInStrokePathNV_ovr_0(path, x, y);
    
    private z_GetPathLengthNV_adr := GetProcAddress('glGetPathLengthNV');
    private z_GetPathLengthNV_ovr_0 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32): single>(z_GetPathLengthNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPathLengthNV(path: UInt32; startSegment: Int32; numSegments: Int32): single :=
    z_GetPathLengthNV_ovr_0(path, startSegment, numSegments);
    
    private z_PointAlongPathNV_adr := GetProcAddress('glPointAlongPathNV');
    private z_PointAlongPathNV_ovr_0 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_1 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_1(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_2 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_3 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_3(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_4 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_4(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_5 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_5(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_6 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_7 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_7(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_8 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_8(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_9 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_9(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_10 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_10(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_11 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_11(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_12 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_12(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_13 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_13(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_14 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_14(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private z_PointAlongPathNV_ovr_15 := GetProcOrNil&<function(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean>(z_PointAlongPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_15(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    
    private z_MatrixLoad3x2fNV_adr := GetProcAddress('glMatrixLoad3x2fNV');
    private z_MatrixLoad3x2fNV_ovr_0 := GetProcOrNil&<procedure(matrixMode: DummyEnum; var m: single)>(z_MatrixLoad3x2fNV_adr);
    private z_MatrixLoad3x2fNV_ovr_0_anh001 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixLoad3x2fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x2fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoad3x2fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixLoad3x2fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x2fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixLoad3x2fNV_ovr_0(matrixMode, m);
    private z_MatrixLoad3x2fNV_ovr_2 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixLoad3x2fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x2fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixLoad3x2fNV_ovr_2(matrixMode, m);
    
    private z_MatrixLoad3x3fNV_adr := GetProcAddress('glMatrixLoad3x3fNV');
    private z_MatrixLoad3x3fNV_ovr_0 := GetProcOrNil&<procedure(matrixMode: DummyEnum; var m: single)>(z_MatrixLoad3x3fNV_adr);
    private z_MatrixLoad3x3fNV_ovr_0_anh001 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixLoad3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoad3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixLoad3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixLoad3x3fNV_ovr_0(matrixMode, m);
    private z_MatrixLoad3x3fNV_ovr_2 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixLoad3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixLoad3x3fNV_ovr_2(matrixMode, m);
    
    private z_MatrixLoadTranspose3x3fNV_adr := GetProcAddress('glMatrixLoadTranspose3x3fNV');
    private z_MatrixLoadTranspose3x3fNV_ovr_0 := GetProcOrNil&<procedure(matrixMode: DummyEnum; var m: single)>(z_MatrixLoadTranspose3x3fNV_adr);
    private z_MatrixLoadTranspose3x3fNV_ovr_0_anh001 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixLoadTranspose3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTranspose3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTranspose3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixLoadTranspose3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTranspose3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixLoadTranspose3x3fNV_ovr_0(matrixMode, m);
    private z_MatrixLoadTranspose3x3fNV_ovr_2 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixLoadTranspose3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTranspose3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixLoadTranspose3x3fNV_ovr_2(matrixMode, m);
    
    private z_MatrixMult3x2fNV_adr := GetProcAddress('glMatrixMult3x2fNV');
    private z_MatrixMult3x2fNV_ovr_0 := GetProcOrNil&<procedure(matrixMode: DummyEnum; var m: single)>(z_MatrixMult3x2fNV_adr);
    private z_MatrixMult3x2fNV_ovr_0_anh001 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixMult3x2fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x2fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMult3x2fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixMult3x2fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x2fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixMult3x2fNV_ovr_0(matrixMode, m);
    private z_MatrixMult3x2fNV_ovr_2 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixMult3x2fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x2fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixMult3x2fNV_ovr_2(matrixMode, m);
    
    private z_MatrixMult3x3fNV_adr := GetProcAddress('glMatrixMult3x3fNV');
    private z_MatrixMult3x3fNV_ovr_0 := GetProcOrNil&<procedure(matrixMode: DummyEnum; var m: single)>(z_MatrixMult3x3fNV_adr);
    private z_MatrixMult3x3fNV_ovr_0_anh001 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixMult3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMult3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixMult3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixMult3x3fNV_ovr_0(matrixMode, m);
    private z_MatrixMult3x3fNV_ovr_2 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixMult3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixMult3x3fNV_ovr_2(matrixMode, m);
    
    private z_MatrixMultTranspose3x3fNV_adr := GetProcAddress('glMatrixMultTranspose3x3fNV');
    private z_MatrixMultTranspose3x3fNV_ovr_0 := GetProcOrNil&<procedure(matrixMode: DummyEnum; var m: single)>(z_MatrixMultTranspose3x3fNV_adr);
    private z_MatrixMultTranspose3x3fNV_ovr_0_anh001 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixMultTranspose3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTranspose3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTranspose3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixMultTranspose3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTranspose3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixMultTranspose3x3fNV_ovr_0(matrixMode, m);
    private z_MatrixMultTranspose3x3fNV_ovr_2 := GetProcOrNil&<procedure(matrixMode: DummyEnum; m: IntPtr)>(z_MatrixMultTranspose3x3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTranspose3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixMultTranspose3x3fNV_ovr_2(matrixMode, m);
    
    private z_StencilThenCoverFillPathNV_adr := GetProcAddress('glStencilThenCoverFillPathNV');
    private z_StencilThenCoverFillPathNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum)>(z_StencilThenCoverFillPathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathNV(path: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum) :=
    z_StencilThenCoverFillPathNV_ovr_0(path, fillMode, mask, coverMode);
    
    private z_StencilThenCoverStrokePathNV_adr := GetProcAddress('glStencilThenCoverStrokePathNV');
    private z_StencilThenCoverStrokePathNV_ovr_0 := GetProcOrNil&<procedure(path: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum)>(z_StencilThenCoverStrokePathNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathNV(path: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum) :=
    z_StencilThenCoverStrokePathNV_ovr_0(path, reference, mask, coverMode);
    
    private z_StencilThenCoverFillPathInstancedNV_adr := GetProcAddress('glStencilThenCoverFillPathInstancedNV');
    private z_StencilThenCoverFillPathInstancedNV_ovr_0 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single)>(z_StencilThenCoverFillPathInstancedNV_adr);
    private z_StencilThenCoverFillPathInstancedNV_ovr_0_anh0000000001 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr)>(z_StencilThenCoverFillPathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilThenCoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues[0]) else
      z_StencilThenCoverFillPathInstancedNV_ovr_0_anh0000000001(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single) :=
    z_StencilThenCoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues);
    private z_StencilThenCoverFillPathInstancedNV_ovr_2 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr)>(z_StencilThenCoverFillPathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr) :=
    z_StencilThenCoverFillPathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues);
    
    private z_StencilThenCoverStrokePathInstancedNV_adr := GetProcAddress('glStencilThenCoverStrokePathInstancedNV');
    private z_StencilThenCoverStrokePathInstancedNV_ovr_0 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single)>(z_StencilThenCoverStrokePathInstancedNV_adr);
    private z_StencilThenCoverStrokePathInstancedNV_ovr_0_anh0000000001 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr)>(z_StencilThenCoverStrokePathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilThenCoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues[0]) else
      z_StencilThenCoverStrokePathInstancedNV_ovr_0_anh0000000001(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single) :=
    z_StencilThenCoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues);
    private z_StencilThenCoverStrokePathInstancedNV_ovr_2 := GetProcOrNil&<procedure(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr)>(z_StencilThenCoverStrokePathInstancedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr) :=
    z_StencilThenCoverStrokePathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues);
    
    private z_PathGlyphIndexRangeNV_adr := GetProcAddress('glPathGlyphIndexRangeNV');
    private z_PathGlyphIndexRangeNV_ovr_0 := GetProcOrNil&<function(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; var baseAndCount: UInt32): DummyEnum>(z_PathGlyphIndexRangeNV_adr);
    private z_PathGlyphIndexRangeNV_ovr_0_anh0000001 := GetProcOrNil&<function(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; baseAndCount: IntPtr): DummyEnum>(z_PathGlyphIndexRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathGlyphIndexRangeNV(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; baseAndCount: array of UInt32): DummyEnum :=
    if (baseAndCount<>nil) and (baseAndCount.Length<>0) then
      z_PathGlyphIndexRangeNV_ovr_0(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, baseAndCount[0]) else
      z_PathGlyphIndexRangeNV_ovr_0_anh0000001(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathGlyphIndexRangeNV(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; var baseAndCount: UInt32): DummyEnum :=
    z_PathGlyphIndexRangeNV_ovr_0(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, baseAndCount);
    private z_PathGlyphIndexRangeNV_ovr_2 := GetProcOrNil&<function(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; baseAndCount: IntPtr): DummyEnum>(z_PathGlyphIndexRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathGlyphIndexRangeNV(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; baseAndCount: IntPtr): DummyEnum :=
    z_PathGlyphIndexRangeNV_ovr_2(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, baseAndCount);
    
    private z_PathGlyphIndexArrayNV_adr := GetProcAddress('glPathGlyphIndexArrayNV');
    private z_PathGlyphIndexArrayNV_ovr_0 := GetProcOrNil&<function(firstPathName: UInt32; fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum>(z_PathGlyphIndexArrayNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathGlyphIndexArrayNV(firstPathName: UInt32; fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum :=
    z_PathGlyphIndexArrayNV_ovr_0(firstPathName, fontTarget, fontName, fontStyle, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale);
    
    private z_PathMemoryGlyphIndexArrayNV_adr := GetProcAddress('glPathMemoryGlyphIndexArrayNV');
    private z_PathMemoryGlyphIndexArrayNV_ovr_0 := GetProcOrNil&<function(firstPathName: UInt32; fontTarget: DummyEnum; fontSize: IntPtr; fontData: IntPtr; faceIndex: Int32; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum>(z_PathMemoryGlyphIndexArrayNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathMemoryGlyphIndexArrayNV(firstPathName: UInt32; fontTarget: DummyEnum; fontSize: IntPtr; fontData: IntPtr; faceIndex: Int32; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum :=
    z_PathMemoryGlyphIndexArrayNV_ovr_0(firstPathName, fontTarget, fontSize, fontData, faceIndex, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale);
    
    private z_ProgramPathFragmentInputGenNV_adr := GetProcAddress('glProgramPathFragmentInputGenNV');
    private z_ProgramPathFragmentInputGenNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; genMode: DummyEnum; components: Int32; var coeffs: single)>(z_ProgramPathFragmentInputGenNV_adr);
    private z_ProgramPathFragmentInputGenNV_ovr_0_anh000001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; genMode: DummyEnum; components: Int32; coeffs: IntPtr)>(z_ProgramPathFragmentInputGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramPathFragmentInputGenNV(&program: gl_program; location: Int32; genMode: DummyEnum; components: Int32; coeffs: array of single) :=
    if (coeffs<>nil) and (coeffs.Length<>0) then
      z_ProgramPathFragmentInputGenNV_ovr_0(&program, location, genMode, components, coeffs[0]) else
      z_ProgramPathFragmentInputGenNV_ovr_0_anh000001(&program, location, genMode, components, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramPathFragmentInputGenNV(&program: gl_program; location: Int32; genMode: DummyEnum; components: Int32; var coeffs: single) :=
    z_ProgramPathFragmentInputGenNV_ovr_0(&program, location, genMode, components, coeffs);
    private z_ProgramPathFragmentInputGenNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; genMode: DummyEnum; components: Int32; coeffs: IntPtr)>(z_ProgramPathFragmentInputGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramPathFragmentInputGenNV(&program: gl_program; location: Int32; genMode: DummyEnum; components: Int32; coeffs: IntPtr) :=
    z_ProgramPathFragmentInputGenNV_ovr_2(&program, location, genMode, components, coeffs);
    
    private z_GetProgramResourcefvNV_adr := GetProcAddress('glGetProgramResourcefvNV');
    private z_GetProgramResourcefvNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; var &params: single)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_0_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_0_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_0_anh000001001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; var length: Int32; &params: array of single) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourcefvNV_ovr_1_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; var length: Int32; var &params: single) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_2_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; var length: Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_2(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; var &params: single)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_3_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_3_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_3_anh000001001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: IntPtr; &params: array of single) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_3(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_3_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_3_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_3_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourcefvNV_ovr_4_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: IntPtr; var &params: single) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_3(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_3_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_5_anh000001000 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: IntPtr; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_5(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_5_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_2(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_3(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_3_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_3(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_5(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_12 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_12_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_12(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_12_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_12(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_14 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_14(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_15 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single)>(z_GetProgramResourcefvNV_adr);
    private z_GetProgramResourcefvNV_ovr_15_anh000000001 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_15(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_15_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_15(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourcefvNV_ovr_17 := GetProcOrNil&<procedure(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourcefvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: gl_program; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_17(&program, _programInterface, index, propCount, props, count, length, &params);
    
    private z_PathColorGenNV_adr := GetProcAddress('glPathColorGenNV');
    private z_PathColorGenNV_ovr_0 := GetProcOrNil&<procedure(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; var coeffs: single)>(z_PathColorGenNV_adr);
    private z_PathColorGenNV_ovr_0_anh00001 := GetProcOrNil&<procedure(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: IntPtr)>(z_PathColorGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathColorGenNV(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: array of single) :=
    if (coeffs<>nil) and (coeffs.Length<>0) then
      z_PathColorGenNV_ovr_0(color, genMode, colorFormat, coeffs[0]) else
      z_PathColorGenNV_ovr_0_anh00001(color, genMode, colorFormat, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathColorGenNV(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; var coeffs: single) :=
    z_PathColorGenNV_ovr_0(color, genMode, colorFormat, coeffs);
    private z_PathColorGenNV_ovr_2 := GetProcOrNil&<procedure(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: IntPtr)>(z_PathColorGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathColorGenNV(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: IntPtr) :=
    z_PathColorGenNV_ovr_2(color, genMode, colorFormat, coeffs);
    
    private z_PathTexGenNV_adr := GetProcAddress('glPathTexGenNV');
    private z_PathTexGenNV_ovr_0 := GetProcOrNil&<procedure(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; var coeffs: single)>(z_PathTexGenNV_adr);
    private z_PathTexGenNV_ovr_0_anh00001 := GetProcOrNil&<procedure(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: IntPtr)>(z_PathTexGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathTexGenNV(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: array of single) :=
    if (coeffs<>nil) and (coeffs.Length<>0) then
      z_PathTexGenNV_ovr_0(texCoordSet, genMode, components, coeffs[0]) else
      z_PathTexGenNV_ovr_0_anh00001(texCoordSet, genMode, components, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathTexGenNV(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; var coeffs: single) :=
    z_PathTexGenNV_ovr_0(texCoordSet, genMode, components, coeffs);
    private z_PathTexGenNV_ovr_2 := GetProcOrNil&<procedure(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: IntPtr)>(z_PathTexGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathTexGenNV(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: IntPtr) :=
    z_PathTexGenNV_ovr_2(texCoordSet, genMode, components, coeffs);
    
    private z_PathFogGenNV_adr := GetProcAddress('glPathFogGenNV');
    private z_PathFogGenNV_ovr_0 := GetProcOrNil&<procedure(genMode: PathGenMode)>(z_PathFogGenNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathFogGenNV(genMode: PathGenMode) :=
    z_PathFogGenNV_ovr_0(genMode);
    
    private z_GetPathColorGenivNV_adr := GetProcAddress('glGetPathColorGenivNV');
    private z_GetPathColorGenivNV_ovr_0 := GetProcOrNil&<procedure(color: PathColor; pname: PathGenMode; var value: Int32)>(z_GetPathColorGenivNV_adr);
    private z_GetPathColorGenivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(color: PathColor; pname: PathGenMode; value: IntPtr)>(z_GetPathColorGenivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenivNV(color: PathColor; pname: PathGenMode; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathColorGenivNV_ovr_0(color, pname, value[0]) else
      z_GetPathColorGenivNV_ovr_0_anh0001(color, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenivNV(color: PathColor; pname: PathGenMode; var value: Int32) :=
    z_GetPathColorGenivNV_ovr_0(color, pname, value);
    private z_GetPathColorGenivNV_ovr_2 := GetProcOrNil&<procedure(color: PathColor; pname: PathGenMode; value: IntPtr)>(z_GetPathColorGenivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenivNV(color: PathColor; pname: PathGenMode; value: IntPtr) :=
    z_GetPathColorGenivNV_ovr_2(color, pname, value);
    
    private z_GetPathColorGenfvNV_adr := GetProcAddress('glGetPathColorGenfvNV');
    private z_GetPathColorGenfvNV_ovr_0 := GetProcOrNil&<procedure(color: PathColor; pname: PathGenMode; var value: single)>(z_GetPathColorGenfvNV_adr);
    private z_GetPathColorGenfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(color: PathColor; pname: PathGenMode; value: IntPtr)>(z_GetPathColorGenfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenfvNV(color: PathColor; pname: PathGenMode; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathColorGenfvNV_ovr_0(color, pname, value[0]) else
      z_GetPathColorGenfvNV_ovr_0_anh0001(color, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenfvNV(color: PathColor; pname: PathGenMode; var value: single) :=
    z_GetPathColorGenfvNV_ovr_0(color, pname, value);
    private z_GetPathColorGenfvNV_ovr_2 := GetProcOrNil&<procedure(color: PathColor; pname: PathGenMode; value: IntPtr)>(z_GetPathColorGenfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenfvNV(color: PathColor; pname: PathGenMode; value: IntPtr) :=
    z_GetPathColorGenfvNV_ovr_2(color, pname, value);
    
    private z_GetPathTexGenivNV_adr := GetProcAddress('glGetPathTexGenivNV');
    private z_GetPathTexGenivNV_ovr_0 := GetProcOrNil&<procedure(texCoordSet: TextureUnit; pname: PathGenMode; var value: Int32)>(z_GetPathTexGenivNV_adr);
    private z_GetPathTexGenivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr)>(z_GetPathTexGenivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenivNV(texCoordSet: TextureUnit; pname: PathGenMode; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathTexGenivNV_ovr_0(texCoordSet, pname, value[0]) else
      z_GetPathTexGenivNV_ovr_0_anh0001(texCoordSet, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenivNV(texCoordSet: TextureUnit; pname: PathGenMode; var value: Int32) :=
    z_GetPathTexGenivNV_ovr_0(texCoordSet, pname, value);
    private z_GetPathTexGenivNV_ovr_2 := GetProcOrNil&<procedure(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr)>(z_GetPathTexGenivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenivNV(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr) :=
    z_GetPathTexGenivNV_ovr_2(texCoordSet, pname, value);
    
    private z_GetPathTexGenfvNV_adr := GetProcAddress('glGetPathTexGenfvNV');
    private z_GetPathTexGenfvNV_ovr_0 := GetProcOrNil&<procedure(texCoordSet: TextureUnit; pname: PathGenMode; var value: single)>(z_GetPathTexGenfvNV_adr);
    private z_GetPathTexGenfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr)>(z_GetPathTexGenfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenfvNV(texCoordSet: TextureUnit; pname: PathGenMode; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathTexGenfvNV_ovr_0(texCoordSet, pname, value[0]) else
      z_GetPathTexGenfvNV_ovr_0_anh0001(texCoordSet, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenfvNV(texCoordSet: TextureUnit; pname: PathGenMode; var value: single) :=
    z_GetPathTexGenfvNV_ovr_0(texCoordSet, pname, value);
    private z_GetPathTexGenfvNV_ovr_2 := GetProcOrNil&<procedure(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr)>(z_GetPathTexGenfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenfvNV(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr) :=
    z_GetPathTexGenfvNV_ovr_2(texCoordSet, pname, value);
    
    private z_MatrixFrustumEXT_adr := GetProcAddress('glMatrixFrustumEXT');
    private z_MatrixFrustumEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real)>(z_MatrixFrustumEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixFrustumEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixFrustumEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private z_MatrixLoadIdentityEXT_adr := GetProcAddress('glMatrixLoadIdentityEXT');
    private z_MatrixLoadIdentityEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode)>(z_MatrixLoadIdentityEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadIdentityEXT(mode: MatrixMode) :=
    z_MatrixLoadIdentityEXT_ovr_0(mode);
    
    private z_MatrixLoadTransposefEXT_adr := GetProcAddress('glMatrixLoadTransposefEXT');
    private z_MatrixLoadTransposefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixLoadTransposefEXT_adr);
    private z_MatrixLoadTransposefEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadTransposefEXT_ovr_0(mode, m);
    private z_MatrixLoadTransposefEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposefEXT_ovr_2(mode, m);
    
    private z_MatrixLoadTransposedEXT_adr := GetProcAddress('glMatrixLoadTransposedEXT');
    private z_MatrixLoadTransposedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixLoadTransposedEXT_adr);
    private z_MatrixLoadTransposedEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoadTransposedEXT_ovr_0(mode, m);
    private z_MatrixLoadTransposedEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposedEXT_ovr_2(mode, m);
    
    private z_MatrixLoadfEXT_adr := GetProcAddress('glMatrixLoadfEXT');
    private z_MatrixLoadfEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixLoadfEXT_adr);
    private z_MatrixLoadfEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadfEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadfEXT_ovr_0(mode, m);
    private z_MatrixLoadfEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoadfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadfEXT_ovr_2(mode, m);
    
    private z_MatrixLoaddEXT_adr := GetProcAddress('glMatrixLoaddEXT');
    private z_MatrixLoaddEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixLoaddEXT_adr);
    private z_MatrixLoaddEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoaddEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoaddEXT_ovr_0(mode, m[0]) else
      z_MatrixLoaddEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoaddEXT_ovr_0(mode, m);
    private z_MatrixLoaddEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixLoaddEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoaddEXT_ovr_2(mode, m);
    
    private z_MatrixMultTransposefEXT_adr := GetProcAddress('glMatrixMultTransposefEXT');
    private z_MatrixMultTransposefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixMultTransposefEXT_adr);
    private z_MatrixMultTransposefEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultTransposefEXT_ovr_0(mode, m);
    private z_MatrixMultTransposefEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposefEXT_ovr_2(mode, m);
    
    private z_MatrixMultTransposedEXT_adr := GetProcAddress('glMatrixMultTransposedEXT');
    private z_MatrixMultTransposedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixMultTransposedEXT_adr);
    private z_MatrixMultTransposedEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultTransposedEXT_ovr_0(mode, m);
    private z_MatrixMultTransposedEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultTransposedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposedEXT_ovr_2(mode, m);
    
    private z_MatrixMultfEXT_adr := GetProcAddress('glMatrixMultfEXT');
    private z_MatrixMultfEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: single)>(z_MatrixMultfEXT_adr);
    private z_MatrixMultfEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultfEXT_ovr_0(mode, m[0]) else
      z_MatrixMultfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultfEXT_ovr_0(mode, m);
    private z_MatrixMultfEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultfEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultfEXT_ovr_2(mode, m);
    
    private z_MatrixMultdEXT_adr := GetProcAddress('glMatrixMultdEXT');
    private z_MatrixMultdEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; var m: real)>(z_MatrixMultdEXT_adr);
    private z_MatrixMultdEXT_ovr_0_anh001 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultdEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultdEXT_ovr_0(mode, m[0]) else
      z_MatrixMultdEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultdEXT_ovr_0(mode, m);
    private z_MatrixMultdEXT_ovr_2 := GetProcOrNil&<procedure(mode: MatrixMode; m: IntPtr)>(z_MatrixMultdEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultdEXT_ovr_2(mode, m);
    
    private z_MatrixOrthoEXT_adr := GetProcAddress('glMatrixOrthoEXT');
    private z_MatrixOrthoEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real)>(z_MatrixOrthoEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixOrthoEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixOrthoEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private z_MatrixPopEXT_adr := GetProcAddress('glMatrixPopEXT');
    private z_MatrixPopEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode)>(z_MatrixPopEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPopEXT(mode: MatrixMode) :=
    z_MatrixPopEXT_ovr_0(mode);
    
    private z_MatrixPushEXT_adr := GetProcAddress('glMatrixPushEXT');
    private z_MatrixPushEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode)>(z_MatrixPushEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPushEXT(mode: MatrixMode) :=
    z_MatrixPushEXT_ovr_0(mode);
    
    private z_MatrixRotatefEXT_adr := GetProcAddress('glMatrixRotatefEXT');
    private z_MatrixRotatefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; angle: single; x: single; y: single; z: single)>(z_MatrixRotatefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatefEXT(mode: MatrixMode; angle: single; x: single; y: single; z: single) :=
    z_MatrixRotatefEXT_ovr_0(mode, angle, x, y, z);
    
    private z_MatrixRotatedEXT_adr := GetProcAddress('glMatrixRotatedEXT');
    private z_MatrixRotatedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; angle: real; x: real; y: real; z: real)>(z_MatrixRotatedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatedEXT(mode: MatrixMode; angle: real; x: real; y: real; z: real) :=
    z_MatrixRotatedEXT_ovr_0(mode, angle, x, y, z);
    
    private z_MatrixScalefEXT_adr := GetProcAddress('glMatrixScalefEXT');
    private z_MatrixScalefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: single; y: single; z: single)>(z_MatrixScalefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScalefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixScalefEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixScaledEXT_adr := GetProcAddress('glMatrixScaledEXT');
    private z_MatrixScaledEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: real; y: real; z: real)>(z_MatrixScaledEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScaledEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixScaledEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixTranslatefEXT_adr := GetProcAddress('glMatrixTranslatefEXT');
    private z_MatrixTranslatefEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: single; y: single; z: single)>(z_MatrixTranslatefEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixTranslatefEXT_ovr_0(mode, x, y, z);
    
    private z_MatrixTranslatedEXT_adr := GetProcAddress('glMatrixTranslatedEXT');
    private z_MatrixTranslatedEXT_ovr_0 := GetProcOrNil&<procedure(mode: MatrixMode; x: real; y: real; z: real)>(z_MatrixTranslatedEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatedEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixTranslatedEXT_ovr_0(mode, x, y, z);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPixelDataRangeNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_pixel_data_range';
    
    private z_PixelDataRangeNV_adr := GetProcAddress('glPixelDataRangeNV');
    private z_PixelDataRangeNV_ovr_0 := GetProcOrNil&<procedure(target: PixelDataRangeTargetNV; length: Int32; pointer: IntPtr)>(z_PixelDataRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelDataRangeNV(target: PixelDataRangeTargetNV; length: Int32; pointer: IntPtr) :=
    z_PixelDataRangeNV_ovr_0(target, length, pointer);
    
    private z_FlushPixelDataRangeNV_adr := GetProcAddress('glFlushPixelDataRangeNV');
    private z_FlushPixelDataRangeNV_ovr_0 := GetProcOrNil&<procedure(target: PixelDataRangeTargetNV)>(z_FlushPixelDataRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushPixelDataRangeNV(target: PixelDataRangeTargetNV) :=
    z_FlushPixelDataRangeNV_ovr_0(target);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPointSpriteNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_point_sprite';
    
    private z_PointParameteriNV_adr := GetProcAddress('glPointParameteriNV');
    private z_PointParameteriNV_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; param: Int32)>(z_PointParameteriNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriNV(pname: PointParameterNameARB; param: Int32) :=
    z_PointParameteriNV_ovr_0(pname, param);
    
    private z_PointParameterivNV_adr := GetProcAddress('glPointParameterivNV');
    private z_PointParameterivNV_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: Int32)>(z_PointParameterivNV_adr);
    private z_PointParameterivNV_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterivNV(pname: PointParameterNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterivNV_ovr_0(pname, &params[0]) else
      z_PointParameterivNV_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterivNV(pname: PointParameterNameARB; var &params: Int32) :=
    z_PointParameterivNV_ovr_0(pname, &params);
    private z_PointParameterivNV_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterivNV(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterivNV_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPresentVideoNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_present_video';
    
    private z_PresentFrameKeyedNV_adr := GetProcAddress('glPresentFrameKeyedNV');
    private z_PresentFrameKeyedNV_ovr_0 := GetProcOrNil&<procedure(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; key0: UInt32; target1: DummyEnum; fill1: UInt32; key1: UInt32)>(z_PresentFrameKeyedNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PresentFrameKeyedNV(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; key0: UInt32; target1: DummyEnum; fill1: UInt32; key1: UInt32) :=
    z_PresentFrameKeyedNV_ovr_0(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, &type, target0, fill0, key0, target1, fill1, key1);
    
    private z_PresentFrameDualFillNV_adr := GetProcAddress('glPresentFrameDualFillNV');
    private z_PresentFrameDualFillNV_ovr_0 := GetProcOrNil&<procedure(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; target1: DummyEnum; fill1: UInt32; target2: DummyEnum; fill2: UInt32; target3: DummyEnum; fill3: UInt32)>(z_PresentFrameDualFillNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PresentFrameDualFillNV(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; target1: DummyEnum; fill1: UInt32; target2: DummyEnum; fill2: UInt32; target3: DummyEnum; fill3: UInt32) :=
    z_PresentFrameDualFillNV_ovr_0(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, &type, target0, fill0, target1, fill1, target2, fill2, target3, fill3);
    
    private z_GetVideoivNV_adr := GetProcAddress('glGetVideoivNV');
    private z_GetVideoivNV_ovr_0 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; var &params: Int32)>(z_GetVideoivNV_adr);
    private z_GetVideoivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoivNV(video_slot: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoivNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideoivNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoivNV(video_slot: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetVideoivNV_ovr_0(video_slot, pname, &params);
    private z_GetVideoivNV_ovr_2 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoivNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoivNV_ovr_2(video_slot, pname, &params);
    
    private z_GetVideouivNV_adr := GetProcAddress('glGetVideouivNV');
    private z_GetVideouivNV_ovr_0 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; var &params: UInt32)>(z_GetVideouivNV_adr);
    private z_GetVideouivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideouivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideouivNV(video_slot: UInt32; pname: DummyEnum; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideouivNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideouivNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideouivNV(video_slot: UInt32; pname: DummyEnum; var &params: UInt32) :=
    z_GetVideouivNV_ovr_0(video_slot, pname, &params);
    private z_GetVideouivNV_ovr_2 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideouivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideouivNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideouivNV_ovr_2(video_slot, pname, &params);
    
    private z_GetVideoi64vNV_adr := GetProcAddress('glGetVideoi64vNV');
    private z_GetVideoi64vNV_ovr_0 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; var &params: Int64)>(z_GetVideoi64vNV_adr);
    private z_GetVideoi64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoi64vNV(video_slot: UInt32; pname: DummyEnum; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoi64vNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideoi64vNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoi64vNV(video_slot: UInt32; pname: DummyEnum; var &params: Int64) :=
    z_GetVideoi64vNV_ovr_0(video_slot, pname, &params);
    private z_GetVideoi64vNV_ovr_2 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoi64vNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoi64vNV_ovr_2(video_slot, pname, &params);
    
    private z_GetVideoui64vNV_adr := GetProcAddress('glGetVideoui64vNV');
    private z_GetVideoui64vNV_ovr_0 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; var &params: UInt64)>(z_GetVideoui64vNV_adr);
    private z_GetVideoui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoui64vNV(video_slot: UInt32; pname: DummyEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoui64vNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideoui64vNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoui64vNV(video_slot: UInt32; pname: DummyEnum; var &params: UInt64) :=
    z_GetVideoui64vNV_ovr_0(video_slot, pname, &params);
    private z_GetVideoui64vNV_ovr_2 := GetProcOrNil&<procedure(video_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoui64vNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoui64vNV_ovr_2(video_slot, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPrimitiveRestartNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_primitive_restart';
    
    private z_PrimitiveRestartNV_adr := GetProcAddress('glPrimitiveRestartNV');
    private z_PrimitiveRestartNV_ovr_0 := GetProcOrNil&<procedure>(z_PrimitiveRestartNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveRestartNV :=
    z_PrimitiveRestartNV_ovr_0;
    
    private z_PrimitiveRestartIndexNV_adr := GetProcAddress('glPrimitiveRestartIndexNV');
    private z_PrimitiveRestartIndexNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32)>(z_PrimitiveRestartIndexNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveRestartIndexNV(index: UInt32) :=
    z_PrimitiveRestartIndexNV_ovr_0(index);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glQueryResourceNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_query_resource';
    
    private z_QueryResourceNV_adr := GetProcAddress('glQueryResourceNV');
    private z_QueryResourceNV_ovr_0 := GetProcOrNil&<function(queryType: DummyEnum; tagId: Int32; count: UInt32; var buffer: Int32): Int32>(z_QueryResourceNV_adr);
    private z_QueryResourceNV_ovr_0_anh00001 := GetProcOrNil&<function(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: IntPtr): Int32>(z_QueryResourceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryResourceNV(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: array of Int32): Int32 :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_QueryResourceNV_ovr_0(queryType, tagId, count, buffer[0]) else
      z_QueryResourceNV_ovr_0_anh00001(queryType, tagId, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryResourceNV(queryType: DummyEnum; tagId: Int32; count: UInt32; var buffer: Int32): Int32 :=
    z_QueryResourceNV_ovr_0(queryType, tagId, count, buffer);
    private z_QueryResourceNV_ovr_2 := GetProcOrNil&<function(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: IntPtr): Int32>(z_QueryResourceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryResourceNV(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: IntPtr): Int32 :=
    z_QueryResourceNV_ovr_2(queryType, tagId, count, buffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glQueryResourceTagNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_query_resource_tag';
    
    private z_GenQueryResourceTagNV_adr := GetProcAddress('glGenQueryResourceTagNV');
    private z_GenQueryResourceTagNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var tagIds: Int32)>(z_GenQueryResourceTagNV_adr);
    private z_GenQueryResourceTagNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; tagIds: IntPtr)>(z_GenQueryResourceTagNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueryResourceTagNV(n: Int32; tagIds: array of Int32) :=
    if (tagIds<>nil) and (tagIds.Length<>0) then
      z_GenQueryResourceTagNV_ovr_0(n, tagIds[0]) else
      z_GenQueryResourceTagNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueryResourceTagNV(n: Int32; var tagIds: Int32) :=
    z_GenQueryResourceTagNV_ovr_0(n, tagIds);
    private z_GenQueryResourceTagNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; tagIds: IntPtr)>(z_GenQueryResourceTagNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueryResourceTagNV(n: Int32; tagIds: IntPtr) :=
    z_GenQueryResourceTagNV_ovr_2(n, tagIds);
    
    private z_DeleteQueryResourceTagNV_adr := GetProcAddress('glDeleteQueryResourceTagNV');
    private z_DeleteQueryResourceTagNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var tagIds: Int32)>(z_DeleteQueryResourceTagNV_adr);
    private z_DeleteQueryResourceTagNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; tagIds: IntPtr)>(z_DeleteQueryResourceTagNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueryResourceTagNV(n: Int32; tagIds: array of Int32) :=
    if (tagIds<>nil) and (tagIds.Length<>0) then
      z_DeleteQueryResourceTagNV_ovr_0(n, tagIds[0]) else
      z_DeleteQueryResourceTagNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueryResourceTagNV(n: Int32; var tagIds: Int32) :=
    z_DeleteQueryResourceTagNV_ovr_0(n, tagIds);
    private z_DeleteQueryResourceTagNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; tagIds: IntPtr)>(z_DeleteQueryResourceTagNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueryResourceTagNV(n: Int32; tagIds: IntPtr) :=
    z_DeleteQueryResourceTagNV_ovr_2(n, tagIds);
    
    private z_QueryResourceTagNV_adr := GetProcAddress('glQueryResourceTagNV');
    private z_QueryResourceTagNV_ovr_0 := GetProcOrNil&<procedure(tagId: Int32; tagString: IntPtr)>(z_QueryResourceTagNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryResourceTagNV(tagId: Int32; tagString: string);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(tagString);
        z_QueryResourceTagNV_ovr_0(tagId, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryResourceTagNV(tagId: Int32; tagString: IntPtr) :=
    z_QueryResourceTagNV_ovr_0(tagId, tagString);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glRegisterCombinersNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_register_combiners';
    
    private z_CombinerParameterfvNV_adr := GetProcAddress('glCombinerParameterfvNV');
    private z_CombinerParameterfvNV_ovr_0 := GetProcOrNil&<procedure(pname: CombinerParameterNV; var &params: single)>(z_CombinerParameterfvNV_adr);
    private z_CombinerParameterfvNV_ovr_0_anh001 := GetProcOrNil&<procedure(pname: CombinerParameterNV; &params: IntPtr)>(z_CombinerParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfvNV(pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CombinerParameterfvNV_ovr_0(pname, &params[0]) else
      z_CombinerParameterfvNV_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfvNV(pname: CombinerParameterNV; var &params: single) :=
    z_CombinerParameterfvNV_ovr_0(pname, &params);
    private z_CombinerParameterfvNV_ovr_2 := GetProcOrNil&<procedure(pname: CombinerParameterNV; &params: IntPtr)>(z_CombinerParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfvNV(pname: CombinerParameterNV; &params: IntPtr) :=
    z_CombinerParameterfvNV_ovr_2(pname, &params);
    
    private z_CombinerParameterfNV_adr := GetProcAddress('glCombinerParameterfNV');
    private z_CombinerParameterfNV_ovr_0 := GetProcOrNil&<procedure(pname: CombinerParameterNV; param: single)>(z_CombinerParameterfNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfNV(pname: CombinerParameterNV; param: single) :=
    z_CombinerParameterfNV_ovr_0(pname, param);
    
    private z_CombinerParameterivNV_adr := GetProcAddress('glCombinerParameterivNV');
    private z_CombinerParameterivNV_ovr_0 := GetProcOrNil&<procedure(pname: CombinerParameterNV; var &params: Int32)>(z_CombinerParameterivNV_adr);
    private z_CombinerParameterivNV_ovr_0_anh001 := GetProcOrNil&<procedure(pname: CombinerParameterNV; &params: IntPtr)>(z_CombinerParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterivNV(pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CombinerParameterivNV_ovr_0(pname, &params[0]) else
      z_CombinerParameterivNV_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterivNV(pname: CombinerParameterNV; var &params: Int32) :=
    z_CombinerParameterivNV_ovr_0(pname, &params);
    private z_CombinerParameterivNV_ovr_2 := GetProcOrNil&<procedure(pname: CombinerParameterNV; &params: IntPtr)>(z_CombinerParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterivNV(pname: CombinerParameterNV; &params: IntPtr) :=
    z_CombinerParameterivNV_ovr_2(pname, &params);
    
    private z_CombinerParameteriNV_adr := GetProcAddress('glCombinerParameteriNV');
    private z_CombinerParameteriNV_ovr_0 := GetProcOrNil&<procedure(pname: CombinerParameterNV; param: Int32)>(z_CombinerParameteriNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameteriNV(pname: CombinerParameterNV; param: Int32) :=
    z_CombinerParameteriNV_ovr_0(pname, param);
    
    private z_CombinerInputNV_adr := GetProcAddress('glCombinerInputNV');
    private z_CombinerInputNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV)>(z_CombinerInputNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerInputNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV) :=
    z_CombinerInputNV_ovr_0(stage, portion, variable, input, mapping, componentUsage);
    
    private z_CombinerOutputNV_adr := GetProcAddress('glCombinerOutputNV');
    private z_CombinerOutputNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; abOutput: CombinerRegisterNV; cdOutput: CombinerRegisterNV; sumOutput: CombinerRegisterNV; scale: CombinerScaleNV; bias: CombinerBiasNV; abDotProduct: boolean; cdDotProduct: boolean; muxSum: boolean)>(z_CombinerOutputNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerOutputNV(stage: CombinerStageNV; portion: CombinerPortionNV; abOutput: CombinerRegisterNV; cdOutput: CombinerRegisterNV; sumOutput: CombinerRegisterNV; scale: CombinerScaleNV; bias: CombinerBiasNV; abDotProduct: boolean; cdDotProduct: boolean; muxSum: boolean) :=
    z_CombinerOutputNV_ovr_0(stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
    
    private z_FinalCombinerInputNV_adr := GetProcAddress('glFinalCombinerInputNV');
    private z_FinalCombinerInputNV_ovr_0 := GetProcOrNil&<procedure(variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV)>(z_FinalCombinerInputNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinalCombinerInputNV(variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV) :=
    z_FinalCombinerInputNV_ovr_0(variable, input, mapping, componentUsage);
    
    private z_GetCombinerInputParameterfvNV_adr := GetProcAddress('glGetCombinerInputParameterfvNV');
    private z_GetCombinerInputParameterfvNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single)>(z_GetCombinerInputParameterfvNV_adr);
    private z_GetCombinerInputParameterfvNV_ovr_0_anh000001 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerInputParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerInputParameterfvNV_ovr_0(stage, portion, variable, pname, &params[0]) else
      z_GetCombinerInputParameterfvNV_ovr_0_anh000001(stage, portion, variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetCombinerInputParameterfvNV_ovr_0(stage, portion, variable, pname, &params);
    private z_GetCombinerInputParameterfvNV_ovr_2 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerInputParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerInputParameterfvNV_ovr_2(stage, portion, variable, pname, &params);
    
    private z_GetCombinerInputParameterivNV_adr := GetProcAddress('glGetCombinerInputParameterivNV');
    private z_GetCombinerInputParameterivNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32)>(z_GetCombinerInputParameterivNV_adr);
    private z_GetCombinerInputParameterivNV_ovr_0_anh000001 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerInputParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerInputParameterivNV_ovr_0(stage, portion, variable, pname, &params[0]) else
      z_GetCombinerInputParameterivNV_ovr_0_anh000001(stage, portion, variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32) :=
    z_GetCombinerInputParameterivNV_ovr_0(stage, portion, variable, pname, &params);
    private z_GetCombinerInputParameterivNV_ovr_2 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerInputParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerInputParameterivNV_ovr_2(stage, portion, variable, pname, &params);
    
    private z_GetCombinerOutputParameterfvNV_adr := GetProcAddress('glGetCombinerOutputParameterfvNV');
    private z_GetCombinerOutputParameterfvNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: single)>(z_GetCombinerOutputParameterfvNV_adr);
    private z_GetCombinerOutputParameterfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerOutputParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerOutputParameterfvNV_ovr_0(stage, portion, pname, &params[0]) else
      z_GetCombinerOutputParameterfvNV_ovr_0_anh00001(stage, portion, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetCombinerOutputParameterfvNV_ovr_0(stage, portion, pname, &params);
    private z_GetCombinerOutputParameterfvNV_ovr_2 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerOutputParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerOutputParameterfvNV_ovr_2(stage, portion, pname, &params);
    
    private z_GetCombinerOutputParameterivNV_adr := GetProcAddress('glGetCombinerOutputParameterivNV');
    private z_GetCombinerOutputParameterivNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: Int32)>(z_GetCombinerOutputParameterivNV_adr);
    private z_GetCombinerOutputParameterivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerOutputParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerOutputParameterivNV_ovr_0(stage, portion, pname, &params[0]) else
      z_GetCombinerOutputParameterivNV_ovr_0_anh00001(stage, portion, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: Int32) :=
    z_GetCombinerOutputParameterivNV_ovr_0(stage, portion, pname, &params);
    private z_GetCombinerOutputParameterivNV_ovr_2 := GetProcOrNil&<procedure(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerOutputParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerOutputParameterivNV_ovr_2(stage, portion, pname, &params);
    
    private z_GetFinalCombinerInputParameterfvNV_adr := GetProcAddress('glGetFinalCombinerInputParameterfvNV');
    private z_GetFinalCombinerInputParameterfvNV_ovr_0 := GetProcOrNil&<procedure(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single)>(z_GetFinalCombinerInputParameterfvNV_adr);
    private z_GetFinalCombinerInputParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetFinalCombinerInputParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterfvNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFinalCombinerInputParameterfvNV_ovr_0(variable, pname, &params[0]) else
      z_GetFinalCombinerInputParameterfvNV_ovr_0_anh0001(variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterfvNV(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetFinalCombinerInputParameterfvNV_ovr_0(variable, pname, &params);
    private z_GetFinalCombinerInputParameterfvNV_ovr_2 := GetProcOrNil&<procedure(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetFinalCombinerInputParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterfvNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetFinalCombinerInputParameterfvNV_ovr_2(variable, pname, &params);
    
    private z_GetFinalCombinerInputParameterivNV_adr := GetProcAddress('glGetFinalCombinerInputParameterivNV');
    private z_GetFinalCombinerInputParameterivNV_ovr_0 := GetProcOrNil&<procedure(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32)>(z_GetFinalCombinerInputParameterivNV_adr);
    private z_GetFinalCombinerInputParameterivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetFinalCombinerInputParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterivNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFinalCombinerInputParameterivNV_ovr_0(variable, pname, &params[0]) else
      z_GetFinalCombinerInputParameterivNV_ovr_0_anh0001(variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterivNV(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32) :=
    z_GetFinalCombinerInputParameterivNV_ovr_0(variable, pname, &params);
    private z_GetFinalCombinerInputParameterivNV_ovr_2 := GetProcOrNil&<procedure(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetFinalCombinerInputParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterivNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetFinalCombinerInputParameterivNV_ovr_2(variable, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glRegisterCombiners2NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_register_combiners2';
    
    private z_CombinerStageParameterfvNV_adr := GetProcAddress('glCombinerStageParameterfvNV');
    private z_CombinerStageParameterfvNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single)>(z_CombinerStageParameterfvNV_adr);
    private z_CombinerStageParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr)>(z_CombinerStageParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CombinerStageParameterfvNV_ovr_0(stage, pname, &params[0]) else
      z_CombinerStageParameterfvNV_ovr_0_anh0001(stage, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single) :=
    z_CombinerStageParameterfvNV_ovr_0(stage, pname, &params);
    private z_CombinerStageParameterfvNV_ovr_2 := GetProcOrNil&<procedure(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr)>(z_CombinerStageParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_CombinerStageParameterfvNV_ovr_2(stage, pname, &params);
    
    private z_GetCombinerStageParameterfvNV_adr := GetProcAddress('glGetCombinerStageParameterfvNV');
    private z_GetCombinerStageParameterfvNV_ovr_0 := GetProcOrNil&<procedure(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single)>(z_GetCombinerStageParameterfvNV_adr);
    private z_GetCombinerStageParameterfvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerStageParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerStageParameterfvNV_ovr_0(stage, pname, &params[0]) else
      z_GetCombinerStageParameterfvNV_ovr_0_anh0001(stage, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetCombinerStageParameterfvNV_ovr_0(stage, pname, &params);
    private z_GetCombinerStageParameterfvNV_ovr_2 := GetProcOrNil&<procedure(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr)>(z_GetCombinerStageParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerStageParameterfvNV_ovr_2(stage, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSampleLocationsNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_sample_locations';
    
    private z_FramebufferSampleLocationsfvNV_adr := GetProcAddress('glFramebufferSampleLocationsfvNV');
    private z_FramebufferSampleLocationsfvNV_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; start: UInt32; count: Int32; var v: single)>(z_FramebufferSampleLocationsfvNV_adr);
    private z_FramebufferSampleLocationsfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr)>(z_FramebufferSampleLocationsfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvNV(target: FramebufferTarget; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_FramebufferSampleLocationsfvNV_ovr_0(target, start, count, v[0]) else
      z_FramebufferSampleLocationsfvNV_ovr_0_anh00001(target, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvNV(target: FramebufferTarget; start: UInt32; count: Int32; var v: single) :=
    z_FramebufferSampleLocationsfvNV_ovr_0(target, start, count, v);
    private z_FramebufferSampleLocationsfvNV_ovr_2 := GetProcOrNil&<procedure(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr)>(z_FramebufferSampleLocationsfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvNV(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr) :=
    z_FramebufferSampleLocationsfvNV_ovr_2(target, start, count, v);
    
    private z_NamedFramebufferSampleLocationsfvNV_adr := GetProcAddress('glNamedFramebufferSampleLocationsfvNV');
    private z_NamedFramebufferSampleLocationsfvNV_ovr_0 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; start: UInt32; count: Int32; var v: single)>(z_NamedFramebufferSampleLocationsfvNV_adr);
    private z_NamedFramebufferSampleLocationsfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr)>(z_NamedFramebufferSampleLocationsfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvNV(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_NamedFramebufferSampleLocationsfvNV_ovr_0(framebuffer, start, count, v[0]) else
      z_NamedFramebufferSampleLocationsfvNV_ovr_0_anh00001(framebuffer, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvNV(framebuffer: gl_framebuffer; start: UInt32; count: Int32; var v: single) :=
    z_NamedFramebufferSampleLocationsfvNV_ovr_0(framebuffer, start, count, v);
    private z_NamedFramebufferSampleLocationsfvNV_ovr_2 := GetProcOrNil&<procedure(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr)>(z_NamedFramebufferSampleLocationsfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvNV(framebuffer: gl_framebuffer; start: UInt32; count: Int32; v: IntPtr) :=
    z_NamedFramebufferSampleLocationsfvNV_ovr_2(framebuffer, start, count, v);
    
    private z_ResolveDepthValuesNV_adr := GetProcAddress('glResolveDepthValuesNV');
    private z_ResolveDepthValuesNV_ovr_0 := GetProcOrNil&<procedure>(z_ResolveDepthValuesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResolveDepthValuesNV :=
    z_ResolveDepthValuesNV_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glScissorExclusiveNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_scissor_exclusive';
    
    private z_ScissorExclusiveNV_adr := GetProcAddress('glScissorExclusiveNV');
    private z_ScissorExclusiveNV_ovr_0 := GetProcOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32)>(z_ScissorExclusiveNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveNV(x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_ScissorExclusiveNV_ovr_0(x, y, width, height);
    
    private z_ScissorExclusiveArrayvNV_adr := GetProcAddress('glScissorExclusiveArrayvNV');
    private z_ScissorExclusiveArrayvNV_ovr_0 := GetProcOrNil&<procedure(first: UInt32; count: Int32; var v: Int32)>(z_ScissorExclusiveArrayvNV_adr);
    private z_ScissorExclusiveArrayvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorExclusiveArrayvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveArrayvNV(first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorExclusiveArrayvNV_ovr_0(first, count, v[0]) else
      z_ScissorExclusiveArrayvNV_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveArrayvNV(first: UInt32; count: Int32; var v: Int32) :=
    z_ScissorExclusiveArrayvNV_ovr_0(first, count, v);
    private z_ScissorExclusiveArrayvNV_ovr_2 := GetProcOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorExclusiveArrayvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveArrayvNV(first: UInt32; count: Int32; v: IntPtr) :=
    z_ScissorExclusiveArrayvNV_ovr_2(first, count, v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShaderBufferLoadNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_shader_buffer_load';
    
    private z_MakeBufferResidentNV_adr := GetProcAddress('glMakeBufferResidentNV');
    private z_MakeBufferResidentNV_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; access: DummyEnum)>(z_MakeBufferResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeBufferResidentNV(target: DummyEnum; access: DummyEnum) :=
    z_MakeBufferResidentNV_ovr_0(target, access);
    
    private z_MakeBufferNonResidentNV_adr := GetProcAddress('glMakeBufferNonResidentNV');
    private z_MakeBufferNonResidentNV_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum)>(z_MakeBufferNonResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeBufferNonResidentNV(target: DummyEnum) :=
    z_MakeBufferNonResidentNV_ovr_0(target);
    
    private z_IsBufferResidentNV_adr := GetProcAddress('glIsBufferResidentNV');
    private z_IsBufferResidentNV_ovr_0 := GetProcOrNil&<function(target: DummyEnum): boolean>(z_IsBufferResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsBufferResidentNV(target: DummyEnum): boolean :=
    z_IsBufferResidentNV_ovr_0(target);
    
    private z_MakeNamedBufferResidentNV_adr := GetProcAddress('glMakeNamedBufferResidentNV');
    private z_MakeNamedBufferResidentNV_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; access: DummyEnum)>(z_MakeNamedBufferResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeNamedBufferResidentNV(buffer: gl_buffer; access: DummyEnum) :=
    z_MakeNamedBufferResidentNV_ovr_0(buffer, access);
    
    private z_MakeNamedBufferNonResidentNV_adr := GetProcAddress('glMakeNamedBufferNonResidentNV');
    private z_MakeNamedBufferNonResidentNV_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer)>(z_MakeNamedBufferNonResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeNamedBufferNonResidentNV(buffer: gl_buffer) :=
    z_MakeNamedBufferNonResidentNV_ovr_0(buffer);
    
    private z_IsNamedBufferResidentNV_adr := GetProcAddress('glIsNamedBufferResidentNV');
    private z_IsNamedBufferResidentNV_ovr_0 := GetProcOrNil&<function(buffer: gl_buffer): boolean>(z_IsNamedBufferResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNamedBufferResidentNV(buffer: gl_buffer): boolean :=
    z_IsNamedBufferResidentNV_ovr_0(buffer);
    
    private z_GetBufferParameterui64vNV_adr := GetProcAddress('glGetBufferParameterui64vNV');
    private z_GetBufferParameterui64vNV_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; pname: DummyEnum; var &params: UInt64)>(z_GetBufferParameterui64vNV_adr);
    private z_GetBufferParameterui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: BufferTarget; pname: DummyEnum; &params: IntPtr)>(z_GetBufferParameterui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterui64vNV(target: BufferTarget; pname: DummyEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameterui64vNV_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameterui64vNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterui64vNV(target: BufferTarget; pname: DummyEnum; var &params: UInt64) :=
    z_GetBufferParameterui64vNV_ovr_0(target, pname, &params);
    private z_GetBufferParameterui64vNV_ovr_2 := GetProcOrNil&<procedure(target: BufferTarget; pname: DummyEnum; &params: IntPtr)>(z_GetBufferParameterui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterui64vNV(target: BufferTarget; pname: DummyEnum; &params: IntPtr) :=
    z_GetBufferParameterui64vNV_ovr_2(target, pname, &params);
    
    private z_GetNamedBufferParameterui64vNV_adr := GetProcAddress('glGetNamedBufferParameterui64vNV');
    private z_GetNamedBufferParameterui64vNV_ovr_0 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; var &params: UInt64)>(z_GetNamedBufferParameterui64vNV_adr);
    private z_GetNamedBufferParameterui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameterui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterui64vNV(buffer: gl_buffer; pname: BufferPNameARB; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameterui64vNV_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameterui64vNV_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterui64vNV(buffer: gl_buffer; pname: BufferPNameARB; var &params: UInt64) :=
    z_GetNamedBufferParameterui64vNV_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameterui64vNV_ovr_2 := GetProcOrNil&<procedure(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr)>(z_GetNamedBufferParameterui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterui64vNV(buffer: gl_buffer; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetNamedBufferParameterui64vNV_ovr_2(buffer, pname, &params);
    
    private z_GetIntegerui64vNV_adr := GetProcAddress('glGetIntegerui64vNV');
    private z_GetIntegerui64vNV_ovr_0 := GetProcOrNil&<procedure(value: DummyEnum; var result: UInt64)>(z_GetIntegerui64vNV_adr);
    private z_GetIntegerui64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(value: DummyEnum; result: IntPtr)>(z_GetIntegerui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64vNV(value: DummyEnum; result: array of UInt64) :=
    if (result<>nil) and (result.Length<>0) then
      z_GetIntegerui64vNV_ovr_0(value, result[0]) else
      z_GetIntegerui64vNV_ovr_0_anh001(value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64vNV(value: DummyEnum; var result: UInt64) :=
    z_GetIntegerui64vNV_ovr_0(value, result);
    private z_GetIntegerui64vNV_ovr_2 := GetProcOrNil&<procedure(value: DummyEnum; result: IntPtr)>(z_GetIntegerui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64vNV(value: DummyEnum; result: IntPtr) :=
    z_GetIntegerui64vNV_ovr_2(value, result);
    
    private z_Uniformui64NV_adr := GetProcAddress('glUniformui64NV');
    private z_Uniformui64NV_ovr_0 := GetProcOrNil&<procedure(location: Int32; value: UInt64)>(z_Uniformui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64NV(location: Int32; value: UInt64) :=
    z_Uniformui64NV_ovr_0(location, value);
    
    private z_Uniformui64vNV_adr := GetProcAddress('glUniformui64vNV');
    private z_Uniformui64vNV_ovr_0 := GetProcOrNil&<procedure(location: Int32; count: Int32; var value: UInt64)>(z_Uniformui64vNV_adr);
    private z_Uniformui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniformui64vNV_ovr_0(location, count, value[0]) else
      z_Uniformui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniformui64vNV_ovr_0(location, count, value);
    private z_Uniformui64vNV_ovr_2 := GetProcOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniformui64vNV_ovr_2(location, count, value);
    
    private z_GetUniformui64vNV_adr := GetProcAddress('glGetUniformui64vNV');
    private z_GetUniformui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; var &params: UInt64)>(z_GetUniformui64vNV_adr);
    private z_GetUniformui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: gl_program; location: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformui64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformui64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: gl_program; location: Int32; var &params: UInt64) :=
    z_GetUniformui64vNV_ovr_0(&program, location, &params);
    private z_GetUniformui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; &params: IntPtr)>(z_GetUniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: gl_program; location: Int32; &params: IntPtr) :=
    z_GetUniformui64vNV_ovr_2(&program, location, &params);
    
    private z_ProgramUniformui64NV_adr := GetProcAddress('glProgramUniformui64NV');
    private z_ProgramUniformui64NV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; value: UInt64)>(z_ProgramUniformui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64NV(&program: gl_program; location: Int32; value: UInt64) :=
    z_ProgramUniformui64NV_ovr_0(&program, location, value);
    
    private z_ProgramUniformui64vNV_adr := GetProcAddress('glProgramUniformui64vNV');
    private z_ProgramUniformui64vNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; var value: UInt64)>(z_ProgramUniformui64vNV_adr);
    private z_ProgramUniformui64vNV_ovr_0_anh00001 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64vNV(&program: gl_program; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniformui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64vNV(&program: gl_program; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniformui64vNV_ovr_0(&program, location, count, value);
    private z_ProgramUniformui64vNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniformui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64vNV(&program: gl_program; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniformui64vNV_ovr_2(&program, location, count, value);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glShadingRateImageNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_shading_rate_image';
    
    private z_BindShadingRateImageNV_adr := GetProcAddress('glBindShadingRateImageNV');
    private z_BindShadingRateImageNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture)>(z_BindShadingRateImageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindShadingRateImageNV(texture: gl_texture) :=
    z_BindShadingRateImageNV_ovr_0(texture);
    
    private z_GetShadingRateImagePaletteNV_adr := GetProcAddress('glGetShadingRateImagePaletteNV');
    private z_GetShadingRateImagePaletteNV_ovr_0 := GetProcOrNil&<procedure(viewport: UInt32; entry: UInt32; var rate: DummyEnum)>(z_GetShadingRateImagePaletteNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateImagePaletteNV(viewport: UInt32; entry: UInt32; var rate: DummyEnum) :=
    z_GetShadingRateImagePaletteNV_ovr_0(viewport, entry, rate);
    private z_GetShadingRateImagePaletteNV_ovr_1 := GetProcOrNil&<procedure(viewport: UInt32; entry: UInt32; rate: IntPtr)>(z_GetShadingRateImagePaletteNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateImagePaletteNV(viewport: UInt32; entry: UInt32; rate: IntPtr) :=
    z_GetShadingRateImagePaletteNV_ovr_1(viewport, entry, rate);
    
    private z_GetShadingRateSampleLocationivNV_adr := GetProcAddress('glGetShadingRateSampleLocationivNV');
    private z_GetShadingRateSampleLocationivNV_ovr_0 := GetProcOrNil&<procedure(rate: DummyEnum; samples: UInt32; index: UInt32; var location: Int32)>(z_GetShadingRateSampleLocationivNV_adr);
    private z_GetShadingRateSampleLocationivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(rate: DummyEnum; samples: UInt32; index: UInt32; location: IntPtr)>(z_GetShadingRateSampleLocationivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateSampleLocationivNV(rate: DummyEnum; samples: UInt32; index: UInt32; location: array of Int32) :=
    if (location<>nil) and (location.Length<>0) then
      z_GetShadingRateSampleLocationivNV_ovr_0(rate, samples, index, location[0]) else
      z_GetShadingRateSampleLocationivNV_ovr_0_anh00001(rate, samples, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateSampleLocationivNV(rate: DummyEnum; samples: UInt32; index: UInt32; var location: Int32) :=
    z_GetShadingRateSampleLocationivNV_ovr_0(rate, samples, index, location);
    private z_GetShadingRateSampleLocationivNV_ovr_2 := GetProcOrNil&<procedure(rate: DummyEnum; samples: UInt32; index: UInt32; location: IntPtr)>(z_GetShadingRateSampleLocationivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateSampleLocationivNV(rate: DummyEnum; samples: UInt32; index: UInt32; location: IntPtr) :=
    z_GetShadingRateSampleLocationivNV_ovr_2(rate, samples, index, location);
    
    private z_ShadingRateImageBarrierNV_adr := GetProcAddress('glShadingRateImageBarrierNV');
    private z_ShadingRateImageBarrierNV_ovr_0 := GetProcOrNil&<procedure(synchronize: boolean)>(z_ShadingRateImageBarrierNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImageBarrierNV(synchronize: boolean) :=
    z_ShadingRateImageBarrierNV_ovr_0(synchronize);
    
    private z_ShadingRateImagePaletteNV_adr := GetProcAddress('glShadingRateImagePaletteNV');
    private z_ShadingRateImagePaletteNV_ovr_0 := GetProcOrNil&<procedure(viewport: UInt32; first: UInt32; count: Int32; var rates: DummyEnum)>(z_ShadingRateImagePaletteNV_adr);
    private z_ShadingRateImagePaletteNV_ovr_0_anh00001 := GetProcOrNil&<procedure(viewport: UInt32; first: UInt32; count: Int32; rates: IntPtr)>(z_ShadingRateImagePaletteNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImagePaletteNV(viewport: UInt32; first: UInt32; count: Int32; rates: array of DummyEnum) :=
    if (rates<>nil) and (rates.Length<>0) then
      z_ShadingRateImagePaletteNV_ovr_0(viewport, first, count, rates[0]) else
      z_ShadingRateImagePaletteNV_ovr_0_anh00001(viewport, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImagePaletteNV(viewport: UInt32; first: UInt32; count: Int32; var rates: DummyEnum) :=
    z_ShadingRateImagePaletteNV_ovr_0(viewport, first, count, rates);
    private z_ShadingRateImagePaletteNV_ovr_2 := GetProcOrNil&<procedure(viewport: UInt32; first: UInt32; count: Int32; rates: IntPtr)>(z_ShadingRateImagePaletteNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImagePaletteNV(viewport: UInt32; first: UInt32; count: Int32; rates: IntPtr) :=
    z_ShadingRateImagePaletteNV_ovr_2(viewport, first, count, rates);
    
    private z_ShadingRateSampleOrderNV_adr := GetProcAddress('glShadingRateSampleOrderNV');
    private z_ShadingRateSampleOrderNV_ovr_0 := GetProcOrNil&<procedure(order: DummyEnum)>(z_ShadingRateSampleOrderNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderNV(order: DummyEnum) :=
    z_ShadingRateSampleOrderNV_ovr_0(order);
    
    private z_ShadingRateSampleOrderCustomNV_adr := GetProcAddress('glShadingRateSampleOrderCustomNV');
    private z_ShadingRateSampleOrderCustomNV_ovr_0 := GetProcOrNil&<procedure(rate: DummyEnum; samples: UInt32; var locations: Int32)>(z_ShadingRateSampleOrderCustomNV_adr);
    private z_ShadingRateSampleOrderCustomNV_ovr_0_anh0001 := GetProcOrNil&<procedure(rate: DummyEnum; samples: UInt32; locations: IntPtr)>(z_ShadingRateSampleOrderCustomNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderCustomNV(rate: DummyEnum; samples: UInt32; locations: array of Int32) :=
    if (locations<>nil) and (locations.Length<>0) then
      z_ShadingRateSampleOrderCustomNV_ovr_0(rate, samples, locations[0]) else
      z_ShadingRateSampleOrderCustomNV_ovr_0_anh0001(rate, samples, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderCustomNV(rate: DummyEnum; samples: UInt32; var locations: Int32) :=
    z_ShadingRateSampleOrderCustomNV_ovr_0(rate, samples, locations);
    private z_ShadingRateSampleOrderCustomNV_ovr_2 := GetProcOrNil&<procedure(rate: DummyEnum; samples: UInt32; locations: IntPtr)>(z_ShadingRateSampleOrderCustomNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderCustomNV(rate: DummyEnum; samples: UInt32; locations: IntPtr) :=
    z_ShadingRateSampleOrderCustomNV_ovr_2(rate, samples, locations);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureBarrierNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_texture_barrier';
    
    private z_TextureBarrierNV_adr := GetProcAddress('glTextureBarrierNV');
    private z_TextureBarrierNV_ovr_0 := GetProcOrNil&<procedure>(z_TextureBarrierNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBarrierNV :=
    z_TextureBarrierNV_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureMultisampleNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_texture_multisample';
    
    private z_TexImage2DMultisampleCoverageNV_adr := GetProcAddress('glTexImage2DMultisampleCoverageNV');
    private z_TexImage2DMultisampleCoverageNV_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean)>(z_TexImage2DMultisampleCoverageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2DMultisampleCoverageNV(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean) :=
    z_TexImage2DMultisampleCoverageNV_ovr_0(target, coverageSamples, colorSamples, internalFormat, width, height, fixedSampleLocations);
    
    private z_TexImage3DMultisampleCoverageNV_adr := GetProcAddress('glTexImage3DMultisampleCoverageNV');
    private z_TexImage3DMultisampleCoverageNV_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean)>(z_TexImage3DMultisampleCoverageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DMultisampleCoverageNV(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean) :=
    z_TexImage3DMultisampleCoverageNV_ovr_0(target, coverageSamples, colorSamples, internalFormat, width, height, depth, fixedSampleLocations);
    
    private z_TextureImage2DMultisampleNV_adr := GetProcAddress('glTextureImage2DMultisampleNV');
    private z_TextureImage2DMultisampleNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean)>(z_TextureImage2DMultisampleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage2DMultisampleNV(texture: gl_texture; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage2DMultisampleNV_ovr_0(texture, target, samples, internalFormat, width, height, fixedSampleLocations);
    
    private z_TextureImage3DMultisampleNV_adr := GetProcAddress('glTextureImage3DMultisampleNV');
    private z_TextureImage3DMultisampleNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean)>(z_TextureImage3DMultisampleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage3DMultisampleNV(texture: gl_texture; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage3DMultisampleNV_ovr_0(texture, target, samples, internalFormat, width, height, depth, fixedSampleLocations);
    
    private z_TextureImage2DMultisampleCoverageNV_adr := GetProcAddress('glTextureImage2DMultisampleCoverageNV');
    private z_TextureImage2DMultisampleCoverageNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean)>(z_TextureImage2DMultisampleCoverageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage2DMultisampleCoverageNV(texture: gl_texture; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage2DMultisampleCoverageNV_ovr_0(texture, target, coverageSamples, colorSamples, internalFormat, width, height, fixedSampleLocations);
    
    private z_TextureImage3DMultisampleCoverageNV_adr := GetProcAddress('glTextureImage3DMultisampleCoverageNV');
    private z_TextureImage3DMultisampleCoverageNV_ovr_0 := GetProcOrNil&<procedure(texture: gl_texture; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean)>(z_TextureImage3DMultisampleCoverageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage3DMultisampleCoverageNV(texture: gl_texture; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage3DMultisampleCoverageNV_ovr_0(texture, target, coverageSamples, colorSamples, internalFormat, width, height, depth, fixedSampleLocations);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransformFeedbackNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_transform_feedback';
    
    private z_BeginTransformFeedbackNV_adr := GetProcAddress('glBeginTransformFeedbackNV');
    private z_BeginTransformFeedbackNV_ovr_0 := GetProcOrNil&<procedure(primitiveMode: PrimitiveType)>(z_BeginTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginTransformFeedbackNV(primitiveMode: PrimitiveType) :=
    z_BeginTransformFeedbackNV_ovr_0(primitiveMode);
    
    private z_EndTransformFeedbackNV_adr := GetProcAddress('glEndTransformFeedbackNV');
    private z_EndTransformFeedbackNV_ovr_0 := GetProcOrNil&<procedure>(z_EndTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndTransformFeedbackNV :=
    z_EndTransformFeedbackNV_ovr_0;
    
    private z_TransformFeedbackAttribsNV_adr := GetProcAddress('glTransformFeedbackAttribsNV');
    private z_TransformFeedbackAttribsNV_ovr_0 := GetProcOrNil&<procedure(count: Int32; var attribs: Int32; bufferMode: DummyEnum)>(z_TransformFeedbackAttribsNV_adr);
    private z_TransformFeedbackAttribsNV_ovr_0_anh0010 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackAttribsNV(count: Int32; attribs: array of Int32; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      z_TransformFeedbackAttribsNV_ovr_0(count, attribs[0], bufferMode) else
      z_TransformFeedbackAttribsNV_ovr_0_anh0010(count, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackAttribsNV(count: Int32; var attribs: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackAttribsNV_ovr_0(count, attribs, bufferMode);
    private z_TransformFeedbackAttribsNV_ovr_2 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackAttribsNV(count: Int32; attribs: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackAttribsNV_ovr_2(count, attribs, bufferMode);
    
    private z_BindBufferRangeNV_adr := GetProcAddress('glBindBufferRangeNV');
    private z_BindBufferRangeNV_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr)>(z_BindBufferRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRangeNV(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRangeNV_ovr_0(target, index, buffer, offset, size);
    
    private z_BindBufferOffsetNV_adr := GetProcAddress('glBindBufferOffsetNV');
    private z_BindBufferOffsetNV_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr)>(z_BindBufferOffsetNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferOffsetNV(target: BufferTarget; index: UInt32; buffer: gl_buffer; offset: IntPtr) :=
    z_BindBufferOffsetNV_ovr_0(target, index, buffer, offset);
    
    private z_BindBufferBaseNV_adr := GetProcAddress('glBindBufferBaseNV');
    private z_BindBufferBaseNV_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; index: UInt32; buffer: gl_buffer)>(z_BindBufferBaseNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBaseNV(target: BufferTarget; index: UInt32; buffer: gl_buffer) :=
    z_BindBufferBaseNV_ovr_0(target, index, buffer);
    
    private z_TransformFeedbackVaryingsNV_adr := GetProcAddress('glTransformFeedbackVaryingsNV');
    private z_TransformFeedbackVaryingsNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; var locations: Int32; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsNV_adr);
    private z_TransformFeedbackVaryingsNV_ovr_0_anh00010 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; locations: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsNV(&program: gl_program; count: Int32; locations: array of Int32; bufferMode: DummyEnum) :=
    if (locations<>nil) and (locations.Length<>0) then
      z_TransformFeedbackVaryingsNV_ovr_0(&program, count, locations[0], bufferMode) else
      z_TransformFeedbackVaryingsNV_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsNV(&program: gl_program; count: Int32; var locations: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackVaryingsNV_ovr_0(&program, count, locations, bufferMode);
    private z_TransformFeedbackVaryingsNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; count: Int32; locations: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackVaryingsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsNV(&program: gl_program; count: Int32; locations: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackVaryingsNV_ovr_2(&program, count, locations, bufferMode);
    
    private z_ActiveVaryingNV_adr := GetProcAddress('glActiveVaryingNV');
    private z_ActiveVaryingNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; name: IntPtr)>(z_ActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveVaryingNV(&program: gl_program; name: string);
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        z_ActiveVaryingNV_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveVaryingNV(&program: gl_program; name: IntPtr) :=
    z_ActiveVaryingNV_ovr_0(&program, name);
    
    private z_GetVaryingLocationNV_adr := GetProcAddress('glGetVaryingLocationNV');
    private z_GetVaryingLocationNV_ovr_0 := GetProcOrNil&<function(&program: gl_program; name: IntPtr): Int32>(z_GetVaryingLocationNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVaryingLocationNV(&program: gl_program; name: string): Int32;
    begin
      var par_2_str_ptr: IntPtr;
      try
        par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
        Result := z_GetVaryingLocationNV_ovr_0(&program, par_2_str_ptr);
      finally
        Marshal.FreeHGlobal(par_2_str_ptr);
      end;
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVaryingLocationNV(&program: gl_program; name: IntPtr): Int32 :=
    z_GetVaryingLocationNV_ovr_0(&program, name);
    
    private z_GetActiveVaryingNV_adr := GetProcAddress('glGetActiveVaryingNV');
    private z_GetActiveVaryingNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: DummyEnum; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_1(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_2 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_2(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_3 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_3(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_4 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_4(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_5 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_5(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_6 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_6(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveVaryingNV_ovr_7 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: gl_program; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_7(&program, index, bufSize, length, size, &type, name);
    
    private z_GetTransformFeedbackVaryingNV_adr := GetProcAddress('glGetTransformFeedbackVaryingNV');
    private z_GetTransformFeedbackVaryingNV_ovr_0 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; var location: Int32)>(z_GetTransformFeedbackVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingNV(&program: gl_program; index: UInt32; var location: Int32) :=
    z_GetTransformFeedbackVaryingNV_ovr_0(&program, index, location);
    private z_GetTransformFeedbackVaryingNV_ovr_1 := GetProcOrNil&<procedure(&program: gl_program; index: UInt32; location: IntPtr)>(z_GetTransformFeedbackVaryingNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingNV(&program: gl_program; index: UInt32; location: IntPtr) :=
    z_GetTransformFeedbackVaryingNV_ovr_1(&program, index, location);
    
    private z_TransformFeedbackStreamAttribsNV_adr := GetProcAddress('glTransformFeedbackStreamAttribsNV');
    private z_TransformFeedbackStreamAttribsNV_ovr_0 := GetProcOrNil&<procedure(count: Int32; var attribs: Int32; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    private z_TransformFeedbackStreamAttribsNV_ovr_0_anh001000 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    private z_TransformFeedbackStreamAttribsNV_ovr_0_anh000010 := GetProcOrNil&<procedure(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    private z_TransformFeedbackStreamAttribsNV_ovr_0_anh001010 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: array of Int32; nbuffers: Int32; bufstreams: array of Int32; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      if (bufstreams<>nil) and (bufstreams.Length<>0) then
        z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs[0], nbuffers, bufstreams[0], bufferMode) else
        z_TransformFeedbackStreamAttribsNV_ovr_0_anh000010(count, attribs[0], nbuffers, IntPtr.Zero, bufferMode) else
      if (bufstreams<>nil) and (bufstreams.Length<>0) then
        z_TransformFeedbackStreamAttribsNV_ovr_0_anh001000(count, IntPtr.Zero, nbuffers, bufstreams[0], bufferMode) else
        z_TransformFeedbackStreamAttribsNV_ovr_0_anh001010(count, IntPtr.Zero, nbuffers, IntPtr.Zero, bufferMode);
    private z_TransformFeedbackStreamAttribsNV_ovr_1_anh001000 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: array of Int32; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs[0], nbuffers, bufstreams, bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_0_anh001000(count, IntPtr.Zero, nbuffers, bufstreams, bufferMode);
    private z_TransformFeedbackStreamAttribsNV_ovr_2 := GetProcOrNil&<procedure(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    private z_TransformFeedbackStreamAttribsNV_ovr_2_anh001000 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: array of Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_2(count, attribs[0], nbuffers, bufstreams, bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_2_anh001000(count, IntPtr.Zero, nbuffers, bufstreams, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: array of Int32; bufferMode: DummyEnum) :=
    if (bufstreams<>nil) and (bufstreams.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs, nbuffers, bufstreams[0], bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_0_anh000010(count, attribs, nbuffers, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; var attribs: Int32; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs, nbuffers, bufstreams, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_2(count, attribs, nbuffers, bufstreams, bufferMode);
    private z_TransformFeedbackStreamAttribsNV_ovr_6 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    private z_TransformFeedbackStreamAttribsNV_ovr_6_anh000010 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: array of Int32; bufferMode: DummyEnum) :=
    if (bufstreams<>nil) and (bufstreams.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_6(count, attribs, nbuffers, bufstreams[0], bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_6_anh000010(count, attribs, nbuffers, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_6(count, attribs, nbuffers, bufstreams, bufferMode);
    private z_TransformFeedbackStreamAttribsNV_ovr_8 := GetProcOrNil&<procedure(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum)>(z_TransformFeedbackStreamAttribsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_8(count, attribs, nbuffers, bufstreams, bufferMode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTransformFeedback2NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_transform_feedback2';
    
    private z_BindTransformFeedbackNV_adr := GetProcAddress('glBindTransformFeedbackNV');
    private z_BindTransformFeedbackNV_ovr_0 := GetProcOrNil&<procedure(target: BufferTarget; id: gl_transform_feedback)>(z_BindTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTransformFeedbackNV(target: BufferTarget; id: gl_transform_feedback) :=
    z_BindTransformFeedbackNV_ovr_0(target, id);
    
    private z_DeleteTransformFeedbacksNV_adr := GetProcAddress('glDeleteTransformFeedbacksNV');
    private z_DeleteTransformFeedbacksNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_DeleteTransformFeedbacksNV_adr);
    private z_DeleteTransformFeedbacksNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacksNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacksNV(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteTransformFeedbacksNV_ovr_0(n, ids[0]) else
      z_DeleteTransformFeedbacksNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacksNV(n: Int32; var ids: gl_transform_feedback) :=
    z_DeleteTransformFeedbacksNV_ovr_0(n, ids);
    private z_DeleteTransformFeedbacksNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacksNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacksNV(n: Int32; ids: IntPtr) :=
    z_DeleteTransformFeedbacksNV_ovr_2(n, ids);
    
    private z_GenTransformFeedbacksNV_adr := GetProcAddress('glGenTransformFeedbacksNV');
    private z_GenTransformFeedbacksNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var ids: gl_transform_feedback)>(z_GenTransformFeedbacksNV_adr);
    private z_GenTransformFeedbacksNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacksNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacksNV(n: Int32; ids: array of gl_transform_feedback) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenTransformFeedbacksNV_ovr_0(n, ids[0]) else
      z_GenTransformFeedbacksNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacksNV(n: Int32; var ids: gl_transform_feedback) :=
    z_GenTransformFeedbacksNV_ovr_0(n, ids);
    private z_GenTransformFeedbacksNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacksNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacksNV(n: Int32; ids: IntPtr) :=
    z_GenTransformFeedbacksNV_ovr_2(n, ids);
    
    private z_IsTransformFeedbackNV_adr := GetProcAddress('glIsTransformFeedbackNV');
    private z_IsTransformFeedbackNV_ovr_0 := GetProcOrNil&<function(id: gl_transform_feedback): boolean>(z_IsTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTransformFeedbackNV(id: gl_transform_feedback): boolean :=
    z_IsTransformFeedbackNV_ovr_0(id);
    
    private z_PauseTransformFeedbackNV_adr := GetProcAddress('glPauseTransformFeedbackNV');
    private z_PauseTransformFeedbackNV_ovr_0 := GetProcOrNil&<procedure>(z_PauseTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PauseTransformFeedbackNV :=
    z_PauseTransformFeedbackNV_ovr_0;
    
    private z_ResumeTransformFeedbackNV_adr := GetProcAddress('glResumeTransformFeedbackNV');
    private z_ResumeTransformFeedbackNV_ovr_0 := GetProcOrNil&<procedure>(z_ResumeTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResumeTransformFeedbackNV :=
    z_ResumeTransformFeedbackNV_ovr_0;
    
    private z_DrawTransformFeedbackNV_adr := GetProcAddress('glDrawTransformFeedbackNV');
    private z_DrawTransformFeedbackNV_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; id: gl_transform_feedback)>(z_DrawTransformFeedbackNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackNV(mode: PrimitiveType; id: gl_transform_feedback) :=
    z_DrawTransformFeedbackNV_ovr_0(mode, id);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVdpauInteropNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vdpau_interop';
    
    private z_VDPAUInitNV_adr := GetProcAddress('glVDPAUInitNV');
    private z_VDPAUInitNV_ovr_0 := GetProcOrNil&<procedure(vdpDevice: IntPtr; getProcAddress: IntPtr)>(z_VDPAUInitNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUInitNV(vdpDevice: IntPtr; getProcAddress: IntPtr) :=
    z_VDPAUInitNV_ovr_0(vdpDevice, getProcAddress);
    
    private z_VDPAUFiniNV_adr := GetProcAddress('glVDPAUFiniNV');
    private z_VDPAUFiniNV_ovr_0 := GetProcOrNil&<procedure>(z_VDPAUFiniNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUFiniNV :=
    z_VDPAUFiniNV_ovr_0;
    
    private z_VDPAURegisterVideoSurfaceNV_adr := GetProcAddress('glVDPAURegisterVideoSurfaceNV');
    private z_VDPAURegisterVideoSurfaceNV_ovr_0 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): gl_vdpau_surface_NV>(z_VDPAURegisterVideoSurfaceNV_adr);
    private z_VDPAURegisterVideoSurfaceNV_ovr_0_anh00001 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): gl_vdpau_surface_NV>(z_VDPAURegisterVideoSurfaceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: array of UInt32): gl_vdpau_surface_NV :=
    if (textureNames<>nil) and (textureNames.Length<>0) then
      z_VDPAURegisterVideoSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames[0]) else
      z_VDPAURegisterVideoSurfaceNV_ovr_0_anh00001(vdpSurface, target, numTextureNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): gl_vdpau_surface_NV :=
    z_VDPAURegisterVideoSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames);
    private z_VDPAURegisterVideoSurfaceNV_ovr_2 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): gl_vdpau_surface_NV>(z_VDPAURegisterVideoSurfaceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): gl_vdpau_surface_NV :=
    z_VDPAURegisterVideoSurfaceNV_ovr_2(vdpSurface, target, numTextureNames, textureNames);
    
    private z_VDPAURegisterOutputSurfaceNV_adr := GetProcAddress('glVDPAURegisterOutputSurfaceNV');
    private z_VDPAURegisterOutputSurfaceNV_ovr_0 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): gl_vdpau_surface_NV>(z_VDPAURegisterOutputSurfaceNV_adr);
    private z_VDPAURegisterOutputSurfaceNV_ovr_0_anh00001 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): gl_vdpau_surface_NV>(z_VDPAURegisterOutputSurfaceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterOutputSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: array of UInt32): gl_vdpau_surface_NV :=
    if (textureNames<>nil) and (textureNames.Length<>0) then
      z_VDPAURegisterOutputSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames[0]) else
      z_VDPAURegisterOutputSurfaceNV_ovr_0_anh00001(vdpSurface, target, numTextureNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterOutputSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): gl_vdpau_surface_NV :=
    z_VDPAURegisterOutputSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames);
    private z_VDPAURegisterOutputSurfaceNV_ovr_2 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): gl_vdpau_surface_NV>(z_VDPAURegisterOutputSurfaceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterOutputSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): gl_vdpau_surface_NV :=
    z_VDPAURegisterOutputSurfaceNV_ovr_2(vdpSurface, target, numTextureNames, textureNames);
    
    private z_VDPAUIsSurfaceNV_adr := GetProcAddress('glVDPAUIsSurfaceNV');
    private z_VDPAUIsSurfaceNV_ovr_0 := GetProcOrNil&<function(surface: gl_vdpau_surface_NV): boolean>(z_VDPAUIsSurfaceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAUIsSurfaceNV(surface: gl_vdpau_surface_NV): boolean :=
    z_VDPAUIsSurfaceNV_ovr_0(surface);
    
    private z_VDPAUUnregisterSurfaceNV_adr := GetProcAddress('glVDPAUUnregisterSurfaceNV');
    private z_VDPAUUnregisterSurfaceNV_ovr_0 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV)>(z_VDPAUUnregisterSurfaceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnregisterSurfaceNV(surface: gl_vdpau_surface_NV) :=
    z_VDPAUUnregisterSurfaceNV_ovr_0(surface);
    
    private z_VDPAUGetSurfaceivNV_adr := GetProcAddress('glVDPAUGetSurfaceivNV');
    private z_VDPAUGetSurfaceivNV_ovr_0 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; var length: Int32; var values: Int32)>(z_VDPAUGetSurfaceivNV_adr);
    private z_VDPAUGetSurfaceivNV_ovr_0_anh000010 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32)>(z_VDPAUGetSurfaceivNV_adr);
    private z_VDPAUGetSurfaceivNV_ovr_0_anh000001 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; var length: Int32; values: IntPtr)>(z_VDPAUGetSurfaceivNV_adr);
    private z_VDPAUGetSurfaceivNV_ovr_0_anh000011 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr)>(z_VDPAUGetSurfaceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: array of Int32; values: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (values<>nil) and (values.Length<>0) then
        z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length[0], values[0]) else
        z_VDPAUGetSurfaceivNV_ovr_0_anh000001(surface, pname, count, length[0], IntPtr.Zero) else
      if (values<>nil) and (values.Length<>0) then
        z_VDPAUGetSurfaceivNV_ovr_0_anh000010(surface, pname, count, IntPtr.Zero, values[0]) else
        z_VDPAUGetSurfaceivNV_ovr_0_anh000011(surface, pname, count, IntPtr.Zero, IntPtr.Zero);
    private z_VDPAUGetSurfaceivNV_ovr_1_anh000010 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32)>(z_VDPAUGetSurfaceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: array of Int32; var values: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length[0], values) else
      z_VDPAUGetSurfaceivNV_ovr_0_anh000010(surface, pname, count, IntPtr.Zero, values);
    private z_VDPAUGetSurfaceivNV_ovr_2 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; var length: Int32; values: IntPtr)>(z_VDPAUGetSurfaceivNV_adr);
    private z_VDPAUGetSurfaceivNV_ovr_2_anh000010 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr)>(z_VDPAUGetSurfaceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: array of Int32; values: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_2(surface, pname, count, length[0], values) else
      z_VDPAUGetSurfaceivNV_ovr_2_anh000010(surface, pname, count, IntPtr.Zero, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; var length: Int32; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length, values[0]) else
      z_VDPAUGetSurfaceivNV_ovr_0_anh000001(surface, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; var length: Int32; var values: Int32) :=
    z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; var length: Int32; values: IntPtr) :=
    z_VDPAUGetSurfaceivNV_ovr_2(surface, pname, count, length, values);
    private z_VDPAUGetSurfaceivNV_ovr_6 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32)>(z_VDPAUGetSurfaceivNV_adr);
    private z_VDPAUGetSurfaceivNV_ovr_6_anh000001 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr)>(z_VDPAUGetSurfaceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_6(surface, pname, count, length, values[0]) else
      z_VDPAUGetSurfaceivNV_ovr_6_anh000001(surface, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32) :=
    z_VDPAUGetSurfaceivNV_ovr_6(surface, pname, count, length, values);
    private z_VDPAUGetSurfaceivNV_ovr_8 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr)>(z_VDPAUGetSurfaceivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: gl_vdpau_surface_NV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr) :=
    z_VDPAUGetSurfaceivNV_ovr_8(surface, pname, count, length, values);
    
    private z_VDPAUSurfaceAccessNV_adr := GetProcAddress('glVDPAUSurfaceAccessNV');
    private z_VDPAUSurfaceAccessNV_ovr_0 := GetProcOrNil&<procedure(surface: gl_vdpau_surface_NV; access: DummyEnum)>(z_VDPAUSurfaceAccessNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUSurfaceAccessNV(surface: gl_vdpau_surface_NV; access: DummyEnum) :=
    z_VDPAUSurfaceAccessNV_ovr_0(surface, access);
    
    private z_VDPAUMapSurfacesNV_adr := GetProcAddress('glVDPAUMapSurfacesNV');
    private z_VDPAUMapSurfacesNV_ovr_0 := GetProcOrNil&<procedure(numSurfaces: Int32; var surfaces: gl_vdpau_surface_NV)>(z_VDPAUMapSurfacesNV_adr);
    private z_VDPAUMapSurfacesNV_ovr_0_anh001 := GetProcOrNil&<procedure(numSurfaces: Int32; surfaces: IntPtr)>(z_VDPAUMapSurfacesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUMapSurfacesNV(numSurfaces: Int32; surfaces: array of gl_vdpau_surface_NV) :=
    if (surfaces<>nil) and (surfaces.Length<>0) then
      z_VDPAUMapSurfacesNV_ovr_0(numSurfaces, surfaces[0]) else
      z_VDPAUMapSurfacesNV_ovr_0_anh001(numSurfaces, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUMapSurfacesNV(numSurfaces: Int32; var surfaces: gl_vdpau_surface_NV) :=
    z_VDPAUMapSurfacesNV_ovr_0(numSurfaces, surfaces);
    private z_VDPAUMapSurfacesNV_ovr_2 := GetProcOrNil&<procedure(numSurfaces: Int32; surfaces: IntPtr)>(z_VDPAUMapSurfacesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUMapSurfacesNV(numSurfaces: Int32; surfaces: IntPtr) :=
    z_VDPAUMapSurfacesNV_ovr_2(numSurfaces, surfaces);
    
    private z_VDPAUUnmapSurfacesNV_adr := GetProcAddress('glVDPAUUnmapSurfacesNV');
    private z_VDPAUUnmapSurfacesNV_ovr_0 := GetProcOrNil&<procedure(numSurface: Int32; var surfaces: gl_vdpau_surface_NV)>(z_VDPAUUnmapSurfacesNV_adr);
    private z_VDPAUUnmapSurfacesNV_ovr_0_anh001 := GetProcOrNil&<procedure(numSurface: Int32; surfaces: IntPtr)>(z_VDPAUUnmapSurfacesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnmapSurfacesNV(numSurface: Int32; surfaces: array of gl_vdpau_surface_NV) :=
    if (surfaces<>nil) and (surfaces.Length<>0) then
      z_VDPAUUnmapSurfacesNV_ovr_0(numSurface, surfaces[0]) else
      z_VDPAUUnmapSurfacesNV_ovr_0_anh001(numSurface, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnmapSurfacesNV(numSurface: Int32; var surfaces: gl_vdpau_surface_NV) :=
    z_VDPAUUnmapSurfacesNV_ovr_0(numSurface, surfaces);
    private z_VDPAUUnmapSurfacesNV_ovr_2 := GetProcOrNil&<procedure(numSurface: Int32; surfaces: IntPtr)>(z_VDPAUUnmapSurfacesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnmapSurfacesNV(numSurface: Int32; surfaces: IntPtr) :=
    z_VDPAUUnmapSurfacesNV_ovr_2(numSurface, surfaces);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVdpauInterop2NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vdpau_interop2';
    
    private z_VDPAURegisterVideoSurfaceWithPictureStructureNV_adr := GetProcAddress('glVDPAURegisterVideoSurfaceWithPictureStructureNV');
    private z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32; isFrameStructure: boolean): gl_vdpau_surface_NV>(z_VDPAURegisterVideoSurfaceWithPictureStructureNV_adr);
    private z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0_anh000010 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr; isFrameStructure: boolean): gl_vdpau_surface_NV>(z_VDPAURegisterVideoSurfaceWithPictureStructureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceWithPictureStructureNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: array of UInt32; isFrameStructure: boolean): gl_vdpau_surface_NV :=
    if (textureNames<>nil) and (textureNames.Length<>0) then
      z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0(vdpSurface, target, numTextureNames, textureNames[0], isFrameStructure) else
      z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0_anh000010(vdpSurface, target, numTextureNames, IntPtr.Zero, isFrameStructure);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceWithPictureStructureNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32; isFrameStructure: boolean): gl_vdpau_surface_NV :=
    z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0(vdpSurface, target, numTextureNames, textureNames, isFrameStructure);
    private z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_2 := GetProcOrNil&<function(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr; isFrameStructure: boolean): gl_vdpau_surface_NV>(z_VDPAURegisterVideoSurfaceWithPictureStructureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceWithPictureStructureNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr; isFrameStructure: boolean): gl_vdpau_surface_NV :=
    z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_2(vdpSurface, target, numTextureNames, textureNames, isFrameStructure);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexArrayRangeNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vertex_array_range';
    
    private z_FlushVertexArrayRangeNV_adr := GetProcAddress('glFlushVertexArrayRangeNV');
    private z_FlushVertexArrayRangeNV_ovr_0 := GetProcOrNil&<procedure>(z_FlushVertexArrayRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushVertexArrayRangeNV :=
    z_FlushVertexArrayRangeNV_ovr_0;
    
    private z_VertexArrayRangeNV_adr := GetProcAddress('glVertexArrayRangeNV');
    private z_VertexArrayRangeNV_ovr_0 := GetProcOrNil&<procedure(length: Int32; pointer: IntPtr)>(z_VertexArrayRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayRangeNV(length: Int32; pointer: IntPtr) :=
    z_VertexArrayRangeNV_ovr_0(length, pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexAttribInteger64bitNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vertex_attrib_integer_64bit';
    
    private z_VertexAttribL1i64NV_adr := GetProcAddress('glVertexAttribL1i64NV');
    private z_VertexAttribL1i64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int64)>(z_VertexAttribL1i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64NV(index: UInt32; x: Int64) :=
    z_VertexAttribL1i64NV_ovr_0(index, x);
    
    private z_VertexAttribL2i64NV_adr := GetProcAddress('glVertexAttribL2i64NV');
    private z_VertexAttribL2i64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int64; y: Int64)>(z_VertexAttribL2i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64NV(index: UInt32; x: Int64; y: Int64) :=
    z_VertexAttribL2i64NV_ovr_0(index, x, y);
    
    private z_VertexAttribL3i64NV_adr := GetProcAddress('glVertexAttribL3i64NV');
    private z_VertexAttribL3i64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int64; y: Int64; z: Int64)>(z_VertexAttribL3i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64NV(index: UInt32; x: Int64; y: Int64; z: Int64) :=
    z_VertexAttribL3i64NV_ovr_0(index, x, y, z);
    
    private z_VertexAttribL4i64NV_adr := GetProcAddress('glVertexAttribL4i64NV');
    private z_VertexAttribL4i64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int64; y: Int64; z: Int64; w: Int64)>(z_VertexAttribL4i64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64NV(index: UInt32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_VertexAttribL4i64NV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribL1i64vNV_adr := GetProcAddress('glVertexAttribL1i64vNV');
    private z_VertexAttribL1i64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int64)>(z_VertexAttribL1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL1i64vNV_ovr_0(index, v);
    private z_VertexAttribL1i64vNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1i64vNV_ovr_1(index, v);
    
    private z_VertexAttribL2i64vNV_adr := GetProcAddress('glVertexAttribL2i64vNV');
    private z_VertexAttribL2i64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int64)>(z_VertexAttribL2i64vNV_adr);
    private z_VertexAttribL2i64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL2i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL2i64vNV_ovr_0(index, v);
    private z_VertexAttribL2i64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2i64vNV_ovr_2(index, v);
    
    private z_VertexAttribL3i64vNV_adr := GetProcAddress('glVertexAttribL3i64vNV');
    private z_VertexAttribL3i64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int64)>(z_VertexAttribL3i64vNV_adr);
    private z_VertexAttribL3i64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL3i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL3i64vNV_ovr_0(index, v);
    private z_VertexAttribL3i64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3i64vNV_ovr_2(index, v);
    
    private z_VertexAttribL4i64vNV_adr := GetProcAddress('glVertexAttribL4i64vNV');
    private z_VertexAttribL4i64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int64)>(z_VertexAttribL4i64vNV_adr);
    private z_VertexAttribL4i64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL4i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL4i64vNV_ovr_0(index, v);
    private z_VertexAttribL4i64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4i64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4i64vNV_ovr_2(index, v);
    
    private z_VertexAttribL1ui64NV_adr := GetProcAddress('glVertexAttribL1ui64NV');
    private z_VertexAttribL1ui64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt64)>(z_VertexAttribL1ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64NV(index: UInt32; x: UInt64) :=
    z_VertexAttribL1ui64NV_ovr_0(index, x);
    
    private z_VertexAttribL2ui64NV_adr := GetProcAddress('glVertexAttribL2ui64NV');
    private z_VertexAttribL2ui64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt64; y: UInt64)>(z_VertexAttribL2ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64NV(index: UInt32; x: UInt64; y: UInt64) :=
    z_VertexAttribL2ui64NV_ovr_0(index, x, y);
    
    private z_VertexAttribL3ui64NV_adr := GetProcAddress('glVertexAttribL3ui64NV');
    private z_VertexAttribL3ui64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt64; y: UInt64; z: UInt64)>(z_VertexAttribL3ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64NV(index: UInt32; x: UInt64; y: UInt64; z: UInt64) :=
    z_VertexAttribL3ui64NV_ovr_0(index, x, y, z);
    
    private z_VertexAttribL4ui64NV_adr := GetProcAddress('glVertexAttribL4ui64NV');
    private z_VertexAttribL4ui64NV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt64; y: UInt64; z: UInt64; w: UInt64)>(z_VertexAttribL4ui64NV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64NV(index: UInt32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_VertexAttribL4ui64NV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribL1ui64vNV_adr := GetProcAddress('glVertexAttribL1ui64vNV');
    private z_VertexAttribL1ui64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt64)>(z_VertexAttribL1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL1ui64vNV_ovr_0(index, v);
    private z_VertexAttribL1ui64vNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1ui64vNV_ovr_1(index, v);
    
    private z_VertexAttribL2ui64vNV_adr := GetProcAddress('glVertexAttribL2ui64vNV');
    private z_VertexAttribL2ui64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt64)>(z_VertexAttribL2ui64vNV_adr);
    private z_VertexAttribL2ui64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL2ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL2ui64vNV_ovr_0(index, v);
    private z_VertexAttribL2ui64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2ui64vNV_ovr_2(index, v);
    
    private z_VertexAttribL3ui64vNV_adr := GetProcAddress('glVertexAttribL3ui64vNV');
    private z_VertexAttribL3ui64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt64)>(z_VertexAttribL3ui64vNV_adr);
    private z_VertexAttribL3ui64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL3ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL3ui64vNV_ovr_0(index, v);
    private z_VertexAttribL3ui64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3ui64vNV_ovr_2(index, v);
    
    private z_VertexAttribL4ui64vNV_adr := GetProcAddress('glVertexAttribL4ui64vNV');
    private z_VertexAttribL4ui64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt64)>(z_VertexAttribL4ui64vNV_adr);
    private z_VertexAttribL4ui64vNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL4ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL4ui64vNV_ovr_0(index, v);
    private z_VertexAttribL4ui64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4ui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4ui64vNV_ovr_2(index, v);
    
    private z_GetVertexAttribLi64vNV_adr := GetProcAddress('glGetVertexAttribLi64vNV');
    private z_GetVertexAttribLi64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: Int64)>(z_GetVertexAttribLi64vNV_adr);
    private z_GetVertexAttribLi64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLi64vNV(index: UInt32; pname: VertexAttribEnum; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLi64vNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLi64vNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLi64vNV(index: UInt32; pname: VertexAttribEnum; var &params: Int64) :=
    z_GetVertexAttribLi64vNV_ovr_0(index, pname, &params);
    private z_GetVertexAttribLi64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLi64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLi64vNV(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLi64vNV_ovr_2(index, pname, &params);
    
    private z_GetVertexAttribLui64vNV_adr := GetProcAddress('glGetVertexAttribLui64vNV');
    private z_GetVertexAttribLui64vNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: UInt64)>(z_GetVertexAttribLui64vNV_adr);
    private z_GetVertexAttribLui64vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vNV(index: UInt32; pname: VertexAttribEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLui64vNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLui64vNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vNV(index: UInt32; pname: VertexAttribEnum; var &params: UInt64) :=
    z_GetVertexAttribLui64vNV_ovr_0(index, pname, &params);
    private z_GetVertexAttribLui64vNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLui64vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vNV(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLui64vNV_ovr_2(index, pname, &params);
    
    private z_VertexAttribLFormatNV_adr := GetProcAddress('glVertexAttribLFormatNV');
    private z_VertexAttribLFormatNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32)>(z_VertexAttribLFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLFormatNV(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32) :=
    z_VertexAttribLFormatNV_ovr_0(index, size, &type, stride);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexBufferUnifiedMemoryNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vertex_buffer_unified_memory';
    
    private z_BufferAddressRangeNV_adr := GetProcAddress('glBufferAddressRangeNV');
    private z_BufferAddressRangeNV_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; index: UInt32; address: UInt64; length: IntPtr)>(z_BufferAddressRangeNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferAddressRangeNV(pname: DummyEnum; index: UInt32; address: UInt64; length: IntPtr) :=
    z_BufferAddressRangeNV_ovr_0(pname, index, address, length);
    
    private z_VertexFormatNV_adr := GetProcAddress('glVertexFormatNV');
    private z_VertexFormatNV_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: VertexPointerType; stride: Int32)>(z_VertexFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexFormatNV(size: Int32; &type: VertexPointerType; stride: Int32) :=
    z_VertexFormatNV_ovr_0(size, &type, stride);
    
    private z_NormalFormatNV_adr := GetProcAddress('glNormalFormatNV');
    private z_NormalFormatNV_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; stride: Int32)>(z_NormalFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalFormatNV(&type: DummyEnum; stride: Int32) :=
    z_NormalFormatNV_ovr_0(&type, stride);
    
    private z_ColorFormatNV_adr := GetProcAddress('glColorFormatNV');
    private z_ColorFormatNV_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: DummyEnum; stride: Int32)>(z_ColorFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFormatNV(size: Int32; &type: DummyEnum; stride: Int32) :=
    z_ColorFormatNV_ovr_0(size, &type, stride);
    
    private z_IndexFormatNV_adr := GetProcAddress('glIndexFormatNV');
    private z_IndexFormatNV_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; stride: Int32)>(z_IndexFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexFormatNV(&type: DummyEnum; stride: Int32) :=
    z_IndexFormatNV_ovr_0(&type, stride);
    
    private z_TexCoordFormatNV_adr := GetProcAddress('glTexCoordFormatNV');
    private z_TexCoordFormatNV_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: DummyEnum; stride: Int32)>(z_TexCoordFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordFormatNV(size: Int32; &type: DummyEnum; stride: Int32) :=
    z_TexCoordFormatNV_ovr_0(size, &type, stride);
    
    private z_EdgeFlagFormatNV_adr := GetProcAddress('glEdgeFlagFormatNV');
    private z_EdgeFlagFormatNV_ovr_0 := GetProcOrNil&<procedure(stride: Int32)>(z_EdgeFlagFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagFormatNV(stride: Int32) :=
    z_EdgeFlagFormatNV_ovr_0(stride);
    
    private z_SecondaryColorFormatNV_adr := GetProcAddress('glSecondaryColorFormatNV');
    private z_SecondaryColorFormatNV_ovr_0 := GetProcOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32)>(z_SecondaryColorFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorFormatNV(size: Int32; &type: ColorPointerType; stride: Int32) :=
    z_SecondaryColorFormatNV_ovr_0(size, &type, stride);
    
    private z_FogCoordFormatNV_adr := GetProcAddress('glFogCoordFormatNV');
    private z_FogCoordFormatNV_ovr_0 := GetProcOrNil&<procedure(&type: DummyEnum; stride: Int32)>(z_FogCoordFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordFormatNV(&type: DummyEnum; stride: Int32) :=
    z_FogCoordFormatNV_ovr_0(&type, stride);
    
    private z_VertexAttribFormatNV_adr := GetProcAddress('glVertexAttribFormatNV');
    private z_VertexAttribFormatNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; stride: Int32)>(z_VertexAttribFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribFormatNV(index: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; stride: Int32) :=
    z_VertexAttribFormatNV_ovr_0(index, size, &type, normalized, stride);
    
    private z_VertexAttribIFormatNV_adr := GetProcAddress('glVertexAttribIFormatNV');
    private z_VertexAttribIFormatNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32)>(z_VertexAttribIFormatNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIFormatNV(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32) :=
    z_VertexAttribIFormatNV_ovr_0(index, size, &type, stride);
    
    private z_GetIntegerui64i_vNV_adr := GetProcAddress('glGetIntegerui64i_vNV');
    private z_GetIntegerui64i_vNV_ovr_0 := GetProcOrNil&<procedure(value: DummyEnum; index: UInt32; var result: UInt64)>(z_GetIntegerui64i_vNV_adr);
    private z_GetIntegerui64i_vNV_ovr_0_anh0001 := GetProcOrNil&<procedure(value: DummyEnum; index: UInt32; result: IntPtr)>(z_GetIntegerui64i_vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64i_vNV(value: DummyEnum; index: UInt32; result: array of UInt64) :=
    if (result<>nil) and (result.Length<>0) then
      z_GetIntegerui64i_vNV_ovr_0(value, index, result[0]) else
      z_GetIntegerui64i_vNV_ovr_0_anh0001(value, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64i_vNV(value: DummyEnum; index: UInt32; var result: UInt64) :=
    z_GetIntegerui64i_vNV_ovr_0(value, index, result);
    private z_GetIntegerui64i_vNV_ovr_2 := GetProcOrNil&<procedure(value: DummyEnum; index: UInt32; result: IntPtr)>(z_GetIntegerui64i_vNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64i_vNV(value: DummyEnum; index: UInt32; result: IntPtr) :=
    z_GetIntegerui64i_vNV_ovr_2(value, index, result);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexProgramNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vertex_program';
    
    private z_AreProgramsResidentNV_adr := GetProcAddress('glAreProgramsResidentNV');
    private z_AreProgramsResidentNV_ovr_0 := GetProcOrNil&<function(n: Int32; var programs: gl_program; var residences: boolean): boolean>(z_AreProgramsResidentNV_adr);
    private z_AreProgramsResidentNV_ovr_0_anh0010 := GetProcOrNil&<function(n: Int32; programs: IntPtr; var residences: boolean): boolean>(z_AreProgramsResidentNV_adr);
    private z_AreProgramsResidentNV_ovr_0_anh0001 := GetProcOrNil&<function(n: Int32; var programs: gl_program; residences: IntPtr): boolean>(z_AreProgramsResidentNV_adr);
    private z_AreProgramsResidentNV_ovr_0_anh0011 := GetProcOrNil&<function(n: Int32; programs: IntPtr; residences: IntPtr): boolean>(z_AreProgramsResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: array of gl_program; residences: array of boolean): boolean :=
    if (programs<>nil) and (programs.Length<>0) then
      if (residences<>nil) and (residences.Length<>0) then
        z_AreProgramsResidentNV_ovr_0(n, programs[0], residences[0]) else
        z_AreProgramsResidentNV_ovr_0_anh0001(n, programs[0], IntPtr.Zero) else
      if (residences<>nil) and (residences.Length<>0) then
        z_AreProgramsResidentNV_ovr_0_anh0010(n, IntPtr.Zero, residences[0]) else
        z_AreProgramsResidentNV_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private z_AreProgramsResidentNV_ovr_1_anh0010 := GetProcOrNil&<function(n: Int32; programs: IntPtr; var residences: boolean): boolean>(z_AreProgramsResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: array of gl_program; var residences: boolean): boolean :=
    if (programs<>nil) and (programs.Length<>0) then
      z_AreProgramsResidentNV_ovr_0(n, programs[0], residences) else
      z_AreProgramsResidentNV_ovr_0_anh0010(n, IntPtr.Zero, residences);
    private z_AreProgramsResidentNV_ovr_2 := GetProcOrNil&<function(n: Int32; var programs: gl_program; residences: IntPtr): boolean>(z_AreProgramsResidentNV_adr);
    private z_AreProgramsResidentNV_ovr_2_anh0010 := GetProcOrNil&<function(n: Int32; programs: IntPtr; residences: IntPtr): boolean>(z_AreProgramsResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: array of gl_program; residences: IntPtr): boolean :=
    if (programs<>nil) and (programs.Length<>0) then
      z_AreProgramsResidentNV_ovr_2(n, programs[0], residences) else
      z_AreProgramsResidentNV_ovr_2_anh0010(n, IntPtr.Zero, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; var programs: gl_program; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreProgramsResidentNV_ovr_0(n, programs, residences[0]) else
      z_AreProgramsResidentNV_ovr_0_anh0001(n, programs, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; var programs: gl_program; var residences: boolean): boolean :=
    z_AreProgramsResidentNV_ovr_0(n, programs, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; var programs: gl_program; residences: IntPtr): boolean :=
    z_AreProgramsResidentNV_ovr_2(n, programs, residences);
    private z_AreProgramsResidentNV_ovr_6 := GetProcOrNil&<function(n: Int32; programs: IntPtr; var residences: boolean): boolean>(z_AreProgramsResidentNV_adr);
    private z_AreProgramsResidentNV_ovr_6_anh0001 := GetProcOrNil&<function(n: Int32; programs: IntPtr; residences: IntPtr): boolean>(z_AreProgramsResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: IntPtr; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreProgramsResidentNV_ovr_6(n, programs, residences[0]) else
      z_AreProgramsResidentNV_ovr_6_anh0001(n, programs, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: IntPtr; var residences: boolean): boolean :=
    z_AreProgramsResidentNV_ovr_6(n, programs, residences);
    private z_AreProgramsResidentNV_ovr_8 := GetProcOrNil&<function(n: Int32; programs: IntPtr; residences: IntPtr): boolean>(z_AreProgramsResidentNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: IntPtr; residences: IntPtr): boolean :=
    z_AreProgramsResidentNV_ovr_8(n, programs, residences);
    
    private z_BindProgramNV_adr := GetProcAddress('glBindProgramNV');
    private z_BindProgramNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: gl_program)>(z_BindProgramNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramNV(target: VertexAttribEnumNV; id: gl_program) :=
    z_BindProgramNV_ovr_0(target, id);
    
    private z_DeleteProgramsNV_adr := GetProcAddress('glDeleteProgramsNV');
    private z_DeleteProgramsNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_DeleteProgramsNV_adr);
    private z_DeleteProgramsNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_DeleteProgramsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsNV(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_DeleteProgramsNV_ovr_0(n, programs[0]) else
      z_DeleteProgramsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsNV(n: Int32; var programs: gl_program) :=
    z_DeleteProgramsNV_ovr_0(n, programs);
    private z_DeleteProgramsNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_DeleteProgramsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsNV(n: Int32; programs: IntPtr) :=
    z_DeleteProgramsNV_ovr_2(n, programs);
    
    private z_ExecuteProgramNV_adr := GetProcAddress('glExecuteProgramNV');
    private z_ExecuteProgramNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: UInt32; var &params: single)>(z_ExecuteProgramNV_adr);
    private z_ExecuteProgramNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: UInt32; &params: IntPtr)>(z_ExecuteProgramNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExecuteProgramNV(target: VertexAttribEnumNV; id: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ExecuteProgramNV_ovr_0(target, id, &params[0]) else
      z_ExecuteProgramNV_ovr_0_anh0001(target, id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExecuteProgramNV(target: VertexAttribEnumNV; id: UInt32; var &params: single) :=
    z_ExecuteProgramNV_ovr_0(target, id, &params);
    private z_ExecuteProgramNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: UInt32; &params: IntPtr)>(z_ExecuteProgramNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExecuteProgramNV(target: VertexAttribEnumNV; id: UInt32; &params: IntPtr) :=
    z_ExecuteProgramNV_ovr_2(target, id, &params);
    
    private z_GenProgramsNV_adr := GetProcAddress('glGenProgramsNV');
    private z_GenProgramsNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_GenProgramsNV_adr);
    private z_GenProgramsNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_GenProgramsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsNV(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_GenProgramsNV_ovr_0(n, programs[0]) else
      z_GenProgramsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsNV(n: Int32; var programs: gl_program) :=
    z_GenProgramsNV_ovr_0(n, programs);
    private z_GenProgramsNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_GenProgramsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsNV(n: Int32; programs: IntPtr) :=
    z_GenProgramsNV_ovr_2(n, programs);
    
    private z_GetProgramParameterdvNV_adr := GetProcAddress('glGetProgramParameterdvNV');
    private z_GetProgramParameterdvNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: real)>(z_GetProgramParameterdvNV_adr);
    private z_GetProgramParameterdvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetProgramParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterdvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramParameterdvNV_ovr_0(target, index, pname, &params[0]) else
      z_GetProgramParameterdvNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterdvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: real) :=
    z_GetProgramParameterdvNV_ovr_0(target, index, pname, &params);
    private z_GetProgramParameterdvNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetProgramParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterdvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetProgramParameterdvNV_ovr_2(target, index, pname, &params);
    
    private z_GetProgramParameterfvNV_adr := GetProcAddress('glGetProgramParameterfvNV');
    private z_GetProgramParameterfvNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: single)>(z_GetProgramParameterfvNV_adr);
    private z_GetProgramParameterfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetProgramParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterfvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramParameterfvNV_ovr_0(target, index, pname, &params[0]) else
      z_GetProgramParameterfvNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterfvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: single) :=
    z_GetProgramParameterfvNV_ovr_0(target, index, pname, &params);
    private z_GetProgramParameterfvNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetProgramParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterfvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetProgramParameterfvNV_ovr_2(target, index, pname, &params);
    
    private z_GetProgramivNV_adr := GetProcAddress('glGetProgramivNV');
    private z_GetProgramivNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; pname: VertexAttribEnumNV; var &params: Int32)>(z_GetProgramivNV_adr);
    private z_GetProgramivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_program; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetProgramivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivNV(id: gl_program; pname: VertexAttribEnumNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramivNV_ovr_0(id, pname, &params[0]) else
      z_GetProgramivNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivNV(id: gl_program; pname: VertexAttribEnumNV; var &params: Int32) :=
    z_GetProgramivNV_ovr_0(id, pname, &params);
    private z_GetProgramivNV_ovr_2 := GetProcOrNil&<procedure(id: gl_program; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetProgramivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivNV(id: gl_program; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetProgramivNV_ovr_2(id, pname, &params);
    
    private z_GetProgramStringNV_adr := GetProcAddress('glGetProgramStringNV');
    private z_GetProgramStringNV_ovr_0 := GetProcOrNil&<procedure(id: gl_program; pname: VertexAttribEnumNV; var &program: Byte)>(z_GetProgramStringNV_adr);
    private z_GetProgramStringNV_ovr_0_anh0001 := GetProcOrNil&<procedure(id: gl_program; pname: VertexAttribEnumNV; &program: IntPtr)>(z_GetProgramStringNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringNV(id: gl_program; pname: VertexAttribEnumNV; &program: array of Byte) :=
    if (&program<>nil) and (&program.Length<>0) then
      z_GetProgramStringNV_ovr_0(id, pname, &program[0]) else
      z_GetProgramStringNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringNV(id: gl_program; pname: VertexAttribEnumNV; var &program: Byte) :=
    z_GetProgramStringNV_ovr_0(id, pname, &program);
    private z_GetProgramStringNV_ovr_2 := GetProcOrNil&<procedure(id: gl_program; pname: VertexAttribEnumNV; &program: IntPtr)>(z_GetProgramStringNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringNV(id: gl_program; pname: VertexAttribEnumNV; &program: IntPtr) :=
    z_GetProgramStringNV_ovr_2(id, pname, &program);
    
    private z_GetTrackMatrixivNV_adr := GetProcAddress('glGetTrackMatrixivNV');
    private z_GetTrackMatrixivNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; var &params: Int32)>(z_GetTrackMatrixivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTrackMatrixivNV(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; var &params: Int32) :=
    z_GetTrackMatrixivNV_ovr_0(target, address, pname, &params);
    private z_GetTrackMatrixivNV_ovr_1 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetTrackMatrixivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTrackMatrixivNV(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetTrackMatrixivNV_ovr_1(target, address, pname, &params);
    
    private z_GetVertexAttribdvNV_adr := GetProcAddress('glGetVertexAttribdvNV');
    private z_GetVertexAttribdvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; var &params: real)>(z_GetVertexAttribdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvNV(index: UInt32; pname: VertexAttribEnumNV; var &params: real) :=
    z_GetVertexAttribdvNV_ovr_0(index, pname, &params);
    private z_GetVertexAttribdvNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetVertexAttribdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvNV(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetVertexAttribdvNV_ovr_1(index, pname, &params);
    
    private z_GetVertexAttribfvNV_adr := GetProcAddress('glGetVertexAttribfvNV');
    private z_GetVertexAttribfvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; var &params: single)>(z_GetVertexAttribfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvNV(index: UInt32; pname: VertexAttribEnumNV; var &params: single) :=
    z_GetVertexAttribfvNV_ovr_0(index, pname, &params);
    private z_GetVertexAttribfvNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetVertexAttribfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvNV(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetVertexAttribfvNV_ovr_1(index, pname, &params);
    
    private z_GetVertexAttribivNV_adr := GetProcAddress('glGetVertexAttribivNV');
    private z_GetVertexAttribivNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; var &params: Int32)>(z_GetVertexAttribivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivNV(index: UInt32; pname: VertexAttribEnumNV; var &params: Int32) :=
    z_GetVertexAttribivNV_ovr_0(index, pname, &params);
    private z_GetVertexAttribivNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr)>(z_GetVertexAttribivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivNV(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetVertexAttribivNV_ovr_1(index, pname, &params);
    
    private z_GetVertexAttribPointervNV_adr := GetProcAddress('glGetVertexAttribPointervNV');
    private z_GetVertexAttribPointervNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; var _pointer: IntPtr)>(z_GetVertexAttribPointervNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervNV(index: UInt32; pname: VertexAttribEnumNV; var _pointer: IntPtr) :=
    z_GetVertexAttribPointervNV_ovr_0(index, pname, _pointer);
    private z_GetVertexAttribPointervNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnumNV; _pointer: pointer)>(z_GetVertexAttribPointervNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervNV(index: UInt32; pname: VertexAttribEnumNV; _pointer: pointer) :=
    z_GetVertexAttribPointervNV_ovr_1(index, pname, _pointer);
    
    private z_IsProgramNV_adr := GetProcAddress('glIsProgramNV');
    private z_IsProgramNV_ovr_0 := GetProcOrNil&<function(id: gl_program): boolean>(z_IsProgramNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramNV(id: gl_program): boolean :=
    z_IsProgramNV_ovr_0(id);
    
    private z_LoadProgramNV_adr := GetProcAddress('glLoadProgramNV');
    private z_LoadProgramNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: UInt32; len: Int32; var &program: Byte)>(z_LoadProgramNV_adr);
    private z_LoadProgramNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: IntPtr)>(z_LoadProgramNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadProgramNV(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: array of Byte) :=
    if (&program<>nil) and (&program.Length<>0) then
      z_LoadProgramNV_ovr_0(target, id, len, &program[0]) else
      z_LoadProgramNV_ovr_0_anh00001(target, id, len, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadProgramNV(target: VertexAttribEnumNV; id: UInt32; len: Int32; var &program: Byte) :=
    z_LoadProgramNV_ovr_0(target, id, len, &program);
    private z_LoadProgramNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: IntPtr)>(z_LoadProgramNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadProgramNV(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: IntPtr) :=
    z_LoadProgramNV_ovr_2(target, id, len, &program);
    
    private z_ProgramParameter4dNV_adr := GetProcAddress('glProgramParameter4dNV');
    private z_ProgramParameter4dNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; x: real; y: real; z: real; w: real)>(z_ProgramParameter4dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dNV(target: VertexAttribEnumNV; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramParameter4dNV_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramParameter4dvNV_adr := GetProcAddress('glProgramParameter4dvNV');
    private z_ProgramParameter4dvNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; var v: real)>(z_ProgramParameter4dvNV_adr);
    private z_ProgramParameter4dvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; v: IntPtr)>(z_ProgramParameter4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dvNV(target: VertexAttribEnumNV; index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameter4dvNV_ovr_0(target, index, v[0]) else
      z_ProgramParameter4dvNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dvNV(target: VertexAttribEnumNV; index: UInt32; var v: real) :=
    z_ProgramParameter4dvNV_ovr_0(target, index, v);
    private z_ProgramParameter4dvNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; v: IntPtr)>(z_ProgramParameter4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dvNV(target: VertexAttribEnumNV; index: UInt32; v: IntPtr) :=
    z_ProgramParameter4dvNV_ovr_2(target, index, v);
    
    private z_ProgramParameter4fNV_adr := GetProcAddress('glProgramParameter4fNV');
    private z_ProgramParameter4fNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; x: single; y: single; z: single; w: single)>(z_ProgramParameter4fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fNV(target: VertexAttribEnumNV; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramParameter4fNV_ovr_0(target, index, x, y, z, w);
    
    private z_ProgramParameter4fvNV_adr := GetProcAddress('glProgramParameter4fvNV');
    private z_ProgramParameter4fvNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; var v: single)>(z_ProgramParameter4fvNV_adr);
    private z_ProgramParameter4fvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; v: IntPtr)>(z_ProgramParameter4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fvNV(target: VertexAttribEnumNV; index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameter4fvNV_ovr_0(target, index, v[0]) else
      z_ProgramParameter4fvNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fvNV(target: VertexAttribEnumNV; index: UInt32; var v: single) :=
    z_ProgramParameter4fvNV_ovr_0(target, index, v);
    private z_ProgramParameter4fvNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; v: IntPtr)>(z_ProgramParameter4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fvNV(target: VertexAttribEnumNV; index: UInt32; v: IntPtr) :=
    z_ProgramParameter4fvNV_ovr_2(target, index, v);
    
    private z_ProgramParameters4dvNV_adr := GetProcAddress('glProgramParameters4dvNV');
    private z_ProgramParameters4dvNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: real)>(z_ProgramParameters4dvNV_adr);
    private z_ProgramParameters4dvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr)>(z_ProgramParameters4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4dvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameters4dvNV_ovr_0(target, index, count, v[0]) else
      z_ProgramParameters4dvNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4dvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: real) :=
    z_ProgramParameters4dvNV_ovr_0(target, index, count, v);
    private z_ProgramParameters4dvNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr)>(z_ProgramParameters4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4dvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr) :=
    z_ProgramParameters4dvNV_ovr_2(target, index, count, v);
    
    private z_ProgramParameters4fvNV_adr := GetProcAddress('glProgramParameters4fvNV');
    private z_ProgramParameters4fvNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: single)>(z_ProgramParameters4fvNV_adr);
    private z_ProgramParameters4fvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr)>(z_ProgramParameters4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4fvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameters4fvNV_ovr_0(target, index, count, v[0]) else
      z_ProgramParameters4fvNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4fvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: single) :=
    z_ProgramParameters4fvNV_ovr_0(target, index, count, v);
    private z_ProgramParameters4fvNV_ovr_2 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr)>(z_ProgramParameters4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4fvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr) :=
    z_ProgramParameters4fvNV_ovr_2(target, index, count, v);
    
    private z_RequestResidentProgramsNV_adr := GetProcAddress('glRequestResidentProgramsNV');
    private z_RequestResidentProgramsNV_ovr_0 := GetProcOrNil&<procedure(n: Int32; var programs: gl_program)>(z_RequestResidentProgramsNV_adr);
    private z_RequestResidentProgramsNV_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_RequestResidentProgramsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RequestResidentProgramsNV(n: Int32; programs: array of gl_program) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_RequestResidentProgramsNV_ovr_0(n, programs[0]) else
      z_RequestResidentProgramsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RequestResidentProgramsNV(n: Int32; var programs: gl_program) :=
    z_RequestResidentProgramsNV_ovr_0(n, programs);
    private z_RequestResidentProgramsNV_ovr_2 := GetProcOrNil&<procedure(n: Int32; programs: IntPtr)>(z_RequestResidentProgramsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RequestResidentProgramsNV(n: Int32; programs: IntPtr) :=
    z_RequestResidentProgramsNV_ovr_2(n, programs);
    
    private z_TrackMatrixNV_adr := GetProcAddress('glTrackMatrixNV');
    private z_TrackMatrixNV_ovr_0 := GetProcOrNil&<procedure(target: VertexAttribEnumNV; address: UInt32; matrix: VertexAttribEnumNV; transform: VertexAttribEnumNV)>(z_TrackMatrixNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TrackMatrixNV(target: VertexAttribEnumNV; address: UInt32; matrix: VertexAttribEnumNV; transform: VertexAttribEnumNV) :=
    z_TrackMatrixNV_ovr_0(target, address, matrix, transform);
    
    private z_VertexAttribPointerNV_adr := GetProcAddress('glVertexAttribPointerNV');
    private z_VertexAttribPointerNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; fsize: Int32; &type: VertexAttribEnumNV; stride: Int32; pointer: IntPtr)>(z_VertexAttribPointerNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointerNV(index: UInt32; fsize: Int32; &type: VertexAttribEnumNV; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointerNV_ovr_0(index, fsize, &type, stride, pointer);
    
    private z_VertexAttrib1dNV_adr := GetProcAddress('glVertexAttrib1dNV');
    private z_VertexAttrib1dNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttrib1dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dNV(index: UInt32; x: real) :=
    z_VertexAttrib1dNV_ovr_0(index, x);
    
    private z_VertexAttrib1dvNV_adr := GetProcAddress('glVertexAttrib1dvNV');
    private z_VertexAttrib1dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib1dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib1dvNV_ovr_0(index, v);
    private z_VertexAttrib1dvNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dvNV_ovr_1(index, v);
    
    private z_VertexAttrib1fNV_adr := GetProcAddress('glVertexAttrib1fNV');
    private z_VertexAttrib1fNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single)>(z_VertexAttrib1fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fNV(index: UInt32; x: single) :=
    z_VertexAttrib1fNV_ovr_0(index, x);
    
    private z_VertexAttrib1fvNV_adr := GetProcAddress('glVertexAttrib1fvNV');
    private z_VertexAttrib1fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib1fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib1fvNV_ovr_0(index, v);
    private z_VertexAttrib1fvNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fvNV_ovr_1(index, v);
    
    private z_VertexAttrib1sNV_adr := GetProcAddress('glVertexAttrib1sNV');
    private z_VertexAttrib1sNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16)>(z_VertexAttrib1sNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sNV(index: UInt32; x: Int16) :=
    z_VertexAttrib1sNV_ovr_0(index, x);
    
    private z_VertexAttrib1svNV_adr := GetProcAddress('glVertexAttrib1svNV');
    private z_VertexAttrib1svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib1svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib1svNV_ovr_0(index, v);
    private z_VertexAttrib1svNV_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1svNV_ovr_1(index, v);
    
    private z_VertexAttrib2dNV_adr := GetProcAddress('glVertexAttrib2dNV');
    private z_VertexAttrib2dNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttrib2dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dNV(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2dNV_ovr_0(index, x, y);
    
    private z_VertexAttrib2dvNV_adr := GetProcAddress('glVertexAttrib2dvNV');
    private z_VertexAttrib2dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib2dvNV_adr);
    private z_VertexAttrib2dvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib2dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib2dvNV_ovr_0(index, v);
    private z_VertexAttrib2dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dvNV_ovr_2(index, v);
    
    private z_VertexAttrib2fNV_adr := GetProcAddress('glVertexAttrib2fNV');
    private z_VertexAttrib2fNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single)>(z_VertexAttrib2fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fNV(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2fNV_ovr_0(index, x, y);
    
    private z_VertexAttrib2fvNV_adr := GetProcAddress('glVertexAttrib2fvNV');
    private z_VertexAttrib2fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib2fvNV_adr);
    private z_VertexAttrib2fvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib2fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib2fvNV_ovr_0(index, v);
    private z_VertexAttrib2fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fvNV_ovr_2(index, v);
    
    private z_VertexAttrib2sNV_adr := GetProcAddress('glVertexAttrib2sNV');
    private z_VertexAttrib2sNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16)>(z_VertexAttrib2sNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sNV(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2sNV_ovr_0(index, x, y);
    
    private z_VertexAttrib2svNV_adr := GetProcAddress('glVertexAttrib2svNV');
    private z_VertexAttrib2svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib2svNV_adr);
    private z_VertexAttrib2svNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2svNV_ovr_0(index, v[0]) else
      z_VertexAttrib2svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib2svNV_ovr_0(index, v);
    private z_VertexAttrib2svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2svNV_ovr_2(index, v);
    
    private z_VertexAttrib3dNV_adr := GetProcAddress('glVertexAttrib3dNV');
    private z_VertexAttrib3dNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttrib3dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dNV(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3dNV_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3dvNV_adr := GetProcAddress('glVertexAttrib3dvNV');
    private z_VertexAttrib3dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib3dvNV_adr);
    private z_VertexAttrib3dvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib3dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib3dvNV_ovr_0(index, v);
    private z_VertexAttrib3dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dvNV_ovr_2(index, v);
    
    private z_VertexAttrib3fNV_adr := GetProcAddress('glVertexAttrib3fNV');
    private z_VertexAttrib3fNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single)>(z_VertexAttrib3fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fNV(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3fNV_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3fvNV_adr := GetProcAddress('glVertexAttrib3fvNV');
    private z_VertexAttrib3fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib3fvNV_adr);
    private z_VertexAttrib3fvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib3fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib3fvNV_ovr_0(index, v);
    private z_VertexAttrib3fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fvNV_ovr_2(index, v);
    
    private z_VertexAttrib3sNV_adr := GetProcAddress('glVertexAttrib3sNV');
    private z_VertexAttrib3sNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16)>(z_VertexAttrib3sNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sNV(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3sNV_ovr_0(index, x, y, z);
    
    private z_VertexAttrib3svNV_adr := GetProcAddress('glVertexAttrib3svNV');
    private z_VertexAttrib3svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib3svNV_adr);
    private z_VertexAttrib3svNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3svNV_ovr_0(index, v[0]) else
      z_VertexAttrib3svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib3svNV_ovr_0(index, v);
    private z_VertexAttrib3svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3svNV_ovr_2(index, v);
    
    private z_VertexAttrib4dNV_adr := GetProcAddress('glVertexAttrib4dNV');
    private z_VertexAttrib4dNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttrib4dNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dNV(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4dNV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4dvNV_adr := GetProcAddress('glVertexAttrib4dvNV');
    private z_VertexAttrib4dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib4dvNV_adr);
    private z_VertexAttrib4dvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib4dvNV_ovr_0(index, v);
    private z_VertexAttrib4dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dvNV_ovr_2(index, v);
    
    private z_VertexAttrib4fNV_adr := GetProcAddress('glVertexAttrib4fNV');
    private z_VertexAttrib4fNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: single; y: single; z: single; w: single)>(z_VertexAttrib4fNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fNV(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4fNV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4fvNV_adr := GetProcAddress('glVertexAttrib4fvNV');
    private z_VertexAttrib4fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib4fvNV_adr);
    private z_VertexAttrib4fvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib4fvNV_ovr_0(index, v);
    private z_VertexAttrib4fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fvNV_ovr_2(index, v);
    
    private z_VertexAttrib4sNV_adr := GetProcAddress('glVertexAttrib4sNV');
    private z_VertexAttrib4sNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16)>(z_VertexAttrib4sNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sNV(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4sNV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4svNV_adr := GetProcAddress('glVertexAttrib4svNV');
    private z_VertexAttrib4svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4svNV_adr);
    private z_VertexAttrib4svNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4svNV_ovr_0(index, v[0]) else
      z_VertexAttrib4svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib4svNV_ovr_0(index, v);
    private z_VertexAttrib4svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4svNV_ovr_2(index, v);
    
    private z_VertexAttrib4ubNV_adr := GetProcAddress('glVertexAttrib4ubNV');
    private z_VertexAttrib4ubNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte)>(z_VertexAttrib4ubNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubNV(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4ubNV_ovr_0(index, x, y, z, w);
    
    private z_VertexAttrib4ubvNV_adr := GetProcAddress('glVertexAttrib4ubvNV');
    private z_VertexAttrib4ubvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4ubvNV_adr);
    private z_VertexAttrib4ubvNV_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvNV(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4ubvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvNV(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubvNV_ovr_0(index, v);
    private z_VertexAttrib4ubvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubvNV_ovr_2(index, v);
    
    private z_VertexAttribs1dvNV_adr := GetProcAddress('glVertexAttribs1dvNV');
    private z_VertexAttribs1dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: real)>(z_VertexAttribs1dvNV_adr);
    private z_VertexAttribs1dvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs1dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs1dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs1dvNV_ovr_0(index, count, v);
    private z_VertexAttribs1dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs1dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs1dvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs1fvNV_adr := GetProcAddress('glVertexAttribs1fvNV');
    private z_VertexAttribs1fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: single)>(z_VertexAttribs1fvNV_adr);
    private z_VertexAttribs1fvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs1fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs1fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs1fvNV_ovr_0(index, count, v);
    private z_VertexAttribs1fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs1fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs1fvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs1svNV_adr := GetProcAddress('glVertexAttribs1svNV');
    private z_VertexAttribs1svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: Int16)>(z_VertexAttribs1svNV_adr);
    private z_VertexAttribs1svNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs1svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs1svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs1svNV_ovr_0(index, count, v);
    private z_VertexAttribs1svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs1svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs1svNV_ovr_2(index, count, v);
    
    private z_VertexAttribs2dvNV_adr := GetProcAddress('glVertexAttribs2dvNV');
    private z_VertexAttribs2dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: real)>(z_VertexAttribs2dvNV_adr);
    private z_VertexAttribs2dvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs2dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs2dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs2dvNV_ovr_0(index, count, v);
    private z_VertexAttribs2dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs2dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs2dvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs2fvNV_adr := GetProcAddress('glVertexAttribs2fvNV');
    private z_VertexAttribs2fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: single)>(z_VertexAttribs2fvNV_adr);
    private z_VertexAttribs2fvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs2fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs2fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs2fvNV_ovr_0(index, count, v);
    private z_VertexAttribs2fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs2fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs2fvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs2svNV_adr := GetProcAddress('glVertexAttribs2svNV');
    private z_VertexAttribs2svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: Int16)>(z_VertexAttribs2svNV_adr);
    private z_VertexAttribs2svNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs2svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs2svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs2svNV_ovr_0(index, count, v);
    private z_VertexAttribs2svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs2svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs2svNV_ovr_2(index, count, v);
    
    private z_VertexAttribs3dvNV_adr := GetProcAddress('glVertexAttribs3dvNV');
    private z_VertexAttribs3dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: real)>(z_VertexAttribs3dvNV_adr);
    private z_VertexAttribs3dvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs3dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs3dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs3dvNV_ovr_0(index, count, v);
    private z_VertexAttribs3dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs3dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs3dvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs3fvNV_adr := GetProcAddress('glVertexAttribs3fvNV');
    private z_VertexAttribs3fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: single)>(z_VertexAttribs3fvNV_adr);
    private z_VertexAttribs3fvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs3fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs3fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs3fvNV_ovr_0(index, count, v);
    private z_VertexAttribs3fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs3fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs3fvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs3svNV_adr := GetProcAddress('glVertexAttribs3svNV');
    private z_VertexAttribs3svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: Int16)>(z_VertexAttribs3svNV_adr);
    private z_VertexAttribs3svNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs3svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs3svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs3svNV_ovr_0(index, count, v);
    private z_VertexAttribs3svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs3svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs3svNV_ovr_2(index, count, v);
    
    private z_VertexAttribs4dvNV_adr := GetProcAddress('glVertexAttribs4dvNV');
    private z_VertexAttribs4dvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: real)>(z_VertexAttribs4dvNV_adr);
    private z_VertexAttribs4dvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs4dvNV_ovr_0(index, count, v);
    private z_VertexAttribs4dvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4dvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4dvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs4fvNV_adr := GetProcAddress('glVertexAttribs4fvNV');
    private z_VertexAttribs4fvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: single)>(z_VertexAttribs4fvNV_adr);
    private z_VertexAttribs4fvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs4fvNV_ovr_0(index, count, v);
    private z_VertexAttribs4fvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4fvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4fvNV_ovr_2(index, count, v);
    
    private z_VertexAttribs4svNV_adr := GetProcAddress('glVertexAttribs4svNV');
    private z_VertexAttribs4svNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: Int16)>(z_VertexAttribs4svNV_adr);
    private z_VertexAttribs4svNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs4svNV_ovr_0(index, count, v);
    private z_VertexAttribs4svNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4svNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4svNV_ovr_2(index, count, v);
    
    private z_VertexAttribs4ubvNV_adr := GetProcAddress('glVertexAttribs4ubvNV');
    private z_VertexAttribs4ubvNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; count: Int32; var v: Byte)>(z_VertexAttribs4ubvNV_adr);
    private z_VertexAttribs4ubvNV_ovr_0_anh0001 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4ubvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4ubvNV(index: UInt32; count: Int32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4ubvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4ubvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4ubvNV(index: UInt32; count: Int32; var v: Byte) :=
    z_VertexAttribs4ubvNV_ovr_0(index, count, v);
    private z_VertexAttribs4ubvNV_ovr_2 := GetProcOrNil&<procedure(index: UInt32; count: Int32; v: IntPtr)>(z_VertexAttribs4ubvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4ubvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4ubvNV_ovr_2(index, count, v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexProgram4NV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vertex_program4';
    
    private z_VertexAttribI1iEXT_adr := GetProcAddress('glVertexAttribI1iEXT');
    private z_VertexAttribI1iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32)>(z_VertexAttribI1iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iEXT(index: UInt32; x: Int32) :=
    z_VertexAttribI1iEXT_ovr_0(index, x);
    
    private z_VertexAttribI2iEXT_adr := GetProcAddress('glVertexAttribI2iEXT');
    private z_VertexAttribI2iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32)>(z_VertexAttribI2iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iEXT(index: UInt32; x: Int32; y: Int32) :=
    z_VertexAttribI2iEXT_ovr_0(index, x, y);
    
    private z_VertexAttribI3iEXT_adr := GetProcAddress('glVertexAttribI3iEXT');
    private z_VertexAttribI3iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32)>(z_VertexAttribI3iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iEXT(index: UInt32; x: Int32; y: Int32; z: Int32) :=
    z_VertexAttribI3iEXT_ovr_0(index, x, y, z);
    
    private z_VertexAttribI4iEXT_adr := GetProcAddress('glVertexAttribI4iEXT');
    private z_VertexAttribI4iEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_VertexAttribI4iEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iEXT(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexAttribI4iEXT_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribI1uiEXT_adr := GetProcAddress('glVertexAttribI1uiEXT');
    private z_VertexAttribI1uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32)>(z_VertexAttribI1uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiEXT(index: UInt32; x: UInt32) :=
    z_VertexAttribI1uiEXT_ovr_0(index, x);
    
    private z_VertexAttribI2uiEXT_adr := GetProcAddress('glVertexAttribI2uiEXT');
    private z_VertexAttribI2uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32)>(z_VertexAttribI2uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiEXT(index: UInt32; x: UInt32; y: UInt32) :=
    z_VertexAttribI2uiEXT_ovr_0(index, x, y);
    
    private z_VertexAttribI3uiEXT_adr := GetProcAddress('glVertexAttribI3uiEXT');
    private z_VertexAttribI3uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32)>(z_VertexAttribI3uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiEXT(index: UInt32; x: UInt32; y: UInt32; z: UInt32) :=
    z_VertexAttribI3uiEXT_ovr_0(index, x, y, z);
    
    private z_VertexAttribI4uiEXT_adr := GetProcAddress('glVertexAttribI4uiEXT');
    private z_VertexAttribI4uiEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_VertexAttribI4uiEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiEXT(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_VertexAttribI4uiEXT_ovr_0(index, x, y, z, w);
    
    private z_VertexAttribI1ivEXT_adr := GetProcAddress('glVertexAttribI1ivEXT');
    private z_VertexAttribI1ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI1ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI1ivEXT_ovr_0(index, v);
    private z_VertexAttribI1ivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1ivEXT_ovr_1(index, v);
    
    private z_VertexAttribI2ivEXT_adr := GetProcAddress('glVertexAttribI2ivEXT');
    private z_VertexAttribI2ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI2ivEXT_adr);
    private z_VertexAttribI2ivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI2ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI2ivEXT_ovr_0(index, v);
    private z_VertexAttribI2ivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2ivEXT_ovr_2(index, v);
    
    private z_VertexAttribI3ivEXT_adr := GetProcAddress('glVertexAttribI3ivEXT');
    private z_VertexAttribI3ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI3ivEXT_adr);
    private z_VertexAttribI3ivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI3ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI3ivEXT_ovr_0(index, v);
    private z_VertexAttribI3ivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3ivEXT_ovr_2(index, v);
    
    private z_VertexAttribI4ivEXT_adr := GetProcAddress('glVertexAttribI4ivEXT');
    private z_VertexAttribI4ivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI4ivEXT_adr);
    private z_VertexAttribI4ivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI4ivEXT_ovr_0(index, v);
    private z_VertexAttribI4ivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ivEXT_ovr_2(index, v);
    
    private z_VertexAttribI1uivEXT_adr := GetProcAddress('glVertexAttribI1uivEXT');
    private z_VertexAttribI1uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI1uivEXT_ovr_0(index, v);
    private z_VertexAttribI1uivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1uivEXT_ovr_1(index, v);
    
    private z_VertexAttribI2uivEXT_adr := GetProcAddress('glVertexAttribI2uivEXT');
    private z_VertexAttribI2uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI2uivEXT_adr);
    private z_VertexAttribI2uivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI2uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI2uivEXT_ovr_0(index, v);
    private z_VertexAttribI2uivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2uivEXT_ovr_2(index, v);
    
    private z_VertexAttribI3uivEXT_adr := GetProcAddress('glVertexAttribI3uivEXT');
    private z_VertexAttribI3uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI3uivEXT_adr);
    private z_VertexAttribI3uivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI3uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI3uivEXT_ovr_0(index, v);
    private z_VertexAttribI3uivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3uivEXT_ovr_2(index, v);
    
    private z_VertexAttribI4uivEXT_adr := GetProcAddress('glVertexAttribI4uivEXT');
    private z_VertexAttribI4uivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI4uivEXT_adr);
    private z_VertexAttribI4uivEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI4uivEXT_ovr_0(index, v);
    private z_VertexAttribI4uivEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4uivEXT_ovr_2(index, v);
    
    private z_VertexAttribI4bvEXT_adr := GetProcAddress('glVertexAttribI4bvEXT');
    private z_VertexAttribI4bvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttribI4bvEXT_adr);
    private z_VertexAttribI4bvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4bvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4bvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; var v: SByte) :=
    z_VertexAttribI4bvEXT_ovr_0(index, v);
    private z_VertexAttribI4bvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4bvEXT_ovr_2(index, v);
    
    private z_VertexAttribI4svEXT_adr := GetProcAddress('glVertexAttribI4svEXT');
    private z_VertexAttribI4svEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttribI4svEXT_adr);
    private z_VertexAttribI4svEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4svEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4svEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; var v: Int16) :=
    z_VertexAttribI4svEXT_ovr_0(index, v);
    private z_VertexAttribI4svEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4svEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4svEXT_ovr_2(index, v);
    
    private z_VertexAttribI4ubvEXT_adr := GetProcAddress('glVertexAttribI4ubvEXT');
    private z_VertexAttribI4ubvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttribI4ubvEXT_adr);
    private z_VertexAttribI4ubvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ubvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4ubvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; var v: Byte) :=
    z_VertexAttribI4ubvEXT_ovr_0(index, v);
    private z_VertexAttribI4ubvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ubvEXT_ovr_2(index, v);
    
    private z_VertexAttribI4usvEXT_adr := GetProcAddress('glVertexAttribI4usvEXT');
    private z_VertexAttribI4usvEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttribI4usvEXT_adr);
    private z_VertexAttribI4usvEXT_ovr_0_anh001 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4usvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4usvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; var v: UInt16) :=
    z_VertexAttribI4usvEXT_ovr_0(index, v);
    private z_VertexAttribI4usvEXT_ovr_2 := GetProcOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4usvEXT_ovr_2(index, v);
    
    private z_VertexAttribIPointerEXT_adr := GetProcAddress('glVertexAttribIPointerEXT');
    private z_VertexAttribIPointerEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32; pointer: IntPtr)>(z_VertexAttribIPointerEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIPointerEXT(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribIPointerEXT_ovr_0(index, size, &type, stride, pointer);
    
    private z_GetVertexAttribIivEXT_adr := GetProcAddress('glGetVertexAttribIivEXT');
    private z_GetVertexAttribIivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: Int32)>(z_GetVertexAttribIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; var &params: Int32) :=
    z_GetVertexAttribIivEXT_ovr_0(index, pname, &params);
    private z_GetVertexAttribIivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIivEXT_ovr_1(index, pname, &params);
    
    private z_GetVertexAttribIuivEXT_adr := GetProcAddress('glGetVertexAttribIuivEXT');
    private z_GetVertexAttribIuivEXT_ovr_0 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: UInt32)>(z_GetVertexAttribIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; var &params: UInt32) :=
    z_GetVertexAttribIuivEXT_ovr_0(index, pname, &params);
    private z_GetVertexAttribIuivEXT_ovr_1 := GetProcOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIuivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIuivEXT_ovr_1(index, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVideoCaptureNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_video_capture';
    
    private z_BeginVideoCaptureNV_adr := GetProcAddress('glBeginVideoCaptureNV');
    private z_BeginVideoCaptureNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32)>(z_BeginVideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginVideoCaptureNV(video_capture_slot: UInt32) :=
    z_BeginVideoCaptureNV_ovr_0(video_capture_slot);
    
    private z_BindVideoCaptureStreamBufferNV_adr := GetProcAddress('glBindVideoCaptureStreamBufferNV');
    private z_BindVideoCaptureStreamBufferNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; offset: IntPtr)>(z_BindVideoCaptureStreamBufferNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVideoCaptureStreamBufferNV(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; offset: IntPtr) :=
    z_BindVideoCaptureStreamBufferNV_ovr_0(video_capture_slot, stream, frame_region, offset);
    
    private z_BindVideoCaptureStreamTextureNV_adr := GetProcAddress('glBindVideoCaptureStreamTextureNV');
    private z_BindVideoCaptureStreamTextureNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; target: DummyEnum; texture: gl_texture)>(z_BindVideoCaptureStreamTextureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVideoCaptureStreamTextureNV(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; target: DummyEnum; texture: gl_texture) :=
    z_BindVideoCaptureStreamTextureNV_ovr_0(video_capture_slot, stream, frame_region, target, texture);
    
    private z_EndVideoCaptureNV_adr := GetProcAddress('glEndVideoCaptureNV');
    private z_EndVideoCaptureNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32)>(z_EndVideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndVideoCaptureNV(video_capture_slot: UInt32) :=
    z_EndVideoCaptureNV_ovr_0(video_capture_slot);
    
    private z_GetVideoCaptureivNV_adr := GetProcAddress('glGetVideoCaptureivNV');
    private z_GetVideoCaptureivNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; pname: DummyEnum; var &params: Int32)>(z_GetVideoCaptureivNV_adr);
    private z_GetVideoCaptureivNV_ovr_0_anh0001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureivNV(video_capture_slot: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureivNV_ovr_0(video_capture_slot, pname, &params[0]) else
      z_GetVideoCaptureivNV_ovr_0_anh0001(video_capture_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureivNV(video_capture_slot: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetVideoCaptureivNV_ovr_0(video_capture_slot, pname, &params);
    private z_GetVideoCaptureivNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureivNV(video_capture_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureivNV_ovr_2(video_capture_slot, pname, &params);
    
    private z_GetVideoCaptureStreamivNV_adr := GetProcAddress('glGetVideoCaptureStreamivNV');
    private z_GetVideoCaptureStreamivNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32)>(z_GetVideoCaptureStreamivNV_adr);
    private z_GetVideoCaptureStreamivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureStreamivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureStreamivNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_GetVideoCaptureStreamivNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetVideoCaptureStreamivNV_ovr_0(video_capture_slot, stream, pname, &params);
    private z_GetVideoCaptureStreamivNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureStreamivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureStreamivNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private z_GetVideoCaptureStreamfvNV_adr := GetProcAddress('glGetVideoCaptureStreamfvNV');
    private z_GetVideoCaptureStreamfvNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single)>(z_GetVideoCaptureStreamfvNV_adr);
    private z_GetVideoCaptureStreamfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureStreamfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureStreamfvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_GetVideoCaptureStreamfvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single) :=
    z_GetVideoCaptureStreamfvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private z_GetVideoCaptureStreamfvNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureStreamfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureStreamfvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private z_GetVideoCaptureStreamdvNV_adr := GetProcAddress('glGetVideoCaptureStreamdvNV');
    private z_GetVideoCaptureStreamdvNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real)>(z_GetVideoCaptureStreamdvNV_adr);
    private z_GetVideoCaptureStreamdvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureStreamdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureStreamdvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_GetVideoCaptureStreamdvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real) :=
    z_GetVideoCaptureStreamdvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private z_GetVideoCaptureStreamdvNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_GetVideoCaptureStreamdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureStreamdvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private z_VideoCaptureNV_adr := GetProcAddress('glVideoCaptureNV');
    private z_VideoCaptureNV_ovr_0 := GetProcOrNil&<function(video_capture_slot: UInt32; var sequence_num: UInt32; var capture_time: UInt64): DummyEnum>(z_VideoCaptureNV_adr);
    private z_VideoCaptureNV_ovr_0_anh0010 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum>(z_VideoCaptureNV_adr);
    private z_VideoCaptureNV_ovr_0_anh0001 := GetProcOrNil&<function(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: IntPtr): DummyEnum>(z_VideoCaptureNV_adr);
    private z_VideoCaptureNV_ovr_0_anh0011 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum>(z_VideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: array of UInt32; capture_time: array of UInt64): DummyEnum :=
    if (sequence_num<>nil) and (sequence_num.Length<>0) then
      if (capture_time<>nil) and (capture_time.Length<>0) then
        z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num[0], capture_time[0]) else
        z_VideoCaptureNV_ovr_0_anh0001(video_capture_slot, sequence_num[0], IntPtr.Zero) else
      if (capture_time<>nil) and (capture_time.Length<>0) then
        z_VideoCaptureNV_ovr_0_anh0010(video_capture_slot, IntPtr.Zero, capture_time[0]) else
        z_VideoCaptureNV_ovr_0_anh0011(video_capture_slot, IntPtr.Zero, IntPtr.Zero);
    private z_VideoCaptureNV_ovr_1_anh0010 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum>(z_VideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: array of UInt32; var capture_time: UInt64): DummyEnum :=
    if (sequence_num<>nil) and (sequence_num.Length<>0) then
      z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num[0], capture_time) else
      z_VideoCaptureNV_ovr_0_anh0010(video_capture_slot, IntPtr.Zero, capture_time);
    private z_VideoCaptureNV_ovr_2 := GetProcOrNil&<function(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: IntPtr): DummyEnum>(z_VideoCaptureNV_adr);
    private z_VideoCaptureNV_ovr_2_anh0010 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum>(z_VideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: array of UInt32; capture_time: IntPtr): DummyEnum :=
    if (sequence_num<>nil) and (sequence_num.Length<>0) then
      z_VideoCaptureNV_ovr_2(video_capture_slot, sequence_num[0], capture_time) else
      z_VideoCaptureNV_ovr_2_anh0010(video_capture_slot, IntPtr.Zero, capture_time);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: array of UInt64): DummyEnum :=
    if (capture_time<>nil) and (capture_time.Length<>0) then
      z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num, capture_time[0]) else
      z_VideoCaptureNV_ovr_0_anh0001(video_capture_slot, sequence_num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; var sequence_num: UInt32; var capture_time: UInt64): DummyEnum :=
    z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num, capture_time);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: IntPtr): DummyEnum :=
    z_VideoCaptureNV_ovr_2(video_capture_slot, sequence_num, capture_time);
    private z_VideoCaptureNV_ovr_6 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum>(z_VideoCaptureNV_adr);
    private z_VideoCaptureNV_ovr_6_anh0001 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum>(z_VideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: array of UInt64): DummyEnum :=
    if (capture_time<>nil) and (capture_time.Length<>0) then
      z_VideoCaptureNV_ovr_6(video_capture_slot, sequence_num, capture_time[0]) else
      z_VideoCaptureNV_ovr_6_anh0001(video_capture_slot, sequence_num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum :=
    z_VideoCaptureNV_ovr_6(video_capture_slot, sequence_num, capture_time);
    private z_VideoCaptureNV_ovr_8 := GetProcOrNil&<function(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum>(z_VideoCaptureNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum :=
    z_VideoCaptureNV_ovr_8(video_capture_slot, sequence_num, capture_time);
    
    private z_VideoCaptureStreamParameterivNV_adr := GetProcAddress('glVideoCaptureStreamParameterivNV');
    private z_VideoCaptureStreamParameterivNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32)>(z_VideoCaptureStreamParameterivNV_adr);
    private z_VideoCaptureStreamParameterivNV_ovr_0_anh00001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_VideoCaptureStreamParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_VideoCaptureStreamParameterivNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_VideoCaptureStreamParameterivNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_VideoCaptureStreamParameterivNV_ovr_0(video_capture_slot, stream, pname, &params);
    private z_VideoCaptureStreamParameterivNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_VideoCaptureStreamParameterivNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_VideoCaptureStreamParameterivNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private z_VideoCaptureStreamParameterfvNV_adr := GetProcAddress('glVideoCaptureStreamParameterfvNV');
    private z_VideoCaptureStreamParameterfvNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single)>(z_VideoCaptureStreamParameterfvNV_adr);
    private z_VideoCaptureStreamParameterfvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_VideoCaptureStreamParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_VideoCaptureStreamParameterfvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_VideoCaptureStreamParameterfvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single) :=
    z_VideoCaptureStreamParameterfvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private z_VideoCaptureStreamParameterfvNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_VideoCaptureStreamParameterfvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_VideoCaptureStreamParameterfvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private z_VideoCaptureStreamParameterdvNV_adr := GetProcAddress('glVideoCaptureStreamParameterdvNV');
    private z_VideoCaptureStreamParameterdvNV_ovr_0 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real)>(z_VideoCaptureStreamParameterdvNV_adr);
    private z_VideoCaptureStreamParameterdvNV_ovr_0_anh00001 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_VideoCaptureStreamParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_VideoCaptureStreamParameterdvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_VideoCaptureStreamParameterdvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real) :=
    z_VideoCaptureStreamParameterdvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private z_VideoCaptureStreamParameterdvNV_ovr_2 := GetProcOrNil&<procedure(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr)>(z_VideoCaptureStreamParameterdvNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_VideoCaptureStreamParameterdvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glViewportSwizzleNV = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_viewport_swizzle';
    
    private z_ViewportSwizzleNV_adr := GetProcAddress('glViewportSwizzleNV');
    private z_ViewportSwizzleNV_ovr_0 := GetProcOrNil&<procedure(index: UInt32; swizzlex: DummyEnum; swizzley: DummyEnum; swizzlez: DummyEnum; swizzlew: DummyEnum)>(z_ViewportSwizzleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportSwizzleNV(index: UInt32; swizzlex: DummyEnum; swizzley: DummyEnum; swizzlez: DummyEnum; swizzlew: DummyEnum) :=
    z_ViewportSwizzleNV_ovr_0(index, swizzlex, swizzley, swizzlez, swizzlew);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glByteCoordinatesOES = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OES_byte_coordinates';
    
    private z_MultiTexCoord1bOES_adr := GetProcAddress('glMultiTexCoord1bOES');
    private z_MultiTexCoord1bOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: SByte)>(z_MultiTexCoord1bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bOES(texture: TextureUnit; s: SByte) :=
    z_MultiTexCoord1bOES_ovr_0(texture, s);
    
    private z_MultiTexCoord1bvOES_adr := GetProcAddress('glMultiTexCoord1bvOES');
    private z_MultiTexCoord1bvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: SByte)>(z_MultiTexCoord1bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord1bvOES_ovr_0(texture, coords);
    private z_MultiTexCoord1bvOES_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord1bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord1bvOES_ovr_1(texture, coords);
    
    private z_MultiTexCoord2bOES_adr := GetProcAddress('glMultiTexCoord2bOES');
    private z_MultiTexCoord2bOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: SByte; t: SByte)>(z_MultiTexCoord2bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bOES(texture: TextureUnit; s: SByte; t: SByte) :=
    z_MultiTexCoord2bOES_ovr_0(texture, s, t);
    
    private z_MultiTexCoord2bvOES_adr := GetProcAddress('glMultiTexCoord2bvOES');
    private z_MultiTexCoord2bvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: SByte)>(z_MultiTexCoord2bvOES_adr);
    private z_MultiTexCoord2bvOES_ovr_0_anh001 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord2bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord2bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord2bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord2bvOES_ovr_0(texture, coords);
    private z_MultiTexCoord2bvOES_ovr_2 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord2bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord2bvOES_ovr_2(texture, coords);
    
    private z_MultiTexCoord3bOES_adr := GetProcAddress('glMultiTexCoord3bOES');
    private z_MultiTexCoord3bOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: SByte; t: SByte; r: SByte)>(z_MultiTexCoord3bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bOES(texture: TextureUnit; s: SByte; t: SByte; r: SByte) :=
    z_MultiTexCoord3bOES_ovr_0(texture, s, t, r);
    
    private z_MultiTexCoord3bvOES_adr := GetProcAddress('glMultiTexCoord3bvOES');
    private z_MultiTexCoord3bvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: SByte)>(z_MultiTexCoord3bvOES_adr);
    private z_MultiTexCoord3bvOES_ovr_0_anh001 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord3bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord3bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord3bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord3bvOES_ovr_0(texture, coords);
    private z_MultiTexCoord3bvOES_ovr_2 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord3bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord3bvOES_ovr_2(texture, coords);
    
    private z_MultiTexCoord4bOES_adr := GetProcAddress('glMultiTexCoord4bOES');
    private z_MultiTexCoord4bOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: SByte; t: SByte; r: SByte; q: SByte)>(z_MultiTexCoord4bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bOES(texture: TextureUnit; s: SByte; t: SByte; r: SByte; q: SByte) :=
    z_MultiTexCoord4bOES_ovr_0(texture, s, t, r, q);
    
    private z_MultiTexCoord4bvOES_adr := GetProcAddress('glMultiTexCoord4bvOES');
    private z_MultiTexCoord4bvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: SByte)>(z_MultiTexCoord4bvOES_adr);
    private z_MultiTexCoord4bvOES_ovr_0_anh001 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord4bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord4bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord4bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord4bvOES_ovr_0(texture, coords);
    private z_MultiTexCoord4bvOES_ovr_2 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord4bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord4bvOES_ovr_2(texture, coords);
    
    private z_TexCoord1bOES_adr := GetProcAddress('glTexCoord1bOES');
    private z_TexCoord1bOES_ovr_0 := GetProcOrNil&<procedure(s: SByte)>(z_TexCoord1bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bOES(s: SByte) :=
    z_TexCoord1bOES_ovr_0(s);
    
    private z_TexCoord1bvOES_adr := GetProcAddress('glTexCoord1bvOES');
    private z_TexCoord1bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_TexCoord1bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bvOES(var coords: SByte) :=
    z_TexCoord1bvOES_ovr_0(coords);
    private z_TexCoord1bvOES_ovr_1 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord1bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bvOES(coords: IntPtr) :=
    z_TexCoord1bvOES_ovr_1(coords);
    
    private z_TexCoord2bOES_adr := GetProcAddress('glTexCoord2bOES');
    private z_TexCoord2bOES_ovr_0 := GetProcOrNil&<procedure(s: SByte; t: SByte)>(z_TexCoord2bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bOES(s: SByte; t: SByte) :=
    z_TexCoord2bOES_ovr_0(s, t);
    
    private z_TexCoord2bvOES_adr := GetProcAddress('glTexCoord2bvOES');
    private z_TexCoord2bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_TexCoord2bvOES_adr);
    private z_TexCoord2bvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord2bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord2bvOES_ovr_0(coords[0]) else
      z_TexCoord2bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bvOES(var coords: SByte) :=
    z_TexCoord2bvOES_ovr_0(coords);
    private z_TexCoord2bvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord2bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bvOES(coords: IntPtr) :=
    z_TexCoord2bvOES_ovr_2(coords);
    
    private z_TexCoord3bOES_adr := GetProcAddress('glTexCoord3bOES');
    private z_TexCoord3bOES_ovr_0 := GetProcOrNil&<procedure(s: SByte; t: SByte; r: SByte)>(z_TexCoord3bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bOES(s: SByte; t: SByte; r: SByte) :=
    z_TexCoord3bOES_ovr_0(s, t, r);
    
    private z_TexCoord3bvOES_adr := GetProcAddress('glTexCoord3bvOES');
    private z_TexCoord3bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_TexCoord3bvOES_adr);
    private z_TexCoord3bvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord3bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord3bvOES_ovr_0(coords[0]) else
      z_TexCoord3bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bvOES(var coords: SByte) :=
    z_TexCoord3bvOES_ovr_0(coords);
    private z_TexCoord3bvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord3bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bvOES(coords: IntPtr) :=
    z_TexCoord3bvOES_ovr_2(coords);
    
    private z_TexCoord4bOES_adr := GetProcAddress('glTexCoord4bOES');
    private z_TexCoord4bOES_ovr_0 := GetProcOrNil&<procedure(s: SByte; t: SByte; r: SByte; q: SByte)>(z_TexCoord4bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bOES(s: SByte; t: SByte; r: SByte; q: SByte) :=
    z_TexCoord4bOES_ovr_0(s, t, r, q);
    
    private z_TexCoord4bvOES_adr := GetProcAddress('glTexCoord4bvOES');
    private z_TexCoord4bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_TexCoord4bvOES_adr);
    private z_TexCoord4bvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord4bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord4bvOES_ovr_0(coords[0]) else
      z_TexCoord4bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bvOES(var coords: SByte) :=
    z_TexCoord4bvOES_ovr_0(coords);
    private z_TexCoord4bvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord4bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bvOES(coords: IntPtr) :=
    z_TexCoord4bvOES_ovr_2(coords);
    
    private z_Vertex2bOES_adr := GetProcAddress('glVertex2bOES');
    private z_Vertex2bOES_ovr_0 := GetProcOrNil&<procedure(x: SByte; y: SByte)>(z_Vertex2bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bOES(x: SByte; y: SByte) :=
    z_Vertex2bOES_ovr_0(x, y);
    
    private z_Vertex2bvOES_adr := GetProcAddress('glVertex2bvOES');
    private z_Vertex2bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_Vertex2bvOES_adr);
    private z_Vertex2bvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex2bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex2bvOES_ovr_0(coords[0]) else
      z_Vertex2bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bvOES(var coords: SByte) :=
    z_Vertex2bvOES_ovr_0(coords);
    private z_Vertex2bvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex2bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bvOES(coords: IntPtr) :=
    z_Vertex2bvOES_ovr_2(coords);
    
    private z_Vertex3bOES_adr := GetProcAddress('glVertex3bOES');
    private z_Vertex3bOES_ovr_0 := GetProcOrNil&<procedure(x: SByte; y: SByte; z: SByte)>(z_Vertex3bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bOES(x: SByte; y: SByte; z: SByte) :=
    z_Vertex3bOES_ovr_0(x, y, z);
    
    private z_Vertex3bvOES_adr := GetProcAddress('glVertex3bvOES');
    private z_Vertex3bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_Vertex3bvOES_adr);
    private z_Vertex3bvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex3bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex3bvOES_ovr_0(coords[0]) else
      z_Vertex3bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bvOES(var coords: SByte) :=
    z_Vertex3bvOES_ovr_0(coords);
    private z_Vertex3bvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex3bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bvOES(coords: IntPtr) :=
    z_Vertex3bvOES_ovr_2(coords);
    
    private z_Vertex4bOES_adr := GetProcAddress('glVertex4bOES');
    private z_Vertex4bOES_ovr_0 := GetProcOrNil&<procedure(x: SByte; y: SByte; z: SByte; w: SByte)>(z_Vertex4bOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bOES(x: SByte; y: SByte; z: SByte; w: SByte) :=
    z_Vertex4bOES_ovr_0(x, y, z, w);
    
    private z_Vertex4bvOES_adr := GetProcAddress('glVertex4bvOES');
    private z_Vertex4bvOES_ovr_0 := GetProcOrNil&<procedure(var coords: SByte)>(z_Vertex4bvOES_adr);
    private z_Vertex4bvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex4bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex4bvOES_ovr_0(coords[0]) else
      z_Vertex4bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bvOES(var coords: SByte) :=
    z_Vertex4bvOES_ovr_0(coords);
    private z_Vertex4bvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex4bvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bvOES(coords: IntPtr) :=
    z_Vertex4bvOES_ovr_2(coords);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFixedPointOES = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OES_fixed_point';
    
    private z_AlphaFuncxOES_adr := GetProcAddress('glAlphaFuncxOES');
    private z_AlphaFuncxOES_ovr_0 := GetProcOrNil&<procedure(func: AlphaFunction; ref: Fixed)>(z_AlphaFuncxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFuncxOES(func: AlphaFunction; ref: Fixed) :=
    z_AlphaFuncxOES_ovr_0(func, ref);
    
    private z_ClearColorxOES_adr := GetProcAddress('glClearColorxOES');
    private z_ClearColorxOES_ovr_0 := GetProcOrNil&<procedure(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed)>(z_ClearColorxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColorxOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_ClearColorxOES_ovr_0(red, green, blue, alpha);
    
    private z_ClearDepthxOES_adr := GetProcAddress('glClearDepthxOES');
    private z_ClearDepthxOES_ovr_0 := GetProcOrNil&<procedure(depth: Fixed)>(z_ClearDepthxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthxOES(depth: Fixed) :=
    z_ClearDepthxOES_ovr_0(depth);
    
    private z_ClipPlanexOES_adr := GetProcAddress('glClipPlanexOES');
    private z_ClipPlanexOES_ovr_0 := GetProcOrNil&<procedure(plane: ClipPlaneName; var equation: Fixed)>(z_ClipPlanexOES_adr);
    private z_ClipPlanexOES_ovr_0_anh001 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_ClipPlanexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanexOES(plane: ClipPlaneName; equation: array of Fixed) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ClipPlanexOES_ovr_0(plane, equation[0]) else
      z_ClipPlanexOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanexOES(plane: ClipPlaneName; var equation: Fixed) :=
    z_ClipPlanexOES_ovr_0(plane, equation);
    private z_ClipPlanexOES_ovr_2 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_ClipPlanexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanexOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_ClipPlanexOES_ovr_2(plane, equation);
    
    private z_Color4xOES_adr := GetProcAddress('glColor4xOES');
    private z_Color4xOES_ovr_0 := GetProcOrNil&<procedure(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed)>(z_Color4xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_Color4xOES_ovr_0(red, green, blue, alpha);
    
    private z_DepthRangexOES_adr := GetProcAddress('glDepthRangexOES');
    private z_DepthRangexOES_ovr_0 := GetProcOrNil&<procedure(n: Fixed; f: Fixed)>(z_DepthRangexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangexOES(n: Fixed; f: Fixed) :=
    z_DepthRangexOES_ovr_0(n, f);
    
    private z_FogxOES_adr := GetProcAddress('glFogxOES');
    private z_FogxOES_ovr_0 := GetProcOrNil&<procedure(pname: FogPName; param: Fixed)>(z_FogxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxOES(pname: FogPName; param: Fixed) :=
    z_FogxOES_ovr_0(pname, param);
    
    private z_FogxvOES_adr := GetProcAddress('glFogxvOES');
    private z_FogxvOES_ovr_0 := GetProcOrNil&<procedure(pname: FogPName; var param: Fixed)>(z_FogxvOES_adr);
    private z_FogxvOES_ovr_0_anh001 := GetProcOrNil&<procedure(pname: FogPName; param: IntPtr)>(z_FogxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxvOES(pname: FogPName; param: array of Fixed) :=
    if (param<>nil) and (param.Length<>0) then
      z_FogxvOES_ovr_0(pname, param[0]) else
      z_FogxvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxvOES(pname: FogPName; var param: Fixed) :=
    z_FogxvOES_ovr_0(pname, param);
    private z_FogxvOES_ovr_2 := GetProcOrNil&<procedure(pname: FogPName; param: IntPtr)>(z_FogxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxvOES(pname: FogPName; param: IntPtr) :=
    z_FogxvOES_ovr_2(pname, param);
    
    private z_FrustumxOES_adr := GetProcAddress('glFrustumxOES');
    private z_FrustumxOES_ovr_0 := GetProcOrNil&<procedure(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed)>(z_FrustumxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrustumxOES(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed) :=
    z_FrustumxOES_ovr_0(l, r, b, t, n, f);
    
    private z_GetClipPlanexOES_adr := GetProcAddress('glGetClipPlanexOES');
    private z_GetClipPlanexOES_ovr_0 := GetProcOrNil&<procedure(plane: ClipPlaneName; var equation: Fixed)>(z_GetClipPlanexOES_adr);
    private z_GetClipPlanexOES_ovr_0_anh001 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_GetClipPlanexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanexOES(plane: ClipPlaneName; equation: array of Fixed) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_GetClipPlanexOES_ovr_0(plane, equation[0]) else
      z_GetClipPlanexOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanexOES(plane: ClipPlaneName; var equation: Fixed) :=
    z_GetClipPlanexOES_ovr_0(plane, equation);
    private z_GetClipPlanexOES_ovr_2 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_GetClipPlanexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanexOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_GetClipPlanexOES_ovr_2(plane, equation);
    
    private z_GetFixedvOES_adr := GetProcAddress('glGetFixedvOES');
    private z_GetFixedvOES_ovr_0 := GetProcOrNil&<procedure(pname: GetPName; var &params: Fixed)>(z_GetFixedvOES_adr);
    private z_GetFixedvOES_ovr_0_anh001 := GetProcOrNil&<procedure(pname: GetPName; &params: IntPtr)>(z_GetFixedvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFixedvOES(pname: GetPName; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFixedvOES_ovr_0(pname, &params[0]) else
      z_GetFixedvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFixedvOES(pname: GetPName; var &params: Fixed) :=
    z_GetFixedvOES_ovr_0(pname, &params);
    private z_GetFixedvOES_ovr_2 := GetProcOrNil&<procedure(pname: GetPName; &params: IntPtr)>(z_GetFixedvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFixedvOES(pname: GetPName; &params: IntPtr) :=
    z_GetFixedvOES_ovr_2(pname, &params);
    
    private z_GetTexEnvxvOES_adr := GetProcAddress('glGetTexEnvxvOES');
    private z_GetTexEnvxvOES_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed)>(z_GetTexEnvxvOES_adr);
    private z_GetTexEnvxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetTexEnvxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexEnvxvOES_ovr_0(target, pname, &params[0]) else
      z_GetTexEnvxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed) :=
    z_GetTexEnvxvOES_ovr_0(target, pname, &params);
    private z_GetTexEnvxvOES_ovr_2 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_GetTexEnvxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetTexEnvxvOES_ovr_2(target, pname, &params);
    
    private z_GetTexParameterxvOES_adr := GetProcAddress('glGetTexParameterxvOES');
    private z_GetTexParameterxvOES_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed)>(z_GetTexParameterxvOES_adr);
    private z_GetTexParameterxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed) :=
    z_GetTexParameterxvOES_ovr_0(target, pname, &params);
    private z_GetTexParameterxvOES_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterxvOES_ovr_2(target, pname, &params);
    
    private z_LightModelxOES_adr := GetProcAddress('glLightModelxOES');
    private z_LightModelxOES_ovr_0 := GetProcOrNil&<procedure(pname: LightModelParameter; param: Fixed)>(z_LightModelxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxOES(pname: LightModelParameter; param: Fixed) :=
    z_LightModelxOES_ovr_0(pname, param);
    
    private z_LightModelxvOES_adr := GetProcAddress('glLightModelxvOES');
    private z_LightModelxvOES_ovr_0 := GetProcOrNil&<procedure(pname: LightModelParameter; var param: Fixed)>(z_LightModelxvOES_adr);
    private z_LightModelxvOES_ovr_0_anh001 := GetProcOrNil&<procedure(pname: LightModelParameter; param: IntPtr)>(z_LightModelxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxvOES(pname: LightModelParameter; param: array of Fixed) :=
    if (param<>nil) and (param.Length<>0) then
      z_LightModelxvOES_ovr_0(pname, param[0]) else
      z_LightModelxvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxvOES(pname: LightModelParameter; var param: Fixed) :=
    z_LightModelxvOES_ovr_0(pname, param);
    private z_LightModelxvOES_ovr_2 := GetProcOrNil&<procedure(pname: LightModelParameter; param: IntPtr)>(z_LightModelxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxvOES(pname: LightModelParameter; param: IntPtr) :=
    z_LightModelxvOES_ovr_2(pname, param);
    
    private z_LightxOES_adr := GetProcAddress('glLightxOES');
    private z_LightxOES_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; param: Fixed)>(z_LightxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxOES(light: LightName; pname: LightParameter; param: Fixed) :=
    z_LightxOES_ovr_0(light, pname, param);
    
    private z_LightxvOES_adr := GetProcAddress('glLightxvOES');
    private z_LightxvOES_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; var &params: Fixed)>(z_LightxvOES_adr);
    private z_LightxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_LightxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxvOES(light: LightName; pname: LightParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_LightxvOES_ovr_0(light, pname, &params[0]) else
      z_LightxvOES_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxvOES(light: LightName; pname: LightParameter; var &params: Fixed) :=
    z_LightxvOES_ovr_0(light, pname, &params);
    private z_LightxvOES_ovr_2 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_LightxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxvOES(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_LightxvOES_ovr_2(light, pname, &params);
    
    private z_LineWidthxOES_adr := GetProcAddress('glLineWidthxOES');
    private z_LineWidthxOES_ovr_0 := GetProcOrNil&<procedure(width: Fixed)>(z_LineWidthxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LineWidthxOES(width: Fixed) :=
    z_LineWidthxOES_ovr_0(width);
    
    private z_LoadMatrixxOES_adr := GetProcAddress('glLoadMatrixxOES');
    private z_LoadMatrixxOES_ovr_0 := GetProcOrNil&<procedure(var m: Fixed)>(z_LoadMatrixxOES_adr);
    private z_LoadMatrixxOES_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadMatrixxOES_ovr_0(m[0]) else
      z_LoadMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixxOES(var m: Fixed) :=
    z_LoadMatrixxOES_ovr_0(m);
    private z_LoadMatrixxOES_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixxOES(m: IntPtr) :=
    z_LoadMatrixxOES_ovr_2(m);
    
    private z_MaterialxOES_adr := GetProcAddress('glMaterialxOES');
    private z_MaterialxOES_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: Fixed)>(z_MaterialxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxOES(face: MaterialFace; pname: MaterialParameter; param: Fixed) :=
    z_MaterialxOES_ovr_0(face, pname, param);
    
    private z_MaterialxvOES_adr := GetProcAddress('glMaterialxvOES');
    private z_MaterialxvOES_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var param: Fixed)>(z_MaterialxvOES_adr);
    private z_MaterialxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: IntPtr)>(z_MaterialxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxvOES(face: MaterialFace; pname: MaterialParameter; param: array of Fixed) :=
    if (param<>nil) and (param.Length<>0) then
      z_MaterialxvOES_ovr_0(face, pname, param[0]) else
      z_MaterialxvOES_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxvOES(face: MaterialFace; pname: MaterialParameter; var param: Fixed) :=
    z_MaterialxvOES_ovr_0(face, pname, param);
    private z_MaterialxvOES_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: IntPtr)>(z_MaterialxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxvOES(face: MaterialFace; pname: MaterialParameter; param: IntPtr) :=
    z_MaterialxvOES_ovr_2(face, pname, param);
    
    private z_MultMatrixxOES_adr := GetProcAddress('glMultMatrixxOES');
    private z_MultMatrixxOES_ovr_0 := GetProcOrNil&<procedure(var m: Fixed)>(z_MultMatrixxOES_adr);
    private z_MultMatrixxOES_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultMatrixxOES_ovr_0(m[0]) else
      z_MultMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixxOES(var m: Fixed) :=
    z_MultMatrixxOES_ovr_0(m);
    private z_MultMatrixxOES_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixxOES(m: IntPtr) :=
    z_MultMatrixxOES_ovr_2(m);
    
    private z_MultiTexCoord4xOES_adr := GetProcAddress('glMultiTexCoord4xOES');
    private z_MultiTexCoord4xOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed; q: Fixed)>(z_MultiTexCoord4xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xOES(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed; q: Fixed) :=
    z_MultiTexCoord4xOES_ovr_0(texture, s, t, r, q);
    
    private z_Normal3xOES_adr := GetProcAddress('glNormal3xOES');
    private z_Normal3xOES_ovr_0 := GetProcOrNil&<procedure(nx: Fixed; ny: Fixed; nz: Fixed)>(z_Normal3xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xOES(nx: Fixed; ny: Fixed; nz: Fixed) :=
    z_Normal3xOES_ovr_0(nx, ny, nz);
    
    private z_OrthoxOES_adr := GetProcAddress('glOrthoxOES');
    private z_OrthoxOES_ovr_0 := GetProcOrNil&<procedure(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed)>(z_OrthoxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure OrthoxOES(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed) :=
    z_OrthoxOES_ovr_0(l, r, b, t, n, f);
    
    private z_PointParameterxvOES_adr := GetProcAddress('glPointParameterxvOES');
    private z_PointParameterxvOES_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: Fixed)>(z_PointParameterxvOES_adr);
    private z_PointParameterxvOES_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterxvOES(pname: PointParameterNameARB; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterxvOES_ovr_0(pname, &params[0]) else
      z_PointParameterxvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterxvOES(pname: PointParameterNameARB; var &params: Fixed) :=
    z_PointParameterxvOES_ovr_0(pname, &params);
    private z_PointParameterxvOES_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterxvOES(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterxvOES_ovr_2(pname, &params);
    
    private z_PointSizexOES_adr := GetProcAddress('glPointSizexOES');
    private z_PointSizexOES_ovr_0 := GetProcOrNil&<procedure(size: Fixed)>(z_PointSizexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointSizexOES(size: Fixed) :=
    z_PointSizexOES_ovr_0(size);
    
    private z_PolygonOffsetxOES_adr := GetProcAddress('glPolygonOffsetxOES');
    private z_PolygonOffsetxOES_ovr_0 := GetProcOrNil&<procedure(factor: Fixed; units: Fixed)>(z_PolygonOffsetxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetxOES(factor: Fixed; units: Fixed) :=
    z_PolygonOffsetxOES_ovr_0(factor, units);
    
    private z_RotatexOES_adr := GetProcAddress('glRotatexOES');
    private z_RotatexOES_ovr_0 := GetProcOrNil&<procedure(angle: Fixed; x: Fixed; y: Fixed; z: Fixed)>(z_RotatexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RotatexOES(angle: Fixed; x: Fixed; y: Fixed; z: Fixed) :=
    z_RotatexOES_ovr_0(angle, x, y, z);
    
    private z_ScalexOES_adr := GetProcAddress('glScalexOES');
    private z_ScalexOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed; z: Fixed)>(z_ScalexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScalexOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_ScalexOES_ovr_0(x, y, z);
    
    private z_TexEnvxOES_adr := GetProcAddress('glTexEnvxOES');
    private z_TexEnvxOES_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; param: Fixed)>(z_TexEnvxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxOES(target: TextureEnvTarget; pname: TextureEnvParameter; param: Fixed) :=
    z_TexEnvxOES_ovr_0(target, pname, param);
    
    private z_TexEnvxvOES_adr := GetProcAddress('glTexEnvxvOES');
    private z_TexEnvxvOES_ovr_0 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed)>(z_TexEnvxvOES_adr);
    private z_TexEnvxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_TexEnvxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexEnvxvOES_ovr_0(target, pname, &params[0]) else
      z_TexEnvxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed) :=
    z_TexEnvxvOES_ovr_0(target, pname, &params);
    private z_TexEnvxvOES_ovr_2 := GetProcOrNil&<procedure(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr)>(z_TexEnvxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_TexEnvxvOES_ovr_2(target, pname, &params);
    
    private z_TexParameterxOES_adr := GetProcAddress('glTexParameterxOES');
    private z_TexParameterxOES_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; param: Fixed)>(z_TexParameterxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxOES(target: TextureTarget; pname: GetTextureParameter; param: Fixed) :=
    z_TexParameterxOES_ovr_0(target, pname, param);
    
    private z_TexParameterxvOES_adr := GetProcAddress('glTexParameterxvOES');
    private z_TexParameterxvOES_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed)>(z_TexParameterxvOES_adr);
    private z_TexParameterxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_TexParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_TexParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed) :=
    z_TexParameterxvOES_ovr_0(target, pname, &params);
    private z_TexParameterxvOES_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_TexParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_TexParameterxvOES_ovr_2(target, pname, &params);
    
    private z_TranslatexOES_adr := GetProcAddress('glTranslatexOES');
    private z_TranslatexOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed; z: Fixed)>(z_TranslatexOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TranslatexOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_TranslatexOES_ovr_0(x, y, z);
    
    private z_AccumxOES_adr := GetProcAddress('glAccumxOES');
    private z_AccumxOES_ovr_0 := GetProcOrNil&<procedure(op: DummyEnum; value: Fixed)>(z_AccumxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AccumxOES(op: DummyEnum; value: Fixed) :=
    z_AccumxOES_ovr_0(op, value);
    
    private z_BitmapxOES_adr := GetProcAddress('glBitmapxOES');
    private z_BitmapxOES_ovr_0 := GetProcOrNil&<procedure(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; var bitmap: Byte)>(z_BitmapxOES_adr);
    private z_BitmapxOES_ovr_0_anh00000001 := GetProcOrNil&<procedure(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: IntPtr)>(z_BitmapxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BitmapxOES(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: array of Byte) :=
    if (bitmap<>nil) and (bitmap.Length<>0) then
      z_BitmapxOES_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap[0]) else
      z_BitmapxOES_ovr_0_anh00000001(width, height, xorig, yorig, xmove, ymove, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BitmapxOES(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; var bitmap: Byte) :=
    z_BitmapxOES_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap);
    private z_BitmapxOES_ovr_2 := GetProcOrNil&<procedure(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: IntPtr)>(z_BitmapxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BitmapxOES(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: IntPtr) :=
    z_BitmapxOES_ovr_2(width, height, xorig, yorig, xmove, ymove, bitmap);
    
    private z_BlendColorxOES_adr := GetProcAddress('glBlendColorxOES');
    private z_BlendColorxOES_ovr_0 := GetProcOrNil&<procedure(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed)>(z_BlendColorxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColorxOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_BlendColorxOES_ovr_0(red, green, blue, alpha);
    
    private z_ClearAccumxOES_adr := GetProcAddress('glClearAccumxOES');
    private z_ClearAccumxOES_ovr_0 := GetProcOrNil&<procedure(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed)>(z_ClearAccumxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearAccumxOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_ClearAccumxOES_ovr_0(red, green, blue, alpha);
    
    private z_Color3xOES_adr := GetProcAddress('glColor3xOES');
    private z_Color3xOES_ovr_0 := GetProcOrNil&<procedure(red: Fixed; green: Fixed; blue: Fixed)>(z_Color3xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xOES(red: Fixed; green: Fixed; blue: Fixed) :=
    z_Color3xOES_ovr_0(red, green, blue);
    
    private z_Color3xvOES_adr := GetProcAddress('glColor3xvOES');
    private z_Color3xvOES_ovr_0 := GetProcOrNil&<procedure(var components: Fixed)>(z_Color3xvOES_adr);
    private z_Color3xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(components: IntPtr)>(z_Color3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xvOES(components: array of Fixed) :=
    if (components<>nil) and (components.Length<>0) then
      z_Color3xvOES_ovr_0(components[0]) else
      z_Color3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xvOES(var components: Fixed) :=
    z_Color3xvOES_ovr_0(components);
    private z_Color3xvOES_ovr_2 := GetProcOrNil&<procedure(components: IntPtr)>(z_Color3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xvOES(components: IntPtr) :=
    z_Color3xvOES_ovr_2(components);
    
    private z_Color4xvOES_adr := GetProcAddress('glColor4xvOES');
    private z_Color4xvOES_ovr_0 := GetProcOrNil&<procedure(var components: Fixed)>(z_Color4xvOES_adr);
    private z_Color4xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(components: IntPtr)>(z_Color4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xvOES(components: array of Fixed) :=
    if (components<>nil) and (components.Length<>0) then
      z_Color4xvOES_ovr_0(components[0]) else
      z_Color4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xvOES(var components: Fixed) :=
    z_Color4xvOES_ovr_0(components);
    private z_Color4xvOES_ovr_2 := GetProcOrNil&<procedure(components: IntPtr)>(z_Color4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xvOES(components: IntPtr) :=
    z_Color4xvOES_ovr_2(components);
    
    private z_ConvolutionParameterxOES_adr := GetProcAddress('glConvolutionParameterxOES');
    private z_ConvolutionParameterxOES_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; param: Fixed)>(z_ConvolutionParameterxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; param: Fixed) :=
    z_ConvolutionParameterxOES_ovr_0(target, pname, param);
    
    private z_ConvolutionParameterxvOES_adr := GetProcAddress('glConvolutionParameterxvOES');
    private z_ConvolutionParameterxvOES_ovr_0 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Fixed)>(z_ConvolutionParameterxvOES_adr);
    private z_ConvolutionParameterxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxvOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxvOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Fixed) :=
    z_ConvolutionParameterxvOES_ovr_0(target, pname, &params);
    private z_ConvolutionParameterxvOES_ovr_2 := GetProcOrNil&<procedure(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr)>(z_ConvolutionParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxvOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterxvOES_ovr_2(target, pname, &params);
    
    private z_EvalCoord1xOES_adr := GetProcAddress('glEvalCoord1xOES');
    private z_EvalCoord1xOES_ovr_0 := GetProcOrNil&<procedure(u: Fixed)>(z_EvalCoord1xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xOES(u: Fixed) :=
    z_EvalCoord1xOES_ovr_0(u);
    
    private z_EvalCoord1xvOES_adr := GetProcAddress('glEvalCoord1xvOES');
    private z_EvalCoord1xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_EvalCoord1xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xvOES(var coords: Fixed) :=
    z_EvalCoord1xvOES_ovr_0(coords);
    private z_EvalCoord1xvOES_ovr_1 := GetProcOrNil&<procedure(coords: IntPtr)>(z_EvalCoord1xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xvOES(coords: IntPtr) :=
    z_EvalCoord1xvOES_ovr_1(coords);
    
    private z_EvalCoord2xOES_adr := GetProcAddress('glEvalCoord2xOES');
    private z_EvalCoord2xOES_ovr_0 := GetProcOrNil&<procedure(u: Fixed; v: Fixed)>(z_EvalCoord2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xOES(u: Fixed; v: Fixed) :=
    z_EvalCoord2xOES_ovr_0(u, v);
    
    private z_EvalCoord2xvOES_adr := GetProcAddress('glEvalCoord2xvOES');
    private z_EvalCoord2xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_EvalCoord2xvOES_adr);
    private z_EvalCoord2xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_EvalCoord2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_EvalCoord2xvOES_ovr_0(coords[0]) else
      z_EvalCoord2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xvOES(var coords: Fixed) :=
    z_EvalCoord2xvOES_ovr_0(coords);
    private z_EvalCoord2xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_EvalCoord2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xvOES(coords: IntPtr) :=
    z_EvalCoord2xvOES_ovr_2(coords);
    
    private z_FeedbackBufferxOES_adr := GetProcAddress('glFeedbackBufferxOES');
    private z_FeedbackBufferxOES_ovr_0 := GetProcOrNil&<procedure(n: Int32; &type: DummyEnum; var buffer: Fixed)>(z_FeedbackBufferxOES_adr);
    private z_FeedbackBufferxOES_ovr_0_anh0001 := GetProcOrNil&<procedure(n: Int32; &type: DummyEnum; buffer: IntPtr)>(z_FeedbackBufferxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBufferxOES(n: Int32; &type: DummyEnum; buffer: array of Fixed) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_FeedbackBufferxOES_ovr_0(n, &type, buffer[0]) else
      z_FeedbackBufferxOES_ovr_0_anh0001(n, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBufferxOES(n: Int32; &type: DummyEnum; var buffer: Fixed) :=
    z_FeedbackBufferxOES_ovr_0(n, &type, buffer);
    private z_FeedbackBufferxOES_ovr_2 := GetProcOrNil&<procedure(n: Int32; &type: DummyEnum; buffer: IntPtr)>(z_FeedbackBufferxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBufferxOES(n: Int32; &type: DummyEnum; buffer: IntPtr) :=
    z_FeedbackBufferxOES_ovr_2(n, &type, buffer);
    
    private z_GetConvolutionParameterxvOES_adr := GetProcAddress('glGetConvolutionParameterxvOES');
    private z_GetConvolutionParameterxvOES_ovr_0 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; var &params: Fixed)>(z_GetConvolutionParameterxvOES_adr);
    private z_GetConvolutionParameterxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: IntPtr)>(z_GetConvolutionParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterxvOES(target: DummyEnum; pname: DummyEnum; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterxvOES(target: DummyEnum; pname: DummyEnum; var &params: Fixed) :=
    z_GetConvolutionParameterxvOES_ovr_0(target, pname, &params);
    private z_GetConvolutionParameterxvOES_ovr_2 := GetProcOrNil&<procedure(target: DummyEnum; pname: DummyEnum; &params: IntPtr)>(z_GetConvolutionParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterxvOES(target: DummyEnum; pname: DummyEnum; &params: IntPtr) :=
    z_GetConvolutionParameterxvOES_ovr_2(target, pname, &params);
    
    private z_GetHistogramParameterxvOES_adr := GetProcAddress('glGetHistogramParameterxvOES');
    private z_GetHistogramParameterxvOES_ovr_0 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Fixed)>(z_GetHistogramParameterxvOES_adr);
    private z_GetHistogramParameterxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterxvOES(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterxvOES(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Fixed) :=
    z_GetHistogramParameterxvOES_ovr_0(target, pname, &params);
    private z_GetHistogramParameterxvOES_ovr_2 := GetProcOrNil&<procedure(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr)>(z_GetHistogramParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterxvOES(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterxvOES_ovr_2(target, pname, &params);
    
    private z_GetLightxOES_adr := GetProcAddress('glGetLightxOES');
    private z_GetLightxOES_ovr_0 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; var &params: Fixed)>(z_GetLightxOES_adr);
    private z_GetLightxOES_ovr_0_anh0001 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_GetLightxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightxOES(light: LightName; pname: LightParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetLightxOES_ovr_0(light, pname, &params[0]) else
      z_GetLightxOES_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightxOES(light: LightName; pname: LightParameter; var &params: Fixed) :=
    z_GetLightxOES_ovr_0(light, pname, &params);
    private z_GetLightxOES_ovr_2 := GetProcOrNil&<procedure(light: LightName; pname: LightParameter; &params: IntPtr)>(z_GetLightxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightxOES(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_GetLightxOES_ovr_2(light, pname, &params);
    
    private z_GetMapxvOES_adr := GetProcAddress('glGetMapxvOES');
    private z_GetMapxvOES_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; var v: Fixed)>(z_GetMapxvOES_adr);
    private z_GetMapxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapxvOES(target: MapTarget; query: GetMapQuery; v: array of Fixed) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapxvOES_ovr_0(target, query, v[0]) else
      z_GetMapxvOES_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapxvOES(target: MapTarget; query: GetMapQuery; var v: Fixed) :=
    z_GetMapxvOES_ovr_0(target, query, v);
    private z_GetMapxvOES_ovr_2 := GetProcOrNil&<procedure(target: MapTarget; query: GetMapQuery; v: IntPtr)>(z_GetMapxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapxvOES(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapxvOES_ovr_2(target, query, v);
    
    private z_GetMaterialxOES_adr := GetProcAddress('glGetMaterialxOES');
    private z_GetMaterialxOES_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: Fixed)>(z_GetMaterialxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialxOES(face: MaterialFace; pname: MaterialParameter; param: Fixed) :=
    z_GetMaterialxOES_ovr_0(face, pname, param);
    
    private z_GetPixelMapxv_adr := GetProcAddress('glGetPixelMapxv');
    private z_GetPixelMapxv_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; size: Int32; var values: Fixed)>(z_GetPixelMapxv_adr);
    private z_GetPixelMapxv_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; size: Int32; values: IntPtr)>(z_GetPixelMapxv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapxv(map: PixelMap; size: Int32; values: array of Fixed) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapxv_ovr_0(map, size, values[0]) else
      z_GetPixelMapxv_ovr_0_anh0001(map, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapxv(map: PixelMap; size: Int32; var values: Fixed) :=
    z_GetPixelMapxv_ovr_0(map, size, values);
    private z_GetPixelMapxv_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; size: Int32; values: IntPtr)>(z_GetPixelMapxv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapxv(map: PixelMap; size: Int32; values: IntPtr) :=
    z_GetPixelMapxv_ovr_2(map, size, values);
    
    private z_GetTexGenxvOES_adr := GetProcAddress('glGetTexGenxvOES');
    private z_GetTexGenxvOES_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed)>(z_GetTexGenxvOES_adr);
    private z_GetTexGenxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGenxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGenxvOES_ovr_0(coord, pname, &params[0]) else
      z_GetTexGenxvOES_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed) :=
    z_GetTexGenxvOES_ovr_0(coord, pname, &params);
    private z_GetTexGenxvOES_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_GetTexGenxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGenxvOES_ovr_2(coord, pname, &params);
    
    private z_GetTexLevelParameterxvOES_adr := GetProcAddress('glGetTexLevelParameterxvOES');
    private z_GetTexLevelParameterxvOES_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Fixed)>(z_GetTexLevelParameterxvOES_adr);
    private z_GetTexLevelParameterxvOES_ovr_0_anh00001 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexLevelParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterxvOES(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexLevelParameterxvOES_ovr_0(target, level, pname, &params[0]) else
      z_GetTexLevelParameterxvOES_ovr_0_anh00001(target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterxvOES(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Fixed) :=
    z_GetTexLevelParameterxvOES_ovr_0(target, level, pname, &params);
    private z_GetTexLevelParameterxvOES_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexLevelParameterxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterxvOES(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexLevelParameterxvOES_ovr_2(target, level, pname, &params);
    
    private z_IndexxOES_adr := GetProcAddress('glIndexxOES');
    private z_IndexxOES_ovr_0 := GetProcOrNil&<procedure(component: Fixed)>(z_IndexxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxOES(component: Fixed) :=
    z_IndexxOES_ovr_0(component);
    
    private z_IndexxvOES_adr := GetProcAddress('glIndexxvOES');
    private z_IndexxvOES_ovr_0 := GetProcOrNil&<procedure(var component: Fixed)>(z_IndexxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxvOES(var component: Fixed) :=
    z_IndexxvOES_ovr_0(component);
    private z_IndexxvOES_ovr_1 := GetProcOrNil&<procedure(component: IntPtr)>(z_IndexxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxvOES(component: IntPtr) :=
    z_IndexxvOES_ovr_1(component);
    
    private z_LoadTransposeMatrixxOES_adr := GetProcAddress('glLoadTransposeMatrixxOES');
    private z_LoadTransposeMatrixxOES_ovr_0 := GetProcOrNil&<procedure(var m: Fixed)>(z_LoadTransposeMatrixxOES_adr);
    private z_LoadTransposeMatrixxOES_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixxOES_ovr_0(m[0]) else
      z_LoadTransposeMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixxOES(var m: Fixed) :=
    z_LoadTransposeMatrixxOES_ovr_0(m);
    private z_LoadTransposeMatrixxOES_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixxOES(m: IntPtr) :=
    z_LoadTransposeMatrixxOES_ovr_2(m);
    
    private z_Map1xOES_adr := GetProcAddress('glMap1xOES');
    private z_Map1xOES_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; u1: Fixed; u2: Fixed; stride: Int32; order: Int32; points: Fixed)>(z_Map1xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1xOES(target: MapTarget; u1: Fixed; u2: Fixed; stride: Int32; order: Int32; points: Fixed) :=
    z_Map1xOES_ovr_0(target, u1, u2, stride, order, points);
    
    private z_Map2xOES_adr := GetProcAddress('glMap2xOES');
    private z_Map2xOES_ovr_0 := GetProcOrNil&<procedure(target: MapTarget; u1: Fixed; u2: Fixed; ustride: Int32; uorder: Int32; v1: Fixed; v2: Fixed; vstride: Int32; vorder: Int32; points: Fixed)>(z_Map2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2xOES(target: MapTarget; u1: Fixed; u2: Fixed; ustride: Int32; uorder: Int32; v1: Fixed; v2: Fixed; vstride: Int32; vorder: Int32; points: Fixed) :=
    z_Map2xOES_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    private z_MapGrid1xOES_adr := GetProcAddress('glMapGrid1xOES');
    private z_MapGrid1xOES_ovr_0 := GetProcOrNil&<procedure(n: Int32; u1: Fixed; u2: Fixed)>(z_MapGrid1xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid1xOES(n: Int32; u1: Fixed; u2: Fixed) :=
    z_MapGrid1xOES_ovr_0(n, u1, u2);
    
    private z_MapGrid2xOES_adr := GetProcAddress('glMapGrid2xOES');
    private z_MapGrid2xOES_ovr_0 := GetProcOrNil&<procedure(n: Int32; u1: Fixed; u2: Fixed; v1: Fixed; v2: Fixed)>(z_MapGrid2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid2xOES(n: Int32; u1: Fixed; u2: Fixed; v1: Fixed; v2: Fixed) :=
    z_MapGrid2xOES_ovr_0(n, u1, u2, v1, v2);
    
    private z_MultTransposeMatrixxOES_adr := GetProcAddress('glMultTransposeMatrixxOES');
    private z_MultTransposeMatrixxOES_ovr_0 := GetProcOrNil&<procedure(var m: Fixed)>(z_MultTransposeMatrixxOES_adr);
    private z_MultTransposeMatrixxOES_ovr_0_anh01 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixxOES_ovr_0(m[0]) else
      z_MultTransposeMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixxOES(var m: Fixed) :=
    z_MultTransposeMatrixxOES_ovr_0(m);
    private z_MultTransposeMatrixxOES_ovr_2 := GetProcOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixxOES(m: IntPtr) :=
    z_MultTransposeMatrixxOES_ovr_2(m);
    
    private z_MultiTexCoord1xOES_adr := GetProcAddress('glMultiTexCoord1xOES');
    private z_MultiTexCoord1xOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: Fixed)>(z_MultiTexCoord1xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xOES(texture: TextureUnit; s: Fixed) :=
    z_MultiTexCoord1xOES_ovr_0(texture, s);
    
    private z_MultiTexCoord1xvOES_adr := GetProcAddress('glMultiTexCoord1xvOES');
    private z_MultiTexCoord1xvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: Fixed)>(z_MultiTexCoord1xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord1xvOES_ovr_0(texture, coords);
    private z_MultiTexCoord1xvOES_ovr_1 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord1xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord1xvOES_ovr_1(texture, coords);
    
    private z_MultiTexCoord2xOES_adr := GetProcAddress('glMultiTexCoord2xOES');
    private z_MultiTexCoord2xOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: Fixed; t: Fixed)>(z_MultiTexCoord2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xOES(texture: TextureUnit; s: Fixed; t: Fixed) :=
    z_MultiTexCoord2xOES_ovr_0(texture, s, t);
    
    private z_MultiTexCoord2xvOES_adr := GetProcAddress('glMultiTexCoord2xvOES');
    private z_MultiTexCoord2xvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: Fixed)>(z_MultiTexCoord2xvOES_adr);
    private z_MultiTexCoord2xvOES_ovr_0_anh001 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord2xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord2xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord2xvOES_ovr_0(texture, coords);
    private z_MultiTexCoord2xvOES_ovr_2 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord2xvOES_ovr_2(texture, coords);
    
    private z_MultiTexCoord3xOES_adr := GetProcAddress('glMultiTexCoord3xOES');
    private z_MultiTexCoord3xOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed)>(z_MultiTexCoord3xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xOES(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed) :=
    z_MultiTexCoord3xOES_ovr_0(texture, s, t, r);
    
    private z_MultiTexCoord3xvOES_adr := GetProcAddress('glMultiTexCoord3xvOES');
    private z_MultiTexCoord3xvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: Fixed)>(z_MultiTexCoord3xvOES_adr);
    private z_MultiTexCoord3xvOES_ovr_0_anh001 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord3xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord3xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord3xvOES_ovr_0(texture, coords);
    private z_MultiTexCoord3xvOES_ovr_2 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord3xvOES_ovr_2(texture, coords);
    
    private z_MultiTexCoord4xvOES_adr := GetProcAddress('glMultiTexCoord4xvOES');
    private z_MultiTexCoord4xvOES_ovr_0 := GetProcOrNil&<procedure(texture: TextureUnit; var coords: Fixed)>(z_MultiTexCoord4xvOES_adr);
    private z_MultiTexCoord4xvOES_ovr_0_anh001 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord4xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord4xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord4xvOES_ovr_0(texture, coords);
    private z_MultiTexCoord4xvOES_ovr_2 := GetProcOrNil&<procedure(texture: TextureUnit; coords: IntPtr)>(z_MultiTexCoord4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord4xvOES_ovr_2(texture, coords);
    
    private z_Normal3xvOES_adr := GetProcAddress('glNormal3xvOES');
    private z_Normal3xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_Normal3xvOES_adr);
    private z_Normal3xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Normal3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Normal3xvOES_ovr_0(coords[0]) else
      z_Normal3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xvOES(var coords: Fixed) :=
    z_Normal3xvOES_ovr_0(coords);
    private z_Normal3xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Normal3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xvOES(coords: IntPtr) :=
    z_Normal3xvOES_ovr_2(coords);
    
    private z_PassThroughxOES_adr := GetProcAddress('glPassThroughxOES');
    private z_PassThroughxOES_ovr_0 := GetProcOrNil&<procedure(token: Fixed)>(z_PassThroughxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PassThroughxOES(token: Fixed) :=
    z_PassThroughxOES_ovr_0(token);
    
    private z_PixelMapx_adr := GetProcAddress('glPixelMapx');
    private z_PixelMapx_ovr_0 := GetProcOrNil&<procedure(map: PixelMap; size: Int32; var values: Fixed)>(z_PixelMapx_adr);
    private z_PixelMapx_ovr_0_anh0001 := GetProcOrNil&<procedure(map: PixelMap; size: Int32; values: IntPtr)>(z_PixelMapx_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapx(map: PixelMap; size: Int32; values: array of Fixed) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapx_ovr_0(map, size, values[0]) else
      z_PixelMapx_ovr_0_anh0001(map, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapx(map: PixelMap; size: Int32; var values: Fixed) :=
    z_PixelMapx_ovr_0(map, size, values);
    private z_PixelMapx_ovr_2 := GetProcOrNil&<procedure(map: PixelMap; size: Int32; values: IntPtr)>(z_PixelMapx_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapx(map: PixelMap; size: Int32; values: IntPtr) :=
    z_PixelMapx_ovr_2(map, size, values);
    
    private z_PixelStorex_adr := GetProcAddress('glPixelStorex');
    private z_PixelStorex_ovr_0 := GetProcOrNil&<procedure(pname: PixelStoreParameter; param: Fixed)>(z_PixelStorex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelStorex(pname: PixelStoreParameter; param: Fixed) :=
    z_PixelStorex_ovr_0(pname, param);
    
    private z_PixelTransferxOES_adr := GetProcAddress('glPixelTransferxOES');
    private z_PixelTransferxOES_ovr_0 := GetProcOrNil&<procedure(pname: PixelTransferParameter; param: Fixed)>(z_PixelTransferxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransferxOES(pname: PixelTransferParameter; param: Fixed) :=
    z_PixelTransferxOES_ovr_0(pname, param);
    
    private z_PixelZoomxOES_adr := GetProcAddress('glPixelZoomxOES');
    private z_PixelZoomxOES_ovr_0 := GetProcOrNil&<procedure(xfactor: Fixed; yfactor: Fixed)>(z_PixelZoomxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelZoomxOES(xfactor: Fixed; yfactor: Fixed) :=
    z_PixelZoomxOES_ovr_0(xfactor, yfactor);
    
    private z_PrioritizeTexturesxOES_adr := GetProcAddress('glPrioritizeTexturesxOES');
    private z_PrioritizeTexturesxOES_ovr_0 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; var priorities: Fixed)>(z_PrioritizeTexturesxOES_adr);
    private z_PrioritizeTexturesxOES_ovr_0_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: Fixed)>(z_PrioritizeTexturesxOES_adr);
    private z_PrioritizeTexturesxOES_ovr_0_anh0001 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; priorities: IntPtr)>(z_PrioritizeTexturesxOES_adr);
    private z_PrioritizeTexturesxOES_ovr_0_anh0011 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: array of gl_texture; priorities: array of Fixed) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesxOES_ovr_0(n, textures[0], priorities[0]) else
        z_PrioritizeTexturesxOES_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesxOES_ovr_0_anh0010(n, IntPtr.Zero, priorities[0]) else
        z_PrioritizeTexturesxOES_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private z_PrioritizeTexturesxOES_ovr_1_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: Fixed)>(z_PrioritizeTexturesxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: array of gl_texture; var priorities: Fixed) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_0(n, textures[0], priorities) else
      z_PrioritizeTexturesxOES_ovr_0_anh0010(n, IntPtr.Zero, priorities);
    private z_PrioritizeTexturesxOES_ovr_2 := GetProcOrNil&<procedure(n: Int32; var textures: gl_texture; priorities: IntPtr)>(z_PrioritizeTexturesxOES_adr);
    private z_PrioritizeTexturesxOES_ovr_2_anh0010 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: array of gl_texture; priorities: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_2(n, textures[0], priorities) else
      z_PrioritizeTexturesxOES_ovr_2_anh0010(n, IntPtr.Zero, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; var textures: gl_texture; priorities: array of Fixed) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_0(n, textures, priorities[0]) else
      z_PrioritizeTexturesxOES_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; var textures: gl_texture; var priorities: Fixed) :=
    z_PrioritizeTexturesxOES_ovr_0(n, textures, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; var textures: gl_texture; priorities: IntPtr) :=
    z_PrioritizeTexturesxOES_ovr_2(n, textures, priorities);
    private z_PrioritizeTexturesxOES_ovr_6 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; var priorities: Fixed)>(z_PrioritizeTexturesxOES_adr);
    private z_PrioritizeTexturesxOES_ovr_6_anh0001 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: IntPtr; priorities: array of Fixed) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_6(n, textures, priorities[0]) else
      z_PrioritizeTexturesxOES_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: IntPtr; var priorities: Fixed) :=
    z_PrioritizeTexturesxOES_ovr_6(n, textures, priorities);
    private z_PrioritizeTexturesxOES_ovr_8 := GetProcOrNil&<procedure(n: Int32; textures: IntPtr; priorities: IntPtr)>(z_PrioritizeTexturesxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: IntPtr; priorities: IntPtr) :=
    z_PrioritizeTexturesxOES_ovr_8(n, textures, priorities);
    
    private z_RasterPos2xOES_adr := GetProcAddress('glRasterPos2xOES');
    private z_RasterPos2xOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed)>(z_RasterPos2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xOES(x: Fixed; y: Fixed) :=
    z_RasterPos2xOES_ovr_0(x, y);
    
    private z_RasterPos2xvOES_adr := GetProcAddress('glRasterPos2xvOES');
    private z_RasterPos2xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_RasterPos2xvOES_adr);
    private z_RasterPos2xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_RasterPos2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_RasterPos2xvOES_ovr_0(coords[0]) else
      z_RasterPos2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xvOES(var coords: Fixed) :=
    z_RasterPos2xvOES_ovr_0(coords);
    private z_RasterPos2xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_RasterPos2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xvOES(coords: IntPtr) :=
    z_RasterPos2xvOES_ovr_2(coords);
    
    private z_RasterPos3xOES_adr := GetProcAddress('glRasterPos3xOES');
    private z_RasterPos3xOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed; z: Fixed)>(z_RasterPos3xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_RasterPos3xOES_ovr_0(x, y, z);
    
    private z_RasterPos3xvOES_adr := GetProcAddress('glRasterPos3xvOES');
    private z_RasterPos3xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_RasterPos3xvOES_adr);
    private z_RasterPos3xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_RasterPos3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_RasterPos3xvOES_ovr_0(coords[0]) else
      z_RasterPos3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xvOES(var coords: Fixed) :=
    z_RasterPos3xvOES_ovr_0(coords);
    private z_RasterPos3xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_RasterPos3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xvOES(coords: IntPtr) :=
    z_RasterPos3xvOES_ovr_2(coords);
    
    private z_RasterPos4xOES_adr := GetProcAddress('glRasterPos4xOES');
    private z_RasterPos4xOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed; z: Fixed; w: Fixed)>(z_RasterPos4xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xOES(x: Fixed; y: Fixed; z: Fixed; w: Fixed) :=
    z_RasterPos4xOES_ovr_0(x, y, z, w);
    
    private z_RasterPos4xvOES_adr := GetProcAddress('glRasterPos4xvOES');
    private z_RasterPos4xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_RasterPos4xvOES_adr);
    private z_RasterPos4xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_RasterPos4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_RasterPos4xvOES_ovr_0(coords[0]) else
      z_RasterPos4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xvOES(var coords: Fixed) :=
    z_RasterPos4xvOES_ovr_0(coords);
    private z_RasterPos4xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_RasterPos4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xvOES(coords: IntPtr) :=
    z_RasterPos4xvOES_ovr_2(coords);
    
    private z_RectxOES_adr := GetProcAddress('glRectxOES');
    private z_RectxOES_ovr_0 := GetProcOrNil&<procedure(x1: Fixed; y1: Fixed; x2: Fixed; y2: Fixed)>(z_RectxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxOES(x1: Fixed; y1: Fixed; x2: Fixed; y2: Fixed) :=
    z_RectxOES_ovr_0(x1, y1, x2, y2);
    
    private z_RectxvOES_adr := GetProcAddress('glRectxvOES');
    private z_RectxvOES_ovr_0 := GetProcOrNil&<procedure(var v1: Fixed; var v2: Fixed)>(z_RectxvOES_adr);
    private z_RectxvOES_ovr_0_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Fixed)>(z_RectxvOES_adr);
    private z_RectxvOES_ovr_0_anh001 := GetProcOrNil&<procedure(var v1: Fixed; v2: IntPtr)>(z_RectxvOES_adr);
    private z_RectxvOES_ovr_0_anh011 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_RectxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: array of Fixed; v2: array of Fixed) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_RectxvOES_ovr_0(v1[0], v2[0]) else
        z_RectxvOES_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_RectxvOES_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_RectxvOES_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private z_RectxvOES_ovr_1_anh010 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Fixed)>(z_RectxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: array of Fixed; var v2: Fixed) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_RectxvOES_ovr_0(v1[0], v2) else
      z_RectxvOES_ovr_0_anh010(IntPtr.Zero, v2);
    private z_RectxvOES_ovr_2 := GetProcOrNil&<procedure(var v1: Fixed; v2: IntPtr)>(z_RectxvOES_adr);
    private z_RectxvOES_ovr_2_anh010 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_RectxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: array of Fixed; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_RectxvOES_ovr_2(v1[0], v2) else
      z_RectxvOES_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(var v1: Fixed; v2: array of Fixed) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_RectxvOES_ovr_0(v1, v2[0]) else
      z_RectxvOES_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(var v1: Fixed; var v2: Fixed) :=
    z_RectxvOES_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(var v1: Fixed; v2: IntPtr) :=
    z_RectxvOES_ovr_2(v1, v2);
    private z_RectxvOES_ovr_6 := GetProcOrNil&<procedure(v1: IntPtr; var v2: Fixed)>(z_RectxvOES_adr);
    private z_RectxvOES_ovr_6_anh001 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_RectxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: IntPtr; v2: array of Fixed) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_RectxvOES_ovr_6(v1, v2[0]) else
      z_RectxvOES_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: IntPtr; var v2: Fixed) :=
    z_RectxvOES_ovr_6(v1, v2);
    private z_RectxvOES_ovr_8 := GetProcOrNil&<procedure(v1: IntPtr; v2: IntPtr)>(z_RectxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: IntPtr; v2: IntPtr) :=
    z_RectxvOES_ovr_8(v1, v2);
    
    private z_TexCoord1xOES_adr := GetProcAddress('glTexCoord1xOES');
    private z_TexCoord1xOES_ovr_0 := GetProcOrNil&<procedure(s: Fixed)>(z_TexCoord1xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xOES(s: Fixed) :=
    z_TexCoord1xOES_ovr_0(s);
    
    private z_TexCoord1xvOES_adr := GetProcAddress('glTexCoord1xvOES');
    private z_TexCoord1xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_TexCoord1xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xvOES(var coords: Fixed) :=
    z_TexCoord1xvOES_ovr_0(coords);
    private z_TexCoord1xvOES_ovr_1 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord1xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xvOES(coords: IntPtr) :=
    z_TexCoord1xvOES_ovr_1(coords);
    
    private z_TexCoord2xOES_adr := GetProcAddress('glTexCoord2xOES');
    private z_TexCoord2xOES_ovr_0 := GetProcOrNil&<procedure(s: Fixed; t: Fixed)>(z_TexCoord2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xOES(s: Fixed; t: Fixed) :=
    z_TexCoord2xOES_ovr_0(s, t);
    
    private z_TexCoord2xvOES_adr := GetProcAddress('glTexCoord2xvOES');
    private z_TexCoord2xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_TexCoord2xvOES_adr);
    private z_TexCoord2xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord2xvOES_ovr_0(coords[0]) else
      z_TexCoord2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xvOES(var coords: Fixed) :=
    z_TexCoord2xvOES_ovr_0(coords);
    private z_TexCoord2xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xvOES(coords: IntPtr) :=
    z_TexCoord2xvOES_ovr_2(coords);
    
    private z_TexCoord3xOES_adr := GetProcAddress('glTexCoord3xOES');
    private z_TexCoord3xOES_ovr_0 := GetProcOrNil&<procedure(s: Fixed; t: Fixed; r: Fixed)>(z_TexCoord3xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xOES(s: Fixed; t: Fixed; r: Fixed) :=
    z_TexCoord3xOES_ovr_0(s, t, r);
    
    private z_TexCoord3xvOES_adr := GetProcAddress('glTexCoord3xvOES');
    private z_TexCoord3xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_TexCoord3xvOES_adr);
    private z_TexCoord3xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord3xvOES_ovr_0(coords[0]) else
      z_TexCoord3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xvOES(var coords: Fixed) :=
    z_TexCoord3xvOES_ovr_0(coords);
    private z_TexCoord3xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xvOES(coords: IntPtr) :=
    z_TexCoord3xvOES_ovr_2(coords);
    
    private z_TexCoord4xOES_adr := GetProcAddress('glTexCoord4xOES');
    private z_TexCoord4xOES_ovr_0 := GetProcOrNil&<procedure(s: Fixed; t: Fixed; r: Fixed; q: Fixed)>(z_TexCoord4xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xOES(s: Fixed; t: Fixed; r: Fixed; q: Fixed) :=
    z_TexCoord4xOES_ovr_0(s, t, r, q);
    
    private z_TexCoord4xvOES_adr := GetProcAddress('glTexCoord4xvOES');
    private z_TexCoord4xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_TexCoord4xvOES_adr);
    private z_TexCoord4xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord4xvOES_ovr_0(coords[0]) else
      z_TexCoord4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xvOES(var coords: Fixed) :=
    z_TexCoord4xvOES_ovr_0(coords);
    private z_TexCoord4xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_TexCoord4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xvOES(coords: IntPtr) :=
    z_TexCoord4xvOES_ovr_2(coords);
    
    private z_TexGenxOES_adr := GetProcAddress('glTexGenxOES');
    private z_TexGenxOES_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; param: Fixed)>(z_TexGenxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxOES(coord: TextureCoordName; pname: TextureGenParameter; param: Fixed) :=
    z_TexGenxOES_ovr_0(coord, pname, param);
    
    private z_TexGenxvOES_adr := GetProcAddress('glTexGenxvOES');
    private z_TexGenxvOES_ovr_0 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed)>(z_TexGenxvOES_adr);
    private z_TexGenxvOES_ovr_0_anh0001 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGenxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGenxvOES_ovr_0(coord, pname, &params[0]) else
      z_TexGenxvOES_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed) :=
    z_TexGenxvOES_ovr_0(coord, pname, &params);
    private z_TexGenxvOES_ovr_2 := GetProcOrNil&<procedure(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr)>(z_TexGenxvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGenxvOES_ovr_2(coord, pname, &params);
    
    private z_Vertex2xOES_adr := GetProcAddress('glVertex2xOES');
    private z_Vertex2xOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed)>(z_Vertex2xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xOES(x: Fixed) :=
    z_Vertex2xOES_ovr_0(x);
    
    private z_Vertex2xvOES_adr := GetProcAddress('glVertex2xvOES');
    private z_Vertex2xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_Vertex2xvOES_adr);
    private z_Vertex2xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex2xvOES_ovr_0(coords[0]) else
      z_Vertex2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xvOES(var coords: Fixed) :=
    z_Vertex2xvOES_ovr_0(coords);
    private z_Vertex2xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex2xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xvOES(coords: IntPtr) :=
    z_Vertex2xvOES_ovr_2(coords);
    
    private z_Vertex3xOES_adr := GetProcAddress('glVertex3xOES');
    private z_Vertex3xOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed)>(z_Vertex3xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xOES(x: Fixed; y: Fixed) :=
    z_Vertex3xOES_ovr_0(x, y);
    
    private z_Vertex3xvOES_adr := GetProcAddress('glVertex3xvOES');
    private z_Vertex3xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_Vertex3xvOES_adr);
    private z_Vertex3xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex3xvOES_ovr_0(coords[0]) else
      z_Vertex3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xvOES(var coords: Fixed) :=
    z_Vertex3xvOES_ovr_0(coords);
    private z_Vertex3xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex3xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xvOES(coords: IntPtr) :=
    z_Vertex3xvOES_ovr_2(coords);
    
    private z_Vertex4xOES_adr := GetProcAddress('glVertex4xOES');
    private z_Vertex4xOES_ovr_0 := GetProcOrNil&<procedure(x: Fixed; y: Fixed; z: Fixed)>(z_Vertex4xOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_Vertex4xOES_ovr_0(x, y, z);
    
    private z_Vertex4xvOES_adr := GetProcAddress('glVertex4xvOES');
    private z_Vertex4xvOES_ovr_0 := GetProcOrNil&<procedure(var coords: Fixed)>(z_Vertex4xvOES_adr);
    private z_Vertex4xvOES_ovr_0_anh01 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex4xvOES_ovr_0(coords[0]) else
      z_Vertex4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xvOES(var coords: Fixed) :=
    z_Vertex4xvOES_ovr_0(coords);
    private z_Vertex4xvOES_ovr_2 := GetProcOrNil&<procedure(coords: IntPtr)>(z_Vertex4xvOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xvOES(coords: IntPtr) :=
    z_Vertex4xvOES_ovr_2(coords);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glQueryMatrixOES = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OES_query_matrix';
    
    private z_QueryMatrixxOES_adr := GetProcAddress('glQueryMatrixxOES');
    private z_QueryMatrixxOES_ovr_0 := GetProcOrNil&<function(var mantissa: Fixed; var exponent: Int32): DummyFlags>(z_QueryMatrixxOES_adr);
    private z_QueryMatrixxOES_ovr_0_anh010 := GetProcOrNil&<function(mantissa: IntPtr; var exponent: Int32): DummyFlags>(z_QueryMatrixxOES_adr);
    private z_QueryMatrixxOES_ovr_0_anh001 := GetProcOrNil&<function(var mantissa: Fixed; exponent: IntPtr): DummyFlags>(z_QueryMatrixxOES_adr);
    private z_QueryMatrixxOES_ovr_0_anh011 := GetProcOrNil&<function(mantissa: IntPtr; exponent: IntPtr): DummyFlags>(z_QueryMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: array of Fixed; exponent: array of Int32): DummyFlags :=
    if (mantissa<>nil) and (mantissa.Length<>0) then
      if (exponent<>nil) and (exponent.Length<>0) then
        z_QueryMatrixxOES_ovr_0(mantissa[0], exponent[0]) else
        z_QueryMatrixxOES_ovr_0_anh001(mantissa[0], IntPtr.Zero) else
      if (exponent<>nil) and (exponent.Length<>0) then
        z_QueryMatrixxOES_ovr_0_anh010(IntPtr.Zero, exponent[0]) else
        z_QueryMatrixxOES_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private z_QueryMatrixxOES_ovr_1_anh010 := GetProcOrNil&<function(mantissa: IntPtr; var exponent: Int32): DummyFlags>(z_QueryMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: array of Fixed; var exponent: Int32): DummyFlags :=
    if (mantissa<>nil) and (mantissa.Length<>0) then
      z_QueryMatrixxOES_ovr_0(mantissa[0], exponent) else
      z_QueryMatrixxOES_ovr_0_anh010(IntPtr.Zero, exponent);
    private z_QueryMatrixxOES_ovr_2 := GetProcOrNil&<function(var mantissa: Fixed; exponent: IntPtr): DummyFlags>(z_QueryMatrixxOES_adr);
    private z_QueryMatrixxOES_ovr_2_anh010 := GetProcOrNil&<function(mantissa: IntPtr; exponent: IntPtr): DummyFlags>(z_QueryMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: array of Fixed; exponent: IntPtr): DummyFlags :=
    if (mantissa<>nil) and (mantissa.Length<>0) then
      z_QueryMatrixxOES_ovr_2(mantissa[0], exponent) else
      z_QueryMatrixxOES_ovr_2_anh010(IntPtr.Zero, exponent);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(var mantissa: Fixed; exponent: array of Int32): DummyFlags :=
    if (exponent<>nil) and (exponent.Length<>0) then
      z_QueryMatrixxOES_ovr_0(mantissa, exponent[0]) else
      z_QueryMatrixxOES_ovr_0_anh001(mantissa, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(var mantissa: Fixed; var exponent: Int32): DummyFlags :=
    z_QueryMatrixxOES_ovr_0(mantissa, exponent);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(var mantissa: Fixed; exponent: IntPtr): DummyFlags :=
    z_QueryMatrixxOES_ovr_2(mantissa, exponent);
    private z_QueryMatrixxOES_ovr_6 := GetProcOrNil&<function(mantissa: IntPtr; var exponent: Int32): DummyFlags>(z_QueryMatrixxOES_adr);
    private z_QueryMatrixxOES_ovr_6_anh001 := GetProcOrNil&<function(mantissa: IntPtr; exponent: IntPtr): DummyFlags>(z_QueryMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: IntPtr; exponent: array of Int32): DummyFlags :=
    if (exponent<>nil) and (exponent.Length<>0) then
      z_QueryMatrixxOES_ovr_6(mantissa, exponent[0]) else
      z_QueryMatrixxOES_ovr_6_anh001(mantissa, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: IntPtr; var exponent: Int32): DummyFlags :=
    z_QueryMatrixxOES_ovr_6(mantissa, exponent);
    private z_QueryMatrixxOES_ovr_8 := GetProcOrNil&<function(mantissa: IntPtr; exponent: IntPtr): DummyFlags>(z_QueryMatrixxOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: IntPtr; exponent: IntPtr): DummyFlags :=
    z_QueryMatrixxOES_ovr_8(mantissa, exponent);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSinglePrecisionOES = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OES_single_precision';
    
    private z_ClearDepthfOES_adr := GetProcAddress('glClearDepthfOES');
    private z_ClearDepthfOES_ovr_0 := GetProcOrNil&<procedure(depth: single)>(z_ClearDepthfOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthfOES(depth: single) :=
    z_ClearDepthfOES_ovr_0(depth);
    
    private z_ClipPlanefOES_adr := GetProcAddress('glClipPlanefOES');
    private z_ClipPlanefOES_ovr_0 := GetProcOrNil&<procedure(plane: ClipPlaneName; var equation: single)>(z_ClipPlanefOES_adr);
    private z_ClipPlanefOES_ovr_0_anh001 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_ClipPlanefOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanefOES(plane: ClipPlaneName; equation: array of single) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ClipPlanefOES_ovr_0(plane, equation[0]) else
      z_ClipPlanefOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanefOES(plane: ClipPlaneName; var equation: single) :=
    z_ClipPlanefOES_ovr_0(plane, equation);
    private z_ClipPlanefOES_ovr_2 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_ClipPlanefOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanefOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_ClipPlanefOES_ovr_2(plane, equation);
    
    private z_DepthRangefOES_adr := GetProcAddress('glDepthRangefOES');
    private z_DepthRangefOES_ovr_0 := GetProcOrNil&<procedure(n: single; f: single)>(z_DepthRangefOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangefOES(n: single; f: single) :=
    z_DepthRangefOES_ovr_0(n, f);
    
    private z_FrustumfOES_adr := GetProcAddress('glFrustumfOES');
    private z_FrustumfOES_ovr_0 := GetProcOrNil&<procedure(l: single; r: single; b: single; t: single; n: single; f: single)>(z_FrustumfOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrustumfOES(l: single; r: single; b: single; t: single; n: single; f: single) :=
    z_FrustumfOES_ovr_0(l, r, b, t, n, f);
    
    private z_GetClipPlanefOES_adr := GetProcAddress('glGetClipPlanefOES');
    private z_GetClipPlanefOES_ovr_0 := GetProcOrNil&<procedure(plane: ClipPlaneName; var equation: single)>(z_GetClipPlanefOES_adr);
    private z_GetClipPlanefOES_ovr_0_anh001 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_GetClipPlanefOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanefOES(plane: ClipPlaneName; equation: array of single) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_GetClipPlanefOES_ovr_0(plane, equation[0]) else
      z_GetClipPlanefOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanefOES(plane: ClipPlaneName; var equation: single) :=
    z_GetClipPlanefOES_ovr_0(plane, equation);
    private z_GetClipPlanefOES_ovr_2 := GetProcOrNil&<procedure(plane: ClipPlaneName; equation: IntPtr)>(z_GetClipPlanefOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanefOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_GetClipPlanefOES_ovr_2(plane, equation);
    
    private z_OrthofOES_adr := GetProcAddress('glOrthofOES');
    private z_OrthofOES_ovr_0 := GetProcOrNil&<procedure(l: single; r: single; b: single; t: single; n: single; f: single)>(z_OrthofOES_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure OrthofOES(l: single; r: single; b: single; t: single; n: single; f: single) :=
    z_OrthofOES_ovr_0(l, r, b, t, n, f);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultiviewOVR = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OVR_multiview';
    
    private z_FramebufferTextureMultiviewOVR_adr := GetProcAddress('glFramebufferTextureMultiviewOVR');
    private z_FramebufferTextureMultiviewOVR_ovr_0 := GetProcOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; baseViewIndex: Int32; numViews: Int32)>(z_FramebufferTextureMultiviewOVR_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureMultiviewOVR(target: FramebufferTarget; attachment: FramebufferAttachment; texture: gl_texture; level: Int32; baseViewIndex: Int32; numViews: Int32) :=
    z_FramebufferTextureMultiviewOVR_ovr_0(target, attachment, texture, level, baseViewIndex, numViews);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMiscHintsPGI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'PGI_misc_hints';
    
    private z_HintPGI_adr := GetProcAddress('glHintPGI');
    private z_HintPGI_ovr_0 := GetProcOrNil&<procedure(target: HintTargetPGI; mode: Int32)>(z_HintPGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure HintPGI(target: HintTargetPGI; mode: Int32) :=
    z_HintPGI_ovr_0(target, mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glDetailTextureSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_detail_texture';
    
    private z_DetailTexFuncSGIS_adr := GetProcAddress('glDetailTexFuncSGIS');
    private z_DetailTexFuncSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; var points: single)>(z_DetailTexFuncSGIS_adr);
    private z_DetailTexFuncSGIS_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; points: IntPtr)>(z_DetailTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetailTexFuncSGIS(target: TextureTarget; n: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_DetailTexFuncSGIS_ovr_0(target, n, points[0]) else
      z_DetailTexFuncSGIS_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetailTexFuncSGIS(target: TextureTarget; n: Int32; var points: single) :=
    z_DetailTexFuncSGIS_ovr_0(target, n, points);
    private z_DetailTexFuncSGIS_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; points: IntPtr)>(z_DetailTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetailTexFuncSGIS(target: TextureTarget; n: Int32; points: IntPtr) :=
    z_DetailTexFuncSGIS_ovr_2(target, n, points);
    
    private z_GetDetailTexFuncSGIS_adr := GetProcAddress('glGetDetailTexFuncSGIS');
    private z_GetDetailTexFuncSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; var points: single)>(z_GetDetailTexFuncSGIS_adr);
    private z_GetDetailTexFuncSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureTarget; points: IntPtr)>(z_GetDetailTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDetailTexFuncSGIS(target: TextureTarget; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_GetDetailTexFuncSGIS_ovr_0(target, points[0]) else
      z_GetDetailTexFuncSGIS_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDetailTexFuncSGIS(target: TextureTarget; var points: single) :=
    z_GetDetailTexFuncSGIS_ovr_0(target, points);
    private z_GetDetailTexFuncSGIS_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; points: IntPtr)>(z_GetDetailTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDetailTexFuncSGIS(target: TextureTarget; points: IntPtr) :=
    z_GetDetailTexFuncSGIS_ovr_2(target, points);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFogFunctionSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_fog_function';
    
    private z_FogFuncSGIS_adr := GetProcAddress('glFogFuncSGIS');
    private z_FogFuncSGIS_ovr_0 := GetProcOrNil&<procedure(n: Int32; var points: single)>(z_FogFuncSGIS_adr);
    private z_FogFuncSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(n: Int32; points: IntPtr)>(z_FogFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogFuncSGIS(n: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_FogFuncSGIS_ovr_0(n, points[0]) else
      z_FogFuncSGIS_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogFuncSGIS(n: Int32; var points: single) :=
    z_FogFuncSGIS_ovr_0(n, points);
    private z_FogFuncSGIS_ovr_2 := GetProcOrNil&<procedure(n: Int32; points: IntPtr)>(z_FogFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogFuncSGIS(n: Int32; points: IntPtr) :=
    z_FogFuncSGIS_ovr_2(n, points);
    
    private z_GetFogFuncSGIS_adr := GetProcAddress('glGetFogFuncSGIS');
    private z_GetFogFuncSGIS_ovr_0 := GetProcOrNil&<procedure(var points: single)>(z_GetFogFuncSGIS_adr);
    private z_GetFogFuncSGIS_ovr_0_anh01 := GetProcOrNil&<procedure(points: IntPtr)>(z_GetFogFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFogFuncSGIS(points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_GetFogFuncSGIS_ovr_0(points[0]) else
      z_GetFogFuncSGIS_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFogFuncSGIS(var points: single) :=
    z_GetFogFuncSGIS_ovr_0(points);
    private z_GetFogFuncSGIS_ovr_2 := GetProcOrNil&<procedure(points: IntPtr)>(z_GetFogFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFogFuncSGIS(points: IntPtr) :=
    z_GetFogFuncSGIS_ovr_2(points);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMultisampleSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_multisample';
    
    private z_SampleMaskSGIS_adr := GetProcAddress('glSampleMaskSGIS');
    private z_SampleMaskSGIS_ovr_0 := GetProcOrNil&<procedure(value: single; invert: boolean)>(z_SampleMaskSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaskSGIS(value: single; invert: boolean) :=
    z_SampleMaskSGIS_ovr_0(value, invert);
    
    private z_SamplePatternSGIS_adr := GetProcAddress('glSamplePatternSGIS');
    private z_SamplePatternSGIS_ovr_0 := GetProcOrNil&<procedure(pattern: OpenGL.SamplePatternSGIS)>(z_SamplePatternSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplePatternSGIS(pattern: OpenGL.SamplePatternSGIS) :=
    z_SamplePatternSGIS_ovr_0(pattern);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPixelTextureSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_pixel_texture';
    
    private z_PixelTexGenParameteriSGIS_adr := GetProcAddress('glPixelTexGenParameteriSGIS');
    private z_PixelTexGenParameteriSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; param: Int32)>(z_PixelTexGenParameteriSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameteriSGIS(pname: PixelTexGenParameterNameSGIS; param: Int32) :=
    z_PixelTexGenParameteriSGIS_ovr_0(pname, param);
    
    private z_PixelTexGenParameterivSGIS_adr := GetProcAddress('glPixelTexGenParameterivSGIS');
    private z_PixelTexGenParameterivSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; var &params: Int32)>(z_PixelTexGenParameterivSGIS_adr);
    private z_PixelTexGenParameterivSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_PixelTexGenParameterivSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PixelTexGenParameterivSGIS_ovr_0(pname, &params[0]) else
      z_PixelTexGenParameterivSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; var &params: Int32) :=
    z_PixelTexGenParameterivSGIS_ovr_0(pname, &params);
    private z_PixelTexGenParameterivSGIS_ovr_2 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_PixelTexGenParameterivSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_PixelTexGenParameterivSGIS_ovr_2(pname, &params);
    
    private z_PixelTexGenParameterfSGIS_adr := GetProcAddress('glPixelTexGenParameterfSGIS');
    private z_PixelTexGenParameterfSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; param: single)>(z_PixelTexGenParameterfSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfSGIS(pname: PixelTexGenParameterNameSGIS; param: single) :=
    z_PixelTexGenParameterfSGIS_ovr_0(pname, param);
    
    private z_PixelTexGenParameterfvSGIS_adr := GetProcAddress('glPixelTexGenParameterfvSGIS');
    private z_PixelTexGenParameterfvSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; var &params: single)>(z_PixelTexGenParameterfvSGIS_adr);
    private z_PixelTexGenParameterfvSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_PixelTexGenParameterfvSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PixelTexGenParameterfvSGIS_ovr_0(pname, &params[0]) else
      z_PixelTexGenParameterfvSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; var &params: single) :=
    z_PixelTexGenParameterfvSGIS_ovr_0(pname, &params);
    private z_PixelTexGenParameterfvSGIS_ovr_2 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_PixelTexGenParameterfvSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_PixelTexGenParameterfvSGIS_ovr_2(pname, &params);
    
    private z_GetPixelTexGenParameterivSGIS_adr := GetProcAddress('glGetPixelTexGenParameterivSGIS');
    private z_GetPixelTexGenParameterivSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; var &params: Int32)>(z_GetPixelTexGenParameterivSGIS_adr);
    private z_GetPixelTexGenParameterivSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_GetPixelTexGenParameterivSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTexGenParameterivSGIS_ovr_0(pname, &params[0]) else
      z_GetPixelTexGenParameterivSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; var &params: Int32) :=
    z_GetPixelTexGenParameterivSGIS_ovr_0(pname, &params);
    private z_GetPixelTexGenParameterivSGIS_ovr_2 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_GetPixelTexGenParameterivSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_GetPixelTexGenParameterivSGIS_ovr_2(pname, &params);
    
    private z_GetPixelTexGenParameterfvSGIS_adr := GetProcAddress('glGetPixelTexGenParameterfvSGIS');
    private z_GetPixelTexGenParameterfvSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; var &params: single)>(z_GetPixelTexGenParameterfvSGIS_adr);
    private z_GetPixelTexGenParameterfvSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_GetPixelTexGenParameterfvSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTexGenParameterfvSGIS_ovr_0(pname, &params[0]) else
      z_GetPixelTexGenParameterfvSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; var &params: single) :=
    z_GetPixelTexGenParameterfvSGIS_ovr_0(pname, &params);
    private z_GetPixelTexGenParameterfvSGIS_ovr_2 := GetProcOrNil&<procedure(pname: PixelTexGenParameterNameSGIS; &params: IntPtr)>(z_GetPixelTexGenParameterfvSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_GetPixelTexGenParameterfvSGIS_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPointParametersSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_point_parameters';
    
    private z_PointParameterfSGIS_adr := GetProcAddress('glPointParameterfSGIS');
    private z_PointParameterfSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; param: single)>(z_PointParameterfSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfSGIS(pname: PointParameterNameARB; param: single) :=
    z_PointParameterfSGIS_ovr_0(pname, param);
    
    private z_PointParameterfvSGIS_adr := GetProcAddress('glPointParameterfvSGIS');
    private z_PointParameterfvSGIS_ovr_0 := GetProcOrNil&<procedure(pname: PointParameterNameARB; var &params: single)>(z_PointParameterfvSGIS_adr);
    private z_PointParameterfvSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfvSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvSGIS(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfvSGIS_ovr_0(pname, &params[0]) else
      z_PointParameterfvSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvSGIS(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfvSGIS_ovr_0(pname, &params);
    private z_PointParameterfvSGIS_ovr_2 := GetProcOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfvSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvSGIS(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfvSGIS_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSharpenTextureSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_sharpen_texture';
    
    private z_SharpenTexFuncSGIS_adr := GetProcAddress('glSharpenTexFuncSGIS');
    private z_SharpenTexFuncSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; var points: single)>(z_SharpenTexFuncSGIS_adr);
    private z_SharpenTexFuncSGIS_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; points: IntPtr)>(z_SharpenTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SharpenTexFuncSGIS(target: TextureTarget; n: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_SharpenTexFuncSGIS_ovr_0(target, n, points[0]) else
      z_SharpenTexFuncSGIS_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SharpenTexFuncSGIS(target: TextureTarget; n: Int32; var points: single) :=
    z_SharpenTexFuncSGIS_ovr_0(target, n, points);
    private z_SharpenTexFuncSGIS_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; n: Int32; points: IntPtr)>(z_SharpenTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SharpenTexFuncSGIS(target: TextureTarget; n: Int32; points: IntPtr) :=
    z_SharpenTexFuncSGIS_ovr_2(target, n, points);
    
    private z_GetSharpenTexFuncSGIS_adr := GetProcAddress('glGetSharpenTexFuncSGIS');
    private z_GetSharpenTexFuncSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; var points: single)>(z_GetSharpenTexFuncSGIS_adr);
    private z_GetSharpenTexFuncSGIS_ovr_0_anh001 := GetProcOrNil&<procedure(target: TextureTarget; points: IntPtr)>(z_GetSharpenTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSharpenTexFuncSGIS(target: TextureTarget; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_GetSharpenTexFuncSGIS_ovr_0(target, points[0]) else
      z_GetSharpenTexFuncSGIS_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSharpenTexFuncSGIS(target: TextureTarget; var points: single) :=
    z_GetSharpenTexFuncSGIS_ovr_0(target, points);
    private z_GetSharpenTexFuncSGIS_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; points: IntPtr)>(z_GetSharpenTexFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSharpenTexFuncSGIS(target: TextureTarget; points: IntPtr) :=
    z_GetSharpenTexFuncSGIS_ovr_2(target, points);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTexture4DSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_texture4D';
    
    private z_TexImage4DSGIS_adr := GetProcAddress('glTexImage4DSGIS');
    private z_TexImage4DSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; size4d: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexImage4DSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage4DSGIS(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; size4d: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage4DSGIS_ovr_0(target, level, _internalformat, width, height, depth, size4d, border, format, &type, pixels);
    
    private z_TexSubImage4DSGIS_adr := GetProcAddress('glTexSubImage4DSGIS');
    private z_TexSubImage4DSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; woffset: Int32; width: Int32; height: Int32; depth: Int32; size4d: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage4DSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage4DSGIS(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; woffset: Int32; width: Int32; height: Int32; depth: Int32; size4d: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage4DSGIS_ovr_0(target, level, xoffset, yoffset, zoffset, woffset, width, height, depth, size4d, format, &type, pixels);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureColorMaskSGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_texture_color_mask';
    
    private z_TextureColorMaskSGIS_adr := GetProcAddress('glTextureColorMaskSGIS');
    private z_TextureColorMaskSGIS_ovr_0 := GetProcOrNil&<procedure(red: boolean; green: boolean; blue: boolean; alpha: boolean)>(z_TextureColorMaskSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureColorMaskSGIS(red: boolean; green: boolean; blue: boolean; alpha: boolean) :=
    z_TextureColorMaskSGIS_ovr_0(red, green, blue, alpha);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTextureFilter4SGIS = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIS_texture_filter4';
    
    private z_GetTexFilterFuncSGIS_adr := GetProcAddress('glGetTexFilterFuncSGIS');
    private z_GetTexFilterFuncSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; filter: TextureFilterSGIS; var weights: single)>(z_GetTexFilterFuncSGIS_adr);
    private z_GetTexFilterFuncSGIS_ovr_0_anh0001 := GetProcOrNil&<procedure(target: TextureTarget; filter: TextureFilterSGIS; weights: IntPtr)>(z_GetTexFilterFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_GetTexFilterFuncSGIS_ovr_0(target, filter, weights[0]) else
      z_GetTexFilterFuncSGIS_ovr_0_anh0001(target, filter, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; var weights: single) :=
    z_GetTexFilterFuncSGIS_ovr_0(target, filter, weights);
    private z_GetTexFilterFuncSGIS_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; filter: TextureFilterSGIS; weights: IntPtr)>(z_GetTexFilterFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; weights: IntPtr) :=
    z_GetTexFilterFuncSGIS_ovr_2(target, filter, weights);
    
    private z_TexFilterFuncSGIS_adr := GetProcAddress('glTexFilterFuncSGIS');
    private z_TexFilterFuncSGIS_ovr_0 := GetProcOrNil&<procedure(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; var weights: single)>(z_TexFilterFuncSGIS_adr);
    private z_TexFilterFuncSGIS_ovr_0_anh00001 := GetProcOrNil&<procedure(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: IntPtr)>(z_TexFilterFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_TexFilterFuncSGIS_ovr_0(target, filter, n, weights[0]) else
      z_TexFilterFuncSGIS_ovr_0_anh00001(target, filter, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; var weights: single) :=
    z_TexFilterFuncSGIS_ovr_0(target, filter, n, weights);
    private z_TexFilterFuncSGIS_ovr_2 := GetProcOrNil&<procedure(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: IntPtr)>(z_TexFilterFuncSGIS_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: IntPtr) :=
    z_TexFilterFuncSGIS_ovr_2(target, filter, n, weights);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glAsyncSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_async';
    
    private z_AsyncMarkerSGIX_adr := GetProcAddress('glAsyncMarkerSGIX');
    private z_AsyncMarkerSGIX_ovr_0 := GetProcOrNil&<procedure(marker: UInt32)>(z_AsyncMarkerSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AsyncMarkerSGIX(marker: UInt32) :=
    z_AsyncMarkerSGIX_ovr_0(marker);
    
    private z_FinishAsyncSGIX_adr := GetProcAddress('glFinishAsyncSGIX');
    private z_FinishAsyncSGIX_ovr_0 := GetProcOrNil&<function(var markerp: UInt32): Int32>(z_FinishAsyncSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FinishAsyncSGIX(var markerp: UInt32): Int32 :=
    z_FinishAsyncSGIX_ovr_0(markerp);
    private z_FinishAsyncSGIX_ovr_1 := GetProcOrNil&<function(markerp: IntPtr): Int32>(z_FinishAsyncSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FinishAsyncSGIX(markerp: IntPtr): Int32 :=
    z_FinishAsyncSGIX_ovr_1(markerp);
    
    private z_PollAsyncSGIX_adr := GetProcAddress('glPollAsyncSGIX');
    private z_PollAsyncSGIX_ovr_0 := GetProcOrNil&<function(var markerp: UInt32): Int32>(z_PollAsyncSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollAsyncSGIX(var markerp: UInt32): Int32 :=
    z_PollAsyncSGIX_ovr_0(markerp);
    private z_PollAsyncSGIX_ovr_1 := GetProcOrNil&<function(markerp: IntPtr): Int32>(z_PollAsyncSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollAsyncSGIX(markerp: IntPtr): Int32 :=
    z_PollAsyncSGIX_ovr_1(markerp);
    
    private z_GenAsyncMarkersSGIX_adr := GetProcAddress('glGenAsyncMarkersSGIX');
    private z_GenAsyncMarkersSGIX_ovr_0 := GetProcOrNil&<function(range: Int32): UInt32>(z_GenAsyncMarkersSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenAsyncMarkersSGIX(range: Int32): UInt32 :=
    z_GenAsyncMarkersSGIX_ovr_0(range);
    
    private z_DeleteAsyncMarkersSGIX_adr := GetProcAddress('glDeleteAsyncMarkersSGIX');
    private z_DeleteAsyncMarkersSGIX_ovr_0 := GetProcOrNil&<procedure(marker: UInt32; range: Int32)>(z_DeleteAsyncMarkersSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteAsyncMarkersSGIX(marker: UInt32; range: Int32) :=
    z_DeleteAsyncMarkersSGIX_ovr_0(marker, range);
    
    private z_IsAsyncMarkerSGIX_adr := GetProcAddress('glIsAsyncMarkerSGIX');
    private z_IsAsyncMarkerSGIX_ovr_0 := GetProcOrNil&<function(marker: UInt32): boolean>(z_IsAsyncMarkerSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsAsyncMarkerSGIX(marker: UInt32): boolean :=
    z_IsAsyncMarkerSGIX_ovr_0(marker);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFlushRasterSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_flush_raster';
    
    private z_FlushRasterSGIX_adr := GetProcAddress('glFlushRasterSGIX');
    private z_FlushRasterSGIX_ovr_0 := GetProcOrNil&<procedure>(z_FlushRasterSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushRasterSGIX :=
    z_FlushRasterSGIX_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFragmentLightingSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_fragment_lighting';
    
    private z_FragmentColorMaterialSGIX_adr := GetProcAddress('glFragmentColorMaterialSGIX');
    private z_FragmentColorMaterialSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; mode: MaterialParameter)>(z_FragmentColorMaterialSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentColorMaterialSGIX(face: MaterialFace; mode: MaterialParameter) :=
    z_FragmentColorMaterialSGIX_ovr_0(face, mode);
    
    private z_FragmentLightfSGIX_adr := GetProcAddress('glFragmentLightfSGIX');
    private z_FragmentLightfSGIX_ovr_0 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: single)>(z_FragmentLightfSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: single) :=
    z_FragmentLightfSGIX_ovr_0(light, pname, param);
    
    private z_FragmentLightfvSGIX_adr := GetProcAddress('glFragmentLightfvSGIX');
    private z_FragmentLightfvSGIX_ovr_0 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single)>(z_FragmentLightfvSGIX_adr);
    private z_FragmentLightfvSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_FragmentLightfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightfvSGIX_ovr_0(light, pname, &params[0]) else
      z_FragmentLightfvSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single) :=
    z_FragmentLightfvSGIX_ovr_0(light, pname, &params);
    private z_FragmentLightfvSGIX_ovr_2 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_FragmentLightfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_FragmentLightfvSGIX_ovr_2(light, pname, &params);
    
    private z_FragmentLightiSGIX_adr := GetProcAddress('glFragmentLightiSGIX');
    private z_FragmentLightiSGIX_ovr_0 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: Int32)>(z_FragmentLightiSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightiSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: Int32) :=
    z_FragmentLightiSGIX_ovr_0(light, pname, param);
    
    private z_FragmentLightivSGIX_adr := GetProcAddress('glFragmentLightivSGIX');
    private z_FragmentLightivSGIX_ovr_0 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32)>(z_FragmentLightivSGIX_adr);
    private z_FragmentLightivSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_FragmentLightivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightivSGIX_ovr_0(light, pname, &params[0]) else
      z_FragmentLightivSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32) :=
    z_FragmentLightivSGIX_ovr_0(light, pname, &params);
    private z_FragmentLightivSGIX_ovr_2 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_FragmentLightivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_FragmentLightivSGIX_ovr_2(light, pname, &params);
    
    private z_FragmentLightModelfSGIX_adr := GetProcAddress('glFragmentLightModelfSGIX');
    private z_FragmentLightModelfSGIX_ovr_0 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; param: single)>(z_FragmentLightModelfSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfSGIX(pname: FragmentLightModelParameterSGIX; param: single) :=
    z_FragmentLightModelfSGIX_ovr_0(pname, param);
    
    private z_FragmentLightModelfvSGIX_adr := GetProcAddress('glFragmentLightModelfvSGIX');
    private z_FragmentLightModelfvSGIX_ovr_0 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; var &params: single)>(z_FragmentLightModelfvSGIX_adr);
    private z_FragmentLightModelfvSGIX_ovr_0_anh001 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; &params: IntPtr)>(z_FragmentLightModelfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfvSGIX(pname: FragmentLightModelParameterSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightModelfvSGIX_ovr_0(pname, &params[0]) else
      z_FragmentLightModelfvSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfvSGIX(pname: FragmentLightModelParameterSGIX; var &params: single) :=
    z_FragmentLightModelfvSGIX_ovr_0(pname, &params);
    private z_FragmentLightModelfvSGIX_ovr_2 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; &params: IntPtr)>(z_FragmentLightModelfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfvSGIX(pname: FragmentLightModelParameterSGIX; &params: IntPtr) :=
    z_FragmentLightModelfvSGIX_ovr_2(pname, &params);
    
    private z_FragmentLightModeliSGIX_adr := GetProcAddress('glFragmentLightModeliSGIX');
    private z_FragmentLightModeliSGIX_ovr_0 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; param: Int32)>(z_FragmentLightModeliSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModeliSGIX(pname: FragmentLightModelParameterSGIX; param: Int32) :=
    z_FragmentLightModeliSGIX_ovr_0(pname, param);
    
    private z_FragmentLightModelivSGIX_adr := GetProcAddress('glFragmentLightModelivSGIX');
    private z_FragmentLightModelivSGIX_ovr_0 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; var &params: Int32)>(z_FragmentLightModelivSGIX_adr);
    private z_FragmentLightModelivSGIX_ovr_0_anh001 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; &params: IntPtr)>(z_FragmentLightModelivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelivSGIX(pname: FragmentLightModelParameterSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightModelivSGIX_ovr_0(pname, &params[0]) else
      z_FragmentLightModelivSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelivSGIX(pname: FragmentLightModelParameterSGIX; var &params: Int32) :=
    z_FragmentLightModelivSGIX_ovr_0(pname, &params);
    private z_FragmentLightModelivSGIX_ovr_2 := GetProcOrNil&<procedure(pname: FragmentLightModelParameterSGIX; &params: IntPtr)>(z_FragmentLightModelivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelivSGIX(pname: FragmentLightModelParameterSGIX; &params: IntPtr) :=
    z_FragmentLightModelivSGIX_ovr_2(pname, &params);
    
    private z_FragmentMaterialfSGIX_adr := GetProcAddress('glFragmentMaterialfSGIX');
    private z_FragmentMaterialfSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: single)>(z_FragmentMaterialfSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfSGIX(face: MaterialFace; pname: MaterialParameter; param: single) :=
    z_FragmentMaterialfSGIX_ovr_0(face, pname, param);
    
    private z_FragmentMaterialfvSGIX_adr := GetProcAddress('glFragmentMaterialfvSGIX');
    private z_FragmentMaterialfvSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: single)>(z_FragmentMaterialfvSGIX_adr);
    private z_FragmentMaterialfvSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_FragmentMaterialfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfvSGIX(face: MaterialFace; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentMaterialfvSGIX_ovr_0(face, pname, &params[0]) else
      z_FragmentMaterialfvSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfvSGIX(face: MaterialFace; pname: MaterialParameter; var &params: single) :=
    z_FragmentMaterialfvSGIX_ovr_0(face, pname, &params);
    private z_FragmentMaterialfvSGIX_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_FragmentMaterialfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfvSGIX(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_FragmentMaterialfvSGIX_ovr_2(face, pname, &params);
    
    private z_FragmentMaterialiSGIX_adr := GetProcAddress('glFragmentMaterialiSGIX');
    private z_FragmentMaterialiSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; param: Int32)>(z_FragmentMaterialiSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialiSGIX(face: MaterialFace; pname: MaterialParameter; param: Int32) :=
    z_FragmentMaterialiSGIX_ovr_0(face, pname, param);
    
    private z_FragmentMaterialivSGIX_adr := GetProcAddress('glFragmentMaterialivSGIX');
    private z_FragmentMaterialivSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: Int32)>(z_FragmentMaterialivSGIX_adr);
    private z_FragmentMaterialivSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_FragmentMaterialivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialivSGIX(face: MaterialFace; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentMaterialivSGIX_ovr_0(face, pname, &params[0]) else
      z_FragmentMaterialivSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialivSGIX(face: MaterialFace; pname: MaterialParameter; var &params: Int32) :=
    z_FragmentMaterialivSGIX_ovr_0(face, pname, &params);
    private z_FragmentMaterialivSGIX_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_FragmentMaterialivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialivSGIX(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_FragmentMaterialivSGIX_ovr_2(face, pname, &params);
    
    private z_GetFragmentLightfvSGIX_adr := GetProcAddress('glGetFragmentLightfvSGIX');
    private z_GetFragmentLightfvSGIX_ovr_0 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single)>(z_GetFragmentLightfvSGIX_adr);
    private z_GetFragmentLightfvSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_GetFragmentLightfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentLightfvSGIX_ovr_0(light, pname, &params[0]) else
      z_GetFragmentLightfvSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single) :=
    z_GetFragmentLightfvSGIX_ovr_0(light, pname, &params);
    private z_GetFragmentLightfvSGIX_ovr_2 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_GetFragmentLightfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_GetFragmentLightfvSGIX_ovr_2(light, pname, &params);
    
    private z_GetFragmentLightivSGIX_adr := GetProcAddress('glGetFragmentLightivSGIX');
    private z_GetFragmentLightivSGIX_ovr_0 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32)>(z_GetFragmentLightivSGIX_adr);
    private z_GetFragmentLightivSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_GetFragmentLightivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentLightivSGIX_ovr_0(light, pname, &params[0]) else
      z_GetFragmentLightivSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32) :=
    z_GetFragmentLightivSGIX_ovr_0(light, pname, &params);
    private z_GetFragmentLightivSGIX_ovr_2 := GetProcOrNil&<procedure(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr)>(z_GetFragmentLightivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_GetFragmentLightivSGIX_ovr_2(light, pname, &params);
    
    private z_GetFragmentMaterialfvSGIX_adr := GetProcAddress('glGetFragmentMaterialfvSGIX');
    private z_GetFragmentMaterialfvSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: single)>(z_GetFragmentMaterialfvSGIX_adr);
    private z_GetFragmentMaterialfvSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetFragmentMaterialfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialfvSGIX(face: MaterialFace; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentMaterialfvSGIX_ovr_0(face, pname, &params[0]) else
      z_GetFragmentMaterialfvSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialfvSGIX(face: MaterialFace; pname: MaterialParameter; var &params: single) :=
    z_GetFragmentMaterialfvSGIX_ovr_0(face, pname, &params);
    private z_GetFragmentMaterialfvSGIX_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetFragmentMaterialfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialfvSGIX(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_GetFragmentMaterialfvSGIX_ovr_2(face, pname, &params);
    
    private z_GetFragmentMaterialivSGIX_adr := GetProcAddress('glGetFragmentMaterialivSGIX');
    private z_GetFragmentMaterialivSGIX_ovr_0 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; var &params: Int32)>(z_GetFragmentMaterialivSGIX_adr);
    private z_GetFragmentMaterialivSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetFragmentMaterialivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialivSGIX(face: MaterialFace; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentMaterialivSGIX_ovr_0(face, pname, &params[0]) else
      z_GetFragmentMaterialivSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialivSGIX(face: MaterialFace; pname: MaterialParameter; var &params: Int32) :=
    z_GetFragmentMaterialivSGIX_ovr_0(face, pname, &params);
    private z_GetFragmentMaterialivSGIX_ovr_2 := GetProcOrNil&<procedure(face: MaterialFace; pname: MaterialParameter; &params: IntPtr)>(z_GetFragmentMaterialivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialivSGIX(face: MaterialFace; pname: MaterialParameter; &params: IntPtr) :=
    z_GetFragmentMaterialivSGIX_ovr_2(face, pname, &params);
    
    private z_LightEnviSGIX_adr := GetProcAddress('glLightEnviSGIX');
    private z_LightEnviSGIX_ovr_0 := GetProcOrNil&<procedure(pname: LightEnvParameterSGIX; param: Int32)>(z_LightEnviSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightEnviSGIX(pname: LightEnvParameterSGIX; param: Int32) :=
    z_LightEnviSGIX_ovr_0(pname, param);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glFramezoomSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_framezoom';
    
    private z_FrameZoomSGIX_adr := GetProcAddress('glFrameZoomSGIX');
    private z_FrameZoomSGIX_ovr_0 := GetProcOrNil&<procedure(factor: Int32)>(z_FrameZoomSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrameZoomSGIX(factor: Int32) :=
    z_FrameZoomSGIX_ovr_0(factor);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glIglooInterfaceSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_igloo_interface';
    
    private z_IglooInterfaceSGIX_adr := GetProcAddress('glIglooInterfaceSGIX');
    private z_IglooInterfaceSGIX_ovr_0 := GetProcOrNil&<procedure(pname: DummyEnum; &params: IntPtr)>(z_IglooInterfaceSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IglooInterfaceSGIX(pname: DummyEnum; &params: IntPtr) :=
    z_IglooInterfaceSGIX_ovr_0(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glInstrumentsSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_instruments';
    
    private z_GetInstrumentsSGIX_adr := GetProcAddress('glGetInstrumentsSGIX');
    private z_GetInstrumentsSGIX_ovr_0 := GetProcOrNil&<function: Int32>(z_GetInstrumentsSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetInstrumentsSGIX: Int32 :=
    z_GetInstrumentsSGIX_ovr_0;
    
    private z_InstrumentsBufferSGIX_adr := GetProcAddress('glInstrumentsBufferSGIX');
    private z_InstrumentsBufferSGIX_ovr_0 := GetProcOrNil&<procedure(size: Int32; var buffer: Int32)>(z_InstrumentsBufferSGIX_adr);
    private z_InstrumentsBufferSGIX_ovr_0_anh001 := GetProcOrNil&<procedure(size: Int32; buffer: IntPtr)>(z_InstrumentsBufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InstrumentsBufferSGIX(size: Int32; buffer: array of Int32) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_InstrumentsBufferSGIX_ovr_0(size, buffer[0]) else
      z_InstrumentsBufferSGIX_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InstrumentsBufferSGIX(size: Int32; var buffer: Int32) :=
    z_InstrumentsBufferSGIX_ovr_0(size, buffer);
    private z_InstrumentsBufferSGIX_ovr_2 := GetProcOrNil&<procedure(size: Int32; buffer: IntPtr)>(z_InstrumentsBufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InstrumentsBufferSGIX(size: Int32; buffer: IntPtr) :=
    z_InstrumentsBufferSGIX_ovr_2(size, buffer);
    
    private z_PollInstrumentsSGIX_adr := GetProcAddress('glPollInstrumentsSGIX');
    private z_PollInstrumentsSGIX_ovr_0 := GetProcOrNil&<function(var marker_p: Int32): Int32>(z_PollInstrumentsSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollInstrumentsSGIX(var marker_p: Int32): Int32 :=
    z_PollInstrumentsSGIX_ovr_0(marker_p);
    private z_PollInstrumentsSGIX_ovr_1 := GetProcOrNil&<function(marker_p: IntPtr): Int32>(z_PollInstrumentsSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollInstrumentsSGIX(marker_p: IntPtr): Int32 :=
    z_PollInstrumentsSGIX_ovr_1(marker_p);
    
    private z_ReadInstrumentsSGIX_adr := GetProcAddress('glReadInstrumentsSGIX');
    private z_ReadInstrumentsSGIX_ovr_0 := GetProcOrNil&<procedure(marker: Int32)>(z_ReadInstrumentsSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadInstrumentsSGIX(marker: Int32) :=
    z_ReadInstrumentsSGIX_ovr_0(marker);
    
    private z_StartInstrumentsSGIX_adr := GetProcAddress('glStartInstrumentsSGIX');
    private z_StartInstrumentsSGIX_ovr_0 := GetProcOrNil&<procedure>(z_StartInstrumentsSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StartInstrumentsSGIX :=
    z_StartInstrumentsSGIX_ovr_0;
    
    private z_StopInstrumentsSGIX_adr := GetProcAddress('glStopInstrumentsSGIX');
    private z_StopInstrumentsSGIX_ovr_0 := GetProcOrNil&<procedure(marker: Int32)>(z_StopInstrumentsSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StopInstrumentsSGIX(marker: Int32) :=
    z_StopInstrumentsSGIX_ovr_0(marker);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glListPrioritySGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_list_priority';
    
    private z_GetListParameterfvSGIX_adr := GetProcAddress('glGetListParameterfvSGIX');
    private z_GetListParameterfvSGIX_ovr_0 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; var &params: single)>(z_GetListParameterfvSGIX_adr);
    private z_GetListParameterfvSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_GetListParameterfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetListParameterfvSGIX_ovr_0(list, pname, &params[0]) else
      z_GetListParameterfvSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterfvSGIX(list: UInt32; pname: ListParameterName; var &params: single) :=
    z_GetListParameterfvSGIX_ovr_0(list, pname, &params);
    private z_GetListParameterfvSGIX_ovr_2 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_GetListParameterfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_GetListParameterfvSGIX_ovr_2(list, pname, &params);
    
    private z_GetListParameterivSGIX_adr := GetProcAddress('glGetListParameterivSGIX');
    private z_GetListParameterivSGIX_ovr_0 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; var &params: Int32)>(z_GetListParameterivSGIX_adr);
    private z_GetListParameterivSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_GetListParameterivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetListParameterivSGIX_ovr_0(list, pname, &params[0]) else
      z_GetListParameterivSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterivSGIX(list: UInt32; pname: ListParameterName; var &params: Int32) :=
    z_GetListParameterivSGIX_ovr_0(list, pname, &params);
    private z_GetListParameterivSGIX_ovr_2 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_GetListParameterivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_GetListParameterivSGIX_ovr_2(list, pname, &params);
    
    private z_ListParameterfSGIX_adr := GetProcAddress('glListParameterfSGIX');
    private z_ListParameterfSGIX_ovr_0 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; param: single)>(z_ListParameterfSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfSGIX(list: UInt32; pname: ListParameterName; param: single) :=
    z_ListParameterfSGIX_ovr_0(list, pname, param);
    
    private z_ListParameterfvSGIX_adr := GetProcAddress('glListParameterfvSGIX');
    private z_ListParameterfvSGIX_ovr_0 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; var &params: single)>(z_ListParameterfvSGIX_adr);
    private z_ListParameterfvSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_ListParameterfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ListParameterfvSGIX_ovr_0(list, pname, &params[0]) else
      z_ListParameterfvSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfvSGIX(list: UInt32; pname: ListParameterName; var &params: single) :=
    z_ListParameterfvSGIX_ovr_0(list, pname, &params);
    private z_ListParameterfvSGIX_ovr_2 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_ListParameterfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_ListParameterfvSGIX_ovr_2(list, pname, &params);
    
    private z_ListParameteriSGIX_adr := GetProcAddress('glListParameteriSGIX');
    private z_ListParameteriSGIX_ovr_0 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; param: Int32)>(z_ListParameteriSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameteriSGIX(list: UInt32; pname: ListParameterName; param: Int32) :=
    z_ListParameteriSGIX_ovr_0(list, pname, param);
    
    private z_ListParameterivSGIX_adr := GetProcAddress('glListParameterivSGIX');
    private z_ListParameterivSGIX_ovr_0 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; var &params: Int32)>(z_ListParameterivSGIX_adr);
    private z_ListParameterivSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_ListParameterivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ListParameterivSGIX_ovr_0(list, pname, &params[0]) else
      z_ListParameterivSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterivSGIX(list: UInt32; pname: ListParameterName; var &params: Int32) :=
    z_ListParameterivSGIX_ovr_0(list, pname, &params);
    private z_ListParameterivSGIX_ovr_2 := GetProcOrNil&<procedure(list: UInt32; pname: ListParameterName; &params: IntPtr)>(z_ListParameterivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_ListParameterivSGIX_ovr_2(list, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPixelTextureSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_pixel_texture';
    
    private z_PixelTexGenSGIX_adr := GetProcAddress('glPixelTexGenSGIX');
    private z_PixelTexGenSGIX_ovr_0 := GetProcOrNil&<procedure(mode: PixelTexGenModeSGIX)>(z_PixelTexGenSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenSGIX(mode: PixelTexGenModeSGIX) :=
    z_PixelTexGenSGIX_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glPolynomialFfdSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_polynomial_ffd';
    
    private z_DeformationMap3dSGIX_adr := GetProcAddress('glDeformationMap3dSGIX');
    private z_DeformationMap3dSGIX_ovr_0 := GetProcOrNil&<procedure(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; var points: real)>(z_DeformationMap3dSGIX_adr);
    private z_DeformationMap3dSGIX_ovr_0_anh000000000000001 := GetProcOrNil&<procedure(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: IntPtr)>(z_DeformationMap3dSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3dSGIX(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_DeformationMap3dSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points[0]) else
      z_DeformationMap3dSGIX_ovr_0_anh000000000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3dSGIX(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; var points: real) :=
    z_DeformationMap3dSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    private z_DeformationMap3dSGIX_ovr_2 := GetProcOrNil&<procedure(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: IntPtr)>(z_DeformationMap3dSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3dSGIX(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: IntPtr) :=
    z_DeformationMap3dSGIX_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    
    private z_DeformationMap3fSGIX_adr := GetProcAddress('glDeformationMap3fSGIX');
    private z_DeformationMap3fSGIX_ovr_0 := GetProcOrNil&<procedure(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; var points: single)>(z_DeformationMap3fSGIX_adr);
    private z_DeformationMap3fSGIX_ovr_0_anh000000000000001 := GetProcOrNil&<procedure(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: IntPtr)>(z_DeformationMap3fSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3fSGIX(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_DeformationMap3fSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points[0]) else
      z_DeformationMap3fSGIX_ovr_0_anh000000000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3fSGIX(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; var points: single) :=
    z_DeformationMap3fSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    private z_DeformationMap3fSGIX_ovr_2 := GetProcOrNil&<procedure(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: IntPtr)>(z_DeformationMap3fSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3fSGIX(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: IntPtr) :=
    z_DeformationMap3fSGIX_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    
    private z_DeformSGIX_adr := GetProcAddress('glDeformSGIX');
    private z_DeformSGIX_ovr_0 := GetProcOrNil&<procedure(mask: FfdMaskSGIX)>(z_DeformSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformSGIX(mask: FfdMaskSGIX) :=
    z_DeformSGIX_ovr_0(mask);
    
    private z_LoadIdentityDeformationMapSGIX_adr := GetProcAddress('glLoadIdentityDeformationMapSGIX');
    private z_LoadIdentityDeformationMapSGIX_ovr_0 := GetProcOrNil&<procedure(mask: FfdMaskSGIX)>(z_LoadIdentityDeformationMapSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadIdentityDeformationMapSGIX(mask: FfdMaskSGIX) :=
    z_LoadIdentityDeformationMapSGIX_ovr_0(mask);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glReferencePlaneSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_reference_plane';
    
    private z_ReferencePlaneSGIX_adr := GetProcAddress('glReferencePlaneSGIX');
    private z_ReferencePlaneSGIX_ovr_0 := GetProcOrNil&<procedure(var equation: real)>(z_ReferencePlaneSGIX_adr);
    private z_ReferencePlaneSGIX_ovr_0_anh01 := GetProcOrNil&<procedure(equation: IntPtr)>(z_ReferencePlaneSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReferencePlaneSGIX(equation: array of real) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ReferencePlaneSGIX_ovr_0(equation[0]) else
      z_ReferencePlaneSGIX_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReferencePlaneSGIX(var equation: real) :=
    z_ReferencePlaneSGIX_ovr_0(equation);
    private z_ReferencePlaneSGIX_ovr_2 := GetProcOrNil&<procedure(equation: IntPtr)>(z_ReferencePlaneSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReferencePlaneSGIX(equation: IntPtr) :=
    z_ReferencePlaneSGIX_ovr_2(equation);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glSpriteSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_sprite';
    
    private z_SpriteParameterfSGIX_adr := GetProcAddress('glSpriteParameterfSGIX');
    private z_SpriteParameterfSGIX_ovr_0 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; param: single)>(z_SpriteParameterfSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfSGIX(pname: SpriteParameterNameSGIX; param: single) :=
    z_SpriteParameterfSGIX_ovr_0(pname, param);
    
    private z_SpriteParameterfvSGIX_adr := GetProcAddress('glSpriteParameterfvSGIX');
    private z_SpriteParameterfvSGIX_ovr_0 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; var &params: single)>(z_SpriteParameterfvSGIX_adr);
    private z_SpriteParameterfvSGIX_ovr_0_anh001 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; &params: IntPtr)>(z_SpriteParameterfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfvSGIX(pname: SpriteParameterNameSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SpriteParameterfvSGIX_ovr_0(pname, &params[0]) else
      z_SpriteParameterfvSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfvSGIX(pname: SpriteParameterNameSGIX; var &params: single) :=
    z_SpriteParameterfvSGIX_ovr_0(pname, &params);
    private z_SpriteParameterfvSGIX_ovr_2 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; &params: IntPtr)>(z_SpriteParameterfvSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfvSGIX(pname: SpriteParameterNameSGIX; &params: IntPtr) :=
    z_SpriteParameterfvSGIX_ovr_2(pname, &params);
    
    private z_SpriteParameteriSGIX_adr := GetProcAddress('glSpriteParameteriSGIX');
    private z_SpriteParameteriSGIX_ovr_0 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; param: Int32)>(z_SpriteParameteriSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameteriSGIX(pname: SpriteParameterNameSGIX; param: Int32) :=
    z_SpriteParameteriSGIX_ovr_0(pname, param);
    
    private z_SpriteParameterivSGIX_adr := GetProcAddress('glSpriteParameterivSGIX');
    private z_SpriteParameterivSGIX_ovr_0 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; var &params: Int32)>(z_SpriteParameterivSGIX_adr);
    private z_SpriteParameterivSGIX_ovr_0_anh001 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; &params: IntPtr)>(z_SpriteParameterivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterivSGIX(pname: SpriteParameterNameSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SpriteParameterivSGIX_ovr_0(pname, &params[0]) else
      z_SpriteParameterivSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterivSGIX(pname: SpriteParameterNameSGIX; var &params: Int32) :=
    z_SpriteParameterivSGIX_ovr_0(pname, &params);
    private z_SpriteParameterivSGIX_ovr_2 := GetProcOrNil&<procedure(pname: SpriteParameterNameSGIX; &params: IntPtr)>(z_SpriteParameterivSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterivSGIX(pname: SpriteParameterNameSGIX; &params: IntPtr) :=
    z_SpriteParameterivSGIX_ovr_2(pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTagSampleBufferSGIX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_tag_sample_buffer';
    
    private z_TagSampleBufferSGIX_adr := GetProcAddress('glTagSampleBufferSGIX');
    private z_TagSampleBufferSGIX_ovr_0 := GetProcOrNil&<procedure>(z_TagSampleBufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TagSampleBufferSGIX :=
    z_TagSampleBufferSGIX_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glColorTableSGI = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGI_color_table';
    
    private z_ColorTableSGI_adr := GetProcAddress('glColorTableSGI');
    private z_ColorTableSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr)>(z_ColorTableSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableSGI(target: ColorTableTargetSGI; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_ColorTableSGI_ovr_0(target, _internalformat, width, format, &type, table);
    
    private z_ColorTableParameterfvSGI_adr := GetProcAddress('glColorTableParameterfvSGI');
    private z_ColorTableParameterfvSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; var &params: single)>(z_ColorTableParameterfvSGI_adr);
    private z_ColorTableParameterfvSGI_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameterfvSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameterfvSGI_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameterfvSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; var &params: single) :=
    z_ColorTableParameterfvSGI_ovr_0(target, pname, &params);
    private z_ColorTableParameterfvSGI_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameterfvSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: IntPtr) :=
    z_ColorTableParameterfvSGI_ovr_2(target, pname, &params);
    
    private z_ColorTableParameterivSGI_adr := GetProcAddress('glColorTableParameterivSGI');
    private z_ColorTableParameterivSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; var &params: Int32)>(z_ColorTableParameterivSGI_adr);
    private z_ColorTableParameterivSGI_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameterivSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterivSGI(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameterivSGI_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameterivSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterivSGI(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; var &params: Int32) :=
    z_ColorTableParameterivSGI_ovr_0(target, pname, &params);
    private z_ColorTableParameterivSGI_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: IntPtr)>(z_ColorTableParameterivSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterivSGI(target: ColorTableTargetSGI; pname: ColorTableParameterPNameSGI; &params: IntPtr) :=
    z_ColorTableParameterivSGI_ovr_2(target, pname, &params);
    
    private z_CopyColorTableSGI_adr := GetProcAddress('glCopyColorTableSGI');
    private z_CopyColorTableSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32)>(z_CopyColorTableSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorTableSGI(target: ColorTableTargetSGI; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorTableSGI_ovr_0(target, _internalformat, x, y, width);
    
    private z_GetColorTableSGI_adr := GetProcAddress('glGetColorTableSGI');
    private z_GetColorTableSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; format: PixelFormat; &type: PixelType; table: IntPtr)>(z_GetColorTableSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableSGI(target: ColorTableTargetSGI; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_GetColorTableSGI_ovr_0(target, format, &type, table);
    
    private z_GetColorTableParameterfvSGI_adr := GetProcAddress('glGetColorTableParameterfvSGI');
    private z_GetColorTableParameterfvSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: single)>(z_GetColorTableParameterfvSGI_adr);
    private z_GetColorTableParameterfvSGI_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterfvSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterfvSGI_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterfvSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: single) :=
    z_GetColorTableParameterfvSGI_ovr_0(target, pname, &params);
    private z_GetColorTableParameterfvSGI_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterfvSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterfvSGI_ovr_2(target, pname, &params);
    
    private z_GetColorTableParameterivSGI_adr := GetProcAddress('glGetColorTableParameterivSGI');
    private z_GetColorTableParameterivSGI_ovr_0 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: Int32)>(z_GetColorTableParameterivSGI_adr);
    private z_GetColorTableParameterivSGI_ovr_0_anh0001 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterivSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterivSGI_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterivSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: Int32) :=
    z_GetColorTableParameterivSGI_ovr_0(target, pname, &params);
    private z_GetColorTableParameterivSGI_ovr_2 := GetProcOrNil&<procedure(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr)>(z_GetColorTableParameterivSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterivSGI_ovr_2(target, pname, &params);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glConstantDataSUNX = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SUNX_constant_data';
    
    private z_FinishTextureSUNX_adr := GetProcAddress('glFinishTextureSUNX');
    private z_FinishTextureSUNX_ovr_0 := GetProcOrNil&<procedure>(z_FinishTextureSUNX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishTextureSUNX :=
    z_FinishTextureSUNX_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glGlobalAlphaSUN = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SUN_global_alpha';
    
    private z_GlobalAlphaFactorbSUN_adr := GetProcAddress('glGlobalAlphaFactorbSUN');
    private z_GlobalAlphaFactorbSUN_ovr_0 := GetProcOrNil&<procedure(factor: SByte)>(z_GlobalAlphaFactorbSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorbSUN(factor: SByte) :=
    z_GlobalAlphaFactorbSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactorsSUN_adr := GetProcAddress('glGlobalAlphaFactorsSUN');
    private z_GlobalAlphaFactorsSUN_ovr_0 := GetProcOrNil&<procedure(factor: Int16)>(z_GlobalAlphaFactorsSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorsSUN(factor: Int16) :=
    z_GlobalAlphaFactorsSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactoriSUN_adr := GetProcAddress('glGlobalAlphaFactoriSUN');
    private z_GlobalAlphaFactoriSUN_ovr_0 := GetProcOrNil&<procedure(factor: Int32)>(z_GlobalAlphaFactoriSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactoriSUN(factor: Int32) :=
    z_GlobalAlphaFactoriSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactorfSUN_adr := GetProcAddress('glGlobalAlphaFactorfSUN');
    private z_GlobalAlphaFactorfSUN_ovr_0 := GetProcOrNil&<procedure(factor: single)>(z_GlobalAlphaFactorfSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorfSUN(factor: single) :=
    z_GlobalAlphaFactorfSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactordSUN_adr := GetProcAddress('glGlobalAlphaFactordSUN');
    private z_GlobalAlphaFactordSUN_ovr_0 := GetProcOrNil&<procedure(factor: real)>(z_GlobalAlphaFactordSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactordSUN(factor: real) :=
    z_GlobalAlphaFactordSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactorubSUN_adr := GetProcAddress('glGlobalAlphaFactorubSUN');
    private z_GlobalAlphaFactorubSUN_ovr_0 := GetProcOrNil&<procedure(factor: Byte)>(z_GlobalAlphaFactorubSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorubSUN(factor: Byte) :=
    z_GlobalAlphaFactorubSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactorusSUN_adr := GetProcAddress('glGlobalAlphaFactorusSUN');
    private z_GlobalAlphaFactorusSUN_ovr_0 := GetProcOrNil&<procedure(factor: UInt16)>(z_GlobalAlphaFactorusSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorusSUN(factor: UInt16) :=
    z_GlobalAlphaFactorusSUN_ovr_0(factor);
    
    private z_GlobalAlphaFactoruiSUN_adr := GetProcAddress('glGlobalAlphaFactoruiSUN');
    private z_GlobalAlphaFactoruiSUN_ovr_0 := GetProcOrNil&<procedure(factor: UInt32)>(z_GlobalAlphaFactoruiSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactoruiSUN(factor: UInt32) :=
    z_GlobalAlphaFactoruiSUN_ovr_0(factor);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glMeshArraySUN = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SUN_mesh_array';
    
    private z_DrawMeshArraysSUN_adr := GetProcAddress('glDrawMeshArraysSUN');
    private z_DrawMeshArraysSUN_ovr_0 := GetProcOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; width: Int32)>(z_DrawMeshArraysSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawMeshArraysSUN(mode: PrimitiveType; first: Int32; count: Int32; width: Int32) :=
    z_DrawMeshArraysSUN_ovr_0(mode, first, count, width);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glTriangleListSUN = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SUN_triangle_list';
    
    private z_ReplacementCodeuiSUN_adr := GetProcAddress('glReplacementCodeuiSUN');
    private z_ReplacementCodeuiSUN_ovr_0 := GetProcOrNil&<procedure(code: UInt32)>(z_ReplacementCodeuiSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiSUN(code: UInt32) :=
    z_ReplacementCodeuiSUN_ovr_0(code);
    
    private z_ReplacementCodeusSUN_adr := GetProcAddress('glReplacementCodeusSUN');
    private z_ReplacementCodeusSUN_ovr_0 := GetProcOrNil&<procedure(code: UInt16)>(z_ReplacementCodeusSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusSUN(code: UInt16) :=
    z_ReplacementCodeusSUN_ovr_0(code);
    
    private z_ReplacementCodeubSUN_adr := GetProcAddress('glReplacementCodeubSUN');
    private z_ReplacementCodeubSUN_ovr_0 := GetProcOrNil&<procedure(code: Byte)>(z_ReplacementCodeubSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubSUN(code: Byte) :=
    z_ReplacementCodeubSUN_ovr_0(code);
    
    private z_ReplacementCodeuivSUN_adr := GetProcAddress('glReplacementCodeuivSUN');
    private z_ReplacementCodeuivSUN_ovr_0 := GetProcOrNil&<procedure(var code: UInt32)>(z_ReplacementCodeuivSUN_adr);
    private z_ReplacementCodeuivSUN_ovr_0_anh01 := GetProcOrNil&<procedure(code: IntPtr)>(z_ReplacementCodeuivSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuivSUN(code: array of UInt32) :=
    if (code<>nil) and (code.Length<>0) then
      z_ReplacementCodeuivSUN_ovr_0(code[0]) else
      z_ReplacementCodeuivSUN_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuivSUN(var code: UInt32) :=
    z_ReplacementCodeuivSUN_ovr_0(code);
    private z_ReplacementCodeuivSUN_ovr_2 := GetProcOrNil&<procedure(code: IntPtr)>(z_ReplacementCodeuivSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuivSUN(code: IntPtr) :=
    z_ReplacementCodeuivSUN_ovr_2(code);
    
    private z_ReplacementCodeusvSUN_adr := GetProcAddress('glReplacementCodeusvSUN');
    private z_ReplacementCodeusvSUN_ovr_0 := GetProcOrNil&<procedure(var code: UInt16)>(z_ReplacementCodeusvSUN_adr);
    private z_ReplacementCodeusvSUN_ovr_0_anh01 := GetProcOrNil&<procedure(code: IntPtr)>(z_ReplacementCodeusvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusvSUN(code: array of UInt16) :=
    if (code<>nil) and (code.Length<>0) then
      z_ReplacementCodeusvSUN_ovr_0(code[0]) else
      z_ReplacementCodeusvSUN_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusvSUN(var code: UInt16) :=
    z_ReplacementCodeusvSUN_ovr_0(code);
    private z_ReplacementCodeusvSUN_ovr_2 := GetProcOrNil&<procedure(code: IntPtr)>(z_ReplacementCodeusvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusvSUN(code: IntPtr) :=
    z_ReplacementCodeusvSUN_ovr_2(code);
    
    private z_ReplacementCodeubvSUN_adr := GetProcAddress('glReplacementCodeubvSUN');
    private z_ReplacementCodeubvSUN_ovr_0 := GetProcOrNil&<procedure(var code: Byte)>(z_ReplacementCodeubvSUN_adr);
    private z_ReplacementCodeubvSUN_ovr_0_anh01 := GetProcOrNil&<procedure(code: IntPtr)>(z_ReplacementCodeubvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubvSUN(code: array of Byte) :=
    if (code<>nil) and (code.Length<>0) then
      z_ReplacementCodeubvSUN_ovr_0(code[0]) else
      z_ReplacementCodeubvSUN_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubvSUN(var code: Byte) :=
    z_ReplacementCodeubvSUN_ovr_0(code);
    private z_ReplacementCodeubvSUN_ovr_2 := GetProcOrNil&<procedure(code: IntPtr)>(z_ReplacementCodeubvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubvSUN(code: IntPtr) :=
    z_ReplacementCodeubvSUN_ovr_2(code);
    
    private z_ReplacementCodePointerSUN_adr := GetProcAddress('glReplacementCodePointerSUN');
    private z_ReplacementCodePointerSUN_ovr_0 := GetProcOrNil&<procedure(&type: ReplacementCodeTypeSUN; stride: Int32; var _pointer: IntPtr)>(z_ReplacementCodePointerSUN_adr);
    private z_ReplacementCodePointerSUN_ovr_0_anh0001 := GetProcOrNil&<procedure(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: IntPtr)>(z_ReplacementCodePointerSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodePointerSUN(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_ReplacementCodePointerSUN_ovr_0(&type, stride, _pointer[0]) else
      z_ReplacementCodePointerSUN_ovr_0_anh0001(&type, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodePointerSUN(&type: ReplacementCodeTypeSUN; stride: Int32; var _pointer: IntPtr) :=
    z_ReplacementCodePointerSUN_ovr_0(&type, stride, _pointer);
    private z_ReplacementCodePointerSUN_ovr_2 := GetProcOrNil&<procedure(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: pointer)>(z_ReplacementCodePointerSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodePointerSUN(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: pointer) :=
    z_ReplacementCodePointerSUN_ovr_2(&type, stride, _pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glVertexSUN = sealed partial class
    public constructor(loader: PlatformLoader);
    private constructor := raise new System.NotSupportedException;
    private function GetProcAddress(name: string): IntPtr;
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SUN_vertex';
    
    private z_Color4ubVertex2fSUN_adr := GetProcAddress('glColor4ubVertex2fSUN');
    private z_Color4ubVertex2fSUN_ovr_0 := GetProcOrNil&<procedure(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single)>(z_Color4ubVertex2fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fSUN(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single) :=
    z_Color4ubVertex2fSUN_ovr_0(r, g, b, a, x, y);
    
    private z_Color4ubVertex2fvSUN_adr := GetProcAddress('glColor4ubVertex2fvSUN');
    private z_Color4ubVertex2fvSUN_ovr_0 := GetProcOrNil&<procedure(var c: Vec4ub; var v: Vec2f)>(z_Color4ubVertex2fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(var c: Vec4ub; var v: Vec2f) :=
    z_Color4ubVertex2fvSUN_ovr_0(c, v);
    private z_Color4ubVertex2fvSUN_ovr_1 := GetProcOrNil&<procedure(var c: Byte; var v: single)>(z_Color4ubVertex2fvSUN_adr);
    private z_Color4ubVertex2fvSUN_ovr_1_anh010 := GetProcOrNil&<procedure(c: IntPtr; var v: single)>(z_Color4ubVertex2fvSUN_adr);
    private z_Color4ubVertex2fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var c: Byte; v: IntPtr)>(z_Color4ubVertex2fvSUN_adr);
    private z_Color4ubVertex2fvSUN_ovr_1_anh011 := GetProcOrNil&<procedure(c: IntPtr; v: IntPtr)>(z_Color4ubVertex2fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(c: array of Byte; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex2fvSUN_ovr_1(c[0], v[0]) else
        z_Color4ubVertex2fvSUN_ovr_1_anh001(c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex2fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Color4ubVertex2fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(var c: Byte; var v: single) :=
    z_Color4ubVertex2fvSUN_ovr_1(c, v);
    private z_Color4ubVertex2fvSUN_ovr_3 := GetProcOrNil&<procedure(c: IntPtr; v: IntPtr)>(z_Color4ubVertex2fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(c: IntPtr; v: IntPtr) :=
    z_Color4ubVertex2fvSUN_ovr_3(c, v);
    
    private z_Color4ubVertex3fSUN_adr := GetProcAddress('glColor4ubVertex3fSUN');
    private z_Color4ubVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single)>(z_Color4ubVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fSUN(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single) :=
    z_Color4ubVertex3fSUN_ovr_0(r, g, b, a, x, y, z);
    
    private z_Color4ubVertex3fvSUN_adr := GetProcAddress('glColor4ubVertex3fvSUN');
    private z_Color4ubVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var c: Vec4ub; var v: Vec3f)>(z_Color4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(var c: Vec4ub; var v: Vec3f) :=
    z_Color4ubVertex3fvSUN_ovr_0(c, v);
    private z_Color4ubVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var c: Byte; var v: single)>(z_Color4ubVertex3fvSUN_adr);
    private z_Color4ubVertex3fvSUN_ovr_1_anh010 := GetProcOrNil&<procedure(c: IntPtr; var v: single)>(z_Color4ubVertex3fvSUN_adr);
    private z_Color4ubVertex3fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var c: Byte; v: IntPtr)>(z_Color4ubVertex3fvSUN_adr);
    private z_Color4ubVertex3fvSUN_ovr_1_anh011 := GetProcOrNil&<procedure(c: IntPtr; v: IntPtr)>(z_Color4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(c: array of Byte; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex3fvSUN_ovr_1(c[0], v[0]) else
        z_Color4ubVertex3fvSUN_ovr_1_anh001(c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Color4ubVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(var c: Byte; var v: single) :=
    z_Color4ubVertex3fvSUN_ovr_1(c, v);
    private z_Color4ubVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(c: IntPtr; v: IntPtr)>(z_Color4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(c: IntPtr; v: IntPtr) :=
    z_Color4ubVertex3fvSUN_ovr_3(c, v);
    
    private z_Color3fVertex3fSUN_adr := GetProcAddress('glColor3fVertex3fSUN');
    private z_Color3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(r: single; g: single; b: single; x: single; y: single; z: single)>(z_Color3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fSUN(r: single; g: single; b: single; x: single; y: single; z: single) :=
    z_Color3fVertex3fSUN_ovr_0(r, g, b, x, y, z);
    
    private z_Color3fVertex3fvSUN_adr := GetProcAddress('glColor3fVertex3fvSUN');
    private z_Color3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var c: Vec3f; var v: Vec3f)>(z_Color3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(var c: Vec3f; var v: Vec3f) :=
    z_Color3fVertex3fvSUN_ovr_0(c, v);
    private z_Color3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var c: single; var v: single)>(z_Color3fVertex3fvSUN_adr);
    private z_Color3fVertex3fvSUN_ovr_1_anh010 := GetProcOrNil&<procedure(c: IntPtr; var v: single)>(z_Color3fVertex3fvSUN_adr);
    private z_Color3fVertex3fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var c: single; v: IntPtr)>(z_Color3fVertex3fvSUN_adr);
    private z_Color3fVertex3fvSUN_ovr_1_anh011 := GetProcOrNil&<procedure(c: IntPtr; v: IntPtr)>(z_Color3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(c: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Color3fVertex3fvSUN_ovr_1(c[0], v[0]) else
        z_Color3fVertex3fvSUN_ovr_1_anh001(c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Color3fVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Color3fVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(var c: single; var v: single) :=
    z_Color3fVertex3fvSUN_ovr_1(c, v);
    private z_Color3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(c: IntPtr; v: IntPtr)>(z_Color3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(c: IntPtr; v: IntPtr) :=
    z_Color3fVertex3fvSUN_ovr_3(c, v);
    
    private z_Normal3fVertex3fSUN_adr := GetProcAddress('glNormal3fVertex3fSUN');
    private z_Normal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_Normal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fSUN(nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_Normal3fVertex3fSUN_ovr_0(nx, ny, nz, x, y, z);
    
    private z_Normal3fVertex3fvSUN_adr := GetProcAddress('glNormal3fVertex3fvSUN');
    private z_Normal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var n: Vec3f; var v: Vec3f)>(z_Normal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(var n: Vec3f; var v: Vec3f) :=
    z_Normal3fVertex3fvSUN_ovr_0(n, v);
    private z_Normal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var n: single; var v: single)>(z_Normal3fVertex3fvSUN_adr);
    private z_Normal3fVertex3fvSUN_ovr_1_anh010 := GetProcOrNil&<procedure(n: IntPtr; var v: single)>(z_Normal3fVertex3fvSUN_adr);
    private z_Normal3fVertex3fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var n: single; v: IntPtr)>(z_Normal3fVertex3fvSUN_adr);
    private z_Normal3fVertex3fvSUN_ovr_1_anh011 := GetProcOrNil&<procedure(n: IntPtr; v: IntPtr)>(z_Normal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(n: array of single; v: array of single) :=
    if (n<>nil) and (n.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Normal3fVertex3fvSUN_ovr_1(n[0], v[0]) else
        z_Normal3fVertex3fvSUN_ovr_1_anh001(n[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Normal3fVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Normal3fVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(var n: single; var v: single) :=
    z_Normal3fVertex3fvSUN_ovr_1(n, v);
    private z_Normal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(n: IntPtr; v: IntPtr)>(z_Normal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(n: IntPtr; v: IntPtr) :=
    z_Normal3fVertex3fvSUN_ovr_3(n, v);
    
    private z_Color4fNormal3fVertex3fSUN_adr := GetProcAddress('glColor4fNormal3fVertex3fSUN');
    private z_Color4fNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_Color4fNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fSUN(r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_Color4fNormal3fVertex3fSUN_ovr_0(r, g, b, a, nx, ny, nz, x, y, z);
    
    private z_Color4fNormal3fVertex3fvSUN_adr := GetProcAddress('glColor4fNormal3fVertex3fvSUN');
    private z_Color4fNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var c: Vec4f; var n: Vec3f; var v: Vec3f)>(z_Color4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_Color4fNormal3fVertex3fvSUN_ovr_0(c, n, v);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var c: single; var n: single; var v: single)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0100 := GetProcOrNil&<procedure(c: IntPtr; var n: single; var v: single)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var c: single; n: IntPtr; var v: single)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0110 := GetProcOrNil&<procedure(c: IntPtr; n: IntPtr; var v: single)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var c: single; var n: single; v: IntPtr)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0101 := GetProcOrNil&<procedure(c: IntPtr; var n: single; v: IntPtr)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var c: single; n: IntPtr; v: IntPtr)>(z_Color4fNormal3fVertex3fvSUN_adr);
    private z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0111 := GetProcOrNil&<procedure(c: IntPtr; n: IntPtr; v: IntPtr)>(z_Color4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(c: array of single; n: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1(c[0], n[0], v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0001(c[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0010(c[0], IntPtr.Zero, v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0011(c[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, n[0], v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(var c: single; var n: single; var v: single) :=
    z_Color4fNormal3fVertex3fvSUN_ovr_1(c, n, v);
    private z_Color4fNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(c: IntPtr; n: IntPtr; v: IntPtr)>(z_Color4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_Color4fNormal3fVertex3fvSUN_ovr_3(c, n, v);
    
    private z_TexCoord2fVertex3fSUN_adr := GetProcAddress('glTexCoord2fVertex3fSUN');
    private z_TexCoord2fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; x: single; y: single; z: single)>(z_TexCoord2fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fSUN(s: single; t: single; x: single; y: single; z: single) :=
    z_TexCoord2fVertex3fSUN_ovr_0(s, t, x, y, z);
    
    private z_TexCoord2fVertex3fvSUN_adr := GetProcAddress('glTexCoord2fVertex3fvSUN');
    private z_TexCoord2fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec2f; var v: Vec3f)>(z_TexCoord2fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(var tc: Vec2f; var v: Vec3f) :=
    z_TexCoord2fVertex3fvSUN_ovr_0(tc, v);
    private z_TexCoord2fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var v: single)>(z_TexCoord2fVertex3fvSUN_adr);
    private z_TexCoord2fVertex3fvSUN_ovr_1_anh010 := GetProcOrNil&<procedure(tc: IntPtr; var v: single)>(z_TexCoord2fVertex3fvSUN_adr);
    private z_TexCoord2fVertex3fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var tc: single; v: IntPtr)>(z_TexCoord2fVertex3fvSUN_adr);
    private z_TexCoord2fVertex3fvSUN_ovr_1_anh011 := GetProcOrNil&<procedure(tc: IntPtr; v: IntPtr)>(z_TexCoord2fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(tc: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord2fVertex3fvSUN_ovr_1(tc[0], v[0]) else
        z_TexCoord2fVertex3fvSUN_ovr_1_anh001(tc[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord2fVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_TexCoord2fVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(var tc: single; var v: single) :=
    z_TexCoord2fVertex3fvSUN_ovr_1(tc, v);
    private z_TexCoord2fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; v: IntPtr)>(z_TexCoord2fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(tc: IntPtr; v: IntPtr) :=
    z_TexCoord2fVertex3fvSUN_ovr_3(tc, v);
    
    private z_TexCoord4fVertex4fSUN_adr := GetProcAddress('glTexCoord4fVertex4fSUN');
    private z_TexCoord4fVertex4fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; p: single; q: single; x: single; y: single; z: single; w: single)>(z_TexCoord4fVertex4fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fSUN(s: single; t: single; p: single; q: single; x: single; y: single; z: single; w: single) :=
    z_TexCoord4fVertex4fSUN_ovr_0(s, t, p, q, x, y, z, w);
    
    private z_TexCoord4fVertex4fvSUN_adr := GetProcAddress('glTexCoord4fVertex4fvSUN');
    private z_TexCoord4fVertex4fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec4f; var v: Vec4f)>(z_TexCoord4fVertex4fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(var tc: Vec4f; var v: Vec4f) :=
    z_TexCoord4fVertex4fvSUN_ovr_0(tc, v);
    private z_TexCoord4fVertex4fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var v: single)>(z_TexCoord4fVertex4fvSUN_adr);
    private z_TexCoord4fVertex4fvSUN_ovr_1_anh010 := GetProcOrNil&<procedure(tc: IntPtr; var v: single)>(z_TexCoord4fVertex4fvSUN_adr);
    private z_TexCoord4fVertex4fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var tc: single; v: IntPtr)>(z_TexCoord4fVertex4fvSUN_adr);
    private z_TexCoord4fVertex4fvSUN_ovr_1_anh011 := GetProcOrNil&<procedure(tc: IntPtr; v: IntPtr)>(z_TexCoord4fVertex4fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(tc: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord4fVertex4fvSUN_ovr_1(tc[0], v[0]) else
        z_TexCoord4fVertex4fvSUN_ovr_1_anh001(tc[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord4fVertex4fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_TexCoord4fVertex4fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(var tc: single; var v: single) :=
    z_TexCoord4fVertex4fvSUN_ovr_1(tc, v);
    private z_TexCoord4fVertex4fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; v: IntPtr)>(z_TexCoord4fVertex4fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(tc: IntPtr; v: IntPtr) :=
    z_TexCoord4fVertex4fvSUN_ovr_3(tc, v);
    
    private z_TexCoord2fColor4ubVertex3fSUN_adr := GetProcAddress('glTexCoord2fColor4ubVertex3fSUN');
    private z_TexCoord2fColor4ubVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single)>(z_TexCoord2fColor4ubVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fSUN(s: single; t: single; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single) :=
    z_TexCoord2fColor4ubVertex3fSUN_ovr_0(s, t, r, g, b, a, x, y, z);
    
    private z_TexCoord2fColor4ubVertex3fvSUN_adr := GetProcAddress('glTexCoord2fColor4ubVertex3fvSUN');
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec2f; var c: Vec4ub; var v: Vec3f)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(var tc: Vec2f; var c: Vec4ub; var v: Vec3f) :=
    z_TexCoord2fColor4ubVertex3fvSUN_ovr_0(tc, c, v);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var c: Byte; var v: single)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0100 := GetProcOrNil&<procedure(tc: IntPtr; var c: Byte; var v: single)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; var v: single)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0110 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; var v: single)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var tc: single; var c: Byte; v: IntPtr)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0101 := GetProcOrNil&<procedure(tc: IntPtr; var c: Byte; v: IntPtr)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; v: IntPtr)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0111 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; v: IntPtr)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(tc: array of single; c: array of Byte; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1(tc[0], c[0], v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0001(tc[0], c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0010(tc[0], IntPtr.Zero, v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0011(tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, c[0], v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(var tc: single; var c: Byte; var v: single) :=
    z_TexCoord2fColor4ubVertex3fvSUN_ovr_1(tc, c, v);
    private z_TexCoord2fColor4ubVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; v: IntPtr)>(z_TexCoord2fColor4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(tc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_TexCoord2fColor4ubVertex3fvSUN_ovr_3(tc, c, v);
    
    private z_TexCoord2fColor3fVertex3fSUN_adr := GetProcAddress('glTexCoord2fColor3fVertex3fSUN');
    private z_TexCoord2fColor3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; r: single; g: single; b: single; x: single; y: single; z: single)>(z_TexCoord2fColor3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fSUN(s: single; t: single; r: single; g: single; b: single; x: single; y: single; z: single) :=
    z_TexCoord2fColor3fVertex3fSUN_ovr_0(s, t, r, g, b, x, y, z);
    
    private z_TexCoord2fColor3fVertex3fvSUN_adr := GetProcAddress('glTexCoord2fColor3fVertex3fvSUN');
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec2f; var c: Vec3f; var v: Vec3f)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(var tc: Vec2f; var c: Vec3f; var v: Vec3f) :=
    z_TexCoord2fColor3fVertex3fvSUN_ovr_0(tc, c, v);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var c: single; var v: single)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0100 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; var v: single)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; var v: single)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0110 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; var v: single)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var tc: single; var c: single; v: IntPtr)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0101 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; v: IntPtr)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; v: IntPtr)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0111 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; v: IntPtr)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(tc: array of single; c: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1(tc[0], c[0], v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0001(tc[0], c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0010(tc[0], IntPtr.Zero, v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0011(tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, c[0], v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(var tc: single; var c: single; var v: single) :=
    z_TexCoord2fColor3fVertex3fvSUN_ovr_1(tc, c, v);
    private z_TexCoord2fColor3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; v: IntPtr)>(z_TexCoord2fColor3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(tc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_TexCoord2fColor3fVertex3fvSUN_ovr_3(tc, c, v);
    
    private z_TexCoord2fNormal3fVertex3fSUN_adr := GetProcAddress('glTexCoord2fNormal3fVertex3fSUN');
    private z_TexCoord2fNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_TexCoord2fNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fSUN(s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_TexCoord2fNormal3fVertex3fSUN_ovr_0(s, t, nx, ny, nz, x, y, z);
    
    private z_TexCoord2fNormal3fVertex3fvSUN_adr := GetProcAddress('glTexCoord2fNormal3fVertex3fvSUN');
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec2f; var n: Vec3f; var v: Vec3f)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(var tc: Vec2f; var n: Vec3f; var v: Vec3f) :=
    z_TexCoord2fNormal3fVertex3fvSUN_ovr_0(tc, n, v);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var n: single; var v: single)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0100 := GetProcOrNil&<procedure(tc: IntPtr; var n: single; var v: single)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var tc: single; n: IntPtr; var v: single)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0110 := GetProcOrNil&<procedure(tc: IntPtr; n: IntPtr; var v: single)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var tc: single; var n: single; v: IntPtr)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0101 := GetProcOrNil&<procedure(tc: IntPtr; var n: single; v: IntPtr)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var tc: single; n: IntPtr; v: IntPtr)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0111 := GetProcOrNil&<procedure(tc: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(tc: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1(tc[0], n[0], v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0001(tc[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0010(tc[0], IntPtr.Zero, v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0011(tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, n[0], v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(var tc: single; var n: single; var v: single) :=
    z_TexCoord2fNormal3fVertex3fvSUN_ovr_1(tc, n, v);
    private z_TexCoord2fNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord2fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(tc: IntPtr; n: IntPtr; v: IntPtr) :=
    z_TexCoord2fNormal3fVertex3fvSUN_ovr_3(tc, n, v);
    
    private z_TexCoord2fColor4fNormal3fVertex3fSUN_adr := GetProcAddress('glTexCoord2fColor4fNormal3fVertex3fSUN');
    private z_TexCoord2fColor4fNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_TexCoord2fColor4fNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fSUN(s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_TexCoord2fColor4fNormal3fVertex3fSUN_ovr_0(s, t, r, g, b, a, nx, ny, nz, x, y, z);
    
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr := GetProcAddress('glTexCoord2fColor4fNormal3fVertex3fvSUN');
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0(tc, c, n, v);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var c: single; var n: single; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01000 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; var n: single; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00100 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; var n: single; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01100 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; var n: single; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00010 := GetProcOrNil&<procedure(var tc: single; var c: single; n: IntPtr; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01010 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; n: IntPtr; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00110 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; n: IntPtr; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01110 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; n: IntPtr; var v: single)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00001 := GetProcOrNil&<procedure(var tc: single; var c: single; var n: single; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01001 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; var n: single; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00101 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; var n: single; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01101 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; var n: single; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00011 := GetProcOrNil&<procedure(var tc: single; var c: single; n: IntPtr; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01011 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; n: IntPtr; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00111 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01111 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(tc: array of single; c: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(tc[0], c[0], n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00001(tc[0], c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00010(tc[0], c[0], IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00011(tc[0], c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00100(tc[0], IntPtr.Zero, n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00101(tc[0], IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00110(tc[0], IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00111(tc[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01000(IntPtr.Zero, c[0], n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01001(IntPtr.Zero, c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01010(IntPtr.Zero, c[0], IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01011(IntPtr.Zero, c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01100(IntPtr.Zero, IntPtr.Zero, n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01101(IntPtr.Zero, IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01110(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(var tc: single; var c: single; var n: single; var v: single) :=
    z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(tc, c, n, v);
    private z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3(tc, c, n, v);
    
    private z_TexCoord4fColor4fNormal3fVertex4fSUN_adr := GetProcAddress('glTexCoord4fColor4fNormal3fVertex4fSUN');
    private z_TexCoord4fColor4fNormal3fVertex4fSUN_ovr_0 := GetProcOrNil&<procedure(s: single; t: single; p: single; q: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single; w: single)>(z_TexCoord4fColor4fNormal3fVertex4fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fSUN(s: single; t: single; p: single; q: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single; w: single) :=
    z_TexCoord4fColor4fNormal3fVertex4fSUN_ovr_0(s, t, p, q, r, g, b, a, nx, ny, nz, x, y, z, w);
    
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr := GetProcAddress('glTexCoord4fColor4fNormal3fVertex4fvSUN');
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_0 := GetProcOrNil&<procedure(var tc: Vec4f; var c: Vec4f; var n: Vec3f; var v: Vec4f)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(var tc: Vec4f; var c: Vec4f; var n: Vec3f; var v: Vec4f) :=
    z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_0(tc, c, n, v);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1 := GetProcOrNil&<procedure(var tc: single; var c: single; var n: single; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01000 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; var n: single; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00100 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; var n: single; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01100 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; var n: single; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00010 := GetProcOrNil&<procedure(var tc: single; var c: single; n: IntPtr; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01010 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; n: IntPtr; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00110 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; n: IntPtr; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01110 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; n: IntPtr; var v: single)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00001 := GetProcOrNil&<procedure(var tc: single; var c: single; var n: single; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01001 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; var n: single; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00101 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; var n: single; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01101 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; var n: single; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00011 := GetProcOrNil&<procedure(var tc: single; var c: single; n: IntPtr; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01011 := GetProcOrNil&<procedure(tc: IntPtr; var c: single; n: IntPtr; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00111 := GetProcOrNil&<procedure(var tc: single; c: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01111 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(tc: array of single; c: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1(tc[0], c[0], n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00001(tc[0], c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00010(tc[0], c[0], IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00011(tc[0], c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00100(tc[0], IntPtr.Zero, n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00101(tc[0], IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00110(tc[0], IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00111(tc[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01000(IntPtr.Zero, c[0], n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01001(IntPtr.Zero, c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01010(IntPtr.Zero, c[0], IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01011(IntPtr.Zero, c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01100(IntPtr.Zero, IntPtr.Zero, n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01101(IntPtr.Zero, IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01110(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(var tc: single; var c: single; var n: single; var v: single) :=
    z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1(tc, c, n, v);
    private z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_3 := GetProcOrNil&<procedure(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_TexCoord4fColor4fNormal3fVertex4fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_3(tc, c, n, v);
    
    private z_ReplacementCodeuiVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiVertex3fSUN');
    private z_ReplacementCodeuiVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; x: single; y: single; z: single)>(z_ReplacementCodeuiVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fSUN(rc: UInt32; x: single; y: single; z: single) :=
    z_ReplacementCodeuiVertex3fSUN_ovr_0(rc, x, y, z);
    
    private z_ReplacementCodeuiVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiVertex3fvSUN');
    private z_ReplacementCodeuiVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var v: Vec3f)>(z_ReplacementCodeuiVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(var rc: UInt32; var v: Vec3f) :=
    z_ReplacementCodeuiVertex3fvSUN_ovr_0(rc, v);
    private z_ReplacementCodeuiVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var v: single)>(z_ReplacementCodeuiVertex3fvSUN_adr);
    private z_ReplacementCodeuiVertex3fvSUN_ovr_1_anh001 := GetProcOrNil&<procedure(var rc: UInt32; v: IntPtr)>(z_ReplacementCodeuiVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(var rc: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ReplacementCodeuiVertex3fvSUN_ovr_1(rc, v[0]) else
      z_ReplacementCodeuiVertex3fvSUN_ovr_1_anh001(rc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(var rc: UInt32; var v: single) :=
    z_ReplacementCodeuiVertex3fvSUN_ovr_1(rc, v);
    private z_ReplacementCodeuiVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; v: IntPtr)>(z_ReplacementCodeuiVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(rc: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiVertex3fvSUN_ovr_3(rc, v);
    
    private z_ReplacementCodeuiColor4ubVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiColor4ubVertex3fSUN');
    private z_ReplacementCodeuiColor4ubVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single)>(z_ReplacementCodeuiColor4ubVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fSUN(rc: UInt32; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single) :=
    z_ReplacementCodeuiColor4ubVertex3fSUN_ovr_0(rc, r, g, b, a, x, y, z);
    
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiColor4ubVertex3fvSUN');
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var c: Vec4ub; var v: Vec3f)>(z_ReplacementCodeuiColor4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(var rc: UInt32; var c: Vec4ub; var v: Vec3f) :=
    z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_0(rc, c, v);
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var c: Byte; var v: single)>(z_ReplacementCodeuiColor4ubVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; var v: single)>(z_ReplacementCodeuiColor4ubVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var rc: UInt32; var c: Byte; v: IntPtr)>(z_ReplacementCodeuiColor4ubVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(var rc: UInt32; c: array of Byte; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1(rc, c[0], v[0]) else
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0001(rc, c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(var rc: UInt32; var c: Byte; var v: single) :=
    z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1(rc, c, v);
    private z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; c: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor4ubVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(rc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_3(rc, c, v);
    
    private z_ReplacementCodeuiColor3fVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiColor3fVertex3fSUN');
    private z_ReplacementCodeuiColor3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; r: single; g: single; b: single; x: single; y: single; z: single)>(z_ReplacementCodeuiColor3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fSUN(rc: UInt32; r: single; g: single; b: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiColor3fVertex3fSUN_ovr_0(rc, r, g, b, x, y, z);
    
    private z_ReplacementCodeuiColor3fVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiColor3fVertex3fvSUN');
    private z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var c: Vec3f; var v: Vec3f)>(z_ReplacementCodeuiColor3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(var rc: UInt32; var c: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_0(rc, c, v);
    private z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var c: single; var v: single)>(z_ReplacementCodeuiColor3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; var v: single)>(z_ReplacementCodeuiColor3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var rc: UInt32; var c: single; v: IntPtr)>(z_ReplacementCodeuiColor3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(var rc: UInt32; c: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1(rc, c[0], v[0]) else
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0001(rc, c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(var rc: UInt32; var c: single; var v: single) :=
    z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1(rc, c, v);
    private z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; c: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(rc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_3(rc, c, v);
    
    private z_ReplacementCodeuiNormal3fVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiNormal3fVertex3fSUN');
    private z_ReplacementCodeuiNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_ReplacementCodeuiNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fSUN(rc: UInt32; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiNormal3fVertex3fSUN_ovr_0(rc, nx, ny, nz, x, y, z);
    
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiNormal3fVertex3fvSUN');
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var n: Vec3f; var v: Vec3f)>(z_ReplacementCodeuiNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(var rc: UInt32; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_0(rc, n, v);
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var n: single; var v: single)>(z_ReplacementCodeuiNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var rc: UInt32; n: IntPtr; var v: single)>(z_ReplacementCodeuiNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var rc: UInt32; var n: single; v: IntPtr)>(z_ReplacementCodeuiNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var rc: UInt32; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(var rc: UInt32; n: array of single; v: array of single) :=
    if (n<>nil) and (n.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1(rc, n[0], v[0]) else
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0001(rc, n[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(var rc: UInt32; var n: single; var v: single) :=
    z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1(rc, n, v);
    private z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(rc: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_3(rc, n, v);
    
    private z_ReplacementCodeuiColor4fNormal3fVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiColor4fNormal3fVertex3fSUN');
    private z_ReplacementCodeuiColor4fNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_ReplacementCodeuiColor4fNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fSUN(rc: UInt32; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fSUN_ovr_0(rc, r, g, b, a, nx, ny, nz, x, y, z);
    
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiColor4fNormal3fVertex3fvSUN');
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var c: Vec4f; var n: Vec3f; var v: Vec3f)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(var rc: UInt32; var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_0(rc, c, n, v);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var c: single; var n: single; var v: single)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00100 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; var n: single; var v: single)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00010 := GetProcOrNil&<procedure(var rc: UInt32; var c: single; n: IntPtr; var v: single)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00110 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; n: IntPtr; var v: single)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00001 := GetProcOrNil&<procedure(var rc: UInt32; var c: single; var n: single; v: IntPtr)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00101 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; var n: single; v: IntPtr)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00011 := GetProcOrNil&<procedure(var rc: UInt32; var c: single; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00111 := GetProcOrNil&<procedure(var rc: UInt32; c: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(var rc: UInt32; c: array of single; n: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1(rc, c[0], n[0], v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00001(rc, c[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00010(rc, c[0], IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00011(rc, c[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00100(rc, IntPtr.Zero, n[0], v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00101(rc, IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00110(rc, IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00111(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(var rc: UInt32; var c: single; var n: single; var v: single) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1(rc, c, n, v);
    private z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(rc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_3(rc, c, n, v);
    
    private z_ReplacementCodeuiTexCoord2fVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiTexCoord2fVertex3fSUN');
    private z_ReplacementCodeuiTexCoord2fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; s: single; t: single; x: single; y: single; z: single)>(z_ReplacementCodeuiTexCoord2fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fSUN(rc: UInt32; s: single; t: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiTexCoord2fVertex3fSUN_ovr_0(rc, s, t, x, y, z);
    
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiTexCoord2fVertex3fvSUN');
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var tc: Vec2f; var v: Vec3f)>(z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(var rc: UInt32; var tc: Vec2f; var v: Vec3f) :=
    z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_0(rc, tc, v);
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var v: single)>(z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0010 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0001 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0011 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(var rc: UInt32; tc: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1(rc, tc[0], v[0]) else
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0001(rc, tc[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(var rc: UInt32; var tc: single; var v: single) :=
    z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1(rc, tc, v);
    private z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; tc: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(rc: IntPtr; tc: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_3(rc, tc, v);
    
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN');
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(rc: UInt32; s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN_ovr_0(rc, s, t, nx, ny, nz, x, y, z);
    
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN');
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var tc: Vec2f; var n: Vec3f; var v: Vec3f)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(var rc: UInt32; var tc: Vec2f; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_0(rc, tc, n, v);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var n: single; var v: single)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00100 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var n: single; var v: single)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00010 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; n: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00110 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; n: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00001 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var n: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00101 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var n: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00011 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00111 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(var rc: UInt32; tc: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1(rc, tc[0], n[0], v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00001(rc, tc[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00010(rc, tc[0], IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00011(rc, tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00100(rc, IntPtr.Zero, n[0], v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00101(rc, IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00110(rc, IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00111(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(var rc: UInt32; var tc: single; var n: single; var v: single) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1(rc, tc, n, v);
    private z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; tc: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(rc: IntPtr; tc: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_3(rc, tc, n, v);
    
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN_adr := GetProcAddress('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN');
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN_ovr_0 := GetProcOrNil&<procedure(rc: UInt32; s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(rc: UInt32; s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN_ovr_0(rc, s, t, r, g, b, a, nx, ny, nz, x, y, z);
    
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr := GetProcAddress('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN');
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0 := GetProcOrNil&<procedure(var rc: UInt32; var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(var rc: UInt32; var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0(rc, tc, c, n, v);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var c: single; var n: single; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001000 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var c: single; var n: single; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000100 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; c: IntPtr; var n: single; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001100 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; c: IntPtr; var n: single; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000010 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var c: single; n: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001010 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var c: single; n: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000110 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; c: IntPtr; n: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001110 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; c: IntPtr; n: IntPtr; var v: single)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000001 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var c: single; var n: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001001 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var c: single; var n: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000101 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; c: IntPtr; var n: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001101 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; c: IntPtr; var n: single; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000011 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; var c: single; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001011 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; var c: single; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000111 := GetProcOrNil&<procedure(var rc: UInt32; var tc: single; c: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001111 := GetProcOrNil&<procedure(var rc: UInt32; tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(var rc: UInt32; tc: array of single; c: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(rc, tc[0], c[0], n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000001(rc, tc[0], c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000010(rc, tc[0], c[0], IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000011(rc, tc[0], c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000100(rc, tc[0], IntPtr.Zero, n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000101(rc, tc[0], IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000110(rc, tc[0], IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000111(rc, tc[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001000(rc, IntPtr.Zero, c[0], n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001001(rc, IntPtr.Zero, c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001010(rc, IntPtr.Zero, c[0], IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001011(rc, IntPtr.Zero, c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001100(rc, IntPtr.Zero, IntPtr.Zero, n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001101(rc, IntPtr.Zero, IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001110(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001111(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(var rc: UInt32; var tc: single; var c: single; var n: single; var v: single) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(rc, tc, c, n, v);
    private z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3 := GetProcOrNil&<procedure(rc: IntPtr; tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr)>(z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(rc: IntPtr; tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3(rc, tc, c, n, v);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglStereoControl3DL = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = '3DL_stereo_control';
    
    private z_SetStereoEmitterState3DL_adr := GetProcAddress('wglSetStereoEmitterState3DL');
    private z_SetStereoEmitterState3DL_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; uState: UInt32): Bool>(z_SetStereoEmitterState3DL_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetStereoEmitterState3DL(hDC: gdi_device_context; uState: UInt32): Bool :=
    z_SetStereoEmitterState3DL_ovr_0(hDC, uState);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglGpuAssociationAMD = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_gpu_association';
    
    private z_GetGPUIDsAMD_adr := GetProcAddress('wglGetGPUIDsAMD');
    private z_GetGPUIDsAMD_ovr_0 := GetProcOrNil&<function(maxCount: UInt32; var ids: UInt32): UInt32>(z_GetGPUIDsAMD_adr);
    private z_GetGPUIDsAMD_ovr_0_anh001 := GetProcOrNil&<function(maxCount: UInt32; ids: IntPtr): UInt32>(z_GetGPUIDsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUIDsAMD(maxCount: UInt32; ids: array of UInt32): UInt32 :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GetGPUIDsAMD_ovr_0(maxCount, ids[0]) else
      z_GetGPUIDsAMD_ovr_0_anh001(maxCount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUIDsAMD(maxCount: UInt32; var ids: UInt32): UInt32 :=
    z_GetGPUIDsAMD_ovr_0(maxCount, ids);
    private z_GetGPUIDsAMD_ovr_2 := GetProcOrNil&<function(maxCount: UInt32; ids: IntPtr): UInt32>(z_GetGPUIDsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUIDsAMD(maxCount: UInt32; ids: IntPtr): UInt32 :=
    z_GetGPUIDsAMD_ovr_2(maxCount, ids);
    
    private z_GetGPUInfoAMD_adr := GetProcAddress('wglGetGPUInfoAMD');
    private z_GetGPUInfoAMD_ovr_0 := GetProcOrNil&<function(id: UInt32; &property: Int32; dataType: DummyEnum; size: UInt32; data: IntPtr): Int32>(z_GetGPUInfoAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUInfoAMD(id: UInt32; &property: Int32; dataType: DummyEnum; size: UInt32; data: IntPtr): Int32 :=
    z_GetGPUInfoAMD_ovr_0(id, &property, dataType, size, data);
    
    private z_GetContextGPUIDAMD_adr := GetProcAddress('wglGetContextGPUIDAMD');
    private z_GetContextGPUIDAMD_ovr_0 := GetProcOrNil&<function(hglrc: wgl_context): UInt32>(z_GetContextGPUIDAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetContextGPUIDAMD(hglrc: wgl_context): UInt32 :=
    z_GetContextGPUIDAMD_ovr_0(hglrc);
    
    private z_CreateAssociatedContextAMD_adr := GetProcAddress('wglCreateAssociatedContextAMD');
    private z_CreateAssociatedContextAMD_ovr_0 := GetProcOrNil&<function(id: UInt32): wgl_context>(z_CreateAssociatedContextAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAMD(id: UInt32): wgl_context :=
    z_CreateAssociatedContextAMD_ovr_0(id);
    
    private z_CreateAssociatedContextAttribsAMD_adr := GetProcAddress('wglCreateAssociatedContextAttribsAMD');
    private z_CreateAssociatedContextAttribsAMD_ovr_0 := GetProcOrNil&<function(id: UInt32; hShareContext: wgl_context; var attribList: Int32): wgl_context>(z_CreateAssociatedContextAttribsAMD_adr);
    private z_CreateAssociatedContextAttribsAMD_ovr_0_anh0001 := GetProcOrNil&<function(id: UInt32; hShareContext: wgl_context; attribList: IntPtr): wgl_context>(z_CreateAssociatedContextAttribsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAttribsAMD(id: UInt32; hShareContext: wgl_context; attribList: array of Int32): wgl_context :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_CreateAssociatedContextAttribsAMD_ovr_0(id, hShareContext, attribList[0]) else
      z_CreateAssociatedContextAttribsAMD_ovr_0_anh0001(id, hShareContext, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAttribsAMD(id: UInt32; hShareContext: wgl_context; var attribList: Int32): wgl_context :=
    z_CreateAssociatedContextAttribsAMD_ovr_0(id, hShareContext, attribList);
    private z_CreateAssociatedContextAttribsAMD_ovr_2 := GetProcOrNil&<function(id: UInt32; hShareContext: wgl_context; attribList: IntPtr): wgl_context>(z_CreateAssociatedContextAttribsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAttribsAMD(id: UInt32; hShareContext: wgl_context; attribList: IntPtr): wgl_context :=
    z_CreateAssociatedContextAttribsAMD_ovr_2(id, hShareContext, attribList);
    
    private z_DeleteAssociatedContextAMD_adr := GetProcAddress('wglDeleteAssociatedContextAMD');
    private z_DeleteAssociatedContextAMD_ovr_0 := GetProcOrNil&<function(hglrc: wgl_context): Bool>(z_DeleteAssociatedContextAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DeleteAssociatedContextAMD(hglrc: wgl_context): Bool :=
    z_DeleteAssociatedContextAMD_ovr_0(hglrc);
    
    private z_MakeAssociatedContextCurrentAMD_adr := GetProcAddress('wglMakeAssociatedContextCurrentAMD');
    private z_MakeAssociatedContextCurrentAMD_ovr_0 := GetProcOrNil&<function(hglrc: wgl_context): Bool>(z_MakeAssociatedContextCurrentAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MakeAssociatedContextCurrentAMD(hglrc: wgl_context): Bool :=
    z_MakeAssociatedContextCurrentAMD_ovr_0(hglrc);
    
    private z_GetCurrentAssociatedContextAMD_adr := GetProcAddress('wglGetCurrentAssociatedContextAMD');
    private z_GetCurrentAssociatedContextAMD_ovr_0 := GetProcOrNil&<function: wgl_context>(z_GetCurrentAssociatedContextAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCurrentAssociatedContextAMD: wgl_context :=
    z_GetCurrentAssociatedContextAMD_ovr_0;
    
    private z_BlitContextFramebufferAMD_adr := GetProcAddress('wglBlitContextFramebufferAMD');
    private z_BlitContextFramebufferAMD_ovr_0 := GetProcOrNil&<procedure(dstCtx: wgl_context; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: DummyFlags; filter: DummyEnum)>(z_BlitContextFramebufferAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitContextFramebufferAMD(dstCtx: wgl_context; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: DummyFlags; filter: DummyEnum) :=
    z_BlitContextFramebufferAMD_ovr_0(dstCtx, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglBufferRegionARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_buffer_region';
    
    private z_CreateBufferRegionARB_adr := GetProcAddress('wglCreateBufferRegionARB');
    private z_CreateBufferRegionARB_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iLayerPlane: Int32; uType: UInt32): IntPtr>(z_CreateBufferRegionARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateBufferRegionARB(hDC: gdi_device_context; iLayerPlane: Int32; uType: UInt32): IntPtr :=
    z_CreateBufferRegionARB_ovr_0(hDC, iLayerPlane, uType);
    
    private z_DeleteBufferRegionARB_adr := GetProcAddress('wglDeleteBufferRegionARB');
    private z_DeleteBufferRegionARB_ovr_0 := GetProcOrNil&<procedure(hRegion: IntPtr)>(z_DeleteBufferRegionARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBufferRegionARB(hRegion: IntPtr) :=
    z_DeleteBufferRegionARB_ovr_0(hRegion);
    
    private z_SaveBufferRegionARB_adr := GetProcAddress('wglSaveBufferRegionARB');
    private z_SaveBufferRegionARB_ovr_0 := GetProcOrNil&<function(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32): Bool>(z_SaveBufferRegionARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SaveBufferRegionARB(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32): Bool :=
    z_SaveBufferRegionARB_ovr_0(hRegion, x, y, width, height);
    
    private z_RestoreBufferRegionARB_adr := GetProcAddress('wglRestoreBufferRegionARB');
    private z_RestoreBufferRegionARB_ovr_0 := GetProcOrNil&<function(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32; xSrc: Int32; ySrc: Int32): Bool>(z_RestoreBufferRegionARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function RestoreBufferRegionARB(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32; xSrc: Int32; ySrc: Int32): Bool :=
    z_RestoreBufferRegionARB_ovr_0(hRegion, x, y, width, height, xSrc, ySrc);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglCreateContextARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_create_context';
    
    private z_CreateContextAttribsARB_adr := GetProcAddress('wglCreateContextAttribsARB');
    private z_CreateContextAttribsARB_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; hShareContext: wgl_context; var attribList: Int32): wgl_context>(z_CreateContextAttribsARB_adr);
    private z_CreateContextAttribsARB_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; hShareContext: wgl_context; attribList: IntPtr): wgl_context>(z_CreateContextAttribsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextAttribsARB(hDC: gdi_device_context; hShareContext: wgl_context; attribList: array of Int32): wgl_context :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_CreateContextAttribsARB_ovr_0(hDC, hShareContext, attribList[0]) else
      z_CreateContextAttribsARB_ovr_0_anh0001(hDC, hShareContext, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextAttribsARB(hDC: gdi_device_context; hShareContext: wgl_context; var attribList: Int32): wgl_context :=
    z_CreateContextAttribsARB_ovr_0(hDC, hShareContext, attribList);
    private z_CreateContextAttribsARB_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; hShareContext: wgl_context; attribList: IntPtr): wgl_context>(z_CreateContextAttribsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextAttribsARB(hDC: gdi_device_context; hShareContext: wgl_context; attribList: IntPtr): wgl_context :=
    z_CreateContextAttribsARB_ovr_2(hDC, hShareContext, attribList);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglExtensionsStringARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_extensions_string';
    
    private z_GetExtensionsStringARB_adr := GetProcAddress('wglGetExtensionsStringARB');
    private z_GetExtensionsStringARB_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context): IntPtr>(z_GetExtensionsStringARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetExtensionsStringARB(hdc: gdi_device_context): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_GetExtensionsStringARB_ovr_0(hdc);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglMakeCurrentReadARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_make_current_read';
    
    private z_MakeContextCurrentARB_adr := GetProcAddress('wglMakeContextCurrentARB');
    private z_MakeContextCurrentARB_ovr_0 := GetProcOrNil&<function(hDrawDC: gdi_device_context; hReadDC: gdi_device_context; hglrc: wgl_context): Bool>(z_MakeContextCurrentARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MakeContextCurrentARB(hDrawDC: gdi_device_context; hReadDC: gdi_device_context; hglrc: wgl_context): Bool :=
    z_MakeContextCurrentARB_ovr_0(hDrawDC, hReadDC, hglrc);
    
    private z_GetCurrentReadDCARB_adr := GetProcAddress('wglGetCurrentReadDCARB');
    private z_GetCurrentReadDCARB_ovr_0 := GetProcOrNil&<function: gdi_device_context>(z_GetCurrentReadDCARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCurrentReadDCARB: gdi_device_context :=
    z_GetCurrentReadDCARB_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglPbufferARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_pbuffer';
    
    private z_CreatePbufferARB_adr := GetProcAddress('wglCreatePbufferARB');
    private z_CreatePbufferARB_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): wgl_pbuffer_ARB>(z_CreatePbufferARB_adr);
    private z_CreatePbufferARB_ovr_0_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): wgl_pbuffer_ARB>(z_CreatePbufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreatePbufferARB(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: array of Int32): wgl_pbuffer_ARB :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_CreatePbufferARB_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList[0]) else
      z_CreatePbufferARB_ovr_0_anh000001(hDC, iPixelFormat, iWidth, iHeight, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreatePbufferARB(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): wgl_pbuffer_ARB :=
    z_CreatePbufferARB_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    private z_CreatePbufferARB_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): wgl_pbuffer_ARB>(z_CreatePbufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreatePbufferARB(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): wgl_pbuffer_ARB :=
    z_CreatePbufferARB_ovr_2(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    
    private z_GetPbufferDCARB_adr := GetProcAddress('wglGetPbufferDCARB');
    private z_GetPbufferDCARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB): gdi_device_context>(z_GetPbufferDCARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPbufferDCARB(hPbuffer: wgl_pbuffer_ARB): gdi_device_context :=
    z_GetPbufferDCARB_ovr_0(hPbuffer);
    
    private z_ReleasePbufferDCARB_adr := GetProcAddress('wglReleasePbufferDCARB');
    private z_ReleasePbufferDCARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; hDC: gdi_device_context): Int32>(z_ReleasePbufferDCARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleasePbufferDCARB(hPbuffer: wgl_pbuffer_ARB; hDC: gdi_device_context): Int32 :=
    z_ReleasePbufferDCARB_ovr_0(hPbuffer, hDC);
    
    private z_DestroyPbufferARB_adr := GetProcAddress('wglDestroyPbufferARB');
    private z_DestroyPbufferARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB): Bool>(z_DestroyPbufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DestroyPbufferARB(hPbuffer: wgl_pbuffer_ARB): Bool :=
    z_DestroyPbufferARB_ovr_0(hPbuffer);
    
    private z_QueryPbufferARB_adr := GetProcAddress('wglQueryPbufferARB');
    private z_QueryPbufferARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iAttribute: Int32; var piValue: Int32): Bool>(z_QueryPbufferARB_adr);
    private z_QueryPbufferARB_ovr_0_anh0001 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryPbufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryPbufferARB(hPbuffer: wgl_pbuffer_ARB; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryPbufferARB_ovr_0(hPbuffer, iAttribute, piValue[0]) else
      z_QueryPbufferARB_ovr_0_anh0001(hPbuffer, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryPbufferARB(hPbuffer: wgl_pbuffer_ARB; iAttribute: Int32; var piValue: Int32): Bool :=
    z_QueryPbufferARB_ovr_0(hPbuffer, iAttribute, piValue);
    private z_QueryPbufferARB_ovr_2 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryPbufferARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryPbufferARB(hPbuffer: wgl_pbuffer_ARB; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_QueryPbufferARB_ovr_2(hPbuffer, iAttribute, piValue);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglPixelFormatARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_pixel_format';
    
    private z_GetPixelFormatAttribivARB_adr := GetProcAddress('wglGetPixelFormatAttribivARB');
    private z_GetPixelFormatAttribivARB_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): Bool>(z_GetPixelFormatAttribivARB_adr);
    private z_GetPixelFormatAttribivARB_ovr_0_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool>(z_GetPixelFormatAttribivARB_adr);
    private z_GetPixelFormatAttribivARB_ovr_0_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivARB_adr);
    private z_GetPixelFormatAttribivARB_ovr_0_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: array of Int32): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues[0]) else
        z_GetPixelFormatAttribivARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues[0]) else
        z_GetPixelFormatAttribivARB_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private z_GetPixelFormatAttribivARB_ovr_1_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool>(z_GetPixelFormatAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var piValues: Int32): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    private z_GetPixelFormatAttribivARB_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivARB_adr);
    private z_GetPixelFormatAttribivARB_ovr_2_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: IntPtr): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivARB_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: array of Int32): Bool :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): Bool :=
    z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): Bool :=
    z_GetPixelFormatAttribivARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private z_GetPixelFormatAttribivARB_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool>(z_GetPixelFormatAttribivARB_adr);
    private z_GetPixelFormatAttribivARB_ovr_6_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: array of Int32): Bool :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivARB_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool :=
    z_GetPixelFormatAttribivARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private z_GetPixelFormatAttribivARB_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool :=
    z_GetPixelFormatAttribivARB_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    
    private z_GetPixelFormatAttribfvARB_adr := GetProcAddress('wglGetPixelFormatAttribfvARB');
    private z_GetPixelFormatAttribfvARB_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): Bool>(z_GetPixelFormatAttribfvARB_adr);
    private z_GetPixelFormatAttribfvARB_ovr_0_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool>(z_GetPixelFormatAttribfvARB_adr);
    private z_GetPixelFormatAttribfvARB_ovr_0_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvARB_adr);
    private z_GetPixelFormatAttribfvARB_ovr_0_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: array of single): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues[0]) else
        z_GetPixelFormatAttribfvARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues[0]) else
        z_GetPixelFormatAttribfvARB_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private z_GetPixelFormatAttribfvARB_ovr_1_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool>(z_GetPixelFormatAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var pfValues: single): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    private z_GetPixelFormatAttribfvARB_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvARB_adr);
    private z_GetPixelFormatAttribfvARB_ovr_2_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: IntPtr): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvARB_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: array of single): Bool :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): Bool :=
    z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): Bool :=
    z_GetPixelFormatAttribfvARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private z_GetPixelFormatAttribfvARB_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool>(z_GetPixelFormatAttribfvARB_adr);
    private z_GetPixelFormatAttribfvARB_ovr_6_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: array of single): Bool :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvARB_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool :=
    z_GetPixelFormatAttribfvARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private z_GetPixelFormatAttribfvARB_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvARB(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool :=
    z_GetPixelFormatAttribfvARB_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    
    private z_ChoosePixelFormatARB_adr := GetProcAddress('wglChoosePixelFormatARB');
    private z_ChoosePixelFormatARB_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0011010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0011001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0010011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0001011 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_0_anh0011011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0001011(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0011011(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_1_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_1_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_1_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_1_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_1_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_1_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_1_anh0011010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_2_anh0011010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_3_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_3_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_3_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_3_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_3_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_3_anh0011001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_4_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_4_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_4_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_5_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_5_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_5_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_6_anh0011001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_7_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_7_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_7_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_8_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_8_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_8_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_8_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_8_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_9_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_9_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_9_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_9_anh0010011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_10_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_10_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_11_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_11_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_12_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_12_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_13_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_14_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_15_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_15_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_16_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_17_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_18 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_18_anh0010011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_19_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_19_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_19_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_20 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_20_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_20_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_20_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_20_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_20_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_21_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_21_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_22_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_23_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_24 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_24_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_24_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_24_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_24_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_24_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_25_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_26 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_26_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_26(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_26_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_8_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_20_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_24_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_26(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_54 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_54_anh0001011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_55_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_55_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_55_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_56 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_56_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_56_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_56_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_56_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_57_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_57_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_58_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_59_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_60 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_60_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_60_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_60_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_60_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_61_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_62 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_62_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_62(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_62_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_62(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_72 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_72_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_72_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_72_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_72_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatARB_ovr_73_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_74 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_74_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_74_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_78 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatARB_adr);
    private z_ChoosePixelFormatARB_ovr_78_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_78_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatARB_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatARB_ovr_80 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatARB(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatARB_ovr_80(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglRenderTextureARB = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_render_texture';
    
    private z_BindTexImageARB_adr := GetProcAddress('wglBindTexImageARB');
    private z_BindTexImageARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iBuffer: Int32): Bool>(z_BindTexImageARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindTexImageARB(hPbuffer: wgl_pbuffer_ARB; iBuffer: Int32): Bool :=
    z_BindTexImageARB_ovr_0(hPbuffer, iBuffer);
    
    private z_ReleaseTexImageARB_adr := GetProcAddress('wglReleaseTexImageARB');
    private z_ReleaseTexImageARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iBuffer: Int32): Bool>(z_ReleaseTexImageARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseTexImageARB(hPbuffer: wgl_pbuffer_ARB; iBuffer: Int32): Bool :=
    z_ReleaseTexImageARB_ovr_0(hPbuffer, iBuffer);
    
    private z_SetPbufferAttribARB_adr := GetProcAddress('wglSetPbufferAttribARB');
    private z_SetPbufferAttribARB_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; var piAttribList: Int32): Bool>(z_SetPbufferAttribARB_adr);
    private z_SetPbufferAttribARB_ovr_0_anh001 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; piAttribList: IntPtr): Bool>(z_SetPbufferAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetPbufferAttribARB(hPbuffer: wgl_pbuffer_ARB; piAttribList: array of Int32): Bool :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_SetPbufferAttribARB_ovr_0(hPbuffer, piAttribList[0]) else
      z_SetPbufferAttribARB_ovr_0_anh001(hPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetPbufferAttribARB(hPbuffer: wgl_pbuffer_ARB; var piAttribList: Int32): Bool :=
    z_SetPbufferAttribARB_ovr_0(hPbuffer, piAttribList);
    private z_SetPbufferAttribARB_ovr_2 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; piAttribList: IntPtr): Bool>(z_SetPbufferAttribARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetPbufferAttribARB(hPbuffer: wgl_pbuffer_ARB; piAttribList: IntPtr): Bool :=
    z_SetPbufferAttribARB_ovr_2(hPbuffer, piAttribList);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglDisplayColorTableEXT = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_display_color_table';
    
    private z_CreateDisplayColorTableEXT_adr := GetProcAddress('wglCreateDisplayColorTableEXT');
    private z_CreateDisplayColorTableEXT_ovr_0 := GetProcOrNil&<function(id: UInt16): boolean>(z_CreateDisplayColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateDisplayColorTableEXT(id: UInt16): boolean :=
    z_CreateDisplayColorTableEXT_ovr_0(id);
    
    private z_LoadDisplayColorTableEXT_adr := GetProcAddress('wglLoadDisplayColorTableEXT');
    private z_LoadDisplayColorTableEXT_ovr_0 := GetProcOrNil&<function(var table: UInt16; length: UInt32): boolean>(z_LoadDisplayColorTableEXT_adr);
    private z_LoadDisplayColorTableEXT_ovr_0_anh010 := GetProcOrNil&<function(table: IntPtr; length: UInt32): boolean>(z_LoadDisplayColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function LoadDisplayColorTableEXT(table: array of UInt16; length: UInt32): boolean :=
    if (table<>nil) and (table.Length<>0) then
      z_LoadDisplayColorTableEXT_ovr_0(table[0], length) else
      z_LoadDisplayColorTableEXT_ovr_0_anh010(IntPtr.Zero, length);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function LoadDisplayColorTableEXT(var table: UInt16; length: UInt32): boolean :=
    z_LoadDisplayColorTableEXT_ovr_0(table, length);
    private z_LoadDisplayColorTableEXT_ovr_2 := GetProcOrNil&<function(table: IntPtr; length: UInt32): boolean>(z_LoadDisplayColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function LoadDisplayColorTableEXT(table: IntPtr; length: UInt32): boolean :=
    z_LoadDisplayColorTableEXT_ovr_2(table, length);
    
    private z_BindDisplayColorTableEXT_adr := GetProcAddress('wglBindDisplayColorTableEXT');
    private z_BindDisplayColorTableEXT_ovr_0 := GetProcOrNil&<function(id: UInt16): boolean>(z_BindDisplayColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindDisplayColorTableEXT(id: UInt16): boolean :=
    z_BindDisplayColorTableEXT_ovr_0(id);
    
    private z_DestroyDisplayColorTableEXT_adr := GetProcAddress('wglDestroyDisplayColorTableEXT');
    private z_DestroyDisplayColorTableEXT_ovr_0 := GetProcOrNil&<procedure(id: UInt16)>(z_DestroyDisplayColorTableEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DestroyDisplayColorTableEXT(id: UInt16) :=
    z_DestroyDisplayColorTableEXT_ovr_0(id);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglExtensionsStringEXT = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_extensions_string';
    
    private z_GetExtensionsStringEXT_adr := GetProcAddress('wglGetExtensionsStringEXT');
    private z_GetExtensionsStringEXT_ovr_0 := GetProcOrNil&<function: IntPtr>(z_GetExtensionsStringEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetExtensionsStringEXT: string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_GetExtensionsStringEXT_ovr_0;
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglMakeCurrentReadEXT = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_make_current_read';
    
    private z_MakeContextCurrentEXT_adr := GetProcAddress('wglMakeContextCurrentEXT');
    private z_MakeContextCurrentEXT_ovr_0 := GetProcOrNil&<function(hDrawDC: gdi_device_context; hReadDC: gdi_device_context; hglrc: wgl_context): Bool>(z_MakeContextCurrentEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MakeContextCurrentEXT(hDrawDC: gdi_device_context; hReadDC: gdi_device_context; hglrc: wgl_context): Bool :=
    z_MakeContextCurrentEXT_ovr_0(hDrawDC, hReadDC, hglrc);
    
    private z_GetCurrentReadDCEXT_adr := GetProcAddress('wglGetCurrentReadDCEXT');
    private z_GetCurrentReadDCEXT_ovr_0 := GetProcOrNil&<function: gdi_device_context>(z_GetCurrentReadDCEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCurrentReadDCEXT: gdi_device_context :=
    z_GetCurrentReadDCEXT_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglPbufferEXT = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_pbuffer';
    
    private z_CreatePbufferEXT_adr := GetProcAddress('wglCreatePbufferEXT');
    private z_CreatePbufferEXT_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): wgl_pbuffer_EXT>(z_CreatePbufferEXT_adr);
    private z_CreatePbufferEXT_ovr_0_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): wgl_pbuffer_EXT>(z_CreatePbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreatePbufferEXT(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: array of Int32): wgl_pbuffer_EXT :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_CreatePbufferEXT_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList[0]) else
      z_CreatePbufferEXT_ovr_0_anh000001(hDC, iPixelFormat, iWidth, iHeight, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreatePbufferEXT(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): wgl_pbuffer_EXT :=
    z_CreatePbufferEXT_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    private z_CreatePbufferEXT_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): wgl_pbuffer_EXT>(z_CreatePbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreatePbufferEXT(hDC: gdi_device_context; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): wgl_pbuffer_EXT :=
    z_CreatePbufferEXT_ovr_2(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    
    private z_GetPbufferDCEXT_adr := GetProcAddress('wglGetPbufferDCEXT');
    private z_GetPbufferDCEXT_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_EXT): gdi_device_context>(z_GetPbufferDCEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPbufferDCEXT(hPbuffer: wgl_pbuffer_EXT): gdi_device_context :=
    z_GetPbufferDCEXT_ovr_0(hPbuffer);
    
    private z_ReleasePbufferDCEXT_adr := GetProcAddress('wglReleasePbufferDCEXT');
    private z_ReleasePbufferDCEXT_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_EXT; hDC: gdi_device_context): Int32>(z_ReleasePbufferDCEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleasePbufferDCEXT(hPbuffer: wgl_pbuffer_EXT; hDC: gdi_device_context): Int32 :=
    z_ReleasePbufferDCEXT_ovr_0(hPbuffer, hDC);
    
    private z_DestroyPbufferEXT_adr := GetProcAddress('wglDestroyPbufferEXT');
    private z_DestroyPbufferEXT_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_EXT): Bool>(z_DestroyPbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DestroyPbufferEXT(hPbuffer: wgl_pbuffer_EXT): Bool :=
    z_DestroyPbufferEXT_ovr_0(hPbuffer);
    
    private z_QueryPbufferEXT_adr := GetProcAddress('wglQueryPbufferEXT');
    private z_QueryPbufferEXT_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_EXT; iAttribute: Int32; var piValue: Int32): Bool>(z_QueryPbufferEXT_adr);
    private z_QueryPbufferEXT_ovr_0_anh0001 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_EXT; iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryPbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryPbufferEXT(hPbuffer: wgl_pbuffer_EXT; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryPbufferEXT_ovr_0(hPbuffer, iAttribute, piValue[0]) else
      z_QueryPbufferEXT_ovr_0_anh0001(hPbuffer, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryPbufferEXT(hPbuffer: wgl_pbuffer_EXT; iAttribute: Int32; var piValue: Int32): Bool :=
    z_QueryPbufferEXT_ovr_0(hPbuffer, iAttribute, piValue);
    private z_QueryPbufferEXT_ovr_2 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_EXT; iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryPbufferEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryPbufferEXT(hPbuffer: wgl_pbuffer_EXT; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_QueryPbufferEXT_ovr_2(hPbuffer, iAttribute, piValue);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglPixelFormatEXT = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_pixel_format';
    
    private z_GetPixelFormatAttribivEXT_adr := GetProcAddress('wglGetPixelFormatAttribivEXT');
    private z_GetPixelFormatAttribivEXT_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): Bool>(z_GetPixelFormatAttribivEXT_adr);
    private z_GetPixelFormatAttribivEXT_ovr_0_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool>(z_GetPixelFormatAttribivEXT_adr);
    private z_GetPixelFormatAttribivEXT_ovr_0_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivEXT_adr);
    private z_GetPixelFormatAttribivEXT_ovr_0_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: array of Int32): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues[0]) else
        z_GetPixelFormatAttribivEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues[0]) else
        z_GetPixelFormatAttribivEXT_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private z_GetPixelFormatAttribivEXT_ovr_1_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool>(z_GetPixelFormatAttribivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var piValues: Int32): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    private z_GetPixelFormatAttribivEXT_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivEXT_adr);
    private z_GetPixelFormatAttribivEXT_ovr_2_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: IntPtr): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivEXT_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: array of Int32): Bool :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): Bool :=
    z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): Bool :=
    z_GetPixelFormatAttribivEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private z_GetPixelFormatAttribivEXT_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool>(z_GetPixelFormatAttribivEXT_adr);
    private z_GetPixelFormatAttribivEXT_ovr_6_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: array of Int32): Bool :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivEXT_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): Bool :=
    z_GetPixelFormatAttribivEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private z_GetPixelFormatAttribivEXT_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool>(z_GetPixelFormatAttribivEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribivEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): Bool :=
    z_GetPixelFormatAttribivEXT_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    
    private z_GetPixelFormatAttribfvEXT_adr := GetProcAddress('wglGetPixelFormatAttribfvEXT');
    private z_GetPixelFormatAttribfvEXT_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    private z_GetPixelFormatAttribfvEXT_ovr_0_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    private z_GetPixelFormatAttribfvEXT_ovr_0_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    private z_GetPixelFormatAttribfvEXT_ovr_0_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: array of single): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues[0]) else
        z_GetPixelFormatAttribfvEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues[0]) else
        z_GetPixelFormatAttribfvEXT_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private z_GetPixelFormatAttribfvEXT_ovr_1_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var pfValues: single): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    private z_GetPixelFormatAttribfvEXT_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    private z_GetPixelFormatAttribfvEXT_ovr_2_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: IntPtr): Bool :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvEXT_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: array of single): Bool :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): Bool :=
    z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): Bool :=
    z_GetPixelFormatAttribfvEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private z_GetPixelFormatAttribfvEXT_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    private z_GetPixelFormatAttribfvEXT_ovr_6_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: array of single): Bool :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvEXT_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): Bool :=
    z_GetPixelFormatAttribfvEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private z_GetPixelFormatAttribfvEXT_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool>(z_GetPixelFormatAttribfvEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPixelFormatAttribfvEXT(hdc: gdi_device_context; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): Bool :=
    z_GetPixelFormatAttribfvEXT_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    
    private z_ChoosePixelFormatEXT_adr := GetProcAddress('wglChoosePixelFormatEXT');
    private z_ChoosePixelFormatEXT_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0011010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0011001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0010011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0001011 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_0_anh0011011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0001011(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0011011(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_1_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_1_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_1_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_1_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_1_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_1_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_1_anh0011010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_2_anh0011010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_3_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_3_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_3_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_3_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_3_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_3_anh0011001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_4_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_4_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_4_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_5_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_5_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_5_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_6_anh0011001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_7_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_7_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_7_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_8_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_8_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_8_anh0011000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_8_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_8_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_9_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_9_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_9_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_9_anh0010011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_10_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_10_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_11_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_11_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_12_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_12_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_13_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_14_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_15_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_15_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_16_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_17_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_18 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_18_anh0010011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_19_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_19_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_19_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_20 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_20_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_20_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_20_anh0010010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_20_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_20_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_21_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_21_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_22_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_23_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_24 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_24_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_24_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_24_anh0010001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_24_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_24_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_25_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_26 := GetProcOrNil&<function(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_26_anh0010000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_26(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_26_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_8_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_20_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_24_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_26(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_54 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_54_anh0001011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_55_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_55_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_55_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_56 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_56_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_56_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_56_anh0001010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_56_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_57_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_57_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_58_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_59_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_60 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_60_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_60_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_60_anh0001001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_60_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_61_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_62 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_62_anh0001000 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_62(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_62_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_62(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_72 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_72_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_72_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_72_anh0000011 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_72_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private z_ChoosePixelFormatEXT_ovr_73_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_74 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_74_anh0000010 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): Bool :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_74_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_78 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool>(z_ChoosePixelFormatEXT_adr);
    private z_ChoosePixelFormatEXT_ovr_78_anh0000001 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): Bool :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_78_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): Bool :=
    z_ChoosePixelFormatEXT_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private z_ChoosePixelFormatEXT_ovr_80 := GetProcOrNil&<function(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool>(z_ChoosePixelFormatEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChoosePixelFormatEXT(hdc: gdi_device_context; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): Bool :=
    z_ChoosePixelFormatEXT_ovr_80(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglSwapControlEXT = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_swap_control';
    
    private z_SwapIntervalEXT_adr := GetProcAddress('wglSwapIntervalEXT');
    private z_SwapIntervalEXT_ovr_0 := GetProcOrNil&<function(interval: Int32): Bool>(z_SwapIntervalEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SwapIntervalEXT(interval: Int32): Bool :=
    z_SwapIntervalEXT_ovr_0(interval);
    
    private z_GetSwapIntervalEXT_adr := GetProcAddress('wglGetSwapIntervalEXT');
    private z_GetSwapIntervalEXT_ovr_0 := GetProcOrNil&<function: Int32>(z_GetSwapIntervalEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSwapIntervalEXT: Int32 :=
    z_GetSwapIntervalEXT_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglDigitalVideoControlI3D = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'I3D_digital_video_control';
    
    private z_GetDigitalVideoParametersI3D_adr := GetProcAddress('wglGetDigitalVideoParametersI3D');
    private z_GetDigitalVideoParametersI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool>(z_GetDigitalVideoParametersI3D_adr);
    private z_GetDigitalVideoParametersI3D_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_GetDigitalVideoParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDigitalVideoParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_GetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_GetDigitalVideoParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDigitalVideoParametersI3D(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool :=
    z_GetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private z_GetDigitalVideoParametersI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_GetDigitalVideoParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDigitalVideoParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_GetDigitalVideoParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
    private z_SetDigitalVideoParametersI3D_adr := GetProcAddress('wglSetDigitalVideoParametersI3D');
    private z_SetDigitalVideoParametersI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool>(z_SetDigitalVideoParametersI3D_adr);
    private z_SetDigitalVideoParametersI3D_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_SetDigitalVideoParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetDigitalVideoParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_SetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_SetDigitalVideoParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetDigitalVideoParametersI3D(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool :=
    z_SetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private z_SetDigitalVideoParametersI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_SetDigitalVideoParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetDigitalVideoParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_SetDigitalVideoParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglGammaI3D = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'I3D_gamma';
    
    private z_GetGammaTableParametersI3D_adr := GetProcAddress('wglGetGammaTableParametersI3D');
    private z_GetGammaTableParametersI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool>(z_GetGammaTableParametersI3D_adr);
    private z_GetGammaTableParametersI3D_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_GetGammaTableParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_GetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_GetGammaTableParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableParametersI3D(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool :=
    z_GetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private z_GetGammaTableParametersI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_GetGammaTableParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_GetGammaTableParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
    private z_SetGammaTableParametersI3D_adr := GetProcAddress('wglSetGammaTableParametersI3D');
    private z_SetGammaTableParametersI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool>(z_SetGammaTableParametersI3D_adr);
    private z_SetGammaTableParametersI3D_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_SetGammaTableParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_SetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_SetGammaTableParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableParametersI3D(hDC: gdi_device_context; iAttribute: Int32; var piValue: Int32): Bool :=
    z_SetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private z_SetGammaTableParametersI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool>(z_SetGammaTableParametersI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableParametersI3D(hDC: gdi_device_context; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_SetGammaTableParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
    private z_GetGammaTableI3D_adr := GetProcAddress('wglGetGammaTableI3D');
    private z_GetGammaTableI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000101 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000011 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_0_anh000111 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: array of UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed[0], IntPtr.Zero, IntPtr.Zero) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000111(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_GetGammaTableI3D_ovr_1_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_1_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_1_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; var puBlue: UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private z_GetGammaTableI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_2_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_2_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_2_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: IntPtr): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_2_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private z_GetGammaTableI3D_ovr_3_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_3_anh000101 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: array of UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private z_GetGammaTableI3D_ovr_4_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; var puBlue: UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private z_GetGammaTableI3D_ovr_5_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private z_GetGammaTableI3D_ovr_6 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_6_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_6_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_6_anh000101 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: array of UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_6_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private z_GetGammaTableI3D_ovr_7_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private z_GetGammaTableI3D_ovr_8 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_8_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_8(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_8_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: array of UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; var puBlue: UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: IntPtr): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): Bool :=
    z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool :=
    z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool :=
    z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool :=
    z_GetGammaTableI3D_ovr_8(hDC, iEntries, puRed, puGreen, puBlue);
    private z_GetGammaTableI3D_ovr_18 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_18_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_18_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_18_anh000011 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: array of UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_GetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_GetGammaTableI3D_ovr_18_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    private z_GetGammaTableI3D_ovr_19_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; var puBlue: UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    private z_GetGammaTableI3D_ovr_20 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_20_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: IntPtr): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_20_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool :=
    z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool :=
    z_GetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen, puBlue);
    private z_GetGammaTableI3D_ovr_24 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_GetGammaTableI3D_adr);
    private z_GetGammaTableI3D_ovr_24_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_24_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool :=
    z_GetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue);
    private z_GetGammaTableI3D_ovr_26 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_GetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool :=
    z_GetGammaTableI3D_ovr_26(hDC, iEntries, puRed, puGreen, puBlue);
    
    private z_SetGammaTableI3D_adr := GetProcAddress('wglSetGammaTableI3D');
    private z_SetGammaTableI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000101 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000011 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_0_anh000111 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: array of UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed[0], IntPtr.Zero, IntPtr.Zero) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000111(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_SetGammaTableI3D_ovr_1_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_1_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_1_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; var puBlue: UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private z_SetGammaTableI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_2_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_2_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_2_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: IntPtr): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_2_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private z_SetGammaTableI3D_ovr_3_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_3_anh000101 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: array of UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private z_SetGammaTableI3D_ovr_4_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; var puBlue: UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private z_SetGammaTableI3D_ovr_5_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private z_SetGammaTableI3D_ovr_6 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_6_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_6_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_6_anh000101 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: array of UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_6_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private z_SetGammaTableI3D_ovr_7_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private z_SetGammaTableI3D_ovr_8 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_8_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_8(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_8_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: array of UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; var puBlue: UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: IntPtr): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): Bool :=
    z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): Bool :=
    z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): Bool :=
    z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): Bool :=
    z_SetGammaTableI3D_ovr_8(hDC, iEntries, puRed, puGreen, puBlue);
    private z_SetGammaTableI3D_ovr_18 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_18_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_18_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_18_anh000011 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: array of UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_SetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_SetGammaTableI3D_ovr_18_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    private z_SetGammaTableI3D_ovr_19_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; var puBlue: UInt16): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    private z_SetGammaTableI3D_ovr_20 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_20_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: IntPtr): Bool :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_20_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): Bool :=
    z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): Bool :=
    z_SetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen, puBlue);
    private z_SetGammaTableI3D_ovr_24 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool>(z_SetGammaTableI3D_adr);
    private z_SetGammaTableI3D_ovr_24_anh000001 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: array of UInt16): Bool :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_24_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): Bool :=
    z_SetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue);
    private z_SetGammaTableI3D_ovr_26 := GetProcOrNil&<function(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool>(z_SetGammaTableI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SetGammaTableI3D(hDC: gdi_device_context; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): Bool :=
    z_SetGammaTableI3D_ovr_26(hDC, iEntries, puRed, puGreen, puBlue);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglGenlockI3D = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'I3D_genlock';
    
    private z_EnableGenlockI3D_adr := GetProcAddress('wglEnableGenlockI3D');
    private z_EnableGenlockI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context): Bool>(z_EnableGenlockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnableGenlockI3D(hDC: gdi_device_context): Bool :=
    z_EnableGenlockI3D_ovr_0(hDC);
    
    private z_DisableGenlockI3D_adr := GetProcAddress('wglDisableGenlockI3D');
    private z_DisableGenlockI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context): Bool>(z_DisableGenlockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DisableGenlockI3D(hDC: gdi_device_context): Bool :=
    z_DisableGenlockI3D_ovr_0(hDC);
    
    private z_IsEnabledGenlockI3D_adr := GetProcAddress('wglIsEnabledGenlockI3D');
    private z_IsEnabledGenlockI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var pFlag: Bool): Bool>(z_IsEnabledGenlockI3D_adr);
    private z_IsEnabledGenlockI3D_ovr_0_anh001 := GetProcOrNil&<function(hDC: gdi_device_context; pFlag: IntPtr): Bool>(z_IsEnabledGenlockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledGenlockI3D(hDC: gdi_device_context; pFlag: array of Bool): Bool :=
    if (pFlag<>nil) and (pFlag.Length<>0) then
      z_IsEnabledGenlockI3D_ovr_0(hDC, pFlag[0]) else
      z_IsEnabledGenlockI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledGenlockI3D(hDC: gdi_device_context; var pFlag: Bool): Bool :=
    z_IsEnabledGenlockI3D_ovr_0(hDC, pFlag);
    private z_IsEnabledGenlockI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; pFlag: IntPtr): Bool>(z_IsEnabledGenlockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledGenlockI3D(hDC: gdi_device_context; pFlag: IntPtr): Bool :=
    z_IsEnabledGenlockI3D_ovr_2(hDC, pFlag);
    
    private z_GenlockSourceI3D_adr := GetProcAddress('wglGenlockSourceI3D');
    private z_GenlockSourceI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; uSource: UInt32): Bool>(z_GenlockSourceI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenlockSourceI3D(hDC: gdi_device_context; uSource: UInt32): Bool :=
    z_GenlockSourceI3D_ovr_0(hDC, uSource);
    
    private z_GetGenlockSourceI3D_adr := GetProcAddress('wglGetGenlockSourceI3D');
    private z_GetGenlockSourceI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var uSource: UInt32): Bool>(z_GetGenlockSourceI3D_adr);
    private z_GetGenlockSourceI3D_ovr_0_anh001 := GetProcOrNil&<function(hDC: gdi_device_context; uSource: IntPtr): Bool>(z_GetGenlockSourceI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceI3D(hDC: gdi_device_context; uSource: array of UInt32): Bool :=
    if (uSource<>nil) and (uSource.Length<>0) then
      z_GetGenlockSourceI3D_ovr_0(hDC, uSource[0]) else
      z_GetGenlockSourceI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceI3D(hDC: gdi_device_context; var uSource: UInt32): Bool :=
    z_GetGenlockSourceI3D_ovr_0(hDC, uSource);
    private z_GetGenlockSourceI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; uSource: IntPtr): Bool>(z_GetGenlockSourceI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceI3D(hDC: gdi_device_context; uSource: IntPtr): Bool :=
    z_GetGenlockSourceI3D_ovr_2(hDC, uSource);
    
    private z_GenlockSourceEdgeI3D_adr := GetProcAddress('wglGenlockSourceEdgeI3D');
    private z_GenlockSourceEdgeI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; uEdge: UInt32): Bool>(z_GenlockSourceEdgeI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenlockSourceEdgeI3D(hDC: gdi_device_context; uEdge: UInt32): Bool :=
    z_GenlockSourceEdgeI3D_ovr_0(hDC, uEdge);
    
    private z_GetGenlockSourceEdgeI3D_adr := GetProcAddress('wglGetGenlockSourceEdgeI3D');
    private z_GetGenlockSourceEdgeI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var uEdge: UInt32): Bool>(z_GetGenlockSourceEdgeI3D_adr);
    private z_GetGenlockSourceEdgeI3D_ovr_0_anh001 := GetProcOrNil&<function(hDC: gdi_device_context; uEdge: IntPtr): Bool>(z_GetGenlockSourceEdgeI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceEdgeI3D(hDC: gdi_device_context; uEdge: array of UInt32): Bool :=
    if (uEdge<>nil) and (uEdge.Length<>0) then
      z_GetGenlockSourceEdgeI3D_ovr_0(hDC, uEdge[0]) else
      z_GetGenlockSourceEdgeI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceEdgeI3D(hDC: gdi_device_context; var uEdge: UInt32): Bool :=
    z_GetGenlockSourceEdgeI3D_ovr_0(hDC, uEdge);
    private z_GetGenlockSourceEdgeI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; uEdge: IntPtr): Bool>(z_GetGenlockSourceEdgeI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceEdgeI3D(hDC: gdi_device_context; uEdge: IntPtr): Bool :=
    z_GetGenlockSourceEdgeI3D_ovr_2(hDC, uEdge);
    
    private z_GenlockSampleRateI3D_adr := GetProcAddress('wglGenlockSampleRateI3D');
    private z_GenlockSampleRateI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; uRate: UInt32): Bool>(z_GenlockSampleRateI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenlockSampleRateI3D(hDC: gdi_device_context; uRate: UInt32): Bool :=
    z_GenlockSampleRateI3D_ovr_0(hDC, uRate);
    
    private z_GetGenlockSampleRateI3D_adr := GetProcAddress('wglGetGenlockSampleRateI3D');
    private z_GetGenlockSampleRateI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var uRate: UInt32): Bool>(z_GetGenlockSampleRateI3D_adr);
    private z_GetGenlockSampleRateI3D_ovr_0_anh001 := GetProcOrNil&<function(hDC: gdi_device_context; uRate: IntPtr): Bool>(z_GetGenlockSampleRateI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSampleRateI3D(hDC: gdi_device_context; uRate: array of UInt32): Bool :=
    if (uRate<>nil) and (uRate.Length<>0) then
      z_GetGenlockSampleRateI3D_ovr_0(hDC, uRate[0]) else
      z_GetGenlockSampleRateI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSampleRateI3D(hDC: gdi_device_context; var uRate: UInt32): Bool :=
    z_GetGenlockSampleRateI3D_ovr_0(hDC, uRate);
    private z_GetGenlockSampleRateI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; uRate: IntPtr): Bool>(z_GetGenlockSampleRateI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSampleRateI3D(hDC: gdi_device_context; uRate: IntPtr): Bool :=
    z_GetGenlockSampleRateI3D_ovr_2(hDC, uRate);
    
    private z_GenlockSourceDelayI3D_adr := GetProcAddress('wglGenlockSourceDelayI3D');
    private z_GenlockSourceDelayI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; uDelay: UInt32): Bool>(z_GenlockSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenlockSourceDelayI3D(hDC: gdi_device_context; uDelay: UInt32): Bool :=
    z_GenlockSourceDelayI3D_ovr_0(hDC, uDelay);
    
    private z_GetGenlockSourceDelayI3D_adr := GetProcAddress('wglGetGenlockSourceDelayI3D');
    private z_GetGenlockSourceDelayI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var uDelay: UInt32): Bool>(z_GetGenlockSourceDelayI3D_adr);
    private z_GetGenlockSourceDelayI3D_ovr_0_anh001 := GetProcOrNil&<function(hDC: gdi_device_context; uDelay: IntPtr): Bool>(z_GetGenlockSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceDelayI3D(hDC: gdi_device_context; uDelay: array of UInt32): Bool :=
    if (uDelay<>nil) and (uDelay.Length<>0) then
      z_GetGenlockSourceDelayI3D_ovr_0(hDC, uDelay[0]) else
      z_GetGenlockSourceDelayI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceDelayI3D(hDC: gdi_device_context; var uDelay: UInt32): Bool :=
    z_GetGenlockSourceDelayI3D_ovr_0(hDC, uDelay);
    private z_GetGenlockSourceDelayI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; uDelay: IntPtr): Bool>(z_GetGenlockSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGenlockSourceDelayI3D(hDC: gdi_device_context; uDelay: IntPtr): Bool :=
    z_GetGenlockSourceDelayI3D_ovr_2(hDC, uDelay);
    
    private z_QueryGenlockMaxSourceDelayI3D_adr := GetProcAddress('wglQueryGenlockMaxSourceDelayI3D');
    private z_QueryGenlockMaxSourceDelayI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var uMaxLineDelay: UInt32; var uMaxPixelDelay: UInt32): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; var uMaxLineDelay: UInt32; uMaxPixelDelay: IntPtr): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0011 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; uMaxLineDelay: array of UInt32; uMaxPixelDelay: array of UInt32): Bool :=
    if (uMaxLineDelay<>nil) and (uMaxLineDelay.Length<>0) then
      if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
        z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay[0], uMaxPixelDelay[0]) else
        z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0001(hDC, uMaxLineDelay[0], IntPtr.Zero) else
      if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
        z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0010(hDC, IntPtr.Zero, uMaxPixelDelay[0]) else
        z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0011(hDC, IntPtr.Zero, IntPtr.Zero);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_1_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; uMaxLineDelay: array of UInt32; var uMaxPixelDelay: UInt32): Bool :=
    if (uMaxLineDelay<>nil) and (uMaxLineDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay[0], uMaxPixelDelay) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0010(hDC, IntPtr.Zero, uMaxPixelDelay);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; var uMaxLineDelay: UInt32; uMaxPixelDelay: IntPtr): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_2_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; uMaxLineDelay: array of UInt32; uMaxPixelDelay: IntPtr): Bool :=
    if (uMaxLineDelay<>nil) and (uMaxLineDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_2(hDC, uMaxLineDelay[0], uMaxPixelDelay) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_2_anh0010(hDC, IntPtr.Zero, uMaxPixelDelay);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; var uMaxLineDelay: UInt32; uMaxPixelDelay: array of UInt32): Bool :=
    if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay, uMaxPixelDelay[0]) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0001(hDC, uMaxLineDelay, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; var uMaxLineDelay: UInt32; var uMaxPixelDelay: UInt32): Bool :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay, uMaxPixelDelay);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; var uMaxLineDelay: UInt32; uMaxPixelDelay: IntPtr): Bool :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_2(hDC, uMaxLineDelay, uMaxPixelDelay);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_6 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_6_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; uMaxLineDelay: IntPtr; uMaxPixelDelay: array of UInt32): Bool :=
    if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_6(hDC, uMaxLineDelay, uMaxPixelDelay[0]) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_6_anh0001(hDC, uMaxLineDelay, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): Bool :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_6(hDC, uMaxLineDelay, uMaxPixelDelay);
    private z_QueryGenlockMaxSourceDelayI3D_ovr_8 := GetProcOrNil&<function(hDC: gdi_device_context; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): Bool>(z_QueryGenlockMaxSourceDelayI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryGenlockMaxSourceDelayI3D(hDC: gdi_device_context; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): Bool :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_8(hDC, uMaxLineDelay, uMaxPixelDelay);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglImageBufferI3D = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'I3D_image_buffer';
    
    private z_CreateImageBufferI3D_adr := GetProcAddress('wglCreateImageBufferI3D');
    private z_CreateImageBufferI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; dwSize: UInt32; uFlags: UInt32): IntPtr>(z_CreateImageBufferI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateImageBufferI3D(hDC: gdi_device_context; dwSize: UInt32; uFlags: UInt32): IntPtr :=
    z_CreateImageBufferI3D_ovr_0(hDC, dwSize, uFlags);
    
    private z_DestroyImageBufferI3D_adr := GetProcAddress('wglDestroyImageBufferI3D');
    private z_DestroyImageBufferI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; pAddress: IntPtr): Bool>(z_DestroyImageBufferI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DestroyImageBufferI3D(hDC: gdi_device_context; pAddress: IntPtr): Bool :=
    z_DestroyImageBufferI3D_ovr_0(hDC, pAddress);
    
    private z_AssociateImageBufferEventsI3D_adr := GetProcAddress('wglAssociateImageBufferEventsI3D');
    private z_AssociateImageBufferEventsI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh001100 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh001010 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_0_anh001110 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; pAddress: array of IntPtr; pSize: array of UInt32; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pAddress<>nil) and (pAddress.Length<>0) then
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress[0], pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent[0], pAddress[0], IntPtr.Zero, count) else
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent[0], IntPtr.Zero, pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh000110(hDC, pEvent[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (pAddress<>nil) and (pAddress.Length<>0) then
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress[0], pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh001010(hDC, IntPtr.Zero, pAddress[0], IntPtr.Zero, count) else
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0_anh001100(hDC, IntPtr.Zero, IntPtr.Zero, pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh001110(hDC, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private z_AssociateImageBufferEventsI3D_ovr_1_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_1_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_1_anh001100 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; pAddress: array of IntPtr; var pSize: UInt32; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent[0], IntPtr.Zero, pSize, count) else
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh001100(hDC, IntPtr.Zero, IntPtr.Zero, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_2_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_2_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_2_anh001100 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; pAddress: array of IntPtr; pSize: IntPtr; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent[0], pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_2_anh000100(hDC, pEvent[0], IntPtr.Zero, pSize, count) else
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_2_anh001000(hDC, IntPtr.Zero, pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_2_anh001100(hDC, IntPtr.Zero, IntPtr.Zero, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_3_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_3_anh001010 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; var pAddress: IntPtr; pSize: array of UInt32; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent[0], pAddress, IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh001010(hDC, IntPtr.Zero, pAddress, IntPtr.Zero, count);
    private z_AssociateImageBufferEventsI3D_ovr_4_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_5_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_2_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_6 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_6_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_6_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_6_anh001010 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; pAddress: pointer; pSize: array of UInt32; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent[0], pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_6_anh000010(hDC, pEvent[0], pAddress, IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_6_anh001000(hDC, IntPtr.Zero, pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_6_anh001010(hDC, IntPtr.Zero, pAddress, IntPtr.Zero, count);
    private z_AssociateImageBufferEventsI3D_ovr_7_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_6_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_8 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_8_anh001000 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: array of IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_8(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_8_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_9_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_9_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: array of IntPtr; pSize: array of UInt32; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress[0], pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent, pAddress[0], IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent, IntPtr.Zero, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000110(hDC, pEvent, IntPtr.Zero, IntPtr.Zero, count);
    private z_AssociateImageBufferEventsI3D_ovr_10_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: array of IntPtr; var pSize: UInt32; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_11_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: array of IntPtr; pSize: IntPtr; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_2_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; var pAddress: IntPtr; pSize: array of UInt32; count: UInt32): Bool :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: pointer; pSize: array of UInt32; count: UInt32): Bool :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_6_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; var pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_8(hDC, pEvent, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_18 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_18_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_18_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_18_anh000110 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; pAddress: array of IntPtr; pSize: array of UInt32; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress[0], pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_18_anh000010(hDC, pEvent, pAddress[0], IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_18_anh000100(hDC, pEvent, IntPtr.Zero, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_18_anh000110(hDC, pEvent, IntPtr.Zero, IntPtr.Zero, count);
    private z_AssociateImageBufferEventsI3D_ovr_19_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; pAddress: array of IntPtr; var pSize: UInt32; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_18_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_20 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_20_anh000100 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; pAddress: array of IntPtr; pSize: IntPtr; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_20(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_20_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; var pAddress: IntPtr; pSize: array of UInt32; count: UInt32): Bool :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_18_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_20(hDC, pEvent, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_24 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    private z_AssociateImageBufferEventsI3D_ovr_24_anh000010 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; pAddress: pointer; pSize: array of UInt32; count: UInt32): Bool :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_24(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_24_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; pAddress: pointer; var pSize: UInt32; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_24(hDC, pEvent, pAddress, pSize, count);
    private z_AssociateImageBufferEventsI3D_ovr_26 := GetProcOrNil&<function(hDC: gdi_device_context; pEvent: pointer; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool>(z_AssociateImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateImageBufferEventsI3D(hDC: gdi_device_context; pEvent: pointer; pAddress: pointer; pSize: IntPtr; count: UInt32): Bool :=
    z_AssociateImageBufferEventsI3D_ovr_26(hDC, pEvent, pAddress, pSize, count);
    
    private z_ReleaseImageBufferEventsI3D_adr := GetProcAddress('wglReleaseImageBufferEventsI3D');
    private z_ReleaseImageBufferEventsI3D_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var pAddress: IntPtr; count: UInt32): Bool>(z_ReleaseImageBufferEventsI3D_adr);
    private z_ReleaseImageBufferEventsI3D_ovr_0_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; pAddress: IntPtr; count: UInt32): Bool>(z_ReleaseImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseImageBufferEventsI3D(hDC: gdi_device_context; pAddress: array of IntPtr; count: UInt32): Bool :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_ReleaseImageBufferEventsI3D_ovr_0(hDC, pAddress[0], count) else
      z_ReleaseImageBufferEventsI3D_ovr_0_anh0010(hDC, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseImageBufferEventsI3D(hDC: gdi_device_context; var pAddress: IntPtr; count: UInt32): Bool :=
    z_ReleaseImageBufferEventsI3D_ovr_0(hDC, pAddress, count);
    private z_ReleaseImageBufferEventsI3D_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; pAddress: pointer; count: UInt32): Bool>(z_ReleaseImageBufferEventsI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseImageBufferEventsI3D(hDC: gdi_device_context; pAddress: pointer; count: UInt32): Bool :=
    z_ReleaseImageBufferEventsI3D_ovr_2(hDC, pAddress, count);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglSwapFrameLockI3D = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'I3D_swap_frame_lock';
    
    private z_EnableFrameLockI3D_adr := GetProcAddress('wglEnableFrameLockI3D');
    private z_EnableFrameLockI3D_ovr_0 := GetProcOrNil&<function: Bool>(z_EnableFrameLockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnableFrameLockI3D: Bool :=
    z_EnableFrameLockI3D_ovr_0;
    
    private z_DisableFrameLockI3D_adr := GetProcAddress('wglDisableFrameLockI3D');
    private z_DisableFrameLockI3D_ovr_0 := GetProcOrNil&<function: Bool>(z_DisableFrameLockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DisableFrameLockI3D: Bool :=
    z_DisableFrameLockI3D_ovr_0;
    
    private z_IsEnabledFrameLockI3D_adr := GetProcAddress('wglIsEnabledFrameLockI3D');
    private z_IsEnabledFrameLockI3D_ovr_0 := GetProcOrNil&<function(var pFlag: Bool): Bool>(z_IsEnabledFrameLockI3D_adr);
    private z_IsEnabledFrameLockI3D_ovr_0_anh01 := GetProcOrNil&<function(pFlag: IntPtr): Bool>(z_IsEnabledFrameLockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledFrameLockI3D(pFlag: array of Bool): Bool :=
    if (pFlag<>nil) and (pFlag.Length<>0) then
      z_IsEnabledFrameLockI3D_ovr_0(pFlag[0]) else
      z_IsEnabledFrameLockI3D_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledFrameLockI3D(var pFlag: Bool): Bool :=
    z_IsEnabledFrameLockI3D_ovr_0(pFlag);
    private z_IsEnabledFrameLockI3D_ovr_2 := GetProcOrNil&<function(pFlag: IntPtr): Bool>(z_IsEnabledFrameLockI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledFrameLockI3D(pFlag: IntPtr): Bool :=
    z_IsEnabledFrameLockI3D_ovr_2(pFlag);
    
    private z_QueryFrameLockMasterI3D_adr := GetProcAddress('wglQueryFrameLockMasterI3D');
    private z_QueryFrameLockMasterI3D_ovr_0 := GetProcOrNil&<function(var pFlag: Bool): Bool>(z_QueryFrameLockMasterI3D_adr);
    private z_QueryFrameLockMasterI3D_ovr_0_anh01 := GetProcOrNil&<function(pFlag: IntPtr): Bool>(z_QueryFrameLockMasterI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameLockMasterI3D(pFlag: array of Bool): Bool :=
    if (pFlag<>nil) and (pFlag.Length<>0) then
      z_QueryFrameLockMasterI3D_ovr_0(pFlag[0]) else
      z_QueryFrameLockMasterI3D_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameLockMasterI3D(var pFlag: Bool): Bool :=
    z_QueryFrameLockMasterI3D_ovr_0(pFlag);
    private z_QueryFrameLockMasterI3D_ovr_2 := GetProcOrNil&<function(pFlag: IntPtr): Bool>(z_QueryFrameLockMasterI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameLockMasterI3D(pFlag: IntPtr): Bool :=
    z_QueryFrameLockMasterI3D_ovr_2(pFlag);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglSwapFrameUsageI3D = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'I3D_swap_frame_usage';
    
    private z_GetFrameUsageI3D_adr := GetProcAddress('wglGetFrameUsageI3D');
    private z_GetFrameUsageI3D_ovr_0 := GetProcOrNil&<function(var pUsage: single): Bool>(z_GetFrameUsageI3D_adr);
    private z_GetFrameUsageI3D_ovr_0_anh01 := GetProcOrNil&<function(pUsage: IntPtr): Bool>(z_GetFrameUsageI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFrameUsageI3D(pUsage: array of single): Bool :=
    if (pUsage<>nil) and (pUsage.Length<>0) then
      z_GetFrameUsageI3D_ovr_0(pUsage[0]) else
      z_GetFrameUsageI3D_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFrameUsageI3D(var pUsage: single): Bool :=
    z_GetFrameUsageI3D_ovr_0(pUsage);
    private z_GetFrameUsageI3D_ovr_2 := GetProcOrNil&<function(pUsage: IntPtr): Bool>(z_GetFrameUsageI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFrameUsageI3D(pUsage: IntPtr): Bool :=
    z_GetFrameUsageI3D_ovr_2(pUsage);
    
    private z_BeginFrameTrackingI3D_adr := GetProcAddress('wglBeginFrameTrackingI3D');
    private z_BeginFrameTrackingI3D_ovr_0 := GetProcOrNil&<function: Bool>(z_BeginFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BeginFrameTrackingI3D: Bool :=
    z_BeginFrameTrackingI3D_ovr_0;
    
    private z_EndFrameTrackingI3D_adr := GetProcAddress('wglEndFrameTrackingI3D');
    private z_EndFrameTrackingI3D_ovr_0 := GetProcOrNil&<function: Bool>(z_EndFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EndFrameTrackingI3D: Bool :=
    z_EndFrameTrackingI3D_ovr_0;
    
    private z_QueryFrameTrackingI3D_adr := GetProcAddress('wglQueryFrameTrackingI3D');
    private z_QueryFrameTrackingI3D_ovr_0 := GetProcOrNil&<function(var pFrameCount: UInt32; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0010 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0110 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0001 := GetProcOrNil&<function(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0101 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0011 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_0_anh0111 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: array of single): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames[0], pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount[0], pMissedFrames[0], IntPtr.Zero) else
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount[0], IntPtr.Zero, pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0011(pFrameCount[0], IntPtr.Zero, IntPtr.Zero) else
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames[0], pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0101(IntPtr.Zero, pMissedFrames[0], IntPtr.Zero) else
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0_anh0110(IntPtr.Zero, IntPtr.Zero, pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_QueryFrameTrackingI3D_ovr_1_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_1_anh0010 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_1_anh0110 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: array of UInt32; var pLastMissedUsage: single): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount[0], IntPtr.Zero, pLastMissedUsage) else
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_0_anh0110(IntPtr.Zero, IntPtr.Zero, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_2 := GetProcOrNil&<function(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_2_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_2_anh0010 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_2_anh0110 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: IntPtr): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_2(pFrameCount[0], pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_2_anh0010(pFrameCount[0], IntPtr.Zero, pLastMissedUsage) else
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_2_anh0100(IntPtr.Zero, pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_2_anh0110(IntPtr.Zero, IntPtr.Zero, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_3_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_3_anh0101 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; var pMissedFrames: UInt32; pLastMissedUsage: array of single): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount[0], pMissedFrames, IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0101(IntPtr.Zero, pMissedFrames, IntPtr.Zero);
    private z_QueryFrameTrackingI3D_ovr_4_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_5_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_2(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_2_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_6 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_6_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_6_anh0001 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_6_anh0101 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: IntPtr; pLastMissedUsage: array of single): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_6(pFrameCount[0], pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_6_anh0001(pFrameCount[0], pMissedFrames, IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_6_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_6_anh0101(IntPtr.Zero, pMissedFrames, IntPtr.Zero);
    private z_QueryFrameTrackingI3D_ovr_7_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_6(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_6_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_8 := GetProcOrNil&<function(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_8_anh0100 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_8(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_8_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: array of single): Bool :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames[0], pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount, pMissedFrames[0], IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0011(pFrameCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: array of UInt32; var pLastMissedUsage: single): Bool :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: IntPtr): Bool :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_2(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_2_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: array of single): Bool :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool :=
    z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool :=
    z_QueryFrameTrackingI3D_ovr_2(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: array of single): Bool :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_6(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_6_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool :=
    z_QueryFrameTrackingI3D_ovr_6(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool :=
    z_QueryFrameTrackingI3D_ovr_8(pFrameCount, pMissedFrames, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_18 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_18_anh0010 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_18_anh0001 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_18_anh0011 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: array of UInt32; pLastMissedUsage: array of single): Bool :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames[0], pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_18_anh0001(pFrameCount, pMissedFrames[0], IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_18_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_18_anh0011(pFrameCount, IntPtr.Zero, IntPtr.Zero);
    private z_QueryFrameTrackingI3D_ovr_19_anh0010 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: array of UInt32; var pLastMissedUsage: single): Bool :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_18_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_20 := GetProcOrNil&<function(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_20_anh0010 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: array of UInt32; pLastMissedUsage: IntPtr): Bool :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_20(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_20_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: array of single): Bool :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_18_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): Bool :=
    z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): Bool :=
    z_QueryFrameTrackingI3D_ovr_20(pFrameCount, pMissedFrames, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_24 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool>(z_QueryFrameTrackingI3D_adr);
    private z_QueryFrameTrackingI3D_ovr_24_anh0001 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: array of single): Bool :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_24(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_24_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): Bool :=
    z_QueryFrameTrackingI3D_ovr_24(pFrameCount, pMissedFrames, pLastMissedUsage);
    private z_QueryFrameTrackingI3D_ovr_26 := GetProcOrNil&<function(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool>(z_QueryFrameTrackingI3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): Bool :=
    z_QueryFrameTrackingI3D_ovr_26(pFrameCount, pMissedFrames, pLastMissedUsage);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglCopyImageNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_copy_image';
    
    private z_CopyImageSubDataNV_adr := GetProcAddress('wglCopyImageSubDataNV');
    private z_CopyImageSubDataNV_ovr_0 := GetProcOrNil&<function(hSrcRC: wgl_context; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; hDstRC: wgl_context; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32): Bool>(z_CopyImageSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CopyImageSubDataNV(hSrcRC: wgl_context; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; hDstRC: wgl_context; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32): Bool :=
    z_CopyImageSubDataNV_ovr_0(hSrcRC, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, hDstRC, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglDelayBeforeSwapNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_delay_before_swap';
    
    private z_DelayBeforeSwapNV_adr := GetProcAddress('wglDelayBeforeSwapNV');
    private z_DelayBeforeSwapNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; seconds: single): Bool>(z_DelayBeforeSwapNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DelayBeforeSwapNV(hDC: gdi_device_context; seconds: single): Bool :=
    z_DelayBeforeSwapNV_ovr_0(hDC, seconds);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglDXInteropNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_DX_interop';
    
    private z_DXSetResourceShareHandleNV_adr := GetProcAddress('wglDXSetResourceShareHandleNV');
    private z_DXSetResourceShareHandleNV_ovr_0 := GetProcOrNil&<function(dxObject: IntPtr; shareHandle: IntPtr): Bool>(z_DXSetResourceShareHandleNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXSetResourceShareHandleNV(dxObject: IntPtr; shareHandle: IntPtr): Bool :=
    z_DXSetResourceShareHandleNV_ovr_0(dxObject, shareHandle);
    
    private z_DXOpenDeviceNV_adr := GetProcAddress('wglDXOpenDeviceNV');
    private z_DXOpenDeviceNV_ovr_0 := GetProcOrNil&<function(dxDevice: IntPtr): IntPtr>(z_DXOpenDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXOpenDeviceNV(dxDevice: IntPtr): IntPtr :=
    z_DXOpenDeviceNV_ovr_0(dxDevice);
    
    private z_DXCloseDeviceNV_adr := GetProcAddress('wglDXCloseDeviceNV');
    private z_DXCloseDeviceNV_ovr_0 := GetProcOrNil&<function(hDevice: IntPtr): Bool>(z_DXCloseDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXCloseDeviceNV(hDevice: IntPtr): Bool :=
    z_DXCloseDeviceNV_ovr_0(hDevice);
    
    private z_DXRegisterObjectNV_adr := GetProcAddress('wglDXRegisterObjectNV');
    private z_DXRegisterObjectNV_ovr_0 := GetProcOrNil&<function(hDevice: IntPtr; dxObject: IntPtr; name: UInt32; &type: DummyEnum; access: DummyEnum): IntPtr>(z_DXRegisterObjectNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXRegisterObjectNV(hDevice: IntPtr; dxObject: IntPtr; name: UInt32; &type: DummyEnum; access: DummyEnum): IntPtr :=
    z_DXRegisterObjectNV_ovr_0(hDevice, dxObject, name, &type, access);
    
    private z_DXUnregisterObjectNV_adr := GetProcAddress('wglDXUnregisterObjectNV');
    private z_DXUnregisterObjectNV_ovr_0 := GetProcOrNil&<function(hDevice: IntPtr; hObject: IntPtr): Bool>(z_DXUnregisterObjectNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXUnregisterObjectNV(hDevice: IntPtr; hObject: IntPtr): Bool :=
    z_DXUnregisterObjectNV_ovr_0(hDevice, hObject);
    
    private z_DXObjectAccessNV_adr := GetProcAddress('wglDXObjectAccessNV');
    private z_DXObjectAccessNV_ovr_0 := GetProcOrNil&<function(hObject: IntPtr; access: DummyEnum): Bool>(z_DXObjectAccessNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXObjectAccessNV(hObject: IntPtr; access: DummyEnum): Bool :=
    z_DXObjectAccessNV_ovr_0(hObject, access);
    
    private z_DXLockObjectsNV_adr := GetProcAddress('wglDXLockObjectsNV');
    private z_DXLockObjectsNV_ovr_0 := GetProcOrNil&<function(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): Bool>(z_DXLockObjectsNV_adr);
    private z_DXLockObjectsNV_ovr_0_anh0001 := GetProcOrNil&<function(hDevice: IntPtr; count: Int32; hObjects: IntPtr): Bool>(z_DXLockObjectsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXLockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: array of IntPtr): Bool :=
    if (hObjects<>nil) and (hObjects.Length<>0) then
      z_DXLockObjectsNV_ovr_0(hDevice, count, hObjects[0]) else
      z_DXLockObjectsNV_ovr_0_anh0001(hDevice, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXLockObjectsNV(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): Bool :=
    z_DXLockObjectsNV_ovr_0(hDevice, count, hObjects);
    private z_DXLockObjectsNV_ovr_2 := GetProcOrNil&<function(hDevice: IntPtr; count: Int32; hObjects: pointer): Bool>(z_DXLockObjectsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXLockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: pointer): Bool :=
    z_DXLockObjectsNV_ovr_2(hDevice, count, hObjects);
    
    private z_DXUnlockObjectsNV_adr := GetProcAddress('wglDXUnlockObjectsNV');
    private z_DXUnlockObjectsNV_ovr_0 := GetProcOrNil&<function(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): Bool>(z_DXUnlockObjectsNV_adr);
    private z_DXUnlockObjectsNV_ovr_0_anh0001 := GetProcOrNil&<function(hDevice: IntPtr; count: Int32; hObjects: IntPtr): Bool>(z_DXUnlockObjectsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXUnlockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: array of IntPtr): Bool :=
    if (hObjects<>nil) and (hObjects.Length<>0) then
      z_DXUnlockObjectsNV_ovr_0(hDevice, count, hObjects[0]) else
      z_DXUnlockObjectsNV_ovr_0_anh0001(hDevice, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXUnlockObjectsNV(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): Bool :=
    z_DXUnlockObjectsNV_ovr_0(hDevice, count, hObjects);
    private z_DXUnlockObjectsNV_ovr_2 := GetProcOrNil&<function(hDevice: IntPtr; count: Int32; hObjects: pointer): Bool>(z_DXUnlockObjectsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DXUnlockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: pointer): Bool :=
    z_DXUnlockObjectsNV_ovr_2(hDevice, count, hObjects);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglGpuAffinityNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_gpu_affinity';
    
    private z_EnumGpusNV_adr := GetProcAddress('wglEnumGpusNV');
    private z_EnumGpusNV_ovr_0 := GetProcOrNil&<function(iGpuIndex: UInt32; var phGpu: wgl_GPU_NV): Bool>(z_EnumGpusNV_adr);
    private z_EnumGpusNV_ovr_0_anh001 := GetProcOrNil&<function(iGpuIndex: UInt32; phGpu: IntPtr): Bool>(z_EnumGpusNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpusNV(iGpuIndex: UInt32; phGpu: array of wgl_GPU_NV): Bool :=
    if (phGpu<>nil) and (phGpu.Length<>0) then
      z_EnumGpusNV_ovr_0(iGpuIndex, phGpu[0]) else
      z_EnumGpusNV_ovr_0_anh001(iGpuIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpusNV(iGpuIndex: UInt32; var phGpu: wgl_GPU_NV): Bool :=
    z_EnumGpusNV_ovr_0(iGpuIndex, phGpu);
    private z_EnumGpusNV_ovr_2 := GetProcOrNil&<function(iGpuIndex: UInt32; phGpu: IntPtr): Bool>(z_EnumGpusNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpusNV(iGpuIndex: UInt32; phGpu: IntPtr): Bool :=
    z_EnumGpusNV_ovr_2(iGpuIndex, phGpu);
    
    private z_EnumGpuDevicesNV_adr := GetProcAddress('wglEnumGpuDevicesNV');
    private z_EnumGpuDevicesNV_ovr_0 := GetProcOrNil&<function(hGpu: wgl_GPU_NV; iDeviceIndex: UInt32; var lpGpuDevice: wgl_GPU_device_NV): Bool>(z_EnumGpuDevicesNV_adr);
    private z_EnumGpuDevicesNV_ovr_0_anh0001 := GetProcOrNil&<function(hGpu: wgl_GPU_NV; iDeviceIndex: UInt32; lpGpuDevice: IntPtr): Bool>(z_EnumGpuDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpuDevicesNV(hGpu: wgl_GPU_NV; iDeviceIndex: UInt32; lpGpuDevice: array of wgl_GPU_device_NV): Bool :=
    if (lpGpuDevice<>nil) and (lpGpuDevice.Length<>0) then
      z_EnumGpuDevicesNV_ovr_0(hGpu, iDeviceIndex, lpGpuDevice[0]) else
      z_EnumGpuDevicesNV_ovr_0_anh0001(hGpu, iDeviceIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpuDevicesNV(hGpu: wgl_GPU_NV; iDeviceIndex: UInt32; var lpGpuDevice: wgl_GPU_device_NV): Bool :=
    z_EnumGpuDevicesNV_ovr_0(hGpu, iDeviceIndex, lpGpuDevice);
    private z_EnumGpuDevicesNV_ovr_2 := GetProcOrNil&<function(hGpu: wgl_GPU_NV; iDeviceIndex: UInt32; lpGpuDevice: IntPtr): Bool>(z_EnumGpuDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpuDevicesNV(hGpu: wgl_GPU_NV; iDeviceIndex: UInt32; lpGpuDevice: IntPtr): Bool :=
    z_EnumGpuDevicesNV_ovr_2(hGpu, iDeviceIndex, lpGpuDevice);
    
    private z_CreateAffinityDCNV_adr := GetProcAddress('wglCreateAffinityDCNV');
    private z_CreateAffinityDCNV_ovr_0 := GetProcOrNil&<function(var phGpuList: wgl_GPU_NV): gdi_device_context>(z_CreateAffinityDCNV_adr);
    private z_CreateAffinityDCNV_ovr_0_anh01 := GetProcOrNil&<function(phGpuList: IntPtr): gdi_device_context>(z_CreateAffinityDCNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAffinityDCNV(phGpuList: array of wgl_GPU_NV): gdi_device_context :=
    if (phGpuList<>nil) and (phGpuList.Length<>0) then
      z_CreateAffinityDCNV_ovr_0(phGpuList[0]) else
      z_CreateAffinityDCNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAffinityDCNV(var phGpuList: wgl_GPU_NV): gdi_device_context :=
    z_CreateAffinityDCNV_ovr_0(phGpuList);
    private z_CreateAffinityDCNV_ovr_2 := GetProcOrNil&<function(phGpuList: IntPtr): gdi_device_context>(z_CreateAffinityDCNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAffinityDCNV(phGpuList: IntPtr): gdi_device_context :=
    z_CreateAffinityDCNV_ovr_2(phGpuList);
    
    private z_EnumGpusFromAffinityDCNV_adr := GetProcAddress('wglEnumGpusFromAffinityDCNV');
    private z_EnumGpusFromAffinityDCNV_ovr_0 := GetProcOrNil&<function(hAffinityDC: gdi_device_context; iGpuIndex: UInt32; var hGpu: wgl_GPU_NV): Bool>(z_EnumGpusFromAffinityDCNV_adr);
    private z_EnumGpusFromAffinityDCNV_ovr_0_anh0001 := GetProcOrNil&<function(hAffinityDC: gdi_device_context; iGpuIndex: UInt32; hGpu: IntPtr): Bool>(z_EnumGpusFromAffinityDCNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpusFromAffinityDCNV(hAffinityDC: gdi_device_context; iGpuIndex: UInt32; hGpu: array of wgl_GPU_NV): Bool :=
    if (hGpu<>nil) and (hGpu.Length<>0) then
      z_EnumGpusFromAffinityDCNV_ovr_0(hAffinityDC, iGpuIndex, hGpu[0]) else
      z_EnumGpusFromAffinityDCNV_ovr_0_anh0001(hAffinityDC, iGpuIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpusFromAffinityDCNV(hAffinityDC: gdi_device_context; iGpuIndex: UInt32; var hGpu: wgl_GPU_NV): Bool :=
    z_EnumGpusFromAffinityDCNV_ovr_0(hAffinityDC, iGpuIndex, hGpu);
    private z_EnumGpusFromAffinityDCNV_ovr_2 := GetProcOrNil&<function(hAffinityDC: gdi_device_context; iGpuIndex: UInt32; hGpu: IntPtr): Bool>(z_EnumGpusFromAffinityDCNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumGpusFromAffinityDCNV(hAffinityDC: gdi_device_context; iGpuIndex: UInt32; hGpu: IntPtr): Bool :=
    z_EnumGpusFromAffinityDCNV_ovr_2(hAffinityDC, iGpuIndex, hGpu);
    
    private z_DeleteDCNV_adr := GetProcAddress('wglDeleteDCNV');
    private z_DeleteDCNV_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context): Bool>(z_DeleteDCNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DeleteDCNV(hdc: gdi_device_context): Bool :=
    z_DeleteDCNV_ovr_0(hdc);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglPresentVideoNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_present_video';
    
    private z_EnumerateVideoDevicesNV_adr := GetProcAddress('wglEnumerateVideoDevicesNV');
    private z_EnumerateVideoDevicesNV_ovr_0 := GetProcOrNil&<function(hDc: gdi_device_context; var phDeviceList: wgl_h_video_output_device_NV): Int32>(z_EnumerateVideoDevicesNV_adr);
    private z_EnumerateVideoDevicesNV_ovr_0_anh001 := GetProcOrNil&<function(hDc: gdi_device_context; phDeviceList: IntPtr): Int32>(z_EnumerateVideoDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoDevicesNV(hDc: gdi_device_context; phDeviceList: array of wgl_h_video_output_device_NV): Int32 :=
    if (phDeviceList<>nil) and (phDeviceList.Length<>0) then
      z_EnumerateVideoDevicesNV_ovr_0(hDc, phDeviceList[0]) else
      z_EnumerateVideoDevicesNV_ovr_0_anh001(hDc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoDevicesNV(hDc: gdi_device_context; var phDeviceList: wgl_h_video_output_device_NV): Int32 :=
    z_EnumerateVideoDevicesNV_ovr_0(hDc, phDeviceList);
    private z_EnumerateVideoDevicesNV_ovr_2 := GetProcOrNil&<function(hDc: gdi_device_context; phDeviceList: IntPtr): Int32>(z_EnumerateVideoDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoDevicesNV(hDc: gdi_device_context; phDeviceList: IntPtr): Int32 :=
    z_EnumerateVideoDevicesNV_ovr_2(hDc, phDeviceList);
    
    private z_BindVideoDeviceNV_adr := GetProcAddress('wglBindVideoDeviceNV');
    private z_BindVideoDeviceNV_ovr_0 := GetProcOrNil&<function(hDc: gdi_device_context; uVideoSlot: UInt32; hVideoDevice: wgl_h_video_output_device_NV; var piAttribList: Int32): Bool>(z_BindVideoDeviceNV_adr);
    private z_BindVideoDeviceNV_ovr_0_anh00001 := GetProcOrNil&<function(hDc: gdi_device_context; uVideoSlot: UInt32; hVideoDevice: wgl_h_video_output_device_NV; piAttribList: IntPtr): Bool>(z_BindVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoDeviceNV(hDc: gdi_device_context; uVideoSlot: UInt32; hVideoDevice: wgl_h_video_output_device_NV; piAttribList: array of Int32): Bool :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_BindVideoDeviceNV_ovr_0(hDc, uVideoSlot, hVideoDevice, piAttribList[0]) else
      z_BindVideoDeviceNV_ovr_0_anh00001(hDc, uVideoSlot, hVideoDevice, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoDeviceNV(hDc: gdi_device_context; uVideoSlot: UInt32; hVideoDevice: wgl_h_video_output_device_NV; var piAttribList: Int32): Bool :=
    z_BindVideoDeviceNV_ovr_0(hDc, uVideoSlot, hVideoDevice, piAttribList);
    private z_BindVideoDeviceNV_ovr_2 := GetProcOrNil&<function(hDc: gdi_device_context; uVideoSlot: UInt32; hVideoDevice: wgl_h_video_output_device_NV; piAttribList: IntPtr): Bool>(z_BindVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoDeviceNV(hDc: gdi_device_context; uVideoSlot: UInt32; hVideoDevice: wgl_h_video_output_device_NV; piAttribList: IntPtr): Bool :=
    z_BindVideoDeviceNV_ovr_2(hDc, uVideoSlot, hVideoDevice, piAttribList);
    
    private z_QueryCurrentContextNV_adr := GetProcAddress('wglQueryCurrentContextNV');
    private z_QueryCurrentContextNV_ovr_0 := GetProcOrNil&<function(iAttribute: Int32; var piValue: Int32): Bool>(z_QueryCurrentContextNV_adr);
    private z_QueryCurrentContextNV_ovr_0_anh001 := GetProcOrNil&<function(iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryCurrentContextNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentContextNV(iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryCurrentContextNV_ovr_0(iAttribute, piValue[0]) else
      z_QueryCurrentContextNV_ovr_0_anh001(iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentContextNV(iAttribute: Int32; var piValue: Int32): Bool :=
    z_QueryCurrentContextNV_ovr_0(iAttribute, piValue);
    private z_QueryCurrentContextNV_ovr_2 := GetProcOrNil&<function(iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryCurrentContextNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentContextNV(iAttribute: Int32; piValue: IntPtr): Bool :=
    z_QueryCurrentContextNV_ovr_2(iAttribute, piValue);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglSwapGroupNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_swap_group';
    
    private z_JoinSwapGroupNV_adr := GetProcAddress('wglJoinSwapGroupNV');
    private z_JoinSwapGroupNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; group: UInt32): Bool>(z_JoinSwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function JoinSwapGroupNV(hDC: gdi_device_context; group: UInt32): Bool :=
    z_JoinSwapGroupNV_ovr_0(hDC, group);
    
    private z_BindSwapBarrierNV_adr := GetProcAddress('wglBindSwapBarrierNV');
    private z_BindSwapBarrierNV_ovr_0 := GetProcOrNil&<function(group: UInt32; barrier: UInt32): Bool>(z_BindSwapBarrierNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindSwapBarrierNV(group: UInt32; barrier: UInt32): Bool :=
    z_BindSwapBarrierNV_ovr_0(group, barrier);
    
    private z_QuerySwapGroupNV_adr := GetProcAddress('wglQuerySwapGroupNV');
    private z_QuerySwapGroupNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var group: UInt32; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_0_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; var group: UInt32; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_0_anh0011 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; group: array of UInt32; barrier: array of UInt32): Bool :=
    if (group<>nil) and (group.Length<>0) then
      if (barrier<>nil) and (barrier.Length<>0) then
        z_QuerySwapGroupNV_ovr_0(hDC, group[0], barrier[0]) else
        z_QuerySwapGroupNV_ovr_0_anh0001(hDC, group[0], IntPtr.Zero) else
      if (barrier<>nil) and (barrier.Length<>0) then
        z_QuerySwapGroupNV_ovr_0_anh0010(hDC, IntPtr.Zero, barrier[0]) else
        z_QuerySwapGroupNV_ovr_0_anh0011(hDC, IntPtr.Zero, IntPtr.Zero);
    private z_QuerySwapGroupNV_ovr_1_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; group: array of UInt32; var barrier: UInt32): Bool :=
    if (group<>nil) and (group.Length<>0) then
      z_QuerySwapGroupNV_ovr_0(hDC, group[0], barrier) else
      z_QuerySwapGroupNV_ovr_0_anh0010(hDC, IntPtr.Zero, barrier);
    private z_QuerySwapGroupNV_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; var group: UInt32; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_2_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; group: array of UInt32; barrier: IntPtr): Bool :=
    if (group<>nil) and (group.Length<>0) then
      z_QuerySwapGroupNV_ovr_2(hDC, group[0], barrier) else
      z_QuerySwapGroupNV_ovr_2_anh0010(hDC, IntPtr.Zero, barrier);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; var group: UInt32; barrier: array of UInt32): Bool :=
    if (barrier<>nil) and (barrier.Length<>0) then
      z_QuerySwapGroupNV_ovr_0(hDC, group, barrier[0]) else
      z_QuerySwapGroupNV_ovr_0_anh0001(hDC, group, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; var group: UInt32; var barrier: UInt32): Bool :=
    z_QuerySwapGroupNV_ovr_0(hDC, group, barrier);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; var group: UInt32; barrier: IntPtr): Bool :=
    z_QuerySwapGroupNV_ovr_2(hDC, group, barrier);
    private z_QuerySwapGroupNV_ovr_6 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_6_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; group: IntPtr; barrier: array of UInt32): Bool :=
    if (barrier<>nil) and (barrier.Length<>0) then
      z_QuerySwapGroupNV_ovr_6(hDC, group, barrier[0]) else
      z_QuerySwapGroupNV_ovr_6_anh0001(hDC, group, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; group: IntPtr; var barrier: UInt32): Bool :=
    z_QuerySwapGroupNV_ovr_6(hDC, group, barrier);
    private z_QuerySwapGroupNV_ovr_8 := GetProcOrNil&<function(hDC: gdi_device_context; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(hDC: gdi_device_context; group: IntPtr; barrier: IntPtr): Bool :=
    z_QuerySwapGroupNV_ovr_8(hDC, group, barrier);
    
    private z_QueryMaxSwapGroupsNV_adr := GetProcAddress('wglQueryMaxSwapGroupsNV');
    private z_QueryMaxSwapGroupsNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var maxGroups: UInt32; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_0_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; var maxGroups: UInt32; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_0_anh0011 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; maxGroups: array of UInt32; maxBarriers: array of UInt32): Bool :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
        z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups[0], maxBarriers[0]) else
        z_QueryMaxSwapGroupsNV_ovr_0_anh0001(hDC, maxGroups[0], IntPtr.Zero) else
      if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
        z_QueryMaxSwapGroupsNV_ovr_0_anh0010(hDC, IntPtr.Zero, maxBarriers[0]) else
        z_QueryMaxSwapGroupsNV_ovr_0_anh0011(hDC, IntPtr.Zero, IntPtr.Zero);
    private z_QueryMaxSwapGroupsNV_ovr_1_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; maxGroups: array of UInt32; var maxBarriers: UInt32): Bool :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups[0], maxBarriers) else
      z_QueryMaxSwapGroupsNV_ovr_0_anh0010(hDC, IntPtr.Zero, maxBarriers);
    private z_QueryMaxSwapGroupsNV_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; var maxGroups: UInt32; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_2_anh0010 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; maxGroups: array of UInt32; maxBarriers: IntPtr): Bool :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_2(hDC, maxGroups[0], maxBarriers) else
      z_QueryMaxSwapGroupsNV_ovr_2_anh0010(hDC, IntPtr.Zero, maxBarriers);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; var maxGroups: UInt32; maxBarriers: array of UInt32): Bool :=
    if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups, maxBarriers[0]) else
      z_QueryMaxSwapGroupsNV_ovr_0_anh0001(hDC, maxGroups, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; var maxGroups: UInt32; var maxBarriers: UInt32): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups, maxBarriers);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; var maxGroups: UInt32; maxBarriers: IntPtr): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_2(hDC, maxGroups, maxBarriers);
    private z_QueryMaxSwapGroupsNV_ovr_6 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_6_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; maxGroups: IntPtr; maxBarriers: array of UInt32): Bool :=
    if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_6(hDC, maxGroups, maxBarriers[0]) else
      z_QueryMaxSwapGroupsNV_ovr_6_anh0001(hDC, maxGroups, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; maxGroups: IntPtr; var maxBarriers: UInt32): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_6(hDC, maxGroups, maxBarriers);
    private z_QueryMaxSwapGroupsNV_ovr_8 := GetProcOrNil&<function(hDC: gdi_device_context; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(hDC: gdi_device_context; maxGroups: IntPtr; maxBarriers: IntPtr): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_8(hDC, maxGroups, maxBarriers);
    
    private z_QueryFrameCountNV_adr := GetProcAddress('wglQueryFrameCountNV');
    private z_QueryFrameCountNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; var count: UInt32): Bool>(z_QueryFrameCountNV_adr);
    private z_QueryFrameCountNV_ovr_0_anh001 := GetProcOrNil&<function(hDC: gdi_device_context; count: IntPtr): Bool>(z_QueryFrameCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameCountNV(hDC: gdi_device_context; count: array of UInt32): Bool :=
    if (count<>nil) and (count.Length<>0) then
      z_QueryFrameCountNV_ovr_0(hDC, count[0]) else
      z_QueryFrameCountNV_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameCountNV(hDC: gdi_device_context; var count: UInt32): Bool :=
    z_QueryFrameCountNV_ovr_0(hDC, count);
    private z_QueryFrameCountNV_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; count: IntPtr): Bool>(z_QueryFrameCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameCountNV(hDC: gdi_device_context; count: IntPtr): Bool :=
    z_QueryFrameCountNV_ovr_2(hDC, count);
    
    private z_ResetFrameCountNV_adr := GetProcAddress('wglResetFrameCountNV');
    private z_ResetFrameCountNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context): Bool>(z_ResetFrameCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ResetFrameCountNV(hDC: gdi_device_context): Bool :=
    z_ResetFrameCountNV_ovr_0(hDC);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglVideoCaptureNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_video_capture';
    
    private z_BindVideoCaptureDeviceNV_adr := GetProcAddress('wglBindVideoCaptureDeviceNV');
    private z_BindVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<function(uVideoSlot: UInt32; hDevice: wgl_h_video_input_device_NV): Bool>(z_BindVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoCaptureDeviceNV(uVideoSlot: UInt32; hDevice: wgl_h_video_input_device_NV): Bool :=
    z_BindVideoCaptureDeviceNV_ovr_0(uVideoSlot, hDevice);
    
    private z_EnumerateVideoCaptureDevicesNV_adr := GetProcAddress('wglEnumerateVideoCaptureDevicesNV');
    private z_EnumerateVideoCaptureDevicesNV_ovr_0 := GetProcOrNil&<function(hDc: gdi_device_context; var phDeviceList: wgl_h_video_input_device_NV): UInt32>(z_EnumerateVideoCaptureDevicesNV_adr);
    private z_EnumerateVideoCaptureDevicesNV_ovr_0_anh001 := GetProcOrNil&<function(hDc: gdi_device_context; phDeviceList: IntPtr): UInt32>(z_EnumerateVideoCaptureDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoCaptureDevicesNV(hDc: gdi_device_context; phDeviceList: array of wgl_h_video_input_device_NV): UInt32 :=
    if (phDeviceList<>nil) and (phDeviceList.Length<>0) then
      z_EnumerateVideoCaptureDevicesNV_ovr_0(hDc, phDeviceList[0]) else
      z_EnumerateVideoCaptureDevicesNV_ovr_0_anh001(hDc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoCaptureDevicesNV(hDc: gdi_device_context; var phDeviceList: wgl_h_video_input_device_NV): UInt32 :=
    z_EnumerateVideoCaptureDevicesNV_ovr_0(hDc, phDeviceList);
    private z_EnumerateVideoCaptureDevicesNV_ovr_2 := GetProcOrNil&<function(hDc: gdi_device_context; phDeviceList: IntPtr): UInt32>(z_EnumerateVideoCaptureDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoCaptureDevicesNV(hDc: gdi_device_context; phDeviceList: IntPtr): UInt32 :=
    z_EnumerateVideoCaptureDevicesNV_ovr_2(hDc, phDeviceList);
    
    private z_LockVideoCaptureDeviceNV_adr := GetProcAddress('wglLockVideoCaptureDeviceNV');
    private z_LockVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<function(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV): Bool>(z_LockVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function LockVideoCaptureDeviceNV(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV): Bool :=
    z_LockVideoCaptureDeviceNV_ovr_0(hDc, hDevice);
    
    private z_QueryVideoCaptureDeviceNV_adr := GetProcAddress('wglQueryVideoCaptureDeviceNV');
    private z_QueryVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<function(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV; iAttribute: Int32; var piValue: Int32): Bool>(z_QueryVideoCaptureDeviceNV_adr);
    private z_QueryVideoCaptureDeviceNV_ovr_0_anh00001 := GetProcOrNil&<function(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV; iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryVideoCaptureDeviceNV(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV; iAttribute: Int32; piValue: array of Int32): Bool :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryVideoCaptureDeviceNV_ovr_0(hDc, hDevice, iAttribute, piValue[0]) else
      z_QueryVideoCaptureDeviceNV_ovr_0_anh00001(hDc, hDevice, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryVideoCaptureDeviceNV(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV; iAttribute: Int32; var piValue: Int32): Bool :=
    z_QueryVideoCaptureDeviceNV_ovr_0(hDc, hDevice, iAttribute, piValue);
    private z_QueryVideoCaptureDeviceNV_ovr_2 := GetProcOrNil&<function(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV; iAttribute: Int32; piValue: IntPtr): Bool>(z_QueryVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryVideoCaptureDeviceNV(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV; iAttribute: Int32; piValue: IntPtr): Bool :=
    z_QueryVideoCaptureDeviceNV_ovr_2(hDc, hDevice, iAttribute, piValue);
    
    private z_ReleaseVideoCaptureDeviceNV_adr := GetProcAddress('wglReleaseVideoCaptureDeviceNV');
    private z_ReleaseVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<function(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV): Bool>(z_ReleaseVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseVideoCaptureDeviceNV(hDc: gdi_device_context; hDevice: wgl_h_video_input_device_NV): Bool :=
    z_ReleaseVideoCaptureDeviceNV_ovr_0(hDc, hDevice);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglVideoOutputNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_video_output';
    
    private z_GetVideoDeviceNV_adr := GetProcAddress('wglGetVideoDeviceNV');
    private z_GetVideoDeviceNV_ovr_0 := GetProcOrNil&<function(hDC: gdi_device_context; numDevices: Int32; var hVideoDevice: wgl_h_video_device_NV): Bool>(z_GetVideoDeviceNV_adr);
    private z_GetVideoDeviceNV_ovr_0_anh0001 := GetProcOrNil&<function(hDC: gdi_device_context; numDevices: Int32; hVideoDevice: IntPtr): Bool>(z_GetVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoDeviceNV(hDC: gdi_device_context; numDevices: Int32; hVideoDevice: array of wgl_h_video_device_NV): Bool :=
    if (hVideoDevice<>nil) and (hVideoDevice.Length<>0) then
      z_GetVideoDeviceNV_ovr_0(hDC, numDevices, hVideoDevice[0]) else
      z_GetVideoDeviceNV_ovr_0_anh0001(hDC, numDevices, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoDeviceNV(hDC: gdi_device_context; numDevices: Int32; var hVideoDevice: wgl_h_video_device_NV): Bool :=
    z_GetVideoDeviceNV_ovr_0(hDC, numDevices, hVideoDevice);
    private z_GetVideoDeviceNV_ovr_2 := GetProcOrNil&<function(hDC: gdi_device_context; numDevices: Int32; hVideoDevice: IntPtr): Bool>(z_GetVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoDeviceNV(hDC: gdi_device_context; numDevices: Int32; hVideoDevice: IntPtr): Bool :=
    z_GetVideoDeviceNV_ovr_2(hDC, numDevices, hVideoDevice);
    
    private z_ReleaseVideoDeviceNV_adr := GetProcAddress('wglReleaseVideoDeviceNV');
    private z_ReleaseVideoDeviceNV_ovr_0 := GetProcOrNil&<function(hVideoDevice: wgl_h_video_device_NV): Bool>(z_ReleaseVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseVideoDeviceNV(hVideoDevice: wgl_h_video_device_NV): Bool :=
    z_ReleaseVideoDeviceNV_ovr_0(hVideoDevice);
    
    private z_BindVideoImageNV_adr := GetProcAddress('wglBindVideoImageNV');
    private z_BindVideoImageNV_ovr_0 := GetProcOrNil&<function(hVideoDevice: wgl_h_video_device_NV; hPbuffer: wgl_pbuffer_ARB; iVideoBuffer: Int32): Bool>(z_BindVideoImageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoImageNV(hVideoDevice: wgl_h_video_device_NV; hPbuffer: wgl_pbuffer_ARB; iVideoBuffer: Int32): Bool :=
    z_BindVideoImageNV_ovr_0(hVideoDevice, hPbuffer, iVideoBuffer);
    
    private z_ReleaseVideoImageNV_adr := GetProcAddress('wglReleaseVideoImageNV');
    private z_ReleaseVideoImageNV_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iVideoBuffer: Int32): Bool>(z_ReleaseVideoImageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseVideoImageNV(hPbuffer: wgl_pbuffer_ARB; iVideoBuffer: Int32): Bool :=
    z_ReleaseVideoImageNV_ovr_0(hPbuffer, iVideoBuffer);
    
    private z_SendPbufferToVideoNV_adr := GetProcAddress('wglSendPbufferToVideoNV');
    private z_SendPbufferToVideoNV_ovr_0 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iBufferType: Int32; var pulCounterPbuffer: UInt64; bBlock: Bool): Bool>(z_SendPbufferToVideoNV_adr);
    private z_SendPbufferToVideoNV_ovr_0_anh00010 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: Bool): Bool>(z_SendPbufferToVideoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SendPbufferToVideoNV(hPbuffer: wgl_pbuffer_ARB; iBufferType: Int32; pulCounterPbuffer: array of UInt64; bBlock: Bool): Bool :=
    if (pulCounterPbuffer<>nil) and (pulCounterPbuffer.Length<>0) then
      z_SendPbufferToVideoNV_ovr_0(hPbuffer, iBufferType, pulCounterPbuffer[0], bBlock) else
      z_SendPbufferToVideoNV_ovr_0_anh00010(hPbuffer, iBufferType, IntPtr.Zero, bBlock);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SendPbufferToVideoNV(hPbuffer: wgl_pbuffer_ARB; iBufferType: Int32; var pulCounterPbuffer: UInt64; bBlock: Bool): Bool :=
    z_SendPbufferToVideoNV_ovr_0(hPbuffer, iBufferType, pulCounterPbuffer, bBlock);
    private z_SendPbufferToVideoNV_ovr_2 := GetProcOrNil&<function(hPbuffer: wgl_pbuffer_ARB; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: Bool): Bool>(z_SendPbufferToVideoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SendPbufferToVideoNV(hPbuffer: wgl_pbuffer_ARB; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: Bool): Bool :=
    z_SendPbufferToVideoNV_ovr_2(hPbuffer, iBufferType, pulCounterPbuffer, bBlock);
    
    private z_GetVideoInfoNV_adr := GetProcAddress('wglGetVideoInfoNV');
    private z_GetVideoInfoNV_ovr_0 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; var pulCounterOutputPbuffer: UInt64; var pulCounterOutputVideo: UInt64): Bool>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_0_anh0010 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Bool>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_0_anh0001 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): Bool>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_0_anh0011 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Bool>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: array of UInt64; pulCounterOutputVideo: array of UInt64): Bool :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
        z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo[0]) else
        z_GetVideoInfoNV_ovr_0_anh0001(hpVideoDevice, pulCounterOutputPbuffer[0], IntPtr.Zero) else
      if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
        z_GetVideoInfoNV_ovr_0_anh0010(hpVideoDevice, IntPtr.Zero, pulCounterOutputVideo[0]) else
        z_GetVideoInfoNV_ovr_0_anh0011(hpVideoDevice, IntPtr.Zero, IntPtr.Zero);
    private z_GetVideoInfoNV_ovr_1_anh0010 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Bool>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: array of UInt64; var pulCounterOutputVideo: UInt64): Bool :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo) else
      z_GetVideoInfoNV_ovr_0_anh0010(hpVideoDevice, IntPtr.Zero, pulCounterOutputVideo);
    private z_GetVideoInfoNV_ovr_2 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): Bool>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_2_anh0010 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Bool>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: array of UInt64; pulCounterOutputVideo: IntPtr): Bool :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      z_GetVideoInfoNV_ovr_2(hpVideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo) else
      z_GetVideoInfoNV_ovr_2_anh0010(hpVideoDevice, IntPtr.Zero, pulCounterOutputVideo);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: array of UInt64): Bool :=
    if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
      z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo[0]) else
      z_GetVideoInfoNV_ovr_0_anh0001(hpVideoDevice, pulCounterOutputPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; var pulCounterOutputPbuffer: UInt64; var pulCounterOutputVideo: UInt64): Bool :=
    z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): Bool :=
    z_GetVideoInfoNV_ovr_2(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    private z_GetVideoInfoNV_ovr_6 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Bool>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_6_anh0001 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Bool>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: array of UInt64): Bool :=
    if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
      z_GetVideoInfoNV_ovr_6(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo[0]) else
      z_GetVideoInfoNV_ovr_6_anh0001(hpVideoDevice, pulCounterOutputPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Bool :=
    z_GetVideoInfoNV_ovr_6(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    private z_GetVideoInfoNV_ovr_8 := GetProcOrNil&<function(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Bool>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(hpVideoDevice: wgl_h_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Bool :=
    z_GetVideoInfoNV_ovr_8(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglVertexArrayRangeNV = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_vertex_array_range';
    
    private z_AllocateMemoryNV_adr := GetProcAddress('wglAllocateMemoryNV');
    private z_AllocateMemoryNV_ovr_0 := GetProcOrNil&<function(size: Int32; readfreq: single; writefreq: single; priority: single): IntPtr>(z_AllocateMemoryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AllocateMemoryNV(size: Int32; readfreq: single; writefreq: single; priority: single): IntPtr :=
    z_AllocateMemoryNV_ovr_0(size, readfreq, writefreq, priority);
    
    private z_FreeMemoryNV_adr := GetProcAddress('wglFreeMemoryNV');
    private z_FreeMemoryNV_ovr_0 := GetProcOrNil&<procedure(pointer: IntPtr)>(z_FreeMemoryNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FreeMemoryNV(pointer: IntPtr) :=
    z_FreeMemoryNV_ovr_0(pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  wglSyncControlOML = sealed partial class
    private function GetProcAddress(name: string) := wgl.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OML_sync_control';
    
    private z_GetSyncValuesOML_adr := GetProcAddress('wglGetSyncValuesOML');
    private z_GetSyncValuesOML_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00010 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00110 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00001 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00101 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00011 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh00111 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc[0], sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust[0], IntPtr.Zero, sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00011(hdc, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc[0], sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00101(hdc, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh00110(hdc, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00111(hdc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_1_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_1_anh00010 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_1_anh00110 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc[0], sbc) else
        z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc[0], sbc) else
        z_GetSyncValuesOML_ovr_0_anh00110(hdc, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_GetSyncValuesOML_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_2_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_2_anh00010 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_2_anh00110 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_2(hdc, ust[0], msc[0], sbc) else
        z_GetSyncValuesOML_ovr_2_anh00010(hdc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_2_anh00100(hdc, IntPtr.Zero, msc[0], sbc) else
        z_GetSyncValuesOML_ovr_2_anh00110(hdc, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_GetSyncValuesOML_ovr_3_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_3_anh00101 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00101(hdc, IntPtr.Zero, msc, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_4_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; var msc: Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc, sbc);
    private z_GetSyncValuesOML_ovr_5_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; var msc: Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_2(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_2_anh00100(hdc, IntPtr.Zero, msc, sbc);
    private z_GetSyncValuesOML_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_6_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_6_anh00001 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_6_anh00101 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_6(hdc, ust[0], msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_6_anh00001(hdc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_6_anh00100(hdc, IntPtr.Zero, msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_6_anh00101(hdc, IntPtr.Zero, msc, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_7_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; msc: IntPtr; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_6(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_6_anh00100(hdc, IntPtr.Zero, msc, sbc);
    private z_GetSyncValuesOML_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_8_anh00100 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: array of Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_8(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_8_anh00100(hdc, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(hdc, ust, msc[0], sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust, IntPtr.Zero, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00011(hdc, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_0(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_2(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_2_anh00010(hdc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_0(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; var msc: Int64; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_0(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_2(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_6(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_6_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_6(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_8(hdc, ust, msc, sbc);
    private z_GetSyncValuesOML_ovr_18 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_18_anh00010 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_18_anh00001 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_18_anh00011 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_18(hdc, ust, msc[0], sbc[0]) else
        z_GetSyncValuesOML_ovr_18_anh00001(hdc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_18_anh00010(hdc, ust, IntPtr.Zero, sbc[0]) else
        z_GetSyncValuesOML_ovr_18_anh00011(hdc, ust, IntPtr.Zero, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_19_anh00010 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_18(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_18_anh00010(hdc, ust, IntPtr.Zero, sbc);
    private z_GetSyncValuesOML_ovr_20 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_20_anh00010 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_20(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_20_anh00010(hdc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_18(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_18_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_18(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_20(hdc, ust, msc, sbc);
    private z_GetSyncValuesOML_ovr_24 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_24_anh00001 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_24(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_24_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_24(hdc, ust, msc, sbc);
    private z_GetSyncValuesOML_ovr_26 := GetProcOrNil&<function(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(hdc: gdi_device_context; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_26(hdc, ust, msc, sbc);
    
    private z_GetMscRateOML_adr := GetProcAddress('wglGetMscRateOML');
    private z_GetMscRateOML_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; var numerator: Int32; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_0_anh0010 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_0_anh0001 := GetProcOrNil&<function(hdc: gdi_device_context; var numerator: Int32; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_0_anh0011 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; numerator: array of Int32; denominator: array of Int32): Bool :=
    if (numerator<>nil) and (numerator.Length<>0) then
      if (denominator<>nil) and (denominator.Length<>0) then
        z_GetMscRateOML_ovr_0(hdc, numerator[0], denominator[0]) else
        z_GetMscRateOML_ovr_0_anh0001(hdc, numerator[0], IntPtr.Zero) else
      if (denominator<>nil) and (denominator.Length<>0) then
        z_GetMscRateOML_ovr_0_anh0010(hdc, IntPtr.Zero, denominator[0]) else
        z_GetMscRateOML_ovr_0_anh0011(hdc, IntPtr.Zero, IntPtr.Zero);
    private z_GetMscRateOML_ovr_1_anh0010 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; numerator: array of Int32; var denominator: Int32): Bool :=
    if (numerator<>nil) and (numerator.Length<>0) then
      z_GetMscRateOML_ovr_0(hdc, numerator[0], denominator) else
      z_GetMscRateOML_ovr_0_anh0010(hdc, IntPtr.Zero, denominator);
    private z_GetMscRateOML_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; var numerator: Int32; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_2_anh0010 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; numerator: array of Int32; denominator: IntPtr): Bool :=
    if (numerator<>nil) and (numerator.Length<>0) then
      z_GetMscRateOML_ovr_2(hdc, numerator[0], denominator) else
      z_GetMscRateOML_ovr_2_anh0010(hdc, IntPtr.Zero, denominator);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; var numerator: Int32; denominator: array of Int32): Bool :=
    if (denominator<>nil) and (denominator.Length<>0) then
      z_GetMscRateOML_ovr_0(hdc, numerator, denominator[0]) else
      z_GetMscRateOML_ovr_0_anh0001(hdc, numerator, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; var numerator: Int32; var denominator: Int32): Bool :=
    z_GetMscRateOML_ovr_0(hdc, numerator, denominator);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; var numerator: Int32; denominator: IntPtr): Bool :=
    z_GetMscRateOML_ovr_2(hdc, numerator, denominator);
    private z_GetMscRateOML_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_6_anh0001 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; numerator: IntPtr; denominator: array of Int32): Bool :=
    if (denominator<>nil) and (denominator.Length<>0) then
      z_GetMscRateOML_ovr_6(hdc, numerator, denominator[0]) else
      z_GetMscRateOML_ovr_6_anh0001(hdc, numerator, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; numerator: IntPtr; var denominator: Int32): Bool :=
    z_GetMscRateOML_ovr_6(hdc, numerator, denominator);
    private z_GetMscRateOML_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(hdc: gdi_device_context; numerator: IntPtr; denominator: IntPtr): Bool :=
    z_GetMscRateOML_ovr_8(hdc, numerator, denominator);
    
    private z_SwapBuffersMscOML_adr := GetProcAddress('wglSwapBuffersMscOML');
    private z_SwapBuffersMscOML_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64): Int64>(z_SwapBuffersMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SwapBuffersMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64): Int64 :=
    z_SwapBuffersMscOML_ovr_0(hdc, target_msc, divisor, remainder);
    
    private z_SwapLayerBuffersMscOML_adr := GetProcAddress('wglSwapLayerBuffersMscOML');
    private z_SwapLayerBuffersMscOML_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; fuPlanes: Int32; target_msc: Int64; divisor: Int64; remainder: Int64): Int64>(z_SwapLayerBuffersMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SwapLayerBuffersMscOML(hdc: gdi_device_context; fuPlanes: Int32; target_msc: Int64; divisor: Int64; remainder: Int64): Int64 :=
    z_SwapLayerBuffersMscOML_ovr_0(hdc, fuPlanes, target_msc, divisor, remainder);
    
    private z_WaitForMscOML_adr := GetProcAddress('wglWaitForMscOML');
    private z_WaitForMscOML_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000110 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000101 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000011 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh00000111 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc[0], sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000011(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000101(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh00000110(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000111(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForMscOML_ovr_1_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_1_anh00000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_1_anh00000110 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc[0], sbc) else
        z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc) else
        z_WaitForMscOML_ovr_0_anh00000110(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForMscOML_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_2_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_2_anh00000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_2_anh00000110 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust[0], msc[0], sbc) else
        z_WaitForMscOML_ovr_2_anh00000010(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_2_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc) else
        z_WaitForMscOML_ovr_2_anh00000110(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForMscOML_ovr_3_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_3_anh00000101 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000101(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForMscOML_ovr_4_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private z_WaitForMscOML_ovr_5_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_2_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private z_WaitForMscOML_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_6_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_6_anh00000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_6_anh00000101 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust[0], msc, sbc[0]) else
        z_WaitForMscOML_ovr_6_anh00000001(hdc, target_msc, divisor, remainder, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_6_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForMscOML_ovr_6_anh00000101(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForMscOML_ovr_7_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_6_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private z_WaitForMscOML_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_8_anh00000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_8(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_8_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc[0], sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000011(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_2_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_6_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_8(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    private z_WaitForMscOML_ovr_18 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_18_anh00000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_18_anh00000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_18_anh00000011 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc[0], sbc[0]) else
        z_WaitForMscOML_ovr_18_anh00000001(hdc, target_msc, divisor, remainder, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_18_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForMscOML_ovr_18_anh00000011(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForMscOML_ovr_19_anh00000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_18_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    private z_WaitForMscOML_ovr_20 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_20_anh00000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_20(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_20_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_18_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_20(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    private z_WaitForMscOML_ovr_24 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_24_anh00000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_24(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_24_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_24(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    private z_WaitForMscOML_ovr_26 := GetProcOrNil&<function(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(hdc: gdi_device_context; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_26(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    
    private z_WaitForSbcOML_adr := GetProcAddress('wglWaitForSbcOML');
    private z_WaitForSbcOML_ovr_0 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000110 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000101 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000011 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh000111 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc[0], sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust[0], IntPtr.Zero, sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000011(hdc, target_sbc, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc[0], sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000101(hdc, target_sbc, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh000110(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000111(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_1_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_1_anh000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_1_anh000110 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc[0], sbc) else
        z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc[0], sbc) else
        z_WaitForSbcOML_ovr_0_anh000110(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForSbcOML_ovr_2 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_2_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_2_anh000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_2_anh000110 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust[0], msc[0], sbc) else
        z_WaitForSbcOML_ovr_2_anh000010(hdc, target_sbc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_2_anh000100(hdc, target_sbc, IntPtr.Zero, msc[0], sbc) else
        z_WaitForSbcOML_ovr_2_anh000110(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForSbcOML_ovr_3_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_3_anh000101 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000101(hdc, target_sbc, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_4_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; var msc: Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    private z_WaitForSbcOML_ovr_5_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; var msc: Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_2_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    private z_WaitForSbcOML_ovr_6 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_6_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_6_anh000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_6_anh000101 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust[0], msc, sbc[0]) else
        z_WaitForSbcOML_ovr_6_anh000001(hdc, target_sbc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_6_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForSbcOML_ovr_6_anh000101(hdc, target_sbc, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_7_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; msc: IntPtr; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_6_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    private z_WaitForSbcOML_ovr_8 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_8_anh000100 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: array of Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_8(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_8_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc[0], sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000011(hdc, target_sbc, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_2_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_6_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_8(hdc, target_sbc, ust, msc, sbc);
    private z_WaitForSbcOML_ovr_18 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_18_anh000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_18_anh000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_18_anh000011 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc[0], sbc[0]) else
        z_WaitForSbcOML_ovr_18_anh000001(hdc, target_sbc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_18_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForSbcOML_ovr_18_anh000011(hdc, target_sbc, ust, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_19_anh000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_18_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    private z_WaitForSbcOML_ovr_20 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_20_anh000010 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_20(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_20_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_18_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_20(hdc, target_sbc, ust, msc, sbc);
    private z_WaitForSbcOML_ovr_24 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_24_anh000001 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_24(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_24_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_24(hdc, target_sbc, ust, msc, sbc);
    private z_WaitForSbcOML_ovr_26 := GetProcOrNil&<function(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(hdc: gdi_device_context; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_26(hdc, target_sbc, ust, msc, sbc);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxGpuAssociationAMD = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'AMD_gpu_association';
    
    private z_GetGPUIDsAMD_adr := GetProcAddress('glXGetGPUIDsAMD');
    private z_GetGPUIDsAMD_ovr_0 := GetProcOrNil&<function(maxCount: UInt32; var ids: UInt32): UInt32>(z_GetGPUIDsAMD_adr);
    private z_GetGPUIDsAMD_ovr_0_anh001 := GetProcOrNil&<function(maxCount: UInt32; ids: IntPtr): UInt32>(z_GetGPUIDsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUIDsAMD(maxCount: UInt32; ids: array of UInt32): UInt32 :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GetGPUIDsAMD_ovr_0(maxCount, ids[0]) else
      z_GetGPUIDsAMD_ovr_0_anh001(maxCount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUIDsAMD(maxCount: UInt32; var ids: UInt32): UInt32 :=
    z_GetGPUIDsAMD_ovr_0(maxCount, ids);
    private z_GetGPUIDsAMD_ovr_2 := GetProcOrNil&<function(maxCount: UInt32; ids: IntPtr): UInt32>(z_GetGPUIDsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUIDsAMD(maxCount: UInt32; ids: IntPtr): UInt32 :=
    z_GetGPUIDsAMD_ovr_2(maxCount, ids);
    
    private z_GetGPUInfoAMD_adr := GetProcAddress('glXGetGPUInfoAMD');
    private z_GetGPUInfoAMD_ovr_0 := GetProcOrNil&<function(id: UInt32; &property: Int32; dataType: DummyEnum; size: UInt32; data: IntPtr): Int32>(z_GetGPUInfoAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGPUInfoAMD(id: UInt32; &property: Int32; dataType: DummyEnum; size: UInt32; data: IntPtr): Int32 :=
    z_GetGPUInfoAMD_ovr_0(id, &property, dataType, size, data);
    
    private z_GetContextGPUIDAMD_adr := GetProcAddress('glXGetContextGPUIDAMD');
    private z_GetContextGPUIDAMD_ovr_0 := GetProcOrNil&<function(ctx: glx_context): UInt32>(z_GetContextGPUIDAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetContextGPUIDAMD(ctx: glx_context): UInt32 :=
    z_GetContextGPUIDAMD_ovr_0(ctx);
    
    private z_CreateAssociatedContextAMD_adr := GetProcAddress('glXCreateAssociatedContextAMD');
    private z_CreateAssociatedContextAMD_ovr_0 := GetProcOrNil&<function(id: UInt32; share_list: glx_context): glx_context>(z_CreateAssociatedContextAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAMD(id: UInt32; share_list: glx_context): glx_context :=
    z_CreateAssociatedContextAMD_ovr_0(id, share_list);
    
    private z_CreateAssociatedContextAttribsAMD_adr := GetProcAddress('glXCreateAssociatedContextAttribsAMD');
    private z_CreateAssociatedContextAttribsAMD_ovr_0 := GetProcOrNil&<function(id: UInt32; share_context: glx_context; var attribList: Int32): glx_context>(z_CreateAssociatedContextAttribsAMD_adr);
    private z_CreateAssociatedContextAttribsAMD_ovr_0_anh0001 := GetProcOrNil&<function(id: UInt32; share_context: glx_context; attribList: IntPtr): glx_context>(z_CreateAssociatedContextAttribsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAttribsAMD(id: UInt32; share_context: glx_context; attribList: array of Int32): glx_context :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_CreateAssociatedContextAttribsAMD_ovr_0(id, share_context, attribList[0]) else
      z_CreateAssociatedContextAttribsAMD_ovr_0_anh0001(id, share_context, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAttribsAMD(id: UInt32; share_context: glx_context; var attribList: Int32): glx_context :=
    z_CreateAssociatedContextAttribsAMD_ovr_0(id, share_context, attribList);
    private z_CreateAssociatedContextAttribsAMD_ovr_2 := GetProcOrNil&<function(id: UInt32; share_context: glx_context; attribList: IntPtr): glx_context>(z_CreateAssociatedContextAttribsAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateAssociatedContextAttribsAMD(id: UInt32; share_context: glx_context; attribList: IntPtr): glx_context :=
    z_CreateAssociatedContextAttribsAMD_ovr_2(id, share_context, attribList);
    
    private z_DeleteAssociatedContextAMD_adr := GetProcAddress('glXDeleteAssociatedContextAMD');
    private z_DeleteAssociatedContextAMD_ovr_0 := GetProcOrNil&<function(ctx: glx_context): Bool>(z_DeleteAssociatedContextAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DeleteAssociatedContextAMD(ctx: glx_context): Bool :=
    z_DeleteAssociatedContextAMD_ovr_0(ctx);
    
    private z_MakeAssociatedContextCurrentAMD_adr := GetProcAddress('glXMakeAssociatedContextCurrentAMD');
    private z_MakeAssociatedContextCurrentAMD_ovr_0 := GetProcOrNil&<function(ctx: glx_context): Bool>(z_MakeAssociatedContextCurrentAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MakeAssociatedContextCurrentAMD(ctx: glx_context): Bool :=
    z_MakeAssociatedContextCurrentAMD_ovr_0(ctx);
    
    private z_GetCurrentAssociatedContextAMD_adr := GetProcAddress('glXGetCurrentAssociatedContextAMD');
    private z_GetCurrentAssociatedContextAMD_ovr_0 := GetProcOrNil&<function: glx_context>(z_GetCurrentAssociatedContextAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCurrentAssociatedContextAMD: glx_context :=
    z_GetCurrentAssociatedContextAMD_ovr_0;
    
    private z_BlitContextFramebufferAMD_adr := GetProcAddress('glXBlitContextFramebufferAMD');
    private z_BlitContextFramebufferAMD_ovr_0 := GetProcOrNil&<procedure(dstCtx: glx_context; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: DummyFlags; filter: DummyEnum)>(z_BlitContextFramebufferAMD_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitContextFramebufferAMD(dstCtx: glx_context; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: DummyFlags; filter: DummyEnum) :=
    z_BlitContextFramebufferAMD_ovr_0(dstCtx, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxCreateContextARB = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_create_context';
    
    private z_CreateContextAttribsARB_adr := GetProcAddress('glXCreateContextAttribsARB');
    private z_CreateContextAttribsARB_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; share_context: glx_context; direct: Bool; var attrib_list: Int32): glx_context>(z_CreateContextAttribsARB_adr);
    private z_CreateContextAttribsARB_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; share_context: glx_context; direct: Bool; attrib_list: IntPtr): glx_context>(z_CreateContextAttribsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextAttribsARB(dpy: x_p_display; config: glx_fb_config; share_context: glx_context; direct: Bool; attrib_list: array of Int32): glx_context :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_CreateContextAttribsARB_ovr_0(dpy, config, share_context, direct, attrib_list[0]) else
      z_CreateContextAttribsARB_ovr_0_anh000001(dpy, config, share_context, direct, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextAttribsARB(dpy: x_p_display; config: glx_fb_config; share_context: glx_context; direct: Bool; var attrib_list: Int32): glx_context :=
    z_CreateContextAttribsARB_ovr_0(dpy, config, share_context, direct, attrib_list);
    private z_CreateContextAttribsARB_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; share_context: glx_context; direct: Bool; attrib_list: IntPtr): glx_context>(z_CreateContextAttribsARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextAttribsARB(dpy: x_p_display; config: glx_fb_config; share_context: glx_context; direct: Bool; attrib_list: IntPtr): glx_context :=
    z_CreateContextAttribsARB_ovr_2(dpy, config, share_context, direct, attrib_list);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxGetProcAddressARB = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'ARB_get_proc_address';
    
    private z_GetProcAddressARB_adr := GetProcAddress('glXGetProcAddressARB');
    private z_GetProcAddressARB_ovr_0 := GetProcOrNil&<function(var procName: Byte): IntPtr>(z_GetProcAddressARB_adr);
    private z_GetProcAddressARB_ovr_0_anh01 := GetProcOrNil&<function(procName: IntPtr): IntPtr>(z_GetProcAddressARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProcAddressARB(procName: array of Byte): IntPtr :=
    if (procName<>nil) and (procName.Length<>0) then
      z_GetProcAddressARB_ovr_0(procName[0]) else
      z_GetProcAddressARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProcAddressARB(var procName: Byte): IntPtr :=
    z_GetProcAddressARB_ovr_0(procName);
    private z_GetProcAddressARB_ovr_2 := GetProcOrNil&<function(procName: IntPtr): IntPtr>(z_GetProcAddressARB_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProcAddressARB(procName: IntPtr): IntPtr :=
    z_GetProcAddressARB_ovr_2(procName);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxImportContextEXT = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_import_context';
    
    private z_GetCurrentDisplayEXT_adr := GetProcAddress('glXGetCurrentDisplayEXT');
    private z_GetCurrentDisplayEXT_ovr_0 := GetProcOrNil&<function: x_p_display>(z_GetCurrentDisplayEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCurrentDisplayEXT: x_p_display :=
    z_GetCurrentDisplayEXT_ovr_0;
    
    private z_QueryContextInfoEXT_adr := GetProcAddress('glXQueryContextInfoEXT');
    private z_QueryContextInfoEXT_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; context: glx_context; attribute: Int32; var value: Int32): Int32>(z_QueryContextInfoEXT_adr);
    private z_QueryContextInfoEXT_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; context: glx_context; attribute: Int32; value: IntPtr): Int32>(z_QueryContextInfoEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryContextInfoEXT(dpy: x_p_display; context: glx_context; attribute: Int32; value: array of Int32): Int32 :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryContextInfoEXT_ovr_0(dpy, context, attribute, value[0]) else
      z_QueryContextInfoEXT_ovr_0_anh00001(dpy, context, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryContextInfoEXT(dpy: x_p_display; context: glx_context; attribute: Int32; var value: Int32): Int32 :=
    z_QueryContextInfoEXT_ovr_0(dpy, context, attribute, value);
    private z_QueryContextInfoEXT_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; context: glx_context; attribute: Int32; value: IntPtr): Int32>(z_QueryContextInfoEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryContextInfoEXT(dpy: x_p_display; context: glx_context; attribute: Int32; value: IntPtr): Int32 :=
    z_QueryContextInfoEXT_ovr_2(dpy, context, attribute, value);
    
    private z_GetContextIDEXT_adr := GetProcAddress('glXGetContextIDEXT');
    private z_GetContextIDEXT_ovr_0 := GetProcOrNil&<function(context: glx_context): glx_context_id>(z_GetContextIDEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetContextIDEXT(context: glx_context): glx_context_id :=
    z_GetContextIDEXT_ovr_0(context);
    
    private z_ImportContextEXT_adr := GetProcAddress('glXImportContextEXT');
    private z_ImportContextEXT_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; contextID: glx_context_id): glx_context>(z_ImportContextEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ImportContextEXT(dpy: x_p_display; contextID: glx_context_id): glx_context :=
    z_ImportContextEXT_ovr_0(dpy, contextID);
    
    private z_FreeContextEXT_adr := GetProcAddress('glXFreeContextEXT');
    private z_FreeContextEXT_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; context: glx_context)>(z_FreeContextEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FreeContextEXT(dpy: x_p_display; context: glx_context) :=
    z_FreeContextEXT_ovr_0(dpy, context);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSwapControlEXT = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_swap_control';
    
    private z_SwapIntervalEXT_adr := GetProcAddress('glXSwapIntervalEXT');
    private z_SwapIntervalEXT_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; interval: Int32)>(z_SwapIntervalEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SwapIntervalEXT(dpy: x_p_display; drawable: glx_drawable; interval: Int32) :=
    z_SwapIntervalEXT_ovr_0(dpy, drawable, interval);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxTextureFromPixmapEXT = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'EXT_texture_from_pixmap';
    
    private z_BindTexImageEXT_adr := GetProcAddress('glXBindTexImageEXT');
    private z_BindTexImageEXT_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; buffer: Int32; var attrib_list: Int32)>(z_BindTexImageEXT_adr);
    private z_BindTexImageEXT_ovr_0_anh00001 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; buffer: Int32; attrib_list: IntPtr)>(z_BindTexImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTexImageEXT(dpy: x_p_display; drawable: glx_drawable; buffer: Int32; attrib_list: array of Int32) :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_BindTexImageEXT_ovr_0(dpy, drawable, buffer, attrib_list[0]) else
      z_BindTexImageEXT_ovr_0_anh00001(dpy, drawable, buffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTexImageEXT(dpy: x_p_display; drawable: glx_drawable; buffer: Int32; var attrib_list: Int32) :=
    z_BindTexImageEXT_ovr_0(dpy, drawable, buffer, attrib_list);
    private z_BindTexImageEXT_ovr_2 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; buffer: Int32; attrib_list: IntPtr)>(z_BindTexImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTexImageEXT(dpy: x_p_display; drawable: glx_drawable; buffer: Int32; attrib_list: IntPtr) :=
    z_BindTexImageEXT_ovr_2(dpy, drawable, buffer, attrib_list);
    
    private z_ReleaseTexImageEXT_adr := GetProcAddress('glXReleaseTexImageEXT');
    private z_ReleaseTexImageEXT_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; buffer: Int32)>(z_ReleaseTexImageEXT_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReleaseTexImageEXT(dpy: x_p_display; drawable: glx_drawable; buffer: Int32) :=
    z_ReleaseTexImageEXT_ovr_0(dpy, drawable, buffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxAgpOffsetMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_agp_offset';
    
    private z_GetAGPOffsetMESA_adr := GetProcAddress('glXGetAGPOffsetMESA');
    private z_GetAGPOffsetMESA_ovr_0 := GetProcOrNil&<function(pointer: IntPtr): UInt32>(z_GetAGPOffsetMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAGPOffsetMESA(pointer: IntPtr): UInt32 :=
    z_GetAGPOffsetMESA_ovr_0(pointer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxCopySubBufferMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_copy_sub_buffer';
    
    private z_CopySubBufferMESA_adr := GetProcAddress('glXCopySubBufferMESA');
    private z_CopySubBufferMESA_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopySubBufferMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopySubBufferMESA(dpy: x_p_display; drawable: glx_drawable; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopySubBufferMESA_ovr_0(dpy, drawable, x, y, width, height);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxPixmapColormapMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_pixmap_colormap';
    
    private z_CreateGLXPixmapMESA_adr := GetProcAddress('glXCreateGLXPixmapMESA');
    private z_CreateGLXPixmapMESA_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; visual: x_p_visual_info; pixmap: x_pixmap; cmap: x_colormap): glx_pixmap>(z_CreateGLXPixmapMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateGLXPixmapMESA(dpy: x_p_display; visual: x_p_visual_info; pixmap: x_pixmap; cmap: x_colormap): glx_pixmap :=
    z_CreateGLXPixmapMESA_ovr_0(dpy, visual, pixmap, cmap);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxQueryRendererMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_query_renderer';
    
    private z_QueryCurrentRendererIntegerMESA_adr := GetProcAddress('glXQueryCurrentRendererIntegerMESA');
    private z_QueryCurrentRendererIntegerMESA_ovr_0 := GetProcOrNil&<function(attribute: Int32; var value: UInt32): Bool>(z_QueryCurrentRendererIntegerMESA_adr);
    private z_QueryCurrentRendererIntegerMESA_ovr_0_anh001 := GetProcOrNil&<function(attribute: Int32; value: IntPtr): Bool>(z_QueryCurrentRendererIntegerMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentRendererIntegerMESA(attribute: Int32; value: array of UInt32): Bool :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryCurrentRendererIntegerMESA_ovr_0(attribute, value[0]) else
      z_QueryCurrentRendererIntegerMESA_ovr_0_anh001(attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentRendererIntegerMESA(attribute: Int32; var value: UInt32): Bool :=
    z_QueryCurrentRendererIntegerMESA_ovr_0(attribute, value);
    private z_QueryCurrentRendererIntegerMESA_ovr_2 := GetProcOrNil&<function(attribute: Int32; value: IntPtr): Bool>(z_QueryCurrentRendererIntegerMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentRendererIntegerMESA(attribute: Int32; value: IntPtr): Bool :=
    z_QueryCurrentRendererIntegerMESA_ovr_2(attribute, value);
    
    private z_QueryCurrentRendererStringMESA_adr := GetProcAddress('glXQueryCurrentRendererStringMESA');
    private z_QueryCurrentRendererStringMESA_ovr_0 := GetProcOrNil&<function(attribute: Int32): IntPtr>(z_QueryCurrentRendererStringMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryCurrentRendererStringMESA(attribute: Int32): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_QueryCurrentRendererStringMESA_ovr_0(attribute);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    private z_QueryRendererIntegerMESA_adr := GetProcAddress('glXQueryRendererIntegerMESA');
    private z_QueryRendererIntegerMESA_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32; var value: UInt32): Bool>(z_QueryRendererIntegerMESA_adr);
    private z_QueryRendererIntegerMESA_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32; value: IntPtr): Bool>(z_QueryRendererIntegerMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryRendererIntegerMESA(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32; value: array of UInt32): Bool :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryRendererIntegerMESA_ovr_0(dpy, screen, renderer, attribute, value[0]) else
      z_QueryRendererIntegerMESA_ovr_0_anh000001(dpy, screen, renderer, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryRendererIntegerMESA(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32; var value: UInt32): Bool :=
    z_QueryRendererIntegerMESA_ovr_0(dpy, screen, renderer, attribute, value);
    private z_QueryRendererIntegerMESA_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32; value: IntPtr): Bool>(z_QueryRendererIntegerMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryRendererIntegerMESA(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32; value: IntPtr): Bool :=
    z_QueryRendererIntegerMESA_ovr_2(dpy, screen, renderer, attribute, value);
    
    private z_QueryRendererStringMESA_adr := GetProcAddress('glXQueryRendererStringMESA');
    private z_QueryRendererStringMESA_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32): IntPtr>(z_QueryRendererStringMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryRendererStringMESA(dpy: x_p_display; screen: Int32; renderer: Int32; attribute: Int32): string;
    begin
      var res_str_ptr: IntPtr;
      res_str_ptr := z_QueryRendererStringMESA_ovr_0(dpy, screen, renderer, attribute);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxReleaseBuffersMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_release_buffers';
    
    private z_ReleaseBuffersMESA_adr := GetProcAddress('glXReleaseBuffersMESA');
    private z_ReleaseBuffersMESA_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable): Bool>(z_ReleaseBuffersMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseBuffersMESA(dpy: x_p_display; drawable: glx_drawable): Bool :=
    z_ReleaseBuffersMESA_ovr_0(dpy, drawable);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSet3dfxModeMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_set_3dfx_mode';
    
    private z_Set3DfxModeMESA_adr := GetProcAddress('glXSet3DfxModeMESA');
    private z_Set3DfxModeMESA_ovr_0 := GetProcOrNil&<function(mode: Int32): boolean>(z_Set3DfxModeMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function Set3DfxModeMESA(mode: Int32): boolean :=
    z_Set3DfxModeMESA_ovr_0(mode);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSwapControlMESA = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'MESA_swap_control';
    
    private z_GetSwapIntervalMESA_adr := GetProcAddress('glXGetSwapIntervalMESA');
    private z_GetSwapIntervalMESA_ovr_0 := GetProcOrNil&<function: Int32>(z_GetSwapIntervalMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSwapIntervalMESA: Int32 :=
    z_GetSwapIntervalMESA_ovr_0;
    
    private z_SwapIntervalMESA_adr := GetProcAddress('glXSwapIntervalMESA');
    private z_SwapIntervalMESA_ovr_0 := GetProcOrNil&<function(interval: UInt32): Int32>(z_SwapIntervalMESA_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SwapIntervalMESA(interval: UInt32): Int32 :=
    z_SwapIntervalMESA_ovr_0(interval);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxCopyBufferNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_copy_buffer';
    
    private z_CopyBufferSubDataNV_adr := GetProcAddress('glXCopyBufferSubDataNV');
    private z_CopyBufferSubDataNV_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; readCtx: glx_context; writeCtx: glx_context; readTarget: DummyEnum; writeTarget: DummyEnum; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyBufferSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyBufferSubDataNV(dpy: x_p_display; readCtx: glx_context; writeCtx: glx_context; readTarget: DummyEnum; writeTarget: DummyEnum; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyBufferSubDataNV_ovr_0(dpy, readCtx, writeCtx, readTarget, writeTarget, readOffset, writeOffset, size);
    
    private z_NamedCopyBufferSubDataNV_adr := GetProcAddress('glXNamedCopyBufferSubDataNV');
    private z_NamedCopyBufferSubDataNV_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; readCtx: glx_context; writeCtx: glx_context; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_NamedCopyBufferSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedCopyBufferSubDataNV(dpy: x_p_display; readCtx: glx_context; writeCtx: glx_context; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_NamedCopyBufferSubDataNV_ovr_0(dpy, readCtx, writeCtx, readBuffer, writeBuffer, readOffset, writeOffset, size);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxCopyImageNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_copy_image';
    
    private z_CopyImageSubDataNV_adr := GetProcAddress('glXCopyImageSubDataNV');
    private z_CopyImageSubDataNV_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; srcCtx: glx_context; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstCtx: glx_context; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32)>(z_CopyImageSubDataNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubDataNV(dpy: x_p_display; srcCtx: glx_context; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstCtx: glx_context; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_CopyImageSubDataNV_ovr_0(dpy, srcCtx, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstCtx, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxDelayBeforeSwapNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_delay_before_swap';
    
    private z_DelayBeforeSwapNV_adr := GetProcAddress('glXDelayBeforeSwapNV');
    private z_DelayBeforeSwapNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; seconds: single): Bool>(z_DelayBeforeSwapNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DelayBeforeSwapNV(dpy: x_p_display; drawable: glx_drawable; seconds: single): Bool :=
    z_DelayBeforeSwapNV_ovr_0(dpy, drawable, seconds);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxPresentVideoNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_present_video';
    
    private z_EnumerateVideoDevicesNV_adr := GetProcAddress('glXEnumerateVideoDevicesNV');
    private z_EnumerateVideoDevicesNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var nelements: Int32): ^UInt32>(z_EnumerateVideoDevicesNV_adr);
    private z_EnumerateVideoDevicesNV_ovr_0_anh0001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^UInt32>(z_EnumerateVideoDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoDevicesNV(dpy: x_p_display; screen: Int32; nelements: array of Int32): ^UInt32 :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_EnumerateVideoDevicesNV_ovr_0(dpy, screen, nelements[0]) else
      z_EnumerateVideoDevicesNV_ovr_0_anh0001(dpy, screen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoDevicesNV(dpy: x_p_display; screen: Int32; var nelements: Int32): ^UInt32 :=
    z_EnumerateVideoDevicesNV_ovr_0(dpy, screen, nelements);
    private z_EnumerateVideoDevicesNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^UInt32>(z_EnumerateVideoDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoDevicesNV(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^UInt32 :=
    z_EnumerateVideoDevicesNV_ovr_2(dpy, screen, nelements);
    
    private z_BindVideoDeviceNV_adr := GetProcAddress('glXBindVideoDeviceNV');
    private z_BindVideoDeviceNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; video_slot: UInt32; video_device: UInt32; var attrib_list: Int32): Int32>(z_BindVideoDeviceNV_adr);
    private z_BindVideoDeviceNV_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; video_slot: UInt32; video_device: UInt32; attrib_list: IntPtr): Int32>(z_BindVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoDeviceNV(dpy: x_p_display; video_slot: UInt32; video_device: UInt32; attrib_list: array of Int32): Int32 :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_BindVideoDeviceNV_ovr_0(dpy, video_slot, video_device, attrib_list[0]) else
      z_BindVideoDeviceNV_ovr_0_anh00001(dpy, video_slot, video_device, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoDeviceNV(dpy: x_p_display; video_slot: UInt32; video_device: UInt32; var attrib_list: Int32): Int32 :=
    z_BindVideoDeviceNV_ovr_0(dpy, video_slot, video_device, attrib_list);
    private z_BindVideoDeviceNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; video_slot: UInt32; video_device: UInt32; attrib_list: IntPtr): Int32>(z_BindVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoDeviceNV(dpy: x_p_display; video_slot: UInt32; video_device: UInt32; attrib_list: IntPtr): Int32 :=
    z_BindVideoDeviceNV_ovr_2(dpy, video_slot, video_device, attrib_list);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSwapGroupNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_swap_group';
    
    private z_JoinSwapGroupNV_adr := GetProcAddress('glXJoinSwapGroupNV');
    private z_JoinSwapGroupNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: UInt32): Bool>(z_JoinSwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function JoinSwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: UInt32): Bool :=
    z_JoinSwapGroupNV_ovr_0(dpy, drawable, group);
    
    private z_BindSwapBarrierNV_adr := GetProcAddress('glXBindSwapBarrierNV');
    private z_BindSwapBarrierNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; group: UInt32; barrier: UInt32): Bool>(z_BindSwapBarrierNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindSwapBarrierNV(dpy: x_p_display; group: UInt32; barrier: UInt32): Bool :=
    z_BindSwapBarrierNV_ovr_0(dpy, group, barrier);
    
    private z_QuerySwapGroupNV_adr := GetProcAddress('glXQuerySwapGroupNV');
    private z_QuerySwapGroupNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var group: UInt32; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_0_anh00010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var group: UInt32; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_0_anh00011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: array of UInt32; barrier: array of UInt32): Bool :=
    if (group<>nil) and (group.Length<>0) then
      if (barrier<>nil) and (barrier.Length<>0) then
        z_QuerySwapGroupNV_ovr_0(dpy, drawable, group[0], barrier[0]) else
        z_QuerySwapGroupNV_ovr_0_anh00001(dpy, drawable, group[0], IntPtr.Zero) else
      if (barrier<>nil) and (barrier.Length<>0) then
        z_QuerySwapGroupNV_ovr_0_anh00010(dpy, drawable, IntPtr.Zero, barrier[0]) else
        z_QuerySwapGroupNV_ovr_0_anh00011(dpy, drawable, IntPtr.Zero, IntPtr.Zero);
    private z_QuerySwapGroupNV_ovr_1_anh00010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: array of UInt32; var barrier: UInt32): Bool :=
    if (group<>nil) and (group.Length<>0) then
      z_QuerySwapGroupNV_ovr_0(dpy, drawable, group[0], barrier) else
      z_QuerySwapGroupNV_ovr_0_anh00010(dpy, drawable, IntPtr.Zero, barrier);
    private z_QuerySwapGroupNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var group: UInt32; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_2_anh00010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: array of UInt32; barrier: IntPtr): Bool :=
    if (group<>nil) and (group.Length<>0) then
      z_QuerySwapGroupNV_ovr_2(dpy, drawable, group[0], barrier) else
      z_QuerySwapGroupNV_ovr_2_anh00010(dpy, drawable, IntPtr.Zero, barrier);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; var group: UInt32; barrier: array of UInt32): Bool :=
    if (barrier<>nil) and (barrier.Length<>0) then
      z_QuerySwapGroupNV_ovr_0(dpy, drawable, group, barrier[0]) else
      z_QuerySwapGroupNV_ovr_0_anh00001(dpy, drawable, group, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; var group: UInt32; var barrier: UInt32): Bool :=
    z_QuerySwapGroupNV_ovr_0(dpy, drawable, group, barrier);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; var group: UInt32; barrier: IntPtr): Bool :=
    z_QuerySwapGroupNV_ovr_2(dpy, drawable, group, barrier);
    private z_QuerySwapGroupNV_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; var barrier: UInt32): Bool>(z_QuerySwapGroupNV_adr);
    private z_QuerySwapGroupNV_ovr_6_anh00001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; barrier: array of UInt32): Bool :=
    if (barrier<>nil) and (barrier.Length<>0) then
      z_QuerySwapGroupNV_ovr_6(dpy, drawable, group, barrier[0]) else
      z_QuerySwapGroupNV_ovr_6_anh00001(dpy, drawable, group, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; var barrier: UInt32): Bool :=
    z_QuerySwapGroupNV_ovr_6(dpy, drawable, group, barrier);
    private z_QuerySwapGroupNV_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; barrier: IntPtr): Bool>(z_QuerySwapGroupNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QuerySwapGroupNV(dpy: x_p_display; drawable: glx_drawable; group: IntPtr; barrier: IntPtr): Bool :=
    z_QuerySwapGroupNV_ovr_8(dpy, drawable, group, barrier);
    
    private z_QueryMaxSwapGroupsNV_adr := GetProcAddress('glXQueryMaxSwapGroupsNV');
    private z_QueryMaxSwapGroupsNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var maxGroups: UInt32; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_0_anh00010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var maxGroups: UInt32; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_0_anh00011 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; maxGroups: array of UInt32; maxBarriers: array of UInt32): Bool :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
        z_QueryMaxSwapGroupsNV_ovr_0(dpy, screen, maxGroups[0], maxBarriers[0]) else
        z_QueryMaxSwapGroupsNV_ovr_0_anh00001(dpy, screen, maxGroups[0], IntPtr.Zero) else
      if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
        z_QueryMaxSwapGroupsNV_ovr_0_anh00010(dpy, screen, IntPtr.Zero, maxBarriers[0]) else
        z_QueryMaxSwapGroupsNV_ovr_0_anh00011(dpy, screen, IntPtr.Zero, IntPtr.Zero);
    private z_QueryMaxSwapGroupsNV_ovr_1_anh00010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; maxGroups: array of UInt32; var maxBarriers: UInt32): Bool :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_0(dpy, screen, maxGroups[0], maxBarriers) else
      z_QueryMaxSwapGroupsNV_ovr_0_anh00010(dpy, screen, IntPtr.Zero, maxBarriers);
    private z_QueryMaxSwapGroupsNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var maxGroups: UInt32; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_2_anh00010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; maxGroups: array of UInt32; maxBarriers: IntPtr): Bool :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_2(dpy, screen, maxGroups[0], maxBarriers) else
      z_QueryMaxSwapGroupsNV_ovr_2_anh00010(dpy, screen, IntPtr.Zero, maxBarriers);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; var maxGroups: UInt32; maxBarriers: array of UInt32): Bool :=
    if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_0(dpy, screen, maxGroups, maxBarriers[0]) else
      z_QueryMaxSwapGroupsNV_ovr_0_anh00001(dpy, screen, maxGroups, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; var maxGroups: UInt32; var maxBarriers: UInt32): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_0(dpy, screen, maxGroups, maxBarriers);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; var maxGroups: UInt32; maxBarriers: IntPtr): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_2(dpy, screen, maxGroups, maxBarriers);
    private z_QueryMaxSwapGroupsNV_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; var maxBarriers: UInt32): Bool>(z_QueryMaxSwapGroupsNV_adr);
    private z_QueryMaxSwapGroupsNV_ovr_6_anh00001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; maxBarriers: array of UInt32): Bool :=
    if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_6(dpy, screen, maxGroups, maxBarriers[0]) else
      z_QueryMaxSwapGroupsNV_ovr_6_anh00001(dpy, screen, maxGroups, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; var maxBarriers: UInt32): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_6(dpy, screen, maxGroups, maxBarriers);
    private z_QueryMaxSwapGroupsNV_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; maxBarriers: IntPtr): Bool>(z_QueryMaxSwapGroupsNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapGroupsNV(dpy: x_p_display; screen: Int32; maxGroups: IntPtr; maxBarriers: IntPtr): Bool :=
    z_QueryMaxSwapGroupsNV_ovr_8(dpy, screen, maxGroups, maxBarriers);
    
    private z_QueryFrameCountNV_adr := GetProcAddress('glXQueryFrameCountNV');
    private z_QueryFrameCountNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var count: UInt32): Bool>(z_QueryFrameCountNV_adr);
    private z_QueryFrameCountNV_ovr_0_anh0001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; count: IntPtr): Bool>(z_QueryFrameCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameCountNV(dpy: x_p_display; screen: Int32; count: array of UInt32): Bool :=
    if (count<>nil) and (count.Length<>0) then
      z_QueryFrameCountNV_ovr_0(dpy, screen, count[0]) else
      z_QueryFrameCountNV_ovr_0_anh0001(dpy, screen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameCountNV(dpy: x_p_display; screen: Int32; var count: UInt32): Bool :=
    z_QueryFrameCountNV_ovr_0(dpy, screen, count);
    private z_QueryFrameCountNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; count: IntPtr): Bool>(z_QueryFrameCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryFrameCountNV(dpy: x_p_display; screen: Int32; count: IntPtr): Bool :=
    z_QueryFrameCountNV_ovr_2(dpy, screen, count);
    
    private z_ResetFrameCountNV_adr := GetProcAddress('glXResetFrameCountNV');
    private z_ResetFrameCountNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32): Bool>(z_ResetFrameCountNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ResetFrameCountNV(dpy: x_p_display; screen: Int32): Bool :=
    z_ResetFrameCountNV_ovr_0(dpy, screen);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxVideoCaptureNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_video_capture';
    
    private z_BindVideoCaptureDeviceNV_adr := GetProcAddress('glXBindVideoCaptureDeviceNV');
    private z_BindVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; video_capture_slot: UInt32; device: glx_video_capture_device_NV): Int32>(z_BindVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoCaptureDeviceNV(dpy: x_p_display; video_capture_slot: UInt32; device: glx_video_capture_device_NV): Int32 :=
    z_BindVideoCaptureDeviceNV_ovr_0(dpy, video_capture_slot, device);
    
    private z_EnumerateVideoCaptureDevicesNV_adr := GetProcAddress('glXEnumerateVideoCaptureDevicesNV');
    private z_EnumerateVideoCaptureDevicesNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var nelements: Int32): ^glx_video_capture_device_NV>(z_EnumerateVideoCaptureDevicesNV_adr);
    private z_EnumerateVideoCaptureDevicesNV_ovr_0_anh0001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^glx_video_capture_device_NV>(z_EnumerateVideoCaptureDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoCaptureDevicesNV(dpy: x_p_display; screen: Int32; nelements: array of Int32): ^glx_video_capture_device_NV :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_EnumerateVideoCaptureDevicesNV_ovr_0(dpy, screen, nelements[0]) else
      z_EnumerateVideoCaptureDevicesNV_ovr_0_anh0001(dpy, screen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoCaptureDevicesNV(dpy: x_p_display; screen: Int32; var nelements: Int32): ^glx_video_capture_device_NV :=
    z_EnumerateVideoCaptureDevicesNV_ovr_0(dpy, screen, nelements);
    private z_EnumerateVideoCaptureDevicesNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^glx_video_capture_device_NV>(z_EnumerateVideoCaptureDevicesNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function EnumerateVideoCaptureDevicesNV(dpy: x_p_display; screen: Int32; nelements: IntPtr): ^glx_video_capture_device_NV :=
    z_EnumerateVideoCaptureDevicesNV_ovr_2(dpy, screen, nelements);
    
    private z_LockVideoCaptureDeviceNV_adr := GetProcAddress('glXLockVideoCaptureDeviceNV');
    private z_LockVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; device: glx_video_capture_device_NV)>(z_LockVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LockVideoCaptureDeviceNV(dpy: x_p_display; device: glx_video_capture_device_NV) :=
    z_LockVideoCaptureDeviceNV_ovr_0(dpy, device);
    
    private z_QueryVideoCaptureDeviceNV_adr := GetProcAddress('glXQueryVideoCaptureDeviceNV');
    private z_QueryVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; device: glx_video_capture_device_NV; attribute: Int32; var value: Int32): Int32>(z_QueryVideoCaptureDeviceNV_adr);
    private z_QueryVideoCaptureDeviceNV_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; device: glx_video_capture_device_NV; attribute: Int32; value: IntPtr): Int32>(z_QueryVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryVideoCaptureDeviceNV(dpy: x_p_display; device: glx_video_capture_device_NV; attribute: Int32; value: array of Int32): Int32 :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryVideoCaptureDeviceNV_ovr_0(dpy, device, attribute, value[0]) else
      z_QueryVideoCaptureDeviceNV_ovr_0_anh00001(dpy, device, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryVideoCaptureDeviceNV(dpy: x_p_display; device: glx_video_capture_device_NV; attribute: Int32; var value: Int32): Int32 :=
    z_QueryVideoCaptureDeviceNV_ovr_0(dpy, device, attribute, value);
    private z_QueryVideoCaptureDeviceNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; device: glx_video_capture_device_NV; attribute: Int32; value: IntPtr): Int32>(z_QueryVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryVideoCaptureDeviceNV(dpy: x_p_display; device: glx_video_capture_device_NV; attribute: Int32; value: IntPtr): Int32 :=
    z_QueryVideoCaptureDeviceNV_ovr_2(dpy, device, attribute, value);
    
    private z_ReleaseVideoCaptureDeviceNV_adr := GetProcAddress('glXReleaseVideoCaptureDeviceNV');
    private z_ReleaseVideoCaptureDeviceNV_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; device: glx_video_capture_device_NV)>(z_ReleaseVideoCaptureDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReleaseVideoCaptureDeviceNV(dpy: x_p_display; device: glx_video_capture_device_NV) :=
    z_ReleaseVideoCaptureDeviceNV_ovr_0(dpy, device);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxVideoOutNV = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'NV_video_out';
    
    private z_GetVideoDeviceNV_adr := GetProcAddress('glXGetVideoDeviceNV');
    private z_GetVideoDeviceNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; numVideoDevices: Int32; var pVideoDevice: glx_video_device_NV): Int32>(z_GetVideoDeviceNV_adr);
    private z_GetVideoDeviceNV_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; numVideoDevices: Int32; pVideoDevice: IntPtr): Int32>(z_GetVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoDeviceNV(dpy: x_p_display; screen: Int32; numVideoDevices: Int32; pVideoDevice: array of glx_video_device_NV): Int32 :=
    if (pVideoDevice<>nil) and (pVideoDevice.Length<>0) then
      z_GetVideoDeviceNV_ovr_0(dpy, screen, numVideoDevices, pVideoDevice[0]) else
      z_GetVideoDeviceNV_ovr_0_anh00001(dpy, screen, numVideoDevices, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoDeviceNV(dpy: x_p_display; screen: Int32; numVideoDevices: Int32; var pVideoDevice: glx_video_device_NV): Int32 :=
    z_GetVideoDeviceNV_ovr_0(dpy, screen, numVideoDevices, pVideoDevice);
    private z_GetVideoDeviceNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; numVideoDevices: Int32; pVideoDevice: IntPtr): Int32>(z_GetVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoDeviceNV(dpy: x_p_display; screen: Int32; numVideoDevices: Int32; pVideoDevice: IntPtr): Int32 :=
    z_GetVideoDeviceNV_ovr_2(dpy, screen, numVideoDevices, pVideoDevice);
    
    private z_ReleaseVideoDeviceNV_adr := GetProcAddress('glXReleaseVideoDeviceNV');
    private z_ReleaseVideoDeviceNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV): Int32>(z_ReleaseVideoDeviceNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseVideoDeviceNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV): Int32 :=
    z_ReleaseVideoDeviceNV_ovr_0(dpy, screen, VideoDevice);
    
    private z_BindVideoImageNV_adr := GetProcAddress('glXBindVideoImageNV');
    private z_BindVideoImageNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; VideoDevice: glx_video_device_NV; pbuf: glx_pbuffer; iVideoBuffer: Int32): Int32>(z_BindVideoImageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindVideoImageNV(dpy: x_p_display; VideoDevice: glx_video_device_NV; pbuf: glx_pbuffer; iVideoBuffer: Int32): Int32 :=
    z_BindVideoImageNV_ovr_0(dpy, VideoDevice, pbuf, iVideoBuffer);
    
    private z_ReleaseVideoImageNV_adr := GetProcAddress('glXReleaseVideoImageNV');
    private z_ReleaseVideoImageNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; pbuf: glx_pbuffer): Int32>(z_ReleaseVideoImageNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseVideoImageNV(dpy: x_p_display; pbuf: glx_pbuffer): Int32 :=
    z_ReleaseVideoImageNV_ovr_0(dpy, pbuf);
    
    private z_SendPbufferToVideoNV_adr := GetProcAddress('glXSendPbufferToVideoNV');
    private z_SendPbufferToVideoNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; pbuf: glx_pbuffer; iBufferType: Int32; var pulCounterPbuffer: UInt64; bBlock: boolean): Int32>(z_SendPbufferToVideoNV_adr);
    private z_SendPbufferToVideoNV_ovr_0_anh000010 := GetProcOrNil&<function(dpy: x_p_display; pbuf: glx_pbuffer; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: boolean): Int32>(z_SendPbufferToVideoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SendPbufferToVideoNV(dpy: x_p_display; pbuf: glx_pbuffer; iBufferType: Int32; pulCounterPbuffer: array of UInt64; bBlock: boolean): Int32 :=
    if (pulCounterPbuffer<>nil) and (pulCounterPbuffer.Length<>0) then
      z_SendPbufferToVideoNV_ovr_0(dpy, pbuf, iBufferType, pulCounterPbuffer[0], bBlock) else
      z_SendPbufferToVideoNV_ovr_0_anh000010(dpy, pbuf, iBufferType, IntPtr.Zero, bBlock);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SendPbufferToVideoNV(dpy: x_p_display; pbuf: glx_pbuffer; iBufferType: Int32; var pulCounterPbuffer: UInt64; bBlock: boolean): Int32 :=
    z_SendPbufferToVideoNV_ovr_0(dpy, pbuf, iBufferType, pulCounterPbuffer, bBlock);
    private z_SendPbufferToVideoNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; pbuf: glx_pbuffer; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: boolean): Int32>(z_SendPbufferToVideoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SendPbufferToVideoNV(dpy: x_p_display; pbuf: glx_pbuffer; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: boolean): Int32 :=
    z_SendPbufferToVideoNV_ovr_2(dpy, pbuf, iBufferType, pulCounterPbuffer, bBlock);
    
    private z_GetVideoInfoNV_adr := GetProcAddress('glXGetVideoInfoNV');
    private z_GetVideoInfoNV_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; var pulCounterOutputPbuffer: UInt64; var pulCounterOutputVideo: UInt64): Int32>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_0_anh000010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Int32>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): Int32>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_0_anh000011 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Int32>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: array of UInt64; pulCounterOutputVideo: array of UInt64): Int32 :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
        z_GetVideoInfoNV_ovr_0(dpy, screen, VideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo[0]) else
        z_GetVideoInfoNV_ovr_0_anh000001(dpy, screen, VideoDevice, pulCounterOutputPbuffer[0], IntPtr.Zero) else
      if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
        z_GetVideoInfoNV_ovr_0_anh000010(dpy, screen, VideoDevice, IntPtr.Zero, pulCounterOutputVideo[0]) else
        z_GetVideoInfoNV_ovr_0_anh000011(dpy, screen, VideoDevice, IntPtr.Zero, IntPtr.Zero);
    private z_GetVideoInfoNV_ovr_1_anh000010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Int32>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: array of UInt64; var pulCounterOutputVideo: UInt64): Int32 :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      z_GetVideoInfoNV_ovr_0(dpy, screen, VideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo) else
      z_GetVideoInfoNV_ovr_0_anh000010(dpy, screen, VideoDevice, IntPtr.Zero, pulCounterOutputVideo);
    private z_GetVideoInfoNV_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): Int32>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_2_anh000010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Int32>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: array of UInt64; pulCounterOutputVideo: IntPtr): Int32 :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      z_GetVideoInfoNV_ovr_2(dpy, screen, VideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo) else
      z_GetVideoInfoNV_ovr_2_anh000010(dpy, screen, VideoDevice, IntPtr.Zero, pulCounterOutputVideo);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: array of UInt64): Int32 :=
    if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
      z_GetVideoInfoNV_ovr_0(dpy, screen, VideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo[0]) else
      z_GetVideoInfoNV_ovr_0_anh000001(dpy, screen, VideoDevice, pulCounterOutputPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; var pulCounterOutputPbuffer: UInt64; var pulCounterOutputVideo: UInt64): Int32 :=
    z_GetVideoInfoNV_ovr_0(dpy, screen, VideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): Int32 :=
    z_GetVideoInfoNV_ovr_2(dpy, screen, VideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    private z_GetVideoInfoNV_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Int32>(z_GetVideoInfoNV_adr);
    private z_GetVideoInfoNV_ovr_6_anh000001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Int32>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: array of UInt64): Int32 :=
    if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
      z_GetVideoInfoNV_ovr_6(dpy, screen, VideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo[0]) else
      z_GetVideoInfoNV_ovr_6_anh000001(dpy, screen, VideoDevice, pulCounterOutputPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): Int32 :=
    z_GetVideoInfoNV_ovr_6(dpy, screen, VideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    private z_GetVideoInfoNV_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Int32>(z_GetVideoInfoNV_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoInfoNV(dpy: x_p_display; screen: Int32; VideoDevice: glx_video_device_NV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): Int32 :=
    z_GetVideoInfoNV_ovr_8(dpy, screen, VideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSyncControlOML = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'OML_sync_control';
    
    private z_GetSyncValuesOML_adr := GetProcAddress('glXGetSyncValuesOML');
    private z_GetSyncValuesOML_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_0_anh000111 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0(dpy, drawable, ust[0], msc[0], sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh000001(dpy, drawable, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh000010(dpy, drawable, ust[0], IntPtr.Zero, sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh000011(dpy, drawable, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh000100(dpy, drawable, IntPtr.Zero, msc[0], sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh000101(dpy, drawable, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh000110(dpy, drawable, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh000111(dpy, drawable, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_1_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_1_anh000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_1_anh000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(dpy, drawable, ust[0], msc[0], sbc) else
        z_GetSyncValuesOML_ovr_0_anh000010(dpy, drawable, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh000100(dpy, drawable, IntPtr.Zero, msc[0], sbc) else
        z_GetSyncValuesOML_ovr_0_anh000110(dpy, drawable, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_GetSyncValuesOML_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_2_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_2_anh000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_2_anh000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_2(dpy, drawable, ust[0], msc[0], sbc) else
        z_GetSyncValuesOML_ovr_2_anh000010(dpy, drawable, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_2_anh000100(dpy, drawable, IntPtr.Zero, msc[0], sbc) else
        z_GetSyncValuesOML_ovr_2_anh000110(dpy, drawable, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_GetSyncValuesOML_ovr_3_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_3_anh000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(dpy, drawable, ust[0], msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh000001(dpy, drawable, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh000100(dpy, drawable, IntPtr.Zero, msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh000101(dpy, drawable, IntPtr.Zero, msc, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_4_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; var msc: Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_0(dpy, drawable, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_0_anh000100(dpy, drawable, IntPtr.Zero, msc, sbc);
    private z_GetSyncValuesOML_ovr_5_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; var msc: Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_2(dpy, drawable, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_2_anh000100(dpy, drawable, IntPtr.Zero, msc, sbc);
    private z_GetSyncValuesOML_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_6_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_6_anh000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_6_anh000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_6(dpy, drawable, ust[0], msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_6_anh000001(dpy, drawable, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_6_anh000100(dpy, drawable, IntPtr.Zero, msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_6_anh000101(dpy, drawable, IntPtr.Zero, msc, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_7_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; msc: IntPtr; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_6(dpy, drawable, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_6_anh000100(dpy, drawable, IntPtr.Zero, msc, sbc);
    private z_GetSyncValuesOML_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_8_anh000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: array of Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_8(dpy, drawable, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_8_anh000100(dpy, drawable, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(dpy, drawable, ust, msc[0], sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh000001(dpy, drawable, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh000010(dpy, drawable, ust, IntPtr.Zero, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh000011(dpy, drawable, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_0(dpy, drawable, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_0_anh000010(dpy, drawable, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_2(dpy, drawable, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_2_anh000010(dpy, drawable, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_0(dpy, drawable, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_0_anh000001(dpy, drawable, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; var msc: Int64; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_0(dpy, drawable, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_2(dpy, drawable, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_6(dpy, drawable, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_6_anh000001(dpy, drawable, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_6(dpy, drawable, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_8(dpy, drawable, ust, msc, sbc);
    private z_GetSyncValuesOML_ovr_18 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_18_anh000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_18_anh000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_18_anh000011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_18(dpy, drawable, ust, msc[0], sbc[0]) else
        z_GetSyncValuesOML_ovr_18_anh000001(dpy, drawable, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_18_anh000010(dpy, drawable, ust, IntPtr.Zero, sbc[0]) else
        z_GetSyncValuesOML_ovr_18_anh000011(dpy, drawable, ust, IntPtr.Zero, IntPtr.Zero);
    private z_GetSyncValuesOML_ovr_19_anh000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_18(dpy, drawable, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_18_anh000010(dpy, drawable, ust, IntPtr.Zero, sbc);
    private z_GetSyncValuesOML_ovr_20 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_20_anh000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_20(dpy, drawable, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_20_anh000010(dpy, drawable, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_18(dpy, drawable, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_18_anh000001(dpy, drawable, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_18(dpy, drawable, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_20(dpy, drawable, ust, msc, sbc);
    private z_GetSyncValuesOML_ovr_24 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_GetSyncValuesOML_adr);
    private z_GetSyncValuesOML_ovr_24_anh000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_24(dpy, drawable, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_24_anh000001(dpy, drawable, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool :=
    z_GetSyncValuesOML_ovr_24(dpy, drawable, ust, msc, sbc);
    private z_GetSyncValuesOML_ovr_26 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_GetSyncValuesOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSyncValuesOML(dpy: x_p_display; drawable: glx_drawable; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool :=
    z_GetSyncValuesOML_ovr_26(dpy, drawable, ust, msc, sbc);
    
    private z_GetMscRateOML_adr := GetProcAddress('glXGetMscRateOML');
    private z_GetMscRateOML_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var numerator: Int32; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_0_anh00010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var numerator: Int32; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_0_anh00011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; numerator: array of Int32; denominator: array of Int32): Bool :=
    if (numerator<>nil) and (numerator.Length<>0) then
      if (denominator<>nil) and (denominator.Length<>0) then
        z_GetMscRateOML_ovr_0(dpy, drawable, numerator[0], denominator[0]) else
        z_GetMscRateOML_ovr_0_anh00001(dpy, drawable, numerator[0], IntPtr.Zero) else
      if (denominator<>nil) and (denominator.Length<>0) then
        z_GetMscRateOML_ovr_0_anh00010(dpy, drawable, IntPtr.Zero, denominator[0]) else
        z_GetMscRateOML_ovr_0_anh00011(dpy, drawable, IntPtr.Zero, IntPtr.Zero);
    private z_GetMscRateOML_ovr_1_anh00010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; numerator: array of Int32; var denominator: Int32): Bool :=
    if (numerator<>nil) and (numerator.Length<>0) then
      z_GetMscRateOML_ovr_0(dpy, drawable, numerator[0], denominator) else
      z_GetMscRateOML_ovr_0_anh00010(dpy, drawable, IntPtr.Zero, denominator);
    private z_GetMscRateOML_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; var numerator: Int32; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_2_anh00010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; numerator: array of Int32; denominator: IntPtr): Bool :=
    if (numerator<>nil) and (numerator.Length<>0) then
      z_GetMscRateOML_ovr_2(dpy, drawable, numerator[0], denominator) else
      z_GetMscRateOML_ovr_2_anh00010(dpy, drawable, IntPtr.Zero, denominator);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; var numerator: Int32; denominator: array of Int32): Bool :=
    if (denominator<>nil) and (denominator.Length<>0) then
      z_GetMscRateOML_ovr_0(dpy, drawable, numerator, denominator[0]) else
      z_GetMscRateOML_ovr_0_anh00001(dpy, drawable, numerator, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; var numerator: Int32; var denominator: Int32): Bool :=
    z_GetMscRateOML_ovr_0(dpy, drawable, numerator, denominator);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; var numerator: Int32; denominator: IntPtr): Bool :=
    z_GetMscRateOML_ovr_2(dpy, drawable, numerator, denominator);
    private z_GetMscRateOML_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; var denominator: Int32): Bool>(z_GetMscRateOML_adr);
    private z_GetMscRateOML_ovr_6_anh00001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; denominator: array of Int32): Bool :=
    if (denominator<>nil) and (denominator.Length<>0) then
      z_GetMscRateOML_ovr_6(dpy, drawable, numerator, denominator[0]) else
      z_GetMscRateOML_ovr_6_anh00001(dpy, drawable, numerator, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; var denominator: Int32): Bool :=
    z_GetMscRateOML_ovr_6(dpy, drawable, numerator, denominator);
    private z_GetMscRateOML_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; denominator: IntPtr): Bool>(z_GetMscRateOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetMscRateOML(dpy: x_p_display; drawable: glx_drawable; numerator: IntPtr; denominator: IntPtr): Bool :=
    z_GetMscRateOML_ovr_8(dpy, drawable, numerator, denominator);
    
    private z_SwapBuffersMscOML_adr := GetProcAddress('glXSwapBuffersMscOML');
    private z_SwapBuffersMscOML_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64): Int64>(z_SwapBuffersMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SwapBuffersMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64): Int64 :=
    z_SwapBuffersMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder);
    
    private z_WaitForMscOML_adr := GetProcAddress('glXWaitForMscOML');
    private z_WaitForMscOML_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_0_anh000000111 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust[0], msc[0], sbc[0]) else
          z_WaitForMscOML_ovr_0_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc[0]) else
          z_WaitForMscOML_ovr_0_anh000000011(dpy, drawable, target_msc, divisor, remainder, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc[0]) else
          z_WaitForMscOML_ovr_0_anh000000101(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh000000110(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_WaitForMscOML_ovr_0_anh000000111(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForMscOML_ovr_1_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_1_anh000000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_1_anh000000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust[0], msc[0], sbc) else
        z_WaitForMscOML_ovr_0_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc) else
        z_WaitForMscOML_ovr_0_anh000000110(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForMscOML_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_2_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_2_anh000000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_2_anh000000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_2(dpy, drawable, target_msc, divisor, remainder, ust[0], msc[0], sbc) else
        z_WaitForMscOML_ovr_2_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_2_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc) else
        z_WaitForMscOML_ovr_2_anh000000110(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForMscOML_ovr_3_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_3_anh000000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh000000101(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForMscOML_ovr_4_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_0_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private z_WaitForMscOML_ovr_5_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_2(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_2_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private z_WaitForMscOML_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_6_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_6_anh000000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_6_anh000000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_6(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, sbc[0]) else
        z_WaitForMscOML_ovr_6_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_6_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForMscOML_ovr_6_anh000000101(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForMscOML_ovr_7_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_6(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_6_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private z_WaitForMscOML_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_8_anh000000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_8(dpy, drawable, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_8_anh000000100(dpy, drawable, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], sbc[0]) else
        z_WaitForMscOML_ovr_0_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh000000011(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_0_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_2(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_2_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_0_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_0(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_2(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_6(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_6_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_6(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_8(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    private z_WaitForMscOML_ovr_18 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_18_anh000000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_18_anh000000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_18_anh000000011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_18(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], sbc[0]) else
        z_WaitForMscOML_ovr_18_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_18_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForMscOML_ovr_18_anh000000011(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForMscOML_ovr_19_anh000000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_18(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_18_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    private z_WaitForMscOML_ovr_20 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_20_anh000000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_20(dpy, drawable, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_20_anh000000010(dpy, drawable, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_18(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_18_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_18(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_20(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    private z_WaitForMscOML_ovr_24 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForMscOML_adr);
    private z_WaitForMscOML_ovr_24_anh000000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_24(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_24_anh000000001(dpy, drawable, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForMscOML_ovr_24(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    private z_WaitForMscOML_ovr_26 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForMscOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForMscOML(dpy: x_p_display; drawable: glx_drawable; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForMscOML_ovr_26(dpy, drawable, target_msc, divisor, remainder, ust, msc, sbc);
    
    private z_WaitForSbcOML_adr := GetProcAddress('glXWaitForSbcOML');
    private z_WaitForSbcOML_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_0_anh0000111 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust[0], msc[0], sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh0000001(dpy, drawable, target_sbc, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh0000010(dpy, drawable, target_sbc, ust[0], IntPtr.Zero, sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh0000011(dpy, drawable, target_sbc, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc[0], sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh0000101(dpy, drawable, target_sbc, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh0000110(dpy, drawable, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh0000111(dpy, drawable, target_sbc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_1_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_1_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_1_anh0000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust[0], msc[0], sbc) else
        z_WaitForSbcOML_ovr_0_anh0000010(dpy, drawable, target_sbc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc[0], sbc) else
        z_WaitForSbcOML_ovr_0_anh0000110(dpy, drawable, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForSbcOML_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_2_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_2_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_2_anh0000110 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_2(dpy, drawable, target_sbc, ust[0], msc[0], sbc) else
        z_WaitForSbcOML_ovr_2_anh0000010(dpy, drawable, target_sbc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_2_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc[0], sbc) else
        z_WaitForSbcOML_ovr_2_anh0000110(dpy, drawable, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc);
    private z_WaitForSbcOML_ovr_3_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_3_anh0000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust[0], msc, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh0000001(dpy, drawable, target_sbc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh0000101(dpy, drawable, target_sbc, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_4_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; var msc: Int64; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_0_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc, sbc);
    private z_WaitForSbcOML_ovr_5_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; var msc: Int64; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_2(dpy, drawable, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_2_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc, sbc);
    private z_WaitForSbcOML_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_6_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_6_anh0000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_6_anh0000101 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_6(dpy, drawable, target_sbc, ust[0], msc, sbc[0]) else
        z_WaitForSbcOML_ovr_6_anh0000001(dpy, drawable, target_sbc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_6_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForSbcOML_ovr_6_anh0000101(dpy, drawable, target_sbc, IntPtr.Zero, msc, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_7_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; msc: IntPtr; var sbc: Int64): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_6(dpy, drawable, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_6_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc, sbc);
    private z_WaitForSbcOML_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_8_anh0000100 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: array of Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_8(dpy, drawable, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_8_anh0000100(dpy, drawable, target_sbc, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust, msc[0], sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh0000001(dpy, drawable, target_sbc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh0000010(dpy, drawable, target_sbc, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh0000011(dpy, drawable, target_sbc, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_0_anh0000010(dpy, drawable, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_2(dpy, drawable, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_2_anh0000010(dpy, drawable, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_0_anh0000001(dpy, drawable, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_0(dpy, drawable, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_2(dpy, drawable, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_6(dpy, drawable, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_6_anh0000001(dpy, drawable, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_6(dpy, drawable, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_8(dpy, drawable, target_sbc, ust, msc, sbc);
    private z_WaitForSbcOML_ovr_18 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_18_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_18_anh0000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_18_anh0000011 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: array of Int64; sbc: array of Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_18(dpy, drawable, target_sbc, ust, msc[0], sbc[0]) else
        z_WaitForSbcOML_ovr_18_anh0000001(dpy, drawable, target_sbc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_18_anh0000010(dpy, drawable, target_sbc, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForSbcOML_ovr_18_anh0000011(dpy, drawable, target_sbc, ust, IntPtr.Zero, IntPtr.Zero);
    private z_WaitForSbcOML_ovr_19_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: array of Int64; var sbc: Int64): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_18(dpy, drawable, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_18_anh0000010(dpy, drawable, target_sbc, ust, IntPtr.Zero, sbc);
    private z_WaitForSbcOML_ovr_20 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_20_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: array of Int64; sbc: IntPtr): Bool :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_20(dpy, drawable, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_20_anh0000010(dpy, drawable, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_18(dpy, drawable, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_18_anh0000001(dpy, drawable, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_18(dpy, drawable, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_20(dpy, drawable, target_sbc, ust, msc, sbc);
    private z_WaitForSbcOML_ovr_24 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool>(z_WaitForSbcOML_adr);
    private z_WaitForSbcOML_ovr_24_anh0000001 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: array of Int64): Bool :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_24(dpy, drawable, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_24_anh0000001(dpy, drawable, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): Bool :=
    z_WaitForSbcOML_ovr_24(dpy, drawable, target_sbc, ust, msc, sbc);
    private z_WaitForSbcOML_ovr_26 := GetProcOrNil&<function(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool>(z_WaitForSbcOML_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitForSbcOML(dpy: x_p_display; drawable: glx_drawable; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): Bool :=
    z_WaitForSbcOML_ovr_26(dpy, drawable, target_sbc, ust, msc, sbc);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxCushionSGI = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGI_cushion';
    
    private z_CushionSGI_adr := GetProcAddress('glXCushionSGI');
    private z_CushionSGI_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; window: x_window; cushion: single)>(z_CushionSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CushionSGI(dpy: x_p_display; window: x_window; cushion: single) :=
    z_CushionSGI_ovr_0(dpy, window, cushion);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxMakeCurrentReadSGI = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGI_make_current_read';
    
    private z_MakeCurrentReadSGI_adr := GetProcAddress('glXMakeCurrentReadSGI');
    private z_MakeCurrentReadSGI_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; draw: glx_drawable; read: glx_drawable; ctx: glx_context): Bool>(z_MakeCurrentReadSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MakeCurrentReadSGI(dpy: x_p_display; draw: glx_drawable; read: glx_drawable; ctx: glx_context): Bool :=
    z_MakeCurrentReadSGI_ovr_0(dpy, draw, read, ctx);
    
    private z_GetCurrentReadDrawableSGI_adr := GetProcAddress('glXGetCurrentReadDrawableSGI');
    private z_GetCurrentReadDrawableSGI_ovr_0 := GetProcOrNil&<function: glx_drawable>(z_GetCurrentReadDrawableSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCurrentReadDrawableSGI: glx_drawable :=
    z_GetCurrentReadDrawableSGI_ovr_0;
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSwapControlSGI = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGI_swap_control';
    
    private z_SwapIntervalSGI_adr := GetProcAddress('glXSwapIntervalSGI');
    private z_SwapIntervalSGI_ovr_0 := GetProcOrNil&<function(interval: Int32): Int32>(z_SwapIntervalSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function SwapIntervalSGI(interval: Int32): Int32 :=
    z_SwapIntervalSGI_ovr_0(interval);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxVideoSyncSGI = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGI_video_sync';
    
    private z_GetVideoSyncSGI_adr := GetProcAddress('glXGetVideoSyncSGI');
    private z_GetVideoSyncSGI_ovr_0 := GetProcOrNil&<function(var count: UInt32): Int32>(z_GetVideoSyncSGI_adr);
    private z_GetVideoSyncSGI_ovr_0_anh01 := GetProcOrNil&<function(count: IntPtr): Int32>(z_GetVideoSyncSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoSyncSGI(count: array of UInt32): Int32 :=
    if (count<>nil) and (count.Length<>0) then
      z_GetVideoSyncSGI_ovr_0(count[0]) else
      z_GetVideoSyncSGI_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoSyncSGI(var count: UInt32): Int32 :=
    z_GetVideoSyncSGI_ovr_0(count);
    private z_GetVideoSyncSGI_ovr_2 := GetProcOrNil&<function(count: IntPtr): Int32>(z_GetVideoSyncSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVideoSyncSGI(count: IntPtr): Int32 :=
    z_GetVideoSyncSGI_ovr_2(count);
    
    private z_WaitVideoSyncSGI_adr := GetProcAddress('glXWaitVideoSyncSGI');
    private z_WaitVideoSyncSGI_ovr_0 := GetProcOrNil&<function(divisor: Int32; remainder: Int32; var count: UInt32): Int32>(z_WaitVideoSyncSGI_adr);
    private z_WaitVideoSyncSGI_ovr_0_anh0001 := GetProcOrNil&<function(divisor: Int32; remainder: Int32; count: IntPtr): Int32>(z_WaitVideoSyncSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitVideoSyncSGI(divisor: Int32; remainder: Int32; count: array of UInt32): Int32 :=
    if (count<>nil) and (count.Length<>0) then
      z_WaitVideoSyncSGI_ovr_0(divisor, remainder, count[0]) else
      z_WaitVideoSyncSGI_ovr_0_anh0001(divisor, remainder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitVideoSyncSGI(divisor: Int32; remainder: Int32; var count: UInt32): Int32 :=
    z_WaitVideoSyncSGI_ovr_0(divisor, remainder, count);
    private z_WaitVideoSyncSGI_ovr_2 := GetProcOrNil&<function(divisor: Int32; remainder: Int32; count: IntPtr): Int32>(z_WaitVideoSyncSGI_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function WaitVideoSyncSGI(divisor: Int32; remainder: Int32; count: IntPtr): Int32 :=
    z_WaitVideoSyncSGI_ovr_2(divisor, remainder, count);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxDmbufferSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_dmbuffer';
    
    private z_AssociateDMPbufferSGIX_adr := GetProcAddress('glXAssociateDMPbufferSGIX');
    private z_AssociateDMPbufferSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; pbuffer: glx_pbuffer; var &params: x_dm_params; dmbuffer: x_dm_buffer): Bool>(z_AssociateDMPbufferSGIX_adr);
    private z_AssociateDMPbufferSGIX_ovr_0_anh00010 := GetProcOrNil&<function(dpy: x_p_display; pbuffer: glx_pbuffer; &params: IntPtr; dmbuffer: x_dm_buffer): Bool>(z_AssociateDMPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateDMPbufferSGIX(dpy: x_p_display; pbuffer: glx_pbuffer; &params: array of x_dm_params; dmbuffer: x_dm_buffer): Bool :=
    if (&params<>nil) and (&params.Length<>0) then
      z_AssociateDMPbufferSGIX_ovr_0(dpy, pbuffer, &params[0], dmbuffer) else
      z_AssociateDMPbufferSGIX_ovr_0_anh00010(dpy, pbuffer, IntPtr.Zero, dmbuffer);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateDMPbufferSGIX(dpy: x_p_display; pbuffer: glx_pbuffer; var &params: x_dm_params; dmbuffer: x_dm_buffer): Bool :=
    z_AssociateDMPbufferSGIX_ovr_0(dpy, pbuffer, &params, dmbuffer);
    private z_AssociateDMPbufferSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; pbuffer: glx_pbuffer; &params: IntPtr; dmbuffer: x_dm_buffer): Bool>(z_AssociateDMPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AssociateDMPbufferSGIX(dpy: x_p_display; pbuffer: glx_pbuffer; &params: IntPtr; dmbuffer: x_dm_buffer): Bool :=
    z_AssociateDMPbufferSGIX_ovr_2(dpy, pbuffer, &params, dmbuffer);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxFbconfigSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_fbconfig';
    
    private z_GetFBConfigAttribSGIX_adr := GetProcAddress('glXGetFBConfigAttribSGIX');
    private z_GetFBConfigAttribSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; attribute: Int32; var value: Int32): Int32>(z_GetFBConfigAttribSGIX_adr);
    private z_GetFBConfigAttribSGIX_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: IntPtr): Int32>(z_GetFBConfigAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFBConfigAttribSGIX(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: array of Int32): Int32 :=
    if (value<>nil) and (value.Length<>0) then
      z_GetFBConfigAttribSGIX_ovr_0(dpy, config, attribute, value[0]) else
      z_GetFBConfigAttribSGIX_ovr_0_anh00001(dpy, config, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFBConfigAttribSGIX(dpy: x_p_display; config: glx_fb_config; attribute: Int32; var value: Int32): Int32 :=
    z_GetFBConfigAttribSGIX_ovr_0(dpy, config, attribute, value);
    private z_GetFBConfigAttribSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: IntPtr): Int32>(z_GetFBConfigAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFBConfigAttribSGIX(dpy: x_p_display; config: glx_fb_config; attribute: Int32; value: IntPtr): Int32 :=
    z_GetFBConfigAttribSGIX_ovr_2(dpy, config, attribute, value);
    
    private z_ChooseFBConfigSGIX_adr := GetProcAddress('glXChooseFBConfigSGIX');
    private z_ChooseFBConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var attrib_list: Int32; var nelements: Int32): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    private z_ChooseFBConfigSGIX_ovr_0_anh00010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    private z_ChooseFBConfigSGIX_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: IntPtr): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    private z_ChooseFBConfigSGIX_ovr_0_anh00011 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; attrib_list: array of Int32; nelements: array of Int32): ^glx_fb_config :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      if (nelements<>nil) and (nelements.Length<>0) then
        z_ChooseFBConfigSGIX_ovr_0(dpy, screen, attrib_list[0], nelements[0]) else
        z_ChooseFBConfigSGIX_ovr_0_anh00001(dpy, screen, attrib_list[0], IntPtr.Zero) else
      if (nelements<>nil) and (nelements.Length<>0) then
        z_ChooseFBConfigSGIX_ovr_0_anh00010(dpy, screen, IntPtr.Zero, nelements[0]) else
        z_ChooseFBConfigSGIX_ovr_0_anh00011(dpy, screen, IntPtr.Zero, IntPtr.Zero);
    private z_ChooseFBConfigSGIX_ovr_1_anh00010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; attrib_list: array of Int32; var nelements: Int32): ^glx_fb_config :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_ChooseFBConfigSGIX_ovr_0(dpy, screen, attrib_list[0], nelements) else
      z_ChooseFBConfigSGIX_ovr_0_anh00010(dpy, screen, IntPtr.Zero, nelements);
    private z_ChooseFBConfigSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: IntPtr): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    private z_ChooseFBConfigSGIX_ovr_2_anh00010 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; attrib_list: array of Int32; nelements: IntPtr): ^glx_fb_config :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_ChooseFBConfigSGIX_ovr_2(dpy, screen, attrib_list[0], nelements) else
      z_ChooseFBConfigSGIX_ovr_2_anh00010(dpy, screen, IntPtr.Zero, nelements);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: array of Int32): ^glx_fb_config :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_ChooseFBConfigSGIX_ovr_0(dpy, screen, attrib_list, nelements[0]) else
      z_ChooseFBConfigSGIX_ovr_0_anh00001(dpy, screen, attrib_list, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; var attrib_list: Int32; var nelements: Int32): ^glx_fb_config :=
    z_ChooseFBConfigSGIX_ovr_0(dpy, screen, attrib_list, nelements);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; var attrib_list: Int32; nelements: IntPtr): ^glx_fb_config :=
    z_ChooseFBConfigSGIX_ovr_2(dpy, screen, attrib_list, nelements);
    private z_ChooseFBConfigSGIX_ovr_6 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    private z_ChooseFBConfigSGIX_ovr_6_anh00001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: array of Int32): ^glx_fb_config :=
    if (nelements<>nil) and (nelements.Length<>0) then
      z_ChooseFBConfigSGIX_ovr_6(dpy, screen, attrib_list, nelements[0]) else
      z_ChooseFBConfigSGIX_ovr_6_anh00001(dpy, screen, attrib_list, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; var nelements: Int32): ^glx_fb_config :=
    z_ChooseFBConfigSGIX_ovr_6(dpy, screen, attrib_list, nelements);
    private z_ChooseFBConfigSGIX_ovr_8 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config>(z_ChooseFBConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChooseFBConfigSGIX(dpy: x_p_display; screen: Int32; attrib_list: IntPtr; nelements: IntPtr): ^glx_fb_config :=
    z_ChooseFBConfigSGIX_ovr_8(dpy, screen, attrib_list, nelements);
    
    private z_CreateGLXPixmapWithConfigSGIX_adr := GetProcAddress('glXCreateGLXPixmapWithConfigSGIX');
    private z_CreateGLXPixmapWithConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap): glx_pixmap>(z_CreateGLXPixmapWithConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateGLXPixmapWithConfigSGIX(dpy: x_p_display; config: glx_fb_config; pixmap: x_pixmap): glx_pixmap :=
    z_CreateGLXPixmapWithConfigSGIX_ovr_0(dpy, config, pixmap);
    
    private z_CreateContextWithConfigSGIX_adr := GetProcAddress('glXCreateContextWithConfigSGIX');
    private z_CreateContextWithConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; render_type: Int32; share_list: glx_context; direct: Bool): glx_context>(z_CreateContextWithConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateContextWithConfigSGIX(dpy: x_p_display; config: glx_fb_config; render_type: Int32; share_list: glx_context; direct: Bool): glx_context :=
    z_CreateContextWithConfigSGIX_ovr_0(dpy, config, render_type, share_list, direct);
    
    private z_GetVisualFromFBConfigSGIX_adr := GetProcAddress('glXGetVisualFromFBConfigSGIX');
    private z_GetVisualFromFBConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config): x_p_visual_info>(z_GetVisualFromFBConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVisualFromFBConfigSGIX(dpy: x_p_display; config: glx_fb_config): x_p_visual_info :=
    z_GetVisualFromFBConfigSGIX_ovr_0(dpy, config);
    
    private z_GetFBConfigFromVisualSGIX_adr := GetProcAddress('glXGetFBConfigFromVisualSGIX');
    private z_GetFBConfigFromVisualSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; vis: x_p_visual_info): glx_fb_config>(z_GetFBConfigFromVisualSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFBConfigFromVisualSGIX(dpy: x_p_display; vis: x_p_visual_info): glx_fb_config :=
    z_GetFBConfigFromVisualSGIX_ovr_0(dpy, vis);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxHyperpipeSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_hyperpipe';
    
    private z_QueryHyperpipeNetworkSGIX_adr := GetProcAddress('glXQueryHyperpipeNetworkSGIX');
    private z_QueryHyperpipeNetworkSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; var npipes: Int32): ^glx_hyperpipe_network_SGIX>(z_QueryHyperpipeNetworkSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeNetworkSGIX(dpy: x_p_display; var npipes: Int32): ^glx_hyperpipe_network_SGIX :=
    z_QueryHyperpipeNetworkSGIX_ovr_0(dpy, npipes);
    private z_QueryHyperpipeNetworkSGIX_ovr_1 := GetProcOrNil&<function(dpy: x_p_display; npipes: IntPtr): ^glx_hyperpipe_network_SGIX>(z_QueryHyperpipeNetworkSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeNetworkSGIX(dpy: x_p_display; npipes: IntPtr): ^glx_hyperpipe_network_SGIX :=
    z_QueryHyperpipeNetworkSGIX_ovr_1(dpy, npipes);
    
    private z_HyperpipeConfigSGIX_adr := GetProcAddress('glXHyperpipeConfigSGIX');
    private z_HyperpipeConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; networkId: Int32; npipes: Int32; var cfg: glx_hyperpipe_config_SGIX; var hpId: Int32): Int32>(z_HyperpipeConfigSGIX_adr);
    private z_HyperpipeConfigSGIX_ovr_0_anh000010 := GetProcOrNil&<function(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: IntPtr; var hpId: Int32): Int32>(z_HyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeConfigSGIX(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: array of glx_hyperpipe_config_SGIX; var hpId: Int32): Int32 :=
    if (cfg<>nil) and (cfg.Length<>0) then
      z_HyperpipeConfigSGIX_ovr_0(dpy, networkId, npipes, cfg[0], hpId) else
      z_HyperpipeConfigSGIX_ovr_0_anh000010(dpy, networkId, npipes, IntPtr.Zero, hpId);
    private z_HyperpipeConfigSGIX_ovr_1 := GetProcOrNil&<function(dpy: x_p_display; networkId: Int32; npipes: Int32; var cfg: glx_hyperpipe_config_SGIX; hpId: IntPtr): Int32>(z_HyperpipeConfigSGIX_adr);
    private z_HyperpipeConfigSGIX_ovr_1_anh000010 := GetProcOrNil&<function(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: IntPtr; hpId: IntPtr): Int32>(z_HyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeConfigSGIX(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: array of glx_hyperpipe_config_SGIX; hpId: IntPtr): Int32 :=
    if (cfg<>nil) and (cfg.Length<>0) then
      z_HyperpipeConfigSGIX_ovr_1(dpy, networkId, npipes, cfg[0], hpId) else
      z_HyperpipeConfigSGIX_ovr_1_anh000010(dpy, networkId, npipes, IntPtr.Zero, hpId);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeConfigSGIX(dpy: x_p_display; networkId: Int32; npipes: Int32; var cfg: glx_hyperpipe_config_SGIX; var hpId: Int32): Int32 :=
    z_HyperpipeConfigSGIX_ovr_0(dpy, networkId, npipes, cfg, hpId);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeConfigSGIX(dpy: x_p_display; networkId: Int32; npipes: Int32; var cfg: glx_hyperpipe_config_SGIX; hpId: IntPtr): Int32 :=
    z_HyperpipeConfigSGIX_ovr_1(dpy, networkId, npipes, cfg, hpId);
    private z_HyperpipeConfigSGIX_ovr_4 := GetProcOrNil&<function(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: IntPtr; var hpId: Int32): Int32>(z_HyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeConfigSGIX(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: IntPtr; var hpId: Int32): Int32 :=
    z_HyperpipeConfigSGIX_ovr_4(dpy, networkId, npipes, cfg, hpId);
    private z_HyperpipeConfigSGIX_ovr_5 := GetProcOrNil&<function(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: IntPtr; hpId: IntPtr): Int32>(z_HyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeConfigSGIX(dpy: x_p_display; networkId: Int32; npipes: Int32; cfg: IntPtr; hpId: IntPtr): Int32 :=
    z_HyperpipeConfigSGIX_ovr_5(dpy, networkId, npipes, cfg, hpId);
    
    private z_QueryHyperpipeConfigSGIX_adr := GetProcAddress('glXQueryHyperpipeConfigSGIX');
    private z_QueryHyperpipeConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; hpId: Int32; var npipes: Int32): ^glx_hyperpipe_config_SGIX>(z_QueryHyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeConfigSGIX(dpy: x_p_display; hpId: Int32; var npipes: Int32): ^glx_hyperpipe_config_SGIX :=
    z_QueryHyperpipeConfigSGIX_ovr_0(dpy, hpId, npipes);
    private z_QueryHyperpipeConfigSGIX_ovr_1 := GetProcOrNil&<function(dpy: x_p_display; hpId: Int32; npipes: IntPtr): ^glx_hyperpipe_config_SGIX>(z_QueryHyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeConfigSGIX(dpy: x_p_display; hpId: Int32; npipes: IntPtr): ^glx_hyperpipe_config_SGIX :=
    z_QueryHyperpipeConfigSGIX_ovr_1(dpy, hpId, npipes);
    
    private z_DestroyHyperpipeConfigSGIX_adr := GetProcAddress('glXDestroyHyperpipeConfigSGIX');
    private z_DestroyHyperpipeConfigSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; hpId: Int32): Int32>(z_DestroyHyperpipeConfigSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function DestroyHyperpipeConfigSGIX(dpy: x_p_display; hpId: Int32): Int32 :=
    z_DestroyHyperpipeConfigSGIX_ovr_0(dpy, hpId);
    
    private z_BindHyperpipeSGIX_adr := GetProcAddress('glXBindHyperpipeSGIX');
    private z_BindHyperpipeSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; hpId: Int32): Int32>(z_BindHyperpipeSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindHyperpipeSGIX(dpy: x_p_display; hpId: Int32): Int32 :=
    z_BindHyperpipeSGIX_ovr_0(dpy, hpId);
    
    private z_QueryHyperpipeBestAttribSGIX_adr := GetProcAddress('glXQueryHyperpipeBestAttribSGIX');
    private z_QueryHyperpipeBestAttribSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_SGIX; var returnAttribList: glx_pipe_rect_SGIX): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    private z_QueryHyperpipeBestAttribSGIX_ovr_0_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr; var returnAttribList: glx_pipe_rect_SGIX): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    private z_QueryHyperpipeBestAttribSGIX_ovr_0_anh0000001 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_SGIX; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    private z_QueryHyperpipeBestAttribSGIX_ovr_0_anh0000011 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeBestAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: array of glx_pipe_rect_SGIX; returnAttribList: array of glx_pipe_rect_SGIX): Int32 :=
    if (attribList<>nil) and (attribList.Length<>0) then
      if (returnAttribList<>nil) and (returnAttribList.Length<>0) then
        z_QueryHyperpipeBestAttribSGIX_ovr_0(dpy, timeSlice, attrib, size, attribList[0], returnAttribList[0]) else
        z_QueryHyperpipeBestAttribSGIX_ovr_0_anh0000001(dpy, timeSlice, attrib, size, attribList[0], IntPtr.Zero) else
      if (returnAttribList<>nil) and (returnAttribList.Length<>0) then
        z_QueryHyperpipeBestAttribSGIX_ovr_0_anh0000010(dpy, timeSlice, attrib, size, IntPtr.Zero, returnAttribList[0]) else
        z_QueryHyperpipeBestAttribSGIX_ovr_0_anh0000011(dpy, timeSlice, attrib, size, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeBestAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_SGIX; var returnAttribList: glx_pipe_rect_SGIX): Int32 :=
    z_QueryHyperpipeBestAttribSGIX_ovr_0(dpy, timeSlice, attrib, size, attribList, returnAttribList);
    private z_QueryHyperpipeBestAttribSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_limits_SGIX; var returnAttribList: glx_pipe_rect_limits_SGIX): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    private z_QueryHyperpipeBestAttribSGIX_ovr_2_anh0000010 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr; var returnAttribList: glx_pipe_rect_limits_SGIX): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    private z_QueryHyperpipeBestAttribSGIX_ovr_2_anh0000001 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_limits_SGIX; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    private z_QueryHyperpipeBestAttribSGIX_ovr_2_anh0000011 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeBestAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: array of glx_pipe_rect_limits_SGIX; returnAttribList: array of glx_pipe_rect_limits_SGIX): Int32 :=
    if (attribList<>nil) and (attribList.Length<>0) then
      if (returnAttribList<>nil) and (returnAttribList.Length<>0) then
        z_QueryHyperpipeBestAttribSGIX_ovr_2(dpy, timeSlice, attrib, size, attribList[0], returnAttribList[0]) else
        z_QueryHyperpipeBestAttribSGIX_ovr_2_anh0000001(dpy, timeSlice, attrib, size, attribList[0], IntPtr.Zero) else
      if (returnAttribList<>nil) and (returnAttribList.Length<>0) then
        z_QueryHyperpipeBestAttribSGIX_ovr_2_anh0000010(dpy, timeSlice, attrib, size, IntPtr.Zero, returnAttribList[0]) else
        z_QueryHyperpipeBestAttribSGIX_ovr_2_anh0000011(dpy, timeSlice, attrib, size, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeBestAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_limits_SGIX; var returnAttribList: glx_pipe_rect_limits_SGIX): Int32 :=
    z_QueryHyperpipeBestAttribSGIX_ovr_2(dpy, timeSlice, attrib, size, attribList, returnAttribList);
    private z_QueryHyperpipeBestAttribSGIX_ovr_4 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeBestAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeBestAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr; returnAttribList: IntPtr): Int32 :=
    z_QueryHyperpipeBestAttribSGIX_ovr_4(dpy, timeSlice, attrib, size, attribList, returnAttribList);
    
    private z_HyperpipeAttribSGIX_adr := GetProcAddress('glXHyperpipeAttribSGIX');
    private z_HyperpipeAttribSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_SGIX): Int32>(z_HyperpipeAttribSGIX_adr);
    private z_HyperpipeAttribSGIX_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr): Int32>(z_HyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: array of glx_pipe_rect_SGIX): Int32 :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_HyperpipeAttribSGIX_ovr_0(dpy, timeSlice, attrib, size, attribList[0]) else
      z_HyperpipeAttribSGIX_ovr_0_anh000001(dpy, timeSlice, attrib, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: glx_pipe_rect_SGIX): Int32 :=
    z_HyperpipeAttribSGIX_ovr_0(dpy, timeSlice, attrib, size, attribList);
    private z_HyperpipeAttribSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: Int32): Int32>(z_HyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var attribList: Int32): Int32 :=
    z_HyperpipeAttribSGIX_ovr_2(dpy, timeSlice, attrib, size, attribList);
    private z_HyperpipeAttribSGIX_ovr_3 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr): Int32>(z_HyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function HyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; attribList: IntPtr): Int32 :=
    z_HyperpipeAttribSGIX_ovr_3(dpy, timeSlice, attrib, size, attribList);
    
    private z_QueryHyperpipeAttribSGIX_adr := GetProcAddress('glXQueryHyperpipeAttribSGIX');
    private z_QueryHyperpipeAttribSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var returnAttribList: glx_pipe_rect_SGIX): Int32>(z_QueryHyperpipeAttribSGIX_adr);
    private z_QueryHyperpipeAttribSGIX_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; returnAttribList: array of glx_pipe_rect_SGIX): Int32 :=
    if (returnAttribList<>nil) and (returnAttribList.Length<>0) then
      z_QueryHyperpipeAttribSGIX_ovr_0(dpy, timeSlice, attrib, size, returnAttribList[0]) else
      z_QueryHyperpipeAttribSGIX_ovr_0_anh000001(dpy, timeSlice, attrib, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var returnAttribList: glx_pipe_rect_SGIX): Int32 :=
    z_QueryHyperpipeAttribSGIX_ovr_0(dpy, timeSlice, attrib, size, returnAttribList);
    private z_QueryHyperpipeAttribSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var returnAttribList: glx_pipe_rect_limits_SGIX): Int32>(z_QueryHyperpipeAttribSGIX_adr);
    private z_QueryHyperpipeAttribSGIX_ovr_2_anh000001 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; returnAttribList: array of glx_pipe_rect_limits_SGIX): Int32 :=
    if (returnAttribList<>nil) and (returnAttribList.Length<>0) then
      z_QueryHyperpipeAttribSGIX_ovr_2(dpy, timeSlice, attrib, size, returnAttribList[0]) else
      z_QueryHyperpipeAttribSGIX_ovr_2_anh000001(dpy, timeSlice, attrib, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var returnAttribList: glx_pipe_rect_limits_SGIX): Int32 :=
    z_QueryHyperpipeAttribSGIX_ovr_2(dpy, timeSlice, attrib, size, returnAttribList);
    private z_QueryHyperpipeAttribSGIX_ovr_4 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var returnAttribList: Int32): Int32>(z_QueryHyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; var returnAttribList: Int32): Int32 :=
    z_QueryHyperpipeAttribSGIX_ovr_4(dpy, timeSlice, attrib, size, returnAttribList);
    private z_QueryHyperpipeAttribSGIX_ovr_5 := GetProcOrNil&<function(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; returnAttribList: IntPtr): Int32>(z_QueryHyperpipeAttribSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryHyperpipeAttribSGIX(dpy: x_p_display; timeSlice: Int32; attrib: Int32; size: Int32; returnAttribList: IntPtr): Int32 :=
    z_QueryHyperpipeAttribSGIX_ovr_5(dpy, timeSlice, attrib, size, returnAttribList);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxPbufferSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_pbuffer';
    
    private z_CreateGLXPbufferSGIX_adr := GetProcAddress('glXCreateGLXPbufferSGIX');
    private z_CreateGLXPbufferSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; width: UInt32; height: UInt32; var attrib_list: Int32): glx_pbuffer>(z_CreateGLXPbufferSGIX_adr);
    private z_CreateGLXPbufferSGIX_ovr_0_anh000001 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; width: UInt32; height: UInt32; attrib_list: IntPtr): glx_pbuffer>(z_CreateGLXPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateGLXPbufferSGIX(dpy: x_p_display; config: glx_fb_config; width: UInt32; height: UInt32; attrib_list: array of Int32): glx_pbuffer :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_CreateGLXPbufferSGIX_ovr_0(dpy, config, width, height, attrib_list[0]) else
      z_CreateGLXPbufferSGIX_ovr_0_anh000001(dpy, config, width, height, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateGLXPbufferSGIX(dpy: x_p_display; config: glx_fb_config; width: UInt32; height: UInt32; var attrib_list: Int32): glx_pbuffer :=
    z_CreateGLXPbufferSGIX_ovr_0(dpy, config, width, height, attrib_list);
    private z_CreateGLXPbufferSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; config: glx_fb_config; width: UInt32; height: UInt32; attrib_list: IntPtr): glx_pbuffer>(z_CreateGLXPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateGLXPbufferSGIX(dpy: x_p_display; config: glx_fb_config; width: UInt32; height: UInt32; attrib_list: IntPtr): glx_pbuffer :=
    z_CreateGLXPbufferSGIX_ovr_2(dpy, config, width, height, attrib_list);
    
    private z_DestroyGLXPbufferSGIX_adr := GetProcAddress('glXDestroyGLXPbufferSGIX');
    private z_DestroyGLXPbufferSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; pbuf: glx_pbuffer)>(z_DestroyGLXPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DestroyGLXPbufferSGIX(dpy: x_p_display; pbuf: glx_pbuffer) :=
    z_DestroyGLXPbufferSGIX_ovr_0(dpy, pbuf);
    
    private z_QueryGLXPbufferSGIX_adr := GetProcAddress('glXQueryGLXPbufferSGIX');
    private z_QueryGLXPbufferSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; pbuf: glx_pbuffer; attribute: Int32; var value: UInt32)>(z_QueryGLXPbufferSGIX_adr);
    private z_QueryGLXPbufferSGIX_ovr_0_anh00001 := GetProcOrNil&<procedure(dpy: x_p_display; pbuf: glx_pbuffer; attribute: Int32; value: IntPtr)>(z_QueryGLXPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryGLXPbufferSGIX(dpy: x_p_display; pbuf: glx_pbuffer; attribute: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_QueryGLXPbufferSGIX_ovr_0(dpy, pbuf, attribute, value[0]) else
      z_QueryGLXPbufferSGIX_ovr_0_anh00001(dpy, pbuf, attribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryGLXPbufferSGIX(dpy: x_p_display; pbuf: glx_pbuffer; attribute: Int32; var value: UInt32) :=
    z_QueryGLXPbufferSGIX_ovr_0(dpy, pbuf, attribute, value);
    private z_QueryGLXPbufferSGIX_ovr_2 := GetProcOrNil&<procedure(dpy: x_p_display; pbuf: glx_pbuffer; attribute: Int32; value: IntPtr)>(z_QueryGLXPbufferSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryGLXPbufferSGIX(dpy: x_p_display; pbuf: glx_pbuffer; attribute: Int32; value: IntPtr) :=
    z_QueryGLXPbufferSGIX_ovr_2(dpy, pbuf, attribute, value);
    
    private z_SelectEventSGIX_adr := GetProcAddress('glXSelectEventSGIX');
    private z_SelectEventSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; mask: UInt64)>(z_SelectEventSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectEventSGIX(dpy: x_p_display; drawable: glx_drawable; mask: UInt64) :=
    z_SelectEventSGIX_ovr_0(dpy, drawable, mask);
    
    private z_GetSelectedEventSGIX_adr := GetProcAddress('glXGetSelectedEventSGIX');
    private z_GetSelectedEventSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; var mask: UInt64)>(z_GetSelectedEventSGIX_adr);
    private z_GetSelectedEventSGIX_ovr_0_anh0001 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; mask: IntPtr)>(z_GetSelectedEventSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSelectedEventSGIX(dpy: x_p_display; drawable: glx_drawable; mask: array of UInt64) :=
    if (mask<>nil) and (mask.Length<>0) then
      z_GetSelectedEventSGIX_ovr_0(dpy, drawable, mask[0]) else
      z_GetSelectedEventSGIX_ovr_0_anh0001(dpy, drawable, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSelectedEventSGIX(dpy: x_p_display; drawable: glx_drawable; var mask: UInt64) :=
    z_GetSelectedEventSGIX_ovr_0(dpy, drawable, mask);
    private z_GetSelectedEventSGIX_ovr_2 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; mask: IntPtr)>(z_GetSelectedEventSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSelectedEventSGIX(dpy: x_p_display; drawable: glx_drawable; mask: IntPtr) :=
    z_GetSelectedEventSGIX_ovr_2(dpy, drawable, mask);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSwapBarrierSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_swap_barrier';
    
    private z_BindSwapBarrierSGIX_adr := GetProcAddress('glXBindSwapBarrierSGIX');
    private z_BindSwapBarrierSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; barrier: Int32)>(z_BindSwapBarrierSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSwapBarrierSGIX(dpy: x_p_display; drawable: glx_drawable; barrier: Int32) :=
    z_BindSwapBarrierSGIX_ovr_0(dpy, drawable, barrier);
    
    private z_QueryMaxSwapBarriersSGIX_adr := GetProcAddress('glXQueryMaxSwapBarriersSGIX');
    private z_QueryMaxSwapBarriersSGIX_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; var max: Int32): Bool>(z_QueryMaxSwapBarriersSGIX_adr);
    private z_QueryMaxSwapBarriersSGIX_ovr_0_anh0001 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; max: IntPtr): Bool>(z_QueryMaxSwapBarriersSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapBarriersSGIX(dpy: x_p_display; screen: Int32; max: array of Int32): Bool :=
    if (max<>nil) and (max.Length<>0) then
      z_QueryMaxSwapBarriersSGIX_ovr_0(dpy, screen, max[0]) else
      z_QueryMaxSwapBarriersSGIX_ovr_0_anh0001(dpy, screen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapBarriersSGIX(dpy: x_p_display; screen: Int32; var max: Int32): Bool :=
    z_QueryMaxSwapBarriersSGIX_ovr_0(dpy, screen, max);
    private z_QueryMaxSwapBarriersSGIX_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; screen: Int32; max: IntPtr): Bool>(z_QueryMaxSwapBarriersSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMaxSwapBarriersSGIX(dpy: x_p_display; screen: Int32; max: IntPtr): Bool :=
    z_QueryMaxSwapBarriersSGIX_ovr_2(dpy, screen, max);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxSwapGroupSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_swap_group';
    
    private z_JoinSwapGroupSGIX_adr := GetProcAddress('glXJoinSwapGroupSGIX');
    private z_JoinSwapGroupSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; drawable: glx_drawable; member: glx_drawable)>(z_JoinSwapGroupSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure JoinSwapGroupSGIX(dpy: x_p_display; drawable: glx_drawable; member: glx_drawable) :=
    z_JoinSwapGroupSGIX_ovr_0(dpy, drawable, member);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxVideoResizeSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_video_resize';
    
    private z_BindChannelToWindowSGIX_adr := GetProcAddress('glXBindChannelToWindowSGIX');
    private z_BindChannelToWindowSGIX_ovr_0 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; window: x_window): Int32>(z_BindChannelToWindowSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindChannelToWindowSGIX(display: x_p_display; screen: Int32; channel: Int32; window: x_window): Int32 :=
    z_BindChannelToWindowSGIX_ovr_0(display, screen, channel, window);
    
    private z_ChannelRectSGIX_adr := GetProcAddress('glXChannelRectSGIX');
    private z_ChannelRectSGIX_ovr_0 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: Int32; y: Int32; w: Int32; h: Int32): Int32>(z_ChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; x: Int32; y: Int32; w: Int32; h: Int32): Int32 :=
    z_ChannelRectSGIX_ovr_0(display, screen, channel, x, y, w, h);
    
    private z_QueryChannelRectSGIX_adr := GetProcAddress('glXQueryChannelRectSGIX');
    private z_QueryChannelRectSGIX_ovr_0 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00000111 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_0_anh00001111 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        if (dw<>nil) and (dw.Length<>0) then
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy[0], dw[0], dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx[0], dy[0], dw[0], IntPtr.Zero) else
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx[0], dy[0], IntPtr.Zero, dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00000011(display, screen, channel, dx[0], dy[0], IntPtr.Zero, IntPtr.Zero) else
        if (dw<>nil) and (dw.Length<>0) then
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw[0], dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00000101(display, screen, channel, dx[0], IntPtr.Zero, dw[0], IntPtr.Zero) else
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00000110(display, screen, channel, dx[0], IntPtr.Zero, IntPtr.Zero, dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00000111(display, screen, channel, dx[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (dy<>nil) and (dy.Length<>0) then
        if (dw<>nil) and (dw.Length<>0) then
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw[0], dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, dy[0], dw[0], IntPtr.Zero) else
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, dy[0], IntPtr.Zero, dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00001011(display, screen, channel, IntPtr.Zero, dy[0], IntPtr.Zero, IntPtr.Zero) else
        if (dw<>nil) and (dw.Length<>0) then
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw[0], dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00001101(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw[0], IntPtr.Zero) else
          if (dh<>nil) and (dh.Length<>0) then
            z_QueryChannelRectSGIX_ovr_0_anh00001110(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, dh[0]) else
            z_QueryChannelRectSGIX_ovr_0_anh00001111(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_1_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_1_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_1_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_1_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_1_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_1_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_1_anh00001110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; dw: array of Int32; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy[0], dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx[0], dy[0], IntPtr.Zero, dh) else
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_0_anh00000110(display, screen, channel, dx[0], IntPtr.Zero, IntPtr.Zero, dh) else
      if (dy<>nil) and (dy.Length<>0) then
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, dy[0], IntPtr.Zero, dh) else
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_0_anh00001110(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_2 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_2_anh00001110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx[0], dy[0], dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_2_anh00000010(display, screen, channel, dx[0], dy[0], IntPtr.Zero, dh) else
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_2_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_2_anh00000110(display, screen, channel, dx[0], IntPtr.Zero, IntPtr.Zero, dh) else
      if (dy<>nil) and (dy.Length<>0) then
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_2_anh00001010(display, screen, channel, IntPtr.Zero, dy[0], IntPtr.Zero, dh) else
        if (dw<>nil) and (dw.Length<>0) then
          z_QueryChannelRectSGIX_ovr_2_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw[0], dh) else
          z_QueryChannelRectSGIX_ovr_2_anh00001110(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_3_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_3_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_3_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_3_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_3_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_3_anh00001101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; var dw: Int32; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy[0], dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx[0], dy[0], dw, IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000101(display, screen, channel, dx[0], IntPtr.Zero, dw, IntPtr.Zero) else
      if (dy<>nil) and (dy.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, dy[0], dw, IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00001101(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_4_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_4_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_4_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; var dw: Int32; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw, dh) else
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_5_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_5_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_5_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; var dw: Int32; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx[0], dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_2_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw, dh) else
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_2_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_6 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_6_anh00001101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx[0], dy[0], dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_6_anh00000001(display, screen, channel, dx[0], dy[0], dw, IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_6_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_6_anh00000101(display, screen, channel, dx[0], IntPtr.Zero, dw, IntPtr.Zero) else
      if (dy<>nil) and (dy.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_6_anh00001001(display, screen, channel, IntPtr.Zero, dy[0], dw, IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_6_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, dh[0]) else
          z_QueryChannelRectSGIX_ovr_6_anh00001101(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_7_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_7_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_7_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; dw: IntPtr; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx[0], dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_6_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw, dh) else
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_6_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_8 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_8_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_8_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_8_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: array of Int32; dw: IntPtr; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_8(display, screen, channel, dx[0], dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_8_anh00000100(display, screen, channel, dx[0], IntPtr.Zero, dw, dh) else
      if (dy<>nil) and (dy.Length<>0) then
        z_QueryChannelRectSGIX_ovr_8_anh00001000(display, screen, channel, IntPtr.Zero, dy[0], dw, dh) else
        z_QueryChannelRectSGIX_ovr_8_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_9_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_9_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_9_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_9_anh00001011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy, dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx[0], dy, dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx[0], dy, IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000011(display, screen, channel, dx[0], dy, IntPtr.Zero, IntPtr.Zero) else
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, dy, dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00001011(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_10_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_10_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; dw: array of Int32; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx[0], dy, IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_11_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_11_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx[0], dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_2_anh00000010(display, screen, channel, dx[0], dy, IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_2_anh00001010(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_12_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_12_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; var dw: Int32; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx[0], dy, dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, dy, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_13_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; var dw: Int32; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_14_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; var dw: Int32; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_15_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_15_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx[0], dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_6_anh00000001(display, screen, channel, dx[0], dy, dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_6_anh00001001(display, screen, channel, IntPtr.Zero, dy, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_16_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; dw: IntPtr; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_17_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_8(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_8_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_18 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_18_anh00001011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx[0], dy, dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_18_anh00000001(display, screen, channel, dx[0], dy, dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_18_anh00000010(display, screen, channel, dx[0], dy, IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_18_anh00000011(display, screen, channel, dx[0], dy, IntPtr.Zero, IntPtr.Zero) else
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_18_anh00001001(display, screen, channel, IntPtr.Zero, dy, dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_18_anh00001010(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_18_anh00001011(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_19_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_19_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_19_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; dw: array of Int32; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx[0], dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_18_anh00000010(display, screen, channel, dx[0], dy, IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_18_anh00001010(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_20 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_20_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_20_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_20_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_20(display, screen, channel, dx[0], dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_20_anh00000010(display, screen, channel, dx[0], dy, IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_20_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_20_anh00001010(display, screen, channel, IntPtr.Zero, dy, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_21_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_21_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; var dw: Int32; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx[0], dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_18_anh00000001(display, screen, channel, dx[0], dy, dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_18_anh00001001(display, screen, channel, IntPtr.Zero, dy, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_22_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_23_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_20(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_20_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_24 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_24_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_24_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_24_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_24(display, screen, channel, dx[0], dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_24_anh00000001(display, screen, channel, dx[0], dy, dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_24_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_24_anh00001001(display, screen, channel, IntPtr.Zero, dy, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_25_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_24(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_24_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_26 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_26_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: array of Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32 :=
    if (dx<>nil) and (dx.Length<>0) then
      z_QueryChannelRectSGIX_ovr_26(display, screen, channel, dx[0], dy, dw, dh) else
      z_QueryChannelRectSGIX_ovr_26_anh00001000(display, screen, channel, IntPtr.Zero, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy[0], dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx, dy[0], dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx, dy[0], IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000011(display, screen, channel, dx, dy[0], IntPtr.Zero, IntPtr.Zero) else
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000101(display, screen, channel, dx, IntPtr.Zero, dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_0_anh00000110(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_0_anh00000111(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; dw: array of Int32; var dh: Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy[0], dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx, dy[0], IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_0_anh00000110(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx, dy[0], dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_2_anh00000010(display, screen, channel, dx, dy[0], IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_2_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_2_anh00000110(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; var dw: Int32; dh: array of Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy[0], dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx, dy[0], dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_0_anh00000101(display, screen, channel, dx, IntPtr.Zero, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; var dw: Int32; var dh: Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_0_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; var dw: Int32; dh: IntPtr): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_2_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx, dy[0], dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_6_anh00000001(display, screen, channel, dx, dy[0], dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_6_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_6_anh00000101(display, screen, channel, dx, IntPtr.Zero, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; dw: IntPtr; var dh: Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_6_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: array of Int32; dw: IntPtr; dh: IntPtr): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_8(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_8_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy, dw[0], dh[0]) else
        z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx, dy, dw[0], IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh[0]) else
        z_QueryChannelRectSGIX_ovr_0_anh00000011(display, screen, channel, dx, dy, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: array of Int32; var dh: Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_0_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_2_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; var dw: Int32; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_0_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; var dw: Int32; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_0(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; var dw: Int32; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_2(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_6_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_6(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_8(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx, dy, dw[0], dh[0]) else
        z_QueryChannelRectSGIX_ovr_18_anh00000001(display, screen, channel, dx, dy, dw[0], IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_18_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh[0]) else
        z_QueryChannelRectSGIX_ovr_18_anh00000011(display, screen, channel, dx, dy, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: array of Int32; var dh: Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_18_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_20(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_20_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_18_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_18(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_20(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_24(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_24_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_24(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; var dx: Int32; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_26(display, screen, channel, dx, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_54 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_54_anh00000111 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy[0], dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_54_anh00000001(display, screen, channel, dx, dy[0], dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_54_anh00000010(display, screen, channel, dx, dy[0], IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_54_anh00000011(display, screen, channel, dx, dy[0], IntPtr.Zero, IntPtr.Zero) else
      if (dw<>nil) and (dw.Length<>0) then
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_54_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw[0], dh[0]) else
          z_QueryChannelRectSGIX_ovr_54_anh00000101(display, screen, channel, dx, IntPtr.Zero, dw[0], IntPtr.Zero) else
        if (dh<>nil) and (dh.Length<>0) then
          z_QueryChannelRectSGIX_ovr_54_anh00000110(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, dh[0]) else
          z_QueryChannelRectSGIX_ovr_54_anh00000111(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_55_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_55_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_55_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; dw: array of Int32; var dh: Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy[0], dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_54_anh00000010(display, screen, channel, dx, dy[0], IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_54_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_54_anh00000110(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_56 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_56_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_56_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_56_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_56(display, screen, channel, dx, dy[0], dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_56_anh00000010(display, screen, channel, dx, dy[0], IntPtr.Zero, dh) else
      if (dw<>nil) and (dw.Length<>0) then
        z_QueryChannelRectSGIX_ovr_56_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw[0], dh) else
        z_QueryChannelRectSGIX_ovr_56_anh00000110(display, screen, channel, dx, IntPtr.Zero, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_57_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_57_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; var dw: Int32; dh: array of Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy[0], dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_54_anh00000001(display, screen, channel, dx, dy[0], dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_54_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_54_anh00000101(display, screen, channel, dx, IntPtr.Zero, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_58_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; var dw: Int32; var dh: Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_54_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_59_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; var dw: Int32; dh: IntPtr): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_56(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_56_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_60 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_60_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_60_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_60_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_60(display, screen, channel, dx, dy[0], dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_60_anh00000001(display, screen, channel, dx, dy[0], dw, IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_60_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh[0]) else
        z_QueryChannelRectSGIX_ovr_60_anh00000101(display, screen, channel, dx, IntPtr.Zero, dw, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_61_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; dw: IntPtr; var dh: Int32): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_60(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_60_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    private z_QueryChannelRectSGIX_ovr_62 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_62_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: array of Int32; dw: IntPtr; dh: IntPtr): Int32 :=
    if (dy<>nil) and (dy.Length<>0) then
      z_QueryChannelRectSGIX_ovr_62(display, screen, channel, dx, dy[0], dw, dh) else
      z_QueryChannelRectSGIX_ovr_62_anh00000100(display, screen, channel, dx, IntPtr.Zero, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy, dw[0], dh[0]) else
        z_QueryChannelRectSGIX_ovr_54_anh00000001(display, screen, channel, dx, dy, dw[0], IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_54_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh[0]) else
        z_QueryChannelRectSGIX_ovr_54_anh00000011(display, screen, channel, dx, dy, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: array of Int32; var dh: Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_54_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_56(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_56_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_54_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_54(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; var dw: Int32; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_56(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_60(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_60_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_60(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; var dy: Int32; dw: IntPtr; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_62(display, screen, channel, dx, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_72 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_72_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_72_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_72_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: array of Int32; dh: array of Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_72(display, screen, channel, dx, dy, dw[0], dh[0]) else
        z_QueryChannelRectSGIX_ovr_72_anh00000001(display, screen, channel, dx, dy, dw[0], IntPtr.Zero) else
      if (dh<>nil) and (dh.Length<>0) then
        z_QueryChannelRectSGIX_ovr_72_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh[0]) else
        z_QueryChannelRectSGIX_ovr_72_anh00000011(display, screen, channel, dx, dy, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelRectSGIX_ovr_73_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: array of Int32; var dh: Int32): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_72(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_72_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    private z_QueryChannelRectSGIX_ovr_74 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_74_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: array of Int32; dh: IntPtr): Int32 :=
    if (dw<>nil) and (dw.Length<>0) then
      z_QueryChannelRectSGIX_ovr_74(display, screen, channel, dx, dy, dw[0], dh) else
      z_QueryChannelRectSGIX_ovr_74_anh00000010(display, screen, channel, dx, dy, IntPtr.Zero, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_72(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_72_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_72(display, screen, channel, dx, dy, dw, dh);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; var dw: Int32; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_74(display, screen, channel, dx, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_78 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32>(z_QueryChannelRectSGIX_adr);
    private z_QueryChannelRectSGIX_ovr_78_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: array of Int32): Int32 :=
    if (dh<>nil) and (dh.Length<>0) then
      z_QueryChannelRectSGIX_ovr_78(display, screen, channel, dx, dy, dw, dh[0]) else
      z_QueryChannelRectSGIX_ovr_78_anh00000001(display, screen, channel, dx, dy, dw, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; var dh: Int32): Int32 :=
    z_QueryChannelRectSGIX_ovr_78(display, screen, channel, dx, dy, dw, dh);
    private z_QueryChannelRectSGIX_ovr_80 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32>(z_QueryChannelRectSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelRectSGIX(display: x_p_display; screen: Int32; channel: Int32; dx: IntPtr; dy: IntPtr; dw: IntPtr; dh: IntPtr): Int32 :=
    z_QueryChannelRectSGIX_ovr_80(display, screen, channel, dx, dy, dw, dh);
    
    private z_QueryChannelDeltasSGIX_adr := GetProcAddress('glXQueryChannelDeltasSGIX');
    private z_QueryChannelDeltasSGIX_ovr_0 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00000111 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_0_anh00001111 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; w: array of Int32; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (w<>nil) and (w.Length<>0) then
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y[0], w[0], h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x[0], y[0], w[0], IntPtr.Zero) else
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x[0], y[0], IntPtr.Zero, h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00000011(display, screen, channel, x[0], y[0], IntPtr.Zero, IntPtr.Zero) else
        if (w<>nil) and (w.Length<>0) then
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w[0], h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00000101(display, screen, channel, x[0], IntPtr.Zero, w[0], IntPtr.Zero) else
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00000110(display, screen, channel, x[0], IntPtr.Zero, IntPtr.Zero, h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00000111(display, screen, channel, x[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (y<>nil) and (y.Length<>0) then
        if (w<>nil) and (w.Length<>0) then
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w[0], h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, y[0], w[0], IntPtr.Zero) else
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, y[0], IntPtr.Zero, h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00001011(display, screen, channel, IntPtr.Zero, y[0], IntPtr.Zero, IntPtr.Zero) else
        if (w<>nil) and (w.Length<>0) then
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w[0], h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00001101(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w[0], IntPtr.Zero) else
          if (h<>nil) and (h.Length<>0) then
            z_QueryChannelDeltasSGIX_ovr_0_anh00001110(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, h[0]) else
            z_QueryChannelDeltasSGIX_ovr_0_anh00001111(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_1_anh00001110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; w: array of Int32; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y[0], w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x[0], y[0], IntPtr.Zero, h) else
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000110(display, screen, channel, x[0], IntPtr.Zero, IntPtr.Zero, h) else
      if (y<>nil) and (y.Length<>0) then
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, y[0], IntPtr.Zero, h) else
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00001110(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_2 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_2_anh00001110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; w: array of Int32; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x[0], y[0], w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_2_anh00000010(display, screen, channel, x[0], y[0], IntPtr.Zero, h) else
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_2_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_2_anh00000110(display, screen, channel, x[0], IntPtr.Zero, IntPtr.Zero, h) else
      if (y<>nil) and (y.Length<>0) then
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_2_anh00001010(display, screen, channel, IntPtr.Zero, y[0], IntPtr.Zero, h) else
        if (w<>nil) and (w.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_2_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w[0], h) else
          z_QueryChannelDeltasSGIX_ovr_2_anh00001110(display, screen, channel, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_3_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_3_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_3_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_3_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_3_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_3_anh00001101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; var w: Int32; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y[0], w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x[0], y[0], w, IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000101(display, screen, channel, x[0], IntPtr.Zero, w, IntPtr.Zero) else
      if (y<>nil) and (y.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, y[0], w, IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00001101(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_4_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_4_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_4_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; var w: Int32; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w, h) else
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_5_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_5_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_5_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; var w: Int32; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x[0], y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_2_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w, h) else
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_2_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_6 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_6_anh00001101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; w: IntPtr; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x[0], y[0], w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_6_anh00000001(display, screen, channel, x[0], y[0], w, IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_6_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_6_anh00000101(display, screen, channel, x[0], IntPtr.Zero, w, IntPtr.Zero) else
      if (y<>nil) and (y.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_6_anh00001001(display, screen, channel, IntPtr.Zero, y[0], w, IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_6_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_6_anh00001101(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_7_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_7_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_7_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; w: IntPtr; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x[0], y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_6_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w, h) else
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_6_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_8 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_8_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_8_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_8_anh00001100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: array of Int32; w: IntPtr; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_8(display, screen, channel, x[0], y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_8_anh00000100(display, screen, channel, x[0], IntPtr.Zero, w, h) else
      if (y<>nil) and (y.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_8_anh00001000(display, screen, channel, IntPtr.Zero, y[0], w, h) else
        z_QueryChannelDeltasSGIX_ovr_8_anh00001100(display, screen, channel, IntPtr.Zero, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_9_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_9_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_9_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_9_anh00001011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; w: array of Int32; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y, w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x[0], y, w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x[0], y, IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000011(display, screen, channel, x[0], y, IntPtr.Zero, IntPtr.Zero) else
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y, w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, y, w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00001011(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_10_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_10_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; w: array of Int32; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x[0], y, IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00001010(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_11_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_11_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; w: array of Int32; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x[0], y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_2_anh00000010(display, screen, channel, x[0], y, IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_2_anh00001010(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_12_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_12_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; var w: Int32; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x[0], y, w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00001001(display, screen, channel, IntPtr.Zero, y, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_13_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; var w: Int32; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_0_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_14_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; var w: Int32; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_2_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_15_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_15_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; w: IntPtr; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x[0], y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_6_anh00000001(display, screen, channel, x[0], y, w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_6_anh00001001(display, screen, channel, IntPtr.Zero, y, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_16_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; w: IntPtr; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_6_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_17_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; var y: Int32; w: IntPtr; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_8(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_8_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_18 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_18_anh00001011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; w: array of Int32; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x[0], y, w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_18_anh00000001(display, screen, channel, x[0], y, w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_18_anh00000010(display, screen, channel, x[0], y, IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_18_anh00000011(display, screen, channel, x[0], y, IntPtr.Zero, IntPtr.Zero) else
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, y, w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_18_anh00001001(display, screen, channel, IntPtr.Zero, y, w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_18_anh00001010(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_18_anh00001011(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_19_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_19_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_19_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; w: array of Int32; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x[0], y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_18_anh00000010(display, screen, channel, x[0], y, IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_18_anh00001010(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_20 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_20_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_20_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_20_anh00001010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; w: array of Int32; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_20(display, screen, channel, x[0], y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_20_anh00000010(display, screen, channel, x[0], y, IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_20_anh00001000(display, screen, channel, IntPtr.Zero, y, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_20_anh00001010(display, screen, channel, IntPtr.Zero, y, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_21_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_21_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; var w: Int32; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x[0], y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_18_anh00000001(display, screen, channel, x[0], y, w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_18_anh00001001(display, screen, channel, IntPtr.Zero, y, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_22_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; var w: Int32; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_18_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_23_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_20(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_20_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_24 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_24_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_24_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_24_anh00001001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; w: IntPtr; h: array of Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_24(display, screen, channel, x[0], y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_24_anh00000001(display, screen, channel, x[0], y, w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_24_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_24_anh00001001(display, screen, channel, IntPtr.Zero, y, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_25_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_24(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_24_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_26 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_26_anh00001000 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: array of Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32 :=
    if (x<>nil) and (x.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_26(display, screen, channel, x[0], y, w, h) else
      z_QueryChannelDeltasSGIX_ovr_26_anh00001000(display, screen, channel, IntPtr.Zero, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; w: array of Int32; h: array of Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y[0], w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x, y[0], w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x, y[0], IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000011(display, screen, channel, x, y[0], IntPtr.Zero, IntPtr.Zero) else
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x, IntPtr.Zero, w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000101(display, screen, channel, x, IntPtr.Zero, w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_0_anh00000110(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_0_anh00000111(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; w: array of Int32; var h: Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y[0], w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x, y[0], IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x, IntPtr.Zero, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000110(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; w: array of Int32; h: IntPtr): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x, y[0], w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_2_anh00000010(display, screen, channel, x, y[0], IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_2_anh00000100(display, screen, channel, x, IntPtr.Zero, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_2_anh00000110(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; var w: Int32; h: array of Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y[0], w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x, y[0], w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000101(display, screen, channel, x, IntPtr.Zero, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; var w: Int32; var h: Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_0_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; var w: Int32; h: IntPtr): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_2_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; w: IntPtr; h: array of Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x, y[0], w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_6_anh00000001(display, screen, channel, x, y[0], w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_6_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_6_anh00000101(display, screen, channel, x, IntPtr.Zero, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; w: IntPtr; var h: Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_6_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: array of Int32; w: IntPtr; h: IntPtr): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_8(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_8_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: array of Int32; h: array of Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y, w[0], h[0]) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x, y, w[0], IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_0_anh00000011(display, screen, channel, x, y, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: array of Int32; var h: Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_0_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: array of Int32; h: IntPtr): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_2_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; var w: Int32; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_0_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; var w: Int32; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_0(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; var w: Int32; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_2(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_6_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_6(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; var y: Int32; w: IntPtr; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_8(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: array of Int32; h: array of Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x, y, w[0], h[0]) else
        z_QueryChannelDeltasSGIX_ovr_18_anh00000001(display, screen, channel, x, y, w[0], IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_18_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_18_anh00000011(display, screen, channel, x, y, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: array of Int32; var h: Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_18_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: array of Int32; h: IntPtr): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_20(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_20_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_18_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_18(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; var w: Int32; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_20(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_24(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_24_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_24(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; var x: Int32; y: IntPtr; w: IntPtr; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_26(display, screen, channel, x, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_54 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_54_anh00000111 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; w: array of Int32; h: array of Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y[0], w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_54_anh00000001(display, screen, channel, x, y[0], w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_54_anh00000010(display, screen, channel, x, y[0], IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_54_anh00000011(display, screen, channel, x, y[0], IntPtr.Zero, IntPtr.Zero) else
      if (w<>nil) and (w.Length<>0) then
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_54_anh00000100(display, screen, channel, x, IntPtr.Zero, w[0], h[0]) else
          z_QueryChannelDeltasSGIX_ovr_54_anh00000101(display, screen, channel, x, IntPtr.Zero, w[0], IntPtr.Zero) else
        if (h<>nil) and (h.Length<>0) then
          z_QueryChannelDeltasSGIX_ovr_54_anh00000110(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, h[0]) else
          z_QueryChannelDeltasSGIX_ovr_54_anh00000111(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_55_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_55_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_55_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; w: array of Int32; var h: Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y[0], w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_54_anh00000010(display, screen, channel, x, y[0], IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_54_anh00000100(display, screen, channel, x, IntPtr.Zero, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_54_anh00000110(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_56 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_56_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_56_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_56_anh00000110 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; w: array of Int32; h: IntPtr): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_56(display, screen, channel, x, y[0], w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_56_anh00000010(display, screen, channel, x, y[0], IntPtr.Zero, h) else
      if (w<>nil) and (w.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_56_anh00000100(display, screen, channel, x, IntPtr.Zero, w[0], h) else
        z_QueryChannelDeltasSGIX_ovr_56_anh00000110(display, screen, channel, x, IntPtr.Zero, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_57_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_57_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; var w: Int32; h: array of Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y[0], w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_54_anh00000001(display, screen, channel, x, y[0], w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_54_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_54_anh00000101(display, screen, channel, x, IntPtr.Zero, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_58_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; var w: Int32; var h: Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_54_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_59_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; var w: Int32; h: IntPtr): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_56(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_56_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_60 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_60_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_60_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_60_anh00000101 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; w: IntPtr; h: array of Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_60(display, screen, channel, x, y[0], w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_60_anh00000001(display, screen, channel, x, y[0], w, IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_60_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_60_anh00000101(display, screen, channel, x, IntPtr.Zero, w, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_61_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; w: IntPtr; var h: Int32): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_60(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_60_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    private z_QueryChannelDeltasSGIX_ovr_62 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_62_anh00000100 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: array of Int32; w: IntPtr; h: IntPtr): Int32 :=
    if (y<>nil) and (y.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_62(display, screen, channel, x, y[0], w, h) else
      z_QueryChannelDeltasSGIX_ovr_62_anh00000100(display, screen, channel, x, IntPtr.Zero, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: array of Int32; h: array of Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y, w[0], h[0]) else
        z_QueryChannelDeltasSGIX_ovr_54_anh00000001(display, screen, channel, x, y, w[0], IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_54_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_54_anh00000011(display, screen, channel, x, y, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: array of Int32; var h: Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_54_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: array of Int32; h: IntPtr): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_56(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_56_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_54_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_54(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; var w: Int32; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_56(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_60(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_60_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_60(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; var y: Int32; w: IntPtr; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_62(display, screen, channel, x, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_72 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_72_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_72_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_72_anh00000011 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: array of Int32; h: array of Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_72(display, screen, channel, x, y, w[0], h[0]) else
        z_QueryChannelDeltasSGIX_ovr_72_anh00000001(display, screen, channel, x, y, w[0], IntPtr.Zero) else
      if (h<>nil) and (h.Length<>0) then
        z_QueryChannelDeltasSGIX_ovr_72_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h[0]) else
        z_QueryChannelDeltasSGIX_ovr_72_anh00000011(display, screen, channel, x, y, IntPtr.Zero, IntPtr.Zero);
    private z_QueryChannelDeltasSGIX_ovr_73_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: array of Int32; var h: Int32): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_72(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_72_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    private z_QueryChannelDeltasSGIX_ovr_74 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_74_anh00000010 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: array of Int32; h: IntPtr): Int32 :=
    if (w<>nil) and (w.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_74(display, screen, channel, x, y, w[0], h) else
      z_QueryChannelDeltasSGIX_ovr_74_anh00000010(display, screen, channel, x, y, IntPtr.Zero, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_72(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_72_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_72(display, screen, channel, x, y, w, h);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; var w: Int32; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_74(display, screen, channel, x, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_78 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32>(z_QueryChannelDeltasSGIX_adr);
    private z_QueryChannelDeltasSGIX_ovr_78_anh00000001 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: array of Int32): Int32 :=
    if (h<>nil) and (h.Length<>0) then
      z_QueryChannelDeltasSGIX_ovr_78(display, screen, channel, x, y, w, h[0]) else
      z_QueryChannelDeltasSGIX_ovr_78_anh00000001(display, screen, channel, x, y, w, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; var h: Int32): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_78(display, screen, channel, x, y, w, h);
    private z_QueryChannelDeltasSGIX_ovr_80 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32>(z_QueryChannelDeltasSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryChannelDeltasSGIX(display: x_p_display; screen: Int32; channel: Int32; x: IntPtr; y: IntPtr; w: IntPtr; h: IntPtr): Int32 :=
    z_QueryChannelDeltasSGIX_ovr_80(display, screen, channel, x, y, w, h);
    
    private z_ChannelRectSyncSGIX_adr := GetProcAddress('glXChannelRectSyncSGIX');
    private z_ChannelRectSyncSGIX_ovr_0 := GetProcOrNil&<function(display: x_p_display; screen: Int32; channel: Int32; synctype: DummyEnum): Int32>(z_ChannelRectSyncSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ChannelRectSyncSGIX(display: x_p_display; screen: Int32; channel: Int32; synctype: DummyEnum): Int32 :=
    z_ChannelRectSyncSGIX_ovr_0(display, screen, channel, synctype);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxVideoSourceSGIX = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SGIX_video_source';
    
    private z_CreateGLXVideoSourceSGIX_adr := GetProcAddress('glXCreateGLXVideoSourceSGIX');
    private z_CreateGLXVideoSourceSGIX_ovr_0 := GetProcOrNil&<function(display: x_p_display; screen: Int32; server: x_vl_server; path: x_vl_path; nodeClass: Int32; drainNode: x_vl_node): glx_video_source_SGIX>(z_CreateGLXVideoSourceSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateGLXVideoSourceSGIX(display: x_p_display; screen: Int32; server: x_vl_server; path: x_vl_path; nodeClass: Int32; drainNode: x_vl_node): glx_video_source_SGIX :=
    z_CreateGLXVideoSourceSGIX_ovr_0(display, screen, server, path, nodeClass, drainNode);
    
    private z_DestroyGLXVideoSourceSGIX_adr := GetProcAddress('glXDestroyGLXVideoSourceSGIX');
    private z_DestroyGLXVideoSourceSGIX_ovr_0 := GetProcOrNil&<procedure(dpy: x_p_display; glxvideosource: glx_video_source_SGIX)>(z_DestroyGLXVideoSourceSGIX_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DestroyGLXVideoSourceSGIX(dpy: x_p_display; glxvideosource: glx_video_source_SGIX) :=
    z_DestroyGLXVideoSourceSGIX_ovr_0(dpy, glxvideosource);
    
  end;
  
  [PCUNotRestore]
  [System.Security.SuppressUnmanagedCodeSecurity]
  glxGetTransparentIndexSUN = sealed partial class
    private function GetProcAddress(name: string) := glx.GetProcAddress(name);
    private static function GetProcOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    public const _ExtStr = 'SUN_get_transparent_index';
    
    private z_GetTransparentIndexSUN_adr := GetProcAddress('glXGetTransparentIndexSUN');
    private z_GetTransparentIndexSUN_ovr_0 := GetProcOrNil&<function(dpy: x_p_display; overlay: x_window; underlay: x_window; var pTransparentIndex: UInt64): Bool>(z_GetTransparentIndexSUN_adr);
    private z_GetTransparentIndexSUN_ovr_0_anh00001 := GetProcOrNil&<function(dpy: x_p_display; overlay: x_window; underlay: x_window; pTransparentIndex: IntPtr): Bool>(z_GetTransparentIndexSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTransparentIndexSUN(dpy: x_p_display; overlay: x_window; underlay: x_window; pTransparentIndex: array of UInt64): Bool :=
    if (pTransparentIndex<>nil) and (pTransparentIndex.Length<>0) then
      z_GetTransparentIndexSUN_ovr_0(dpy, overlay, underlay, pTransparentIndex[0]) else
      z_GetTransparentIndexSUN_ovr_0_anh00001(dpy, overlay, underlay, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTransparentIndexSUN(dpy: x_p_display; overlay: x_window; underlay: x_window; var pTransparentIndex: UInt64): Bool :=
    z_GetTransparentIndexSUN_ovr_0(dpy, overlay, underlay, pTransparentIndex);
    private z_GetTransparentIndexSUN_ovr_2 := GetProcOrNil&<function(dpy: x_p_display; overlay: x_window; underlay: x_window; pTransparentIndex: IntPtr): Bool>(z_GetTransparentIndexSUN_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTransparentIndexSUN(dpy: x_p_display; overlay: x_window; underlay: x_window; pTransparentIndex: IntPtr): Bool :=
    z_GetTransparentIndexSUN_ovr_2(dpy, overlay, underlay, pTransparentIndex);
    
  end;
  
  {$endregion Extensions}
  
  {$endregion Функции}
  
  {$region Платформы}
  
  /// Платформа Windows
  PlWin = sealed class(PlatformLoader)
    private lib: IntPtr;
    
    public constructor := lib :=
    LoadLibrary('opengl32.dll');
    
    public function GetProcAddress(name: string): IntPtr; override;
    begin
      Result := wgl.GetProcAddress(name); if Result<>IntPtr.Zero then exit;
      Result := GetProcAddress(lib,name); if Result<>IntPtr.Zero then exit;
    end;
    
  end;
  
  /// Платформа XWindow (используется в UNIX-подобных системах)
  PlX = sealed class(PlatformLoader)
    public function GetProcAddress(name: string): IntPtr; override;
    begin
      Result := glx.GetProcAddress(name);
      //TODO Then try from 'libGL.so.1'
    end;
  end;
  
  {$endregion Платформы}
  
implementation

{$region Платформо-зависимая реализация}

type
  api_with_loader = abstract class
    public loader: PlatformLoader;
    
    public constructor(loader: PlatformLoader) := self.loader := loader;
    private constructor := raise new NotSupportedException;
    
  end;
  
type gl = sealed partial class(api_with_loader) end;
constructor gl.Create(loader: PlatformLoader) := inherited Create(loader);
function gl.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glD = sealed partial class(api_with_loader) end;
constructor glD.Create(loader: PlatformLoader) := inherited Create(loader);
function glD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTbuffer3DFX = sealed partial class(api_with_loader) end;
constructor glTbuffer3DFX.Create(loader: PlatformLoader) := inherited Create(loader);
function glTbuffer3DFX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDebugOutputAMD = sealed partial class(api_with_loader) end;
constructor glDebugOutputAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glDebugOutputAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawBuffersBlendAMD = sealed partial class(api_with_loader) end;
constructor glDrawBuffersBlendAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawBuffersBlendAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferMultisampleAdvancedAMD = sealed partial class(api_with_loader) end;
constructor glFramebufferMultisampleAdvancedAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferMultisampleAdvancedAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferSamplePositionsAMD = sealed partial class(api_with_loader) end;
constructor glFramebufferSamplePositionsAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferSamplePositionsAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuShaderInt64AMD = sealed partial class(api_with_loader) end;
constructor glGpuShaderInt64AMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuShaderInt64AMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInterleavedElementsAMD = sealed partial class(api_with_loader) end;
constructor glInterleavedElementsAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glInterleavedElementsAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultiDrawIndirectAMD = sealed partial class(api_with_loader) end;
constructor glMultiDrawIndirectAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultiDrawIndirectAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glNameGenDeleteAMD = sealed partial class(api_with_loader) end;
constructor glNameGenDeleteAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glNameGenDeleteAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glOcclusionQueryEventAMD = sealed partial class(api_with_loader) end;
constructor glOcclusionQueryEventAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glOcclusionQueryEventAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPerformanceMonitorAMD = sealed partial class(api_with_loader) end;
constructor glPerformanceMonitorAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glPerformanceMonitorAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSamplePositionsAMD = sealed partial class(api_with_loader) end;
constructor glSamplePositionsAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glSamplePositionsAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSparseTextureAMD = sealed partial class(api_with_loader) end;
constructor glSparseTextureAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glSparseTextureAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glStencilOperationExtendedAMD = sealed partial class(api_with_loader) end;
constructor glStencilOperationExtendedAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glStencilOperationExtendedAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexShaderTessellatorAMD = sealed partial class(api_with_loader) end;
constructor glVertexShaderTessellatorAMD.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexShaderTessellatorAMD.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glElementArrayAPPLE = sealed partial class(api_with_loader) end;
constructor glElementArrayAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glElementArrayAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFenceAPPLE = sealed partial class(api_with_loader) end;
constructor glFenceAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glFenceAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFlushBufferRangeAPPLE = sealed partial class(api_with_loader) end;
constructor glFlushBufferRangeAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glFlushBufferRangeAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glObjectPurgeableAPPLE = sealed partial class(api_with_loader) end;
constructor glObjectPurgeableAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glObjectPurgeableAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureRangeAPPLE = sealed partial class(api_with_loader) end;
constructor glTextureRangeAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureRangeAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayObjectAPPLE = sealed partial class(api_with_loader) end;
constructor glVertexArrayObjectAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayObjectAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayRangeAPPLE = sealed partial class(api_with_loader) end;
constructor glVertexArrayRangeAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayRangeAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexProgramEvaluatorsAPPLE = sealed partial class(api_with_loader) end;
constructor glVertexProgramEvaluatorsAPPLE.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexProgramEvaluatorsAPPLE.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glES2CompatibilityARB = sealed partial class(api_with_loader) end;
constructor glES2CompatibilityARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glES2CompatibilityARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glES31CompatibilityARB = sealed partial class(api_with_loader) end;
constructor glES31CompatibilityARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glES31CompatibilityARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glES32CompatibilityARB = sealed partial class(api_with_loader) end;
constructor glES32CompatibilityARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glES32CompatibilityARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBaseInstanceARB = sealed partial class(api_with_loader) end;
constructor glBaseInstanceARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glBaseInstanceARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBindlessTextureARB = sealed partial class(api_with_loader) end;
constructor glBindlessTextureARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glBindlessTextureARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendFuncExtendedARB = sealed partial class(api_with_loader) end;
constructor glBlendFuncExtendedARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendFuncExtendedARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBufferStorageARB = sealed partial class(api_with_loader) end;
constructor glBufferStorageARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glBufferStorageARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glClEventARB = sealed partial class(api_with_loader) end;
constructor glClEventARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glClEventARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glClearBufferObjectARB = sealed partial class(api_with_loader) end;
constructor glClearBufferObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glClearBufferObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glClearTextureARB = sealed partial class(api_with_loader) end;
constructor glClearTextureARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glClearTextureARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glClipControlARB = sealed partial class(api_with_loader) end;
constructor glClipControlARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glClipControlARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glColorBufferFloatARB = sealed partial class(api_with_loader) end;
constructor glColorBufferFloatARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glColorBufferFloatARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glComputeShaderARB = sealed partial class(api_with_loader) end;
constructor glComputeShaderARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glComputeShaderARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glComputeVariableGroupSizeARB = sealed partial class(api_with_loader) end;
constructor glComputeVariableGroupSizeARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glComputeVariableGroupSizeARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCopyBufferARB = sealed partial class(api_with_loader) end;
constructor glCopyBufferARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glCopyBufferARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCopyImageARB = sealed partial class(api_with_loader) end;
constructor glCopyImageARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glCopyImageARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDebugOutputARB = sealed partial class(api_with_loader) end;
constructor glDebugOutputARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDebugOutputARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDirectStateAccessARB = sealed partial class(api_with_loader) end;
constructor glDirectStateAccessARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDirectStateAccessARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawBuffersARB = sealed partial class(api_with_loader) end;
constructor glDrawBuffersARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawBuffersARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawBuffersBlendARB = sealed partial class(api_with_loader) end;
constructor glDrawBuffersBlendARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawBuffersBlendARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawElementsBaseVertexARB = sealed partial class(api_with_loader) end;
constructor glDrawElementsBaseVertexARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawElementsBaseVertexARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawIndirectARB = sealed partial class(api_with_loader) end;
constructor glDrawIndirectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawIndirectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawInstancedARB = sealed partial class(api_with_loader) end;
constructor glDrawInstancedARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawInstancedARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFragmentProgramARB = sealed partial class(api_with_loader) end;
constructor glFragmentProgramARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glFragmentProgramARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferNoAttachmentsARB = sealed partial class(api_with_loader) end;
constructor glFramebufferNoAttachmentsARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferNoAttachmentsARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferObjectARB = sealed partial class(api_with_loader) end;
constructor glFramebufferObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGeometryShader4ARB = sealed partial class(api_with_loader) end;
constructor glGeometryShader4ARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glGeometryShader4ARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGetProgramBinaryARB = sealed partial class(api_with_loader) end;
constructor glGetProgramBinaryARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glGetProgramBinaryARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGetTextureSubImageARB = sealed partial class(api_with_loader) end;
constructor glGetTextureSubImageARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glGetTextureSubImageARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGlSpirvARB = sealed partial class(api_with_loader) end;
constructor glGlSpirvARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glGlSpirvARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuShaderFp64ARB = sealed partial class(api_with_loader) end;
constructor glGpuShaderFp64ARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuShaderFp64ARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuShaderInt64ARB = sealed partial class(api_with_loader) end;
constructor glGpuShaderInt64ARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuShaderInt64ARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glImagingARB = sealed partial class(api_with_loader) end;
constructor glImagingARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glImagingARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glIndirectParametersARB = sealed partial class(api_with_loader) end;
constructor glIndirectParametersARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glIndirectParametersARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInstancedArraysARB = sealed partial class(api_with_loader) end;
constructor glInstancedArraysARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glInstancedArraysARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInternalformatQueryARB = sealed partial class(api_with_loader) end;
constructor glInternalformatQueryARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glInternalformatQueryARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInternalformatQuery2ARB = sealed partial class(api_with_loader) end;
constructor glInternalformatQuery2ARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glInternalformatQuery2ARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInvalidateSubdataARB = sealed partial class(api_with_loader) end;
constructor glInvalidateSubdataARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glInvalidateSubdataARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMapBufferRangeARB = sealed partial class(api_with_loader) end;
constructor glMapBufferRangeARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glMapBufferRangeARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMatrixPaletteARB = sealed partial class(api_with_loader) end;
constructor glMatrixPaletteARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glMatrixPaletteARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultiBindARB = sealed partial class(api_with_loader) end;
constructor glMultiBindARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultiBindARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultiDrawIndirectARB = sealed partial class(api_with_loader) end;
constructor glMultiDrawIndirectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultiDrawIndirectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultisampleARB = sealed partial class(api_with_loader) end;
constructor glMultisampleARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultisampleARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultitextureARB = sealed partial class(api_with_loader) end;
constructor glMultitextureARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultitextureARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glOcclusionQueryARB = sealed partial class(api_with_loader) end;
constructor glOcclusionQueryARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glOcclusionQueryARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glParallelShaderCompileARB = sealed partial class(api_with_loader) end;
constructor glParallelShaderCompileARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glParallelShaderCompileARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPointParametersARB = sealed partial class(api_with_loader) end;
constructor glPointParametersARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glPointParametersARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPolygonOffsetClampARB = sealed partial class(api_with_loader) end;
constructor glPolygonOffsetClampARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glPolygonOffsetClampARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glProgramInterfaceQueryARB = sealed partial class(api_with_loader) end;
constructor glProgramInterfaceQueryARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glProgramInterfaceQueryARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glProvokingVertexARB = sealed partial class(api_with_loader) end;
constructor glProvokingVertexARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glProvokingVertexARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glRobustnessARB = sealed partial class(api_with_loader) end;
constructor glRobustnessARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glRobustnessARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSampleLocationsARB = sealed partial class(api_with_loader) end;
constructor glSampleLocationsARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSampleLocationsARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSampleShadingARB = sealed partial class(api_with_loader) end;
constructor glSampleShadingARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSampleShadingARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSamplerObjectsARB = sealed partial class(api_with_loader) end;
constructor glSamplerObjectsARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSamplerObjectsARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSeparateShaderObjectsARB = sealed partial class(api_with_loader) end;
constructor glSeparateShaderObjectsARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSeparateShaderObjectsARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderAtomicCountersARB = sealed partial class(api_with_loader) end;
constructor glShaderAtomicCountersARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderAtomicCountersARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderImageLoadStoreARB = sealed partial class(api_with_loader) end;
constructor glShaderImageLoadStoreARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderImageLoadStoreARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderObjectsARB = sealed partial class(api_with_loader) end;
constructor glShaderObjectsARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderObjectsARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderStorageBufferObjectARB = sealed partial class(api_with_loader) end;
constructor glShaderStorageBufferObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderStorageBufferObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderSubroutineARB = sealed partial class(api_with_loader) end;
constructor glShaderSubroutineARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderSubroutineARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShadingLanguageIncludeARB = sealed partial class(api_with_loader) end;
constructor glShadingLanguageIncludeARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glShadingLanguageIncludeARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSparseBufferARB = sealed partial class(api_with_loader) end;
constructor glSparseBufferARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSparseBufferARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSparseTextureARB = sealed partial class(api_with_loader) end;
constructor glSparseTextureARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSparseTextureARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSyncARB = sealed partial class(api_with_loader) end;
constructor glSyncARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glSyncARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTessellationShaderARB = sealed partial class(api_with_loader) end;
constructor glTessellationShaderARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTessellationShaderARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureBarrierARB = sealed partial class(api_with_loader) end;
constructor glTextureBarrierARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureBarrierARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureBufferObjectARB = sealed partial class(api_with_loader) end;
constructor glTextureBufferObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureBufferObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureBufferRangeARB = sealed partial class(api_with_loader) end;
constructor glTextureBufferRangeARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureBufferRangeARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureCompressionARB = sealed partial class(api_with_loader) end;
constructor glTextureCompressionARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureCompressionARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureMultisampleARB = sealed partial class(api_with_loader) end;
constructor glTextureMultisampleARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureMultisampleARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureStorageARB = sealed partial class(api_with_loader) end;
constructor glTextureStorageARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureStorageARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureStorageMultisampleARB = sealed partial class(api_with_loader) end;
constructor glTextureStorageMultisampleARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureStorageMultisampleARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureViewARB = sealed partial class(api_with_loader) end;
constructor glTextureViewARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureViewARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTimerQueryARB = sealed partial class(api_with_loader) end;
constructor glTimerQueryARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTimerQueryARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransformFeedback2ARB = sealed partial class(api_with_loader) end;
constructor glTransformFeedback2ARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransformFeedback2ARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransformFeedback3ARB = sealed partial class(api_with_loader) end;
constructor glTransformFeedback3ARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransformFeedback3ARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransformFeedbackInstancedARB = sealed partial class(api_with_loader) end;
constructor glTransformFeedbackInstancedARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransformFeedbackInstancedARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransposeMatrixARB = sealed partial class(api_with_loader) end;
constructor glTransposeMatrixARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransposeMatrixARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glUniformBufferObjectARB = sealed partial class(api_with_loader) end;
constructor glUniformBufferObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glUniformBufferObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayObjectARB = sealed partial class(api_with_loader) end;
constructor glVertexArrayObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexAttrib64bitARB = sealed partial class(api_with_loader) end;
constructor glVertexAttrib64bitARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexAttrib64bitARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexAttribBindingARB = sealed partial class(api_with_loader) end;
constructor glVertexAttribBindingARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexAttribBindingARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexBlendARB = sealed partial class(api_with_loader) end;
constructor glVertexBlendARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexBlendARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexBufferObjectARB = sealed partial class(api_with_loader) end;
constructor glVertexBufferObjectARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexBufferObjectARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexProgramARB = sealed partial class(api_with_loader) end;
constructor glVertexProgramARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexProgramARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexShaderARB = sealed partial class(api_with_loader) end;
constructor glVertexShaderARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexShaderARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexType2101010RevARB = sealed partial class(api_with_loader) end;
constructor glVertexType2101010RevARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexType2101010RevARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glViewportArrayARB = sealed partial class(api_with_loader) end;
constructor glViewportArrayARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glViewportArrayARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glWindowPosARB = sealed partial class(api_with_loader) end;
constructor glWindowPosARB.Create(loader: PlatformLoader) := inherited Create(loader);
function glWindowPosARB.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawBuffersATI = sealed partial class(api_with_loader) end;
constructor glDrawBuffersATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawBuffersATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glElementArrayATI = sealed partial class(api_with_loader) end;
constructor glElementArrayATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glElementArrayATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glEnvmapBumpmapATI = sealed partial class(api_with_loader) end;
constructor glEnvmapBumpmapATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glEnvmapBumpmapATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFragmentShaderATI = sealed partial class(api_with_loader) end;
constructor glFragmentShaderATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glFragmentShaderATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMapObjectBufferATI = sealed partial class(api_with_loader) end;
constructor glMapObjectBufferATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glMapObjectBufferATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPnTrianglesATI = sealed partial class(api_with_loader) end;
constructor glPnTrianglesATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glPnTrianglesATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSeparateStencilATI = sealed partial class(api_with_loader) end;
constructor glSeparateStencilATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glSeparateStencilATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayObjectATI = sealed partial class(api_with_loader) end;
constructor glVertexArrayObjectATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayObjectATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexAttribArrayObjectATI = sealed partial class(api_with_loader) end;
constructor glVertexAttribArrayObjectATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexAttribArrayObjectATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexStreamsATI = sealed partial class(api_with_loader) end;
constructor glVertexStreamsATI.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexStreamsATI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glEGLImageStorageEXT = sealed partial class(api_with_loader) end;
constructor glEGLImageStorageEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glEGLImageStorageEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBindableUniformEXT = sealed partial class(api_with_loader) end;
constructor glBindableUniformEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glBindableUniformEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendColorEXT = sealed partial class(api_with_loader) end;
constructor glBlendColorEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendColorEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendEquationSeparateEXT = sealed partial class(api_with_loader) end;
constructor glBlendEquationSeparateEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendEquationSeparateEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendFuncSeparateEXT = sealed partial class(api_with_loader) end;
constructor glBlendFuncSeparateEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendFuncSeparateEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendMinmaxEXT = sealed partial class(api_with_loader) end;
constructor glBlendMinmaxEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendMinmaxEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glColorSubtableEXT = sealed partial class(api_with_loader) end;
constructor glColorSubtableEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glColorSubtableEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCompiledVertexArrayEXT = sealed partial class(api_with_loader) end;
constructor glCompiledVertexArrayEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glCompiledVertexArrayEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConvolutionEXT = sealed partial class(api_with_loader) end;
constructor glConvolutionEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glConvolutionEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCoordinateFrameEXT = sealed partial class(api_with_loader) end;
constructor glCoordinateFrameEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glCoordinateFrameEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCopyTextureEXT = sealed partial class(api_with_loader) end;
constructor glCopyTextureEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glCopyTextureEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCullVertexEXT = sealed partial class(api_with_loader) end;
constructor glCullVertexEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glCullVertexEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDebugLabelEXT = sealed partial class(api_with_loader) end;
constructor glDebugLabelEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDebugLabelEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDebugMarkerEXT = sealed partial class(api_with_loader) end;
constructor glDebugMarkerEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDebugMarkerEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDepthBoundsTestEXT = sealed partial class(api_with_loader) end;
constructor glDepthBoundsTestEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDepthBoundsTestEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDirectStateAccessEXT = sealed partial class(api_with_loader) end;
constructor glDirectStateAccessEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDirectStateAccessEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawBuffers2EXT = sealed partial class(api_with_loader) end;
constructor glDrawBuffers2EXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawBuffers2EXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawInstancedEXT = sealed partial class(api_with_loader) end;
constructor glDrawInstancedEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawInstancedEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawRangeElementsEXT = sealed partial class(api_with_loader) end;
constructor glDrawRangeElementsEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawRangeElementsEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glExternalBufferEXT = sealed partial class(api_with_loader) end;
constructor glExternalBufferEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glExternalBufferEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFogCoordEXT = sealed partial class(api_with_loader) end;
constructor glFogCoordEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glFogCoordEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferBlitEXT = sealed partial class(api_with_loader) end;
constructor glFramebufferBlitEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferBlitEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferMultisampleEXT = sealed partial class(api_with_loader) end;
constructor glFramebufferMultisampleEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferMultisampleEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferObjectEXT = sealed partial class(api_with_loader) end;
constructor glFramebufferObjectEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferObjectEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGeometryShader4EXT = sealed partial class(api_with_loader) end;
constructor glGeometryShader4EXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glGeometryShader4EXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuProgramParametersEXT = sealed partial class(api_with_loader) end;
constructor glGpuProgramParametersEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuProgramParametersEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuShader4EXT = sealed partial class(api_with_loader) end;
constructor glGpuShader4EXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuShader4EXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glHistogramEXT = sealed partial class(api_with_loader) end;
constructor glHistogramEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glHistogramEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glIndexFuncEXT = sealed partial class(api_with_loader) end;
constructor glIndexFuncEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glIndexFuncEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glIndexMaterialEXT = sealed partial class(api_with_loader) end;
constructor glIndexMaterialEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glIndexMaterialEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glLightTextureEXT = sealed partial class(api_with_loader) end;
constructor glLightTextureEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glLightTextureEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMemoryObjectEXT = sealed partial class(api_with_loader) end;
constructor glMemoryObjectEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glMemoryObjectEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMemoryObjectFdEXT = sealed partial class(api_with_loader) end;
constructor glMemoryObjectFdEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glMemoryObjectFdEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMemoryObjectWin32EXT = sealed partial class(api_with_loader) end;
constructor glMemoryObjectWin32EXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glMemoryObjectWin32EXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultiDrawArraysEXT = sealed partial class(api_with_loader) end;
constructor glMultiDrawArraysEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultiDrawArraysEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultisampleEXT = sealed partial class(api_with_loader) end;
constructor glMultisampleEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultisampleEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPalettedTextureEXT = sealed partial class(api_with_loader) end;
constructor glPalettedTextureEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glPalettedTextureEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPixelTransformEXT = sealed partial class(api_with_loader) end;
constructor glPixelTransformEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glPixelTransformEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPointParametersEXT = sealed partial class(api_with_loader) end;
constructor glPointParametersEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glPointParametersEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPolygonOffsetEXT = sealed partial class(api_with_loader) end;
constructor glPolygonOffsetEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glPolygonOffsetEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPolygonOffsetClampEXT = sealed partial class(api_with_loader) end;
constructor glPolygonOffsetClampEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glPolygonOffsetClampEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glProvokingVertexEXT = sealed partial class(api_with_loader) end;
constructor glProvokingVertexEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glProvokingVertexEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glRasterMultisampleEXT = sealed partial class(api_with_loader) end;
constructor glRasterMultisampleEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glRasterMultisampleEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSemaphoreEXT = sealed partial class(api_with_loader) end;
constructor glSemaphoreEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glSemaphoreEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSemaphoreFdEXT = sealed partial class(api_with_loader) end;
constructor glSemaphoreFdEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glSemaphoreFdEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSemaphoreWin32EXT = sealed partial class(api_with_loader) end;
constructor glSemaphoreWin32EXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glSemaphoreWin32EXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSecondaryColorEXT = sealed partial class(api_with_loader) end;
constructor glSecondaryColorEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glSecondaryColorEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSeparateShaderObjectsEXT = sealed partial class(api_with_loader) end;
constructor glSeparateShaderObjectsEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glSeparateShaderObjectsEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderFramebufferFetchNonCoherentEXT = sealed partial class(api_with_loader) end;
constructor glShaderFramebufferFetchNonCoherentEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderFramebufferFetchNonCoherentEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderImageLoadStoreEXT = sealed partial class(api_with_loader) end;
constructor glShaderImageLoadStoreEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderImageLoadStoreEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glStencilClearTagEXT = sealed partial class(api_with_loader) end;
constructor glStencilClearTagEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glStencilClearTagEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glStencilTwoSideEXT = sealed partial class(api_with_loader) end;
constructor glStencilTwoSideEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glStencilTwoSideEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSubtextureEXT = sealed partial class(api_with_loader) end;
constructor glSubtextureEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glSubtextureEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTexture3DEXT = sealed partial class(api_with_loader) end;
constructor glTexture3DEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTexture3DEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureArrayEXT = sealed partial class(api_with_loader) end;
constructor glTextureArrayEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureArrayEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureBufferObjectEXT = sealed partial class(api_with_loader) end;
constructor glTextureBufferObjectEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureBufferObjectEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureIntegerEXT = sealed partial class(api_with_loader) end;
constructor glTextureIntegerEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureIntegerEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureObjectEXT = sealed partial class(api_with_loader) end;
constructor glTextureObjectEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureObjectEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTexturePerturbNormalEXT = sealed partial class(api_with_loader) end;
constructor glTexturePerturbNormalEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTexturePerturbNormalEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureStorageEXT = sealed partial class(api_with_loader) end;
constructor glTextureStorageEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureStorageEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTimelineSemaphoreNV = sealed partial class(api_with_loader) end;
constructor glTimelineSemaphoreNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glTimelineSemaphoreNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTimerQueryEXT = sealed partial class(api_with_loader) end;
constructor glTimerQueryEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTimerQueryEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransformFeedbackEXT = sealed partial class(api_with_loader) end;
constructor glTransformFeedbackEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransformFeedbackEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayEXT = sealed partial class(api_with_loader) end;
constructor glVertexArrayEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexAttrib64bitEXT = sealed partial class(api_with_loader) end;
constructor glVertexAttrib64bitEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexAttrib64bitEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexShaderEXT = sealed partial class(api_with_loader) end;
constructor glVertexShaderEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexShaderEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexWeightingEXT = sealed partial class(api_with_loader) end;
constructor glVertexWeightingEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexWeightingEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glWin32KeyedMutexEXT = sealed partial class(api_with_loader) end;
constructor glWin32KeyedMutexEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glWin32KeyedMutexEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glWindowRectanglesEXT = sealed partial class(api_with_loader) end;
constructor glWindowRectanglesEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glWindowRectanglesEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glX11SyncObjectEXT = sealed partial class(api_with_loader) end;
constructor glX11SyncObjectEXT.Create(loader: PlatformLoader) := inherited Create(loader);
function glX11SyncObjectEXT.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFrameTerminatorGREMEDY = sealed partial class(api_with_loader) end;
constructor glFrameTerminatorGREMEDY.Create(loader: PlatformLoader) := inherited Create(loader);
function glFrameTerminatorGREMEDY.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glStringMarkerGREMEDY = sealed partial class(api_with_loader) end;
constructor glStringMarkerGREMEDY.Create(loader: PlatformLoader) := inherited Create(loader);
function glStringMarkerGREMEDY.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glImageTransformHP = sealed partial class(api_with_loader) end;
constructor glImageTransformHP.Create(loader: PlatformLoader) := inherited Create(loader);
function glImageTransformHP.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultimodeDrawArraysIBM = sealed partial class(api_with_loader) end;
constructor glMultimodeDrawArraysIBM.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultimodeDrawArraysIBM.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glStaticDataIBM = sealed partial class(api_with_loader) end;
constructor glStaticDataIBM.Create(loader: PlatformLoader) := inherited Create(loader);
function glStaticDataIBM.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayListsIBM = sealed partial class(api_with_loader) end;
constructor glVertexArrayListsIBM.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayListsIBM.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendFuncSeparateINGR = sealed partial class(api_with_loader) end;
constructor glBlendFuncSeparateINGR.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendFuncSeparateINGR.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferCMAAINTEL = sealed partial class(api_with_loader) end;
constructor glFramebufferCMAAINTEL.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferCMAAINTEL.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMapTextureINTEL = sealed partial class(api_with_loader) end;
constructor glMapTextureINTEL.Create(loader: PlatformLoader) := inherited Create(loader);
function glMapTextureINTEL.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glParallelArraysINTEL = sealed partial class(api_with_loader) end;
constructor glParallelArraysINTEL.Create(loader: PlatformLoader) := inherited Create(loader);
function glParallelArraysINTEL.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPerformanceQueryINTEL = sealed partial class(api_with_loader) end;
constructor glPerformanceQueryINTEL.Create(loader: PlatformLoader) := inherited Create(loader);
function glPerformanceQueryINTEL.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendEquationAdvancedKHR = sealed partial class(api_with_loader) end;
constructor glBlendEquationAdvancedKHR.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendEquationAdvancedKHR.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDebugKHR = sealed partial class(api_with_loader) end;
constructor glDebugKHR.Create(loader: PlatformLoader) := inherited Create(loader);
function glDebugKHR.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glRobustnessKHR = sealed partial class(api_with_loader) end;
constructor glRobustnessKHR.Create(loader: PlatformLoader) := inherited Create(loader);
function glRobustnessKHR.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glParallelShaderCompileKHR = sealed partial class(api_with_loader) end;
constructor glParallelShaderCompileKHR.Create(loader: PlatformLoader) := inherited Create(loader);
function glParallelShaderCompileKHR.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferFlipYMESA = sealed partial class(api_with_loader) end;
constructor glFramebufferFlipYMESA.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferFlipYMESA.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glResizeBuffersMESA = sealed partial class(api_with_loader) end;
constructor glResizeBuffersMESA.Create(loader: PlatformLoader) := inherited Create(loader);
function glResizeBuffersMESA.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glWindowPosMESA = sealed partial class(api_with_loader) end;
constructor glWindowPosMESA.Create(loader: PlatformLoader) := inherited Create(loader);
function glWindowPosMESA.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConditionalRenderNVX = sealed partial class(api_with_loader) end;
constructor glConditionalRenderNVX.Create(loader: PlatformLoader) := inherited Create(loader);
function glConditionalRenderNVX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glLinkedGpuMulticastNVX = sealed partial class(api_with_loader) end;
constructor glLinkedGpuMulticastNVX.Create(loader: PlatformLoader) := inherited Create(loader);
function glLinkedGpuMulticastNVX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glAlphaToCoverageDitherControlNV = sealed partial class(api_with_loader) end;
constructor glAlphaToCoverageDitherControlNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glAlphaToCoverageDitherControlNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBindlessMultiDrawIndirectNV = sealed partial class(api_with_loader) end;
constructor glBindlessMultiDrawIndirectNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glBindlessMultiDrawIndirectNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBindlessMultiDrawIndirectCountNV = sealed partial class(api_with_loader) end;
constructor glBindlessMultiDrawIndirectCountNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glBindlessMultiDrawIndirectCountNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBindlessTextureNV = sealed partial class(api_with_loader) end;
constructor glBindlessTextureNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glBindlessTextureNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glBlendEquationAdvancedNV = sealed partial class(api_with_loader) end;
constructor glBlendEquationAdvancedNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glBlendEquationAdvancedNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glClipSpaceWScalingNV = sealed partial class(api_with_loader) end;
constructor glClipSpaceWScalingNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glClipSpaceWScalingNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCommandListNV = sealed partial class(api_with_loader) end;
constructor glCommandListNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glCommandListNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConditionalRenderNV = sealed partial class(api_with_loader) end;
constructor glConditionalRenderNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glConditionalRenderNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConservativeRasterNV = sealed partial class(api_with_loader) end;
constructor glConservativeRasterNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glConservativeRasterNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConservativeRasterDilateNV = sealed partial class(api_with_loader) end;
constructor glConservativeRasterDilateNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glConservativeRasterDilateNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConservativeRasterPreSnapTrianglesNV = sealed partial class(api_with_loader) end;
constructor glConservativeRasterPreSnapTrianglesNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glConservativeRasterPreSnapTrianglesNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glCopyImageNV = sealed partial class(api_with_loader) end;
constructor glCopyImageNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glCopyImageNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDepthBufferFloatNV = sealed partial class(api_with_loader) end;
constructor glDepthBufferFloatNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glDepthBufferFloatNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawTextureNV = sealed partial class(api_with_loader) end;
constructor glDrawTextureNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawTextureNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDrawVulkanImageNV = sealed partial class(api_with_loader) end;
constructor glDrawVulkanImageNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glDrawVulkanImageNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glEvaluatorsNV = sealed partial class(api_with_loader) end;
constructor glEvaluatorsNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glEvaluatorsNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glExplicitMultisampleNV = sealed partial class(api_with_loader) end;
constructor glExplicitMultisampleNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glExplicitMultisampleNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFenceNV = sealed partial class(api_with_loader) end;
constructor glFenceNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glFenceNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFragmentCoverageToColorNV = sealed partial class(api_with_loader) end;
constructor glFragmentCoverageToColorNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glFragmentCoverageToColorNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFragmentProgramNV = sealed partial class(api_with_loader) end;
constructor glFragmentProgramNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glFragmentProgramNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferMixedSamplesNV = sealed partial class(api_with_loader) end;
constructor glFramebufferMixedSamplesNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferMixedSamplesNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramebufferMultisampleCoverageNV = sealed partial class(api_with_loader) end;
constructor glFramebufferMultisampleCoverageNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramebufferMultisampleCoverageNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGeometryProgram4NV = sealed partial class(api_with_loader) end;
constructor glGeometryProgram4NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glGeometryProgram4NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuProgram4NV = sealed partial class(api_with_loader) end;
constructor glGpuProgram4NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuProgram4NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuProgram5NV = sealed partial class(api_with_loader) end;
constructor glGpuProgram5NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuProgram5NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuShader5NV = sealed partial class(api_with_loader) end;
constructor glGpuShader5NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuShader5NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glHalfFloatNV = sealed partial class(api_with_loader) end;
constructor glHalfFloatNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glHalfFloatNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInternalformatSampleQueryNV = sealed partial class(api_with_loader) end;
constructor glInternalformatSampleQueryNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glInternalformatSampleQueryNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuMulticastNV = sealed partial class(api_with_loader) end;
constructor glGpuMulticastNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuMulticastNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGpuMulticast2NVX = sealed partial class(api_with_loader) end;
constructor glGpuMulticast2NVX.Create(loader: PlatformLoader) := inherited Create(loader);
function glGpuMulticast2NVX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glProgressFenceNVX = sealed partial class(api_with_loader) end;
constructor glProgressFenceNVX.Create(loader: PlatformLoader) := inherited Create(loader);
function glProgressFenceNVX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMemoryAttachmentNV = sealed partial class(api_with_loader) end;
constructor glMemoryAttachmentNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glMemoryAttachmentNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMemoryObjectSparseNV = sealed partial class(api_with_loader) end;
constructor glMemoryObjectSparseNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glMemoryObjectSparseNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMeshShaderNV = sealed partial class(api_with_loader) end;
constructor glMeshShaderNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glMeshShaderNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glOcclusionQueryNV = sealed partial class(api_with_loader) end;
constructor glOcclusionQueryNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glOcclusionQueryNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glParameterBufferObjectNV = sealed partial class(api_with_loader) end;
constructor glParameterBufferObjectNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glParameterBufferObjectNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPathRenderingNV = sealed partial class(api_with_loader) end;
constructor glPathRenderingNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glPathRenderingNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPixelDataRangeNV = sealed partial class(api_with_loader) end;
constructor glPixelDataRangeNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glPixelDataRangeNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPointSpriteNV = sealed partial class(api_with_loader) end;
constructor glPointSpriteNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glPointSpriteNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPresentVideoNV = sealed partial class(api_with_loader) end;
constructor glPresentVideoNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glPresentVideoNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPrimitiveRestartNV = sealed partial class(api_with_loader) end;
constructor glPrimitiveRestartNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glPrimitiveRestartNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glQueryResourceNV = sealed partial class(api_with_loader) end;
constructor glQueryResourceNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glQueryResourceNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glQueryResourceTagNV = sealed partial class(api_with_loader) end;
constructor glQueryResourceTagNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glQueryResourceTagNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glRegisterCombinersNV = sealed partial class(api_with_loader) end;
constructor glRegisterCombinersNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glRegisterCombinersNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glRegisterCombiners2NV = sealed partial class(api_with_loader) end;
constructor glRegisterCombiners2NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glRegisterCombiners2NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSampleLocationsNV = sealed partial class(api_with_loader) end;
constructor glSampleLocationsNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glSampleLocationsNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glScissorExclusiveNV = sealed partial class(api_with_loader) end;
constructor glScissorExclusiveNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glScissorExclusiveNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShaderBufferLoadNV = sealed partial class(api_with_loader) end;
constructor glShaderBufferLoadNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glShaderBufferLoadNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glShadingRateImageNV = sealed partial class(api_with_loader) end;
constructor glShadingRateImageNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glShadingRateImageNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureBarrierNV = sealed partial class(api_with_loader) end;
constructor glTextureBarrierNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureBarrierNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureMultisampleNV = sealed partial class(api_with_loader) end;
constructor glTextureMultisampleNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureMultisampleNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransformFeedbackNV = sealed partial class(api_with_loader) end;
constructor glTransformFeedbackNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransformFeedbackNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTransformFeedback2NV = sealed partial class(api_with_loader) end;
constructor glTransformFeedback2NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glTransformFeedback2NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVdpauInteropNV = sealed partial class(api_with_loader) end;
constructor glVdpauInteropNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVdpauInteropNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVdpauInterop2NV = sealed partial class(api_with_loader) end;
constructor glVdpauInterop2NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVdpauInterop2NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexArrayRangeNV = sealed partial class(api_with_loader) end;
constructor glVertexArrayRangeNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexArrayRangeNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexAttribInteger64bitNV = sealed partial class(api_with_loader) end;
constructor glVertexAttribInteger64bitNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexAttribInteger64bitNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexBufferUnifiedMemoryNV = sealed partial class(api_with_loader) end;
constructor glVertexBufferUnifiedMemoryNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexBufferUnifiedMemoryNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexProgramNV = sealed partial class(api_with_loader) end;
constructor glVertexProgramNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexProgramNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexProgram4NV = sealed partial class(api_with_loader) end;
constructor glVertexProgram4NV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexProgram4NV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVideoCaptureNV = sealed partial class(api_with_loader) end;
constructor glVideoCaptureNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glVideoCaptureNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glViewportSwizzleNV = sealed partial class(api_with_loader) end;
constructor glViewportSwizzleNV.Create(loader: PlatformLoader) := inherited Create(loader);
function glViewportSwizzleNV.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glByteCoordinatesOES = sealed partial class(api_with_loader) end;
constructor glByteCoordinatesOES.Create(loader: PlatformLoader) := inherited Create(loader);
function glByteCoordinatesOES.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFixedPointOES = sealed partial class(api_with_loader) end;
constructor glFixedPointOES.Create(loader: PlatformLoader) := inherited Create(loader);
function glFixedPointOES.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glQueryMatrixOES = sealed partial class(api_with_loader) end;
constructor glQueryMatrixOES.Create(loader: PlatformLoader) := inherited Create(loader);
function glQueryMatrixOES.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSinglePrecisionOES = sealed partial class(api_with_loader) end;
constructor glSinglePrecisionOES.Create(loader: PlatformLoader) := inherited Create(loader);
function glSinglePrecisionOES.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultiviewOVR = sealed partial class(api_with_loader) end;
constructor glMultiviewOVR.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultiviewOVR.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMiscHintsPGI = sealed partial class(api_with_loader) end;
constructor glMiscHintsPGI.Create(loader: PlatformLoader) := inherited Create(loader);
function glMiscHintsPGI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glDetailTextureSGIS = sealed partial class(api_with_loader) end;
constructor glDetailTextureSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glDetailTextureSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFogFunctionSGIS = sealed partial class(api_with_loader) end;
constructor glFogFunctionSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glFogFunctionSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMultisampleSGIS = sealed partial class(api_with_loader) end;
constructor glMultisampleSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glMultisampleSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPixelTextureSGIS = sealed partial class(api_with_loader) end;
constructor glPixelTextureSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glPixelTextureSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPointParametersSGIS = sealed partial class(api_with_loader) end;
constructor glPointParametersSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glPointParametersSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSharpenTextureSGIS = sealed partial class(api_with_loader) end;
constructor glSharpenTextureSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glSharpenTextureSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTexture4DSGIS = sealed partial class(api_with_loader) end;
constructor glTexture4DSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glTexture4DSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureColorMaskSGIS = sealed partial class(api_with_loader) end;
constructor glTextureColorMaskSGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureColorMaskSGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTextureFilter4SGIS = sealed partial class(api_with_loader) end;
constructor glTextureFilter4SGIS.Create(loader: PlatformLoader) := inherited Create(loader);
function glTextureFilter4SGIS.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glAsyncSGIX = sealed partial class(api_with_loader) end;
constructor glAsyncSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glAsyncSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFlushRasterSGIX = sealed partial class(api_with_loader) end;
constructor glFlushRasterSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glFlushRasterSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFragmentLightingSGIX = sealed partial class(api_with_loader) end;
constructor glFragmentLightingSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glFragmentLightingSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glFramezoomSGIX = sealed partial class(api_with_loader) end;
constructor glFramezoomSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glFramezoomSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glIglooInterfaceSGIX = sealed partial class(api_with_loader) end;
constructor glIglooInterfaceSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glIglooInterfaceSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glInstrumentsSGIX = sealed partial class(api_with_loader) end;
constructor glInstrumentsSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glInstrumentsSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glListPrioritySGIX = sealed partial class(api_with_loader) end;
constructor glListPrioritySGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glListPrioritySGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPixelTextureSGIX = sealed partial class(api_with_loader) end;
constructor glPixelTextureSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glPixelTextureSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glPolynomialFfdSGIX = sealed partial class(api_with_loader) end;
constructor glPolynomialFfdSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glPolynomialFfdSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glReferencePlaneSGIX = sealed partial class(api_with_loader) end;
constructor glReferencePlaneSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glReferencePlaneSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glSpriteSGIX = sealed partial class(api_with_loader) end;
constructor glSpriteSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glSpriteSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTagSampleBufferSGIX = sealed partial class(api_with_loader) end;
constructor glTagSampleBufferSGIX.Create(loader: PlatformLoader) := inherited Create(loader);
function glTagSampleBufferSGIX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glColorTableSGI = sealed partial class(api_with_loader) end;
constructor glColorTableSGI.Create(loader: PlatformLoader) := inherited Create(loader);
function glColorTableSGI.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glConstantDataSUNX = sealed partial class(api_with_loader) end;
constructor glConstantDataSUNX.Create(loader: PlatformLoader) := inherited Create(loader);
function glConstantDataSUNX.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glGlobalAlphaSUN = sealed partial class(api_with_loader) end;
constructor glGlobalAlphaSUN.Create(loader: PlatformLoader) := inherited Create(loader);
function glGlobalAlphaSUN.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glMeshArraySUN = sealed partial class(api_with_loader) end;
constructor glMeshArraySUN.Create(loader: PlatformLoader) := inherited Create(loader);
function glMeshArraySUN.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glTriangleListSUN = sealed partial class(api_with_loader) end;
constructor glTriangleListSUN.Create(loader: PlatformLoader) := inherited Create(loader);
function glTriangleListSUN.GetProcAddress(name: string) := loader.GetProcAddress(name);

type glVertexSUN = sealed partial class(api_with_loader) end;
constructor glVertexSUN.Create(loader: PlatformLoader) := inherited Create(loader);
function glVertexSUN.GetProcAddress(name: string) := loader.GetProcAddress(name);

{$endregion Платформо-зависимая реализация}

{$region MtrMlt}

function operator*(m1: Mtr2x2f; m2: Mtr2x2f): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x3f): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x4f): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x2d): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x3d): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x4d): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x3f): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x2f): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x4f): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x3d): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x2d): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x4d): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x4f): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x2f): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x3f): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x4d): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x2d): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x3d): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x3f): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x2f): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x4f): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x3d): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x2d): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x4d): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x2f): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x3f): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x4f): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x2d): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x3d): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x4d): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x4f): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x2f): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x3f): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x4d): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x2d): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x3d): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x2f): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x3f): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x4f): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x2d): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x3d): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x4d): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x4f): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x2f): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x3f): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x4d): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x2d): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x3d): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x3f): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x2f): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x4f): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x3d): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x2d): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x4d): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x2f): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x3f): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x4f): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x2d): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x3d): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x4d): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x3f): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x2f): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x4f): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x3d): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x2d): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x4d): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x4f): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x2f): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x3f): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x4d): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x2d): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x3d): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x3f): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x2f): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x4f): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x3d): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x2d): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x4d): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x2f): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x3f): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x4f): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x2d): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x3d): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x4d): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x4f): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x2f): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x3f): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x4d): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x2d): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x3d): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x2f): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x3f): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x4f): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x2d): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x3d): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x4d): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x4f): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x2f): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x3f): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x4d): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x2d): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x3d): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x3f): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x2f): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x4f): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x3d): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x2d): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x4d): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

{$endregion MtrMlt}

{$region MtrTranspose}

function Transpose(self: Mtr2x2f); extensionmethod :=
new Mtr2x2f(self.val00, self.val10, self.val01, self.val11);

function Transpose(self: Mtr3x3f); extensionmethod :=
new Mtr3x3f(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22);

function Transpose(self: Mtr4x4f); extensionmethod :=
new Mtr4x4f(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32, self.val03, self.val13, self.val23, self.val33);

function Transpose(self: Mtr2x3f); extensionmethod :=
new Mtr3x2f(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12);
function Transpose(self: Mtr3x2f); extensionmethod :=
new Mtr2x3f(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21);

function Transpose(self: Mtr2x4f); extensionmethod :=
new Mtr4x2f(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12, self.val03, self.val13);
function Transpose(self: Mtr4x2f); extensionmethod :=
new Mtr2x4f(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31);

function Transpose(self: Mtr3x4f); extensionmethod :=
new Mtr4x3f(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22, self.val03, self.val13, self.val23);
function Transpose(self: Mtr4x3f); extensionmethod :=
new Mtr3x4f(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32);

function Transpose(self: Mtr2x2d); extensionmethod :=
new Mtr2x2d(self.val00, self.val10, self.val01, self.val11);

function Transpose(self: Mtr3x3d); extensionmethod :=
new Mtr3x3d(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22);

function Transpose(self: Mtr4x4d); extensionmethod :=
new Mtr4x4d(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32, self.val03, self.val13, self.val23, self.val33);

function Transpose(self: Mtr2x3d); extensionmethod :=
new Mtr3x2d(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12);
function Transpose(self: Mtr3x2d); extensionmethod :=
new Mtr2x3d(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21);

function Transpose(self: Mtr2x4d); extensionmethod :=
new Mtr4x2d(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12, self.val03, self.val13);
function Transpose(self: Mtr4x2d); extensionmethod :=
new Mtr2x4d(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31);

function Transpose(self: Mtr3x4d); extensionmethod :=
new Mtr4x3d(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22, self.val03, self.val13, self.val23);
function Transpose(self: Mtr4x3d); extensionmethod :=
new Mtr3x4d(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32);

{$endregion MtrTranspose}

end.